const String phrasePinyin = '''{
  "㞎㞎": "bǎ,ba",
  "㧑挹": "huī,yì",
  "㧑损": "huī,sǔn",
  "㹴犬": "gěng,quǎn",
  "一一对应": "yī,yī,duì,yìng",
  "一丁点儿": "yī,dīng,diǎn,er",
  "一万次地": "yī,wàn,cì,de",
  "一下儿": "yī,xià,er",
  "一下子": "yī,xià,zi",
  "一不为少": "yī,bù,wéi,shǎo",
  "一不做": "yī,bū,zuò",
  "一不安地": "yī,bù,ān,de",
  "一不小心": "yí,bù,xiǎo,xīn",
  "一丘貉": "yī,qiū,mò",
  "一丝不差": "yì,sī,bù,chā",
  "一个": "yí,gè",
  "一个一个地": "yí,gè,yí,gè,de",
  "一个个地": "yí,gè,gè,de",
  "一个个地来": "yí,gè,gè,de,lái",
  "一个人相好": "yí,gè,rén,xiāng,hǎo",
  "一个劲": "yí,gè,jìn",
  "一个劲儿": "yī,gè,jìn,er",
  "一个劲地": "yí,gè,jìn,de",
  "一个劲地咳嗽": "yí,gè,jìn,de,ké,sòu",
  "一个劲地抱怨": "yí,gè,jìn,de,bào,yuàn",
  "一个劲地问": "yí,gè,jìn,de,wèn",
  "一个劲地鼓掌": "yí,gè,jìn,de,gǔ,zhǎng",
  "一个半": "yī,ge,bàn",
  "一个大": "yí,gè,dà",
  "一个头两个大": "yī,ge,tóu,liǎng,ge,dà",
  "一个子儿": "yí,gè,zi,er",
  "一个心眼": "yí,gè,xīn,yǎn",
  "一个心眼儿": "yí,gè,xīn,yǎn,ér",
  "一个接一个": "yī,ge,jiē,yī,ge",
  "一个接一个地": "yí,gè,jiē,yí,gè,de",
  "一个是一个": "yí,gè,shì,yí,gè",
  "一个样": "yī,ge,yàng",
  "一个稿子": "yí,gè,gǎo,zi",
  "一个老鼠害一锅汤": "yí,gè,lǎo,shǔ,hài,yī,guō,tāng",
  "一个萝卜一个坑": "yī,gè,luó,bo,yī,gè,kēng",
  "一为地": "yī,wèi,de",
  "一之为甚": "yī,zhī,wéi,shèn",
  "一了": "yī,liǎo",
  "一了百了": "yī,liǎo,bǎi,liǎo",
  "一了百当": "yī,liǎo,bǎi,dàng",
  "一事无成": "yí,shì,wú,chéng",
  "一五一十": "yì,wǔ,yì,shí",
  "一人做事一人当": "yì,rén,zuò,shì,yì,rén,dāng",
  "一仆二主": "yī,pú,èr,zhǔ",
  "一代": "yí,dài",
  "一令纸": "yī,lǐng,zhǐ",
  "一伙儿": "yī,huǒ,er",
  "一会儿": "yī,huì,er",
  "一体两面": "yì,tǐ,liǎng,miàn",
  "一倍": "yí,bèi",
  "一倡百和": "yī,chàng,bǎi,hè",
  "一六兀剌": "yī,liù,wū,là",
  "一再地": "yī,zài,de",
  "一再地吼": "yī,zài,de,hǒu",
  "一冲性子": "yī,chōng,xìng,zi",
  "一出戏": "yì,chū,xì",
  "一刀两断": "yì,dāo,liǎng,duàn",
  "一分为二": "yī,fēn,wéi,èr",
  "一分子": "yī,fèn,zi",
  "一分行情一分货": "yī,fēn,háng,qíng,yī,fēn,huò",
  "一分钟": "yì,fēn,zhōng",
  "一切": "yī,qiè",
  "一切事物": "yī,qiè,shì,wù",
  "一切众生": "yī,qiè,zhòng,shēng",
  "一切向钱看": "yī,qiè,xiàng,qián,kàn",
  "一切地": "yī,qiè,de",
  "一切如旧": "yī,qiè,rú,jiù",
  "一切就绪": "yī,qiè,jiù,xù",
  "一切智": "yī,qiè,zhì",
  "一切有情": "yī,qiè,yǒu,qíng",
  "一切法": "yī,qiè,fǎ",
  "一切种智": "yī,qiè,zhǒng,zhì",
  "一切经": "yī,qiè,jīng",
  "一切诸佛": "yī,qiè,zhū,fó",
  "一切险": "yī,qiè,xiǎn",
  "一刬": "yī,chàn",
  "一到": "yí,dào",
  "一到伴": "yí,dào,bàn",
  "一到处": "yí,dào,chù",
  "一制地": "yī,zhì,de",
  "一刹": "yī,shā",
  "一刻地": "yī,kè,de",
  "一劳永逸": "yì,láo,yǒng,yì",
  "一劳永逸地": "yì,láo,yǒng,yì,de",
  "一化": "yī,huā",
  "一匹": "yì,pǐ",
  "一匹马": "yì,pǐ,mǎ",
  "一千八百担": "yī,qiān,bā,bǎi,dàn",
  "一半": "yí,bàn",
  "一半地": "yí,bàn,de",
  "一卷": "yī,juàn",
  "一厢情愿": "yì,xiāng,qíng,yuàn",
  "一厢情愿地想": "yì,xiāng,qíng,yuàn,de,xiǎng",
  "一发": "yī,fà",
  "一发不可收拾": "yī,fā,bù,kě,shōu,shi",
  "一发千钧": "yī,fà,qiān,jūn",
  "一发破的": "yī,fā,pò,dì",
  "一口不能着两匙": "yī,kǒu,bù,néng,zháo,liǎng,chí",
  "一口吃不成胖子": "yī,kǒu,chī,bù,chéng,pàng,zi",
  "一口吃个胖子": "yī,kǒu,chī,ge,pàng,zi",
  "一口咬定": "yì,kǒu,yǎo,dìng",
  "一口气": "yì,kǒu,qì",
  "一口气儿": "yī,kǒu,qì,er",
  "一口气地": "yì,kǒu,qì,de",
  "一古脑儿": "yī,gǔ,nǎo,er",
  "一只": "yī,zhī",
  "一叶扁舟": "yí,yè,piān,zhōu",
  "一名誉地": "yī,míng,yù,de",
  "一吐为快": "yī,tǔ,wéi,kuài",
  "一向": "yí,xiàng",
  "一吟一咏": "yī,yīn,yī,yǒng",
  "一味地": "yī,wèi,de",
  "一味地强调": "yī,wèi,de,qiáng,diào",
  "一呼百应": "yī,hū,bǎi,yìng",
  "一命呜呼": "yí,mìng,wū,hū",
  "一和": "yī,hè",
  "一和和": "yī,hè,hé",
  "一哄": "yí,hòng",
  "一哄而上": "yì,hōng,ér,shàng",
  "一哄而散": "yī,hòng,ér,sàn",
  "一哭二闹": "yì,kū,èr,nào",
  "一唱": "yí,chàng",
  "一唱一和": "yī,chàng,yī,hè",
  "一唱雄鸡天下白": "yí,chàng,xióng,jī,tiān,xià,bái",
  "一回儿": "yì,huí,er",
  "一场梦": "yì,cháng,mèng",
  "一场空": "yī,cháng,kōng",
  "一场雨": "yī,cháng,yǔ",
  "一均衡地": "yī,jūn,héng,de",
  "一块儿": "yī,kuài,er",
  "一块土": "yí,kuài,tǔ",
  "一块地": "yī,kuài,de",
  "一块石头落了地": "yī,kuài,shí,tou,luò,le,dì",
  "一块肉": "yí,kuài,ròu",
  "一塌刮子": "yī,tā,guā,zi",
  "一塌括仔": "yī,tā,kuò,zǎi",
  "一声不吭": "yī,shēng,bù,kēng",
  "一声不吭地溜走": "yī,shēng,bù,kēng,de,liū,zǒu",
  "一声不响": "yì,shēng,bù,xiǎng",
  "一夕一朝": "yī,xī,yī,zhāo",
  "一夕之间": "yì,xī,zhī,jiān",
  "一夕数惊": "yī,xī,shù,jīng",
  "一多对应": "yī,duō,duì,yìng",
  "一夜又一夜地": "yī,yè,yòu,yī,yè,de",
  "一夜情": "yí,yè,qíng",
  "一夜走红": "yí,yè,zǒu,hóng",
  "一夜露水": "yī,yè,lù,shui",
  "一大早儿": "yī,dà,zǎo,er",
  "一大溜": "yī,dà,liù",
  "一天": "yì,tiān",
  "一天一个样": "yī,tiān,yī,ge,yàng",
  "一天星斗": "yī,tiān,xīng,dǒu",
  "一夫拼命": "yī,fū,pàn,mìng",
  "一夫荷戟": "yī,fū,hè,jǐ",
  "一央一个肯": "yī,yāng,yí,gè,kěn",
  "一头儿沉": "yī,tou,er,chén",
  "一如既往": "yì,rú,jì,wǎng",
  "一字不变地": "yī,zì,bù,biàn,de",
  "一字不差": "yī,zì,bù,chā",
  "一字不落": "yī,zì,bù,là",
  "一字不错地熟记": "yī,zì,bù,cuò,de,shú,jì",
  "一字儿": "yī,zì,er",
  "一定": "yí,dìng",
  "一定义地": "yí,deng,yì,de",
  "一定地": "yí,deng,de",
  "一定期地": "yí,deng,qī,de",
  "一定要清醒地认识到": "yí,deng,yào,qīng,xǐng,de,rèn,shí,dào",
  "一家之长": "yī,jiā,zhī,zhǎng",
  "一家伙": "yī,jiā,huo",
  "一宿": "yī,xiǔ",
  "一宿之行": "yī,xiǔ,zhī,xíng",
  "一宿觉": "yī,xiǔ,jué",
  "一对儿": "yī,duì,er",
  "一寻一个着": "yī,xún,yí,gè,zhe",
  "一将难求": "yī,jiàng,nán,qiú",
  "一小部分": "yī,xiǎo,bù,fèn",
  "一小阵儿": "yī,xiǎo,zhèn,er",
  "一就手儿": "yī,jiù,shǒu,er",
  "一屈服地": "yī,qū,fú,de",
  "一帆": "yī,fān",
  "一帆顺风": "yī,fān,shùn,fēng",
  "一帆风": "yī,fān,fēng",
  "一帆风顺": "yī,fán,fēng,shùn",
  "一帖": "yī,tiē",
  "一带儿": "yí,dài,ér",
  "一幕": "yí,mù",
  "一幕幕地": "yí,mù,mù,de",
  "一年三秀": "yì,nián,sān,xiù",
  "一年三节": "yì,nián,sān,jié",
  "一年之计": "yì,nián,zhī,jì",
  "一年到头": "yì,nián,dào,tóu",
  "一年半载": "yī,nián,bàn,zǎi",
  "一年大": "yì,nián,dà",
  "一年春尽一年春": "yì,nián,chūn,jìn,yì,nián,chūn",
  "一年景": "yì,nián,jǐng",
  "一年级": "yì,nián,jí",
  "一度": "yí,dù",
  "一式二份": "yī,shì,ér,fèn",
  "一律地": "yī,lǜ,de",
  "一得": "yī,de",
  "一心一意": "yì,xīn,yí,yì",
  "一心向往": "yì,xīn,xiàng,wǎng",
  "一忙地": "yī,máng,de",
  "一念之差": "yī,niàn,zhī,chā",
  "一念之间": "yí,niàn,zhī,jiān",
  "一怒之下": "yí,nù,zhī,xià",
  "一怔": "yí,zhèng",
  "一性地": "yī,xìng,de",
  "一成": "yì,chéng",
  "一成形地": "yì,chéng,xíng,de",
  "一扇风": "yī,shān,fēng",
  "一扎脚儿": "yī,zā,jué,ér",
  "一把子": "yī,bà,zi",
  "一把抓了两头弗露": "yī,bǎ,zhuā,le,liǎng,tóu,fú,lù",
  "一把钥匙开一把锁": "yī,bǎ,yào,shi,kāi,yī,bǎ,suǒ",
  "一抔黄沙": "yì,póu,huáng,shā",
  "一折一磨": "yī,shé,yī,mó",
  "一折书": "yī,shé,shū",
  "一报还一报": "yī,bào,huán,yī,bào",
  "一抹头": "yī,mò,tóu",
  "一抿子": "yī,mǐn,zi",
  "一拃": "yī,zhà",
  "一担挑": "yī,dàn,tiāo",
  "一拨儿": "yī,bō,er",
  "一拳头砸出一眼井": "yī,quán,tou,zá,chū,yī,yǎn,jǐng",
  "一拿一个着": "yī,ná,yí,gè,zhe",
  "一指头禅": "yī,zhǐ,tou,chán",
  "一掊土": "yī,póu,tǔ",
  "一排排地": "yī,pái,pái,de",
  "一掴一掌血": "yī,guó,yī,zhǎng,xuè",
  "一揽子": "yī,lǎn,zi",
  "一撇": "yī,piě",
  "一撇子": "yī,piě,zǐ",
  "一撒手儿": "yī,sā,shǒu,er",
  "一撮": "yī,zuǒ",
  "一斗珠": "yī,dǒu,zhū",
  "一方面": "yì,fāng,miàn",
  "一日三省": "yī,rì,sān,xǐng",
  "一日三秋": "yí,rì,sān,qiū",
  "一日为师": "yī,rì,wéi,shī",
  "一旦": "yí,dàn",
  "一时千载": "yī,shí,qiān,zǎi",
  "一时半会儿": "yī,shí,bàn,huì,er",
  "一时地": "yī,shí,de",
  "一时得逞": "yì,shí,dé,chěng",
  "一时疏忽": "yì,shí,shū,hū",
  "一明了地": "yī,míng,liǎo,de",
  "一星儿": "yī,xīng,er",
  "一星半点儿": "yī,xīng,bàn,diǎn,er",
  "一暴十寒": "yī,pù,shí,hán",
  "一更": "yī,gēng",
  "一月": "yí,yuè",
  "一服": "yī,fù",
  "一服药": "yī,fù,yào",
  "一望无垠": "yí,wàng,wú,yín",
  "一望无涯": "yí,wàng,wú,yá",
  "一望无际": "yí,wàng,wú,jì",
  "一朝": "yī,zhāo",
  "一朝一夕": "yī,zhāo,yī,xī",
  "一朝之忿": "yī,zhāo,zhī,fèn",
  "一朝之患": "yī,zhāo,zhī,huàn",
  "一朝千里": "yī,zhāo,qiān,lǐ",
  "一朝夕": "yī,zhāo,xī",
  "一朝怀胎": "yī,zhāo,huái,tāi",
  "一朝权在手": "yī,zhāo,quán,zài,shǒu",
  "一朝马死黄金尽": "yī,zhāo,mǎ,sǐ,huáng,jīn,jìn",
  "一札眼": "yī,zhā,yǎn",
  "一朵一朵地摘": "yī,duǒ,yī,duǒ,de,zhāi",
  "一朵一朵地采": "yī,duǒ,yī,duǒ,de,cǎi",
  "一杆子": "yī,gān,zi",
  "一杆子插到底": "yī,gān,zi,chā,dào,dǐ",
  "一条扁担两头挑": "yī,tiáo,biǎn,dàn,liǎng,tóu,tiāo",
  "一条线儿拴俩蚂蚱": "yī,tiáo,xiàn,er,shuān,liǎ,mà,zhà",
  "一条绳上的蚂蚱": "yī,tiáo,shéng,shàng,de,mà,zha",
  "一板地": "yī,bǎn,de",
  "一枪命中": "yī,qiāng,mìng,zhòng",
  "一架子": "yī,jià,zi",
  "一柞": "yī,zhà",
  "一样地": "yī,yàng,de",
  "一根绳上的蚂蚱": "yī,gēn,shéng,shàng,de,mà,zha",
  "一棍子打死": "yī,gùn,zi,dǎ,sǐ",
  "一棒子": "yī,bàng,zi",
  "一模一样": "yī,mú,yī,yàng",
  "一次一次地": "yī,cì,yī,cì,de",
  "一次函数": "yī,cì,hán,shù",
  "一次又一次地": "yī,cì,yòu,yī,cì,de",
  "一次地": "yī,cì,de",
  "一次性": "yí,cì,xìng",
  "一次性地": "yí,cì,xìng,de",
  "一次次地": "yī,cì,cì,de",
  "一次污染物": "yí,cì,wū,rǎn,wù",
  "一步一步": "yí,bù,yí,bù",
  "一步一步地": "yí,bù,yí,bù,de",
  "一步步": "yí,bù,bù",
  "一步步地": "yí,bù,bù,de",
  "一死了之": "yī,sǐ,liǎo,zhī",
  "一毂辘": "yī,gū,lù",
  "一毫不差": "yī,háo,bù,chā",
  "一气一个死": "yī,qì,yí,gè,sǐ",
  "一气之下": "yí,qì,zhī,xià",
  "一气地": "yī,qì,de",
  "一水儿": "yī,shuǐ,er",
  "一沐三捉发": "yī,mù,sān,zhuō,fà",
  "一沐三握发": "yī,mù,sān,wò,fà",
  "一沓": "yī,dá",
  "一沓纸": "yì,dá,zhǐ",
  "一沓钞票": "yì,dá,chāo,piào",
  "一沤": "yī,ōu",
  "一泡子": "yī,pāo,zǐ",
  "一泻千里": "yí,xiè,qiān,lǐ",
  "一派胡言": "yí,pài,hú,yán",
  "一派胡言乱语": "yí,pài,hú,yán,luàn,yǔ",
  "一流": "yì,liú",
  "一流地": "yì,liú,de",
  "一清二楚": "yì,qīng,èr,chǔ",
  "一清宿弊": "yì,qīng,sù,bì",
  "一溜儿": "yī,liù,ér",
  "一溜兀剌": "yī,liū,wū,là",
  "一溜烟": "yī,liú,yān",
  "一溜烟跑掉": "yí,liù,yān,pǎo,diào",
  "一点": "yì,diǎn",
  "一点一点地": "yì,diǎn,yì,diǎn,de",
  "一点一点地完善": "yì,diǎn,yì,diǎn,de,wán,shàn",
  "一点儿": "yī,diǎn,er",
  "一点点地": "yì,diǎn,diǎn,de",
  "一点点地做好": "yì,diǎn,diǎn,de,zuò,hǎo",
  "一点论": "yì,diǎn,lùn",
  "一点钟": "yì,diǎn,zhōng",
  "一熟悉地": "yī,shú,xī,de",
  "一片昏黑": "yí,piàn,hūn,hēi",
  "一片混乱": "yí,piàn,hùn,luàn",
  "一片片地": "yī,piàn,piàn,de",
  "一片空白": "yí,piàn,kòng,bái",
  "一物降一物": "yī,wù,xiáng,yī,wù",
  "一现昙华": "yī,xiàn,tán,huā",
  "一生一世": "yì,shēng,yí,shì",
  "一略数": "yī,lüè,shù",
  "一疙瘩": "yī,gē,dā",
  "一疲倦地": "yī,pí,juàn,de",
  "一百": "yì,bǎi",
  "一百二十行": "yī,bǎi,èr,shí,háng",
  "一百亿": "yì,bǎi,yì",
  "一盘散沙": "yī,pán,sǎn,shā",
  "一目了然": "yī,mù,liǎo,rán",
  "一目五行": "yī,mù,wǔ,háng",
  "一目十行": "yī,mù,shí,háng",
  "一目数行": "yī,mù,shù,háng",
  "一直": "yì,zhí",
  "一直在苦苦地": "yì,zhí,zài,kǔ,kǔ,de",
  "一直地": "yì,zhí,de",
  "一直安静地": "yì,zhí,ān,jìng,de",
  "一直线地": "yì,zhí,xiàn,de",
  "一直走": "yì,zhí,zǒu",
  "一着": "yī,zhāo",
  "一着不慎": "yī,zhāo,bù,shèn",
  "一着不慎全盘皆输": "yī,zhāo,bù,shèn,quán,pán,jiē,shū",
  "一着被蛇咬": "yī,zhāo,bèi,shé,yǎo",
  "一矢中的": "yī,shǐ,zhòng,dì",
  "一稳定地": "yī,wěn,deng,de",
  "一窝蜂地": "yī,wō,fēng,de",
  "一竿子插到底": "yī,gān,zi,chā,dào,dǐ",
  "一笑了之": "yī,xiào,liǎo,zhī",
  "一笔抹𢫬": "yī,bǐ,mò,sà",
  "一笴": "yī,gǎn",
  "一等奖": "yì,děng,jiǎng",
  "一箍脑儿": "yī,gū,nǎo,er",
  "一箭上垛": "yī,jiàn,shàng,duò",
  "一篇文章": "yì,piān,wén,zhāng",
  "一线之隔": "yí,xiàn,zhī,gé",
  "一而再": "yì,ér,zài",
  "一肚子": "yī,dǔ,zi",
  "一股劲": "yì,gǔ,jìn",
  "一股劲儿": "yī,gǔ,jìn,er",
  "一股子": "yī,gǔ,zi",
  "一股脑儿": "yī,gǔ,nǎo,er",
  "一股脑地": "yī,gǔ,nǎo,de",
  "一胆地": "yī,dǎn,de",
  "一致": "yí,zhì",
  "一致地": "yí,zhì,de",
  "一致性效应": "yī,zhì,xìng,xiào,yìng",
  "一舍": "yī,shè",
  "一般": "yì,bān",
  "一般化": "yì,bān,huà",
  "一般地": "yì,bān,de",
  "一般地指": "yì,bān,de,zhǐ",
  "一般地讲": "yì,bān,de,jiǎng",
  "一般地说": "yì,bān,de,shuō",
  "一般性地": "yì,bān,xìng,de",
  "一般样": "yì,bān,yàng",
  "一般规律": "yì,bān,guī,lǜ",
  "一艘船": "yì,sōu,chuán",
  "一节俭地": "yī,jié,jiǎn,de",
  "一裹脑子": "yī,guǒ,nǎo,zi",
  "一视同仁地对待": "yī,shì,tóng,rén,de,duì,dài",
  "一览无遗": "yì,lǎn,wú,yí",
  "一觉": "yī,jiào",
  "一觉地": "yī,jiào,de",
  "一觉醒来": "yī,jiào,xǐng,lái",
  "一言中的": "yì,yán,zhòng,dì",
  "一言为定": "yī,yán,wéi,dìng",
  "一言为重": "yī,yán,wéi,zhòng",
  "一言九鼎": "yì,yán,jiǔ,dǐng",
  "一言兴邦": "yī,yán,xīng,bāng",
  "一语中人": "yī,yǔ,zhòng,rén",
  "一语中的": "yī,yǔ,zhòng,dì",
  "一语破的": "yī,yǔ,pò,dì",
  "一诺千金": "yí,nuò,qiān,jīn",
  "一贯": "yí,guàn",
  "一贯地": "yí,guàn,de",
  "一贯性": "yí,guàn,xìng",
  "一走了之": "yī,zǒu,liǎo,zhī",
  "一起": "yì,qǐ",
  "一起头": "yì,qǐ,tóu",
  "一起子": "yì,qǐ,zǐ",
  "一跌不振": "yī,diē,bù,zhèn",
  "一路人": "yí,lù,rén",
  "一路哭": "yí,lù,kū",
  "一路平安": "yí,lù,píng,ān",
  "一路神祇": "yī,lù,shén,qí",
  "一踏脚儿": "yī,tà,jué,ér",
  "一蹴而就": "yí,cù,ér,jiù",
  "一蹶不兴": "yī,juě,bù,xīng",
  "一车骨头半车肉": "yī,chē,gú,tou,bàn,chē,ròu",
  "一辈子": "yī,bèi,zi",
  "一边好奇地": "yī,biān,hào,qí,de",
  "一还一报": "yī,huán,yī,bào",
  "一连气儿": "yī,lián,qì,er",
  "一适": "yī,shì",
  "一通": "yí,tòng",
  "一通儿": "yī,tòng,ér",
  "一通连": "yī,tòng,lián",
  "一部分": "yī,bù,fen",
  "一部分地": "yī,bù,fèn,de",
  "一重一掩": "yī,chóng,yī,yǎn",
  "一针一缐": "yī,zhēn,yī,yú",
  "一铳子性儿": "yī,chòng,zi,xìng,ér",
  "一铺": "yī,pù",
  "一铺安心": "yī,pù,ān,xīn",
  "一铺滩": "yī,pù,tān",
  "一锤子买卖": "yī,chuí,zi,mǎi,mài",
  "一门口子": "yī,mén,kǒu,zi",
  "一问一个肯": "yī,wèn,yí,gè,kěn",
  "一阵子": "yī,zhèn,zi",
  "一隅": "yì,yú",
  "一面": "yí,miàn",
  "一面之缘": "yí,miàn,zhī,yuán",
  "一面倒": "yí,miàn,dǎo",
  "一鞭先着": "yī,biān,xiān,zhāo",
  "一鞭先著": "yī,biān,xiān,zhuó",
  "一项一项地": "yī,xiàng,yī,xiàng,de",
  "一饭之顷": "yī,fàn,zhī,qīng",
  "一驮": "yī,duò",
  "一驮粮": "yí,duò,liáng",
  "一骨碌": "yī,gū,lù",
  "一鸣惊人": "yì,míng,jīng,rén",
  "一齐地": "yī,qí,de",
  "丁令": "dīng,líng",
  "丁令威": "dīng,líng,wēi",
  "丁巳复辟": "dīng,sì,fù,bì",
  "丁折": "dīng,shé",
  "丁板子": "dīng,bǎn,zi",
  "丁点儿": "dīng,diǎn,er",
  "七倍地": "qī,bèi,de",
  "七停八当": "qī,tíng,bā,dàng",
  "七十二地煞": "qī,shí,èr,dì,shà",
  "七十二行": "qī,shí,èr,háng",
  "七十二钻": "qī,shí,èr,zuàn",
  "七十倍地": "qī,shí,bèi,de",
  "七十钻": "qī,shí,zuàn",
  "七大夫": "qī,dài,fū",
  "七拱八翘": "qī,gǒng,bā,qiào",
  "七搭八搭": "qī,cháng,bā,dā",
  "七断八续": "qī,duàn,bā,sù",
  "七星冠": "qī,xīng,guān",
  "七板子": "qī,bǎn,zi",
  "七次量衣一次裁": "qī,cì,liáng,yī,yī,cì,cái",
  "七煞": "qī,shà",
  "七科适": "qī,kē,shì",
  "七䇲": "qī,jiā",
  "七舆大夫": "qī,yú,dài,fū",
  "七舍": "qī,shè",
  "七行俱下": "qī,háng,jù,xià",
  "七观帖": "qī,guān,tiē",
  "七调": "qī,diào",
  "七贵五侯": "qī,guì,wǔ,hòu",
  "七跌八撞": "qī,diē,bā,zhuàng",
  "七返还丹": "qī,fǎn,huán,dān",
  "七郄八手": "qī,xì,bā,shǒu",
  "七重围子": "qī,chóng,wéi,zǐ",
  "七隩": "qī,yù",
  "万乘": "wàn,shèng",
  "万俟": "mò,qí",
  "万分地小心": "wàn,fēn,de,xiǎo,xīn",
  "万别千差": "wàn,bié,qiān,chā",
  "万卷": "wàn,juàn",
  "万头攒动": "wàn,tóu,cuán,dòng",
  "万应灵丹": "wàn,yìng,líng,dān",
  "万应灵药": "wàn,yìng,líng,yào",
  "万应锭": "wàn,yìng,dìng",
  "万户侯": "wàn,hù,hòu",
  "万柏林": "wàn,bó,lín",
  "万柏林区": "wàn,bó,lín,qū",
  "万石": "wàn,dàn",
  "万石君": "wàn,dàn,jūn",
  "万箭攒心": "wàn,jiàn,cuán,xīn",
  "万耑": "wàn,zhuān",
  "万能曲尺": "wàn,néng,qū,chǐ",
  "万能钥匙": "wàn,néng,yào,shi",
  "万象更新": "wàn,xiàng,gēng,xīn",
  "万里侯": "wàn,lǐ,hòu",
  "丈二金刚摸不着头脑": "zhàng,èr,jīn,gāng,mō,bu,zháo,tóu,nǎo",
  "丈夫儿": "zhàng,fū,er",
  "丈数": "zhàng,shù",
  "丈量": "zhàng,liáng",
  "三不拗六": "sān,bù,niù,liù",
  "三个和尚没水吃": "sān,gè,hé,shang,méi,shuǐ,chī",
  "三个和尚没水喝": "sān,gè,hé,shang,méi,shuǐ,hē",
  "三个女人一台戏": "sān,ge,nǚ,rén,yī,tái,xì",
  "三乘": "sān,shèng",
  "三九相公": "sān,jiǔ,xiàng,gōng",
  "三侯": "sān,hòu",
  "三侯之章": "sān,hòu,zhī,zhāng",
  "三保太监": "sān,bǎo,tài,jiàn",
  "三倍地": "sān,bèi,de",
  "三冠": "sān,guān",
  "三削": "sān,xuē",
  "三十二相": "sān,shí,èr,xiàng",
  "三十倍地": "sān,shí,bèi,de",
  "三十儿": "sān,shí,er",
  "三十六着": "sān,shí,liù,zhe",
  "三十六行": "sān,shí,liù,háng",
  "三占从二": "sān,zhān,cóng,èr",
  "三句不离本行": "sān,jù,bù,lí,běn,háng",
  "三句话不离本行": "sān,jù,huà,bù,lí,běn,háng",
  "三只手": "sān,zhī,shǒu",
  "三咽": "sān,yān",
  "三处合": "sān,chǔ,hé",
  "三大差别": "sān,dà,chā,bié",
  "三天两宿": "sān,tiān,liǎng,xiǔ",
  "三宝太监": "sān,bǎo,tài,jiàn",
  "三家𫉄": "sān,jiā,zhū",
  "三宿": "sān,xiǔ",
  "三宿恋": "sān,xiǔ,liàn",
  "三寸咽": "sān,cùn,yān",
  "三小子": "sān,xiǎo,zi",
  "三差两错": "sān,chā,liǎng,cuò",
  "三差五错": "sān,chā,wǔ,cuò",
  "三征七辟": "sān,zhǐ,qī,pì",
  "三折股为良医": "sān,zhé,gǔ,wéi,liáng,yī",
  "三折肱为良医": "sān,zhé,gōng,wéi,liáng,yī",
  "三握发": "sān,wò,fà",
  "三支比量": "sān,zhī,bǐ,liáng",
  "三数": "sān,shù",
  "三斗尘": "sān,dǒu,chén",
  "三斗葱": "sān,dǒu,cōng",
  "三斗醋": "sān,dǒu,cù",
  "三无坐处": "sān,wú,zuò,chǔ",
  "三日三夜说不了": "sān,rì,sān,yè,shuō,bù,liǎo",
  "三日仆射": "sān,rì,pú,yè",
  "三旨相公": "sān,zhǐ,xiàng,gōng",
  "三更": "sān,gēng",
  "三更半夜": "sān,gēng,bàn,yè",
  "三更枣": "sān,gēng,zǎo",
  "三查三整": "sān,zhā,sān,zhěng",
  "三次地": "sān,cì,de",
  "三次曲线": "sān,cì,qū,xiàn",
  "三段地": "sān,duàn,de",
  "三澣": "sān,hàn",
  "三灾八难": "sān,zāi,bā,nàn",
  "三牛为麄": "sān,niú,wéi,cū",
  "三率": "sān,shuài",
  "三百六十行": "sān,bǎi,liù,shí,háng",
  "三相点": "sān,xiàng,diǎn",
  "三省": "sān,xǐng",
  "三省吾身": "sān,xǐng,wú,shēn",
  "三祇": "sān,qí",
  "三笴": "sān,gǎn",
  "三累": "sān,lèi",
  "三缪": "sān,miù",
  "三翟": "sān,zhái",
  "三老五更": "sān,lǎo,wǔ,gēng",
  "三脚虾蟆": "sān,jiǎo,há,má",
  "三舍": "sān,shè",
  "三舍人诗": "sān,shè,rén,shī",
  "三舍法": "sān,shè,fǎ",
  "三色堇": "sān,sè,jǐn",
  "三藏": "sān,zàng",
  "三藏法师": "sān,zàng,fǎ,shī",
  "三角函数": "sān,jiǎo,hán,shù",
  "三角地": "sān,jiǎo,de",
  "三角测量法": "sān,jiǎo,cè,liáng,fǎ",
  "三角裤衩": "sān,jiǎo,kù,chǎ",
  "三请诸葛亮": "sān,qǐng,zhū,gě,liàng",
  "三调": "sān,diào",
  "三轮儿": "sān,lún,er",
  "三适": "sān,shì",
  "三𰺷鹊": "sān,rǎo,què",
  "三邻四舍": "sān,lín,sì,shè",
  "三郄": "sān,xì",
  "三都县": "sān,dū,xiàn",
  "三都水族自治县": "sān,dū,shuǐ,zú,zì,zhì,xiàn",
  "三重": "sān,chóng",
  "三重县": "sān,chóng,xiàn",
  "三重唱": "sān,chóng,chàng",
  "三重地": "sān,chóng,de",
  "三重奏": "sān,chóng,zòu",
  "三重市": "sān,chóng,shì",
  "三重门": "sān,chóng,mén",
  "三锥子扎不出血来": "sān,zhuī,zǐ,zhā,bù,chū,xuè,lái",
  "三𬮴": "sān,ān",
  "三门干部": "sān,mén,gàn,bù",
  "三闾大夫": "sān,lǘ,dài,fū",
  "三阳交泰": "sān,yáng,jiāo,tai",
  "三陪小姐": "sān,péi,xiǎo,jie",
  "三露": "sān,lù",
  "三鹿为奔": "sān,lù,wéi,bēn",
  "三鹿为犇": "sān,lù,wéi,bēn",
  "上一个": "shàng,yī,ge",
  "上下地": "shàng,xià,de",
  "上下打量": "shàng,xià,dǎ,liang",
  "上下文地": "shàng,xià,wén,de",
  "上下铺": "shàng,xià,pù",
  "上不了台面": "shàng,bù,liǎo,tái,miàn",
  "上不着天": "shàng,bù,zháo,tiān",
  "上个": "shàng,ge",
  "上之所好": "shàng,zhī,suǒ,hào",
  "上刹": "shàng,shā",
  "上半部分": "shàng,bàn,bù,fèn",
  "上去": "shǎng,qù",
  "上同调": "shàng,tóng,diào",
  "上吐下泻": "shàng,tù,xià,xiè",
  "上声": "shǎng,shēng",
  "上大夫": "shàng,dài,fū",
  "上头": "shàng,tou",
  "上将": "shàng,jiàng",
  "上将军": "shàng,jiàng,jūn",
  "上尖儿": "shàng,jiān,er",
  "上岁数": "shàng,suì,shù",
  "上帝地": "shàng,de,de",
  "上干": "shàng,gàn",
  "上座儿": "shàng,zuò,er",
  "上当": "shàng,dàng",
  "上当受骗": "shàng,dàng,shòu,piàn",
  "上愬": "shàng,shuò",
  "上槛": "shàng,kǎn",
  "上海浦东发展银行": "shàng,hǎi,pǔ,dōng,fā,zhǎn,yín,háng",
  "上海音乐学院": "shàng,hǎi,yīn,yuè,xué,yuàn",
  "上澣": "shàng,hàn",
  "上相": "shàng,xiàng",
  "上着": "shàng,zhe",
  "上舍": "shàng,shè",
  "上证综合指数": "shàng,zhèng,zōng,hé,zhǐ,shù",
  "上诉地": "shàng,sù,de",
  "上调": "shàng,diào",
  "上载": "shàng,zǎi",
  "上辈子": "shàng,bèi,zi",
  "上边儿": "shàng,bian,er",
  "上述地": "shàng,shù,de",
  "上都": "shàng,dū",
  "上钩儿": "shàng,gōu,er",
  "上铺": "shàng,pù",
  "上阳白发人": "shàng,yáng,bái,fà,rén",
  "上馆子": "shàng,guǎn,zi",
  "上齐": "shàng,jì",
  "下一个": "xià,yī,ge",
  "下一钩子": "xià,yī,gōu,zi",
  "下不为例": "xià,bù,wéi,lì",
  "下不了台": "xià,bù,liǎo,tái",
  "下不着地": "xià,bù,zháo,dì",
  "下个": "xià,ge",
  "下乘": "xià,shèng",
  "下作": "xià,zuo",
  "下划线": "xià,huà,xiàn",
  "下卷": "xià,juàn",
  "下参差": "xià,cēn,cī",
  "下句丽": "xià,jù,lí",
  "下吧": "xià,ba",
  "下嗑子": "xià,kè,zǐ",
  "下处": "xià,chǔ",
  "下大夫": "xià,dài,fū",
  "下头": "xià,tou",
  "下巴": "xià,ba",
  "下得": "xià,de",
  "下得去": "xià,děi,qù",
  "下性子": "xià,xìng,zi",
  "下意识地": "xià,yì,shí,de",
  "下意识地收手": "xià,yì,shí,de,shōu,shǒu",
  "下意识地避开了": "xià,yì,shí,de,bì,kāi,le",
  "下无卓锥": "xià,wú,zhuō,zhuī",
  "下来": "xià,lai",
  "下槛": "xià,kǎn",
  "下流地": "xià,liú,de",
  "下潠田": "xià,sùn,tián",
  "下澣": "xià,hàn",
  "下着": "xià,zhe",
  "下等地": "xià,děng,de",
  "下自成行": "xià,zì,chéng,háng",
  "下自成蹊": "xià,zì,chéng,xī",
  "下舍": "xià,shè",
  "下蕃": "xià,fān",
  "下调": "xià,diào",
  "下贱地": "xià,jiàn,de",
  "下贲": "xià,bēn",
  "下跌": "xià,diē",
  "下载": "xià,zǎi",
  "下辈子": "xià,bèi,zi",
  "下边": "xià,bian",
  "下边儿": "xià,bian,er",
  "下都": "xià,dū",
  "下野地": "xià,yě,de",
  "下铺": "xià,pù",
  "下降地": "xià,jiàng,de",
  "下馆子": "xià,guǎn,zi",
  "丌官": "jī,guān",
  "不一会儿": "bù,yī,huì,er",
  "不一定": "bù,yí,dìng",
  "不一样": "bù,yí,yàng",
  "不一致地": "bù,yī,zhì,de",
  "不丁点儿": "bù,dīng,diǎn,er",
  "不世": "bu,shi",
  "不严密地": "bù,yán,mì,de",
  "不严格地": "bù,yán,gé,de",
  "不中意": "bù,zhòng,yì",
  "不为": "bù,wéi",
  "不为五斗米折腰": "bù,wèi,wǔ,dǒu,mǐ,zhé,yāo",
  "不为人知": "bù,wéi,rén,zhī",
  "不为名不为利": "bù,wéi,míng,bù,wéi,lì",
  "不为已甚": "bù,wéi,yǐ,shèn",
  "不为所动": "bù,wéi,suǒ,dòng",
  "不为牛后": "bù,wéi,niú,hòu",
  "不为瓦全": "bù,wéi,wǎ,quán",
  "不为过": "bù,wéi,guò",
  "不为酒困": "bù,wéi,jiǔ,kùn",
  "不久地": "bù,jiǔ,de",
  "不义": "bú,yì",
  "不义地": "bú,yì,de",
  "不习惯地": "bù,xí,guàn,de",
  "不了": "bù,liǎo",
  "不了不当": "bù,liǎo,bù,dàng",
  "不了了之": "bù,liǎo,liǎo,zhī",
  "不了事": "bù,liǎo,shì",
  "不了格": "bù,liǎo,gé",
  "不了缘": "bù,liǎo,yuán",
  "不了而了": "bù,liǎo,ér,liǎo",
  "不予理会": "bù,yǔ,lǐ,huì",
  "不予置评": "bù,yǔ,zhì,píng",
  "不予评论": "bù,yǔ,píng,lùn",
  "不亦说乎": "bù,yì,yuè,hū",
  "不亲切地": "bù,qīn,qiè,de",
  "不仔细地": "bù,zǐ,xì,de",
  "不以为奇": "bù,yǐ,wéi,qí",
  "不以为意": "bù,yǐ,wéi,yì",
  "不以为然": "bù,yǐ,wéi,rán",
  "不以为耻": "bù,yǐ,wéi,chǐ",
  "不以语人": "bù,yǐ,yù,rén",
  "不价": "bù,jie",
  "不休息地": "bù,xiū,xī,de",
  "不优美地": "bù,yōu,měi,de",
  "不会": "bú,huì",
  "不会又悄悄地": "bú,huì,yòu,qiāo,qiāo,de",
  "不会得": "bú,huì,de",
  "不会眼睁睁地": "bú,huì,yǎn,zhēng,zhēng,de",
  "不会那样地": "bú,huì,nà,yàng,de",
  "不住": "bú,zhù",
  "不住地": "bú,zhù,de",
  "不住地后退": "bú,zhù,de,hòu,tuì",
  "不住地呕吐": "bú,zhù,de,ǒu,tù",
  "不住地咳嗽": "bú,zhù,de,ké,sòu",
  "不住地淌": "bú,zhù,de,tǎng",
  "不住地磕头": "bú,zhù,de,kē,tóu",
  "不住地说": "bú,zhù,de,shuō",
  "不住地跳": "bú,zhù,de,tiào",
  "不住地颤抖": "bú,zhù,de,chàn,dǒu",
  "不住子": "bú,zhù,zǐ",
  "不住气": "bú,zhù,qì",
  "不体贴地": "bù,tǐ,tiē,de",
  "不体面地": "bù,tǐ,miàn,de",
  "不作为": "bù,zuò,wéi",
  "不作兴": "bù,zuò,xīng",
  "不便地": "bù,biàn,de",
  "不保险地": "bù,bǎo,xiǎn,de",
  "不信相地": "bù,xìn,xiāng,de",
  "不信神地": "bù,xìn,shén,de",
  "不值当": "bù,zhí,dàng",
  "不值得": "bù,zhí,de",
  "不值得地": "bù,zhí,dé,de",
  "不值识者一笑": "bù,zhí,shí,zhě,yí,xiào",
  "不假地": "bù,jiǎ,de",
  "不偏离地": "bù,piān,lí,de",
  "不停地": "bù,tíng,de",
  "不停地做": "bù,tíng,de,zuò",
  "不停地发出": "bù,tíng,de,fā,chū",
  "不停地发抖": "bù,tíng,de,fā,dǒu",
  "不停地变化": "bù,tíng,de,biàn,huà",
  "不停地叫": "bù,tíng,de,jiào",
  "不停地叫喊着": "bù,tíng,de,jiào,hǎn,zhe",
  "不停地吃": "bù,tíng,de,chī",
  "不停地告饶": "bù,tíng,de,gào,ráo",
  "不停地哭": "bù,tíng,de,kū",
  "不停地喊": "bù,tíng,de,hǎn",
  "不停地嚼": "bù,tíng,de,jué",
  "不停地大笑": "bù,tíng,de,dà,xiào",
  "不停地宣泄": "bù,tíng,de,xuān,xiè",
  "不停地射出": "bù,tíng,de,shè,chū",
  "不停地射击": "bù,tíng,de,shè,jī",
  "不停地想": "bù,tíng,de,xiǎng",
  "不停地换花样": "bù,tíng,de,huàn,huā,yàng",
  "不停地提升": "bù,tíng,de,tí,shēng",
  "不停地提醒自己": "bù,tíng,de,tí,xǐng,zì,jǐ",
  "不停地摇着": "bù,tíng,de,yáo,zhe",
  "不停地旋转": "bù,tíng,de,xuán,zhuǎn",
  "不停地求饶": "bù,tíng,de,qiú,ráo",
  "不停地涌现": "bù,tíng,de,yǒng,xiàn",
  "不停地淌": "bù,tíng,de,tǎng",
  "不停地笑": "bù,tíng,de,xiào",
  "不停地讲": "bù,tíng,de,jiǎng",
  "不停地说": "bù,tíng,de,shuō",
  "不停地说话": "bù,tíng,de,shuō,huà",
  "不停地走": "bù,tíng,de,zǒu",
  "不停地跳": "bù,tíng,de,tiào",
  "不停地转动": "bù,tíng,de,zhuàn,dòng",
  "不停地闪烁": "bù,tíng,de,shǎn,shuò",
  "不停地颤抖": "bù,tíng,de,chàn,dǒu",
  "不停地骂": "bù,tíng,de,mà",
  "不停地骚扰": "bù,tíng,de,sāo,rǎo",
  "不停顿地": "bù,tíng,dùn,de",
  "不健全地": "bù,jiàn,quán,de",
  "不健康地": "bù,jiàn,kāng,de",
  "不儿": "bú,er",
  "不儿道": "bū,er,dào",
  "不允许地": "bù,yǔn,xǔ,de",
  "不充分地": "bù,chōng,fèn,de",
  "不充足地": "bù,chōng,zú,de",
  "不公平地": "bù,gōng,píng,de",
  "不公正地": "bù,gōng,zhèng,de",
  "不关心地": "bù,guān,xīn,de",
  "不兴": "bù,xīng",
  "不具名地": "bù,jù,míng,de",
  "不冒昧地": "bù,mào,mèi,de",
  "不凋萎地": "bù,diāo,wēi,de",
  "不减弱地": "bù,jiǎn,ruò,de",
  "不减退地": "bù,jiǎn,tuì,de",
  "不分开地": "bù,fēn,kāi,de",
  "不切": "bù,qiè",
  "不切合实际": "bù,qiè,hé,shí,jì",
  "不切题": "bú,qiè,tí",
  "不切题地": "bú,qiè,tí,de",
  "不利地": "bù,lì,de",
  "不到": "bú,dào",
  "不到乌江心不死": "bú,dào,wū,jiāng,xīn,bù,sǐ",
  "不到位": "bú,dào,wèi",
  "不到头": "bú,dào,tóu",
  "不到家": "bú,dào,jiā",
  "不到得": "bú,dào,de",
  "不到的": "bú,dào,de",
  "不到长城非好汉": "bú,dào,cháng,chéng,fēi,hǎo,hàn",
  "不加深究地": "bù,jiā,shēn,jiū,de",
  "不动地": "bù,dòng,de",
  "不动声色地": "bù,dòng,shēng,sè,de",
  "不动如山": "bú,dòng,rú,shān",
  "不动心地": "bù,dòng,xīn,de",
  "不区别地": "bù,qū,bié,de",
  "不协调地": "bù,xié,tiáo,de",
  "不卖查梨": "bù,mài,zhā,lí",
  "不卫生地": "bù,wèi,shēng,de",
  "不厌倦地": "bù,yàn,juàn,de",
  "不厌其烦地": "bù,yàn,qí,fán,de",
  "不及物地": "bù,jí,wù,de",
  "不友善地": "bù,yǒu,shàn,de",
  "不友好地": "bù,yǒu,hǎo,de",
  "不友好地对待": "bù,yǒu,hǎo,de,duì,dài",
  "不发声地": "bù,fā,shēng,de",
  "不变化地": "bù,biàn,huà,de",
  "不变地": "bù,biàn,de",
  "不可估量": "bù,kě,gū,liáng",
  "不可信地": "bù,kě,xìn,de",
  "不可分地": "bù,kě,fēn,de",
  "不可变更地": "bù,kě,biàn,gēng,de",
  "不可揆度": "bù,kě,kuí,duó",
  "不可改变地": "bù,kě,gǎi,biàn,de",
  "不可数地": "bù,kě,shù,de",
  "不可数集": "bù,kě,shuò,jí",
  "不可能地": "bù,kě,néng,de",
  "不可能无限制地": "bù,kě,néng,wú,xiàn,zhì,de",
  "不可觉地": "bù,kě,jué,de",
  "不可解地": "bù,kě,jiě,de",
  "不可避免地": "bù,kě,bì,miǎn,de",
  "不可闻地": "bù,kě,wén,de",
  "不可靠地": "bù,kě,kào,de",
  "不合宜地": "bù,hé,yí,de",
  "不合理地": "bù,hé,lǐ,de",
  "不合适地": "bù,hé,shì,de",
  "不吉利地": "bù,jí,lì,de",
  "不吉地": "bù,jí,de",
  "不吉祥地": "bù,jí,xiáng,de",
  "不同地": "bù,tóng,de",
  "不同程度地": "bù,tóng,chéng,dù,de",
  "不同等地": "bù,tóng,děng,de",
  "不同类地": "bù,tóng,lèi,de",
  "不名数": "bù,míng,shù",
  "不名誉地": "bù,míng,yù,de",
  "不吝惜地": "bù,lìn,xī,de",
  "不含糊": "bù,hán,hù",
  "不含糊地": "bù,hán,hù,de",
  "不听话地": "bù,tīng,huà,de",
  "不咋地": "bù,zǎ,de",
  "不和悦地": "bù,hé,yuè,de",
  "不和蔼地": "bù,hé,ǎi,de",
  "不和谐地": "bù,hé,xié,de",
  "不善地": "bù,shàn,de",
  "不嗄": "bù,á",
  "不固定地": "bù,gù,deng,de",
  "不在乎地": "bù,zài,hū,de",
  "不在其位不谋其政": "bù,zài,qí,wèi,bù,mòu,qí,zhèng",
  "不在意地": "bù,zài,yì,de",
  "不在行": "bù,zài,háng",
  "不均地": "bù,jūn,de",
  "不均衡地": "bù,jūn,héng,de",
  "不坚固地": "bù,jiān,gù,de",
  "不坦白地": "bù,tǎn,bái,de",
  "不坦诚地": "bù,tǎn,chéng,de",
  "不堤防": "bù,dī,fáng",
  "不塞不流": "bù,sè,bù,liú",
  "不声不吭": "bù,shēng,bù,kēng",
  "不处": "bù,chǔ",
  "不外露": "bù,wài,lù",
  "不夜侯": "bù,yè,hòu",
  "不够格地": "bù,gòu,gé,de",
  "不大方便": "bú,dà,fāng,biàn",
  "不大离儿": "bù,dà,lí,er",
  "不失为": "bù,shī,wéi",
  "不夸张地": "bù,kuā,zhāng,de",
  "不夸张地说": "bù,kuā,zhāng,de,shuō",
  "不好意思地": "bù,hǎo,yì,sī,de",
  "不好看地": "bù,hǎo,kàn,de",
  "不如薄技在身": "bù,rú,bó,jì,zài,shēn",
  "不妥地": "bù,tuǒ,de",
  "不宁地": "bù,níng,de",
  "不安全地": "bù,ān,quán,de",
  "不安分": "bù,ān,fèn",
  "不安地": "bù,ān,de",
  "不安定地": "bù,ān,deng,de",
  "不完全地": "bù,wán,quán,de",
  "不完善地": "bù,wán,shàn,de",
  "不完备地": "bù,wán,bèi,de",
  "不完美地": "bù,wán,měi,de",
  "不定地": "bù,deng,de",
  "不定时地": "bù,deng,shí,de",
  "不定期地": "bù,deng,qī,de",
  "不定期地出现": "bù,deng,qī,de,chū,xiàn",
  "不定期地检查": "bù,deng,qī,de,jiǎn,chá",
  "不实地": "bù,shí,de",
  "不客气": "bú,kè,qì",
  "不客气地": "bú,kè,qì,de",
  "不客气地说": "bú,kè,qì,de,shuō",
  "不害臊地": "bù,hài,sào,de",
  "不宽恕地": "bù,kuān,shù,de",
  "不寐": "bú,mèi",
  "不对": "bú,duì",
  "不对劲": "bú,duì,jìn",
  "不对劲儿": "bù,duì,jìn,er",
  "不对味儿": "bú,duì,wèi,er",
  "不对头": "bú,duì,tóu",
  "不对当": "bú,duì,dāng",
  "不对碴儿": "bù,duì,chá,er",
  "不对称": "bù,duì,chèn",
  "不对茬儿": "bú,duì,chá,ér",
  "不寻常地": "bù,xún,cháng,de",
  "不寻思": "bù,xín,sī",
  "不小心地": "bù,xiǎo,xīn,de",
  "不少地": "bù,shǎo,de",
  "不屈地": "bù,qū,de",
  "不屈曲地": "bù,qū,qū,de",
  "不屈服地": "bù,qū,fú,de",
  "不屑一读": "bú,xiè,yì,dú",
  "不屑于": "bú,xiè,yú",
  "不屑地说": "bù,xiè,de,shuō",
  "不屑意": "bú,xiè,yì",
  "不差上下": "bù,chā,shàng,xià",
  "不差什": "bù,chà,shí",
  "不差毫厘": "bù,chā,háo,lí",
  "不差毫发": "bù,chā,háo,fà",
  "不差累黍": "bù,chā,lěi,shǔ",
  "不帑": "bù,tǎng",
  "不常有地": "bù,cháng,yǒu,de",
  "不干": "bù,gàn",
  "不干事": "bù,gàn,shì",
  "不平地": "bù,píng,de",
  "不平坦地": "bù,píng,tǎn,de",
  "不平常地": "bù,píng,cháng,de",
  "不平稳地": "bù,píng,wěn,de",
  "不平衡地": "bù,píng,héng,de",
  "不幸地": "bù,xìng,de",
  "不幸地成为": "bù,xìng,de,chéng,wéi",
  "不幸而言中": "bù,xìng,ér,yán,zhòng",
  "不幸言中": "bù,xìng,yán,zhòng",
  "不幽默地": "bù,yōu,mò,de",
  "不应当地": "bù,yīng,dāng,de",
  "不应得地": "bù,yīng,de,de",
  "不应期": "bù,yìng,qī",
  "不延迟地": "bù,yán,chí,de",
  "不当": "bù,dàng",
  "不当一回事": "bù,dàng,yī,huí,shì",
  "不当人": "bù,dàng,rén",
  "不当价": "bù,dàng,jià",
  "不当地": "bù,dàng,de",
  "不当奇": "bù,dàng,qí",
  "不当家": "bù,dàng,jiā",
  "不当家化化的": "bù,dàng,jiā,huà,huà,de",
  "不当家花拉": "bù,dàng,jiā,huā,lā",
  "不当家豁拉": "bù,dàng,jiā,huō,lā",
  "不当得利": "bù,dàng,dé,lì",
  "不当村": "bù,dàng,cūn",
  "不当稳便": "bù,dàng,wěn,biàn",
  "不当道": "bù,dàng,dào",
  "不徇": "bù,xún",
  "不得体地": "bù,dé,tǐ,de",
  "不得命": "bu,de,ming",
  "不得哥儿们": "bù,dé,gē,ér,men",
  "不得已地": "bù,dé,yǐ,de",
  "不得已而为之": "bù,dé,yǐ,ér,wéi,zhī",
  "不得当地": "bù,dé,dāng,de",
  "不得随地吐痰": "bù,dé,suí,de,tǔ,tán",
  "不得随地大小便": "bù,dé,suí,de,dà,xiǎo,biàn",
  "不必要地": "bù,bì,yào,de",
  "不必过多地": "bù,bì,guò,duō,de",
  "不忘宿志": "bú,wàng,sù,zhì",
  "不忠地": "bù,zhōng,de",
  "不忠实地": "bù,zhōng,shí,de",
  "不怀好意": "bù,huái,hào,yì",
  "不怕地": "bù,pà,de",
  "不怨地": "bù,yuàn,de",
  "不怨天不怨地": "bù,yuàn,tiān,bù,yuàn,de",
  "不恰当地": "bù,qià,dàng,de",
  "不悦": "bú,yuè",
  "不悦地": "bú,yuè,de",
  "不情愿地": "bù,qíng,yuàn,de",
  "不情愿地说": "bù,qíng,yuàn,de,shuō",
  "不惜一切代价": "bù,xī,yí,qiè,dài,jià",
  "不惜工本地": "bù,xī,gōng,běn,de",
  "不惜血本": "bù,xī,xuè,běn",
  "不愉快地": "bù,yú,kuài,de",
  "不愿意地": "bù,yuàn,yì,de",
  "不慈悲地": "bù,cí,bēi,de",
  "不慌张地": "bù,huāng,zhāng,de",
  "不慌忙地": "bù,huāng,máng,de",
  "不慎地": "bù,shèn,de",
  "不懈地": "bù,xiè,de",
  "不成形地": "bù,chéng,xíng,de",
  "不成样子": "bù,chéng,yàng,zi",
  "不战而胜": "bú,zhàn,ér,shèng",
  "不战而降": "bú,zhàn,ér,xiáng",
  "不戴帽地": "bù,dài,mào,de",
  "不扎": "bù,zhā",
  "不拉几": "bù,lā,jī",
  "不拔一毛": "bù,bá,yì,máo",
  "不拘于时": "bu,ju,yu,shi",
  "不拘形迹": "bù,jū,xíng,jī",
  "不持久地": "bù,chí,jiǔ,de",
  "不揆梼昧": "bù,kuí,táo,mèi",
  "不揣": "bù,chuǎi",
  "不揣冒昧": "bù,chuǎi,mào,mèi",
  "不敢丝毫地": "bù,gǎn,sī,háo,de",
  "不敢为天下先": "bù,gǎn,wéi,tiān,xià,xiān",
  "不敢大胆地": "bù,gǎn,dà,dǎn,de",
  "不敢恭维": "bù,gǎn,gōng,wei",
  "不敬地": "bù,jìng,de",
  "不数": "bù,shù",
  "不数数": "bù,shǔ,shù",
  "不整洁地": "bù,zhěng,jié,de",
  "不整齐地": "bù,zhěng,qí,de",
  "不断地": "bù,duàn,de",
  "不断地供给": "bù,duàn,de,gōng,jǐ",
  "不断地修正": "bù,duàn,de,xiū,zhèng",
  "不断地做": "bù,duàn,de,zuò",
  "不断地做出决定": "bù,duàn,de,zuò,chū,jué,deng",
  "不断地做某事": "bù,duàn,de,zuò,mǒu,shì",
  "不断地减小": "bù,duàn,de,jiǎn,xiǎo",
  "不断地努力": "bù,duàn,de,nǔ,lì",
  "不断地去": "bù,duàn,de,qù",
  "不断地去尝试": "bù,duàn,de,qù,cháng,shì",
  "不断地去淬取": "bù,duàn,de,qù,cuì,qǔ",
  "不断地去淬炼": "bù,duàn,de,qù,cuì,liàn",
  "不断地反省": "bù,duàn,de,fǎn,xǐng",
  "不断地反省自己": "bù,duàn,de,fǎn,xǐng,zì,jǐ",
  "不断地发展": "bù,duàn,de,fā,zhǎn",
  "不断地发现": "bù,duàn,de,fā,xiàn",
  "不断地向着": "bù,duàn,de,xiàng,zhe",
  "不断地完善": "bù,duàn,de,wán,shàn",
  "不断地将": "bù,duàn,de,jiāng",
  "不断地尝试": "bù,duàn,de,cháng,shì",
  "不断地影响": "bù,duàn,de,yǐng,xiǎng",
  "不断地成长": "bù,duàn,de,chéng,zhǎng",
  "不断地抄": "bù,duàn,de,chāo",
  "不断地挣扎": "bù,duàn,de,zhēng,zhá",
  "不断地探索": "bù,duàn,de,tàn,suǒ",
  "不断地提高": "bù,duàn,de,tí,gāo",
  "不断地摇头": "bù,duàn,de,yáo,tóu",
  "不断地播出": "bù,duàn,de,bō,chū",
  "不断地来": "bù,duàn,de,lái",
  "不断地治疗": "bù,duàn,de,zhì,liáo",
  "不断地淬励自己": "bù,duàn,de,cuì,lì,zì,jǐ",
  "不断地淬取": "bù,duàn,de,cuì,qǔ",
  "不断地淬取智慧": "bù,duàn,de,cuì,qǔ,zhì,huì",
  "不断地淬炼": "bù,duàn,de,cuì,liàn",
  "不断地淬炼话术": "bù,duàn,de,cuì,liàn,huà,shù",
  "不断地添加": "bù,duàn,de,tiān,jiā",
  "不断地笑": "bù,duàn,de,xiào",
  "不断地练": "bù,duàn,de,liàn",
  "不断地能": "bù,duàn,de,néng",
  "不断地补充": "bù,duàn,de,bǔ,chōng",
  "不断地请求": "bù,duàn,de,qǐng,qiú",
  "不断地谈": "bù,duàn,de,tán",
  "不断地超越": "bù,duàn,de,chāo,yuè",
  "不断地追求": "bù,duàn,de,zhuī,qiú",
  "不断地适应": "bù,duàn,de,shì,yìng",
  "不断地重复": "bù,duàn,de,chóng,fù",
  "不断地鼓掌": "bù,duàn,de,gǔ,zhǎng",
  "不方便地": "bù,fāng,biàn,de",
  "不早当晚": "bù,zǎo,dàng,wǎn",
  "不时地": "bù,shí,de",
  "不时髦地": "bù,shí,máo,de",
  "不明了地": "bù,míng,le,de",
  "不明显地": "bù,míng,xiǎn,de",
  "不明智地": "bù,míng,zhì,de",
  "不明确地": "bù,míng,què,de",
  "不易地": "bù,yì,de",
  "不易弯地": "bù,yì,wān,de",
  "不是": "bú,shì",
  "不是一般地": "bú,shì,yì,bān,de",
  "不是东西": "bù,shì,dōng,xi",
  "不是东风压了西风": "bú,shì,dōng,fēng,yā,le,xī,fēng",
  "不是个儿": "bú,shì,gè,ér",
  "不是久住之乡": "bú,shì,jiǔ,zhù,zhī,xiāng",
  "不是久恋之家": "bú,shì,jiǔ,liàn,zhī,jiā",
  "不是事": "bú,shì,shì",
  "不是味儿": "bú,shì,wèi,ér",
  "不是处": "bú,shì,chù",
  "不是头": "bú,shì,tóu",
  "不是好好地": "bú,shì,hǎo,hǎo,de",
  "不是寃家不聚头": "bú,shì,yuān,jiā,bù,jù,tóu",
  "不是很好地": "bú,shì,hěn,hǎo,de",
  "不是玩的": "bú,shì,wán,de",
  "不是简单地": "bú,shì,jiǎn,dān,de",
  "不是能更好地": "bú,shì,néng,gèng,hǎo,de",
  "不是话头": "bú,shì,huà,tóu",
  "不是路": "bú,shì,lù",
  "不显山不露水": "bù,xiǎn,shān,bù,lù,shuǐ",
  "不显着地": "bù,xiǎn,zhe,de",
  "不智地": "bù,zhì,de",
  "不更": "bù,gēng",
  "不更事": "bù,gēng,shì",
  "不曾序过": "bu,ceng,xu,guo",
  "不服从地": "bù,fú,cóng,de",
  "不服气地": "bù,fú,qì,de",
  "不期然地": "bù,qī,rán,de",
  "不机敏地": "bù,jī,mǐn,de",
  "不朽地": "bù,xiǔ,de",
  "不来头": "bù,lái,tou",
  "不校": "bù,jiào",
  "不正地": "bù,zhèng,de",
  "不正常": "bú,zhèng,cháng",
  "不正常地": "bú,zhèng,cháng,de",
  "不正当": "bù,zhèng,dàng",
  "不正当关系": "bù,zhèng,dàng,guān,xì",
  "不正当地": "bù,zhèng,dāng,de",
  "不正当地使用": "bù,zhèng,dāng,de,shǐ,yòng",
  "不正直地": "bù,zhèng,zhí,de",
  "不正确地": "bù,zhèng,què,de",
  "不殷勤地": "bù,yīn,qín,de",
  "不毂": "bù,gū",
  "不毛地": "bù,máo,de",
  "不法分子": "bù,fǎ,fèn,zǐ",
  "不注意地": "bù,zhù,yì,de",
  "不洁地": "bù,jié,de",
  "不活动地": "bù,huó,dòng,de",
  "不活泼地": "bù,huó,pō,de",
  "不流行地": "bù,liú,xíng,de",
  "不消得": "bù,xiāo,de",
  "不清楚": "bù,qīng,chu",
  "不清楚地": "bù,qīng,chǔ,de",
  "不清洁地": "bù,qīng,jié,de",
  "不滑稽地": "bù,huá,jī,de",
  "不满地": "bù,mǎn,de",
  "不满地说": "bù,mǎn,de,shuō",
  "不满意地说": "bù,mǎn,yì,de,shuō",
  "不满足地": "bù,mǎn,zú,de",
  "不漂亮地": "bù,piào,liàng,de",
  "不灭地": "bù,miè,de",
  "不灵巧地": "bù,líng,qiǎo,de",
  "不点儿": "bù,diǎn,er",
  "不热心地": "bù,rè,xīn,de",
  "不煞": "bù,shà",
  "不熟悉地": "bù,shú,xī,de",
  "不熟练地": "bù,shú,liàn,de",
  "不爽累黍": "bù,shuǎng,lèi,shǔ",
  "不犯着": "bù,fàn,zháo",
  "不犹疑地": "bù,yóu,yí,de",
  "不犹豫地": "bù,yóu,yù,de",
  "不理会地": "bù,lǐ,huì,de",
  "不甚了了": "bù,shèn,liǎo,liǎo",
  "不生育地": "bù,shēng,yù,de",
  "不用客气": "bù,yòng,kè,qi",
  "不用说": "bú,yòng,shuō",
  "不由得": "bù,yóu,de",
  "不由自主地": "bù,yóu,zì,zhǔ,de",
  "不畏惧地": "bù,wèi,jù,de",
  "不畏缩地": "bù,wèi,suō,de",
  "不留心地": "bù,liú,xīn,de",
  "不留神地": "bù,liú,shén,de",
  "不疑地": "bù,yí,de",
  "不疲倦地": "bù,pí,juàn,de",
  "不痛地": "bù,tòng,de",
  "不相中": "bù,xiāng,zhòng",
  "不相为谋": "bù,xiāng,wéi,móu",
  "不相信地": "bù,xiāng,xìn,de",
  "不相同地": "bù,xiāng,tóng,de",
  "不相容地": "bù,xiāng,róng,de",
  "不相称": "bù,xiāng,chèn",
  "不相称地": "bù,xiāng,chèn,de",
  "不相等地": "bù,xiāng,děng,de",
  "不省": "bù,xǐng",
  "不省人事": "bù,xǐng,rén,shì",
  "不省得": "bù,xǐng,de",
  "不真诚地恋爱": "bù,zhēn,chéng,de,liàn,ài",
  "不眨眼地": "bù,zhǎ,yǎn,de",
  "不着": "bù,zháo",
  "不着人": "bù,zháo,rén",
  "不着坟墓": "bù,zháo,fén,mù",
  "不着家": "bù,zháo,jiā",
  "不着情": "bù,zháo,qíng",
  "不着调": "bù,zháo,diào",
  "不知不觉地": "bù,zhī,bù,jué,de",
  "不知为不知": "bù,zhī,wéi,bù,zhǐ",
  "不知名地": "bù,zhī,míng,de",
  "不知怎么地": "bù,zhī,zěn,me,de",
  "不知情地": "bù,zhī,qíng,de",
  "不知所为": "bù,zhī,suǒ,wéi",
  "不知觉地": "bù,zhī,jué,de",
  "不知足地": "bù,zhī,zú,de",
  "不破不立": "bú,pò,bú,lì",
  "不确定地": "bù,què,deng,de",
  "不碍事地": "bù,ài,shì,de",
  "不碎玻璃": "bù,suì,bō,li",
  "不礼貌地": "bù,lǐ,mào,de",
  "不祥地": "bù,xiáng,de",
  "不禁地": "bù,jīn,de",
  "不离儿": "bù,lí,er",
  "不稳定地": "bù,wěn,deng,de",
  "不究": "bù,jiù",
  "不突出地": "bù,tū,chū,de",
  "不等边地": "bù,děng,biān,de",
  "不答理": "bù,dā,lǐ",
  "不精密地": "bù,jīng,mì,de",
  "不精确地": "bù,jīng,què,de",
  "不糁": "bù,shēn",
  "不约而同地": "bù,yuē,ér,tóng,de",
  "不纯地": "bù,chún,de",
  "不终朝": "bù,zhōng,zhāo",
  "不经常地": "bù,jīng,cháng,de",
  "不经意地": "bù,jīng,yì,de",
  "不经济地": "bù,jīng,jì,de",
  "不绝地": "bù,jué,de",
  "不绝如发": "bù,jué,rú,fà",
  "不老实地": "bù,lǎo,shí,de",
  "不老少": "bù,lǎo,shào",
  "不老练地": "bù,lǎo,liàn,de",
  "不耐烦地": "bù,nài,fán,de",
  "不耻相师": "bu,chi,xiang,shi",
  "不肖": "bù,xiào",
  "不肖子": "bú,xiào,zǐ",
  "不肖子孙": "bù,xiào,zǐ,sūn",
  "不肯定地": "bù,kěn,deng,de",
  "不能偷偷地": "bù,néng,tōu,tōu,de",
  "不能公正地": "bù,néng,gōng,zhèng,de",
  "不能很好地": "bù,néng,hěn,hǎo,de",
  "不能很好地实现": "bù,néng,hěn,hǎo,de,shí,xiàn",
  "不能正确地": "bù,néng,zhèng,què,de",
  "不能简单地": "bù,néng,jiǎn,dān,de",
  "不脸红地": "bù,liǎn,hóng,de",
  "不自然地": "bù,zì,rán,de",
  "不自私地": "bù,zì,sī,de",
  "不自觉地": "bù,zì,jué,de",
  "不自觉地出现": "bù,zì,jué,de,chū,xiàn",
  "不舍得": "bù,shě,de",
  "不舒服地": "bù,shū,fú,de",
  "不舒适": "bù,shū,shì",
  "不舒适地": "bù,shū,shì,de",
  "不良地": "bù,liáng,de",
  "不节俭地": "bù,jié,jiǎn,de",
  "不菲": "bù,fěi",
  "不萉": "bù,féi",
  "不落": "bù,là",
  "不落体": "bù,là,tǐ",
  "不落夹": "bù,là,jiā",
  "不落手": "bù,là,shǒu",
  "不落眼": "bù,là,yǎn",
  "不落荚": "bù,là,jiá",
  "不落道": "bù,là,dào",
  "不蒸馒头争口气": "bù,zhēng,mán,tou,zhēng,kǒu,qì",
  "不虔诚地": "bù,qián,chéng,de",
  "不虚伪地": "bù,xū,wěi,de",
  "不血食": "bù,xuè,shí",
  "不衰地": "bù,shuāi,de",
  "不衰弱地": "bù,shuāi,ruò,de",
  "不褪色地": "bù,tuì,shǎi,de",
  "不要": "bú,yào",
  "不要怕": "bú,yào,pà",
  "不要想当然地": "bú,yào,xiǎng,dāng,rán,de",
  "不要有意识地": "bú,yào,yǒu,yì,shí,de",
  "不要盲目地": "bú,yào,máng,mù,de",
  "不要紧": "bú,yào,jǐn",
  "不要脸": "bú,yào,liǎn",
  "不要脸地": "bú,yào,liǎn,de",
  "不见": "bú,jiàn",
  "不见不散": "bú,jiàn,bú,sàn",
  "不见了": "bú,jiàn,le",
  "不见便": "bú,jiàn,biàn",
  "不见兔子不撒鹰": "bù,jiàn,tù,zi,bù,sā,yīng",
  "不见得": "bú,jiàn,de",
  "不见的": "bú,jiàn,de",
  "不见经传": "bù,jiàn,jīng,zhuàn",
  "不见舆薪": "bú,jiàn,yú,xīn",
  "不见起": "bú,jiàn,qǐ",
  "不规则地": "bù,guī,zé,de",
  "不规律地": "bù,guī,lǜ,de",
  "不规矩": "bù,guī,ju",
  "不觉地": "bù,jué,de",
  "不觉察地": "bù,jué,chá,de",
  "不解地": "bù,jiě,de",
  "不解地说": "bù,jiě,de,shuō",
  "不解地问": "bù,jiě,de,wèn",
  "不解地问道": "bù,jiě,de,wèn,dào",
  "不触目地": "bù,chù,mù,de",
  "不计其数": "bù,jì,qí,shù",
  "不计得失": "bú,jì,dé,shī",
  "不认真地": "bù,rèn,zhēn,de",
  "不记得": "bú,jì,dé",
  "不许可地": "bù,xǔ,kě,de",
  "不论何地": "bù,lùn,hé,de",
  "不论如何": "bú,lùn,rú,hé",
  "不识得有": "bù,shí,de,yǒu",
  "不识相": "bù,shí,xiàng",
  "不诚恳地": "bù,chéng,kěn,de",
  "不调和地": "bù,tiáo,hé,de",
  "不贞地": "bù,zhēn,de",
  "不贤都头": "bù,xián,dū,tóu",
  "不贪为宝": "bù,tān,wéi,bǎo",
  "不贵地": "bù,guì,de",
  "不费力地": "bù,fèi,lì,de",
  "不赞成地": "bù,zàn,chéng,de",
  "不起眼儿": "bù,qǐ,yǎn,er",
  "不足为凭": "bù,zú,wéi,píng",
  "不足为外人道": "bù,zú,wéi,wài,rén,dào",
  "不足为奇": "bù,zú,wéi,qí",
  "不足为怪": "bù,zú,wéi,guài",
  "不足为意": "bù,zú,wéi,yì",
  "不足为据": "bù,zú,wéi,jù",
  "不足为法": "bù,zú,wéi,fǎ",
  "不足为虑": "bù,zú,wéi,lǜ",
  "不足为训": "bù,zú,wéi,xùn",
  "不足为道": "bù,zú,wéi,dào",
  "不足取地": "bù,zú,qǔ,de",
  "不足地": "bù,zú,de",
  "不足数": "bù,zú,shù",
  "不足道地": "bù,zú,dào,de",
  "不踌躇地": "bù,chóu,chú,de",
  "不转头": "bù,zhuàn,tóu",
  "不转眼": "bù,zhuàn,yǎn",
  "不转睛": "bù,zhuàn,jīng",
  "不轻信地": "bù,qīng,xìn,de",
  "不辟斧钺": "bù,bì,fǔ,yuè",
  "不过地": "bù,guò,de",
  "不过很快地": "bù,guò,hěn,kuài,de",
  "不还踵": "bù,huán,zhǒng",
  "不连续地": "bù,lián,xù,de",
  "不连贯地": "bù,lián,guàn,de",
  "不迟疑地": "bù,chí,yí,de",
  "不适": "bù,shì",
  "不适切地": "bù,shì,qiè,de",
  "不适合": "bú,shì,hé",
  "不适合地": "bú,shì,hé,de",
  "不适宜地": "bù,shì,yí,de",
  "不适当": "bù,shì,dàng",
  "不适当地": "bù,shì,dāng,de",
  "不逊地": "bù,xùn,de",
  "不透明": "bú,tòu,míng",
  "不透明地": "bú,tòu,míng,de",
  "不逮": "bù,dǎi",
  "不逮养": "bù,dǎi,yǎng",
  "不遂": "bù,suí",
  "不遑启处": "bù,huáng,qǐ,chǔ",
  "不遑宁处": "bù,huáng,níng,chǔ",
  "不道得": "bù,dào,de",
  "不道德地": "bù,dào,dé,de",
  "不遗余力地": "bù,yí,yú,lì,de",
  "不遗余力地宣传": "bù,yí,yú,lì,de,xuān,chuán",
  "不配合地": "bù,pèi,hé,de",
  "不重要": "bú,zhòng,yào",
  "不重要地": "bú,zhòng,yào,de",
  "不钉点儿": "bù,dīng,diǎn,er",
  "不长一智": "bù,zhǎng,yī,zhì",
  "不长俊": "bù,zhǎng,jùn",
  "不长心": "bù,zhǎng,xīn",
  "不长眼睛": "bù,zhǎng,yǎn,jing",
  "不长进": "bù,zhǎng,jìn",
  "不问事实真相": "bú,wèn,shì,shí,zhēn,xiàng",
  "不问年龄大小": "bú,wèn,nián,líng,dà,xiǎo",
  "不问是非曲直": "bú,wèn,shì,fēi,qū,zhí",
  "不间断地": "bù,jiàn,duàn,de",
  "不阿": "bù,ē",
  "不随溜儿": "bù,suí,liù,ér",
  "不隐瞒地": "bù,yǐn,mán,de",
  "不雅地": "bù,yǎ,de",
  "不雅观地": "bù,yǎ,guān,de",
  "不露圭角": "bù,lù,guī,jiǎo",
  "不露声色": "bù,lù,shēng,sè",
  "不露形色": "bù,lù,xíng,sè",
  "不露朴": "bù,lòu,piáo",
  "不露神色": "bù,lù,shén,sè",
  "不露锋芒": "bù,lù,fēng,máng",
  "不露锋铓": "bù,lù,fēng,máng",
  "不顺从地": "bù,shùn,cóng,de",
  "不顾一切": "bù,gù,yī,qiè",
  "不顾一切地": "bù,gù,yī,qiè,de",
  "不顾地": "bù,gù,de",
  "不骜": "bù,ào",
  "不高兴地": "bù,gāo,xìng,de",
  "不鲜": "bù,xiǎn",
  "不鲜明地": "bù,xiān,míng,de",
  "不齐地": "bù,qí,de",
  "与世无争": "yú,shì,wú,zhēng",
  "与世沉浮": "yú,shì,chén,fú",
  "与么": "yǔ,mǒ",
  "与人": "yú,rén",
  "与人为善": "yǔ,rén,wéi,shàn",
  "与会": "yù,huì",
  "与全世界为敌": "yǔ,quán,shì,jiè,wéi,dí",
  "与前同地": "yǔ,qián,tóng,de",
  "与民更始": "yǔ,mín,gēng,shǐ",
  "与赛": "yù,sài",
  "与闻": "yù,wén",
  "丑媳妇总得见公婆": "chǒu,xí,fù,zǒng,de,jiàn,gōng,pó",
  "丑媳妇早晚也得见公婆": "chǒu,xí,fù,zǎo,wǎn,yě,děi,jiàn,gōng,pó",
  "丑态毕露": "chǒu,tài,bì,lù",
  "丑怪地": "chǒu,guài,de",
  "丑恶地": "chǒu,è,de",
  "丑相": "chǒu,xiàng",
  "丑角": "chǒu,jué",
  "丑话说在前头": "chǒu,huà,shuō,zài,qián,tou",
  "丑陋地": "chǒu,lòu,de",
  "专业地": "zhuān,yè,de",
  "专业银行": "zhuān,yè,yín,háng",
  "专供": "zhuān,gōng",
  "专制地": "zhuān,zhì,de",
  "专差": "zhuān,chāi",
  "专心一致": "zhuān,xīn,yí,zhì",
  "专心地": "zhuān,xīn,de",
  "专心致志地": "zhuān,xīn,zhì,zhì,de",
  "专折": "zhuān,shé",
  "专有地": "zhuān,yǒu,de",
  "专横": "zhuān,hèng",
  "专横地": "zhuān,hèng,de",
  "专横跋扈": "zhuān,hèng,bá,hù",
  "专注地": "zhuān,zhù,de",
  "专门地": "zhuān,mén,de",
  "专门性地": "zhuān,mén,xìng,de",
  "且住为佳": "qiě,zhù,wéi,jiā",
  "且兰": "jū,lán",
  "且夫": "qiě,fú",
  "且食蛤蜊": "qiě,shí,há,lí",
  "丕应": "pī,yìng",
  "世仆": "shì,pú",
  "世代相传地": "shì,dài,xiāng,chuán,de",
  "世俗地": "shì,sú,de",
  "世干": "shì,gàn",
  "世态人情": "shì,tai,rén,qíng",
  "世数": "shì,shù",
  "世界小姐选美": "shì,jiè,xiǎo,jie,xuǎn,měi",
  "世界粮食署": "shì,jiè,liáng,shi,shǔ",
  "世界银行": "shì,jiè,yín,háng",
  "世相": "shì,xiàng",
  "世累": "shì,lèi",
  "世行": "shì,háng",
  "世调": "shì,diào",
  "世载": "shì,zǎi",
  "世辟": "shì,bì",
  "丘陵地": "qiū,líng,de",
  "丙舍": "bǐng,shè",
  "业余爱好者": "yè,yú,ài,hào,zhě",
  "业累": "yè,lèi",
  "业缝": "yè,fèng",
  "业骨头": "yè,gú,tou",
  "丛帖": "cóng,tiē",
  "丛箐": "cóng,jīng",
  "丛缪": "cóng,miù",
  "东一榔头西一棒子": "dōng,yī,láng,tóu,xī,yī,bàng,zi",
  "东一筢子西一扫帚": "dōng,yī,pá,zǐ,xī,yī,sào,zhǒu",
  "东一耙子西一扫帚": "dōng,yī,pá,zǐ,xī,yī,sào,zhǒu",
  "东亚银行": "dōng,yà,yín,háng",
  "东倒西歪地走": "dōng,dǎo,xī,wāi,de,zǒu",
  "东兴": "dōng,xīng",
  "东兴区": "dōng,xīng,qū",
  "东兴市": "dōng,xīng,shì",
  "东厸": "dōng,miǎn",
  "东又不着": "dōng,yòu,bù,zháo",
  "东坡肘子": "dōng,pō,zhǒu,zi",
  "东墙处子": "dōng,qiáng,chǔ,zǐ",
  "东家处子": "dōng,jiā,chǔ,zǐ",
  "东山日头一大堆": "dōng,shān,rì,tou,yī,dà,duī",
  "东扯西拽": "dōng,chě,xī,zhuāi",
  "东抹西涂": "dōng,mò,xī,tú",
  "东挦西撦": "dōng,xián,xī,là",
  "东方千骑": "dōng,fāng,qiān,jì",
  "东方地": "dōng,fāng,de",
  "东方日头一大堆": "dōng,fāng,rì,tou,yī,dà,duī",
  "东方汇理与苏伊士银行": "dōng,fāng,huì,lǐ,yǔ,sū,yī,shì,yín,háng",
  "东方汇理银行": "dōng,fāng,huì,lǐ,yín,háng",
  "东洋参": "dōng,yáng,shēn",
  "东洋鬼子": "dōng,yáng,guǐ,zi",
  "东渐": "dōng,jiān",
  "东渐于海": "dōng,jiān,yú,hǎi",
  "东猜西揣": "dōng,cāi,xī,chuāi",
  "东窗消息": "dōng,chuāng,xiāo,xi",
  "东篱乐府": "dōng,lí,yuè,fǔ",
  "东莞": "dōng,guǎn",
  "东莞市": "dōng,guǎn,shì",
  "东行不见西行利": "dōng,xíng,bú,jiàn,xī,xíng,lì",
  "东西南北人": "dōng,xi,nán,běi,rén",
  "东西南北客": "dōng,xi,nán,běi,kè",
  "东西易面": "dōng,xi,yì,miàn",
  "东边": "dōng,bian",
  "东边儿": "dōng,biān,er",
  "东邻西舍": "dōng,lín,xī,shè",
  "东量西折": "dōng,liàng,xī,shé",
  "东阙": "dōng,què",
  "东阳二轧": "dōng,yáng,èr,zhá",
  "东阿": "dōng,ē",
  "东阿县": "dōng,ē,xiàn",
  "东陵侯": "dōng,líng,hòu",
  "丝发": "sī,fà",
  "丝带地": "sī,dài,de",
  "丝恩发怨": "sī,ēn,fà,yuàn",
  "丝柎": "sī,fù",
  "丝柏": "sī,bó",
  "丝毫不差": "sī,háo,bù,chā",
  "丞相": "chéng,xiàng",
  "丢三落四": "diū,sān,là,sì",
  "丢下耙儿弄扫帚": "diū,xià,pá,er,nòng,sào,zhǒu",
  "丢下钯儿弄扫帚": "diū,xià,bǎ,ér,nòng,sào,zhǒu",
  "丢卒保车": "diū,zú,bǎo,jū",
  "丢撇": "diū,piě",
  "丢脸地": "diū,liǎn,de",
  "丢车保帅": "diū,jū,bǎo,shuài",
  "丢面子": "diū,miàn,zi",
  "两下子": "liǎng,xià,zi",
  "两世为人": "liǎng,shì,wéi,rén",
  "两人合穿一条裤子": "liǎng,rén,hé,chuān,yī,tiáo,kù,zi",
  "两侧地": "liǎng,cè,de",
  "两侧对称": "liǎng,cè,duì,chèn",
  "两倍地": "liǎng,bèi,de",
  "两口儿": "liǎng,kǒu,er",
  "两口子": "liǎng,kǒu,zi",
  "两和": "liǎng,huò",
  "两头儿": "liǎng,tóu,er",
  "两头虺": "liǎng,tóu,huī",
  "两弹一星": "liǎng,dàn,yī,xīng",
  "两得": "liǎng,de",
  "两性差距": "liǎng,xìng,chā,jù",
  "两把刷子": "liǎng,bǎ,shuā,zi",
  "两服": "liǎng,fù",
  "两样东西": "liǎng,yàng,dōng,xi",
  "两样子": "liǎng,yàng,zi",
  "两梁冠": "liǎng,liáng,guān",
  "两着儿": "liǎng,zhāo,er",
  "两石弓": "liǎng,dàn,gōng",
  "两禁": "liǎng,jìn",
  "两贤相厄": "liǎng,xián,xiàng,è",
  "两边": "liǎng,bian",
  "两边地": "liǎng,biān,de",
  "两都": "liǎng,dū",
  "两重": "liǎng,chóng",
  "两重人格": "liǎng,chóng,rén,gé",
  "两重天": "liǎng,chóng,tiān",
  "两重性": "liǎng,chóng,xìng",
  "两重阳": "liǎng,chóng,yáng",
  "两面干部": "liǎng,miàn,gàn,bù",
  "严丝合缝": "yán,sī,hé,fèng",
  "严了眼儿": "yán,le,yǎn,er",
  "严于律已": "yán,yú,lǜ,jǐ",
  "严削": "yán,xuē",
  "严𠡠": "yán,lài",
  "严厉地": "yán,lì,de",
  "严处": "yán,chǔ",
  "严实": "yán,shi",
  "严密地": "yán,mì,de",
  "严峻地": "yán,jùn,de",
  "严干": "yán,gàn",
  "严更": "yán,gēng",
  "严格地": "yán,gé,de",
  "严格地讲": "yán,gé,de,jiǎng",
  "严格地说": "yán,gé,de,shuō",
  "严正地": "yán,zhèng,de",
  "严禁": "yán,jìn",
  "严絜": "yán,jié",
  "严肃地": "yán,sù,de",
  "严肃地说": "yán,sù,de,shuō",
  "严肃音乐": "yán,sù,yīn,yuè",
  "严谨地": "yán,jǐn,de",
  "严酷地": "yán,kù,de",
  "严重关切": "yán,zhòng,guān,qiè",
  "严重地": "yán,zhòng,de",
  "严重地伤害了": "yán,zhòng,de,shāng,hài,le",
  "丧乱": "sāng,luàn",
  "丧事": "sāng,shì",
  "丧仆": "sàng,pú",
  "丧仪": "sāng,yí",
  "丧假": "sāng,jià",
  "丧冠": "sàng,guān",
  "丧尸": "sāng,shī",
  "丧服": "sāng,fú",
  "丧棒": "sāng,bàng",
  "丧气地": "sàng,qì,de",
  "丧煞": "sàng,shà",
  "丧礼": "sāng,lǐ",
  "丧荒": "sāng,huāng",
  "丧葬": "sāng,zàng",
  "丧葬费": "sāng,zàng,fèi",
  "丧钟": "sāng,zhōng",
  "个人储蓄积累养老保险": "gè,rén,chǔ,xù,jī,lěi,yǎng,lǎo,bǎo,xiǎn",
  "个人地": "gè,rén,de",
  "个人数字助理": "gè,rén,shù,zì,zhù,lǐ",
  "个别地": "gè,bié,de",
  "个处": "gè,chǔ",
  "个头儿": "gè,tou,er",
  "个子": "gè,zi",
  "个数": "gè,shù",
  "丫头": "yā,tou",
  "丫头片子": "yā,tou,piàn,zi",
  "丫子": "yā,zi",
  "丫巴儿": "yā,bā,er",
  "丫杈": "yā,chà",
  "丫环": "yā,huan",
  "丫鬟": "yā,huan",
  "中东呼吸综合征": "zhōng,dōng,hū,xī,zōng,hé,zhèng",
  "中举": "zhòng,jǔ",
  "中乐透": "zhòng,lè,tòu",
  "中二千石": "zhōng,èr,qiān,dàn",
  "中伤": "zhòng,shāng",
  "中伤地": "zhòng,shāng,de",
  "中位数": "zhōng,wèi,shù",
  "中信银行": "zhōng,xìn,yín,háng",
  "中兴": "zhōng,xīng",
  "中兴三明": "zhōng,xīng,sān,míng",
  "中兴新村": "zhōng,xīng,xīn,cūn",
  "中兴颂": "zhōng,xīng,sòng",
  "中凸地": "zhōng,tū,de",
  "中北部地": "zhōng,běi,bù,de",
  "中南部地": "zhōng,nán,bù,de",
  "中卷": "zhōng,juàn",
  "中吕调": "zhōng,lǚ,diào",
  "中和乐舞": "zhōng,hé,yuè,wǔ",
  "中国人民银行": "zhōng,guó,rén,mín,yín,háng",
  "中国光大银行": "zhōng,guó,guāng,dà,yín,háng",
  "中国共产党为公布国共合作宣言": "zhōng,guó,gòng,chǎn,dǎng,wéi,gōng,bù,guó,gòng,hé,zuò,xuān,yán",
  "中国农业银行": "zhōng,guó,nóng,yè,yín,háng",
  "中国动物地理区划": "zhōng,guó,dòng,wù,dì,lǐ,qū,huà",
  "中国地质调查局": "zhōng,guó,dì,zhì,diào,chá,jú",
  "中国少年儿童队": "zhōng,guó,shào,nián,ér,tóng,duì",
  "中国少年报": "zhōng,guó,shào,nián,bào",
  "中国工商银行": "zhōng,guó,gōng,shāng,yín,háng",
  "中国建设银行": "zhōng,guó,jiàn,shè,yín,háng",
  "中国证监会": "zhōng,guó,zhèng,jiàn,huì",
  "中国进出口银行": "zhōng,guó,jìn,chū,kǒu,yín,háng",
  "中国银行": "zhōng,guó,yín,háng",
  "中国银行业监督管理委员会": "zhōng,guó,yín,háng,yè,jiān,dū,guǎn,lǐ,wěi,yuán,huì",
  "中圈套": "zhòng,quān,tào",
  "中坚分子": "zhōng,jiān,fèn,zǐ",
  "中处": "zhōng,chǔ",
  "中大夫": "zhōng,dài,fū",
  "中央处理机": "zhōng,yāng,chǔ,lǐ,jī",
  "中央银行": "zhōng,yāng,yín,háng",
  "中央音乐学院": "zhōng,yāng,yīn,yuè,xué,yuàn",
  "中奖": "zhòng,jiǎng",
  "中子弹": "zhōng,zǐ,dàn",
  "中子数": "zhōng,zǐ,shù",
  "中宪大夫": "zhōng,xiàn,dài,fū",
  "中将": "zhōng,jiàng",
  "中层干部": "zhōng,céng,gàn,bù",
  "中山狼传": "zhōng,shān,láng,zhuàn",
  "中帑": "zhōng,tǎng",
  "中庸地": "zhōng,yōng,de",
  "中弹": "zhòng,dàn",
  "中彩": "zhòng,cǎi",
  "中得": "zhōng,de",
  "中心地": "zhōng,xīn,de",
  "中折": "zhōng,shé",
  "中招": "zhòng,zhāo",
  "中数": "zhōng,shù",
  "中文信息处理": "zhōng,wén,xìn,xī,chǔ,lǐ",
  "中断地": "zhōng,duàn,de",
  "中暑": "zhòng,shǔ",
  "中更": "zhōng,gēng",
  "中板地": "zhōng,bǎn,de",
  "中枪": "zhòng,qiāng",
  "中标": "zhòng,biāo",
  "中毒": "zhòng,dú",
  "中毒性": "zhòng,dú,xìng",
  "中江举帆": "zhōng,jiāng,jǔ,fān",
  "中油": "zhòng,yóu",
  "中澣": "zhōng,hàn",
  "中火铺": "zhōng,huǒ,pù",
  "中牟": "zhōng,mù",
  "中省地": "zhōng,shěng,de",
  "中禁": "zhōng,jìn",
  "中秋帖": "zhōng,qiū,tiē",
  "中空玻璃": "zhōng,kōng,bō,li",
  "中立地": "zhōng,lì,de",
  "中等地": "zhōng,děng,de",
  "中签": "zhòng,qiān",
  "中箭落马": "zhòng,jiàn,luò,mǎ",
  "中绳": "zhòng,shéng",
  "中缝": "zhōng,fèng",
  "中罫": "zhōng,guà",
  "中肯": "zhòng,kěn",
  "中肯地": "zhōng,kěn,de",
  "中肯地说": "zhōng,kěn,de,shuō",
  "中舍": "zhōng,shè",
  "中舍人": "zhōng,shè,rén",
  "中药铺": "zhōng,yào,pù",
  "中𰰮": "zhōng,kuī",
  "中行": "zhōng,háng",
  "中规中矩": "zhòng,guī,zhòng,jǔ",
  "中觉": "zhōng,jiào",
  "中计": "zhòng,jì",
  "中调": "zhōng,diào",
  "中路梆子": "zhōng,lù,bāng,zi",
  "中适": "zhōng,shì",
  "中选": "zhòng,xuǎn",
  "中速地": "zhōng,sù,de",
  "中邪": "zhòng,xié",
  "中郎将": "zhōng,láng,jiàng",
  "中都城": "zhōng,dū,chéng",
  "中间地": "zhōng,jiān,de",
  "中靶": "zhòng,bǎ",
  "中风": "zhòng,fēng",
  "中风狂走": "zhòng,fēng,kuáng,zǒu",
  "中风瘫痪": "zhòng,fēng,tān,huàn",
  "中魔": "zhòng,mó",
  "丰上削下": "fēng,shàng,xuē,xià",
  "丰侯": "fēng,hòu",
  "丰富地": "fēng,fù,de",
  "丰干": "fēng,gàn",
  "丰干饶舌": "fēng,gàn,ráo,shé",
  "丰折": "fēng,shé",
  "丰收计划": "fēng,shōu,jì,huà",
  "丰楙": "fēng,mào",
  "丰絜": "fēng,jié",
  "丰翘": "fēng,qiào",
  "丰𰮇": "fēng,wǔ",
  "丰都": "fēng,dū",
  "丰都县": "fēng,dū,xiàn",
  "丰镐": "fēng,hào",
  "丰露": "fēng,lù",
  "串味儿": "chuàn,wèi,er",
  "串哄": "chuàn,hǒng",
  "串处理": "chuàn,chǔ,lǐ",
  "串行": "chuàn,háng",
  "串门儿": "chuàn,mén,er",
  "串门子": "chuàn,mén,zi",
  "串鼻子": "chuàn,bí,zi",
  "临帖": "lín,tiè",
  "临干": "lín,gàn",
  "临床上地": "lín,chuáng,shàng,de",
  "临床地": "lín,chuáng,de",
  "临敌易将": "lín,dí,yì,jiàng",
  "临时地": "lín,shí,de",
  "临月儿": "lín,yuè,er",
  "临机应变": "lín,jī,yìng,biàn",
  "临深履薄": "lín,shēn,lǚ,bó",
  "临贲": "lín,bēn",
  "临难": "lín,nàn",
  "临难不恐": "lín,nàn,bù,kǒng",
  "临难不惧": "lín,nàn,bù,jù",
  "临难苟免": "lín,nàn,gǒu,miǎn",
  "临难铸兵": "lín,nàn,zhù,bīng",
  "丸子": "wán,zi",
  "丹参": "dān,shēn",
  "丹墀": "dan,chi",
  "丹干": "dān,gàn",
  "丹心碧血": "dān,xīn,bì,xuè",
  "丹慊": "dān,qiè",
  "丹槛": "dān,kǎn",
  "丹槛折": "dān,kǎn,shé",
  "丹毂": "dān,gū",
  "丹瑞大将": "dān,ruì,dà,jiàng",
  "丹禁": "dān,jìn",
  "丹翘": "dān,qiào",
  "丹雘": "dān,wò",
  "为万安计": "wei,wan,an,ji",
  "为上": "wéi,shàng",
  "为下": "wéi,xià",
  "为主": "wéi,zhǔ",
  "为久": "wéi,jiǔ",
  "为之地": "wéi,zhī,dì",
  "为之语塞": "wéi,zhī,yǔ,sè",
  "为乐": "wéi,lè",
  "为书": "wéi,shū",
  "为乱": "wéi,luàn",
  "为了更好地": "wèi,le,gèng,hǎo,de",
  "为了更好地改进": "wèi,le,gèng,hǎo,de,gǎi,jìn",
  "为了有效地": "wèi,le,yǒu,xiào,de",
  "为了能方便地": "wèi,le,néng,fāng,biàn,de",
  "为事": "wéi,shì",
  "为五斗米折腰": "wèi,wǔ,dǒu,mǐ,zhé,yāo",
  "为人": "wéi,rén",
  "为人后": "wéi,rén,hòu",
  "为人师表": "wéi,rén,shī,biǎo",
  "为什": "wèi,shí",
  "为什么不好好地": "wèi,shén,me,bù,hǎo,hǎo,de",
  "为仁不富": "wéi,rén,bù,fù",
  "为从": "wéi,cóng",
  "为他人作嫁衣裳": "wèi,tā,rén,zuò,jià,yī,shang",
  "为他人做嫁衣裳": "wèi,tā,rén,zuò,jià,yī,shang",
  "为伍": "wéi,wǔ",
  "为作": "wéi,zuò",
  "为例": "wéi,lì",
  "为准": "wéi,zhǔn",
  "为别": "wéi,bié",
  "为力": "wéi,lì",
  "为命": "wéi,mìng",
  "为善": "wéi,shàn",
  "为善最乐": "wéi,shàn,zuì,lè",
  "为因": "wéi,yīn",
  "为国为民": "wéi,guó,wéi,mín",
  "为地": "wéi,dì",
  "为复": "wéi,fù",
  "为头": "wéi,tóu",
  "为好成歉": "wéi,hǎo,chéng,qiàn",
  "为学": "wéi,xué",
  "为害": "wéi,hài",
  "为容": "wéi,róng",
  "为富不仁": "wéi,fù,bù,rén",
  "为寿": "wéi,shòu",
  "为尔": "wéi,ěr",
  "为山": "wéi,shān",
  "为山九仞": "wéi,shān,jiǔ,rèn",
  "为山止篑": "wéi,shān,zhǐ,kuì",
  "为己任": "wéi,jǐ,rèn",
  "为市": "wéi,shì",
  "为底": "wéi,dǐ",
  "为当": "wéi,dāng",
  "为德不卒": "wéi,dé,bù,zú",
  "为德不终": "wéi,dé,bù,zhōng",
  "为性": "wéi,xìng",
  "为恶不悛": "wéi,è,bù,quān",
  "为患": "wéi,huàn",
  "为情": "wéi,qíng",
  "为意": "wéi,yì",
  "为所欲为": "wéi,suǒ,yù,wéi",
  "为政": "wéi,zhèng",
  "为数": "wéi,shù",
  "为文": "wéi,wén",
  "为时": "wéi,shí",
  "为时不晚": "wéi,shí,bù,wǎn",
  "为时已晚": "wéi,shí,yǐ,wǎn",
  "为时未晚": "wéi,shí,wèi,wǎn",
  "为时过早": "wéi,shí,guò,zǎo",
  "为是": "wéi,shì",
  "为更好地": "wèi,gèng,hǎo,de",
  "为期": "wéi,qī",
  "为期不远": "wéi,qī,bù,yuǎn",
  "为止": "wéi,zhǐ",
  "为比": "wéi,bǐ",
  "为民父母": "wéi,mín,fù,mǔ",
  "为气": "wéi,qì",
  "为法": "wéi,fǎ",
  "为法自弊": "wéi,fǎ,zì,bì",
  "为然": "wéi,rán",
  "为理": "wéi,lǐ",
  "为甚": "wéi,shèn",
  "为生": "wéi,shēng",
  "为真": "wéi,zhēn",
  "为着": "wéi,zhe",
  "为臣": "wéi,chén",
  "为良医": "wéi,liáng,yī",
  "为荷": "wéi,hè",
  "为薪": "wéi,xīn",
  "为虺弗摧": "wéi,huǐ,fú,cuī",
  "为蛇添足": "wéi,shé,tiān,zú",
  "为蛇画足": "wéi,shé,huà,zú",
  "为蛇若何": "wéi,shé,ruò,hé",
  "为行": "wéi,xíng",
  "为裘": "wéi,qiú",
  "为裘为箕": "wéi,qiú,wéi,jī",
  "为言": "wéi,yán",
  "为许": "wéi,xǔ",
  "为诈": "wéi,zhà",
  "为身": "wéi,shēn",
  "为道": "wéi,dào",
  "为重": "wéi,zhòng",
  "为间": "wéi,jiān",
  "为限": "wéi,xiàn",
  "为难": "wéi,nán",
  "为难地": "wéi,nán,de",
  "为难地说": "wéi,nán,de,shuō",
  "为非作恶": "wéi,fēi,zuò,è",
  "为非作歹": "wéi,fēi,zuò,dǎi",
  "为饥寒所迫": "wéi,jī,hán,suǒ,pò",
  "为首": "wéi,shǒu",
  "为鬼为蜮": "wéi,guǐ,wéi,yù",
  "为鱼": "wéi,yú",
  "主一无适": "zhǔ,yī,wú,shì",
  "主丧": "zhǔ,sāng",
  "主仆": "zhǔ,pú",
  "主动地": "zhǔ,dòng,de",
  "主子": "zhǔ,zi",
  "主将": "zhǔ,jiàng",
  "主帆": "zhǔ,fān",
  "主干": "zhǔ,gàn",
  "主干线": "zhǔ,gàn,xiàn",
  "主干网络": "zhǔ,gàn,wǎng,luò",
  "主干网路": "zhǔ,gàn,wǎng,lù",
  "主心馄饨": "zhǔ,xīn,hún,tun",
  "主意": "zhǔ,yi",
  "主笔地": "zhǔ,bǐ,de",
  "主薄": "zhǔ,bù",
  "主要地": "zhǔ,yào,de",
  "主观地": "zhǔ,guān,de",
  "主角": "zhǔ,jué",
  "主调": "zhǔ,diào",
  "丽什": "lì,shí",
  "丽佳娜": "lì,jiā,nà",
  "丽刹": "lì,shā",
  "丽圭𰴂": "lì,guī,shān",
  "丽水": "lí,shuǐ",
  "丽水地区": "lí,shuǐ,dì,qū",
  "丽水市": "lí,shuǐ,shì",
  "丽着": "lì,zhe",
  "丽都": "lì,dū",
  "举世混浊": "jǔ,shì,hún,zhuó",
  "举办地": "jǔ,bàn,de",
  "举动荆棘": "ju,dong,jin,ji",
  "举措不当": "jǔ,cuò,bù,dàng",
  "举措失当": "jǔ,cuò,shī,dàng",
  "举隅法": "jǔ,yù,fǎ",
  "乃我困汝": "nai,wo,kun,nu",
  "乃纔": "nǎi,shān",
  "久久地凝视着": "jiǔ,jiǔ,de,níng,shì,zhe",
  "久别重逢": "jiǔ,bié,chóng,féng",
  "久要不忘": "jiǔ,yāo,bù,wàng",
  "久远地": "jiǔ,yuǎn,de",
  "么似地": "me,shì,de",
  "义兴": "yì,xīng",
  "义台": "yí,tái",
  "义愤地": "yì,fèn,de",
  "义舍": "yì,shè",
  "义薄云天": "yì,bó,yún,tiān",
  "义铺": "yì,pù",
  "之后地": "zhī,hòu,de",
  "之死靡它": "zhī,sǐ,mǐ,tā",
  "之状地": "zhī,zhuàng,de",
  "之适": "zhī,shì",
  "乌什": "wū,shí",
  "乌什县": "wū,shí,xiàn",
  "乌什塔拉": "wū,shí,tǎ,lā",
  "乌什塔拉乡": "wū,shí,tǎ,lā,xiāng",
  "乌什塔拉回族乡": "wū,shí,tǎ,lā,huí,zú,xiāng",
  "乌咖哩": "wū,gā,lí",
  "乌咽": "wū,yān",
  "乌尔都语": "wū,ěr,dū,yǔ",
  "乌拉": "wù,la",
  "乌拉圭": "wù,la,guī",
  "乌拉尔山脉": "wù,la,ěr,shān,mài",
  "乌拉尔河": "wù,la,ěr,hé",
  "乌拉草": "wù,la,cǎo",
  "乌涂": "wū,tu",
  "乌漆抹黑": "wū,qī,mā,hēi",
  "乌良哈": "wū,liáng,hǎ",
  "乌菟": "wū,tú",
  "乌踆": "wū,cún",
  "乌踆兔走": "wū,cún,tù,zǒu",
  "乏兴": "fá,xīng",
  "乏军兴": "fá,jūn,xīng",
  "乏味地": "fá,wèi,de",
  "乏累": "fá,lèi",
  "乏角儿": "fá,jué,ér",
  "乐亭": "lào,tíng",
  "乐亭县": "lào,tíng,xiàn",
  "乐亭大鼓": "lào,tíng,dà,gǔ",
  "乐亭调": "lào,tíng,diào",
  "乐只": "lè,zhī",
  "乐呵呵地": "lè,hē,hē,de",
  "乐善好施": "lè,shàn,hào,shī",
  "乐器": "yuè,qì",
  "乐团": "yuè,tuán",
  "乐坛": "yuè,tán",
  "乐学者": "yuè,xué,zhě",
  "乐官": "yuè,guān",
  "乐工": "yuè,gōng",
  "乐师": "yuè,shī",
  "乐府": "yuè,fǔ",
  "乐府令": "yuè,fǔ,lìng",
  "乐府诗": "yuè,fǔ,shī",
  "乐府诗集": "yuè,fǔ,shī,jí",
  "乐律": "yuè,lǜ",
  "乐得": "lè,de",
  "乐意地": "lè,yì,de",
  "乐感": "yuè,gǎn",
  "乐户": "yuè,hù",
  "乐曲": "yuè,qǔ",
  "乐歌": "yuè,gē",
  "乐正": "yuè,zhèng",
  "乐毅": "yuè,yì",
  "乐氏枣": "yuè,shì,zǎo",
  "乐水": "yào,shuǐ",
  "乐池": "yuè,chí",
  "乐沙": "yuè,shā",
  "乐清": "yuè,qīng",
  "乐清市": "yuè,qīng,shì",
  "乐理": "yuè,lǐ",
  "乐禁": "lè,jìn",
  "乐章": "yuè,zhāng",
  "乐经": "yuè,jīng",
  "乐舞": "yuè,wǔ",
  "乐舞生": "yuè,wǔ,shēng",
  "乐观地": "lè,guān,de",
  "乐讽": "lè,fěng",
  "乐请": "yuè,qǐng",
  "乐调": "lè,diào",
  "乐谱": "yuè,pǔ",
  "乐迷": "yuè,mí",
  "乐都县": "lè,dū,xiàn",
  "乐队": "yuè,duì",
  "乐音": "yuè,yīn",
  "乔干": "qiáo,gàn",
  "乔模乔样": "qiáo,mú,qiáo,yàng",
  "乔模样": "qiáo,mú,yàng",
  "乔禁架": "qiáo,jìn,jià",
  "乔答摩": "qiáo,dā,mó",
  "乖乖地": "guāi,guāi,de",
  "乖乖地交钱": "guāi,guāi,de,jiāo,qián",
  "乖乖地听": "guāi,guāi,de,tīng",
  "乖乖地回去": "guāi,guāi,de,huí,qù",
  "乖乖地坐在": "guāi,guāi,de,zuò,zài",
  "乖乖地睡觉": "guāi,guāi,de,shuì,jiào",
  "乖乖地走开了": "guāi,guāi,de,zǒu,kāi,le",
  "乖乖地闭上了嘴": "guāi,guāi,de,bì,shàng,le,zuǐ",
  "乖乘地": "guāi,chéng,de",
  "乖僻地": "guāi,pì,de",
  "乖唳地": "guāi,lì,de",
  "乖孩子": "guāi,hái,zi",
  "乖巧地": "guāi,qiǎo,de",
  "乖张地": "guāi,zhāng,de",
  "乖戾地": "guāi,lì,de",
  "乖缪": "guāi,miù",
  "乖背": "guāi,bèi",
  "乖角儿": "guāi,jué,ér",
  "乖调": "guāi,diào",
  "乖露": "guāi,lù",
  "乘务长": "chéng,wù,zhǎng",
  "乘壶": "shèng,hú",
  "乘处": "chéng,chǔ",
  "乘数": "chéng,shù",
  "乘查": "chéng,zhā",
  "乘肥衣轻": "chéng,féi,yì,qīng",
  "乘舆": "shèng,yú",
  "乘舆车": "shèng,yú,chē",
  "乘𫏋": "chéng,jué",
  "乘间": "chéng,jiàn",
  "乘间伺隙": "chéng,jiān,sì,xì",
  "乘风兴浪": "chéng,fēng,xīng,làng",
  "乙干": "yǐ,gàn",
  "乙更": "yǐ,gēng",
  "乙酰胺吡咯烷酮": "yǐ,xiān,àn,bǐ,luò,wán,tóng",
  "乜乜些些": "niè,niè,xiē,xiē",
  "乜乜斜斜": "niè,niè,xié,xié",
  "乜乜踅踅": "niè,niè,xué,xué",
  "乜些": "niè,xiē",
  "乜呆呆": "niè,dāi,dāi",
  "乜嬉": "niè,xī",
  "乜斜缠帐": "niè,xié,chán,zhàng",
  "乜邪": "niè,xié",
  "九九重阳": "jiǔ,jiǔ,chóng,yáng",
  "九侯": "jiǔ,hòu",
  "九倍地": "jiǔ,bèi,de",
  "九华英": "jiǔ,huā,yīng",
  "九卿相": "jiǔ,qīng,xiàng",
  "九埏": "jiǔ,shān",
  "九声六调": "jiǔ,shēng,liù,diào",
  "九大行星": "jiǔ,dà,háng,xīng",
  "九头狮子": "jiǔ,tóu,shī,zi",
  "九奏乐": "jiǔ,zòu,yuè",
  "九宫十三调": "jiǔ,gōng,shí,sān,diào",
  "九宫格数独": "jiǔ,gōng,gé,shù,dú",
  "九征": "jiǔ,zhǐ",
  "九数": "jiǔ,shù",
  "九斿": "jiǔ,yóu",
  "九曲回肠": "jiǔ,qū,huí,cháng",
  "九服": "jiǔ,fù",
  "九梁朝冠": "jiǔ,liáng,cháo,guān",
  "九死一生": "jiǔ,sǐ,yì,shēng",
  "九浍": "jiǔ,huì",
  "九牛一毛": "jiǔ,niú,yì,máo",
  "九牛拉不转": "jiǔ,niú,lā,bù,zhuàn",
  "九皋处士": "jiǔ,gāo,chǔ,shì",
  "九禁": "jiǔ,jìn",
  "九背向": "jiǔ,bèi,xiàng",
  "九节狸": "jiǔ,jié,mái",
  "九行": "jiǔ,háng",
  "九行八业": "jiǔ,háng,bā,yè",
  "九貉": "jiǔ,mò",
  "九转": "jiǔ,zhuàn",
  "九转丹": "jiǔ,zhuàn,dān",
  "九转功成": "jiǔ,zhuàn,gōng,chéng",
  "九转还丹": "jiǔ,zhuàn,huán,dān",
  "九转金丹": "jiǔ,zhuàn,jīn,dān",
  "九转鼎": "jiǔ,zhuàn,dǐng",
  "九还丹": "jiǔ,huán,dān",
  "九重围": "jiǔ,chóng,wéi",
  "九重霄": "jiǔ,chóng,xiāo",
  "九钻": "jiǔ,zuàn",
  "九锡": "jiǔ,cì",
  "九隩": "jiǔ,yù",
  "九难": "jiǔ,nàn",
  "九鼎不足为重": "jiǔ,dǐng,bù,zú,wéi,zhòng",
  "九齿钉耙": "jiǔ,chǐ,dīng,pá",
  "乞丐地": "qǐ,gài,de",
  "乞力马扎罗山": "qǐ,lì,mǎ,zhā,luó,shān",
  "乞求地": "qǐ,qiú,de",
  "乞留兀良": "qǐ,liú,wū,liáng",
  "乞米帖": "qǐ,mǐ,tiē",
  "乞𰷞": "qǐ,tè",
  "乞降": "qǐ,xiáng",
  "也一步一步地": "yě,yí,bù,yí,bù,de",
  "也么": "yě,mǒ",
  "也么哥": "yě,mǒ,gē",
  "也么天": "yě,mǒ,tiān",
  "也么沙": "yě,mǒ,shā",
  "也乖乖地": "yě,guāi,guāi,de",
  "也会不断地变化": "yě,huì,bù,duàn,de,biàn,huà",
  "也会不时地": "yě,huì,bù,shí,de",
  "也会慢慢地": "yě,huì,màn,màn,de",
  "也似地": "yě,shì,de",
  "也动情地": "yě,dòng,qíng,de",
  "也可以很好地": "yě,kě,yǐ,hěn,hǎo,de",
  "也在不停地": "yě,zài,bù,tíng,de",
  "也好不了多少": "yě,hǎo,bu,liǎo,duō,shǎo",
  "也尽可能地": "yě,jìn,kě,néng,de",
  "也得": "yě,de",
  "也悄悄地": "yě,qiāo,qiāo,de",
  "也慢慢地": "yě,màn,màn,de",
  "也是为了更好地": "yě,shì,wèi,le,gèng,hǎo,de",
  "也是我本能地": "yě,shì,wǒ,běn,néng,de",
  "也是该地": "yě,shì,gāi,de",
  "也曾": "yě,zēng",
  "也没有很好地": "yě,méi,yǒu,hěn,hǎo,de",
  "也清醒地": "yě,qīng,xǐng,de",
  "也特别地": "yě,tè,bié,de",
  "也相应地": "yě,xiāng,yìng,de",
  "也者么": "yě,zhě,mǒ",
  "也耶": "yě,yē",
  "也能安全地": "yě,néng,ān,quán,de",
  "也许地": "yě,xǔ,de",
  "也该好好地想想": "yě,gāi,hǎo,hǎo,de,xiǎng,xiǎng",
  "习为故常": "xí,wéi,gù,cháng",
  "习以为常": "xí,yǐ,wéi,cháng",
  "习字帖": "xí,zì,tiè",
  "习常地": "xí,cháng,de",
  "习很深地": "xí,hěn,shēn,de",
  "习惯地": "xí,guàn,de",
  "习惯性地": "xí,guàn,xìng,de",
  "习舌调吻": "xí,shé,diào,wěn",
  "乡下": "xiāng,xia",
  "乡下佬": "xiāng,xia,lǎo",
  "乡下味地": "xiāng,xià,wèi,de",
  "乡侯": "xiāng,hòu",
  "乡土气地": "xiāng,tǔ,qì,de",
  "乡大夫": "xiāng,dài,fū",
  "乡巴佬儿": "xiāng,bā,lǎo,er",
  "乡戚": "xiāng,qi",
  "乡曲": "xiāng,qū",
  "乡村音乐": "xiāng,cūn,yīn,yuè",
  "乡背": "xiāng,bèi",
  "乡调": "xiāng,diào",
  "乡关": "xiāng,wān",
  "乡音地": "xiāng,yīn,de",
  "乡风": "xiàng,fēng",
  "书削": "shū,xuē",
  "书卷": "shū,juàn",
  "书卷奖": "shū,juàn,jiǎng",
  "书卷气": "shū,juàn,qì",
  "书吧": "shū,ba",
  "书呆子": "shū,dāi,zi",
  "书帖": "shū,tiē",
  "书归正传": "shū,guī,zhèng,zhuàn",
  "书扣子": "shū,kòu,zi",
  "书摊儿": "shū,tān,er",
  "书数": "shū,shù",
  "书皮儿": "shū,pí,er",
  "书䇲": "shū,jiā",
  "书缺有间": "shū,quē,yǒu,jiàn",
  "书背": "shū,bèi",
  "书舍": "shū,shè",
  "书虫子": "shū,chóng,zi",
  "书记": "shū,ji",
  "书记处": "shū,ji,chù",
  "书记官": "shū,ji,guān",
  "书铺": "shū,pù",
  "书馆儿": "shū,guǎn,er",
  "买不起": "mǎi,bu,qǐ",
  "买东西": "mǎi,dōng,xi",
  "买哄": "mǎi,hǒng",
  "买帆": "mǎi,fān",
  "买得起": "mǎi,de,qǐ",
  "买服": "mǎi,fù",
  "买服钱": "mǎi,fù,qián",
  "买椟还珠": "mǎi,dú,huán,zhū",
  "买面子": "mǎi,miàn,zi",
  "乱作胡为": "luàn,zuò,hú,wéi",
  "乱咕攘": "luàn,gū,rang",
  "乱哄": "luàn,hǒng",
  "乱哄哄": "luàn,hǒng,hǒng",
  "乱子": "luàn,zi",
  "乱尨": "luàn,méng",
  "乱成一团": "luàn,chéng,yì,tuán",
  "乱扎扎": "luàn,zhā,zhā",
  "乱摊子": "luàn,tān,zi",
  "乱数": "luàn,shù",
  "乱片子": "luàn,piān,zi",
  "乱箭攒心": "luàn,jiàn,cuán,xīn",
  "乱糟糟地": "luàn,zāo,zāo,de",
  "乱蓬蓬": "luàn,pēng,pēng",
  "乱麻麻": "luàn,mā,ma",
  "乳晕": "rǔ,yùn",
  "乳杆菌": "rǔ,gǎn,jūn",
  "乳筩": "rǔ,yǒng",
  "乳臭": "rǔ,xiù",
  "乳臭儿": "rǔ,xiù,ér",
  "乳臭子": "rǔ,xiù,zǐ",
  "乳臭小儿": "rǔ,xiù,xiǎo,ér",
  "乳臭小子": "rǔ,xiù,xiǎo,zi",
  "乳臭未干": "rǔ,xiù,wèi,gān",
  "乳舍": "rǔ,shè",
  "乾闼婆": "gàn,tà,pó",
  "了不": "liǎo,bù",
  "了不可见": "liǎo,bù,kě,jiàn",
  "了不得": "liǎo,bù,dé",
  "了不成": "liǎo,bù,chéng",
  "了不的": "liǎo,bù,de",
  "了不起": "liǎo,bù,qǐ",
  "了不起地": "liǎo,bù,qǐ,de",
  "了不长进": "liǎo,bù,zhǎng,jìn",
  "了了": "liǎo,liǎo",
  "了了可见": "liǎo,liǎo,kě,jiàn",
  "了事": "liǎo,shì",
  "了事环": "liǎo,shì,huán",
  "了事痴": "liǎo,shì,chī",
  "了债": "liǎo,zhài",
  "了却": "liǎo,què",
  "了却此生": "liǎo,què,cǐ,shēng",
  "了处": "le,chǔ",
  "了如": "liǎo,rú",
  "了如指掌": "liǎo,rú,zhǐ,zhǎng",
  "了如观火": "liǎo,rú,guān,huǒ",
  "了局": "liǎo,jú",
  "了干": "le,gàn",
  "了当": "liǎo,dàng",
  "了得": "liǎo,de",
  "了悟": "liǎo,wù",
  "了断": "liǎo,duàn",
  "了无": "liǎo,wú",
  "了无惧色": "liǎo,wú,jù,sè",
  "了无新意": "liǎo,wú,xīn,yì",
  "了无生趣": "liǎo,wú,shēng,qù",
  "了望台": "liào,wàng,tái",
  "了望塔": "liào,wàng,tǎ",
  "了法": "liǎo,fǎ",
  "了然": "liǎo,rán",
  "了然于胸": "liǎo,rán,yú,xiōng",
  "了知": "liǎo,zhī",
  "了结": "liǎo,jié",
  "了若指掌": "liǎo,ruò,zhǐ,zhǎng",
  "了解": "liǎo,jiě",
  "了账": "liǎo,zhàng",
  "了身达命": "liǎo,shēn,dá,mìng",
  "予乐": "yǔ,lè",
  "予人口实": "yǔ,rén,kǒu,shí",
  "予以": "yǔ,yǐ",
  "予以照顾": "yǔ,yǐ,zhào,gù",
  "予冲人": "yǔ,chōng,rén",
  "予冲子": "yǔ,chòng,zi",
  "予决": "yǔ,jué",
  "予勾": "yǔ,gōu",
  "予句": "yǔ,jù",
  "予告": "yǔ,gào",
  "予圣": "yǔ,shèng",
  "予夺": "yǔ,duó",
  "予夺生杀": "yǔ,duó,shēng,shā",
  "予宁": "yǔ,níng",
  "予小子": "yǔ,xiǎo,zi",
  "予归": "yǔ,guī",
  "予末小子": "yú,mò,xiǎo,zi",
  "予知": "yǔ,zhī",
  "予美": "yǔ,měi",
  "予赐": "yǔ,cì",
  "予雄": "yǔ,xióng",
  "予齿去角": "yǔ,chǐ,qù,jiǎo",
  "争友": "zhèng,yǒu",
  "争子": "zhèng,zǐ",
  "争引": "zhèng,yǐn",
  "争弟": "zhèng,dì",
  "争强好胜": "zhēng,qiáng,hào,shèng",
  "争得": "zhēng,de",
  "争朝夕": "zhēng,zhāo,xī",
  "争长": "zhēng,zhǎng",
  "争长相雄": "zhēng,zhǎng,xiàng,xióng",
  "争面子": "zhēng,miàn,zi",
  "事与心违": "shì,yù,xīn,wéi",
  "事为": "shì,wéi",
  "事假": "shì,jià",
  "事儿": "shì,er",
  "事儿妈": "shì,er,mā",
  "事先地": "shì,xiān,de",
  "事前地": "shì,qián,de",
  "事危累卵": "shì,wēi,lèi,luǎn",
  "事后聪明": "shì,hòu,cōng,ming",
  "事在人为": "shì,zài,rén,wéi",
  "事实地": "shì,shí,de",
  "事干": "shì,gàn",
  "事怕行家": "shì,pà,háng,jiā",
  "事情": "shì,qing",
  "事情要一点一点地做": "shì,qíng,yào,yì,diǎn,yì,diǎn,de,zuò",
  "事数": "shì,shù",
  "二不棱登": "èr,bù,lēng,dēng",
  "二二糊糊": "èr,èr,hū,hū",
  "二人转": "èr,rén,zhuàn",
  "二倍地": "èr,bèi,de",
  "二八地": "èr,bā,de",
  "二十八宿": "èr,shí,bā,xiù",
  "二十八舍": "èr,shí,bā,shè",
  "二十八调": "èr,shí,bā,diào",
  "二千石": "èr,qiān,dàn",
  "二和药": "èr,huò,yào",
  "二尕子": "èr,gǎ,zi",
  "二性子": "èr,xìng,zi",
  "二愣子": "èr,lèng,zi",
  "二拇指": "èr,mu,zhǐ",
  "二拇指头": "èr,mǔ,zhǐ,tou",
  "二更": "èr,gēng",
  "二杆": "èr,gǎn",
  "二杆子": "èr,gān,zi",
  "二次函数": "èr,cì,hán,shù",
  "二次曲": "èr,cì,qū",
  "二次曲线": "èr,cì,qū,xiàn",
  "二次曲面": "èr,cì,qū,miàn",
  "二毛子": "èr,máo,zi",
  "二流子": "èr,liú,zi",
  "二王帖": "èr,wáng,tiē",
  "二竖为虐": "èr,shù,wéi,nüè",
  "二舍": "èr,shè",
  "二荤铺": "èr,hūn,pù",
  "二葛": "èr,gě",
  "二辈子": "èr,bèi,zi",
  "二适": "èr,shì",
  "二道贩子": "èr,dào,fàn,zi",
  "二里头": "èr,lǐ,tou",
  "二重": "èr,chóng",
  "二重下标": "èr,chóng,xià,biāo",
  "二重唱": "èr,chóng,chàng",
  "二重奏": "èr,chóng,zòu",
  "二重性": "èr,chóng,xìng",
  "二重根": "èr,chóng,gēn",
  "二重母音": "èr,chóng,mǔ,yīn",
  "二项式系数": "èr,xiàng,shì,xì,shù",
  "二鬼子": "èr,guǐ,zi",
  "于今为烈": "yú,jīn,wéi,liè",
  "于家为国": "yú,jiā,wéi,guó",
  "于心无愧": "yú,jīn,wú,kuì",
  "于思": "yú,sāi",
  "于戏": "wū,hū",
  "于无声处": "yú,wú,shēng,chǔ",
  "于是乖乖地": "yú,shì,guāi,guāi,de",
  "于熙": "wū,hū",
  "于穆": "wū,mù",
  "于赫": "wū,hè",
  "于都": "yú,dū",
  "于都县": "yú,dū,xiàn",
  "亏得": "kuī,de",
  "亏累": "kuī,lèi",
  "云为": "yún,wéi",
  "云兴": "yún,xīng",
  "云兴霞蔚": "yún,xīng,xiá,wèi",
  "云冠": "yún,guān",
  "云合响应": "yún,hé,xiǎng,yìng",
  "云堤": "yún,dī",
  "云头儿": "yún,tou,er",
  "云头子": "yún,tóu,zi",
  "云帆": "yún,fān",
  "云幢": "yún,zhuàng",
  "云干": "yún,gàn",
  "云庄休居自适小乐府": "yún,zhuāng,xiū,jū,zì,shì,xiǎo,yuè,fǔ",
  "云彩": "yún,cai",
  "云彻雾卷": "yún,chè,wù,juàn",
  "云朝雨暮": "yún,zhāo,yǔ,mù",
  "云母冠": "yún,mǔ,guān",
  "云泥之差": "yún,ní,zhī,chā",
  "云溪醉侯": "yún,xī,zuì,hòu",
  "云𥮾": "yún,zān",
  "云翘": "yún,qiào",
  "云𫐌": "yún,pēng",
  "云集响应": "yún,jí,xiǎng,yìng",
  "云露": "yún,lù",
  "互为": "hù,wéi",
  "互为因果": "hù,wéi,yīn,guǒ",
  "互为表里": "hù,wéi,biǎo,lǐ",
  "互助地": "hù,zhù,de",
  "互折": "hù,shé",
  "互相地": "hù,xiāng,de",
  "互见": "hù,xiàn",
  "互诉衷肠": "hū,sù,zhōng,cháng",
  "五七干校": "wǔ,qī,gàn,xiào",
  "五七干部学校": "wǔ,qī,gàn,bù,xué,xiào",
  "五侯": "wǔ,hòu",
  "五侯七贵": "wǔ,hòu,qī,guì",
  "五侯九伯": "wǔ,hòu,jiǔ,bó",
  "五侯第": "wǔ,hòu,dì",
  "五侯蜡烛": "wǔ,hòu,là,zhú",
  "五侯鲭": "wǔ,hòu,qīng",
  "五倍地": "wǔ,bèi,de",
  "五倍子树": "wǔ,bèi,zi,shù",
  "五剽": "wǔ,piāo",
  "五十倍地": "wǔ,shí,bèi,de",
  "五单于": "wǔ,chán,yú",
  "五𰊑": "wǔ,làn",
  "五处士": "wǔ,chǔ,shì",
  "五大夫": "wǔ,dài,fū",
  "五大夫城": "wǔ,dài,fū,chéng",
  "五姓蕃": "wǔ,xìng,fān",
  "五属大夫": "wǔ,shǔ,dài,fū",
  "五年计划": "wǔ,nián,jì,huà",
  "五征": "wǔ,zhǐ",
  "五数": "wǔ,shù",
  "五斗": "wǔ,dǒu",
  "五斗先生": "wǔ,dǒu,xiān,shēng",
  "五斗子": "wǔ,dǒu,zi",
  "五斗折腰": "wǔ,dǒu,zhé,yāo",
  "五斗柜": "wǔ,dǒu,guì",
  "五斗橱": "wǔ,dǒu,chú",
  "五斗禄": "wǔ,dǒu,lù",
  "五斗米": "wǔ,dǒu,mǐ",
  "五斗米师": "wǔ,dǒu,mǐ,shī",
  "五斗米道": "wǔ,dǒu,mǐ,dào",
  "五斗粟": "wǔ,dǒu,sù",
  "五斗解酲": "wǔ,dǒu,jiě,chéng",
  "五方幢": "wǔ,fāng,zhuàng",
  "五方杂处": "wǔ,fāng,zá,chǔ",
  "五方狮子舞": "wǔ,fāng,shī,zi,wǔ",
  "五日子": "wǔ,rì,zi",
  "五更": "wǔ,gēng",
  "五更天": "wǔ,gēng,tiān",
  "五更头": "wǔ,gēng,tóu",
  "五更调": "wǔ,gēng,diào",
  "五更转": "wǔ,gēng,zhuàn",
  "五更鸡": "wǔ,gēng,jī",
  "五柞": "wǔ,zhà",
  "五柞宫": "wǔ,zhà,gōng",
  "五梁冠": "wǔ,liáng,guān",
  "五汶": "wǔ,mén",
  "五石": "wǔ,dàn",
  "五石散": "wǔ,dàn,sàn",
  "五石瓠": "wǔ,dàn,hù",
  "五石铜": "wǔ,dàn,tóng",
  "五禁": "wǔ,jìn",
  "五精舍": "wǔ,jīng,shè",
  "五经解元": "wǔ,jīng,jiè,yuán",
  "五缞": "wǔ,shuāi",
  "五脊六兽": "wǔ,jí,liù,shòu",
  "五花腌猪肉": "wǔ,huā,yān,zhū,ròu",
  "五苓散": "wǔ,líng,sǎn",
  "五荫": "wǔ,yìn",
  "五藏": "wǔ,zàng",
  "五藏神": "wǔ,zàng,shén",
  "五虎将": "wǔ,hǔ,jiàng",
  "五行八作": "wǔ,háng,bā,zuò",
  "五行四柱": "wǔ,háng,sì,zhù",
  "五行大布": "wǔ,háng,dà,bù",
  "五行家": "wǔ,háng,jiā",
  "五行并下": "wǔ,háng,bìng,xià",
  "五行生胜": "wǔ,háng,shēng,shèng",
  "五行相克": "wǔ,háng,xiāng,kè",
  "五行相生": "wǔ,háng,xiāng,shēng",
  "五行相胜": "wǔ,háng,xiāng,shèng",
  "五行舞": "wǔ,háng,wǔ",
  "五行阵": "wǔ,háng,zhèn",
  "五调": "wǔ,diào",
  "五通神": "wǔ,tòng,shén",
  "五金店铺": "wǔ,jīn,diàn,pù",
  "五金行": "wǔ,jīn,háng",
  "五铣衣": "wǔ,xǐ,yī",
  "五长": "wǔ,zhǎng",
  "五陵年少": "wǔ,líng,nián,shào",
  "井冠": "jǐng,guān",
  "井干": "jǐng,gàn",
  "井干楼": "jǐng,gàn,lóu",
  "井底蛤蟆": "jǐng,dǐ,há,má",
  "井槛": "jǐng,kǎn",
  "井硙": "jǐng,wèi",
  "井落在吊桶里": "jǐng,là,zài,diào,tǒng,lǐ",
  "亚们": "yà,men",
  "亚利安娜": "yà,lì,ān,nà",
  "亚剌伯": "yà,lā,bó",
  "亚塞拜然": "yà,sè,bài,rán",
  "亚大夫": "yà,dài,fū",
  "亚平宁": "yà,píng,nìng",
  "亚得里亚海": "yà,de,lǐ,yà,hǎi",
  "亚投行": "yà,tóu,háng",
  "亚洲地": "yà,zhōu,de",
  "亚洲开发银行": "yà,zhōu,kāi,fā,yín,háng",
  "亚的斯亚贝巴": "yà,dì,sī,yà,bèi,bā",
  "亚肩叠背": "yà,jiān,dié,bèi",
  "亚肩迭背": "yà,jiān,dié,bèi",
  "些仔": "xiē,zǎi",
  "些儿子": "xiē,ér,zi",
  "些子儿": "xiē,zǐ,er",
  "些微地": "xiē,wēi,de",
  "亡为": "wáng,wéi",
  "亡犴": "wáng,àn",
  "亢宿": "kàng,xiù",
  "亢心㤭气": "kàng,xīn,xià,qì",
  "亢扞": "kàng,gǎn",
  "亢音高唱": "gāng,yīn,gāo,chàng",
  "交互地": "jiāo,hù,de",
  "交互式地": "jiāo,hù,shì,de",
  "交切": "jiāo,qiè",
  "交卷": "jiāo,juàn",
  "交叉地": "jiāo,chā,de",
  "交哄": "jiāo,hǒng",
  "交响乐": "jiāo,xiǎng,yuè",
  "交响乐团": "jiāo,xiǎng,yuè,tuán",
  "交响乐队": "jiāo,xiǎng,yuè,duì",
  "交差": "jiāo,chāi",
  "交应": "jiāo,yìng",
  "交恶": "jiāo,wù",
  "交情": "jiāo,qing",
  "交战中地": "jiāo,zhàn,zhōng,de",
  "交换代数": "jiāo,huàn,dài,shù",
  "交换代数学": "jiāo,huàn,dài,shù,xué",
  "交替地": "jiāo,tì,de",
  "交朋友": "jiāo,péng,you",
  "交查": "jiāo,zhā",
  "交白卷": "jiāo,bái,juàn",
  "交葛": "jiāo,gě",
  "交行": "jiāo,háng",
  "交让冠": "jiāo,ràng,guān",
  "交轧": "jiāo,zhá",
  "交还": "jiāo,huán",
  "交通堵塞": "jiāo,tōng,dǔ,sè",
  "交通梗塞": "jiāo,tōng,gěng,sè",
  "交通银行": "jiāo,tōng,yín,háng",
  "交通阻塞": "jiāo,tōng,zǔ,sè",
  "交酢": "jiāo,cù",
  "交露": "jiāo,lù",
  "亦都护": "yì,dū,hù",
  "产供销": "chǎn,gōng,xiāo",
  "产假": "chǎn,jià",
  "产气地": "chǎn,qì,de",
  "产米地": "chǎn,mǐ,de",
  "产粮地": "chǎn,liáng,de",
  "产舍": "chǎn,shè",
  "产量多地": "chǎn,liàng,duō,de",
  "京削": "jīng,xuē",
  "京味儿": "jīng,wèi,er",
  "京毂": "jīng,gū",
  "京片子": "jīng,piàn,zi",
  "京都": "jīng,dū",
  "京都八景": "jīng,dū,bā,jǐng",
  "京都十景": "jīng,dū,shí,jǐng",
  "京都府": "jīng,dū,fǔ",
  "京都念慈庵": "jīng,dū,niàn,cí,ān",
  "亭侯": "tíng,hòu",
  "亭子": "tíng,zi",
  "亭子间": "tíng,zi,jiān",
  "亭槛": "tíng,kǎn",
  "亭舍": "tíng,shè",
  "亭长": "tíng,zhǎng",
  "亮皮子": "liàng,pí,zi",
  "亮盒子摇": "liàng,hé,zi,yáo",
  "亮相": "liàng,xiàng",
  "亮𬮴": "liàng,ān",
  "亮闪闪地": "liàng,shǎn,shǎn,de",
  "亲为": "qīn,wéi",
  "亲们": "qīn,men",
  "亲切": "qīn,qiè",
  "亲切地": "qīn,qiè,de",
  "亲切地交": "qīn,qiè,de,jiāo",
  "亲切地交谈": "qīn,qiè,de,jiāo,tán",
  "亲切地叫": "qīn,qiè,de,jiào",
  "亲切地呼": "qīn,qiè,de,hū",
  "亲切地说": "qīn,qiè,de,shuō",
  "亲切地问": "qīn,qiè,de,wèn",
  "亲切感": "qīn,qiè,gǎn",
  "亲力亲为": "qīn,lì,qīn,wéi",
  "亲家": "qìng,jia",
  "亲家公": "qìng,jiā,gōng",
  "亲家母": "qìng,jiā,mǔ",
  "亲家爹": "qìng,jiā,diē",
  "亲家翁": "qìng,jiā,wēng",
  "亲密地": "qīn,mì,de",
  "亲密地合作": "qīn,mì,de,hé,zuò",
  "亲密地挽着": "qīn,mì,de,wǎn,zhe",
  "亲密无间": "qīn,mì,wú,jiàn",
  "亲㧛": "qīn,lǎn",
  "亲昵地": "qīn,nì,de",
  "亲昵地说": "qīn,nì,de,shuō",
  "亲热地": "qīn,rè,de",
  "亲热地叫": "qīn,rè,de,jiào",
  "亲热地打招呼": "qīn,rè,de,dǎ,zhāo,hū",
  "亲热地搂着": "qīn,rè,de,lǒu,zhe",
  "亲热地说": "qīn,rè,de,shuō",
  "亲爱地": "qīn,ài,de",
  "亲笔地": "qīn,bǐ,de",
  "亲累": "qīn,lèi",
  "亲自地": "qīn,zì,de",
  "亲近地": "qīn,jìn,de",
  "亲骨血": "qīn,gǔ,xuè",
  "亵渎地": "xiè,dú,de",
  "亵翫": "xiè,wàn",
  "亵露": "xiè,lù",
  "亶爰": "chán,yuán",
  "亸剥": "duǒ,bāo",
  "亹源": "mén,yuán",
  "人丁兴旺": "rén,dīng,xīng,wàng",
  "人不可以貌相": "rén,bù,kě,yǐ,mào,xiàng",
  "人不可貌相": "rén,bù,kě,mào,xiàng",
  "人与地": "rén,yǔ,de",
  "人为": "rén,wéi",
  "人为刀俎": "rén,wéi,dāo,zǔ",
  "人为土": "rén,wéi,tǔ",
  "人为地": "rén,wéi,de",
  "人为地加入": "rén,wéi,de,jiā,rù",
  "人为地将": "rén,wéi,de,jiāng",
  "人为地干涉": "rén,wéi,de,gān,shè",
  "人事不省": "rén,shì,bù,xǐng",
  "人们": "rén,men",
  "人体炸弹": "rén,tǐ,zhà,dàn",
  "人体解剖": "rén,tǐ,jiě,pōu",
  "人体解剖学": "rén,tǐ,jiě,pōu,xué",
  "人儿": "rén,er",
  "人参": "rén,shēn",
  "人参果": "rén,shēn,guǒ",
  "人口总数": "rén,kǒu,zǒng,shù",
  "人口数": "rén,kǒu,shù",
  "人口机械增长": "rén,kǒu,jī,xiè,zēng,zhǎng",
  "人口调查": "rén,kǒu,diào,chá",
  "人各有所好": "rén,gè,yǒu,suǒ,hào",
  "人味儿": "rén,wèi,er",
  "人多阙少": "rén,duō,què,shǎo",
  "人头攒动": "rén,tóu,cuán,dòng",
  "人尖儿": "rén,jiān,er",
  "人工地": "rén,gōng,de",
  "人心向背": "rén,xīn,xiàng,bèi",
  "人性上地": "rén,xìng,shàng,de",
  "人情世态": "rén,qíng,shì,tai",
  "人情味儿": "rén,qíng,wèi,er",
  "人才济济": "rén,cái,jǐ,jǐ",
  "人数": "rén,shù",
  "人数众多": "rén,shù,zhòng,duō",
  "人有旦夕祸福": "dì,yǒu,dàn,xī,huò,fú",
  "人样儿": "rén,yàng,er",
  "人样子": "rén,yàng,zi",
  "人模狗样": "rén,mú,gǒu,yàng",
  "人模狗样儿": "rén,mú,gǒu,yàng,ér",
  "人民银行": "rén,mín,yín,háng",
  "人涉卬否": "rén,shè,áng,fǒu",
  "人满为患": "rén,mǎn,wéi,huàn",
  "人烟浩穰": "rén,yān,hào,rǎng",
  "人物肖像": "rén,wù,xiào,xiàng",
  "人生如朝露": "rén,shēng,rú,zhāo,lù",
  "人生朝露": "rén,shēng,cháo,lù",
  "人生自古谁无死": "rén,shēng,zì,gǔ,shéi,wú,sǐ",
  "人皮囤": "rén,pí,dùn",
  "人相": "rén,xiàng",
  "人相学": "rén,xiàng,xué",
  "人祇": "rén,qí",
  "人种差别": "rén,zhǒng,chā,bié",
  "人类基因组计划": "rén,lèi,jī,yīn,zǔ,jì,huà",
  "人给家足": "rén,jǐ,jiā,zú",
  "人缘儿": "rén,yuán,er",
  "人缝": "rén,fèng",
  "人自为战": "rén,zì,wéi,zhàn",
  "人自为政": "rén,zì,wéi,zhèng",
  "人舍": "rén,shè",
  "人言藉藉": "rén,yán,jí,jí",
  "人谁无过": "rén,shéi,wú,guò",
  "人足家给": "rén,zú,jiā,jǐ",
  "人车混行": "rén,chē,hún,xíng",
  "人轧人": "rén,gá,rén",
  "人轮子": "rén,lún,zi",
  "人造地": "rén,zào,de",
  "人面子": "rén,miàn,zi",
  "人鱼小姐": "rén,yú,xiǎo,jie",
  "亿载": "yì,zǎi",
  "什一": "shí,yī",
  "什一奉献": "shí,yī,fèng,xiàn",
  "什不闲": "shí,bù,xián",
  "什么地方": "shén,me,dì,fang",
  "什九": "shí,jiǔ",
  "什件": "shí,jiàn",
  "什件儿": "shí,jiàn,ér",
  "什伍": "shí,wǔ",
  "什伍东西": "shí,wǔ,dōng,xī",
  "什伯": "shí,bǎi",
  "什具": "shí,jù",
  "什刹海": "shí,chà,hǎi",
  "什叶": "shí,yè",
  "什叶派": "shí,yè,pài",
  "什吏": "shí,lì",
  "什器": "shí,qì",
  "什围伍攻": "shí,wéi,wǔ,gōng",
  "什末": "shí,mò",
  "什物": "shí,wù",
  "什篇": "shí,piān",
  "什菜": "shí,cài",
  "什袭": "shí,xí",
  "什袭以藏": "shí,xí,yǐ,cáng",
  "什袭珍藏": "shí,xí,zhēn,cáng",
  "什袭而藏": "shí,xí,ér,cáng",
  "什邡": "shí,fāng",
  "什邡市": "shí,fāng,shì",
  "什锦": "shí,jǐn",
  "什锦果盘": "shí,jǐn,guǒ,pán",
  "什长": "shí,cháng",
  "什面": "shí,miàn",
  "仁儿": "rén,er",
  "仁慈地": "rén,cí,de",
  "仁朴": "rén,piáo",
  "仁波切": "rén,bō,qiè",
  "仁爱地": "rén,ài,de",
  "仄兀": "zè,wū",
  "仄注冠": "zè,zhù,guān",
  "仅仅是习惯性地": "jǐn,jǐn,shì,xí,guàn,xìng,de",
  "仅供": "jǐn,gōng",
  "仅供参考": "jǐn,gōng,cān,kǎo",
  "仅得乎中": "jìn,dé,hū,zhōng",
  "仆乘": "pú,chéng",
  "仆人": "pú,rén",
  "仆仆": "pú,pú",
  "仆仆亟拜": "pú,pú,jí,bài",
  "仆仆道途": "pú,pú,dào,tú",
  "仆仆风尘": "pú,pú,fēng,chén",
  "仆从": "pú,cóng",
  "仆从军": "pú,cóng,jūn",
  "仆从国": "pú,cóng,guó",
  "仆使": "pú,shǐ",
  "仆僮": "pú,tóng",
  "仆党": "pú,dǎng",
  "仆区": "pú,qū",
  "仆卒": "pú,zú",
  "仆厕": "pú,cè",
  "仆厮": "pú,sī",
  "仆固": "pú,gù",
  "仆圉": "pú,yǔ",
  "仆大夫": "pú,dài,fū",
  "仆夫": "pú,fū",
  "仆奴": "pú,nú",
  "仆妇": "pú,fù",
  "仆妾": "pú,qiè",
  "仆姑": "pú,gū",
  "仆媵": "pú,yìng",
  "仆子": "pú,zǐ",
  "仆射": "pú,yè",
  "仆废": "pú,fèi",
  "仆役": "pú,yì",
  "仆御": "pú,yù",
  "仆憎": "pú,zēng",
  "仆散": "pú,sàn",
  "仆数": "pú,shù",
  "仆斋": "pú,zhāi",
  "仆旅": "pú,lǚ",
  "仆欧": "pú,ōu",
  "仆死": "pú,sǐ",
  "仆漏": "pú,lòu",
  "仆灭": "pú,miè",
  "仆牛": "pú,niú",
  "仆程": "pú,chéng",
  "仆竖": "pú,shù",
  "仆童": "pú,tóng",
  "仆累": "pú,lèi",
  "仆缘": "pú,yuán",
  "仆臣": "pú,chén",
  "仆舆": "pú,yú",
  "仆虏": "pú,lǔ",
  "仆质": "pú,zhì",
  "仆赁": "pú,lìn",
  "仆遫": "pú,chì",
  "仆遬": "pú,sù",
  "仆陈": "pú,chén",
  "仆隶": "pú,lì",
  "仆食": "pú,shí",
  "仆马": "pú,mǎ",
  "仆骨": "pú,gǔ",
  "仇姓": "qiú,xìng",
  "今儿": "jīn,er",
  "今夫": "jīn,fú",
  "今朝": "jīn,zhāo",
  "今朝有酒今朝醉": "jīn,zhāo,yǒu,jiǔ,jīn,zhāo,zuì",
  "今蝉蜕殻": "jīn,chán,tuì,què",
  "介壳": "jiè,qiào",
  "介电常数": "jiè,diàn,cháng,shù",
  "介絜": "jiè,jié",
  "仍执着地": "réng,zhí,zhuó,de",
  "仍然不断地": "réng,rán,bù,duàn,de",
  "仍痴痴地": "réng,chī,chī,de",
  "仍静静地": "réng,jìng,jìng,de",
  "从严惩处": "cóng,yán,chéng,chǔ",
  "从前地": "cóng,qián,de",
  "从容地": "cóng,róng,de",
  "从容地走": "cóng,róng,de,zǒu",
  "从容应对": "cóng,róng,yìng,duì",
  "从开始地": "cóng,kāi,shǐ,de",
  "从未真正地": "cóng,wèi,zhēn,zhèng,de",
  "从来没有好好地": "cóng,lái,méi,yǒu,hǎo,hǎo,de",
  "从而大大地": "cóng,ér,dà,dà,de",
  "从而成功地": "cóng,ér,chéng,gōng,de",
  "从而更好地": "cóng,ér,gèng,hǎo,de",
  "从轻处罚": "cóng,qīng,chǔ,fá",
  "从远处地": "cóng,yuǎn,chù,de",
  "从适": "cóng,shì",
  "仑背": "lún,bèi",
  "仑背乡": "lún,bèi,xiāng",
  "仓促地": "cāng,cù,de",
  "仓兄": "chuàng,huǎng",
  "仓卒": "cāng,cù",
  "仓卒主人": "cāng,cù,zhǔ,rén",
  "仓卒之际": "cāng,cù,zhī,jì",
  "仓帑": "cāng,tǎng",
  "仓舍": "cāng,shè",
  "仔么": "zǎi,mǒ",
  "仔仔": "zǐ,zǎi",
  "仔仔细细地": "zǎi,zǐ,xì,xì,de",
  "仔兽": "zǎi,shòu",
  "仔敢": "zǎi,gǎn",
  "仔望": "zǎi,wàng",
  "仔琫": "zǎi,běng",
  "仔细地": "zǐ,xì,de",
  "仔细地听着": "zǐ,xì,de,tīng,zhe",
  "仔细地回忆": "zǐ,xì,de,huí,yì",
  "仔细地想": "zǐ,xì,de,xiǎng",
  "仔细地想一想": "zǐ,xì,de,xiǎng,yī,xiǎng",
  "仔细地打量": "zǐ,xì,de,dǎ,liàng",
  "仔细地看": "zǐ,xì,de,kàn",
  "仔细地看一下": "zǐ,xì,de,kàn,yī,xià",
  "仔细地看看": "zǐ,xì,de,kàn,kàn",
  "仔细地看着": "zǐ,xì,de,kàn,zhe",
  "仔细地看过": "zǐ,xì,de,kàn,guò",
  "仔细地研究": "zǐ,xì,de,yán,jiū",
  "仔细地研究一下": "zǐ,xì,de,yán,jiū,yī,xià",
  "仔细地研究过": "zǐ,xì,de,yán,jiū,guò",
  "仔细地观察着": "zǐ,xì,de,guān,chá,zhe",
  "仔细地说出": "zǐ,xì,de,shuō,chū",
  "仔肩": "zī,jiān",
  "他不停地": "tā,bù,tíng,de",
  "他不断地": "tā,bù,duàn,de",
  "他为难地": "tā,wéi,nán,de",
  "他乐意地": "tā,lè,yì,de",
  "他亲切地": "tā,qīn,qiè,de",
  "他他藉藉": "tā,tā,jí,jí",
  "他们": "tā,men",
  "他们不停地": "tā,men,bù,tíng,de",
  "他们俩": "tā,men,liǎ",
  "他们的": "tā,men,de",
  "他们自己": "tā,men,zì,jǐ",
  "他们自己的": "tā,men,zì,jǐ,de",
  "他俩": "tā,liǎ",
  "他冷静地": "tā,lěng,jìng,de",
  "他处": "tā,chǔ",
  "他失望地": "tā,shī,wàng,de",
  "他妈妈": "tā,mā,ma",
  "他悄悄地": "tā,qiāo,qiāo,de",
  "他明确地": "tā,míng,què,de",
  "他本能地": "tā,běn,néng,de",
  "他果断地": "tā,guǒ,duàn,de",
  "他气愤地": "tā,qì,fèn,de",
  "他清楚地": "tā,qīng,chǔ,de",
  "他清醒地": "tā,qīng,xǐng,de",
  "他激动地": "tā,jī,dòng,de",
  "他猛地": "tā,měng,de",
  "他自觉地": "tā,zì,jué,de",
  "他茫然地": "tā,máng,rán,de",
  "他适": "tā,shì",
  "他顽强地": "tā,wán,qiáng,de",
  "他频繁地": "tā,pín,fán,de",
  "他高兴地": "tā,gāo,xìng,de",
  "仗舍": "zhàng,shè",
  "付之一炬": "fù,zhī,yí,jù",
  "付予": "fù,yǔ",
  "付款地": "fù,kuǎn,de",
  "仙人掌杆菌": "xiān,rén,zhǎng,gǎn,jūn",
  "仙呗": "xiān,bài",
  "仙幢": "xiān,zhuàng",
  "仙方儿": "xiān,fāng,er",
  "仙禁": "xiān,jìn",
  "仙露": "xiān,lù",
  "仙露明珠": "xiān,lù,míng,zhū",
  "仙露琼浆": "xiān,lù,qióng,jiāng",
  "仟伯": "qiān,bǎi",
  "仡佬年": "gē,lǎo,nián",
  "仡佬族": "gē,lǎo,zú",
  "仡佬语": "gē,lǎo,yǔ",
  "代为": "dài,wéi",
  "代为说项": "dài,wéi,shuō,xiàng",
  "代偿地": "dài,cháng,de",
  "代兴": "dài,xīng",
  "代数": "dài,shù",
  "代数几何": "dài,shù,jǐ,hé",
  "代数几何学": "dài,shù,jǐ,hé,xué",
  "代数函数": "dài,shù,hán,shù",
  "代数函数论": "dài,shù,hán,shù,lùn",
  "代数和": "dài,shù,hé",
  "代数基本定理": "dài,shù,jī,běn,dìng,lǐ",
  "代数学": "dài,shù,xué",
  "代数学基本定理": "dài,shù,xué,jī,běn,dìng,lǐ",
  "代数式": "dài,shù,shì",
  "代数拓扑": "dài,shù,tuò,pū",
  "代数数": "dài,shù,shù",
  "代数数域": "dài,shù,shù,yù",
  "代数方程": "dài,shù,fāng,chéng",
  "代数曲线": "dài,shù,qū,xiàn",
  "代数曲面": "dài,shù,qū,miàn",
  "代数簇": "dài,shù,cù",
  "代数结构": "dài,shù,jié,gòu",
  "代数群": "dài,shù,qún",
  "代数运算": "dài,shù,yùn,suàn",
  "代数量": "dài,shù,liàng",
  "代理地": "dài,lǐ,de",
  "代翟": "dài,zhái",
  "代舍": "dài,shè",
  "代表地": "dài,biǎo,de",
  "代表性地": "dài,biǎo,xìng,de",
  "令人不安地": "lìng,rén,bù,ān,de",
  "令人信服地": "lìng,rén,xìn,fú,de",
  "令人切齿": "lìng,rén,qiè,chǐ",
  "令人发指": "lìng,rén,fà,zhǐ",
  "令人惊讶地": "lìng,rén,jīng,yà,de",
  "令人愉快地": "lìng,rén,yú,kuài,de",
  "令人气恼地": "lìng,rén,qì,nǎo,de",
  "令人满意地": "lìng,rén,mǎn,yì,de",
  "令人畏惧地": "lìng,rén,wèi,jù,de",
  "令人钦佩地": "lìng,rén,qīn,pèi,de",
  "令人难忘地": "lìng,rén,nán,wàng,de",
  "令仆": "lìng,pú",
  "令原之戚": "líng,yuán,zhī,qī",
  "令原之痛": "líng,yuán,zhī,tòng",
  "令狐": "líng,hú",
  "令狐德棻": "líng,hú,dé,fēn",
  "令舍": "lìng,shè",
  "令行禁止": "lìng,xíng,jìn,zhǐ",
  "令长": "lìng,zhǎng",
  "以不变应万变": "yǐ,bù,biàn,yìng,wàn,biàn",
  "以不济可": "yǐ,fǒu,jì,kě",
  "以为": "yǐ,wéi",
  "以为后图": "yǐ,wéi,hòu,tú",
  "以书为御": "yǐ,shū,wéi,yù",
  "以亲为解": "yǐ,qīn,wéi,jiě",
  "以人为本": "yǐ,rén,wéi,běn",
  "以人为鉴": "yǐ,rén,wéi,jiàn",
  "以人为镜": "yǐ,rén,wéi,jìng",
  "以冠补履": "yǐ,guān,bǔ,lǚ",
  "以利相倾": "yi,li,xiang,qu",
  "以利累形": "yǐ,lì,lěi,xíng",
  "以前地": "yǐ,qián,de",
  "以升量石": "yǐ,shēng,liáng,dàn",
  "以压倒之势地": "yǐ,yā,dǎo,zhī,shì,de",
  "以古为鉴": "yǐ,gǔ,wéi,jiàn",
  "以古为镜": "yǐ,gǔ,wéi,jìng",
  "以史为鉴": "yǐ,shǐ,wéi,jiàn",
  "以合唱地": "yǐ,hé,chàng,de",
  "以后地": "yǐ,hòu,de",
  "以和为贵": "yǐ,hé,wéi,guì",
  "以地换地": "yǐ,de,huàn,de",
  "以夜继朝": "yǐ,yè,jì,zhāo",
  "以大恶细": "yǐ,dà,wù,xì",
  "以天下为己任": "yǐ,tiān,xià,wéi,jǐ,rèn",
  "以太坊": "yǐ,tài,fáng",
  "以守为攻": "yǐ,shǒu,wéi,gōng",
  "以宫笑角": "yǐ,gōng,xiào,jué",
  "以尽吾齿": "yi,jin,wu,ci",
  "以工代干": "yǐ,gōng,dài,gàn",
  "以己度人": "yǐ,jǐ,duó,rén",
  "以往地": "yǐ,wǎng,de",
  "以德报德": "yǐ,dé,bào,yu",
  "以忍为阍": "yǐ,rěn,wéi,hūn",
  "以意为主": "yǐ,yì,wéi,zhǔ",
  "以意为之": "yǐ,yì,wéi,zhī",
  "以慎为键": "yǐ,shèn,wéi,jiàn",
  "以攻为守": "yǐ,gōng,wéi,shǒu",
  "以文为诗": "yǐ,wén,wéi,shī",
  "以日为年": "yǐ,rì,wéi,nián",
  "以是为恨": "yǐ,shì,wéi,hèn",
  "以有效地": "yǐ,yǒu,xiào,de",
  "以此为": "yǐ,cǐ,wéi",
  "以毁为罚": "yǐ,huǐ,wéi,fá",
  "以毛相马": "yǐ,máo,xiàng,mǎ",
  "以水洗血": "yǐ,shuǐ,xǐ,xuè",
  "以水济水": "yǐ,shuǐ,jǐ,shuǐ",
  "以法为教": "yǐ,fǎ,wéi,jiào",
  "以泽量尸": "yǐ,zé,liáng,shī",
  "以牙还牙": "yǐ,yá,huán,yá",
  "以狸致鼠": "yǐ,lǐ,zhì,shǔ",
  "以狸饵鼠": "yǐ,lǐ,ěr,shǔ",
  "以电报地": "yǐ,diàn,bào,de",
  "以疏间亲": "yǐ,shū,jiàn,qīn",
  "以白为黑": "yǐ,bái,wéi,hēi",
  "以眼还眼": "yǐ,yǎn,huán,yǎn",
  "以筌为鱼": "yǐ,quán,wéi,yú",
  "以紫为朱": "yǐ,zǐ,wéi,zhū",
  "以耳为目": "yǐ,ěr,wéi,mù",
  "以肉𫗪虎": "yǐ,ròu,sì,hǔ",
  "以茶当酒": "yǐ,chá,dàng,jiǔ",
  "以荷析薪": "yǐ,hè,xī,xīn",
  "以蠡测海": "yǐ,lí,cè,hǎi",
  "以血洗血": "yǐ,xuè,xǐ,xuè",
  "以规为瑱": "yǐ,guī,wéi,tiàn",
  "以言为讳": "yǐ,yán,wéi,huì",
  "以誉为赏": "yǐ,yù,wéi,shǎng",
  "以身殉国": "yǐ,shēng,xùn,guó",
  "以还": "yǐ,huán",
  "以退为进": "yǐ,tuì,wéi,jìn",
  "以邻为壑": "yǐ,lín,wéi,hè",
  "以郄视文": "yǐ,xì,shì,wén",
  "以鹿为马": "yǐ,lù,wéi,mǎ",
  "以黑为白": "yǐ,hēi,wéi,bái",
  "仪器地": "yí,qì,de",
  "仪干": "yí,gàn",
  "仪式上地": "yí,shì,shàng,de",
  "仪式地": "yí,shì,de",
  "仪数": "yí,shù",
  "仪禁": "yí,jìn",
  "仪适": "yí,shì",
  "仰事俯畜": "yǎng,shì,fǔ,xù",
  "仰俛": "yǎng,miǎn",
  "仰卧地": "yǎng,wò,de",
  "仰屋兴叹": "yǎng,wū,xīng,tàn",
  "仰给": "yǎng,jǐ",
  "仰而赋诗": "yang,er,fu,shi",
  "件数": "jiàn,shù",
  "任一个": "rèn,yī,ge",
  "任丘": "rén,qiū",
  "任丘市": "rén,qiū,shì",
  "任么": "rèn,mǒ",
  "任兴": "rèn,xīng",
  "任务栏": "rèn,wu,lán",
  "任务管理器": "rèn,wu,guǎn,lǐ,qì",
  "任县": "rén,xiàn",
  "任姓": "rén,xìng",
  "任安": "rén,ān",
  "任性地": "rèn,xìng,de",
  "任意地": "rèn,yì,de",
  "任数": "rèn,shù",
  "任甚么": "rèn,shèn,mǒ",
  "任达华": "rén,dá,huá",
  "份儿菜": "fèn,er,cài",
  "份子": "fèn,zi",
  "份子钱": "fèn,zi,qián",
  "仿佛": "fǎng,fú",
  "仿偟": "páng,huáng",
  "仿徨失措": "páng,huáng,shī,cuò",
  "仿讽": "fǎng,fěng",
  "企投": "qì,tóu",
  "企逮": "qǐ,dǎi",
  "伉伉": "gāng,gāng",
  "伉厉": "gāng,lì",
  "伉浪": "gāng,làng",
  "伉爽": "gāng,shuǎng",
  "伉直": "gāng,zhí",
  "伊丽莎白": "yī,lì,shā,bái",
  "伊们": "yī,men",
  "伊儿汗国": "yī,ér,hán,guó",
  "伊哩乌卢": "yī,lǐ,wū,lú",
  "伊妹儿": "yī,mèi,er",
  "伊媚儿": "yī,mèi,er",
  "伊浴": "yī,gǔ",
  "伊莉莎白": "yī,lì,shā,bái",
  "伊轧": "yī,zhá",
  "伍什": "wǔ,shí",
  "伍侯": "wǔ,hòu",
  "伍长": "wǔ,zhǎng",
  "伎数": "jì,shù",
  "伏伏帖帖": "fú,fú,tiē,tiē",
  "伏伺": "fú,sì",
  "伏侍": "fú,shi",
  "伏地扣子": "fú,dì,kòu,zi",
  "伏处": "fú,chǔ",
  "伏尔加河纤夫": "fú,ěr,jiā,hé,qiàn,fū",
  "伏帖": "fú,tiē",
  "伏而咶天": "fú,ér,shì,tiān",
  "伏菟": "fú,tú",
  "伏虎降龙": "fú,hǔ,xiáng,lóng",
  "伏都教": "fú,dū,jiào",
  "伏𬮴": "fú,ān",
  "伏阙": "fú,què",
  "休假": "xiū,jià",
  "休养地": "xiū,yǎng,de",
  "休应": "xiū,yìng",
  "休得": "xiū,de",
  "休息地": "xiū,xī,de",
  "休憩地": "xiū,qì,de",
  "休澣": "xiū,hàn",
  "休舍": "xiū,shè",
  "休闲地": "xiū,xián,de",
  "众人捧柴火焰高": "zhòng,rén,pěng,chái,huō,yàn,gāo",
  "众口嚣嚣": "zhòng,kǒu,áo,áo",
  "众啄同音": "zhòng,zhòu,tóng,yīn",
  "众好众恶": "zhòng,hào,zhòng,wù",
  "众怨之的": "zhòng,yuàn,zhī,dì",
  "众恶": "zhòng,wù",
  "众数": "zhòng,shù",
  "众星攒月": "zhòng,xīng,cuán,yuè",
  "众毛攒裘": "zhòng,máo,cuán,qiú",
  "众生好度人难度": "zhòng,shēng,hǎo,duó,rén,nán,dù",
  "众生相": "zhòng,shēng,xiàng",
  "众矢之的": "zhòng,shǐ,zhī,dì",
  "众虎攒羊": "zhòng,hǔ,cuán,yáng",
  "众适": "zhòng,shì",
  "众香子": "zhòng,xiāng,zi",
  "优为": "yōu,wéi",
  "优先地": "yōu,xiān,de",
  "优劣得所": "yōu,liè,de,suǒ",
  "优厚地": "yōu,hòu,de",
  "优孟衣冠": "yōu,mèng,yī,guān",
  "优游自适": "yōu,yóu,zì,shì",
  "优秀地": "yōu,xiù,de",
  "优致地": "yōu,zhì,de",
  "优调": "yōu,diào",
  "优越地": "yōu,yuè,de",
  "优酪乳": "yōu,luò,rǔ",
  "优雅地": "yōu,yǎ,de",
  "伙子": "huǒ,zi",
  "伙种": "huǒ,zhòng",
  "伙计": "huǒ,ji",
  "会不断地": "huì,bù,duàn,de",
  "会不时地": "huì,bù,shí,de",
  "会不知不觉地": "huì,bù,zhī,bù,jué,de",
  "会不自觉地": "huì,bù,zì,jué,de",
  "会乖乖地": "huì,guāi,guāi,de",
  "会传染地": "huì,chuán,rǎn,de",
  "会儿": "huì,er",
  "会冒失地": "huì,mào,shī,de",
  "会准确地": "huì,zhǔn,què,de",
  "会凋零地": "huì,diāo,líng,de",
  "会哭的孩子有奶吃": "huì,kū,de,hái,zi,yǒu,nǎi,chī",
  "会哭的孩子有糖吃": "huì,kū,de,hái,zi,yǒu,táng,chī",
  "会大量地": "huì,dà,liàng,de",
  "会子": "huì,zi",
  "会得": "huì,de",
  "会心地一笑": "huì,xīn,de,yī,xiào",
  "会心地笑了": "huì,xīn,de,xiào,le",
  "会慢慢地": "huì,màn,màn,de",
  "会折": "huì,shé",
  "会晤地": "huì,wù,de",
  "会有留人处": "huì,yǒu,liú,rén,chǔ",
  "会永远地跟随着": "huì,yǒng,yuǎn,de,gēn,suí,zhe",
  "会深深地": "huì,shēn,shēn,de",
  "会稡": "huì,zú",
  "会稽": "kuài,jī",
  "会计": "kuài,jì",
  "会计准则理事会": "kuài,jì,zhǔn,zé,lǐ,shì,huì",
  "会计制度": "kuài,jì,zhì,dù",
  "会计学": "kuài,jì,xué",
  "会计师": "kuài,jì,shī",
  "会计科目": "kuài,jì,kē,mù",
  "会话地": "huì,huà,de",
  "会越来越多地": "huì,yuè,lái,yuè,duō,de",
  "会逐渐地": "huì,zhú,jiàn,de",
  "会逢其适": "huì,féng,qí,shì",
  "会逮": "huì,dǎi",
  "会长": "huì,zhǎng",
  "会长团": "huì,zhǎng,tuán",
  "会骄傲地": "huì,jiāo,ào,de",
  "会鼌": "huì,zhāo",
  "伛背": "yǔ,bèi",
  "伞橑": "sǎn,lǎo",
  "伞簳": "sǎn,gàn",
  "伞菌": "sǎn,jùn",
  "伟大地": "wěi,dà,de",
  "伟干": "wěi,gàn",
  "传为佳话": "chuán,wéi,jiā,huà",
  "传为笑柄": "chuán,wéi,xiào,bǐng",
  "传为笑谈": "chuán,wéi,xiào,tán",
  "传为美谈": "chuán,wéi,měi,tán",
  "传单炸弹": "chuán,dān,zhà,dàn",
  "传奇似地": "chuán,qí,shì,de",
  "传奇性地": "chuán,qí,xìng,de",
  "传帖": "chuán,tiē",
  "传染地": "chuán,rǎn,de",
  "传染性地": "chuán,rǎn,xìng,de",
  "传注": "zhuàn,zhù",
  "传热学": "zhuàn,rè,xué",
  "传略": "zhuàn,lüè",
  "传着": "chuán,zhe",
  "传统上地": "chuán,tǒng,shàng,de",
  "传统地": "chuán,tǒng,de",
  "传统逻辑": "chuán,tǒng,luó,ji",
  "传翫": "chuán,wàn",
  "传舍": "chuán,shè",
  "传记": "zhuàn,jì",
  "传记体地": "zhuàn,jì,tǐ,de",
  "传记片": "zhuàn,jì,piàn",
  "传讽": "chuán,fěng",
  "传说地": "chuán,shuō,de",
  "传赞": "zhuàn,zàn",
  "传载": "chuán,zǎi",
  "传道地": "chuán,dào,de",
  "传风扇火": "chuán,fēng,shān,huǒ",
  "伢子": "yá,zi",
  "伤剥": "shāng,bāo",
  "伤和气": "shāng,hé,qi",
  "伤害地": "shāng,hài,de",
  "伤心地": "shāng,xīn,de",
  "伤折": "shāng,shé",
  "伤痕累累": "shāng,hén,lěi,lěi",
  "伤言扎语": "shāng,yán,zhā,yǔ",
  "伤蹶": "shāng,juě",
  "伤面子": "shāng,miàn,zi",
  "伦侯": "lún,hòu",
  "伦理地": "lún,lǐ,de",
  "伧人": "chen,rén",
  "伧儜": "chen,níng",
  "伧儿": "chen,ér",
  "伧劣": "chen,liè",
  "伧夫": "chen,fū",
  "伧头": "chen,tóu",
  "伧奴": "chen,nú",
  "伧子": "chen,zǐ",
  "伧才": "chen,cái",
  "伧攘": "chen,rǎng",
  "伧楚": "chen,chǔ",
  "伧歌": "chen,gē",
  "伧气": "chen,qì",
  "伧父": "cāng,fǔ",
  "伧荒": "chen,huāng",
  "伧言": "chen,yán",
  "伧语": "chen,yǔ",
  "伧辈": "chen,bèi",
  "伧鄙": "chen,bǐ",
  "伧重": "chen,zhòng",
  "伧陋": "chen,lòu",
  "伧靡": "chen,mí",
  "伧鬼": "chen,guǐ",
  "伪君子": "wěi,jūn,zi",
  "伪善地": "wěi,shàn,de",
  "伪缪": "wěi,miù",
  "伪造地": "wěi,zào,de",
  "伫兴": "zhù,xīng",
  "伯乐相马": "bó,lè,xiàng,mǎ",
  "伯夫": "bǎi,fū",
  "伯子": "bǎi,zǐ",
  "伯气": "bà,qì",
  "伯莎": "bó,shā",
  "伯远帖": "bó,yuǎn,tiē",
  "伯都": "bó,dū",
  "伯颜": "bà,yán",
  "估衣": "gù,yī",
  "估量": "gū,liáng",
  "伴乐": "bàn,yuè",
  "伴随效应": "bàn,suí,xiào,yìng",
  "伴食宰相": "bàn,shí,zǎi,xiàng",
  "伶俐地": "líng,lì,de",
  "伸剖": "shēn,pōu",
  "伸卷": "shēn,juàn",
  "伸吭": "shēn,kēng",
  "伸愬": "shēn,shuò",
  "伸曲": "shēn,qū",
  "伸缩喇叭": "shēn,suō,lǎ,ba",
  "伸缩地": "shēn,suō,de",
  "伸舌头": "shēn,shé,tou",
  "伺侯": "cì,hòu",
  "伺便": "sì,biàn",
  "伺察": "sì,chá",
  "伺应": "sì,yīng",
  "伺晨": "sì,chén",
  "伺服": "sì,fú",
  "伺服器": "sì,fú,qì",
  "伺望": "sì,wàng",
  "伺机": "sì,jī",
  "伺漏": "sì,lòu",
  "伺瑕导𧏖": "sì,xiá,dǎo,pín",
  "伺瑕导隙": "sì,xiá,dǎo,xì",
  "伺瑕抵𧏖": "sì,xiá,dǐ,pín",
  "伺瑕抵隙": "sì,xiá,dǐ,xì",
  "伺窥": "sì,kuī",
  "伺舋": "sì,xìn",
  "伺衅": "sì,xìn",
  "伺觇": "sì,chān",
  "伺诈": "sì,zhà",
  "伺闲": "sì,xián",
  "伺隙": "sì,xì",
  "伺风乌": "sì,fēng,wū",
  "似合理地": "shì,hé,lǐ,de",
  "似地穿过": "shì,de,chuān,guò",
  "似妻地": "shì,qī,de",
  "似妻子地": "shì,qī,zǐ,de",
  "似旋涡地": "shì,xuán,wō,de",
  "似毒蛇地": "shì,dú,shé,de",
  "似玻璃地": "shì,bō,lí,de",
  "似的": "shì,de",
  "似真地": "shì,zhēn,de",
  "似露水地": "shì,lù,shuǐ,de",
  "似黄铜地": "shì,huáng,tóng,de",
  "伽伽": "qié,qié",
  "伽南香": "qié,nán,xiāng",
  "伽尼": "qié,ní",
  "伽梨": "qié,lí",
  "伽耶": "qié,yē",
  "伽荼": "qié,tú",
  "伽蓝": "qié,lán",
  "伽蓝神": "qié,lán,shén",
  "伽蓝香": "qié,lán,xiāng",
  "伽那": "qié,nà",
  "伽陀": "qié,tuó",
  "伽陀罗": "qié,tuó,luó",
  "伽马": "gā,mǎ",
  "伽马刀": "gā,mǎ,dāo",
  "伽马射线": "gā,mǎ,shè,xiàn",
  "佁儗": "chì,nǐ",
  "佃仆": "diàn,pú",
  "佃作": "tián,zuò",
  "佃具": "tián,jù",
  "佃器": "tián,qì",
  "佃渔": "tián,yú",
  "但我们不能简单地": "dàn,wǒ,men,bù,néng,jiǎn,dān,de",
  "但是却不时地": "dàn,shì,què,bù,shí,de",
  "佋侥": "zhāo,yáo",
  "位分": "wèi,fèn",
  "位子": "wèi,zi",
  "位着": "wèi,zhe",
  "位置": "wèi,zhi",
  "位置效应": "wèi,zhì,xiào,yìng",
  "低低切切": "dī,dī,qiè,qiè",
  "低佪": "dī,huái",
  "低劣地": "dī,liè,de",
  "低卬": "dī,áng",
  "低声地": "dī,shēng,de",
  "低声地哭": "dī,shēng,de,kū",
  "低声地讲": "dī,shēng,de,jiǎng",
  "低声地说": "dī,shēng,de,shuō",
  "低庳": "dī,bì",
  "低徊": "dī,huí",
  "低情曲意": "dī,qíng,qū,yì",
  "低折": "dī,shé",
  "低捋": "dī,lǚ",
  "低攲": "dī,jī",
  "低氧血": "dī,yǎng,xuè",
  "低沉地": "dī,chén,de",
  "低沉地说": "dī,chén,de,shuō",
  "低血压": "dī,xuè,yā",
  "低血糖": "dī,xuè,táng",
  "低调": "dī,diào",
  "低调地": "dī,diào,de",
  "低调照片": "dī,diào,zhào,piān",
  "低音喇叭": "dī,yīn,lǎ,ba",
  "住一宿": "zhù,yì,xiǔ",
  "住宅地": "zhù,zhái,de",
  "住扎": "zhù,zhā",
  "住着": "zhù,zhe",
  "住舍": "zhù,shè",
  "住蕃": "zhù,fān",
  "体外地": "tǐ,wài,de",
  "体己": "tī,jǐ",
  "体己人": "tī,ji,rén",
  "体己话": "tī,ji,huà",
  "体己钱": "tī,ji,qián",
  "体帖": "tǐ,tiē",
  "体干": "tǐ,gàn",
  "体查": "tǐ,zhā",
  "体育地": "tǐ,yù,de",
  "体胀系数": "tǐ,zhàng,xì,shù",
  "体视地": "tǐ,shì,de",
  "体调": "tǐ,diào",
  "体贴地": "tǐ,tiē,de",
  "体镜地": "tǐ,jìng,de",
  "体面地": "tǐ,miàn,de",
  "体鸣乐器": "tǐ,míng,yuè,qì",
  "何为": "hé,wéi",
  "何乐不为": "hé,lè,bù,wéi",
  "何乐而不为": "hé,lè,ér,bù,wéi",
  "何伺": "hé,sì",
  "何其衰也": "he,qi,ai,ye",
  "何在乎": "hé,zài,hu",
  "何处": "hé,chǔ",
  "何家地": "hé,jiā,de",
  "何应钦": "hé,yìng,qīn",
  "何得": "hé,de",
  "何德堪之": "he,de,kan,zi",
  "何所不为": "hé,suǒ,bù,wéi",
  "何曾": "hé,zēng",
  "何足为奇": "hé,zú,wéi,qí",
  "何适": "hé,shì",
  "佗乡": "tā,xiāng",
  "佗人": "tā,rén",
  "佗发": "tuō,fà",
  "佗方": "tā,fāng",
  "佗背": "tuó,bèi",
  "畲太君": "shé,tài,jūn",
  "余勇可贾": "yú,yǒng,kě,gǔ",
  "余响𰺷梁": "yú,xiǎng,rǎo,liáng",
  "余处": "yú,chǔ",
  "余小子": "yú,xiǎo,zi",
  "余懽": "yú,guàn",
  "余数": "yú,shù",
  "余数定理": "yú,shù,dìng,lǐ",
  "余留无符号数": "yú,liú,wú,fú,hào,shù",
  "余粖": "yú,mò",
  "佛刹": "fó,shā",
  "佛吉尼亚": "fú,jí,ní,yà",
  "佛头著粪": "fó,tóu,zhuó,fèn",
  "佛徒": "fú,tú",
  "佛戾": "fú,lì",
  "佛桑": "fú,sāng",
  "佛泥": "bó,ní",
  "佛洛斯特": "fú,luò,sī,tè",
  "佛牙舍利": "fó,yá,shè,lì",
  "佛狸": "bì,lí",
  "佛狸祠": "bì,lí,cí",
  "佛罗里达": "fú,luó,lǐ,dá",
  "佛肸": "bì,xī",
  "佛舍": "fó,shè",
  "佛舍利": "fó,shè,lì",
  "佛藏": "fó,zàng",
  "佛道": "fú,dào",
  "佛道艾": "fú,dào,ài",
  "佛郁": "fú,yù",
  "佛雷泽尔": "fú,léi,zé,ěr",
  "作为": "zuò,wéi",
  "作么": "zuò,mǒ",
  "作么朗": "zuò,mǒ,lǎng",
  "作么生": "zuò,mǒ,shēng",
  "作乐": "zuò,yuè",
  "作兴": "zuò,xīng",
  "作坊": "zuō,fāng",
  "作嫁衣裳": "zuò,jià,yī,shang",
  "作对地": "zuò,duì,de",
  "作弄": "zuō,nòng",
  "作得": "zuò,de",
  "作房": "zuō,fáng",
  "作数": "zuò,shù",
  "作料": "zuò,liao",
  "作歹为非": "zuò,dǎi,wéi,fēi",
  "作浪兴风": "zuò,làng,xīng,fēng",
  "作瘪子": "zuò,biě,zǐ",
  "作罫": "zuò,guà",
  "作翫": "zuò,wàn",
  "作舍道边": "zuò,shè,dào,biān",
  "作𰵤": "zuò,è",
  "作适": "zuò,shì",
  "作面子": "zuò,miàn,zi",
  "佝偻": "gōu,lóu",
  "佝偻病": "gōu,lóu,bìng",
  "佝偻着腰": "gōu,lóu,zhe,yāo",
  "佝瞀": "kòu,mào",
  "佞侻": "nìng,tuì",
  "你不断地": "nǐ,bù,duàn,de",
  "你个头": "nǐ,ge,tóu",
  "你乐意地": "nǐ,lè,yì,de",
  "你们": "nǐ,men",
  "你们俩": "nǐ,men,liǎ",
  "你们的": "nǐ,men,de",
  "你们自己": "nǐ,men,zì,jǐ",
  "你们自己的": "nǐ,men,zì,jǐ,de",
  "你会惊讶地发现": "nǐ,huì,jīng,yà,de,fā,xiàn",
  "你大大地": "nǐ,dà,dà,de",
  "你奇怪地": "nǐ,qí,guài,de",
  "你无私地": "nǐ,wú,sī,de",
  "你最好乖乖地": "nǐ,zuì,hǎo,guāi,guāi,de",
  "你看着办吧": "nǐ,kàn,zhe,bàn,ba",
  "你老子": "nǐ,lǎo,zi",
  "你要好好地": "nǐ,yāo,hǎo,hǎo,de",
  "你还是这样地": "nǐ,hái,shì,zhè,yàng,de",
  "佢们": "qú,men",
  "佣中佼佼": "yòng,zhōng,jiǎo,jiǎo",
  "佣仆": "yōng,pú",
  "佣畊": "yòng,gēng",
  "佣金": "yòng,jīn",
  "佣钱": "yòng,qián",
  "佥都御史": "qiān,dū,yù,shǐ",
  "佩觹": "pèi,wéi",
  "佪佪": "huái,huái",
  "佪挠": "huái,náo",
  "佪旋": "huái,xuán",
  "佪翔": "huái,xiáng",
  "佯为": "yáng,wéi",
  "佯背": "yáng,bèi",
  "佳丽酿": "jiā,lì,niáng",
  "佳人薄命": "jiā,rén,bó,mìng",
  "佳什": "jiā,shí",
  "佳兴": "jiā,xīng",
  "佳处": "jiā,chǔ",
  "佳妙地": "jiā,miào,de",
  "佴之蚕室": "er,zi,chan,shi",
  "佹得": "guǐ,de",
  "佻侻": "tiāo,tuì",
  "佻剽": "tiāo,piāo",
  "佻薄": "tiāo,bó",
  "使不着": "shǐ,bù,zháo",
  "使出浑身解数": "shǐ,chū,hún,shēn,xiè,shù",
  "使劲儿": "shǐ,jìn,er",
  "使劲地": "shǐ,jìn,de",
  "使劲地嚼": "shǐ,jìn,de,jué",
  "使劲地干": "shǐ,jìn,de,gàn",
  "使劲地打": "shǐ,jìn,de,dǎ",
  "使劲地摇头": "shǐ,jìn,de,yáo,tóu",
  "使劲地鼓掌": "shǐ,jìn,de,gǔ,zhǎng",
  "使命地": "shǐ,mìng,de",
  "使唤": "shǐ,huan",
  "使徒行传": "shǐ,tú,xíng,zhuàn",
  "使得": "shǐ,de",
  "使性子": "shǐ,xìng,zi",
  "使感动地": "shǐ,gǎn,dòng,de",
  "使无效地": "shǐ,wú,xiào,de",
  "使气地": "shǐ,qì,de",
  "使用数量": "shǐ,yòng,shù,liàng",
  "使窘迫地": "shǐ,jiǒng,pò,de",
  "使羊将狼": "shǐ,yáng,jiàng,láng",
  "使迷惑地": "shǐ,mí,huò,de",
  "使陷危地": "shǐ,xiàn,wēi,de",
  "使麻木地": "shǐ,má,mù,de",
  "侃然正色": "kan,ran,zheng,she",
  "侄儿": "zhí,er",
  "侄儿子": "zhí,ér,zi",
  "侄女儿": "zhí,nǚ,er",
  "侄媳妇": "zhí,xí,fu",
  "侄子": "zhí,zi",
  "侄少爷": "zhí,shào,yé",
  "侈弇": "chǐ,yān",
  "侉子": "kuǎ,zi",
  "例假": "lì,jià",
  "例如地": "lì,rú,de",
  "例子": "lì,zi",
  "例直禁简": "lì,zhí,jìn,jiǎn",
  "例禁": "lì,jìn",
  "例行差事": "lì,xíng,chāi,shì",
  "侍应": "shì,yìng",
  "侍应生": "shì,yìng,shēng",
  "侍禁": "shì,jìn",
  "侔色揣称": "móu,sè,chuǎi,chèn",
  "侗侗": "tǒng,tǒng",
  "侗长": "tǒng,cháng",
  "供不应求": "gōng,bù,yìng,qiú",
  "供人": "gōng,rén",
  "供体": "gōng,tǐ",
  "供大于求": "gōng,dà,yú,qiú",
  "供孩子上学": "gōng,hái,zi,shàng,xué",
  "供展览地": "gōng,zhǎn,lǎn,de",
  "供应": "gōng,yìng",
  "供应品": "gōng,yìng,pǐn",
  "供应商": "gōng,yìng,shāng",
  "供应地": "gōng,yìng,de",
  "供应室": "gōng,yìng,shì",
  "供应点": "gōng,yìng,diǎn",
  "供应站": "gōng,yìng,zhàn",
  "供应者": "gōng,yìng,zhě",
  "供应舰": "gōng,yìng,jiàn",
  "供应链": "gōng,yìng,liàn",
  "供房": "gōng,fáng",
  "供料": "gōng,liào",
  "供旅客休息": "gōng,lǚ,kè,xiū,xī",
  "供欣赏": "gōng,xīn,shǎng",
  "供气": "gōng,qì",
  "供水": "gōng,shuǐ",
  "供求": "gōng,qiú",
  "供求关系": "gōng,qiú,guān,xì",
  "供求率": "gōng,qiú,lǜ",
  "供油系统": "gōng,yóu,xì,tǒng",
  "供热": "gōng,rè",
  "供燃气": "gōng,rán,qì",
  "供电": "gōng,diàn",
  "供石": "gōng,shí",
  "供给": "gōng,jǐ",
  "供给制": "gōng,jǐ,zhì",
  "供血": "gōng,xuè",
  "供血者": "gōng,xuè,zhě",
  "供认不讳": "gòng,rèn,bú,huì",
  "供读者参考": "gōng,dú,zhě,cān,kǎo",
  "供货": "gōng,huò",
  "供货商": "gōng,huò,shāng",
  "供过于求": "gōng,guò,yú,qiú",
  "供销": "gōng,xiāo",
  "供销合作社": "gōng,xiāo,hé,zuò,shè",
  "供销商": "gōng,xiāo,shāng",
  "供销社": "gōng,xiāo,shè",
  "供需": "gōng,xū",
  "侜张为幻": "zhōu,zhāng,wéi,huàn",
  "依丱附木": "yī,kuàng,fù,mù",
  "依从地": "yī,cóng,de",
  "依依不舍地": "yī,yī,bù,shě,de",
  "依地语": "yī,de,yǔ",
  "依头缕当": "yī,tóu,lǚ,dàng",
  "依序地": "yī,xù,de",
  "依得": "yī,de",
  "依柔乞煞": "yī,róu,qǐ,shà",
  "依样画葫芦": "yī,yàng,huà,hú,lu",
  "依样葫芦": "yī,yàng,hú,lu",
  "依次地": "yī,cì,de",
  "依法炮制": "yī,fǎ,páo,zhì",
  "依着": "yī,zhe",
  "依职权地": "yī,zhí,quán,de",
  "依芘": "yī,pí",
  "依葫芦画瓢": "yī,hú,lu,huà,piáo",
  "依阿": "yī,ē",
  "依阿取容": "yī,ē,qǔ,róng",
  "侟绅": "jiàn,shēn",
  "侠毂": "xiá,gū",
  "侥会": "yáo,huì",
  "侥傒": "yáo,xī",
  "侥僺": "yáo,qiào",
  "侥冀": "yáo,jì",
  "侥冒": "yáo,mào",
  "侥利": "yáo,lì",
  "侥取": "yáo,qǔ",
  "侥奇": "yáo,qí",
  "侥幸地": "jiǎo,xìng,de",
  "侥忝": "yáo,tiǎn",
  "侥望": "yáo,wàng",
  "侥求": "yáo,qiú",
  "侥滥": "yáo,làn",
  "侥灵": "yáo,líng",
  "侥竞": "yáo,jìng",
  "侥薄": "yáo,báo",
  "侥觊": "yáo,jì",
  "侥觎": "yáo,yú",
  "侥躐": "yáo,liè",
  "侥速": "yáo,sù",
  "侦伺": "zhēn,sì",
  "侧向地": "cè,xiàng,de",
  "侧商调": "cè,shāng,diào",
  "侧弁": "zè,biàn",
  "侧棱": "zhāi,léng",
  "侧歪": "zhāi,wāi",
  "侧背": "cè,bèi",
  "侧调": "cè,diào",
  "侧跌": "cè,diē",
  "侧载": "cè,zǎi",
  "侧面地": "cè,miàn,de",
  "侨处": "qiáo,chǔ",
  "侮折": "wǔ,shé",
  "侮翫": "wǔ,wàn",
  "侮谩": "wǔ,màn",
  "侮辱地": "wǔ,rǔ,de",
  "侯不": "hòu,bù",
  "侯伏侯": "hòu,fú,hòu",
  "侯伯": "hòu,bó",
  "侯冈": "hòu,gāng",
  "侯刚": "hòu,gāng",
  "侯卫": "hòu,wèi",
  "侯印": "hòu,yìn",
  "侯史": "hòu,shǐ",
  "侯吕陵": "hòu,lǚ,líng",
  "侯国": "hòu,guó",
  "侯圻": "hòu,qí",
  "侯头": "hòu,tóu",
  "侯家": "hòu,jiā",
  "侯封": "hòu,fēng",
  "侯度": "hòu,dù",
  "侯弓": "hòu,gōng",
  "侯氏": "hòu,shì",
  "侯波": "hòu,bō",
  "侯牏": "hòu,yú",
  "侯牧": "hòu,mù",
  "侯王": "hòu,wáng",
  "侯甸": "hòu,diàn",
  "侯畿": "hòu,jī",
  "侯白": "hòu,bái",
  "侯社": "hòu,shè",
  "侯禳": "hòu,ráng",
  "侯籍": "hòu,jí",
  "侯者": "hòu,zhě",
  "侯莫陈": "hòu,mò,chén",
  "侯道": "hòu,dào",
  "侯鲭": "hòu,qīng",
  "侯龟": "hòu,guī",
  "侵入地": "qīn,rù,de",
  "侵削": "qīn,xuē",
  "侵剥": "qīn,bāo",
  "侵权行为": "qīn,quán,xíng,wéi",
  "侵牟": "qīn,mù",
  "侵略地": "qīn,lüè,de",
  "侵蚀地": "qīn,shí,de",
  "侵轧": "qīn,zhá",
  "侻失": "tuì,shī",
  "侻陋": "tuì,lòu",
  "侻顺": "tuō,shùn",
  "便了": "biàn,liǎo",
  "便佞": "pián,nìng",
  "便利地": "biàn,lì,de",
  "便固执地": "biàn,gù,zhí,de",
  "便嬖": "pián,bì",
  "便嬛": "pián,xuān",
  "便宜": "pián,yi",
  "便宜地": "pián,yí,de",
  "便宜货": "pián,yí,huò",
  "便悄悄地": "biàn,qiāo,qiāo,de",
  "便把令来行": "biàn,bǎ,lìng,lái,xí",
  "便捷地": "biàn,jié,de",
  "便旋": "pián,xuán",
  "便果断地": "biàn,guǒ,duàn,de",
  "便溺": "biàn,niào",
  "便章": "pián,zhāng",
  "便蕃": "biàn,fān",
  "便血": "biàn,xuè",
  "便言": "pián,yán",
  "便还就孤": "bian,huan,jiu,gu",
  "便难": "biàn,nàn",
  "便飞快地": "biàn,fēi,kuài,de",
  "促数": "cù,shù",
  "促调": "cù,diào",
  "促载": "cù,zǎi",
  "俊俏地": "jùn,qiào,de",
  "俊鹘": "jùn,hú",
  "俏头": "qiào,tou",
  "俏成俏败": "xiào,chéng,xiào,bài",
  "俏样子": "qiào,yàng,zi",
  "俏皮地": "qiào,pí,de",
  "俐落地": "lì,luò,de",
  "俗丽地": "sú,lì,de",
  "俗乐": "sú,yuè",
  "俗气地": "sú,qì,de",
  "俗累": "sú,lèi",
  "俗调": "sú,diào",
  "俘掠": "fú,lüě",
  "俘累": "fú,lèi",
  "俛临": "miǎn,lín",
  "俛伏": "miǎn,fú",
  "俛偻": "miǎn,lǚ",
  "俛僶": "miǎn,mǐn",
  "俛卬": "miǎn,áng",
  "俛啄": "miǎn,zhuó",
  "俛容": "miǎn,róng",
  "俛就": "miǎn,jiù",
  "俛然": "miǎn,rán",
  "俛眄": "miǎn,miǎn",
  "俛眉": "miǎn,méi",
  "俛视": "miǎn,shì",
  "俛诎": "miǎn,qū",
  "俛起": "miǎn,qǐ",
  "俛附": "miǎn,fù",
  "俛首帖耳": "fǔ,shǒu,tiē,ěr",
  "俛默": "miǎn,mò",
  "保不住": "bǎo,bú,zhù",
  "保守地": "bǎo,shǒu,de",
  "保守地说": "bǎo,shǒu,de,shuō",
  "保安局局长": "bǎo,ān,jú,jú,zhǎng",
  "保得住": "bǎo,de,zhù",
  "保得定": "bǎo,de,dìng",
  "保扞": "bǎo,gǎn",
  "保持曲线": "bǎo,chí,qū,xiàn",
  "保揣": "bǎo,chuāi",
  "保泰持盈": "bǎo,tài,chì,yíng",
  "保浇地": "bǎo,jiāo,de",
  "保盈持泰": "bǎo,yíng,chì,tài",
  "保角对应": "bǎo,jiǎo,duì,yìng",
  "保证地": "bǎo,zhèng,de",
  "保长": "bǎo,zhǎng",
  "保长对应": "bǎo,cháng,duì,yìng",
  "保险箱地": "bǎo,xiǎn,xiāng,de",
  "保险系数": "bǎo,xiǎn,xì,shù",
  "俞柎": "yú,fù",
  "俞穴": "shù,xué",
  "信人调": "xìn,rén,diào",
  "信以为真": "xìn,yǐ,wéi,zhēn",
  "信仰地": "xìn,yǎng,de",
  "信任地": "xìn,rèn,de",
  "信号处理": "xìn,hào,chǔ,lǐ",
  "信号弹": "xìn,hào,dàn",
  "信差": "xìn,chāi",
  "信得及": "xìn,de,jí",
  "信息灵通": "xìn,xi,líng,tōng",
  "信数": "xìn,shù",
  "信服地": "xìn,fú,de",
  "信皮儿": "xìn,pí,er",
  "信眉": "shēn,méi",
  "信而好古": "xìn,ér,hào,gǔ",
  "信赖地": "xìn,lài,de",
  "俩人": "liǎ,rén",
  "俩钱": "liǎ,qián",
  "俩钱儿": "liǎ,qián,er",
  "俭不中礼": "jiǎn,bù,zhòng,lǐ",
  "俭朴地": "jiǎn,pǔ,de",
  "俭省地": "jiǎn,shěng,de",
  "俭薄": "jiǎn,bó",
  "修为": "xiū,wéi",
  "修𠡠": "xiū,lài",
  "修指甲": "xiū,zhǐ,jia",
  "修省": "xiū,xǐng",
  "修禁": "xiū,jìn",
  "修絜": "xiū,jié",
  "修补地": "xiū,bǔ,de",
  "修道士地": "xiū,dào,shì,de",
  "修道院地": "xiū,dào,yuàn,de",
  "修郄": "xiū,xì",
  "修饰地": "xiū,shì,de",
  "俯帖": "fǔ,tiē",
  "俯首帖耳": "fǔ,shǒu,tiē,ěr",
  "俱舍宗": "jù,shè,zōng",
  "俳佪": "pái,huái",
  "俳调": "pái,diào",
  "俵着": "biào,zhe",
  "俶傥": "tì,tǎng",
  "俶载": "chù,zǎi",
  "俸帖": "fèng,tiē",
  "俸给": "fèng,jǐ",
  "俺们": "ǎn,men",
  "俾使": "bǐ,shǐ",
  "俾倪": "bǐ,ní",
  "俾利": "bǐ,lì",
  "俾夜作昼": "bǐ,yè,zuò,zhòu",
  "俾斯麦": "bǐ,sī,mài",
  "俾昼作夜": "bǐ,zhòu,zuò,yè",
  "俾格米": "bǐ,gé,mǐ",
  "俾路支": "bǐ,lù,zhī",
  "俾路支省": "bǐ,lù,zhī,shěng",
  "倍儿": "bèi,er",
  "倍儿棒": "bèi,er,bàng",
  "倍处": "bèi,chǔ",
  "倍数": "bèi,shù",
  "倍称": "bèi,chèn",
  "倍讽": "bèi,fěng",
  "倏地一下": "shū,de,yī,xià",
  "倏地飞": "shū,de,fēi",
  "倒不": "dào,bù",
  "倒不是": "dào,bú,shì",
  "倒不错": "dào,bú,cuò",
  "倒也": "dào,yě",
  "倒产": "dào,chǎn",
  "倒位": "dào,wèi",
  "倒像": "dào,xiàng",
  "倒儿爷": "dǎo,er,yé",
  "倒写": "dào,xiě",
  "倒冠落佩": "dǎo,guān,luò,pèi",
  "倒出": "dào,chū",
  "倒出去": "dào,chū,qù",
  "倒出来": "dào,chū,lái",
  "倒刺": "dào,cì",
  "倒剪": "dào,jiǎn",
  "倒卖违禁品": "dǎo,mài,wéi,jìn,pǐn",
  "倒卵形": "dào,luǎn,xíng",
  "倒卷": "dào,juǎn",
  "倒叙": "dào,xù",
  "倒口子": "dǎo,kǒu,zi",
  "倒吊": "dào,diào",
  "倒吊蜡烛": "dào,diào,là,zhú",
  "倒向": "dào,xiàng",
  "倒吸一口凉气": "dào,xī,yī,kǒu,liáng,qì",
  "倒嚼": "dǎo,jiào",
  "倒因为果": "dǎo,yīn,wéi,guǒ",
  "倒圈": "dǎo,juàn",
  "倒垃圾": "dào,lā,jī",
  "倒头便睡": "dào,tóu,biàn,shuì",
  "倒好": "dào,hǎo",
  "倒屣相迎": "dào,xǐ,xiāng,yíng",
  "倒带": "dào,dài",
  "倒带键": "dào,dài,jiàn",
  "倒序词典": "dào,xù,cí,diǎn",
  "倒座儿": "dào,zuò,er",
  "倒开": "dào,kāi",
  "倒彩": "dào,cǎi",
  "倒彩声": "dào,cǎi,shēng",
  "倒影": "dào,yǐng",
  "倒悬": "dào,xuán",
  "倒悬之危": "dào,xuán,zhī,wēi",
  "倒悬之急": "dào,xuán,zhī,jí",
  "倒悬之苦": "dào,xuán,zhī,kǔ",
  "倒憋气": "dào,biē,qì",
  "倒打一瓦": "dào,dǎ,yī,wǎ",
  "倒打一耙": "dào,dǎ,yī,pá",
  "倒扣": "dào,kòu",
  "倒抽一口冷气": "dào,chōu,yì,kǒu,lěng,qì",
  "倒抽一口气": "dào,chōu,yī,kǒu,qì",
  "倒拽": "dào,zhuāi",
  "倒持": "dào,chí",
  "倒持泰阿": "dào,chí,tài,ē",
  "倒挂": "dào,guà",
  "倒挂子": "dào,guà,zǐ",
  "倒挂金钟": "dào,guà,jīn,zhōng",
  "倒挂雀": "dào,guà,què",
  "倒接": "dào,jiē",
  "倒插": "dào,chā",
  "倒插笔": "dào,chā,bǐ",
  "倒插门": "dào,chā,mén",
  "倒收付息": "dào,shōu,fù,xī",
  "倒放": "dào,fàng",
  "倒数": "dào,shǔ",
  "倒数式": "dào,shù,shì",
  "倒数方程": "dào,shǔ,fāng,chéng",
  "倒数比": "dào,shù,bǐ",
  "倒数计时": "dào,shǔ,jì,shí",
  "倒施": "dào,shī",
  "倒时差": "dǎo,shí,chā",
  "倒映": "dào,yìng",
  "倒果为因": "dào,guǒ,wéi,yīn",
  "倒栽地": "dào,zāi,de",
  "倒栽葱地": "dǎo,zāi,cōng,de",
  "倒档": "dào,dàng",
  "倒欠": "dào,qiàn",
  "倒水": "dào,shuǐ",
  "倒流": "dào,liú",
  "倒流儿": "dào,liú,ér",
  "倒灌": "dào,guàn",
  "倒烟": "dào,yān",
  "倒片": "dào,piàn",
  "倒片机": "dào,piàn,jī",
  "倒牌子": "dǎo,pái,zi",
  "倒相": "dào,xiàng",
  "倒着": "dào,zhe",
  "倒睫": "dào,jié",
  "倒空": "dào,kōng",
  "倒立": "dào,lì",
  "倒立像": "dào,lì,xiàng",
  "倒竖": "dào,shù",
  "倒粪": "dào,fèn",
  "倒绷孩儿": "dào,bēng,hái,ér",
  "倒置": "dào,zhì",
  "倒置地": "dào,zhì,de",
  "倒置干戈": "dào,zhì,gān,gē",
  "倒背如流": "dào,bèi,rú,liú",
  "倒背手": "dào,bèi,shǒu",
  "倒背手儿": "dào,bèi,shǒu,er",
  "倒脉冲": "dào,mài,chōng",
  "倒苦水": "dào,kǔ,shuǐ",
  "倒茶": "dào,chá",
  "倒虹吸管": "dào,hóng,xī,guǎn",
  "倒血霉": "dǎo,xuè,méi",
  "倒行逆施": "dào,xíng,nì,shī",
  "倒装": "dào,zhuāng",
  "倒装句": "dào,zhuāng,jù",
  "倒装词序": "dào,zhuāng,cí,xù",
  "倒装门": "dào,zhuāng,mén",
  "倒裳索领": "dào,cháng,suǒ,lǐng",
  "倒褪": "dǎo,tùn",
  "倒计时": "dào,jì,shí",
  "倒许": "dào,xǔ",
  "倒读数": "dào,dú,shù",
  "倒贴": "dào,tiē",
  "倒赔": "dào,péi",
  "倒跌": "dǎo,diē",
  "倒踏门": "dào,tà,mén",
  "倒车": "dào,chē",
  "倒车挡": "dào,chē,dǎng",
  "倒转": "dào,zhuǎn",
  "倒转地": "dào,zhuǎn,de",
  "倒转来说": "dào,zhuǎn,lái,shuō",
  "倒轮闸": "dào,lún,zhá",
  "倒载干戈": "dào,zài,gān,gē",
  "倒过儿": "dào,guò,ér",
  "倒过去": "dào,guò,qù",
  "倒过来": "dào,guò,lái",
  "倒退": "dào,tuì",
  "倒退一步": "dào,tuì,yí,bù",
  "倒酒": "dào,jiǔ",
  "倒采": "dào,cǎi",
  "倒金字塔": "dào,jīn,zì,tǎ",
  "倒钩": "dào,gōu",
  "倒锁": "dào,suǒ",
  "倒锁上门": "dào,suǒ,shàng,mén",
  "倒霉地": "dǎo,méi,de",
  "倒霉蛋儿": "dǎo,méi,dàn,er",
  "倒风": "dào,fēng",
  "倒飞": "dào,fēi",
  "倔傀": "juè,guī",
  "倔头": "juè,tou",
  "倔头倔脑": "juè,tou,juè,nǎo",
  "倔头强脑": "juè,tóu,jiàng,nǎo",
  "倔强": "jué,jiàng",
  "倔强倨傲": "jué,jiàng,jù,ào",
  "倔强地": "jué,jiàng,de",
  "倘佯": "cháng,yáng",
  "候伺": "hòu,sì",
  "候舍": "hòu,shè",
  "候骑": "hòu,jì",
  "倚倚𰇣𰇣": "yǐ,yǐ,xì,xì",
  "倚儿不当": "yǐ,ér,bù,dàng",
  "倚槛": "yǐ,kǎn",
  "倚此为命": "yǐ,cǐ,wéi,mìng",
  "倚着": "yǐ,zhe",
  "倚门倚闾": "yǐ,mén,yǐ,lǚ",
  "倜侏": "zhōu,zhū",
  "倜倡": "zhōu,chàng",
  "借单儿": "jiè,dān,er",
  "借古讽今": "jiè,gǔ,fěng,jīn",
  "借字儿": "jiè,zì,er",
  "借尸还阳": "jiè,shī,huán,yáng",
  "借尸还魂": "jiè,shī,huán,hún",
  "借方差额": "jiè,fāng,chā,é",
  "借翫": "jiè,wàn",
  "借调": "jiè,diào",
  "借𰷞": "jiè,tè",
  "借面吊丧": "jiè,miàn,diào,sāng",
  "倡条": "chāng,tiáo",
  "倡条冶叶": "chāng,tiáo,yě,yè",
  "倡狂": "chāng,kuáng",
  "倡而不和": "chàng,ér,bù,hè",
  "倡𬣱": "chàng,zhòu",
  "倥侗": "kōng,tóng",
  "倥偬": "kǒng,zǒng",
  "倦怠地": "juàn,dài,de",
  "倦鸟知还": "juàn,niǎo,zhī,huán",
  "倨慠": "jù,ào",
  "倨骜": "jù,ào",
  "倩浰": "qiàn,liàn",
  "倪露": "ní,lù",
  "倭傀": "wō,guī",
  "倭黑猩猩": "wō,hēi,xīng,xing",
  "倮露": "luǒ,lù",
  "倰僜": "lèng,dēng",
  "债务重组": "zhài,wù,chóng,zǔ",
  "债各有主": "zhai,gè,yǒu,zhǔ",
  "值不当": "zhí,bù,dàng",
  "值当": "zhí,dàng",
  "值得": "zhí,de",
  "值得一提": "zhí,dé,yì,tí",
  "值得信赖": "zhí,de,xìn,lài",
  "值得品味": "zhí,de,pǐn,wèi",
  "值得敬佩": "zhí,de,jìng,pèi",
  "值得注意": "zhí,de,zhù,yì",
  "值得称赞": "zhí,de,chēng,zàn",
  "值更": "zhí,gēng",
  "倾仆": "qīng,pú",
  "倾折": "qīng,shé",
  "倾斜地": "qīng,xié,de",
  "倾筐倒庋": "qīng,kuāng,dào,guǐ",
  "倾筐倒箧": "qīng,kuāng,dào,qiè",
  "倾箱倒箧": "qīng,xiāng,dào,qiè",
  "倾肠倒肚": "qīng,cháng,dào,dǔ",
  "倾背": "qīng,bèi",
  "倾褚": "qīng,chǔ",
  "倾角地": "qīng,jiǎo,de",
  "倾跌": "qīng,diē",
  "倾银铺": "qīng,yín,pù",
  "倾阤": "qīng,yǐ",
  "偃仆": "yǎn,pú",
  "偃佒": "yǎn,yāng",
  "偃俛": "yǎn,miǎn",
  "偃帖": "yǎn,tiē",
  "偃折": "yǎn,shé",
  "偃旗仆鼓": "yǎn,qí,pú,gǔ",
  "偃武兴文": "yǎn,wǔ,xīng,wén",
  "偃革为轩": "yǎn,gé,wéi,xuān",
  "假假地": "jiǎ,jiǎ,de",
  "假分数": "jiǎ,fēn,shù",
  "假别": "jià,bié",
  "假发": "jiǎ,fà",
  "假嗓子": "jiǎ,sǎng,zi",
  "假定地": "jiǎ,deng,de",
  "假小子": "jiǎ,xiǎo,zi",
  "假惺惺地说": "jiǎ,xīng,xīng,de,shuō",
  "假招子": "jiǎ,zhāo,zi",
  "假撇欠": "jiǎ,piě,qiàn",
  "假日": "jià,rì",
  "假日经济": "jià,rì,jīng,jì",
  "假期": "jià,qī",
  "假条": "jià,tiáo",
  "假正经地": "jiǎ,zhèng,jīng,de",
  "假洋鬼子": "jiǎ,yáng,guǐ,zi",
  "假相国": "jiǎ,xiàng,guó",
  "假笑地": "jiǎ,xiào,de",
  "假腥腥地": "jiǎ,xīng,xīng,de",
  "假节侯": "jiǎ,jié,hòu",
  "假装地": "jiǎ,zhuāng,de",
  "假设地": "jiǎ,shè,de",
  "假𰷞": "jiǎ,tè",
  "偈偈": "jié,jié",
  "偏为": "piān,wéi",
  "偏侯": "piān,hòu",
  "偏僻地": "piān,pì,de",
  "偏将": "piān,jiàng",
  "偏巧地": "piān,qiǎo,de",
  "偏差": "piān,chā",
  "偏差距离": "piān,chā,jù,lí",
  "偏得": "piān,de",
  "偏心地": "piān,xīn,de",
  "偏心眼儿": "piān,xīn,yǎn,er",
  "偏担儿难挨": "piān,dān,ér,nán,ái",
  "偏拗": "piān,niù",
  "偏柎": "piān,fù",
  "偏爱地": "piān,ài,de",
  "偏累": "piān,lèi",
  "偏缝": "piān,fèng",
  "偏背": "piān,bèi",
  "偏袒地": "piān,tǎn,de",
  "偏裼": "piān,tì",
  "偏载": "piān,zǎi",
  "偏𬮴": "piān,ān",
  "偏露": "piān,lù",
  "偕适": "xié,shì",
  "做一路": "zuò,yí,lù",
  "做不是的": "zuò,bú,shì,de",
  "做为": "zuò,wéi",
  "做什": "zuò,shí",
  "做什么": "zuò,shí,mǒ",
  "做伴儿": "zuò,bàn,er",
  "做作": "zuò,zuo",
  "做作地": "zuò,zuò,de",
  "做作地说": "zuò,zuò,de,shuō",
  "做功夫": "zuò,gōng,fu",
  "做厅长": "zuò,tīng,zhǎng",
  "做嗄": "zuò,á",
  "做处": "zuò,chǔ",
  "做头发": "zuò,tóu,fà",
  "做工夫": "zuò,gōng,fu",
  "做木头": "zuò,mù,tou",
  "做模样": "zuò,mú,yàng",
  "做法人地": "zuò,fǎ,rén,de",
  "做活儿": "zuò,huó,er",
  "做私商勾当": "zuò,sī,shāng,gòu,dàng",
  "做脚色": "zuò,jué,sè",
  "停不停地": "tíng,bù,tíng,de",
  "停妻娶妻": "tíng,qì,qǔ,qī",
  "停当": "tíng,dàng",
  "停滞地": "tíng,zhì,de",
  "停潦": "tíng,liáo",
  "停留长智": "tíng,liú,zhǎng,zhì",
  "停着": "tíng,zhe",
  "停车位置": "tíng,chē,wèi,zhi",
  "偞卑": "yè,bēi",
  "健仆": "jiàn,pú",
  "健全地": "jiàn,quán,de",
  "健壮地": "jiàn,zhuàng,de",
  "健将": "jiàn,jiàng",
  "健康地": "jiàn,kāng,de",
  "健康地发展": "jiàn,kāng,de,fā,zhǎn",
  "健康地成长": "jiàn,kāng,de,chéng,zhǎng",
  "健康地活着": "jiàn,kāng,de,huó,zhe",
  "健忘地": "jiàn,wàng,de",
  "健鹘": "jiàn,hú",
  "偪剥": "bī,bāo",
  "偭背": "miǎn,bèi",
  "偶一为之": "ǒu,yī,wéi,zhī",
  "偶像包袱": "ǒu,xiàng,bāo,fu",
  "偶函数": "ǒu,hán,shù",
  "偶发地": "ǒu,fā,de",
  "偶尔地": "ǒu,ěr,de",
  "偶数": "ǒu,shù",
  "偶然地": "ǒu,rán,de",
  "偶联反应": "ǒu,lián,fǎn,yìng",
  "偷偷地": "tōu,tōu,de",
  "偷偷地做": "tōu,tōu,de,zuò",
  "偷偷地到处瞧": "tōu,tōu,de,dào,chù,qiáo",
  "偷偷地哭": "tōu,tōu,de,kū",
  "偷偷地将": "tōu,tōu,de,jiāng",
  "偷偷地收集": "tōu,tōu,de,shōu,jí",
  "偷偷地溜了出来": "tōu,tōu,de,liū,le,chū,lái",
  "偷偷地看": "tōu,tōu,de,kàn",
  "偷偷地离开": "tōu,tōu,de,lí,kāi",
  "偷偷地笑": "tōu,tōu,de,xiào",
  "偷偷地笑了": "tōu,tōu,de,xiào,le",
  "偷偷地走": "tōu,tōu,de,zǒu",
  "偷偷摸摸地走": "tōu,tōu,mō,mō,de,zǒu",
  "偷嫷": "tōu,duò",
  "偷懒地": "tōu,lǎn,de",
  "偷汉子": "tōu,hàn,zi",
  "偷空": "tōu,kòng",
  "偷窃癖地": "tōu,qiè,pǐ,de",
  "偷鸡不着": "tōu,jī,bù,zháo",
  "偷鸡不着蚀把米": "tōu,jī,bù,zhe,shí,bǎ,mǐ",
  "偻㑩": "lóu,luo",
  "偻啰": "lóu,luō",
  "偻数": "lǚ,shù",
  "偻背": "lǚ,bèi",
  "偾仆": "fèn,pú",
  "偾兴": "fèn,xīng",
  "偾蹶": "fèn,juě",
  "偿还": "cháng,huán",
  "傀伟": "guī,wěi",
  "傀俄": "guī,é",
  "傀卓": "guī,zhuó",
  "傀垒": "guī,lěi",
  "傀奇": "guī,qí",
  "傀异": "guī,yì",
  "傀怪": "guī,guài",
  "傀民": "guī,mín",
  "傀然": "guī,rán",
  "傅予": "fù,yǔ",
  "傅着": "fù,zhe",
  "傋霿": "gòu,méng",
  "傍偟": "páng,huáng",
  "傍傍": "páng,páng",
  "傍家儿": "bàng,jiā,er",
  "傍州": "páng,zhōu",
  "傍州例": "páng,zhōu,lì",
  "傍戟": "páng,jǐ",
  "傍舍": "bàng,shè",
  "傍若无人": "páng,ruò,wú,rén",
  "傍角儿": "bàng,jué,ér",
  "傔仆": "qiàn,pú",
  "傥阆": "tǎng,láng",
  "傧相": "bīn,xiàng",
  "傧背": "bīn,bèi",
  "储蓄银行": "chǔ,xù,yín,háng",
  "储蕃": "chǔ,fān",
  "𫢺酢": "cān,cù",
  "催化地": "cuī,huà,de",
  "催吐": "cuī,tù",
  "催更": "cuī,gēng",
  "催泪弹": "cuī,lèi,dàn",
  "催泪炸弹": "cuī,lèi,zhà,dàn",
  "催眠地": "cuī,mián,de",
  "催逼地": "cuī,bī,de",
  "傲不可长": "ào,bù,kě,zhǎng",
  "傲兀": "ào,wū",
  "傲慢地": "ào,màn,de",
  "傲撇": "ào,piě",
  "傲然地": "ào,rán,de",
  "傲睨一切": "ào,nì,yī,qiè",
  "傻傻地": "shǎ,shǎ,de",
  "傻劲儿": "shǎ,jìn,er",
  "傻呆呆地": "shǎ,dāi,dāi,de",
  "傻呵呵地": "shǎ,hē,hē,de",
  "傻地": "shǎ,de",
  "傻大个儿": "shǎ,dà,gè,er",
  "傻子": "shǎ,zi",
  "傻小子": "shǎ,xiǎo,zi",
  "傻帽儿": "shǎ,mào,er",
  "傻楞楞": "shǎ,lèng,lèng",
  "傻瓜相机": "shǎ,guā,xiàng,jī",
  "傻眉楞眼": "shǎ,méi,lèng,yǎn",
  "傻笑地": "shǎ,xiào,de",
  "傻里傻气": "shǎ,li,shǎ,qì",
  "𫢪子": "lián,zǐ",
  "僋佄": "tàn,hān",
  "僋俕": "tàn,sàn",
  "像人地": "xiàng,rén,de",
  "像夹": "xiàng,jiā",
  "像差": "xiàng,chā",
  "像帝王地": "xiàng,de,wáng,de",
  "像幻影地": "xiàng,huàn,yǐng,de",
  "像心适意": "xiàng,xīn,shì,yì",
  "像煞": "xiàng,shà",
  "像煞有介事": "xiàng,shà,yǒu,jiè,shì",
  "像蔷薇地": "xiàng,qiáng,wēi,de",
  "像软木地": "xiàng,ruǎn,mù,de",
  "像软片地": "xiàng,ruǎn,piàn,de",
  "像那么回事儿": "xiàng,nà,me,huí,shì,er",
  "像骑士地": "xiàng,qí,shì,de",
  "𰂜𰂜": "tuí,tuí",
  "僚仆": "liáo,pú",
  "僦舍": "jiù,shè",
  "僦载": "jiù,zǎi",
  "僧伽": "sēng,qié",
  "僧伽梨": "sēng,qié,lí",
  "僧伽蓝": "sēng,qié,lán",
  "僧侣地": "sēng,lǚ,de",
  "僧刹": "sēng,shā",
  "僧祇": "sēng,qí",
  "僧祇户": "sēng,qí,hù",
  "僧祇支": "sēng,qí,zhī",
  "僧祇粟": "sēng,qí,sù",
  "僧祇谷": "sēng,qí,gǔ",
  "僧舍": "sēng,shè",
  "僬侥": "jiāo,yáo",
  "僭忒": "jiàn,tuī",
  "僭越地": "jiàn,yuè,de",
  "僮仆": "tóng,pú",
  "僮干": "tóng,gàn",
  "僮族": "zhuàng,zú",
  "僵尸粉": "jiāng,shǐ,fěn",
  "僵硬地": "jiāng,yìng,de",
  "僶俛": "mǐn,miǎn",
  "僻处": "pì,chǔ",
  "儆省": "jǐng,xǐng",
  "儋石之储": "dàn,shí,zhī,chǔ",
  "儒将": "rú,jiàng",
  "儿啼帖": "ér,tí,tiē",
  "儿女亲家": "ér,nǚ,qìng,jiā",
  "儿女成行": "ér,nǚ,chéng,háng",
  "儿女英雄传": "ér,nǚ,yīng,xióng,zhuàn",
  "儿媳妇": "ér,xí,fu",
  "儿子": "ér,zi",
  "儿子气": "ér,zi,qì",
  "儿童片": "ér,tóng,piān",
  "兀兀": "wū,wū",
  "兀兀淘淘": "wū,wū,táo,táo",
  "兀兀腾腾": "wū,wū,téng,téng",
  "兀兀陶陶": "wū,wū,táo,táo",
  "兀剌": "wū,là",
  "兀剌赤": "wū,là,chì",
  "兀卒": "wū,zú",
  "兀地奴": "wū,dì,nú",
  "兀奡": "wū,ào",
  "兀子": "wū,zǐ",
  "兀尔": "wū,ěr",
  "兀岸": "wū,àn",
  "兀底": "wū,dǐ",
  "兀底律": "wū,dǐ,lǜ",
  "兀得": "wū,de",
  "兀斜": "wū,xié",
  "兀日": "wū,rì",
  "兀楞楞": "wū,lèng,lèng",
  "兀硉": "wū,lù",
  "兀秃": "wū,tū",
  "兀者": "wū,zhě",
  "兀良": "wū,liáng",
  "兀谁": "wū,shuí",
  "兀赤": "wū,chì",
  "兀那": "wū,nà",
  "兀颜": "wū,yán",
  "兀首": "wū,shǒu",
  "允帖": "yǔn,tiē",
  "允当": "yǔn,dàng",
  "允着": "yǔn,zhe",
  "元侯": "yuán,hòu",
  "元好问": "yuán,hào,wèn",
  "元数据": "yuán,shù,jù",
  "元𰺷": "yuán,rǎo",
  "元长史": "yuán,zhǎng,shǐ",
  "兄弟似地": "xiōng,de,shì,de",
  "兄弟般地": "xiōng,de,bān,de",
  "兄长": "xiōng,zhǎng",
  "充份地": "chōng,fèn,de",
  "充军地": "chōng,jūn,de",
  "充分": "chōng,fèn",
  "充分又必要条件": "chōng,fèn,yòu,bì,yào,tiáo,jiàn",
  "充分地": "chōng,fèn,de",
  "充分地反映": "chōng,fèn,de,fǎn,yìng",
  "充分就业": "chōng,fèn,jiù,yè",
  "充分考虑": "chōng,fèn,kǎo,lǜ",
  "充咽": "chōng,yān",
  "充塞": "chōng,sè",
  "充填因数": "chōng,tián,yīn,shù",
  "充干": "chōng,gàn",
  "充应": "chōng,yìng",
  "充数": "chōng,shù",
  "充气地": "chōng,qì,de",
  "充沛地": "chōng,pèi,de",
  "充满地": "chōng,mǎn,de",
  "充满深情地": "chōng,mǎn,shēn,qíng,de",
  "充血": "chōng,xuè",
  "充裕地": "chōng,yù,de",
  "充调": "chōng,diào",
  "充足地": "chōng,zú,de",
  "充闾之庆": "chōng,lǚ,zhī,qìng",
  "兆头": "zhào,tou",
  "兆数": "zhào,shù",
  "兆载永劫": "zhào,zǎi,yǒng,jié",
  "先下手为强": "xiān,xià,shǒu,wéi,qiáng",
  "先代所美": "xian,dai,shuo,mei",
  "先入为主": "xiān,rù,wéi,zhǔ",
  "先前地": "xiān,qián,de",
  "先大夫": "xiān,dài,fū",
  "先天地": "xiān,tiān,de",
  "先是细细地": "xiān,shì,xì,xì,de",
  "先王之乐": "xiān,wáng,zhī,yuè",
  "先生": "xiān,sheng",
  "先着": "xiān,zhāo",
  "先睹为快": "xiān,dǔ,wéi,kuài",
  "先神祇": "xiān,shén,qí",
  "先约略地": "xiān,yuē,lüè,de",
  "先𬢎为快": "xiān,dǔ,wéi,kuài",
  "先零": "xiān,lián",
  "先露": "xiān,lù",
  "光亮地": "guāng,liàng,de",
  "光头地": "guāng,tóu,de",
  "光学地": "guāng,xué,de",
  "光学玻璃": "guāng,xué,bō,li",
  "光应": "guāng,yìng",
  "光彩地": "guāng,cǎi,de",
  "光彩夺目地": "guāng,cǎi,duó,mù,de",
  "光感应": "guāng,gǎn,yìng",
  "光明地": "guāng,míng,de",
  "光明正大地": "guāng,míng,zhèng,dà,de",
  "光晃": "guāng,huàng",
  "光晃晃": "guāng,huàng,huǎng",
  "光晕": "guāng,yùn",
  "光杆": "guāng,gǎn",
  "光杆儿": "guāng,gǎn,ér",
  "光柱子": "guāng,zhù,zi",
  "光栅": "guāng,shān",
  "光泽地": "guāng,zé,de",
  "光电效应": "guāng,diàn,xiào,yìng",
  "光着": "guāng,zhe",
  "光禄大夫": "guāng,lù,dài,fu",
  "光纤分布式数据接口": "guāng,xiān,fēn,bù,shì,shù,jù,jiē,kǒu",
  "光纤分布数据接口": "guāng,xiān,fēn,bù,shù,jù,jiē,kǒu",
  "光缝": "guāng,fèng",
  "光背地鸫": "guāng,bèi,dì,dōng",
  "光膀子": "guāng,bǎng,zi",
  "光荣地": "guāng,róng,de",
  "光被": "guāng,pī",
  "光贲": "guāng,bēn",
  "光赤净杆": "guāng,chì,jìng,gǎn",
  "光趟": "guāng,chēng",
  "光身地": "guāng,shēn,de",
  "光辉灿烂地": "guāng,huī,càn,làn,de",
  "光银子": "guāng,yín,zi",
  "克丝钳子": "kè,sī,qián,zi",
  "克什": "kè,shí",
  "克什克腾": "kè,shí,kè,téng",
  "克什克腾旗": "kè,shí,kè,téng,qí",
  "克什米尔": "kè,shí,mǐ,ěr",
  "克仑特罗": "kè,lún,tè,luō",
  "克分子": "kè,fèn,zǐ",
  "克削": "kè,xuē",
  "克剥": "kè,bāo",
  "克厌": "kè,yā",
  "克已地": "kè,yǐ,de",
  "克着": "kè,zhe",
  "克耶族": "kè,yē,zú",
  "克耶邦": "kè,yē,bāng",
  "克荷": "kè,hè",
  "克蕾儿": "kè,lěi,er",
  "克薄": "kè,bó",
  "克逮克容": "kè,dǎi,kè,róng",
  "免不了": "miǎn,bù,liǎo",
  "免予": "miǎn,yǔ",
  "免予刑事处分": "miǎn,yǔ,xíng,shì,chǔ,fèn",
  "免冠": "miǎn,guān",
  "免削": "miǎn,xuē",
  "免得": "miǎn,de",
  "免服": "wèn,fú",
  "免疫反应": "miǎn,yì,fǎn,yìng",
  "免疫应答": "miǎn,yì,yìng,dá",
  "免税地": "miǎn,shuì,de",
  "免袒": "wèn,tǎn",
  "免调": "miǎn,diào",
  "免费地": "miǎn,fèi,de",
  "免除处罚": "miǎn,chú,chǔ,fá",
  "免麻": "wèn,má",
  "兔子": "tù,zi",
  "兔子不吃窝边草": "tù,zi,bù,chī,wō,biān,cǎo",
  "兔子尾巴长不了": "tù,zi,wěi,ba,cháng,bu,liǎo",
  "兔崽子": "tù,zǎi,zi",
  "兔死凫举": "tǔ,sǐ,fú,jǔ",
  "兔羔子": "tù,gāo,zi",
  "兔起凫举": "tǔ,qǐ,fú,jǔ",
  "兔起鹘落": "tù,qǐ,hú,luò",
  "兔鹘": "tù,hú",
  "党参": "dǎng,shēn",
  "党派性地": "dǎng,pài,xìng,de",
  "党禁": "dǎng,jìn",
  "党豺为虐": "dǎng,chái,wéi,nüè",
  "兜儿": "dōu,er",
  "兜兜": "dōu,dou",
  "兜圈子": "dōu,quān,zi",
  "兜得转": "dōu,de,zhuǎn",
  "兜牟": "dōu,mù",
  "兜率": "dōu,shuài",
  "兜率天": "dōu,shuài,tiān",
  "兜率宫": "dōu,shuài,gōng",
  "兜肚连肠": "dōu,dǔ,lián,cháng",
  "兜鞬": "dōu,jiān",
  "兢兢干干": "jīng,jīng,gàn,gàn",
  "入冠": "rù,guān",
  "入味儿": "rù,wèi,er",
  "入国问禁": "rù,guó,wèn,jìn",
  "入土为安": "rù,tú,wéi,ān",
  "入境问禁": "rù,jìng,wèn,jìn",
  "入孝出弟": "rù,xiào,chū,tì",
  "入室操戈": "rù,shǐ,cāo,gē",
  "入时地": "rù,shí,de",
  "入相": "rù,xiàng",
  "入神地": "rù,shén,de",
  "入禁": "rù,jìn",
  "入竟问禁": "rù,jìng,wèn,jìn",
  "入舍": "rù,shè",
  "入行": "rù,háng",
  "入褚": "rù,chǔ",
  "入调": "rù,diào",
  "全世界无产者联合起来": "quán,shì,jiè,wú,chǎn,zhě,lián,hé,qǐ,lai",
  "全乎": "quán,hu",
  "全体地": "quán,tǐ,de",
  "全军覆没": "quán,jūn,fù,mò",
  "全力地": "quán,lì,de",
  "全地": "quán,de",
  "全帖": "quán,tiē",
  "全心全意地": "quán,xīn,quán,yì,de",
  "全心全意地为人民服务": "quán,xīn,quán,yì,de,wéi,rén,mín,fú,wù",
  "全数": "quán,shù",
  "全方位地": "quán,fāng,wèi,de",
  "全景式地": "quán,jǐng,shì,de",
  "全武行": "quán,wǔ,háng",
  "全然地": "quán,rán,de",
  "全神贯注地": "quán,shén,guàn,zhù,de",
  "全神贯注地倾听着": "quán,shén,guàn,zhù,de,qīng,tīng,zhe",
  "全神贯注地听": "quán,shén,guàn,zhù,de,tīng",
  "全能地": "quán,néng,de",
  "全裂地": "quán,liè,de",
  "全身地": "quán,shēn,de",
  "全身心地": "quán,shēn,xīn,de",
  "全速地": "quán,sù,de",
  "全部地": "quán,bù,de",
  "全都乖乖地": "quán,dōu,guāi,guāi,de",
  "全长地": "quán,zhǎng,de",
  "全面地": "quán,miàn,de",
  "全面地看": "quán,miàn,de,kàn",
  "全面地看问题": "quán,miàn,de,kàn,wèn,tí",
  "全面地认识": "quán,miàn,de,rèn,shí",
  "全面禁止": "quán,miàn,jìn,zhǐ",
  "全面禁止核试验条约": "quán,miàn,jìn,zhǐ,hé,shì,yàn,tiáo,yuē",
  "全须全尾儿": "quán,xū,quán,yǐ,er",
  "八一起义": "bā,yì,qǐ,yì",
  "八一通粉": "bā,yī,tòng,fěn",
  "八万大藏经": "bā,wàn,dà,zàng,jīng",
  "八倍地": "bā,bèi,de",
  "八十四调": "bā,shí,sì,diào",
  "八千卷楼": "bā,qiān,juàn,lóu",
  "八哥儿": "bā,gē,er",
  "八埏": "bā,shān",
  "八大人觉": "bā,dà,ren,jué",
  "八大王": "bā,dài,wáng",
  "八大胡同": "bā,dà,hú,tòng",
  "八字帆": "bā,zì,fān",
  "八字帖": "bā,zì,tiè",
  "八字没一撇": "bā,zì,méi,yī,piě",
  "八字没见一撇": "bā,zì,méi,jiàn,yī,piě",
  "八字还没一撇": "bā,zì,hái,méi,yī,piě",
  "八字还没一撇儿": "bā,zì,hái,méi,yī,piě,er",
  "八字还没有一撇": "bā,zì,hái,méi,yǒu,yī,piě",
  "八字都没一撇": "bā,zì,dōu,méi,yī,piě",
  "八家将": "bā,jiā,jiàng",
  "八寸三分帽子": "bā,cùn,sān,fēn,mào,zi",
  "八斗": "bā,dǒu",
  "八斗之才": "bā,dǒu,zhī,cái",
  "八斗才": "bā,dǒu,cái",
  "八斗陈思": "bā,dǒu,chén,sī",
  "八方呼应": "bā,fāng,hū,yìng",
  "八旗子弟": "bā,qí,zi,dì",
  "八旗都统": "bā,qí,dū,tǒng",
  "八更": "bā,gēng",
  "八棍子撂不着": "bā,gùn,zi,liào,bù,zháo",
  "八棒十三的罪过": "bā,bàng,shí,sān,de,zuì,guo",
  "八棒十挟": "bā,bàng,shí,jiā",
  "八煞": "bā,shà",
  "八爪鱼": "bā,zhuǎ,yú",
  "八相成道": "bā,xiàng,chéng,dào",
  "八石": "bā,dàn",
  "八竿子打不着": "bā,gān,zǐ,dǎ,bù,zháo",
  "八股地": "bā,gǔ,de",
  "八舍": "bā,shè",
  "八蕃": "bā,fān",
  "八行": "bā,háng",
  "八行书": "bā,háng,shū",
  "八行纸": "bā,háng,zhǐ",
  "八角形地": "bā,jiǎo,xíng,de",
  "八辈子": "bā,bèi,zi",
  "八郄": "bā,xì",
  "八重奏": "bā,chóng,zòu",
  "八难": "bā,nàn",
  "八难三灾": "bā,nàn,sān,zāi",
  "八面张罗": "bā,miàn,zhāng,luo",
  "八音盒子": "bā,yīn,hé,zi",
  "公仆": "gōng,pú",
  "公仔": "gōng,zǎi",
  "公仔面": "gōng,zǎi,miàn",
  "公们俩": "gōng,men,liǎ",
  "公倍数": "gōng,bèi,shù",
  "公假": "gōng,jià",
  "公公": "gōng,gong",
  "公共休假日": "gōng,gòng,xiū,jià,rì",
  "公共假期": "gōng,gòng,jià,qī",
  "公共地": "gōng,gòng,de",
  "公共知识分子": "gōng,gòng,zhī,shi,fèn,zǐ",
  "公共积累": "gōng,gòng,jī,lěi",
  "公务上地": "gōng,wù,shàng,de",
  "公古哩": "gōng,gǔ,lǐ",
  "公合": "gōng,gě",
  "公大夫": "gōng,dài,fū",
  "公姥": "gōng,mǔ",
  "公子哥儿": "gōng,zǐ,gē,er",
  "公差": "gōng,chāi",
  "公帑": "gōng,tǎng",
  "公干": "gōng,gàn",
  "公平地": "gōng,píng,de",
  "公平地说": "gōng,píng,de,shuō",
  "公开地": "gōng,kāi,de",
  "公开地讲": "gōng,kāi,de,jiǎng",
  "公开地说": "gōng,kāi,de,shuō",
  "公开钥匙": "gōng,kāi,yào,shi",
  "公文帖": "gōng,wén,tiē",
  "公斗": "gōng,dǒu",
  "公族大夫": "gōng,zú,dài,fū",
  "公梼": "gōng,táo",
  "公正不阿": "gōng,zhèng,bù,ē",
  "公正地": "gōng,zhèng,de",
  "公正地说": "gōng,zhèng,de,shuō",
  "公母俩": "gōng,mǔ,liǎ",
  "公然地": "gōng,rán,de",
  "公理地": "gōng,lǐ,de",
  "公石": "gōng,dàn",
  "公絜": "gōng,jié",
  "公约数": "gōng,yuē,shù",
  "公羊传": "gōng,yáng,zhuàn",
  "公舍": "gōng,shè",
  "公认地": "gōng,rèn,de",
  "公诸同好": "gōng,zhū,tóng,hào",
  "公调": "gōng,diào",
  "公转": "gōng,zhuàn",
  "六丁黑煞": "liù,dīng,hēi,shà",
  "六十花甲子": "liù,shí,huā,jiá,zǐ",
  "六合区": "lù,hé,qū",
  "六安": "lù,ān",
  "六安地区": "lù,ān,dì,qū",
  "六安市": "lù,ān,shì",
  "六安茶": "lù,ān,chá",
  "六将军": "liù,jiàng,jūn",
  "六帖": "liù,tiē",
  "六更": "liù,gēng",
  "六服": "liù,fù",
  "六枝特区": "lù,zhī,tè,qū",
  "六点儿": "liù,diǎn,er",
  "六畜兴旺": "liù,chù,xīng,wàng",
  "六石弓": "liù,dàn,gōng",
  "六艺经传": "liù,yì,jīng,zhuàn",
  "六蕃": "liù,fān",
  "六行": "liù,háng",
  "六轮子": "liù,lún,zi",
  "六陈铺": "liù,chén,pù",
  "六齐": "liù,jì",
  "兰亭帖": "lán,tíng,tiē",
  "兰干": "lán,gàn",
  "兰弹": "lán,dàn",
  "兰桡": "lán,náo",
  "兰橑": "lán,lǎo",
  "兰臭": "lán,xiù",
  "兰若": "lán,rě",
  "兰裓": "lán,jiē",
  "兰锜": "lán,yǐ",
  "共为唇齿": "gòng,wéi,chún,chǐ",
  "共事务地": "gòng,shì,wù,de",
  "共享函数库": "gòng,xiǎng,hán,shù,kù",
  "共享计划": "gòng,xiǎng,jì,huà",
  "共同地": "gòng,tóng,de",
  "共处": "gòng,chǔ",
  "共有地": "gòng,yǒu,de",
  "共枝别干": "gòng,zhī,bié,gàn",
  "共轭复数": "gòng,è,fù,shù",
  "共轭虚数": "gòng,è,xū,shù",
  "共鸣地": "gòng,míng,de",
  "关东出相": "guān,dōng,chū,xiàng",
  "关侯": "guān,hòu",
  "关切": "guān,qiè",
  "关切地": "guān,qiè,de",
  "关切地问": "guān,qiè,de,wèn",
  "关卡": "guān,qiǎ",
  "关堡": "guān,pù",
  "关塞": "guān,sài",
  "关壮缪": "guān,zhuàng,miù",
  "关子": "guān,zi",
  "关应": "guān,yìng",
  "关心地问": "guān,xīn,de,wèn",
  "关揵": "guān,jiàn",
  "关毂": "guān,gū",
  "关煞": "guān,shà",
  "关禁": "guān,jìn",
  "关禁闭": "guān,jìn,bì",
  "关系代名词": "guān,xi,dài,míng,cí",
  "关系地": "guān,xì,de",
  "关系词地": "guān,xì,cí,de",
  "关𦈡": "guān,xū",
  "关西出将": "guān,xī,chū,jiàng",
  "兴业": "xīng,yè",
  "兴业县": "xīng,yè,xiàn",
  "兴业银行": "xīng,yè,yín,háng",
  "兴中会": "xīng,zhōng,huì",
  "兴为": "xīng,wéi",
  "兴主": "xīng,zhǔ",
  "兴举": "xīng,jǔ",
  "兴义": "xīng,yì",
  "兴义市": "xīng,yì,shì",
  "兴事": "xīng,shì",
  "兴云致雨": "xīng,yún,zhì,yǔ",
  "兴亡": "xīng,wáng",
  "兴亡祸福": "xīng,wáng,huò,fú",
  "兴亡继绝": "xīng,wáng,jì,jué",
  "兴仁": "xīng,rén",
  "兴仁县": "xīng,rén,xiàn",
  "兴仆": "xīng,pú",
  "兴代": "xīng,dài",
  "兴作": "xīng,zuò",
  "兴修": "xīng,xiū",
  "兴兴头头": "xīng,xìng,tou,tóu",
  "兴兵": "xīng,bīng",
  "兴兵动众": "xīng,bīng,dòng,zhòng",
  "兴冲冲": "xīng,chōng,chōng",
  "兴冲冲地": "xīng,chōng,chōng,de",
  "兴况": "xīng,kuàng",
  "兴凯刺鳑鲏": "xīng,kǎi,cì,páng,pí",
  "兴利除害": "xīng,lì,chú,hài",
  "兴利除弊": "xīng,lì,chú,bì",
  "兴办": "xīng,bàn",
  "兴功": "xīng,gōng",
  "兴匆匆": "xīng,cōng,cōng",
  "兴化": "xīng,huà",
  "兴化市": "xīng,huà,shì",
  "兴化部": "xīng,huà,bù",
  "兴县": "xīng,xiàn",
  "兴发": "xīng,fā",
  "兴叹": "xīng,tàn",
  "兴名": "xīng,míng",
  "兴启": "xīng,qǐ",
  "兴和": "xīng,hé",
  "兴和县": "xīng,hé,xiàn",
  "兴咏": "xīng,yǒng",
  "兴喻": "xīng,yù",
  "兴嗟": "xīng,jiē",
  "兴国": "xīng,guó",
  "兴国县": "xīng,guó,xiàn",
  "兴坏": "xīng,huài",
  "兴城": "xīng,chéng",
  "兴城市": "xīng,chéng,shì",
  "兴复": "xīng,fù",
  "兴头": "xìng,tou",
  "兴头儿上": "xìng,tou,er,shàng",
  "兴头话": "xìng,tou,huà",
  "兴奋": "xīng,fèn",
  "兴奋剂": "xīng,fèn,jì",
  "兴奋地": "xīng,fèn,de",
  "兴奋地叫道": "xīng,fèn,de,jiào,dào",
  "兴奋地喊": "xīng,fèn,de,hǎn",
  "兴奋地大叫": "xīng,fèn,de,dà,jiào",
  "兴奋地说": "xīng,fèn,de,shuō",
  "兴奋地蹦了起来": "xīng,fèn,de,bèng,le,qǐ,lái",
  "兴奋高潮": "xīng,fèn,gāo,cháo",
  "兴妖作乱": "xīng,yāo,zuò,luàn",
  "兴妖作孽": "xīng,yāo,zuò,niè",
  "兴妖作怪": "xīng,yāo,zuò,guài",
  "兴学": "xīng,xué",
  "兴宁": "xīng,níng",
  "兴宁区": "xīng,níng,qū",
  "兴宁市": "xīng,níng,shì",
  "兴安": "xīng,ān",
  "兴安区": "xīng,ān,qū",
  "兴安县": "xīng,ān,xiàn",
  "兴安盟": "xīng,ān,méng",
  "兴安运河": "xīng,ān,yùn,hé",
  "兴家": "xīng,jiā",
  "兴家立业": "xīng,jiā,lì,yè",
  "兴宾": "xīng,bīn",
  "兴宾区": "xīng,bīn,qū",
  "兴寄": "xīng,jì",
  "兴富": "xīng,fù",
  "兴寝": "xīng,qǐn",
  "兴居": "xīng,jū",
  "兴山": "xīng,shān",
  "兴山区": "xīng,shān,qū",
  "兴山县": "xīng,shān,xiàn",
  "兴工": "xīng,gōng",
  "兴师": "xīng,shī",
  "兴师动众": "xīng,shī,dòng,zhòng",
  "兴师问罪": "xīng,shī,wèn,zuì",
  "兴平": "xīng,píng",
  "兴平市": "xīng,píng,shì",
  "兴庆": "xīng,qìng",
  "兴庆区": "xīng,qìng,qū",
  "兴废": "xīng,fèi",
  "兴废继绝": "xīng,fèi,jì,jué",
  "兴廉": "xīng,lián",
  "兴建": "xīng,jiàn",
  "兴徭": "xīng,yáo",
  "兴微继绝": "xīng,wēi,jì,jué",
  "兴德": "xīng,dé",
  "兴心": "xīng,xīn",
  "兴怀": "xīng,huái",
  "兴思": "xīng,sī",
  "兴怨": "xīng,yuàn",
  "兴怱怱": "xīng,cōng,cōng",
  "兴情": "xīng,qíng",
  "兴慕": "xīng,mù",
  "兴戎": "xīng,róng",
  "兴托": "xīng,tuō",
  "兴抖抖": "xīng,dǒu,dǒu",
  "兴教寺": "xīng,jiào,sì",
  "兴文": "xīng,wén",
  "兴文匽武": "xīng,wén,yǎn,wǔ",
  "兴文县": "xīng,wén,xiàn",
  "兴无灭资": "xīng,wú,miè,zī",
  "兴时": "xīng,shí",
  "兴旺": "xīng,wàng",
  "兴旺发达": "xīng,wàng,fā,dá",
  "兴昌": "xīng,chāng",
  "兴易": "xīng,yì",
  "兴替": "xīng,tì",
  "兴朝": "xīng,cháo",
  "兴树": "xīng,shù",
  "兴止": "xīng,zhǐ",
  "兴殖": "xīng,zhí",
  "兴毁": "xīng,huǐ",
  "兴波": "xīng,bō",
  "兴海": "xīng,hǎi",
  "兴海县": "xīng,hǎi,xiàn",
  "兴灭继绝": "xīng,miè,jì,jué",
  "兴王": "xīng,wáng",
  "兴生": "xīng,shēng",
  "兴甿": "xīng,méng",
  "兴盛": "xīng,shèng",
  "兴福": "xīng,fú",
  "兴积": "xīng,jī",
  "兴立": "xīng,lì",
  "兴筑": "xīng,zhù",
  "兴绪": "xīng,xù",
  "兴缮": "xīng,shàn",
  "兴能": "xīng,néng",
  "兴腾": "xīng,téng",
  "兴致勃勃地": "xìng,zhì,bó,bó,de",
  "兴舍": "xīng,shè",
  "兴舞": "xīng,wǔ",
  "兴荣": "xīng,róng",
  "兴葺": "xīng,qì",
  "兴行": "xīng,xíng",
  "兴衰": "xīng,shuāi",
  "兴言": "xīng,yán",
  "兴讬": "xīng,tuō",
  "兴许": "xīng,xǔ",
  "兴讹造讪": "xīng,é,zào,shàn",
  "兴讼": "xīng,sòng",
  "兴词": "xīng,cí",
  "兴词构讼": "xīng,cí,gòu,sòng",
  "兴谕": "xīng,yù",
  "兴象": "xīng,xiàng",
  "兴贤": "xīng,xián",
  "兴贩": "xīng,fàn",
  "兴赏": "xīng,shǎng",
  "兴起": "xīng,qǐ",
  "兴趣浓地": "xìng,qù,nóng,de",
  "兴跃": "xīng,yuè",
  "兴辅": "xīng,fǔ",
  "兴辞": "xīng,cí",
  "兴运": "xīng,yùn",
  "兴造": "xīng,zào",
  "兴道": "xīng,dào",
  "兴邦": "xīng,bāng",
  "兴邦立国": "xīng,bāng,lì,guó",
  "兴都库什": "xīng,dū,kù,shí",
  "兴长": "xīng,cháng",
  "兴门": "xīng,mén",
  "兴阑": "xīng,lán",
  "兴隆": "xīng,lóng",
  "兴隆县": "xīng,lóng,xiàn",
  "兴隆台": "xīng,lóng,tái",
  "兴隆台区": "xīng,lóng,tái,qū",
  "兴隆地": "xīng,lóng,de",
  "兴雨": "xīng,yǔ",
  "兴革": "xīng,gé",
  "兴风作浪": "xīng,fēng,zuò,làng",
  "兵不由将": "bīng,bù,yóu,jiàng",
  "兵不血刃": "bīng,bù,xuè,rèn",
  "兵多将广": "bīng,duō,jiàng,guǎng",
  "兵差": "bīng,chāi",
  "兵强将勇": "bīng,qiáng,jiàng,yǒng",
  "兵微将寡": "bīng,wēi,jiàng,guǎ",
  "兵无血刃": "bīng,wú,xuè,rèn",
  "兵未血刃": "bīng,wèi,xuè,rèn",
  "兵来将挡": "bīng,lái,jiàng,dǎng",
  "兵来将敌": "bīng,lái,jiàng,dí",
  "兵来将迎": "bīng,lái,jiàng,yíng",
  "兵痞子": "bīng,pǐ,zi",
  "兵舍": "bīng,shè",
  "其义自见": "qí,yì,zì,xiàn",
  "其后地": "qí,hòu,de",
  "其实难符": "qí,shí,nán,fù",
  "其应如响": "qí,yìng,rú,xiǎng",
  "其应若响": "qí,yìng,ruò,xiǎng",
  "其次地": "qí,cì,de",
  "具体地": "jù,tǐ,de",
  "具体地说": "jù,tǐ,de,shuō",
  "具体计划": "jù,tǐ,jì,huà",
  "具折": "jù,shé",
  "具数": "jù,shù",
  "具理解地": "jù,lǐ,jiě,de",
  "具自陈道": "ju,zhi,cheng,dao",
  "具载": "jù,zǎi",
  "具食与乐": "ju,shi,yu,le",
  "典乐": "diǎn,yuè",
  "典冠": "diǎn,guān",
  "典型地": "diǎn,xíng,de",
  "典干": "diǎn,gàn",
  "典当": "diǎn,dàng",
  "典狱长": "diǎn,yù,zhǎng",
  "典贲": "diǎn,bēn",
  "典铺": "diǎn,pù",
  "养分": "yǎng,fèn",
  "养女调妇": "yǎng,nǚ,diào,fù",
  "养尊处优": "yǎng,zūn,chǔ,yōu",
  "养汞调铅": "yǎng,gǒng,diào,qiān",
  "养活": "yǎng,huo",
  "养精畜锐": "yǎng,jīng,xù,ruì",
  "养蕃": "yǎng,fān",
  "养虎为患": "yǎng,hǔ,wéi,huàn",
  "养鹰飏去": "yǎng,yīng,zǒu,qù",
  "兼仆": "jiān,pú",
  "兼任地": "jiān,rèn,de",
  "兼容地": "jiān,róng,de",
  "兼差": "jiān,chāi",
  "兼有其地": "jiān,yǒu,qí,de",
  "兼舍": "jiān,shè",
  "兽侯": "shòu,hòu",
  "兽性地": "shòu,xìng,de",
  "兽类地": "shòu,lèi,de",
  "兽迒鸟迹": "shòu,hàn,niǎo,jì",
  "兽铤": "shòu,dìng",
  "内乐府": "nèi,yuè,fǔ",
  "内传": "nèi,zhuàn",
  "内入行长": "nèi,rù,háng,zhǎng",
  "内八府宰相": "nèi,bā,fǔ,zǎi,xiàng",
  "内内": "nèi,nei",
  "内冓": "nèi,gōu",
  "内出血": "nèi,chū,xuè",
  "内向地": "nèi,xiàng,de",
  "内哄": "nèi,hòng",
  "内外夹攻": "nèi,wài,jiā,gōng",
  "内宰相": "nèi,zǎi,xiàng",
  "内帑": "nèi,tǎng",
  "内干": "nèi,gàn",
  "内应": "nèi,yìng",
  "内政部长": "nèi,zhèng,bù,zhǎng",
  "内查外调": "nèi,chá,wài,diào",
  "内比都": "nèi,bǐ,dū",
  "内爆法原子弹": "nèi,bào,fǎ,yuán,zǐ,dàn",
  "内疚地": "nèi,jiù,de",
  "内省": "nèi,xǐng",
  "内省不疚": "nèi,xǐng,bù,jiù",
  "内省地": "nèi,xǐng,de",
  "内省性": "nèi,xǐng,xìng",
  "内禁": "nèi,jìn",
  "内线消息": "nèi,xiàn,xiāo,xi",
  "内聚性地": "nèi,jù,xìng,de",
  "内舍": "nèi,shè",
  "内蒙": "nèi,měng",
  "内蒙古": "nèi,měng,gǔ",
  "内蒙古大学": "nèi,měng,gǔ,dà,xué",
  "内蒙古自治区": "nèi,měng,gǔ,zì,zhì,qū",
  "内蒙古高原": "nèi,měng,gǔ,gāo,yuán",
  "内行": "nèi,háng",
  "内行厂": "nèi,háng,chǎng",
  "内行地": "nèi,háng,de",
  "内部地": "nèi,bù,de",
  "内金": "nà,jīn",
  "内韄": "nèi,hù",
  "内骨子": "nèi,gǔ,zi",
  "内黄侯": "nèi,huáng,hòu",
  "册子": "cè,zi",
  "再一次": "zài,yí,cì",
  "再一次地": "zài,yí,cì,de",
  "再三地": "zài,sān,de",
  "再兴": "zài,xīng",
  "再创地量": "zài,chuàng,de,liàng",
  "再发见": "zài,fā,xiàn",
  "再处": "zài,chǔ",
  "再处理": "zài,chǔ,lǐ",
  "再客观地说": "zài,kè,guān,de,shuō",
  "再往前地": "zài,wǎng,qián,de",
  "再拜稽首": "zài,bài,qǐ,shǒu",
  "再生不良性贫血": "zài,shēng,bù,liáng,xìng,pín,xuè",
  "再生地": "zài,shēng,de",
  "再用力地": "zài,yòng,lì,de",
  "再适": "zài,shì",
  "冒充地": "mào,chōng,de",
  "冒冒失失地": "mào,mào,shī,shī,de",
  "冒处": "mào,chǔ",
  "冒失地": "mào,shī,de",
  "冒失地进去": "mào,shī,de,jìn,qù",
  "冒干": "mào,gàn",
  "冒愬": "mào,shuò",
  "冒昧地": "mào,mèi,de",
  "冒昧地擅自做": "mào,mèi,de,shàn,zì,zuò",
  "冒没": "mào,mò",
  "冒渎地": "mào,dú,de",
  "冒着": "mào,zhe",
  "冒禁": "mào,jìn",
  "冒险地": "mào,xiǎn,de",
  "冒顿": "mò,dú",
  "冒风险地": "mào,fēng,xiǎn,de",
  "冕冠": "miǎn,guān",
  "冗散": "rǒng,sǎn",
  "冗数": "rǒng,shù",
  "冗条子": "rǒng,tiáo,zi",
  "冗赘地": "rǒng,zhuì,de",
  "冗长地": "rǒng,cháng,de",
  "冗馀地": "rǒng,yú,de",
  "冘疑": "yóu,yí",
  "冘豫": "yóu,yù",
  "写字枱": "xiě,zì,tái",
  "写着": "xiě,zhe",
  "写载": "xiě,zǎi",
  "军不血刃": "jūn,bù,xuè,rèn",
  "军乐": "jūn,yuè",
  "军乐团": "jūn,yuè,tuán",
  "军乐队": "jūn,yuè,duì",
  "军事力量": "jūn,shì,lì,liang",
  "军兴": "jūn,xīng",
  "军兴法": "jūn,xīng,fǎ",
  "军哄": "jūn,hǒng",
  "军团杆菌": "jūn,tuán,gǎn,jūn",
  "军帑": "jūn,tǎng",
  "军政要地": "jūn,zhèng,yào,de",
  "军来将敌": "jūn,lái,jiàng,dí",
  "军禁": "jūn,jìn",
  "军铺": "jūn,pù",
  "军长": "jūn,zhǎng",
  "军鞞": "jūn,bǐ",
  "农大夫": "nóng,dài,fū",
  "农桐间作": "nóng,tóng,jiàn,zuò",
  "农活儿": "nóng,huó,er",
  "农舍": "nóng,shè",
  "农行": "nóng,háng",
  "冠上加冠": "guān,shàng,jiā,guān",
  "冠上履下": "guān,shàng,lǚ,xià",
  "冠世": "guān,shì",
  "冠事": "guān,shì",
  "冠代": "guān,dài",
  "冠佩": "guān,pèi",
  "冠具": "guān,jù",
  "冠冒": "guān,mào",
  "冠冕": "guān,miǎn",
  "冠冕堂皇": "guān,miǎn,táng,huáng",
  "冠凫": "guān,fú",
  "冠剑": "guān,jiàn",
  "冠县": "guān,xiàn",
  "冠古": "guān,gǔ",
  "冠名": "guān,míng",
  "冠场": "guān,chǎng",
  "冠婚": "guān,hūn",
  "冠子": "guàn,zi",
  "冠履": "guān,lǚ",
  "冠履倒易": "guān,lǚ,dào,yì",
  "冠履倒置": "guān,lǚ,dào,zhì",
  "冠屦": "guān,jù",
  "冠帔": "guān,pèi",
  "冠帽": "guān,mào",
  "冠年": "guān,nián",
  "冠座": "guān,zuò",
  "冠弁": "guān,biàn",
  "冠形词": "guān,xíng,cí",
  "冠德": "guān,dé",
  "冠心病": "guān,xīn,bìng",
  "冠挂": "guān,guà",
  "冠斑犀鸟": "guān,bān,xī,niǎo",
  "冠时": "guān,shí",
  "冠昏": "guān,hūn",
  "冠服": "guān,fú",
  "冠栉": "guān,zhì",
  "冠海雀": "guān,hǎi,què",
  "冠状": "guān,zhuàng",
  "冠状动脉": "guān,zhuàng,dòng,mài",
  "冠状动脉旁路移植手术": "guān,zhuàng,dòng,mài,páng,lù,yí,zhí,shǒu,shù",
  "冠状动脉旁通手术": "guān,zhuàng,dòng,mài,páng,tōng,shǒu,shù",
  "冠状动脉硬化": "guān,zhuàng,dòng,mài,yìng,huà",
  "冠状动脉血栓形成": "guān,zhuàng,dòng,mài,xuè,shuān,xíng,chéng",
  "冠状动脉阻塞": "guān,zhuàng,dòng,mài,zǔ,sè",
  "冠状病毒": "guān,zhuàng,bìng,dú",
  "冠状静脉": "guān,zhuàng,jìng,mài",
  "冠玉": "guān,yù",
  "冠珥": "guān,ěr",
  "冠盖": "guān,gài",
  "冠盖云集": "guān,gài,yún,jí",
  "冠盖场": "guān,gài,chǎng",
  "冠盖如云": "guān,gài,rú,yún",
  "冠盖相属": "guān,gài,xiāng,zhǔ",
  "冠盖相望": "guān,gài,xiāng,wàng",
  "冠盖里": "guān,gài,lǐ",
  "冠石": "guān,shí",
  "冠笄": "guān,jī",
  "冠簪": "guān,zān",
  "冠𰬜": "guān,wèn",
  "冠𮉫": "guān,ruí",
  "冠纹柳莺": "guān,wén,liǔ,yīng",
  "冠绂": "guān,fú",
  "冠组": "guān,zǔ",
  "冠绅": "guān,shēn",
  "冠绶": "guān,shòu",
  "冠缦": "guān,màn",
  "冠缨": "guān,yīng",
  "冠群": "guān,qún",
  "冠胄": "guān,zhòu",
  "冠脉": "guān,mài",
  "冠脉循环": "guān,mài,xún,huán",
  "冠蝉": "guān,chán",
  "冠袍带履": "guān,páo,dài,lǚ",
  "冠裳": "guān,cháng",
  "冠裾": "guān,jū",
  "冠豸": "guān,zhì",
  "冠轶": "guān,yì",
  "冠辞": "guān,cí",
  "冠醮": "guān,jiào",
  "冠醴": "guān,lǐ",
  "冠雀": "guān,què",
  "冠霞": "guān,xiá",
  "冠饰": "guān,shì",
  "冠鱼狗": "guān,yú,gǒu",
  "冠鸡": "guān,jī",
  "冠麻鸭": "guān,má,yā",
  "冢舍": "zhǒng,shè",
  "冢适": "zhǒng,shì",
  "冤冤相报何时了": "yuān,yuān,xiāng,bào,hé,shí,liǎo",
  "冤家对头": "yuān,jia,duì,tóu",
  "冤家路狭": "yuān,jia,lù,xiá",
  "冤枉": "yuān,wang",
  "冤枉地": "yuān,wǎng,de",
  "冤枉路": "yuān,wang,lù",
  "冤枉钱": "yuān,wang,qián",
  "冤疙瘩": "yuān,gē,dā",
  "冥应": "míng,yìng",
  "冥想地": "míng,xiǎng,de",
  "冥数": "míng,shù",
  "冥行𰔖埴": "míng,xíng,zhì,zhí",
  "冥𬮴": "míng,ān",
  "冥顽不化": "míng,wán,bú,huà",
  "冬冬地敲": "dōng,dōng,de,qiāo",
  "冬禁": "dōng,jìn",
  "冬种": "dōng,zhòng",
  "冬粘": "dōng,zhān",
  "冬裘夏葛": "dōng,qiú,xià,gě",
  "冯应": "féng,yìng",
  "冯河": "píng,hé",
  "冯生": "píng,shēng",
  "冯生弹铗": "féng,shēng,dàn,jiá",
  "冯𬴐弹铗": "féng,huān,dàn,jiá",
  "冰上曲棍球": "bīng,shàng,qū,gùn,qiú",
  "冰似地": "bīng,shì,de",
  "冰冷地": "bīng,lěng,de",
  "冰冻般地": "bīng,dòng,bān,de",
  "冰坨子": "bīng,tuó,zi",
  "冰天雪窑": "bīng,tiān,xuě,jiào",
  "冰排子": "bīng,pǎi,zǐ",
  "冰斗": "bīng,dǒu",
  "冰核儿": "bīng,hú,ér",
  "冰瀑": "bīng,bào",
  "冰爪": "bīng,zhuǎ",
  "冰糖葫芦": "bīng,táng,hú,lu",
  "冰解的破": "bīng,jiě,dì,pò",
  "冰钻": "bīng,zuàn",
  "冰雪聪明": "bīng,xuě,cōng,ming",
  "冲冠": "chōng,guān",
  "冲冠怒发": "chōng,guàn,nù,fà",
  "冲击钻": "chōng,jī,zuàn",
  "冲动地": "chōng,dòng,de",
  "冲劲": "chòng,jìn",
  "冲劲儿": "chòng,jìn,er",
  "冲压": "chòng,yā",
  "冲天大将军": "chōng,tiān,dà,jiàng,jūn",
  "冲子": "chòng,zi",
  "冲孔": "chòng,kǒng",
  "冲床": "chòng,chuáng",
  "冲模": "chòng,mú",
  "冲盹儿": "chòng,dǔn,er",
  "冲积地": "chōng,jī,de",
  "冲适": "chōng,shì",
  "冲𬮴": "chōng,ān",
  "冲𫘤": "chōng,ái",
  "决堤": "jué,dī",
  "决定地": "jué,deng,de",
  "决定性地": "jué,deng,xìng,de",
  "决然地": "jué,rán,de",
  "决䇲": "jué,jiā",
  "决舍": "jué,shè",
  "冶葛": "yě,gě",
  "冷不丁地": "lěng,bù,dīng,de",
  "冷不丁地就": "lěng,bù,dīng,de,jiù",
  "冷不防地": "lěng,bù,fáng,de",
  "冷冰冰地": "lěng,bīng,bīng,de",
  "冷冷地": "lěng,lěng,de",
  "冷冷地回答": "lěng,lěng,de,huí,dá",
  "冷冷地回答道": "lěng,lěng,de,huí,dá,dào",
  "冷冷地看着": "lěng,lěng,de,kàn,zhe",
  "冷冷地说": "lěng,lěng,de,shuō",
  "冷冷地说道": "lěng,lěng,de,shuō,dào",
  "冷切": "lěng,qiè",
  "冷嘲热讽": "lěng,cháo,rè,fěng",
  "冷处理": "lěng,chǔ,lǐ",
  "冷峻地": "lěng,jùn,de",
  "冷水浇背": "lěng,shuǐ,jiāo,bèi",
  "冷淡地": "lěng,dàn,de",
  "冷漠地": "lěng,mò,de",
  "冷热度数": "lěng,rè,dù,shù",
  "冷知识": "lěng,zhī,shi",
  "冷笑地": "lěng,xiào,de",
  "冷笑式地": "lěng,xiào,shì,de",
  "冷笑话": "lěng,xiào,hua",
  "冷背": "lěng,bèi",
  "冷血": "lěng,xuè",
  "冷血动物": "lěng,xuè,dòng,wù",
  "冷血地": "lěng,xuè,de",
  "冷调": "lěng,diào",
  "冷轧": "lěng,zhá",
  "冷酷地": "lěng,kù,de",
  "冷铺": "lěng,pù",
  "冷露": "lěng,lù",
  "冷静地": "lěng,jìng,de",
  "冷静地分析": "lěng,jìng,de,fēn,xī",
  "冷静地说": "lěng,jìng,de,shuō",
  "冷颤": "lěng,zhàn",
  "冻儿": "dòng,er",
  "冻剥剥": "dòng,bāo,bāo",
  "净得": "jìng,de",
  "凄凉地": "qī,liáng,de",
  "凄凉调": "qī,liáng,diào",
  "凄切": "qī,qiè",
  "凄咽": "qī,yān",
  "凄惨地": "qī,cǎn,de",
  "凄浰": "qī,liàn",
  "准予": "zhǔn,yǔ",
  "准信儿": "zhǔn,xìn,er",
  "准假": "zhǔn,jià",
  "准备地": "zhǔn,bèi,de",
  "准头": "zhǔn,tou",
  "准将": "zhǔn,jiàng",
  "准折": "zhǔn,shé",
  "准数": "zhǔn,shù",
  "准时地": "zhǔn,shí,de",
  "准点地": "zhǔn,diǎn,de",
  "准的": "zhǔn,dì",
  "准确地": "zhǔn,què,de",
  "准确地打在": "zhǔn,què,de,dǎ,zài",
  "准确地找出": "zhǔn,què,de,zhǎo,chū",
  "准确地说": "zhǔn,què,de,shuō",
  "准谱儿": "zhǔn,pǔ,er",
  "凉一凉": "liàng,yī,liàng",
  "凉血": "liáng,xuè",
  "凉适": "liáng,shì",
  "凉𬮴": "liáng,ān",
  "凋剥": "diāo,bāo",
  "凋翫": "diāo,wàn",
  "凌乱地": "líng,luàn,de",
  "凌慠": "líng,ào",
  "凌折": "líng,shé",
  "凌趠": "líng,chào",
  "凌跞": "líng,luò",
  "凌霜侯": "líng,shuāng,hòu",
  "减削": "jiǎn,xuē",
  "减折": "jiǎn,shé",
  "减损地": "jiǎn,sǔn,de",
  "减数": "jiǎn,shù",
  "减数分裂": "jiǎn,shù,fēn,liè",
  "减速地": "jiǎn,sù,de",
  "凑付": "còu,fu",
  "凑份子": "còu,fèn,zi",
  "凑兴": "còu,xīng",
  "凑口馒头": "còu,kǒu,mán,tou",
  "凑合": "còu,he",
  "凑巧地": "còu,qiǎo,de",
  "凑数": "còu,shù",
  "凑热闹": "còu,rè,nao",
  "凑胆子": "còu,dǎn,zi",
  "凛絜": "lǐn,jié",
  "凝咽": "níng,yān",
  "凝固汽油弹": "níng,gù,qì,yóu,dàn",
  "凝帖": "níng,tiē",
  "凝朴": "níng,piáo",
  "凝神地": "níng,shén,de",
  "凝结性地": "níng,jié,xìng,de",
  "凝翫": "níng,wàn",
  "凝聚性地": "níng,jù,xìng,de",
  "凝血": "níng,xuè",
  "凝血素": "níng,xuè,sù",
  "凝血酶": "níng,xuè,méi",
  "凝血酶原": "níng,xuè,méi,yuán",
  "凝露": "níng,lù",
  "凝露騘": "níng,lù,cōng",
  "凝露骢": "níng,lù,cōng",
  "几丁": "jī,dīng",
  "几丁质": "jī,dīng,zhì",
  "几不欲生": "jī,bù,yù,shēng",
  "几乎": "jī,hū",
  "几乎不": "jī,hū,bù",
  "几乎地": "jī,hū,de",
  "几乎完全": "jī,hū,wán,quán",
  "几乎正确地": "jī,hū,zhèng,què,de",
  "几何学地": "jǐ,hé,xué,de",
  "几何平均数": "jǐ,hé,píng,jūn,shù",
  "几何级数": "jǐ,hé,jí,shù",
  "几何级数增长": "jǐ,hé,jí,shù,zēng,zhǎng",
  "几倍地": "jǐ,bèi,de",
  "几内亚": "jī,nèi,yà",
  "几内亚比索": "jī,nèi,yà,bǐ,suǒ",
  "几内亚比绍": "jī,nèi,yà,bǐ,shào",
  "几几乎": "jǐ,jī,hū",
  "几十年如一日": "jǐ,shí,nián,rú,yí,rì",
  "几只": "jǐ,zhī",
  "几可乱真": "jī,kě,luàn,zhēn",
  "几希": "jī,xī",
  "几微": "jī,wēi",
  "几曾": "jǐ,zēng",
  "几案": "jī,àn",
  "几案才": "jī,àn,cái",
  "几次地": "jǐ,cì,de",
  "几欲": "jī,yù",
  "几率": "jī,lǜ",
  "几禁": "jǐ,jìn",
  "几米": "jī,mǐ",
  "几维鸟": "jī,wéi,niǎo",
  "几至": "jī,zhì",
  "几谏": "jī,jiàn",
  "几近": "jī,jìn",
  "几里地": "jǐ,lǐ,de",
  "凡数": "fán,shù",
  "凡调": "fán,diào",
  "凡𬮴": "fán,ān",
  "凤冠": "fèng,guān",
  "凤冠粟": "fèng,guān,sù",
  "凤冠霞帔": "fèng,guān,xiá,pèi",
  "凤凰翘": "fèng,huáng,qiào",
  "凤刹": "fèng,shā",
  "凤只鸾孤": "fèng,zhī,luán,gū",
  "凤头冠": "fèng,tóu,guān",
  "凤尾罗": "fèng,yǐ,luó",
  "凤楼龙阙": "fèng,lóu,lóng,què",
  "凤翘": "fèng,qiào",
  "凤胏麟脯": "fèng,fèi,lín,fǔ",
  "凤舍": "fèng,shè",
  "凤血石": "fèng,xuè,shí",
  "凤觜": "fèng,zuǐ",
  "凤跄": "fèng,qiàng",
  "凤阁舍人": "fèng,gé,shè,rén",
  "凤靡鸾吪": "fèng,mǐ,luán,é",
  "凤鸣朝阳": "fèng,míng,zhāo,yáng",
  "凫䐪": "fú,juǎn",
  "凫茈": "fú,cí",
  "凭一己之力": "píng,yì,jǐ,zhī,lì",
  "凭几": "píng,jī",
  "凭几据杖": "píng,jī,jù,zhàng",
  "凭应": "píng,yìng",
  "凭槛": "píng,kǎn",
  "凭着": "píng,zhe",
  "凭触觉地": "píng,chù,jué,de",
  "凯子": "kǎi,zi",
  "凳子": "dèng,zi",
  "凶丧": "xiōng,sāng",
  "凶忒": "xiōng,tuī",
  "凶恶地": "xiōng,è,de",
  "凶慊": "xiōng,qiè",
  "凶慓": "xiōng,piào",
  "凶折": "xiōng,shé",
  "凶暴地": "xiōng,bào,de",
  "凶横": "xiōng,hèng",
  "凶煞": "xiōng,shà",
  "凶煞煞": "xiōng,shà,shà",
  "凶猛地": "xiōng,měng,de",
  "凶相": "xiōng,xiàng",
  "凶相地": "xiōng,xiàng,de",
  "凶相毕露": "xiōng,xiàng,bì,lù",
  "凶短折": "xiōng,duǎn,shé",
  "凶神恶煞": "xiōng,shén,è,shà",
  "凶𬮴": "xiōng,ān",
  "凶骜": "xiōng,ào",
  "凸凸囊囊": "tū,tū,nāng,nang",
  "凸圆地": "tū,yuán,de",
  "凸露": "tū,lù",
  "凸面地": "tū,miàn,de",
  "凹朴皮": "āo,pò,pí",
  "出丧": "chū,sāng",
  "出主意": "chū,zhǔ,yi",
  "出举兴生": "chū,jǔ,xīng,shēng",
  "出乖露丑": "chū,guāi,lù,chǒu",
  "出乱子": "chū,luàn,zi",
  "出份子": "chū,fèn,zi",
  "出分子": "chū,fèn,zǐ",
  "出口地": "chū,kǒu,de",
  "出口调查": "chū,kǒu,diào,chá",
  "出喽子": "chū,lóu,zi",
  "出塞": "chū,sài",
  "出声地": "chū,shēng,de",
  "出声地哭": "chū,shēng,de,kū",
  "出处殊涂": "chū,chǔ,shū,tú",
  "出处殊途": "chū,chǔ,shū,tú",
  "出处语默": "chū,chǔ,yǔ,mò",
  "出处进退": "chū,chǔ,jìn,tuì",
  "出大差": "chū,dà,chāi",
  "出头棒子": "chū,tóu,bàng,zi",
  "出头的椽子先烂": "chū,tóu,de,chuán,zi,xiān,làn",
  "出头露面": "chū,tóu,lù,miàn",
  "出奇地": "chū,qí,de",
  "出奇地低": "chū,qí,de,dī",
  "出奇地快": "chū,qí,de,kuài",
  "出奇地静": "chū,qí,de,jìng",
  "出娄子": "chū,lóu,zi",
  "出家地": "chū,jiā,de",
  "出将": "chū,jiàng",
  "出将入相": "chū,jiàng,rù,xiàng",
  "出尖儿": "chū,jiān,er",
  "出岔子": "chū,chà,zi",
  "出差": "chū,chāi",
  "出差子": "chū,chāi,zǐ",
  "出差错": "chū,chā,cuò",
  "出帖": "chū,tiē",
  "出常调": "chū,cháng,diào",
  "出摊儿": "chū,tān,er",
  "出月子": "chū,yuè,zi",
  "出条子": "chū,tiáo,zi",
  "出来混迟早要还的": "chū,lái,hùn,chí,zǎo,yào,huán,de",
  "出楼子": "chū,lóu,zi",
  "出没": "chū,mò",
  "出没不常": "chū,mò,bù,cháng",
  "出没无常": "chū,mò,wú,cháng",
  "出洋相": "chū,yáng,xiàng",
  "出活儿": "chū,huó,er",
  "出溜屁": "chū,liu,pì",
  "出漏子": "chū,lòu,zi",
  "出点子": "chū,diǎn,zi",
  "出神地": "chū,shén,de",
  "出神地看": "chū,shén,de,kàn",
  "出神音乐": "chū,shén,yīn,yuè",
  "出臭子儿": "chū,chòu,zǐ,er",
  "出舍": "chū,shè",
  "出色地": "chū,sè,de",
  "出色地完成": "chū,sè,de,wán,chéng",
  "出落": "chū,là",
  "出血": "chū,xuè",
  "出血性": "chū,xuè,xìng",
  "出血性登革热": "chū,xuè,xìng,dēng,gé,rè",
  "出血热": "chū,xuè,rè",
  "出调": "chū,diào",
  "出谋划策": "chū,móu,huà,cè",
  "出适": "chū,shì",
  "出锋头": "chū,fēng,tou",
  "出露": "chū,lù",
  "出风头": "chū,fēng,tou",
  "击中": "jī,zhòng",
  "击中要害": "jī,zhòng,yào,hài",
  "击剥": "jī,bāo",
  "击天抓地": "jī,tiān,zhuā,de",
  "击应": "jī,yìng",
  "击弦类乐器": "jī,xián,lèi,yuè,qì",
  "击折": "jī,shé",
  "击掊": "jī,póu",
  "击排冒没": "jī,pái,mào,mò",
  "击搒": "jī,péng",
  "击缶": "jí,fǒu",
  "击轧": "jī,zhá",
  "凼子": "dàng,zi",
  "函子": "hán,zi",
  "函数": "hán,shù",
  "函数论": "hán,shù,lùn",
  "函调": "hán,diào",
  "函𮝹": "hán,huán",
  "凿井得铜奴得翁": "záo,jǐng,de,tóng,nú,de,wēng",
  "凿坏": "záo,pī",
  "凿坏以遁": "záo,pī,yǐ,dùn",
  "凿坏而遁": "záo,pī,ér,dùn",
  "凿干": "záo,gàn",
  "凿龟数䇲": "záo,guī,shù,jiā",
  "刀光血影": "dāo,guāng,xuè,yǐng",
  "刀子": "dāo,zi",
  "刀子嘴": "dāo,zi,zuǐ",
  "刀子嘴豆腐心": "dāo,zi,zuǐ,dòu,fǔ,xīn",
  "刀子秤": "dāo,zi,chèng",
  "刀子靶": "dāo,zi,bǎ",
  "刀强地": "dāo,qiáng,de",
  "刀把": "dāo,bà",
  "刀把儿": "dāo,bà,er",
  "刀把子": "dāo,bà,zi",
  "刀断地": "dāo,duàn,de",
  "刀楯": "dāo,dùn",
  "刀𥬞": "dāo,mí",
  "刀耕火种": "dāo,gēng,huǒ,zhòng",
  "刀背": "dāo,bèi",
  "刀螂": "dāo,lang",
  "刁斗": "diāo,dǒu",
  "刁斗旗杆": "diāo,dǒu,qí,gān",
  "刁斗森严": "diāo,dǒu,sēn,yán",
  "刁横": "diāo,hèng",
  "刁调": "diāo,diào",
  "刁蹬": "diāo,dèng",
  "刁钻促搯": "diāo,zuàn,cù,tāo",
  "刁钻促狭": "diāo,zuàn,cù,xiá",
  "刁钻刻薄": "diāo,zuān,kè,bó",
  "刁难": "diāo,nàn",
  "刁难地": "diāo,nàn,de",
  "刃创": "rèn,chuāng",
  "分为": "fēn,wéi",
  "分位数": "fēn,wèi,shù",
  "分光镜地": "fēn,guāng,jìng,de",
  "分内": "fèn,nèi",
  "分内之事": "fèn,nèi,zhī,shì",
  "分削": "fēn,xuē",
  "分剖": "fēn,pōu",
  "分华丽地": "fēn,huá,lì,de",
  "分叉": "fēn,chà",
  "分处": "fēn,chǔ",
  "分外": "fèn,wài",
  "分外之物": "fèn,wài,zhī,wù",
  "分外妖娆": "fèn,wài,yāo,ráo",
  "分外明白": "fèn,wài,míng,bai",
  "分外眼明": "fèn,wài,yǎn,míng",
  "分外眼睁": "fèn,wài,yǎn,zhēng",
  "分外眼红": "fèn,wài,yǎn,hóng",
  "分子": "fèn,zǐ",
  "分子力": "fèn,zǐ,lì",
  "分子式": "fèn,zǐ,shì",
  "分子物理学": "fèn,zǐ,wù,lǐ,xué",
  "分子生物学": "fèn,zǐ,shēng,wù,xué",
  "分子筛": "fèn,zǐ,shāi",
  "分子运动论": "fèn,zǐ,yùn,dòng,lùn",
  "分子量": "fèn,zǐ,liàng",
  "分子钟": "fèn,zǐ,zhōng",
  "分当": "fèn,dāng",
  "分得": "fēn,de",
  "分批地": "fēn,pī,de",
  "分拆": "fèn,chāi",
  "分撇": "fēn,piě",
  "分散": "fēn,sǎn",
  "分散主义": "fēn,sǎn,zhǔ,yì",
  "分散地": "fēn,sǎn,de",
  "分散指挥": "fēn,sǎn,zhǐ,huī",
  "分散染料": "fēn,sǎn,rǎn,liào",
  "分散系": "fēn,sǎn,xì",
  "分数": "fēn,shù",
  "分数挂帅": "fēn,shù,guà,shuài",
  "分数线": "fēn,shù,xiàn",
  "分析处理": "fēn,xī,chǔ,lǐ",
  "分毫不差": "fēn,háo,bù,chā",
  "分毫之差": "fēn,háo,zhī,chā",
  "分液漏斗": "fēn,yè,lòu,dǒu",
  "分相": "fēn,xiàng",
  "分离分子": "fēn,lí,fèn,zǐ",
  "分离地": "fēn,lí,de",
  "分缝": "fēn,fèng",
  "分背": "fēn,bèi",
  "分虚伪地": "fēn,xū,wěi,de",
  "分行": "fēn,háng",
  "分行布白": "fēn,háng,bù,bái",
  "分解反应": "fēn,jiě,fǎn,yìng",
  "分量": "fèn,liàng",
  "分阶段地": "fēn,jiē,duàn,de",
  "分际": "fèn,jì",
  "分风劈流": "fēn,fēng,pǐ,liú",
  "分馏": "fēn,liú",
  "切不": "qiè,bù",
  "切中": "qiè,zhòng",
  "切中事理": "qiè,zhòng,shì,lǐ",
  "切中时弊": "qiè,zhòng,shí,bì",
  "切中时病": "qiè,zhòng,shí,bìng",
  "切云": "qiè,yún",
  "切云冠": "qiè,yún,guān",
  "切分": "qiè,fēn",
  "切切偲偲": "qiē,qiē,sī,sī",
  "切切嚓嚓": "qiē,qiē,chā,chā",
  "切切在心": "qiè,qiè,zài,xīn",
  "切切实实": "qiè,qiè,shí,shí",
  "切切此令": "qiè,qiè,cǐ,lìng",
  "切切此布": "qiè,qiè,cǐ,bù",
  "切切牢记": "qiè,qiè,láo,jì",
  "切切私语": "qiè,qiè,sī,yǔ",
  "切切请求": "qiè,qiè,qǐng,qiú",
  "切剥": "qiē,bāo",
  "切力效应": "qiē,lì,xiào,yìng",
  "切𠡠": "qiē,lài",
  "切勿倒置": "qiè,wù,dào,zhì",
  "切勿受潮": "qiè,wù,shòu,cháo",
  "切勿吸烟": "qiè,wù,xī,yān",
  "切勿靠近": "qiè,wù,kào,jìn",
  "切勿颠倒": "qiè,wù,diān,dǎo",
  "切合": "qiè,hé",
  "切合实际": "qiè,hé,shí,jì",
  "切响": "qiè,xiǎng",
  "切嘱": "qiè,zhǔ",
  "切实": "qiè,shí",
  "切实可行": "qiè,shí,kě,xíng",
  "切实地": "qiè,shí,de",
  "切尔西": "qiè,ěr,xī",
  "切己": "qiè,jǐ",
  "切忌": "qiè,jì",
  "切望": "qiè,wàng",
  "切末": "qiè,mò",
  "切格瓦拉": "qiè,gé,wǎ,lā",
  "切激": "qiè,jī",
  "切盼": "qiè,pàn",
  "切结书": "qiè,jié,shū",
  "切肤": "qiè,fū",
  "切肤之痛": "qiè,fū,zhī,tòng",
  "切脉": "qiè,mài",
  "切莫": "qiè,mò",
  "切要": "qiè,yào",
  "切触": "qiè,chù",
  "切记": "qiè,jì",
  "切诊": "qiè,zhěn",
  "切谏": "qiè,jiàn",
  "切责": "qiè,zé",
  "切贴": "qiè,tiē",
  "切踦": "qiē,jī",
  "切身": "qiè,shēn",
  "切身体验": "qiè,shēn,tǐ,yàn",
  "切身利害": "qiè,shēn,lì,hài",
  "切身大事": "qiè,shēn,dà,shì",
  "切达": "qiè,dá",
  "切近": "qiè,jìn",
  "切迫": "qiè,pò",
  "切适": "qiē,shì",
  "切音": "qiè,yīn",
  "切韵": "qiè,yùn",
  "切题": "qiè,tí",
  "切骨": "qiè,gǔ",
  "切骨之仇": "qiè,gǔ,zhī,chóu",
  "切骨之寒": "qiè,gǔ,zhī,hán",
  "切骨之恨": "qiè,gǔ,zhī,hèn",
  "切齿": "qiè,chǐ",
  "切齿人": "qiè,chǐ,rén",
  "切齿咒骂": "qiè,chǐ,zhòu,mà",
  "切齿拊心": "qiè,chǐ,fǔ,xīn",
  "切齿痛心": "qiè,chǐ,tòng,xīn",
  "切齿痛恨": "qiè,chǐ,tòng,hèn",
  "切齿腐心": "qiè,chǐ,fǔ,xīn",
  "刈包": "guà,bāo",
  "刊削": "kān,xuē",
  "刊剥": "kān,bāo",
  "刊载": "kān,zǎi",
  "刑不上大夫": "xíng,bù,shàng,dài,fū",
  "刑禁": "xíng,jìn",
  "刑𮝹": "xíng,huán",
  "划一": "huà,yī",
  "划一不二": "huà,yī,bù,èr",
  "划下": "huà,xià",
  "划价": "huà,jià",
  "划位": "huà,wèi",
  "划分": "huà,fēn",
  "划切": "huá,qiè",
  "划十字": "huà,shí,zì",
  "划圆防守": "huà,yuán,fáng,shǒu",
  "划地为牢": "huá,dì,wéi,láo",
  "划定": "huà,dìng",
  "划归": "huà,guī",
  "划得来": "huá,de,lái",
  "划拨": "huà,bō",
  "划拨清算": "huà,bō,qīng,suàn",
  "划掉": "huà,diào",
  "划时代": "huà,shí,dài",
  "划样": "huà,yàng",
  "划水": "huà,shuǐ",
  "划清": "huà,qīng",
  "划界": "huà,jiè",
  "划粥割齑": "huà,zhōu,gē,jī",
  "划线": "huà,xiàn",
  "划线板": "huà,xiàn,bǎn",
  "划花": "huà,huā",
  "划重点": "huà,zhòng,diǎn",
  "刓方为圆": "wán,fāng,wéi,yuán",
  "刓缪": "wán,miù",
  "刖趾适履": "yuè,zhǐ,shì,lǚ",
  "刖趾适屦": "yuè,zhǐ,shì,jù",
  "列为": "liè,wéi",
  "列传": "liè,zhuàn",
  "列别杰夫": "liè,biè,jié,fū",
  "列刹": "liè,shā",
  "列大夫": "liè,dài,fū",
  "列女传": "liè,nǚ,zhuàn",
  "列舍": "liè,shè",
  "列蛸": "liè,shāo",
  "列趄": "liè,qie",
  "列车长": "liè,chē,zhǎng",
  "刘姥姥进大观园": "liú,lǎo,lao,jìn,dà,guān,yuán",
  "刘少奇": "liú,shào,qí",
  "刘氏冠": "liú,shì,guān",
  "刘海儿": "liú,hǎi,er",
  "刘猛将军": "liú,měng,jiàng,jūn",
  "刘禅": "liú,shàn",
  "刘累": "liú,lèi",
  "刘阿斗": "liú,ā,dǒu",
  "则么": "zé,mǒ",
  "则是不断地": "zé,shì,bù,duàn,de",
  "则深刻地": "zé,shēn,kè,de",
  "刚克消亡": "gang,ke,xiao,wang",
  "刚刚": "gāng,gang",
  "刚剽": "gāng,piāo",
  "刚劲": "gāng,jìng",
  "刚勇地": "gāng,yǒng,de",
  "刚只": "gāng,zhī",
  "刚强地": "gāng,qiáng,de",
  "刚愎地": "gāng,bì,de",
  "刚慠": "gāng,ào",
  "刚折": "gāng,shé",
  "刚朴": "gāng,piáo",
  "刚正不阿": "gāng,zhèng,bù,ē",
  "刚獝": "gāng,yù",
  "刚瘅": "gāng,dān",
  "刚直不阿": "gāng,zhí,bù,ē",
  "刚着地": "gāng,zhe,de",
  "刚絜": "gāng,jié",
  "刚纔": "gāng,shān",
  "刚罫": "gāng,guà",
  "创伤": "chuāng,shāng",
  "创伤后": "chuāng,shāng,hòu",
  "创伤后压力": "chuāng,shāng,hòu,yā,lì",
  "创伤后压力紊乱": "chuāng,shāng,hòu,yā,lì,wěn,luàn",
  "创伤后心理压力紧张综合症": "chuāng,shāng,hòu,xīn,lǐ,yā,lì,jǐn,zhāng,zōng,hé,zhèng",
  "创兴": "chuàng,xīng",
  "创口": "chuāng,kǒu",
  "创口贴": "chuāng,kǒu,tiē",
  "创可贴": "chuāng,kě,tiē",
  "创巨痛深": "chuāng,jù,tòng,shēn",
  "创牌子": "chuàng,pái,zi",
  "创痍": "chuāng,yí",
  "创痕": "chuāng,hén",
  "创痛": "chuāng,tòng",
  "创艾": "chuāng,yì",
  "创调": "chuàng,diào",
  "创造性地": "chuàng,zào,xìng,de",
  "创面": "chuāng,miàn",
  "初冠": "chū,guān",
  "初始地": "chū,shǐ,de",
  "初更": "chū,gēng",
  "初期地": "chū,qī,de",
  "初等代数": "chū,děng,dài,shù",
  "初载": "chū,zǎi",
  "初露": "chū,lù",
  "初露头角": "chū,lù,tóu,jiǎo",
  "初露才华": "chū,lù,cái,huá",
  "初露锋芒": "chū,lù,fēng,máng",
  "初风头水": "chū,fēng,tou,shuǐ",
  "删削": "shān,xuē",
  "删掠": "shān,lüě",
  "删着": "shān,zhe",
  "判处": "pàn,chǔ",
  "判折": "pàn,shé",
  "刨丝器": "bào,sī,qì",
  "刨光": "bào,guāng",
  "刨冰": "bào,bīng",
  "刨刀": "bào,dāo",
  "刨削": "páo,xuē",
  "刨头": "bào,tóu",
  "刨子": "bào,zǐ",
  "刨平": "bào,píng",
  "刨床": "bào,chuáng",
  "刨木板": "bào,mù,bǎn",
  "刨烟铺": "páo,yān,pù",
  "刨程": "bào,chéng",
  "刨笔刀": "bào,bǐ,dāo",
  "刨花": "bào,huā",
  "刨花板": "bào,huā,bǎn",
  "刨身": "bào,shēn",
  "刨齿": "bào,chǐ",
  "利什曼病": "lì,shí,màn,bìng",
  "利他地": "lì,tā,de",
  "利他行为": "lì,tā,xíng,wéi",
  "利刹": "lì,shā",
  "利口捷给": "lì,kǒu,jié,jǐ",
  "利害关系": "lì,hài,guān,xi",
  "利害关系人": "lì,hài,guān,xi,rén",
  "利害关系方": "lì,hài,guān,xi,fāng",
  "利州帖": "lì,zhōu,tiē",
  "利己地": "lì,jǐ,de",
  "利得": "lì,de",
  "利爪": "lì,zhuǎ",
  "利索": "lì,suo",
  "利适": "lì,shì",
  "利齿伶牙": "lì,chǐ,líng,yā",
  "别人牵驴你拔橛子": "bié,ren,qiān,lǘ,nǐ,bá,jué,zi",
  "别传": "bié,zhuàn",
  "别具只眼": "bié,jù,zhī,yǎn",
  "别创一格": "bié,chuàng,yí,gé",
  "别别": "biè,biè",
  "别削": "bié,xuē",
  "别堡": "bié,pù",
  "别太客气": "bié,tài,kè,qi",
  "别子": "bié,zi",
  "别客气": "bié,kè,qi",
  "别干": "bié,gàn",
  "别开一格": "bié,kāi,yí,gé",
  "别开蹊径": "bié,kāi,xī,jìng",
  "别扭": "biè,niǔ",
  "别拗": "bié,niù",
  "别柎": "bié,fù",
  "别致地": "bié,zhì,de",
  "别舍": "bié,shè",
  "别苗头": "bié,miáo,tou",
  "别调": "bié,diào",
  "刬削": "chǎn,xuē",
  "刬着": "chǎn,zhe",
  "刬骡子": "chǎn,luó,zi",
  "刮喇喇": "guā,là,là",
  "刮毛龟背": "guā,máo,guī,bèi",
  "刮缝": "guā,fèng",
  "刮胡子": "guā,hú,zi",
  "刮鼻子": "guā,bí,zi",
  "到三不着两": "dào,sān,bù,zháo,liǎng",
  "到哪座山里唱哪个歌": "dào,nǎ,zuò,shān,lǐ,chàng,něi,gè,gē",
  "到处地": "dào,chù,de",
  "到岁数": "dào,suì,shù",
  "到差": "dào,chāi",
  "到此为止": "dào,cǐ,wéi,zhǐ",
  "到水中地": "dào,shuǐ,zhōng,de",
  "到目前为止": "dào,mù,qián,wéi,zhǐ",
  "到远方地": "dào,yuǎn,fāng,de",
  "刳削": "kū,xuē",
  "刳剖": "kū,pōu",
  "刳剥": "kū,bāo",
  "刳精呕血": "kū,jīng,ǒu,xuè",
  "刳精𬬸心": "kū,jīng,jiū,xīn",
  "制𠡠": "zhì,lài",
  "制度上地": "zhì,dù,shàng,de",
  "制数": "zhì,shù",
  "制模": "zhì,mú",
  "刷亮": "shuà,liàng",
  "刷利": "shuà,lì",
  "刷刷地": "shuā,shuā,de",
  "刷卷": "shuā,juàn",
  "刷地一声": "shuā,de,yī,shēng",
  "刷地泛红": "shuā,de,fàn,hóng",
  "刷白": "shuà,bái",
  "券帖": "quàn,tiē",
  "券门": "xuàn,mén",
  "刹不住": "shā,bù,zhù",
  "刹住": "shā,zhù",
  "刹利": "shā,lì",
  "刹刹": "shā,shā",
  "刹刹尘尘": "shā,shā,chén,chén",
  "刹土": "shā,tǔ",
  "刹寺": "shā,sì",
  "刹尘": "shā,chén",
  "刹帝利": "shā,dì,lì",
  "刹手锏": "shā,shǒu,jiǎn",
  "刹把": "shā,bǎ",
  "刹时": "shā,shí",
  "刹末": "shā,mò",
  "刹柱": "shā,zhù",
  "刹海": "shā,hǎi",
  "刹竿": "shā,gān",
  "刹车": "shā,chē",
  "刹车灯": "shā,chē,dēng",
  "刺中": "cì,zhòng",
  "刺儿李": "cì,er,lǐ",
  "刺儿话": "cì,er,huà",
  "刺啦": "cī,lā",
  "刺干": "cì,gàn",
  "刺心切骨": "cì,xīn,qiè,gǔ",
  "刺打": "cī,da",
  "刺溜": "cī,liū",
  "刺激地": "cì,jī,de",
  "刺痒": "cì,yáng",
  "刺痛地": "cì,tòng,de",
  "刺的一声": "cī,de,yī,shēng",
  "刺耳地": "cì,ěr,de",
  "刺背": "cì,bèi",
  "刺蝥": "cì,móu",
  "刺血": "cì,xuè",
  "刺透地": "cì,tòu,de",
  "刺骨地": "cì,gǔ,de",
  "刻削": "kè,xuē",
  "刻意为之": "kè,yì,wéi,zhī",
  "刻意地": "kè,yì,de",
  "刻意地去": "kè,yì,de,qù",
  "刻木为吏": "kè,mù,wéi,lì",
  "刻木为鹄": "kè,mù,wéi,hú",
  "刻板地": "kè,bǎn,de",
  "刻着": "kè,zhe",
  "刻薄": "kè,bó",
  "刻薄地": "kè,bó,de",
  "刻薄寡思": "kè,bó,guǎ,sī",
  "刻薄寡恩": "kè,bó,guǎ,ēn",
  "刻足适屦": "kè,zú,shì,jù",
  "刻露": "kè,lù",
  "刻骨地爱": "kè,gǔ,de,ài",
  "刽子手": "guì,zi,shǒu",
  "刿心𬬸肾": "guì,xīn,xù,shèn",
  "刿目𬬸心": "guì,mù,xù,xīn",
  "刿𬬸心腑": "guì,xù,xīn,fǔ",
  "刿𬬸肝肾": "guì,xù,gān,shèn",
  "剀切中理": "kǎi,qiè,zhòng,lǐ",
  "剀切教导": "kǎi,qiè,jiào,dǎo",
  "剀切详明": "kǎi,qiè,xiáng,míng",
  "剀讽": "kǎi,fěng",
  "剂子": "jì,zi",
  "剂调": "jì,diào",
  "剂量效应": "jì,liàng,xiào,yìng",
  "剃削": "tì,xuē",
  "剃发": "tì,fà",
  "剃发令": "tì,fà,lìng",
  "剃发留辫": "tì,fà,liú,biàn",
  "剃头挑子一头热": "tì,tóu,tiāo,zi,yī,tóu,rè",
  "剉折": "cuò,shé",
  "削书": "xuē,shū",
  "削亡": "xuē,wáng",
  "削价": "xuē,jià",
  "削免": "xuē,miǎn",
  "削减": "xuē,jiǎn",
  "削刀": "xuē,dāo",
  "削刑": "xuē,xíng",
  "削券": "xuē,quàn",
  "削刻": "xuē,kè",
  "削削": "xuē,xuē",
  "削剔": "xuē,tī",
  "削剟": "xuē,duō",
  "削剥": "xuē,bāo",
  "削劖": "xuē,chán",
  "削发": "xuē,fà",
  "削发披缁": "xuē,fà,pī,zī",
  "削口": "xuē,kǒu",
  "削哺": "xuē,bǔ",
  "削国": "xuē,guó",
  "削地": "xuē,dì",
  "削墨": "xuē,mò",
  "削壁": "xuē,bì",
  "削头": "xuē,tóu",
  "削夺": "xuē,duó",
  "削定": "xuē,dìng",
  "削小": "xuē,xiǎo",
  "削尖脑袋": "xuē,jiān,nǎo,dài",
  "削崖": "xuē,yá",
  "削平": "xuē,píng",
  "削弱": "xuē,ruò",
  "削抹": "xuē,mǒ",
  "削损": "xuē,sǔn",
  "削改": "xuē,gǎi",
  "削政": "xuē,zhèng",
  "削敛": "xuē,liǎn",
  "削斥": "xuē,chì",
  "削木为吏": "xuē,mù,wéi,lì",
  "削杖": "xuē,zhàng",
  "削杮": "xuē,bèi",
  "削株掘根": "xuē,zhū,jué,gēn",
  "削格": "xuē,gé",
  "削正": "xuē,zhèng",
  "削波": "xuē,bō",
  "削消": "xuē,xiāo",
  "削涤": "xuē,dí",
  "削灭": "xuē,miè",
  "削然": "xuē,rán",
  "削燧": "xuē,suì",
  "削爵": "xuē,jué",
  "削牍": "xuē,dú",
  "削瓜": "xuē,guā",
  "削瘦": "xuē,shòu",
  "削秩": "xuē,zhì",
  "削稿": "xuē,gǎo",
  "削立": "xuē,lì",
  "削简": "xuē,jiǎn",
  "削籍": "xuē,jí",
  "削约": "xuē,yuē",
  "削绌": "xuē,chù",
  "削绝": "xuē,jué",
  "削缝": "xuē,fèng",
  "削职": "xuē,zhí",
  "削职为民": "xuē,zhí,wéi,mín",
  "削肩": "xuē,jiān",
  "削肺": "xuē,fèi",
  "削背": "xuē,bèi",
  "削色": "xuē,sè",
  "削草": "xuē,cǎo",
  "削草除根": "xuē,cǎo,chú,gēn",
  "削落": "xuē,luò",
  "削葱": "xuē,cōng",
  "削薄": "xuē,báo",
  "削藩": "xuē,fān",
  "削藳": "xuē,gǎo",
  "削虐": "xuē,nüè",
  "削行": "xuē,xíng",
  "削袂": "xuē,mèi",
  "削足适履": "xuē,zú,shì,lǚ",
  "削趾适屦": "xuē,zhǐ,shì,jù",
  "削𮣷": "xuē,jù",
  "削铁": "xuē,tiě",
  "削铁如泥": "xuē,tiě,rú,ní",
  "削铁无声": "xuē,tiě,wú,shēng",
  "削长": "xuē,cháng",
  "削阶": "xuē,jiē",
  "削除": "xuē,chú",
  "削青": "xuē,qīng",
  "削面": "xuē,miàn",
  "削黜": "xuē,chù",
  "剌犮": "là,bá",
  "剌登哩登": "là,dēng,lǐ,dēng",
  "剌缪": "là,miù",
  "剌耳地": "lá,ěr,de",
  "前一阵子": "qián,yī,zhèn,zi",
  "前不着村": "qián,bù,zháo,cūn",
  "前人种树": "qián,rén,zhòng,shù",
  "前仆后踣": "qián,pú,hòu,bó",
  "前任地": "qián,rèn,de",
  "前侧地": "qián,cè,de",
  "前侯": "qián,hòu",
  "前儿": "qián,er",
  "前兆地": "qián,zhào,de",
  "前冠": "qián,guān",
  "前凸后翘": "qián,tū,hòu,qiào",
  "前半天儿": "qián,bàn,tiān,er",
  "前半晌儿": "qián,bàn,shǎng,er",
  "前口儿": "qián,kǒu,er",
  "前台地": "qián,tái,de",
  "前后来回地": "qián,hòu,lái,huí,de",
  "前后直排地": "qián,hòu,zhí,pái,de",
  "前后脚儿": "qián,hòu,jiǎo,er",
  "前咽": "qián,yān",
  "前头": "qián,tou",
  "前头人": "qián,tou,rén",
  "前帆": "qián,fān",
  "前数": "qián,shù",
  "前方地": "qián,fāng,de",
  "前燕": "qián,yān",
  "前爪": "qián,zhuǎ",
  "前缘未了": "qián,yuán,wèi,liǎo",
  "前置词地": "qián,zhì,cí,de",
  "前者地": "qián,zhě,de",
  "前胸贴后背": "qián,xiōng,tiē,hòu,bèi",
  "前言不对后语": "qián,yán,bú,duì,hòu,yǔ",
  "前调": "qián,diào",
  "前载": "qián,zǎi",
  "前边": "qián,bian",
  "前边儿": "qián,bian,er",
  "前进地": "qián,jìn,de",
  "前述地": "qián,shù,de",
  "前郄": "qián,xì",
  "前郭尔罗斯蒙古族自治县": "qián,guō,ěr,luó,sī,měng,gǔ,zú,zì,zhì,xiàn",
  "前面地": "qián,miàn,de",
  "前额地": "qián,é,de",
  "前首相": "qián,shǒu,xiàng",
  "剑态箫心": "jiàn,tai,xiāo,xīn",
  "剑镡": "jiàn,tán",
  "剔抽秃揣": "tī,chōu,tū,chuǎi",
  "剔蝎撩蜂": "tī,xiē,liáo,fēng",
  "剖冤": "pōu,yuān",
  "剖决": "pōu,jué",
  "剖决如流": "pōu,jué,rú,liú",
  "剖分": "pōu,fēn",
  "剖列": "pōu,liè",
  "剖判": "pōu,pàn",
  "剖别": "pōu,bié",
  "剖割": "pōu,gē",
  "剖卵": "pōu,luǎn",
  "剖奏": "pōu,zòu",
  "剖宫产": "pōu,gōng,chǎn",
  "剖宫产手术": "pōu,gōng,chǎn,shǒu,shù",
  "剖尸": "pōu,shī",
  "剖幽析微": "pōu,yōu,xī,wēi",
  "剖心": "pōu,xīn",
  "剖心坼肝": "pōu,xīn,chè,gān",
  "剖心析肝": "pōu,xīn,xī,gān",
  "剖心析胆": "pōu,xīn,xī,dǎn",
  "剖心泣血": "pōu,xīn,qì,xuè",
  "剖悉": "pōu,xī",
  "剖拨": "pōu,bō",
  "剖摘": "pōu,zhāi",
  "剖散": "pōu,sàn",
  "剖断": "pōu,duàn",
  "剖斲": "pōu,zhuó",
  "剖明": "pōu,míng",
  "剖晰": "pōu,xī",
  "剖析": "pōu,xī",
  "剖析肝胆": "pōu,xī,gān,dǎn",
  "剖棃": "pōu,lí",
  "剖毫析芒": "pōu,háo,xī,máng",
  "剖治": "pōu,zhì",
  "剖泮": "pōu,pàn",
  "剖爱": "pōu,ài",
  "剖玄析微": "pōu,xuán,xī,wēi",
  "剖疑": "pōu,yí",
  "剖白": "pōu,bái",
  "剖破": "pōu,pò",
  "剖竹": "pōu,zhú",
  "剖符": "pōu,fú",
  "剖𰩮": "pōu,tuán",
  "剖肝沥胆": "pōu,gān,lì,dǎn",
  "剖肝泣血": "pōu,gān,qì,xuè",
  "剖腹": "pōu,fù",
  "剖腹产": "pōu,fù,chǎn",
  "剖腹产手术": "pōu,fù,chǎn,shǒu,shù",
  "剖腹自杀": "pōu,fù,zì,shā",
  "剖腹藏珠": "pōu,fù,cáng,zhū",
  "剖蚌得珠": "pōu,bàng,dé,zhū",
  "剖蚌求珠": "pōu,bàng,qiú,zhū",
  "剖衷": "pōu,zhōng",
  "剖裁": "pōu,cái",
  "剖裂": "pōu,liè",
  "剖视": "pōu,shì",
  "剖视图": "pōu,shì,tú",
  "剖觚": "pōu,gū",
  "剖解": "pōu,jiě",
  "剖解图": "pōu,jiě,tú",
  "剖诉": "pōu,sù",
  "剖说": "pōu,shuō",
  "剖豁": "pōu,huō",
  "剖辞": "pōu,cí",
  "剖辨": "pōu,biàn",
  "剖辩": "pōu,biàn",
  "剖释": "pōu,shì",
  "剖陈": "pōu,chén",
  "剖露": "pōu,lù",
  "剖面": "pōu,miàn",
  "剖面图": "pōu,miàn,tú",
  "剖验": "pōu,yàn",
  "剖鲤": "pōu,lǐ",
  "剟削": "duō,xuē",
  "剟剽": "duō,piāo",
  "剡中": "shàn,zhōng",
  "剡客": "shàn,kè",
  "剡楮": "shàn,chǔ",
  "剡溪": "shàn,xī",
  "剡溪兴": "shàn,xī,xīng",
  "剡溪船": "shàn,xī,chuán",
  "剡溪藤": "shàn,xī,téng",
  "剡纸": "shàn,zhǐ",
  "剥一节": "bāo,yī,jié",
  "剥丧": "bāo,sàng",
  "剥乱": "bāo,luàn",
  "剥人": "bāo,rén",
  "剥制": "bāo,zhì",
  "剥刺": "bāo,cì",
  "剥削": "bō,xuē",
  "剥削者": "bō,xuē,zhě",
  "剥削阶级": "bō,xuē,jiē,jí",
  "剥剔": "bāo,tī",
  "剥剖": "bāo,pōu",
  "剥剥": "bāo,bāo",
  "剥割": "bāo,gē",
  "剥剽": "bāo,piāo",
  "剥卸": "bāo,xiè",
  "剥取": "bāo,qǔ",
  "剥坏": "bāo,huài",
  "剥坐": "bāo,zuò",
  "剥壳": "bāo,ké",
  "剥奠": "bāo,diàn",
  "剥害": "bāo,hài",
  "剥寒": "bāo,hán",
  "剥庐": "bāo,lú",
  "剥异": "bāo,yì",
  "剥怨": "bāo,yuàn",
  "剥戮": "bāo,lù",
  "剥折": "bāo,shé",
  "剥损": "bāo,sǔn",
  "剥掠": "bāo,lüě",
  "剥放": "bāo,fàng",
  "剥敛": "bāo,liǎn",
  "剥文": "bāo,wén",
  "剥斲": "bāo,zhuó",
  "剥桡": "bāo,ráo",
  "剥殻枪": "bāo,ké,qiāng",
  "剥毁": "bāo,huǐ",
  "剥泐": "bāo,lè",
  "剥漶": "bāo,huàn",
  "剥烂": "bāo,làn",
  "剥猪猡": "bāo,zhū,luó",
  "剥琢": "bāo,zhuó",
  "剥皮": "bāo,pí",
  "剥皮囊草": "bāo,pí,náng,cǎo",
  "剥皮实草": "bāo,pí,shí,cǎo",
  "剥皮钳": "bāo,pí,qián",
  "剥示": "bāo,shì",
  "剥缺": "bāo,quē",
  "剥肤椎髓": "bō,fū,chuí,suǐ",
  "剥脱": "bāo,tuō",
  "剥船": "bāo,chuán",
  "剥花生": "bāo,huā,shēng",
  "剥苹果": "bāo,píng,guǒ",
  "剥葱": "bāo,cōng",
  "剥裂": "bāo,liè",
  "剥褫": "bāo,chǐ",
  "剥辱": "bāo,rǔ",
  "剥运": "bāo,yùn",
  "剥除": "bāo,chú",
  "剥露": "bāo,lù",
  "剥面皮": "bāo,miàn,pí",
  "剥麻": "bāo,má",
  "剧吐": "jù,tù",
  "剧增地": "jù,zēng,de",
  "剧毒地": "jù,dú,de",
  "剧烈地": "jù,liè,de",
  "剧跌": "jù,diē",
  "剩下地": "shèng,xià,de",
  "剪刀差": "jiǎn,dāo,chā",
  "剪刀石头布": "jiǎn,dāo,shí,tou,bù",
  "剪削": "jiǎn,xuē",
  "剪发": "jiǎn,fà",
  "剪发杜门": "jiǎn,fà,dù,mén",
  "剪头发": "jiǎn,tóu,fa",
  "剪子": "jiǎn,zi",
  "剪帖": "jiǎn,tiē",
  "剪应力": "jiǎn,yìng,lì",
  "剪截铺": "jiǎn,jié,pù",
  "剪髪被褐": "jiǎn,fà,pī,hè",
  "剬削": "duān,xuē",
  "副书记": "fù,shū,ji",
  "副将": "fù,jiàng",
  "副州长": "fù,zhōu,zhǎng",
  "副市长": "fù,shì,zhǎng",
  "副校长": "fù,xiào,zhǎng",
  "副相": "fù,xiàng",
  "副着": "fù,zhe",
  "副秘书长": "fù,mì,shū,zhǎng",
  "副行长": "fù,háng,zhǎng",
  "副议长": "fù,yì,zhǎng",
  "副部长": "fù,bù,zhǎng",
  "副院长": "fù,yuàn,zhǎng",
  "割削": "gē,xuē",
  "割包": "guà,bāo",
  "割舍了": "gē,shè,le",
  "割舍得": "gē,shè,de",
  "割舍的": "gē,shè,de",
  "割须弃袍": "gē,xū,qì,pào",
  "剽伤": "piāo,shāng",
  "剽便": "piāo,biàn",
  "剽俗": "piāo,sú",
  "剽分": "piāo,fēn",
  "剽刦": "piāo,jié",
  "剽利": "piāo,lì",
  "剽削": "piāo,xuē",
  "剽剟": "piāo,duō",
  "剽剠": "piāo,lüè",
  "剽剥": "piāo,bāo",
  "剽劫": "piāo,jié",
  "剽劲": "piāo,jìn",
  "剽勇": "piāo,yǒng",
  "剽卖": "piāo,mài",
  "剽卤": "piāo,lǔ",
  "剽取": "piāo,qǔ",
  "剽声": "piāo,shēng",
  "剽夺": "piāo,duó",
  "剽奋": "piāo,fèn",
  "剽姚": "piāo,yáo",
  "剽尘": "piāo,chén",
  "剽急": "piāo,jí",
  "剽怸": "piāo,xī",
  "剽悍": "piāo,hàn",
  "剽戮": "piāo,lù",
  "剽拂": "piāo,fú",
  "剽拟": "piāo,nǐ",
  "剽拾": "piāo,shí",
  "剽捍": "piāo,hàn",
  "剽掇": "piāo,duō",
  "剽掠": "piāo,lüè",
  "剽摘": "piāo,zhāi",
  "剽攘": "piāo,rǎng",
  "剽攻": "piāo,gōng",
  "剽敚": "piāo,duó",
  "剽杀": "piāo,shā",
  "剽模": "piāo,mó",
  "剽狡": "piāo,jiǎo",
  "剽猾": "piāo,huá",
  "剽略": "piāo,lüè",
  "剽疾": "piāo,jí",
  "剽盗": "piāo,dào",
  "剽窃": "piāo,qiè",
  "剽系": "piāo,xì",
  "剽缀": "piāo,zhuì",
  "剽获": "piāo,huò",
  "剽薄": "piāo,báo",
  "剽虏": "piāo,lǔ",
  "剽袭": "piāo,xí",
  "剽裂": "piāo,liè",
  "剽贼": "piāo,zéi",
  "剽蹂": "piāo,róu",
  "剽轻": "piāo,qīng",
  "剽迫": "piāo,pò",
  "剽遬": "piāo,sù",
  "剽锐": "piāo,ruì",
  "剽闻": "piāo,wén",
  "剿拾": "chāo,shí",
  "剿袭": "chāo,xí",
  "剿说": "chāo,shuō",
  "劁折": "qiāo,shé",
  "劄子": "zhá,zǐ",
  "劄记": "zhá,jì",
  "劈剥": "pī,bāo",
  "劈劈啪啪地响": "pī,pī,pā,pā,de,xiǎng",
  "劈叉": "pǐ,chà",
  "劈哩叭啦": "pī,lǐ,bā,lā",
  "劈哩啪啦": "pī,lǐ,pā,lā",
  "劈啪地响": "pī,pā,de,xiǎng",
  "劈成": "pǐ,chéng",
  "劈木头": "pī,mù,tou",
  "劈柴": "pǐ,chái",
  "劈柴刀": "pǐ,chái,dāo",
  "劈着": "pī,zhe",
  "劈腿": "pǐ,tuǐ",
  "劈角儿": "pī,jué,ér",
  "劈账": "pǐ,zhàng",
  "劈里啪啦": "pī,lǐ,pā,la",
  "劐弄": "huō,leng",
  "劓剥": "yì,bāo",
  "劖削": "chán,xuē",
  "劘剥": "mó,bāo",
  "力帆": "lì,fān",
  "力拼": "lì,pàn",
  "力有未逮": "lì,yǒu,wèi,dǎi",
  "力气": "lì,qi",
  "力能扛鼎": "lì,néng,gāng,dǐng",
  "力薄": "lì,bó",
  "力透纸背": "lì,tòu,zhǐ,bèi",
  "劝哄": "quàn,hǒng",
  "劝百讽一": "quàn,bǎi,fěng,yī",
  "劝讽": "quàn,fěng",
  "劝降": "quàn,xiáng",
  "办不到": "bàn,bú,dào",
  "办差": "bàn,chāi",
  "功不可没": "gōng,bù,kě,mò",
  "功夫流感": "gōng,fu,liú,gǎn",
  "功夫片儿": "gōng,fū,piān,er",
  "功夫球": "gōng,fu,qiú",
  "功夫病毒": "gōng,fu,bìng,dú",
  "功干": "gōng,gàn",
  "功薄蝉翼": "gōng,bó,chán,yì",
  "功调": "gōng,diào",
  "功载": "gōng,zǎi",
  "功遂身退": "gōng,suí,shēn,tuì",
  "加俾额尔": "jiā,bǐ,é,ěr",
  "加倍地": "jiā,bèi,de",
  "加冠": "jiā,guān",
  "加劲儿": "jiā,jìn,er",
  "加哩": "jiā,lǐ",
  "加地夫": "jiā,de,fū",
  "加害地": "jiā,hài,de",
  "加强地": "jiā,qiáng,de",
  "加德满都": "jiā,dé,mǎn,dū",
  "加快地": "jiā,kuài,de",
  "加数": "jiā,shù",
  "加班地": "jiā,bān,de",
  "加的斯": "jiā,dì,sī",
  "加缪": "jiā,miù",
  "加速地": "jiā,sù,de",
  "务川仡佬族苗族自治县": "wù,chuān,gē,lǎo,zú,miáo,zú,zì,zhì,xiàn",
  "务必地": "wù,bì,de",
  "劣迹昭着": "liè,jì,zhāo,zhe",
  "动不动就生气": "dòng,bu,dòng,jiù,shēng,qì",
  "动人地": "dòng,rén,de",
  "动力反应堆": "dòng,lì,fǎn,yìng,duī",
  "动劲儿": "dòng,jìn,er",
  "动听地": "dòng,tīng,de",
  "动嘴皮儿": "dòng,zuǐ,pí,er",
  "动嘴皮子": "dòng,zuǐ,pí,zi",
  "动弹不得": "dòng,tan,bu,dé",
  "动态地": "dòng,tài,de",
  "动态更新": "dòng,tài,gēng,xīn",
  "动情地": "dòng,qíng,de",
  "动情地说": "dòng,qíng,de,shuō",
  "动掸": "dòng,chán",
  "动摇地": "dòng,yáo,de",
  "动摇着地": "dòng,yáo,zhe,de",
  "动物学地": "dòng,wù,xué,de",
  "动画影片": "dòng,huà,yǐng,piān",
  "动画片": "dòng,huà,piān",
  "动画片儿": "dòng,huà,piān,er",
  "动粘": "dòng,zhān",
  "动脑子": "dòng,nǎo,zi",
  "动词地": "dòng,cí,de",
  "动词重叠": "dòng,cí,chóng,dié",
  "助人为乐": "zhù,rén,wéi,lè",
  "助人为快乐之本": "zhù,rén,wéi,kuài,lè,zhī,běn",
  "助天为虐": "zhù,tiān,wéi,nüè",
  "助桀为恶": "zhù,jié,wéi,è",
  "助桀为暴": "zhù,jié,wéi,bào",
  "助桀为虐": "zhù,jié,wéi,nüè",
  "助纣为虐": "zhù,zhòu,wéi,nüè",
  "助长": "zhù,zhǎng",
  "努力地": "nǔ,lì,de",
  "努力地做": "nǔ,lì,de,zuò",
  "努力地活下去": "nǔ,lì,de,huó,xià,qù",
  "努劲儿": "nǔ,jìn,er",
  "努嘴儿": "nǔ,zuǐ,er",
  "劫剥": "jié,bāo",
  "劫剽": "jié,piāo",
  "劫摽": "jié,biāo",
  "劫数": "jié,shù",
  "劫数难逃": "jié,shù,nán,táo",
  "劫舍": "jié,shè",
  "劫难": "jié,nàn",
  "励磁地": "lì,cí,de",
  "励精更始": "lì,jīng,gēng,shǐ",
  "劲儿": "jìn,er",
  "劲兵": "jìng,bīng",
  "劲卒": "jìng,zú",
  "劲吹": "jìng,chuī",
  "劲射": "jìng,shè",
  "劲峭": "jìng,qiào",
  "劲度系数": "jìn,dù,xì,shù",
  "劲急": "jìng,jí",
  "劲拔": "jìng,bá",
  "劲挺": "jìng,tǐng",
  "劲敌": "jìng,dí",
  "劲旅": "jìng,lǚ",
  "劲松": "jìng,sōng",
  "劲烈": "jìng,liè",
  "劲爆": "jìng,bào",
  "劲直": "jìng,zhí",
  "劲舞": "jìng,wǔ",
  "劲草": "jìng,cǎo",
  "劲风": "jìng,fēng",
  "劲骨丰肌": "jìng,gǔ,fēng,jī",
  "劳什子": "láo,shí,zǐ",
  "劳什骨子": "láo,shí,gǔ,zi",
  "劳务合同": "láo,wù,hé,tong",
  "劳动二重性": "láo,dòng,èr,chóng,xìng",
  "劳动合同": "láo,dòng,hé,tong",
  "劳劳叨叨": "láo,lao,dāo,dāo",
  "劳劳嚷嚷": "láo,láo,rāng,rang",
  "劳累": "láo,lèi",
  "势利地": "shì,lì,de",
  "势利小人": "shì,li,xiǎo,rén",
  "势力": "shì,li",
  "势子": "shì,zi",
  "势煞": "shì,shà",
  "勀剥": "kè,bāo",
  "勃兴": "bó,xīng",
  "勃缪": "bó,miù",
  "勃艮第": "bó,gěn,dì",
  "勇剽": "yǒng,piāo",
  "勇干": "yǒng,gàn",
  "勇敢地": "yǒng,gǎn,de",
  "勇敢地与": "yǒng,gǎn,de,yǔ",
  "勇敢地对": "yǒng,gǎn,de,duì",
  "勇敢地对付": "yǒng,gǎn,de,duì,fù",
  "勇敢地迎接": "yǒng,gǎn,de,yíng,jiē",
  "勇敢地面对": "yǒng,gǎn,de,miàn,duì",
  "勇武地": "yǒng,wǔ,de",
  "勇气地": "yǒng,qì,de",
  "勇猛地": "yǒng,měng,de",
  "勉为其难": "miǎn,wéi,qí,nán",
  "勉从地": "miǎn,cóng,de",
  "勉力而为": "miǎn,lì,ér,wéi",
  "勉勉强强": "miǎn,miǎn,qiǎng,qiáng",
  "勉强": "miǎn,qiǎng",
  "勉强地": "miǎn,qiǎng,de",
  "勉强地去": "miǎn,qiǎng,de,qù",
  "勉强地在": "miǎn,qiǎng,de,zài",
  "勉强地笑道": "miǎn,qiǎng,de,xiào,dào",
  "𠡠书": "lài,shū",
  "𠡠使": "lài,shǐ",
  "𠡠勒": "lài,lè",
  "𠡠厉": "lài,lì",
  "𠡠命": "lài,mìng",
  "𠡠戒": "lài,jiè",
  "𠡠牒": "lài,dié",
  "𠡠葬": "lài,zàng",
  "𠡠诫": "lài,jiè",
  "𠡠身": "lài,shēn",
  "𠡠额": "lài,é",
  "勒住": "lēi,zhù",
  "勒勒车": "lēi,lēi,chē",
  "勒威耶": "lè,wēi,yē",
  "勒杀": "lēi,shā",
  "勒死": "lēi,sǐ",
  "勒毙": "lēi,bì",
  "勒索地": "lè,suǒ,de",
  "勒紧": "lēi,jǐn",
  "勒紧裤带": "lēi,jǐn,kù,dài",
  "勒维夫": "lè,wéi,fu",
  "勒脖子": "lēi,bó,zi",
  "勘校": "kān,jiào",
  "勤俭为服务之本": "qín,jiǎn,wéi,fú,wù,zhī,běn",
  "勤劳地": "qín,láo,de",
  "勤劳地干": "qín,láo,de,gàn",
  "勤勉地": "qín,miǎn,de",
  "勤奋地": "qín,fèn,de",
  "勤干": "qín,gàn",
  "勤快地": "qín,kuài,de",
  "勤朴": "qín,piáo",
  "勤黾": "qín,miǎn",
  "勺口儿": "sháo,kǒu,er",
  "勺子": "sháo,zi",
  "勾划": "gōu,huà",
  "勾剥": "gōu,bāo",
  "勾哄": "gōu,hǒng",
  "勾干": "gōu,gàn",
  "勾引地": "gōu,yǐn,de",
  "勾当": "gòu,dàng",
  "勾缝": "gōu,fèng",
  "勾股数": "gōu,gǔ,shù",
  "勾肩搭背": "gōu,jiān,dā,bèi",
  "勾达甲坼": "gōu,dá,jiá,chè",
  "匀厚地涂": "yún,hòu,de,tú",
  "匀实": "yún,shi",
  "匀称": "yún,chèn",
  "匀称地": "yún,chèn,de",
  "匄𰷞": "gài,tè",
  "包圆儿": "bāo,yuán,er",
  "包在我身上": "bāo,zài,wǒ,shēn,shang",
  "包子": "bāo,zi",
  "包子有肉不在褶上": "bāo,zi,yǒu,ròu,bù,zài,zhě,shàng",
  "包弹": "bāo,dàn",
  "包括地": "bāo,kuò,de",
  "包活儿": "bāo,huó,er",
  "包片儿": "bāo,piān,er",
  "包背装": "bāo,bèi,zhuāng",
  "包衣种子": "bāo,yī,zhǒng,zi",
  "包袱": "bāo,fu",
  "包袱底儿": "bāo,fu,dǐ,er",
  "包袱皮儿": "bāo,fu,pí,er",
  "包饺子": "bāo,jiǎo,zi",
  "匆匆地": "cōng,cōng,de",
  "匆匆地看看": "cōng,cōng,de,kàn,kàn",
  "匆匆地走": "cōng,cōng,de,zǒu",
  "匆匆忙忙地": "cōng,cōng,máng,máng,de",
  "匆卒": "cōng,cù",
  "匆忙地": "cōng,máng,de",
  "匆忙地做": "cōng,máng,de,zuò",
  "匍匐地": "pú,fú,de",
  "匕䇲": "bǐ,jiā",
  "化为乌有": "huà,wéi,wū,yǒu",
  "化为泡影": "huà,wéi,pāo,yǐng",
  "化为灰烬": "huà,wéi,huī,jìn",
  "化名地": "huà,míng,de",
  "化子": "huā,zi",
  "化学反应": "huà,xué,fǎn,yìng",
  "化学地": "huà,xué,de",
  "化学弹药": "huà,xué,dàn,yào",
  "化学成分": "huà,xué,chéng,fèn",
  "化学航弹": "huà,xué,háng,dàn",
  "化干戈为玉帛": "huà,gān,gē,wéi,yù,bó",
  "化敌为友": "huà,dí,wéi,yǒu",
  "化整为零": "huà,zhěng,wéi,líng",
  "化枭为鸠": "huà,xiāo,wéi,jiū",
  "化石地": "huà,shí,de",
  "化脓地": "huà,nóng,de",
  "化腐为奇": "huà,fǔ,wéi,qí",
  "化腐朽为神奇": "huà,fǔ,xiǔ,wéi,shén,qí",
  "化覃": "huà,qín",
  "化险为夷": "huà,xiǎn,wéi,yí",
  "化零为整": "huà,líng,wéi,zhěng",
  "化鸱为凤": "huà,chī,wéi,fèng",
  "北京大兴国际机场": "běi,jīng,dà,xīng,guó,jì,jī,chǎng",
  "北卷": "běi,juàn",
  "北庭都护府": "běi,tíng,dū,hù,fǔ",
  "北斗": "běi,dǒu",
  "北斗七星": "běi,dǒu,qī,xīng",
  "北斗之尊": "běi,dǒu,zhī,zūn",
  "北斗卫星导航系统": "běi,dǒu,wèi,xīng,dǎo,háng,xì,tǒng",
  "北斗星": "běi,dǒu,xīng",
  "北斗镇": "běi,dǒu,zhèn",
  "北朝鲜": "běi,cháo,xiǎn",
  "北燕": "běi,yān",
  "北碑南帖": "běi,bēi,nán,tiē",
  "北翟": "běi,zhái",
  "北蕃": "běi,fān",
  "北貉": "běi,mò",
  "北辕适楚": "běi,yuán,shì,chǔ",
  "北辕适粤": "běi,yuán,shì,yuè",
  "北边儿": "běi,biān,er",
  "北阙": "běi,què",
  "匙子": "chí,zi",
  "匡其不逮": "kuāng,qí,bù,dǎi",
  "匡𠡠": "kuāng,lài",
  "匡捄": "kuāng,jū",
  "匡救弥缝": "kuāng,jiù,mí,fèng",
  "匡裨": "kuāng,bì",
  "匣儿": "xiá,er",
  "匣子": "xiá,zi",
  "匣子枪": "xiá,zi,qiāng",
  "匣子炮": "xiá,zi,pào",
  "匣里龙吟": "xiá,lǐ,lóng,yīn",
  "匪什": "fěi,shí",
  "匪伊朝夕": "fěi,yī,zhāo,xī",
  "匪匪翼翼": "féi,féi,yì,yì",
  "匪夷匪惠": "fěi,jí,fěi,huì",
  "匮椟": "guì,dú",
  "匮藏": "guì,cáng",
  "匹处": "pǐ,chǔ",
  "匹头": "pǐ,tou",
  "匹马只轮": "pǐ,mǎ,zhī,lún",
  "区划": "qū,huà",
  "区别地": "qū,bié,de",
  "区区仆仆": "qū,qū,pú,pú",
  "区区将将": "qū,qū,qiāng,qiāng",
  "区区惓惓": "qū,qū,quán,quán",
  "区域地": "qū,yù,de",
  "区域网路": "qū,yù,wǎng,luò",
  "区处": "qū,chǔ",
  "区舍": "qū,shè",
  "区长": "qū,zhǎng",
  "医之好治不病以为功": "yī,zhī,hào,zhì,bù,bìng,yǐ,wéi,gōng",
  "医学地": "yī,xué,de",
  "医术地": "yī,shù,de",
  "医疗地": "yī,liáo,de",
  "匾扎": "biǎn,zhā",
  "匾柎": "biǎn,fù",
  "匿名地": "nì,míng,de",
  "匿𫍙": "nì,yí",
  "十一倍地": "shí,yí,bèi,de",
  "十一点": "shí,yì,diǎn",
  "十一点钟": "shí,yì,diǎn,zhōng",
  "十七帖": "shí,qī,tiē",
  "十三省": "shí,sān,xǐng",
  "十三调": "shí,sān,diào",
  "十不闲莲花落": "shí,bù,xián,lián,huā,lào",
  "十二处": "shí,èr,chǔ",
  "十二时辰": "shí,èr,shí,chen",
  "十二生肖": "shí,èr,shēng,xiào",
  "十二相属": "shí,èr,xiāng,zhǔ",
  "十二舍": "shí,èr,shè",
  "十二调": "shí,èr,diào",
  "十二重楼": "shí,èr,chóng,lóu",
  "十倍地": "shí,bèi,de",
  "十八侯": "shí,bā,hòu",
  "十八子儿": "shí,bā,zǐ,er",
  "十八层地": "shí,bā,céng,de",
  "十分位数": "shí,fēn,wèi,shù",
  "十分地": "shí,fēn,de",
  "十分地关注": "shí,fēn,de,guān,zhù",
  "十分地矛盾": "shí,fēn,de,máo,dùn",
  "十刹海": "shí,shā,hǎi",
  "十四行诗": "shí,sì,háng,shī",
  "十围五攻": "shí,wén,wǔ,gōng",
  "十大曲": "shí,dà,qū",
  "十夫楺椎": "shí,fū,rǒu,zhuī",
  "十头添撇": "shí,tóu,tiān,piě",
  "十字形地": "shí,zì,xíng,de",
  "十字状地": "shí,zì,zhuàng,de",
  "十字转门": "shí,zì,zhuàn,mén",
  "十年九潦": "shí,nián,jiǔ,liáo",
  "十拏九稳": "shí,mù,jiǔ,wěn",
  "十拗": "shí,niù",
  "十指露缝": "shí,zhǐ,lù,fèng",
  "十捉九着": "shí,zhuō,jiǔ,zhe",
  "十数": "shí,shù",
  "十行": "shí,háng",
  "十行俱下": "shí,háng,jù,xià",
  "十行本": "shí,háng,běn",
  "十行诏": "shí,háng,zhào",
  "十足地": "shí,zú,de",
  "十载寒窗": "shí,zǎi,hán,chuāng",
  "十进对数": "shí,jìn,duì,shù",
  "十郎八当": "shí,láng,bā,dàng",
  "十里堡": "shí,lǐ,pù",
  "十钻": "shí,zuàn",
  "十魔九难": "shí,mó,jiǔ,nàn",
  "千乘": "qiān,shèng",
  "千乘不轻": "qiān,shèng,bù,qīng",
  "千乘之国": "qiān,shèng,zhī,guó",
  "千乘之王": "qiān,shèng,zhī,wáng",
  "千了万当": "qiān,le,wàn,dàng",
  "千了百当": "qiān,liǎo,bǎi,dàng",
  "千倍地": "qiān,bèi,de",
  "千儿八百": "qiān,er,bā,bǎi",
  "千古绝调": "qiān,gǔ,jué,diào",
  "千夫长": "qiān,fū,zhǎng",
  "千妥万当": "qiān,tuǒ,wàn,dàng",
  "千差万别": "qiān,chā,wàn,bié",
  "千帆": "qiān,fān",
  "千年万载": "qiān,nián,wàn,zǎi",
  "千年调": "qiān,nián,diào",
  "千户侯": "qiān,hù,hòu",
  "千折": "qiān,shé",
  "千斤重担": "qiān,jīn,zhòng,dàn",
  "千百年地": "qiān,bǎi,nián,de",
  "千石": "qiān,dàn",
  "千磨百折": "qiān,mó,bǎi,shé",
  "千载": "qiān,zǎi",
  "千载一会": "qiān,zǎi,yī,huì",
  "千载一圣": "qiān,zǎi,yī,shèng",
  "千载一弹": "qiān,zǎi,yī,dàn",
  "千载一日": "qiān,zǎi,yī,rì",
  "千载一时": "qiān,zǎi,yī,shí",
  "千载一逢": "qiān,zǎi,yī,féng",
  "千载一遇": "qiān,zǎi,yī,yù",
  "千载奇遇": "qiān,zǎi,qí,yù",
  "千载恨": "qiān,zǎi,hèn",
  "千载难逢": "qiān,zǎi,nán,féng",
  "千载难遇": "qiān,zǎi,nán,yù",
  "千里之堤": "qiān,lǐ,zhī,dī",
  "千金堨": "qiān,jīn,ài",
  "千金子": "qiān,jīn,zi",
  "千金比屋": "qian,jing,bi,wu",
  "千钧一发": "qiān,jūn,yī,fà",
  "千钧为轻": "qiān,jūn,wéi,qīng",
  "千骑": "qiān,jì",
  "升元帖": "shēng,yuán,tiē",
  "升冠": "shēng,guān",
  "升平帖": "shēng,píng,tiē",
  "升斗": "shēng,dǒu",
  "升斗小民": "shēng,dǒu,xiǎo,mín",
  "升调": "shēng,diào",
  "午觉": "wǔ,jiào",
  "半丝半缕": "bàn,sī,bàn,lǜ",
  "半个": "bàn,ge",
  "半个人": "bàn,ge,rén",
  "半乳糖血症": "bàn,rǔ,táng,xuè,zhèng",
  "半分儿": "bàn,fēn,er",
  "半吊子": "bàn,diào,zi",
  "半吐半露": "bàn,tǔ,bàn,lù",
  "半周地": "bàn,zhōu,de",
  "半夜三更": "bàn,yè,sān,gēng",
  "半官方地": "bàn,guān,fāng,de",
  "半宿": "bàn,xiǔ",
  "半对数": "bàn,duì,shù",
  "半小时地": "bàn,xiǎo,shí,de",
  "半开地": "bàn,kāi,de",
  "半开玩笑地说": "bàn,kāi,wán,xiào,de,shuō",
  "半开门儿": "bàn,kāi,mén,er",
  "半意识地": "bàn,yì,shí,de",
  "半截汉子": "bàn,jié,hàn,zi",
  "半打": "bàn,dá",
  "半折": "bàn,shé",
  "半拉": "bàn,lǎ",
  "半拉子": "bàn,lǎ,zǐ",
  "半拉架": "bàn,lǎ,jià",
  "半数": "bàn,shù",
  "半数以上": "bàn,shù,yǐ,shàng",
  "半更": "bàn,gēng",
  "半更子": "bàn,gēng,zǐ",
  "半正式地": "bàn,zhèng,shì,de",
  "半点儿": "bàn,diǎn,er",
  "半瓶子醋": "bàn,píng,zi,cù",
  "半臂背子": "bàn,bì,bēi,zi",
  "半自觉地": "bàn,zì,jué,de",
  "半舍": "bàn,shè",
  "半路地": "bàn,lù,de",
  "半身不遂": "bàn,shēn,bù,suí",
  "半载": "bàn,zǎi",
  "半辈子": "bàn,bèi,zi",
  "半透明地": "bàn,tòu,míng,de",
  "半道儿": "bàn,dào,er",
  "半部论语": "bàn,bù,lún,yǔ",
  "半部论语治天下": "bàn,bù,lún,yǔ,zhì,tiān,xià",
  "华丝葛": "huá,sī,gě",
  "华为": "huá,wéi",
  "华丽地": "huá,lì,de",
  "华亭鹤": "huà,tíng,hè",
  "华亭鹤唳": "huà,tíng,hè,lì",
  "华佗": "huà,tuó",
  "华俗气地": "huá,sú,qì,de",
  "华兴会": "huá,xīng,huì",
  "华冠": "huá,guān",
  "华冠丽服": "huá,guān,lì,fú",
  "华南冠纹柳莺": "huá,nán,guān,wén,liǔ,yīng",
  "华发": "huá,fà",
  "华叶": "huā,yè",
  "华国锋": "huà,guó,fēng",
  "华夏银行": "huá,xià,yín,háng",
  "华实": "huā,shí",
  "华山": "huà,shān",
  "华山畿": "huà,shān,jī",
  "华嵩": "huà,sōng",
  "华扁": "huà,biǎn",
  "华椷": "huá,hán",
  "华氏温度计": "huà,shì,wēn,dù,jì",
  "华纳音乐集团": "huá,nà,yīn,yuè,jí,tuán",
  "华罗庚": "huà,luó,gēng",
  "华美地": "huá,měi,de",
  "华胜": "huā,shèng",
  "华𰮇": "huá,wǔ",
  "华英": "huā,yīng",
  "华贵地": "huá,guì,de",
  "华达呢": "huá,dá,ní",
  "华陀": "huà,tuó",
  "华龙": "huà,lóng",
  "华龙区": "huà,lóng,qū",
  "协作地": "xié,zuò,de",
  "协力地": "xié,lì,de",
  "协同地": "xié,tóng,de",
  "协应": "xié,yìng",
  "协方差": "xié,fāng,chā",
  "协调地": "xié,tiáo,de",
  "卑俗地": "bēi,sú,de",
  "卑削": "bēi,xuē",
  "卑劣地": "bēi,liè,de",
  "卑宫菲食": "bēi,gōng,fěi,shí",
  "卑庳": "bēi,bì",
  "卑微地": "bēi,wēi,de",
  "卑恭屈节地": "bēi,gōng,qū,jié,de",
  "卑贱地": "bēi,jiàn,de",
  "卑鄙地": "bēi,bǐ,de",
  "卑陋地": "bēi,lòu,de",
  "卒中": "cù,zhòng",
  "卒乘": "zú,shèng",
  "卒卒": "cù,cù",
  "卒更": "zú,gēng",
  "卒然": "cù,rán",
  "卓冠": "zhuó,guān",
  "卓着": "zhuó,zhe",
  "卓越地": "zhuó,yuè,de",
  "卓跞": "zhuó,luò",
  "卓锥": "zhuō,zhuī",
  "单丛": "dān,cōng",
  "单个": "dān,ge",
  "单于": "chán,yú",
  "单人地": "dān,rén,de",
  "单县": "shàn,xiàn",
  "单反相机": "dān,fǎn,xiàng,jī",
  "单口相声": "dān,kǒu,xiàng,shēng",
  "单叶双曲面": "dān,yè,shuāng,qū,miàn",
  "单处": "dān,chǔ",
  "单夫只妇": "dān,fū,zhī,fù",
  "单姓": "shàn,xìng",
  "单子": "dān,zi",
  "单子叶植物": "dān,zi,yè,zhí,wù",
  "单帖": "dān,tiē",
  "单干": "dān,gàn",
  "单干户": "dān,gàn,hù",
  "单弦牌子曲": "dān,xián,pái,zi,qǔ",
  "单房差": "dān,fáng,chā",
  "单手地": "dān,shǒu,de",
  "单挑": "dān,tiǎo",
  "单数": "dān,shù",
  "单数地": "dān,shù,de",
  "单方恐吓": "dān,fāng,kǒng,hè",
  "单方面地": "dān,fāng,miàn,de",
  "单点地": "dān,diǎn,de",
  "单父": "shàn,fù",
  "单父琴": "chán,fù,qín",
  "单独地": "dān,dú,de",
  "单相": "dān,xiàng",
  "单眼相机": "dān,yǎn,xiàng,jī",
  "单红帖": "dān,hóng,tiē",
  "单纯地": "dān,chún,de",
  "单纯地去": "dān,chún,de,qù",
  "单纯地追求": "dān,chún,de,zhuī,qiú",
  "单缞": "dān,shuāi",
  "单老": "shàn,lǎo",
  "单耳地": "dān,ěr,de",
  "单薄": "dān,bó",
  "单调": "dān,diào",
  "单调乏味": "dān,diào,fá,wèi",
  "单调函数": "dān,diào,hán,shù",
  "单调地": "dān,diào,de",
  "单调地唱": "dān,diào,de,chàng",
  "单镜反光相机": "dān,jìng,fǎn,guāng,xiàng,jī",
  "单间差": "dān,jiān,chā",
  "单阏": "chán,yè",
  "单雄": "shàn,xióng",
  "单露": "dān,lù",
  "卖关子": "mài,guān,zi",
  "卖力地": "mài,lì,de",
  "卖力气": "mài,lì,qi",
  "卖命地干": "mài,mìng,de,gàn",
  "卖嘴皮子": "mài,zuǐ,pí,zi",
  "卖折": "mài,shé",
  "卖拳头": "mài,quán,tou",
  "卖文为生": "mài,wén,wéi,shēng",
  "卖服": "mài,fù",
  "卖查梨": "mài,zhā,lí",
  "卖猪仔": "mài,zhū,zǎi",
  "卖相": "mài,xiàng",
  "卖蒙懂": "mài,měng,dǒng",
  "卖解": "mài,xiè",
  "卖镜重圆": "mài,jìng,chóng,yuán",
  "卖面子": "mài,miàn,zi",
  "南为": "nán,wéi",
  "南冠": "nán,guān",
  "南冠客": "nán,guān,kè",
  "南冠楚囚": "nán,guān,chǔ,qiú",
  "南北卷": "nán,běi,juàn",
  "南华老仙": "nán,huà,lǎo,xiān",
  "南卷": "nán,juàn",
  "南味儿": "nán,wèi,er",
  "南宫舍人": "nán,gōng,shè,rén",
  "南宰相府": "nán,zǎi,xiàng,fǔ",
  "南州冠冕": "nán,zhōu,guān,miǎn",
  "南无": "nā,mó",
  "南无阿弥陀佛": "nā,mó,ē,mí,tuó,fó",
  "南朝鲜": "nán,cháo,xiǎn",
  "南梆子": "nán,bāng,zi",
  "南海子": "nán,hǎi,zi",
  "南班子": "nán,bān,zi",
  "南监本": "nán,jiàn,běn",
  "南省舍人": "nán,shěng,shè,rén",
  "南箕北斗": "nán,jī,běi,dǒu",
  "南腔北调": "nán,qiāng,běi,diào",
  "南蕃": "nán,fān",
  "南诏画卷": "nán,zhào,huà,juàn",
  "南贩北贾": "nán,fàn,běi,gǔ",
  "南边儿": "nán,bian,er",
  "南郭处士": "nán,guō,chǔ,shì",
  "南阳三葛": "nán,yáng,sān,gě",
  "博兴": "bó,xīng",
  "博兴县": "bó,xīng,xiàn",
  "博学地": "bó,xué,de",
  "博尔塔拉蒙古自治州": "bó,ěr,tǎ,lā,měng,gǔ,zì,zhì,zhōu",
  "博弈犹贤": "bō,yì,yóu,xián",
  "博得": "bó,de",
  "博格多汗宫": "bó,gé,duō,hán,gōng",
  "博浪椎": "bó,làng,chuí",
  "博爱地": "bó,ài,de",
  "博识地": "bó,shí,de",
  "博闻强识": "bó,wén,qiáng,zhì",
  "卜卜地": "bo,bo,de",
  "卜卜米": "bo,bo,mǐ",
  "卜占": "bǔ,zhān",
  "卜数": "bǔ,shù",
  "卜数只偶": "bǔ,shù,zhī,ǒu",
  "卜数师": "bǔ,shù,shī",
  "卞庄子": "biàn,zhuāng,zi",
  "卞庄子刺虎": "biàn,zhuāng,zi,cì,hǔ",
  "卟啉": "bǔ,lín",
  "占为己有": "zhàn,wéi,jǐ,yǒu",
  "占主导地": "zhàn,zhǔ,dǎo,de",
  "占优势地": "zhàn,yōu,shì,de",
  "占便宜": "zhàn,pián,yí",
  "占俾": "zhàn,bǐ",
  "占卜": "zhān,bǔ",
  "占卦": "zhān,guà",
  "占地儿": "zhàn,dì,er",
  "占地方": "zhàn,dì,fang",
  "占地面积": "zhàn,dì,miàn,ji",
  "占多数": "zhàn,duō,shù",
  "占山为王": "zhàn,shān,wéi,wáng",
  "占排场": "zhàn,pái,chang",
  "占数": "zhàn,shù",
  "占星": "zhān,xīng",
  "占星学": "zhān,xīng,xué",
  "占星家": "zhān,xīng,jiā",
  "占星师": "zhān,xīng,shī",
  "占星术": "zhān,xīng,shù",
  "占有地": "zhàn,yǒu,de",
  "占梦": "zhān,mèng",
  "占着": "zhàn,zhe",
  "占着茅坑不拉屎": "zhān,zhe,máo,kēng,bù,lā,shǐ",
  "占筮": "zhān,shì",
  "占课": "zhān,kè",
  "占风使帆": "zhān,fēng,shǐ,fān",
  "占风望气": "zhān,fēng,wàng,qì",
  "占风铎": "zhān,fēng,duó",
  "卡具": "qiǎ,jù",
  "卡地根郡": "kǎ,de,gēn,jùn",
  "卡塔地响": "kǎ,tǎ,de,xiǎng",
  "卡壳": "qiǎ,ké",
  "卡子": "qiǎ,zi",
  "卡弹": "kǎ,dàn",
  "卡扎菲": "kǎ,zhā,fēi",
  "卡拉什尼科夫": "kǎ,lā,shí,ní,kē,fū",
  "卡拉奇那": "kǎ,lā,jī,nà",
  "卡拉季奇": "kǎ,lā,jì,jī",
  "卡文迪什": "kǎ,wén,dí,shí",
  "卡波耶拉": "kǎ,bō,yē,lā",
  "卡洛娜": "kǎ,luò,nà",
  "卡盘": "qiǎ,pán",
  "卡秋莎": "kǎ,qiū,shā",
  "卡脖子": "qiǎ,bó,zi",
  "卡西米尔效应": "kǎ,xī,mǐ,ěr,xiào,yìng",
  "卡门柏乳酪": "kǎ,mén,bó,rǔ,lào",
  "卢塞恩": "lú,sài,ēn",
  "卢牟": "lú,mù",
  "卢瑟福粒子散射实验": "lú,sè,fú,lì,zǐ,sǎn,shè,shí,yàn",
  "卤剽": "lǔ,piāo",
  "卤掠": "lǔ,lüě",
  "卤楯": "lǔ,dùn",
  "卦铺": "guà,pù",
  "卧处": "wò,chǔ",
  "卧式镗床": "wò,shì,táng,chuáng",
  "卧果儿": "wò,guǒ,er",
  "卧铺": "wò,pù",
  "卫氏朝鲜": "wèi,shì,cháo,xiǎn",
  "卫满朝鲜": "wèi,mǎn,cháo,xiǎn",
  "卫生地": "wèi,shēng,de",
  "卬卬": "áng,áng",
  "卬头阔步": "áng,tóu,kuò,bù",
  "卬州": "áng,zhōu",
  "卬曲": "áng,qǔ",
  "卬望": "áng,wàng",
  "卬然": "áng,rán",
  "卬燥": "áng,zào",
  "卬给": "áng,gěi",
  "卬角": "áng,jiǎo",
  "卬贵": "áng,guì",
  "卬食": "áng,shí",
  "卬首信眉": "áng,shǒu,shēn,méi",
  "卬鼻": "áng,bí",
  "卯不对榫": "mǎo,bú,duì,sǔn",
  "印儿": "yìn,er",
  "印刷上地": "yìn,shuā,shàng,de",
  "印古什": "yìn,gǔ,shí",
  "印子": "yìn,zi",
  "印子钱": "yìn,zi,qián",
  "印子铺": "yìn,zǐ,pù",
  "印度音乐": "yìn,dù,yīn,yuè",
  "印把": "yìn,bà",
  "印把子": "yìn,bà,zi",
  "印数": "yìn,shù",
  "印相纸": "yìn,xiàng,zhǐ",
  "危于累卵": "wēi,yú,lěi,luǎn",
  "危如朝露": "wēi,rú,zhāo,lù",
  "危如累卵": "wēi,rú,lěi,luǎn",
  "危机重重": "wēi,jī,chóng,chóng",
  "危若朝露": "wēi,ruò,zhāo,lù",
  "危险地": "wēi,xiǎn,de",
  "危险地方": "wēi,xiǎn,de,fāng",
  "危难": "wēi,nàn",
  "即为": "jí,wéi",
  "即兴地": "jí,xìng,de",
  "即刻地": "jí,kè,de",
  "即墨侯": "jí,mò,hòu",
  "即将着地": "jí,jiāng,zhe,de",
  "即时地": "jí,shí,de",
  "却不好好地": "què,bù,hǎo,hǎo,de",
  "却不幸地": "què,bù,xìng,de",
  "却倒": "què,dào",
  "却倔犟地": "què,juè,jiàng,de",
  "却冠": "què,guān",
  "却冷酷地": "què,lěng,kù,de",
  "却敌冠": "què,dí,guān",
  "却整齐地": "què,zhěng,qí,de",
  "却更多地": "què,gèng,duō,de",
  "却深深地": "què,shēn,shēn,de",
  "却清楚地": "què,qīng,chǔ,de",
  "却热情地": "què,rè,qíng,de",
  "却纔": "què,shān",
  "却老还童": "què,lǎo,huán,tóng",
  "却背": "què,bèi",
  "却舍": "què,shè",
  "却隐隐地": "què,yǐn,yǐn,de",
  "却非冠": "què,fēi,guān",
  "却默默地": "què,mò,mò,de",
  "卵泡": "luǎn,pāo",
  "卵覆鸟飞": "luán,fù,niǎo,fēi",
  "卷卷": "juàn,juàn",
  "卷发": "juǎn,fà",
  "卷发器": "juǎn,fà,qì",
  "卷土重来": "juǎn,tǔ,chóng,lái",
  "卷地皮": "juàn,dì,pí",
  "卷子": "juǎn,zi",
  "卷子本": "juǎn,zi,běn",
  "卷宗": "juàn,zōng",
  "卷层云": "juàn,céng,yún",
  "卷帘": "juàn,lián",
  "卷帙": "juàn,zhì",
  "卷帙浩繁": "juàn,zhì,hào,fán",
  "卷席而居": "juàn,xí,ér,jū",
  "卷心菜": "juàn,xīn,cài",
  "卷曲": "juǎn,qū",
  "卷柏": "juàn,bǎi",
  "卷甲束兵": "juàn,jiǎ,shù,bīng",
  "卷甲衔枚": "juàn,jiǎ,xián,méi",
  "卷甲韬戈": "juàn,jiǎ,tāo,gē",
  "卷积云": "juàn,jī,yún",
  "卷筒纸": "juàn,tǒng,zhǐ",
  "卷缩": "juàn,suō",
  "卷轴": "juàn,zhóu",
  "卷面": "juàn,miàn",
  "卷须": "juàn,xū",
  "卸帆": "xiè,fān",
  "卸磨杀驴": "xiè,mò,shā,lǘ",
  "卸肩儿": "xiè,jiān,er",
  "卸载": "xiè,zǎi",
  "卿大夫": "qīng,dài,fū",
  "卿相": "qīng,xiàng",
  "厂长": "chǎng,zhǎng",
  "厄莎": "è,shā",
  "厄难": "è,nàn",
  "厅长": "tīng,zhǎng",
  "历史地": "lì,shǐ,de",
  "历史背景": "lì,shǐ,bèi,jǐng",
  "历史重演": "lì,shǐ,chóng,yǎn",
  "历害地": "lì,hài,de",
  "历精为治": "lì,jīng,wéi,zhì",
  "历蓂": "lì,mì",
  "历载": "lì,zǎi",
  "厈厈": "hǎn,hǎn",
  "厉声地说": "lì,shēng,de,shuō",
  "厉害": "lì,hai",
  "厉害地": "lì,hài,de",
  "厉禁": "lì,jìn",
  "厉精为治": "lì,jīng,wéi,zhì",
  "厉精更始": "lì,jīng,gēng,shǐ",
  "压不碎": "yā,bu,suì",
  "压倒多数": "yā,dǎo,duō,shù",
  "压倒性地": "yā,dǎo,xìng,de",
  "压制地": "yā,zhì,de",
  "压卷": "yā,juàn",
  "压卷之作": "yā,juàn,zhī,zuò",
  "压压脚": "yā,ya,jiǎo",
  "压压脚儿": "yā,ya,jiǎo,er",
  "压担子": "yā,dàn,zi",
  "压杠子": "yā,gàng,zi",
  "压板": "yà,bǎn",
  "压根": "yà,gēn",
  "压根儿": "yà,gēn,ér",
  "压死骆驼的最后一根稻草": "yā,sǐ,luò,tuo,de,zuì,hòu,yī,gēn,dào,cǎo",
  "压着": "yā,zhe",
  "压缩地": "yā,suō,de",
  "压肩叠背": "yā,jiān,dié,bèi",
  "压肩迭背": "yā,jiān,dié,bèi",
  "压良为贱": "yā,liáng,wéi,jiàn",
  "压蔓": "yā,wàn",
  "压轴": "yā,zhòu",
  "压轴好戏": "yā,zhòu,hǎo,xì",
  "压轴子": "yā,zhòu,zǐ",
  "压轴戏": "yā,zhòu,xì",
  "压迫地": "yā,pò,de",
  "压马路": "yà,mǎ,lù",
  "厌倦地": "yàn,juàn,de",
  "厌冠": "yàn,guān",
  "厌厌": "yān,yān",
  "厌厌害害": "yān,yān,hài,hài",
  "厌宜": "yā,yí",
  "厌当": "yā,dāng",
  "厌恶": "yàn,wù",
  "厌恶人类者": "yàn,wù,rén,lèi,zhě",
  "厌恶地": "yàn,wù,de",
  "厌浥": "yā,yì",
  "厌烦地": "yàn,fán,de",
  "厌焉": "yā,yān",
  "厌禳": "yā,ráng",
  "厌翟": "yàn,zhái",
  "厌胜": "yā,shèng",
  "厌薄": "yàn,bó",
  "厌降": "yā,jiàng",
  "厓厈": "yá,hǎn",
  "厚今薄古": "hòu,jīn,bó,gǔ",
  "厚养薄葬": "hòu,yǎng,bó,zàng",
  "厚厚地": "hòu,hòu,de",
  "厚厚地涂": "hòu,hòu,de,tú",
  "厚厚地涂抹": "hòu,hòu,de,tú,mǒ",
  "厚古薄今": "hòu,gǔ,bó,jīn",
  "厚味腊毒": "hòu,wèi,xī,dú",
  "厚实": "hòu,shi",
  "厚德载福": "hòu,dé,zǎi,fú",
  "厚朴": "hòu,pò",
  "厚此薄彼": "hòu,cǐ,bó,bǐ",
  "厚死薄生": "hòu,sǐ,bó,shēng",
  "厚生相": "hòu,shēng,xiàng",
  "厚皮馒头": "hòu,pí,mán,tou",
  "厚积薄发": "hòu,jī,bó,fā",
  "厚脸皮地": "hòu,liǎn,pí,de",
  "厚薄规": "hòu,bó,guī",
  "厚载": "hòu,zǎi",
  "厚道": "hòu,dao",
  "厚重地": "hòu,zhòng,de",
  "厚颜地": "hòu,yán,de",
  "厝火燎原": "cuò,huǒ,liǎo,yuán",
  "厝舍": "cuò,shè",
  "原函数": "yuán,hán,shù",
  "原则上": "yuán,zé,shang",
  "原卷": "yuán,juàn",
  "原处": "yuán,chǔ",
  "原始地": "yuán,shǐ,de",
  "原始积累": "yuán,shǐ,jī,lěi",
  "原子反应堆": "yuán,zǐ,fǎn,yìng,duī",
  "原子序数": "yuán,zǐ,xù,shù",
  "原子弹": "yuán,zǐ,dàn",
  "原子爆弹": "yuán,zǐ,bào,dàn",
  "原子爆破弹药": "yuán,zǐ,bào,pò,dàn,yào",
  "原底子": "yuán,dǐ,zi",
  "原形毕露": "yuán,xíng,bì,lù",
  "原形败露": "yuán,xíng,bài,lù",
  "原文地": "yuán,wén,de",
  "原来地": "yuán,lái,de",
  "原着": "yuán,zhe",
  "原速地": "yuán,sù,de",
  "厥貉": "jué,mò",
  "厦门": "xià,mén",
  "厦门大学": "xià,mén,dà,xué",
  "厦门市": "xià,mén,shì",
  "厨子": "chú,zi",
  "厨师长": "chú,shī,zhǎng",
  "厨𱄆": "chú,chì",
  "厮仆": "sī,pú",
  "厮禁": "sī,jìn",
  "厮舍": "sī,shè",
  "𰆚诸": "lán,zhū",
  "厹犹": "qiú,yóu",
  "厹由": "qiú,yóu",
  "厹矛": "qiú,máo",
  "去大胆地": "qù,dà,dǎn,de",
  "去得": "qù,de",
  "厽砢": "lěi,luǒ",
  "县久": "xuán,jiǔ",
  "县侯": "xiàn,hòu",
  "县兴": "xuán,xīng",
  "县垂": "xuán,chuí",
  "县大夫": "xiàn,dài,fū",
  "县帖": "xiàn,tiē",
  "县法": "xuán,fǎ",
  "县熢": "xiàn,fēng",
  "县磬": "xuán,qìng",
  "县绝": "xuán,jué",
  "县联": "xuán,lián",
  "县车": "xuán,chē",
  "县远": "xuán,yuǎn",
  "县长": "xiàn,zhǎng",
  "县隔": "xuán,gé",
  "参与": "cān,yù",
  "参与者": "cān,yù,zhě",
  "参伍": "cēn,wǔ",
  "参伍错综": "cēn,wǔ,cuò,zōng",
  "参伺": "cān,sì",
  "参参": "sān,sān",
  "参商": "shēn,shāng",
  "参商之虞": "shēn,shāng,zhī,yú",
  "参回": "shēn,huí",
  "参回斗转": "shēn,huí,dǒu,zhuǎn",
  "参处": "cān,chǔ",
  "参宿": "shēn,xiù",
  "参宿七": "shēn,xiù,qī",
  "参差": "cēn,cī",
  "参差不一": "cēn,cī,bù,yī",
  "参差不齐": "cēn,cī,bù,qí",
  "参差竹": "cēn,cī,zhú",
  "参差错落": "cēn,cī,cuò,luò",
  "参干": "cān,gàn",
  "参弹": "cān,dàn",
  "参数": "cān,shù",
  "参数方程": "cān,shù,fāng,chéng",
  "参星": "shēn,xīng",
  "参校": "cān,jiào",
  "参横": "shēn,héng",
  "参横斗转": "shēn,héng,dǒu,zhuǎn",
  "参省": "cān,xǐng",
  "参茸": "shēn,róng",
  "参薯": "shēn,shǔ",
  "参覃": "cān,qín",
  "参谋总长": "cān,móu,zǒng,zhǎng",
  "参谋长": "cān,móu,zhǎng",
  "参辰": "shēn,chén",
  "参辰卯酉": "shēn,chén,mǎo,yǒu",
  "参辰日月": "shēn,chén,rì,yuè",
  "参错": "cēn,cuò",
  "参鸡汤": "shēn,jī,tāng",
  "又一次地": "yòu,yī,cì,de",
  "又傻傻地": "yòu,shǎ,shǎ,de",
  "又反感地": "yòu,fǎn,gǎn,de",
  "又吐又泻": "yòu,tù,yòu,xiè",
  "又在不停地": "yòu,zài,bù,tíng,de",
  "又想当婊子又想立牌坊": "yòu,xiǎng,dāng,biǎo,zi,yòu,xiǎng,lì,pái,fāng",
  "又清晰地": "yòu,qīng,xī,de",
  "又讷讷地": "yòu,nè,nè,de",
  "又详细地": "yòu,xiáng,xì,de",
  "叉儿": "chā,er",
  "叉开": "chǎ,kāi",
  "叉开双腿": "chǎ,kāi,shuāng,tuǐ",
  "叉杆": "chā,gǎn",
  "及冠": "jí,guān",
  "及早地": "jí,zǎo,de",
  "及时地": "jí,shí,de",
  "及时地推出": "jí,shí,de,tuī,chū",
  "及时地进行": "jí,shí,de,jìn,xíng",
  "及时处理": "jí,shí,chǔ,lǐ",
  "及物地": "jí,wù,de",
  "友善地": "yǒu,shàn,de",
  "友善地问": "yǒu,shàn,de,wèn",
  "友好地": "yǒu,hǎo,de",
  "双亲地": "shuāng,qīn,de",
  "双人包夹": "shuāng,rén,bāo,jiā",
  "双台子": "shuāng,tái,zi",
  "双台子区": "shuāng,tái,zi,qū",
  "双城子": "shuāng,chéng,zi",
  "双手紧紧地": "shuāng,shǒu,jǐn,jǐn,de",
  "双折地": "shuāng,zhé,de",
  "双数": "shuāng,shù",
  "双斑绿柳莺": "huāng,bān,lǜ,liǔ,yīng",
  "双曲": "shuāng,qū",
  "双曲余割": "shuāng,qū,yú,gē",
  "双曲余弦": "shuāng,qū,yú,xián",
  "双曲几何": "shuāng,qū,jǐ,hé",
  "双曲抛物面": "shuāng,qū,pāo,wù,miàn",
  "双曲拱桥": "shuāng,qū,gǒng,qiáo",
  "双曲正弦": "shuāng,qū,zhèng,xián",
  "双曲线": "shuāng,qū,xiàn",
  "双曲线正弦": "shuāng,qū,xiàn,zhèng,xián",
  "双曲面": "shuāng,qū,miàn",
  "双枱": "shuāng,tái",
  "双柑斗酒": "shuāng,gān,dǒu,jiǔ",
  "双红拜帖": "shuāng,hóng,bài,tiē",
  "双节地": "shuāng,jié,de",
  "双调": "shuāng,diào",
  "双足重茧": "shuāng,zú,chóng,jiǎn",
  "双身子": "shuāng,shēn,zi",
  "双重": "shuāng,chóng",
  "双重人格": "shuāng,chóng,rén,gé",
  "双重国籍": "shuāng,chóng,guó,jí",
  "双重地": "shuāng,chóng,de",
  "双重标准": "shuāng,chóng,biāo,zhǔn",
  "反三角函数": "fǎn,sān,jiǎo,hán,shù",
  "反倒": "fǎn,dào",
  "反兴奋剂": "fǎn,xīng,fèn,jì",
  "反函数": "fǎn,hán,shù",
  "反切": "fǎn,qiè",
  "反动分子": "fǎn,dòng,fèn,zi",
  "反动势力": "fǎn,dòng,shì,li",
  "反动地": "fǎn,dòng,de",
  "反劳为逸": "fǎn,láo,wéi,yì",
  "反叛分子": "fǎn,pàn,fèn,zǐ",
  "反向地": "fǎn,xiàng,de",
  "反响强烈地": "fǎn,xiǎng,qiáng,liè,de",
  "反复地": "fǎn,fù,de",
  "反复地做": "fǎn,fù,de,zuò",
  "反复地说": "fǎn,fù,de,shuō",
  "反复地问": "fǎn,fù,de,wèn",
  "反宗教地": "fǎn,zōng,jiào,de",
  "反客为主": "fǎn,kè,wéi,zhǔ",
  "反密码子": "fǎn,mì,mǎ,zi",
  "反对地": "fǎn,duì,de",
  "反对数": "fǎn,duì,shù",
  "反导导弹": "fǎn,dǎo,dǎo,dàn",
  "反导弹": "fǎn,dǎo,dàn",
  "反射地": "fǎn,shè,de",
  "反常地": "fǎn,cháng,de",
  "反常情地": "fǎn,cháng,qíng,de",
  "反常行为": "fǎn,cháng,xíng,wéi",
  "反应": "fǎn,yìng",
  "反应两极": "fǎn,yìng,liǎng,jí",
  "反应器": "fǎn,yìng,qì",
  "反应堆": "fǎn,yìng,duī",
  "反应堆燃料元件": "fǎn,yìng,duī,rán,liào,yuán,jiàn",
  "反应堆芯": "fǎn,yìng,duī,xīn",
  "反应式": "fǎn,yìng,shì",
  "反应性地": "fǎn,yìng,xìng,de",
  "反应性染料": "fǎn,yìng,xìng,rǎn,liào",
  "反应时": "fǎn,yìng,shí",
  "反应时间": "fǎn,yìng,shí,jiān",
  "反应炉": "fǎn,yìng,lú",
  "反应过度": "fǎn,yìng,guò,dù",
  "反应过渡": "fǎn,yìng,guò,dù",
  "反应锅": "fǎn,yìng,guō",
  "反弹": "fǎn,dàn",
  "反弹导弹": "fǎn,dàn,dǎo,dàn",
  "反弹道导弹导弹": "fǎn,dàn,dào,dǎo,dàn,dǎo,dàn",
  "反战分子": "fǎn,zhàn,fèn,zi",
  "反扒": "fǎn,pá",
  "反抗地": "fǎn,kàng,de",
  "反折一把米": "fǎn,shé,yī,bǎ,mǐ",
  "反方向地": "fǎn,fāng,xiàng,de",
  "反朴": "fǎn,piáo",
  "反朴还淳": "fǎn,pǔ,huán,chún",
  "反正还淳": "fǎn,zhèng,huán,chún",
  "反相地": "fǎn,xiāng,de",
  "反省": "fǎn,xǐng",
  "反知识": "fǎn,zhī,shi",
  "反社会行为": "fǎn,shè,huì,xíng,wéi",
  "反美华工禁约运动": "fǎn,měi,huá,gōng,jìn,yuē,yùn,dòng",
  "反老还童": "fǎn,lǎo,huán,tóng",
  "反背": "fǎn,bèi",
  "反脸": "fān,liǎn",
  "反舰导弹": "fǎn,jiàn,dǎo,dàn",
  "反舰艇巡航导弹": "fǎn,jiàn,tǐng,xún,háng,dǎo,dàn",
  "反复地讲": "fǎn,fù,de,jiǎng",
  "反讽": "fǎn,fěng",
  "反调": "fǎn,diào",
  "反败为胜": "fǎn,bài,wéi,shèng",
  "反跌": "fǎn,diē",
  "反躬自省": "fǎn,gōng,zì,xǐng",
  "反转来": "fǎn,zhuàn,lái",
  "反辐射导弹": "fǎn,fú,shè,dǎo,dàn",
  "反过来": "fǎn,guo,lái",
  "反过来地": "fǎn,guò,lái,de",
  "反间": "fǎn,jiàn",
  "反间之计": "fǎn,jiàn,zhī,jì",
  "反间计": "fǎn,jiàn,jì",
  "反间谍": "fǎn,jiàn,dié",
  "反面儿": "fǎn,miàn,er",
  "发上冲冠": "fà,shàng,chōng,guān",
  "发上指冠": "fà,shàng,zhǐ,guān",
  "发丝": "fà,sī",
  "发丧": "fā,sāng",
  "发乳": "fà,rǔ",
  "发亮地": "fā,liàng,de",
  "发人深省": "fā,rén,shēn,xǐng",
  "发作性地": "fā,zuò,xìng,de",
  "发兴": "fā,xīng",
  "发冠卷尾": "fà,guān,juǎn,wěi",
  "发冢": "fà,zhǒng",
  "发冲冠": "fā,chōng,guān",
  "发刷": "fà,shuā",
  "发卡": "fà,qiǎ",
  "发卷": "fà,juǎn",
  "发呆似地": "fā,dāi,shì,de",
  "发噱": "fā,xué",
  "发型": "fà,xíng",
  "发型师": "fà,xíng,shī",
  "发型设计师": "fà,xíng,shè,jì,shī",
  "发夹": "fā,jiā",
  "发奋为雄": "fā,fèn,wéi,xióng",
  "发奋有为": "fā,fèn,yǒu,wéi",
  "发套": "fà,tào",
  "发奸露复": "fā,jiān,lù,fù",
  "发妻": "fà,qī",
  "发射地": "fā,shè,de",
  "发射机应答器": "fā,shè,jī,yìng,dá,qì",
  "发射极耦合逻辑集成电路": "fā,shè,jí,ǒu,hé,luó,ji,jí,chéng,diàn,lù",
  "发小": "fà,xiǎo",
  "发小儿": "fà,xiǎo,er",
  "发尾": "fà,wěi",
  "发屋": "fà,wū",
  "发帖": "fā,tiē",
  "发带": "fà,dài",
  "发廊": "fà,láng",
  "发式": "fà,shì",
  "发引千钧": "fà,yǐn,qiān,jūn",
  "发怒冲冠": "fà,nù,chōng,guān",
  "发怒地": "fā,nù,de",
  "发怒穿冠": "fà,nù,chuān,guān",
  "发怔": "fā,zhèng",
  "发抖地": "fā,dǒu,de",
  "发指": "fà,zhǐ",
  "发指眦裂": "fà,zhǐ,zì,liè",
  "发擂": "fā,lèi",
  "发旋": "fà,xuán",
  "发柔光地": "fā,róu,guāng,de",
  "发案地": "fā,àn,de",
  "发梢": "fà,shāo",
  "发植穿冠": "fà,zhí,chuān,guān",
  "发横财": "fā,hèng,cái",
  "发烟弹": "fā,yān,dàn",
  "发热伴血小板减少综合征": "fā,rè,bàn,xuè,xiǎo,bǎn,jiǎn,shǎo,zōng,hé,zhēng",
  "发狂似地": "fā,kuáng,shì,de",
  "发狂地": "fā,kuáng,de",
  "发生关系": "fā,shēng,guān,xi",
  "发生认识论": "fā,shēng,rèn,shi,lùn",
  "发疟子": "fā,yào,zǐ",
  "发癣": "fà,xuǎn",
  "发短心长": "fà,duǎn,xīn,cháng",
  "发秃齿豁": "fà,tū,chǐ,huò",
  "发竖": "fà,shù",
  "发箍": "fà,gū",
  "发簪": "fà,zān",
  "发绺": "fà,liǔ",
  "发背": "fā,bèi",
  "发脚": "fà,jiǎo",
  "发药": "fèi,yào",
  "发菜": "fà,cài",
  "发蒙": "fā,mēng",
  "发蜡": "fà,là",
  "发解": "fā,jiè",
  "发言中肯": "fā,yán,zhòng,kěn",
  "发调": "fā,diào",
  "发踊冲冠": "fà,yǒng,chōng,guān",
  "发辫": "fà,biàn",
  "发达地": "fā,dá,de",
  "发还": "fā,huán",
  "发钗": "fà,chāi",
  "发际": "fà,jì",
  "发难": "fā,nàn",
  "发露": "fā,lù",
  "发髻": "fà,jì",
  "发鬓": "fà,bìn",
  "叔叔": "shū,shu",
  "叔子": "shū,zi",
  "取予": "qǔ,yǔ",
  "取予有节": "qǔ,yǔ,yǒu,jié",
  "取以来": "qu,yi,lai",
  "取地": "qǔ,de",
  "取应": "qǔ,yìng",
  "取得": "qǔ,de",
  "取样数量": "qǔ,yàng,shù,liàng",
  "取民愈广": "qu,min,yu,guang",
  "取消禁令": "qǔ,xiāo,jìn,lìng",
  "取灯儿": "qǔ,dēng,er",
  "取笑地": "qǔ,xiào,de",
  "取累": "qǔ,lèi",
  "取适": "qǔ,shì",
  "取高利地": "qǔ,gāo,lì,de",
  "受不了": "shòu,bù,liǎo",
  "受交友地": "shòu,jiāo,yǒu,de",
  "受伤地": "shòu,shāng,de",
  "受冻挨饿": "shòu,dòng,ái,è",
  "受制于人": "shòu,zhì,yù,rén",
  "受嘲弄地": "shòu,cháo,nòng,de",
  "受嘲笑地": "shòu,cháo,xiào,de",
  "受困惑地": "shòu,kùn,huò,de",
  "受夹板气": "shòu,jiā,bǎn,qì",
  "受夹板罪": "shòu,jiā,bǎn,zuì",
  "受得了": "shòu,de,liǎo",
  "受瘪": "shòu,biě",
  "受禅": "shòu,shàn",
  "受禅台": "shòu,shàn,tái",
  "受禅碑": "shòu,shàn,bēi",
  "受累": "shòu,lěi",
  "受降": "shòu,xiáng",
  "受降仪式": "shòu,xiáng,yí,shì",
  "受降城": "shòu,xiáng,chéng",
  "受难": "shòu,nàn",
  "受难日": "shòu,nàn,rì",
  "受难者": "shòu,nàn,zhě",
  "变为": "biàn,wéi",
  "变则地": "biàn,zé,de",
  "变危为安": "biàn,wēi,wéi,ān",
  "变后掠翼飞机": "biàn,hòu,lüě,yì,fēi,jī",
  "变味儿": "biàn,wèi,er",
  "变坏地": "biàn,huài,de",
  "变大雅": "biàn,dà,yá",
  "变应": "biàn,yìng",
  "变得": "biàn,de",
  "变徵": "biàn,zhǐ",
  "变徵之声": "biàn,zhǐ,zhī,shēng",
  "变快地": "biàn,kuài,de",
  "变态反应": "biàn,tài,fǎn,yìng",
  "变态地": "biàn,tài,de",
  "变态百出": "biàn,tài,běi,chū",
  "变故易常": "biàn,gǔ,yì,cháng",
  "变数": "biàn,shù",
  "变数器": "biàn,shù,qì",
  "变更": "biàn,gēng",
  "变样儿": "biàn,yàng,er",
  "变法儿": "biàn,fǎ,er",
  "变溢地": "biàn,yì,de",
  "变炫无穷": "biàn,xuán,wú,qióng",
  "变相": "biàn,xiàng",
  "变相地": "biàn,xiàng,de",
  "变缞": "biàn,shuāi",
  "变调": "biàn,diào",
  "变调夹": "biàn,diào,jiā",
  "变贪厉薄": "biàn,tān,lì,bó",
  "变迁地": "biàn,qiān,de",
  "变速杆": "biàn,sù,gǎn",
  "变音记号": "biàn,yīn,jì,hao",
  "叙述地": "xù,shù,de",
  "叚借": "jiǎ,jiè",
  "叛乱地": "pàn,luàn,de",
  "叛背": "pàn,bèi",
  "叛舰喋血记": "pàn,jiàn,dié,xuè,jì",
  "叛逆地": "pàn,nì,de",
  "叠矩重规": "dié,jǔ,chóng,guī",
  "叠累": "dié,lèi",
  "叠见": "dié,xiàn",
  "叠见层出": "dié,xiàn,céng,chū",
  "口不应心": "kǒu,bù,yìng,xīn",
  "口𠡠": "kǒu,lài",
  "口口声声": "kǒu,kou,shēng,shēng",
  "口吃地": "kǒu,chī,de",
  "口吃地说": "kǒu,chī,de,shuō",
  "口呿眸眙": "kǒu,qù,móu,yí",
  "口啍": "kǒu,tūn",
  "口头上地": "kǒu,tóu,shàng,de",
  "口头地": "kǒu,tóu,de",
  "口子": "kǒu,zi",
  "口尚乳臭": "kǒu,shàng,rǔ,xiù",
  "口惽": "kǒu,hūn",
  "口才好地": "kǒu,cái,hǎo,de",
  "口数": "kǒu,shù",
  "口数粥": "kǒu,shù,zhōu",
  "口渴地": "kǒu,kě,de",
  "口累": "kǒu,lèi",
  "口腔地": "kǒu,qiāng,de",
  "口腹之累": "kǒu,fù,zhī,lěi",
  "口血未干": "kǒu,xuè,wèi,gān",
  "口角": "kǒu,jué",
  "口角炎": "kǒu,jué,yán",
  "口调": "kǒu,diào",
  "口轻舌薄": "kǒu,qīng,shé,bó",
  "口述地": "kǒu,shù,de",
  "口部地": "kǒu,bù,de",
  "口钳舌卷": "kǒu,qián,shé,juàn",
  "口齿清楚": "kǒu,chǐ,qīng,chu",
  "古为今用": "gǔ,wéi,jīn,yòng",
  "古乐府": "gǔ,yuè,fǔ",
  "古兴": "gǔ,xīng",
  "古典乐": "gǔ,diǎn,yuè",
  "古典音乐": "gǔ,diǎn,yīn,yuè",
  "古冠": "gǔ,guān",
  "古劲": "gǔ,jìng",
  "古处": "gǔ,chǔ",
  "古怪地": "gǔ,guài,de",
  "古惑仔": "gǔ,huò,zǎi",
  "古时候": "gǔ,shí,hou",
  "古是今非": "gǔ,shì,jīng,fēi",
  "古朴": "gǔ,piáo",
  "古板地": "gǔ,bǎn,de",
  "古查": "gǔ,zhā",
  "古纤道": "gǔ,qiàn,dào",
  "古细菌域": "gǔ,xì,jùn,yù",
  "古细菌界": "gǔ,xì,jùn,jiè",
  "古腔古调": "gǔ,qiāng,gǔ,diào",
  "古腾堡计划": "gǔ,téng,bǎo,jì,huà",
  "古调": "gǔ,diào",
  "古调不弹": "gǔ,diào,bù,tán",
  "古调单弹": "gǔ,diào,dān,tán",
  "古调诗": "gǔ,diào,shī",
  "古都": "gǔ,dū",
  "古都都": "gǔ,dū,dōu",
  "古雅地": "gǔ,yǎ,de",
  "句丽": "jù,lí",
  "句剥": "jù,bāo",
  "句吴": "gōu,wú",
  "句婴": "jiǔ,yīng",
  "句子": "jù,zi",
  "句子成分": "jù,zi,chéng,fèn",
  "句当": "gòu,dāng",
  "句数": "jù,shù",
  "句望": "gōu,wàng",
  "句枉": "gōu,wǎng",
  "句注": "gōu,zhù",
  "句芒": "gōu,máng",
  "句萌": "gōu,méng",
  "句读": "jù,dòu",
  "句调": "jù,diào",
  "句骊": "gōu,lí",
  "另一方面": "lìng,yì,fāng,miàn",
  "另一面": "lìng,yí,miàn",
  "另存为": "lìng,cún,wéi",
  "另当别论": "lìng,dàng,bié,lùn",
  "另辟蹊径": "lìng,pì,xī,jìng",
  "叨光": "tāo,guāng",
  "叨咕": "dáo,gu",
  "叨唠": "dāo,láo",
  "叨在知己": "tāo,zài,zhī,jǐ",
  "叨扰": "tāo,rǎo",
  "叨拢": "tāo,lǒng",
  "叨教": "tāo,jiào",
  "叨蹬": "dāo,dēng",
  "叨陪": "tāo,péi",
  "叨陪末座": "tāo,péi,mò,zuò",
  "叩应": "kòu,yìng",
  "叩心泣血": "kòu,xīn,qì,xuè",
  "叩愬": "kòu,shuò",
  "只且": "zhī,qiě",
  "只个": "zhī,gè",
  "只么": "zhī,mǒ",
  "只争朝夕": "zhǐ,zhēng,zhāo,xī",
  "只今": "zhī,jīn",
  "只从": "zhī,cóng",
  "只会简单地": "zhǐ,huì,jiǎn,dān,de",
  "只使": "zhī,shǐ",
  "只偶": "zhī,ǒu",
  "只凤": "zhī,fèng",
  "只千古": "zhī,qiān,gǔ",
  "只古里": "zhī,gǔ,lǐ",
  "只句": "zhī,jù",
  "只合": "zhī,hé",
  "只在": "zhī,zài",
  "只如": "zhī,rú",
  "只字": "zhī,zì",
  "只字不提": "zhī,zì,bù,tí",
  "只孙": "zhī,sūn",
  "只尺": "zhī,chǐ",
  "只履": "zhī,lǚ",
  "只影": "zhī,yǐng",
  "只得": "zhǐ,de",
  "只恁": "zhī,nèn",
  "只情": "zhī,qíng",
  "只想好好地": "zhǐ,xiǎng,hǎo,hǎo,de",
  "只手": "zhī,shǒu",
  "只才": "zhī,cái",
  "只教": "zhī,jiào",
  "只日": "zhī,rì",
  "只是一味地": "zhǐ,shì,yī,wèi,de",
  "只是为了更好地": "zhǐ,shì,wèi,le,gèng,hǎo,de",
  "只是呆呆地": "zhǐ,shì,dāi,dāi,de",
  "只是地": "zhǐ,shì,de",
  "只是定定地": "zhǐ,shì,deng,deng,de",
  "只是静静地": "zhǐ,shì,jìng,jìng,de",
  "只有不断地": "zhǐ,yǒu,bù,duàn,de",
  "只有真正地": "zhǐ,yǒu,zhēn,zhèng,de",
  "只此": "zhī,cǐ",
  "只此一家别无分店": "zhī,cǐ,yī,jiā,bié,wú,fēn,diàn",
  "只没": "zhī,méi",
  "只留支剌": "zhī,liú,zhī,là",
  "只眼": "zhī,yǎn",
  "只眼独具": "zhī,yǎn,dú,jù",
  "只知其一": "zhǐ,zhī,qí,shān",
  "只磨": "zhī,mó",
  "只立": "zhī,lì",
  "只竟": "zhī,jìng",
  "只箇": "zhī,gè",
  "只缘": "zhī,yuán",
  "只翼": "zhī,yì",
  "只耦": "zhī,ǒu",
  "只能不断地": "zhǐ,néng,bù,duàn,de",
  "只能乖乖地": "zhǐ,néng,guāi,guāi,de",
  "只能无奈地": "zhǐ,néng,wú,nài,de",
  "只能眼巴巴地": "zhǐ,néng,yǎn,bā,bā,de",
  "只能眼巴巴地看着": "zhǐ,néng,yǎn,bā,bā,de,kàn,zhe",
  "只能眼睁睁地": "zhǐ,néng,yǎn,zhēng,zhēng,de",
  "只能眼睁睁地看着": "zhǐ,néng,yǎn,zhēng,zhēng,de,kàn,zhe",
  "只能隐约地": "zhǐ,néng,yǐn,yuē,de",
  "只能默默地": "zhǐ,néng,mò,mò,de",
  "只自": "zhī,zì",
  "只要不断地": "zhǐ,yào,bù,duàn,de",
  "只要简单地": "zhǐ,yào,jiǎn,dān,de",
  "只要认真地": "zhǐ,yào,rèn,zhēn,de",
  "只见": "zhī,jiàn",
  "只言片语": "zhī,yán,piàn,yǔ",
  "只诓": "zhī,kuāng",
  "只该": "zhī,gāi",
  "只语": "zhī,yǔ",
  "只读存储器": "zhī,dú,cún,chǔ,qì",
  "只赤": "zhī,chì",
  "只身": "zhī,shēn",
  "只身一人": "zhī,shēn,yī,rén",
  "只身孤影": "zhī,shēn,gū,yǐng",
  "只轮不反": "zhī,lún,bù,fǎn",
  "只轮不返": "zhī,lún,bù,fǎn",
  "只轮无反": "zhī,lún,wú,fǎn",
  "只逊": "zhī,xùn",
  "只道": "zhī,dào",
  "只除": "zhī,chú",
  "只首": "zhī,shǒu",
  "只骑不反": "zhī,qí,bù,fǎn",
  "只鸡": "zhī,jī",
  "只鸡斗酒": "zhī,jī,dǒu,jiǔ",
  "只鸡樽酒": "zhī,jī,zūn,jiǔ",
  "只鸡絮酒": "zhī,jī,xù,jiǔ",
  "叫化子": "jiào,huā,zi",
  "叫吖吖": "jiào,ā,ā",
  "叫哥哥": "jiào,gē,ge",
  "叫唤": "jiào,huan",
  "叫嚷地": "jiào,rǎng,de",
  "叫天吖地": "jiào,tiān,ā,dì",
  "叫应": "jiào,yìng",
  "叫座儿": "jiào,zuò,er",
  "叫更": "jiào,gēng",
  "叫条子": "jiào,tiáo,zi",
  "叫横": "jiào,hèng",
  "叫花子": "jiào,huā,zi",
  "召伯树": "shào,bó,shù",
  "召伯棠": "shào,bó,táng",
  "召平瓜": "shào,píng,guā",
  "召杜": "shào,dù",
  "召棠": "shào,táng",
  "召父杜母": "shào,fù,dù,mǔ",
  "召陵": "shào,líng",
  "召陵区": "shào,líng,qū",
  "叭嚓": "bā,chā",
  "可不时地": "kě,bù,shí,de",
  "可不是": "kě,bú,shì",
  "可中止地": "kě,zhōng,zhǐ,de",
  "可丽露": "kě,lì,lù",
  "可争辩地": "kě,zhēng,biàn,de",
  "可交换地": "kě,jiāo,huàn,de",
  "可享乐地": "kě,xiǎng,lè,de",
  "可亲地": "kě,qīn,de",
  "可什": "kě,shí",
  "可什么": "kě,shí,mǒ",
  "可以任意地": "kě,yǐ,rèn,yì,de",
  "可以准确地": "kě,yǐ,zhǔn,què,de",
  "可以安安静静地": "kě,yǐ,ān,ān,jìng,jìng,de",
  "可以平静地": "kě,yǐ,píng,jìng,de",
  "可以很好地": "kě,yǐ,hěn,hǎo,de",
  "可以很快地": "kě,yǐ,hěn,kuài,de",
  "可以很方便地": "kě,yǐ,hěn,fāng,biàn,de",
  "可以很清楚地": "kě,yǐ,hěn,qīng,chǔ,de",
  "可以很负责地": "kě,yǐ,hěn,fù,zé,de",
  "可以快速地": "kě,yǐ,kuài,sù,de",
  "可以接受地": "kě,yǐ,jiē,shòu,de",
  "可以放心地": "kě,yǐ,fàng,xīn,de",
  "可以方便地": "kě,yǐ,fāng,biàn,de",
  "可以明确地说": "kě,yǐ,míng,què,de,shuō",
  "可以更好地": "kě,yǐ,gèng,hǎo,de",
  "可以有选择地": "kě,yǐ,yǒu,xuǎn,zé,de",
  "可以流利地": "kě,yǐ,liú,lì,de",
  "可以清晰地感觉到": "kě,yǐ,qīng,xī,de,gǎn,jué,dào",
  "可以清晰地看出": "kě,yǐ,qīng,xī,de,kàn,chū",
  "可以清晰地看到": "kě,yǐ,qīng,xī,de,kàn,dào",
  "可以清楚地看见": "kě,yǐ,qīng,chǔ,de,kàn,jiàn",
  "可以痛痛快快地": "kě,yǐ,tòng,tòng,kuài,kuài,de",
  "可以简单地概括": "kě,yǐ,jiǎn,dān,de,gài,kuò",
  "可以肯定地告诉你": "kě,yǐ,kěn,deng,de,gào,sù,nǐ",
  "可以肯定地说": "kě,yǐ,kěn,deng,de,shuō",
  "可以自由地": "kě,yǐ,zì,yóu,de",
  "可以自自然然地": "kě,yǐ,zì,zì,rán,rán,de",
  "可以舒舒服服地": "kě,yǐ,shū,shū,fú,fú,de",
  "可以轻松地": "kě,yǐ,qīng,sōng,de",
  "可以轻松地打出来": "kě,yǐ,qīng,sōng,de,dǎ,chū,lái",
  "可以轻轻地": "kě,yǐ,qīng,qīng,de",
  "可以迅速地": "kě,yǐ,xùn,sù,de",
  "可以适当地": "kě,yǐ,shì,dàng,de",
  "可以随意地": "kě,yǐ,suí,yì,de",
  "可以非常明确地": "kě,yǐ,fēi,cháng,míng,què,de",
  "可以非常简单地": "kě,yǐ,fēi,cháng,jiǎn,dān,de",
  "可估价地": "kě,gū,jià,de",
  "可佩地": "kě,pèi,de",
  "可供军用": "kě,gōng,jūn,yòng",
  "可依赖地": "kě,yī,lài,de",
  "可保卫地": "kě,bǎo,wèi,de",
  "可信任地": "kě,xìn,rèn,de",
  "可信地": "kě,xìn,de",
  "可信赖地": "kě,xìn,lài,de",
  "可公开地": "kě,gōng,kāi,de",
  "可共患难": "kě,gòng,huàn,nàn",
  "可分别地": "kě,fēn,bié,de",
  "可分离地": "kě,fēn,lí,de",
  "可列举地": "kě,liè,jǔ,de",
  "可劝告地": "kě,quàn,gào,de",
  "可动性地": "kě,dòng,xìng,de",
  "可劲儿": "kě,jìn,er",
  "可区分地": "kě,qū,fēn,de",
  "可区别地": "kě,qū,bié,de",
  "可单独地": "kě,dān,dú,de",
  "可厌地": "kě,yàn,de",
  "可原谅地": "kě,yuán,liàng,de",
  "可反对地": "kě,fǎn,duì,de",
  "可反驳地": "kě,fǎn,bó,de",
  "可取代地": "kě,qǔ,dài,de",
  "可变地": "kě,biàn,de",
  "可变通地": "kě,biàn,tōng,de",
  "可口地": "kě,kǒu,de",
  "可叹地": "kě,tàn,de",
  "可哀地": "kě,āi,de",
  "可喜地": "kě,xǐ,de",
  "可嘉地": "kě,jiā,de",
  "可塞": "kě,sài",
  "可实行地": "kě,shí,xíng,de",
  "可容忍地": "kě,róng,rěn,de",
  "可容许地": "kě,róng,xǔ,de",
  "可宽恕地": "kě,kuān,shù,de",
  "可察觉地": "kě,chá,jué,de",
  "可尊敬地": "kě,zūn,jìng,de",
  "可展曲面": "kě,zhǎn,qū,miàn",
  "可崇敬地": "kě,chóng,jìng,de",
  "可忍受地": "kě,rěn,shòu,de",
  "可忍地": "kě,rěn,de",
  "可忍耐地": "kě,rěn,nài,de",
  "可怕地": "kě,pà,de",
  "可怖地": "kě,bù,de",
  "可怜地": "kě,lián,de",
  "可怜悯地": "kě,lián,mǐn,de",
  "可恨地": "kě,hèn,de",
  "可恶": "kě,wù",
  "可恶地": "kě,wù,de",
  "可悬吊地": "kě,xuán,diào,de",
  "可惊地": "kě,jīng,de",
  "可惜地": "kě,xī,de",
  "可想像地": "kě,xiǎng,xiàng,de",
  "可想象地": "kě,xiǎng,xiàng,de",
  "可憎地": "kě,zēng,de",
  "可憎恶地": "kě,zēng,è,de",
  "可扩张地": "kě,kuò,zhāng,de",
  "可承认地": "kě,chéng,rèn,de",
  "可承诺地": "kě,chéng,nuò,de",
  "可折射地": "kě,zhé,shè,de",
  "可拥护地": "kě,yōng,hù,de",
  "可接近地": "kě,jiē,jìn,de",
  "可擦写可编程只读存储器": "kě,cā,xiě,kě,biān,chéng,zhī,dú,cún,chǔ,qì",
  "可支持地": "kě,zhī,chí,de",
  "可改变地": "kě,gǎi,biàn,de",
  "可救济地": "kě,jiù,jì,de",
  "可教地": "kě,jiào,de",
  "可敬地": "kě,jìng,de",
  "可断定地": "kě,duàn,deng,de",
  "可断言地": "kě,duàn,yán,de",
  "可旋转地": "kě,xuán,zhuǎn,de",
  "可明言地": "kě,míng,yán,de",
  "可是么": "kě,shì,mǒ",
  "可是很快地": "kě,shì,hěn,kuài,de",
  "可更好地": "kě,gèng,hǎo,de",
  "可曾": "kě,zēng",
  "可替换地": "kě,tì,huàn,de",
  "可比较地": "kě,bǐ,jiào,de",
  "可汗": "kè,hán",
  "可治疗地": "kě,zhì,liáo,de",
  "可点数地": "kě,diǎn,shù,de",
  "可煞": "kě,shà",
  "可爱地": "kě,ài,de",
  "可爱地仃": "kě,ài,de,dīng",
  "可理解地": "kě,lǐ,jiě,de",
  "可疑分子": "kě,yí,fèn,zǐ",
  "可疑地": "kě,yí,de",
  "可的松": "kě,dì,sōng",
  "可目视地": "kě,mù,shì,de",
  "可着": "kě,zhe",
  "可着头做帽子": "kě,zhe,tóu,zuò,mào,zi",
  "可着色地": "kě,zhe,sè,de",
  "可知觉地": "kě,zhī,jué,de",
  "可移动地": "kě,yí,dòng,de",
  "可笑地": "kě,xiào,de",
  "可耻地": "kě,chǐ,de",
  "可肯定地": "kě,kěn,deng,de",
  "可能地": "kě,néng,de",
  "可节省地": "kě,jié,shěng,de",
  "可被选地": "kě,bèi,xuǎn,de",
  "可见地": "kě,jiàn,de",
  "可观地": "kě,guān,de",
  "可触知地": "kě,chù,zhī,de",
  "可计算地": "kě,jì,suàn,de",
  "可认识地": "kě,rèn,shí,de",
  "可让出地": "kě,ràng,chū,de",
  "可论证地": "kě,lùn,zhèng,de",
  "可证明地": "kě,zhèng,míng,de",
  "可评价地": "kě,píng,jià,de",
  "可说明地": "kě,shuō,míng,de",
  "可贵地": "kě,guì,de",
  "可贺地": "kě,hè,de",
  "可赞赏地": "kě,zàn,shǎng,de",
  "可转动地": "kě,zhuàn,dòng,de",
  "可较好地": "kě,jiào,hǎo,de",
  "可辨别地": "kě,biàn,bié,de",
  "可辩护地": "kě,biàn,hù,de",
  "可辩解地": "kě,biàn,jiě,de",
  "可选地": "kě,xuǎn,de",
  "可选择地": "kě,xuǎn,zé,de",
  "可鄙地": "kě,bǐ,de",
  "可钦佩地": "kě,qīn,pèi,de",
  "可防御地": "kě,fáng,yù,de",
  "可靠地": "kě,kào,de",
  "可预料地": "kě,yù,liào,de",
  "可饶恕地": "kě,ráo,shù,de",
  "可驳斥地": "kě,bó,chì,de",
  "台仆": "tái,pú",
  "台𠡠": "tái,lài",
  "台堡": "tái,pù",
  "台子": "tái,zi",
  "台州": "tāi,zhōu",
  "台州地区": "tāi,zhōu,dì,qū",
  "台州市": "tāi,zhōu,shì",
  "台巴子": "tái,bā,zi",
  "台柱子": "tái,zhù,zi",
  "台湾话": "tāi,wān,huà",
  "台禁": "tái,jìn",
  "台背": "tái,bèi",
  "台观": "tái,guàn",
  "台长": "tái,zhǎng",
  "台阶地": "tái,jiē,de",
  "台面呢": "tái,miàn,ní",
  "台骀": "tái,dài",
  "叱咀": "chì,zuǐ",
  "叱喝": "chì,hè",
  "叱干": "chì,gàn",
  "叱责地": "chì,zé,de",
  "史乘": "shǐ,shèng",
  "史传": "shǐ,zhuàn",
  "史传小说": "shǐ,zhuàn,xiǎo,shuō",
  "史侯": "shǐ,hòu",
  "史前地": "shǐ,qián,de",
  "史学地": "shǐ,xué,de",
  "史诗式地": "shǐ,shī,shì,de",
  "史高比耶": "shǐ,gāo,bǐ,yē",
  "右丞相": "yòu,chéng,xiàng",
  "右佥都御史": "yòu,qiān,dū,yù,shǐ",
  "右旋地": "yòu,xuán,de",
  "右更": "yòu,gēng",
  "右派分子": "yòu,pài,fèn,zǐ",
  "右肋": "yòu,lē",
  "右边": "yòu,bian",
  "右边儿": "yòu,bian,er",
  "右都御史": "yòu,dū,yù,shǐ",
  "叵测地": "pǒ,cè,de",
  "叶中": "xié,zhōng",
  "叶佐": "xié,zuǒ",
  "叶公好龙": "yè,gōng,hào,lóng",
  "叶力": "xié,lì",
  "叶卡捷琳娜": "yè,kǎ,jié,lín,nà",
  "叶卡特琳娜堡": "yè,kǎ,tè,lín,nà,bǎo",
  "叶卷": "yè,juàn",
  "叶吉": "xié,jí",
  "叶和": "xié,hé",
  "叶契": "xié,qì",
  "叶子": "yè,zi",
  "叶子列": "yè,zi,liè",
  "叶子戏": "yè,zi,xì",
  "叶子板": "yè,zi,bǎn",
  "叶子格": "yè,zi,gé",
  "叶子烟": "yè,zi,yān",
  "叶子牌": "yè,zi,pái",
  "叶子香": "yè,zi,xiāng",
  "叶律": "xié,lǜ",
  "叶心": "xié,xīn",
  "叶泰": "xié,tài",
  "叶谋": "xié,móu",
  "叶赞": "xié,zàn",
  "叶韵": "xié,yùn",
  "叶齐": "xié,qí",
  "号丧": "háo,sāng",
  "号叫": "háo,jiào",
  "号咷": "háo,táo",
  "号咷大哭": "háo,táo,dà,kū",
  "号唫": "hào,yín",
  "号啕": "háo,táo",
  "号啕大哭": "háo,táo,dà,kū",
  "号嗄": "hào,á",
  "号寒啼饥": "háo,hán,tí,jī",
  "号愬": "hào,shuò",
  "号数": "hào,shù",
  "号舍": "hào,shè",
  "司务长": "sī,wù,zhǎng",
  "司天监": "sī,tiān,jiàn",
  "司应": "sī,yìng",
  "司更卒": "sī,gēng,zú",
  "司法上地": "sī,fǎ,shàng,de",
  "司载": "sī,zǎi",
  "司钻": "sī,zuàn",
  "司长": "sī,zhǎng",
  "叹为观止": "tàn,wéi,guān,zhǐ",
  "叹吁": "tàn,yù",
  "叹息地说": "tàn,xī,de,shuō",
  "叹慜": "tàn,mǐn",
  "叽叽咕咕": "jī,ji,gū,gū",
  "叽叽咯咯": "jī,jī,gē,gē",
  "叽哩呱啦": "jī,lǐ,guā,lā",
  "叽哩咕噜": "jī,lǐ,gū,lū",
  "叽哩哇啦": "jī,lǐ,wā,lā",
  "叽哩嘎啦": "jī,lǐ,gā,lā",
  "叽哩旮旯": "jī,lǐ,gā,lá",
  "叽里咕噜": "jī,li,gū,lū",
  "吁俊": "yù,jùn",
  "吁俞": "yù,yú",
  "吁号": "yù,hào",
  "吁叹": "yù,tàn",
  "吁吸": "yù,xī",
  "吁告": "yù,gào",
  "吁呼": "yù,hū",
  "吁咈": "yù,fú",
  "吁咈都俞": "yù,fú,dōu,yú",
  "吁唏": "yù,xī",
  "吁嗟": "yù,jiē",
  "吁嘅": "yù,kǎi",
  "吁嘘": "yù,xū",
  "吁嘻": "yù,xī",
  "吁地呼天": "yù,dì,hū,tiān",
  "吁天": "yù,tiān",
  "吁天呼地": "yù,tiān,hū,dì",
  "吁怪": "yù,guài",
  "吁恳": "yù,kěn",
  "吁气": "yù,qì",
  "吁求": "yù,qiú",
  "吁然": "yù,rán",
  "吁猷": "yù,yóu",
  "吁留": "yù,liú",
  "吁祷": "yù,dǎo",
  "吁策": "yù,cè",
  "吁荼": "yù,tú",
  "吁请": "yù,qǐng",
  "吁谋": "yù,móu",
  "吁谟": "yù,mó",
  "吁骇": "yù,hài",
  "吃不下": "chī,bu,xià",
  "吃不了": "chī,bù,liǎo",
  "吃不了兜着走": "chī,bù,liǎo,dōu,zhe,zǒu",
  "吃不了包着走": "chī,bù,liǎo,bāo,zhe,zǒu",
  "吃不住": "chī,bú,zhù",
  "吃不住劲": "chī,bú,zhù,jìn",
  "吃不到葡萄说葡萄酸": "chī,bù,dào,pú,tao,shuō,pú,tao,suān",
  "吃不完兜着走": "chī,bù,wán,dōu,zhe,zǒu",
  "吃个虱子留只脚": "chī,gè,shī,zi,liú,zhī,jiǎo",
  "吃亏上当": "chī,kuī,shàng,dàng",
  "吃人不吐骨头": "chī,rén,bù,tǔ,gú,tou",
  "吃人血馒头": "chī,rén,xuè,mán,tou",
  "吃儿": "chī,er",
  "吃力地": "chī,lì,de",
  "吃力地将": "chī,lì,de,jiāng",
  "吃吃地": "chī,chī,de",
  "吃吃地笑": "chī,chī,de,xiào",
  "吃奶劲儿": "chī,nǎi,jìn,er",
  "吃奶的力气": "chī,nǎi,de,lì,qi",
  "吃屎都赶不上热乎的": "chī,shǐ,dōu,gǎn,bu,shàng,rè,hu,de",
  "吃得上": "chī,děi,shàng",
  "吃得下": "chī,de,xià",
  "吃得住": "chī,de,zhù",
  "吃得光": "chī,de,guāng",
  "吃得准": "chī,de,zhǔn",
  "吃得开": "chī,de,kāi",
  "吃得来": "chī,de,lái",
  "吃得消": "chī,de,xiāo",
  "吃惊地": "chī,jīng,de",
  "吃惊地发现": "chī,jīng,de,fā,xiàn",
  "吃拿卡要": "chī,ná,qiǎ,yào",
  "吃板子": "chī,bǎn,zi",
  "吃死人不吐骨头": "chī,sǐ,rén,bù,tǔ,gú,tou",
  "吃熊心豹子胆": "chī,xióng,xīn,bào,zi,dǎn",
  "吃瘪": "chī,biě",
  "吃白相饭": "chī,bái,xiàng,fàn",
  "吃相": "chī,xiàng",
  "吃着碗里看着锅里": "chī,zhuó,wǎn,lǐ,kàn,zhe,guō,lǐ",
  "吃着碗里瞧着锅里": "chī,zhe,wǎn,lǐ,qiáo,zhe,guō,lǐ",
  "吃着碟子看着碗": "chī,zhuó,dié,zǐ,kàn,zhe,wǎn",
  "吃空额": "chī,kòng,é",
  "吃空饷": "chī,kòng,xiǎng",
  "吃累": "chī,lèi",
  "吃肉不吐骨头": "chī,ròu,bù,tǔ,gú,tou",
  "吃苦受累": "chī,kǔ,shòu,lèi",
  "吃苦头": "chī,kǔ,tou",
  "吃虀宰相": "chī,jī,zǎi,xiàng",
  "吃虱子留后腿": "chī,shī,zi,liú,hòu,tuǐ",
  "吃血": "chī,xuè",
  "吃角子老虎": "chī,jiǎo,zi,lǎo,hǔ",
  "吃豆腐": "chī,dòu,fu",
  "吃跌": "chī,diē",
  "吃蹶": "chī,juě",
  "吃里扒外": "chī,lǐ,pá,wài",
  "吃钉子": "chī,dīng,zi",
  "吃饭处": "chī,fàn,chǔ",
  "吃饭家伙": "chī,fàn,jiā,huo",
  "吃饱撑着": "chī,bǎo,chēng,zhe",
  "吃馄饨": "chī,hún,tun",
  "吃馆子": "chī,guǎn,zi",
  "吃麻栗子": "chī,má,lì,zi",
  "各个地": "gè,gè,de",
  "各别地": "gè,bié,de",
  "各奔东西": "gè,bèn,dōng,xī",
  "各奔前程": "gè,bèn,qián,chéng",
  "各尽其职": "gè,jǐn,qí,zhí",
  "各市地": "gè,shì,de",
  "各干一行": "gè,gàn,yī,xíng",
  "各扎邦": "gè,zhā,bāng",
  "各有所好": "gè,yǒu,suǒ,hào",
  "各自为战": "gè,zì,wéi,zhàn",
  "各自为政": "gè,zì,wéi,zhèng",
  "各自地": "gè,zì,de",
  "各行各业": "gè,háng,gè,yè",
  "吆五喝六": "yāo,wǔ,hè,liù",
  "吆吆喝喝": "yāo,yāo,he,hē",
  "合不着": "hé,bù,zháo",
  "合两为一": "hé,liǎng,wéi,yī",
  "合为": "hé,wéi",
  "合二为一": "hé,èr,wéi,yī",
  "合什": "hé,shí",
  "合仆": "hé,pú",
  "合从": "hé,zòng",
  "合从连衡": "hé,zòng,lián,héng",
  "合众为一": "hé,zhòng,wéi,yī",
  "合众银行": "hé,zhòng,yín,háng",
  "合作地": "hé,zuò,de",
  "合同各方": "hé,tong,gè,fāng",
  "合同法": "hé,tong,fǎ",
  "合唱地": "hé,chàng,de",
  "合四乙尺工": "hé,sì,yǐ,chě,gōng",
  "合宜地": "hé,yí,de",
  "合干": "hé,gàn",
  "合应": "hé,yìng",
  "合得来": "hé,de,lái",
  "合得着": "hé,de,zháo",
  "合情合理地": "hé,qíng,hé,lǐ,de",
  "合意地": "hé,yì,de",
  "合成一个诸葛亮": "hé,chéng,yí,gè,zhū,gě,liàng",
  "合成地": "hé,chéng,de",
  "合成数": "hé,chéng,shù",
  "合拍地": "hé,pāi,de",
  "合数": "hé,shù",
  "合时令地": "hé,shí,lìng,de",
  "合时宜地": "hé,shí,yí,de",
  "合格地": "hé,gé,de",
  "合法地": "hé,fǎ,de",
  "合浦珠还": "hé,pǔ,zhū,huán",
  "合浦还珠": "hé,pǔ,huán,zhū",
  "合煞": "hé,shà",
  "合理地": "hé,lǐ,de",
  "合着": "hé,zhe",
  "合𦈡": "hé,xū",
  "合缝": "hé,fèng",
  "合群地": "hé,qún,de",
  "合而为一": "hé,ér,wéi,yī",
  "合落儿": "hé,lào,ér",
  "合调": "hé,diào",
  "合辙儿": "hé,zhé,er",
  "合适": "hé,shì",
  "合适地": "hé,shì,de",
  "吉人天相": "jí,rén,tiān,xiàng",
  "吉人自有天相": "jí,rén,zì,yǒu,tiān,xiàng",
  "吉兆地": "jí,zhào,de",
  "吉兴": "jí,xīng",
  "吉利地": "jí,lì,de",
  "吉娃娃": "jí,wá,wa",
  "吉尼系数": "jí,ní,xì,shù",
  "吉帖": "jí,tiē",
  "吉应": "jí,yìng",
  "吉里骨碌": "jí,lǐ,gū,lù",
  "吊丧": "diào,sāng",
  "吊儿郎当": "diào,er,láng,dāng",
  "吊卷": "diào,juàn",
  "吊嗓子": "diào,sǎng,zi",
  "吊带背心": "diào,dài,bèi,xīn",
  "吊拷𰬔把": "diào,kǎo,bīng,bǎ",
  "吊斗": "diào,dǒu",
  "吊查": "diào,zhā",
  "吊膀子": "diào,bàng,zi",
  "吊铺": "diào,pù",
  "吊鼻子": "diào,bí,zi",
  "同位素地": "tóng,wèi,sù,de",
  "同声相应": "tóng,shēng,xiāng,yìng",
  "同处": "tóng,chǔ",
  "同好": "tóng,hào",
  "同形地": "tóng,xíng,de",
  "同恶": "tóng,wù",
  "同恶相助": "tóng,wù,xiāng,zhù",
  "同恶相恤": "tóng,wù,xiāng,xù",
  "同情地": "tóng,qíng,de",
  "同意地": "tóng,yì,de",
  "同时发生地": "tóng,shí,fā,shēng,de",
  "同时地": "tóng,shí,de",
  "同时着地": "tóng,shí,zhe,de",
  "同样地": "tóng,yàng,de",
  "同样地大": "tóng,yàng,de,dà",
  "同步地": "tóng,bù,de",
  "同步数位阶层": "tóng,bù,shù,wèi,jiē,céng",
  "同盟地": "tóng,méng,de",
  "同相地": "tóng,xiāng,de",
  "同等地": "tóng,děng,de",
  "同舍": "tóng,shè",
  "同舍郎": "tóng,shè,láng",
  "同行": "tóng,háng",
  "同裯": "tóng,dāo",
  "同调": "tóng,diào",
  "同载": "tóng,zǎi",
  "同量地": "tóng,liàng,de",
  "同铺": "tóng,pù",
  "名不正言不顺": "míng,bu,zhèng,yán,bu,shùn",
  "名不见经传": "míng,bú,jiàn,jīng,zhuàn",
  "名为": "míng,wéi",
  "名义上地": "míng,yì,shàng,de",
  "名人地": "míng,rén,de",
  "名人效应": "míng,rén,xiào,yìng",
  "名儿": "míng,er",
  "名刹": "míng,shā",
  "名号侯": "míng,hào,hòu",
  "名堂": "míng,tang",
  "名头": "míng,tou",
  "名字": "míng,zi",
  "名将": "míng,jiàng",
  "名数": "míng,shù",
  "名狼藉地": "míng,láng,jí,de",
  "名相": "míng,xiàng",
  "名着": "míng,zhe",
  "名角": "míng,jué",
  "名角儿": "míng,jué,er",
  "名词性地": "míng,cí,xìng,de",
  "后不着店": "hòu,bù,zháo,diàn",
  "后儿": "hòu,er",
  "后发座": "hòu,fà,zuò",
  "后堤": "hòu,dī",
  "后头": "hòu,tou",
  "后尾儿": "hòu,wěi,er",
  "后悔地": "hòu,huǐ,de",
  "后来地": "hòu,lái,de",
  "后楯": "hòu,dùn",
  "后爪": "hòu,zhuǎ",
  "后生仔": "hòu,shēng,zǎi",
  "后着": "hòu,zhe",
  "后祇": "hòu,qí",
  "后累": "hòu,lèi",
  "后翻筋斗": "hòu,fān,jīn,dǒu",
  "后老子": "hòu,lǎo,zi",
  "后背": "hòu,bèi",
  "后脑勺儿": "hòu,nǎo,sháo,er",
  "后脑勺子": "hòu,nǎo,sháo,zi",
  "后调": "hòu,diào",
  "后辈子": "hòu,bèi,zi",
  "后边": "hòu,bian",
  "后边儿": "hòu,bian,er",
  "后里头": "hòu,lǐ,tou",
  "后钩儿": "hòu,gōu,er",
  "吏干": "lì,gàn",
  "吏舍": "lì,shè",
  "吐口水": "tù,kǒu,shuǐ",
  "吐哺握发": "tǔ,bǔ,wò,fà",
  "吐喽": "tǔ,lou",
  "吐嘈": "tù,cáo",
  "吐槽": "tù,cáo",
  "吐槽大会": "tù,cáo,dà,huì",
  "吐沫": "tù,mò",
  "吐泻": "tù,xiè",
  "吐肝露胆": "tǔ,gān,lù,dǎn",
  "吐舌头": "tǔ,shé,tou",
  "吐蕃": "tǔ,bō",
  "吐蕃王朝": "tǔ,bō,wáng,cháo",
  "吐血": "tù,xiě",
  "吐谷浑": "tǔ,yù,hún",
  "吐露": "tǔ,lù",
  "吐露真情": "tǔ,lù,zhēn,qíng",
  "吐鹘": "tǔ,hú",
  "向上一纵": "xiàng,shàng,yí,zòng",
  "向上地": "xiàng,shàng,de",
  "向下地": "xiàng,xià,de",
  "向东方地": "xiàng,dōng,fāng,de",
  "向侧面地": "xiàng,cè,miàn,de",
  "向内部地": "xiàng,nèi,bù,de",
  "向前地": "xiàng,qián,de",
  "向北方地": "xiàng,běi,fāng,de",
  "向原野地": "xiàng,yuán,yě,de",
  "向右地": "xiàng,yòu,de",
  "向右转地": "xiàng,yòu,zhuǎn,de",
  "向后地": "xiàng,hòu,de",
  "向后转地": "xiàng,hòu,zhuǎn,de",
  "向后面地": "xiàng,hòu,miàn,de",
  "向地地": "xiàng,de,de",
  "向地球地": "xiàng,de,qiú,de",
  "向声背实": "xiàng,shēng,bèi,shí",
  "向外地": "xiàng,wài,de",
  "向天空地": "xiàng,tiān,kōng,de",
  "向头部地": "xiàng,tóu,bù,de",
  "向家地": "xiàng,jiā,de",
  "向岸地": "xiàng,àn,de",
  "向应": "xiàng,yìng",
  "向心里地": "xiàng,xīn,lǐ,de",
  "向旁地": "xiàng,páng,de",
  "向旁边地": "xiàng,páng,biān,de",
  "向水性地": "xiàng,shuǐ,xìng,de",
  "向湿性地": "xiàng,shī,xìng,de",
  "向着": "xiàng,zhe",
  "向神地": "xiàng,shén,de",
  "向背": "xiàng,bèi",
  "向船尾地": "xiàng,chuán,wěi,de",
  "向药性地": "xiàng,yào,xìng,de",
  "向西方地": "xiàng,xī,fāng,de",
  "向西部地": "xiàng,xī,bù,de",
  "向边缘地": "xiàng,biān,yuán,de",
  "向量代数": "xiàng,liàng,dài,shù",
  "吓一大跳": "xià,yí,dà,tiào",
  "吓煞": "xià,shà",
  "吕葛": "lǚ,gě",
  "吖丁啶": "ā,dīng,dìng",
  "吖吖": "ā,ā",
  "吖啶": "ā,dìng",
  "吖嗪": "ā,qín",
  "吗吗糊糊": "ma,ma,hū,hū",
  "吗哪": "mǎ,nǎ",
  "吗啉": "mǎ,lín",
  "吗啡": "mǎ,fēi",
  "吗玩意儿": "má,wán,yì,er",
  "吚吚哑哑": "yī,yī,yā,yā",
  "吚哩呱喇": "yī,lǐ,guā,lǎ",
  "吚唔": "yī,wú",
  "吚喔": "yī,wō",
  "吚轧": "yī,zhá",
  "君侯": "jūn,hòu",
  "君大夫": "jūn,dài,fū",
  "君子": "jūn,zi",
  "君子好逑": "jūn,zǐ,hào,qiú",
  "君子远庖厨": "jūn,zǐ,yuàn,páo,chú",
  "君长": "jūn,zhǎng",
  "吝啬地": "lìn,sè,de",
  "吝啬地给": "lìn,sè,de,gěi",
  "吞吞地": "tūn,tūn,de",
  "吞吞地前进": "tūn,tūn,de,qián,jìn",
  "吞咀": "tūn,zuǐ",
  "吞搂": "tūn,lōu",
  "吞没": "tūn,mò",
  "吞言咽理": "tūn,yán,yān,lǐ",
  "吟兴": "yín,xīng",
  "吟卷": "yín,juàn",
  "吟呗": "yín,bài",
  "吟哦": "yín,é",
  "吟翫": "yín,wàn",
  "吟讽": "yín,fěng",
  "吠尨": "fèi,méng",
  "吠舍": "fèi,shè",
  "吡叻": "bǐ,lè",
  "吡吡": "bǐ,bǐ",
  "吡咯": "bǐ,gē",
  "吡哩叭喇": "bǐ,lǐ,bā,lǎ",
  "吡唎": "bǐ,lī",
  "吡唑": "bǐ,zuò",
  "吡啶": "bǐ,dìng",
  "吡喃": "bǐ,nán",
  "吡嗪": "bǐ,qín",
  "吡噉": "bǐ,dàn",
  "吡拉西坦": "bǐ,lā,xī,tǎn",
  "否剥": "pǐ,bāo",
  "否去泰来": "pǐ,qù,tài,lái",
  "否口": "pǐ,kǒu",
  "否塞": "pǐ,sāi",
  "否妇": "pǐ,fù",
  "否定地": "fǒu,deng,de",
  "否屈": "pǐ,qū",
  "否往泰来": "pǐ,wǎng,tài,lái",
  "否德": "pǐ,dé",
  "否戾": "pǐ,lì",
  "否极泰回": "pǐ,jí,tài,huí",
  "否极泰来": "pǐ,jí,tài,lái",
  "否极阳回": "pǐ,jí,yáng,huí",
  "否桑": "pǐ,sāng",
  "否泰": "pǐ,tài",
  "否滞": "pǐ,zhì",
  "否终则泰": "pǐ,zhōng,zé,tài",
  "否终复泰": "pǐ,zhōng,fù,tài",
  "否结": "pǐ,jié",
  "否臧": "pǐ,zāng",
  "否败": "pǐ,bài",
  "否运": "pǐ,yùn",
  "否道": "pǐ,dào",
  "否闭": "pǐ,bì",
  "否隔": "pǐ,gé",
  "否鬲": "pǐ,gé",
  "吧儿狗": "ba,ér,gǒu",
  "吧咂": "ba,zā",
  "吧唧吧唧": "bā,ji,bā,ji",
  "吧嚓": "ba,chā",
  "吨数": "dūn,shù",
  "含含糊糊": "hán,hán,hū,hū",
  "含味隽永": "hán,wèi,juàn,yǒng",
  "含咀": "hán,zuǐ",
  "含咽": "hán,yān",
  "含情脉脉": "hán,qíng,mò,mò",
  "含括": "hán,guā",
  "含春侯": "hán,chūn,hòu",
  "含有地": "hán,yǒu,de",
  "含殓": "hàn,liàn",
  "含泪地": "hán,lèi,de",
  "含混地说": "hán,hùn,de,shuō",
  "含着骨头露着肉": "hán,zhe,gǔ,tóu,lù,zhe,ròu",
  "含笑地": "hán,xiào,de",
  "含糊地": "hán,hú,de",
  "含糊地发": "hán,hú,de,fā",
  "含糊地发音": "hán,hú,de,fā,yīn",
  "含糊地念": "hán,hú,de,niàn",
  "含糊地说": "hán,hú,de,shuō",
  "含而不露": "hán,ér,bù,lù",
  "含胡": "hán,hu",
  "含蓄地": "hán,xù,de",
  "含血": "hán,xuè",
  "含血喷人": "hán,xuè,pēn,rén",
  "含血噀人": "hán,xuè,xùn,rén",
  "含血潠人": "hán,xuè,xùn,rén",
  "含露": "hán,lù",
  "听上去": "tīng,shàng,qu",
  "听不到": "tīng,bu,dào",
  "听不见": "tīng,bu,jiàn",
  "听不进去": "tīng,bù,jìn,qu",
  "听从地": "tīng,cóng,de",
  "听伺": "tīng,sì",
  "听墙根儿": "tīng,qiáng,gēn,er",
  "听差": "tīng,chāi",
  "听得到": "tīng,de,dào",
  "听得懂": "tīng,de,dǒng",
  "听得见": "tīng,de,jiàn",
  "听教训地": "tīng,jiào,xùn,de",
  "听而不闻": "tīng,ér,bú,wén",
  "听调": "tīng,diào",
  "听起来": "tīng,qi,lai",
  "吭吃": "kēng,chī",
  "吭吭": "kēng,kēng",
  "吭吭吃吃": "kēng,kēng,chī,chī",
  "吭咽": "háng,yān",
  "吭哧": "kēng,chī",
  "吭唧": "kēng,jī",
  "吭唷": "kēng,yō",
  "吭啷": "kēng,lāng",
  "吭嗌": "háng,ài",
  "吭嗓": "kēng,sǎng",
  "吭嗤": "kēng,chī",
  "吭声": "kēng,shēng",
  "吭气": "kēng,qì",
  "吭臆": "kēng,yì",
  "吮血": "shǔn,xuè",
  "启予": "qǐ,yǔ",
  "启动子": "qǐ,dòng,zi",
  "启发地": "qǐ,fā,de",
  "启处": "qǐ,chǔ",
  "启应祈祷": "qǐ,yìng,qí,dǎo",
  "启示地": "qǐ,shì,de",
  "启蒙地": "qǐ,méng,de",
  "启蕃": "qǐ,fān",
  "启闭塞": "qǐ,bì,sè",
  "启露": "qǐ,lù",
  "吱吱咯咯": "zhī,zhī,gē,gē",
  "吱吱地叫": "zhī,zhī,de,jiào",
  "吱吱声": "zī,zī,shēng",
  "吱咀": "zī,zuǐ",
  "吱咕": "zī,gū",
  "吱哇": "zī,wā",
  "吱哩哇啦": "zhī,lī,wā,lā",
  "吱唔": "zhī,wú",
  "吱啦": "zī,lā",
  "吱喳": "zī,zhā",
  "吱喽": "zī,lou",
  "吱喽喽": "zī,lou,lou",
  "吱嗻": "zī,zhē",
  "吱妞": "zī,niū",
  "吱扭": "zī,niǔ",
  "吱溜": "zī,liū",
  "吴兴": "wú,xīng",
  "吴兴体": "wú,xīng,tǐ",
  "吴兴区": "wú,xīng,qū",
  "吴堡": "wú,bǔ",
  "吴堡县": "wú,bǔ,xiàn",
  "吴干": "wú,gàn",
  "吴楚帆": "wú,chǔ,fān",
  "吴调": "wú,diào",
  "吵包子": "chǎo,bāo,zi",
  "吵闹地": "chǎo,nào,de",
  "吸取教训": "xī,qǔ,jiào,xun",
  "吸引人地": "xī,yǐn,rén,de",
  "吸引子": "xī,yǐn,zi",
  "吸欻": "xī,chuā",
  "吸湿性地": "xī,shī,xìng,de",
  "吸血": "xī,xuè",
  "吸血乌贼": "xī,xuè,wū,zéi",
  "吸血者": "xī,xuè,zhě",
  "吸血鬼": "xī,xuè,guǐ",
  "吸逮": "xī,dǎi",
  "吸露": "xī,lù",
  "吸风饮露": "xī,fēng,yǐn,lù",
  "吹吁": "chuī,yù",
  "吹呴": "chuī,hǒu",
  "吹喇叭": "chuī,lǎ,ba",
  "吹嘘地": "chuī,xū,de",
  "吹微风地": "chuī,wēi,fēng,de",
  "吹毛数睫": "chuī,máo,shù,jié",
  "吹毛求疵地": "chuī,máo,qiú,cī,de",
  "吹求疵地": "chuī,qiú,cī,de",
  "吹竹弹丝": "chuī,zhú,dàn,sī",
  "吹管乐": "chuī,guǎn,yuè",
  "吹胡子瞪眼": "chuī,hú,zi,dèng,yǎn",
  "吻喇喇": "wěn,là,là",
  "吼三喝四": "hǒu,sān,hè,sì",
  "吽吽": "hōng,hōng",
  "吽呀": "ōu,yā",
  "吽牙": "ōu,yá",
  "吾们": "wú,men",
  "吾自有处": "wú,zì,yǒu,chǔ",
  "呀吁": "yā,yù",
  "呀呀唔": "yā,yā,wú",
  "呃吓": "e,xià",
  "呃呃": "e,e",
  "呃喔": "e,wō",
  "呃𰇣": "e,xì",
  "呆会儿": "dāi,huì,er",
  "呆呆地": "dāi,dāi,de",
  "呆呆地坐在": "dāi,dāi,de,zuò,zài",
  "呆呆地坐在地上": "dāi,dāi,de,zuò,zài,de,shàng",
  "呆呆地想": "dāi,dāi,de,xiǎng",
  "呆呆地看": "dāi,dāi,de,kàn",
  "呆呆地看住": "dāi,dāi,de,kàn,zhù",
  "呆呆地看着": "dāi,dāi,de,kàn,zhe",
  "呆呆地看着自己": "dāi,dāi,de,kàn,zhe,zì,jǐ",
  "呆呆地站着": "dāi,dāi,de,zhàn,zhe",
  "呆子": "dāi,zi",
  "呆怔": "dāi,zhèng",
  "呆木头": "dāi,mù,tou",
  "呆板地": "dāi,bǎn,de",
  "呆滞地": "dāi,zhì,de",
  "呆钝地": "dāi,dùn,de",
  "呈卷": "chéng,juàn",
  "呈应": "chéng,yìng",
  "呈红色地": "chéng,hóng,sè,de",
  "呈露": "chéng,lù",
  "告一段落": "gào,yí,duàn,luò",
  "告假": "gào,jià",
  "告儿": "gào,er",
  "告𠡠": "gào,lài",
  "告化子": "gào,huā,zǐ",
  "告存": "jū,cún",
  "告愬": "gào,shuò",
  "告朔": "gù,shuò",
  "告朔饩羊": "gù,shuò,xì,yáng",
  "告示": "gào,shi",
  "告老还乡": "gào,lǎo,huán,xiāng",
  "告老还家": "gào,lǎo,huán,jiā",
  "告诉才处理": "gào,sù,cái,chǔ,lǐ",
  "告诫地": "gào,jiè,de",
  "告送": "gào,song",
  "呐呐地": "nà,nà,de",
  "呒不": "wǔ,bù",
  "呒啥": "wǔ,shá",
  "呒没": "wǔ,méi",
  "呒淘成": "wǔ,táo,chéng",
  "呒虾米": "wú,xiā,mǐ",
  "呒虾米输入法": "wǔ,xiā,mǐ,shū,rù,fǎ",
  "呓挣": "yì,zhēng",
  "呕吐": "ǒu,tù",
  "呕吐物": "ǒu,tù,wù",
  "呕呴": "ǒu,hǒu",
  "呕哑": "ōu,yā",
  "呕心沥血": "ǒu,xīn,lì,xuè",
  "呕心滴血": "ǒu,xīn,dī,xuè",
  "呕心血": "ǒu,xīn,xuè",
  "呕血": "ǒu,xuè",
  "呕轧": "ǒu,zhá",
  "呗佛": "bài,fó",
  "呗偈": "bài,jì",
  "呗唱": "bài,chàng",
  "呗声": "bài,shēng",
  "呗赞": "bài,zàn",
  "呗音": "bài,yīn",
  "员圌": "yuán,chuí",
  "员数": "yuán,shù",
  "员栅": "yuán,shān",
  "呙堕髻": "guō,duò,jì",
  "呙斜": "guō,xié",
  "呙氏": "guō,shì",
  "呛人": "qiàng,rén",
  "呛到": "qiàng,dào",
  "呛咕": "qiāng,gu",
  "呛咳": "qiāng,hāi",
  "呛啍": "qiāng,tūn",
  "呛眼": "qiàng,yǎn",
  "呛鼻": "qiàng,bí",
  "呜呃": "wū,e",
  "呜呜咽咽": "wū,wū,yè,yè",
  "呜呜地叫": "wū,wū,de,jiào",
  "呜呜地哭": "wū,wū,de,kū",
  "呜咽": "wū,yè",
  "呜哩呜喇": "wū,lǐ,wū,lǎ",
  "呜哩哇啦": "wū,lǐ,wā,lā",
  "呜轧": "wū,zhá",
  "呢呢": "ní,ní",
  "呢呢痴痴": "ní,ní,chī,chī",
  "呢喃": "ní,nán",
  "呢喃细语": "ní,nán,xì,yǔ",
  "呢子": "ní,zǐ",
  "呢绒": "ní,róng",
  "呦咽": "yōu,yān",
  "周任": "zhōu,rén",
  "周内": "zhōu,nà",
  "周围地": "zhōu,wéi,de",
  "周围性眩晕": "zhōu,wéi,xìng,xuàn,yùn",
  "周埏": "zhōu,shān",
  "周处": "zhōu,chǔ",
  "周密地": "zhōu,mì,de",
  "周扎": "zhōu,zhā",
  "周期函数": "zhōu,qī,hán,shù",
  "周期地": "zhōu,qī,de",
  "周期性地": "zhōu,qī,xìng,de",
  "周期数": "zhōu,qī,shù",
  "周正": "zhōu,zhēng",
  "周翫": "zhōu,wàn",
  "周镐": "zhōu,hào",
  "周露": "zhōu,lù",
  "呪禁": "zhòu,jìn",
  "呪禁师": "zhòu,jìn,shī",
  "呫吨": "zhān,dūn",
  "呫吨酮": "zhān,dūn,tóng",
  "呫唫": "tiè,yín",
  "呫嚅": "chè,rú",
  "呮查": "qì,zhā",
  "呰牙咧嘴": "zǐ,yá,liě,zuǐ",
  "呱呱": "gū,gū",
  "呱呱地叫": "gū,gū,de,jiào",
  "呱呱坠地": "gū,gū,zhuì,dì",
  "呱呱堕地": "gū,gū,duò,dì",
  "呱呱落地": "gū,gū,luò,dì",
  "呱打打": "guā,dā,dā",
  "呲呲": "cī,cī",
  "呲打": "cī,dá",
  "呲牙咧嘴": "zī,yá,liě,zuǐ",
  "味儿": "wèi,er",
  "味淡地": "wèi,dàn,de",
  "味道": "wèi,dao",
  "呴俞": "hǒu,yú",
  "呴偷": "hǒu,tōu",
  "呴吁": "hǒu,yù",
  "呴呕": "hǒu,ǒu",
  "呴呴": "hǒu,hǒu",
  "呴呴呕呕": "hǒu,hǒu,ǒu,ǒu",
  "呴呴濡沫": "hǒu,hǒu,rú,mò",
  "呴喻": "hǒu,yù",
  "呴嘘": "hǒu,xū",
  "呴嘷": "hǒu,háo",
  "呴愉": "hǒu,yú",
  "呴沫": "hǒu,mò",
  "呴濡": "hǒu,rú",
  "呴煦": "hǒu,xù",
  "呴犁湖": "hǒu,lí,hú",
  "呴谕": "hǒu,yù",
  "呴鸣": "hǒu,míng",
  "呵叻": "kē,lè",
  "呵喝": "hē,hè",
  "呵禁": "hē,jìn",
  "呵罗罗": "hē,luō,luō",
  "呷呷": "gā,gā",
  "呷蛇龟": "gā,shé,guī",
  "呻吟地说": "shēn,yín,de,shuō",
  "呻恫": "shēn,tōng",
  "呼不给吸": "hū,bù,jǐ,xī",
  "呼卢喝雉": "hū,lú,hè,zhì",
  "呼号": "hū,háo",
  "呼吁": "hū,yù",
  "呼吁书": "hū,yù,shū",
  "呼呼哱": "hū,hū,bō",
  "呼哧呼哧": "hū,chi,hū,chi",
  "呼唤地": "hū,huàn,de",
  "呼喇喇": "hū,là,là",
  "呼喝": "hū,hè",
  "呼天吁地": "hū,tiān,yù,dì",
  "呼天抢地": "hū,tiān,qiāng,dì",
  "呼天钥地": "hū,tiān,yào,dì",
  "呼幺喝六": "hū,yāo,hè,liù",
  "呼应": "hū,yìng",
  "呼来喝去": "hū,lái,hè,qù",
  "命中": "mìng,zhòng",
  "命中率": "mìng,zhòng,lǜ",
  "命令式地": "mìng,lìng,shì,de",
  "命令行": "mìng,lìng,háng",
  "命名地": "mìng,míng,de",
  "命干": "mìng,gàn",
  "命数": "mìng,shù",
  "命根子": "mìng,gēn,zi",
  "命舃": "mìng,tuō",
  "命薄": "mìng,bó",
  "命铺": "mìng,pù",
  "命题逻辑": "mìng,tí,luó,ji",
  "呿吟": "qù,yín",
  "呿吸": "qù,xī",
  "呿呀": "qù,yā",
  "呿唫": "qù,yín",
  "呿嗋": "qù,xié",
  "呿嗟": "qù,jiē",
  "呿嵯": "qù,cuó",
  "呿陀": "qù,tuó",
  "呿颐结舌": "qù,yí,jié,shé",
  "咀吞": "zuǐ,tūn",
  "咀呪": "zuǐ,zhòu",
  "咀味": "zuǐ,wèi",
  "咀咂": "zuǐ,zā",
  "咀咏": "zuǐ,yǒng",
  "咀唔": "jǔ,wú",
  "咀啖": "zuǐ,dàn",
  "咀啜": "zuǐ,chuò",
  "咀啮": "zuǐ,niè",
  "咀噍": "zuǐ,jiào",
  "咀嚅": "zuǐ,rú",
  "咀嚼": "jǔ,jué",
  "咀嚼英华": "jǔ,jué,yīng,huá",
  "咀征含商": "zuǐ,zhēng,hán,shāng",
  "咀片": "zuǐ,piàn",
  "咀脸": "zuǐ,liǎn",
  "咀茹": "zuǐ,rú",
  "咀药": "zuǐ,yào",
  "咀赖罗": "zuǐ,lài,luó",
  "咂咂地吃": "zā,zā,de,chī",
  "咂摸": "zā,mo",
  "咆哮地": "páo,xiāo,de",
  "咆哱": "páo,bō",
  "咇剥剥": "bì,bāo,bāo",
  "咇咇剥剥": "bì,bì,bāo,bāo",
  "咇茀": "bì,bó",
  "咉咽": "yǎng,yān",
  "咋呼": "zhā,hū",
  "咋唬": "zhā,hǔ",
  "咋唶": "zé,jiè",
  "咋噬": "zé,shì",
  "咋指": "zé,zhǐ",
  "咋指吐舌": "zé,zhǐ,tǔ,shé",
  "咋笔": "zé,bǐ",
  "咋舌": "zé,shé",
  "和丸": "huò,wán",
  "和了": "hú,le",
  "和从": "hè,cóng",
  "和哄": "hè,hòng",
  "和善地": "hé,shàn,de",
  "和善地问": "hé,shàn,de,wèn",
  "和堇": "hé,jǐn",
  "和声地": "hé,shēng,de",
  "和好地": "hé,hǎo,de",
  "和尚打伞": "hé,shang,dǎ,sǎn",
  "和布克赛尔蒙古自治县": "hé,bù,kè,sài,ěr,měng,gǔ,zì,zhì,xiàn",
  "和平共处": "hé,píng,gòng,chǔ",
  "和平共处五项原则": "hé,píng,gòng,chǔ,wǔ,xiàng,yuán,zé",
  "和平地": "hé,píng,de",
  "和平地解决": "hé,píng,de,jiě,jué",
  "和应": "hé,yìng",
  "和弄": "huò,nòng",
  "和弹": "hé,dàn",
  "和得来": "hé,de,lái",
  "和散那": "hé,sǎn,nà",
  "和数": "hé,shù",
  "和朴": "hé,piáo",
  "和气地": "hé,qì,de",
  "和泥": "huó,ní",
  "和熊": "huó,xióng",
  "和牌": "hú,pái",
  "和睦地": "hé,mù,de",
  "和睦相处": "hé,mù,xiāng,chǔ",
  "和稀泥": "huò,xī,ní",
  "和缓地": "hé,huǎn,de",
  "和药": "huò,yào",
  "和蔼地": "hé,ǎi,de",
  "和蔼地说": "hé,ǎi,de,shuō",
  "和蕃": "hé,fān",
  "和诗": "hè,shī",
  "和调": "hé,diào",
  "和谐地": "hé,xié,de",
  "和适": "hé,shì",
  "和霭地": "hé,ǎi,de",
  "和面": "huó,miàn",
  "和颜说色": "hé,yán,yuè,sè",
  "咍吁": "hāi,yù",
  "咎累": "jiù,lèi",
  "咏叹调": "yǒng,tàn,diào",
  "咒禁师": "zhòu,jìn,shī",
  "咒骂地": "zhòu,mà,de",
  "咔哒声": "kǎ,da,shēng",
  "咔啦": "kā,lā",
  "咔嗒": "kā,dā",
  "咔嚓": "kā,chā",
  "咕咕地": "gū,gū,de",
  "咕咕地叫": "gū,gū,de,jiào",
  "咕哝": "gū,nong",
  "咕噜": "gū,lu",
  "咕攘": "gū,rang",
  "咕量": "gū,liáng",
  "咕隆": "gū,lōng",
  "咖啡馆儿": "kā,fēi,guǎn,er",
  "咖喱": "gā,lí",
  "咖喱粉": "gā,lí,fěn",
  "咚咚": "dōng,dong",
  "咥咥": "xī,xī",
  "咥噬": "xī,shì",
  "咥然": "xī,rán",
  "咧嘴": "liě,zuǐ",
  "咧开嘴笑": "liě,kāi,zuǐ,xiào",
  "咧扯": "liě,chě",
  "咧着嘴笑": "liě,zhe,zuǐ,xiào",
  "咨牙露嘴": "zī,yá,lù,zuǐ",
  "咨趄": "zī,jū",
  "咨逮": "zī,dǎi",
  "咪咪地叫": "mī,mī,de,jiào",
  "咬嚼吞吐": "yǎo,jué,tūn,tǔ",
  "咬牙切齿": "yǎo,yá,qiè,chǐ",
  "咬着耳朵": "yǎo,zhe,ěr,duo",
  "咬耳朵": "yǎo,ěr,duo",
  "咬血为盟": "yǎo,xuè,wéi,méng",
  "咭力骨碌": "jī,lì,gū,lù",
  "咭咧呱啦": "jī,liě,guā,lā",
  "咭咭咯咯": "jī,jī,gē,gē",
  "咭哩咕哝": "jī,lǐ,gū,nóng",
  "咭噔咯噔": "jī,dēng,gē,dēng",
  "咯叽": "gē,jī",
  "咯吧": "gē,ba",
  "咯吱": "gē,zhī",
  "咯咂": "gē,zā",
  "咯咯": "gē,gē",
  "咯咯地叫": "gē,gē,de,jiào",
  "咯咯地笑": "gē,gē,de,xiào",
  "咯咯笑": "gē,gē,xiào",
  "咯喳喳": "gē,zhā,zhā",
  "咯嗒": "gē,dā",
  "咯嘣": "gē,bēng",
  "咯噔": "gē,dēng",
  "咯嚓": "gē,chā",
  "咯娄": "gē,lóu",
  "咯崩": "gē,bēng",
  "咯巴": "gē,bā",
  "咯当": "gē,dāng",
  "咯支": "gē,zhī",
  "咯支支": "gē,zhī,zhī",
  "咯碌": "gē,lù",
  "咯腾": "gē,téng",
  "咯蹬": "gē,dēng",
  "咱们": "zán,men",
  "咱俩": "zán,liǎ",
  "咱家": "zá,jiā",
  "咳儿": "hāi,ér",
  "咳吐": "hāi,tǔ",
  "咳呛": "ké,qiàng",
  "咳咳": "hāi,hāi",
  "咳咳巴巴": "hāi,hāi,bā,bā",
  "咳唶": "hāi,jiè",
  "咳声叹气": "hāi,shēng,tàn,qì",
  "咳婴": "hāi,yīng",
  "咳家": "hāi,jiā",
  "咳歌打战": "hāi,gē,dǎ,zhàn",
  "咳气": "hāi,qì",
  "咳笑": "hái,xiào",
  "咳血": "ké,xuè",
  "咳首": "hāi,shǒu",
  "咶咶喇喇": "huài,huài,là,là",
  "咸丝丝儿": "xián,sī,sī,er",
  "咸兴": "xián,xīng",
  "咸兴市": "xián,xīng,shì",
  "咸津津儿": "xián,jīn,jīn,er",
  "咸濩": "xián,hù",
  "咸舃": "xián,tuō",
  "咺唏": "xuān,xī",
  "咻呴": "xiū,hǒu",
  "咻地": "xiū,de",
  "咻地发声": "xiū,de,fā,shēng",
  "咽人": "yān,rén",
  "咽切": "yān,qiē",
  "咽吭": "yān,kēng",
  "咽呜": "yān,wū",
  "咽咽": "yè,yè",
  "咽哕": "yān,yuě",
  "咽哳": "yān,zhā",
  "咽哺": "yān,bǔ",
  "咽哽": "yān,gěng",
  "咽唾": "yān,tuò",
  "咽喉": "yān,hóu",
  "咽喉炎": "yān,hóu,yán",
  "咽喉要地": "yān,hóu,yào,dì",
  "咽嗢": "yān,wà",
  "咽噱": "yān,jué",
  "咽嚼": "yān,jiáo",
  "咽塞": "yān,sāi",
  "咽头": "yān,tóu",
  "咽峡": "yān,xiá",
  "咽峡炎": "yān,xiá,yán",
  "咽息": "yān,xī",
  "咽日": "yān,rì",
  "咽泣": "yān,qì",
  "咽津": "yān,jīn",
  "咽漱": "yān,shù",
  "咽炎": "yān,yán",
  "咽绝": "yān,jué",
  "咽语": "yān,yǔ",
  "咽音": "yān,yīn",
  "咽项": "yān,xiàng",
  "咽领": "yān,lǐng",
  "咽颈": "yān,jǐng",
  "咽颔": "yān,hàn",
  "咽鼓管": "yān,gǔ,guǎn",
  "咿咿哑哑": "yī,yī,yā,yā",
  "咿哑": "yī,yā",
  "咿哩呱喇": "yī,lǐ,guā,lǎ",
  "咿哩哇啦": "yī,lǐ,wā,lā",
  "咿唔": "yī,wú",
  "咿喔": "yī,wō",
  "咿轧": "yī,zhá",
  "哀乐": "āi,yuè",
  "哀伤地": "āi,shāng,de",
  "哀号": "āi,háo",
  "哀吁": "āi,yù",
  "哀咽": "āi,yān",
  "哀哀地": "āi,āi,de",
  "哀哀地叫": "āi,āi,de,jiào",
  "哀哭切齿": "āi,kū,qiè,chǐ",
  "哀弹": "āi,dàn",
  "哀怜地": "āi,lián,de",
  "哀恫": "āi,tōng",
  "哀毁瘠立": "āi,huǐ,jī,lì",
  "哀求地": "āi,qiú,de",
  "哀臒": "āi,qú",
  "哀骀": "āi,dài",
  "品相": "pǐn,xiàng",
  "品着": "pǐn,zhe",
  "品端地": "pǐn,duān,de",
  "品竹调弦": "pǐn,zhú,diào,xián",
  "品调": "pǐn,diào",
  "哄争": "hǒng,zhēng",
  "哄人": "hǒng,rén",
  "哄伙": "hǒng,huǒ",
  "哄劝": "hǒng,quàn",
  "哄咙": "hǒng,lóng",
  "哄哄": "hǒng,hǒng",
  "哄场": "hòng,chǎng",
  "哄士": "hǒng,shì",
  "哄孩子": "hǒng,hái,zi",
  "哄导": "hǒng,dǎo",
  "哄小孩": "hǒng,xiǎo,hái",
  "哄局": "hǒng,jú",
  "哄市": "hǒng,shì",
  "哄弄": "hǒng,nòng",
  "哄怂": "hǒng,sǒng",
  "哄拥": "hǒng,yōng",
  "哄斗": "hǒng,dòu",
  "哄犯": "hǒng,fàn",
  "哄瞒": "hǒng,mán",
  "哄腾": "hǒng,téng",
  "哄语": "hǒng,yǔ",
  "哄诱": "hǒng,yòu",
  "哄逗": "hǒng,dòu",
  "哄集": "hǒng,jí",
  "哄饮": "hǒng,yǐn",
  "哄骗": "hǒng,piàn",
  "哄骗地": "hǒng,piàn,de",
  "哆口": "chǐ,kǒu",
  "哆哆嗦嗦": "duō,duō,suo,suo",
  "哆哩哆嗦": "duō,lǐ,duō,suo",
  "哆嗦": "duō,suo",
  "哇哇地": "wā,wā,de",
  "哇哇地叫": "wā,wā,de,jiào",
  "哇哇地哭": "wā,wā,de,kū",
  "哇哩哇啦": "wā,lǐ,wā,lā",
  "哇地一声": "wa,de,yī,shēng",
  "哈什": "hà,shí",
  "哈什蚂": "hà,shí,mǎ",
  "哈叭狗": "hǎ,bā,gǒu",
  "哈哄哄": "hā,hǒng,hǒng",
  "哈哈地笑": "hā,hā,de,xiào",
  "哈士蟆": "hà,shi,má",
  "哈巴": "hǎ,bā",
  "哈巴儿": "hǎ,bā,er",
  "哈巴狗": "hǎ,bā,gǒu",
  "哈拉子": "hā,lā,zi",
  "哈达": "hǎ,dá",
  "哈迪": "hǎ,dí",
  "呱啶": "pài,dìng",
  "呱嗪": "pài,qín",
  "呱替啶": "pài,tì,dìng",
  "响亮地": "xiǎng,liàng,de",
  "响应": "xiǎng,yìng",
  "响应号召": "xiǎng,yìng,hào,zhào",
  "响应地": "xiǎng,yìng,de",
  "响应时间": "xiǎng,yìng,shí,jiān",
  "响糖狮子": "xiǎng,táng,shī,zi",
  "响铛铛": "xiǎng,chēng,chēng",
  "哑吧": "yǎ,ba",
  "哑吧亏": "yǎ,ba,kuī",
  "哑咽": "yǎ,yān",
  "哑哑": "yā,yā",
  "哑巴吃黄莲": "yǎ,ba,chī,huáng,lián",
  "哑然地": "yǎ,rán,de",
  "哑轧": "yǎ,zhá",
  "哓哮": "xiāo,xiāo",
  "哔剥": "bì,bāo",
  "哔吱": "bì,zī",
  "哔哔剥剥": "bì,bì,bāo,bāo",
  "哔哩哔哩": "bī,lī,bī,lī",
  "哔哩礴喇": "bì,lǐ,bó,lǎ",
  "哕咽": "yuě,yān",
  "哕哕": "huì,huì",
  "哕心沥血": "yue,xīn,lì,xuè",
  "哗儿哗儿": "huá,er,huá,er",
  "哗哄": "huá,hǒng",
  "哗哗": "huā,huā",
  "哗哗地流": "huā,huā,de,liú",
  "哗啦": "huā,lā",
  "哗啦一声": "huā,lā,yī,shēng",
  "哗啦啦": "huā,lā,lā",
  "哗啦棒": "huā,lā,bàng",
  "哗喇喇": "huá,là,là",
  "哞哞地叫": "mōu,mōu,de,jiào",
  "哢吭": "lòng,kēng",
  "哥们": "gē,men",
  "哥们儿": "gē,men,er",
  "哥儿": "gē,er",
  "哥儿们": "gē,er,men",
  "哥儿俩": "gē,er,liǎ",
  "哥哥": "gē,ge",
  "哧哧地": "chī,chī,de",
  "哧哧地笑": "chī,chī,de,xiào",
  "哧的一声": "chī,de,yì,shēng",
  "哨卡": "shào,qiǎ",
  "哨哄": "shào,hǒng",
  "哨子": "shào,zi",
  "哨子声": "shào,zi,shēng",
  "哨尖儿": "shào,jiān,er",
  "哩也波哩也啰": "lǐ,yě,bō,lǐ,yě,luō",
  "哩哩啰啰": "lī,li,luō,luō",
  "哩哩罗罗": "li,li,luō,luō",
  "哩啰哩": "lǐ,luō,lǐ",
  "哩𪡏啰𪡏": "lǐ,lián,luō,lián",
  "哩溜歪斜": "lī,liū,wāi,xié",
  "哪一个": "nǎ,yī,ge",
  "哪个": "něi,gè",
  "哪些": "něi,xiē",
  "哪会儿": "něi,huì,er",
  "哪儿的话": "nǎ,er,de,huà",
  "哪儿跟哪儿": "nǎ,er,gēn,nǎ,er",
  "哪吒": "né,zhā",
  "哪里都": "nǎ,li,dōu",
  "哬哬": "hé,hé",
  "哭丧": "kū,sāng",
  "哭丧棍": "kū,sang,gùn",
  "哭丧棒": "kū,sāng,bàng",
  "哭丧着脸": "kū,sāng,zhe,liǎn",
  "哭丧脸": "kū,sang,liǎn",
  "哭哭啼啼": "kū,ku,tí,tí",
  "哭天哭地": "kū,tiān,kū,de",
  "哭天嚎地": "kū,tiān,háo,de",
  "哭天抢地": "kū,tiān,qiāng,dì",
  "哭得死去活来": "kū,de,sǐ,qù,huó,lái",
  "哭泣地说": "kū,qì,de,shuō",
  "哭鼻子": "kū,bí,zi",
  "哮吼": "xiāo,hǒu",
  "哮呷": "xiāo,xiā",
  "哮呼": "xiāo,hū",
  "哮咆": "xiāo,páo",
  "哮咷": "xiāo,táo",
  "哮哓": "xiāo,xiāo",
  "哮唬": "xiāo,hǔ",
  "哮啕": "xiāo,táo",
  "哮噬": "xiāo,shì",
  "哮悍": "xiāo,hàn",
  "哮阚": "xiāo,kàn",
  "哰哰唔唔": "láo,láo,wú,wú",
  "哱啰": "bō,luō",
  "哱息": "bō,xī",
  "哲嶷": "zhé,nì",
  "哺乳假": "bǔ,rǔ,jià",
  "哺子": "bù,zi",
  "哺露": "bǔ,lù",
  "哺𬳂": "bǔ,zhuì",
  "哼儿哈儿": "hēng,er,hā,er",
  "哼哈二将": "hēng,hā,èr,jiàng",
  "哼唧": "hēng,ji",
  "哼地": "hēng,de",
  "哽咽": "gěng,yè",
  "哽塞": "gěng,sè",
  "唆哄": "suō,hǒng",
  "唆调": "suō,diào",
  "唉呀": "āi,ya",
  "唌唌": "yán,yán",
  "唏哩哗啦": "xī,lī,huā,lā",
  "唏𰇣": "xī,xì",
  "唏里哗啦": "xī,lǐ,huā,lā",
  "唐三藏": "táng,sān,zàng",
  "唐临晋帖": "táng,lín,jìn,tiē",
  "唐古忒": "táng,gǔ,tuī",
  "唐突地": "táng,tū,de",
  "唐蕃会盟碑": "táng,fān,huì,méng,bēi",
  "唔伊": "wú,yī",
  "唔使": "wú,shǐ",
  "唔吱": "wú,zhī",
  "唔哚": "wú,duǒ",
  "唔哝": "wú,nóng",
  "唔哩": "wú,lǐ",
  "唔好睇": "wú,hǎo,dì",
  "唔笃": "wú,dǔ",
  "唛啶": "mà,dìng",
  "唛头": "mà,tóu",
  "唠什子": "lào,shí,zǐ",
  "唠叨": "láo,dāo",
  "唠叨地": "láo,dāo,de",
  "唠叨地讲": "láo,dāo,de,jiǎng",
  "唠咯": "lào,gē",
  "唠唠叨叨": "láo,láo,dāo,dāo",
  "唤出地": "huàn,chū,de",
  "唤头": "huàn,tou",
  "唤应": "huàn,yìng",
  "唤起地": "huàn,qǐ,de",
  "唧咕": "jī,gu",
  "唧哩咕噜": "jī,lǐ,gū,lū",
  "唧唧嘎嘎": "jī,ji,gā,gā",
  "唧唧地叫": "jī,jī,de,jiào",
  "唪唪": "běng,běng",
  "唪经": "běng,jīng",
  "唪诵": "běng,sòng",
  "唫呻": "yín,shēn",
  "唫咏": "yín,yǒng",
  "唫啸": "yín,xiào",
  "唬杀": "xià,shā",
  "唯唯": "wěi,wěi",
  "唯唯否否": "wěi,wěi,fǒu,fǒu",
  "唯唯连声": "wěi,wěi,lián,shēng",
  "唯恐天下不乱": "wéi,kǒng,tiān,xià,bú,luàn",
  "唯成分论": "wéi,chéng,fèn,lùn",
  "唯所欲为": "wéi,suǒ,yù,wéi",
  "唰喇喇": "shuā,là,là",
  "唱主角": "chàng,zhǔ,jué",
  "唱反调": "chàng,fǎn,diào",
  "唱和": "chàng,hè",
  "唱喁": "chàng,yú",
  "唱春调": "chàng,chūn,diào",
  "唱片儿": "chàng,piān,er",
  "唱筹量沙": "chàng,chóu,liáng,shā",
  "唱𬣱": "chàng,zhòu",
  "唱高调": "chàng,gāo,diào",
  "唱高调儿": "chàng,gāo,diào,er",
  "唲𱌹": "ér,óu",
  "唵吧香": "ǎn,ba,xiāng",
  "唵嘛呢叭咪吽": "ǎn,ma,ne,ba,mī,hōng",
  "唵噆": "ǎn,cǎn",
  "唼啑": "shà,dié",
  "唼喋": "shà,zhá",
  "唼血": "shà,xuè",
  "唾沫": "tuò,mo",
  "唾沫星子": "tuò,mò,xīng,zi",
  "唾洟": "tuò,tì",
  "唾背": "tuò,bèi",
  "唾脠": "tuò,chān",
  "唿喇喇": "hū,là,là",
  "啁哳": "zhāo,zhā",
  "啁啾地叫": "zhōu,jiū,de,jiào",
  "啃骨头": "kěn,gú,tou",
  "商业应用": "shāng,yè,yìng,yòng",
  "商业行为": "shāng,yè,xíng,wéi",
  "商业计划": "shāng,yè,jì,huà",
  "商业银行": "shāng,yè,yín,háng",
  "商人银行": "shāng,rén,yín,háng",
  "商务代表处": "shāng,wù,dài,biǎo,chǔ",
  "商参": "shāng,shēn",
  "商数": "shāng,shù",
  "商行": "shāng,háng",
  "商调": "shāng,diào",
  "商贾": "shāng,gǔ",
  "商都": "shāng,dū",
  "商都县": "shāng,dū,xiàn",
  "商量": "shāng,liáng",
  "商铺": "shāng,pù",
  "啉啉": "lín,lín",
  "啊哟": "ā,yo",
  "啍啍": "tūn,tūn",
  "啍喥": "tūn,duó",
  "啑啑": "dié,dié",
  "啑喋": "dié,dié",
  "啑盐指": "dié,yán,zhǐ",
  "啑血": "dié,xuè",
  "啖饭处": "dàn,fàn,chǔ",
  "啘呕": "yè,ǒu",
  "啛啛喳喳": "cuì,cuì,chā,chā",
  "啜咀": "chuò,zuǐ",
  "啜哄": "chuò,hǒng",
  "啜喇": "chuài,lǎ",
  "啜血": "chuò,xuè",
  "啥子": "shá,zi",
  "啦呱": "lā,gua",
  "啦啦队长": "lā,lā,duì,zhǎng",
  "啪嚓": "pā,chā",
  "啪地一声": "pā,de,yī,shēng",
  "啫哩": "zhě,lí",
  "啫喱": "zhě,lí",
  "啮折": "niè,shé",
  "啮血为盟": "niè,xuè,wéi,méng",
  "啮血沁骨": "niè,xuè,qìn,gǔ",
  "啰哩": "luō,lǐ",
  "啰哩啰嗦": "luō,lǐ,luō,suo",
  "啰唆": "luō,suo",
  "啰唣": "luó,zào",
  "啰喽": "luō,lou",
  "啰嗦": "luō,suo",
  "啰里啰嗦": "luō,li,luō,suo",
  "啴咺": "tān,xuān",
  "啴唌": "tān,yán",
  "啴啍": "tān,tūn",
  "啴啴": "chǎn,chǎn",
  "啴缓": "chǎn,huǎn",
  "啵啵": "bō,bō",
  "啸侣命俦": "xiāo,lǚ,mìng,chóu",
  "啼号": "tí,háo",
  "啼咽": "tí,yān",
  "啼血": "tí,xuè",
  "啼饥号寒": "tí,jī,háo,hán",
  "喀什": "kā,shí",
  "喀什噶尔": "kā,shí,gá,ěr",
  "喀什地区": "kā,shí,dì,qū",
  "喀什市": "kā,shí,shì",
  "喀吧": "kā,ba",
  "喀喇沁左翼蒙古族自治县": "kā,lǎ,qìn,zuǒ,yì,měng,gǔ,zú,zì,zhì,xiàn",
  "喀嚓": "kā,chā",
  "喀拉汗国": "kā,lā,hán,guó",
  "喀拉汗王朝": "kā,lā,hán,wáng,cháo",
  "喀秋莎": "kā,qiū,shā",
  "喂喂地叫": "wèi,wèi,de,jiào",
  "喃喃地": "nán,nán,de",
  "喃喃地说": "nán,nán,de,shuō",
  "善为士者不武": "shàn,wéi,shì,zhě,bù,wǔ",
  "善为说辞": "shàn,wéi,shuō,cí",
  "善于应对": "shàn,yú,yìng,duì",
  "善卷": "shàn,juàn",
  "善变地": "shàn,biàn,de",
  "善善恶恶": "shàn,shàn,wù,è",
  "善处": "shàn,chǔ",
  "善应": "shàn,yìng",
  "善意地": "shàn,yì,de",
  "善查": "shàn,zhā",
  "善禁": "shàn,jìn",
  "善自为谋": "shàn,zì,wéi,móu",
  "善良地": "shàn,liáng,de",
  "善贾": "shàn,gǔ",
  "善贾而沽": "shàn,gǔ,ér,gū",
  "善辩地": "shàn,biàn,de",
  "喇叭": "lǎ,ba",
  "喇叭形": "lǎ,ba,xíng",
  "喇叭水仙": "lā,bā,shuǐ,xiān",
  "喇叭花": "lǎ,ba,huā",
  "喇叭裤": "lǎ,ba,kù",
  "喇喇": "là,là",
  "喇喇叭叭": "là,là,bā,bā",
  "喇喇忽忽": "là,là,hū,hū",
  "喇喇蛄": "là,la,gū",
  "喇喇蛌": "là,là,gǔ",
  "喇嘛": "lǎ,ma",
  "喇嘛庙": "lǎ,ma,miào",
  "喇嘛教": "lǎ,ma,jiào",
  "喇舌": "lǎ,jī",
  "喇赛": "lā,sài",
  "喉咽": "hóu,yān",
  "喉塞音": "hóu,sè,yīn",
  "喉音地": "hóu,yīn,de",
  "喊倒好儿": "hǎn,dào,hǎo,er",
  "喊叫地": "hǎn,jiào,de",
  "喊哑嗓子": "hǎn,yǎ,sǎng,zi",
  "喋血": "dié,xuè",
  "喓喐": "yāo,yù",
  "喔促": "wō,cù",
  "喔喔": "wō,wō",
  "喘不过": "chuǎn,bu,guò",
  "喘不过气来": "chuǎn,bu,guò,qì,lái",
  "喘气地": "chuǎn,qì,de",
  "喜吵架地": "xǐ,chǎo,jià,de",
  "喜好": "xǐ,hào",
  "喜子": "xǐ,zi",
  "喜庆地": "xǐ,qìng,de",
  "喜怒不形于色": "xǐ,nù,bù,xìng,yú,sè",
  "喜悦地": "xǐ,yuè,de",
  "喜欢": "xǐ,huan",
  "喜欢地": "xǐ,huān,de",
  "喜气地": "xǐ,qì,de",
  "喜爱地": "xǐ,ài,de",
  "喜钱": "xǐ,qian",
  "喝令": "hè,lìng",
  "喝倒彩": "hè,dào,cǎi",
  "喝叱": "hè,chì",
  "喝彩": "hè,cǎi",
  "喝彩地": "hè,cǎi,de",
  "喝斥": "hè,chì",
  "喝止": "hè,zhǐ",
  "喝道": "hè,dào",
  "喝酒地": "hē,jiǔ,de",
  "喝采": "hè,cǎi",
  "喝采地": "hè,cǎi,de",
  "喝问": "hè,wèn",
  "喢血": "shà,xuè",
  "喧哄": "xuān,hǒng",
  "喧哗地": "xuān,huá,de",
  "喧嚣地": "xuān,xiāo,de",
  "喧闹地": "xuān,nào,de",
  "喳喳": "chā,cha",
  "喳喳叫地": "zhā,zhā,jiào,de",
  "喷嘴儿": "pēn,zuǐ,er",
  "喷子": "pēn,zi",
  "喷撒": "pēn,sǎ",
  "喷筩": "pēn,yǒng",
  "喷红": "pèn,hóng",
  "喷薄": "pēn,bó",
  "喷薄欲出": "pēn,bó,yù,chū",
  "喷血自污": "pēn,xuè,zì,wū",
  "喷香": "pèn,xiāng",
  "喷香兽": "pèn,xiāng,shòu",
  "喹啉": "kuí,lín",
  "喼汁": "jié,zhī",
  "喽喽": "lou,lou",
  "喽子": "lóu,zi",
  "嗑药": "kè,yào",
  "嗒丧": "tà,sàng",
  "嗒嗒地响": "dā,dā,de,xiǎng",
  "嗒嗒地跑": "dā,dā,de,pǎo",
  "嗒焉": "tà,yān",
  "嗒然": "tà,rán",
  "嗒然若丧": "tà,rán,ruò,sàng",
  "嗓子": "sǎng,zi",
  "嗓子眼": "sǎng,zi,yǎn",
  "嗓子眼儿": "sǎng,zi,yǎn,er",
  "嗓门儿": "sǎng,mén,er",
  "嗔喝": "chēn,hè",
  "嗔着": "chēn,zhe",
  "嗖地": "sōu,de",
  "嗖地发射": "sōu,de,fā,shè",
  "嗖地挥动": "sōu,de,huī,dòng",
  "嗜好": "shì,hào",
  "嗜杀地": "shì,shā,de",
  "嗜血": "shì,xuè",
  "嗜血杆菌": "shì,xuè,gǎn,jūn",
  "嗜酸乳杆菌": "shì,suān,rǔ,gǎn,jūn",
  "嗝儿": "gé,er",
  "嗝儿屁": "gé,er,pì",
  "嗟吁": "jiē,yù",
  "嗡嗡地": "wēng,wēng,de",
  "嗡嗡地响": "wēng,wēng,de,xiǎng",
  "嗡嗡弹": "wēng,wēng,dàn",
  "嗡地一声": "wēng,de,yī,shēng",
  "嗣子": "sì,zi",
  "嗤嗤地笑": "chī,chī,de,xiào",
  "嗨呀": "hāi,ya",
  "嗯哼": "en,hēng",
  "嗳气吞酸": "ǎi,qì,tūn,suān",
  "嗳气呕逆": "ǎi,qì,ǒu,nì",
  "嗳气腐臭": "ǎi,qì,fǔ,chòu",
  "嗳气酸腐": "ǎi,qì,suān,fǔ",
  "嗳腐": "ǎi,fǔ",
  "嗳腐吞酸": "ǎi,fǔ,tūn,suān",
  "嗳酸": "ǎi,suān",
  "嘀咕": "dí,gu",
  "嘀嗒": "dī,dā",
  "嘀地": "dí,de",
  "嘁哩喀喳": "qī,lǐ,kā,chā",
  "嘁喳喳地叫": "qī,zhā,zhā,de,jiào",
  "嘁嘁喳喳地叫": "qī,qī,zhā,zhā,de,jiào",
  "嘉兴": "jiā,xīng",
  "嘉兴地区": "jiā,xīng,dì,qū",
  "嘉兴市": "jiā,xīng,shì",
  "嘉应": "jiā,yìng",
  "嘉柏隆里": "jiā,bó,lóng,lǐ",
  "嘉荫": "jiā,yìn",
  "嘉荫县": "jiā,yìn,xiàn",
  "嘌呤": "piào,líng",
  "嘎吱嘎吱地响": "gā,zhī,gā,zhī,de,xiǎng",
  "嘎吱地响": "gā,zhī,de,xiǎng",
  "嘎嘎地叫": "gā,gā,de,jiào",
  "嘎嘎地响": "gā,gā,de,xiǎng",
  "嘎嘎小姐": "gā,gā,xiǎo,jie",
  "嘎嚓嘎嚓地响": "gā,cā,gā,cā,de,xiǎng",
  "嘎声地": "gā,shēng,de",
  "嘎子": "gǎ,zǐ",
  "嘎拉哈": "gā,lā,hà",
  "嘘嘘地响": "xū,xū,de,xiǎng",
  "嘟哝": "dū,nong",
  "嘟嘟地喝": "dū,dū,de,hē",
  "嘟囔": "dū,nang",
  "嘟着嘴": "dū,zhe,zuǐ",
  "嘲哳": "zhāo,zhā",
  "嘲弄地": "cháo,nòng,de",
  "嘲弄地骂": "cháo,nòng,de,mà",
  "嘲笑地": "cháo,xiào,de",
  "嘲讽": "cháo,fěng",
  "嘲讽地": "cháo,fěng,de",
  "嘲讽地说": "cháo,fěng,de,shuō",
  "嘲骂地": "cháo,mà,de",
  "嘴儿": "zuǐ,er",
  "嘴子": "zuǐ,zi",
  "嘴巴": "zuǐ,ba",
  "嘴巴子": "zuǐ,ba,zi",
  "嘴皮子": "zuǐ,pí,zi",
  "嘶哑地": "sī,yǎ,de",
  "嘶嘶地响": "sī,sī,de,xiǎng",
  "嘻笑地说": "xī,xiào,de,shuō",
  "嘿嘿地": "hēi,hēi,de",
  "嘿嘿地笑": "hēi,hēi,de,xiào",
  "噗哧一声": "pū,chī,yì,shēng",
  "噗地一声": "pū,de,yī,shēng",
  "噗地喷出": "pū,de,pēn,chū",
  "器官上地": "qì,guān,shàng,de",
  "噱头": "xué,tou",
  "噶厦": "gá,xià",
  "噶嗒": "gá,tà",
  "嚓地响": "cā,de,xiǎng",
  "嚯地站起": "huò,de,zhàn,qǐ",
  "嚷嚷": "rāng,rāng",
  "嚼劲儿": "jiáo,jìn,er",
  "嚼墨喷纸": "jué,mò,pēn,zhǐ",
  "嚼穿龈血": "jiáo,chuān,yín,xuè",
  "嚼舌头": "jiáo,shé,tou",
  "囊揣": "nāng,chuài",
  "囊膪": "nāng,chuài",
  "囊锥露颖": "náng,zhuī,lù,yǐng",
  "囔囔": "nāng,nang",
  "囚禁": "qiú,jìn",
  "四下里": "sì,xià,li",
  "四不拗六": "sì,bù,niù,liù",
  "四个全面": "sì,ge,quán,miàn",
  "四个现代化": "sì,ge,xiàn,dài,huà",
  "四亭八当": "sì,tíng,bā,dàng",
  "四倍地": "sì,bèi,de",
  "四元数": "sì,yuán,shù",
  "四分五剖": "sì,fēn,wǔ,pōu",
  "四分位数": "sì,fēn,wèi,shù",
  "四厢乐歌": "sì,xiāng,yuè,gē",
  "四塞": "sì,sài",
  "四姓小侯": "sì,xìng,xiǎo,hòu",
  "四季调": "sì,jì,diào",
  "四季豆腐": "sì,jì,dòu,fu",
  "四散地": "sì,sàn,de",
  "四斗五方": "sì,dǒu,wǔ,fāng",
  "四时充美": "si,shi,chong,mei",
  "四更": "sì,gēng",
  "四海为家": "sì,hǎi,wéi,jiā",
  "四禁": "sì,jìn",
  "四称": "sì,chèng",
  "四背": "sì,bèi",
  "四脯着地": "sì,fǔ,zháo,dì",
  "四蕃": "sì,fān",
  "四行": "sì,háng",
  "四角地": "sì,jiǎo,de",
  "四貉": "sì,mò",
  "四边形地": "sì,biān,xíng,de",
  "四通": "sì,tòng",
  "四邻八舍": "sì,lín,bā,shè",
  "四重唱": "sì,chóng,chàng",
  "四重奏": "sì,chóng,zòu",
  "四铺子着地": "sì,pù,zǐ,zháo,dì",
  "四门斗里": "sì,mén,dǒu,lǐ",
  "四马攒蹄": "sì,mǎ,cuán,tí",
  "回佣": "huí,yòng",
  "回动地": "huí,dòng,de",
  "回单儿": "huí,dān,er",
  "回去": "huí,qu",
  "回回": "huí,hui",
  "回处士": "huí,chǔ,shì",
  "回天运斗": "huí,tiān,yùn,dǒu",
  "回家心切": "huí,jiā,xīn,qiè",
  "回帆": "huí,fān",
  "回帆挝": "huí,fān,wō",
  "回帆鼓": "huí,fān,gǔ",
  "回帖": "huí,tiē",
  "回应": "huí,yìng",
  "回忆地": "huí,yì,de",
  "回怼": "huí,duǐ",
  "回折格子": "huí,zhé,gé,zi",
  "回数": "huí,shù",
  "回旋地飞": "huí,xuán,de,fēi",
  "回来": "huí,lai",
  "回槛": "huí,kǎn",
  "回潏": "huí,jué",
  "回煞": "huí,shà",
  "回背": "huí,bèi",
  "回舟兴": "huí,zhōu,xīng",
  "回调函数": "huí,diào,hán,shù",
  "回跌": "huí,diē",
  "回蹬": "huí,dēng",
  "回还": "huí,huán",
  "回遟": "huí,zhì",
  "回顾地": "huí,gù,de",
  "回鹘": "huí,hú",
  "回鹘文": "huí,hú,wén",
  "回鹘豆": "huí,hú,dòu",
  "回黄转绿": "huí,huáng,zhuǎn,lù",
  "因为我不停地": "yīn,wèi,wǒ,bù,tíng,de",
  "因其固然": "yin,qi,gu,ran",
  "因应": "yīn,yìng",
  "因敌为资": "yīn,dí,wéi,zī",
  "因数": "yīn,shù",
  "因果报应": "yīn,guǒ,bào,yìng",
  "因树为屋": "yīn,shù,wéi,wū",
  "因特网提供商": "yīn,tè,wǎng,tí,gōng,shāng",
  "因用剡地": "yīn,yòng,shàn,de",
  "因祸为福": "yīn,huò,wéi,fú",
  "因缘为市": "yīn,yuán,wéi,shì",
  "因袭陈规": "yin,xi,chen,gui",
  "团剥": "tuán,bāo",
  "团团地": "tuán,tuán,de",
  "团团转": "tuán,tuán,zhuàn",
  "团子": "tuán,zi",
  "团结地": "tuán,jié,de",
  "团结就是力量": "tuán,jié,jiù,shì,lì,liang",
  "团转": "tuán,zhuàn",
  "团长": "tuán,zhǎng",
  "囤户": "dùn,hù",
  "囫囵个儿": "hú,lun,gè,ér",
  "囫囵竹": "hú,lun,zhú",
  "囫囵课": "hú,lun,kè",
  "园满地": "yuán,mǎn,de",
  "园舍": "yuán,shè",
  "园长": "yuán,zhǎng",
  "困坷": "kùn,kē",
  "困处": "kùn,chǔ",
  "困𪧘": "kùn,lóu",
  "困恼地": "kùn,nǎo,de",
  "困惑地": "kùn,huò,de",
  "困惑地问": "kùn,huò,de,wèn",
  "困折": "kùn,shé",
  "困窘地": "kùn,jiǒng,de",
  "困觉": "kùn,jiào",
  "困踧": "kùn,dí",
  "困蹶": "kùn,juě",
  "困难在于": "kùn,nan,zài,yú",
  "困难地": "kùn,nán,de",
  "困难重重": "kùn,nán,chóng,chóng",
  "围场满族蒙古族自治县": "wéi,chǎng,mǎn,zú,měng,gǔ,zú,zì,zhì,xiàn",
  "围绕地": "wéi,rào,de",
  "围脖儿": "wéi,bó,er",
  "围𰺷": "wéi,rǎo",
  "固体地": "gù,tǐ,de",
  "固执不变": "gù,zhí,bú,biàn",
  "固执地": "gù,zhí,de",
  "固执地说": "gù,zhí,de,shuō",
  "固有地": "gù,yǒu,de",
  "国不堪贰": "guo,bu,kan,er",
  "国丧": "guó,sāng",
  "国会议长": "guó,huì,yì,zhǎng",
  "国内地": "guó,nèi,de",
  "国冠": "guó,guān",
  "国务长官": "guó,wù,zhǎng,guān",
  "国子监": "guó,zǐ,jiàn",
  "国定假日": "guó,dìng,jià,rì",
  "国家发展计划委员会": "guó,jiā,fā,zhǎn,jì,huà,wěi,yuán,huì",
  "国家开发银行": "guó,jiā,kāi,fā,yín,háng",
  "国家旅游度假区": "guó,jiā,lǚ,yóu,dù,jià,qū",
  "国家计划委员会": "guó,jiā,jì,huà,wěi,yuán,huì",
  "国帑": "guó,tǎng",
  "国干": "guó,gàn",
  "国民地": "guó,mín,de",
  "国王似地": "guó,wáng,shì,de",
  "国禁": "guó,jìn",
  "国䇲": "guó,jiā",
  "国貉": "guó,mò",
  "国蹶": "guó,juě",
  "国都": "guó,dū",
  "国防部长": "guó,fáng,bù,zhǎng",
  "国际复兴开发银行": "guó,jì,fù,xīng,kāi,fā,yín,háng",
  "国际性地": "guó,jì,xìng,de",
  "国际数学联盟": "guó,jì,shù,xué,lián,méng",
  "国际日期变更线": "guó,jì,rì,qī,biàn,gēng,xiàn",
  "国际清算银行": "guó,jì,qīng,suàn,yín,háng",
  "国际肿瘤研究机构": "guó,jì,zhōng,liú,yán,jiū,jī,gòu",
  "国难": "guó,nàn",
  "国难当头": "guó,nàn,dāng,tóu",
  "图像处理": "tú,xiàng,chǔ,lǐ",
  "图卷": "tú,juàn",
  "图型地": "tú,xíng,de",
  "图堡": "tú,pù",
  "图形地": "tú,xíng,de",
  "图白忒": "tú,bái,tuī",
  "图穷匕见": "tú,qióng,bǐ,xiàn",
  "图穷匕首见": "tú,qióng,bǐ,shǒu,xiàn",
  "图表地": "tú,biǎo,de",
  "图论": "tú,lún",
  "图载": "tú,zǎi",
  "圄犴": "yǔ,àn",
  "圆冠方领": "yuán,guān,fāng,lǐng",
  "圆函数": "yuán,hán,shù",
  "圆圆地": "yuán,yuán,de",
  "圆头地": "yuán,tóu,de",
  "圆子": "yuán,zi",
  "圆应": "yuán,yìng",
  "圆形地": "yuán,xíng,de",
  "圆折": "yuán,shé",
  "圆晕": "yuán,yùn",
  "圆滑地": "yuán,huá,de",
  "圆满地": "yuán,mǎn,de",
  "圆满地完成": "yuán,mǎn,de,wán,chéng",
  "圆满地完成了": "yuán,mǎn,de,wán,chéng,le",
  "圆石头": "yuán,shí,tou",
  "圆筒形地": "yuán,tǒng,xíng,de",
  "圆通地": "yuán,tōng,de",
  "圆锥曲线": "yuán,zhuī,qū,xiàn",
  "圈儿": "quān,er",
  "圈养": "juàn,yǎng",
  "圈圈": "quān,quan",
  "圈圈点点": "quān,quan,diǎn,diǎn",
  "圈子": "quān,zi",
  "圈数": "quān,shù",
  "圈槛": "quān,kǎn",
  "圈𭫀": "quān,kuì",
  "圈牢养物": "juàn,láo,yǎng,wù",
  "圈猪": "juàn,zhū",
  "圈禁": "quān,jìn",
  "圈肥": "juàn,féi",
  "圈舍": "juàn,shè",
  "圌山": "chuí,shān",
  "圌廪": "chuí,lǐn",
  "圜丘": "yuán,qiū",
  "圜冠": "huán,guān",
  "圜土": "yuán,tǔ",
  "圜墙": "yuán,qiáng",
  "圜焘": "huán,tāo",
  "圜舍": "huán,shè",
  "土包子": "tǔ,bāo,zi",
  "土地利用规划": "tǔ,dì,lì,yòng,guī,huà",
  "土地规划": "tǔ,dì,guī,huà",
  "土坎儿": "tǔ,kǎn,er",
  "土坷垃": "tǔ,kē,lā",
  "土堡": "tǔ,pù",
  "土处": "tǔ,chǔ",
  "土得掉渣": "tǔ,de,diào,zhā",
  "土方子": "tǔ,fāng,zi",
  "土木之难": "tǔ,mù,zhī,nàn",
  "土木堡": "tǔ,mù,pù",
  "土生土长": "tǔ,shēng,tǔ,zhǎng",
  "土疙瘩": "tǔ,gē,da",
  "土着": "tǔ,zhe",
  "土祇": "tǔ,qí",
  "土禁": "tǔ,jìn",
  "土穰细流": "tǔ,rǎng,xì,liú",
  "土老帽儿": "tǔ,lǎo,mào,er",
  "土舍": "tǔ,shè",
  "土蕃": "tǔ,fān",
  "土虺": "tǔ,huī",
  "土虺蛇": "tǔ,huī,shé",
  "土调": "tǔ,diào",
  "土铛": "tǔ,chēng",
  "土长": "tǔ,zhǎng",
  "土长根生": "tǔ,zhǎng,gēn,shēng",
  "土阆": "tǔ,láng",
  "土馒头": "tǔ,mán,tou",
  "圣人不为而成": "shèng,rén,bù,wéi,ér,chéng",
  "圣体血": "shèng,tǐ,xuè",
  "圣君贤相": "shèng,jūn,xián,xiàng",
  "圣安地列斯断层": "shèng,ān,de,liè,sī,duàn,céng",
  "圣母帖": "shèng,mǔ,tiē",
  "圣潘克勒斯站": "shèng,pān,kè,lēi,sī,zhàn",
  "圣经外传": "shèng,jīng,wài,zhuàn",
  "圣经贤传": "shèng,jīng,xián,zhuàn",
  "圣赫勒拿": "shèng,hè,lēi,ná",
  "圣露西亚": "shèng,lù,xī,yà",
  "圣饼子": "shèng,bǐng,zi",
  "在上流地": "zài,shàng,liú,de",
  "在上面地": "zài,shàng,miàn,de",
  "在不停地": "zài,bù,tíng,de",
  "在不懈地": "zài,bù,xiè,de",
  "在不断地": "zài,bù,duàn,de",
  "在不断地影响": "zài,bù,duàn,de,yǐng,xiǎng",
  "在中心地": "zài,zhōng,xīn,de",
  "在中间地": "zài,zhōng,jiān,de",
  "在乎": "zài,hu",
  "在先地": "zài,xiān,de",
  "在其它地": "zài,qí,tā,de",
  "在内地": "zài,nèi,de",
  "在内部地": "zài,nèi,bù,de",
  "在前地": "zài,qián,de",
  "在前方地": "zài,qián,fāng,de",
  "在剧烈地": "zài,jù,liè,de",
  "在南方地": "zài,nán,fāng,de",
  "在后台地": "zài,hòu,tái,de",
  "在后地": "zài,hòu,de",
  "在后地在": "zài,hòu,de,zài",
  "在处": "zài,chǔ",
  "在家地": "zài,jiā,de",
  "在岸上地": "zài,àn,shàng,de",
  "在床上地": "zài,chuáng,shàng,de",
  "在得": "zài,de",
  "在愤怒地": "zài,fèn,nù,de",
  "在数": "zài,shù",
  "在无声地变化着": "zài,wú,shēng,de,biàn,huà,zhe",
  "在本国地": "zài,běn,guó,de",
  "在机械地": "zài,jī,xiè,de",
  "在海上地": "zài,hǎi,shàng,de",
  "在热情地": "zài,rè,qíng,de",
  "在痛苦地": "zài,tòng,kǔ,de",
  "在第七地": "zài,de,qī,de",
  "在船尾地": "zài,chuán,wěi,de",
  "在行": "zài,háng",
  "在贵地": "zài,guì,de",
  "在边际地": "zài,biān,jì,de",
  "在远方地": "zài,yuǎn,fāng,de",
  "在那儿": "zài,na,er",
  "在附近地": "zài,fù,jìn,de",
  "在默默地": "zài,mò,mò,de",
  "圩场": "xū,cháng",
  "圩垸": "wéi,yuàn",
  "圩堤": "wéi,dī",
  "圩子": "wéi,zǐ",
  "圩田": "wéi,tián",
  "圩顶": "yú,dǐng",
  "圪垯": "gē,da",
  "圪弹": "gē,dàn",
  "圪节": "gē,jiē",
  "圭角不露": "guī,jiǎo,bù,lù",
  "圮剥": "pǐ,bāo",
  "地中海贫血": "dì,zhōng,hǎi,pín,xuè",
  "地侯": "dì,hòu",
  "地儿": "dì,er",
  "地区差价": "dì,qū,chā,jià",
  "地块儿": "dì,kuài,er",
  "地堡": "dì,pù",
  "地壳": "dì,qiào",
  "地壳运动": "dì,qiào,yùn,dòng",
  "地处": "dì,chǔ",
  "地对空导弹": "dì,duì,kōng,dǎo,dàn",
  "地排车": "dì,pǎi,chē",
  "地摊儿": "dì,tān,er",
  "地数": "dì,shù",
  "地暴十寒": "dì,pù,shí,hán",
  "地煞": "dì,shà",
  "地狱变相": "dì,yù,biàn,xiàng",
  "地理数据": "dì,lǐ,shù,jù",
  "地理数据库": "dì,lǐ,shù,jù,kù",
  "地着": "dì,zhe",
  "地祇": "dì,qí",
  "地祇坛": "dì,qí,tán",
  "地禁": "dì,jìn",
  "地空导弹": "dì,kōng,dǎo,dàn",
  "地藏": "dì,zàng,#包括一切,地藏xxx,，比如地藏寺、地藏王、地藏菩萨等等",
  "地藏寺": "dì,zàng,sì",
  "地藏王": "dì,zàng,wáng",
  "地藏王菩萨": "dì,zàng,wáng,pú,sà",
  "地藏菩萨": "dì,zàng,pú,sà",
  "地调": "dì,diào",
  "地转": "dì,zhuàn",
  "地铺": "dì,pù",
  "场人": "cháng,rén",
  "场儿": "chǎng,er",
  "场区应急": "chǎng,qū,yìng,jí",
  "场圃": "cháng,pǔ",
  "场外应急": "chǎng,wài,yìng,jí",
  "场子": "chǎng,zi",
  "场师": "cháng,shī",
  "场期": "cháng,qī",
  "场院": "cháng,yuàn",
  "均匀地": "jūn,yún,de",
  "均匀地涂": "jūn,yún,de,tú",
  "均等地": "jūn,děng,de",
  "均调": "jūn,diào",
  "均适": "jūn,shì",
  "坎侯": "kǎn,hòu",
  "坎侯漆": "kǎn,hòu,qī",
  "坎儿": "kǎn,er",
  "坎儿井": "kǎn,er,jǐng",
  "坎埳": "kǎn,kǎn",
  "坎子": "kǎn,zi",
  "坎肩儿": "kǎn,jiān,er",
  "坏兆头": "huài,zhào,tou",
  "坏分子": "huài,fèn,zǐ",
  "坏包儿": "huài,bāo,er",
  "坏坏地": "huài,huài,de",
  "坏坏地看着": "huài,huài,de,kàn,zhe",
  "坏心眼儿": "huài,xīn,yǎn,er",
  "坏心眼地": "huài,xīn,yǎn,de",
  "坏点子": "huài,diǎn,zi",
  "坏肠子": "huài,cháng,zi",
  "坏血病": "huài,xuè,bìng",
  "坏裳为袴": "huài,cháng,wéi,kù",
  "坏裳为裤": "huài,shang,wéi,kù",
  "坏透地": "huài,tòu,de",
  "坐下": "zuò,xia",
  "坐不重席": "zuò,bù,chóng,xí",
  "坐五行三": "zuò,wǔ,háng,sān",
  "坐冷房子": "zuò,lěng,fáng,zi",
  "坐台子": "zuò,tái,zi",
  "坐戒垂堂": "zuò,jǐng,chuí,táng",
  "坐更": "zuò,gēng",
  "坐月子": "zuò,yuè,zi",
  "坐禁闭": "zuò,jìn,bì",
  "坐累": "zuò,lèi",
  "坐红椅子": "zuò,hóng,yǐ,zi",
  "坐萝卜": "zuò,luó,bo",
  "坐谩": "zuò,màn",
  "坐贾": "zuò,gǔ",
  "坐逮": "zuò,dǎi",
  "坐铺": "zuò,pù",
  "坑坑洼洼": "kēng,keng,wā,wā",
  "坑埳": "gāng,kǎn",
  "坑煞": "kēng,shà",
  "块儿八毛": "kuài,er,bā,máo",
  "坚决地": "jiān,jué,de",
  "坚决地说": "jiān,jué,de,shuō",
  "坚固地": "jiān,gù,de",
  "坚定不移地": "jiān,deng,bù,yí,de",
  "坚定不移地走": "jiān,deng,bù,yí,de,zǒu",
  "坚定地": "jiān,deng,de",
  "坚定地说": "jiān,deng,de,shuō",
  "坚定地走": "jiān,deng,de,zǒu",
  "坚实可靠地": "jiān,shí,kě,kào,de",
  "坚尼地": "jiān,ní,de",
  "坚尼系数": "jiān,ní,xì,shù",
  "坚弥地城海旁": "jiān,mí,de,chéng,hǎi,páng",
  "坚强地": "jiān,qiáng,de",
  "坚忍地": "jiān,rěn,de",
  "坚持不懈地": "jiān,chí,bù,xiè,de",
  "坚持地": "jiān,chí,de",
  "坚朴": "jiān,piáo",
  "坚果地": "jiān,guǒ,de",
  "坚毅地": "jiān,yì,de",
  "坚牢地": "jiān,láo,de",
  "坚瓠": "jiān,hú",
  "坚白相盈": "jiān,bái,xiàng,yíng",
  "坚硬地": "jiān,yìng,de",
  "坚韧地": "jiān,rèn,de",
  "坛卷": "tán,juàn",
  "坛𭏸": "tán,wěi",
  "坛子": "tán,zi",
  "坟埏": "fén,shān",
  "坠子": "zhuì,zi",
  "坠蹬": "zhuì,dèng",
  "坡公堤": "pō,gōng,dī",
  "坡撇": "pō,piě",
  "坤角": "kūn,jué",
  "坤角儿": "kūn,jué,ér",
  "坤载": "kūn,zǎi",
  "坦朴": "tǎn,piáo",
  "坦然地说": "tǎn,rán,de,shuō",
  "坦率": "tǎn,shuài",
  "坦率地": "tǎn,shuài,de",
  "坦率地讲": "tǎn,shuài,de,jiǎng",
  "坦率地说": "tǎn,shuài,de,shuō",
  "坦率地说吧": "tǎn,shuài,de,shuō,ba",
  "坦率地谈": "tǎn,shuài,de,tán",
  "坦白地": "tǎn,bái,de",
  "坦诚地": "tǎn,chéng,de",
  "坦谩": "tǎn,màn",
  "坦露": "tǎn,lù",
  "坨儿": "tuó,er",
  "坨子": "tuó,zi",
  "坯子": "pī,zi",
  "坯模": "pī,mú",
  "坱轧": "yǎng,zhá",
  "坷坎": "kē,kǎn",
  "坷垃": "kē,lā",
  "坷拉": "kē,lā",
  "坻崿": "chí,è",
  "坼剖": "chè,pōu",
  "垂发": "chuí,fà",
  "垂头拓翼": "chuí,tóu,tà,yì",
  "垂头搨翼": "chuí,tóu,dá,yì",
  "垂橐稛载": "chuí,tuó,kǔn,zǎi",
  "垂死挣扎": "chuí,sǐ,zhēng,zhá",
  "垂死的狮子": "chuí,sǐ,de,shī,zi",
  "垂没": "chuí,mò",
  "垂直地": "chuí,zhí,de",
  "垂衣裳": "chuí,yī,shang",
  "垂露": "chuí,lù",
  "垂露书": "chuí,lù,shū",
  "垂首帖耳": "chuí,shǒu,tiē,ěr",
  "型芯": "xíng,xìn",
  "垒栅": "lěi,shān",
  "垒舍": "lěi,shè",
  "垓埏": "gāi,shān",
  "垛子": "duǒ,zi",
  "垢累": "gòu,lèi",
  "垢翫": "gòu,wàn",
  "垦拓荒地": "kěn,tuò,huāng,de",
  "垦殖地": "kěn,zhí,de",
  "垦殖指数": "kěn,zhí,zhǐ,shù",
  "垦种": "kěn,zhòng",
  "垫儿": "diàn,er",
  "垫圈": "diàn,juàn",
  "垫子": "diàn,zi",
  "垫背": "diàn,bèi",
  "垫脚": "diàn,jiao",
  "垫补": "diàn,bu",
  "垮杆": "kuǎ,gǎn",
  "埂子": "gěng,zi",
  "埃堨": "āi,ài",
  "埃塞俄比亚界": "āi,sài,é,bǐ,yà,jiè",
  "埃拉托塞尼斯": "āi,lā,tuō,sè,ní,sī",
  "埃琳娜": "āi,lín,nà",
  "埋三怨四": "mán,sān,yuàn,sì",
  "埋天怨地": "mán,tiān,yuàn,dì",
  "埋头苦干": "mái,tóu,kǔ,gàn",
  "埋怨": "mán,yuàn",
  "埋没": "mái,mò",
  "埋缊": "mái,wēn",
  "埋葬地": "mái,zàng,de",
  "城头子路": "chéng,tóu,zi,lù",
  "城子河": "chéng,zi,hé",
  "城子河区": "chéng,zi,hé,qū",
  "城市总体规划": "chéng,shì,zǒng,tǐ,guī,huà",
  "城市规划": "chéng,shì,guī,huà",
  "城干": "chéng,gàn",
  "城栅": "chéng,shān",
  "城禁": "chéng,jìn",
  "城铺": "chéng,pù",
  "城阙": "chéng,què",
  "城陴": "chéng,pí",
  "埏垓": "shān,gāi",
  "埏埴": "shān,zhí",
  "埏路": "shān,lù",
  "埏蹂": "shān,róu",
  "埏道": "shān,dào",
  "埏镕": "shān,róng",
  "埏闼": "shān,tà",
  "埏陶": "shān,táo",
  "埏隧": "shān,suì",
  "埒才角妙": "liè,cái,jué,miào",
  "埙篪相和": "xūn,chí,xiāng,hè",
  "埠头": "bù,tou",
  "埢垣": "juǎn,yuán",
  "埳井": "kǎn,jǐng",
  "埳井之蛙": "kǎn,jǐng,zhī,wā",
  "埳井之鼃": "kǎn,jǐng,zhī,wā",
  "埳坷": "kǎn,kē",
  "埳室": "kǎn,shì",
  "埳蛙": "kǎn,wā",
  "埳轲": "kǎn,kē",
  "培果": "bèi,guǒ",
  "基尼系数": "jī,ní,xì,shù",
  "基干": "jī,gàn",
  "基数": "jī,shù",
  "基数词": "jī,shù,cí",
  "基本上": "jī,běn,shang",
  "基本上地": "jī,běn,shàng,de",
  "基础地": "jī,chǔ,de",
  "基调": "jī,diào",
  "埽𦈉": "sào,yùn",
  "堂堂地": "táng,táng,de",
  "堂妹夫": "táng,mèi,fu",
  "堂姐夫": "táng,jiě,fu",
  "堂帖": "táng,tiē",
  "堂札": "táng,zhā",
  "堂皇地": "táng,huáng,de",
  "堆垒数论": "duī,lěi,shù,lùn",
  "堆案盈几": "duī,àn,yíng,jī",
  "堆积地": "duī,jī,de",
  "堆笑地": "duī,xiào,de",
  "堆高车": "tuī,gāo,chē",
  "堇块": "jǐn,kuài",
  "堇堇": "jǐn,jǐn",
  "堇泥": "jǐn,ní",
  "堇色": "jǐn,sè",
  "堇菜": "jǐn,cài",
  "堋的": "péng,dì",
  "堙没": "yīn,mò",
  "堡团": "pù,tuán",
  "堡坞": "pù,wù",
  "堡堠": "pù,hòu",
  "堡塞": "pù,sāi",
  "堡子": "bǔ,zi",
  "堡栅": "pù,shān",
  "堡砦": "pù,zhài",
  "堡聚": "pù,jù",
  "堤唐": "dī,táng",
  "堤围": "dī,wéi",
  "堤坝": "dī,bà",
  "堤坡": "dī,pō",
  "堤垸": "dī,yuàn",
  "堤埂": "dī,gěng",
  "堤埽": "dī,sào",
  "堤堤": "dī,dī",
  "堤堰": "dī,yàn",
  "堤塍": "dī,chéng",
  "堤塘": "dī,táng",
  "堤塞": "dī,sāi",
  "堤备": "dī,bèi",
  "堤夫": "dī,fū",
  "堤封": "dī,fēng",
  "堤山": "dī,shān",
  "堤岸": "dī,àn",
  "堤川": "dī,chuān",
  "堤工": "dī,gōng",
  "堤拉米苏": "dī,lā,mǐ,sū",
  "堤捍": "dī,hàn",
  "堤梁": "dī,liáng",
  "堤水": "dī,shuǐ",
  "堤溃蚁孔": "dī,kuì,yǐ,kǒng",
  "堤溃蚁穴": "dī,kuì,yǐ,xué",
  "堤火": "dī,huǒ",
  "堤繇": "dī,yáo",
  "堤遏": "dī,è",
  "堤阏": "dī,è",
  "堤防": "dī,fáng",
  "堤障": "dī,zhàng",
  "堤顶大路": "dī,dǐng,dà,lù",
  "堰堨": "yàn,ài",
  "堰塞湖": "yàn,sè,hú",
  "堵塞": "dǔ,sè",
  "堵塞费": "dǔ,sè,fèi",
  "堵缝": "dǔ,fèng",
  "塈完": "xì,wán",
  "塈茨": "xì,cí",
  "塌实": "tā,shi",
  "塌鼻子": "tā,bí,zi",
  "塑料炸弹": "sù,liào,zhà,dàn",
  "塔什干": "tǎ,shí,gàn",
  "塔什库尔干乡": "tǎ,shí,kù,ěr,gān,xiāng",
  "塔什库尔干塔吉克自治县": "tǎ,shí,kù,ěr,gān,tǎ,jí,kè,zì,zhì,xiàn",
  "塔什库尔干自治县": "tǎ,shí,kù,ěr,gān,zì,zhì,xiàn",
  "塔塔儿": "tǎ,tǎ,er",
  "塔塔儿人": "tǎ,tǎ,er,rén",
  "塞北": "sài,běi",
  "塞哥维亚": "sè,gē,wéi,yà",
  "塞外": "sài,wài",
  "塞子": "sāi,zi",
  "塞尔南": "sài,ěr,nán",
  "塞尔达": "sài,ěr,dá",
  "塞席尔": "sè,xí,ěr",
  "塞拉利昂": "sài,lā,lì,áng",
  "塞拉耶佛": "sè,lā,yē,fó",
  "塞浦路斯": "sài,pǔ,lù,sī",
  "塞维勒的理发师": "sāi,wéi,lè,de,lǐ,fà,shī",
  "塞缪尔": "sāi,miù,ěr",
  "塞翁": "sài,wēng",
  "塞翁之马": "sài,wēng,zhī,mǎ",
  "塞翁失马": "sài,wēng,shī,mǎ",
  "塞翁失马安知非福": "sài,wēng,shī,mǎ,ān,zhī,fēi,fú",
  "塞翁失马焉知非福": "sài,wēng,shī,mǎ,yān,zhī,fēi,fú",
  "塞翁得马": "sài,wēng,dé,mǎ",
  "塞翁马": "sài,wēng,mǎ",
  "塞耳盗锺": "sè,ěr,dào,zhōng",
  "塞聪": "sè,cōng",
  "塞舌尔": "sài,shé,ěr",
  "塞舌尔群岛": "sài,shé,ěr,qún,dǎo",
  "塞语": "sài,yǔ",
  "塞责": "sè,zé",
  "塞道": "sè,dào",
  "塞门": "sài,mén",
  "塞韦里诺": "sài,wéi,lǐ,nuò",
  "塞音": "sè,yīn",
  "填仆": "tián,pú",
  "填咽": "tián,yān",
  "填塞物": "tián,sè,wù",
  "填帖": "tián,tiē",
  "填扎": "tián,zhā",
  "填格子": "tián,gé,zi",
  "填空": "tián,kòng",
  "填笮": "tián,zé",
  "填缝": "tián,fèng",
  "填阬满谷": "tián,gāng,mǎn,gǔ",
  "墅舍": "shù,shè",
  "𰊂积": "dì,jī",
  "𰊂翳": "dì,yì",
  "𰊂霓": "dì,ní",
  "𰊂鬻": "dì,yù",
  "墓舍": "mù,shè",
  "墓阙": "mù,què",
  "墙有缝": "qiáng,yǒu,fèng",
  "墙缝": "qiáng,fèng",
  "墙铺": "qiáng,pù",
  "增殖反应堆": "zēng,zhí,fǎn,yìng,duī",
  "增累": "zēng,lèi",
  "增调": "zēng,diào",
  "增量参数": "zēng,liàng,cān,shù",
  "增长": "zēng,zhǎng",
  "增长主": "zēng,zhǎng,zhǔ",
  "增长地": "zēng,zhǎng,de",
  "增长天": "zēng,zhǎng,tiān",
  "增长天王": "zēng,zhǎng,tiān,wáng",
  "增长点": "zēng,zhǎng,diǎn",
  "增长率": "zēng,zhǎng,lǜ",
  "增长速度": "zēng,zhǎng,sù,dù",
  "𫭨田士": "bá,tián,shì",
  "墨𠡠": "mò,lài",
  "墨卷": "mò,juàn",
  "墨帖": "mò,tiē",
  "墨斗": "mò,dǒu",
  "墨斗鱼": "mò,dǒu,yú",
  "墨晕": "mò,yùn",
  "墨曹都统": "mò,cáo,dū,tǒng",
  "墨杘": "mò,chī",
  "墨水儿": "mò,shuǐ,er",
  "墨盒子": "mò,hé,zi",
  "墨累": "mò,lèi",
  "墨累达令流域": "mò,lèi,dá,lìng,liú,yù",
  "墨缞": "mò,shuāi",
  "墨缞从戎": "mò,shuāi,cóng,róng",
  "墩地": "dūn,de",
  "墩堡": "dūn,pù",
  "壁效应": "bì,xiào,yìng",
  "壅塞": "yōng,sè",
  "壅掠": "yōng,lüě",
  "𰊑埮": "làn,tán",
  "𭏸坛": "wěi,tán",
  "𭏸埒": "wěi,liè",
  "𭏸墙": "wěi,qiáng",
  "𭏸宫": "wěi,gōng",
  "壮严地": "zhuàng,yán,de",
  "壮丽地": "zhuàng,lì,de",
  "壮健地": "zhuàng,jiàn,de",
  "壮实": "zhuàng,shi",
  "壮缪侯": "zhuàng,miù,hòu",
  "壮观地": "zhuàng,guān,de",
  "壮起胆子": "zhuàng,qǐ,dǎn,zi",
  "声乐": "shēng,yuè",
  "声势烜赫": "shēng,shì,huǐ,hè",
  "声名烜赫": "shēng,míng,huǐ,hè",
  "声名狼藉": "shēng,míng,láng,jí",
  "声咳": "shēng,hāi",
  "声喏": "shēng,rě",
  "声地": "shēng,de",
  "声应气求": "shēng,yìng,qì,qiú",
  "声求气应": "shēng,qiú,qì,yìng",
  "声调": "shēng,diào",
  "声调语言": "shēng,diào,yǔ,yán",
  "声调轮廓": "shēng,diào,lún,kuò",
  "壳儿": "ké,er",
  "壳牌": "qiào,pái",
  "壳牌公司": "qiào,pái,gōng,sī",
  "壳菜": "qiào,cài",
  "壳质": "qiào,zhì",
  "壹留兀渌": "yī,liú,wū,lù",
  "壹适": "yī,shì",
  "处世": "chǔ,shì",
  "处世之道": "chǔ,shì,zhī,dào",
  "处世原则": "chǔ,shì,yuán,zé",
  "处世哲学": "chǔ,shì,zhé,xué",
  "处业": "chǔ,yè",
  "处中": "chǔ,zhōng",
  "处之夷然": "chǔ,zhī,yí,rán",
  "处之怡然": "chǔ,zhī,yí,rán",
  "处之晏然": "chǔ,zhī,yàn,rán",
  "处之泰然": "chǔ,zhī,tài,rán",
  "处之绰然": "chǔ,zhī,chuō,rán",
  "处事": "chǔ,shì",
  "处事原则": "chǔ,shì,yuán,zé",
  "处于": "chǔ,yú",
  "处于昏睡状态": "chǔ,yú,hūn,shuì,zhuàng,tài",
  "处于昏迷状态": "chǔ,yú,hūn,mí,zhuàng,tài",
  "处交": "chǔ,jiāo",
  "处人": "chǔ,rén",
  "处以": "chǔ,yǐ",
  "处决": "chǔ,jué",
  "处分": "chǔ,fèn",
  "处分权": "chǔ,fèn,quán",
  "处刑": "chǔ,xíng",
  "处别": "chǔ,bié",
  "处制": "chǔ,zhì",
  "处剂": "chǔ,jì",
  "处势": "chǔ,shì",
  "处变": "chǔ,biàn",
  "处变不惊": "chǔ,biàn,bù,jīng",
  "处和": "chǔ,hé",
  "处囊": "chǔ,náng",
  "处困": "chǔ,kùn",
  "处在": "chǔ,zài",
  "处在瓶颈": "chǔ,zài,píng,jǐng",
  "处堂燕雀": "chǔ,táng,yàn,què",
  "处堂燕鹊": "chǔ,táng,yàn,què",
  "处境": "chǔ,jìng",
  "处士": "chǔ,shì",
  "处士星": "chǔ,shì,xīng",
  "处处": "chǔ,chù",
  "处处地": "chǔ,chù,de",
  "处女": "chǔ,nǚ",
  "处女作": "chǔ,nǚ,zuò",
  "处女地": "chǔ,nǚ,dì",
  "处女座": "chǔ,nǚ,zuò",
  "处女膜": "chǔ,nǚ,mó",
  "处女航": "chǔ,nǚ,háng",
  "处妇": "chǔ,fù",
  "处妾": "chǔ,qiè",
  "处姊": "chǔ,zǐ",
  "处子": "chǔ,zǐ",
  "处子秀": "chǔ,zǐ,xiù",
  "处守": "chǔ,shǒu",
  "处安思危": "chǔ,ān,sī,wēi",
  "处实": "chǔ,shí",
  "处实效功": "chǔ,shí,xiào,gōng",
  "处家": "chǔ,jiā",
  "处尊居显": "chǔ,zūn,jū,xiǎn",
  "处常": "chǔ,cháng",
  "处当": "chǔ,dāng",
  "处待": "chǔ,dài",
  "处心": "chǔ,xīn",
  "处心积虑": "chǔ,xīn,jī,lǜ",
  "处斩": "chǔ,zhǎn",
  "处断": "chǔ,duàn",
  "处方": "chǔ,fāng",
  "处方药": "chǔ,fāng,yào",
  "处暑": "chǔ,shǔ",
  "处正": "chǔ,zhèng",
  "处死": "chǔ,sǐ",
  "处治": "chǔ,zhì",
  "处法": "chǔ,fǎ",
  "处片": "chǔ,piàn",
  "处物": "chǔ,wù",
  "处理": "chǔ,lǐ",
  "处理品": "chǔ,lǐ,pǐn",
  "处理器": "chǔ,lǐ,qì",
  "处理失当": "chǔ,lǐ,shī,dàng",
  "处理得当": "chǔ,lǐ,dé,dàng",
  "处理者": "chǔ,lǐ,zhě",
  "处理能力": "chǔ,lǐ,néng,lì",
  "处男": "chǔ,nán",
  "处画": "chǔ,huà",
  "处疗": "chǔ,liáo",
  "处石": "chǔ,shí",
  "处约": "chǔ,yuē",
  "处罚": "chǔ,fá",
  "处置": "chǔ,zhì",
  "处舍": "chǔ,shè",
  "处裁": "chǔ,cái",
  "处警": "chǔ,jǐng",
  "处议": "chǔ,yì",
  "处身": "chǔ,shēn",
  "处身设地": "chǔ,shēn,shè,de",
  "处逸": "chǔ,yì",
  "处长": "chù,zhǎng",
  "处长地": "chù,zhǎng,de",
  "处顺": "chǔ,shùn",
  "处馆": "chǔ,guǎn",
  "处高临深": "chǔ,gāo,lín,shēn",
  "处齐": "chǔ,qí",
  "备不住": "bèi,bú,zhù",
  "备位充数": "bèi,wèi,chōng,shù",
  "备数": "bèi,shù",
  "备舍": "bèi,shè",
  "备载": "bèi,zǎi",
  "复于左毂": "fù,yú,zuǒ,gū",
  "复仇地": "fù,chóu,de",
  "复兴": "fù,xīng",
  "复兴乡": "fù,xīng,xiāng",
  "复兴党": "fù,xīng,dǎng",
  "复兴区": "fù,xīng,qū",
  "复兴时代": "fù,xīng,shí,dài",
  "复兴门": "fù,xīng,mén",
  "复分解反应": "fù,fēn,jiě,fǎn,yìng",
  "复变函数": "fù,biàn,hán,shù",
  "复变函数论": "fù,biàn,hán,shù,lùn",
  "复合函数": "fù,hé,hán,shù",
  "复名数": "fù,míng,shù",
  "复子明辟": "fù,zǐ,míng,bì",
  "复折": "fù,shé",
  "复数": "fù,shù",
  "复数域": "fù,shù,yù",
  "复数平面": "fù,shù,píng,miàn",
  "复数形式": "fù,shù,xíng,shì",
  "复朴": "fù,piáo",
  "复杂地": "fù,zá,de",
  "复种指数": "fù,zhǒng,zhǐ,shù",
  "复笮": "fù,zé",
  "复辟": "fù,bì",
  "复还": "fù,huán",
  "夏数": "xià,shù",
  "夏楚": "jiǎ,chǔ",
  "夏正": "xià,zhēng",
  "夏清侯": "xià,qīng,hòu",
  "夏潦": "xià,liáo",
  "夏种": "xià,zhòng",
  "夏葛": "xià,gě",
  "夏虫朝菌": "xià,chóng,zhāo,jūn",
  "夏载": "xià,zǎi",
  "夐别": "xuàn,bié",
  "夐古": "xuàn,gǔ",
  "夐夐": "xuàn,xuàn",
  "夐寥": "xuàn,liáo",
  "夐异": "xuàn,yì",
  "夐然": "xuàn,rán",
  "夐绝": "xuàn,jué",
  "夐迂": "xuàn,yū",
  "夐远": "xuàn,yuǎn",
  "夐阻": "xuàn,zǔ",
  "夐隔": "xuàn,gé",
  "夕发朝至": "xī,fā,zhāo,zhì",
  "夕寐宵兴": "xī,mèi,xiāo,xīng",
  "夕惕朝乾": "xī,tì,zhāo,qián",
  "外交地": "wài,jiāo,de",
  "外交豁免权": "wài,jiāo,huò,miǎn,quán",
  "外交部长": "wài,jiāo,bù,zhǎng",
  "外仆": "wài,pú",
  "外传": "wài,zhuàn",
  "外侧地": "wài,cè,de",
  "外出血": "wài,chū,xuè",
  "外合里应": "wài,hé,lǐ,yìng",
  "外因地": "wài,yīn,de",
  "外围地": "wài,wéi,de",
  "外国地": "wài,guó,de",
  "外地地": "wài,de,de",
  "外场人": "wài,cháng,rén",
  "外𭏸": "wài,wěi",
  "外外姐姐": "wài,wài,jiě,jie",
  "外头": "wài,tou",
  "外头人": "wài,tou,rén",
  "外孙女儿": "wài,sūn,nǚ,er",
  "外孙子": "wài,sūn,zi",
  "外应": "wài,yìng",
  "外形地": "wài,xíng,de",
  "外曾祖": "wài,zēng,zǔ",
  "外来地": "wài,lái,de",
  "外活儿": "wài,huó,er",
  "外源地": "wài,yuán,de",
  "外爷": "wài,ye",
  "外甥女婿": "wài,sheng,nǚ,xu",
  "外甥媳妇": "wài,sheng,xí,fù",
  "外界地": "wài,jiè,de",
  "外累": "wài,lèi",
  "外舍": "wài,shè",
  "外蒙古": "wài,měng,gǔ",
  "外蕃": "wài,fān",
  "外行": "wài,háng",
  "外行人": "wài,háng,rén",
  "外行地": "wài,háng,de",
  "外行话": "wài,háng,huà",
  "外表上地": "wài,biǎo,shàng,de",
  "外表地": "wài,biǎo,de",
  "外观上地": "wài,guān,shàng,de",
  "外观好地": "wài,guān,hǎo,de",
  "外调": "wài,diào",
  "外边": "wài,bian",
  "外边儿": "wài,bian,er",
  "外部地": "wài,bù,de",
  "外长": "wài,zhǎng",
  "外露": "wài,lù",
  "外面儿光": "wài,miàn,er,guāng",
  "外面地": "wài,miàn,de",
  "夗专": "wǎn,zhuān",
  "夙兴": "sù,xīng",
  "夙兴夜处": "sù,xīng,yè,chǔ",
  "夙兴夜寐": "sù,xīng,yè,mèi",
  "夙兴昧旦": "sù,xīng,mèi,dàn",
  "多一个": "duō,yí,gè",
  "多一点": "duō,yì,diǎn",
  "多个": "duō,ge",
  "多么地好": "duō,me,de,hǎo",
  "多人口地": "duō,rén,kǒu,de",
  "多任务处理": "duō,rèn,wu,chǔ,lǐ",
  "多会儿": "duō,huì,er",
  "多值函数": "duō,zhí,hán,shù",
  "多元函数": "duō,yuán,hán,shù",
  "多劳多得": "duō,láo,duō,de",
  "多半地": "duō,bàn,de",
  "多变化地": "duō,biàn,huà,de",
  "多变地": "duō,biàn,de",
  "多口相声": "duō,kǒu,xiàng,shēng",
  "多咱": "duō,zá",
  "多多地": "duō,duō,de",
  "多多地吻": "duō,duō,de,wěn",
  "多多地牵手": "duō,duō,de,qiān,shǒu",
  "多多地看": "duō,duō,de,kàn",
  "多年媳妇熬成婆": "duō,nián,xí,fù,áo,chéng,pó",
  "多应": "duō,yìng",
  "多弹头": "duō,dàn,tóu",
  "多得": "duō,de",
  "多得是": "duō,de,shì",
  "多情地": "duō,qíng,de",
  "多情地笑": "duō,qíng,de,xiào",
  "多才地": "duō,cái,de",
  "多数": "duō,shù",
  "多数党": "duō,shù,dǎng",
  "多数决": "duō,shù,jué",
  "多数地": "duō,shù,de",
  "多文为富": "duō,wén,wéi,fù",
  "多方面地": "duō,fāng,miàn,de",
  "多普勒效应": "duō,pǔ,lè,xiào,yìng",
  "多曾": "duō,zēng",
  "多次曝光": "duō,cì,bào,guāng",
  "多水分": "duō,shuǐ,fèn",
  "多汁地": "duō,zhī,de",
  "多洞穴地": "duō,dòng,xué,de",
  "多滥葛": "duō,làn,gě",
  "多灾多难": "duō,zāi,duō,nàn",
  "多烟地": "duō,yān,de",
  "多疑地": "duō,yí,de",
  "多瘤地": "duō,liú,de",
  "多目的": "duō,mù,dì",
  "多累": "duō,lèi",
  "多菲什": "duō,fēi,shí",
  "多览葛": "duō,lǎn,gě",
  "多言地": "duō,yán,de",
  "多言数穷": "duō,yán,shuò,qióng",
  "多财善贾": "duō,cái,shàn,gǔ",
  "多那太罗": "duō,nǎ,tài,luó",
  "多重": "duō,chóng",
  "多重人格": "duō,chóng,rén,gé",
  "多重国籍": "duō,chóng,guó,jí",
  "多重性": "duō,chóng,xìng",
  "多重结局": "duō,chóng,jié,jú",
  "多钱善贾": "duō,qián,shàn,gǔ",
  "多难": "duō,nàn",
  "多难兴邦": "duō,nàn,xīng,bāng",
  "多雨地": "duō,yǔ,de",
  "多露": "duō,lù",
  "多顾虑地": "duō,gù,lǜ,de",
  "多风波地": "duō,fēng,bō,de",
  "多鱼地": "duō,yú,de",
  "夜以继日地工作": "yè,yǐ,jì,rì,de,gōng,zuò",
  "夜光之璧": "ye,guang,zi,bi",
  "夜发": "yè,fèi",
  "夜头": "yè,tou",
  "夜如何其": "yè,rú,hé,jī",
  "夜宵儿": "yè,xiāo,er",
  "夜盆儿": "yè,pén,er",
  "夜禁": "yè,jìn",
  "夜里": "yè,li",
  "夜静更深": "yè,jìng,gēng,shēn",
  "夜静更阑": "yè,jìng,gēng,lán",
  "够不着": "gòu,bu,zháo",
  "够劲儿": "gòu,jìn,er",
  "够得上": "gòu,děi,shàng",
  "够得着": "gòu,de,zháo",
  "够戗": "gòu,qiàng",
  "够数": "gòu,shù",
  "够朋友": "gòu,péng,you",
  "够气派地": "gòu,qì,pài,de",
  "够着": "gòu,zháo",
  "大丈夫能屈能伸": "dà,zhàng,fu,néng,qū,néng,shēn",
  "大不了": "dà,bù,liǎo",
  "大不列蹀": "dà,bu,lie,die",
  "大个儿": "dà,gè,er",
  "大个子": "dà,gè,zi",
  "大丫头": "dà,yā,tou",
  "大中学生": "dà,zhōng,xué,sheng",
  "大为": "dà,wéi",
  "大予": "dà,yǔ",
  "大事不妙": "dà,shì,bú,miào",
  "大人不见小人怪": "dà,rén,bú,jiàn,xiǎo,rén,guài",
  "大人似地": "dà,rén,shì,de",
  "大仆": "dà,pú",
  "大仓": "tài,cāng",
  "大伙儿": "dà,huǒ,er",
  "大伯子": "dà,bǎi,zǐ",
  "大体解剖学": "dà,tǐ,jiě,pōu,xué",
  "大侯": "dà,hòu",
  "大修道院长": "dà,xiū,dào,yuàn,zhǎng",
  "大兴": "dà,xīng",
  "大兴区": "dà,xīng,qū",
  "大兴土木": "dà,xīng,tǔ,mù",
  "大兴地": "dà,xīng,de",
  "大兴安岭": "dà,xīng,ān,lǐng",
  "大兴安岭地区": "dà,xīng,ān,lǐng,dì,qū",
  "大兴安岭山脉": "dà,xīng,ān,lǐng,shān,mài",
  "大兴机场": "dà,xīng,jī,chǎng",
  "大兴问罪之师": "dà,xīng,wèn,zuì,zhī,shī",
  "大冠": "dà,guān",
  "大冠子夏": "dà,guàn,zi,xià",
  "大出丧": "dà,chū,sāng",
  "大出血": "dà,chū,xuè",
  "大剌剌地": "dà,lá,lá,de",
  "大包干儿": "dà,bāo,gān,er",
  "大半地": "dà,bàn,de",
  "大半拉": "dà,bàn,lǎ",
  "大单于": "dà,chán,yú",
  "大卷": "dà,juàn",
  "大口地": "dà,kǒu,de",
  "大口地吃": "dà,kǒu,de,chī",
  "大口地吞": "dà,kǒu,de,tūn",
  "大口地喝": "dà,kǒu,de,hē",
  "大只": "dà,zhī",
  "大吃大喝": "dà,chī,dà,hè",
  "大唐三藏取经诗话": "dà,táng,sān,zàng,qǔ,jīng,shī,huà",
  "大喇喇": "dà,là,là",
  "大嘴巴": "dà,zuǐ,ba",
  "大嚼": "dà,jué",
  "大地测量": "dà,dì,cè,liáng",
  "大地测量学": "dà,dì,cè,liáng,xué",
  "大型空爆炸弹": "dà,xíng,kōng,bào,zhà,dàn",
  "大埔": "dà,bù",
  "大埔县": "dà,bù,xiàn",
  "大堡礁": "dà,pù,jiāo",
  "大堤": "dà,dī",
  "大堤曲": "dà,dī,qǔ",
  "大声地": "dà,shēng,de",
  "大声地叫": "dà,shēng,de,jiào",
  "大声地哭": "dà,shēng,de,kū",
  "大声地喊": "dà,shēng,de,hǎn",
  "大声地喊道": "dà,shēng,de,hǎn,dào",
  "大声地嚼": "dà,shēng,de,jué",
  "大声地尖叫": "dà,shēng,de,jiān,jiào",
  "大声地笑": "dà,shēng,de,xiào",
  "大声地要求": "dà,shēng,de,yāo,qiú",
  "大声地讲": "dà,shēng,de,jiǎng",
  "大声地说": "dà,shēng,de,shuō",
  "大多数": "dà,duō,shù",
  "大大地": "dà,dà,de",
  "大大地不同": "dà,dà,de,bù,tóng",
  "大大地拖累了": "dà,dà,de,tuō,lěi,le",
  "大大地提高": "dà,dà,de,tí,gāo",
  "大大地露脸": "dà,dà,de,lòu,liǎn",
  "大夫": "dài,fū",
  "大夫松": "dài,fū,sōng",
  "大夫枝": "dài,fū,zhī",
  "大头娃娃": "dà,tóu,wá,wa",
  "大奶奶": "dà,nǎi,nai",
  "大妈妈": "dà,mā,ma",
  "大妹子": "dà,mèi,zi",
  "大始": "tài,shǐ",
  "大姐姐": "dà,jiě,jie",
  "大嫂子": "dà,sǎo,zi",
  "大安的列斯": "dà,ān,dì,liè,sī",
  "大安的列斯群岛": "dà,ān,dì,liè,sī,qún,dǎo",
  "大宛": "dà,yuān",
  "大宛马": "dà,yuān,mǎ",
  "大家伙": "dà,jiā,huo",
  "大家伙儿": "dà,jiā,huo,er",
  "大家数": "dà,jiā,shù",
  "大将": "dà,jiàng",
  "大将军": "dà,jiàng,jūn",
  "大尉迟": "dà,yù,chí",
  "大小子": "dà,xiǎo,zi",
  "大少爷": "dà,shào,yé",
  "大少爷作风": "dà,shào,yé,zuò,fēng",
  "大尾巴狼": "dà,yǐ,ba,láng",
  "大山小山": "tài,shān,xiǎo,shān",
  "大师傅": "dà,shī,fū",
  "大师父": "dà,shī,fu",
  "大帽子": "dà,mào,zi",
  "大幅增长": "dà,fú,zēng,zhǎng",
  "大幅度地": "dà,fú,dù,de",
  "大幅度地超过": "dà,fú,dù,de,chāo,guò",
  "大干": "dà,gàn",
  "大度地说": "dà,dù,de,shuō",
  "大息": "tài,xī",
  "大意失荆州": "dà,yi,shī,jīng,zhōu",
  "大愿地藏菩萨": "dà,yuàn,dì,zàng,pú,sà",
  "大折": "dà,shé",
  "大抬杆": "dà,tái,gǎn",
  "大拇指头": "dà,mǔ,zhǐ,tou",
  "大换血": "dà,huàn,xuè",
  "大排行": "dà,pái,háng",
  "大摇大摆地走": "dà,yáo,dà,bǎi,de,zǒu",
  "大撒把": "dà,sā,bà",
  "大数": "dà,shù",
  "大数据": "dà,shù,jù",
  "大数法则": "dà,shù,fǎ,zé",
  "大斑鹡鸰": "dà,bān,jí,líng",
  "大斗": "dà,dǒu",
  "大方地": "dà,fāng,de",
  "大方地拿出": "dà,fāng,de,ná,chū",
  "大方地讲": "dà,fāng,de,jiǎng",
  "大曲": "dà,qū",
  "大月氏": "dà,yuè,zhī",
  "大有为": "dà,yǒu,wéi",
  "大有作为": "dà,yǒu,zuò,wéi",
  "大有可为": "dà,yǒu,kě,wéi",
  "大有裨益": "dà,yǒu,bì,yì",
  "大查科平原": "dà,zhā,kē,píng,yuán",
  "大概地": "dà,gài,de",
  "大概地说": "dà,gài,de,shuō",
  "大模厮样": "dà,mú,sī,yàng",
  "大模尸样": "dà,mú,shī,yàng",
  "大步地": "dà,bù,de",
  "大毒日头": "dà,dú,rì,tou",
  "大气保温效应": "dà,qì,bǎo,wēn,xiào,yìng",
  "大气儿": "dà,qì,er",
  "大气磅礴": "dà,qì,páng,bó",
  "大汗": "dà,hán",
  "大洋型地壳": "dà,yáng,xíng,dì,qiào",
  "大溜": "dà,liù",
  "大演数": "dà,yǎn,shù",
  "大濩": "dà,hù",
  "大炮打蚊子": "dà,pào,dǎ,wén,zi",
  "大煞风趣": "dà,shà,fēng,qù",
  "大率": "dà,shuài",
  "大王": "dài,wáng",
  "大王父": "dài,wáng,fù",
  "大王风": "dài,wáng,fēng",
  "大璞不完": "tài,pú,bù,wán",
  "大略地": "dà,lüè,de",
  "大略地看": "dà,lüè,de,kàn",
  "大皇": "tài,huáng",
  "大盘子": "dà,pán,zi",
  "大相国寺": "dà,xiàng,guó,sì",
  "大着作": "dà,zhe,zuò",
  "大石调": "dà,shí,diào",
  "大碗儿茶": "dà,wǎn,er,chá",
  "大碗岛上的一个星期日": "dà,wǎn,dǎo,shàng,de,yí,gè,xīng,qī,rì",
  "大禁": "dà,jìn",
  "大红全帖": "dà,hóng,quán,tiē",
  "大红日子": "dà,hóng,rì,zi",
  "大红鼻子": "dà,hóng,bí,zi",
  "大约地": "dà,yuē,de",
  "大缪": "dà,miù",
  "大缪不然": "dà,miù,bù,rán",
  "大老子": "dà,lǎo,zi",
  "大老爷们儿": "dà,lǎo,yé,men,ér",
  "大而无当": "dà,ér,wú,dàng",
  "大肚子": "dà,dǔ,zi",
  "大肚子经济": "dà,dù,zi,jīng,jì",
  "大肠杆菌": "dà,cháng,gǎn,jūn",
  "大肥喏": "dà,féi,rě",
  "大胆地": "dà,dǎn,de",
  "大胆地去": "dà,dǎn,de,qù",
  "大胆地吻": "dà,dǎn,de,wěn",
  "大胆地尝试": "dà,dǎn,de,cháng,shì",
  "大胆地干": "dà,dǎn,de,gàn",
  "大胆地思考": "dà,dǎn,de,sī,kǎo",
  "大胆地表白": "dà,dǎn,de,biǎo,bái",
  "大胆地表示": "dà,dǎn,de,biǎo,shì",
  "大胆地讲": "dà,dǎn,de,jiǎng",
  "大胆地说": "dà,dǎn,de,shuō",
  "大胆地闯": "dà,dǎn,de,chuǎng",
  "大脖子病": "dà,bó,zi,bìng",
  "大脚片儿": "dà,jiǎo,piān,er",
  "大脚色": "dà,jué,sè",
  "大腕儿": "dà,wàn,er",
  "大腹便便": "dà,fù,pián,pián",
  "大致地": "dà,zhì,de",
  "大舌头": "dà,shé,tou",
  "大舍": "dà,shè",
  "大茀": "dà,bó",
  "大茴香子": "dà,huí,xiāng,zi",
  "大萝卜": "dà,luó,bo",
  "大落": "dà,luō",
  "大落落": "dà,luō,luò",
  "大藏": "dà,zàng",
  "大藏经": "dà,zàng,jīng",
  "大行人": "dà,háng,rén",
  "大行大市": "dà,háng,dà,shì",
  "大行政区": "dà,háng,zhèng,qū",
  "大行星": "dà,háng,xīng",
  "大行皇后": "dà,háng,huáng,hòu",
  "大观帖": "dà,guān,tiē",
  "大规模地": "dà,guī,mó,de",
  "大说": "dà,yuè",
  "大调": "dà,diào",
  "大谱儿": "dà,pǔ,er",
  "大象地": "dà,xiàng,de",
  "大貉小貉": "dà,mò,xiǎo,mò",
  "大贾": "dà,gǔ",
  "大跌": "dà,diē",
  "大跌市": "dà,diē,shì",
  "大跌眼镜": "dà,diē,yǎn,jìng",
  "大踏步地": "dà,tà,bù,de",
  "大身子": "dà,shēn,zi",
  "大轴": "dà,zhòu",
  "大轴子": "dà,zhòu,zǐ",
  "大轴戏": "dà,zhòu,xì",
  "大还丹": "dà,huán,dān",
  "大部分": "dà,bù,fèn",
  "大部分地": "dà,bù,fèn,de",
  "大部地": "dà,bù,de",
  "大都": "dà,dū",
  "大都会": "dà,dū,huì",
  "大都宪": "dà,dū,xiàn",
  "大都市": "dà,dū,shì",
  "大都市地区": "dà,dū,shì,dì,qū",
  "大量地": "dà,liàng,de",
  "大量地使用": "dà,liàng,de,shǐ,yòng",
  "大量地做": "dà,liàng,de,zuò",
  "大量地给": "dà,liàng,de,gěi",
  "大金背啄木鸟": "dà,jīn,bèi,zhuó,mù,niǎo",
  "大长": "dà,zhǎng",
  "大长公主": "dà,zhǎng,gōng,zhǔ",
  "大门头儿": "dà,mén,tou,er",
  "大间歇泉": "dà,jiàn,xiē,quán",
  "大难": "dà,nàn",
  "大难不死": "dà,nàn,bù,sǐ",
  "大难临头": "dà,nàn,lín,tóu",
  "大雅": "dà,yá",
  "大雨般地": "dà,yǔ,bān,de",
  "大面儿": "dà,miàn,er",
  "大面皮儿": "dà,miàn,pí,er",
  "大面积地": "dà,miàn,jī,de",
  "大鳞大马哈鱼": "dà,lín,dá,mǎ,hǎ,yú",
  "大鳞大麻哈鱼": "dà,lín,dá,má,hǎ,yú",
  "大麦克指数": "dà,mài,kè,zhǐ,shù",
  "大黄": "dài,huáng",
  "大黄冠啄木鸟": "dà,huáng,guān,zhuó,mù,niǎo",
  "大黄鱼": "dài,huáng,yú",
  "大鼜": "dà,qì",
  "大鼻子地": "dà,bí,zi,de",
  "大𥻗子": "dà,chá,zi",
  "天上下刀子": "tiān,shàng,xià,dāo,zi",
  "天上地": "tiān,shàng,de",
  "天下为公": "tiān,xià,wéi,gōng",
  "天下为家": "tiān,xià,wéi,jiā",
  "天下为笼": "tiān,xià,wéi,lóng",
  "天下兴亡": "tiān,xià,xīng,wáng",
  "天不怕地": "tiān,bù,pà,de",
  "天不转地转": "tiān,bù,zhuàn,dì,zhuàn",
  "天之僇民": "tiān,zhī,ruò,mín",
  "天人之分": "tiān,rén,zhī,fèn",
  "天人感应": "tiān,rén,gǎn,yìng",
  "天人相应": "tiān,rén,xiāng,yìng",
  "天体地": "tiān,tǐ,de",
  "天使般地": "tiān,shǐ,bān,de",
  "天儿": "tiān,er",
  "天兵天将": "tiān,bīng,tiān,jiàng",
  "天冠": "tiān,guān",
  "天冠地屦": "tiān,guān,dì,jù",
  "天分": "tiān,fèn",
  "天华": "tiān,huā",
  "天华乱坠": "tiān,huā,luàn,zhuì",
  "天可汗": "tiān,kè,hán",
  "天台": "tiān,tāi",
  "天台县": "tiān,tāi,xiàn",
  "天台女": "tiān,tāi,nǚ",
  "天台山": "tiān,tāi,shān",
  "天哟": "tiān,yo",
  "天哪": "tiān,na",
  "天地剖判": "tiān,dì,pōu,pàn",
  "天地折": "tiān,dì,shé",
  "天姥": "tiān,mǔ",
  "天姥山": "tiān,mǔ,shān",
  "天家": "tiān,jie",
  "天将": "tiān,jiàng",
  "天差地别": "tiān,chā,dì,bié",
  "天差地远": "tiān,chā,dì,yuǎn",
  "天干地燥": "tiān,gān,de,zào",
  "天应": "tiān,yìng",
  "天得": "tiān,de",
  "天性地": "tiān,xìng,de",
  "天数": "tiān,shù",
  "天文数字": "tiān,wén,shù,zì",
  "天旋地转": "tiān,xuán,dì,zhuàn",
  "天晓得": "tiān,xiǎo,de",
  "天机不可泄露": "tiān,jī,bù,kě,xiè,lù",
  "天然地": "tiān,rán,de",
  "天煞孤星": "tiān,shà,gū,xīng",
  "天生一对": "tiān,shēng,yí,duì",
  "天生地": "tiān,shēng,de",
  "天监": "tiān,jiàn",
  "天盖地": "tiān,gài,de",
  "天相": "tiān,xiàng",
  "天真地": "tiān,zhēn,de",
  "天真地认为": "tiān,zhēn,de,rèn,wéi",
  "天真地说": "tiān,zhēn,de,shuō",
  "天真地问": "tiān,zhēn,de,wèn",
  "天祝藏族自治县": "tiān,zhù,zàng,zú,zì,zhì,xiàn",
  "天禄大夫": "tiān,lù,dài,fū",
  "天竺牡丹": "tiān,zhú,mǔ,dan",
  "天策上将": "tiān,cè,shàng,jiàng",
  "天𬙝": "tiān,bì",
  "天老儿": "tiān,lǎo,er",
  "天老爷": "tiān,lǎo,ye",
  "天衣无缝": "tiān,yī,wú,fèng",
  "天覆地载": "tiān,fù,dì,zǎi",
  "天设地造": "tiān,shè,de,zào",
  "天赋地": "tiān,fù,de",
  "天道好还": "tiān,dào,hǎo,huán",
  "天郄": "tiān,xì",
  "天都": "tiān,dū",
  "天长节": "tiān,zhǎng,jié",
  "天阙": "tiān,què",
  "天雨": "tiān,yù",
  "天雨粟": "tiān,yù,sù",
  "天雨路滑": "tiān,yù,lù,huá",
  "太一数": "tài,yī,shù",
  "太仆": "tài,pú",
  "太仆寺": "tài,pú,sì",
  "太仆寺卿": "tài,pú,sì,qīng",
  "太冲": "tài,chòng",
  "太古洋行": "tài,gǔ,yáng,háng",
  "太多地用": "tài,duō,de,yòng",
  "太太": "tài,tai",
  "太子参": "tài,zi,shēn",
  "太室阙": "tài,shì,què",
  "太师轿子": "tài,shī,jiào,zi",
  "太常雅乐": "tài,cháng,yǎ,yuè",
  "太朴": "tài,piáo",
  "太煞": "tài,shà",
  "太甚地": "tài,shèn,de",
  "太监": "tài,jiàn",
  "太行八陉": "tài,háng,bā,xíng",
  "太行山": "tài,háng,shān",
  "太行山绿化工程": "tài,háng,shān,lǜ,huà,gōng,chéng",
  "太过分": "tài,guò,fèn",
  "太阳": "tài,yang",
  "太阳神计划": "tài,yáng,shén,jì,huà",
  "太阳蛋": "tài,yang,dàn",
  "太阿": "tài,ē",
  "太阿倒持": "tài,ē,dào,chí",
  "太阿在握": "tài,ē,zài,wò",
  "夫夫": "fú,fū",
  "夫妇般地": "fū,fù,bān,de",
  "夫妻相": "fū,qī,xiàng",
  "夫妻间地": "fū,qī,jiān,de",
  "夫差": "fū,chāi",
  "夫己氏": "fú,jǐ,shì",
  "夫调": "fū,diào",
  "夭娜": "yāo,nà",
  "央告": "yāng,gao",
  "央央跄跄": "yāng,yāng,qiàng,qiàng",
  "央行": "yāng,háng",
  "夯货": "bèn,huò",
  "夯雀儿先飞": "bèn,què,ér,xiān,fēi",
  "失常地": "shī,cháng,de",
  "失当": "shī,dàng",
  "失得": "shī,de",
  "失态地": "shī,tài,de",
  "失懽": "shī,guàn",
  "失控地": "shī,kòng,de",
  "失望地": "shī,wàng,de",
  "失着": "shī,zhāo",
  "失礼地": "shī,lǐ,de",
  "失禁": "shī,jìn",
  "失策地": "shī,cè,de",
  "失䇲": "shī,jiā",
  "失而复得": "shī,ér,fù,de",
  "失血": "shī,xuè",
  "失血性贫血": "shī,xuè,xìng,pín,xuè",
  "失败为成功之母": "shī,bài,wéi,chéng,gōng,zhī,mǔ",
  "失败地": "shī,bài,de",
  "失身分": "shī,shēn,fèn",
  "失载": "shī,zǎi",
  "失面子": "shī,miàn,zi",
  "失马塞翁": "shī,mǎ,sài,wēng",
  "头上著头": "tóu,shàng,zhuó,tóu",
  "头也不回地离开": "tóu,yě,bù,huí,de,lí,kāi",
  "头也不回地走了": "tóu,yě,bù,huí,de,zǒu,le",
  "头会": "tóu,kuài",
  "头会箕敛": "tóu,kuài,jī,liǎn",
  "头会箕赋": "tóu,kuài,jī,fù",
  "头倒立": "tóu,dào,lì",
  "头儿": "tóu,er",
  "头儿脑儿": "tóu,er,nǎo,er",
  "头冠": "tóu,guān",
  "头出头没": "tóu,chū,tóu,mò",
  "头半天儿": "tóu,bàn,tiān,er",
  "头发": "tóu,fà",
  "头发油": "tóu,fà,yóu",
  "头发胡子一把抓": "tóu,fa,hú,zi,yī,bǎ,zhuā",
  "头向前地": "tóu,xiàng,qián,de",
  "头嗌": "tóu,ài",
  "头头儿": "tóu,tóu,er",
  "头子": "tóu,zi",
  "头子钱": "tóu,zi,qián",
  "头庶剠": "tóu,shù,lüè",
  "头把儿": "tóu,bà,er",
  "头昏脑涨": "tóu,hūn,nǎo,zhàng",
  "头晕地": "tóu,yūn,de",
  "头晕脑涨": "tóu,yūn,nǎo,zhàng",
  "头汤": "tóu,táng",
  "头没杯案": "tóu,mò,bēi,àn",
  "头牟": "tóu,mù",
  "头破血出": "tóu,pò,xuè,chū",
  "头破血流": "tóu,pò,xuè,liú",
  "头破血淋": "tóu,pò,xuè,lín",
  "头童齿豁": "tóu,tóng,chǐ,huò",
  "头箍儿": "tóu,gū,er",
  "头脑清楚": "tóu,nǎo,qīng,chu",
  "头脸儿": "tóu,liǎn,er",
  "头足倒置": "tóu,zú,dào,zhì",
  "头足异处": "tóu,zú,yì,chǔ",
  "夷为平地": "yí,wéi,píng,dì",
  "夷岨": "yí,qū",
  "夷牟": "yí,mù",
  "夷离堇": "yí,lí,jǐn",
  "夷翟": "yí,zhái",
  "夷貉": "yí,mò",
  "夷鬼子": "yí,guǐ,zi",
  "夸下海口": "kuā,xia,hǎi,kǒu",
  "夸嘐": "kuā,jiāo",
  "夸大地": "kuā,dà,de",
  "夸张地": "kuā,zhāng,de",
  "夸张地说": "kuā,zhāng,de,shuō",
  "夸耀地": "kuā,yào,de",
  "夸谩": "kuā,màn",
  "夸骜": "kuā,ào",
  "夹七夹八": "jiā,qī,jiā,bā",
  "夹丝玻璃": "jiā,sī,bō,li",
  "夹乘": "jiā,chéng",
  "夹介": "jiā,jiè",
  "夹具": "jiā,jù",
  "夹击": "jiā,jī",
  "夹剪": "jiā,jiǎn",
  "夹剪舱": "jiā,jiǎn,cāng",
  "夹助": "jiā,zhù",
  "夹单": "jiā,dān",
  "夹厕": "jiā,cè",
  "夹发": "jiā,fā",
  "夹叙夹议": "jiā,xù,jiā,yì",
  "夹和": "jiā,hé",
  "夹囊": "jiā,náng",
  "夹圈": "jiā,quān",
  "夹城": "jiā,chéng",
  "夹塞儿": "jiā,sāi,er",
  "夹墙": "jiā,qiáng",
  "夹壁": "jiā,bì",
  "夹壮": "jiā,zhuàng",
  "夹娃娃": "jiā,wá,wa",
  "夹子": "jiā,zi",
  "夹宣": "jiā,xuān",
  "夹室": "jiā,shì",
  "夹寨": "jiā,zhài",
  "夹寨夫人": "jiā,zhài,fū,rén",
  "夹尾巴": "jiā,wěi,ba",
  "夹屁股": "jiā,pì,gǔ",
  "夹层": "jiā,céng",
  "夹层玻璃": "jiā,céng,bō,lí",
  "夹层话": "jiā,céng,huà",
  "夹山国家森林公园": "jiā,shān,guó,jiā,sēn,lín,gōng,yuán",
  "夹山寺": "jiā,shān,sì",
  "夹岸": "jiā,àn",
  "夹峙": "jiā,zhì",
  "夹巷": "jiā,xiàng",
  "夹帐": "jiā,zhàng",
  "夹带": "jiā,dài",
  "夹幕": "jiā,mù",
  "夹庾": "jiā,yǔ",
  "夹弄": "jiā,nòng",
  "夹弓": "jiā,gōng",
  "夹当": "jiā,dāng",
  "夹当儿": "jiā,dāng,er",
  "夹径": "jiā,jìng",
  "夹心": "jiā,xīn",
  "夹心族": "jiā,xīn,zú",
  "夹心饼干": "jiā,xīn,bǐng,gān",
  "夹打": "jiā,dǎ",
  "夹批": "jiā,pī",
  "夹拜": "jiā,bài",
  "夹拥": "jiā,yōng",
  "夹持": "jiā,chí",
  "夹振": "jiā,zhèn",
  "夹搀": "jiā,chān",
  "夹攻": "jiā,gōng",
  "夹断": "jiā,duàn",
  "夹日": "jiā,rì",
  "夹望车": "jiā,wàng,chē",
  "夹杂": "jiā,zá",
  "夹板": "jiā,bǎn",
  "夹板气": "jiā,bǎn,qì",
  "夹板船": "jiā,bǎn,chuán",
  "夹枪带棍": "jiā,qiāng,dài,gùn",
  "夹枪带棒": "jiā,qiāng,dài,bàng",
  "夹桚": "jiā,zā",
  "夹棍": "jiā,gùn",
  "夹棒": "jiā,bàng",
  "夹榆": "jiā,yú",
  "夹毂": "jiā,gū",
  "夹毂队": "jiā,gū,duì",
  "夹江": "jiā,jiāng",
  "夹江县": "jiā,jiāng,xiàn",
  "夹注": "jiā,zhù",
  "夹漈先生": "jiā,jì,xiān,shēng",
  "夹片": "jiā,piàn",
  "夹生": "jiā,shēng",
  "夹生话": "jiā,shēng,huà",
  "夹生饭": "jiā,shēng,fàn",
  "夹疑": "jiā,yí",
  "夹白": "jiā,bái",
  "夹盘": "jiā,pán",
  "夹磨": "jiā,mó",
  "夹私": "jiā,sī",
  "夹窓": "jiā,chuāng",
  "夹窗": "jiā,chuāng",
  "夹竹桃": "jiā,zhú,táo",
  "夹箔幛": "jiā,bó,zhàng",
  "夹紧": "jiā,jǐn",
  "夹纩": "jiā,kuàng",
  "夹纸灯笼": "jiā,zhǐ,dēng,lóng",
  "夹纻": "jiā,zhù",
  "夹纾": "jiā,shū",
  "夹细": "jiā,xì",
  "夹结": "jiā,jié",
  "夹绕": "jiā,rào",
  "夹缝": "jiā,fèng",
  "夹缠": "jiā,chán",
  "夹缬": "jiā,xié",
  "夹肝": "jiā,gān",
  "夹肢窝": "gā,zhi,wō",
  "夹脊梁": "jiā,jǐ,liáng",
  "夹脑": "jiā,nǎo",
  "夹脑风": "jiā,nǎo,fēng",
  "夹脚拖": "jiā,jiǎo,tuō",
  "夹腰": "jiā,yāo",
  "夹膝": "jiā,xī",
  "夹臾": "jiā,yú",
  "夹衖": "jiā,lòng",
  "夹衩": "jiā,chà",
  "夹衫": "jiā,shān",
  "夹袋": "jiā,dài",
  "夹袋中人物": "jiā,dài,zhōng,rén,wù",
  "夹袋人物": "jiā,dài,rén,wù",
  "夹角": "jiā,jiǎo",
  "夹讯": "jiā,xùn",
  "夹谷": "jiā,gǔ",
  "夹起尾巴": "jiā,qǐ,wěi,ba",
  "夹路": "jiā,lù",
  "夹辅": "jiā,fǔ",
  "夹道": "jiā,dào",
  "夹道欢迎": "jiā,dào,huān,yíng",
  "夹钟": "jiā,zhōng",
  "夹钳": "jiā,qián",
  "夹锡钱": "jiā,xī,qián",
  "夹镜": "jiā,jìng",
  "夹间": "jiā,jiān",
  "夹食": "jiā,shí",
  "夹馅": "jiā,xiàn",
  "夹马营": "jiā,mǎ,yíng",
  "夺人所好": "duó,rén,suǒ,hào",
  "夺得": "duó,de",
  "夺适": "duó,shì",
  "奄人": "yān,rén",
  "奄欻": "yǎn,chuā",
  "奇中": "qí,zhòng",
  "奇偶": "jī,ǒu",
  "奇偶性": "jī,ǒu,xìng",
  "奇傀": "qí,guī",
  "奇函数": "jī,hán,shù",
  "奇咳": "qí,hāi",
  "奇妙地": "qí,miào,de",
  "奇嶷": "qí,nì",
  "奇干": "qí,gàn",
  "奇异地": "qí,yì,de",
  "奇性地": "qí,xìng,de",
  "奇怪地": "qí,guài,de",
  "奇怪地问": "qí,guài,de,wèn",
  "奇数": "jī,shù",
  "奇数地": "jī,shù,de",
  "奇羡": "jī,xiàn",
  "奇肱": "jī,gōng",
  "奇请它比": "qí,qíng,tā,bǐ",
  "奇蹄目": "jī,tí,mù",
  "奇蹄类": "jī,tí,lèi",
  "奇迹地": "qí,jì,de",
  "奇迹般地": "qí,jì,bān,de",
  "奇零": "jī,líng",
  "奉为": "fèng,wéi",
  "奉为圭臬": "fèng,wéi,guī,niè",
  "奉为楷模": "fèng,wéi,kǎi,mó",
  "奉为至宝": "fèng,wéi,zhì,bǎo",
  "奉公不阿": "fèng,gōng,bù,ē",
  "奉𠡠": "fèng,lài",
  "奉承": "fèng,cheng",
  "奉承地": "fèng,chéng,de",
  "奉承讨好": "fèng,cheng,tǎo,hǎo",
  "奉调": "fèng,diào",
  "奉还": "fèng,huán",
  "奋兴": "fèn,xīng",
  "奋发地": "fèn,fā,de",
  "奋发有为": "fèn,fā,yǒu,wéi",
  "奋肣": "fèn,hán",
  "奋褎": "fèn,yòu",
  "奋轧": "fèn,zhá",
  "奎蹏": "kuí,dì",
  "奏乐": "zòu,yuè",
  "奏削": "zòu,xuē",
  "奏弹": "zòu,dàn",
  "契帖": "qì,tiē",
  "契𦈡": "qì,xū",
  "契约上地": "qì,yuē,shàng,de",
  "奓刺": "zhà,cì",
  "奓大": "zhà,dà",
  "奓太": "zhà,tài",
  "奓毛": "zhà,máo",
  "奓汰": "zhà,tài",
  "奓沙": "zhà,shā",
  "奓纵": "zhà,zòng",
  "奓言": "zhà,yán",
  "奓阔": "zhà,kuò",
  "奓靡": "zhà,mí",
  "奔丧": "bēn,sāng",
  "奔命": "bèn,mìng",
  "奔四": "bèn,sì",
  "奔头": "bèn,tóu",
  "奔头儿": "bèn,tou,er",
  "奔放地": "bēn,fàng,de",
  "奔月": "bèn,yuè",
  "奔走呼号": "bēn,zǒu,hū,háo",
  "奔跑地": "bēn,pǎo,de",
  "奕偞": "yì,yè",
  "套交情": "tào,jiāo,qing",
  "套儿": "tào,er",
  "套套": "tào,tao",
  "套子": "tào,zi",
  "套数": "tào,shù",
  "套种": "tào,zhòng",
  "套色": "tào,shǎi",
  "套衫儿": "tào,shān,er",
  "套调": "tào,diào",
  "套马杆": "tào,mǎ,gǎn",
  "奚蠡": "xī,lí",
  "奚适": "xī,shì",
  "奠都": "diàn,dū",
  "奡兀": "ào,wū",
  "奢侈地": "shē,chǐ,de",
  "奢奓": "shē,zhà",
  "奤夿屯": "hǎ,bā,tún",
  "奤子": "hǎ,zǐ",
  "奤调": "hǎ,diào",
  "奥什": "ào,shí",
  "奥古斯都": "ào,gǔ,sī,dū",
  "奥塞梯": "ào,sè,tī",
  "奥处": "ào,chǔ",
  "奥得河": "ào,de,hé",
  "奥折": "ào,shé",
  "奥数": "ào,shù",
  "奥米伽": "ào,mǐ,gā",
  "奥维耶多": "ào,wéi,yē,duō",
  "女主角": "nǚ,zhǔ,jué",
  "女主角地": "nǚ,zhǔ,jué,de",
  "女人似地": "nǚ,rén,shì,de",
  "女人家": "nǚ,rén,jia",
  "女仆": "nǚ,pú",
  "女体盛": "nǚ,tǐ,chéng",
  "女傧相": "nǚ,bīn,xiàng",
  "女儿子": "nǚ,ér,zi",
  "女儿葛": "nǚ,ér,gě",
  "女冠": "nǚ,guān",
  "女冠子": "nǚ,guàn,zi",
  "女大不中留": "nǚ,dà,bù,zhòng,liú",
  "女孩子": "nǚ,hái,zi",
  "女将": "nǚ,jiàng",
  "女强人": "nǚ,qiǎng,rén",
  "女性厌恶": "nǚ,xìng,yàn,wù",
  "女性地": "nǚ,xìng,de",
  "女曲": "nǚ,qū",
  "女校长": "nǚ,xiào,zhǎng",
  "女汉子": "nǚ,hàn,zi",
  "女王般地": "nǚ,wáng,bān,de",
  "女相": "nǚ,xiàng",
  "女相如": "nǚ,xiàng,rú",
  "女红": "nǚ,gōng",
  "女舍监": "nǚ,shè,jiān",
  "女长当嫁": "nǚ,zhǎng,dāng,jià",
  "女长须嫁": "nǚ,zhǎng,xū,jià",
  "女陴": "nǚ,pí",
  "女黄冠": "nǚ,huáng,guān",
  "奴仆": "nú,pú",
  "奴儿干都司": "nú,ér,gān,dū,sī",
  "奴婢似地": "nú,bì,shì,de",
  "奴才": "nú,cai",
  "奴隶般地": "nú,lì,bān,de",
  "奶哥哥": "nǎi,gē,ge",
  "奶嘴儿": "nǎi,zuǐ,er",
  "奶奶": "nǎi,nai",
  "奶奶的": "nǎi,nai,de",
  "奶子": "nǎi,zi",
  "奶拽": "nǎi,zhuǎi",
  "奶油似地": "nǎi,yóu,shì,de",
  "奸为": "jiān,wéi",
  "奸同鬼蜮": "jiān,tong,guǐ,yù",
  "奸愬": "jiān,shuò",
  "奸数": "jiān,shù",
  "奸细": "jiān,xi",
  "奸诈地": "jiān,zhà,de",
  "她为难地": "tā,wéi,nán,de",
  "她们": "tā,men",
  "她猛地": "tā,měng,de",
  "她羞愧地": "tā,xiū,kuì,de",
  "好一会儿": "hǎo,yī,huì,er",
  "好丹非素": "hào,dān,fēi,sù",
  "好为事端": "hào,wéi,shì,duān",
  "好为人师": "hào,wéi,rén,shī",
  "好久不见": "hǎo,jiǔ,bu,jiàn",
  "好久地": "hǎo,jiǔ,de",
  "好乱地": "hǎo,luàn,de",
  "好争吵地": "hǎo,zhēng,chǎo,de",
  "好事之徒": "hào,shì,zhī,tú",
  "好事者": "hào,shì,zhě",
  "好交际地": "hǎo,jiāo,jì,de",
  "好仇": "hào,qiú",
  "好佚恶劳": "hǎo,yì,wù,láo",
  "好兆头": "hǎo,zhào,tou",
  "好利": "hào,lì",
  "好动": "hào,dòng",
  "好勇斗狠": "hào,yǒng,dòu,hěn",
  "好古": "hào,gǔ",
  "好吃好喝": "hào,chī,hào,hē",
  "好吃懒做": "hào,chī,lǎn,zuò",
  "好吧": "hǎo,ba",
  "好听地": "hǎo,tīng,de",
  "好吹牛": "hào,chuī,niú",
  "好和平地": "hǎo,hé,píng,de",
  "好善": "hào,shàn",
  "好善乐施": "hào,shàn,lè,shī",
  "好善恶恶": "hǎo,shàn,wù,è",
  "好大喜功": "hào,dà,xǐ,gōng",
  "好天儿": "hǎo,tiān,er",
  "好奇": "hào,qí",
  "好奇地": "hào,qí,de",
  "好奇地听": "hào,qí,de,tīng",
  "好奇地看着": "hào,qí,de,kàn,zhe",
  "好奇地问": "hào,qí,de,wèn",
  "好奇地问一句": "hào,qí,de,wèn,yī,jù",
  "好奇地问道": "hào,qí,de,wèn,dào",
  "好奇心": "hào,qí,xīn",
  "好好地": "hǎo,hǎo,de",
  "好好地休息一下": "hǎo,hǎo,de,xiū,xī,yī,xià",
  "好好地吃": "hǎo,hǎo,de,chī",
  "好好地唱": "hǎo,hǎo,de,chàng",
  "好好地对待": "hǎo,hǎo,de,duì,dài",
  "好好地想想": "hǎo,hǎo,de,xiǎng,xiǎng",
  "好好地招待": "hǎo,hǎo,de,zhāo,dài",
  "好好地整顿": "hǎo,hǎo,de,zhěng,dùn",
  "好好地活着": "hǎo,hǎo,de,huó,zhe",
  "好好地用": "hǎo,hǎo,de,yòng",
  "好好地睡一觉": "hǎo,hǎo,de,shuì,yī,jiào",
  "好好地练": "hǎo,hǎo,de,liàn",
  "好好地聊聊": "hǎo,hǎo,de,liáo,liáo",
  "好好地谈一谈": "hǎo,hǎo,de,tán,yī,tán",
  "好嫉妒地": "hǎo,jí,dù,de",
  "好嬉戏地": "hǎo,xī,xì,de",
  "好学": "hào,xué",
  "好学不倦": "hào,xué,bù,juàn",
  "好学地": "hào,xué,de",
  "好学深思": "hào,xué,shēn,sī",
  "好客": "hào,kè",
  "好家伙": "hǎo,jiā,huo",
  "好尚": "hào,shàng",
  "好强": "hào,qiáng",
  "好得很": "hǎo,de,hěn",
  "好心倒做了驴肝肺": "hǎo,xīn,dào,zuò,le,lǘ,gān,fēi",
  "好心地": "hǎo,xīn,de",
  "好恶": "hào,wù",
  "好想静静地看看": "hǎo,xiǎng,jìng,jìng,de,kàn,kàn",
  "好意地": "hǎo,yì,de",
  "好戏还在后头": "hǎo,xì,hái,zài,hòu,tou",
  "好战": "hào,zhàn",
  "好战分子": "hào,zhàn,fèn,zi",
  "好战地": "hào,zhàn,de",
  "好打听地": "hǎo,dǎ,tīng,de",
  "好批评地": "hǎo,pī,píng,de",
  "好挑剔地": "hǎo,tiāo,tī,de",
  "好故事百听不厌": "hǎo,gù,shi,bǎi,tīng,bù,yàn",
  "好整以暇": "hào,zhěng,yǐ,xiá",
  "好斗": "hào,dòu",
  "好施": "hào,shī",
  "好日头": "hǎo,rì,tou",
  "好日子": "hǎo,rì,zi",
  "好朋友": "hǎo,péng,you",
  "好样儿的": "hǎo,yàng,er,de",
  "好死不如赖活着": "hǎo,sǐ,bù,rú,lài,huó,zhe",
  "好氧": "hào,yǎng",
  "好玩地": "hǎo,wán,de",
  "好生之德": "hào,shēng,zhī,dé",
  "好畤侯": "hǎo,zhì,hòu",
  "好看地": "hǎo,kàn,de",
  "好竞争地": "hǎo,jìng,zhēng,de",
  "好端端地": "hǎo,duān,duān,de",
  "好笑地": "hǎo,xiào,de",
  "好累": "hǎo,lèi",
  "好翫": "hǎo,wàn",
  "好胜": "hào,shèng",
  "好胜地": "hào,shèng,de",
  "好自为之": "hào,zì,wéi,zhī",
  "好色": "hào,sè",
  "好色之徒": "hào,sè,zhī,tú",
  "好色地": "hào,sè,de",
  "好行小惠": "hào,xíng,xiǎo,huì",
  "好评地": "hǎo,píng,de",
  "好读书": "hào,dú,shū",
  "好谋善断": "hào,móu,shàn,duàn",
  "好起来": "hǎo,qǐ,lai",
  "好还": "hǎo,huán",
  "好逸恶劳": "hào,yì,wù,láo",
  "好酒贪杯": "hào,jiǔ,tān,bēi",
  "好问决疑": "hào,wèn,jué,yí",
  "好问则裕": "hào,wèn,zé,yù",
  "好问地": "hǎo,wèn,de",
  "好闲": "hào,xián",
  "好音": "hào,yīn",
  "好骑者堕": "hào,qí,zhě,duò",
  "好高": "hào,gāo",
  "好高务远": "hào,gāo,wù,yuǎn",
  "好高骛远": "hào,gāo,wù,yuǎn",
  "如何很好地": "rú,hé,hěn,hǎo,de",
  "如何更好地": "rú,hé,gèng,hǎo,de",
  "如何有效地": "rú,hé,yǒu,xiào,de",
  "如其所好": "rú,qí,suǒ,hào",
  "如刺地": "rú,cì,de",
  "如台": "rú,yí",
  "如夫人": "rú,fū,ren",
  "如屠夫地": "rú,tú,fū,de",
  "如履薄冰": "rú,lǚ,bó,bīng",
  "如常地": "rú,cháng,de",
  "如干": "rú,gàn",
  "如应斯响": "rú,yìng,sī,xiǎng",
  "如意地": "rú,yì,de",
  "如扇形地": "rú,shàn,xíng,de",
  "如数": "rú,shù",
  "如期地": "rú,qī,de",
  "如果一味地": "rú,guǒ,yī,wèi,de",
  "如果慢慢地": "rú,guǒ,màn,màn,de",
  "如果能不断地": "rú,guǒ,néng,bù,duàn,de",
  "如梦地": "rú,mèng,de",
  "如水赴壑": "rú,shǔ,fù,hè",
  "如法炮制": "rú,fǎ,páo,zhì",
  "如泡地": "rú,pào,de",
  "如火地": "rú,huǒ,de",
  "如狼如虎": "rú,láng,sì,hǔ",
  "如登春台": "rú,dé,chūn,tái",
  "如芒刺背": "rú,máng,cì,bèi",
  "如芒在背": "rú,máng,zài,bèi",
  "如解倒悬": "rú,jiě,dào,xuán",
  "如闻其声": "rú,wéi,qí,shēng",
  "如雷般地": "rú,léi,bān,de",
  "如饥似渴地": "rú,jī,sì,kě,de",
  "妃子笑": "fēi,zi,xiào",
  "妄为": "wàng,wéi",
  "妄予": "wàng,yǔ",
  "妄想地": "wàng,xiǎng,de",
  "妄折": "wàng,shé",
  "妄自菲薄": "wàng,zì,fěi,bó",
  "妆啉妆呆": "zhuāng,lín,zhuāng,dāi",
  "妆掠": "zhuāng,lüě",
  "妆晃": "zhuāng,huàng",
  "妈了个巴子": "mā,le,ge,bā,zi",
  "妈咪": "mā,mi",
  "妈妈": "mā,ma",
  "妈妈子": "mā,ma,zǐ",
  "妈妈桑": "mā,ma,sāng",
  "妈妈论儿": "mā,ma,lùn,ér",
  "妈拉个巴子": "mā,lā,ge,bā,zi",
  "妒忌地": "dù,jì,de",
  "妖么": "yāo,mǒ",
  "妖娆地": "yāo,ráo,de",
  "妖由人兴": "yāo,yóu,rén,xīng",
  "妖精": "yāo,jing",
  "妖艳地": "yāo,yàn,de",
  "妖调": "yāo,diào",
  "妗子": "jìn,zi",
  "妙弹": "miào,dàn",
  "妙着": "miào,zhāo",
  "妙适": "miào,shì",
  "妙龄女子": "miào,líng,nǚ,zi",
  "妞儿": "niū,er",
  "妞妞": "niū,niu",
  "妞子": "niū,zi",
  "妥善地": "tuǒ,shàn,de",
  "妥帖": "tuǒ,tiē",
  "妥干": "tuǒ,gàn",
  "妥当": "tuǒ,dàng",
  "妥当地": "tuǒ,dàng,de",
  "妥适": "tuǒ,shì",
  "妥首帖耳": "tuǒ,shǒu,tiē,ěr",
  "妪姁": "yù,xū",
  "妮子": "nī,zi",
  "妹妹": "mèi,mei",
  "妹妹头": "mèi,mei,tóu",
  "妹子": "mèi,zi",
  "妻娶": "qì,qǔ",
  "妻子似地": "qī,zǐ,shì,de",
  "妻子般地": "qī,zǐ,bān,de",
  "妻帑": "qī,tǎng",
  "妻略": "qì,lüè",
  "姁偷": "xū,tōu",
  "姁妪": "xū,yù",
  "姁姁": "xū,xū",
  "姁媮": "xū,yú",
  "始兴": "shǐ,xīng",
  "始兴县": "shǐ,xīng,xiàn",
  "始冠": "shǐ,guān",
  "姐儿们": "jiě,ér,men",
  "姐妹般地": "jiě,mèi,bān,de",
  "姐姐": "jiě,jie",
  "姑奶奶": "gū,nǎi,nai",
  "姑姑": "gū,gu",
  "姑姥姥": "gū,lǎo,lao",
  "姑娘": "gū,niang",
  "姑子": "gū,zi",
  "姑射神人": "gū,yè,shén,rén",
  "姑爷": "gū,ye",
  "姑爷爷": "gū,yé,ye",
  "姓仇": "xìng,qiú",
  "姓任": "xìng,rén",
  "姓蒋还是姓汪": "xìng,jiǎng,hái,shi,xìng,wāng",
  "姓解": "xìng,xiè",
  "委之于地": "wěi,zhī,yú,de",
  "委予": "wěi,yǔ",
  "委任统治地": "wěi,rèn,tǒng,zhì,de",
  "委体于地": "wěi,tǐ,yú,de",
  "委佗": "wěi,yí",
  "委员长": "wěi,yuán,zhǎng",
  "委咽": "wěi,yān",
  "委委佗佗": "wēi,wēi,tuó,tuó",
  "委委蛇蛇": "wěi,wēi,yí,shé",
  "委婉地": "wěi,wǎn,de",
  "委婉地说": "wěi,wǎn,de,shuō",
  "委屈地": "wěi,qū,de",
  "委屈地哭": "wěi,qū,de,kū",
  "委屈地哭了": "wěi,qū,de,kū,le",
  "委屈地望着": "wěi,qū,de,wàng,zhe",
  "委屈地看着": "wěi,qū,de,kàn,zhe",
  "委屈地说": "wěi,qū,de,shuō",
  "委折": "wěi,shé",
  "委曲": "wěi,qū",
  "委曲地说": "wěi,qū,de,shuō",
  "委曲求全": "wěi,qū,qiú,quán",
  "委肉虎蹊": "wěi,ròu,hǔ,xī",
  "委舍": "wěi,shè",
  "委蛇": "wēi,yí",
  "委靡": "wěi,mǐ",
  "委靡不振": "wěi,mǐ,bù,zhèn",
  "姘头": "pīn,tou",
  "姣㛤": "jiāo,lí",
  "姥爷": "lǎo,ye",
  "姨太太": "yí,tài,tai",
  "姨奶奶": "yí,nǎi,nai",
  "姨孃": "yí,ráng",
  "姨甥男女": "yí,sheng,nán,nǚ",
  "姫路市": "jī,lù,shì",
  "姬仆": "jī,pú",
  "姿意妄为": "zī,yì,wàng,wéi",
  "姿调": "zī,diào",
  "威严地": "wēi,yán,de",
  "威吓": "wēi,hè",
  "威慑力量": "wēi,shè,lì,liang",
  "威折": "wēi,shé",
  "威挟": "wēi,jiā",
  "威望素着": "wēi,wàng,sù,zhù",
  "威禁": "wēi,jìn",
  "威翟": "wēi,zhái",
  "威胁性地": "wēi,xié,xìng,de",
  "威风地": "wēi,fēng,de",
  "娃娃": "wá,wa",
  "娃娃兵": "wá,wa,bīng",
  "娃娃气": "wá,wa,qì",
  "娃娃生": "wá,wa,shēng",
  "娃娃脸": "wá,wa,liǎn",
  "娃娃菜": "wá,wa,cài",
  "娃娃装": "wá,wa,zhuāng",
  "娃娃车": "wá,wa,chē",
  "娃娃音": "wá,wa,yīn",
  "娃娃鱼": "wá,wa,yú",
  "娃子": "wá,zi",
  "娄子": "lóu,zi",
  "娄宿": "lóu,xiù",
  "娅嬛": "yā,huán",
  "娇媚地": "jiāo,mèi,de",
  "娇媠": "jiāo,duò",
  "娇嫩": "jiāo,nen",
  "娇嫩地": "jiāo,nèn,de",
  "娇宠地": "jiāo,chǒng,de",
  "娇弱地": "jiāo,ruò,de",
  "娇滴滴地": "jiāo,dī,dī,de",
  "娇的的": "jiāo,de,dí",
  "娇𫘤": "jiāo,ái",
  "娉婷婀娜": "pīng,tíng,ē,nà",
  "娘们": "niáng,men",
  "娘们儿": "niáng,men,er",
  "娘儿们": "niáng,er,men",
  "娘娘": "niáng,niang",
  "娘娘腔": "niáng,niang,qiāng",
  "娘子": "niáng,zi",
  "娘家姓": "niáng,jia,xìng",
  "娘老子": "niáng,lǎo,zi",
  "娜塔莉": "nà,tǎ,lì",
  "娜娜": "nà,nà",
  "娜婀": "nà,ē",
  "娜袅": "nà,niǎo",
  "娟嬛": "juān,qióng",
  "娭姐": "āi,jiě",
  "娭毑": "āi,jiě",
  "娱乐地": "yú,lè,de",
  "娱戏": "yú,hū",
  "娱翫": "yú,wàn",
  "娱适": "yú,shì",
  "娴适": "xián,shì",
  "娶媳妇儿": "qǔ,xí,fù,er",
  "婆侯伎": "pó,hòu,jì",
  "婆子": "pó,zi",
  "婆家": "pó,jia",
  "婉娜": "wǎn,nà",
  "婉娩": "wǎn,wǎn",
  "婉折": "wǎn,shé",
  "婉曲": "wǎn,qū",
  "婉曲地": "wǎn,qū,de",
  "婉转地": "wǎn,zhuǎn,de",
  "婉转地说": "wǎn,zhuǎn,de,shuō",
  "婊子": "biǎo,zi",
  "婑娜": "wǒ,nà",
  "婑媠": "wǒ,duò",
  "婑嫷": "wǒ,duò",
  "婘婘": "quán,quán",
  "婘属": "quán,shǔ",
  "婘恋": "quán,liàn",
  "婚丧喜庆": "hūn,sāng,xǐ,qìng",
  "婚假": "hūn,jià",
  "婚冠": "hūn,guān",
  "婚前性行为": "hūn,qián,xìng,xíng,wéi",
  "婚姻地": "hūn,yīn,de",
  "婚帖": "hūn,tiē",
  "婢仆": "bì,pú",
  "婢奴似地": "bì,nú,shì,de",
  "婥婥": "nào,nào",
  "婥约": "nào,yuē",
  "婩斫": "yàn,zhuó",
  "婴儿子": "yīng,ér,zi",
  "婴累": "yīng,lèi",
  "婵媛": "chán,yuán",
  "婶儿": "shěn,er",
  "婶婶": "shěn,shen",
  "婶子": "shěn,zi",
  "媒人": "méi,ren",
  "媒妈妈": "méi,mā,ma",
  "媒染剂地": "méi,rǎn,jì,de",
  "媒染性地": "méi,rǎn,xìng,de",
  "媠媠": "duò,duò",
  "媠岀": "duò,chū",
  "媠服": "duò,fú",
  "媠谩": "duò,màn",
  "媥姺": "piān,xiān",
  "媮乐": "yú,lè",
  "媮冒": "yú,mào",
  "媮窳": "yú,yǔ",
  "媮靡": "yú,mí",
  "媳妇儿": "xí,fù,er",
  "媳妇熬成婆": "xí,fù,áo,chéng,pó",
  "嫁妆": "jià,zhuang",
  "嫁衣裳": "jià,yī,shang",
  "嫁装": "jià,zhuang",
  "嫂嫂": "sǎo,sao",
  "嫂子": "sǎo,zi",
  "嫇奵": "míng,dīng",
  "嫉妒地": "jí,dù,de",
  "嫌恶": "xián,wù",
  "嫌恶地": "xián,wù,de",
  "嫌郄": "xián,xì",
  "嫏嬛洞": "láng,qióng,dòng",
  "嫚儿": "mān,ér",
  "嫚子": "mān,zi",
  "嫡子": "dí,zi",
  "嫡长子": "dí,zhǎng,zǐ",
  "嫣然一笑": "yān,rán,yí,xiào",
  "嬉戏地": "xī,xì,de",
  "嬉闹地": "xī,nào,de",
  "嬖大夫": "bì,dài,fū",
  "嬗更": "shàn,gēng",
  "嬛佞": "qióng,nìng",
  "嬛好": "qióng,hǎo",
  "嬛嬛": "xuān,xuān",
  "嬛緜": "qióng,mián",
  "嬛绵": "qióng,mián",
  "嬛薄": "qióng,báo",
  "嬴得": "yíng,de",
  "嬷嬷": "mó,mo",
  "孅人": "qiān,rén",
  "孅介": "qiān,jiè",
  "孅儿": "qiān,ér",
  "孅啬": "qiān,sè",
  "孅孅": "qiān,qiān",
  "孅弱": "qiān,ruò",
  "孅犁": "qiān,lí",
  "孅趋": "qiān,qū",
  "孅趍": "qiān,qū",
  "孅阿": "qiān,ā",
  "㛤姬": "lí,jī",
  "㛤戎": "lí,róng",
  "子为父隐": "zǐ,wéi,fù,yǐn",
  "子么": "zǐ,mǒ",
  "子儿": "zǐ,er",
  "子卷": "zǐ,juàn",
  "子堤": "zǐ,dī",
  "子大夫": "zǐ,dài,fū",
  "子女似地": "zǐ,nǚ,shì,de",
  "子孙娘娘": "zǐ,sūn,niáng,niang",
  "子孙饺子": "zǐ,sūn,jiǎo,zi",
  "子弹": "zǐ,dàn",
  "子弹火车": "zǐ,dàn,huǒ,chē",
  "子曰诗云": "zǐ,yuè,shī,yún",
  "子母弹": "zǐ,mǔ,dàn",
  "子母炮弹": "zǐ,mǔ,pào,dàn",
  "子母炸弹": "zǐ,mǔ,zhà,dàn",
  "子牟": "zǐ,mù",
  "子舍": "zǐ,shè",
  "孑孑为义": "jié,jié,wéi,yì",
  "孔席不适": "kǒng,xí,bù,shì",
  "孔曾": "kǒng,zēng",
  "孕吐": "yùn,tù",
  "孖仔": "mā,zǎi",
  "孖毡": "mā,zhān",
  "孖生": "mā,shēng",
  "孖舲艇": "mā,líng,tǐng",
  "字帖": "zì,tiè",
  "字形地": "zì,xíng,de",
  "字数": "zì,shù",
  "字模": "zì,mú",
  "字母地": "zì,mǔ,de",
  "字眼儿": "zì,yǎn,er",
  "字纸篓子": "zì,zhǐ,lǒu,zi",
  "字节数": "zì,jié,shù",
  "字调": "zì,diào",
  "字迹清楚地": "zì,jì,qīng,chǔ,de",
  "字里行间": "zì,lǐ,háng,jiān",
  "字面地": "zì,miàn,de",
  "存心地": "cún,xīn,de",
  "孙女儿": "sūn,nǚ,er",
  "孙子": "sūn,zi",
  "孙子定理": "sūn,zi,dìng,lǐ",
  "孙少奶奶": "sūn,shào,nǎi,nai",
  "孙少爷": "sūn,shào,yé",
  "孙曾": "sūn,zēng",
  "孙猴子": "sūn,hóu,zi",
  "孚甲": "fú,jiá",
  "孛娄": "bó,lóu",
  "孛孛": "bó,bó",
  "孛孛丁": "bó,bó,dīng",
  "孛彗": "bó,huì",
  "孛戾": "bó,lì",
  "孛散": "bó,sàn",
  "孛沴": "bó,lì",
  "孛相": "bó,xiāng",
  "孛篮": "bó,lán",
  "孛罗": "bó,luó",
  "孛老": "bó,lǎo",
  "孛辘": "bó,lù",
  "孝衣裳": "xiào,yī,shang",
  "孝道": "xiào,dao",
  "孝顺地": "xiào,shùn,de",
  "孟什维克": "mèng,shí,wéi,kè",
  "孟侯": "mèng,hòu",
  "孟姜女调": "mèng,jiāng,nǚ,diào",
  "孟贲": "mèng,bēn",
  "孢子": "bāo,zi",
  "孢子植物": "bāo,zi,zhí,wù",
  "季兴": "jì,xīng",
  "季度地": "jì,dù,de",
  "季相": "jì,xiàng",
  "季节性地": "jì,jié,xìng,de",
  "孤兴": "gū,xīng",
  "孤刹": "gū,shā",
  "孤削": "gū,xuē",
  "孤单一人": "gū,dān,yì,rén",
  "孤单地": "gū,dān,de",
  "孤山处士": "gū,shān,chǔ,shì",
  "孤帆": "gū,fān",
  "孤干": "gū,gàn",
  "孤文只义": "gū,wén,zhī,yì",
  "孤注一掷": "gū,zhù,yí,zhì",
  "孤注一掷地": "gū,zhù,yí,zhì,de",
  "孤独地": "gū,dú,de",
  "孤独矜寡": "gū,dú,guān,guǎ",
  "孤立地": "gū,lì,de",
  "孤立地看": "gū,lì,de,kàn",
  "孤立地说": "gū,lì,de,shuō",
  "孤累": "gū,lèi",
  "孤絜": "gū,jié",
  "孤背": "gū,bèi",
  "孤身只影": "gū,shēn,zhī,yǐng",
  "孤零零地": "gū,líng,líng,de",
  "孤露": "gū,lù",
  "孥累": "nú,lèi",
  "学堂地": "xué,táng,de",
  "学摸": "xué,mo",
  "学术上地": "xué,shù,shàng,de",
  "学术地": "xué,shù,de",
  "学生": "xué,sheng",
  "学生会": "xué,sheng,huì",
  "学生证": "xué,sheng,zhèng",
  "学生运动": "xué,sheng,yùn,dòng",
  "学究地": "xué,jiū,de",
  "学究气地": "xué,jiū,qì,de",
  "学舍": "xué,shè",
  "学长": "xué,zhǎng",
  "学问上地": "xué,wèn,shàng,de",
  "孩儿": "hái,er",
  "孩儿们": "hái,ér,men",
  "孩子": "hái,zi",
  "孩子们": "hái,zi,men",
  "孩子似地": "hái,zi,shì,de",
  "孩子头": "hái,zi,tóu",
  "孩子头儿": "hái,zi,tóu,er",
  "孩子气": "hái,zi,qì",
  "孩子气地": "hái,zi,qì,de",
  "孩子王": "hái,zi,wáng",
  "孩子话": "hái,zi,huà",
  "孱头": "càn,tou",
  "孳蕃": "zī,fān",
  "孷孖": "lí,mā",
  "宁为玉碎": "nìng,wéi,yù,suì",
  "宁为鸡口": "nìng,wéi,jī,kǒu",
  "宁侯": "níng,hòu",
  "宁可": "nìng,kě",
  "宁可清贫": "nìng,kě,qīng,pín",
  "宁可玉碎": "nìng,kě,yù,suì",
  "宁处": "níng,chǔ",
  "宁左勿右": "nìng,zuǒ,wù,yòu",
  "宁帖": "níng,tiē",
  "宁愿": "nìng,yuàn",
  "宁折不弯": "nìng,zhé,bù,wān",
  "宁曲勿折": "níng,qū,wù,zhé",
  "宁死不屈": "nìng,sǐ,bù,qū",
  "宁缺勿滥": "nìng,quē,wù,làn",
  "宁缺毋滥": "nìng,quē,wú,làn",
  "宁肯": "nìng,kěn",
  "宁都": "níng,dū",
  "宁都县": "níng,dū,xiàn",
  "宁静地": "níng,jìng,de",
  "它们": "tā,men",
  "它它藉藉": "tā,tā,jí,jí",
  "宅子": "zhái,zi",
  "宅度假": "zhái,dù,jià",
  "宅舍": "zhái,shè",
  "宇宙地": "yǔ,zhòu,de",
  "守丧": "shǒu,sāng",
  "守住": "shǒu,zhu",
  "守侯": "shǒu,hòu",
  "守分": "shǒu,fèn",
  "守势地": "shǒu,shì,de",
  "守如处女": "shǒu,rú,chǔ,nǚ",
  "守折": "shǒu,shé",
  "守摊子": "shǒu,tān,zi",
  "守数": "shǒu,shù",
  "守更": "shǒu,gēng",
  "守本分": "shǒu,běn,fèn",
  "守本分地": "shǒu,běn,fèn,de",
  "守朴": "shǒu,piáo",
  "守正不阿": "shǒu,zhèng,bù,ē",
  "守法地": "shǒu,fǎ,de",
  "守禁": "shǒu,jìn",
  "守舍": "shǒu,shè",
  "守蕃": "shǒu,fān",
  "守藏": "shǒu,zàng",
  "守规矩": "shǒu,guī,ju",
  "守适": "shǒu,shì",
  "守阙抱残": "shǒu,què,bào,cán",
  "守陴": "shǒu,pí",
  "守鼜": "shǒu,qì",
  "安乐地": "ān,lè,de",
  "安于一隅": "ān,yù,yī,yù",
  "安份地": "ān,fèn,de",
  "安全玻璃": "ān,quán,bō,li",
  "安全系数": "ān,quán,xì,shù",
  "安分": "ān,fèn",
  "安分守己": "ān,fèn,shǒu,jǐ",
  "安分守已": "ān,fěn,shǒu,jǐ",
  "安分守纪": "ān,fèn,shǒu,jì",
  "安分知足": "ān,fèn,zhī,zú",
  "安厘王": "ān,xī,wáng",
  "安处": "ān,chǔ",
  "安处先生": "ān,chǔ,xiān,shēng",
  "安娜": "ān,nà",
  "安宁地": "ān,níng,de",
  "安守本分": "ān,shǒu,běn,fèn",
  "安安静静地": "ān,ān,jìng,jìng,de",
  "安家帖": "ān,jiā,tiē",
  "安宿": "ān,xiù",
  "安帖": "ān,tiē",
  "安常处顺": "ān,cháng,chǔ,shùn",
  "安常守分": "ān,cháng,shǒu,fèn",
  "安干": "ān,gàn",
  "安得虎子": "ān,de,hǔ,zǐ",
  "安心地": "ān,xīn,de",
  "安息地": "ān,xī,de",
  "安慰地": "ān,wèi,de",
  "安扎": "ān,zhā",
  "安时处顺": "ān,shí,chǔ,shùn",
  "安根子": "ān,gēn,zi",
  "安步当车": "ān,bù,dàng,chē",
  "安着": "ān,zhe",
  "安碓硙": "ān,duì,wèi",
  "安祥地": "ān,xiáng,de",
  "安稳地": "ān,wěn,de",
  "安老怀少": "ān,lǎo,huái,shào",
  "安营扎寨": "ān,yíng,zhā,zhài",
  "安葬地": "ān,zàng,de",
  "安西都护府": "ān,xī,dū,hù,fǔ",
  "安详地": "ān,xiáng,de",
  "安身为乐": "ān,shēn,wéi,lè",
  "安适": "ān,shì",
  "安适如常": "ān,shì,rú,cháng",
  "安逸地": "ān,yì,de",
  "安闲地": "ān,xián,de",
  "安闲自在": "ān,xián,zì,zai",
  "安闲舒适": "ān,xián,shū,shì",
  "安阇那": "ān,shé,nà",
  "安难": "ān,nàn",
  "安静地": "ān,jìng,de",
  "安静地听": "ān,jìng,de,tīng",
  "安静地坐着": "ān,jìng,de,zuò,zhe",
  "安静地死去": "ān,jìng,de,sǐ,qù",
  "安静地离开": "ān,jìng,de,lí,kāi",
  "安静地走": "ān,jìng,de,zǒu",
  "安魂弥撒": "ān,hún,mí,sa",
  "宋之的": "sòng,zhī,dì",
  "宋斤鲁削": "sòng,jīn,lǔ,xuē",
  "完全地": "wán,quán,de",
  "完全地破开": "wán,quán,de,pò,kāi",
  "完全懂得": "wán,quán,dǒng,de",
  "完卷": "wán,juàn",
  "完型填空": "wán,xíng,tián,kòng",
  "完好地": "wán,hǎo,de",
  "完形填空": "wán,xíng,tián,kòng",
  "完成地": "wán,chéng,de",
  "完满地结束": "wán,mǎn,de,jié,shù",
  "完满地解决": "wán,mǎn,de,jiě,jué",
  "完絜": "wán,jié",
  "完美地": "wán,měi,de",
  "宏伟地": "hóng,wěi,de",
  "宏焘": "hóng,tāo",
  "宏碁": "hóng,jī",
  "宏碁集团": "hóng,jī,jí,tuán",
  "宏都拉斯": "hóng,dū,lā,sī",
  "宓妃": "fú,fēi",
  "宓子": "fú,zǐ",
  "宓子贱": "fú,zǐ,jiàn",
  "宓羲": "fú,xī",
  "宓羲氏": "fú,xī,shì",
  "宕仆": "dàng,pú",
  "宕跌": "dàng,diē",
  "宗干": "zōng,gàn",
  "宗爷爷": "zōng,yé,ye",
  "宗蕃": "zōng,fān",
  "宗规上地": "zōng,guī,shàng,de",
  "官仓老鼠": "guān,cāng,láo,shǔ",
  "官偪民反": "guān,bèng,mín,fǎn",
  "官僚地": "guān,liáo,de",
  "官兴": "guān,xīng",
  "官卷": "guān,juàn",
  "官司": "guān,si",
  "官官相为": "guān,guān,xiāng,wéi",
  "官差": "guān,chāi",
  "官帑": "guān,tǎng",
  "官帖": "guān,tiē",
  "官房长官": "guān,fáng,zhǎng,guān",
  "官架子": "guān,jià,zi",
  "官法帖": "guān,fǎ,tiè",
  "官着": "guān,zhe",
  "官禁": "guān,jìn",
  "官老爷": "guān,lǎo,ye",
  "官能地": "guān,néng,de",
  "官舍": "guān,shè",
  "官虾蟆": "guān,há,má",
  "官长": "guān,zhǎng",
  "定从": "dìng,zòng",
  "定兴": "dìng,xīng",
  "定兴县": "dìng,xīng,xiàn",
  "定分": "dìng,fèn",
  "定名为": "dìng,míng,wéi",
  "定处": "dìng,chǔ",
  "定定地": "deng,deng,de",
  "定定地望向": "deng,deng,de,wàng,xiàng",
  "定帖": "dìng,tiē",
  "定当": "dìng,dàng",
  "定性地": "deng,xìng,de",
  "定数": "dìng,shù",
  "定时地": "deng,shí,de",
  "定时性地": "deng,shí,xìng,de",
  "定时炸弹": "dìng,shí,zhà,dàn",
  "定更": "dìng,gēng",
  "定期地": "deng,qī,de",
  "定点数": "dìng,diǎn,shù",
  "定省": "dìng,xǐng",
  "定省凊温": "dìng,xǐng,qìng,wēn",
  "定着": "dìng,zhe",
  "定罪地": "deng,zuì,de",
  "定舍": "dìng,shè",
  "定调": "dìng,diào",
  "定调子": "dìng,diào,zi",
  "定远侯": "dìng,yuǎn,hòu",
  "定都": "dìng,dū",
  "定钱": "dìng,qian",
  "宛折": "wǎn,shé",
  "宛蟺": "wǎn,dàn",
  "宜兴": "yí,xīng",
  "宜兴壶": "yí,xīng,hú",
  "宜兴市": "yí,xīng,shì",
  "宜适": "yí,shì",
  "宜都": "yí,dū",
  "宜都市": "yí,dū,shì",
  "宝兴": "bǎo,xīng",
  "宝兴县": "bǎo,xīng,xiàn",
  "宝兴歌鸫": "bǎo,xīng,gē,dōng",
  "宝冠": "bǎo,guān",
  "宝卷": "bǎo,juàn",
  "宝头儿": "bǎo,tou,er",
  "宝幢": "bǎo,zhuàng",
  "宝应": "bǎo,yìng",
  "宝应县": "bǎo,yìng,xiàn",
  "宝盖儿": "bǎo,gài,er",
  "宝翫": "bǎo,wàn",
  "宝葫芦": "bǎo,hú,lu",
  "宝葫芦的秘密": "bǎo,hú,lu,de,mì,mì",
  "宝藏": "bǎo,zàng",
  "宝贝儿": "bǎo,bèi,er",
  "宝贝疙瘩": "bǎo,bèi,gē,dā",
  "宝钻": "bǎo,zuàn",
  "宝露": "bǎo,lù",
  "实与有力": "shí,yù,yǒu,lì",
  "实习地": "shí,xí,de",
  "实习生": "shí,xí,sheng",
  "实事求是地": "shí,shì,qiú,shì,de",
  "实事求是地讲": "shí,shì,qiú,shì,de,jiǎng",
  "实偪处此": "shí,bī,chǔ,cǐ",
  "实况地": "shí,kuàng,de",
  "实受资本": "shí,shou,zī,běn",
  "实变函数": "shí,biàn,hán,shù",
  "实变函数论": "shí,biàn,hán,shù,lùn",
  "实实地": "shí,shí,de",
  "实干": "shí,gàn",
  "实干家": "shí,gàn,jiā",
  "实弹": "shí,dàn",
  "实打实地": "shí,dǎ,shí,de",
  "实打实着": "shí,dǎ,shí,zhe",
  "实数": "shí,shù",
  "实数值": "shí,shù,zhí",
  "实数集": "shí,shù,jí",
  "实相": "shí,xiàng",
  "实着": "shí,zhe",
  "实蕃有徒": "shí,fān,yǒu,tú",
  "实质性地": "shí,zhì,xìng,de",
  "实逼处此": "shí,bī,chǔ,cǐ",
  "实际参数": "shí,jì,cān,shù",
  "实际地": "shí,jì,de",
  "实际应用": "shí,jì,yìng,yòng",
  "实验式地": "shí,yàn,shì,de",
  "实验性地": "shí,yàn,xìng,de",
  "宠数": "chǒng,shù",
  "宠𰷠": "chǒng,yí",
  "宠贲": "chǒng,bēn",
  "审判上地": "shěn,pàn,shàng,de",
  "审判长": "shěn,pàn,zhǎng",
  "审处": "shěn,chǔ",
  "审己度人": "shěn,jǐ,duó,rén",
  "审干": "shěn,gàn",
  "审度": "shěn,duó",
  "审度时势": "shěn,duó,shí,shì",
  "审慎地": "shěn,shèn,de",
  "审数": "shěn,shù",
  "审时度势": "shěn,shí,duó,shì",
  "审曲面埶": "shěn,qǔ,miàn,shì",
  "审校": "shěn,jiào",
  "审美上地": "shěn,měi,shàng,de",
  "审美地": "shěn,měi,de",
  "审计长": "shěn,jì,zhǎng",
  "客兴": "kè,xīng",
  "客处": "kè,chǔ",
  "客帆": "kè,fān",
  "客户应用": "kè,hù,yìng,yòng",
  "客气": "kè,qi",
  "客气地": "kè,qì,de",
  "客气地说": "kè,qì,de,shuō",
  "客气话": "kè,qi,huà",
  "客舍": "kè,shè",
  "客观地": "kè,guān,de",
  "客观地反映出": "kè,guān,de,fǎn,yìng,chū",
  "客观地看": "kè,guān,de,kàn",
  "客观地讲": "kè,guān,de,jiǎng",
  "客观地说": "kè,guān,de,shuō",
  "宣传弹": "xuān,chuán,dàn",
  "宣𠡠": "xuān,lài",
  "宣卷": "xuān,juàn",
  "宣帖": "xuān,tiē",
  "宣干": "xuān,gàn",
  "宣着": "xuān,zhe",
  "宣调": "xuān,diào",
  "宣赞舍人": "xuān,zàn,shè,rén",
  "宣露": "xuān,lù",
  "室内乐": "shì,nèi,yuè",
  "室处": "shì,chǔ",
  "室舍": "shì,shè",
  "室隩": "shì,yù",
  "宪禁": "xiàn,jìn",
  "宫商角徵羽": "gōng,shāng,jué,zhǐ,yǔ",
  "宫宷": "gōng,cài",
  "宫庭音乐": "gōng,tíng,yīn,yuè",
  "宫槛": "gōng,kǎn",
  "宫禁": "gōng,jìn",
  "宫舍": "gōng,shè",
  "宫观": "gōng,guàn",
  "宫调": "gōng,diào",
  "宫阙": "gōng,què",
  "宰予昼寝": "zǎi,yǔ,zhòu,qǐn",
  "宰父": "zǎi,fǔ",
  "宰相": "zǎi,xiàng",
  "宰相器": "zǎi,xiàng,qì",
  "宰相肚里好撑船": "zǎi,xiàng,dù,lǐ,hǎo,chēng,chuán",
  "害孩子": "hài,hái,zi",
  "害得": "hài,de",
  "害月子": "hài,yuè,zi",
  "害累": "hài,lèi",
  "害羞地": "hài,xiū,de",
  "害肚子": "hài,dù,zi",
  "害臊": "hài,sào",
  "宴处": "yàn,chǔ",
  "宴适": "yàn,shì",
  "宴镐": "yàn,hào",
  "宵兴": "xiāo,xīng",
  "宵禁": "xiāo,jìn",
  "宵载": "xiāo,zǎi",
  "家乘": "jiā,shèng",
  "家什": "jiā,shí",
  "家仆": "jiā,pú",
  "家伙": "jiā,huo",
  "家伙座儿": "jiā,huo,zuò,ér",
  "家伙点": "jiā,huo,diǎn",
  "家削": "jiā,xuē",
  "家和万事兴": "jiā,hé,wàn,shì,xīng",
  "家处": "jiā,chǔ",
  "家头房子": "jiā,tóu,fáng,zi",
  "家子": "jiā,zi",
  "家将": "jiā,jiàng",
  "家常豆腐": "jiā,cháng,dòu,fu",
  "家底儿": "jiā,dǐ,er",
  "家庭式地": "jiā,tíng,shì,de",
  "家当": "jiā,dàng",
  "家把什": "jiā,bǎ,shí",
  "家数": "jiā,shù",
  "家无儋石": "jiā,wú,dàn,shí",
  "家无担石": "jiā,wú,dàn,shí",
  "家生孩子": "jiā,shēng,hái,zi",
  "家生肖": "jiā,shēng,xiào",
  "家种": "jiā,zhòng",
  "家系地": "jiā,xì,de",
  "家累": "jiā,lěi",
  "家累千金": "jiā,lèi,qiān,jīn",
  "家给": "jiā,jǐ",
  "家给人足": "jiā,jǐ,rén,zú",
  "家给户足": "jiā,jǐ,hù,zú",
  "家给民足": "jiā,jǐ,mín,zú",
  "家舍": "jiā,shè",
  "家衍人给": "jiā,yǎn,rén,jǐ",
  "家衖": "jiā,lòng",
  "家长": "jiā,zhǎng",
  "家长会": "jiā,zhǎng,huì",
  "家长作风": "jiā,zhǎng,zuò,fēng",
  "家长制": "jiā,zhǎng,zhì",
  "家长学校": "jiā,zhǎng,xué,xiào",
  "家雀": "jiā,qiǎo",
  "家雀儿": "jiā,qiǎo,ér",
  "容不得": "róng,bu,dé",
  "容城侯": "róng,chéng,hòu",
  "容易地": "róng,yì,de",
  "容易错地": "róng,yì,cuò,de",
  "容纳地": "róng,nà,de",
  "容翟": "róng,zhái",
  "容臭": "róng,xiù",
  "容舍": "róng,shè",
  "容芘": "róng,pí",
  "容载": "róng,zǎi",
  "宽厚地": "kuān,hòu,de",
  "宽大为怀": "kuān,dà,wéi,huái",
  "宽大地": "kuān,dà,de",
  "宽宏地": "kuān,hóng,de",
  "宽广地": "kuān,guǎng,de",
  "宽心丸儿": "kuān,xīn,wán,er",
  "宽恕地": "kuān,shù,de",
  "宽敞": "kuān,chang",
  "宽敞地": "kuān,chǎng,de",
  "宽朴": "kuān,piáo",
  "宽松地": "kuān,sōng,de",
  "宽舍": "kuān,shè",
  "宽裕地": "kuān,yù,de",
  "宽褪": "kuān,tùn",
  "宽适": "kuān,shì",
  "宽阔地": "kuān,kuò,de",
  "宾仆": "bīn,pú",
  "宾兴": "bīn,xīng",
  "宾烕": "bīn,xuè",
  "宾牟": "bīn,mù",
  "宿分": "sù,fèn",
  "宿命地": "sù,mìng,de",
  "宿命论地": "sù,mìng,lùn,de",
  "宿将": "sù,jiàng",
  "宿水飡风": "xiǔ,shuǐ,cān,fēng",
  "宿水餐风": "xiǔ,shuǐ,cān,fēng",
  "宿着": "sù,zhe",
  "宿舍": "sù,shè",
  "宿舍楼": "sù,shè,lóu",
  "宿雨餐风": "xiǔ,yǔ,cān,fēng",
  "宿露": "sù,lù",
  "寂处": "jì,chǔ",
  "寂寞地": "jì,mò,de",
  "寂静地": "jì,jìng,de",
  "寄予": "jì,yǔ",
  "寄予厚望": "jì,yǔ,hòu,wàng",
  "寄传": "jì,zhuàn",
  "寄兴": "jì,xīng",
  "寄处": "jì,chǔ",
  "寄宿舍": "jì,sù,shè",
  "寄帑": "jì,tǎng",
  "寄应": "jì,yìng",
  "寄禁": "jì,jìn",
  "寄调": "jì,diào",
  "寄载": "jì,zǎi",
  "寄适": "jì,shì",
  "寄附铺": "jì,fù,pù",
  "密伺": "mì,sì",
  "密切": "mì,qiè",
  "密切地": "mì,qiè,de",
  "密切地联系": "mì,qiè,de,lián,xì",
  "密切接触者": "mì,qiè,jiē,chù,zhě",
  "密切注意": "mì,qiè,zhù,yì",
  "密切注视": "mì,qiè,zhù,shì",
  "密切相关": "mì,qiè,xiāng,guān",
  "密切相连": "mì,qiè,xiāng,lián",
  "密发": "mì,fà",
  "密司忒": "mì,sī,tuī",
  "密处": "mì,chǔ",
  "密密匝匝": "mì,mi,zā,zā",
  "密密地": "mì,mì,de",
  "密密实实": "mì,mi,shí,shi",
  "密密层层": "mì,mi,céng,céng",
  "密密扎扎": "mì,mì,zhā,zhā",
  "密密麻麻": "mì,mi,má,má",
  "密封地": "mì,fēng,de",
  "密折": "mì,shé",
  "密查": "mì,zhā",
  "密码地": "mì,mǎ,de",
  "密码子": "mì,mǎ,zi",
  "密筩": "mì,yǒng",
  "密箐": "mì,jīng",
  "密集地": "mì,jí,de",
  "密靓": "mì,liàng",
  "寇剽": "kòu,piāo",
  "寇掠": "kòu,lüě",
  "富人侯": "fù,rén,hòu",
  "富人情地": "fù,rén,qíng,de",
  "富余": "fù,yu",
  "富国彊兵": "fù,guó,jiāng,bīng",
  "富平侯": "fù,píng,hòu",
  "富得流油": "fù,de,liú,yóu",
  "富态": "fù,tai",
  "富情感地": "fù,qíng,gǎn,de",
  "富感情地": "fù,gǎn,qíng,de",
  "富民侯": "fù,mín,hòu",
  "富蕃": "fù,fān",
  "富集地": "fù,jí,de",
  "寎月": "bìng,yuè",
  "寒伧": "hán,chen",
  "寒假": "hán,jià",
  "寒冷地": "hán,lěng,de",
  "寒𪧘": "hán,lóu",
  "寒暑假": "hán,shǔ,jià",
  "寒更": "hán,gēng",
  "寒栗子": "hán,lì,zi",
  "寒禁": "hán,jìn",
  "寒耕暑耘": "hán,gēng,shǔ,yùn",
  "寒耕热耘": "hán,gēng,rè,yùn",
  "寒舍": "hán,shè",
  "寒蝉凄切": "hán,chán,qī,qiè",
  "寒酸地": "hán,suān,de",
  "寒酸相": "hán,suān,xiàng",
  "寒附火者": "han,fu,huo,zhe",
  "寒露": "hán,lù",
  "寒颤": "hán,zhàn",
  "寒颤颤": "hán,zhàn,chàn",
  "寓兴": "yù,xīng",
  "寓舍": "yù,shè",
  "寓言地": "yù,yán,de",
  "寖久": "jìn,jiǔ",
  "寖乖": "jìn,guāi",
  "寖信": "jìn,xìn",
  "寖假": "jìn,jiǎ",
  "寖兴": "jìn,xīng",
  "寖剧": "jìn,jù",
  "寖坏": "jìn,huài",
  "寖多": "jìn,duō",
  "寖大": "jìn,dà",
  "寖失": "jìn,shī",
  "寖安": "jìn,ān",
  "寖密": "jìn,mì",
  "寖寖": "jìn,jìn",
  "寖寻": "jìn,xún",
  "寖少": "jìn,shǎo",
  "寖广": "jìn,guǎng",
  "寖废": "jìn,fèi",
  "寖弛": "jìn,chí",
  "寖弱": "jìn,ruò",
  "寖强": "jìn,qiáng",
  "寖微": "jìn,wēi",
  "寖怠": "jìn,dài",
  "寖急": "jìn,jí",
  "寖息": "jìn,xī",
  "寖恶": "jìn,è",
  "寖成": "jìn,chéng",
  "寖昌": "jìn,chāng",
  "寖昌寖炽": "jìn,chāng,jìn,chì",
  "寖染": "jìn,rǎn",
  "寖洳": "jìn,rù",
  "寖润": "jìn,rùn",
  "寖淫": "jìn,yín",
  "寖深": "jìn,shēn",
  "寖滥": "jìn,làn",
  "寖疎": "jìn,shū",
  "寖益": "jìn,yì",
  "寖盛": "jìn,shèng",
  "寖着": "jìn,zhe",
  "寖耗": "jìn,hào",
  "寖薄": "jìn,báo",
  "寖衰": "jìn,shuāi",
  "寖辟": "jìn,pì",
  "寖近": "jìn,jìn",
  "寖远": "jìn,yuǎn",
  "寖迷": "jìn,mí",
  "寖闻": "jìn,wén",
  "寖陋": "jìn,lòu",
  "寖露": "jìn,lù",
  "寖顿": "jìn,dùn",
  "寖骄": "jìn,jiāo",
  "寖高": "jìn,gāo",
  "寝侻": "qǐn,tuì",
  "寝兴": "qǐn,xīng",
  "寝处": "qǐn,chǔ",
  "寝苫枕干": "qǐn,shān,zhěn,gàn",
  "察伺": "chá,sì",
  "察只": "chá,zhī",
  "察合台": "chá,gě,tái",
  "察察为明": "chá,chá,wéi,míng",
  "察尔汗盐湖": "chá,ěr,hán,yán,hú",
  "𪧘乏": "lóu,fá",
  "𪧘人": "lóu,rén",
  "𪧘儒": "lóu,rú",
  "𪧘夫": "lóu,fū",
  "𪧘数": "lóu,shù",
  "𪧘薮": "lóu,sǒu",
  "寡为": "guǎ,wéi",
  "寡嗛": "guǎ,qiàn",
  "寡处": "guǎ,chǔ",
  "寡大夫": "guǎ,dài,fū",
  "寡头地": "guǎ,tóu,de",
  "寡妇": "guǎ,fu",
  "寡妇莎": "guǎ,fù,shā",
  "寡廉鲜耻": "guǎ,lián,xiǎn,chǐ",
  "寡弹": "guǎ,dàn",
  "寡薄": "guǎ,bó",
  "寡见鲜闻": "guǎ,jiàn,xiǎn,wén",
  "寡言地": "guǎ,yán,de",
  "寡𬮴": "guǎ,ān",
  "寥夐": "liáo,xuàn",
  "寥寥数语": "liáo,liáo,shù,yǔ",
  "寥翘": "liáo,qiào",
  "寨堡": "zhài,pù",
  "寨子": "zhài,zi",
  "寮舍": "liáo,shè",
  "寰埏": "huán,shān",
  "寸劲儿": "cùn,jìn,er",
  "寸折": "cùn,shé",
  "寸积铢累": "cùn,jī,zhū,lěi",
  "寸蹏尺缣": "cùn,dì,chǐ,jiān",
  "寸量铢称": "cùn,liáng,zhū,chēng",
  "寸铁在手": "cùn,tiě,zāi,shǒu",
  "对不住": "duì,bú,zhù",
  "对事不对人": "duì,shì,bú,duì,rén",
  "对付": "duì,fu",
  "对偶地": "duì,ǒu,de",
  "对劲儿": "duì,jìn,er",
  "对口地": "duì,kǒu,de",
  "对口相声": "duì,kǒu,xiàng,shēng",
  "对味儿": "duì,wèi,er",
  "对外间接投资": "duì,wài,jiàn,jiē,tóu,zī",
  "对工儿": "duì,gōng,er",
  "对应": "duì,yìng",
  "对得住": "duì,de,zhù",
  "对得数": "duì,dé,shù",
  "对得起": "duì,de,qǐ",
  "对心儿": "duì,xīn,er",
  "对撇子": "duì,piě,zǐ",
  "对数": "duì,shù",
  "对数函数": "duì,shù,hán,shù",
  "对槛儿": "duì,kǎn,ér",
  "对比地": "duì,bǐ,de",
  "对比效应": "duì,bǐ,xiào,yìng",
  "对着和尚骂贼秃": "duì,zhe,hé,shang,mà,zéi,tū",
  "对着干": "duì,zhe,gàn",
  "对禁": "duì,jìn",
  "对称": "duì,chèn",
  "对称与非对称": "duì,chèn,yǔ,fēi,duì,chèn",
  "对称地": "duì,chèn,de",
  "对称多项式": "duì,chèn,duō,xiàng,shì",
  "对称性": "duì,chèn,xìng",
  "对称破缺": "duì,chèn,pò,quē",
  "对称空间": "duì,chèn,kōng,jiān",
  "对称美": "duì,chèn,měi",
  "对称轴": "duì,chèn,zhóu",
  "对立地": "duì,lì,de",
  "对等地": "duì,děng,de",
  "对翫": "duì,wàn",
  "对茬儿": "duì,chá,er",
  "对薄公堂": "duì,bù,gōng,táng",
  "对角线地": "duì,jiǎo,xiàn,de",
  "对话地": "duì,huà,de",
  "对调": "duì,diào",
  "对过细地": "duì,guò,xì,de",
  "寺刹": "sì,shā",
  "寺舍": "sì,shè",
  "寺观": "sì,guàn",
  "寻乐地": "xún,lè,de",
  "寻宫数调": "xún,gōng,shù,diào",
  "寻思": "xín,sī",
  "寻摸": "xún,mo",
  "寻瑕伺隙": "xún,xiá,sì,xì",
  "寻的": "xún,dì",
  "寻行数墨": "xún,háng,shǔ,mò",
  "导以取保": "dao,yi,qu,bao",
  "导函数": "dǎo,hán,shù",
  "导弹": "dǎo,dàn",
  "导弹基地": "dǎo,dàn,jī,dì",
  "导弹核潜艇": "dǎo,dàn,hé,qián,tǐng",
  "导弹武器技术控制制度": "dǎo,dàn,wǔ,qì,jì,shù,kòng,zhì,zhì,dù",
  "导弹潜艇": "dǎo,dàn,qián,tǐng",
  "导弹艇": "dǎo,dàn,tǐng",
  "导弹预警卫星": "dǎo,dàn,yù,jǐng,wèi,xīng",
  "导数": "dǎo,shù",
  "寿头模子": "shòu,tóu,mú,zǐ",
  "寿数": "shòu,shù",
  "寿数已尽": "shòu,shù,yǐ,jǐn",
  "封𭏸": "fēng,wěi",
  "封妻荫子": "fēng,qī,yìn,zǐ",
  "封着": "fēng,zhe",
  "封禁": "fēng,jìn",
  "封禅": "fēng,shàn",
  "封禅书": "fēng,shàn,shū",
  "封禅文": "fēng,shàn,wén",
  "封禅树": "fēng,shàn,shù",
  "封禅藳": "fēng,shàn,gǎo",
  "封装地": "fēng,zhuāng,de",
  "封隩": "fēng,yù",
  "尃濩": "fū,hù",
  "射中": "shè,zhòng",
  "射侯": "shè,hòu",
  "射帖": "shè,tiē",
  "射干": "yè,gàn",
  "射幸数跌": "shè,xìng,shù,diē",
  "射弹": "shè,dàn",
  "射数": "shè,shù",
  "射的": "shè,dì",
  "射莎": "shè,shā",
  "射雕英雄传": "shè,diāo,yīng,xióng,zhuàn",
  "将令": "jiàng,lìng",
  "将会大大地减少": "jiāng,huì,dà,dà,de,jiǎn,shǎo",
  "将会尽可能地": "jiāng,huì,jìn,kě,néng,de",
  "将会极大地": "jiāng,huì,jí,dà,de",
  "将伯": "qiāng,bó",
  "将伯之助": "qiāng,bó,zhī,zhù",
  "将伯之呼": "qiāng,bó,zhī,hū",
  "将佐": "jiàng,zuǒ",
  "将作少府": "jiāng,zuò,shào,fǔ",
  "将作长史": "jiāng,zuò,zhǎng,shǐ",
  "将兵": "jiàng,bīng",
  "将军肚子": "jiāng,jūn,dù,zi",
  "将功折过": "jiāng,gōng,shé,guò",
  "将取固予": "jiāng,qǔ,gù,yǔ",
  "将士": "jiàng,shì",
  "将官": "jiàng,guān",
  "将将": "qiāng,qiāng",
  "将尉": "jiàng,wèi",
  "将帅": "jiàng,shuài",
  "将成功地": "jiāng,chéng,gōng,de",
  "将才": "jiàng,cái",
  "将有效地": "jiāng,yǒu,xiào,de",
  "将来地": "jiāng,lái,de",
  "将校": "jiàng,xiào",
  "将棋": "jiàng,qí",
  "将牌": "jiàng,pái",
  "将理性地": "jiāng,lǐ,xìng,de",
  "将略": "jiàng,lüè",
  "将相": "jiàng,xiàng",
  "将相之器": "jiàng,xiàng,zhī,qì",
  "将相应地": "jiàng,xiàng,yīng,de",
  "将紧密地": "jiāng,jǐn,mì,de",
  "将纔": "jiāng,shān",
  "将迎": "jiàng,yíng",
  "将近地": "jiāng,jìn,de",
  "将进酒": "qiāng,jìn,jiǔ",
  "将遇良才": "jiàng,yù,liáng,cái",
  "将遇良材": "jiàng,yù,liáng,cái",
  "将门": "jiàng,mén",
  "将门无犬子": "jiàng,mén,wú,quǎn,zǐ",
  "将门有将": "jiàng,mén,yǒu,jiàng",
  "将门虎子": "jiàng,mén,hǔ,zǐ",
  "将领": "jiàng,lǐng",
  "尉犁": "yù,lí",
  "尉犁县": "yù,lí,xiàn",
  "尉缭子": "wèi,liáo,zi",
  "尉迟": "yù,chí",
  "尉迟恭": "yù,chí,gōng",
  "尉迟杯": "yù,chí,bēi",
  "尊侯": "zūn,hòu",
  "尊敬地": "zūn,jìng,de",
  "尊累": "zūn,lèi",
  "尊长": "zūn,zhǎng",
  "小不点儿": "xiǎo,bù,diǎn,er",
  "小丑般地": "xiǎo,chǒu,bān,de",
  "小两口儿": "xiǎo,liǎng,kǒu,er",
  "小丫头": "xiǎo,yā,tou",
  "小乐府": "xiǎo,yuè,fǔ",
  "小事一件": "xiǎo,shì,yí,jiàn",
  "小人儿": "xiǎo,rén,er",
  "小人儿书": "xiǎo,rén,er,shū",
  "小仔": "xiǎo,zǎi",
  "小伙儿": "xiǎo,huǒ,er",
  "小伙子": "xiǎo,huǒ,zi",
  "小传": "xiǎo,zhuàn",
  "小传胪": "xiǎo,zhuàn,lú",
  "小侯": "xiǎo,hòu",
  "小便宜": "xiǎo,pián,yí",
  "小便斗": "xiǎo,biàn,dǒu",
  "小册子": "xiǎo,cè,zi",
  "小冠": "xiǎo,guān",
  "小冠子夏": "xiǎo,guàn,zi,xià",
  "小单于": "xiǎo,chán,yú",
  "小可的": "xiǎo,kě,dì",
  "小哥哥": "xiǎo,gē,ge",
  "小嘎子": "xiǎo,gǎ,zǐ",
  "小器作": "xiǎo,qì,zuō",
  "小圈子": "xiǎo,quān,zi",
  "小声地": "xiǎo,shēng,de",
  "小声地说": "xiǎo,shēng,de,shuō",
  "小声地问道": "xiǎo,shēng,de,wèn,dào",
  "小太太": "xiǎo,tài,tai",
  "小奶奶": "xiǎo,nǎi,nai",
  "小妞儿": "xiǎo,niū,er",
  "小妳妳": "xiǎo,nǎi,nǎi",
  "小妹妹": "xiǎo,mèi,mei",
  "小姐": "xiǎo,jie",
  "小姐姐": "xiǎo,jiě,jie",
  "小姑独处": "xiǎo,gū,dú,chǔ",
  "小姨子": "xiǎo,yí,zi",
  "小娃娃": "xiǎo,wá,wa",
  "小婶子": "xiǎo,shěn,zi",
  "小媳妇": "xiǎo,xí,fu",
  "小孩儿": "xiǎo,hái,er",
  "小孩堤防": "xiǎo,hái,dí,fáng",
  "小孩子": "xiǎo,hái,zi",
  "小宰相": "xiǎo,zǎi,xiàng",
  "小家伙": "xiǎo,jiā,huo",
  "小家子气": "xiǎo,jiā,zi,qì",
  "小家数": "xiǎo,jiā,shù",
  "小将": "xiǎo,jiàng",
  "小尉迟": "xiǎo,yù,chí",
  "小小地": "xiǎo,xiǎo,de",
  "小小子": "xiǎo,xiǎo,zi",
  "小尕子": "xiǎo,gǎ,zi",
  "小山包包": "xiǎo,shān,bāo,bao",
  "小差": "xiǎo,chāi",
  "小帖": "xiǎo,tiē",
  "小干": "xiǎo,gàn",
  "小干仵": "xiǎo,gàn,wǔ",
  "小弟弟": "xiǎo,dì,di",
  "小弹": "xiǎo,dàn",
  "小心地": "xiǎo,xīn,de",
  "小心眼儿": "xiǎo,xīn,yǎn,er",
  "小心翼翼地": "xiǎo,xīn,yì,yì,de",
  "小心翼翼地问": "xiǎo,xīn,yì,yì,de,wèn",
  "小性子": "xiǎo,xìng,zi",
  "小愒": "xiǎo,kài",
  "小房子": "xiǎo,fáng,zi",
  "小手儿": "xiǎo,shǒu,er",
  "小抄儿": "xiǎo,chāo,er",
  "小指头": "xiǎo,zhǐ,tou",
  "小掠": "xiǎo,lüě",
  "小摊儿": "xiǎo,tān,er",
  "小数": "xiǎo,shù",
  "小斗": "xiǎo,dǒu",
  "小日子": "xiǎo,rì,zi",
  "小日本儿": "xiǎo,rì,běn,er",
  "小时了了": "xiǎo,shí,liǎo,liǎo",
  "小时候": "xiǎo,shí,hou",
  "小时候儿": "xiǎo,shí,hou,er",
  "小时地": "xiǎo,shí,de",
  "小月氏": "xiǎo,ròu,zhī",
  "小段子": "xiǎo,duàn,zi",
  "小气地": "xiǎo,qì,de",
  "小气地给": "xiǎo,qì,de,gěi",
  "小池百合子": "xiǎo,chí,bǎi,hé,zi",
  "小河般地流": "xiǎo,hé,bān,de,liú",
  "小流氓": "xiǎo,liú,máng",
  "小猴子": "xiǎo,hóu,zi",
  "小白脸儿": "xiǎo,bái,liǎn,er",
  "小相": "xiǎo,xiàng",
  "小眼薄皮": "xiǎo,yǎn,bó,pí",
  "小碟子": "xiǎo,dié,zi",
  "小红萝卜": "xiǎo,hóng,luó,bo",
  "小纪": "xiǎo,jǐ",
  "小缸缸儿": "xiǎo,gāng,gang,er",
  "小聪明": "xiǎo,cōng,ming",
  "小肚子": "xiǎo,dǔ,zi",
  "小胖爪": "xiǎo,pàng,zhuǎ",
  "小胡同": "xiǎo,hú,tòng",
  "小脏鬼": "xiǎo,zāng,guǐ",
  "小舅子": "xiǎo,jiù,zi",
  "小舍": "xiǎo,shè",
  "小舍人": "xiǎo,shè,rén",
  "小苏打": "xiǎo,sū,dá",
  "小范老子": "xiǎo,fàn,lǎo,zi",
  "小菜儿": "xiǎo,cài,er",
  "小菜碟儿": "xiǎo,cài,dié,er",
  "小萝卜": "xiǎo,luó,bo",
  "小萝卜头": "xiǎo,luó,bo,tóu",
  "小蓝呢轿子": "xiǎo,lán,ne,jiào,zi",
  "小虾米": "xiǎo,xiā,mi",
  "小行子": "xiǎo,háng,zǐ",
  "小衣子儿": "xiǎo,yī,zǐ,er",
  "小规模地": "xiǎo,guī,mó,de",
  "小说般地": "xiǎo,shuō,bān,de",
  "小调": "xiǎo,diào",
  "小貉": "xiǎo,mò",
  "小蹄子": "xiǎo,tí,zi",
  "小辫儿": "xiǎo,biàn,er",
  "小辫子": "xiǎo,biàn,zi",
  "小道儿消息": "xiǎo,dào,er,xiāo,xī",
  "小道消息": "xiǎo,dào,xiāo,xi",
  "小里小气": "xiǎo,li,xiǎo,qì",
  "小铲子": "xiǎo,chǎn,zi",
  "小镏子": "xiǎo,liù,zǐ",
  "小门脸儿": "xiǎo,mén,liǎn,er",
  "小院儿": "xiǎo,yuàn,er",
  "小鬼似地": "xiǎo,guǐ,shì,de",
  "小𥻗子": "xiǎo,chá,zi",
  "少一点": "shǎo,yì,diǎn",
  "少不了": "shào,bù,liǎo",
  "少不得": "shào,bù,dé",
  "少不更事": "shào,bù,gēng,shì",
  "少不的": "shào,bù,de",
  "少不经事": "shào,bù,jīng,shì",
  "少东": "shào,dōng",
  "少东家": "shào,dōng,jiā",
  "少儿": "shào,ér",
  "少儿不宜": "shào,ér,bù,yí",
  "少先队": "shào,xiān,duì",
  "少壮": "shào,zhuàng",
  "少壮不努力": "shào,zhuàng,bù,nǔ,lì",
  "少壮派": "shào,zhuàng,pài",
  "少女": "shào,nǚ",
  "少女似地": "shào,nǚ,shì,de",
  "少女嫩妇": "shào,nǚ,nèn,fù",
  "少女峰": "shào,nǚ,fēng",
  "少女装": "shào,nǚ,zhuāng",
  "少女风": "shào,nǚ,fēng",
  "少奶": "shào,nǎi",
  "少奶奶": "shào,nǎi,nǎi",
  "少妇": "shào,fù",
  "少将": "shào,jiàng",
  "少尉": "shào,wèi",
  "少小": "shào,xiǎo",
  "少小无猜": "shào,xiǎo,wú,cāi",
  "少少地": "shǎo,shǎo,de",
  "少年": "shào,nián",
  "少年中国学会": "shào,nián,zhōng,guó,xué,huì",
  "少年中国说": "shào,nián,zhōng,guó,shuō",
  "少年之家": "shào,nián,zhī,jiā",
  "少年儿童业余体育学校": "shào,nián,ér,tóng,yè,yú,tǐ,yù,xué,xiào",
  "少年先锋营": "shào,nián,xiān,fēng,yíng",
  "少年先锋队": "shào,nián,xiān,fēng,duì",
  "少年地": "shào,nián,de",
  "少年场": "shào,nián,chǎng",
  "少年夫妻老来伴": "shào,nián,fū,qī,lǎo,lái,bàn",
  "少年子": "shào,nián,zǐ",
  "少年宫": "shào,nián,gōng",
  "少年得志": "shào,nián,dé,zhì",
  "少年法庭": "shào,nián,fǎ,tíng",
  "少年犯": "shào,nián,fàn",
  "少年白发": "shào,nián,bái,fà",
  "少年维特的烦恼": "shào,nián,wéi,tè,de,fán,nǎo",
  "少年老成": "shào,nián,lǎo,chéng",
  "少年行": "shào,nián,xíng",
  "少年飘泊者": "shào,nián,piāo,bó,zhě",
  "少府": "shào,fǔ",
  "少康": "shào,kāng",
  "少成": "shào,chéng",
  "少成若性": "shào,chéng,ruò,xìng",
  "少掌柜": "shào,zhǎng,guì",
  "少数": "shǎo,shù",
  "少数地": "shǎo,shù,de",
  "少数民族": "shǎo,shù,mín,zú",
  "少数民族乡": "shǎo,shù,mín,zú,xiāng",
  "少校": "shào,xiào",
  "少爷": "shào,yé",
  "少牢": "shào,láo",
  "少甚么": "shǎo,shèn,mǒ",
  "少男少女": "shào,nán,shào,nǚ",
  "少相": "shào,xiāng",
  "少管所": "shào,guǎn,suǒ",
  "少艾": "shào,ài",
  "少见地": "shǎo,jiàn,de",
  "少说为佳": "shǎo,shuō,wéi,jiā",
  "少量地分配": "shǎo,liàng,de,fēn,pèi",
  "少量地吃": "shǎo,liàng,de,chī",
  "少长": "shào,zhǎng",
  "少间": "shǎo,jiàn",
  "少阳病": "shào,yáng,bìng",
  "少阳经": "shào,yáng,jīng",
  "尕驴儿": "gǎ,lǘ,er",
  "尖儿": "jiān,er",
  "尖刻地": "jiān,kè,de",
  "尖叫地": "jiān,jiào,de",
  "尖嘴薄舌": "jiān,zuǐ,bó,shé",
  "尖声地": "jiān,shēng,de",
  "尖声地叫": "jiān,shēng,de,jiào",
  "尖声地说": "jiān,shēng,de,shuō",
  "尖子": "jiān,zi",
  "尖子生": "jiān,zi,shēng",
  "尖扎": "jiān,zhā",
  "尖扎县": "jiān,zhā,xiàn",
  "尖担两头脱": "jiān,dàn,liǎng,tóu,tuō",
  "尖沙咀": "jiān,shā,zuǐ",
  "尖瘦地": "jiān,shòu,de",
  "尖酸刻薄": "jiān,suān,kè,bó",
  "尖酸地": "jiān,suān,de",
  "尖锐地": "jiān,ruì,de",
  "尘世间地": "chén,shì,jiān,de",
  "尘仆": "chén,pú",
  "尘刹": "chén,shā",
  "尘卷风": "chén,juàn,fēng",
  "尘坋": "chén,fèn",
  "尘尘刹刹": "chén,chén,shā,shā",
  "尘毂": "chén,gū",
  "尘累": "chén,lèi",
  "尘露": "chén,lù",
  "尚兀": "shàng,wū",
  "尚兀自": "shàng,wū,zì",
  "尚冠": "shàng,guān",
  "尚可地": "shàng,kě,de",
  "尚方舃": "shàng,fāng,tuō",
  "尚父": "shàng,fǔ",
  "尜儿": "gá,er",
  "尜尜": "gá,ga",
  "尝出入": "cang,chu,ru",
  "尝在围中": "cang,zhai,wei,zong",
  "尝试性地": "cháng,shì,xìng,de",
  "尝鼎一脔": "cháng,dǐng,yì,luán",
  "尤为": "yóu,wéi",
  "尤其地": "yóu,qí,de",
  "尤甚": "yóu,shén",
  "尤累": "yóu,lèi",
  "尧年舜日": "yáo,nián,shùn,yuè",
  "尧蓂": "yáo,mì",
  "尧都": "yáo,dū",
  "尧都区": "yáo,dū,qū",
  "尨乱": "méng,luàn",
  "尨奇": "méng,qí",
  "尨杂": "méng,zá",
  "尨民": "méng,mín",
  "尨然": "méng,rán",
  "尨眉": "méng,méi",
  "尨眉皓发": "máng,méi,hào,fà",
  "尨茸": "méng,róng",
  "尨诡": "méng,guǐ",
  "尨降": "méng,jiàng",
  "尪𬮴": "wāng,ān",
  "就会更好地": "jiù,huì,gèng,hǎo,de",
  "就可以很好地": "jiù,kě,yǐ,hěn,hǎo,de",
  "就可以很方便地": "jiù,kě,yǐ,hěn,fāng,biàn,de",
  "就坚决地": "jiù,jiān,jué,de",
  "就大大地": "jiù,dà,dà,de",
  "就尴尬地": "jiù,gān,gà,de",
  "就急急地": "jiù,jí,jí,de",
  "就悄悄地": "jiù,qiāo,qiāo,de",
  "就慢慢地": "jiù,màn,màn,de",
  "就把地": "jiù,bǎ,de",
  "就明显地": "jiù,míng,xiǎn,de",
  "就是狠狠地": "jiù,shì,hěn,hěn,de",
  "就永远地": "jiù,yǒng,yuǎn,de",
  "就渐渐地": "jiù,jiàn,jiàn,de",
  "就着": "jiù,zhe",
  "就细致地": "jiù,xì,zhì,de",
  "就自动地": "jiù,zì,dòng,de",
  "就象征性地": "jiù,xiàng,zhēng,xìng,de",
  "就轻轻地": "jiù,qīng,qīng,de",
  "就逮": "jiù,dǎi",
  "就顺利地": "jiù,shùn,lì,de",
  "就飞快地": "jiù,fēi,kuài,de",
  "就鲜明地": "jiù,xiān,míng,de",
  "尴尬地": "gān,gà,de",
  "尴尬地笑": "gān,gà,de,xiào",
  "尸体剖检": "shī,tǐ,pōu,jiǎn",
  "尸体解剖": "shī,tǐ,jiě,pōu",
  "尸居龙见": "shī,jū,lóng,xiàn",
  "尸山血海": "shī,shān,xuè,hǎi",
  "尸皮子": "shī,pí,zi",
  "尸首": "shī,shou",
  "尹地": "yǐn,de",
  "尹潽善": "yǐn,pǔ,shàn",
  "尺二冤家": "chǐ,èr,yuān,jia",
  "尺子": "chǐ,zi",
  "尺寸过大": "chǐ,cun,guò,dà",
  "尺布斗粟": "chǐ,bù,dǒu,sù",
  "尺蚓穿堤": "chǐ,yǐn,chuān,dī",
  "尺蹏": "chǐ,dì",
  "尻门子": "kāo,mén,zi",
  "尼干": "ní,gàn",
  "尽先": "jǐn,xiān",
  "尽兴地": "jìn,xìng,de",
  "尽其所有": "jǐn,qí,suǒ,yǒu",
  "尽力地": "jìn,lì,de",
  "尽力而为": "jìn,lì,ér,wéi",
  "尽只": "jìn,zhī",
  "尽可能地": "jìn,kě,néng,de",
  "尽可能地优化": "jìn,kě,néng,de,yōu,huà",
  "尽可能地减少": "jìn,kě,néng,de,jiǎn,shǎo",
  "尽可能地去": "jìn,kě,néng,de,qù",
  "尽可能地多": "jìn,kě,néng,de,duō",
  "尽可能地将": "jìn,kě,néng,de,jiāng",
  "尽可能地搜集": "jìn,kě,néng,de,sōu,jí",
  "尽可能地消除": "jìn,kě,néng,de,xiāo,chú",
  "尽可能地照顾": "jìn,kě,néng,de,zhào,gù",
  "尽可能多地": "jìn,kě,néng,duō,de",
  "尽可能快地": "jìn,kě,néng,kuài,de",
  "尽多": "jǐn,duō",
  "尽多尽少": "jǐn,duō,jǐn,shǎo",
  "尽快": "jǐn,kuài",
  "尽快地": "jǐn,kuài,de",
  "尽快地吸收": "jǐn,kuài,de,xī,shōu",
  "尽快地唱": "jǐn,kuài,de,chàng",
  "尽情地": "jìn,qíng,de",
  "尽情地享受": "jìn,qíng,de,xiǎng,shòu",
  "尽情地嘲讽": "jìn,qíng,de,cháo,fěng",
  "尽情地玩": "jìn,qíng,de,wán",
  "尽情地谈": "jìn,qíng,de,tán",
  "尽数": "jìn,shù",
  "尽早": "jǐn,zǎo",
  "尽早地": "jǐn,zǎo,de",
  "尽显": "jǐn,xiǎn",
  "尽着": "jǐn,zhe",
  "尽管": "jǐn,guǎn",
  "尽职调查": "jìn,zhí,diào,chá",
  "尽自": "jǐn,zì",
  "尽说漂亮话": "jìn,shuō,piào,liàng,huà",
  "尽里头": "jǐn,lǐ,tou",
  "尽量": "jǐn,liàng",
  "尽量地": "jǐn,liàng,de",
  "尽量地得到": "jǐn,liàng,de,dé,dào",
  "尾子": "wěi,zi",
  "尾数": "wěi,shù",
  "尾煞": "wěi,shà",
  "尾随不舍": "wěi,suí,bú,shè",
  "尿失禁": "niào,shī,jìn",
  "尿尿把把": "niào,suī,bǎ,bǎ",
  "尿泡": "suī,pào",
  "尿泡种子": "suī,pào,zhǒng,zi",
  "尿盆儿": "niào,pén,er",
  "尿胞": "suī,bāo",
  "尿胞种子": "suī,bāo,zhǒng,zi",
  "尿脬": "suī,pāo",
  "尿血": "niào,xuè",
  "局促不安地": "jú,cù,bù,ān,de",
  "局促地": "jú,cù,de",
  "局地吁天": "jú,dì,yù,tiān",
  "局地钥天": "jú,dì,yào,tiān",
  "局子": "jú,zi",
  "局干": "jú,gàn",
  "局数": "jú,shù",
  "局笮": "jú,zé",
  "局背": "jú,bèi",
  "局调": "jú,diào",
  "局踀": "jú,chù",
  "局踧": "jú,dí",
  "局部地": "jú,bù,de",
  "局部性地": "jú,bù,xìng,de",
  "局长": "jú,zhǎng",
  "局高蹐厚": "jú,gāo,guǎ,hòu",
  "屁墩儿": "pì,dūn,er",
  "屁屁": "pì,pi",
  "屁眼儿": "pì,yǎn,er",
  "屁股": "pì,gu",
  "屁股决定脑袋": "pì,gu,jué,dìng,nǎo,dai",
  "屁股眼": "pì,gu,yǎn",
  "屁股着地": "pì,gǔ,zhe,de",
  "屁股蛋": "pì,gu,dàn",
  "屁股蹲儿": "pì,gu,dūn,er",
  "层台累榭": "céng,tái,lěi,xiè",
  "层子": "céng,zi",
  "层折": "céng,shé",
  "层禁": "céng,jìn",
  "层离法地": "céng,lí,fǎ,de",
  "层累": "céng,lèi",
  "层见迭出": "céng,xiàn,dié,chū",
  "屄屄": "bī,bi",
  "屄样儿": "bī,yàng,er",
  "居不重席": "jū,bù,chóng,xí",
  "居不重茵": "jū,bù,chóng,yīn",
  "居世界领先地": "jū,shì,jiè,lǐng,xiān,de",
  "居丧": "jū,sāng",
  "居先地": "jū,xiān,de",
  "居冠": "jū,guān",
  "居处": "jū,chǔ",
  "居干": "jū,gàn",
  "居心叵测地": "jū,xīn,pǒ,cè,de",
  "居民消费价格指数": "jū,mín,xiāo,fèi,jià,gé,zhǐ,shù",
  "居民点儿": "jū,mín,diǎn,er",
  "居礼夫人": "jū,lǐ,fū,ren",
  "居舍": "jū,shè",
  "居轴处中": "jū,zhóu,chǔ,zhōng",
  "居里夫人": "jū,lǐ,fū,ren",
  "屈从地": "qū,cóng,de",
  "屈侯": "qū,hòu",
  "屈地性": "qū,de,xìng",
  "屈地街": "qū,de,jiē",
  "屈处": "qū,chǔ",
  "屈戌儿": "qū,qu,er",
  "屈折": "qū,shé",
  "屈服地": "qū,fú,de",
  "屈笮": "qū,zé",
  "屉子": "tì,zi",
  "屋子": "wū,zi",
  "屋舍": "wū,shè",
  "屎壳郎": "shǐ,ké,làng",
  "屎盆子": "shǐ,pén,zi",
  "屏住": "bǐng,zhù",
  "屏声息气": "bǐng,shēng,xī,qì",
  "屏处": "píng,chǔ",
  "屏居": "bǐng,jū",
  "屏弃": "bǐng,qì",
  "屏息": "bǐng,xī",
  "屏息地": "bǐng,xī,de",
  "屏扞": "píng,gǎn",
  "屏斥": "bǐng,chì",
  "屏气": "bǐng,qì",
  "屏气凝神": "bǐng,qì,níng,shén",
  "屏气慑息": "bǐng,qì,shè,xī",
  "屏气敛息": "bǐng,qì,liǎn,xī",
  "屏着": "píng,zhe",
  "屏绝": "bǐng,jué",
  "屏舍": "píng,shè",
  "屏营": "bīng,yíng",
  "屏退": "bǐng,tuì",
  "屏除": "bǐng,chú",
  "屑侯": "xiè,hòu",
  "屑子": "xiè,zi",
  "展出地": "zhǎn,chū,de",
  "展帆": "zhǎn,fān",
  "展开地": "zhǎn,kāi,de",
  "展筩": "zhǎn,yǒng",
  "展翫": "zhǎn,wàn",
  "展露": "zhǎn,lù",
  "屖遟": "xī,zhì",
  "屙血事": "ē,xuè,shì",
  "屙金溺银": "ē,jīn,niào,yín",
  "属付": "zhǔ,fù",
  "属令": "zhǔ,lìng",
  "属仰": "zhǔ,yǎng",
  "属任": "zhǔ,rèn",
  "属兵": "zhǔ,bīng",
  "属句": "zhǔ,jù",
  "属命": "zhǔ,mìng",
  "属和": "zhǔ,hé",
  "属垣": "zhǔ,yuán",
  "属垣有耳": "zhǔ,yuán,yǒu,ěr",
  "属好": "zhǔ,hǎo",
  "属客": "zhǔ,kè",
  "属引": "zhǔ,yǐn",
  "属役": "zhǔ,yì",
  "属心": "zhǔ,xīn",
  "属志": "zhǔ,zhì",
  "属性地": "shǔ,xìng,de",
  "属意": "zhǔ,yì",
  "属托": "zhǔ,tuō",
  "属文": "zhǔ,wén",
  "属昔": "zhǔ,xī",
  "属望": "zhǔ,wàng",
  "属毛离里": "zhǔ,máo,lí,lǐ",
  "属民": "zhǔ,mín",
  "属玉": "zhǔ,yù",
  "属目": "zhǔ,mù",
  "属相": "shǔ,xiàng",
  "属着": "shǔ,zhe",
  "属类地": "shǔ,lèi,de",
  "属累": "shǔ,lèi",
  "属纩": "zhǔ,kuàng",
  "属者": "zhǔ,zhě",
  "属耳": "zhǔ,ěr",
  "属臾": "zhǔ,yú",
  "属行": "zhǔ,xíng",
  "属言": "zhǔ,yán",
  "属词比事": "zhǔ,cí,bǐ,shì",
  "属调": "shǔ,diào",
  "属辞比事": "zhǔ,cí,bǐ,shì",
  "屠剥": "tú,bāo",
  "屠夫般地": "tú,fū,bān,de",
  "屡次地": "lǚ,cì,de",
  "屡禁不止": "lǚ,jìn,bù,zhǐ",
  "屡禁不绝": "lǚ,jìn,bù,jué",
  "履絜": "lǚ,jié",
  "履舃": "lǚ,tuō",
  "履舃交错": "lǚ,tuō,jiāo,cuò",
  "履薄临深": "lǚ,bó,lín,shēn",
  "履𫏋": "lǚ,jué",
  "屦舃": "jù,tuō",
  "屮𫏋": "chè,jué",
  "屯剥": "tún,bāo",
  "屯咽": "tún,yān",
  "屯堡": "tún,pù",
  "屯如": "zhūn,rú",
  "屯扎": "tún,zhā",
  "屯穷": "zhūn,qióng",
  "屯膏": "zhūn,gāo",
  "屯謇": "zhūn,jiǎn",
  "屯蹇": "zhūn,jiǎn",
  "屯蹶": "zhūn,juě",
  "屯蹶否塞": "tún,juě,fǒu,sāi",
  "屯邅": "zhūn,zhān",
  "屯长": "tún,zhǎng",
  "山不转水转": "shān,bù,zhuàn,shuǐ,zhuàn",
  "山不转路转": "shān,bù,zhuàn,lù,zhuàn",
  "山东梆子": "shān,dōng,bāng,zi",
  "山中宰相": "shān,zhōng,zǎi,xiàng",
  "山乐官": "shān,yuè,guān",
  "山公倒载": "shān,gōng,dǎo,zǎi",
  "山公兴": "shān,gōng,xīng",
  "山公酩酊": "shān,gōng,mǐng,dǐng",
  "山坑": "shān,gāng",
  "山复整妆": "shan,fu,zheng,zhuang",
  "山大王": "shān,dài,wáng",
  "山子": "shān,zi",
  "山岗": "shān,gāng",
  "山岗子": "shān,gāng,zǐ",
  "山峦重叠": "shān,luán,chóng,dié",
  "山崩钟应": "shān,bēng,zhōng,yìng",
  "山嶞": "shān,duò",
  "山枇杷": "shān,pí,bà",
  "山查": "shān,zhā",
  "山查糕": "shān,zhā,gāo",
  "山核桃差着一槅儿": "shān,hé,táo,chà,zhe,yī,gé,ér",
  "山槛": "shān,kǎn",
  "山殽野𣲗": "shān,yáo,yě,wéi",
  "山溜穿石": "shān,liù,chuān,shí",
  "山瀑": "shān,bào",
  "山砠水厓": "shān,jū,shuǐ,zhì",
  "山祇": "shān,qí",
  "山简兴": "shān,jiǎn,xīng",
  "山箐": "shān,jīng",
  "山背": "shān,bèi",
  "山脑坢": "shān,nǎo,pǎn",
  "山臊": "shān,sào",
  "山舍": "shān,shè",
  "山茄子": "shān,qié,zi",
  "山药": "shān,yao",
  "山药蛋": "shān,yao,dàn",
  "山菌子": "shān,jùn,zǐ",
  "山𫉄": "shān,zhū",
  "山行海宿": "shān,xíng,hǎi,xiǔ",
  "山西出将": "shān,xī,chū,jiàng",
  "山西梆子": "shān,xī,bāng,zi",
  "山阴乘兴": "shān,yīn,chéng,xīng",
  "山阴兴": "shān,yīn,xīng",
  "山阿": "shān,ē",
  "山难": "shān,nàn",
  "山高岭削": "shān,gāo,lǐng,xuē",
  "山高遮不住太阳": "shān,gāo,zhē,bú,zhù,tài,yáng",
  "山鸣谷应": "shān,míng,gǔ,yìng",
  "山鹡鸰": "shān,jí,líng",
  "屹兀": "yì,wū",
  "屹蹬蹬": "yì,dēng,dēng",
  "屹蹶": "yì,juě",
  "岁寒三友": "suì,hán,sā,yǒu",
  "岁序更新": "suì,xù,gēng,xīn",
  "岁数": "suì,shù",
  "岁聿其莫": "suì,yù,qí,mù",
  "岁调": "suì,diào",
  "岂弟": "kǎi,tì",
  "岂弟君子": "kǎi,tì,jūn,zǐ",
  "岂得": "qǐ,de",
  "岌峇": "jí,bā",
  "岌嶷": "jí,nì",
  "岐嶷": "qí,nì",
  "岑参": "cén,shēn",
  "岑牟": "cén,mù",
  "岔子": "chà,zi",
  "岔调": "chà,diào",
  "岗口儿甜": "gàng,kǒu,er,tián",
  "岗头泽底": "gāng,tóu,zé,dǐ",
  "岗舍": "gǎng,shè",
  "岝峉": "zuò,è",
  "岧𫶇": "tiáo,dì",
  "岨固": "qū,gù",
  "岨峻": "qū,jùn",
  "岨峿": "qū,yǔ",
  "岨崄": "qū,xiǎn",
  "岨深": "qū,shēn",
  "岨谷": "qū,gǔ",
  "岨险": "qū,xiǎn",
  "岩侥": "yán,yáo",
  "岩唫": "yán,yín",
  "岩堡": "yán,pù",
  "岩处": "yán,chǔ",
  "岩居穴处": "yán,jū,xué,chǔ",
  "岩峿": "yán,yǔ",
  "岩栖穴处": "yán,qī,xué,chǔ",
  "岩芯": "yán,xìn",
  "岩阿": "yán,ē",
  "岭𫶕": "líng,yíng",
  "岳祇": "yuè,qí",
  "岳老子": "yuè,lǎo,zi",
  "岳镇渊渟": "yuè,zhèn,yuān,tīng",
  "峇厘": "bā,lí",
  "峇峇娘惹": "bā,bā,niáng,rě",
  "峇拉煎": "bā,lā,jiān",
  "峇里": "bā,lǐ",
  "峉峉": "è,è",
  "峍兀": "lù,wū",
  "峒丁": "dòng,dīng",
  "峒人": "dòng,rén",
  "峒兵": "dòng,bīng",
  "峒剧": "dòng,jù",
  "峒室": "dòng,shì",
  "峒户": "dòng,hù",
  "峣嶷": "yáo,nì",
  "峨冠": "é,guān",
  "峨冠博带": "é,guān,bó,dài",
  "峨峨汤汤": "é,é,shāng,shāng",
  "峭削": "qiào,xuē",
  "峭帆": "qiào,fān",
  "峭阤": "qiào,yǐ",
  "峮嶙": "qūn,lín",
  "峳峳": "yóu,yóu",
  "峻削": "jùn,xuē",
  "峻岨": "jùn,qū",
  "峻折": "jùn,shé",
  "峿台": "yǔ,tái",
  "崁顶": "kǎn,dǐng",
  "崁顶乡": "kǎn,dǐng,xiāng",
  "崃嵦": "lái,ái",
  "崄岨": "xiǎn,qū",
  "崇庳": "chóng,bì",
  "崇拜地": "chóng,bài,de",
  "崇敬地": "chóng,jìng,de",
  "崇着": "chóng,zhe",
  "崇阿": "chóng,ē",
  "崇高地": "chóng,gāo,de",
  "崎锜": "qí,yǐ",
  "崒兀": "zú,wū",
  "崔罗什": "cuī,luó,shí",
  "崛兴": "jué,xīng",
  "崜峗": "duō,wéi",
  "崤黾": "xiáo,miǎn",
  "崩剥": "bēng,bāo",
  "崩查": "bēng,zhā",
  "崩背": "bēng,bèi",
  "崩阤": "bēng,yǐ",
  "崭露头脚": "zhǎn,lù,tóu,jiǎo",
  "崭露头角": "zhǎn,lù,tóu,jiǎo",
  "崭齐地": "zhǎn,qí,de",
  "𰎖嶷": "zè,nì",
  "崴子": "wǎi,zi",
  "崴磈": "wǎi,wěi",
  "崴脚": "wǎi,jiǎo",
  "崴魁": "wǎi,kuí",
  "嵇侍中血": "jī,shì,zhōng,xuè",
  "嵇绍血": "jī,shào,xuè",
  "嵌缝": "qiàn,fèng",
  "嵎銕": "yú,yí",
  "嵡𡵝": "wěng,zōng",
  "嵩邙": "sōng,māng",
  "嵬嶷": "wéi,nì",
  "嵬𱅗": "wéi,é",
  "嵰山": "qiǎn,shān",
  "嵰岭": "qiǎn,lǐng",
  "嵰州": "qiǎn,zhōu",
  "𡵝𰎎": "zōng,lóng",
  "𡵝森": "zōng,sēn",
  "𫶇嵲": "dì,niè",
  "𫶇霓": "dì,ní",
  "嶒嶷": "céng,nì",
  "嶙峋地": "lín,xún,de",
  "嶜岑": "jīn,cén",
  "嶜崟": "jīn,yín",
  "嶞嶞": "duò,duò",
  "𰎑𱅗": "yè,é",
  "嶷如": "nì,rú",
  "嶷尔": "nì,ěr",
  "嶷岌": "nì,jí",
  "嶷嶷": "nì,nì",
  "嶷然": "nì,rán",
  "嶷爽": "nì,shuǎng",
  "巂周": "xī,zhōu",
  "𰎎𡵝": "lóng,zōng",
  "巅𰊂": "diān,dì",
  "巉削": "chán,xuē",
  "巉剥": "chán,bāo",
  "巉岨": "chán,qū",
  "巍冠": "wēi,guān",
  "巍卬": "wēi,áng",
  "川党参": "chuān,dǎng,shēn",
  "川渟岳峙": "chuān,tīng,yuè,zhì",
  "川滇藏": "chuān,diān,zàng",
  "川甽": "chuān,quǎn",
  "川祇": "chuān,qí",
  "川藏": "chuān,zàng",
  "川藏公路": "chuān,zàng,gōng,lù",
  "州处": "zhōu,chǔ",
  "州都": "zhōu,dū",
  "州长": "zhōu,zhǎng",
  "巡回地": "xún,huí,de",
  "巡更": "xún,gēng",
  "巡禁": "xún,jìn",
  "巡航导弹": "xún,háng,dǎo,dàn",
  "巡逴": "xún,chuò",
  "巡𰺷": "xún,rǎo",
  "巡铺": "xún,pù",
  "巢居穴处": "cháo,jū,xué,chǔ",
  "工业规划": "gōng,yè,guī,huà",
  "工伤假": "gōng,shāng,jià",
  "工作地": "gōng,zuò,de",
  "工口": "ēi,luó",
  "工商银行": "gōng,shāng,yín,háng",
  "工坊": "gōng,fáng",
  "工夫茶": "gōng,fu,chá",
  "工尺": "gōng,chě",
  "工尺谱": "gōng,chě,pǔ",
  "工行": "gōng,háng",
  "工长": "gōng,zhǎng",
  "左一次右一次地": "zuǒ,yī,cì,yòu,yī,cì,de",
  "左一遍右一遍地": "zuǒ,yī,biàn,yòu,yī,biàn,de",
  "左不是": "zuǒ,bú,shì",
  "左丞相": "zuǒ,chéng,xiàng",
  "左传": "zuǒ,zhuàn",
  "左传癖": "zuǒ,zhuàn,pǐ",
  "左侧地": "zuǒ,cè,de",
  "左削": "zuǒ,xuē",
  "左右为难": "zuǒ,yòu,wéi,nán",
  "左嗓子": "zuǒ,sǎng,zi",
  "左强": "zuǒ,jiàng",
  "左撇子": "zuǒ,piě,zǐ",
  "左方地": "zuǒ,fāng,de",
  "左更": "zuǒ,gēng",
  "左边": "zuǒ,bian",
  "左边儿": "zuǒ,bian,er",
  "左邻右舍": "zuǒ,lín,yòu,shè",
  "巧劲儿": "qiǎo,jìn,er",
  "巧发奇中": "qiǎo,fā,qí,zhòng",
  "巧合地": "qiǎo,hé,de",
  "巧妇难为无米之炊": "qiǎo,fù,nán,wéi,wú,mǐ,zhī,chuī",
  "巧妙地": "qiǎo,miào,de",
  "巧妙地将": "qiǎo,miào,de,jiāng",
  "巧干": "qiǎo,gàn",
  "巧捷地": "qiǎo,jié,de",
  "巧舌头": "qiǎo,shé,tou",
  "巨什": "jù,shí",
  "巨大地": "jù,dà,de",
  "巨无霸汉堡包指数": "jù,wú,bà,hàn,bǎo,bāo,zhǐ,shù",
  "巨查": "jù,zhā",
  "巨槛": "jù,kǎn",
  "巨着": "jù,zhe",
  "巨获": "jǔ,huò",
  "巨贾": "jù,gǔ",
  "巨鹿侯": "jù,lù,hòu",
  "差一点": "chà,yì,diǎn",
  "差一点儿": "chà,yì,diǎn,er",
  "差三错四": "chā,sān,cuò,sì",
  "差不多地": "chà,bù,duō,de",
  "差不多的": "chà,bu,duō,de",
  "差不离儿": "chà,bù,lí,er",
  "差之千里": "chā,zhī,qiān,lǐ",
  "差之毫厘": "chā,zhī,háo,lí",
  "差之毫厘失之千里": "chā,zhī,háo,lí,shī,zhī,qiān,lǐ",
  "差事": "chāi,shì",
  "差互": "cī,hù",
  "差人": "chāi,rén",
  "差人去": "chāi,rén,qù",
  "差人去请医生": "chāi,rén,qù,qǐng,yī,shēng",
  "差以毫厘": "chā,yǐ,háo,lí",
  "差价": "chā,jià",
  "差使": "chāi,shǐ",
  "差值": "chā,zhí",
  "差分": "chā,fēn",
  "差分方程": "chā,fēn,fāng,chéng",
  "差别": "chā,bié",
  "差动": "chā,dòng",
  "差动齿轮": "chā,dòng,chǐ,lún",
  "差劲地": "chà,jìn,de",
  "差可": "chā,kě",
  "差可告慰": "chā,kě,gào,wèi",
  "差商": "chā,shāng",
  "差夫": "chāi,fū",
  "差序": "cī,xù",
  "差异": "chā,yì",
  "差异地": "chā,yì,de",
  "差异性": "chā,yì,xìng",
  "差异法": "chā,yì,fǎ",
  "差强人意": "chā,qiáng,rén,yì",
  "差役": "chāi,yì",
  "差得很远": "chà,de,hěn,yuǎn",
  "差得远": "chà,de,yuǎn",
  "差拨": "chāi,bō",
  "差数": "chā,shù",
  "差旅费": "chāi,lǚ,fèi",
  "差池": "chā,chí",
  "差派": "chāi,pài",
  "差点儿": "chà,diǎn,er",
  "差缪": "chà,miù",
  "差缺": "chāi,quē",
  "差肩": "cī,jiān",
  "差讹": "chā,é",
  "差跌": "chà,diē",
  "差距": "chā,jù",
  "差违": "chā,wéi",
  "差迟": "chā,chí",
  "差速器": "chā,sù,qì",
  "差遣": "chāi,qiǎn",
  "差错": "chā,cuò",
  "差额": "chā,é",
  "差额选举": "chā,é,xuǎn,jǔ",
  "差饷": "chāi,xiǎng",
  "已坏地": "yǐ,huài,de",
  "已大大地": "yǐ,dà,dà,de",
  "已废地": "yǐ,fèi,de",
  "已悄悄地": "yǐ,qiāo,qiāo,de",
  "已清楚地": "yǐ,qīng,chǔ,de",
  "已牢牢地": "yǐ,láo,láo,de",
  "已知数": "yǐ,zhī,shù",
  "已经尽量地": "yǐ,jīng,jǐn,liàng,de",
  "已经慢慢地": "yǐ,jīng,màn,màn,de",
  "已经成功地": "yǐ,jīng,chéng,gōng,de",
  "已经深深地": "yǐ,jīng,shēn,shēn,de",
  "已经清楚地": "yǐ,jīng,qīng,chǔ,de",
  "已起床地": "yǐ,qǐ,chuáng,de",
  "已降": "yǐ,xiáng",
  "巴儿": "bā,er",
  "巴儿思": "bā,er,sī",
  "巴儿狗": "bā,er,gǒu",
  "巴克什": "bā,kè,shí",
  "巴克莱银行": "bā,kè,lái,yín,háng",
  "巴刹": "bā,shā",
  "巴唧": "bā,ji",
  "巴唧巴唧": "bā,ji,bā,ji",
  "巴塞罗那": "bā,sài,luó,nà",
  "巴塞隆纳": "bā,sài,lóng,nà",
  "巴尔喀什湖": "bā,ěr,kā,shí,hú",
  "巴尔干": "bā,ěr,gàn",
  "巴尔干半岛": "bā,ěr,gàn,bàn,dǎo",
  "巴尔扎克": "bā,ěr,zhā,kè",
  "巴尔的摩": "bā,ěr,dì,mó",
  "巴巴儿地": "bā,bā,ér,de",
  "巴巴儿的": "bā,bā,er,de",
  "巴巴地": "bā,bā,de",
  "巴巴结结": "bā,bā,jiē,jiē",
  "巴布亚纽几内亚": "bā,bù,yà,niǔ,jī,nèi,yà",
  "巴干达人": "bā,gàn,dá,rén",
  "巴得": "bā,de",
  "巴扎": "bā,zhā",
  "巴掌": "bā,zhang",
  "巴控克什米尔": "bā,kòng,kè,shí,mǐ,ěr",
  "巴斗": "bā,dǒu",
  "巴耶利巴": "bā,yē,lì,bā",
  "巴西侯": "bā,xī,hòu",
  "巴西等地": "bā,xī,děng,de",
  "巴谩": "bā,màn",
  "巴音满都呼": "bā,yīn,mǎn,dū,hū",
  "巴音郭楞蒙古自治州": "bā,yīn,guō,léng,měng,gǔ,zì,zhì,zhōu",
  "巷子": "xiàng,zi",
  "巷弄": "xiàng,lòng",
  "巷道": "hàng,dào",
  "巽輭": "xùn,ér",
  "巾冠": "jīn,guān",
  "巾卷": "jīn,juàn",
  "巾舃": "jīn,tuō",
  "巾褚": "jīn,chǔ",
  "巾韈": "jīn,wà",
  "市哄": "shì,hǒng",
  "市场划分": "shì,chǎng,huà,fēn",
  "市场调查": "shì,chǎng,diào,chá",
  "市担": "shì,dàn",
  "市斗": "shì,dǒu",
  "市石": "shì,dàn",
  "市舍": "shì,shè",
  "市调": "shì,diào",
  "市贾": "shì,gǔ",
  "市铺": "shì,pù",
  "市长": "shì,zhǎng",
  "布什": "bù,shí",
  "布什尔": "bù,shí,ěr",
  "布侯": "bù,hòu",
  "布冠": "bù,guān",
  "布娃娃": "bù,wá,wa",
  "布尔什维克": "bù,ěr,shí,wéi,kè",
  "布尔代数": "bù,ěr,dài,shù",
  "布帆": "bù,fān",
  "布帆无恙": "bù,fán,wú,yàng",
  "布干": "bù,gàn",
  "布斐": "bǔ,fěi",
  "布氏杆菌病": "bù,shì,gǎn,jūn,bìng",
  "布洋娃娃": "bù,yáng,wá,wa",
  "布濩": "bù,hù",
  "布袋弹": "bù,dài,dàn",
  "布隆伯格": "bù,lōng,bó,gé",
  "布露": "bù,lù",
  "布鲁塞尔": "bù,lǔ,sài,ěr",
  "帅气": "shuài,qi",
  "帅气地": "shuài,qì,de",
  "帆伞": "fān,sǎn",
  "帆具": "fān,jù",
  "帆力": "fān,lì",
  "帆势": "fān,shì",
  "帆叶": "fān,yè",
  "帆布": "fān,bù",
  "帆布包": "fān,bù,bāo",
  "帆布床": "fān,bù,chuáng",
  "帆布鞋": "fān,bù,xié",
  "帆帏": "fān,wéi",
  "帆席": "fān,xí",
  "帆幅": "fān,fú",
  "帆幔": "fān,màn",
  "帆影": "fān,yǐng",
  "帆板": "fān,bǎn",
  "帆板运动": "fān,bǎn,yùn,dòng",
  "帆楫": "fān,jí",
  "帆樯": "fān,qiáng",
  "帆檝": "fān,jí",
  "帆海": "fān,hǎi",
  "帆篷": "fān,péng",
  "帆索": "fān,suǒ",
  "帆背潜鸭": "fān,bèi,qián,yā",
  "帆脚": "fān,jiǎo",
  "帆腹": "fān,fù",
  "帆舶": "fān,bó",
  "帆船": "fān,chuán",
  "帆船运动": "fān,chuán,yùn,dòng",
  "帆颠": "fān,diān",
  "帆风": "fān,fēng",
  "师傅": "shī,fu",
  "师兄弟": "shī,xīng,dì",
  "师尚父": "shī,shàng,fǔ",
  "师干": "shī,gàn",
  "师父娘": "shī,fu,niáng",
  "师直为壮": "shī,zhí,wéi,zhuàng",
  "师禁": "shī,jìn",
  "师长": "shī,zhǎng",
  "希望地": "xī,wàng,de",
  "希望能更好地": "xī,wàng,néng,gèng,hǎo,de",
  "希罕": "xī,han",
  "希里打哄": "xī,lǐ,dǎ,hǒng",
  "帐主子": "zhàng,zhǔ,zi",
  "帐子": "zhàng,zi",
  "帐干": "zhàng,gàn",
  "帐棚": "zhàng,peng",
  "帐篷": "zhàng,peng",
  "帐荫子": "zhàng,yìn,zǐ",
  "帑储": "tǎng,chǔ",
  "帑僇": "tǎng,lù",
  "帑实": "tǎng,shí",
  "帑屋": "tǎng,wū",
  "帑帛": "tǎng,bó",
  "帑库": "tǎng,kù",
  "帑府": "tǎng,fǔ",
  "帑庾": "tǎng,yǔ",
  "帑𰏶": "tǎng,kuài",
  "帑廪": "tǎng,lǐn",
  "帑抹": "tǎng,mǒ",
  "帑椟": "tǎng,dú",
  "帑簿": "tǎng,bù",
  "帑臧": "tǎng,zāng",
  "帑舍": "tǎng,shè",
  "帑藏": "tǎng,zàng",
  "帑金": "tǎng,jīn",
  "帑钱": "tǎng,qián",
  "帑银": "tǎng,yín",
  "帑项": "tǎng,xiàng",
  "帕子": "pà,zi",
  "帕拉塞尔士": "pà,lā,sè,ěr,shì",
  "帕累托": "pà,lèi,tuō",
  "帕累托最优": "pà,lèi,tuō,zuì,yōu",
  "帕累托法则": "pà,lèi,tuō,fǎ,zé",
  "帖伏": "tiē,fú",
  "帖例": "tiē,lì",
  "帖妥": "tiē,tuǒ",
  "帖学": "tiè,xué",
  "帖帖": "tiē,tiē",
  "帖席": "tiē,xí",
  "帖息": "tiē,xī",
  "帖敕": "tiē,chì",
  "帖服": "tiē,fú",
  "帖木儿": "tiē,mù,ér",
  "帖木儿大汗": "tiē,mù,ér,dà,hán",
  "帖泰": "tiē,tài",
  "帖耳": "tiē,ěr",
  "帖职": "tiē,zhí",
  "帖胁": "tiē,xié",
  "帖骑": "tiē,qí",
  "帖黄": "tiē,huáng",
  "帗舞": "bō,wǔ",
  "帘子": "lián,zi",
  "帘窥壁听": "lián,kuī,bì,tìng",
  "帝王将相": "dì,wáng,jiàng,xiàng",
  "帝王般地": "de,wáng,bān,de",
  "帝载": "dì,zǎi",
  "帝都": "dì,dū",
  "帣鞲": "juǎn,gōu",
  "帣鞴": "juǎn,bèi",
  "带儿": "dài,er",
  "带分数": "dài,fēn,shù",
  "带去": "dài,qu",
  "带子": "dài,zi",
  "带灰地": "dài,huī,de",
  "带状地": "dài,zhuàng,de",
  "带着铃铛去做贼": "dài,zhe,líng,dāng,qù,zuò,zéi",
  "带累": "dài,lèi",
  "带肚子": "dài,dǔ,zi",
  "带薪休假": "dài,xīn,xiū,jià",
  "带调": "dài,diào",
  "带露": "dài,lù",
  "带露水地": "dài,lù,shuǐ,de",
  "帩头": "qiào,tóu",
  "席不暇煖": "xí,bù,xiá,xuān",
  "席子": "xí,zi",
  "席帆": "xí,fān",
  "帮倒忙": "bāng,dào,máng",
  "帮兴": "bāng,xīng",
  "帮子": "bāng,zi",
  "帮宝适": "bāng,bǎo,shì",
  "帮帮忙": "bāng,bang,máng",
  "帱察": "dào,chá",
  "帱载": "dào,zǎi",
  "帷毂": "wéi,gū",
  "帷薄": "wéi,bó",
  "帷薄不修": "wéi,bó,bù,xiū",
  "常不免地": "cháng,bù,miǎn,de",
  "常亲切地": "cháng,qīn,qiè,de",
  "常便": "cháng,pián",
  "常卖铺": "cháng,mài,pù",
  "常处": "cháng,chǔ",
  "常常地": "cháng,cháng,de",
  "常年累月": "cháng,nián,lèi,yuè",
  "常数": "cháng,shù",
  "常用对数": "cháng,yòng,duì,shù",
  "常禁": "cháng,jìn",
  "常见地": "cháng,jiàn,de",
  "常规炸弹": "cháng,guī,zhà,dàn",
  "常言说得好": "cháng,yán,shuō,de,hǎo",
  "常调": "cháng,diào",
  "帽子": "mào,zi",
  "帽子头": "mào,zi,tóu",
  "帽子戏法": "mào,zi,xì,fǎ",
  "帽箍儿": "mào,gū,er",
  "幂数": "mì,shù",
  "幂级数": "mì,jí,shù",
  "幌子": "huǎng,zi",
  "幔子": "màn,zi",
  "幛子": "zhàng,zi",
  "幡刹": "fān,shā",
  "幡幢": "fān,zhuàng",
  "幡斿": "fān,yóu",
  "幢主": "zhuàng,zhǔ",
  "幢容": "zhuàng,róng",
  "幢将": "zhuàng,jiāng",
  "幢幡": "zhuàng,fān",
  "幢戟": "zhuàng,jǐ",
  "幢旗": "zhuàng,qí",
  "幢校": "zhuàng,xiào",
  "幢牙": "zhuàng,yá",
  "幢盖": "zhuàng,gài",
  "幢相": "zhuàng,xiāng",
  "幢竿": "zhuàng,gān",
  "幢络": "zhuàng,luò",
  "幢翳": "zhuàng,yì",
  "幢节": "zhuàng,jié",
  "幢葆": "zhuàng,bǎo",
  "幢队": "zhuàng,duì",
  "幢麾": "zhuàng,huī",
  "干与": "gān,yù",
  "干丐": "gàn,gài",
  "干世": "gàn,shì",
  "干丝": "qián,sī",
  "干主": "gàn,zhǔ",
  "干么": "gàn,me",
  "干乔": "qián,qiáo",
  "干乞": "gàn,qǐ",
  "干了": "gàn,le",
  "干事": "gàn,shì",
  "干事人": "gàn,shì,rén",
  "干事长": "gàn,shi,zhǎng",
  "干什么": "gàn,shén,me",
  "干仆": "gàn,pú",
  "干仗": "gàn,zhàng",
  "干任": "gàn,rèn",
  "干休所": "gàn,xiū,suǒ",
  "干位": "gàn,wèi",
  "干佐": "gàn,zuǒ",
  "干余骨": "gàn,yú,gǔ",
  "干侯": "gàn,hòu",
  "干修": "gàn,xiū",
  "干倔": "gàn,juè",
  "干傺": "gàn,chì",
  "干僮": "gàn,tóng",
  "干僵": "gàn,jiāng",
  "干儛": "gàn,wǔ",
  "干儿子": "gān,ér,zi",
  "干兰": "gàn,lán",
  "干具": "gàn,jù",
  "干典": "gàn,diǎn",
  "干冒": "gàn,mào",
  "干冬": "gàn,dōng",
  "干净": "gàn,jìng",
  "干净利索": "gàn,jìng,lì,suǒ",
  "干净利落": "gàn,jìng,lì,luò",
  "干净土": "gàn,jìng,tǔ",
  "干净地": "gàn,jìng,dì",
  "干则": "gàn,zé",
  "干剥剥": "gān,bāo,bāo",
  "干剧": "gàn,jù",
  "干力": "gàn,lì",
  "干办": "gàn,bàn",
  "干办公事": "gàn,bàn,gōng,shì",
  "干劲": "gàn,jìn",
  "干勇": "gàn,yǒng",
  "干化": "gàn,huà",
  "干匿": "gàn,nì",
  "干升": "gàn,shēng",
  "干叩": "gàn,kòu",
  "干号": "gān,háo",
  "干吊": "gàn,diào",
  "干名": "gàn,míng",
  "干吏": "gàn,lì",
  "干吗": "gàn,má",
  "干启": "gàn,qǐ",
  "干吾": "gàn,wú",
  "干员": "gàn,yuán",
  "干命": "gàn,mìng",
  "干和": "gàn,hé",
  "干咎": "gàn,jiù",
  "干咳": "gān,hāi",
  "干咽": "qián,yān",
  "干哑": "qián,yǎ",
  "干啥": "gàn,shá",
  "干嗌": "gàn,ài",
  "干嘛": "gàn,ma",
  "干噎": "gàn,yē",
  "干器": "gàn,qì",
  "干固": "gàn,gù",
  "干国": "gàn,guó",
  "干城之将": "gān,chéng,zhī,jiàng",
  "干堂": "gàn,táng",
  "干堆": "gàn,duī",
  "干处理": "gàn,chǔ,lǐ",
  "干大": "gàn,dà",
  "干天": "gàn,tiān",
  "干奴": "gàn,nú",
  "干奶婆": "qián,nǎi,pó",
  "干妹子": "gàn,mèi,zǐ",
  "干媚": "gàn,mèi",
  "干子": "gàn,zǐ",
  "干宇": "gàn,yǔ",
  "干官": "gàn,guān",
  "干实": "gàn,shí",
  "干家": "gàn,jiā",
  "干寤": "gàn,wù",
  "干将": "gàn,jiàng",
  "干将莫邪": "gān,jiàng,mò,yé",
  "干尽": "gàn,jìn",
  "干局": "gàn,jú",
  "干屎橛": "qián,shǐ,jué",
  "干属": "gàn,shǔ",
  "干巴巴地": "gān,bā,bā,de",
  "干干": "gàn,gàn",
  "干干净": "qián,qián,jìng",
  "干干净净": "gàn,gàn,jìng,jìng",
  "干干翼翼": "gàn,gàn,yì,yì",
  "干度": "gàn,dù",
  "干弄": "gàn,nòng",
  "干强": "gàn,qiáng",
  "干当": "gàn,dāng",
  "干当人": "gàn,dāng,rén",
  "干役": "gàn,yì",
  "干忙": "qián,máng",
  "干忤": "gàn,wǔ",
  "干恩荫": "gàn,ēn,yìn",
  "干愁": "gàn,chóu",
  "干戈载戢": "gān,gē,zǎi,jí",
  "干戚": "gàn,qī",
  "干戚舞": "gàn,qī,wǔ",
  "干手": "gàn,shǒu",
  "干才": "gàn,cái",
  "干打哄": "gàn,dǎ,hǒng",
  "干打雷": "gàn,dǎ,léi",
  "干托": "gàn,tuō",
  "干扬": "gàn,yáng",
  "干扰地": "gān,rǎo,de",
  "干折": "qián,shé",
  "干持": "gàn,chí",
  "干挣": "qián,zhèng",
  "干捷": "gàn,jié",
  "干掉": "gàn,diào",
  "干掌": "gàn,zhǎng",
  "干掫": "gàn,zōu",
  "干敏": "gàn,mǐn",
  "干方": "gàn,fāng",
  "干旄": "gàn,máo",
  "干旌": "gàn,jīng",
  "干旍": "gàn,jīng",
  "干𭤰": "gàn,yú",
  "干时": "gàn,shí",
  "干暴": "gàn,bào",
  "干本": "gàn,běn",
  "干材": "gàn,cái",
  "干村沙": "gàn,cūn,shā",
  "干条": "qián,tiáo",
  "干板": "gàn,bǎn",
  "干枉": "gàn,wǎng",
  "干枝": "gàn,zhī",
  "干架": "gàn,jià",
  "干柘": "gàn,zhè",
  "干栏": "gàn,lán",
  "干校": "gàn,xiào",
  "干校六记": "gàn,xiào,liù,jì",
  "干桢": "gàn,zhēn",
  "干梅子": "gān,méi,zi",
  "干植": "gàn,zhí",
  "干榨": "gàn,zhà",
  "干槁": "gàn,gǎo",
  "干欲": "gàn,yù",
  "干欺": "gàn,qī",
  "干止": "gàn,zhǐ",
  "干求": "gàn,qiú",
  "干沐浴": "qián,mù,yù",
  "干没": "gān,mò",
  "干河": "gàn,hé",
  "干治": "gàn,zhì",
  "干法": "gàn,fǎ",
  "干泽": "gàn,zé",
  "干活": "gàn,huó",
  "干活儿": "gàn,huó,er",
  "干流": "gàn,liú",
  "干浄利索": "gàn,jìng,lì,suǒ",
  "干浄利落": "gàn,jìng,lì,luo",
  "干浄土": "qián,jìng,tǔ",
  "干浄地": "qián,jìng,dì",
  "干浅": "gàn,qiǎn",
  "干济": "gàn,jì",
  "干浴": "qián,yù",
  "干浼": "gàn,měi",
  "干涝": "gàn,lào",
  "干渎": "gàn,dú",
  "干渠": "gàn,qú",
  "干渡钱": "gàn,dù,qián",
  "干渣渣": "gàn,zhā,zhā",
  "干湿度地带性": "gàn,shī,dù,dì,dài,xìng",
  "干湿球温度表": "gàn,shī,qiú,wēn,dù,biǎo",
  "干溢": "qián,yì",
  "干溪": "qián,xī",
  "干溪台": "qián,xī,tái",
  "干漠": "qián,mò",
  "干漫": "gàn,màn",
  "干灾": "gàn,zāi",
  "干烦": "gàn,fán",
  "干焦": "gàn,jiāo",
  "干燋": "gàn,jiāo",
  "干燥地": "gān,zào,de",
  "干父": "gàn,fù",
  "干父之蛊": "gàn,fù,zhī,gǔ",
  "干物": "qián,wù",
  "干玃": "gàn,jué",
  "干理": "gàn,lǐ",
  "干甚": "gàn,shèn",
  "干甚么": "gàn,shèn,mǒ",
  "干用": "gàn,yòng",
  "干略": "gàn,lüè",
  "干痨": "gàn,láo",
  "干瘪": "gān,biě",
  "干白": "gàn,bái",
  "干直": "gàn,zhí",
  "干相思": "qián,xiāng,sī",
  "干着": "qián,zhe",
  "干着急": "gān,zháo,jí",
  "干矢橛": "gàn,shǐ,jué",
  "干研墨": "qián,yán,mò",
  "干祈": "gàn,qí",
  "干祫": "gàn,xiá",
  "干禁": "gàn,jìn",
  "干禄": "gàn,lù",
  "干福": "gàn,fú",
  "干突": "gàn,tū",
  "干窃": "gàn,qiè",
  "干竭": "gàn,jié",
  "干端坤倪": "gàn,duān,kūn,ní",
  "干策": "gàn,cè",
  "干䇲䇲": "gān,jiā,jiā",
  "干管": "gàn,guǎn",
  "干篾片": "qián,miè,piàn",
  "干糒": "gàn,bèi",
  "干索": "gàn,suǒ",
  "干累": "gān,lèi",
  "干纪": "gàn,jì",
  "干线": "gàn,xiàn",
  "干练": "gàn,liàn",
  "干练地": "gàn,liàn,de",
  "干细胞": "gàn,xì,bāo",
  "干绩": "gàn,jì",
  "干缦": "gàn,màn",
  "干缩": "qián,suō",
  "干罚": "gàn,fá",
  "干罢": "gàn,bà",
  "干群": "gàn,qún",
  "干羽": "gàn,yǔ",
  "干翮": "gàn,hé",
  "干翼": "gàn,yì",
  "干老子": "gàn,lǎo,zi",
  "干肃": "gàn,sù",
  "干肥": "gàn,féi",
  "干胏": "qián,fèi",
  "干能": "gàn,néng",
  "干脆地": "gān,cuì,de",
  "干脯": "gàn,fǔ",
  "干腊": "gàn,là",
  "干臣": "gàn,chén",
  "干舆": "gàn,yú",
  "干舞": "gàn,wǔ",
  "干船坞": "gàn,chuán,wù",
  "干色": "gàn,sè",
  "干茨腊": "gàn,cí,là",
  "干莫": "gàn,mò",
  "干菓": "qián,guǒ",
  "干萎": "gàn,wěi",
  "干营": "gàn,yíng",
  "干落": "qián,luò",
  "干落得": "qián,luò,de",
  "干蔗": "gàn,zhè",
  "干蛊": "gàn,gǔ",
  "干蛋": "gàn,dàn",
  "干血劳": "qián,xuè,láo",
  "干血浆": "qián,xuè,jiāng",
  "干血痨": "gàn,xuè,láo",
  "干裕": "gàn,yù",
  "干触": "gàn,chù",
  "干警": "gàn,jǐng",
  "干讬": "gàn,tuō",
  "干话": "gàn,huà",
  "干诟": "gàn,gòu",
  "干误": "gàn,wù",
  "干说": "gàn,shuō",
  "干请": "gàn,qǐng",
  "干谋": "gàn,móu",
  "干谢": "qián,xiè",
  "干豆": "gàn,dòu",
  "干豆腐": "gàn,dòu,fǔ",
  "干象辇": "gàn,xiàng,niǎn",
  "干豫": "gàn,yù",
  "干貌": "gàn,mào",
  "干质": "gàn,zhì",
  "干贽": "gàn,zhì",
  "干赏": "gàn,shǎng",
  "干越": "gàn,yuè",
  "干路": "gàn,lù",
  "干蹦蹦": "gàn,bèng,bèng",
  "干辅": "gàn,fǔ",
  "干辣辣": "gàn,là,là",
  "干达达": "gàn,dá,dá",
  "干运": "gàn,yùn",
  "干进": "gàn,jìn",
  "干逆": "gàn,nì",
  "干逜": "gàn,wǔ",
  "干逼": "gàn,bī",
  "干道": "gàn,dào",
  "干遮": "gàn,zhē",
  "干部": "gàn,bù",
  "干部四化": "gàn,bù,sì,huà",
  "干部学校": "gàn,bù,xué,xiào",
  "干都": "gàn,dōu",
  "干酒": "gàn,jiǔ",
  "干酢酒": "gàn,cù,jiǔ",
  "干钧": "gàn,jūn",
  "干错": "gàn,cuò",
  "干镆": "gàn,mò",
  "干阑": "gàn,lán",
  "干阿你": "gàn,ā,nǐ",
  "干阿妳": "qián,ā,nǎi",
  "干陬": "gàn,zōu",
  "干隐": "gàn,yǐn",
  "干隔涝汉子": "gàn,gé,lào,hàn,zi",
  "干雨": "qián,yǔ",
  "干雪": "qián,xuě",
  "干雷": "gàn,léi",
  "干霄": "gàn,xiāo",
  "干霄蔽日": "gàn,xiāo,bì,rì",
  "干面": "qián,miàn",
  "干革": "gàn,gé",
  "干韵": "gàn,yùn",
  "干颡": "gàn,sǎng",
  "干食": "gàn,shí",
  "干饰": "gàn,shì",
  "干馏": "gān,liú",
  "干马": "gàn,mǎ",
  "干鲜": "qián,xiān",
  "干鸟": "qián,niǎo",
  "干黩": "gàn,dú",
  "干鼎": "gàn,dǐng",
  "平上𫐌车": "píng,shàng,pēng,chē",
  "平侧": "píng,zè",
  "平凡地": "píng,fán,de",
  "平和地": "píng,hé,de",
  "平地一声": "píng,de,yī,shēng",
  "平地起波澜": "píng,de,qǐ,bō,lán",
  "平地起风": "píng,de,qǐ,fēng",
  "平均地": "píng,jūn,de",
  "平均数": "píng,jūn,shù",
  "平坦地": "píng,tǎn,de",
  "平处": "píng,chú",
  "平复帖": "píng,fù,tiē",
  "平天冠": "píng,tiān,guān",
  "平头数": "píng,tóu,shù",
  "平安地": "píng,ān,de",
  "平峒": "píng,dòng",
  "平巷": "píng,hàng",
  "平帖": "píng,tiē",
  "平常地": "píng,cháng,de",
  "平干": "píng,gàn",
  "平平静静地生活": "píng,píng,jìng,jìng,de,shēng,huó",
  "平放地": "píng,fàng,de",
  "平方反比定律": "píng,fāng,fǎn,bì,dìng,lǜ",
  "平方平均数": "píng,fāng,píng,jūn,shù",
  "平易地": "píng,yì,de",
  "平淡地": "píng,dàn,de",
  "平滑地": "píng,huá,de",
  "平直地": "píng,zhí,de",
  "平稳地": "píng,wěn,de",
  "平等地": "píng,děng,de",
  "平衡地": "píng,héng,de",
  "平调": "píng,diào",
  "平调曲": "píng,diào,qǔ",
  "平适": "píng,shì",
  "平铺": "píng,pù",
  "平铺直序": "píng,pù,zhí,xù",
  "平露": "píng,lù",
  "平静地": "píng,jìng,de",
  "平静地说": "píng,jìng,de,shuō",
  "平静地过去": "píng,jìng,de,guò,qù",
  "平面子": "píng,miàn,zi",
  "平面曲线": "píng,miàn,qū,xiàn",
  "年休假": "nián,xiū,jià",
  "年假": "nián,jià",
  "年均增长率": "nián,jūn,zēng,zhǎng,lǜ",
  "年复一年地": "nián,fù,yī,nián,de",
  "年头儿": "nián,tóu,er",
  "年头禁": "nián,tóu,jìn",
  "年家": "nián,jie",
  "年家子": "nián,jie,zǐ",
  "年少": "nián,shào",
  "年少无知": "nián,shào,wú,zhī",
  "年帖": "nián,tiē",
  "年成": "nián,cheng",
  "年数": "nián,shù",
  "年画儿": "nián,huà,er",
  "年谊世好": "nián,yì,shì,hào",
  "年轻地": "nián,qīng,de",
  "年轻有为": "nián,qīng,yǒu,wéi",
  "年载": "nián,zǎi",
  "年较差": "nián,jiào,chā",
  "年长": "nián,zhǎng",
  "并不在乎": "bìng,bù,zài,hu",
  "并不断地": "bìng,bù,duàn,de",
  "并不时地": "bìng,bù,shí,de",
  "并不是简单地": "bìng,bú,shì,jiǎn,dān,de",
  "并且自觉地": "bìng,qiě,zì,jué,de",
  "并为一谈": "bìng,wéi,yī,tán",
  "并卷": "bìng,juàn",
  "并处": "bìng,chǔ",
  "并夹": "bìng,jiā",
  "并州": "bīng,zhōu",
  "并巧妙地": "bìng,qiǎo,miào,de",
  "并排地": "bìng,pái,de",
  "并更好地": "bìng,gèng,hǎo,de",
  "并更好地实现": "bìng,gèng,hǎo,de,shí,xiàn",
  "并毂": "bìng,gū",
  "并相应地": "bìng,xiāng,yìng,de",
  "并肩地": "bìng,jiān,de",
  "并舍": "bìng,shè",
  "并载": "bìng,zǎi",
  "幸好地": "xìng,hǎo,de",
  "幸得": "xìng,de",
  "幸福地": "xìng,fú,de",
  "幸舍": "xìng,shè",
  "幸运地": "xìng,yùn,de",
  "幸运地拥有": "xìng,yùn,de,yōng,yǒu",
  "幺么": "yāo,mǒ",
  "幺么小丑": "yāo,mó,xiǎo,chǒu",
  "幺幺小丑": "yāo,mó,xiǎo,chǒu",
  "幻影地": "huàn,yǐng,de",
  "幻想地": "huàn,xiǎng,de",
  "幻数": "huàn,shù",
  "幻沤": "huàn,ōu",
  "幻觉地": "huàn,jué,de",
  "幼小地": "yòu,xiǎo,de",
  "幼稚地": "yòu,zhì,de",
  "幼累": "yòu,lèi",
  "幽兴": "yōu,xīng",
  "幽咽": "yōu,yè",
  "幽埏": "yōu,shān",
  "幽夐": "yōu,xuàn",
  "幽幽地": "yōu,yōu,de",
  "幽幽地说": "yōu,yōu,de,shuō",
  "幽折": "yōu,shé",
  "幽揵": "yōu,jiàn",
  "幽暗地": "yōu,àn,de",
  "幽朴": "yōu,piáo",
  "幽灵似地": "yōu,líng,shì,de",
  "幽灵般地": "yōu,líng,bān,de",
  "幽禁": "yōu,jìn",
  "幽𰱈": "yōu,yǒng",
  "幽轧": "yōu,zhá",
  "幽𬮴": "yōu,ān",
  "幽门螺旋杆菌": "yōu,mén,luó,xuán,gǎn,jūn",
  "幽门螺杆菌": "yōu,mén,luó,gǎn,jūn",
  "幽雅地": "yōu,yǎ,de",
  "幽靓": "yōu,liàng",
  "幽默地": "yōu,mò,de",
  "幽默地说": "yōu,mò,de,shuō",
  "广东音乐": "guǎng,dōng,yīn,yuè",
  "广为": "guǎng,wéi",
  "广义地说": "guǎng,yì,de,shuō",
  "广乐": "guǎng,yuè",
  "广博地": "guǎng,bó,de",
  "广泛地": "guǎng,fàn,de",
  "广泛深入地": "guǎng,fàn,shēn,rù,de",
  "广种薄收": "guǎng,zhòng,bó,shōu",
  "广舃": "guǎng,tuō",
  "广覃": "guǎng,qín",
  "广贲": "guǎng,bēn",
  "广阔地": "guǎng,kuò,de",
  "广陕": "guǎng,xiá",
  "广陵散绝": "guǎng,líng,sǎn,jué",
  "庄严地": "zhuāng,yán,de",
  "庄严宝相": "zhuāng,yán,bǎo,xiàng",
  "庄折": "zhuāng,shé",
  "庄稼": "zhuāng,jia",
  "庄稼人": "zhuāng,jia,rén",
  "庄稼户": "zhuāng,jia,hù",
  "庄稼户儿": "zhuāng,jia,hù,er",
  "庄稼汉": "zhuāng,jia,hàn",
  "庄稼活儿": "zhuāng,jia,huó,er",
  "庄重地": "zhuāng,zhòng,de",
  "庄重地说": "zhuāng,zhòng,de,shuō",
  "庆削": "qìng,xuē",
  "庆幸地说": "qìng,xìng,de,shuō",
  "庆忌冠": "qìng,jì,guān",
  "庆父": "qìng,fǔ",
  "庆覃": "qìng,qín",
  "庇荫": "bì,yìn",
  "床子": "chuáng,zi",
  "床铺": "chuáng,pù",
  "庌舍": "yǎ,shè",
  "序兴": "xù,xīng",
  "序数": "xù,shù",
  "序数词": "xù,shù,cí",
  "序累": "xù,lèi",
  "庐舍": "lú,shè",
  "库克船长": "kù,kè,chuán,zhǎng",
  "库帑": "kù,tǎng",
  "应世": "yìng,shì",
  "应举": "yìng,jǔ",
  "应书": "yìng,shū",
  "应事": "yìng,shì",
  "应人": "yìng,rén",
  "应从": "yìng,cóng",
  "应付": "yìng,fù",
  "应付自如": "yìng,fù,zì,rú",
  "应付裕如": "yìng,fù,yù,rú",
  "应令": "yìng,lìng",
  "应会": "yìng,huì",
  "应供": "yìng,gòng",
  "应俗": "yìng,sú",
  "应候": "yìng,hòu",
  "应偶": "yìng,ǒu",
  "应傲": "yìng,ào",
  "应允地": "yīng,yǔn,de",
  "应兆": "yìng,zhào",
  "应兵": "yìng,bīng",
  "应典": "yìng,diǎn",
  "应准": "yìng,zhǔn",
  "应刃而解": "yìng,rèn,ér,jiě",
  "应分": "yīng,fèn",
  "应刘": "yìng,liú",
  "应制": "yìng,zhì",
  "应副": "yìng,fù",
  "应力": "yìng,lì",
  "应力场": "yìng,lì,chǎng",
  "应务": "yìng,wù",
  "应劫": "yìng,jié",
  "应募": "yìng,mù",
  "应化": "yìng,huà",
  "应卒": "yìng,zú",
  "应卯": "yìng,mǎo",
  "应县": "yìng,xiàn",
  "应县木塔": "yìng,xiàn,mù,tǎ",
  "应取": "yìng,qǔ",
  "应受地": "yīng,shòu,de",
  "应变": "yìng,biàn",
  "应变力": "yìng,biàn,lì",
  "应变无方": "yìng,biàn,wú,fāng",
  "应变管理": "yìng,biàn,guǎn,lǐ",
  "应叟": "yìng,sǒu",
  "应口": "yìng,kǒu",
  "应召": "yìng,zhào",
  "应召女郎": "yìng,zhào,nǚ,láng",
  "应召站": "yìng,zhào,zhàn",
  "应合": "yìng,hé",
  "应名儿": "yìng,míng,ér",
  "应名点卯": "yìng,míng,diǎn,mǎo",
  "应命": "yìng,mìng",
  "应和": "yìng,hè",
  "应响": "yìng,xiǎng",
  "应唯": "yìng,wéi",
  "应喏": "yìng,nuò",
  "应嘴": "yìng,zuǐ",
  "应器": "yìng,qì",
  "应图": "yìng,tú",
  "应圉": "yìng,yǔ",
  "应城": "yìng,chéng",
  "应城市": "yìng,chéng,shì",
  "应塞": "yìng,sāi",
  "应声虫": "yìng,shēng,chóng",
  "应天": "yìng,tiān",
  "应天从人": "yìng,tiān,cóng,rén",
  "应天承运": "yìng,tiān,chéng,yùn",
  "应天顺人": "yìng,tiān,shùn,rén",
  "应天顺民": "yìng,tiān,shùn,mín",
  "应奉": "yìng,fèng",
  "应官": "yìng,guān",
  "应实": "yìng,shí",
  "应客": "yìng,kè",
  "应宰": "yìng,zǎi",
  "应容": "yìng,róng",
  "应对": "yìng,duì",
  "应对如响": "yìng,duì,rú,xiǎng",
  "应对如流": "yìng,duì,rú,liú",
  "应对得体": "yìng,duì,dé,tǐ",
  "应工": "yìng,gōng",
  "应市": "yìng,shì",
  "应干": "yìng,gàn",
  "应序": "yìng,xù",
  "应度": "yìng,dù",
  "应弦而倒": "yìng,xián,ér,dǎo",
  "应形": "yìng,xíng",
  "应役": "yìng,yì",
  "应征": "yìng,zhēng",
  "应待": "yìng,dài",
  "应律": "yìng,lǜ",
  "应徐": "yìng,xú",
  "应得": "yīng,de",
  "应徵": "yìng,zhǐ",
  "应德": "yìng,dé",
  "应心": "yìng,xīn",
  "应急": "yìng,jí",
  "应急待命": "yìng,jí,dài,mìng",
  "应急措施": "yìng,jí,cuò,shī",
  "应急照射": "yìng,jí,zhào,shè",
  "应感": "yìng,gǎn",
  "应成": "yìng,chéng",
  "应战": "yìng,zhàn",
  "应手": "yìng,shǒu",
  "应承": "yìng,chéng",
  "应报": "yìng,bào",
  "应指责地": "yīng,zhǐ,zé,de",
  "应捕": "yìng,bǔ",
  "应接": "yìng,jiē",
  "应接不暇": "yìng,jiē,bù,xiá",
  "应援": "yìng,yuán",
  "应敌": "yìng,dí",
  "应敕": "yìng,chì",
  "应教": "yìng,jiào",
  "应时": "yìng,shí",
  "应时地": "yìng,shí,de",
  "应时对景": "yìng,shí,duì,jǐng",
  "应昂": "yìng,áng",
  "应星": "yìng,xīng",
  "应春花": "yìng,chūn,huā",
  "应是": "yìng,shì",
  "应昴": "yìng,mǎo",
  "应景": "yìng,jǐng",
  "应景儿": "yìng,jǐng,er",
  "应有意识地": "yīng,yǒu,yì,shí,de",
  "应期": "yìng,qī",
  "应机立断": "yìng,jī,lì,duàn",
  "应权通变": "yìng,quán,tōng,biàn",
  "应条": "yìng,tiáo",
  "应格": "yìng,gé",
  "应步": "yìng,bù",
  "应求": "yìng,qiú",
  "应激": "yìng,jī",
  "应激反应": "yìng,jī,fǎn,yìng",
  "应激性": "yìng,jī,xìng",
  "应激源": "yìng,jī,yuán",
  "应点": "yìng,diǎn",
  "应物": "yìng,wù",
  "应猝": "yìng,cù",
  "应王": "yìng,wáng",
  "应现": "yìng,xiàn",
  "应瑞": "yìng,ruì",
  "应生": "yìng,shēng",
  "应用": "yìng,yòng",
  "应用层": "yìng,yòng,céng",
  "应用平台": "yìng,yòng,píng,tái",
  "应用数学": "yìng,yòng,shù,xué",
  "应用文": "yìng,yòng,wén",
  "应用物理": "yìng,yòng,wù,lǐ",
  "应用科学": "yìng,yòng,kē,xué",
  "应用程序": "yìng,yòng,chéng,xù",
  "应用程序接口": "yìng,yòng,chéng,xù,jiē,kǒu",
  "应用程序编程接口": "yìng,yòng,chéng,xù,biān,chéng,jiē,kǒu",
  "应用程式": "yìng,yòng,chéng,shì",
  "应用程式介面": "yìng,yòng,chéng,shì,jiè,miàn",
  "应用软件": "yìng,yòng,ruǎn,jiàn",
  "应用软体": "yìng,yòng,ruǎn,tǐ",
  "应用题": "yìng,yòng,tí",
  "应病": "yìng,bìng",
  "应真": "yìng,zhēn",
  "应矩": "yìng,jǔ",
  "应笔": "yìng,bǐ",
  "应符": "yìng,fú",
  "应答": "yìng,dá",
  "应答地": "yìng,dá,de",
  "应答如响": "yìng,dá,rú,xiǎng",
  "应答如流": "yìng,dá,rú,liú",
  "应约": "yìng,yuē",
  "应给": "yìng,gěi",
  "应绳": "yìng,shéng",
  "应缘": "yìng,yuán",
  "应考": "yìng,kǎo",
  "应聘": "yìng,pìn",
  "应聘者": "yìng,pìn,zhě",
  "应节合拍": "yìng,jié,hé,pāi",
  "应荐": "yìng,jiàn",
  "应行": "yìng,xíng",
  "应袭": "yìng,xí",
  "应讯": "yìng,xùn",
  "应记": "yìng,jì",
  "应诉": "yìng,sù",
  "应诊": "yìng,zhěn",
  "应诏": "yìng,zhào",
  "应试": "yìng,shì",
  "应试教育": "yìng,shì,jiào,yù",
  "应该好好地": "yīng,gāi,hǎo,hǎo,de",
  "应该更多地放在": "yīng,gāi,gèng,duō,de,fàng,zài",
  "应诺": "yìng,nuò",
  "应谊": "yìng,yì",
  "应谐": "yìng,xié",
  "应谢": "yìng,xiè",
  "应谶": "yìng,chèn",
  "应赞": "yìng,zàn",
  "应赴": "yìng,fù",
  "应身": "yìng,shēn",
  "应辟": "yìng,pì",
  "应运": "yìng,yùn",
  "应运而生": "yìng,yùn,ér,shēng",
  "应远": "yìng,yuǎn",
  "应迹": "yìng,jì",
  "应适": "yìng,shì",
  "应选": "yìng,xuǎn",
  "应邀": "yìng,yāo",
  "应酬": "yìng,chóu",
  "应金": "yìng,jīn",
  "应钟": "yìng,zhōng",
  "应门": "yìng,mén",
  "应阮": "yìng,ruǎn",
  "应陈": "yìng,chén",
  "应难": "yìng,nán",
  "应鞞": "yìng,bǐ",
  "应须": "yìng,xū",
  "应验": "yìng,yàn",
  "应鼔": "yìng,gǔ",
  "应鼙": "yìng,pí",
  "应龙": "yìng,lóng",
  "底处": "dǐ,chǔ",
  "底子": "dǐ,zi",
  "底数": "dǐ,shù",
  "底死谩生": "dǐ,sǐ,màn,shēng",
  "底片儿": "dǐ,piān,er",
  "底着": "dǐ,zhe",
  "店舍": "diàn,shè",
  "店铺": "diàn,pù",
  "店长": "diàn,zhǎng",
  "府帑": "fǔ,tǎng",
  "府干": "fǔ,gàn",
  "府舍": "fǔ,shè",
  "庞大地": "páng,dà,de",
  "庞眉白发": "páng,méi,bái,fà",
  "庞眉皓发": "páng,méi,hào,fà",
  "废兴": "fèi,xīng",
  "废卷": "fèi,juàn",
  "废弃地": "fèi,qì,de",
  "废物点心": "fèi,wù,diǎn,xin",
  "废着": "fèi,zhe",
  "废舍": "fèi,shè",
  "度人之心": "duó,rén,zhī,xīn",
  "度人之腹": "duó,rén,zhī,fù",
  "度假": "dù,jià",
  "度假区": "dù,jià,qū",
  "度假村": "dù,jià,cūn",
  "度关𦈡": "dù,guān,xū",
  "度君子之腹": "duó,jūn,zǐ,zhī,fù",
  "度己以绳": "duó,jǐ,yǐ,shéng",
  "度己失期": "duo,yi,shi,qi",
  "度德量力": "duó,dé,liàng,lì",
  "度数": "dù,shù",
  "座儿": "zuò,er",
  "座地式": "zuò,de,shì",
  "座子": "zuò,zi",
  "座椅套子": "zuò,yǐ,tào,zi",
  "庬洪": "máng,hóng",
  "庬𭱊": "máng,hòng",
  "庬鸿": "máng,hóng",
  "庭长": "tíng,zhǎng",
  "庭𬮤": "tíng,gé",
  "庳下": "bì,xià",
  "庳侧": "bì,cè",
  "庳小": "bì,xiǎo",
  "庳庐": "bì,lú",
  "庳恶": "bì,è",
  "庳湿": "bì,shī",
  "庳狭": "bì,xiá",
  "庳矢": "bì,shǐ",
  "庳细": "bì,xì",
  "庳陋": "bì,lòu",
  "庳隘": "bì,ài",
  "庵舍": "ān,shè",
  "庵观": "ān,guàn",
  "庶几": "shù,jī",
  "庶几乎": "shù,jī,hū",
  "康了": "kāng,liǎo",
  "康侯": "kāng,hòu",
  "康复中地": "kāng,fù,zhōng,de",
  "康巴藏区": "kāng,bā,zàng,qū",
  "康有为": "kāng,yǒu,wéi",
  "康老子": "kāng,lǎo,zi",
  "康适": "kāng,shì",
  "庸仆": "yōng,pú",
  "庸俗地": "yōng,sú,de",
  "庸缪": "yōng,miù",
  "庸𬮴": "yōng,ān",
  "庸𫘤": "yōng,ái",
  "廉价地": "lián,jià,de",
  "廉干": "lián,gàn",
  "廉折": "lián,shé",
  "廉㧑": "lián,huī",
  "廉絜": "lián,jié",
  "廊坊": "láng,fáng",
  "廊坊地区": "láng,fáng,dì,qū",
  "廊坊市": "láng,fáng,shì",
  "廊子": "láng,zi",
  "𫷮干": "yìn,gàn",
  "𫷮监生": "yìn,jiàn,shēng",
  "𫷮调": "yìn,diào",
  "廛舍": "chán,shè",
  "廨舍": "xiè,shè",
  "廪帑": "lǐn,tǎng",
  "延累": "yán,lèi",
  "延误": "yán,wu",
  "延误费": "yán,wu,fèi",
  "延𰷠": "yán,yí",
  "延边朝鲜族自治州": "yán,biān,cháo,xiǎn,zú,zì,zhì,zhōu",
  "延迟地": "yán,chí,de",
  "延长地": "yán,cháng,de",
  "延露": "yán,lù",
  "延颈跂踵": "yán,jǐng,qǐ,zhǒng",
  "廷折": "tíng,shé",
  "建侯": "jiàn,hòu",
  "建筑上地": "jiàn,zhù,shàng,de",
  "建行": "jiàn,háng",
  "建议有选择地": "jiàn,yì,yǒu,xuǎn,zé,de",
  "建设性地": "jiàn,shè,xìng,de",
  "建都": "jiàn,dū",
  "开倒车": "kāi,dào,chē",
  "开兴": "kāi,xīng",
  "开制地": "kāi,zhì,de",
  "开剖": "kāi,pōu",
  "开剥": "kāi,bāo",
  "开劫度人": "kāi,jié,duó,rén",
  "开华结果": "kāi,huā,jié,guǒ",
  "开卷": "kāi,juàn",
  "开卷有益": "kāi,juàn,yǒu,yì",
  "开发地": "kāi,fā,de",
  "开发银行": "kāi,fā,yín,háng",
  "开口子": "kāi,kǒu,zi",
  "开口成脏": "kāi,kǒu,chéng,zāng",
  "开哄": "kāi,hǒng",
  "开垦地": "kāi,kěn,de",
  "开小差": "kāi,xiǎo,chāi",
  "开已地": "kāi,yǐ,de",
  "开帆": "kāi,fān",
  "开心地": "kāi,xīn,de",
  "开心地离开了": "kāi,xīn,de,lí,kāi,le",
  "开心地笑": "kāi,xīn,de,xiào",
  "开心地说": "kāi,xīn,de,shuō",
  "开快地": "kāi,kuài,de",
  "开怀畅饮": "kāi,huán,chàng,yǐn",
  "开性地": "kāi,xìng,de",
  "开户行": "kāi,hù,háng",
  "开折": "kāi,shé",
  "开拓地": "kāi,tuò,de",
  "开杆": "kāi,gǎn",
  "开枱": "kāi,tái",
  "开查": "kāi,zhā",
  "开玩笑地": "kāi,wán,xiào,de",
  "开玩笑地说": "kāi,wán,xiào,de,shuō",
  "开硬地": "kāi,yìng,de",
  "开禁": "kāi,jìn",
  "开穵": "kāi,yà",
  "开箱倒笼": "kāi,xiāng,dǎo,lǒng",
  "开细地": "kāi,xì,de",
  "开缝": "kāi,fèng",
  "开胃地": "kāi,wèi,de",
  "开花儿": "kāi,huā,er",
  "开花地": "kāi,huā,de",
  "开花弹": "kāi,huā,dàn",
  "开讽": "kāi,fěng",
  "开载": "kāi,zǎi",
  "开速地": "kāi,sù,de",
  "开都河": "kāi,dū,hé",
  "开铺": "kāi,pù",
  "开锣喝道": "kāi,luó,hè,dào",
  "开风地": "kāi,fēng,de",
  "异口同声地": "yì,kǒu,tóng,shēng,de",
  "异口同声地说": "yì,kǒu,tóng,shēng,de,shuō",
  "异咯嗪": "yì,gē,qín",
  "异国情调": "yì,guó,qíng,diào",
  "异己分子": "yì,jǐ,fèn,zǐ",
  "异常地": "yì,cháng,de",
  "异常地快": "yì,cháng,de,kuài",
  "异数": "yì,shù",
  "异相地": "yì,xiāng,de",
  "异端地": "yì,duān,de",
  "异舍": "yì,shè",
  "异议分子": "yì,yì,fèn,zǐ",
  "弃予": "qì,yǔ",
  "弃卷": "qì,juàn",
  "弃好背盟": "qì,hǎo,bèi,méng",
  "弃撇": "qì,piě",
  "弃甲于思": "qì,jiǎ,yú,sāi",
  "弃𦈡": "qì,xū",
  "弃𦈡关": "qì,xū,guān",
  "弃𦈡年": "qì,xū,nián",
  "弃𦈡生": "qì,xū,shēng",
  "弃𦈡者": "qì,xū,zhě",
  "弃𦈡郎": "qì,xū,láng",
  "弃约背盟": "qì,yuē,bèi,méng",
  "弃背": "qì,bèi",
  "弃背天下": "qì,bèi,tiān,xià",
  "弃责": "qì,zhài",
  "弄不懂": "nòng,bu,dǒng",
  "弄不清": "nòng,bu,qīng",
  "弄口": "lòng,kǒu",
  "弄唐": "lòng,táng",
  "弄堂": "lòng,táng",
  "弄堂房子": "lòng,táng,fáng,zi",
  "弄成一团": "nòng,chéng,yì,tuán",
  "弄明白": "nòng,míng,bai",
  "弄混": "nòng,hún",
  "弄燕调莺": "nòng,yàn,diào,yīng",
  "弄白相": "nòng,bái,xiàng",
  "弄硶儿": "nòng,cén,ér",
  "弄竹弹丝": "nòng,zhú,dàn,sī",
  "弄管调弦": "nòng,guǎn,diào,xián",
  "弄粉调朱": "nòng,fěn,diào,zhū",
  "弄脏": "nòng,zāng",
  "弇中": "yān,zhōng",
  "弇侈": "yān,chǐ",
  "弇兹": "yān,zī",
  "弇口": "yān,kǒu",
  "弇山": "yān,shān",
  "弇州": "yān,zhōu",
  "弇敛": "yān,liǎn",
  "弇汗": "yān,hàn",
  "弇郁": "yān,yù",
  "弇鄙": "yān,bǐ",
  "弊仆": "bì,pú",
  "弊𢫬": "bì,shā",
  "弊𫏋": "bì,jué",
  "式子": "shì,zi",
  "式干": "shì,gàn",
  "弓子": "gōng,zi",
  "弓子铺": "gōng,zi,pù",
  "弓弦儿": "gōng,xián,er",
  "弓弹": "gōng,dàn",
  "弓杆轿子": "gōng,gǎn,jiào,zi",
  "弓背": "gōng,bèi",
  "弓腰曲背": "gōng,yāo,qū,bèi",
  "弓调马服": "gōng,diào,mǎ,fú",
  "弓鞬": "gōng,jiān",
  "引以为傲": "yǐn,yǐ,wéi,ào",
  "引以为憾": "yǐn,yǐ,wéi,hàn",
  "引以为戒": "yǐn,yǐ,wéi,jiè",
  "引以为耻": "yǐn,yǐ,wéi,chǐ",
  "引以为荣": "yǐn,yǐ,wéi,róng",
  "引以为鉴": "yǐn,yǐ,wéi,jiàn",
  "引力地": "yǐn,lì,de",
  "引子": "yǐn,zi",
  "引得": "yǐn,de",
  "引楯": "yǐn,dùn",
  "引注目地": "yǐn,zhù,mù,de",
  "引着": "yǐn,zháo",
  "引芯": "yǐn,xìn",
  "引诱人地": "yǐn,yòu,rén,de",
  "引调": "yǐn,diào",
  "引逮": "yǐn,dǎi",
  "弗敢专也": "fei,gan,zhuan,ye",
  "弗洛勒斯岛": "fú,luò,lēi,sī,dǎo",
  "弘此远谟": "hong,chi,yuan,mo",
  "弛侯": "chí,hòu",
  "弛禁": "chí,jìn",
  "弟兄们": "dì,xiōng,men",
  "弟舍": "dì,shè",
  "弟靡": "dì,mǐ",
  "张侯论": "zhāng,hòu,lùn",
  "张僧繇": "zhāng,sēng,yóu",
  "张冠李戴": "zhāng,guān,lǐ,dài",
  "张勋复辟": "zhāng,xūn,fù,bì",
  "张国焘": "zhāng,guó,tāo",
  "张大口地": "zhāng,dà,kǒu,de",
  "张女弹": "zhāng,nǚ,dàn",
  "张家长": "zhāng,jiā,zhǎng",
  "张家长李家短": "zhāng,jiā,zhǎng,lǐ,jiā,duǎn",
  "张春帆": "zhāng,chūn,fān",
  "张柏芝": "zhāng,bó,zhī",
  "张眼露睛": "zhāng,yǎn,lù,jīng",
  "张睢阳齿": "zhāng,suī,yáng,chǐ",
  "张罗": "zhāng,luo",
  "张脉偾兴": "zhāng,mài,fèn,xīng",
  "张荫桓": "zhāng,yìn,huán",
  "张角": "zhāng,jué",
  "张靓颖": "zhāng,liàng,yǐng",
  "弥天亘地": "mí,tiān,gèn,de",
  "弥日累夜": "mí,rì,lèi,yè",
  "弥牟": "mí,mù",
  "弥缝其阙": "mí,féng,qí,què",
  "弦乐": "xián,yuè",
  "弦乐器": "xián,yuè,qì",
  "弦乐队": "xián,yuè,duì",
  "弦数": "xián,shù",
  "弦诵不缀": "xián,sòng,bù,chuò",
  "弦鸣乐器": "xián,míng,yuè,qì",
  "弧长参数": "hú,cháng,cān,shù",
  "弭帖": "mǐ,tiē",
  "弯子": "wān,zi",
  "弯弯曲曲": "wān,wān,qū,qū",
  "弯弹": "wān,dàn",
  "弯曲": "wān,qū",
  "弯曲地": "wān,qū,de",
  "弯曲度": "wān,qū,dù",
  "弯曲空间": "wān,qū,kōng,jiān",
  "弯脖子": "wān,bó,zi",
  "弯腰驼背": "wān,yāo,tuó,bèi",
  "弱弱地": "ruò,ruò,de",
  "弱弱地问一句": "ruò,ruò,de,wèn,yī,jù",
  "弱管轻丝": "ruo,guan,qing,si",
  "弱累": "ruò,lèi",
  "弹丸": "dàn,wán",
  "弹丸之地": "dàn,wán,zhī,dì",
  "弹丸黑子": "dàn,wán,hēi,zǐ",
  "弹丸黑志": "dàn,wán,hēi,zhì",
  "弹举": "dàn,jǔ",
  "弹事": "dàn,shì",
  "弹体": "dàn,tǐ",
  "弹兑": "dàn,duì",
  "弹冠": "tán,guān",
  "弹冠振衣": "tán,guān,zhèn,yī",
  "弹冠振衿": "tán,guān,zhèn,jīn",
  "弹冠相庆": "tán,guān,xiāng,qìng",
  "弹冠结绶": "tán,guān,jié,shòu",
  "弹冰": "dàn,bīng",
  "弹击": "dàn,jī",
  "弹剑": "dàn,jiàn",
  "弹剥": "dàn,bāo",
  "弹包": "dàn,bāo",
  "弹匣": "dàn,xiá",
  "弹参": "dàn,cān",
  "弹唇": "dàn,chún",
  "弹坐": "dàn,zuò",
  "弹坑": "dàn,kēng",
  "弹墨": "dàn,mò",
  "弹墨绫": "dàn,mò,líng",
  "弹壳": "dàn,ké",
  "弹头": "dàn,tóu",
  "弹夹": "dàn,jiā",
  "弹子": "dàn,zǐ",
  "弹子房": "dàn,zǐ,fáng",
  "弹子涡": "dàn,zǐ,wō",
  "弹子窝": "dàn,zǐ,wō",
  "弹子锁": "dàn,zi,suǒ",
  "弹孔": "dàn,kǒng",
  "弹尽援绝": "dàn,jìn,yuán,jué",
  "弹尽粮绝": "dàn,jìn,liáng,jué",
  "弹幕": "dàn,mù",
  "弹弓": "dàn,gōng",
  "弹弦": "dàn,xián",
  "弹抨": "dàn,pēng",
  "弹抵": "dàn,dǐ",
  "弹拍": "dàn,pāi",
  "弹拨乐": "tán,bō,yuè",
  "弹拨乐器": "tán,bō,yuè,qì",
  "弹𫼝": "dàn,chōu",
  "弹文": "dàn,wén",
  "弹断": "dàn,duàn",
  "弹无虚发": "dàn,wú,xū,fā",
  "弹曲": "dàn,qǔ",
  "弹枉": "dàn,wǎng",
  "弹棊": "dàn,qí",
  "弹棋": "dàn,qí",
  "弹歌": "dàn,gē",
  "弹正": "dàn,zhèng",
  "弹毫": "dàn,háo",
  "弹治": "dàn,zhì",
  "弹泪": "dàn,lèi",
  "弹激": "dàn,jī",
  "弹爵": "dàn,jué",
  "弹片": "dàn,piàn",
  "弹珠": "dàn,zhū",
  "弹珠台": "dàn,zhū,tái",
  "弹疽": "dàn,jū",
  "弹痕": "dàn,hén",
  "弹痕累累": "dàn,hén,lěi,lěi",
  "弹痤": "dàn,cuó",
  "弹盘": "dàn,pán",
  "弹碁": "dàn,qí",
  "弹禁": "dàn,jìn",
  "弹窝": "dàn,wō",
  "弹章": "dàn,zhāng",
  "弹筋估两": "dàn,jīn,gū,liǎng",
  "弹算": "dàn,suàn",
  "弹𫄙": "dàn,jiū",
  "弹纬": "dàn,wěi",
  "弹肃": "dàn,sù",
  "弹腿": "dàn,tuǐ",
  "弹膛": "dàn,táng",
  "弹药": "dàn,yào",
  "弹药库": "dàn,yào,kù",
  "弹药补给站": "dàn,yào,bǔ,jǐ,zhàn",
  "弹觔估两": "dàn,jīn,gū,liǎng",
  "弹议": "dàn,yì",
  "弹论": "dàn,lùn",
  "弹诋": "dàn,dǐ",
  "弹诘": "dàn,jié",
  "弹责": "dàn,zé",
  "弹路": "dàn,lù",
  "弹违": "dàn,wéi",
  "弹道": "dàn,dào",
  "弹道学地": "dàn,dào,xué,de",
  "弹道导弹": "dàn,dào,dǎo,dàn",
  "弹金": "dàn,jīn",
  "弹𨱑": "dàn,huáng",
  "弹铗": "dàn,jiá",
  "弹铗无鱼": "dàn,jiá,wú,yú",
  "弹镊": "dàn,niè",
  "弹随": "dàn,suí",
  "弹雨": "dàn,yǔ",
  "弹雨枪林": "dàn,yǔ,qiāng,lín",
  "弹驳": "dàn,bó",
  "弹骨": "dàn,gǔ",
  "弹黜": "dàn,chù",
  "强不知以为知": "qiǎng,bù,zhī,yǐ,wéi,zhī",
  "强买强卖": "qiǎng,mǎi,qiǎng,mài",
  "强予": "qiáng,yǔ",
  "强人": "qiǎng,rén",
  "强人所难": "qiǎng,rén,suǒ,nán",
  "强作解人": "qiǎng,zuò,jiě,rén",
  "强健地": "qiáng,jiàn,de",
  "强凫变鹤": "qiǎng,fú,biàn,hè",
  "强制地": "qiáng,zhì,de",
  "强制性地": "qiáng,zhì,xìng,de",
  "强劲": "qiáng,jìng",
  "强劲地": "qiáng,jìng,de",
  "强劳": "qiǎng,láo",
  "强取地": "qiáng,qǔ,de",
  "强嘴": "jiàng,zuǐ",
  "强嘴拗舌": "jiàng,zuǐ,niù,shé",
  "强嘴硬牙": "jiàng,zuǐ,yìng,yá",
  "强地": "qiáng,de",
  "强壮地": "qiáng,zhuàng,de",
  "强大地": "qiáng,dà,de",
  "强头强脑": "qiáng,tóu,jiàng,nǎo",
  "强夺地": "qiáng,duó,de",
  "强将": "qiáng,jiàng",
  "强将手下无弱兵": "qiáng,jiàng,shǒu,xià,wú,ruò,bīng",
  "强干": "qiáng,gàn",
  "强弓劲弩": "qiáng,gōng,jìng,nǔ",
  "强征": "qiǎng,zhēng",
  "强得易贫": "qiǎng,dé,yì,pín",
  "强折贱买": "qiáng,shé,jiàn,mǎi",
  "强拉": "qiǎng,lā",
  "强撑": "qiǎng,chēng",
  "强文假醋": "qiǎng,wén,jiǎ,cù",
  "强文浉醋": "qiǎng,wén,shī,cù",
  "强暴地": "qiáng,bào,de",
  "强有力地": "qiáng,yǒu,lì,de",
  "强横": "qiáng,hèng",
  "强死强活": "qiǎng,sǐ,qiǎng,huó",
  "强死赖活": "qiǎng,sǐ,lài,huó",
  "强求": "qiǎng,qiú",
  "强求地": "qiǎng,qiú,de",
  "强烈地": "qiáng,liè,de",
  "强烈地吸引住": "qiáng,liè,de,xī,yǐn,zhù",
  "强烈地感觉到": "qiáng,liè,de,gǎn,jué,dào",
  "强煞": "qiáng,shà",
  "强留": "qiǎng,liú",
  "强直自遂": "qiáng,zhí,zì,suí",
  "强硬地": "qiáng,yìng,de",
  "强笑": "qiǎng,xiào",
  "强而后可": "qiǎng,ér,hòu,kě",
  "强聒不舍": "qiǎng,guō,bù,shě",
  "强自取折": "qiáng,zì,qǔ,shé",
  "强行地": "qiáng,xíng,de",
  "强识": "qiáng,zhì",
  "强识博闻": "qiǎng,shí,bó,wén",
  "强词": "qiǎng,cí",
  "强词夺正": "qiǎng,cí,duó,zhèng",
  "强词夺理": "qiǎng,cí,duó,lǐ",
  "强调": "qiáng,diào",
  "强调地": "qiáng,diào,de",
  "强辩到底": "qiǎng,biàn,dào,dǐ",
  "强迫": "qiǎng,pò",
  "强迫人地": "qiǎng,pò,rén,de",
  "强迫劳动": "qiǎng,pò,láo,dòng",
  "强迫地": "qiǎng,pò,de",
  "强迫性": "qiǎng,pò,xìng",
  "强迫性储物症": "qiǎng,pò,xìng,chǔ,wù,zhèng",
  "强迫性性行为": "qiǎng,pò,xìng,xìng,xíng,wéi",
  "强迫症": "qiǎng,pò,zhèng",
  "强迫自己不断地": "qiǎng,pò,zì,jǐ,bù,duàn,de",
  "强迫观念": "qiǎng,pò,guān,niàn",
  "强逼": "qiǎng,bī",
  "强酒": "qiǎng,jiǔ",
  "强颜": "qiǎng,yán",
  "强颜欢笑": "qiǎng,yán,huān,xiào",
  "强食自爱": "qiǎng,shí,zì,ài",
  "强食靡角": "qiǎng,shí,mí,jiǎo",
  "𭚦弩": "kuò,nǔ",
  "𭚦骑": "kuò,qí",
  "归兴": "guī,xīng",
  "归咎地": "guī,jiù,de",
  "归因地": "guī,yīn,de",
  "归处": "guī,chǔ",
  "归帆": "guī,fān",
  "归煞": "guī,shà",
  "归省": "guī,xǐng",
  "归着": "guī,zhe",
  "归纳地": "guī,nà,de",
  "归罪地": "guī,zuì,de",
  "归蕃": "guī,fān",
  "归还": "guī,huán",
  "归降": "guī,xiáng",
  "当一天和尚撞一天钟": "dāng,yì,tiān,hé,shàng,zhuàng,yì,tiān,zhōng",
  "当一日和尚撞一天钟": "dāng,yī,rì,hé,shàng,zhuàng,yì,tiān,zhōng",
  "当上": "dāng,shang",
  "当下地": "dāng,xià,de",
  "当不住": "dāng,bú,zhù",
  "当中间儿": "dāng,zhōng,jiān,er",
  "当之无愧地": "dāng,zhī,wú,kuì,de",
  "当作": "dàng,zuò",
  "当做": "dàng,zuò",
  "当出去": "dàng,chū,qù",
  "当前地": "dāng,qián,de",
  "当卖": "dàng,mài",
  "当口儿": "dāng,kǒu,er",
  "当呼格地": "dāng,hū,gé,de",
  "当回事": "dàng,huí,shì",
  "当回事儿": "dàng,huí,shì,er",
  "当处": "dāng,chǔ",
  "当外人看": "dàng,wài,rén,kàn",
  "当夜": "dàng,yè",
  "当天": "dàng,tiān",
  "当天事当天毕": "dàng,tiān,shì,dàng,tiān,bì",
  "当头棒喝": "dāng,tóu,bàng,hè",
  "当宁": "dāng,zhù",
  "当差": "dāng,chāi",
  "当应": "dāng,yìng",
  "当得": "dāng,de",
  "当成": "dàng,chéng",
  "当户": "dàng,hù",
  "当掉": "dàng,diào",
  "当是": "dàng,shì",
  "当晚": "dàng,wǎn",
  "当月": "dàng,yuè",
  "当月钱": "dàng,yuè,qián",
  "当机": "dàng,jī",
  "当然地": "dāng,rán,de",
  "当甚么": "dāng,shèn,mǒ",
  "当真": "dàng,zhēn",
  "当真假": "dàng,zhēn,jiǎ",
  "当着": "dāng,zhe",
  "当票": "dàng,piào",
  "当票子": "dàng,piào,zi",
  "当行": "dāng,háng",
  "当行出色": "dāng,háng,chū,sè",
  "当行家": "dāng,háng,jiā",
  "当𬤀": "dāng,háo",
  "当路子": "dāng,lù,zi",
  "当轴处中": "dāng,zhóu,chǔ,zhōng",
  "当道撅坑": "dāng,dào,jué,kēng",
  "当铺": "dàng,pù",
  "当铺老板": "dàng,pù,lǎo,bǎn",
  "当间": "dāng,jiàn",
  "当间儿": "dāng,jiàn,ér",
  "当面是人背后是鬼": "dāng,miàn,shì,rén,bèi,hòu,shì,guǐ",
  "当面输心背面笑": "dāng,miàn,shū,xīn,bèi,miàn,xiào",
  "当馆": "dàng,guǎn",
  "录相": "lù,xiàng",
  "彗孛": "huì,bó",
  "彗茀": "huì,bó",
  "彝数": "yí,shù",
  "彡姐": "xiǎn,zǐ",
  "形劫势禁": "xíng,jié,shì,jìn",
  "形单影只": "xíng,dān,yǐng,zhī",
  "形只影单": "xíng,zhī,yǐng,dān",
  "形孤影只": "xíng,gū,yǐng,zhī",
  "形容词地": "xíng,róng,cí,de",
  "形干": "xíng,gàn",
  "形式上地": "xíng,shì,shàng,de",
  "形式地": "xíng,shì,de",
  "形式逻辑": "xíng,shì,luó,ji",
  "形数": "xíng,shù",
  "形枉影曲": "xíng,wǎng,yǐng,qū",
  "形格势禁": "xíng,gé,shì,jìn",
  "形禁势格": "xíng,jìn,shì,gé",
  "形累": "xíng,lèi",
  "形象地": "xíng,xiàng,de",
  "形象地将": "xíng,xiàng,de,jiāng",
  "形象地称": "xíng,xiàng,de,chēng",
  "形象地说": "xíng,xiàng,de,shuō",
  "形载": "xíng,zǎi",
  "彤幢": "tóng,zhuàng",
  "彤彤": "tóng,tōng",
  "彩弹": "cǎi,dàn",
  "彩斿": "cǎi,yóu",
  "彩色地": "cǎi,sè,de",
  "彩色影片": "cǎi,sè,yǐng,piān",
  "彩色照片": "cǎi,sè,zhào,piān",
  "彪个子": "biāo,gè,zi",
  "彪子": "biāo,zi",
  "彬彬济济": "bīn,bīn,jǐ,jǐ",
  "彭丽媛": "péng,lì,yuán",
  "彭侯": "péng,hòu",
  "彭彭": "bāng,bāng",
  "彭篯": "péng,jiān",
  "彯撇": "piāo,piě",
  "彰明昭着": "zhāng,míng,zhāo,zhe",
  "彰明较着": "zhāng,míng,jiào,zhù",
  "彰瘅": "zhāng,dān",
  "彰着": "zhāng,zhe",
  "彰露": "zhāng,lù",
  "影像处理": "yǐng,xiàng,chǔ,lǐ",
  "影儿": "yǐng,er",
  "影削": "yǐng,xuē",
  "影只形单": "yǐng,zhī,xíng,dān",
  "影只形孤": "yǐng,zhī,xíng,gū",
  "影响地": "yǐng,xiǎng,de",
  "影子": "yǐng,zi",
  "影子内阁": "yǐng,zi,nèi,gé",
  "影子花": "yǐng,zi,huā",
  "影子语": "yǐng,zi,yǔ",
  "影射地": "yǐng,shè,de",
  "影片": "yǐng,piān",
  "影片儿": "yǐng,piān,er",
  "影调": "yǐng,diào",
  "影调剧": "yǐng,diào,jù",
  "彷似": "fǎng,sì",
  "彷髴": "páng,fèi",
  "役畜": "yì,xù",
  "役调": "yì,diào",
  "彻侯": "chè,hòu",
  "彻卷": "chè,juàn",
  "彻底地": "chè,dǐ,de",
  "彻底地做": "chè,dǐ,de,zuò",
  "彻底地征服了": "chè,dǐ,de,zhēng,fú,le",
  "彻底地想一想": "chè,dǐ,de,xiǎng,yī,xiǎng",
  "彻底地放弃": "chè,dǐ,de,fàng,qì",
  "彻底地消失": "chè,dǐ,de,xiāo,shī",
  "彻扎": "chè,zhā",
  "彻盷": "chè,tián",
  "彼一时此一时": "bǐ,yì,shí,cǐ,yì,shí",
  "彼倡此和": "bǐ,chàng,cǐ,hè",
  "彼唱此和": "bǐ,chàng,cǐ,hè",
  "彼得卢惨案": "bǐ,de,lú,cǎn,àn",
  "往上游地": "wǎng,shàng,yóu,de",
  "往后地": "wǎng,hòu,de",
  "往国外地": "wǎng,guó,wài,de",
  "往复地": "wǎng,fù,de",
  "往心里去": "wǎng,xīn,li,qù",
  "往数": "wǎng,shù",
  "往昔地": "wǎng,xī,de",
  "往泥里踩": "wǎng,nì,lǐ,cǎi",
  "往渚还汀": "wǎng,zhǔ,huán,tīng",
  "往载": "wǎng,zǎi",
  "往还": "wǎng,huán",
  "征传": "zhēng,zhuàn",
  "征剥": "zhēng,bāo",
  "征地卖地": "zhēng,de,mài,de",
  "征帆": "zhēng,fān",
  "征恠": "zhǐ,guài",
  "征扞": "zhēng,gǎn",
  "征数": "zhēng,shù",
  "征调": "zhēng,diào",
  "征贲": "zhēng,bēn",
  "征辟": "zhēng,bì",
  "徂背": "cú,bèi",
  "径直地": "jìng,zhí,de",
  "径行直遂": "jìng,xíng,zhí,suí",
  "径露": "jìng,lù",
  "待会": "dāi,hui",
  "待会儿": "dāi,huì,er",
  "待发育地": "dài,fā,yù,de",
  "待定系数法": "dài,dìng,xì,shù,fǎ",
  "待得": "dài,de",
  "待时守分": "dài,shí,shǒu,fèn",
  "待见": "dài,jian",
  "待贾而沽": "dài,gǔ,ér,gū",
  "徇铺": "xùn,pù",
  "徇难": "xùn,nàn",
  "很不幸地": "hěn,bù,xìng,de",
  "很不幸地碰上了": "hěn,bù,xìng,de,pèng,shàng,le",
  "很不错": "hěn,bú,cuò",
  "很仔细地": "hěn,zǐ,xì,de",
  "很体贴地": "hěn,tǐ,tiē,de",
  "很便宜地": "hěn,pián,yí,de",
  "很兴奋地": "hěn,xīng,fèn,de",
  "很兴奋地说": "hěn,xīng,fèn,de,shuō",
  "很准确地": "hěn,zhǔn,què,de",
  "很努力地": "hěn,nǔ,lì,de",
  "很厉害地": "hěn,lì,hài,de",
  "很可怕地": "hěn,kě,pà,de",
  "很听话地": "hěn,tīng,huà,de",
  "很响亮地": "hěn,xiǎng,liàng,de",
  "很均匀地": "hěn,jūn,yún,de",
  "很坚决地说": "hěn,jiān,jué,de,shuō",
  "很多地": "hěn,duō,de",
  "很大方地": "hěn,dà,fāng,de",
  "很好地": "hěn,hǎo,de",
  "很好地享受": "hěn,hǎo,de,xiǎng,shòu",
  "很好地使用": "hěn,hǎo,de,shǐ,yòng",
  "很好地修改": "hěn,hǎo,de,xiū,gǎi",
  "很好地实现": "hěn,hǎo,de,shí,xiàn",
  "很好地掌握": "hěn,hǎo,de,zhǎng,wò",
  "很好地控制": "hěn,hǎo,de,kòng,zhì",
  "很好地满足": "hěn,hǎo,de,mǎn,zú",
  "很好地生活": "hěn,hǎo,de,shēng,huó",
  "很好地用": "hěn,hǎo,de,yòng",
  "很好地画": "hěn,hǎo,de,huà",
  "很好地解决": "hěn,hǎo,de,jiě,jué",
  "很好地解决了": "hěn,hǎo,de,jiě,jué,le",
  "很好地解释了": "hěn,hǎo,de,jiě,shì,le",
  "很好地识别": "hěn,hǎo,de,shí,bié",
  "很好地说明了": "hěn,hǎo,de,shuō,míng,le",
  "很好地转变": "hěn,hǎo,de,zhuǎn,biàn",
  "很好地转换": "hěn,hǎo,de,zhuǎn,huàn",
  "很好地输入": "hěn,hǎo,de,shū,rù",
  "很好地达到": "hěn,hǎo,de,dá,dào",
  "很委婉地": "hěn,wěi,wǎn,de",
  "很委屈地说": "hěn,wěi,qū,de,shuō",
  "很安静地": "hěn,ān,jìng,de",
  "很客气地": "hěn,kè,qì,de",
  "很害羞地": "hěn,hài,xiū,de",
  "很小地": "hěn,xiǎo,de",
  "很少地": "hěn,shǎo,de",
  "很尴尬地": "hěn,gān,gà,de",
  "很巧妙地": "hěn,qiǎo,miào,de",
  "很干脆地": "hěn,gān,cuì,de",
  "很幸运地": "hěn,xìng,yùn,de",
  "很得意地": "hěn,dé,yì,de",
  "很得意地说": "hěn,dé,yì,de,shuō",
  "很快地": "hěn,kuài,de",
  "很快地写": "hěn,kuài,de,xiě",
  "很快地出现": "hěn,kuài,de,chū,xiàn",
  "很快地流": "hěn,kuài,de,liú",
  "很快地消失": "hěn,kuài,de,xiāo,shī",
  "很快地跑来": "hěn,kuài,de,pǎo,lái",
  "很快地飞": "hěn,kuài,de,fēi",
  "很惊奇地": "hěn,jīng,qí,de",
  "很慢地": "hěn,màn,de",
  "很投入地": "hěn,tóu,rù,de",
  "很方便地": "hěn,fāng,biàn,de",
  "很明显地": "hěn,míng,xiǎn,de",
  "很明智地": "hěn,míng,zhì,de",
  "很明白地": "hěn,míng,bái,de",
  "很晚地": "hěn,wǎn,de",
  "很有效地": "hěn,yǒu,xiào,de",
  "很有默契地": "hěn,yǒu,mò,qì,de",
  "很残酷地": "hěn,cán,kù,de",
  "很沮丧地": "hěn,jǔ,sàng,de",
  "很流畅地用": "hěn,liú,chàng,de,yòng",
  "很清楚地听到": "hěn,qīng,chǔ,de,tīng,dào",
  "很清楚地知道": "hěn,qīng,chǔ,de,zhī,dào",
  "很满意地": "hěn,mǎn,yì,de",
  "很爽地": "hěn,shuǎng,de",
  "很爽快地": "hěn,shuǎng,kuài,de",
  "很痛快地": "hěn,tòng,kuài,de",
  "很积极地": "hěn,jī,jí,de",
  "很稳定地": "hěn,wěn,deng,de",
  "很突然地": "hěn,tū,rán,de",
  "很简单地": "hěn,jiǎn,dān,de",
  "很紧密地": "hěn,jǐn,mì,de",
  "很紧张地": "hěn,jǐn,zhāng,de",
  "很累": "hěn,lèi",
  "很细地": "hěn,xì,de",
  "很耐心地": "hěn,nài,xīn,de",
  "很肯定地": "hěn,kěn,deng,de",
  "很脏": "hěn,zāng",
  "很腼腆地": "hěn,miǎn,tiǎn,de",
  "很自然地": "hěn,zì,rán,de",
  "很自由地": "hěn,zì,yóu,de",
  "很自由地打": "hěn,zì,yóu,de,dǎ",
  "很自觉地": "hěn,zì,jué,de",
  "很茫然地": "hěn,máng,rán,de",
  "很认真地": "hěn,rèn,zhēn,de",
  "很认真地看": "hěn,rèn,zhēn,de,kàn",
  "很详细地": "hěn,xiáng,xì,de",
  "很谦恭地": "hěn,qiān,gōng,de",
  "很负责地说": "hěn,fù,zé,de,shuō",
  "很轻松地": "hěn,qīng,sōng,de",
  "很轻蔑地": "hěn,qīng,miè,de",
  "很辛苦地": "hěn,xīn,kǔ,de",
  "很遗憾地": "hěn,yí,hàn,de",
  "很随便地": "hěn,suí,biàn,de",
  "很隐敝地": "hěn,yǐn,bì,de",
  "很难准确地反映": "hěn,nán,zhǔn,què,de,fǎn,yìng",
  "很顺利地": "hěn,shùn,lì,de",
  "很顺手地": "hěn,shùn,shǒu,de",
  "很高兴地": "hěn,gāo,xìng,de",
  "很高兴地说": "hěn,gāo,xìng,de,shuō",
  "徊肠伤气": "huí,cháng,shāng,qì",
  "律讽": "lǜ,fěng",
  "徍徥": "wā,shì",
  "徐徐地": "xú,xú,de",
  "徐徐地吹": "xú,xú,de,chuī",
  "徐熙媛": "xú,xī,yuán",
  "徐继畲": "xú,jì,yú",
  "徐缓地吹": "xú,huǎn,de,chuī",
  "徐缓地移动": "xú,huǎn,de,yí,dòng",
  "徒劳地": "tú,láo,de",
  "徒处": "tú,chǔ",
  "徒步地": "tú,bù,de",
  "徒然地": "tú,rán,de",
  "徒长": "tú,zhǎng",
  "得丧": "de,sàng",
  "得中": "dé,zhòng",
  "得也": "de,yě",
  "得也么": "de,yě,mǒ",
  "得了吧": "dé,le,ba",
  "得亏": "děi,kuī",
  "得亡": "de,wáng",
  "得仙": "de,xiān",
  "得代": "de,dài",
  "得众": "de,zhòng",
  "得似": "de,sì",
  "得位": "de,wèi",
  "得佛": "de,fó",
  "得使": "de,shǐ",
  "得便宜卖乖": "dé,pián,yi,mài,guāi",
  "得俊": "de,jùn",
  "得全": "de,quán",
  "得其所": "de,qí,suǒ",
  "得兼": "de,jiān",
  "得凤": "de,fèng",
  "得功夫": "de,gōng,fū",
  "得勿": "de,wù",
  "得卜": "de,bǔ",
  "得句": "de,jù",
  "得可以": "de,kě,yǐ",
  "得合": "de,hé",
  "得君": "de,jūn",
  "得命": "de,mìng",
  "得售": "de,shòu",
  "得喝水了": "děi,hē,shuǐ,le",
  "得国": "de,guó",
  "得地": "de,dì",
  "得地里": "de,dì,lǐ",
  "得墨忒耳": "de,mò,tuī,ěr",
  "得士": "de,shì",
  "得壹": "de,yī",
  "得壹元宝": "de,yī,yuán,bǎo",
  "得壹钱": "de,yī,qián",
  "得姓": "de,xìng",
  "得宝歌": "de,bǎo,gē",
  "得实": "de,shí",
  "得对": "de,duì",
  "得寿": "de,shòu",
  "得尔塔": "děi,ěr,tǎ",
  "得岁": "de,suì",
  "得工夫": "de,gōng,fū",
  "得巧": "de,qiǎo",
  "得己": "de,jǐ",
  "得已": "de,yǐ",
  "得年": "de,nián",
  "得幸": "de,xìng",
  "得度": "de,dù",
  "得当": "dé,dàng",
  "得当地": "dé,dàng,de",
  "得彩": "de,cǎi",
  "得很": "de,hěn",
  "得得": "de,de",
  "得得地响": "dé,dé,de,xiǎng",
  "得心应手": "dé,xīn,yìng,shǒu",
  "得性": "de,xìng",
  "得意地笑了": "dé,yì,de,xiào,le",
  "得意地笑着": "dé,yì,de,xiào,zhe",
  "得意地笑笑": "dé,yì,de,xiào,xiào",
  "得意洋洋地": "dé,yì,yáng,yáng,de",
  "得所": "de,suǒ",
  "得托": "de,tuō",
  "得按": "de,àn",
  "得放手时须放手": "de,fàng,shǒu,shí,xū,fàng,shǒu",
  "得政": "de,zhèng",
  "得故子": "de,gù,zǐ",
  "得数": "dé,shù",
  "得旨": "de,zhǐ",
  "得时": "de,shí",
  "得月": "de,yuè",
  "得朋": "de,péng",
  "得来": "de,lái",
  "得来全不费工夫": "de,lái,quán,bù,fèi,gōng,fū",
  "得极": "de,jí",
  "得果": "de,guǒ",
  "得样儿": "de,yàng,ér",
  "得桂": "de,guì",
  "得案": "de,àn",
  "得正": "de,zhèng",
  "得死": "de,sǐ",
  "得毋": "de,wú",
  "得民": "de,mín",
  "得玑": "de,jī",
  "得理": "de,lǐ",
  "得用": "de,yòng",
  "得男": "de,nán",
  "得眼": "de,yǎn",
  "得着": "dé,zháo",
  "得神": "de,shén",
  "得空": "dé,kòng",
  "得第": "de,dì",
  "得策": "de,cè",
  "得筹": "de,chóu",
  "得算": "de,suàn",
  "得职": "de,zhí",
  "得胜地": "dé,shèng,de",
  "得能": "de,néng",
  "得脱": "de,tuō",
  "得至宝": "de,zhì,bǎo",
  "得舆": "de,yú",
  "得获": "de,huò",
  "得薄能鲜": "dé,bó,néng,xiān",
  "得行": "de,xíng",
  "得衷": "de,zhōng",
  "得要": "děi,yào",
  "得解": "de,jiě",
  "得言": "de,yán",
  "得请": "de,qǐng",
  "得负": "de,fù",
  "得赢": "de,yíng",
  "得趣": "de,qù",
  "得路": "de,lù",
  "得辛": "de,xīn",
  "得辠": "de,zuì",
  "得这": "de,zhè",
  "得适": "de,shì",
  "得途": "de,tú",
  "得间": "dé,jiàn",
  "得隽": "de,juàn",
  "得雄": "de,xióng",
  "得霜鹰": "de,shuāng,yīng",
  "得非": "de,fēi",
  "得靠": "de,kào",
  "得马折足": "dé,mǎ,shé,zú",
  "得鹿": "de,lù",
  "徘徊地": "pái,huái,de",
  "徙处": "xǐ,chǔ",
  "徙舍": "xǐ,shè",
  "徙薪曲突": "xǐ,xīn,qū,tū",
  "御仆": "yù,pú",
  "御史大夫": "yù,shǐ,dài,fū",
  "御堤": "yù,dī",
  "御干": "yù,qián",
  "御扞": "yù,gǎn",
  "循分": "xún,fèn",
  "循化撒拉族自治县": "xún,huà,sǎ,lā,zú,zì,zhì,xiàn",
  "循咀": "xún,zuǐ",
  "循揣": "xún,chuāi",
  "循环地": "xún,huán,de",
  "循环小数": "xún,huán,xiǎo,shù",
  "循着": "xún,zhe",
  "循翫": "xún,wàn",
  "循行": "xún,háng",
  "微丝血管": "wēi,sī,xuè,guǎn",
  "微为繁富": "wei,wei,fan,fu",
  "微亮地": "wēi,liàng,de",
  "微伺": "wēi,sì",
  "微创手术": "wēi,chuāng,shǒu,shù",
  "微处理器": "wēi,chǔ,lǐ,qì",
  "微处理机": "wēi,chǔ,lǐ,jī",
  "微妙地": "wēi,miào,de",
  "微小地": "wēi,xiǎo,de",
  "微开地": "wēi,kāi,de",
  "微弱地": "wēi,ruò,de",
  "微微了了": "wēi,wēi,liǎo,liǎo",
  "微微地": "wēi,wēi,de",
  "微微地笑着": "wēi,wēi,de,xiào,zhe",
  "微急地": "wēi,jí,de",
  "微晕": "wēi,yùn",
  "微笑地": "wēi,xiào,de",
  "微笑地说": "wēi,xiào,de,shuō",
  "微累": "wēi,lèi",
  "微细地": "wēi,xì,de",
  "微薄": "wēi,bó",
  "微血管": "wēi,xuè,guǎn",
  "微行地": "wēi,xíng,de",
  "微讽": "wēi,fěng",
  "微量地": "wēi,liàng,de",
  "微露": "wēi,lù",
  "徵士": "zhǐ,shì",
  "徵实": "zhǐ,shí",
  "德先生": "dé,xiān,sheng",
  "德兴": "dé,xīng",
  "德兴市": "dé,xīng,shì",
  "德国汉莎航空公司": "dé,guó,hàn,shā,háng,kōng,gōng,sī",
  "德州地区": "dé,zhōu,de,qū",
  "德州扒鸡": "dé,zhōu,pá,jī",
  "德干高原": "dé,gàn,gāo,yuán",
  "德意志银行": "dé,yì,zhì,yín,háng",
  "德累斯顿": "dé,lèi,sī,dùn",
  "德莱塞": "dé,lái,sè",
  "德薄": "dé,bó",
  "德薄才疏": "dé,bó,cái,shū",
  "德薄能鲜": "dé,bó,néng,xiǎn",
  "德都": "dé,dū",
  "德都县": "dé,dū,xiàn",
  "徼伺": "jiǎo,sì",
  "徼巡": "jiào,xún",
  "徽数": "huī,shù",
  "徽调": "huī,diào",
  "𪫌徸": "lòng,chōng",
  "心不在焉地": "xīn,bù,zài,yān,de",
  "心中一懔": "xīn,zhōng,yì,lǐn",
  "心中偷偷地": "xīn,zhōng,tōu,tōu,de",
  "心中无数": "xīn,zhōng,wú,shù",
  "心中有数": "xīn,zhōng,yǒu,shù",
  "心事重重": "xīn,shì,chóng,chóng",
  "心兴": "xīn,xīng",
  "心切": "xīn,qiè",
  "心在魏阙": "xīn,zài,wèi,què",
  "心如刀剉": "xīn,rú,dāo,yíng",
  "心存魏阙": "xīn,cún,wèi,què",
  "心宽体胖": "xīn,kuān,tǐ,pán",
  "心宿二": "xīn,xiù,èr",
  "心尖子": "xīn,jiān,zi",
  "心广体胖": "xīn,guǎng,tǐ,pán",
  "心怀魏阙": "xīn,huái,wèi,què",
  "心急吃不了热豆腐": "xīn,jí,chī,bu,liǎo,rè,dòu,fu",
  "心急火燎": "xīn,jí,huǒ,liǎo",
  "心悬魏阙": "xīn,xuán,wèi,què",
  "心情地流淌": "xīn,qíng,de,liú,tǎng",
  "心慌撩乱": "xīn,huāng,liáo,luàn",
  "心手相应": "xīn,shǒu,xiāng,yìng",
  "心拙口夯": "xīn,zhuō,kǒu,bèn",
  "心数": "xīn,shù",
  "心无挂碍": "xīn,wú,guài,ài",
  "心歉歉地": "xīn,qiàn,qiàn,de",
  "心毒地": "xīn,dú,de",
  "心满意足地看": "xīn,mǎn,yì,zú,de,kàn",
  "心灵感应": "xīn,líng,gǎn,yìng",
  "心照不宣地": "xīn,zhào,bù,xuān,de",
  "心理上地": "xīn,lǐ,shàng,de",
  "心理地": "xīn,lǐ,de",
  "心理学地": "xīn,lǐ,xué,de",
  "心电感应": "xīn,diàn,gǎn,yìng",
  "心疼地": "xīn,téng,de",
  "心痒难挝": "xīn,yǎng,nán,zhuā",
  "心痛地说": "xīn,tòng,de,shuō",
  "心眼儿": "xīn,yǎn,er",
  "心瞻魏阙": "xīn,zhān,wèi,què",
  "心神不属": "xīn,shén,bù,zhǔ",
  "心窝儿": "xīn,wō,er",
  "心肌梗塞": "xīn,jī,gěng,sè",
  "心背": "xīn,bèi",
  "心虚地说": "xīn,xū,de,shuō",
  "心血": "xīn,xuè",
  "心血来潮": "xīn,xuè,lái,cháo",
  "心血管": "xīn,xuè,guǎn",
  "心血管疾病": "xīn,xuè,guǎn,jí,bìng",
  "心趄": "xīn,jū",
  "心里": "xīn,li",
  "心里有数": "xīn,lǐ,yǒu,shù",
  "心里有鬼": "xīn,li,yǒu,guǐ",
  "心里痒痒": "xīn,lǐ,yǎng,yang",
  "心里美萝卜": "xīn,li,měi,luó,bo",
  "心里话": "xīn,li,huà",
  "心里陡地": "xīn,lǐ,dǒu,de",
  "心长发短": "xīn,cháng,fà,duǎn",
  "心驰魏阙": "xīn,chí,wèi,què",
  "必丢仆答": "bì,diū,pú,dá",
  "必和必拓": "bì,huó,bì,tuò",
  "必定地": "bì,deng,de",
  "必应": "bì,yìng",
  "必得": "bì,děi",
  "必必剥剥": "bì,bì,bāo,bāo",
  "必然地": "bì,rán,de",
  "必要地": "bì,yào,de",
  "必需地": "bì,xū,de",
  "必须地": "bì,xū,de",
  "忆鹤华亭": "yì,hè,huà,tíng",
  "忌妒": "jì,du",
  "忌禁": "jì,jìn",
  "忍不住": "rěn,bu,zhù",
  "忍不住地": "rěn,bú,zhù,de",
  "忍不住地想": "rěn,bú,zhù,de,xiǎng",
  "忍从地": "rěn,cóng,de",
  "忍得": "rěn,de",
  "忍得住": "rěn,de,zhù",
  "忍耐地": "rěn,nài,de",
  "忍苦耐劳": "rěn,kǔ,nai,láo",
  "忍饥挨饿": "rěn,jī,ái,è",
  "忏悔地": "chàn,huǐ,de",
  "忒忒": "tuī,tuī",
  "忒楞楞": "tuī,lèng,lèng",
  "忒楞楞腾": "tuī,lèng,lèng,téng",
  "忒煞": "tè,shà",
  "忖度": "cǔn,duó",
  "志干": "zhì,gàn",
  "志愿地": "zhì,yuàn,de",
  "忘不了": "wàng,bù,liǎo",
  "忘却地": "wàng,què,de",
  "忘恩背义": "wàng,ēn,bèi,yì",
  "忘我地": "wàng,wǒ,de",
  "忙乱地": "máng,luàn,de",
  "忙叨叨": "máng,dāo,dao",
  "忙得不亦乐乎": "máng,de,bú,yì,lè,hū",
  "忙忙叨叨": "máng,mang,dāo,dāo",
  "忙活": "máng,huo",
  "忙着": "máng,zhe",
  "忙碌地": "máng,lù,de",
  "忙碌地来回": "máng,lù,de,lái,huí",
  "忝累": "tiǎn,lèi",
  "忞忞": "wěn,wěn",
  "忠义地": "zhōng,yì,de",
  "忠仆": "zhōng,pú",
  "忠厚地": "zhōng,hòu,de",
  "忠实地": "zhōng,shí,de",
  "忠干": "zhōng,gàn",
  "忠朴": "zhōng,piáo",
  "忠诚地": "zhōng,chéng,de",
  "忠贞地": "zhōng,zhēn,de",
  "忠靖冠": "zhōng,jìng,guān",
  "忠静冠": "zhōng,jìng,guān",
  "忤累": "wǔ,lèi",
  "忧伤地": "yōu,shāng,de",
  "忧国地": "yōu,guó,de",
  "忧愁地": "yōu,chóu,de",
  "忧虑地": "yōu,lǜ,de",
  "忧郁地": "yōu,yù,de",
  "忨愒": "wán,kài",
  "快乐地": "kuài,lè,de",
  "快心遂意": "kuài,xīn,suí,yì",
  "快快乐乐地": "kuài,kuài,lè,lè,de",
  "快快地": "kuài,kuài,de",
  "快捷地": "kuài,jié,de",
  "快捷地设置": "kuài,jié,de,shè,zhì",
  "快板儿": "kuài,bǎn,er",
  "快活": "kuài,huo",
  "快活地": "kuài,huó,de",
  "快炙背": "kuài,zhì,bèi",
  "快点儿": "kuài,diǎn,er",
  "快行家": "kuài,háng,jiā",
  "快适": "kuài,shì",
  "快速地": "kuài,sù,de",
  "快速地切换": "kuài,sù,de,qiè,huàn",
  "快速地消散": "kuài,sù,de,xiāo,sàn",
  "快速地跑": "kuài,sù,de,pǎo",
  "忮忒": "zhì,tuī",
  "念头": "niàn,tou",
  "忸忕": "niǔ,tài",
  "忻懽": "xīn,guàn",
  "忻翘": "xīn,qiào",
  "忻适": "xīn,shì",
  "忽剌巴儿": "hū,là,bā,er",
  "忽喇喇": "hū,là,là",
  "忽悠": "hū,you",
  "忿忿地": "fèn,fèn,de",
  "忿怒地": "fèn,nù,de",
  "忿疐": "fèn,dì",
  "怀什": "huái,shí",
  "怀念地": "huái,niàn,de",
  "怀恨地": "huái,hèn,de",
  "怀恶意地": "huái,è,yì,de",
  "怀才不遇": "huái,cái,bú,yù",
  "怀挟": "huái,jiā",
  "怀揣": "huái,chuāi",
  "怀敌意地": "huái,dí,yì,de",
  "怀熟虑地": "huái,shú,lǜ,de",
  "怀疑地": "huái,yí,de",
  "怀疑性地": "huái,yí,xìng,de",
  "怀着鬼胎": "huái,zhe,guǐ,tāi",
  "怀葛": "huái,gě",
  "怀负义地": "huái,fù,yì,de",
  "态子": "tài,zi",
  "怎一个愁字了得": "zěn,yī,gè,chóu,zì,liǎo,dé",
  "怎么得了": "zěn,me,dé,liǎo",
  "怎么着": "zěn,me,zhāo",
  "怎当得": "zěn,dāng,de",
  "怎得": "zěn,de",
  "怎样地": "zěn,yàng,de",
  "怎样着": "zěn,yàng,zhe",
  "怎着": "zěn,zhe",
  "怎见得": "zěn,jiàn,de",
  "怒冠三挂": "nù,guān,sān,guà",
  "怒发": "nù,fà",
  "怒发冲冠": "nù,fà,chōng,guān",
  "怒号": "nù,háo",
  "怒吠地": "nù,fèi,de",
  "怒吽吽": "nù,hōng,hōng",
  "怒呺": "nù,háo",
  "怒哄哄": "nù,hǒng,hǒng",
  "怒喝": "nù,hè",
  "怒怼": "nù,duǐ",
  "怒目切齿": "nù,mù,qiè,chǐ",
  "怔住": "zhèng,zhù",
  "怔忪": "zhēng,zhōng",
  "怔怔": "zhèng,zhèng",
  "怔怔地": "zhēng,zhēng,de",
  "怔怔地看着": "zhēng,zhēng,de,kàn,zhe",
  "怔神儿": "zhēng,shén,er",
  "怕人地": "pà,rén,de",
  "怕头": "pà,tou",
  "怕羞地": "pà,xiū,de",
  "怕臊": "pà,sào",
  "怜悯地": "lián,mǐn,de",
  "怜慜": "lián,mǐn",
  "怜爱地": "lián,ài,de",
  "思干": "sī,gàn",
  "思想上地": "sī,xiǎng,shàng,de",
  "思想包袱": "sī,xiǎng,bāo,fu",
  "思慕地": "sī,mù,de",
  "思索地": "sī,suǒ,de",
  "思虑地": "sī,lǜ,de",
  "思覃": "sī,qín",
  "思辩地": "sī,biàn,de",
  "思遟": "sī,zhì",
  "思量": "sī,liáng",
  "怠惰地": "dài,duò,de",
  "怠慠": "dài,ào",
  "怠慢地": "dài,màn,de",
  "怠骜": "dài,ào",
  "急促地": "jí,cù,de",
  "急促地说": "jí,cù,de,shuō",
  "急促地谈": "jí,cù,de,tán",
  "急促而不清楚地说出": "jí,cù,ér,bù,qīng,chǔ,de,shuō,chū",
  "急公好义": "jí,gōng,hào,yì",
  "急公好施": "jí,gōng,hào,shī",
  "急切": "jí,qiè",
  "急切地": "jí,qiè,de",
  "急切地说": "jí,qiè,de,shuō",
  "急刹车": "jí,shā,chē",
  "急剧地": "jí,jù,de",
  "急功好利": "jí,gōng,hào,lì",
  "急动地": "jí,dòng,de",
  "急匆匆地": "jí,cōng,cōng,de",
  "急干": "jí,gàn",
  "急忙地": "jí,máng,de",
  "急忙地讲": "jí,máng,de,jiǎng",
  "急急地": "jí,jí,de",
  "急性子": "jí,xìng,zi",
  "急惊风撞着慢郎中": "jí,jīng,fēng,zhuàng,zhe,màn,láng,zhōng",
  "急拉地": "jí,lā,de",
  "急景": "jí,yǐng",
  "急景凋年": "jí,yǐng,diāo,nián",
  "急流地": "jí,liú,de",
  "急煞": "jí,shà",
  "急留骨碌": "jí,liú,gū,lù",
  "急着": "jí,zhe",
  "急穰穰": "jí,rǎng,rǎng",
  "急赶急地": "jí,gǎn,jí,de",
  "急赶急地赶来了": "jí,gǎn,jí,de,gǎn,lái,le",
  "急跳地": "jí,tiào,de",
  "急躁地": "jí,zào,de",
  "急迫地": "jí,pò,de",
  "急递铺": "jí,dì,pù",
  "急速地": "jí,sù,de",
  "急速地念": "jí,sù,de,niàn",
  "急速地说": "jí,sù,de,shuō",
  "急速地跳": "jí,sù,de,tiào",
  "急速地跳动": "jí,sù,de,tiào,dòng",
  "急难": "jí,nàn",
  "急需地": "jí,xū,de",
  "性偏好": "xìng,piān,hào",
  "性兴奋": "xìng,xīng,fèn",
  "性别地": "xìng,bié,de",
  "性别角色": "xìng,bié,jué,sè",
  "性子": "xìng,zi",
  "性急地": "xìng,jí,de",
  "性急地在": "xìng,jí,de,zài",
  "性欲地": "xìng,yù,de",
  "性爱地": "xìng,ài,de",
  "性禁忌": "xìng,jìn,jì",
  "性行为": "xìng,xíng,wéi",
  "性行为地": "xìng,xíng,wèi,de",
  "怨咽": "yuàn,yān",
  "怨回鹘": "yuàn,huí,hú",
  "怨天忧人": "yuàn,tiān,yóu,rén",
  "怨廻鹘": "yuàn,huí,hú",
  "怨恨地": "yuàn,hèn,de",
  "怨背": "yuàn,bèi",
  "怨艾": "yuàn,yì",
  "怨诗行": "yuàn,shī,háng",
  "怨调": "yuàn,diào",
  "怪不到": "guài,bú,dào",
  "怪不着": "guài,bù,zháo",
  "怪叔叔": "guài,shū,shu",
  "怪天怪地": "guài,tiān,guài,de",
  "怪得": "guài,de",
  "怪念头": "guài,niàn,tou",
  "怪怪地": "guài,guài,de",
  "怪样儿": "guài,yàng,er",
  "怪物": "guài,wu",
  "怪物似地": "guài,wù,shì,de",
  "怪相": "guài,xiàng",
  "怪腔怪调": "guài,qiāng,guài,diào",
  "怪行货": "guài,háng,huò",
  "怪诞地": "guài,dàn,de",
  "怪调": "guài,diào",
  "怫异": "fèi,yì",
  "怯地": "qiè,de",
  "怯子": "qiè,zi",
  "怯弱地": "qiè,ruò,de",
  "怯怯地": "qiè,qiè,de",
  "怯怯地答": "qiè,qiè,de,dá",
  "怯懦地": "qiè,nuò,de",
  "怯条子": "qiè,tiáo,zi",
  "怯生生地": "qiè,shēng,shēng,de",
  "总书记": "zǒng,shū,ji",
  "总会会长": "zǒng,huì,huì,zhǎng",
  "总体规划": "zǒng,tǐ,guī,huà",
  "总供给": "zǒng,gōng,jǐ",
  "总偷偷地": "zǒng,tōu,tōu,de",
  "总务长": "zǒng,wù,zhǎng",
  "总参谋长": "zǒng,cān,móu,zhǎng",
  "总干": "zǒng,gàn",
  "总干事": "zǒng,gàn,shi",
  "总得": "zǒng,děi",
  "总㧛": "zǒng,lǎn",
  "总数": "zǒng,shù",
  "总是不时地": "zǒng,shì,bù,shí,de",
  "总是神秘地": "zǒng,shì,shén,mì,de",
  "总次数": "zǒng,cì,shù",
  "总理衙门": "zǒng,lǐ,yá,men",
  "总论地": "zǒng,lùn,de",
  "总铺": "zǒng,pù",
  "总长": "zǒng,zhǎng",
  "恁么": "rèn,me",
  "恁们": "nèn,men",
  "恁般": "rèn,bān",
  "恋三宿": "liàn,sān,xiǔ",
  "恋爱地": "liàn,ài,de",
  "恋着": "liàn,zhe",
  "恐吓": "kǒng,hè",
  "恐怖分子": "kǒng,bù,fèn,zi",
  "恐怖地": "kǒng,bù,de",
  "恐怖片儿": "kǒng,bù,piān,er",
  "恐愒": "kǒng,kài",
  "恐猲": "kǒng,hè",
  "恐血症": "kǒng,xuè,zhèng",
  "恒久地": "héng,jiǔ,de",
  "恒地营": "héng,de,yíng",
  "恒干": "héng,gàn",
  "恒数": "héng,shù",
  "恒沙数": "héng,shā,shù",
  "恒河沙数": "héng,hé,shā,shù",
  "恒生中资企业指数": "héng,shēng,zhōng,zī,qǐ,yè,zhǐ,shù",
  "恒生指数": "héng,shēng,zhǐ,shù",
  "恒生银行": "héng,shēng,yín,háng",
  "恓恓惶惶": "qī,qī,huáng,huáng",
  "恢恑憰怪": "huī,guǐ,lián,guài",
  "恣意地": "zì,yì,de",
  "恣意妄为": "zì,yì,wàng,wéi",
  "恣睢": "zì,suī",
  "恣睢无忌": "zì,suī,wú,jì",
  "恣骜": "zì,ào",
  "恤削": "xù,xuē",
  "恤数": "xù,shù",
  "恨恨地": "hèn,hèn,de",
  "恨恨地离开": "hèn,hèn,de,lí,kāi",
  "恨恨地说": "hèn,hèn,de,shuō",
  "恨恶": "hèn,wù",
  "恨血": "hèn,xuè",
  "恩培多克勒": "ēn,péi,duō,kè,lēi",
  "恩数": "ēn,shù",
  "恩泽侯": "ēn,zé,hòu",
  "恩荫": "ēn,yìn",
  "恫吓": "dòng,hè",
  "恫忧": "tōng,yōu",
  "恫怨": "tōng,yuàn",
  "恫恐": "tōng,kǒng",
  "恫悔": "tōng,huǐ",
  "恫疑虚喝": "dòng,yí,xū,hè",
  "恫疑虚猲": "dòng,yí,xū,gé",
  "恫瘝": "tōng,guān",
  "恫瘝在抱": "tōng,guān,zài,bào",
  "恫矜": "tōng,jīn",
  "恫鳏": "tōng,guān",
  "恬不为怪": "tián,bù,wéi,guài",
  "恬不为意": "tián,bù,wéi,yì",
  "恬惔": "tián,dàn",
  "恬淡无为": "tián,dàn,wú,wéi",
  "恬适": "tián,shì",
  "恭惟": "gōng,wei",
  "恭敬地": "gōng,jìng,de",
  "恭敬地送": "gōng,jìng,de,sòng",
  "恭维": "gōng,wei",
  "恭谨地": "gōng,jǐn,de",
  "恭顺地": "gōng,shùn,de",
  "息调": "xī,diào",
  "息贲": "xī,bēn",
  "恰好地": "qià,hǎo,de",
  "恰如其分": "qià,rú,qí,fèn",
  "恰当": "qià,dàng",
  "恰当地": "qià,dàng,de",
  "恰纔": "qià,shān",
  "恰适": "qià,shì",
  "恳切": "kěn,qiè",
  "恳切地": "kěn,qiè,de",
  "恳切地说": "kěn,qiè,de,shuō",
  "恳求似地": "kěn,qiú,shì,de",
  "恳求地": "kěn,qiú,de",
  "恳求地说": "kěn,qiú,de,shuō",
  "恳血": "kěn,xuè",
  "恶不去善": "wù,bù,qù,shàn",
  "恶之欲其死": "wù,zhī,yù,qí,sǐ",
  "恶乎": "wū,hū",
  "恶作剧地": "è,zuò,jù,de",
  "恶兆地": "è,zhào,de",
  "恶则坠诸渊": "wù,zé,zhuì,zhū,yuān",
  "恶创": "è,chuāng",
  "恶刹": "è,shā",
  "恶劣地": "è,liè,de",
  "恶势煞": "è,shì,shà",
  "恶名儿": "è,míng,er",
  "恶唑啉": "è,zuò,lín",
  "恶唑啉酮": "è,zuò,lín,tóng",
  "恶噷噷": "è,hěn,hěn",
  "恶处": "è,chǔ",
  "恶头儿": "è,tou,er",
  "恶寒": "wù,hán",
  "恶少": "è,shào",
  "恶少年": "è,shào,nián",
  "恶居下流": "wù,jū,xià,liú",
  "恶徒地": "è,tú,de",
  "恶得": "è,de",
  "恶心": "ě,xīn",
  "恶心烦": "ě,xīn,fán",
  "恶心钱": "ě,xīn,qián",
  "恶性地": "è,xìng,de",
  "恶恶": "è,wù",
  "恶恶从短": "wù,wù,cóng,duǎn",
  "恶意中伤": "è,yì,zhòng,shāng",
  "恶意地": "è,yì,de",
  "恶支煞": "è,zhī,shà",
  "恶杀": "wù,shā",
  "恶杀都来": "wù,shā,dōu,lái",
  "恶棍般地": "è,gùn,bān,de",
  "恶模样": "è,mú,yàng",
  "恶欲": "wù,yù",
  "恶毒地": "è,dú,de",
  "恶湿居下": "wù,shī,jū,xià",
  "恶煞": "è,shà",
  "恶煞星": "è,shà,xīng",
  "恶狠狠地": "è,hěn,hěn,de",
  "恶狠狠地看着": "è,hěn,hěn,de,kàn,zhe",
  "恶狠狠地说": "è,hěn,hěn,de,shuō",
  "恶相": "è,xiàng",
  "恶相仪": "è,xiàng,yí",
  "恶紫夺朱": "wù,zǐ,duó,zhū",
  "恶臭地": "è,chòu,de",
  "恶血": "è,xuè",
  "恶语中伤": "è,yǔ,zhòng,shāng",
  "恶迹昭着": "è,jì,zhāo,zhe",
  "恶醉强酒": "wù,zuì,qiǎng,jiǔ",
  "恶露": "è,lù",
  "恶魔似地": "è,mó,shì,de",
  "恶魔般地": "è,mó,bān,de",
  "恺切": "kǎi,qiè",
  "恺弟": "kǎi,tì",
  "恼人地": "nǎo,rén,de",
  "恼怒地": "nǎo,nù,de",
  "恼煞": "nǎo,shà",
  "悂缪": "pī,miù",
  "悄声": "qiǎo,shēng",
  "悄寂": "qiǎo,jì",
  "悄悄地": "qiāo,qiāo,de",
  "悄悄地听": "qiāo,qiāo,de,tīng",
  "悄悄地开门": "qiāo,qiāo,de,kāi,mén",
  "悄悄地瞄": "qiāo,qiāo,de,miáo",
  "悄悄地瞥几眼": "qiāo,qiāo,de,piē,jǐ,yǎn",
  "悄悄地离开": "qiāo,qiāo,de,lí,kāi",
  "悄悄地站在": "qiāo,qiāo,de,zhàn,zài",
  "悄悄地说": "qiāo,qiāo,de,shuō",
  "悄悄地调整了": "qiāo,qiāo,de,tiáo,zhěng,le",
  "悄悄地走人": "qiāo,qiāo,de,zǒu,rén",
  "悄悄地问一句": "qiāo,qiāo,de,wèn,yī,jù",
  "悄无声息": "qiǎo,wú,shēng,xī",
  "悄没声": "qiǎo,méi,shēng",
  "悄然": "qiǎo,rán",
  "悄然地": "qiǎo,rán,de",
  "悄然无声": "qiǎo,rán,wú,shēng",
  "悉索薄赋": "xī,suǒ,bó,fù",
  "悍将": "hàn,jiàng",
  "悍慓": "hàn,piào",
  "悍骜": "hàn,ào",
  "悔恨地": "huǐ,hèn,de",
  "悔悟地": "huǐ,wù,de",
  "悔改地": "huǐ,gǎi,de",
  "悔罪地": "huǐ,zuì,de",
  "悖忒": "bèi,tuī",
  "悖慠": "bèi,ào",
  "悖理地": "bèi,lǐ,de",
  "悖缪": "bèi,miù",
  "悖谩": "bèi,màn",
  "悖骜": "bèi,ào",
  "悠晃": "yōu,huàng",
  "悠着": "yōu,zhe",
  "悠缪": "yōu,miù",
  "悠𬮴": "yōu,ān",
  "悠闲地": "yōu,xián,de",
  "悠闲地抽着烟": "yōu,xián,de,chōu,zhe,yān",
  "患溃疡地": "huàn,kuì,yáng,de",
  "患热病地": "huàn,rè,bìng,de",
  "患累": "huàn,lèi",
  "患难": "huàn,nàn",
  "患难与共": "huàn,nàn,yǔ,gòng",
  "患难之交": "huàn,nàn,zhī,jiāo",
  "患难夫妻": "huàn,nàn,fū,qī",
  "患难见真情": "huàn,nàn,jiàn,zhēn,qíng",
  "悦人地": "yuè,rén,de",
  "悦耳地": "yuè,ěr,de",
  "悬侯": "xuán,hòu",
  "悬壶问世": "xián,hú,wèn,shì",
  "悬处": "xuán,chǔ",
  "悬应": "xuán,yìng",
  "悬揣": "xuán,chuǎi",
  "悬瀑": "xuán,bào",
  "悬牟": "xuán,mù",
  "悬石": "xuán,dàn",
  "悬石程书": "xuán,dàn,chéng,shū",
  "悬絙": "xuán,gēng",
  "悬调": "xuán,diào",
  "悬钩子": "xuán,gōu,zi",
  "悬首吴阙": "xuán,shǒu,wú,què",
  "悬龟系鱼": "xuán,guī,jì,yú",
  "悲伤地": "bēi,shāng,de",
  "悲伤地哭": "bēi,shāng,de,kū",
  "悲切": "bēi,qiè",
  "悲切切": "bēi,qiè,qiē",
  "悲剥": "bēi,bāo",
  "悲剧地": "bēi,jù,de",
  "悲剧性地": "bēi,jù,xìng,de",
  "悲咽": "bēi,yān",
  "悲哀地": "bēi,āi,de",
  "悲哀地说": "bēi,āi,de,shuō",
  "悲恸地": "bēi,tòng,de",
  "悲悲切切": "bēi,bēi,qiè,qiē",
  "悲惨地": "bēi,cǎn,de",
  "悲歌当哭": "bēi,gē,dàng,kū",
  "悲痛地": "bēi,tòng,de",
  "悲筑": "bēi,zhú",
  "悲观地": "bēi,guān,de",
  "悸动地": "jì,dòng,de",
  "情不自禁地": "qíng,bù,zì,jīn,de",
  "情儿": "qíng,er",
  "情分": "qíng,fèn",
  "情在骏奔": "qing,zhai,jun,ben",
  "情形": "qíng,xing",
  "情急了": "qíng,jí,liǎo",
  "情愿地": "qíng,yuàn,de",
  "情憭": "qíng,liáo",
  "情数": "qíng,shù",
  "情柔地": "qíng,róu,de",
  "情真意切": "qíng,zhēn,yì,qiè",
  "情累": "qíng,lèi",
  "情绪商数": "qíng,xù,shāng,shù",
  "情翫": "qíng,wàn",
  "情见": "qíng,xiàn",
  "情见乎辞": "qíng,xiàn,hū,cí",
  "情见力屈": "qíng,xiàn,lì,qū",
  "情见势屈": "qíng,xiàn,shì,qū",
  "情见埶竭": "qíng,jiàn,shì,jié",
  "情调": "qíng,diào",
  "惇朴": "dūn,piáo",
  "惊人地": "jīng,rén,de",
  "惊人地相似": "jīng,rén,de,xiāng,sì",
  "惊人地高": "jīng,rén,de,gāo",
  "惊人显着地": "jīng,rén,xiǎn,zhe,de",
  "惊仆": "jīng,pú",
  "惊吁": "jīng,yù",
  "惊喜地发现": "jīng,xǐ,de,fā,xiàn",
  "惊喜地说": "jīng,xǐ,de,shuō",
  "惊喜地问": "jīng,xǐ,de,wèn",
  "惊喜欲狂": "jīng,xǐ,ruò,kuáng",
  "惊天地": "jīng,tiān,de",
  "惊奇地": "jīng,qí,de",
  "惊奇地发现": "jīng,qí,de,fā,xiàn",
  "惊帆": "jīng,fān",
  "惊恐地": "jīng,kǒng,de",
  "惊慌地": "jīng,huāng,de",
  "惊槑": "jīng,dāi",
  "惊𬤀": "jīng,háo",
  "惊讶地": "jīng,yà,de",
  "惊讶地发现": "jīng,yà,de,fā,xiàn",
  "惊讶地看着": "jīng,yà,de,kàn,zhe",
  "惊讶地说": "jīng,yà,de,shuō",
  "惊蹶": "jīng,juě",
  "惊骇地": "jīng,hài,de",
  "惋咽": "wǎn,yān",
  "惋惜地说": "wǎn,xī,de,shuō",
  "惑着": "huò,zhe",
  "惑𬮴": "huò,ān",
  "惓切": "quán,qiē",
  "惓恳": "quán,kěn",
  "惓惓": "quán,quán",
  "惔怕": "dàn,pà",
  "惔焚": "dàn,fén",
  "惟妙惟肖": "wéi,miào,wéi,xiào",
  "惟所欲为": "wéi,suǒ,yù,wéi",
  "惟日为岁": "wéi,rì,wéi,suì",
  "惟肖": "wéi,xiào",
  "惠子": "huì,zi",
  "惠文冠": "huì,wén,guān",
  "惠更斯": "huì,gēng,sī",
  "惠鲜": "huì,xiàn",
  "惨兮兮地": "cǎn,xī,xī,de",
  "惨咽": "cǎn,yān",
  "惨淡地": "cǎn,dàn,de",
  "惨痛地": "cǎn,tòng,de",
  "惨白地": "cǎn,bái,de",
  "惨绿少年": "cǎn,lù,shǎo,nián",
  "惨绿年华": "cǎn,lù,nián,huá",
  "惨绿愁红": "cǎn,lù,chóu,hóng",
  "惨𬮴": "cǎn,ān",
  "惩处": "chéng,chǔ",
  "惩罚地": "chéng,fá,de",
  "惩艾": "chéng,yì",
  "惬当": "qiè,dàng",
  "惬意地": "qiè,yì,de",
  "惬适": "qiè,shì",
  "惭愧地说": "cán,kuì,de,shuō",
  "惯一不着": "guàn,yī,bù,zháo",
  "惯例地": "guàn,lì,de",
  "惯家": "guàn,jia",
  "惯常地": "guàn,cháng,de",
  "惯曾": "guàn,zēng",
  "惯曾为旅偏怜客": "guàn,zēng,wéi,lǚ,piān,lián,kè",
  "想不到": "xiǎng,bú,dào",
  "想不到地": "xiǎng,bú,dào,de",
  "想不通": "xiǎng,bu,tōng",
  "想像上地": "xiǎng,xiàng,shàng,de",
  "想头": "xiǎng,tou",
  "想好好地": "xiǎng,hǎo,hǎo,de",
  "想当然地": "xiǎng,dāng,rán,de",
  "想当然地认为": "xiǎng,dāng,rán,de,rèn,wéi",
  "想得开": "xiǎng,de,kāi",
  "想必地": "xiǎng,bì,de",
  "想更多地": "xiǎng,gèng,duō,de",
  "想更好地": "xiǎng,gèng,hǎo,de",
  "想更快地": "xiǎng,gèng,kuài,de",
  "想望地": "xiǎng,wàng,de",
  "想狠狠地": "xiǎng,hěn,hěn,de",
  "想着": "xiǎng,zhe",
  "想睡地": "xiǎng,shuì,de",
  "想要似地": "xiǎng,yào,shì,de",
  "想象上地": "xiǎng,xiàng,shàng,de",
  "想象中地": "xiǎng,xiàng,zhōng,de",
  "想象地": "xiǎng,xiàng,de",
  "想起来": "xiǎng,qi,lai",
  "惹不起": "rě,bu,qǐ",
  "惹乱子": "rě,luàn,zi",
  "惹喽子": "rě,lóu,zi",
  "惹娄子": "rě,lóu,zi",
  "惹楼子": "rě,lóu,zi",
  "惹虱子头上挠": "rě,shī,zi,tóu,shàng,náo",
  "惹麻烦": "rě,má,fan",
  "愀动地": "qiǎo,dòng,de",
  "愀地": "qiǎo,de",
  "愀洋洋地": "qiǎo,yáng,yáng,de",
  "愀知地": "qiǎo,zhī,de",
  "愁予": "chóu,yǔ",
  "愁煞": "chóu,shà",
  "愁红惨绿": "chóu,hóng,cǎn,lù",
  "愁脉脉": "chóu,mò,mò",
  "愁闷地": "chóu,mèn,de",
  "愆忒": "qiān,tuī",
  "愈更": "yù,gēng",
  "愉快地": "yú,kuài,de",
  "愉快地唱": "yú,kuài,de,chàng",
  "愉悦地": "yú,yuè,de",
  "愉悦地心情": "yú,yuè,de,xīn,qíng",
  "意兴索然": "yì,xīng,suǒ,rán",
  "意味着": "yì,wèi,zhe",
  "意外地": "yì,wài,de",
  "意干": "yì,gàn",
  "意得": "yì,de",
  "意志力地": "yì,zhì,lì,de",
  "意志地": "yì,zhì,de",
  "意思相反地": "yì,sī,xiāng,fǎn,de",
  "意折": "yì,shé",
  "意数": "yì,shù",
  "意望已过": "yi,wang,yi,guo",
  "意调": "yì,diào",
  "愒息": "kài,xī",
  "愒日": "kài,rì",
  "愒阴": "kài,yīn",
  "愕然地": "è,rán,de",
  "愚小子": "yú,xiǎo,zi",
  "愚庳": "yú,bì",
  "愚弄地": "yú,nòng,de",
  "愚戆": "yú,zhuàng",
  "愚昧地": "yú,mèi,de",
  "愚朴": "yú,piáo",
  "愚民安知": "yu,min,an,zhi",
  "愚笨地": "yú,bèn,de",
  "愚蠢地": "yú,chǔn,de",
  "愚钝地": "yú,dùn,de",
  "愚𬮴": "yú,ān",
  "愚𫘤": "yú,ái",
  "感人地": "gǎn,rén,de",
  "感伤地": "gǎn,shāng,de",
  "感兴": "gǎn,xīng",
  "感动地": "gǎn,dòng,de",
  "感叹地": "gǎn,tàn,de",
  "感叹地说": "gǎn,tàn,de,shuō",
  "感咽": "gǎn,yān",
  "感天泣地": "gǎn,tiān,qì,de",
  "感应": "gǎn,yìng",
  "感应器": "gǎn,yìng,qì",
  "感应圈": "gǎn,yìng,quān",
  "感应电动势": "gǎn,yìng,diàn,dòng,shì",
  "感应电流": "gǎn,yìng,diàn,liú",
  "感应线圈": "gǎn,yìng,xiàn,quān",
  "感性地": "gǎn,xìng,de",
  "感恩荷德": "gǎn,ēn,hè,dé",
  "感情上地": "gǎn,qíng,shàng,de",
  "感情地": "gǎn,qíng,de",
  "感慨地说": "gǎn,kǎi,de,shuō",
  "感戴二天": "gǎ,dài,èr,tiān",
  "感染人数": "gǎn,rǎn,rén,shù",
  "感激地": "gǎn,jī,de",
  "感激地说": "gǎn,jī,de,shuō",
  "感荷": "gǎn,hè",
  "感觉上地": "gǎn,jué,shàng,de",
  "感觉到地": "gǎn,jué,dào,de",
  "感讽": "gǎn,fěng",
  "感谢地": "gǎn,xiè,de",
  "愠怒地": "yùn,nù,de",
  "愠𰑄": "yùn,lún",
  "愣劲儿": "lèng,jìn,er",
  "愣头儿青": "lèng,tóu,er,qīng",
  "愣干": "lèng,gàn",
  "愣神儿": "lèng,shén,er",
  "愤兴": "fèn,xīng",
  "愤怒地": "fèn,nù,de",
  "愤怒地说": "fèn,nù,de,shuō",
  "愤愤不平地": "fèn,fèn,bù,píng,de",
  "愤愤不平地说": "fèn,fèn,bù,píng,de,shuō",
  "愤愤地说": "fèn,fèn,de,shuō",
  "愤慨地": "fèn,kǎi,de",
  "愤然地": "fèn,rán,de",
  "愬冤": "shuò,yuān",
  "愬告": "shuò,gào",
  "愬愬": "shuò,shuò",
  "愬苦": "shuò,kǔ",
  "愬讼": "shuò,sòng",
  "愿意地": "yuàn,yì,de",
  "愿望地": "yuàn,wàng,de",
  "愿朴": "yuàn,piáo",
  "慅婴": "cǎo,yīng",
  "慅扰": "cǎo,rǎo",
  "慈善地": "cí,shàn,de",
  "慈姑": "cí,gu",
  "慈悲为本": "cí,bēi,wéi,běn",
  "慈悲地": "cí,bēi,de",
  "慊吝": "qiè,lìn",
  "慊如": "qiè,rú",
  "慊心": "qiè,xīn",
  "慊恨": "qiè,hèn",
  "慊惧": "qiè,jù",
  "慊意": "qiè,yì",
  "慊慊": "qiè,qiè",
  "慊款": "qiè,kuǎn",
  "慊然": "qiè,rán",
  "慊苦": "qiè,kǔ",
  "慊足": "qiè,zú",
  "慊郁": "qiè,yù",
  "慊阔": "qiè,kuò",
  "慌乱地": "huāng,luàn,de",
  "慌张势煞": "huāng,zhāng,shì,shà",
  "慌张地": "huāng,zhāng,de",
  "慌得": "huāng,de",
  "慌忙地": "huāng,máng,de",
  "慎重地": "shèn,zhòng,de",
  "慓劲": "piào,jìn",
  "慓勇": "piào,yǒng",
  "慓士": "piào,shì",
  "慓悍": "piào,hàn",
  "慓慓": "piào,piào",
  "慓敢": "piào,gǎn",
  "慓果": "piào,guǒ",
  "慓疾": "piào,jí",
  "慓轻": "piào,qīng",
  "慓锐": "piào,ruì",
  "慓鸷": "piào,zhì",
  "慕古薄今": "mù,gǔ,bó,jīn",
  "慜念": "mǐn,niàn",
  "慜顾": "mǐn,gù",
  "慠世": "ào,shì",
  "慠亢": "ào,kàng",
  "慠佷": "ào,hěn",
  "慠俗": "ào,sú",
  "慠如": "ào,rú",
  "慠弄": "ào,nòng",
  "慠很": "ào,hěn",
  "慠忽": "ào,hū",
  "慠慢": "ào,màn",
  "慠民": "ào,mín",
  "慠物": "ào,wù",
  "慠猛": "ào,měng",
  "慠诞": "ào,dàn",
  "慠达": "ào,dá",
  "慠迈": "ào,mài",
  "慢吞吞地": "màn,tūn,tūn,de",
  "慢吞吞地前进": "màn,tūn,tūn,de,qián,jìn",
  "慢声慢气地说": "màn,shēng,màn,qì,de,shuō",
  "慢弛之阙": "man,chi,zi,que",
  "慢性地": "màn,xìng,de",
  "慢性子": "màn,xìng,zi",
  "慢性阻塞性肺病": "màn,xìng,zǔ,sè,xìng,fèi,bìng",
  "慢悠悠地": "màn,yōu,yōu,de",
  "慢慠": "màn,ào",
  "慢慢吞吞": "màn,man,tūn,tūn",
  "慢慢地": "màn,màn,de",
  "慢慢地从": "màn,màn,de,cóng",
  "慢慢地出现在": "màn,màn,de,chū,xiàn,zài",
  "慢慢地发出": "màn,màn,de,fā,chū",
  "慢慢地发现": "màn,màn,de,fā,xiàn",
  "慢慢地变成了": "màn,màn,de,biàn,chéng,le",
  "慢慢地变老": "màn,màn,de,biàn,lǎo",
  "慢慢地好": "màn,màn,de,hǎo",
  "慢慢地就学会": "màn,màn,de,jiù,xué,huì",
  "慢慢地恢复": "màn,màn,de,huī,fù",
  "慢慢地恢复了": "màn,màn,de,huī,fù,le",
  "慢慢地改变": "màn,màn,de,gǎi,biàn",
  "慢慢地有些": "màn,màn,de,yǒu,xiē",
  "慢慢地来吧": "màn,màn,de,lái,ba",
  "慢慢地消失": "màn,màn,de,xiāo,shī",
  "慢慢地消散": "màn,màn,de,xiāo,sàn",
  "慢慢地渗透": "màn,màn,de,shèn,tòu",
  "慢慢地渗透到": "màn,màn,de,shèn,tòu,dào",
  "慢慢地煮": "màn,màn,de,zhǔ",
  "慢慢地煮沸": "màn,màn,de,zhǔ,fèi",
  "慢慢地玩": "màn,màn,de,wán",
  "慢慢地研究": "màn,màn,de,yán,jiū",
  "慢慢地聊": "màn,màn,de,liáo",
  "慢慢地腐蚀": "màn,màn,de,fǔ,shí",
  "慢慢地认识了": "màn,màn,de,rèn,shí,le",
  "慢慢地讲述着": "màn,màn,de,jiǎng,shù,zhe",
  "慢慢地说": "màn,màn,de,shuō",
  "慢慢地说着": "màn,màn,de,shuō,zhe",
  "慢慢地谈": "màn,màn,de,tán",
  "慢慢地走": "màn,màn,de,zǒu",
  "慢慢地走到": "màn,màn,de,zǒu,dào",
  "慢慢地走着": "màn,màn,de,zǒu,zhe",
  "慢慢地适应": "màn,màn,de,shì,yìng",
  "慢慢地醒来": "màn,màn,de,xǐng,lái",
  "慢慢地长大": "màn,màn,de,zhǎng,dà",
  "慢慢地陪着你走": "màn,màn,de,péi,zhe,nǐ,zǒu",
  "慢腾腾地": "màn,téng,téng,de",
  "慢𫍙": "màn,yí",
  "慢调": "màn,diào",
  "慰姁": "wèi,xū",
  "慷慨地": "kāng,kǎi,de",
  "㥪㥪": "lóu,lóu",
  "㥪诚": "lóu,chéng",
  "憋不住": "biē,bu,zhù",
  "憋拗": "biē,niù",
  "憎恨地": "zēng,hèn,de",
  "憎恶": "zēng,wù",
  "憎恶地": "zēng,wù,de",
  "憔悴地": "qiáo,cuì,de",
  "憨厚": "hān,hou",
  "憨子": "hān,zi",
  "憨豆先生": "hān,dòu,xiān,sheng",
  "憭栗": "liáo,lì",
  "憭解": "liáo,jiě",
  "𱞕忒": "tǎn,tuī",
  "憵朴": "pī,piáo",
  "憺折": "dàn,shé",
  "憿籴": "jī,dí",
  "憿绝": "jī,jué",
  "懂得": "dǒng,de",
  "懂行": "dǒng,háng",
  "懂门儿": "dǒng,mén,er",
  "懃惓": "qín,quán",
  "懈忒": "xiè,tuī",
  "懊丧地说": "ào,sàng,de,shuō",
  "懊悔地": "ào,huǐ,de",
  "懋着": "mào,zhe",
  "懒媠": "lǎn,duò",
  "懒得": "lǎn,de",
  "懒得搭理": "lǎn,de,dā,lǐ",
  "懒惰地": "lǎn,duò,de",
  "懒散": "lǎn,sǎn",
  "懒散地": "lǎn,sǎn,de",
  "懒洋洋": "lǎn,yāng,yāng",
  "懒洋洋地": "lǎn,yáng,yáng,de",
  "懒洋洋地倚靠": "lǎn,yáng,yáng,de,yǐ,kào",
  "懒洋洋地坐在": "lǎn,yáng,yáng,de,zuò,zài",
  "懒洋洋地说": "lǎn,yáng,yáng,de,shuō",
  "懒洋洋地问": "lǎn,yáng,yáng,de,wèn",
  "懒觉": "lǎn,jiào",
  "懒驴上磨屎尿多": "lǎn,lǘ,shàng,mò,shǐ,niào,duō",
  "懒骨头": "lǎn,gǔ,tou",
  "怡子": "dāi,zǐ",
  "懦弱地": "nuò,ruò,de",
  "懵劲儿": "měng,jìn,er",
  "懵头转向": "měng,tóu,zhuàn,xiàng",
  "戆朴": "gàng,piáo",
  "戆直": "zhuàng,zhí",
  "戆𬮴": "gàng,ān",
  "戆𫘤": "gàng,ái",
  "戈什": "gē,shí",
  "戈什哈": "gē,shí,hā",
  "戈楯": "gē,dùn",
  "戈槛": "gē,kǎn",
  "戌削": "xū,xuē",
  "戍堡": "shù,pù",
  "戍栅": "shù,shān",
  "戎事倥偬": "róng,shì,kǒng,zǒng",
  "戎仆": "róng,pú",
  "戎冠": "róng,guān",
  "戎禁": "róng,jìn",
  "戎翟": "róng,zhái",
  "戎行": "róng,háng",
  "戎马倥偬": "róng,mǎ,kǒng,zǒng",
  "戏乐": "xì,yuè",
  "戏剧似地": "xì,jù,shì,de",
  "戏剧化地": "xì,jù,huà,de",
  "戏剧地": "xì,jù,de",
  "戏剧性地": "xì,jù,xìng,de",
  "戏剧般地": "xì,jù,bān,de",
  "戏匣子": "xì,xiá,zi",
  "戏台子": "xì,tái,zi",
  "戏弄地": "xì,nòng,de",
  "戏提调": "xì,tí,diào",
  "戏班子": "xì,bān,zi",
  "戏謿": "xì,zhāo",
  "戏调": "xì,diào",
  "戏谑地": "xì,xuè,de",
  "戏适": "xì,shì",
  "戏鸿堂帖": "xì,hóng,táng,tiē",
  "成不了气候": "chéng,bu,liǎo,qì,hòu",
  "成个儿": "chéng,gè,er",
  "成为": "chéng,wéi",
  "成倍地": "chéng,bèi,de",
  "成倍地增长": "chéng,bèi,de,zēng,zhǎng",
  "成冠": "chéng,guān",
  "成分": "chéng,fèn",
  "成切线地": "chéng,qiè,xiàn,de",
  "成列地": "chéng,liè,de",
  "成则为王": "chéng,zé,wéi,wáng",
  "成功地": "chéng,gōng,de",
  "成功地为": "chéng,gōng,de,wèi",
  "成功地为自己": "chéng,gōng,de,wèi,zì,jǐ",
  "成功地做": "chéng,gōng,de,zuò",
  "成功地做某事": "chéng,gōng,de,zuò,mǒu,shì",
  "成功地推广": "chéng,gōng,de,tuī,guǎng",
  "成功地解决了": "chéng,gōng,de,jiě,jué,le",
  "成功地进行了": "chéng,gōng,de,jìn,xíng,le",
  "成千累万": "chéng,qiān,lèi,wàn",
  "成双地": "chéng,shuāng,de",
  "成吉思汗": "chéng,jí,sī,hán",
  "成吉思汗陵": "chéng,jí,sī,hán,líng",
  "成宿": "chéng,xiǔ",
  "成对地": "chéng,duì,de",
  "成就地": "chéng,jiù,de",
  "成年家": "chéng,nián,jie",
  "成年累月": "chéng,nián,lěi,yuè",
  "成弓形地": "chéng,gōng,xíng,de",
  "成扇地": "chéng,shàn,de",
  "成批地": "chéng,pī,de",
  "成指数地": "chéng,zhǐ,shù,de",
  "成数": "chéng,shù",
  "成方儿": "chéng,fāng,er",
  "成方形地": "chéng,fāng,xíng,de",
  "成束地": "chéng,shù,de",
  "成样子": "chéng,yàng,zi",
  "成梯形地": "chéng,tī,xíng,de",
  "成楔形地": "chéng,xiē,xíng,de",
  "成比例地": "chéng,bǐ,lì,de",
  "成熟地": "chéng,shú,de",
  "成直角地": "chéng,zhí,jiǎo,de",
  "成线地": "chéng,xiàn,de",
  "成群地": "chéng,qún,de",
  "成群地游": "chéng,qún,de,yóu",
  "成群结队地走": "chéng,qún,jié,duì,de,zǒu",
  "成荫地": "chéng,yīn,de",
  "成行": "chéng,háng",
  "成衣铺": "chéng,yī,pù",
  "成角地": "chéng,jiǎo,de",
  "成败兴废": "chéng,bài,xīng,fèi",
  "成都": "chéng,dū",
  "成都体育大学": "chéng,dū,tǐ,yù,dà,xué",
  "成都卖卜": "chéng,dū,mài,bǔ",
  "成都卜": "chéng,dū,bǔ",
  "成都市": "chéng,dū,shì",
  "成都平原": "chéng,dū,píng,yuán",
  "成长": "chéng,zhǎng",
  "成长率": "chéng,zhǎng,lǜ",
  "我一直不停地": "wǒ,yì,zhí,bù,tíng,de",
  "我不停地": "wǒ,bù,tíng,de",
  "我不再积极地": "wǒ,bù,zài,jī,jí,de",
  "我为人人": "wǒ,wéi,rén,rén",
  "我为鱼肉": "wǒ,wéi,yú,ròu",
  "我也会不停地写": "wǒ,yě,huì,bù,tíng,de,xiě",
  "我也好好地": "wǒ,yě,hǎo,hǎo,de",
  "我仔细地": "wǒ,zǐ,xì,de",
  "我以后会好好地": "wǒ,yǐ,hòu,huì,hǎo,hǎo,de",
  "我们": "wǒ,men",
  "我们俩": "wǒ,men,liǎ",
  "我们坚定地": "wǒ,men,jiān,deng,de",
  "我们将逐步地": "wǒ,men,jiāng,zhú,bù,de",
  "我们就要好好地": "wǒ,men,jiù,yào,hǎo,hǎo,de",
  "我们的": "wǒ,men,de",
  "我们自己": "wǒ,men,zì,jǐ",
  "我们自己的": "wǒ,men,zì,jǐ,de",
  "我会好好地": "wǒ,huì,hǎo,hǎo,de",
  "我会尽量地": "wǒ,huì,jǐn,liàng,de",
  "我会慢慢地": "wǒ,huì,màn,màn,de",
  "我会毫不犹豫地": "wǒ,huì,háo,bù,yóu,yù,de",
  "我伲": "wǒ,nì",
  "我再简单地": "wǒ,zài,jiǎn,dān,de",
  "我努力地": "wǒ,nǔ,lì,de",
  "我勇敢地": "wǒ,yǒng,gǎn,de",
  "我勒个去": "wǒ,lè,ge,qù",
  "我可以明确地告诉你": "wǒ,kě,yǐ,míng,què,de,gào,sù,nǐ",
  "我呆呆地看": "wǒ,dāi,dāi,de,kàn",
  "我奇怪地": "wǒ,qí,guài,de",
  "我幸运地": "wǒ,xìng,yùn,de",
  "我很认真地": "wǒ,hěn,rèn,zhēn,de",
  "我才深深地感觉到": "wǒ,cái,shēn,shēn,de,gǎn,jué,dào",
  "我操": "wǒ,cào",
  "我正确地": "wǒ,zhèng,què,de",
  "我现在慢慢地": "wǒ,xiàn,zài,màn,màn,de",
  "我理智地": "wǒ,lǐ,zhì,de",
  "我痛切地": "wǒ,tòng,qiè,de",
  "我真诚地": "wǒ,zhēn,chéng,de",
  "我简单地": "wǒ,jiǎn,dān,de",
  "我自豪地": "wǒ,zì,háo,de",
  "我衷心地": "wǒ,zhōng,xīn,de",
  "我这个人": "wǒ,zhè,ge,rén",
  "我这儿": "wǒ,zhe,er",
  "我迷迷糊糊地": "wǒ,mí,mí,hū,hū,de",
  "我需要好好地": "wǒ,xū,yào,hǎo,hǎo,de",
  "我静静地坐着": "wǒ,jìng,jìng,de,zuò,zhe",
  "我静静地看着": "wǒ,jìng,jìng,de,kàn,zhe",
  "我静静地站着": "wǒ,jìng,jìng,de,zhàn,zhe",
  "我非常地抱歉": "wǒ,fēi,cháng,de,bào,qiàn",
  "我高兴地": "wǒ,gāo,xìng,de",
  "戒奢宁俭": "jiè,shē,nìng,jiǎn",
  "戒子": "jiè,zi",
  "戒指": "jiè,zhi",
  "戒禁": "jiè,jìn",
  "戕折": "qiāng,shé",
  "或者是想当然地": "huò,zhě,shì,xiǎng,dāng,rán,de",
  "戗住": "qiàng,zhù",
  "戗堤": "qiàng,dī",
  "戗柱": "qiàng,zhù",
  "戗脊": "qiàng,jǐ",
  "戗金": "qiàng,jīn",
  "戗面": "qiàng,miàn",
  "戗面馒头": "qiàng,miàn,mán,tou",
  "战哄": "zhàn,hǒng",
  "战将": "zhàn,jiàng",
  "战帆": "zhàn,fān",
  "战战兢兢地": "zhàn,zhàn,jīng,jīng,de",
  "战斗中地": "zhàn,dòu,zhōng,de",
  "战斗里成长": "zhàn,dòu,lǐ,chéng,zhǎng",
  "战术导弹": "zhàn,shù,dǎo,dàn",
  "战栅": "zhàn,shān",
  "战略导弹": "zhàn,lüè,dǎo,dàn",
  "战略核力量": "zhàn,lüè,hé,lì,liang",
  "战鞞": "zhàn,bǐ",
  "戚蕃": "qī,fān",
  "戟幢": "jǐ,zhuàng",
  "戟指怒目": "jǐ,zhǐ,nǔ,mù",
  "戟楯": "jǐ,dùn",
  "戢载": "jí,zǎi",
  "戤米囤饿杀": "gài,mǐ,dùn,è,shā",
  "截削": "jié,xuē",
  "截发": "jié,fà",
  "截发剉藳": "jié,fà,cuò,gǎo",
  "截发锉藳": "jié,fà,cuò,gǎo",
  "截然地": "jié,rán,de",
  "截胫剖心": "jié,jìng,pōu,xīn",
  "截趾适履": "jié,zhǐ,shì,lǚ",
  "截趾适屦": "jié,zhǐ,shì,jù",
  "截铁斩钉": "jié,tiě,zhǎn,dìng",
  "戮没": "lù,mò",
  "戳不住": "chuō,bu,zhù",
  "戳个儿": "chuō,gè,er",
  "戳份儿": "chuō,fèn,er",
  "戳儿": "chuō,er",
  "戳子": "chuō,zi",
  "戳得住": "chuō,de,zhù",
  "戳瘪脚": "chuō,biě,jiǎo",
  "戳背脊": "chuō,bèi,jǐ",
  "戳脊梁": "chuō,jǐ,liang",
  "戳脊梁骨": "chuō,jǐ,liang,gǔ",
  "戴上": "dài,shang",
  "戴冠郎": "dài,guān,láng",
  "戴大帽子": "dài,dà,mào,zi",
  "戴安娜": "dài,ān,nà",
  "戴安娜王妃": "dài,ān,nà,wáng,fēi",
  "戴帽子": "dài,mào,zi",
  "戴干": "dài,gàn",
  "戴着斗笠亲嘴": "dài,zhe,dǒu,lì,qīn,zuǐ",
  "戴绿帽子": "dài,lǜ,mào,zi",
  "戴高帽子": "dài,gāo,mào,zi",
  "户帖": "hù,tiē",
  "户槛": "hù,kǎn",
  "户调": "hù,diào",
  "户长": "hù,zhǎng",
  "户限为穿": "hù,xiàn,wéi,chuān",
  "戽斗": "hù,dǒu",
  "戾莎": "lì,shā",
  "房子": "fáng,zi",
  "房子租": "fáng,zi,zū",
  "房帖": "fáng,tiē",
  "房牙子": "fáng,yá,zi",
  "房累": "fáng,lèi",
  "房脊": "fáng,jí",
  "房舍": "fáng,shè",
  "房露": "fáng,lù",
  "所为": "suǒ,wéi",
  "所以才不停地": "suǒ,yǐ,cái,bù,tíng,de",
  "所作所为": "suǒ,zuò,suǒ,wéi",
  "所向披靡": "suǒ,xiàng,pī,mǐ",
  "所向风靡": "suǒ,xiàng,fēng,mǐ",
  "所处": "suǒ,chǔ",
  "所得": "suǒ,de",
  "所得税": "suǒ,de,shuì",
  "所适": "suǒ,shì",
  "所长": "suǒ,zhǎng",
  "扁乘": "piān,chéng",
  "扁化地": "biǎn,huà,de",
  "扁善": "biàn,shàn",
  "扁平地": "biǎn,píng,de",
  "扁形动物门": "piān,xíng,dòng,wù,mén",
  "扁担": "biǎn,dàn",
  "扁担星": "biǎn,dan,xīng",
  "扁担社": "biǎn,dàn,shè",
  "扁担舞": "biǎn,dàn,wǔ",
  "扁担花": "biǎn,dàn,huā",
  "扁枯": "piān,kū",
  "扁舟": "piān,zhōu",
  "扁舟乘兴": "piān,zhōu,chéng,xìng",
  "扁舟兴尽": "piān,zhōu,xìng,jìn",
  "扁舟意": "piān,zhōu,yì",
  "扃禁": "jiōng,jìn",
  "扇动": "shān,dòng",
  "扇子": "shàn,zi",
  "扇子仙": "shàn,zi,xiān",
  "扇子地": "shàn,zi,de",
  "扇尾沙锥": "shān,wěi,shā,zhuī",
  "扇席": "shān,xí",
  "扇惑": "shān,huò",
  "扇枕": "shān,zhěn",
  "扇枕温席": "shān,zhěn,wēn,xí",
  "扇枕温被": "shān,zhěn,wēn,bèi",
  "扇面琴": "shān,miàn,qín",
  "扇风": "shān,fēng",
  "扇风机": "shān,fēng,jī",
  "扇风耳朵": "shān,fēng,ěr,duo",
  "扇骨子": "shàn,gǔ,zi",
  "手下败将": "shǒu,xià,bài,jiàng",
  "手不时地": "shǒu,bù,shí,de",
  "手不释卷": "shǒu,bù,shì,juàn",
  "手倒立": "shǒu,dào,lì",
  "手刹车": "shǒu,shā,chē",
  "手动地": "shǒu,dòng,de",
  "手劲儿": "shǒu,jìn,er",
  "手𠡠": "shǒu,lài",
  "手卷": "shǒu,juàn",
  "手夹": "shǒu,jiā",
  "手帖": "shǒu,tiē",
  "手心手背都是肉": "shǒu,xīn,shǒu,bèi,dōu,shì,ròu",
  "手扎": "shǒu,zhā",
  "手扳葫芦": "shǒu,bān,hú,lu",
  "手把": "shǒu,bà",
  "手把子": "shǒu,bà,zi",
  "手把手地": "shǒu,bǎ,shǒu,de",
  "手折": "shǒu,shé",
  "手拉手地": "shǒu,lā,shǒu,de",
  "手拉葫芦": "shǒu,lā,hú,lu",
  "手指头": "shǒu,zhǐ,tou",
  "手指头肚儿": "shǒu,zhǐ,tou,dù,ér",
  "手挽手地": "shǒu,wǎn,shǒu,de",
  "手条子": "shǒu,tiáo,zi",
  "手板葫芦": "shǒu,bǎn,hú,lu",
  "手榴弹": "shǒu,liú,dàn",
  "手爪子": "shǒu,zhuǎ,zǐ",
  "手版倒持": "shǒu,bǎn,dào,chí",
  "手相": "shǒu,xiàng",
  "手背": "shǒu,bèi",
  "手脖子": "shǒu,bó,zi",
  "手腕子": "shǒu,wàn,zi",
  "手膀子": "shǒu,bǎng,zi",
  "手足异处": "shǒu,zú,yì,chǔ",
  "手足重茧": "shǒu,zú,chóng,jiǎn",
  "手钻": "shǒu,zuàn",
  "手镏": "shǒu,liù",
  "手镐": "shǒu,hào",
  "才分": "cái,fèn",
  "才占八斗": "cái,zhān,bā,dǒu",
  "才夸八斗": "cái,kuā,bā,dǒu",
  "才干": "cái,gàn",
  "才慢慢地": "cái,màn,màn,de",
  "才数": "cái,shù",
  "才疏德薄": "cái,shū,dé,bó",
  "才真正地": "cái,zhēn,zhèng,de",
  "才缊": "cái,wēn",
  "才缓缓地": "cái,huǎn,huǎn,de",
  "才能不断地成长": "cái,néng,bù,duàn,de,chéng,zhǎng",
  "才能平安地": "cái,néng,píng,ān,de",
  "才能成功地": "cái,néng,chéng,gōng,de",
  "才能更好地": "cái,néng,gèng,hǎo,de",
  "才能最大限度地": "cái,néng,zuì,dà,xiàn,dù,de",
  "才能最好地": "cái,néng,zuì,hǎo,de",
  "才能真正地": "cái,néng,zhēn,zhèng,de",
  "才能迅速地": "cái,néng,xùn,sù,de",
  "才能顺利地": "cái,néng,shùn,lì,de",
  "才能顺畅地": "cái,néng,shùn,chàng,de",
  "才自嘲地": "cái,zì,cháo,de",
  "才薄智浅": "cái,bó,zhì,qiǎn",
  "才认真地": "cái,rèn,zhēn,de",
  "才调": "cái,diào",
  "才轻德薄": "cái,qīng,dé,bó",
  "才高八斗": "cái,gāo,bā,dǒu",
  "扎也": "zhā,yě",
  "扎伊尔": "zhā,yī,ěr",
  "扎伐子": "zhā,fá,zǐ",
  "扎住": "zhā,zhù",
  "扎作": "zhā,zuò",
  "扎克伯格": "zhā,kè,bó,gé",
  "扎兰屯": "zhā,lán,tún",
  "扎兰屯市": "zhā,lán,tún,shì",
  "扎包": "zhā,bāo",
  "扎口辣舌": "zhā,kǒu,là,shé",
  "扎古": "zhā,gǔ",
  "扎古丁": "zhā,gǔ,dīng",
  "扎呼": "zhā,hū",
  "扎啤": "zhā,pí",
  "扎固": "zhā,gù",
  "扎垫": "zhā,diàn",
  "扎堆": "zhā,duī",
  "扎塞": "zhā,sāi",
  "扎姑": "zhā,gū",
  "扎子": "zhā,zǐ",
  "扎实": "zhā,shí",
  "扎实地": "zhā,shí,de",
  "扎实推进": "zhā,shi,tuī,jìn",
  "扎寨": "zhā,zhài",
  "扎寨夫人": "zhā,zhài,fū,rén",
  "扎巴": "zhā,bā",
  "扎布": "zhā,bù",
  "扎心": "zhā,xīn",
  "扎手": "zhā,shǒu",
  "扎扎": "zhā,zhā",
  "扎扎地踏": "zhā,zhā,de,tà",
  "扎扎实实": "zhā,zha,shí,shí",
  "扎扮": "zhā,bàn",
  "扎把": "zhā,bǎ",
  "扎括": "zhā,kuò",
  "扎挣": "zhá,zhēng",
  "扎捎": "zhā,shāo",
  "扎掂": "zhā,diān",
  "扎揭": "zhā,jiē",
  "扎撒": "zhā,sā",
  "扎朦": "zhā,méng",
  "扎板儿": "zhā,bǎn,ér",
  "扎枪": "zhā,qiāng",
  "扎根": "zhā,gēn",
  "扎根串连": "zhā,gēn,chuàn,lián",
  "扎款": "zhā,kuǎn",
  "扎火囤": "zhā,huǒ,dùn",
  "扎煞": "zhā,shà",
  "扎猛子": "zhā,měng,zǐ",
  "扎盲盲": "zhā,máng,máng",
  "扎眼": "zhā,yǎn",
  "扎破": "zhá,pò",
  "扎硬": "zhā,yìng",
  "扎称": "zhā,chēng",
  "扎空枪": "zhā,kōng,qiāng",
  "扎穿": "zhā,chuān",
  "扎窝": "zhā,wō",
  "扎缚": "zhā,fù",
  "扎罚子": "zhā,fá,zǐ",
  "扎翰": "zhā,hàn",
  "扎老女坟": "zhā,lǎo,nǚ,fén",
  "扎耳朵": "zhā,ěr,duǒ",
  "扎脑子": "zhā,nǎo,zi",
  "扎脚": "zhā,jiǎo",
  "扎脚勒手": "zhā,jiǎo,lè,shǒu",
  "扎腰": "zhā,yāo",
  "扎花": "zhā,huā",
  "扎营": "zhā,yíng",
  "扎落": "zhā,luò",
  "扎裹": "zhā,guǒ",
  "扎记": "zhā,jì",
  "扎诈": "zhā,zhà",
  "扎赉特": "zhā,lài,tè",
  "扎赉特旗": "zhā,lài,tè,qí",
  "扎蹭": "zhā,cèng",
  "扎野": "zhā,yě",
  "扎针": "zhā,zhēn",
  "扎钩": "zhā,gōu",
  "扎雾": "zhā,wù",
  "扎靠": "zhā,kào",
  "扎顾": "zhā,gù",
  "扎马剌丁": "zā,mǎ,lá,dīng",
  "扑哩扑剌": "pū,lǐ,pū,là",
  "扑扇": "pū,shān",
  "扑杀此獠": "pū,shā,cǐ,lǎo",
  "扑棱": "pū,lēng",
  "扑楞楞": "pū,lèng,lèng",
  "扑脸儿": "pū,liǎn,er",
  "扑腾": "pū,teng",
  "扑跌": "pū,diē",
  "扑通地": "pū,tōng,de",
  "扒分": "pá,fēn",
  "扒头儿": "bā,tou,er",
  "扒山虎": "pá,shān,hǔ",
  "扒手": "pá,shǒu",
  "扒搂": "bā,lōu",
  "扒杆": "bā,gǎn",
  "扒沙": "pá,shā",
  "扒灰": "pá,huī",
  "扒犁": "pá,lí",
  "扒窃": "pá,qiè",
  "扒粪": "pá,fèn",
  "扒糕": "pá,gāo",
  "扒耳搔腮": "pá,ěr,sāo,sāi",
  "扒艇": "pá,tǐng",
  "扒草": "pá,cǎo",
  "扒饭": "pá,fàn",
  "扒鸡": "pá,jī",
  "扒龙": "pá,lóng",
  "打一折": "dǎ,yì,zhé",
  "打不住": "dǎ,bú,zhù",
  "打不过": "dǎ,bu,guò",
  "打不通": "dǎ,bu,tōng",
  "打中": "dǎ,zhòng",
  "打中火": "dǎ,zhòng,huǒ",
  "打么诃": "dǎ,mǒ,hē",
  "打伙儿": "dǎ,huǒ,er",
  "打光棍儿": "dǎ,guāng,gùn,er",
  "打出调入": "dǎ,chū,diào,rù",
  "打击乐": "dǎ,jī,yuè",
  "打击乐器": "dǎ,jī,yuè,qì",
  "打击军事力量": "dǎ,jī,jūn,shì,lì,liang",
  "打吭吭": "dǎ,kēng,kēng",
  "打呃": "dǎ,e",
  "打呵欠地": "dǎ,hē,qiàn,de",
  "打哄": "dǎ,hǒng",
  "打哆嗦": "dǎ,duō,suo",
  "打哈哈儿": "dǎ,hā,ha,er",
  "打响鼻儿": "dǎ,xiǎng,bí,er",
  "打啵": "dǎ,bō",
  "打喯儿": "dǎ,pèn,ér",
  "打嗝儿": "dǎ,gé,er",
  "打嘴巴": "dǎ,zuǐ,ba",
  "打嚏喷": "dǎ,tì,pen",
  "打圈子": "dǎ,quān,zi",
  "打地铺": "dǎ,dì,pù",
  "打场": "dǎ,cháng",
  "打场儿": "dǎ,cháng,ér",
  "打场子": "dǎ,chǎng,zi",
  "打夹帐": "dǎ,jiā,zhàng",
  "打孔钻": "dǎ,kǒng,zuàn",
  "打定主意": "dǎ,dìng,zhǔ,yi",
  "打家劫舍": "dǎ,jiā,jié,shè",
  "打屁股": "dǎ,pì,gu",
  "打工仔": "dǎ,gōng,zǎi",
  "打干": "dǎ,gàn",
  "打底子": "dǎ,dǐ,zi",
  "打开话匣子": "dǎ,kāi,huà,xiá,zi",
  "打弹": "dǎ,dàn",
  "打得好": "dǎ,de,hǎo",
  "打心眼里": "dǎ,xīn,yǎn,li",
  "打把子": "dǎ,bà,zi",
  "打拍子": "dǎ,pāi,zi",
  "打拗": "dǎ,niù",
  "打挟": "dǎ,jiā",
  "打掠": "dǎ,lüě",
  "打提溜": "dǎ,dī,liū",
  "打揲": "dǎ,dié",
  "打撇": "dǎ,piě",
  "打撒手儿": "dǎ,sā,shǒu,er",
  "打擂": "dǎ,lèi",
  "打擂台": "dǎ,lèi,tái",
  "打旋儿": "dǎ,xuán,er",
  "打旋磨": "dǎ,xuán,mò",
  "打旋磨儿": "dǎ,xuán,mò,ér",
  "打更": "dǎ,gēng",
  "打杂儿": "dǎ,zá,er",
  "打杈": "dǎ,chà",
  "打杠子": "dǎ,gàng,zi",
  "打板子": "dǎ,bǎn,zi",
  "打格子": "dǎ,gé,zi",
  "打档": "dǎ,dǎng",
  "打档车": "dǎ,dǎng,chē",
  "打棍子": "dǎ,gùn,zi",
  "打模糊": "dǎ,mó,hu",
  "打滚儿": "dǎ,gǔn,er",
  "打烊": "dǎ,yàng",
  "打照面儿": "dǎ,zhào,miàn,er",
  "打熬": "dǎ,áo",
  "打狗还得看主人": "dǎ,gǒu,hái,děi,kàn,zhǔ,rén",
  "打甚么不紧": "dǎ,shèn,mǒ,bù,jǐn",
  "打甚么紧": "dǎ,shèn,mǒ,jǐn",
  "打的": "dǎ,dī",
  "打盹儿": "dǎ,dǔn,er",
  "打短儿": "dǎ,duǎn,er",
  "打稿子": "dǎ,gǎo,zi",
  "打筋斗": "dǎ,jīn,dǒu",
  "打粟干": "dǎ,sù,gàn",
  "打耙": "dǎ,pá",
  "打莲花落": "dǎ,lián,huā,lào",
  "打调": "dǎ,diào",
  "打谩评跋": "dǎ,màn,píng,bá",
  "打趔趄": "dǎ,liè,qie",
  "打趣地": "dǎ,qù,de",
  "打趣地说": "dǎ,qù,de,shuō",
  "打跌": "dǎ,diē",
  "打跟头": "dǎ,gēn,tou",
  "打躬作揖": "dǎ,gōng,zuō,yī",
  "打辫子": "dǎ,biàn,zi",
  "打采地": "dǎ,cài,de",
  "打铺": "dǎ,pù",
  "打顿儿": "dǎ,dùn,er",
  "打颤": "dǎ,zhàn",
  "打鸡血": "dǎ,jī,xuè",
  "打鸭子上架": "dǎ,yā,zi,shàng,jià",
  "打麻将": "dǎ,má,jiàng",
  "托兴": "tuō,xīng",
  "托处": "tuō,chǔ",
  "托物寓兴": "tuō,wù,yù,xīng",
  "托管地": "tuō,guǎn,de",
  "托舍": "tuō,shè",
  "托芘": "tuō,pí",
  "托讽": "tuō,fěng",
  "托载": "tuō,zǎi",
  "托运行李": "tuō,yùn,xíng,li",
  "扛半拉子活": "káng,bàn,lǎ,zǐ,huó",
  "扛半拉活": "káng,bàn,lǎ,huó",
  "扛哄": "káng,hǒng",
  "扛大个儿": "káng,dà,gè,er",
  "扛得住": "káng,de,zhù",
  "扛把子": "káng,bǎ,zi",
  "扛鼎": "gāng,dǐng",
  "扛鼎抃牛": "gāng,dǐng,biàn,niú",
  "扛鼎拔山": "gāng,dǐng,bá,shān",
  "扜罙": "yū,mí",
  "扞制": "gǎn,zhì",
  "扞卫": "gǎn,wèi",
  "扞圉": "gǎn,yǔ",
  "扞城": "gǎn,chéng",
  "扞士": "gǎn,shì",
  "扞将": "gǎn,jiāng",
  "扞御": "gǎn,yù",
  "扞戍": "gǎn,shù",
  "扞戾": "gǎn,lì",
  "扞抚": "gǎn,fǔ",
  "扞护": "gǎn,hù",
  "扞拒": "gǎn,jù",
  "扞掫": "gǎn,zōu",
  "扞网": "gǎn,wǎng",
  "扞蔽": "gǎn,bì",
  "扞遏": "gǎn,è",
  "扞马": "gǎn,mǎ",
  "扢扎": "gǔ,zhā",
  "扢扎帮": "gǔ,zhā,bāng",
  "扣子": "kòu,zi",
  "扣屎盆子": "kòu,shǐ,pén,zi",
  "扣屎盔子": "kòu,shǐ,kuī,zi",
  "扣帽子": "kòu,mào,zi",
  "扣应": "kòu,yìng",
  "扣折": "kòu,shé",
  "扣日子": "kòu,rì,zi",
  "扣盘扪钥": "kòu,pán,mén,yào",
  "扣眼儿": "kòu,yǎn,er",
  "扣背": "kòu,bèi",
  "执干": "zhí,gàn",
  "执念地": "zhí,niàn,de",
  "执拗": "zhí,niù",
  "执拗地": "zhí,niù,de",
  "执拗地讲": "zhí,niù,de,jiǎng",
  "执禁": "zhí,jìn",
  "执著": "zhí,zhuó",
  "执行长": "zhí,xíng,zhǎng",
  "执鞭随蹬": "zhí,biān,suí,dèng",
  "扪参": "mén,shēn",
  "扪参历井": "mén,shēn,lì,jǐng",
  "扫兀": "sǎo,wū",
  "扫帚": "sào,zhǒu",
  "扫帚星": "sào,zhǒu,xīng",
  "扫帚菜": "sào,zhǒu,cài",
  "扫帚颠倒竖": "sào,zhǒu,diān,dào,shù",
  "扫把": "sào,bǎ",
  "扫把星": "sào,bǎ,xīng",
  "扫掠": "sǎo,lüě",
  "扫数": "sǎo,shù",
  "扫脑儿": "sǎo,nǎo,er",
  "扫荡地": "sǎo,dàng,de",
  "扬厉铺张": "yáng,lì,pù,zhāng",
  "扬场": "yáng,cháng",
  "扬己露才": "yáng,jǐ,lù,cái",
  "扬帆": "yáng,fān",
  "扬帆远航": "yáng,fān,yuǎn,háng",
  "扬眉眴目": "yáng,méi,shùn,mù",
  "扬累": "yáng,lèi",
  "扬跞": "yáng,luò",
  "扬露": "yáng,lù",
  "扬风扎毛": "yáng,fēng,zhā,máo",
  "扬风扢雅": "yáng,fēng,jié,yǎ",
  "扭亏为盈": "niǔ,kuī,wéi,yíng",
  "扭捏": "niǔ,nie",
  "扭曲": "niǔ,qū",
  "扭曲作直": "niǔ,qū,zuò,zhí",
  "扭直作曲": "niǔ,zhí,zuò,qū",
  "扭转干坤": "niǔ,zhuǎn,gàn,kūn",
  "扮相": "bàn,xiàng",
  "扯嗓子": "chě,sǎng,zi",
  "扯犊子": "chě,dú,zi",
  "扯篷拉纤": "chě,péng,lā,qiàn",
  "扯纤拉烟": "chě,qiàn,lā,yān",
  "扯臊": "chě,sào",
  "扯鸡巴蛋": "chě,jī,ba,dàn",
  "扰乱地": "rǎo,luàn,de",
  "扰累": "rǎo,lèi",
  "扳不倒儿": "bān,bù,dǎo,er",
  "扳子": "bān,zi",
  "扳害": "pān,hài",
  "扳折": "bān,shé",
  "扳指儿": "bān,zhǐ,er",
  "扳本儿": "bān,běn,er",
  "扳絙": "bān,gēng",
  "扳谈": "pān,tán",
  "扶不起的阿斗": "fú,bù,qǐ,de,ā,dǒu",
  "扶夹": "fú,jiā",
  "扶挟": "fú,jiā",
  "扶毂": "fú,gū",
  "扶辇下除": "fu,nian,xia,chu",
  "批亢抵巇": "pī,gāng,dǐ,xī",
  "批假": "pī,jià",
  "批判地": "pī,pàn,de",
  "批判性地": "pī,pàn,xìng,de",
  "批削": "pī,xuē",
  "批卷": "pī,juàn",
  "批处理": "pī,chǔ,lǐ",
  "批娅娜": "pī,yà,nà",
  "批帖": "pī,tiē",
  "批扞": "pī,gǎn",
  "批条子": "pī,tiáo,zi",
  "批砉导窾": "pī,huā,dǎo,kuǎn",
  "批评性地": "pī,píng,xìng,de",
  "批郄导窽": "pī,xì,dǎo,kuǎn",
  "批郄导窾": "pī,xì,dǎo,kuǎn",
  "批零差价": "pī,líng,chā,jià",
  "批风抹月": "pī,fēng,mò,yuè",
  "扼亢拊背": "è,kàng,fǔ,bèi",
  "扼吭拊背": "è,háng,fǔ,bèi",
  "扼喉抚背": "è,hóu,fǔ,bèi",
  "扼腕叹息": "è,wǎn,tàn,xī",
  "扼襟控咽": "è,jīn,kòng,yān",
  "扼要地": "è,yào,de",
  "扼要地说": "è,yào,de,shuō",
  "找不到": "zhǎo,bu,dào",
  "找不着": "zhǎo,bu,zháo",
  "找不着北": "zhǎo,bu,zháo,běi",
  "找不自在": "zhǎo,bù,zì,zai",
  "找乐子": "zhǎo,lè,zi",
  "找刺儿": "zhǎo,cì,er",
  "找台阶儿": "zhǎo,tái,jiē,er",
  "找头": "zhǎo,tou",
  "找岔子": "zhǎo,chà,zi",
  "找得到": "zhǎo,de,dào",
  "找着": "zhǎo,zháo",
  "找茬儿": "zhǎo,chá,er",
  "找补": "zhǎo,bu",
  "找麻烦": "zhǎo,má,fan",
  "承兴": "chéng,xīng",
  "承应": "chéng,yìng",
  "承溜": "chéng,liù",
  "承舍": "chéng,shè",
  "承蜩": "zhěng,tiáo",
  "承销价差": "chéng,xiāo,jià,chā",
  "承销利差": "chéng,xiāo,lì,chā",
  "承露": "chéng,lù",
  "承露囊": "chéng,lù,náng",
  "承露盘": "chéng,lù,pán",
  "技巧地": "jì,qiǎo,de",
  "技术上地": "jì,shù,shàng,de",
  "技术地": "jì,shù,de",
  "技术好地": "jì,shù,hǎo,de",
  "技术知识": "jì,shù,zhī,shi",
  "抄扎": "chāo,zhā",
  "抄掠": "chāo,lüě",
  "抄数": "chāo,shù",
  "抄更纸": "chāo,gēng,zhǐ",
  "抄空儿": "chāo,kòng,ér",
  "抄近儿": "chāo,jìn,er",
  "抄靶子": "chāo,bǎ,zi",
  "抆血": "wěn,xuè",
  "抉露": "jué,lù",
  "把儿": "bà,er",
  "把卷": "bǎ,juàn",
  "把口儿": "bǎ,kǒu,er",
  "把子": "bà,zi",
  "把心放在肚子里": "bǎ,xīn,fàng,zài,dù,zi,lǐ",
  "把方便当随便": "bǎ,fāng,biàn,dàng,suí,biàn",
  "把翫": "bǎ,wàn",
  "把背": "bǎ,bèi",
  "把马子": "bǎ,mǎ,zi",
  "抍捄": "zhěng,jū",
  "抑削": "yì,xuē",
  "抑压地": "yì,yā,de",
  "抑塞": "yì,sè",
  "抑塞磊落": "yì,sè,lěi,luò",
  "抑折": "yì,shé",
  "抑掠": "yì,lüě",
  "抑郁地": "yì,yù,de",
  "抓功夫": "zhuā,gōng,fu",
  "抓头不是尾": "zhuā,tóu,bú,shì,wěi",
  "抓子儿": "zhuā,zǐ,er",
  "抓小辫子": "zhuā,xiǎo,biàn,zi",
  "抓尖儿": "zhuā,jiān,er",
  "抓差": "zhuā,chāi",
  "抓扎": "zhuā,zhā",
  "抓挠": "zhuā,nao",
  "抓牛鼻子": "zhuā,niú,bí,zi",
  "抓空儿": "zhuā,kòng,er",
  "抓辫子": "zhuā,biàn,zi",
  "投中": "tóu,zhòng",
  "投传而去": "tóu,zhuàn,ér,qù",
  "投入地": "tóu,rù,de",
  "投其所好": "tóu,qí,suǒ,hào",
  "投冠": "tóu,guān",
  "投分": "tóu,fèn",
  "投奔": "tóu,bèn",
  "投弹": "tóu,dàn",
  "投影地": "tóu,yǐng,de",
  "投得": "tóu,de",
  "投机分子": "tóu,jī,fèn,zi",
  "投袂荷戈": "tóu,mèi,hè,gē",
  "投逩": "tóu,bēn",
  "投间": "tóu,jiàn",
  "投降": "tóu,xiáng",
  "抖抖擞擞": "dǒu,dǒu,sǒu,sòu",
  "抖搂": "dǒu,lōu",
  "抖擞": "dǒu,sǒu",
  "抖擞精神": "dǒu,sǒu,jīng,shén",
  "抖露": "dǒu,lù",
  "抗凝血剂": "kàng,níng,xuè,jì",
  "抗坏血酸": "kàng,huài,xuè,suān",
  "抗折": "kàng,shé",
  "抗脏": "kàng,zāng",
  "抗血清": "kàng,xuè,qīng",
  "抗议地": "kàng,yì,de",
  "抗议地说": "kàng,yì,de,shuō",
  "抗颜为师": "kàng,yán,wéi,shī",
  "折丹": "shé,dān",
  "折么": "shé,mǒ",
  "折乌巾": "shé,wū,jīn",
  "折乏": "shé,fá",
  "折伏": "shé,fú",
  "折伐": "shé,fá",
  "折便宜": "shé,biàn,yí",
  "折俎": "shé,zǔ",
  "折倒": "shé,dǎo",
  "折儿": "shé,ér",
  "折充": "shé,chōng",
  "折关": "shé,guān",
  "折准": "shé,zhǔn",
  "折减": "shé,jiǎn",
  "折刀儿": "zhé,dāo,er",
  "折到": "shé,dào",
  "折勾": "shé,gōu",
  "折北": "shé,běi",
  "折博": "shé,bó",
  "折受": "shé,shòu",
  "折口福": "shé,kǒu,fú",
  "折句": "shé,jù",
  "折困": "shé,kùn",
  "折堕": "shé,duò",
  "折声": "shé,shēng",
  "折头": "zhé,tou",
  "折契": "shé,qì",
  "折实": "shé,shí",
  "折对": "shé,duì",
  "折射性地": "zhé,shè,xìng,de",
  "折屐": "shé,jī",
  "折巾": "shé,jīn",
  "折巾郭": "shé,jīn,guō",
  "折帛": "shé,bó",
  "折带皴": "shé,dài,cūn",
  "折席": "shé,xí",
  "折干": "shé,qián",
  "折床": "shé,chuáng",
  "折庭槛": "shé,tíng,kǎn",
  "折当": "shé,dāng",
  "折征": "shé,zhǐ",
  "折意": "shé,yì",
  "折愧": "shé,kuì",
  "折慢幢": "shé,màn,zhuàng",
  "折戗": "shé,qiāng",
  "折扬": "shé,yáng",
  "折折": "shé,shé",
  "折抢": "shé,qiǎng",
  "折拉": "shé,lā",
  "折拒": "shé,jù",
  "折拗": "shé,niù",
  "折损": "shé,sǔn",
  "折捶": "shé,chuí",
  "折掇": "shé,duō",
  "折措": "shé,cuò",
  "折摇": "shé,yáo",
  "折支": "shé,zhī",
  "折数": "shé,shù",
  "折斤斗": "shé,jīn,dǒu",
  "折旋": "shé,xuán",
  "折易": "shé,yì",
  "折末": "shé,mò",
  "折本": "shé,běn",
  "折札": "shé,zhá",
  "折杖": "shé,zhàng",
  "折杨": "shé,yáng",
  "折杨柳": "shé,yáng,liǔ",
  "折柬": "shé,jiǎn",
  "折桌": "shé,zhuō",
  "折槛": "shé,kǎn",
  "折正": "shé,zhèng",
  "折步": "shé,bù",
  "折死": "shé,sǐ",
  "折气": "shé,qì",
  "折水": "shé,shuǐ",
  "折消": "shé,xiāo",
  "折漕": "shé,cáo",
  "折澄": "shé,chéng",
  "折片": "shé,piàn",
  "折狱": "shé,yù",
  "折登": "shé,dēng",
  "折盘": "shé,pán",
  "折短": "shé,duǎn",
  "折碗": "shé,wǎn",
  "折磨地": "zhé,mó,de",
  "折秤": "shé,chèng",
  "折箩": "zhē,luó",
  "折箭": "shé,jiàn",
  "折箭为誓": "shé,jiàn,wéi,shì",
  "折纳": "shé,nà",
  "折绵": "shé,mián",
  "折罗": "shé,luó",
  "折罚": "shé,fá",
  "折翅": "shé,chì",
  "折翼": "shé,yì",
  "折耗": "shé,hào",
  "折肱": "shé,gōng",
  "折胁": "shé,xié",
  "折脖子": "shé,bó,zi",
  "折脚": "shé,jiǎo",
  "折脚铛": "shé,jiǎo,chēng",
  "折腰五斗": "shé,yāo,wǔ,dòu",
  "折腾": "zhē,téng",
  "折臂三公": "shé,bì,sān,gōng",
  "折色": "shé,sè",
  "折苕": "shé,tiáo",
  "折莫": "shé,mò",
  "折葼": "shé,zōng",
  "折蒲": "shé,pú",
  "折行": "shé,xíng",
  "折衷": "shé,zhōng",
  "折衷地": "shé,zhōng,de",
  "折要": "shé,yào",
  "折要步": "shé,yào,bù",
  "折讼": "shé,sòng",
  "折证": "shé,zhèng",
  "折谋": "shé,móu",
  "折足铛": "zhé,zú,chēng",
  "折跟头": "zhē,gēn,tou",
  "折蹬": "shé,dēng",
  "折身": "shé,shēn",
  "折躬": "shé,gōng",
  "折辕": "shé,yuán",
  "折辨": "shé,biàn",
  "折辩": "shé,biàn",
  "折辱": "shé,rǔ",
  "折过": "zhē,guò",
  "折过儿": "zhē,guò,er",
  "折还": "shé,hái",
  "折钗": "shé,chāi",
  "折钗股": "shé,chāi,gǔ",
  "折钱": "shé,qián",
  "折铛": "shé,chēng",
  "折锉": "shé,cuò",
  "折除": "shé,chú",
  "折难": "shé,nán",
  "折风": "shé,fēng",
  "折馘": "shé,guó",
  "折骨": "shé,gǔ",
  "折麻": "shé,má",
  "折齿": "shé,chǐ",
  "抚慰地": "fǔ,wèi,de",
  "抚背": "fǔ,bèi",
  "抛到一边": "pāo,dào,yì,biān",
  "抛声调嗓": "pāo,shēng,diào,sǎng",
  "抛头露面": "pāo,tóu,lù,miàn",
  "抛撇": "pāo,piě",
  "抛数": "pāo,shù",
  "抛调": "pāo,diào",
  "抛露": "pāo,lù",
  "抠字眼儿": "kōu,zì,yǎn,er",
  "抠心挖血": "kōu,xīn,wā,xuè",
  "抠搂": "kōu,lōu",
  "抠着手掌": "kōu,zhe,shǒu,zhǎng",
  "抠门儿": "kōu,mén,er",
  "抡元": "lún,yuán",
  "抡才": "lún,cái",
  "抡打": "lún,dǎ",
  "抡择": "lún,zé",
  "抡捆": "lún,kǔn",
  "抡材": "lún,cái",
  "抡算": "lún,suàn",
  "抡选": "lún,xuǎn",
  "抡魁": "lún,kuí",
  "抢地": "qiāng,dì",
  "抢地呼天": "qiāng,dì,hū,tiān",
  "抢抢攘攘": "chēng,chēng,rǎng,rǎng",
  "抢攘": "chēng,rǎng",
  "抢生意": "qiǎng,shēng,yi",
  "抢种": "qiǎng,zhòng",
  "抢背": "qiǎng,bèi",
  "抢风": "qiāng,fēng",
  "抢风航行": "qiāng,fēng,háng,xíng",
  "护书夹": "hù,shū,jiā",
  "护发": "hù,fà",
  "护发乳": "hù,fà,rǔ",
  "护发素": "hù,fà,sù",
  "护堤": "hù,dī",
  "护士": "hù,shi",
  "护士长": "hù,shì,zhǎng",
  "护犊子": "hù,dú,zi",
  "护着": "hù,zhe",
  "护调": "hù,diào",
  "护身符子": "hù,shēn,fú,zi",
  "护𰺷": "hù,rǎo",
  "报丧": "bào,sāng",
  "报喜不报忧": "bào,xǐ,bú,bào,yōu",
  "报复地": "bào,fù,de",
  "报复性地": "bào,fù,xìng,de",
  "报子": "bào,zi",
  "报应": "bào,yìng",
  "报应不爽": "bào,yìng,bù,shuǎng",
  "报数": "bào,shù",
  "报更": "bào,gēng",
  "报禁": "bào,jìn",
  "报载": "bào,zǎi",
  "报酬": "bào,chou",
  "报销差旅费": "bào,xiāo,chāi,lǚ,fèi",
  "披削": "pī,xuē",
  "披卷": "pī,juàn",
  "披发": "pī,fà",
  "披发左衽": "pī,fà,zuǒ,rèn",
  "披发左袵": "pī,fà,zuǒ,rèn",
  "披发文身": "pī,fà,wén,shēn",
  "披头四乐团": "pī,tóu,sì,yuè,tuán",
  "披头散发": "pī,tóu,sàn,fà",
  "披心沥血": "pī,xīn,lì,xuè",
  "披披藉藉": "pī,pī,jí,jí",
  "披散": "pī,sǎn",
  "披枷带锁": "jīn,jiā,yù,suǒ",
  "披毛索靥": "pī,máo,suǒ,yǎn",
  "披沙剖璞": "pī,shā,pōu,pú",
  "披翫": "pī,wàn",
  "披肝沥血": "pī,gān,lì,xuè",
  "披肝露胆": "pī,gān,lù,dǎn",
  "披肩发": "pī,jiān,fà",
  "披露": "pī,lù",
  "披露肝胆": "pī,lù,gān,dǎn",
  "披露腹心": "pī,lù,fù,xīn",
  "披靡": "pī,mǐ",
  "抬举": "tái,ju",
  "抬帖": "tái,tiē",
  "抬揲": "tái,dié",
  "抬轿子": "tái,jiào,zi",
  "抱儿当户": "bào,ér,dàng,hù",
  "抱娃娃": "bào,wá,wa",
  "抱怨地": "bào,yuàn,de",
  "抱怨地说": "bào,yuàn,de,shuō",
  "抱朴": "bào,piáo",
  "抱歉地": "bào,qiàn,de",
  "抱歉地说": "bào,qiàn,de,shuō",
  "抱法处势": "bào,fǎ,chǔ,shì",
  "抱璞泣血": "bào,pú,qì,xuè",
  "抱着希望地": "bào,zhe,xī,wàng,de",
  "抱着旧皇历": "bào,zhe,jiù,huáng,lì",
  "抱蔓摘瓜": "bào,wàn,zhāi,guā",
  "抵当": "dǐ,dàng",
  "抵扞": "dǐ,gǎn",
  "抵掌": "zhǐ,zhǎng",
  "抵死谩生": "dǐ,sǐ,màn,shēng",
  "抵禁": "dǐ,jìn",
  "抵背": "dǐ,bèi",
  "抵背扼喉": "dǐ,bèi,è,hóu",
  "抵触地": "dǐ,chù,de",
  "抵颓": "zhǐ,tuí",
  "抹一鼻子灰": "mǒ,yī,bí,zi,huī",
  "抹下来": "mā,xià,lái",
  "抹不开": "mò,bù,kāi",
  "抹头": "mò,tóu",
  "抹布": "mā,bù",
  "抹得开": "mò,de,kāi",
  "抹𢫬": "mǒ,shā",
  "抹桌子": "mā,zhuō,zi",
  "抹泥": "mò,ní",
  "抹澡": "mā,zǎo",
  "抹灰": "mò,huī",
  "抹灰层": "mò,huī,céng",
  "抹煞": "mǒ,shà",
  "抹着阎王鼻子": "mǒ,zhe,yán,wáng,bí,zi",
  "抹粉施脂": "mò,fěn,shī,zhī",
  "抹胸": "mò,xiōng",
  "抹脖子": "mǒ,bó,zi",
  "抹脸": "mā,liǎn",
  "抹衣": "mò,yī",
  "抹角": "mò,jiǎo",
  "抹角转弯": "mò,jiǎo,zhuǎn,wān",
  "抹角转湾": "mò,jiǎo,zhuǎn,wān",
  "抹跄": "mǒ,qiàng",
  "抹门儿": "mò,mén,ér",
  "抹面": "mò,miàn",
  "抹额": "mò,é",
  "抹鼻子": "mǒ,bí,zi",
  "押头": "yā,tou",
  "押差": "yā,chāi",
  "押当": "yā,dàng",
  "押禁": "yā,jìn",
  "押缝": "yā,fèng",
  "押解": "yā,jiè",
  "押铺": "yā,pù",
  "抽丝剥茧": "chōu,sī,bāo,jiǎn",
  "抽中": "chōu,zhòng",
  "抽冷子": "chōu,lěng,zi",
  "抽剥": "chōu,bāo",
  "抽咽": "chōu,yè",
  "抽嘴巴": "chōu,zuǐ,ba",
  "抽噎地": "chōu,yē,de",
  "抽噎地哭": "chōu,yē,de,kū",
  "抽屉": "chōu,ti",
  "抽心舍": "chōu,xīn,shè",
  "抽抽噎噎": "chōu,chou,yē,yē",
  "抽斗": "chōu,dǒu",
  "抽样调查": "chōu,yàng,diào,chá",
  "抽祕骋妍": "chōu,bì,chěng,yán",
  "抽筋剥皮": "chōu,jīn,bāo,pí",
  "抽血": "chōu,xuè",
  "抽讽": "chōu,fěng",
  "抽调": "chōu,diào",
  "抽象代数": "chōu,xiàng,dài,shù",
  "抽象地": "chōu,xiàng,de",
  "抽象性地": "chōu,xiàng,xìng,de",
  "抽鼻子": "chōu,bí,zi",
  "抿子": "mǐn,zi",
  "拂士": "bì,shì",
  "拂掠": "fú,lüě",
  "拂翟": "fú,zhái",
  "拂褏": "fú,yòu",
  "拂过": "bì,guò",
  "拃挣": "zhà,zhèng",
  "担不是": "dān,bú,shì",
  "担仆": "dān,pú",
  "担仔面": "dàn,zǎi,miàn",
  "担子": "dàn,zi",
  "担幢": "dān,zhuàng",
  "担幢伎": "dān,zhuàng,jì",
  "担干系": "dǎn,gān,xì",
  "担心地": "dān,xīn,de",
  "担心地看着": "dān,xīn,de,kàn,zhe",
  "担心地说": "dān,xīn,de,shuō",
  "担忧地": "dān,yōu,de",
  "担担手": "dàn,dan,shǒu",
  "担担面": "dàn,dàn,miàn",
  "担挢": "jiē,jiǎo",
  "担石": "dān,dàn",
  "担荷": "dān,hè",
  "担误": "dān,wu",
  "拆卷": "chāi,juàn",
  "拆烂污": "cā,làn,wū",
  "拇指甲": "mǔ,zhǐ,jia",
  "拈折": "niān,shé",
  "拉㞎㞎": "lā,bǎ,ba",
  "拉个手": "lā,ge,shǒu",
  "拉什卡尔加": "lā,shí,kǎ,ěr,jiā",
  "拉什莫尔山": "lā,shí,mò,ěr,shān",
  "拉勾儿": "lā,gòu,er",
  "拉后钩儿": "lā,hòu,gōu,er",
  "拉呱": "lā,gua",
  "拉场子": "lā,chǎng,zi",
  "拉家常": "lá,jiā,cháng",
  "拉尼娜": "lā,ní,nà",
  "拉开架势": "lā,kāi,jià,shi",
  "拉忽": "lǎ,hū",
  "拉扯大": "lā,che,dà",
  "拉折": "lā,shé",
  "拉擸": "lā,là",
  "拉杆": "lā,gǎn",
  "拉杆子": "lā,gān,zi",
  "拉枯折朽": "lā,kū,shé,xiǔ",
  "拉碴": "lā,chā",
  "拉紧地": "lā,jǐn,de",
  "拉纤": "lā,qiàn",
  "拉肚子": "lā,dǔ,zi",
  "拉舌头": "lā,shé,tou",
  "拊心泣血": "fǔ,xīn,qì,xuè",
  "拊背": "fǔ,bèi",
  "拊背扼吭": "fǔ,bèi,è,kēng",
  "拊背扼喉": "fǔ,bèi,è,hóu",
  "拊背搤吭": "fǔ,bèi,è,kēng",
  "拌和": "bàn,huò",
  "拌舍": "bàn,shè",
  "拍卖行": "pāi,mài,háng",
  "拍婆子": "pāi,pó,zi",
  "拍子": "pāi,zi",
  "拍弹": "pāi,dàn",
  "拍拍屁股走人": "pāi,pāi,pì,gu,zǒu,rén",
  "拍摄地": "pāi,shè,de",
  "拍桌子": "pāi,zhuō,zi",
  "拍片儿": "pāi,piān,er",
  "拍胸脯": "pāi,xiōng,pú",
  "拐子": "guǎi,zi",
  "拐弯儿": "guǎi,wān,er",
  "拐弯抹角": "guǎi,wān,mò,jiǎo",
  "拐棍儿": "guǎi,gùn,er",
  "拐棒子": "guǎi,bàng,zi",
  "拐良为娼": "guǎi,liáng,wéi,chāng",
  "拒付地": "jù,fù,de",
  "拒扞": "jù,gǎn",
  "拒折": "jù,shé",
  "拒收地": "jù,shōu,de",
  "拓写": "tà,xiě",
  "拓印": "tà,yìn",
  "拓墨": "tà,mò",
  "拓工": "tà,gōng",
  "拓手": "tà,shǒu",
  "拓本": "tà,běn",
  "拓片": "tà,piàn",
  "拔了萝卜地皮宽": "bá,le,luó,bo,dì,pí,kuān",
  "拔兴": "bá,xīng",
  "拔出萝卜带出泥": "bá,chū,luó,bo,dài,chū,ní",
  "拔尖儿": "bá,jiān,er",
  "拔山扛鼎": "bá,shān,gāng,dǐng",
  "拔干": "bá,gàn",
  "拔𢫬": "bá,shā",
  "拔本塞原": "bá,běn,sè,yuán",
  "拔本塞源": "bá,běn,sè,yuán",
  "拔来报往": "bá,lái,fù,wǎng",
  "拔火罐儿": "bá,huǒ,guàn,er",
  "拔火罐子": "bá,huǒ,guàn,zi",
  "拔着短筹": "bá,zhe,duǎn,chóu",
  "拔絜": "bá,jié",
  "拔缝": "bá,fèng",
  "拔舍": "bá,shè",
  "拔苗助长": "bá,miáo,zhù,zhǎng",
  "拔钉子": "bá,dīng,zi",
  "拖尾巴": "tuō,wěi,ba",
  "拖延地": "tuō,yán,de",
  "拖拖栖栖": "tuō,tuō,xī,xī",
  "拖拽": "tuō,yè",
  "拖斗": "tuō,dǒu",
  "拖空子": "tuō,kòng,zi",
  "拖累": "tuō,lěi",
  "拖累症": "tuō,lěi,zhèng",
  "拖露": "tuō,lù",
  "拗不过": "niù,bù,guò",
  "拗体": "niù,tǐ",
  "拗体诗": "niù,tǐ,shī",
  "拗别": "niù,bié",
  "拗劲": "niù,jìn",
  "拗却": "niù,què",
  "拗取": "niù,qǔ",
  "拗口地": "ào,kǒu,de",
  "拗句": "niù,jù",
  "拗句格": "niù,jù,gé",
  "拗声": "niù,shēng",
  "拗字": "niù,zì",
  "拗峭": "niù,qiào",
  "拗开": "niù,kāi",
  "拗强": "niù,qiáng",
  "拗律": "niù,lǜ",
  "拗怒": "niù,nù",
  "拗性": "niù,xìng",
  "拗戾": "niù,lì",
  "拗执": "niù,zhí",
  "拗抗": "niù,kàng",
  "拗折": "ǎo,shé",
  "拗拙": "niù,zhuō",
  "拗拢": "niù,lǒng",
  "拗捩": "niù,liè",
  "拗救": "niù,jiù",
  "拗断": "ǎo,duàn",
  "拗曲作直": "ǎo,qǔ,zuò,zhí",
  "拗木枕": "niù,mù,zhěn",
  "拗格": "niù,gé",
  "拗涩": "niù,sè",
  "拗相公": "niù,xiàng,gōng",
  "拗花": "niù,huā",
  "拗语": "niù,yǔ",
  "拗调": "niù,diào",
  "拗转": "niù,zhuǎn",
  "拗阻": "niù,zǔ",
  "拗项": "niù,xiàng",
  "拗项桥": "niù,xiàng,qiáo",
  "拘卢舍": "jū,lú,shè",
  "拘挐": "jū,ná",
  "拘挛儿": "jū,luán,er",
  "拘泥": "jū,nì",
  "拘泥地": "jū,nì,de",
  "拘神遣将": "jū,shén,qiǎn,jiàng",
  "拘禁": "jū,jìn",
  "拘累": "jū,lèi",
  "拘絜": "jū,jié",
  "拘谨地": "jū,jǐn,de",
  "拙劣地": "zhuō,liè,de",
  "拙劣地做": "zhuō,liè,de,zuò",
  "拙劣地工作": "zhuō,liè,de,gōng,zuò",
  "拙朴": "zhuō,piáo",
  "拙着": "zhuō,zhe",
  "拼去": "pàn,qù",
  "拼命": "pàn,mìng",
  "拼命地": "pàn,mìng,de",
  "拼弃": "pàn,qì",
  "拼得": "pīn,de",
  "拼死": "pàn,sǐ",
  "拼着一身剐": "pīn,zhe,yī,shēn,guǎ",
  "拼舍": "pīn,shè",
  "拼财": "pàn,cái",
  "拼除": "pàn,chú",
  "招人喜欢": "zhāo,rén,xǐ,huan",
  "招卷": "zhāo,juàn",
  "招呼": "zhāo,hu",
  "招呼站": "zhāo,hu,zhàn",
  "招帖": "zhāo,tiē",
  "招干": "zhāo,gàn",
  "招应": "zhāo,yìng",
  "招待会": "zhāo,dāi,huì",
  "招揽生意": "zhāo,lǎn,shēng,yi",
  "招数": "zhāo,shù",
  "招牌": "zhāo,pai",
  "招箾": "zhāo,xiāo",
  "招行": "zhāo,háng",
  "招降": "zhāo,xiáng",
  "招降纳叛": "zhāo,xiáng,nà,pàn",
  "拜人为师": "bài,rén,wéi,shī",
  "拜兴": "bài,xīng",
  "拜将": "bài,jiàng",
  "拜将封侯": "bài,jiàng,fēng,hóu",
  "拜帖": "bài,tiē",
  "拜帖匣": "bài,tiē,xiá",
  "拜把子": "bài,bà,zi",
  "拜折": "bài,shé",
  "拜拜": "bái,bái",
  "拜斗": "bài,dǒu",
  "拜相": "bài,xiàng",
  "拟声地": "nǐ,shēng,de",
  "拣口儿": "jiǎn,kǒu,er",
  "拤把": "qiá,bǎ",
  "拥塞": "yōng,sè",
  "拥篲救火": "yōng,huǐ,jiù,huǒ",
  "拥舍": "yōng,shè",
  "拦不住": "lán,bú,zhù",
  "拦禁": "lán,jìn",
  "拧一把": "níng,yì,bǎ",
  "拧劲儿": "nǐng,jìn,er",
  "拧性": "nìng,xìng",
  "拧成一股": "níng,chéng,yī,gǔ",
  "拧成一股绳": "níng,chéng,yī,gǔ,shéng",
  "拧扯": "níng,chě",
  "拧毛巾": "níng,máo,jīn",
  "拧紧": "níng,jǐn",
  "拧脾气": "nìng,pí,qì",
  "拧衣服": "níng,yī,fú",
  "拨乱为治": "bō,luàn,wéi,zhì",
  "拨云撩雨": "bō,yún,liáo,yǔ",
  "拨什库": "bō,shí,kù",
  "拨刺": "bō,cī",
  "拨卷": "bō,juàn",
  "拨喇喇": "bō,là,là",
  "拨嘴撩牙": "bō,zuǐ,liáo,yá",
  "拨子": "bō,zi",
  "拨弦乐器": "bō,xián,yuè,qì",
  "拨浪鼓": "bō,lang,gǔ",
  "拨空": "bō,kòng",
  "拨调": "bō,diào",
  "拨铺": "bō,pù",
  "拨雨撩云": "bō,yǔ,liáo,yún",
  "择不开": "zhái,bù,kāi",
  "择刺": "zhái,cì",
  "择处": "zé,chǔ",
  "择席": "zhái,xí",
  "择日子": "zhái,rì,zi",
  "择菜": "zhái,cài",
  "择音": "zé,yìn",
  "括帖": "kuò,tiē",
  "拭子": "shì,zi",
  "拮据": "jié,jū",
  "拱券": "gǒng,xuàn",
  "拱廊似地": "gǒng,láng,shì,de",
  "拱手相让": "gōng,shǒu,xiāng,ràng",
  "拱手而降": "gǒng,shǒu,ér,xiáng",
  "拱揖指㧑": "gǒng,yī,zhǐ,huī",
  "拱枓": "gǒng,dǒu",
  "拱肩缩背": "gǒng,jiān,suō,bèi",
  "拳头": "quán,tou",
  "拳头上站的人": "quán,tou,shàng,zhàn,de,rén",
  "拳头上走的马": "quán,tou,shàng,zǒu,de,mǎ",
  "拳头产品": "quán,tou,chǎn,pǐn",
  "拳曲": "quán,qū",
  "拶刑": "zǎn,xíng",
  "拶夹": "zā,jiā",
  "拶子": "zǎn,zǐ",
  "拶指": "zǎn,zhǐ",
  "拼命地抵抗": "pīn,mìng,de,dǐ,kàng",
  "拼弹": "pīn,dàn",
  "拼攒": "pīn,cuán",
  "拼起来": "pīn,qi,lai",
  "拽巷啰街": "zhuài,xiàng,luó,jiē",
  "拽巷𫽋街": "zhuài,xiàng,luǒ,jiē",
  "拽布拖麻": "zhuāi,bù,tuō,má",
  "拽得紧紧地": "zhuāi,dé,jǐn,jǐn,de",
  "拽扎": "yè,zā",
  "拽欛扶犂": "zhuāi,bà,fú,lí",
  "拽耙扶犁": "zhuāi,pá,fú,lí",
  "拽耙扶犂": "zhuài,pá,fú,lí",
  "拾带重还": "shí,dài,zhòng,huán",
  "拾级": "shè,jí",
  "拾级而上": "shè,jí,ér,shàng",
  "拾菜孃": "shí,cài,ráng",
  "拿不住": "ná,bú,zhù",
  "拿不动": "ná,bu,dòng",
  "拿主意": "ná,zhǔ,yi",
  "拿刀动杖": "ná,dāo,nòng,zhàng",
  "拿印把儿": "ná,yìn,bà,er",
  "拿得起": "ná,de,qǐ",
  "拿得起放得下": "ná,de,qǐ,fàng,de,xià",
  "拿得起来": "ná,de,qǐ,lái",
  "拿撒勒": "ná,sǎ,lè",
  "拿架子": "ná,jià,zi",
  "拿着鸡毛当令箭": "ná,zhe,jī,máo,dàng,lìng,jiàn",
  "拿粗夹细": "ná,cū,jiā,xì",
  "拿腔作调": "ná,qiāng,zuò,diào",
  "拿腔拿调": "ná,qiāng,ná,diào",
  "拿解": "ná,jiè",
  "拿身分": "ná,shēn,fèn",
  "持久地": "chí,jiǔ,de",
  "持更": "chí,gēng",
  "持球触地": "chí,qiú,chù,de",
  "持续不断": "chí,xù,bú,duàn",
  "持续不断地": "chí,xù,bú,duàn,de",
  "持续地": "chí,xù,de",
  "持续地工作": "chí,xù,de,gōng,zuò",
  "持续稳定地增长": "chí,xù,wěn,deng,de,zēng,zhǎng",
  "持蠡": "chí,lí",
  "持蠡测海": "chí,lí,cè,hǎi",
  "持载": "chí,zǎi",
  "挂一钩子": "guà,yī,gōu,zi",
  "挂不住": "guà,bú,zhù",
  "挂冠": "guà,guān",
  "挂冠归去": "guà,guān,guī,qù",
  "挂冠求去": "guà,guān,qiú,qù",
  "挂在嘴上": "guà,zai,zuǐ,shang",
  "挂帆": "guà,fān",
  "挂席为门": "guà,xí,wéi,mén",
  "挂幌子": "guà,huǎng,zi",
  "挂念地": "guà,niàn,de",
  "挂斗": "guà,dǒu",
  "挂星查": "guà,xīng,zhā",
  "挂毂": "guà,gū",
  "挂相": "guà,xiàng",
  "挂累": "guà,lèi",
  "挂落": "guà,là",
  "挂衣冠": "guà,yì,guān",
  "挂钩儿": "guà,gōu,er",
  "指东划西": "zhǐ,dōng,huà,xī",
  "指令性计划": "zhǐ,lìng,xìng,jì,huà",
  "指冠": "zhǐ,guān",
  "指划": "zhǐ,huà",
  "指向地": "zhǐ,xiàng,de",
  "指天为誓": "zhǐ,tiān,wéi,shì",
  "指头": "zhǐ,tou",
  "指头画": "zhǐ,tou,huà",
  "指导性计划": "zhǐ,dǎo,xìng,jì,huà",
  "指山卖磨": "zhǐ,shān,mài,mò",
  "指山说磨": "zhǐ,shān,shuō,mò",
  "指弹": "zhǐ,dàn",
  "指手划脚": "zhǐ,shǒu,huà,jiǎo",
  "指㧑": "zhǐ,huī",
  "指数": "zhǐ,shù",
  "指数函数": "zhǐ,shù,hán,shù",
  "指数地": "zhǐ,shù,de",
  "指数基金": "zhǐ,shù,jī,jīn",
  "指数套利": "zhǐ,shù,tào,lì",
  "指数期权": "zhǐ,shù,qī,quán",
  "指望地": "zhǐ,wàng,de",
  "指树为姓": "zhǐ,shù,wéi,xìng",
  "指甲": "zhǐ,jia",
  "指甲刀": "zhǐ,jia,dāo",
  "指甲剪": "zhǐ,jia,jiǎn",
  "指甲油": "zhǐ,jia,yóu",
  "指甲盖儿": "zhǐ,jiǎ,gài,er",
  "指甲花": "zhǐ,jiá,huā",
  "指甲草": "zhǐ,jiá,cǎo",
  "指甲钳": "zhǐ,jia,qián",
  "指皁为白": "zhǐ,zào,wéi,bái",
  "指皂为白": "zhǐ,zào,wéi,bái",
  "指着和尚骂秃子": "zhǐ,zhe,hé,shang,mà,tū,zi",
  "指腹为亲": "zhǐ,fù,wéi,qīn",
  "指腹为婚": "zhǐ,fù,wéi,hūn",
  "指舍": "zhǐ,shè",
  "指责地": "zhǐ,zé,de",
  "指适": "zhǐ,shì",
  "指雁为羹": "zhǐ,yàn,wéi,gēng",
  "指鹿为马": "zhǐ,lù,wéi,mǎ",
  "挈瓶之知": "qiè,píng,zhī,zhì",
  "挈累": "qiè,lèi",
  "按常规地": "àn,cháng,guī,de",
  "按年代地": "àn,nián,dài,de",
  "按弹": "àn,dàn",
  "按时地": "àn,shí,de",
  "按期地": "àn,qī,de",
  "按比例地": "àn,bǐ,lì,de",
  "按照计划": "àn,zhào,jì,huà",
  "按着三板一眼": "àn,zhe,sān,bǎn,yī,yǎn",
  "按着葫芦抠子": "àn,zhe,hú,lu,kōu,zǐ",
  "按种别地": "àn,zhǒng,bié,de",
  "按章给付": "àn,zhāng,jǐ,fù",
  "按类别地": "àn,lèi,bié,de",
  "按级地": "àn,jí,de",
  "按调": "àn,diào",
  "按𫏋": "àn,jué",
  "按鹘": "àn,hú",
  "挎兜儿": "kuà,dōu,er",
  "挎斗": "kuà,dǒu",
  "挐兵": "ná,bīng",
  "挐攫": "ná,jué",
  "挐繁": "ná,fán",
  "挐音": "ná,yīn",
  "挐首": "ná,shǒu",
  "挑三窝四": "tiǎo,sān,wō,sì",
  "挑中": "tiāo,zhòng",
  "挑么挑六": "tiāo,yāo,tiāo,liù",
  "挑刺儿": "tiāo,cì,er",
  "挑剔地": "tiāo,tī,de",
  "挑动": "tiǎo,dòng",
  "挑唆": "tiǎo,suō",
  "挑唇料嘴": "tiǎo,chún,liào,zuǐ",
  "挑嘴": "tiǎo,zuǐ",
  "挑大梁": "tiǎo,dà,liáng",
  "挑头儿": "tiǎo,tóu,er",
  "挑子": "tiāo,zi",
  "挑弄": "tiǎo,nòng",
  "挑得篮里便是菜": "tiǎo,dé,lán,lǐ,biàn,shì,cài",
  "挑战": "tiǎo,zhàn",
  "挑战书": "tiǎo,zhàn,shū",
  "挑战地": "tiǎo,zhàn,de",
  "挑战者": "tiǎo,zhàn,zhě",
  "挑战者号": "tiǎo,zhàn,zhě,hào",
  "挑担": "tiāo,dàn",
  "挑担子": "tiāo,dàn,zi",
  "挑拔": "tiǎo,bá",
  "挑拨": "tiǎo,bō",
  "挑拨地": "tiǎo,bō,de",
  "挑拨是非": "tiǎo,bō,shì,fēi",
  "挑拨离间": "tiǎo,bō,lí,jiàn",
  "挑揥": "tiāo,dì",
  "挑明": "tiǎo,míng",
  "挑檐": "tiǎo,yán",
  "挑毛剔刺儿": "tiāo,máo,tī,cì,er",
  "挑灯": "tiǎo,dēng",
  "挑灯夜战": "tiǎo,dēng,yè,zhàn",
  "挑灯拨火": "tiǎo,dēng,bō,huǒ",
  "挑牙": "tiǎo,yá",
  "挑牙料唇": "tiǎo,yá,liào,chún",
  "挑牙虫": "tiǎo,yá,chóng",
  "挑穵": "tiāo,yà",
  "挑花": "tiǎo,huā",
  "挑花眼": "tiǎo,huā,yǎn",
  "挑衅": "tiǎo,xìn",
  "挑衅似地": "tiǎo,xìn,shì,de",
  "挑起": "tiǎo,qǐ",
  "挑逗": "tiǎo,dòu",
  "挑逗性": "tiǎo,dòu,xìng",
  "挑错儿": "tiāo,cuò,er",
  "挑高": "tiǎo,gāo",
  "挓挲": "zhā,shā",
  "挖空心思地去": "wā,kōng,xīn,sī,de,qù",
  "挖苦地": "wā,kǔ,de",
  "挖苦地说": "wā,kǔ,de,shuō",
  "挖角": "wā,jué",
  "挖鼻子": "wā,bí,zi",
  "挚切": "zhì,qiè",
  "挚爱地": "zhì,ài,de",
  "挝鼓": "zhuā,gǔ",
  "挞煞": "tà,shà",
  "挟主行令": "jiā,zhǔ,xíng,lìng",
  "挟义": "jiā,yì",
  "挟书": "jiā,shū",
  "挟书令": "jiā,shū,lìng",
  "挟书律": "jiā,shū,lǜ",
  "挟令": "jiā,lìng",
  "挟依": "jiā,yī",
  "挟养": "jiā,yǎng",
  "挟册": "jiā,cè",
  "挟势弄权": "jiā,shì,nòng,quán",
  "挟奸": "jiā,jiān",
  "挟尺": "jiā,chǐ",
  "挟忿": "jiā,fèn",
  "挟恃": "jiā,shì",
  "挟挠": "jiā,náo",
  "挟提": "jiā,tí",
  "挟揓": "jiā,shì",
  "挟斯": "jiā,sī",
  "挟日": "jiā,rì",
  "挟暮": "jiā,mù",
  "挟治": "jiā,zhì",
  "挟生": "jiā,shēng",
  "挟策": "jiā,cè",
  "挟纩": "jiā,kuàng",
  "挟藏": "jiā,cáng",
  "挟赞": "jiā,zàn",
  "挟赤": "jiā,chì",
  "挟辀": "jiā,zhōu",
  "挟辅": "jiā,fǔ",
  "挠折": "náo,shé",
  "挠曲": "náo,qū",
  "挠曲枉直": "náo,qū,wǎng,zhí",
  "挠痒痒": "náo,yǎng,yang",
  "挠直为曲": "náo,zhí,wéi,qū",
  "挡头": "dǎng,tou",
  "挡头阵": "dǎng,tou,zhèn",
  "挡调": "dǎng,diào",
  "挡风玻璃": "dǎng,fēng,bō,li",
  "挣扎": "zhēng,zhá",
  "挣扎地": "zhēng,zhá,de",
  "挣气": "zhēng,qì",
  "挤上去": "jǐ,shàng,qu",
  "挥澣": "huī,hàn",
  "挥霍地": "huī,huò,de",
  "挦剥": "xián,bāo",
  "挨个儿": "āi,gè,er",
  "挨冻受饿": "ái,dòng,shòu,è",
  "挨刀的": "ái,dāo,de",
  "挨剋": "ái,kēi",
  "挨呲儿": "ái,cī,er",
  "挨头子": "ái,tóu,zi",
  "挨宰": "ái,zǎi",
  "挨家挨户地": "āi,jiā,āi,hù,de",
  "挨山塞海": "āi,shān,sè,hǎi",
  "挨延": "ái,yán",
  "挨打": "ái,dǎ",
  "挨打受气": "ái,dǎ,shòu,qì",
  "挨打受骂": "ái,dǎ,shòu,mà",
  "挨批": "ái,pī",
  "挨挤": "ái,jǐ",
  "挨挨抢抢": "āi,āi,chēng,chēng",
  "挨挨挤挤": "āi,ái,jǐ,jǐ",
  "挨揍": "ái,zòu",
  "挨整": "ái,zhěng",
  "挨斗": "ái,dòu",
  "挨日子": "ái,rì,zi",
  "挨时间": "ái,shí,jiān",
  "挨板子": "ái,bǎn,zi",
  "挨查": "āi,zhā",
  "挨着": "āi,zhe",
  "挨罚": "ái,fá",
  "挨肩儿": "āi,jiān,er",
  "挨肩叠背": "āi,jiān,dié,bèi",
  "挨肩搭背": "āi,jiān,dā,bèi",
  "挨肩擦背": "āi,jiān,cā,bèi",
  "挨肩迭背": "āi,jiān,dié,bèi",
  "挨说": "ái,shuō",
  "挨边儿": "āi,biān,er",
  "挨闷雷": "ái,mèn,léi",
  "挨风缉缝": "āi,fēng,jī,fèng",
  "挨饥抵饿": "ái,jī,dǐ,è",
  "挨饿": "ái,è",
  "挨骂": "ái,mà",
  "挪窝儿": "nuó,wō,er",
  "振兴": "zhèn,xīng",
  "振兴区": "zhèn,xīng,qū",
  "振冠": "zhèn,guān",
  "振动地": "zhèn,dòng,de",
  "振捄": "zhèn,jū",
  "挹斗扬箕": "yì,dǒu,yáng,jī",
  "挺冠": "tǐng,guān",
  "挺奇怪地说": "tǐng,qí,guài,de,shuō",
  "挺括": "tǐng,guā",
  "挺杆": "tǐng,gǎn",
  "挼好长发": "ruó,hǎo,cháng,fà",
  "挼曲子": "ruó,qǔ,zi",
  "挼莎": "ruó,shā",
  "挽手儿": "wǎn,shǒu,er",
  "挽搂": "wǎn,lōu",
  "挽毂": "wǎn,gū",
  "捂盖子": "wǔ,gài,zi",
  "捄世": "jū,shì",
  "捄偏": "jū,piān",
  "捄正": "jū,zhèng",
  "捄荒": "jū,huāng",
  "捅喽子": "tǒng,lóu,zi",
  "捅娄子": "tǒng,lóu,zi",
  "捅楼子": "tǒng,lóu,zi",
  "捆扎": "kǔn,zhā",
  "捉发": "zhuō,fà",
  "捉挐": "zhuō,ná",
  "捉衿露肘": "zhuō,jīn,lù,zhǒu",
  "捉襟露肘": "zhuō,jīn,lù,zhǒu",
  "捉贼捉脏": "zhuō,zéi,zhuō,zāng",
  "捋胡子": "lǚ,hú,zǐ",
  "捋胳膊": "luō,gē,bo",
  "捋荼": "lǚ,tú",
  "捋袖子": "luō,xiù,zi",
  "捋须": "lǚ,xū",
  "捋须钱": "lǚ,xū,qián",
  "捋髭钱": "lǚ,zī,qián",
  "捏估": "niē,gu",
  "捏和": "niē,huò",
  "捏揣": "niē,chuāi",
  "捏着鼻子": "niē,zhe,bí,zi",
  "捏舌头": "niē,shé,tou",
  "捏造地": "niē,zào,de",
  "捐背": "juān,bèi",
  "捐血": "juān,xuè",
  "捐血者": "juān,xuè,zhě",
  "捐躯殉国": "juān,qù,xùn,guó",
  "捐躯赴难": "juān,qū,fù,nàn",
  "捐馆舍": "juān,guǎn,shè",
  "捕处": "bǔ,chǔ",
  "捘削": "zùn,xuē",
  "捞什子": "lāo,shí,zi",
  "损兵折将": "sǔn,bīng,zhé,jiàng",
  "损军折将": "sǔn,jūn,zhé,jiàng",
  "损剥": "sǔn,bāo",
  "损折": "sǔn,shé",
  "捡了芝麻丢了西瓜": "jiǎn,le,zhī,ma,diū,le,xī,guā",
  "捡便宜": "jiǎn,pián,yí",
  "捡洋落儿": "jiǎn,yáng,là,ér",
  "捡破烂儿": "jiǎn,pò,làn,er",
  "换手抓背": "huàn,shǒu,zhuā,bèi",
  "换把子": "huàn,bà,zi",
  "换挡杆": "huàn,dǎng,gǎn",
  "换斗移星": "huàn,dǒu,yí,xīng",
  "换血": "huàn,xuè",
  "换行": "huàn,háng",
  "捣乱分子": "dǎo,luàn,fèn,zi",
  "捣嗓子": "dǎo,sǎng,zi",
  "捣鬼地": "dǎo,guǐ,de",
  "捣鼓": "dǎo,gu",
  "捧角": "pěng,jué",
  "捧角儿": "pěng,jué,er",
  "捭棁": "bǎi,tuō",
  "据为己有": "jù,wéi,jǐ,yǒu",
  "捯饬": "dáo,chi",
  "捰袖揎拳": "luò,xiù,xuān,quán",
  "捱三顶五": "āi,sān,dǐng,wǔ",
  "捱三顶四": "āi,sān,dǐng,sì",
  "捱查": "ái,zhā",
  "捱风缉缝": "āi,fēng,qī,fèng",
  "捶子": "chuí,zi",
  "捶掠": "chuí,lüě",
  "捶背": "chuí,bèi",
  "捶胸跌脚": "chuí,xiōng,diē,jiǎo",
  "捶胸跌足": "chuí,xiōng,diē,zú",
  "捷得": "jié,de",
  "捷给": "jié,jǐ",
  "捺兴": "nà,xīng",
  "捺弮": "nà,quān",
  "捻土为香": "niǎn,tǔ,wéi,xiāng",
  "捻捻转": "niǎn,niǎn,zhuàn",
  "捻捻转儿": "niǎn,niǎn,zhuàn,ér",
  "捻着鼻子": "niǎn,zhe,bí,zi",
  "捻脚捻手": "niē,jiǎo,niē,shǒu",
  "捻转儿": "niǎn,zhuàn,ér",
  "捼莎": "ruó,shā",
  "捽兀": "zuó,wū",
  "掀背车": "xiān,bèi,chē",
  "掂折": "diān,shé",
  "掂斤抹两": "diān,jīn,mò,liǎng",
  "掂梢折本": "diān,shāo,shé,běn",
  "掂量": "diān,liáng",
  "授予": "shòu,yǔ",
  "掉价儿": "diào,jià,er",
  "掉点儿": "diào,diǎn,er",
  "掉链子": "diào,liàn,zi",
  "掉队地": "diào,duì,de",
  "掊克": "póu,kè",
  "掊冒": "póu,mào",
  "掊刻": "póu,kè",
  "掊取": "póu,qǔ",
  "掊怨": "póu,yuàn",
  "掊攟": "póu,jùn",
  "掊攻": "póu,gōng",
  "掊敛": "póu,liǎn",
  "掊斗折衡": "pǒu,dǒu,zhé,héng",
  "掊斥": "póu,chì",
  "掊聚": "póu,jù",
  "掌子面": "zhǎng,zi,miàn",
  "掌掴": "zhǎng,guāi",
  "掌盘子": "zhǎng,pán,zi",
  "掌相": "zhǎng,xiàng",
  "掌舍": "zhǎng,shè",
  "掍殽": "hùn,yáo",
  "掎挈伺诈": "jǐ,qiè,sì,zhà",
  "掎裳连𰳵": "jǐ,shang,lián,yì",
  "掏火耙": "tāo,huǒ,pá",
  "掏肠剖肚": "tāo,cháng,pōu,dù",
  "掐着指头": "qiā,zhe,zhǐ,tou",
  "掐脖子": "qiā,bó,zi",
  "排他地": "pái,tā,de",
  "排叉": "pái,chà",
  "排叉儿": "pái,chà,ér",
  "排外地": "pái,wài,de",
  "排子枪": "pǎi,zǐ,qiāng",
  "排子炮": "pǎi,zǐ,pào",
  "排子车": "pǎi,zǐ,chē",
  "排忧解难": "pái,yōu,jiě,nàn",
  "排折": "pái,shé",
  "排数": "pái,shù",
  "排栅": "pái,shān",
  "排泄物地": "pái,xiè,wù,de",
  "排笮": "pái,zé",
  "排行": "pái,háng",
  "排行榜": "pái,háng,bǎng",
  "排调": "pái,diào",
  "排车": "pǎi,chē",
  "排轧": "pái,zhá",
  "排长": "pái,zhǎng",
  "排难": "pái,nàn",
  "排难解纷": "pái,nàn,jiě,fēn",
  "掖咕": "yē,gu",
  "掖在怀里": "yē,zài,huái,lǐ",
  "掖掖盖盖": "yē,yē,gài,gài",
  "掖满": "yē,mǎn",
  "掖给": "yē,gěi",
  "掖进去": "yē,jìn,qù",
  "掘井及泉": "jué,jǐng,jǐ,quán",
  "掘强": "jué,jiàng",
  "掞丽": "yàn,lì",
  "掞天": "yàn,tiān",
  "掞张": "yàn,zhāng",
  "掞蔚": "yàn,wèi",
  "掞藻": "yàn,zǎo",
  "掞迈": "yàn,mài",
  "掠削": "lüě,xuē",
  "掠剩": "lüě,shèng",
  "掠剩使": "lüě,shèng,shǐ",
  "掠剩鬼": "lüě,shèng,guǐ",
  "掠劫": "lüě,jié",
  "掠卤": "lüě,lǔ",
  "掠地": "lüě,dì",
  "掠头": "lüě,tóu",
  "掠子": "lüě,zǐ",
  "掠彴": "lüě,zhuó",
  "掠役": "lüě,yì",
  "掠抄": "lüě,chāo",
  "掠拷": "lüě,kǎo",
  "掠掳": "lüě,lǔ",
  "掠敚": "lüě,duó",
  "掠服": "lüě,fú",
  "掠杀": "lüě,shā",
  "掠楚": "lüě,chǔ",
  "掠治": "lüě,zhì",
  "掠海": "lüě,hǎi",
  "掠理": "lüě,lǐ",
  "掠盗": "lüě,dào",
  "掠立": "lüě,lì",
  "掠笞": "lüě,chī",
  "掠约": "lüě,yuē",
  "掠美市恩": "lüě,měi,shì,ēn",
  "掠考": "lüě,kǎo",
  "掠草": "lüě,cǎo",
  "掠虏": "lüě,lǔ",
  "掠虚": "lüě,xū",
  "掠袭": "lüě,xí",
  "掠贩": "lüě,fàn",
  "掠闹": "lüě,nào",
  "掠阵": "lüě,zhèn",
  "探亲假": "tàn,qīn,jià",
  "探伺": "tàn,sì",
  "探头探脑儿": "tàn,tóu,tàn,nǎo,er",
  "探子": "tàn,zi",
  "探揣": "tàn,chuāi",
  "探索地": "tàn,suǒ,de",
  "探身子": "tàn,shēn,zi",
  "探长": "tàn,zhǎng",
  "掣襟露肘": "chè,jīn,lù,zhǒu",
  "接发": "jiē,fà",
  "接受地": "jiē,shòu,de",
  "接头儿": "jiē,tou,er",
  "接应": "jiē,yìng",
  "接煞": "jiē,shà",
  "接着": "jiē,zhe",
  "接种": "jiē,zhòng",
  "接纳地": "jiē,nà,de",
  "接缝": "jiē,fèng",
  "接触地": "jiē,chù,de",
  "接近地": "jiē,jìn,de",
  "接连地": "jiē,lián,de",
  "接连地打": "jiē,lián,de,dǎ",
  "控于地": "kòng,yú,de",
  "控制杆": "kòng,zhì,gǎn",
  "控卷": "kòng,juàn",
  "控咽": "kòng,yān",
  "控愬": "kòng,shuò",
  "控揣": "kòng,chuāi",
  "推剥": "tuī,bāo",
  "推垛子": "tuī,duǒ,zi",
  "推处": "tuī,chǔ",
  "推子": "tuī,zi",
  "推弹": "tuī,dàn",
  "推恩削藩": "tuī,ēn,xuē,fān",
  "推数": "tuī,shù",
  "推枯折腐": "tuī,kū,shé,fǔ",
  "推潭仆远": "tuī,tán,pú,yuǎn",
  "推理地": "tuī,lǐ,de",
  "推磨": "tuī,mò",
  "推䇲": "tuī,jiā",
  "推背图": "tuī,bèi,tú",
  "推论地": "tuī,lùn,de",
  "推诿地": "tuī,wěi,de",
  "推调": "tuī,diào",
  "推轮捧毂": "tuī,lún,pěng,gū",
  "掩伺": "yǎn,sì",
  "掩卷": "yǎn,juàn",
  "掩咽": "yǎn,yān",
  "掩着": "yǎn,zhe",
  "掩薶": "yǎn,wō",
  "措辞不当": "cuò,cí,bú,dàng",
  "措辞得当": "cuò,cí,dé,dàng",
  "掫扞": "zōu,gǎn",
  "掰扯": "bāi,che",
  "掰腕子": "bāi,wàn,zi",
  "掴手": "guāi,shǒu",
  "掴耳光": "guāi,ěr,guāng",
  "掷弹筒": "zhì,dàn,tǒng",
  "掷楯": "zhì,dùn",
  "掷色": "zhì,shǎi",
  "掷还": "zhì,huán",
  "掷骰子": "zhì,tóu,zi",
  "掸子": "dǎn,zi",
  "掸桌子": "dǎn,zhuō,zi",
  "掸邦": "shàn,bāng",
  "掸邦高原": "shàn,bāng,gāo,yuán",
  "掺合": "chān,he",
  "掺和": "chān,huo",
  "掺手": "shǎn,shǒu",
  "掺挝": "càn,zhuā",
  "掺沙子": "chān,shā,zi",
  "掺袂": "shǎn,mèi",
  "揃刈": "jiān,yì",
  "揃坏": "jiān,huài",
  "揃扑": "jiān,pū",
  "揃搣": "jiān,miè",
  "揃落": "jiān,luò",
  "揄翟": "yú,zhái",
  "揄铺": "yú,pù",
  "揆度": "kuí,duó",
  "揆情度理": "kuí,qíng,duó,lǐ",
  "揆理度情": "kuí,lǐ,duó,qíng",
  "揉搓": "róu,cuo",
  "揉磨": "róu,mo",
  "揎拳捰袖": "xuān,quán,luǒ,xiù",
  "描写地": "miáo,xiě,de",
  "描着模儿": "miáo,zhe,mó,ér",
  "提供": "tí,gōng",
  "提供商": "tí,gōng,shāng",
  "提供者": "tí,gōng,zhě",
  "提前地": "tí,qián,de",
  "提头儿": "tí,tóu,er",
  "提干": "tí,gàn",
  "提溜": "dī,liū",
  "提溜秃卢": "dī,liū,tū,lú",
  "提珩": "tí,háng",
  "提示性地": "tí,shì,xìng,de",
  "提篮儿": "tí,lán,er",
  "提调": "tí,diào",
  "提起精神": "tí,qǐ,jīng,shen",
  "提防": "dī,fáng",
  "插一杠子": "chā,yī,gàng,zi",
  "插上": "chā,shang",
  "插不上手": "chā,bu,shàng,shǒu",
  "插句地": "chā,jù,de",
  "插杠子": "chā,gàng,zi",
  "插空": "chā,kòng",
  "揘毕": "yóng,bì",
  "揙刀": "biàn,dāo",
  "揙玭": "biàn,pín",
  "揜着": "yǎn,zhe",
  "揠苗助长": "yà,miáo,zhù,zhǎng",
  "握发": "wò,fà",
  "握发殿": "wò,fà,diàn",
  "握沐吐飱": "wò,mù,tǔ,cān",
  "握粟出卜": "wò,sù,chū,bo",
  "握𱌶": "wò,chuò",
  "揣与": "chuāi,yǔ",
  "揣丸": "chuāi,wán",
  "揣事": "chuāi,shì",
  "揣侔": "chuāi,móu",
  "揣切": "chuāi,qiē",
  "揣力": "chuāi,lì",
  "揣占": "chuāi,zhàn",
  "揣合": "chuāi,hé",
  "揣合逢迎": "chuǎi,hé,féng,yíng",
  "揣在怀里": "chuāi,zài,huái,lǐ",
  "揣夺": "chuǎi,duó",
  "揣奸把猾": "chuāi,jiān,bǎ,huá",
  "揣己": "chuāi,jǐ",
  "揣巴": "chuāi,bā",
  "揣度": "chuǎi,duó",
  "揣微": "chuāi,wēi",
  "揣情": "chuǎi,qíng",
  "揣想": "chuǎi,xiǎng",
  "揣手": "chuāi,shǒu",
  "揣手儿": "chuāi,shǒu,er",
  "揣抹": "chuāi,mǒ",
  "揣拟": "chuāi,nǐ",
  "揣挫": "chuǎi,cuò",
  "揣揣": "chuāi,chuāi",
  "揣摩": "chuǎi,mó",
  "揣摸": "chuǎi,mō",
  "揣摹": "chuǎi,mó",
  "揣料": "chuǎi,liào",
  "揣时度力": "chuǎi,shí,duó,lì",
  "揣歪": "chuāi,wāi",
  "揣歪捏怪": "chuāi,wāi,niē,guài",
  "揣测": "chuǎi,cè",
  "揣着明白装糊涂": "chuāi,zhe,míng,bai,zhuāng,hú,tu",
  "揣称": "chuǎi,chèn",
  "揣说": "chuāi,shuō",
  "揣较": "chuāi,jiào",
  "揣量": "chuāi,liàng",
  "揣驹": "chuāi,jū",
  "揣骨": "chuāi,gǔ",
  "揣骨听声": "chuāi,gǔ,tīng,shēng",
  "揦子": "lá,zi",
  "揩摨": "kāi,nái",
  "揩背": "kāi,bèi",
  "揪撇": "jiū,piě",
  "揪辫子": "jiū,biàn,zi",
  "揭盖子": "jiē,gài,zi",
  "揭衣涉水": "qì,yī,shè,shuǐ",
  "揭调": "jiē,diào",
  "揭载": "jiē,zǎi",
  "揭露": "jiē,lù",
  "揲揲锤锤": "dié,dié,chuí,chuí",
  "揲蓍": "dié,shī",
  "揲蓍草": "dié,shī,cǎo",
  "揲贯": "dié,guàn",
  "援交小姐": "yuán,jiāo,xiǎo,jie",
  "援古证今": "yá,gǔ,zhèng,jīn",
  "援应": "yuán,yìng",
  "援藏": "yuán,zàng",
  "揵子": "jiàn,zǐ",
  "揵毒": "jiàn,dú",
  "揶揄地": "yé,yú,de",
  "揽载": "lǎn,zǎi",
  "搀和": "chān,huo",
  "搀摵": "chān,shè",
  "搀行夺市": "chān,háng,duó,shì",
  "搀要地": "chān,yào,de",
  "搁不住": "gé,bú,zhù",
  "搁得住": "gé,de,zhù",
  "搁栅": "gé,zhà",
  "搁浅地": "gē,qiǎn,de",
  "搁煞": "gē,shà",
  "搂伐": "lōu,fá",
  "搂包": "lōu,bāo",
  "搂处": "lōu,chǔ",
  "搂带": "lōu,dài",
  "搂把": "lōu,bǎ",
  "搂揽": "lōu,lǎn",
  "搂搜": "lōu,sōu",
  "搂摗": "lōu,sōu",
  "搂沟子": "lōu,gōu,zǐ",
  "搂算": "lōu,suàn",
  "搂罗": "lōu,luó",
  "搂账": "lōu,zhàng",
  "搂钱": "lōu,qián",
  "搅和": "jiǎo,huo",
  "搅哄": "jiǎo,hòng",
  "搅撩": "jiǎo,liáo",
  "搅混": "jiǎo,gǔn",
  "𫼝弹": "chōu,dàn",
  "𫼝弹家": "chōu,dàn,jiā",
  "𫼝扎": "chōu,zhā",
  "搋子": "chuāi,zi",
  "搐口儿": "chù,kǒu,er",
  "搒决": "péng,jué",
  "搒挞": "péng,tà",
  "搒捶": "péng,chuí",
  "搒掠": "péng,lüě",
  "搒械": "péng,xiè",
  "搒棰": "péng,chuí",
  "搒楚": "péng,chǔ",
  "搒童": "péng,tóng",
  "搒笞": "péng,chī",
  "搓麻将": "cuō,má,jiàng",
  "搔着痒处": "sāo,zhe,yǎng,chù",
  "搔耙": "sāo,pá",
  "搔背": "sāo,bèi",
  "搔背扒子": "sāo,bèi,pá,zǐ",
  "搜岩采干": "sōu,yán,cǎi,gàn",
  "搜括": "sōu,guā",
  "搜掠": "sōu,lüě",
  "搞不好": "gǎo,bu,hǎo",
  "搞不懂": "gǎo,bu,dǒng",
  "搞头": "gǎo,tou",
  "搞笑地": "gǎo,xiào,de",
  "搞脏": "gǎo,zāng",
  "搞花样儿": "gǎo,huā,yàng,er",
  "搞错地": "gǎo,cuò,de",
  "搠渰": "shuò,yǎn",
  "搢朴": "jìn,piáo",
  "搤吭": "è,kēng",
  "搥背": "chuí,bèi",
  "搥胸跌脚": "duī,xiōng,diē,jiǎo",
  "搥胸跌足": "duī,xiōng,diē,zú",
  "搧小扇子": "shān,xiǎo,shàn,zi",
  "搪塞": "táng,sè",
  "搪差使": "táng,chāi,shǐ",
  "搬兴废": "bān,xīng,fèi",
  "搬枒": "bān,yá",
  "搬楦头": "bān,xuàn,tou",
  "搬石头砸自己的脚": "bān,shí,tou,zá,zì,jǐ,de,jiǎo",
  "搬舌头": "bān,shé,tou",
  "搬调": "bān,diào",
  "搬起石头砸自己的脚": "bān,qǐ,shí,tou,zá,zì,jǐ,de,jiǎo",
  "搬铺": "bān,pù",
  "搭当": "dā,dàng",
  "搭把子": "dā,bà,zi",
  "搭把手儿": "dā,bǎ,shǒu,er",
  "搭挡": "dā,dàng",
  "搭架子": "dā,jià,zi",
  "搭班子": "dā,bān,zi",
  "搭缝": "dā,fèng",
  "搭背": "dā,bèi",
  "搭茬儿": "dā,chá,er",
  "搭裢": "dā,lian",
  "搭调": "dā,diào",
  "搴㧛": "qiān,lǎn",
  "搴旗取将": "qiān,qí,qǔ,jiàng",
  "搴旗斩将": "qiān,qí,zhǎn,jiàng",
  "抢水": "qiāng,shuǐ",
  "摁扣儿": "èn,kòu,er",
  "摆动地": "bǎi,dòng,de",
  "摆摊儿": "bǎi,tān,er",
  "摆摊子": "bǎi,tān,zi",
  "摆擂": "bǎi,lèi",
  "摆擂台": "bǎi,lèi,tái",
  "摆擂枱": "bǎi,lèi,tái",
  "摆晃": "bǎi,huàng",
  "摆枱": "bǎi,tái",
  "摆架子": "bǎi,jià,zi",
  "摆样子": "bǎi,yàng,zi",
  "摆花架子": "bǎi,huā,jià,zi",
  "摆袖却金": "bài,xiù,què,jīn",
  "摆设儿": "bǎi,she,er",
  "摆调": "bǎi,diào",
  "摆谱儿": "bǎi,pǔ,er",
  "摆铺": "bǎi,pù",
  "摇动地": "yáo,dòng,de",
  "摇头晃脑": "yáo,tóu,huàng,nǎo",
  "摇手触禁": "yáo,shǒu,chù,jìn",
  "摇把": "yáo,bà",
  "摇摆地": "yáo,bǎi,de",
  "摇晃": "yáo,huàng",
  "摇晃地": "yáo,huàng,de",
  "摇晃地悬挂着": "yáo,huàng,de,xuán,guà,zhe",
  "摇曳地": "yáo,yè,de",
  "摇杆": "yáo,gǎn",
  "摇滚乐": "yáo,gǔn,yuè",
  "摇笔杆儿": "yáo,bǐ,gǎn,er",
  "摊事儿": "tān,shì,er",
  "摊儿": "tān,er",
  "摊子": "tān,zi",
  "摊薄": "tān,bó",
  "摊薄后每股盈利": "tān,bó,hòu,měi,gǔ,yíng,lì",
  "摒挡": "bìng,dàng",
  "摔打": "shuāi,dá",
  "摔跌": "shuāi,diē",
  "摔跟头": "shuāi,gēn,tou",
  "摘帽子": "zhāi,mào,zi",
  "摘桃子": "zhāi,táo,zi",
  "摘瑕指瑜": "tì,xiá,zhǐ,yú",
  "摘要地": "zhāi,yào,de",
  "摛掞": "chī,yàn",
  "摧刚为柔": "cuī,gāng,wéi,róu",
  "摧心剖肝": "cuī,xīn,pōu,gān",
  "摧折": "cuī,shé",
  "摩侯罗": "mó,hòu,luó",
  "摩托车的士": "mó,tuō,chē,dī,shì",
  "摩挲": "mā,sā",
  "摩挲石": "mā,sā,shí",
  "摩捋": "mó,lǚ",
  "摩揣": "mó,chuāi",
  "摩登地": "mó,dēng,de",
  "摩的": "mó,dī",
  "摩翫": "mó,wàn",
  "摩耶": "mó,yē",
  "摩跌": "mó,diē",
  "摸不着": "mō,bù,zháo",
  "摸不着头脑": "mō,bù,zháo,tóu,nǎo",
  "摸头不着": "mō,tóu,bù,zháo",
  "摸得着": "mō,de,zháo",
  "摸着石头过河": "mō,zhe,shí,tou,guò,hé",
  "摸石头过河": "mō,shí,tou,guò,hé",
  "摸索": "mō,suo",
  "摸索着地": "mō,suǒ,zhe,de",
  "摸门不着": "mō,mén,bù,zháo",
  "摸门儿": "mō,mén,er",
  "摸黑儿": "mō,hēi,er",
  "摹帖": "mó,tiē",
  "摹揣": "mó,chuāi",
  "摹调": "mó,diào",
  "撂挑子": "liào,tiāo,zi",
  "撅坑撅堑": "jué,kēng,jué,qiàn",
  "撇下": "piē,xia",
  "撇号": "piě,hào",
  "撇呆打堕": "piě,dāi,dǎ,duò",
  "撇嘴": "piě,zuǐ",
  "撇大条": "piě,dà,tiáo",
  "撇条": "piě,tiáo",
  "撇步": "piě,bù",
  "撒切尔夫人": "sā,qiē,ěr,fū,ren",
  "撒呓挣": "sā,yì,zhēng",
  "撒娇似地": "sā,jiāo,shì,de",
  "撒娇地说": "sā,jiāo,de,shuō",
  "撒布": "sǎ,bù",
  "撒播": "sǎ,bō",
  "撒施": "sǎ,shī",
  "撒狗粮": "sǎ,gǒu,liáng",
  "撒种": "sǎ,zhǒng",
  "撒豆成兵": "sǎ,dòu,chéng,bīng",
  "撒都该人": "sā,dū,gāi,rén",
  "撒马尔干": "sā,mǎ,ěr,gàn",
  "撞运气": "zhuàng,yùn,qi",
  "撤差": "chè,chāi",
  "𪮖耳揉腮": "yōng,ěr,róu,sāi",
  "𪮖耳顿足": "yǎn,ěr,dùn,zú",
  "撩乱": "liáo,luàn",
  "撩云拨雨": "liáo,yún,bō,yǔ",
  "撩人": "liáo,rén",
  "撩动": "liáo,dòng",
  "撩妹": "liáo,mèi",
  "撩开": "liáo,kāi",
  "撩惹": "liáo,rě",
  "撩拨": "liáo,bō",
  "撩是生非": "liáo,shì,shēng,fēi",
  "撩火加油": "liáo,huǒ,jiā,yóu",
  "撩蜂剔蝎": "liáo,fēng,tì,xiē",
  "撩蜂吃螫": "liáo,fēng,chī,shì",
  "撩逗": "liáo,dòu",
  "播撒": "bō,sǎ",
  "播穅眯目": "bō,kāng,mǐ,mù",
  "播糠眯目": "bō,kāng,mǐ,mù",
  "撮科打哄": "cuō,kē,dǎ,hòng",
  "撰著": "zhuàn,zhe",
  "擂主": "lèi,zhǔ",
  "擂台": "lèi,tái",
  "擂台赛": "lèi,tái,sài",
  "擅权地": "shàn,quán,de",
  "擅长地": "shàn,cháng,de",
  "操之过切": "cāo,zhī,guò,qiè",
  "操作数": "cāo,zuò,shù",
  "操你妈": "cào,nǐ,mā",
  "操其奇赢": "chao,qi,ji,ying",
  "操切": "cāo,qiè",
  "操屄": "cào,bī",
  "操持": "cāo,chi",
  "操纵杆": "cāo,zòng,gǎn",
  "操蛋": "cào,dàn",
  "操逼": "cào,bī",
  "擎露": "qíng,lù",
  "擘划": "bò,huà",
  "擢发莫数": "zhuó,fà,mò,shǔ",
  "擢发难数": "zhuó,fà,nán,shǔ",
  "擦子": "cā,zi",
  "擦屁股": "cā,pì,gu",
  "擦拳抹掌": "cā,quán,mò,zhǎng",
  "擦背": "cā,bèi",
  "擦黑儿": "cā,hēi,er",
  "𰔖埴索涂": "zhāi,zhí,suǒ,tú",
  "𰔖埴索途": "zhāi,zhí,suǒ,tú",
  "𰔖植索涂": "zhāi,zhí,suǒ,tú",
  "攀今㧛古": "pān,jīn,lǎn,gǔ",
  "攀意地": "pān,yì,de",
  "攀敛性地": "pān,liǎn,xìng,de",
  "攀朱槛": "pān,zhū,kǎn",
  "攀槛": "pān,kǎn",
  "攀橑": "pān,lǎo",
  "攀治地": "pān,zhì,de",
  "攀累": "pān,lèi",
  "攀翫": "pān,wàn",
  "攀育地": "pān,yù,de",
  "攀良似地": "pān,liáng,shì,de",
  "攀花折柳": "pān,huā,shé,liǔ",
  "攀藤揽葛": "pān,téng,lǎn,gě",
  "攀藤附葛": "pān,téng,fù,gě",
  "攀蟾折桂": "pān,chán,shé,guì",
  "攀针地": "pān,zhēn,de",
  "攀龙讬凤": "pān,lóng,xiù,fèng",
  "攒三聚五": "cuán,sān,jù,wǔ",
  "攒三集五": "cuán,sān,jí,wǔ",
  "攒动": "cuán,dòng",
  "攒射": "cuán,shè",
  "攒盒": "cuán,hé",
  "攒眉": "cuán,méi",
  "攒眉蹙额": "cuán,méi,cù,é",
  "攒簇": "cuán,cù",
  "攒聚": "cuán,jù",
  "攒锋聚镝": "cuán,fēng,jù,dí",
  "攒集": "cuán,jí",
  "攒零合整": "cuán,líng,hé,zhěng",
  "攘场": "rǎng,cháng",
  "攘辟": "rǎng,bì",
  "𫽋袖揎拳": "luǒ,xiù,xuān,quán",
  "攥拳头": "zuàn,quán,tou",
  "攫为己有": "jué,wéi,jǐ,yǒu",
  "支付地": "zhī,fù,de",
  "支兀另": "zhī,wū,lìng",
  "支吾地": "zhī,wú,de",
  "支吾地说": "zhī,wú,de,shuō",
  "支差": "zhī,chāi",
  "支帖": "zhī,tiē",
  "支干": "zhī,gàn",
  "支应": "zhī,yìng",
  "支应局": "zhī,yìng,jú",
  "支招儿": "zhī,zhāo,er",
  "支支查查": "zhī,zhī,zhā,zhā",
  "支数": "zhī,shù",
  "支更": "zhī,gēng",
  "支查": "zhī,zhā",
  "支楞楞": "zhī,lèng,lèng",
  "支楞楞争": "zhī,lèng,lèng,zhēng",
  "支煞": "zhī,shà",
  "支着": "zhī,zhāo",
  "支着儿": "zhī,zhāo,ér",
  "支行": "zhī,háng",
  "支调": "zhī,diào",
  "攲侧": "jī,cè",
  "攲倾": "jī,qīng",
  "收什": "shōu,shí",
  "收假": "shōu,jià",
  "收帑": "shōu,tǎng",
  "收得": "shōu,de",
  "收拾残局": "shōu,shi,cán,jú",
  "收掠": "shōu,lüě",
  "收摊儿": "shōu,tān,er",
  "收摊子": "shōu,tān,zi",
  "收敛性地": "shōu,liǎn,xìng,de",
  "收敛级数": "shōu,liǎn,jí,shù",
  "收数": "shōu,shù",
  "收旗卷伞": "shōu,qí,juàn,sǎn",
  "收禁": "shōu,jìn",
  "收藏夹": "shōu,cáng,jiā",
  "收血": "shōu,xuè",
  "收责": "shōu,zhài",
  "收购要约": "shōu,gòu,yāo,yuē",
  "收载": "shōu,zǎi",
  "收降": "shōu,xiáng",
  "改为": "gǎi,wéi",
  "改削": "gǎi,xuē",
  "改善关系": "gǎi,shàn,guān,xi",
  "改土为流": "gǎi,tǔ,wéi,liú",
  "改姓更名": "gǎi,xìng,gēng,míng",
  "改张易调": "gǎi,zhāng,yì,diào",
  "改弦易调": "gǎi,xián,yì,diào",
  "改弦更张": "gǎi,xián,gēng,zhāng",
  "改恶为善": "gǎi,è,wéi,shàn",
  "改折": "gǎi,shé",
  "改曲易调": "gǎi,qǔ,yì,diào",
  "改更": "gǎi,gēng",
  "改行": "gǎi,háng",
  "改行为善": "gǎi,xíng,wéi,shàn",
  "改调": "gǎi,diào",
  "改适": "gǎi,shì",
  "攻不破地": "gōng,bù,pò,de",
  "攻击行为": "gōng,jī,xíng,wéi",
  "攻剖": "gōng,pōu",
  "攻剥": "gōng,bāo",
  "攻剽": "gōng,piāo",
  "攻势地": "gōng,shì,de",
  "攻城掠地": "gōng,chéng,lüě,dì",
  "攻弹": "gōng,dàn",
  "攻心扼吭": "gōng,xīn,è,kēng",
  "攻掠": "gōng,lüě",
  "攻𰱈": "gōng,yǒng",
  "攻过箴阙": "gōng,guò,zhēn,què",
  "攻难": "gōng,nàn",
  "放下你的鞭子": "fàng,xià,nǐ,de,biān,zi",
  "放下包袱": "fàng,xia,bāo,fu",
  "放不下": "fàng,bu,xià",
  "放不下心": "fàng,bu,xià,xīn",
  "放任地": "fàng,rèn,de",
  "放假": "fàng,jià",
  "放声地哭": "fàng,shēng,de,kū",
  "放大倍数": "fàng,dà,bèi,shù",
  "放大率": "fàng,dà,shuài",
  "放射状地": "fàng,shè,zhuàng,de",
  "放射镜地": "fàng,shè,jìng,de",
  "放屁辣臊": "fàng,pì,là,sào",
  "放得下": "fàng,de,xià",
  "放心地做": "fàng,xīn,de,zuò",
  "放心地用": "fàng,xīn,de,yòng",
  "放心地走了": "fàng,xīn,de,zǒu,le",
  "放心地饮用": "fàng,xīn,de,yǐn,yòng",
  "放恣": "fàng,cī",
  "放敶": "fàng,zhèn",
  "放烟幕弹": "fàng,yān,mù,dàn",
  "放热反应": "fàng,rè,fǎn,yìng",
  "放着": "fàng,zhe",
  "放着明白装糊涂": "fàng,zhe,míng,bai,zhuāng,hú,tu",
  "放纵地": "fàng,zòng,de",
  "放纵地笑": "fàng,zòng,de,xiào",
  "放肆地": "fàng,sì,de",
  "放肆地笑": "fàng,sì,de,xiào",
  "放荡地": "fàng,dàng,de",
  "放血": "fàng,xuè",
  "放骜": "fàng,ào",
  "放鸽子": "fàng,gē,zi",
  "政府拨地": "zhèng,fǔ,bō,de",
  "政教处": "zhèng,jiào,chǔ",
  "政治上地": "zhèng,zhì,shàng,de",
  "政治地": "zhèng,zhì,de",
  "政治避难": "zhèng,zhì,bì,nàn",
  "政策性银行": "zhèng,cè,xìng,yín,háng",
  "政适": "zhèng,shì",
  "敁敠": "diān,duó",
  "故事影片": "gù,shì,yǐng,piān",
  "故事片儿": "gù,shì,piān,er",
  "故侯": "gù,hòu",
  "故侯瓜": "gù,hòu,guā",
  "故地重游": "gù,dì,chóng,yóu",
  "故处": "gù,chǔ",
  "故封识": "gu,feng,zhi",
  "故帖": "gù,tiē",
  "故弄玄虚地": "gù,nòng,xuán,xū,de",
  "故态复还": "gù,tài,fù,huán",
  "故意地": "gù,yì,de",
  "故技重演": "gù,jì,chóng,yǎn",
  "故都": "gù,dū",
  "效应": "xiào,yìng",
  "敌对地": "dí,duì,de",
  "敌将": "dí,jiàng",
  "敌应": "dí,yìng",
  "敌方地": "dí,fāng,de",
  "敌特分子": "dí,tè,fèn,zǐ",
  "敏感地": "mǐn,gǎn,de",
  "敏感地发现": "mǐn,gǎn,de,fā,xiàn",
  "敏捷地": "mǐn,jié,de",
  "敏而好学": "mǐn,ér,hào,xué",
  "敏锐地": "mǐn,ruì,de",
  "救寒莫如重裘": "jiù,hán,mò,rú,chóng,qiú",
  "救应": "jiù,yìng",
  "救恩计划": "jiù,ēn,jì,huà",
  "救数人": "jiù,shù,rén",
  "救火投薪": "jiù,huò,tóu,xīn",
  "救生堤": "jiù,shēng,dī",
  "救苦救难": "jiù,kǔ,jiù,nàn",
  "救难": "jiù,nàn",
  "救难船": "jiù,nàn,chuán",
  "敖不可长": "ào,bù,kě,zhǎng",
  "教一识百": "jiāo,yī,shí,bǎi",
  "教中文": "jiāo,zhōng,wén",
  "教书": "jiāo,shū",
  "教书匠": "jiāo,shū,jiàng",
  "教会": "jiāo,huì",
  "教会地": "jiào,huì,de",
  "教养地": "jiào,yǎng,de",
  "教务长": "jiào,wù,zhǎng",
  "教区地": "jiào,qū,de",
  "教坏": "jiāo,huài",
  "教学": "jiāo,xué",
  "教学相长": "jiào,xué,xiāng,zhǎng",
  "教学计划": "jiào,xué,jì,huà",
  "教导地": "jiào,dǎo,de",
  "教帖": "jiào,tiē",
  "教数": "jiào,shù",
  "教猱升木": "jiāo,náo,shēng,mù",
  "教禁": "jiào,jìn",
  "教给": "jiāo,gěi",
  "教育地": "jiào,yù,de",
  "教育背景": "jiào,yù,bèi,jǐng",
  "教育部长": "jiào,yù,bù,zhǎng",
  "教训": "jiào,xun",
  "教训地": "jiào,xùn,de",
  "教课": "jiāo,kè",
  "教长": "jiào,zhǎng",
  "教音乐": "jiāo,yīn,yuè",
  "敛剥": "liǎn,bāo",
  "敛声屏气": "liǎn,shēng,bǐng,qì",
  "敛容屏气": "liǎn,róng,bǐng,qì",
  "敛巴": "liǎn,ba",
  "敛掠": "liǎn,lüě",
  "敛色屏气": "liǎn,sè,bǐng,qì",
  "敜干敹甲": "niè,gàn,liáo,jiǎ",
  "敝绨恶粟": "bì,tì,è,sù",
  "敝舃": "bì,tuō",
  "敝𫏋": "bì,jué",
  "敞开儿": "chǎng,kāi,er",
  "敞胸露怀": "chǎng,xiōng,lù,huái",
  "敢为": "gǎn,wéi",
  "敢为人先": "gǎn,wéi,rén,xiān",
  "敢为敢做": "gǎn,wéi,gǎn,zuò",
  "敢仔": "gǎn,zǎi",
  "敢作敢为": "gǎn,zuò,gǎn,wéi",
  "敢做敢为": "gǎn,zuò,gǎn,wéi",
  "敢干": "gǎn,gàn",
  "敢情": "gǎn,qing",
  "散乱": "sǎn,luàn",
  "散乱地": "sǎn,luàn,de",
  "散人": "sǎn,rén",
  "散件": "sǎn,jiàn",
  "散体": "sǎn,tǐ",
  "散侯": "sàn,hòu",
  "散光": "sǎn,guāng",
  "散兵": "sǎn,bīng",
  "散兵坑": "sǎn,bīng,kēng",
  "散兵游勇": "sǎn,bīng,yóu,yǒng",
  "散兵线": "sǎn,bīng,xiàn",
  "散养": "sǎn,yǎng",
  "散列": "sǎn,liè",
  "散剂": "sǎn,jì",
  "散剽": "sàn,piāo",
  "散匪": "sǎn,fěi",
  "散发": "sàn,fà",
  "散发抽簪": "sàn,fà,chōu,zān",
  "散处": "sàn,chǔ",
  "散客": "sǎn,kè",
  "散射": "sǎn,shè",
  "散居": "sǎn,jū",
  "散工": "sǎn,gōng",
  "散布地": "sàn,bù,de",
  "散座儿": "sǎn,zuò,er",
  "散开地": "sàn,kāi,de",
  "散弹": "sǎn,dàn",
  "散弹枪": "sǎn,dàn,qiāng",
  "散慢地说": "sàn,màn,de,shuō",
  "散摊子": "sàn,tān,zi",
  "散散停停": "sǎn,sǎn,tíng,tíng",
  "散散儿": "sǎn,sǎn,ér",
  "散散的": "sǎn,sǎn,de",
  "散散落落": "sǎn,sǎn,luò,luò",
  "散文": "sǎn,wén",
  "散文式地": "sǎn,wén,shì,de",
  "散文般地": "sǎn,wén,bān,de",
  "散文诗": "sǎn,wén,shī",
  "散景": "sǎn,jǐng",
  "散曲": "sǎn,qǔ",
  "散更": "sàn,gēng",
  "散朴": "sàn,piáo",
  "散板": "sǎn,bǎn",
  "散架": "sǎn,jià",
  "散步似地": "sàn,bù,shì,de",
  "散沙": "sǎn,shā",
  "散漫": "sǎn,màn",
  "散漫地": "sǎn,màn,de",
  "散漫地说": "sǎn,màn,de,shuō",
  "散点图": "sǎn,diǎn,tú",
  "散热器护栅": "sàn,rè,qì,hù,shān",
  "散碎": "sǎn,suì",
  "散禁": "sàn,jìn",
  "散粉": "sǎn,fěn",
  "散职": "sǎn,zhí",
  "散腿裤": "sǎn,tuǐ,kù",
  "散装": "sǎn,zhuāng",
  "散见": "sǎn,jiàn",
  "散记": "sǎn,jì",
  "散话": "sǎn,huà",
  "散诞": "sǎn,dàn",
  "散适": "sàn,shì",
  "敦处": "dūn,chǔ",
  "敦庬": "dūn,máng",
  "敦弓": "diāo,gōng",
  "敦朴": "dūn,piáo",
  "敦然": "tuán,rán",
  "敦瓜": "tuán,guā",
  "敦碻": "dūn,qiāo",
  "敦适": "dūn,shì",
  "敬慕地": "jìng,mù,de",
  "数一数": "shǔ,yī,shù",
  "数万": "shù,wàn",
  "数不尽": "shǔ,bu,jìn",
  "数不清地": "shǔ,bù,qīng,de",
  "数不着": "shǔ,bù,zháo",
  "数世之患": "shù,shì,zhī,huàn",
  "数中": "shù,zhōng",
  "数以亿计": "shù,yǐ,yì,jì",
  "数以千计": "shù,yǐ,qiān,jì",
  "数以百计": "shù,yǐ,bǎi,jì",
  "数众": "shù,zhòng",
  "数伤": "shù,shāng",
  "数位": "shù,wèi",
  "数位信号": "shù,wèi,xìn,hào",
  "数位网路": "shù,wèi,wǎng,lù",
  "数位货币": "shù,wèi,huò,bì",
  "数值": "shù,zhí",
  "数值分析": "shù,zhí,fēn,xī",
  "数值解": "shù,zhí,jiě",
  "数内": "shù,nèi",
  "数列": "shù,liè",
  "数制": "shù,zhì",
  "数十亿": "shù,shí,yì",
  "数参": "shù,cān",
  "数叨": "shù,dāo",
  "数周": "shù,zhōu",
  "数命": "shù,mìng",
  "数器": "shù,qì",
  "数四": "shù,sì",
  "数域": "shù,yù",
  "数奇": "shù,jī",
  "数字": "shù,zì",
  "数字信号": "shù,zì,xìn,hào",
  "数字分频": "shù,zì,fēn,pín",
  "数字化": "shù,zì,huà",
  "数字命理学": "shù,zì,mìng,lǐ,xué",
  "数字地": "shù,zì,de",
  "数字导览设施": "shù,zì,dǎo,lǎn,shè,shī",
  "数字时钟": "shù,zì,shí,zhōng",
  "数字游民": "shù,zì,yóu,mín",
  "数字版权管理": "shù,zì,bǎn,quán,guǎn,lǐ",
  "数字用户线路": "shù,zì,yòng,hù,xiàn,lù",
  "数字电视": "shù,zì,diàn,shì",
  "数字电路": "shù,zì,diàn,lù",
  "数字网": "shù,zì,wǎng",
  "数字货币": "shù,zì,huò,bì",
  "数字通信": "shù,zì,tōng,xìn",
  "数字钟": "shù,zì,zhōng",
  "数学": "shù,xué",
  "数学公式": "shù,xué,gōng,shì",
  "数学分析": "shù,xué,fēn,xī",
  "数学家": "shù,xué,jiā",
  "数学模型": "shù,xué,mó,xíng",
  "数学物理": "shù,xué,wù,lǐ",
  "数学物理学": "shù,xué,wù,lǐ,xué",
  "数家": "shù,jiā",
  "数小时": "shù,xiǎo,shí",
  "数巡": "shù,xún",
  "数年": "shù,nián",
  "数年如一日": "shù,nián,rú,yí,rì",
  "数度": "shù,dù",
  "数得上": "shǔ,děi,shàng",
  "数得着": "shǔ,de,zháo",
  "数息": "shù,xī",
  "数据": "shù,jù",
  "数据介面": "shù,jù,jiè,miàn",
  "数据传输": "shù,jù,chuán,shū",
  "数据压缩": "shù,jù,yā,suō",
  "数据处理": "shù,jù,chǔ,lǐ",
  "数据库": "shù,jù,kù",
  "数据库管理系统": "shù,jù,kù,guǎn,lǐ,xì,tǒng",
  "数据库软件": "shù,jù,kù,ruǎn,jiàn",
  "数据总线": "shù,jù,zǒng,xiàn",
  "数据挖掘": "shù,jù,wā,jué",
  "数据接口": "shù,jù,jiē,kǒu",
  "数据机": "shù,jù,jī",
  "数据段": "shù,jù,duàn",
  "数据流": "shù,jù,liú",
  "数据流计算机": "shù,jù,liú,jì,suàn,jī",
  "数据组": "shù,jù,zǔ",
  "数据网络": "shù,jù,wǎng,luò",
  "数据通信": "shù,jù,tōng,xìn",
  "数据链路": "shù,jù,liàn,lù",
  "数据链路层": "shù,jù,liàn,lù,céng",
  "数据链路连接标识": "shù,jù,liàn,lù,lián,jiē,biāo,zhì",
  "数控": "shù,kòng",
  "数控机床": "shù,kòng,jī,chuáng",
  "数数": "shǔ,shù",
  "数斯": "shù,sī",
  "数日恶": "shuò,rì,è",
  "数月": "shù,yuè",
  "数术": "shù,shù",
  "数杂": "shù,zá",
  "数棊": "shù,qí",
  "数模": "shù,mó",
  "数模转换器": "shù,mó,zhuǎn,huàn,qì",
  "数法": "shù,fǎ",
  "数独": "shù,dú",
  "数珠": "shù,zhū",
  "数理": "shù,lǐ",
  "数理分析": "shù,lǐ,fēn,xī",
  "数理化": "shù,lǐ,huà",
  "数理统计": "shù,lǐ,tǒng,jì",
  "数理逻辑": "shù,lǐ,luó,jí",
  "数番家": "shù,fān,jiā",
  "数百": "shù,bǎi",
  "数百万": "shù,bǎi,wàn",
  "数目": "shù,mù",
  "数目字": "shù,mù,zì",
  "数相": "shù,xiāng",
  "数码": "shù,mǎ",
  "数码冲印": "shù,mǎ,chōng,yìn",
  "数码化": "shù,mǎ,huà",
  "数码扫描": "shù,mǎ,sǎo,miáo",
  "数码港": "shù,mǎ,gǎng",
  "数码照相机": "shù,mǎ,zhào,xiàng,jī",
  "数码相机": "shù,mǎ,xiàng,jī",
  "数码货币": "shù,mǎ,huò,bì",
  "数码通": "shù,mǎ,tōng",
  "数种": "shù,zhǒng",
  "数策": "shù,cè",
  "数米量柴": "shǔ,mǐ,liáng,chái",
  "数粒": "shù,lì",
  "数纪": "shù,jì",
  "数组": "shù,zǔ",
  "数罪": "shù,zuì",
  "数罪并罚": "shù,zuì,bìng,fá",
  "数蓍": "shù,shī",
  "数表": "shù,biǎo",
  "数见不鲜": "shuò,jiàn,bù,xiān",
  "数计": "shù,jì",
  "数论": "shù,lùn",
  "数词": "shù,cí",
  "数责": "shù,zé",
  "数轴": "shù,zhóu",
  "数迹": "shù,jì",
  "数量": "shù,liàng",
  "数量分析": "shù,liàng,fēn,xī",
  "数量积": "shù,liàng,jī",
  "数量级": "shù,liàng,jí",
  "数量词": "shù,liàng,cí",
  "数额": "shù,é",
  "数黄道白": "shù,huáng,dào,bái",
  "数黑论白": "shù,hēi,lùn,bái",
  "敲丧钟": "qiāo,sāng,zhōng",
  "敲中背": "qiāo,zhōng,bèi",
  "敲削": "qiāo,xuē",
  "敲剥": "qiāo,bāo",
  "敲坷垃": "qiāo,kē,lā",
  "敲大背": "qiāo,dà,bèi",
  "敲小背": "qiāo,xiǎo,bèi",
  "敲弹": "qiāo,dàn",
  "敲搒": "qiāo,péng",
  "敲更": "qiāo,gēng",
  "敲朴": "qiāo,piáo",
  "敲背": "qiāo,bèi",
  "敲诈地": "qiāo,zhà,de",
  "敲锣边儿": "qiāo,luó,biān,er",
  "敲骨剥髓": "qiāo,gǔ,bāo,suǐ",
  "整个儿地": "zhěng,gè,ér,de",
  "整个地": "zhěng,gè,de",
  "整体数位服务网路": "zhěng,tǐ,shù,wèi,fú,wù,wǎng,lù",
  "整体服务数位网路": "zhěng,tǐ,fú,wù,shù,wèi,wǎng,lù",
  "整倍数": "zhěng,bèi,shù",
  "整年累月": "zhěng,nián,lèi,yuè",
  "整形地": "zhěng,xíng,de",
  "整批地": "zhěng,pī,de",
  "整数": "zhěng,shù",
  "整数倍数": "zhěng,shù,bèi,shù",
  "整数集合": "zhěng,shù,jí,hé",
  "整洁地": "zhěng,jié,de",
  "整絜": "zhěng,jié",
  "整躬率物": "zhěng,gōng,shuài,wù",
  "整除数": "zhěng,chú,shù",
  "整顿干坤": "zhěng,dùn,gàn,kūn",
  "整齐划一": "zhěng,qí,huà,yī",
  "整齐地": "zhěng,qí,de",
  "敷兴": "fū,xīng",
  "敷翫": "fū,wàn",
  "敷衍了事": "fū,yǎn,liǎo,shì",
  "敷衍地": "fū,yǎn,de",
  "敷衍塞责": "fū,yǎn,sè,zé",
  "敷衍搪塞": "fū,yǎn,táng,sè",
  "敷露": "fū,lù",
  "文书处理": "wén,shū,chǔ,lǐ",
  "文什": "wén,shí",
  "文件夹": "wén,jiàn,jiā",
  "文化上地": "wén,huà,shàng,de",
  "文卷": "wén,juàn",
  "文坛宿将": "wén,tán,sù,jiàng",
  "文字上地": "wén,zì,shàng,de",
  "文字处理": "wén,zì,chǔ,lǐ",
  "文学上地": "wén,xué,shàng,de",
  "文帖": "wén,tiē",
  "文干": "wén,gàn",
  "文房四侯": "wén,fáng,sì,hòu",
  "文扎": "wén,zhā",
  "文朴": "wén,piáo",
  "文法上地": "wén,fǎ,shàng,de",
  "文禁": "wén,jìn",
  "文章憎命": "wén,zhāng,zèng,mìng",
  "文绉绉": "wén,zhōu,zhōu",
  "文背": "wén,bèi",
  "文艺复兴": "wén,yì,fù,xīng",
  "文艺复兴艺术": "wén,yì,fù,xīng,yì,shù",
  "文行出处": "wén,xíng,chū,chǔ",
  "文调": "wén,diào",
  "文貍": "wén,mái",
  "文过遂非": "wén,guò,suí,fēi",
  "文雅地": "wén,yǎ,de",
  "文𱇒": "wén,bǐ",
  "斋仆": "zhāi,pú",
  "斋冠": "zhāi,guān",
  "斋干": "zhāi,gàn",
  "斋禁": "zhāi,jìn",
  "斋絜": "zhāi,jié",
  "斋舍": "zhāi,shè",
  "斐什": "fěi,shí",
  "斑特处士": "bān,tè,chǔ,shì",
  "斑背噪鹛": "bān,bèi,zào,méi",
  "斑背大尾莺": "bān,bèi,dà,wěi,yīng",
  "斑背潜鸭": "bān,bèi,qián,yā",
  "斑背燕尾": "bān,bèi,yàn,wěi",
  "斗乱": "dǒu,luàn",
  "斗份子": "dòu,fèn,zi",
  "斗储": "dǒu,chǔ",
  "斗六": "dǒu,liù",
  "斗六市": "dǒu,liù,shì",
  "斗内": "dǒu,nèi",
  "斗分子": "dòu,fèn,zǐ",
  "斗升之水": "dǒu,shēng,zhī,shuǐ",
  "斗南": "dǒu,nán",
  "斗南一人": "dǒu,nán,yī,rén",
  "斗南镇": "dǒu,nán,zhèn",
  "斗叶子": "dòu,yè,zi",
  "斗哄": "dòu,hǒng",
  "斗大": "dǒu,dà",
  "斗子": "dǒu,zi",
  "斗子盐": "dǒu,zi,yán",
  "斗室": "dǒu,shì",
  "斗宿": "dǒu,xiù",
  "斗帐": "dǒu,zhàng",
  "斗折": "dǒu,shé",
  "斗折蛇行": "dǒu,zhé,shé,xíng",
  "斗拱": "dǒu,gǒng",
  "斗挹箕扬": "dǒu,yì,jī,yáng",
  "斗方": "dǒu,fāng",
  "斗方名士": "dǒu,fāng,míng,shì",
  "斗柄": "dǒu,bǐng",
  "斗榫合缝": "dǒu,sǔn,hé,fèng",
  "斗渠": "dǒu,qú",
  "斗牛㹴": "dòu,niú,gěng",
  "斗笠": "dǒu,lì",
  "斗筐": "dǒu,kuāng",
  "斗筲": "dǒu,shāo",
  "斗筲之人": "dǒu,shāo,zhī,rén",
  "斗筲之器": "dǒu,shāo,zhī,qì",
  "斗筲之材": "dǒu,shāo,zhī,cái",
  "斗筲子": "dǒu,shāo,zǐ",
  "斗篷": "dǒu,péng",
  "斗米尺布": "dǒu,mǐ,chǐ,bù",
  "斗粟": "dǒu,sù",
  "斗粟尺布": "dǒu,sù,chǐ,bù",
  "斗绝一隅": "dǒu,jué,yī,yú",
  "斗缝": "dòu,fèng",
  "斗胆": "dǒu,dǎn",
  "斗舍": "dòu,shè",
  "斗袚": "dòu,bō",
  "斗趣儿": "dòu,qù,er",
  "斗车": "dǒu,chē",
  "斗转": "dǒu,zhuǎn",
  "斗转参横": "dǒu,zhuǎn,shēn,héng",
  "斗转星移": "dǒu,zhuǎn,xīng,yí",
  "斗酒": "dǒu,jiǔ",
  "斗酒只鸡": "dǒu,jiǔ,zhī,jī",
  "斗酒学士": "dǒu,jiǔ,xué,shì",
  "斗酒百篇": "dǒu,jiǔ,bǎi,piān",
  "斗酒飞拳": "dǒu,jiǔ,fēi,quán",
  "斗量": "dǒu,liáng",
  "斗量筲计": "dǒu,liáng,shāo,jì",
  "斗量车载": "dǒu,liáng,chē,zài",
  "斗门": "dǒu,mén",
  "斗门区": "dǒu,mén,qū",
  "料件子": "liào,jiàn,zi",
  "料件子活": "liào,jiàn,zi,huó",
  "料头儿": "liào,tóu,er",
  "料子": "liào,zi",
  "料子服": "liào,zi,fú",
  "料应": "liào,yìng",
  "料得": "liào,de",
  "料数": "liào,shù",
  "料斗": "liào,dǒu",
  "料理铺": "liào,lǐ,pù",
  "料豆儿": "liào,dòu,er",
  "斛槛": "hú,kǎn",
  "斜向一边地": "xié,xiàng,yī,biān,de",
  "斜地横过": "xié,de,héng,guò",
  "斜地里": "xié,de,lǐ",
  "斜对地": "xié,duì,de",
  "斜愣眼": "xié,leng,yǎn",
  "斜愣眼儿": "xié,leng,yǎn,er",
  "斜攲": "xié,jī",
  "斜斜地": "xié,xié,de",
  "斜杆": "xié,gǎn",
  "斜着地": "xié,zhe,de",
  "斜纹软呢": "xié,wén,ruǎn,ní",
  "斜航地": "xié,háng,de",
  "斜视地": "xié,shì,de",
  "斜靠式地": "xié,kào,shì,de",
  "斜驶地": "xié,shǐ,de",
  "斟汋": "zhēn,yuè",
  "斤削": "jīn,xuē",
  "斤斗": "jīn,dǒu",
  "斤斗云": "jīn,dǒu,yún",
  "斥责地": "chì,zé,de",
  "斧削": "fǔ,xuē",
  "斧子": "fǔ,zi",
  "斧𬬱": "fǔ,yǐn",
  "斩六将": "zhǎn,liù,jiàng",
  "斩头沥血": "zhǎn,tóu,lì,xuè",
  "斩将刈旗": "zhǎn,jiàng,yì,qí",
  "斩将夺旗": "zhǎn,jiàng,duó,qí",
  "斩将搴旗": "zhǎn,jiàng,qiān,qí",
  "斩缞": "zhǎn,shuāi",
  "斩衰冠": "zhǎn,shuāi,guān",
  "斫木为舟": "zhuó,mù,wéi,zhōu",
  "斫琱为朴": "zhuó,diāo,wéi,pǔ",
  "斫畲": "zhuó,yú",
  "斫雕为朴": "zhuó,diāo,wéi,pǔ",
  "断不了": "duàn,bù,liǎo",
  "断发": "duàn,fà",
  "断发文身": "duàn,fà,wén,shēn",
  "断喝": "duàn,hè",
  "断堤": "duàn,dī",
  "断奏地": "duàn,zòu,de",
  "断手续玉": "duàn,shóu,xù,yù",
  "断断续续地": "duàn,duàn,xù,xù,de",
  "断然地": "duàn,rán,de",
  "断片儿": "duàn,piàn,er",
  "断续地干咳": "duàn,xù,de,gān,hāi",
  "断续性地": "duàn,xù,xìng,de",
  "断背": "duàn,bèi",
  "断背山": "duàn,bèi,shān",
  "断行": "duàn,háng",
  "断袖之好": "duàn,xiù,zhī,hào",
  "断裂模数": "duàn,liè,mó,shù",
  "断褏": "duàn,yòu",
  "断还": "duàn,huán",
  "断还归宗": "duàn,huán,guī,zōng",
  "断鹤继凫": "duan,he,xu,fu",
  "斯堪的纳维亚": "sī,kān,dì,nà,wéi,yà",
  "斯堪的纳维亚半岛": "sī,kān,dì,nà,wéi,yà,bàn,dǎo",
  "斯多葛主义": "sī,duō,gě,zhǔ,yì",
  "斯夹巴": "sī,jiā,bā",
  "斯宾塞": "sī,bīn,sè",
  "斯宾诺莎": "sī,bīn,nuò,shā",
  "斯干": "sī,gàn",
  "斯干之梦": "sī,gàn,zhī,mèng",
  "斯文地": "sī,wén,de",
  "斯文委地": "sī,wén,wěi,de",
  "斯禁": "sī,jìn",
  "新乐府": "xīn,yuè,fǔ",
  "新兴": "xīn,xīng",
  "新兴产业": "xīn,xīng,chǎn,yè",
  "新兴区": "xīn,xīng,qū",
  "新兴县": "xīn,xīng,xiàn",
  "新兴经济国家": "xīn,xīng,jīng,jì,guó,jiā",
  "新冠": "xīn,guān",
  "新冠病毒": "xīn,guān,bìng,dú",
  "新冠肺炎": "xīn,guān,fèi,yán",
  "新地圩": "xīn,de,wéi",
  "新型冠状病毒": "xīn,xíng,guān,zhuàng,bìng,dú",
  "新大地": "xīn,dà,de",
  "新奇地": "xīn,qí,de",
  "新娘子": "xīn,niáng,zi",
  "新媳妇儿": "xīn,xí,fù,er",
  "新干": "xīn,gàn",
  "新干县": "xīn,gàn,xiàn",
  "新干线": "xīn,gàn,xiàn",
  "新开茅厕三日香": "xīn,kāi,máo,si,sān,rì,xiāng",
  "新斯科舍": "xīn,sī,kē,shè",
  "新柏拉图主义": "xīn,bó,lā,tú,zhǔ,yì",
  "新正": "xīn,zhēng",
  "新派地": "xīn,pài,de",
  "新畬": "xīn,yú",
  "新禁": "xīn,jìn",
  "新粮地": "xīn,liáng,de",
  "新罕布什尔": "xīn,hǎn,bù,shí,ěr",
  "新罕布什尔州": "xīn,hǎn,bù,shí,ěr,zhōu",
  "新调": "xīn,diào",
  "新近地": "xīn,jìn,de",
  "新都": "xīn,dū",
  "新都区": "xīn,dū,qū",
  "新都桥": "xīn,dū,qiáo",
  "新都桥镇": "xīn,dū,qiáo,zhèn",
  "新闻策划": "xīn,wén,cè,huà",
  "新靓": "xīn,liàng",
  "新鲜劲儿": "xīn,xiān,jìn,er",
  "新鲜血液": "xīn,xiān,xuè,yè",
  "斲削": "zhuó,xuē",
  "斲琱为朴": "zhuó,diāo,wéi,piáo",
  "斲雕为朴": "zhuó,diāo,wéi,piáo",
  "方丈": "fāng,zhang",
  "方亭侯": "fāng,tíng,hòu",
  "方侯": "fāng,hòu",
  "方便主子": "fāng,biàn,zhǔ,zi",
  "方便地": "fāng,biàn,de",
  "方便地使用": "fāng,biàn,de,shǐ,yòng",
  "方便地制作": "fāng,biàn,de,zhì,zuò",
  "方便地查看": "fāng,biàn,de,chá,kàn",
  "方兴未已": "fāng,xīng,wèi,yǐ",
  "方兴未艾": "fāng,xīng,wèi,ài",
  "方处": "fāng,chǔ",
  "方子": "fāng,zi",
  "方寸万重": "fāng,cùn,wàn,chóng",
  "方山冠": "fāng,shān,guān",
  "方形地": "fāng,xíng,de",
  "方折": "fāng,shé",
  "方数": "fāng,shù",
  "方歅": "fāng,yīn",
  "方正不阿": "fāng,zhèng,bù,ē",
  "方毂": "fāng,gū",
  "方祇": "fāng,qí",
  "方䇲": "fāng,jiā",
  "方絜": "fāng,jié",
  "方纔": "fāng,shān",
  "方载": "fāng,zǎi",
  "於乎": "wū,hū",
  "於菟": "wū,tú",
  "施为": "shī,wéi",
  "施予": "shī,yǔ",
  "施工缝": "shī,gōng,fèng",
  "施绯拖绿": "shī,fēi,tuō,lù",
  "斿旐": "yóu,zhào",
  "斿贡": "yóu,gòng",
  "旁午": "bàng,wǔ",
  "旁州样子": "páng,zhōu,yàng,zi",
  "旁舍": "páng,shè",
  "旁观者效应": "páng,guān,zhě,xiào,yìng",
  "旁跌": "páng,diē",
  "旁边儿": "páng,biān,er",
  "旁边地": "páng,biān,de",
  "旄倪": "mào,ní",
  "旄幢": "máo,zhuàng",
  "旄期": "mào,qī",
  "旅帆": "lǚ,fān",
  "旅舍": "lǚ,shè",
  "旅贲": "lǚ,bēn",
  "旋儿": "xuán,er",
  "旋卷": "xuán,juàn",
  "旋子": "xuán,zi",
  "旋工": "xuàn,gōng",
  "旋床": "xuàn,chuáng",
  "旋折": "xuán,shé",
  "旋木": "xuàn,mù",
  "旋沤": "xuán,ōu",
  "旋涡似地": "xuán,wō,shì,de",
  "旋背": "xuán,bèi",
  "旋蠡": "xuán,lí",
  "旋转地": "xuán,zhuǎn,de",
  "旋转干坤": "xuán,zhuǎn,gàn,kūn",
  "旋转曲面": "xuán,zhuǎn,qū,miàn",
  "旋转行李传送带": "xuán,zhuǎn,xíng,li,chuán,sòng,dài",
  "旋𰺷": "xuán,rǎo",
  "旋风": "xuàn,fēng",
  "旋风册子": "xuàn,fēng,cè,zi",
  "旋风分离器": "xuàn,fēng,fēn,lí,qì",
  "旋风叶": "xuàn,fēng,yè",
  "旋风笔": "xuàn,fēng,bǐ",
  "旋风脚": "xuàn,fēng,jiǎo",
  "旋风装": "xuàn,fēng,zhuāng",
  "旌干": "jīng,gàn",
  "旌斿": "jīng,yóu",
  "旌贲": "jīng,bēn",
  "族曾王母": "zú,zēng,wáng,mǔ",
  "族曾王父": "zú,zēng,wáng,fù",
  "族曾祖母": "zú,zēng,zǔ,mǔ",
  "族曾祖父": "zú,zēng,zǔ,fù",
  "族蠡": "zú,lí",
  "族长": "zú,zhǎng",
  "旗子": "qí,zi",
  "旗幢": "qí,zhuàng",
  "旗干": "qí,gàn",
  "旛幢": "fān,zhuàng",
  "无万数": "wú,wàn,shù",
  "无上地": "wú,shàng,de",
  "无上将军": "wú,shàng,jiàng,jūn",
  "无下箸处": "wú,xià,zhù,chǔ",
  "无与为比": "wú,yǔ,wéi,bǐ",
  "无业闲散": "wú,yè,xián,sǎn",
  "无为": "wú,wéi",
  "无为之治": "wú,wéi,zhī,zhì",
  "无为化": "wú,wéi,huà",
  "无为县": "wú,wéi,xiàn",
  "无为天下先": "wú,wéi,tiān,xià,xiān",
  "无为子": "wú,wéi,zǐ",
  "无为法": "wú,wéi,fǎ",
  "无为牛后": "wú,wéi,niú,hòu",
  "无为而成": "wú,wéi,ér,chéng",
  "无为而治": "wú,wéi,ér,zhì",
  "无为自化": "wú,wéi,zì,huà",
  "无为自成": "wú,wéi,zì,chéng",
  "无为谓": "wú,wéi,wèi",
  "无以为": "wú,yǐ,wéi",
  "无以为报": "wú,yǐ,wéi,bào",
  "无以为生": "wú,yǐ,wéi,shēng",
  "无以塞责": "wú,yǐ,sè,zé",
  "无价值地": "wú,jià,zhí,de",
  "无休止地": "wú,xiū,zhǐ,de",
  "无伤无臭": "wú,shāng,wú,xiù",
  "无使滋蔓": "wu,shi,zi,man",
  "无保留地": "wú,bǎo,liú,de",
  "无信仰地": "wú,xìn,yǎng,de",
  "无俾": "wú,bǐ",
  "无做作": "wú,zuò,zuo",
  "无儋石": "wú,dàn,shí",
  "无光泽地": "wú,guāng,zé,de",
  "无关地": "wú,guān,de",
  "无兴趣地": "wú,xìng,qù,de",
  "无准备地": "wú,zhǔn,bèi,de",
  "无分别地": "wú,fēn,bié,de",
  "无力地": "wú,lì,de",
  "无力地看": "wú,lì,de,kàn",
  "无力地看着": "wú,lì,de,kàn,zhe",
  "无力地靠在": "wú,lì,de,kào,zài",
  "无力气地": "wú,lì,qì,de",
  "无动为大": "wú,dòng,wéi,dà",
  "无助地": "wú,zhù,de",
  "无双地": "wú,shuāng,de",
  "无变化地": "wú,biàn,huà,de",
  "无可奈何地": "wú,kě,nài,hé,de",
  "无可挑剔": "wú,kě,tiāo,ti",
  "无可非议地": "wú,kě,fēi,yì,de",
  "无可非难": "wú,kě,fēi,nàn",
  "无名声地": "wú,míng,shēng,de",
  "无后为大": "wú,hòu,wéi,dà",
  "无困难地": "wú,kùn,nán,de",
  "无地自处": "wú,dì,zì,chǔ",
  "无地起楼台相公": "wú,dì,qǐ,lóu,tái,xiàng,gōng",
  "无堤": "wú,dī",
  "无堤之舆": "wú,dī,zhī,yú",
  "无声乐": "wú,shēng,yuè",
  "无声地": "wú,shēng,de",
  "无声无臭": "wú,shēng,wú,xiù",
  "无处": "wú,chǔ",
  "无头苍蝇": "wú,tóu,cāng,ying",
  "无奈地": "wú,nài,de",
  "无奈地摇头": "wú,nài,de,yáo,tóu",
  "无奈地笑道": "wú,nài,de,xiào,dào",
  "无奈地说": "wú,nài,de,shuō",
  "无宁": "wú,nìng",
  "无宗教地": "wú,zōng,jiào,de",
  "无定形地": "wú,deng,xíng,de",
  "无定着": "wú,dìng,zhe",
  "无害地": "wú,hài,de",
  "无射": "wú,yì",
  "无射律": "wú,yì,lǜ",
  "无将牌": "wú,jiàng,pái",
  "无尽地": "wú,jìn,de",
  "无差别地": "wú,chā,bié,de",
  "无希望地": "wú,xī,wàng,de",
  "无常地": "wú,cháng,de",
  "无底地": "wú,dǐ,de",
  "无度地": "wú,dù,de",
  "无异议地": "wú,yì,yì,de",
  "无当": "wú,dàng",
  "无得": "wú,de",
  "无心地": "wú,xīn,de",
  "无忒": "wú,tuī",
  "无思想地": "wú,sī,xiǎng,de",
  "无性地": "wú,xìng,de",
  "无恒安息": "wu,heng,an,xi",
  "无恶不为": "wú,è,bù,wéi",
  "无恶意地": "wú,è,yì,de",
  "无悔意地": "wú,huǐ,yì,de",
  "无情地": "wú,qíng,de",
  "无意义地": "wú,yì,yì,de",
  "无意地": "wú,yì,de",
  "无意识地": "wú,yì,shí,de",
  "无感地": "wú,gǎn,de",
  "无感情地": "wú,gǎn,qíng,de",
  "无感觉地": "wú,gǎn,jué,de",
  "无愧地说": "wú,kuì,de,shuō",
  "无慈悲地": "wú,cí,bēi,de",
  "无所不为": "wú,suǒ,bù,wéi",
  "无所事事地": "wú,suǒ,shì,shì,de",
  "无所事事地过活": "wú,suǒ,shì,shì,de,guò,huó",
  "无所作为": "wú,suǒ,zuò,wéi",
  "无所适从": "wú,suǒ,shì,cóng",
  "无扎垫": "wú,zhā,diàn",
  "无技巧地": "wú,jì,qiǎo,de",
  "无技术地": "wú,jì,shù,de",
  "无把握地": "wú,bǎ,wò,de",
  "无掩饰地": "wú,yǎn,shì,de",
  "无故地": "wú,gù,de",
  "无效地": "wú,xiào,de",
  "无效率地": "wú,xiào,lǜ,de",
  "无敌地": "wú,dí,de",
  "无数": "wú,shù",
  "无数地": "wú,shù,de",
  "无数次地": "wú,shù,cì,de",
  "无斑点地": "wú,bān,diǎn,de",
  "无方向地": "wú,fāng,xiàng,de",
  "无智地": "wú,zhì,de",
  "无曾": "wú,zēng",
  "无望地": "wú,wàng,de",
  "无权地": "wú,quán,de",
  "无条件地": "wú,tiáo,jiàn,de",
  "无条件投降": "wú,tiáo,jiàn,tóu,xiáng",
  "无条理地": "wú,tiáo,lǐ,de",
  "无次序地": "wú,cì,xù,de",
  "无欲地": "wú,yù,de",
  "无毒地": "wú,dú,de",
  "无比地": "wú,bǐ,de",
  "无气力地": "wú,qì,lì,de",
  "无污地": "wú,wū,de",
  "无污染地": "wú,wū,rǎn,de",
  "无法地": "wú,fǎ,de",
  "无法律地": "wú,fǎ,lǜ,de",
  "无法真正地": "wú,fǎ,zhēn,zhèng,de",
  "无活力地": "wú,huó,lì,de",
  "无添饰地": "wú,tiān,shì,de",
  "无理性地": "wú,lǐ,xìng,de",
  "无理数": "wú,lǐ,shù",
  "无理智地": "wú,lǐ,zhì,de",
  "无瑕疵地": "wú,xiá,cī,de",
  "无生命地": "wú,shēng,mìng,de",
  "无生气地": "wú,shēng,qì,de",
  "无畏地": "wú,wèi,de",
  "无疑地": "wú,yí,de",
  "无病自炙": "wú,bìng,zì,jiǔ",
  "无症状地": "wú,zhèng,zhuàng,de",
  "无痛苦地": "wú,tòng,kǔ,de",
  "无的放矢": "wú,dì,fàng,shǐ",
  "无益地": "wú,yì,de",
  "无目地": "wú,mù,de",
  "无知地": "wú,zhī,de",
  "无知觉地": "wú,zhī,jué,de",
  "无礼地": "wú,lǐ,de",
  "无礼貌地": "wú,lǐ,mào,de",
  "无禁": "wú,jìn",
  "无私地": "wú,sī,de",
  "无稽地": "wú,jī,de",
  "无穷地": "wú,qióng,de",
  "无穷尽地": "wú,qióng,jìn,de",
  "无穷递缩等比数列": "wú,qióng,dì,suō,děng,bǐ,shù,liè",
  "无端地": "wú,duān,de",
  "无䇲": "wú,jiā",
  "无算数": "wú,suàn,shù",
  "无累": "wú,lěi",
  "无经验地": "wú,jīng,yàn,de",
  "无缘无故地": "wú,yuán,wú,gù,de",
  "无缝": "wú,fèng",
  "无缝塔": "wú,fèng,tǎ",
  "无缝连接": "wú,fèng,lián,jiē",
  "无缝钢管": "wú,fèng,gāng,guǎn",
  "无缺点地": "wú,quē,diǎn,de",
  "无罪地": "wú,zuì,de",
  "无耐性地": "wú,nài,xìng,de",
  "无耻地": "wú,chǐ,de",
  "无聊地": "wú,liáo,de",
  "无联络地": "wú,lián,luò,de",
  "无背无侧": "wú,bèi,wú,cè",
  "无能为": "wú,néng,wéi",
  "无能为力": "wú,néng,wéi,lì",
  "无能为力地": "wú,néng,wéi,lì,de",
  "无能为役": "wú,néng,wéi,yì",
  "无能力地": "wú,néng,lì,de",
  "无能地": "wú,néng,de",
  "无自信地": "wú,zì,xìn,de",
  "无臭": "wú,xiù",
  "无色无臭": "wú,sè,wú,xiù",
  "无节制地": "wú,jié,zhì,de",
  "无薪假": "wú,xīn,jià",
  "无虑地": "wú,lǜ,de",
  "无血地": "wú,xuè,de",
  "无血色地": "wú,xuè,sè,de",
  "无表情地": "wú,biǎo,qíng,de",
  "无裨": "wú,bì",
  "无褒弹": "wú,bāo,dàn",
  "无见识地": "wú,jiàn,shí,de",
  "无言地": "wú,yán,de",
  "无计划地": "wú,jì,huà,de",
  "无计量": "wú,jì,liáng",
  "无诚意地": "wú,chéng,yì,de",
  "无误地": "wú,wù,de",
  "无误地予": "wú,wù,de,yǔ",
  "无说服力地": "wú,shuō,fú,lì,de",
  "无谋地": "wú,móu,de",
  "无谓地": "wú,wèi,de",
  "无赖地": "wú,lài,de",
  "无趣味地": "wú,qù,wèi,de",
  "无趣地": "wú,qù,de",
  "无跌": "wú,diē",
  "无辜受累": "wú,gū,shòu,lěi",
  "无边地": "wú,biān,de",
  "无适": "wú,shì",
  "无适无莫": "wú,shì,wú,mò",
  "无逮": "wú,dǎi",
  "无邪地": "wú,xié,de",
  "无量数": "wú,liàng,shù",
  "无间": "wú,jiàn",
  "无间可伺": "wú,jiān,kě,sì",
  "无间地狱": "wú,jiàn,dì,yù",
  "无间是非": "wú,jiàn,shì,fēi",
  "无间狱": "wú,jiàn,yù",
  "无阻碍地": "wú,zǔ,ài,de",
  "无限制地": "wú,xiàn,zhì,de",
  "无限地": "wú,xiàn,de",
  "无限地夸大": "wú,xiàn,de,kuā,dà",
  "无限小数": "wú,xiàn,xiǎo,shù",
  "无限期地": "wú,xiàn,qī,de",
  "无隄": "wú,dī",
  "无隄之舆": "wú,dī,zhī,yú",
  "无隐饰地": "wú,yǐn,shì,de",
  "无鞍地": "wú,ān,de",
  "无颜之冠": "wú,yán,zhī,guān",
  "无风浪地": "wú,fēng,làng,de",
  "无食子": "wú,sì,zǐ",
  "无骹尊": "wú,xiāo,zūn",
  "既要当婊子又要立牌坊": "jì,yào,dāng,biǎo,zi,yòu,yào,lì,pái,fāng",
  "日不暇给": "rì,bù,xiá,jǐ",
  "日中为市": "rì,zhōng,wéi,shì",
  "日以为常": "rì,yǐ,wéi,cháng",
  "日以继夜地": "rì,yǐ,jì,yè,de",
  "日佣": "rì,yòng",
  "日佣人": "rì,yòng,rén",
  "日冠": "rì,guān",
  "日削月割": "rì,xuē,yuè,gē",
  "日削月朘": "rì,xuē,yuè,juān",
  "日升月恒": "rì,shēng,yuè,gèng",
  "日复一日": "rì,fù,yí,rì",
  "日复一日地": "rì,fù,yí,rì,de",
  "日头": "rì,tou",
  "日子": "rì,zi",
  "日常地": "rì,cháng,de",
  "日幢": "rì,zhuàng",
  "日干": "rì,gàn",
  "日日夜夜地": "rì,rì,yè,yè,de",
  "日昳": "rì,yì",
  "日晕": "rì,yùn",
  "日月参辰": "rì,yuè,shēn,chén",
  "日月晕": "rì,yuè,yùn",
  "日月相": "rì,yuè,xiàng",
  "日月重光": "rì,yuè,chóng,guāng",
  "日朘月削": "rì,juān,yuè,xuē",
  "日本银行": "rì,běn,yín,háng",
  "日本鬼子": "rì,běn,guǐ,zi",
  "日本鹡鸰": "rì,běn,jí,líng",
  "日毂": "rì,gū",
  "日益增长地": "rì,yì,zēng,zhǎng,de",
  "日省": "rì,xǐng",
  "日省月修": "rì,xǐng,yuè,xiū",
  "日省月试": "rì,xǐng,yuè,shì",
  "日省月课": "rì,xǐng,yuè,kè",
  "日禁": "rì,jìn",
  "日积月累": "rì,jī,yuè,lěi",
  "日累月积": "rì,lèi,yuè,jī",
  "日经平均指数": "rì,jīng,píng,jūn,zhǐ,shù",
  "日经指数": "rì,jīng,zhǐ,shù",
  "日薄": "rì,bó",
  "日薄崦嵫": "rì,bó,yān,zī",
  "日薄西山": "rì,bó,xī,shān",
  "日较差": "rì,jiào,chā",
  "日进斗金": "rì,jìn,dǒu,jīn",
  "日重光": "rì,chóng,guāng",
  "日𬮴": "rì,ān",
  "旦不报夕": "dàn,bú,bào,xī",
  "旦夕之危": "dàn,xī,zhī,wěi",
  "旦种暮成": "dàn,zhòng,mù,chéng",
  "旦角": "dàn,jué",
  "旦角儿": "dàn,jué,ér",
  "旧地重游": "jiù,dì,chóng,yóu",
  "旧式地": "jiù,shì,de",
  "旧念复萌": "jiù,niàn,fù,máng",
  "旧景重现": "jiù,jǐng,chóng,xiàn",
  "旧框框": "jiù,kuāng,kuāng",
  "旧皇历": "jiù,huáng,li",
  "旧话重提": "jiù,huà,chóng,tí",
  "旧调子": "jiù,diào,zi",
  "旧调重弹": "jiù,diào,chóng,tán",
  "旧都": "jiù,dū",
  "旧雨重逢": "jiù,yǔ,chóng,féng",
  "早为": "zǎo,wéi",
  "早先地": "zǎo,xiān,de",
  "早八辈子": "zǎo,bā,bèi,zi",
  "早占勿药": "zǎo,zhān,wù,yào",
  "早早儿": "zǎo,zǎo,er",
  "早早地溜掉了": "zǎo,zǎo,de,liū,diào,le",
  "早早地解决了": "zǎo,zǎo,de,jiě,jué,le",
  "早期地": "zǎo,qī,de",
  "早期效应": "zǎo,qī,xiào,yìng",
  "早点铺": "zǎo,diǎn,pù",
  "早班儿": "zǎo,bān,er",
  "早知道": "zǎo,zhī,dao",
  "旮旯儿": "gā,lá,er",
  "旱鸭子": "hàn,yā,zi",
  "时不时地": "shí,bù,shí,de",
  "时为": "shí,wéi",
  "时候": "shí,hou",
  "时兴": "shí,xīng",
  "时常地": "shí,cháng,de",
  "时干": "shí,gàn",
  "时式地": "shí,shì,de",
  "时新地": "shí,xīn,de",
  "时时地": "shí,shí,de",
  "时炸弹": "shí,zhà,dàn",
  "时禁": "shí,jìn",
  "时累": "shí,lèi",
  "时缪": "shí,miù",
  "时背": "shí,bèi",
  "时行": "shí,háng",
  "时行病": "shí,háng,bìng",
  "时调": "shí,diào",
  "时辰": "shí,chen",
  "时辰未到": "shí,chen,wèi,dào",
  "时运不齐": "shí,yùn,bù,jì",
  "时适": "shí,shì",
  "时间地": "shí,jiān,de",
  "时髦地": "shí,máo,de",
  "旷日累时": "kuàng,rì,lěi,shí",
  "旷载": "kuàng,zǎi",
  "旷适": "kuàng,shì",
  "旺兴": "wàng,xīng",
  "旺盛地": "wàng,shèng,de",
  "昂贵地": "áng,guì,de",
  "昆山调": "kūn,shān,diào",
  "昆调": "kūn,diào",
  "昆蹏": "kūn,dì",
  "昆都仑": "kūn,dū,lún",
  "昆都仑区": "kūn,dū,lún,qū",
  "昆阆": "kūn,láng",
  "昌亭之客": "cháng,tíng,zhī,kè",
  "昌仆": "chāng,pú",
  "昌侯": "chāng,hòu",
  "昌兴": "chāng,xīng",
  "昌都": "chāng,dū",
  "昌都地区": "chāng,dū,dì,qū",
  "明了": "míng,liǎo",
  "明了地": "míng,liǎo,de",
  "明亮地": "míng,liàng,de",
  "明侯": "míng,hòu",
  "明儿": "míng,er",
  "明𠡠": "míng,lài",
  "明媚地": "míng,mèi,de",
  "明子": "míng,zi",
  "明嶷": "míng,nì",
  "明干": "míng,gàn",
  "明忒": "míng,tuī",
  "明快地": "míng,kuài,de",
  "明摆着": "míng,bǎi,zhe",
  "明显地": "míng,xiǎn,de",
  "明显地感觉到": "míng,xiǎn,de,gǎn,jué,dào",
  "明显地放大": "míng,xiǎn,de,fàng,dà",
  "明晰地": "míng,xī,de",
  "明智地": "míng,zhì,de",
  "明朗地": "míng,lǎng,de",
  "明白": "míng,bai",
  "明白了当": "míng,bái,liǎo,dàng",
  "明白地": "míng,bái,de",
  "明白地告诉你": "míng,bái,de,gào,sù,nǐ",
  "明白地说": "míng,bái,de,shuō",
  "明着": "míng,zhe",
  "明确地": "míng,què,de",
  "明确地叙述": "míng,què,de,xù,shù",
  "明确地知道": "míng,què,de,zhī,dào",
  "明确地说": "míng,què,de,shuō",
  "明祇": "míng,qí",
  "明窗净几": "míng,chuāng,jìng,jī",
  "明絜": "míng,jié",
  "明罚𠡠法": "míng,fá,lài,fǎ",
  "明辟": "míng,bì",
  "明𬮴": "míng,ān",
  "明露": "míng,lù",
  "昏僝": "hūn,chán",
  "昏冠": "hūn,guān",
  "昏定晨省": "hūn,dìng,chén,xǐng",
  "昏昏沉沉地": "hūn,hūn,chén,chén,de",
  "昏澄澄": "hūn,deng,deng",
  "昏缪": "hūn,miù",
  "昏蒙": "hūn,mēng",
  "昏蹶": "hūn,juě",
  "昏迷不省": "hūn,mí,bù,xǐng",
  "昏镜重明": "hūn,jìng,chóng,míng",
  "昏镜重磨": "hūn,jìng,chóng,mó",
  "昏𬮴": "hūn,ān",
  "易了解地": "yì,liǎo,jiě,de",
  "易传": "yì,zhuàn",
  "易兴奋地": "yì,xīng,fèn,de",
  "易发生地": "yì,fā,shēng,de",
  "易受伤地": "yì,shòu,shāng,de",
  "易受骗地": "yì,shòu,piàn,de",
  "易变动地": "yì,biàn,dòng,de",
  "易变地": "yì,biàn,de",
  "易地而处": "yì,dì,ér,chǔ",
  "易处理地": "yì,chǔ,lǐ,de",
  "易弯地": "yì,wān,de",
  "易弯曲地": "yì,wān,qū,de",
  "易忘地": "yì,wàng,de",
  "易忘记地": "yì,wàng,jì,de",
  "易怒地": "yì,nù,de",
  "易感知地": "yì,gǎn,zhī,de",
  "易懂地": "yì,dǒng,de",
  "易数": "yì,shù",
  "易曲地": "yì,qū,de",
  "易曲折地": "yì,qū,zhé,de",
  "易流泪地": "yì,liú,lèi,de",
  "易理解地": "yì,lǐ,jiě,de",
  "易生气地": "yì,shēng,qì,de",
  "易知地": "yì,zhī,de",
  "易碎地": "yì,suì,de",
  "易管理地": "yì,guǎn,lǐ,de",
  "易行地": "yì,xíng,de",
  "易被瞒地": "yì,bèi,mán,de",
  "易觉察地": "yì,jué,chá,de",
  "易读地": "yì,dú,de",
  "易逝地": "yì,shì,de",
  "易驾驭地": "yì,jià,yù,de",
  "昔耶": "xī,yē",
  "星冠": "xīng,guān",
  "星占": "xīng,zhān",
  "星处": "xīng,chǔ",
  "星宿": "xīng,xiù",
  "星宿坛": "xīng,xiù,tán",
  "星宿川": "xīng,xiù,chuān",
  "星宿海": "xīng,xiù,hǎi",
  "星宿菜": "xīng,xiù,cài",
  "星数": "xīng,shù",
  "星斗": "xīng,dǒu",
  "星星": "xīng,xing",
  "星星之火": "xīng,xing,zhī,huǒ",
  "星火计划": "xīng,huǒ,jì,huà",
  "星相": "xīng,xiàng",
  "星相图": "xīng,xiàng,tú",
  "星相学": "xīng,xiàng,xué",
  "星相家": "xīng,xiàng,jiā",
  "星相师": "xīng,xiàng,shī",
  "星相术": "xīng,xiàng,shù",
  "星移斗转": "xīng,yí,dǒu,zhuǎn",
  "星货铺": "xīng,huò,pù",
  "星镡": "xīng,tán",
  "星露": "xīng,lù",
  "春假": "chūn,jià",
  "春华": "chūn,huā",
  "春天地": "chūn,tiān,de",
  "春生夏长": "chūn,shēng,xià,zhǎng",
  "春禁": "chūn,jìn",
  "春秋三传": "chūn,qiū,sān,zhuàn",
  "春秋左氏传": "chūn,qiū,zuǒ,shì,zhuàn",
  "春秋笔法": "chūn,qiū,bǐ,fá",
  "春秋繁露": "chūn,qiū,fán,lù",
  "春种": "chūn,zhòng",
  "春端帖": "chūn,duān,tiē",
  "春翘": "chūn,qiào",
  "春色撩人": "chūn,sè,liáo,rén",
  "春露秋霜": "chūn,lù,qiū,shuāng",
  "春风深醉的晚上": "chūn,fēng,shēn,zuì,de,wǎn,shang",
  "春风雨露": "chūn,fēng,yǔ,lù",
  "昧揥": "mèi,dì",
  "昧旦晨兴": "mèi,dàn,chén,xīng",
  "昧没": "mèi,mò",
  "昨伲": "zuó,nì",
  "昨儿": "zuó,er",
  "昨日子": "zuó,rì,zi",
  "昭应": "zhāo,yìng",
  "昭德塞违": "zhāo,dé,sè,wéi",
  "昭焯": "zhāo,chāo",
  "昭着": "zhāo,zhe",
  "昭缪": "zhāo,miù",
  "昭露": "zhāo,lù",
  "是不是": "shì,bú,shì",
  "是么": "shì,mǒ",
  "是味儿": "shì,wèi,er",
  "是多么地": "shì,duō,me,de",
  "是得": "shì,de",
  "是拉差": "shì,lā,chā",
  "是杠杠地": "shì,gàng,gàng,de",
  "是非只为多开口": "shì,fēi,zhī,wèi,duō,kāi,kǒu",
  "昳丽": "yì,lì",
  "昴宿星团": "mǎo,xiù,xīng,tuán",
  "昵比": "nì,bì",
  "昼夜不断地": "zhòu,yè,bù,duàn,de",
  "昼干夕惕": "zhòu,gàn,xī,tì",
  "昼度夜思": "zhòu,duó,yè,sī",
  "显处": "xiǎn,chǔ",
  "显处视月": "xiǎn,chǔ,shì,yuè",
  "显山露水": "xiǎn,shān,lù,shuǐ",
  "显应": "xiǎn,yìng",
  "显弹": "xiǎn,dàn",
  "显得": "xiǎn,de",
  "显微解剖学": "xiǎn,wēi,jiě,pōu,xué",
  "显摆": "xiǎn,bai",
  "显明地": "xiǎn,míng,de",
  "显然地": "xiǎn,rán,de",
  "显白": "xiǎn,bai",
  "显目地": "xiǎn,mù,de",
  "显眼地": "xiǎn,yǎn,de",
  "显着地": "xiǎn,zhe,de",
  "显而易见地": "xiǎn,ér,yì,jiàn,de",
  "显豁": "xiǎn,huò",
  "显贲": "xiǎn,bēn",
  "显贵地": "xiǎn,guì,de",
  "显露": "xiǎn,lù",
  "显露出": "xiǎn,lù,chū",
  "显露头角": "xiǎn,lù,tóu,jiǎo",
  "显𫘤子": "xiǎn,ái,zǐ",
  "晃动": "huàng,dòng",
  "晃子": "huàng,zǐ",
  "晃悠": "huàng,yōu",
  "晃搭": "huàng,dā",
  "晃摇": "huàng,yáo",
  "晃昱": "huàng,yù",
  "晃晃": "huàng,huǎng",
  "晃晃悠悠": "huàng,huǎng,yōu,yōu",
  "晃曜": "huàng,yào",
  "晃曳": "huàng,yè",
  "晃朗": "huàng,lǎng",
  "晃漾": "huàng,yàng",
  "晃𰜝": "huàng,yǎng",
  "晃烂": "huàng,làn",
  "晃然": "huàng,rán",
  "晃煜": "huàng,yù",
  "晃着": "huàng,zhe",
  "晃荡": "huàng,dàng",
  "晋帖": "jìn,tiē",
  "晌午": "shǎng,wu",
  "晏处": "yàn,chǔ",
  "晒场": "shài,cháng",
  "晒骆驼": "shài,luò,tuo",
  "晓得": "xiǎo,de",
  "晕东东": "yùn,dōng,dōng",
  "晕乎": "yūn,hu",
  "晕乎乎": "yùn,hū,hū",
  "晕光": "yùn,guāng",
  "晕圈": "yùn,quān",
  "晕场": "yùn,chǎng",
  "晕头转向": "yūn,tóu,zhuàn,xiàng",
  "晕影": "yùn,yǐng",
  "晕忽忽": "yùn,hū,hū",
  "晕春潮": "yùn,chūn,cháo",
  "晕晕忽忽": "yùn,yùn,hū,hū",
  "晕晕糊糊": "yūn,yūn,hū,hū",
  "晕月": "yùn,yuè",
  "晕机": "yùn,jī",
  "晕染": "yùn,rǎn",
  "晕池": "yùn,chí",
  "晕状": "yùn,zhuàng",
  "晕目": "yùn,mù",
  "晕糊": "yūn,hu",
  "晕船": "yùn,chuán",
  "晕花": "yùn,huā",
  "晕血": "yùn,xuè",
  "晕血症": "yùn,xuè,zhèng",
  "晕车": "yùn,chē",
  "晕过去": "yùn,guò,qù",
  "晕适": "yūn,shì",
  "晕针": "yùn,zhēn",
  "晕高": "yùn,gāo",
  "晚一点": "wǎn,yì,diǎn",
  "晚上": "wǎn,shang",
  "晚兴": "wǎn,xīng",
  "晚半天儿": "wǎn,ban,tiān,er",
  "晚帆": "wǎn,fān",
  "晚甘侯": "wǎn,gān,hòu",
  "晚老子": "wǎn,lǎo,zi",
  "晚食当肉": "wǎn,shí,dàng,ròu",
  "晞露": "xī,lù",
  "晦涩地": "huì,sè,de",
  "晦盲否塞": "huì,máng,pǐ,sè",
  "晦𬮴": "huì,ān",
  "晨兴": "chén,xīng",
  "晨兴夜寐": "chén,xīng,yè,mèi",
  "晨昏定省": "chén,hūn,dìng,xǐng",
  "晨昏蒙影": "chén,hūn,mēng,yǐng",
  "晨省": "chén,xǐng",
  "晨露": "chén,lù",
  "晩老子": "wǎn,lǎo,zi",
  "晬面盎背": "zuì,miàn,àng,bèi",
  "普什图语": "pǔ,shí,tú,yǔ",
  "普及地": "pǔ,jí,de",
  "普天率土": "pǔ,tiān,shuài,tǔ",
  "普朗克常数": "pǔ,lǎng,kè,cháng,shù",
  "普罗扎克": "pǔ,luó,zhā,kè",
  "普覃": "pǔ,qín",
  "普适": "pǔ,shì",
  "普通地": "pǔ,tōng,de",
  "普遍地": "pǔ,biàn,de",
  "普里什蒂纳": "pǔ,lǐ,shí,dì,nà",
  "普里切特": "pǔ,lǐ,qiè,tè",
  "景从": "yǐng,cóng",
  "景征": "jǐng,zhǐ",
  "景数": "jǐng,shù",
  "晰毛辨发": "xī,máo,biàn,fà",
  "晴干": "qíng,qián",
  "晴朗地": "qíng,lǎng,de",
  "晶晃": "jīng,huàng",
  "智力商数": "zhì,lì,shāng,shù",
  "智数": "zhì,shù",
  "智识分子": "zhì,shí,fèn,zǐ",
  "智调": "zhì,diào",
  "晻世": "ǎn,shì",
  "晻冉": "ǎn,rǎn",
  "晻忽": "ǎn,hū",
  "晻映": "ǎn,yìng",
  "晻昧": "ǎn,mèi",
  "晻晻": "ǎn,ǎn",
  "晻暧": "ǎn,ài",
  "晻曀": "ǎn,yì",
  "晻曶": "ǎn,hū",
  "晻淡": "ǎn,dàn",
  "晻澹": "ǎn,dàn",
  "晻𱨚": "ǎn,ǎi",
  "晻然": "ǎn,rán",
  "晻翳": "ǎn,yì",
  "晻莫": "ǎn,mò",
  "晻蔼": "ǎn,ǎi",
  "晻𫉁": "ǎn,ài",
  "晻霭": "ǎn,ǎi",
  "晻霮": "ǎn,dàn",
  "晻鬰": "ǎn,yù",
  "晻黮": "ǎn,dǎn",
  "晾衣夹": "liàng,yī,jiā",
  "暂停地": "zàn,tíng,de",
  "暂时地": "zàn,shí,de",
  "暂时地失去": "zàn,shí,de,shī,qù",
  "暄腾": "xuān,teng",
  "暇适": "xiá,shì",
  "暋乱": "mín,luàn",
  "暋作": "mín,zuò",
  "暌载": "kuí,zǎi",
  "暏是": "dǔ,shì",
  "暑假": "shǔ,jià",
  "暖和": "nuǎn,huo",
  "暖昧地": "nuǎn,mèi,de",
  "暖暖地": "nuǎn,nuǎn,de",
  "暖烘烘地": "nuǎn,hōng,hōng,de",
  "暖调": "nuǎn,diào",
  "暗中地": "àn,zhōng,de",
  "暗哨儿": "àn,shào,er",
  "暗底子": "àn,dǐ,zi",
  "暗扣儿": "àn,kòu,er",
  "暗数": "àn,shù",
  "暗暗地": "àn,àn,de",
  "暗暗地想": "àn,àn,de,xiǎng",
  "暗查": "àn,zhā",
  "暗然地": "àn,rán,de",
  "暗示地": "àn,shì,de",
  "暗箭中人": "àn,jiàn,zhòng,rén",
  "暗绿背鸬鹚": "àn,lǜ,bèi,lú,cí",
  "暗缪": "àn,miù",
  "暗背雨燕": "àn,bèi,yǔ,yàn",
  "暗花儿": "àn,huā,er",
  "暗记儿": "àn,jì,er",
  "暗适应": "àn,shì,yìng",
  "暗间儿": "àn,jiān,er",
  "暧昧地": "ài,mèi,de",
  "暮暮朝朝": "mù,mù,zhāo,zhāo",
  "暮更": "mù,gēng",
  "暮虢朝虞": "mù,guó,zhāo,yú",
  "暮雨朝云": "mù,yǔ,zhāo,yún",
  "暴乱地": "bào,luàn,de",
  "暴处": "bào,chǔ",
  "暴慠": "bào,ào",
  "暴戾地": "bào,lì,de",
  "暴戾恣睢": "bào,lì,zì,suī",
  "暴掠": "bào,lüě",
  "暴晒": "pù,shài",
  "暴浣": "pù,huàn",
  "暴炙": "pù,zhì",
  "暴烈地": "bào,liè,de",
  "暴着": "bào,zhe",
  "暴禁": "bào,jìn",
  "暴缪": "bào,miù",
  "暴背": "pù,bèi",
  "暴腮龙门": "pù,sāi,lóng,mén",
  "暴虎冯河": "bào,hǔ,píng,hé",
  "暴虐地": "bào,nüè,de",
  "暴衣": "pù,yī",
  "暴衣露冠": "pù,yī,lù,guàn",
  "暴衣露盖": "pù,yī,lù,gài",
  "暴谩": "bào,màn",
  "暴跌": "bào,diē",
  "暴蹶": "bào,juě",
  "暴躁地": "bào,zào,de",
  "暴露": "bào,lù",
  "暴露无遗": "bào,lù,wú,yí",
  "暴露狂": "bào,lù,kuáng",
  "暴露癖": "bào,lù,pǐ",
  "暴风地": "bào,fēng,de",
  "暴风雨地": "bào,fēng,yǔ,de",
  "暴风雨般地": "bào,fēng,yǔ,bān,de",
  "暴骜": "bào,ào",
  "暴骨": "pù,gǔ",
  "曒絜": "jiǎo,jié",
  "曙更": "shǔ,gēng",
  "曜晃": "yào,huàng",
  "曝光": "bào,guāng",
  "曝光表": "bào,guāng,biǎo",
  "曝昳": "pù,yì",
  "曝背": "pù,bèi",
  "曝背食芹": "pù,bèi,shí,qín",
  "曝露": "pù,lù",
  "曩载": "nǎng,zǎi",
  "曱甴": "yuē,zhá",
  "曲制": "qū,zhì",
  "曲君": "qū,jūn",
  "曲士": "qū,shì",
  "曲奇": "qū,qí",
  "曲子": "qǔ,zi",
  "曲子相公": "qǔ,zi,xiàng,gōng",
  "曲孽": "qū,niè",
  "曲室": "qū,shì",
  "曲射": "qū,shè",
  "曲射炮": "qū,shè,pào",
  "曲尘": "qū,chén",
  "曲尘丝": "qū,chén,sī",
  "曲尘罗": "qū,chén,luó",
  "曲尺": "qū,chǐ",
  "曲尺楼梯": "qū,chǐ,lóu,tī",
  "曲尽其妙": "qū,jìn,qí,miào",
  "曲店": "qū,diàn",
  "曲径": "qū,jìng",
  "曲径通幽": "qū,jìng,tōng,yōu",
  "曲意": "qū,yì",
  "曲意逢迎": "qū,yì,féng,yíng",
  "曲成": "qū,chéng",
  "曲折": "qū,zhé",
  "曲折地": "qū,zhé,de",
  "曲拗": "qǔ,niù",
  "曲曲": "qū,qū",
  "曲曲弯弯": "qū,qū,wān,wān",
  "曲曲折折": "qū,qū,zhé,shé",
  "曲曲湾湾": "qū,qū,wān,wān",
  "曲柄": "qū,bǐng",
  "曲柄笠": "qū,bǐng,lì",
  "曲柄钻": "qū,bǐng,zuàn",
  "曲棍": "qū,gùn",
  "曲棍球": "qū,gùn,qiú",
  "曲槛": "qǔ,kǎn",
  "曲池穴": "qū,chí,xué",
  "曲率向量": "qū,lǜ,xiàng,liàng",
  "曲监": "qū,jiān",
  "曲直": "qū,zhí",
  "曲禁": "qū,jìn",
  "曲突徙薪": "qū,tū,xǐ,xīn",
  "曲笔": "qū,bǐ",
  "曲米": "qū,mǐ",
  "曲米春": "qū,mǐ,chūn",
  "曲糁": "qǔ,shēn",
  "曲糵": "qū,niè",
  "曲线": "qū,xiàn",
  "曲线图": "qū,xiàn,tú",
  "曲线拟合": "qū,xiàn,nǐ,hé",
  "曲线救国": "qū,xiàn,jiù,guó",
  "曲线板": "qū,xiàn,bǎn",
  "曲线美": "qū,xiàn,měi",
  "曲线论": "qū,xiàn,lùn",
  "曲线运动": "qū,xiàn,yùn,dòng",
  "曲线锯": "qū,xiàn,ju",
  "曲腰哈背": "qǔ,yāo,hā,bèi",
  "曲䓖": "qū,qióng",
  "曲蟺": "qǔ,dàn",
  "曲衷": "qū,zhōng",
  "曲覃": "qǔ,qín",
  "曲解": "qū,jiě",
  "曲解地": "qū,jiě,de",
  "曲说": "qū,shuō",
  "曲课": "qū,kè",
  "曲调": "qǔ,diào",
  "曲豉": "qū,chǐ",
  "曲车": "qū,chē",
  "曲轴": "qū,zhóu",
  "曲辫子": "qǔ,biàn,zi",
  "曲道士": "qū,dào,shì",
  "曲酒": "qū,jiǔ",
  "曲里拐弯": "qū,lǐ,guǎi,wān",
  "曲钱": "qū,qián",
  "曲阜": "qū,fù",
  "曲阜孔庙": "qū,fù,kǒng,miào",
  "曲阜市": "qū,fù,shì",
  "曲霉": "qū,méi",
  "曲面论": "qū,miàn,lùn",
  "曲颈瓶": "qū,jǐng,píng",
  "曲饼": "qū,bǐng",
  "曲高和寡": "qǔ,gāo,hè,guǎ",
  "曲鳝": "qū,shàn",
  "曳光弹": "yè,guāng,dàn",
  "更不幸地": "gèng,bù,xìng,de",
  "更且": "gēng,qiě",
  "更世": "gēng,shì",
  "更严重地": "gèng,yán,zhòng,de",
  "更为": "gèng,wéi",
  "更事": "gēng,shì",
  "更互": "gēng,hù",
  "更人": "gēng,rén",
  "更仆": "gēng,pú",
  "更仆数": "gēng,pú,shù",
  "更仆难尽": "gèng,pú,nán,jìn",
  "更仆难数": "gēng,pú,nán,shǔ",
  "更仆难终": "gēng,pú,nán,zhōng",
  "更代": "gēng,dài",
  "更令明号": "gēng,lìng,míng,hào",
  "更休": "gēng,xiū",
  "更做": "gēng,zuò",
  "更做到": "gēng,zuò,dào",
  "更做道": "gēng,zuò,dào",
  "更傜": "gēng,yáo",
  "更元": "gēng,yuán",
  "更全面地": "gèng,quán,miàn,de",
  "更兴": "gēng,xīng",
  "更兼": "gēng,jiān",
  "更准确地": "gèng,zhǔn,què,de",
  "更准确地说": "gèng,zhǔn,què,de,shuō",
  "更则道": "gēng,zé,dào",
  "更初": "gēng,chū",
  "更制": "gēng,zhì",
  "更加地": "gèng,jiā,de",
  "更加地快": "gèng,jiā,de,kuài",
  "更加地爱": "gèng,jiā,de,ài",
  "更动": "gēng,dòng",
  "更努力地": "gèng,nǔ,lì,de",
  "更化": "gēng,huà",
  "更卒": "gēng,zú",
  "更博": "gēng,bó",
  "更历": "gēng,lì",
  "更变": "gēng,biàn",
  "更可取地": "gèng,kě,qǔ,de",
  "更号": "gēng,hào",
  "更名": "gēng,míng",
  "更向前地": "gèng,xiàng,qián,de",
  "更唱叠和": "gēng,chàng,dié,hé",
  "更唱迭和": "gēng,chàng,dié,hé",
  "更坊": "gēng,fāng",
  "更坏地": "gèng,huài,de",
  "更坚决地": "gèng,jiān,jué,de",
  "更多地": "gèng,duō,de",
  "更多地关心": "gèng,duō,de,guān,xīn",
  "更多地关注": "gèng,duō,de,guān,zhù",
  "更多地在": "gèng,duō,de,zài",
  "更多地放在": "gèng,duō,de,fàng,zài",
  "更多地是": "gèng,duō,de,shì",
  "更多地是为了": "gèng,duō,de,shì,wèi,le",
  "更多地是在": "gèng,duō,de,shì,zài",
  "更多地用": "gèng,duō,de,yòng",
  "更多地留给": "gèng,duō,de,liú,gěi",
  "更夜": "gēng,yè",
  "更夫": "gēng,fū",
  "更头": "gēng,tóu",
  "更好地": "gèng,hǎo,de",
  "更好地为": "gèng,hǎo,de,wèi",
  "更好地了解": "gèng,hǎo,de,liǎo,jiě",
  "更好地代表": "gèng,hǎo,de,dài,biǎo",
  "更好地体现了": "gèng,hǎo,de,tǐ,xiàn,le",
  "更好地体验": "gèng,hǎo,de,tǐ,yàn",
  "更好地使用": "gèng,hǎo,de,shǐ,yòng",
  "更好地促进": "gèng,hǎo,de,cù,jìn",
  "更好地兼容": "gèng,hǎo,de,jiān,róng",
  "更好地分享": "gèng,hǎo,de,fēn,xiǎng",
  "更好地去": "gèng,hǎo,de,qù",
  "更好地发展": "gèng,hǎo,de,fā,zhǎn",
  "更好地发挥": "gèng,hǎo,de,fā,huī",
  "更好地完成任务": "gèng,hǎo,de,wán,chéng,rèn,wù",
  "更好地实现": "gèng,hǎo,de,shí,xiàn",
  "更好地应付": "gèng,hǎo,de,yìng,fù",
  "更好地引导": "gèng,hǎo,de,yǐn,dǎo",
  "更好地把握": "gèng,hǎo,de,bǎ,wò",
  "更好地控制": "gèng,hǎo,de,kòng,zhì",
  "更好地推动": "gèng,hǎo,de,tuī,dòng",
  "更好地改进": "gèng,hǎo,de,gǎi,jìn",
  "更好地活着": "gèng,hǎo,de,huó,zhe",
  "更好地满足": "gèng,hǎo,de,mǎn,zú",
  "更好地生存": "gèng,hǎo,de,shēng,cún",
  "更好地维护": "gèng,hǎo,de,wéi,hù",
  "更好地解决": "gèng,hǎo,de,jiě,jué",
  "更好地配合": "gèng,hǎo,de,pèi,hé",
  "更妆": "gēng,zhuāng",
  "更始": "gēng,shǐ",
  "更姓改物": "gēng,xìng,gǎi,wù",
  "更嫁": "gēng,jià",
  "更嬗": "gēng,shàn",
  "更嬴": "gēng,yíng",
  "更定": "gēng,dìng",
  "更害": "gēng,hài",
  "更少地": "gèng,shǎo,de",
  "更尝": "gēng,cháng",
  "更居": "gēng,jū",
  "更履": "gēng,lǚ",
  "更巡": "gēng,xún",
  "更年期": "gēng,nián,qī",
  "更年期综合征": "gēng,nián,qī,zōng,hé,zhēng",
  "更广泛地": "gèng,guǎng,fàn,de",
  "更张": "gēng,zhāng",
  "更弦改辙": "gēng,xián,gǎi,zhé",
  "更弦易辙": "gēng,xián,yì,zhé",
  "更彻底地分开": "gèng,chè,dǐ,de,fēn,kāi",
  "更徙": "gēng,xǐ",
  "更快地": "gèng,kuài,de",
  "更快地找到": "gèng,kuài,de,zhǎo,dào",
  "更快地输入": "gèng,kuài,de,shū,rù",
  "更快地适应": "gèng,kuài,de,shì,yìng",
  "更快更好地": "gèng,kuài,gèng,hǎo,de",
  "更恶劣地": "gèng,è,liè,de",
  "更愉快地": "gèng,yú,kuài,de",
  "更戍": "gēng,shù",
  "更成": "gēng,chéng",
  "更成功地": "gèng,chéng,gōng,de",
  "更房": "gēng,fáng",
  "更换": "gēng,huàn",
  "更授": "gēng,shòu",
  "更改": "gēng,gǎi",
  "更新": "gēng,xīn",
  "更新世": "gēng,xīn,shì",
  "更新换代": "gēng,xīn,huàn,dài",
  "更新版": "gēng,xīn,bǎn",
  "更日": "gēng,rì",
  "更易": "gēng,yì",
  "更更": "gēng,gēng",
  "更替": "gēng,tì",
  "更有力地": "gèng,yǒu,lì,de",
  "更有效地": "gèng,yǒu,xiào,de",
  "更期": "gēng,qī",
  "更楼": "gēng,lóu",
  "更次": "gēng,cì",
  "更正": "gēng,zhèng",
  "更正确地": "gēng,zhèng,què,de",
  "更正错误": "gēng,zhèng,cuò,wù",
  "更步": "gēng,bù",
  "更法": "gēng,fǎ",
  "更涉": "gēng,shè",
  "更深": "gēng,shēn",
  "更深人静": "gēng,shēn,rén,jìng",
  "更深入地": "gēng,shēn,rù,de",
  "更深刻地": "gēng,shēn,kè,de",
  "更深地": "gēng,shēn,de",
  "更深夜静": "gēng,shēn,yè,jìng",
  "更漏": "gēng,lòu",
  "更漏子": "gēng,lòu,zǐ",
  "更点": "gēng,diǎn",
  "更爽": "gēng,shuǎng",
  "更版": "gēng,bǎn",
  "更王": "gēng,wáng",
  "更生": "gēng,shēng",
  "更番": "gēng,fān",
  "更直": "gēng,zhí",
  "更相": "gēng,xiāng",
  "更确切地": "gèng,què,qiè,de",
  "更确切地说": "gèng,què,qiè,de,shuō",
  "更移": "gēng,yí",
  "更窜": "gēng,cuàn",
  "更立": "gēng,lì",
  "更端": "gēng,duān",
  "更筹": "gēng,chóu",
  "更签": "gēng,qiān",
  "更箭": "gēng,jiàn",
  "更粗劣地": "gèng,cū,liè,de",
  "更精确地": "gèng,jīng,què,de",
  "更精确地说": "gèng,jīng,què,de,shuō",
  "更紧密地合作": "gèng,jǐn,mì,de,hé,zuò",
  "更练": "gēng,liàn",
  "更续": "gēng,xù",
  "更缓慢地": "gèng,huǎn,màn,de",
  "更置": "gēng,zhì",
  "更羸": "gēng,léi",
  "更老": "gēng,lǎo",
  "更自": "gēng,zì",
  "更自觉地": "gèng,zì,jué,de",
  "更苏": "gēng,sū",
  "更若役": "geng,ruo,yu",
  "更葬": "gēng,zàng",
  "更虑": "gēng,lǜ",
  "更行": "gēng,xíng",
  "更衣": "gēng,yī",
  "更衣室": "gēng,yī,shì",
  "更衣曲": "gēng,yī,qǔ",
  "更要好好地": "gèng,yāo,hǎo,hǎo,de",
  "更覆": "gēng,fù",
  "更议": "gēng,yì",
  "更详细地": "gèng,xiáng,xì,de",
  "更调": "gēng,diào",
  "更谨慎地": "gèng,jǐn,shèn,de",
  "更赋": "gēng,fù",
  "更践": "gēng,jiàn",
  "更轻松地": "gèng,qīng,sōng,de",
  "更轻松地访问": "gèng,qīng,sōng,de,fǎng,wèn",
  "更辛苦地": "gèng,xīn,kǔ,de",
  "更进一步": "gèng,jìn,yí,bù",
  "更远地": "gèng,yuǎn,de",
  "更迭": "gēng,dié",
  "更适": "gēng,shì",
  "更选": "gēng,xuǎn",
  "更递": "gēng,dì",
  "更造": "gēng,zào",
  "更钥": "gēng,yuè",
  "更锣": "gēng,luó",
  "更长梦短": "gēng,cháng,mèng,duǎn",
  "更阑": "gēng,lán",
  "更阑人静": "gēng,lán,rén,jìng",
  "更难仆数": "gēng,nán,pú,shù",
  "更雄伟地": "gèng,xióng,wěi,de",
  "更革": "gēng,gé",
  "更香": "gēng,xiāng",
  "更高性能": "gēng,gāo,xìng,néng",
  "更鼓": "gēng,gǔ",
  "曷为": "hé,wéi",
  "曹不兴": "cáo,bù,xīng",
  "曹大家": "cáo,dà,gū",
  "曹干": "cáo,gàn",
  "曹牟": "cáo,mù",
  "曼珠沙华": "màn,zhū,shā,huā",
  "曾不惨然": "zēng,bù,cǎn,rán",
  "曾乔": "zēng,qiáo",
  "曾云": "zēng,yún",
  "曾伤": "zēng,shāng",
  "曾加": "zēng,jiā",
  "曾华": "zēng,huá",
  "曾参": "zēng,shēn",
  "曾参杀人": "zēng,shēn,shā,rén",
  "曾史": "zēng,shǐ",
  "曾国荃": "zēng,guó,quán",
  "曾国藩": "zēng,guó,fān",
  "曾坑": "zēng,kēng",
  "曾城": "zēng,chéng",
  "曾外祖母": "zēng,wài,zǔ,mǔ",
  "曾外祖父": "zēng,wài,zǔ,fù",
  "曾大父": "zēng,dà,fù",
  "曾子": "zēng,zǐ",
  "曾孙": "zēng,sūn",
  "曾孙女": "zēng,sūn,nǚ",
  "曾孝谷": "zēng,xiào,gǔ",
  "曾岭": "zēng,lǐng",
  "曾崖": "zēng,yá",
  "曾巅": "zēng,diān",
  "曾巢": "zēng,cháo",
  "曾巩": "zēng,gǒng",
  "曾庆红": "zēng,qìng,hóng",
  "曾思": "zēng,sī",
  "曾恐惧地": "céng,kǒng,jù,de",
  "曾折": "zēng,shé",
  "曾挠": "zēng,náo",
  "曾掖": "zēng,yè",
  "曾明确地": "céng,míng,què,de",
  "曾晖": "zēng,huī",
  "曾曲": "zēng,qǔ",
  "曾朴": "zēng,pǔ",
  "曾标": "zēng,biāo",
  "曾母投杼": "zēng,mǔ,tóu,zhù",
  "曾泉": "zēng,quán",
  "曾波": "zēng,bō",
  "曾潭": "zēng,tán",
  "曾父": "zēng,fù",
  "曾玄": "zēng,xuán",
  "曾王父": "zēng,wáng,fù",
  "曾祖": "zēng,zǔ",
  "曾祖妣": "zēng,zǔ,bǐ",
  "曾祖母": "zēng,zǔ,mǔ",
  "曾祖父": "zēng,zǔ,fù",
  "曾祖父母": "zēng,zǔ,fù,mǔ",
  "曾祖王母": "zēng,zǔ,wáng,mǔ",
  "曾祖王父": "zēng,zǔ,wáng,fù",
  "曾祝": "zēng,zhù",
  "曾穹": "zēng,qióng",
  "曾空": "zēng,kōng",
  "曾累": "zēng,lèi",
  "曾繁仁": "zēng,fán,rén",
  "曾纪泽": "zēng,jì,zé",
  "曾翁": "zēng,wēng",
  "曾臣": "zēng,chén",
  "曾茧": "zēng,jiǎn",
  "曾荫权": "zēng,yìn,quán",
  "曾辉煌地": "céng,huī,huáng,de",
  "曾逝": "zēng,shì",
  "曾都": "zēng,dū",
  "曾都区": "zēng,dū,qū",
  "曾金燕": "zēng,jīn,yàn",
  "曾门": "zēng,mén",
  "曾闳": "zēng,hóng",
  "曾闵": "zēng,mǐn",
  "曾阴": "zēng,yīn",
  "曾阿": "zēng,ā",
  "曾青": "zēng,qīng",
  "曾颊": "zēng,jiá",
  "曾颜": "zēng,yán",
  "曾颠": "zēng,diān",
  "曾飔": "zēng,sī",
  "曾飙": "zēng,biāo",
  "替班儿": "tì,bān,er",
  "替角": "tì,jué",
  "替角儿": "tì,jué,er",
  "最上地": "zuì,shàng,de",
  "最下位地": "zuì,xià,wèi,de",
  "最下面地": "zuì,xià,miàn,de",
  "最为": "zuì,wéi",
  "最乱地": "zuì,luàn,de",
  "最优地": "zuì,yōu,de",
  "最佳地": "zuì,jiā,de",
  "最决定地": "zuì,jué,deng,de",
  "最初地": "zuì,chū,de",
  "最可觞客": "zhui,ke,shang,ke",
  "最名地": "zuì,míng,de",
  "最后一刻": "zuì,hòu,yí,kè",
  "最后地": "zuì,hòu,de",
  "最坏地": "zuì,huài,de",
  "最大公约数": "zuì,dà,gōng,yuē,shù",
  "最大可能地": "zuì,dà,kě,néng,de",
  "最大地": "zuì,dà,de",
  "最大程度地": "zuì,dà,chéng,dù,de",
  "最大限度地": "zuì,dà,xiàn,dù,de",
  "最大限度地减少": "zuì,dà,xiàn,dù,de,jiǎn,shǎo",
  "最好地": "zuì,hǎo,de",
  "最好地发展": "zuì,hǎo,de,fā,zhǎn",
  "最害地": "zuì,hài,de",
  "最小公倍数": "zuì,xiǎo,gōng,bèi,shù",
  "最年长": "zuì,nián,zhǎng",
  "最度地": "zuì,dù,de",
  "最强地": "zuì,qiáng,de",
  "最快地": "zuì,kuài,de",
  "最快捷地": "zuì,kuài,jié,de",
  "最性地": "zuì,xìng,de",
  "最效地": "zuì,xiào,de",
  "最新地": "zuì,xīn,de",
  "最有效地": "zuì,yǒu,xiào,de",
  "最理想地": "zuì,lǐ,xiǎng,de",
  "最简分数": "zuì,jiǎn,fēn,shù",
  "最终地": "zuì,zhōng,de",
  "最缺点地": "zuì,quē,diǎn,de",
  "最能上地": "zuì,néng,shàng,de",
  "最节制地": "zuì,jié,zhì,de",
  "最趣地": "zuì,qù,de",
  "最近地": "zuì,jìn,de",
  "最适宜地": "zuì,shì,yí,de",
  "最长期地": "zuì,cháng,qī,de",
  "最雄辩地证明": "zuì,xióng,biàn,de,zhèng,míng",
  "朅休": "qiè,xiū",
  "朅伽": "qiè,jiā",
  "朅朅": "qiè,qiè",
  "朅来": "qiè,lái",
  "月中折桂": "yuè,zhōng,shé,guì",
  "月亮": "yuè,liang",
  "月亮女神号": "yuè,liang,nǚ,shén,hào",
  "月亮杯": "yuè,liang,bēi",
  "月份牌儿": "yuè,fèn,pái,er",
  "月供": "yuè,gōng",
  "月候血": "yuè,hòu,xuè",
  "月分": "yuè,fèn",
  "月堤": "yuè,dī",
  "月夕花朝": "yuè,xī,huā,zhāo",
  "月夜花朝": "yuè,yè,huā,zhāo",
  "月头儿": "yuè,tou,er",
  "月婆子": "yuè,pó,zi",
  "月子": "yuè,zi",
  "月子病": "yuè,zi,bìng",
  "月数": "yuè,shù",
  "月晕": "yuè,yùn",
  "月晕而风": "yuè,yùn,ér,fēng",
  "月桂冠": "yuè,guì,guān",
  "月氏": "yuè,zhī",
  "月没参横": "yuè,mò,shēn,héng",
  "月牙儿": "yuè,yá,er",
  "月相": "yuè,xiàng",
  "月落参横": "yuè,luò,shēn,héng",
  "月蓂": "yuè,mì",
  "月隄": "yuè,dī",
  "月露": "yuè,lù",
  "月露之体": "yuè,lù,zhī,tǐ",
  "月露风云": "yuè,lù,fēng,yún",
  "有一只": "yǒu,yī,zhī",
  "有一手儿": "yǒu,yī,shǒu,er",
  "有一点儿": "yǒu,yī,diǎn,er",
  "有丁点地": "yǒu,dīng,diǎn,de",
  "有不少名堂": "yǒu,bù,shǎo,míng,tang",
  "有中国特色的社会主义": "yǒu,zhōng,guó,tè,shǎi,de,shè,huì,zhǔ,yì",
  "有为": "yǒu,wéi",
  "有为有守": "yǒu,wéi,yǒu,shǒu",
  "有为法": "yǒu,wéi,fǎ",
  "有些遗憾地": "yǒu,xiē,yí,hàn,de",
  "有代表性地": "yǒu,dài,biǎo,xìng,de",
  "有以善处": "yǒu,yǐ,shàn,chǔ",
  "有价值地": "yǒu,jià,zhí,de",
  "有会儿": "yǒu,huì,er",
  "有何贵干": "yǒu,hé,guì,gàn",
  "有余地": "yǒu,yú,de",
  "有例不兴": "yǒu,lì,bù,xīng",
  "有保留地": "yǒu,bǎo,liú,de",
  "有信心地": "yǒu,xìn,xīn,de",
  "有借无还": "yǒu,jiè,wú,huán",
  "有光泽地": "yǒu,guāng,zé,de",
  "有全权地": "yǒu,quán,quán,de",
  "有关电地": "yǒu,guān,diàn,de",
  "有关联地": "yǒu,guān,lián,de",
  "有关连地": "yǒu,guān,lián,de",
  "有兴": "yǒu,xīng",
  "有兴味地": "yǒu,xìng,wèi,de",
  "有兴趣地": "yǒu,xìng,qù,de",
  "有冯有翼": "yǒu,píng,yǒu,yì",
  "有准备地": "yǒu,zhǔn,bèi,de",
  "有几分地": "yǒu,jǐ,fēn,de",
  "有分": "yǒu,fèn",
  "有分交": "yǒu,fèn,jiāo",
  "有分教": "yǒu,fèn,jiào",
  "有利地": "yǒu,lì,de",
  "有利益地": "yǒu,lì,yì,de",
  "有剧毒地": "yǒu,jù,dú,de",
  "有力地": "yǒu,lì,de",
  "有力地打击": "yǒu,lì,de,dǎ,jī",
  "有力地推动": "yǒu,lì,de,tuī,dòng",
  "有力地证明": "yǒu,lì,de,zhèng,míng",
  "有力地说": "yǒu,lì,de,shuō",
  "有助地": "yǒu,zhù,de",
  "有助益地": "yǒu,zhù,yì,de",
  "有勇气地": "yǒu,yǒng,qì,de",
  "有区别地": "yǒu,qū,bié,de",
  "有原因地": "yǒu,yuán,yīn,de",
  "有名地": "yǒu,míng,de",
  "有名誉地": "yǒu,míng,yù,de",
  "有吸引力地": "yǒu,xī,yǐn,lì,de",
  "有味儿": "yǒu,wèi,er",
  "有因果地": "yǒu,yīn,guǒ,de",
  "有处": "yǒu,chǔ",
  "有多么地在乎你": "yǒu,duō,me,de,zài,hū,nǐ",
  "有失厚道": "yǒu,shī,hòu,dao",
  "有奇": "yǒu,jī",
  "有学问地": "yǒu,xué,wèn,de",
  "有害地": "yǒu,hài,de",
  "有局地": "yǒu,jú,de",
  "有差别地": "yǒu,chā,bié,de",
  "有差错地": "yǒu,chā,cuò,de",
  "有希望地": "yǒu,xī,wàng,de",
  "有帮助地": "yǒu,bāng,zhù,de",
  "有常识地": "yǒu,cháng,shí,de",
  "有年头": "yǒu,nián,tou",
  "有庳": "yǒu,bì",
  "有弇": "yǒu,yān",
  "有弱点地": "yǒu,ruò,diǎn,de",
  "有弹性地": "yǒu,tán,xìng,de",
  "有形地": "yǒu,xíng,de",
  "有得": "yǒu,de",
  "有性地": "yǒu,xìng,de",
  "有恶臭地": "yǒu,è,chòu,de",
  "有意义地": "yǒu,yì,yì,de",
  "有意图地": "yǒu,yì,tú,de",
  "有意地": "yǒu,yì,de",
  "有意志地": "yǒu,yì,zhì,de",
  "有意思地": "yǒu,yì,sī,de",
  "有意识地": "yǒu,yì,shí,de",
  "有成果地": "yǒu,chéng,guǒ,de",
  "有成绩地": "yǒu,chéng,jì,de",
  "有所作为": "yǒu,suǒ,zuò,wéi",
  "有才干": "yǒu,cái,gàn",
  "有才能地": "yǒu,cái,néng,de",
  "有把握地": "yǒu,bǎ,wò,de",
  "有搞头": "yǒu,gǎo,tou",
  "有收入地": "yǒu,shōu,rù,de",
  "有效地": "yǒu,xiào,de",
  "有效地减轻了": "yǒu,xiào,de,jiǎn,qīng,le",
  "有效地控制": "yǒu,xiào,de,kòng,zhì",
  "有效地提高": "yǒu,xiào,de,tí,gāo",
  "有效地改进": "yǒu,xiào,de,gǎi,jìn",
  "有效地防止": "yǒu,xiào,de,fáng,zhǐ",
  "有效果地": "yǒu,xiào,guǒ,de",
  "有效率地": "yǒu,xiào,lǜ,de",
  "有敌意地": "yǒu,dí,yì,de",
  "有教养地": "yǒu,jiào,yǎng,de",
  "有数": "yǒu,shù",
  "有旋律地": "yǒu,xuán,lǜ,de",
  "有日子": "yǒu,rì,zi",
  "有时候": "yǒu,shí,hou",
  "有时地": "yǒu,shí,de",
  "有朝": "yǒu,zhāo",
  "有朝一日": "yǒu,zhāo,yī,rì",
  "有本事": "yǒu,běn,shi",
  "有机地": "yǒu,jī,de",
  "有机地结合起来": "yǒu,jī,de,jié,hé,qǐ,lái",
  "有机性地": "yǒu,jī,xìng,de",
  "有机智地": "yǒu,jī,zhì,de",
  "有权威地": "yǒu,quán,wēi,de",
  "有条件地": "yǒu,tiáo,jiàn,de",
  "有条件地参与": "yǒu,tiáo,jiàn,de,cān,yù",
  "有条件地投降": "yǒu,tiáo,jiàn,de,tóu,xiáng",
  "有条有理地": "yǒu,tiáo,yǒu,lǐ,de",
  "有条理地": "yǒu,tiáo,lǐ,de",
  "有条纹地": "yǒu,tiáo,wén,de",
  "有模有样": "yǒu,mú,yǒu,yàng",
  "有步骤地": "yǒu,bù,zhòu,de",
  "有毅力地": "yǒu,yì,lì,de",
  "有毒地": "yǒu,dú,de",
  "有毒害地": "yǒu,dú,hài,de",
  "有气派地": "yǒu,qì,pài,de",
  "有氧地": "yǒu,yǎng,de",
  "有求必应": "yǒu,qiú,bì,yìng",
  "有活力地": "yǒu,huó,lì,de",
  "有渰": "yǒu,yǎn",
  "有湿气地": "yǒu,shī,qì,de",
  "有滋味地": "yǒu,zī,wèi,de",
  "有点儿": "yǒu,diǎn,er",
  "有点坏坏地笑道": "yǒu,diǎn,huài,huài,de,xiào,dào",
  "有焦点地": "yǒu,jiāo,diǎn,de",
  "有爵位地": "yǒu,jué,wèi,de",
  "有理函数": "yǒu,lǐ,hán,shù",
  "有理地": "yǒu,lǐ,de",
  "有理数": "yǒu,lǐ,shù",
  "有理数域": "yǒu,lǐ,shù,yù",
  "有理数集": "yǒu,lǐ,shù,jí",
  "有生气地": "yǒu,shēng,qì,de",
  "有病地": "yǒu,bìng,de",
  "有的放矢": "yǒu,dì,fàng,shǐ",
  "有益健康地": "yǒu,yì,jiàn,kāng,de",
  "有益地": "yǒu,yì,de",
  "有益处": "yǒu,yì,chu",
  "有盼头": "yǒu,pàn,tou",
  "有眼力见儿": "yǒu,yǎn,lì,jiàn,er",
  "有着": "yǒu,zhe",
  "有知识地": "yǒu,zhī,shí,de",
  "有硬皮地": "yǒu,yìng,pí,de",
  "有礼地": "yǒu,lǐ,de",
  "有礼貌地": "yǒu,lǐ,mào,de",
  "有秩序地": "yǒu,zhì,xù,de",
  "有空": "yǒu,kòng",
  "有空儿": "yǒu,kòng,er",
  "有粘性地": "yǒu,zhān,xìng,de",
  "有精神地": "yǒu,jīng,shén,de",
  "有系统地": "yǒu,xì,tǒng,de",
  "有纹地": "yǒu,wén,de",
  "有组织地": "yǒu,zǔ,zhī,de",
  "有结地": "yǒu,jié,de",
  "有结果地": "yǒu,jié,guǒ,de",
  "有缘无分": "yǒu,yuán,wú,fèn",
  "有缺点地": "yǒu,quē,diǎn,de",
  "有缺陷地": "yǒu,quē,xiàn,de",
  "有罪地": "yǒu,zuì,de",
  "有耐性地": "yǒu,nài,xìng,de",
  "有胆量地": "yǒu,dǎn,liàng,de",
  "有胜败地": "yǒu,shèng,bài,de",
  "有腔调": "yǒu,qiāng,diào",
  "有腿无裤子": "yǒu,tuǐ,wú,kù,zi",
  "有腿没裤子": "yǒu,tuǐ,méi,kù,zi",
  "有自信地": "yǒu,zì,xìn,de",
  "有臭味地": "yǒu,chòu,wèi,de",
  "有艺术地": "yǒu,yì,shù,de",
  "有节制地": "yǒu,jié,zhì,de",
  "有节奏地": "yǒu,jié,zòu,de",
  "有苦说不出": "yǒu,kǔ,shuō,bu,chū",
  "有营养地": "yǒu,yíng,yǎng,de",
  "有血有肉": "yǒu,xuè,yǒu,ròu",
  "有行为能力": "yǒu,xíng,wéi,néng,lì",
  "有见识地": "yǒu,jiàn,shí,de",
  "有规则地": "yǒu,guī,zé,de",
  "有规律地": "yǒu,guī,lǜ,de",
  "有角地": "yǒu,jiǎo,de",
  "有角色": "yǒu,jué,sè",
  "有计划地": "yǒu,jì,huà,de",
  "有诗意地": "yǒu,shī,yì,de",
  "有说有笑地": "yǒu,shuō,yǒu,xiào,de",
  "有谱儿": "yǒu,pǔ,er",
  "有趣味地": "yǒu,qù,wèi,de",
  "有趣地": "yǒu,qù,de",
  "有身分": "yǒu,shēn,fèn",
  "有边儿": "yǒu,biān,er",
  "有远虑地": "yǒu,yuǎn,lǜ,de",
  "有选择地": "yǒu,xuǎn,zé,de",
  "有选择地添加": "yǒu,xuǎn,zé,de,tiān,jiā",
  "有选择性地": "yǒu,xuǎn,zé,xìng,de",
  "有道德地": "yǒu,dào,dé,de",
  "有道理": "yǒu,dào,li",
  "有郄": "yǒu,xì",
  "有重点地": "yǒu,zhòng,diǎn,de",
  "有针对性地": "yǒu,zhēn,duì,xìng,de",
  "有钱使得鬼推磨": "yǒu,qián,shǐ,de,guǐ,tuī,mò",
  "有钱能使鬼推磨": "yǒu,qián,néng,shǐ,guǐ,tuī,mò",
  "有门儿": "yǒu,mén,er",
  "有问题地": "yǒu,wèn,tí,de",
  "有间": "yǒu,jiàn",
  "有限度地": "yǒu,xiàn,dù,de",
  "有难同当": "yǒu,nàn,tóng,dāng",
  "有预见地": "yǒu,yù,jiàn,de",
  "有预谋地": "yǒu,yù,móu,de",
  "有骨头": "yǒu,gú,tou",
  "有魄力地": "yǒu,pò,lì,de",
  "有魅力地": "yǒu,mèi,lì,de",
  "有鼻子有眼": "yǒu,bí,zi,yǒu,yǎn",
  "朋兴": "péng,xīng",
  "朋友": "péng,you",
  "朋友圈": "péng,you,quān",
  "朋友妻不可欺": "péng,you,qī,bù,kě,qī",
  "朋比为奸": "péng,bǐ,wéi,jiān",
  "朌布": "bān,bù",
  "服丧": "fú,sāng",
  "服事": "fú,shi",
  "服从地": "fú,cóng,de",
  "服务提供商": "fú,wù,tí,gōng,shāng",
  "服务提供者": "fú,wù,tí,gōng,zhě",
  "服务行业": "fú,wù,háng,yè",
  "服差役": "fú,chāi,yì",
  "服帖": "fú,tiē",
  "服更": "fú,gēng",
  "服服": "fú,fu",
  "服服帖帖": "fú,fú,tiē,tiē",
  "服着": "fú,zhe",
  "服翫": "fú,wàn",
  "服舍": "fú,shè",
  "服𬮴": "fú,ān",
  "朒数": "nǜ,shù",
  "朔数": "shuò,shù",
  "朗弹": "lǎng,dàn",
  "朗晃": "lǎng,huàng",
  "朗朗地": "lǎng,lǎng,de",
  "朗讽": "lǎng,fěng",
  "朗调": "lǎng,diào",
  "朘削": "juān,xuē",
  "朘剥": "juān,bāo",
  "望其项背": "wàng,qí,xiàng,bèi",
  "望头": "wàng,tou",
  "望影揣情": "wàng,yǐng,chuāi,qíng",
  "望洋兴叹": "wàng,yáng,xīng,tàn",
  "望筩": "wàng,yǒng",
  "望而兴叹": "wàng,ér,xīng,tàn",
  "望远地": "wàng,yuǎn,de",
  "望远瞄准镜": "wàng,yuǎn,miào,zhǔn,jìng",
  "望远镜地": "wàng,yuǎn,jìng,de",
  "望都": "wàng,dū",
  "望都县": "wàng,dū,xiàn",
  "望阙谢恩": "wàng,què,xiè,ēn",
  "望风披靡": "wàng,fēng,pī,mǐ",
  "朝三暮二": "zhāo,sān,mù,èr",
  "朝三暮四": "zhāo,sān,mù,sì",
  "朝上地": "cháo,shàng,de",
  "朝不保夕": "zhāo,bù,bǎo,xī",
  "朝不保暮": "zhāo,bù,bǎo,mù",
  "朝不及夕": "zhāo,bù,jí,xī",
  "朝不虑夕": "zhāo,bù,lǜ,xī",
  "朝不谋夕": "zhāo,bù,móu,xī",
  "朝乾夕惕": "zhāo,qián,xī,tì",
  "朝乾夕愓": "zhāo,qián,xī,dàng",
  "朝云": "zhāo,yún",
  "朝云暮雨": "zhāo,yún,mù,yǔ",
  "朝令夕改": "zhāo,lìng,xī,gǎi",
  "朝令暮改": "zhāo,lìng,mù,gǎi",
  "朝会": "zhāo,huì",
  "朝冠": "cháo,guān",
  "朝前地": "cháo,qián,de",
  "朝前夕惕": "zhāo,qián,xī,tì",
  "朝升暮合": "zhāo,shēng,mù,gě",
  "朝华夕秀": "zhāo,huá,xī,xiù",
  "朝参": "zhāo,cān",
  "朝发夕至": "zhāo,fā,xī,zhì",
  "朝发暮至": "zhāo,fā,mù,zhì",
  "朝后地": "cháo,hòu,de",
  "朝处": "cháo,chǔ",
  "朝夕": "zhāo,xī",
  "朝夕乌": "zhāo,xī,wū",
  "朝夕池": "zhāo,xī,chí",
  "朝夕相处": "zhāo,xī,xiāng,chǔ",
  "朝夕鸟": "zhāo,xī,niǎo",
  "朝大夫": "cháo,dài,fū",
  "朝天馄饨": "cháo,tiān,hún,tun",
  "朝夷暮跖": "zhāo,yí,mù,zhí",
  "朝奏夕召": "zhāo,zòu,xī,zhào",
  "朝奏暮召": "zhāo,zòu,mù,zhào",
  "朝思暮想": "zhāo,sī,mù,xiǎng",
  "朝成夕毁": "zhāo,chéng,xī,huǐ",
  "朝成暮徧": "zhāo,chéng,mù,biàn",
  "朝成暮毁": "zhāo,chéng,mù,huǐ",
  "朝成暮遍": "zhāo,chéng,mù,biàn",
  "朝折暮折": "zhāo,shé,mù,shé",
  "朝攀暮折": "zhāo,pān,mù,shé",
  "朝斯夕斯": "zhāo,sī,xī,sī",
  "朝日": "zhāo,rì",
  "朝日放送": "zhāo,rì,fàng,sòng",
  "朝日新闻": "zhāo,rì,xīn,wén",
  "朝晖": "zhāo,huī",
  "朝晖夕阴": "zhāo,huī,xī,yīn",
  "朝暮": "zhāo,mù",
  "朝暾": "zhāo,tūn",
  "朝曦": "zhāo,xī",
  "朝更暮改": "zhāo,gèng,mù,gǎi",
  "朝朝": "zhāo,zhāo",
  "朝朝寒食": "zhāo,zhāo,hán,shí",
  "朝朝暮暮": "zhāo,zhāo,mù,mù",
  "朝来": "zhāo,lái",
  "朝梁暮周": "zhāo,liáng,mù,zhōu",
  "朝梁暮晋": "zhāo,liáng,mù,jìn",
  "朝梁暮陈": "zhāo,liáng,mù,chén",
  "朝欢暮乐": "zhāo,huān,mù,lè",
  "朝歌": "zhāo,gē",
  "朝歌夜弦": "zhāo,gē,yè,xián",
  "朝歌暮弦": "zhāo,gē,mù,xián",
  "朝歌镇": "zhāo,gē,zhèn",
  "朝气": "zhāo,qì",
  "朝气蓬勃": "zhāo,qì,péng,bó",
  "朝生夕死": "zhāo,shēng,xī,sǐ",
  "朝生暮死": "zhāo,shēng,mù,sǐ",
  "朝着": "cháo,zhe",
  "朝着云地": "cháo,zhe,yún,de",
  "朝种暮获": "zhāo,zhǒng,mù,huò",
  "朝秦暮楚": "zhāo,qín,mù,chǔ",
  "朝穿暮塞": "zhāo,chuān,mù,sāi",
  "朝红色地": "cháo,hóng,sè,de",
  "朝经": "zhāo,jīng",
  "朝经暮史": "zhāo,jīng,mù,shǐ",
  "朝花夕拾": "zhāo,huā,xī,shí",
  "朝荣夕灭": "zhāo,róng,xī,miè",
  "朝菌": "zhāo,jūn",
  "朝衣东市": "zhāo,yī,dōng,shì",
  "朝趁暮食": "zhāo,chèn,mù,shí",
  "朝过夕改": "zhāo,guò,xī,gǎi",
  "朝钟暮鼓": "zhāo,zhōng,mù,gǔ",
  "朝锺暮鼓": "zhāo,zhōng,mù,gǔ",
  "朝闻夕改": "zhāo,wén,xī,gǎi",
  "朝闻夕死": "zhāo,wén,xī,sǐ",
  "朝闻道": "zhāo,wén,dào",
  "朝闻道夕死可矣": "zhāo,wén,dào,xī,sǐ,kě,yǐ",
  "朝阳": "zhāo,yáng",
  "朝阳产业": "zhāo,yáng,chǎn,yè",
  "朝阳凤": "zhāo,yáng,fèng",
  "朝阳地": "zhāo,yáng,de",
  "朝阳地区": "zhāo,yáng,dì,qū",
  "朝阳鸣凤": "zhāo,yáng,míng,fèng",
  "朝雨": "zhāo,yǔ",
  "朝霞": "zhāo,xiá",
  "朝露": "zhāo,lù",
  "朝露暮霭": "zhāo,lù,mù,ǎi",
  "朝露溘至": "zhāo,lù,kè,zhì",
  "朝食": "zhāo,shí",
  "朝饔夕飧": "zhāo,yōng,xī,sūn",
  "朝鲜": "cháo,xiǎn",
  "朝鲜中央通讯社": "cháo,xiǎn,zhōng,yāng,tōng,xùn,shè",
  "朝鲜人": "cháo,xiǎn,rén",
  "朝鲜八道": "cháo,xiǎn,bā,dào",
  "朝鲜劳动党": "cháo,xiǎn,láo,dòng,dǎng",
  "朝鲜半岛": "cháo,xiǎn,bàn,dǎo",
  "朝鲜参": "cháo,xiǎn,cān",
  "朝鲜太宗": "cháo,xiǎn,tài,zōng",
  "朝鲜字母": "cháo,xiǎn,zì,mǔ",
  "朝鲜总督府": "cháo,xiǎn,zǒng,dū,fǔ",
  "朝鲜战争": "cháo,xiǎn,zhàn,zhēng",
  "朝鲜文": "cháo,xiǎn,wén",
  "朝鲜族": "cháo,xiǎn,zú",
  "朝鲜日报": "cháo,xiǎn,rì,bào",
  "朝鲜核谈": "cháo,xiǎn,hé,tán",
  "朝鲜民主主义人民共和国": "cháo,xiǎn,mín,zhǔ,zhǔ,yì,rén,mín,gòng,hé,guó",
  "朝鲜海峡": "cháo,xiǎn,hǎi,xiá",
  "朝鲜筝": "cháo,xiǎn,zhēng",
  "朝鲜语": "cháo,xiǎn,yǔ",
  "朝齑夕盐": "zhāo,jī,xī,yán",
  "朝齑暮盐": "zhāo,jī,mù,yán",
  "期年": "jī,nián",
  "期待地": "qī,dài,de",
  "期数": "qī,shù",
  "期月": "jī,yuè",
  "期望地": "qī,wàng,de",
  "期货地": "qī,huò,de",
  "朦头转向": "méng,tóu,zhuàn,xiàng",
  "朦胧地": "méng,lóng,de",
  "朦胧地出现": "méng,lóng,de,chū,xiàn",
  "木仆": "mù,pú",
  "木侯": "mù,hòu",
  "木偶衣冠": "mù,ǒu,yì,guān",
  "木制地": "mù,zhì,de",
  "木吒": "mù,zha",
  "木堇": "mù,jǐn",
  "木堤": "mù,dī",
  "木处": "mù,chǔ",
  "木头": "mù,tou",
  "木头人": "mù,tou,rén",
  "木头屑": "mù,tou,xiè",
  "木头底儿": "mù,tou,dǐ,ér",
  "木头橛子": "mù,tou,jué,zǐ",
  "木夹": "mù,jiā",
  "木家什": "mù,jiā,shí",
  "木居海处": "mù,jū,hǎi,chǔ",
  "木强": "mù,jiàng",
  "木数": "mù,shù",
  "木朴": "mù,piáo",
  "木杆": "mù,gǎn",
  "木杘": "mù,chī",
  "木杮": "mù,bèi",
  "木板地": "mù,bǎn,de",
  "木栅": "mù,shān",
  "木椆": "mù,zhòu",
  "木椹": "mù,shèn",
  "木模": "mù,mú",
  "木然地": "mù,rán,de",
  "木犀": "mù,xi",
  "木犀肉": "mù,xi,ròu",
  "木竹子": "mù,zhú,zi",
  "木管乐器": "mù,guǎn,yuè,qì",
  "木𫏋": "mù,jué",
  "木里藏族自治县": "mù,lǐ,zàng,zú,zì,zhì,xiàn",
  "木钩子": "mù,gōu,zi",
  "木钻": "mù,zuàn",
  "木锜": "mù,yǐ",
  "木难": "mù,nàn",
  "木馒头": "mù,mán,tou",
  "木骨都束": "mù,gǔ,dū,shù",
  "木齿耙": "mù,chǐ,pá",
  "未与人接": "wei,yu,ren,jie",
  "未为不可": "wèi,wéi,bù,kě",
  "未了": "wèi,liǎo",
  "未了公案": "wèi,liǎo,gōng,àn",
  "未了因": "wèi,liǎo,yīn",
  "未了缘": "wèi,liǎo,yuán",
  "未冠": "wèi,guān",
  "未决定地": "wèi,jué,deng,de",
  "未受伤地": "wèi,shòu,shāng,de",
  "未处理": "wèi,chǔ,lǐ",
  "未婚地": "wèi,hūn,de",
  "未应": "wèi,yìng",
  "未必然地": "wèi,bì,rán,de",
  "未成冠": "wèi,chéng,guān",
  "未戴帽地": "wèi,dài,mào,de",
  "未提炼地": "wèi,tí,liàn,de",
  "未期望地": "wèi,qī,wàng,de",
  "未来地": "wèi,lái,de",
  "未烤透地": "wèi,kǎo,tòu,de",
  "未爆炸弹": "wèi,bào,zhà,dàn",
  "未知数": "wèi,zhī,shù",
  "未知数儿": "wèi,zhī,shù,er",
  "未艾方兴": "wèi,ài,fāng,xīng",
  "未表明地": "wèi,biǎo,míng,de",
  "未见得": "wèi,jiàn,de",
  "未逮": "wèi,dǎi",
  "末了": "mò,liǎo",
  "末儿": "mò,er",
  "末卷": "mò,juàn",
  "末子": "mò,zi",
  "末折": "mò,shé",
  "末𢫬": "mò,shā",
  "末末了": "mò,mò,liǎo",
  "末着": "mò,zhe",
  "末衖": "mò,lòng",
  "末调": "mò,diào",
  "本体地": "běn,tǐ,de",
  "本分": "běn,fèn",
  "本分官": "běn,fèn,guān",
  "本剽": "běn,piāo",
  "本头儿": "běn,tou,er",
  "本子": "běn,zi",
  "本干": "běn,gàn",
  "本底子": "běn,dǐ,zi",
  "本底计数": "běn,dǐ,jì,shù",
  "本底调查": "běn,dǐ,diào,chá",
  "本数": "běn,shù",
  "本文地": "běn,wén,de",
  "本末倒置": "běn,mò,dào,zhì",
  "本本分分": "běn,běn,fèn,fēn",
  "本朴": "běn,piáo",
  "本来地": "běn,lái,de",
  "本相": "běn,xiàng",
  "本相毕露": "běn,xiàng,bì,lù",
  "本着": "běn,zhe",
  "本能地": "běn,néng,de",
  "本行": "běn,háng",
  "本质上地": "běn,zhì,shàng,de",
  "本适": "běn,shì",
  "本铺": "běn,pù",
  "札马剌丁": "zhá,mǎ,lá,dīng",
  "术士冠": "shù,shì,guān",
  "术数": "shù,shù",
  "术氏冠": "shù,shì,guān",
  "朱万卷": "zhū,wàn,juàn",
  "朱云折槛": "zhū,yún,zhē,kǎn",
  "朱云槛": "zhū,yún,kǎn",
  "朱冠": "zhū,guān",
  "朱卷": "zhū,juàn",
  "朱槃玉敦": "zhū,pán,yù,duì",
  "朱槛": "zhū,kǎn",
  "朱殷": "zhū,yān",
  "朱毂": "zhū,gū",
  "朱游和药": "zhū,yóu,huò,yào",
  "朱盘玉敦": "zhū,pán,yù,duì",
  "朱笔帖": "zhū,bǐ,tiē",
  "朱笔条子": "zhū,bǐ,tiáo,zi",
  "朱翘": "zhū,qiào",
  "朱耶": "zhū,yē",
  "朱背啄花鸟": "zhū,bèi,zhuó,huā,niǎo",
  "朱芾": "zhū,fú",
  "朱茀": "zhū,bó",
  "朱𫉄": "zhū,zhū",
  "朱袚": "zhū,bō",
  "朱韈": "zhū,wà",
  "朴人": "piáo,rén",
  "朴俭": "piáo,jiǎn",
  "朴僿": "piáo,sài",
  "朴儒": "piáo,rú",
  "朴击": "piáo,jī",
  "朴刀": "pō,dāo",
  "朴力": "piáo,lì",
  "朴劣": "piáo,liè",
  "朴勇": "piáo,yǒng",
  "朴古": "piáo,gǔ",
  "朴士": "piáo,shì",
  "朴壹": "piáo,yī",
  "朴子": "pú,zǐ",
  "朴子市": "pú,zǐ,shì",
  "朴实地": "pǔ,shí,de",
  "朴属": "piáo,shǔ",
  "朴廉": "piáo,lián",
  "朴强": "piáo,jiāng",
  "朴忠": "pò,zhōng",
  "朴悍": "piáo,hàn",
  "朴悫": "piáo,què",
  "朴悴": "piáo,cuì",
  "朴愚": "piáo,yú",
  "朴慎": "piáo,shèn",
  "朴懦": "piáo,nuò",
  "朴戆": "piáo,gàng",
  "朴抶": "piáo,chì",
  "朴握": "piáo,wò",
  "朴散": "piáo,sàn",
  "朴斲": "piáo,zhuó",
  "朴斵": "piáo,zhuó",
  "朴智星": "piáo,zhì,xīng",
  "朴木": "piáo,mù",
  "朴桷": "piáo,jué",
  "朴椽": "piáo,chuán",
  "朴槿惠": "piáo,jǐn,huì",
  "朴樕": "pú,sù",
  "朴正熙": "piáo,zhèng,xī",
  "朴洁": "piáo,jié",
  "朴浑": "piáo,hún",
  "朴消": "piáo,xiāo",
  "朴涩": "piáo,sè",
  "朴淳": "piáo,chún",
  "朴渥": "piáo,wò",
  "朴澹": "piáo,dàn",
  "朴父": "piáo,fù",
  "朴牛": "pò,niú",
  "朴猪": "piáo,zhū",
  "朴率": "piáo,lǜ",
  "朴略": "piáo,lüè",
  "朴疎": "piáo,shū",
  "朴疏": "piáo,shū",
  "朴硝": "pò,xiāo",
  "朴秀": "piáo,xiù",
  "朴简": "piáo,jiǎn",
  "朴簌": "piáo,sù",
  "朴素地": "pǔ,sù,de",
  "朴索": "piáo,suǒ",
  "朴练": "piáo,liàn",
  "朴船": "piáo,chuán",
  "朴蔌": "piáo,sù",
  "朴诚": "piáo,chéng",
  "朴谨": "piáo,jǐn",
  "朴貌": "piáo,mào",
  "朴质地": "pǔ,zhì,de",
  "朴赡": "piáo,shàn",
  "朴趾源": "piáo,zhǐ,yuán",
  "朴辞": "piáo,cí",
  "朴远": "piáo,yuǎn",
  "朴遬": "piáo,sù",
  "朴鄙": "piáo,bǐ",
  "朴醇": "piáo,chún",
  "朴重": "piáo,zhòng",
  "朴野": "piáo,yě",
  "朴金野现象": "piáo,jīn,yě,xiàn,xiàng",
  "朴钝": "piáo,dùn",
  "朴隘": "piáo,ài",
  "朴雅": "piáo,yǎ",
  "朴静": "piáo,jìng",
  "朴𫘤": "piáo,ái",
  "朴马": "piáo,mǎ",
  "朴鲁": "piáo,lǔ",
  "朴鲠": "piáo,gěng",
  "朴鸷": "piáo,zhì",
  "朵儿": "duǒ,er",
  "朵儿别": "duǒ,er,bié",
  "朹实": "guǐ,shí",
  "机会地": "jī,huì,de",
  "机伶": "jī,ling",
  "机哩瓜拉": "jī,lī,guā,lā",
  "机埳": "jī,kǎn",
  "机壳": "jī,qiào",
  "机子": "jī,zi",
  "机巧地": "jī,qiǎo,de",
  "机帆船": "jī,fān,chuán",
  "机干": "jī,gàn",
  "机房仔": "jī,fáng,zǎi",
  "机敏地": "jī,mǐn,de",
  "机数": "jī,shù",
  "机智地": "jī,zhì,de",
  "机械地": "jī,xiè,de",
  "机械地做": "jī,xiè,de,zuò",
  "机椷": "jī,hán",
  "机槛": "jī,kǎn",
  "机灵": "jī,ling",
  "机灵地": "jī,líng,de",
  "机能上地": "jī,néng,shàng,de",
  "机警地": "jī,jǐng,de",
  "机长": "jī,zhǎng",
  "朽折": "xiǔ,shé",
  "朽𬮴": "xiǔ,ān",
  "朽骀": "xiǔ,dài",
  "杀人不见血": "shā,rén,bù,jiàn,xuè",
  "杀人地": "shā,rén,de",
  "杀人处钻出头来": "shā,rén,chù,zuàn,chū,tóu,lái",
  "杀人如蓺": "shā,rén,rú,tiě",
  "杀伤炸弹": "shā,shāng,zhà,dàn",
  "杀出重围": "shā,chū,chóng,wéi",
  "杀妻求将": "shā,qī,qiú,jiàng",
  "杀手级应用": "shā,shǒu,jí,yìng,yòng",
  "杀掠": "shā,lüě",
  "杀着": "shā,zhe",
  "杀缝": "shā,fèng",
  "杀鸡为黍": "shā,jī,wéi,shǔ",
  "杀鸡儿抹脖子": "shā,jī,ér,mǒ,bó,zi",
  "杂七夹八": "zá,qī,jiā,bā",
  "杂乱地": "zá,luàn,de",
  "杂乱地堆放着": "zá,luàn,de,duī,fàng,zhe",
  "杂件儿": "zá,jiàn,er",
  "杂兴": "zá,xīng",
  "杂和面": "zá,huo,miàn",
  "杂和面儿": "zá,huo,miàn,er",
  "杂处": "zá,chǔ",
  "杂数诗": "zá,shù,shī",
  "杂泛差役": "zá,fàn,chāi,yì",
  "杂牌儿": "zá,pái,er",
  "杂着": "zá,zhe",
  "杂碎": "zá,sui",
  "杂糁": "zá,shēn",
  "杂累": "zá,lèi",
  "杂调": "zá,diào",
  "杂货铺": "zá,huò,pù",
  "杂院儿": "zá,yuàn,er",
  "权利要求": "quán,lì,yāo,qiú",
  "权威地": "quán,wēi,de",
  "权宜地": "quán,yí,de",
  "权帖": "quán,tiē",
  "权数": "quán,shù",
  "权钥": "quán,yào",
  "杆儿": "gǎn,ér",
  "杆塔": "gǎn,tǎ",
  "杆子": "gān,zi",
  "杆弓": "gǎn,gōng",
  "杆拨": "gǎn,bō",
  "杆棒": "gǎn,bàng",
  "杆棘": "gǎn,jí",
  "杆秤": "gǎn,chèng",
  "杆菌": "gǎn,jūn",
  "杇槾": "wū,mán",
  "杈杆儿": "chā,gǎn,ér",
  "杈枒": "chā,yá",
  "杉木": "shā,mù",
  "杉板子": "shān,bǎn,zi",
  "杉篙": "shā,gāo",
  "李下不整冠": "lǐ,xià,bù,zhěng,guān",
  "李下不正冠": "lǐ,xià,bù,zhèng,guān",
  "李云娜": "lǐ,yún,nà",
  "李代数": "lǐ,dài,shù",
  "李娃传": "lǐ,wá,zhuàn",
  "李娜": "lǐ,nà",
  "李子": "lǐ,zi",
  "李将军列传": "lǐ,jiāng,jūn,liè,zhuàn",
  "李广不侯": "lǐ,guǎng,bù,hòu",
  "李斯特氏杆菌": "lǐ,sī,tè,shì,gǎn,jūn",
  "李昌镐": "lǐ,chāng,hào",
  "李氏朝鲜": "lǐ,shì,cháo,xiǎn",
  "李玟": "lǐ,wén",
  "李适": "lǐ,kuò",
  "李重茂": "lǐ,chóng,mào",
  "李隆基": "lǐ,lōng,jī",
  "李飞将": "lǐ,fēi,jiàng",
  "李鸿章杂碎": "lǐ,hóng,zhāng,zá,sui",
  "杏仁豆腐": "xìng,rén,dòu,fu",
  "杏叶沙参": "xìng,yè,shā,shēn",
  "杏子": "xìng,zi",
  "材优干济": "cái,yōu,gàn,jǐ",
  "材干": "cái,gàn",
  "材朴": "cái,piáo",
  "材知": "cái,zhì",
  "材茂行絜": "cái,mào,xíng,jié",
  "材薄质衰": "cái,bó,zhì,shuāi",
  "材调": "cái,diào",
  "材轻德薄": "cái,qīng,dé,bó",
  "材铺": "cái,pù",
  "材高知深": "cái,gāo,zhì,shēn",
  "村上隆": "cūn,shàng,lōng",
  "村仆": "cūn,pú",
  "村势煞": "cūn,shì,shà",
  "村卷": "cūn,juàn",
  "村堡": "cūn,pù",
  "村子": "cūn,zi",
  "村拗": "cūn,niù",
  "村朴": "cūn,piáo",
  "村煞": "cūn,shà",
  "村老子": "cūn,lǎo,zi",
  "村舍": "cūn,shè",
  "村长": "cūn,zhǎng",
  "杓子": "sháo,zi",
  "杖屦往还": "zhàng,jù,wǎng,huán",
  "杖杜宰相": "zhàng,dù,zǎi,xiàng",
  "杖䇲": "zhàng,jiā",
  "杜塞": "dù,sè",
  "杜塞道夫": "dù,sè,dào,fū",
  "杜尔伯特蒙古族自治县": "dù,ěr,bó,tè,měng,gǔ,zú,zì,zhì,xiàn",
  "杜撰地": "dù,zhuàn,de",
  "杜禁": "dù,jìn",
  "杜莎夫人": "dù,suō,fū,ren",
  "杜门塞窦": "dù,mén,sè,dòu",
  "杜门自守": "dù,mén,zì,shòu",
  "杜门面壁": "dù,mén,mian,bì",
  "杜隙防微": "dù,xī,fāng,wēi",
  "杜鹃啼血": "dù,juān,tí,xuè",
  "杜鹃血": "dù,juān,xuè",
  "杜默为诗": "dù,mò,wéi,shī",
  "束发": "shù,fà",
  "束发冠": "shù,fà,guān",
  "束发小生": "shù,fà,xiǎo,shēng",
  "束戈卷甲": "shù,gē,juàn,jiǎ",
  "束柎": "shù,fù",
  "束椽为柱": "shù,chuán,wéi,zhù",
  "束累": "shù,lèi",
  "束缊举火": "shù,yūn,jǔ,huǒ",
  "束缊还妇": "shù,yūn,huán,fù",
  "束蒲为脯": "shù,pú,wéi,pú",
  "束藴乞火": "shù,wēn,qǐ,huǒ",
  "束藴请火": "shù,wēn,qǐng,huǒ",
  "束身自好": "shù,shēn,zì,hào",
  "束载": "shù,zǎi",
  "束雪量珠": "shù,xuě,liáng,zhū",
  "杠子": "gàng,zi",
  "杠杆": "gàng,gǎn",
  "杠杆原理": "gàng,gǎn,yuán,lǐ",
  "杠杆收购": "gàng,gǎn,shōu,gòu",
  "杠杠地": "gàng,gàng,de",
  "杠枱": "gàng,tái",
  "杠毂": "gàng,gū",
  "杠铺": "gàng,pù",
  "条件反应": "tiáo,jiàn,fǎn,yìng",
  "条侯": "tiáo,hòu",
  "条几": "tiáo,jī",
  "条处": "tiáo,chǔ",
  "条子": "tiáo,zi",
  "条子地": "tiáo,zi,de",
  "条属": "tāo,zhǔ",
  "条干": "tiáo,gàn",
  "条数": "tiáo,shù",
  "条桑": "tiāo,sāng",
  "条狼": "dí,láng",
  "条狼氏": "dí,láng,shì",
  "条禁": "tiáo,jìn",
  "条缨": "tāo,yīng",
  "条荡": "dí,dàng",
  "条载": "tiáo,zǎi",
  "来回地": "lái,huí,de",
  "来回来去地": "lái,huí,lái,qù,de",
  "来头": "lái,tou",
  "来式地": "lái,shì,de",
  "来得": "lái,de",
  "来得个": "lái,de,gè",
  "来得及": "lái,de,jí",
  "来得早": "lái,de,zǎo",
  "来得早不如来得巧": "lái,de,zǎo,bù,rú,lái,de,qiǎo",
  "来日大难": "lái,rì,dà,nàn",
  "来朝": "lái,zhāo",
  "来来往往地": "lái,lái,wǎng,wǎng,de",
  "来火儿": "lái,huǒ,er",
  "来煞": "lái,shà",
  "来着": "lái,zhe",
  "来舍": "lái,shè",
  "来还": "lái,huán",
  "来项": "lái,xiang",
  "杨剥皮": "yáng,bāo,pí",
  "杨家将": "yáng,jiā,jiàng",
  "杨振宁": "yáng,zhèn,nìng",
  "杨楯": "yáng,dùn",
  "杨花水性": "yáng,hu,huǐ,xìng",
  "杨花落": "yáng,huā,lào",
  "杩叉": "mà,chā",
  "杩头": "mà,tóu",
  "杩子": "mà,zǐ",
  "杩桶": "mà,tǒng",
  "杩槎": "mà,chá",
  "杭育": "háng,yō",
  "杮札": "bèi,zhá",
  "杮柎": "bèi,fù",
  "杮附": "bèi,fù",
  "杯子": "bēi,zi",
  "杯盘狼藉": "bēi,pán,láng,jí",
  "杯血": "bēi,xuè",
  "杰什": "jié,shí",
  "杰出地": "jié,chū,de",
  "杰骜": "jié,ào",
  "杳无踪迹": "yǎo,wú,zōng,jī",
  "杷杆船": "pá,gǎn,chuán",
  "杻械": "chǒu,xiè",
  "杼柚": "zhù,zhú",
  "杼柚之空": "zhù,zhóu,zhī,kōng",
  "杼柚其空": "zhù,zhóu,qí,kōng",
  "杼柚空虚": "zhù,zhóu,kōng,xū",
  "松塔儿": "sōng,tǎ,er",
  "松弛地": "sōng,chí,de",
  "松快": "sōng,kuai",
  "松懈地": "sōng,xiè,de",
  "松散": "sōng,sǎn",
  "松散地": "sōng,sǎn,de",
  "松散物料": "sōng,san,wù,liào",
  "松松地": "sōng,sōng,de",
  "松槛": "sōng,kǎn",
  "松滋侯": "sōng,zī,hòu",
  "松瀑": "sōng,bào",
  "松筠之节": "sōng,jūn,zhī,jié",
  "松菌": "sōng,jùn",
  "松赞干布": "sōng,zàn,gàn,bù",
  "松赞干布陵": "sōng,zàn,gàn,bù,líng",
  "松露": "sōng,lù",
  "松露猪": "sōng,lù,zhū",
  "板上钉钉": "bǎn,shàng,dìng,dīng",
  "板儿爷": "bǎn,er,yé",
  "板子": "bǎn,zi",
  "板干": "bǎn,gàn",
  "板扎": "bǎn,zhā",
  "板擦儿": "bǎn,cā,er",
  "板楯蛮": "bǎn,dùn,mán",
  "板槛": "bǎn,kǎn",
  "板渚隋堤": "bǎn,zhǔ,suí,dī",
  "板铺": "bǎn,pù",
  "极为": "jí,wéi",
  "极为庞大": "jí,wéi,páng,dà",
  "极佳地": "jí,jiā,de",
  "极其地": "jí,qí,de",
  "极冠": "jí,guān",
  "极准时地": "jí,zhǔn,shí,de",
  "极力地": "jí,lì,de",
  "极力地克制着": "jí,lì,de,kè,zhì,zhe",
  "极力地克制自己": "jí,lì,de,kè,zhì,zì,jǐ",
  "极力地掩饰": "jí,lì,de,yǎn,shì",
  "极右分子": "jí,yòu,fèn,zǐ",
  "极均衡地": "jí,jūn,héng,de",
  "极坏地": "jí,huài,de",
  "极处": "jí,chǔ",
  "极大地": "jí,dà,de",
  "极大地丰富了": "jí,dà,de,fēng,fù,le",
  "极大地削弱": "jí,dà,de,xuē,ruò",
  "极大地干扰": "jí,dà,de,gān,rǎo",
  "极大地提升": "jí,dà,de,tí,shēng",
  "极大地提高了": "jí,dà,de,tí,gāo,le",
  "极大地改善": "jí,dà,de,gǎi,shàn",
  "极大地调动了": "jí,dà,de,diào,dòng,le",
  "极天爬地": "jí,tiān,pá,de",
  "极好地": "jí,hǎo,de",
  "极妙地": "jí,miào,de",
  "极小地": "jí,xiǎo,de",
  "极少地": "jí,shǎo,de",
  "极少数": "jí,shǎo,shù",
  "极差": "jí,chā",
  "极度地": "jí,dù,de",
  "极弱地": "jí,ruò,de",
  "极微地": "jí,wēi,de",
  "极快地": "jí,kuài,de",
  "极快地说": "jí,kuài,de,shuō",
  "极恶地": "jí,è,de",
  "极愚地": "jí,yú,de",
  "极数": "jí,shù",
  "极深研几": "jí,shēn,yán,jī",
  "极痛苦地": "jí,tòng,kǔ,de",
  "极着": "jí,zhe",
  "极端分子": "jí,duān,fèn,zǐ",
  "极端地": "jí,duān,de",
  "极紊乱地": "jí,wěn,luàn,de",
  "极详细地": "jí,xiáng,xì,de",
  "极谨慎地": "jí,jǐn,shèn,de",
  "极难地": "jí,nán,de",
  "构兴": "gòu,xīng",
  "构哄": "gòu,hǒng",
  "构扇": "gòu,shān",
  "构橑": "gòu,lǎo",
  "构词地": "gòu,cí,de",
  "枇杷": "pí,pa",
  "枉帆": "wǎng,fān",
  "枉然地": "wǎng,rán,de",
  "枉矢哨壶": "wǎng,shǐ,qiào,hú",
  "枉禁": "wǎng,jìn",
  "枉累": "wǎng,lèi",
  "枋箄": "fāng,bǐ",
  "枌橑": "fén,lǎo",
  "枍栺": "yì,yì",
  "枎栘": "fū,yí",
  "枎疏": "fū,shū",
  "析律舞文": "xī,lǜ,wǔ,wēn",
  "析毫剖厘": "xī,háo,pōu,lí",
  "析毫剖芒": "xī,háo,pōu,máng",
  "析精剖微": "xī,jīng,pōu,wēi",
  "枒杈": "yá,chā",
  "枒枝": "yá,zhī",
  "枒槎": "yá,chá",
  "枓拱": "dǒu,gǒng",
  "枓栱": "dǒu,gǒng",
  "枕头": "zhěn,tou",
  "枕头套": "zhěn,tou,tào",
  "枕头箱": "zhěn,tou,xiāng",
  "枕头蛋糕": "zhěn,tou,dàn,gāo",
  "枕头衣": "zhěn,tou,yī",
  "枕头风": "zhěn,tou,fēng",
  "枕席儿": "zhěn,xí,er",
  "枕席还师": "zhěn,xí,huán,shī",
  "枕干之雠": "zhěn,gàn,zhī,chóu",
  "枕戈泣血": "zhěn,gē,qì,xuè",
  "枕戈饮血": "zhěn,gē,yǐn,xuè",
  "枕曲": "zhěn,qū",
  "枕曲藉糟": "zhěn,qū,jiè,zāo",
  "枕石嗽流": "zhěn,shí,shù,liú",
  "枕边故事": "zhěn,biān,gù,shi",
  "枖枖": "yāo,yāo",
  "林冠": "lín,guān",
  "林处士": "lín,chǔ,shì",
  "林子": "lín,zi",
  "林宗折巾": "lín,zōng,shé,jīn",
  "林檎干": "lín,qín,gàn",
  "林箐": "lín,jīng",
  "林荫大道": "lín,yìn,dà,dào",
  "林荫路": "lín,yìn,lù",
  "林薄": "lín,bó",
  "林阿": "lín,ē",
  "枘凿": "ruì,zuò",
  "枚数": "méi,shù",
  "枚速马工": "mǎ,gōng,méi,sù",
  "果仁儿": "guǒ,rén,er",
  "果只": "guǒ,zhī",
  "果子": "guǒ,zi",
  "果子冻": "guǒ,zi,dòng",
  "果子狸": "guǒ,zi,lí",
  "果子酱": "guǒ,zi,jiàng",
  "果子露": "guǒ,zǐ,lù",
  "果干": "guǒ,gàn",
  "果干儿": "guǒ,gān,er",
  "果得": "guǒ,de",
  "果敢地": "guǒ,gǎn,de",
  "果料儿": "guǒ,liào,er",
  "果断地": "guǒ,duàn,de",
  "果洛藏族自治州": "guǒ,luò,zàng,zú,zì,zhì,zhōu",
  "枝剥": "zhī,bāo",
  "枝头干": "zhī,tóu,gàn",
  "枝干": "zhī,gàn",
  "枝干相持": "zhī,gàn,xiāng,chí",
  "枝扞": "zhī,gǎn",
  "枝木之冠": "zhī,mù,zhī,guān",
  "枝杈": "zhī,chà",
  "枝节地": "zhī,jié,de",
  "枝蔓": "zhī,wàn",
  "枝附叶著": "zhī,fù,yè,zhuó",
  "枞阳": "zōng,yáng",
  "枞阳县": "zōng,yáng,xiàn",
  "枢干": "shū,gàn",
  "枢禁": "shū,jìn",
  "枣子": "zǎo,zi",
  "枪子儿": "qiāng,zi,er",
  "枪弹": "qiāng,dàn",
  "枪把": "qiāng,bà",
  "枪把儿": "qiāng,bà,er",
  "枪把子": "qiāng,bà,zi",
  "枪杆": "qiāng,gǎn",
  "枪杆儿": "qiāng,gǎn,er",
  "枪杆子": "qiāng,gǎn,zi",
  "枪林弹雨": "qiāng,lín,dàn,yǔ",
  "枪榴弹": "qiāng,liú,dàn",
  "枪累": "qiāng,lèi",
  "枭处": "xiāo,chǔ",
  "枭𰥨": "xiāo,jiàn",
  "枭𮝹": "xiāo,huán",
  "枭骜": "xiāo,ào",
  "枯折": "kū,shé",
  "枯枿朽株": "kū,niǎo,xiǔ,zhū",
  "枯查": "kū,zhā",
  "枯树生华": "kū,shù,shēng,huā",
  "枯燥地": "kū,zào,de",
  "枯草杆菌": "kū,cǎo,gǎn,jūn",
  "枱历": "tái,lì",
  "枱子": "tái,zǐ",
  "枱布": "tái,bù",
  "枱灯": "tái,dēng",
  "枱球": "tái,qiú",
  "枱盘": "tái,pán",
  "枱钟": "tái,zhōng",
  "枲着": "xǐ,zhe",
  "架不住": "jià,bú,zhù",
  "架势": "jià,shi",
  "架子": "jià,zi",
  "架子工": "jià,zi,gōng",
  "架子床": "jià,zi,chuáng",
  "架子猪": "jià,zi,zhū",
  "架子花": "jià,zi,huā",
  "架子花脸": "jià,zi,huā,liǎn",
  "架子车": "jià,zi,chē",
  "架子鼓": "jià,zi,gǔ",
  "架式": "jià,shi",
  "架牟": "jià,mù",
  "架累": "jià,lèi",
  "架肩击毂": "jià,jiān,jī,gū",
  "架舌头": "jià,shé,tou",
  "枷禁": "jiā,jìn",
  "枸榾": "gǒu,gǔ",
  "枸橘": "gōu,jú",
  "枸橼": "jǔ,yuán",
  "枸酱": "jǔ,jiàng",
  "柈子": "bàn,zǐ",
  "柉禁": "fán,jìn",
  "柍桭": "yǎng,zhēn",
  "柏侯": "bǎi,hòu",
  "柏克郡": "bó,kè,jùn",
  "柏孜克里克千佛洞": "bó,zī,kè,lǐ,kè,qiān,fó,dòng",
  "柏悦": "bó,yuè",
  "柏拉图": "bó,lā,tú",
  "柏拉图哲学": "bó,lā,tú,zhé,xué",
  "柏林": "bó,lín",
  "柏林围墙": "bó,lín,wéi,qiáng",
  "柏林墙": "bó,lín,qiáng",
  "柏林大学": "bó,lín,dà,xué",
  "柏林寺": "bó,lín,sì",
  "柏林工业大学": "bó,lín,gōng,yè,dà,xué",
  "柏柏尔": "bò,bò,ěr",
  "柏油纸": "bó,yóu,zhǐ",
  "柏蒂切利": "bó,dì,qiè,lì",
  "柏辽兹": "bó,liáo,zī",
  "柏露": "bǎi,lù",
  "柏青哥": "bó,qīng,gē",
  "某们": "mǒu,men",
  "某舍": "mǒu,shè",
  "染削": "rǎn,xuē",
  "染发": "rǎn,fà",
  "染发剂": "rǎn,fà,jì",
  "染坊": "rǎn,fáng",
  "染指甲草": "rǎn,zhǐ,jiá,cǎo",
  "染着": "rǎn,zhe",
  "染累": "rǎn,lèi",
  "染蓝涅皂": "rǎn,lán,niè,zǎo",
  "染逮": "rǎn,dǎi",
  "染铺": "rǎn,pù",
  "柔冠": "róu,guān",
  "柔和地": "róu,hé,de",
  "柔弱地": "róu,ruò,de",
  "柔情脉脉": "róu,qíng,mò,mò",
  "柔柔地": "róu,róu,de",
  "柔滑地": "róu,huá,de",
  "柔祇": "róu,qí",
  "柔荑": "róu,tí",
  "柔荑花序": "róu,tí,huā,xù",
  "柔莩": "róu,piǎo",
  "柔蝡": "róu,ruǎn",
  "柔调": "róu,diào",
  "柔輭": "róu,ér",
  "柔软地": "róu,ruǎn,de",
  "柔露": "róu,lù",
  "柔韧地": "róu,rèn,de",
  "柔顺地": "róu,shùn,de",
  "柘弹": "zhè,dàn",
  "柚子": "yòu,zi",
  "柚木": "yóu,mù",
  "柜子": "guì,zi",
  "柜枱": "guì,tái",
  "柜柳": "jǔ,liǔ",
  "柞叶": "zhà,yè",
  "柞子": "zhà,zǐ",
  "柞撒": "zhà,sā",
  "柞木": "zhà,mù",
  "柞树": "zhà,shù",
  "柞格": "zhà,gé",
  "柞氏": "zhà,shì",
  "柞水": "zhà,shuǐ",
  "柞水县": "zhà,shuǐ,xiàn",
  "柞狭": "zhà,xiá",
  "柞薪": "zhà,xīn",
  "柞鄂": "zhà,è",
  "查丈": "zhā,zhàng",
  "查下": "zhā,xià",
  "查不出号儿": "zhā,bù,chū,hào,ér",
  "查催": "zhā,cuī",
  "查儿": "zhā,ér",
  "查关": "zhā,guān",
  "查参": "zhā,cān",
  "查发": "zhā,fā",
  "查哇": "zhā,wā",
  "查士丁尼": "zhā,shì,dīng,ní",
  "查处": "chá,chǔ",
  "查头": "zhā,tóu",
  "查头子": "zhā,tóu,zi",
  "查头鳊": "zhā,tóu,biān",
  "查夺": "zhā,duó",
  "查子": "zhā,zǐ",
  "查子帐": "zhā,zǐ,zhàng",
  "查学": "zhā,xué",
  "查审": "zhā,shěn",
  "查察": "zhā,chá",
  "查尔瓦": "zhā,ěr,wǎ",
  "查工": "zhā,gōng",
  "查店": "zhā,diàn",
  "查度": "zhā,dù",
  "查影": "zhā,yǐng",
  "查截": "zhā,jié",
  "查手": "zhā,shǒu",
  "查手舞脚": "zhā,shǒu,wǔ,jiǎo",
  "查报": "zhā,bào",
  "查拏": "zhā,ná",
  "查拿": "zhā,ná",
  "查数": "zhā,shù",
  "查条": "zhā,tiáo",
  "查果": "zhā,guǒ",
  "查枿": "zhā,niè",
  "查查": "zhā,zhā",
  "查查胡胡": "zhā,zhā,hú,hú",
  "查梨相": "zhā,lí,xiāng",
  "查比": "zhā,bǐ",
  "查沙": "zhā,shā",
  "查没": "chá,mò",
  "查浦": "zhā,pǔ",
  "查滓": "zhā,zǐ",
  "查牙": "zhā,yá",
  "查理": "zhā,lǐ",
  "查理定律": "zhā,lǐ,dìng,lǜ",
  "查理曼帝国": "zhā,lǐ,màn,dì,guó",
  "查田": "zhā,tián",
  "查田定产": "zhā,tián,dìng,chǎn",
  "查监": "zhā,jiān",
  "查盘": "zhā,pán",
  "查禁": "chá,jìn",
  "查秽": "zhā,huì",
  "查筭": "zhā,suàn",
  "查算": "zhā,suàn",
  "查胡势": "zhā,hú,shì",
  "查裹": "zhā,guǒ",
  "查视": "zhā,shì",
  "查览": "zhā,lǎn",
  "查解": "zhā,jiě",
  "查讯": "zhā,xùn",
  "查诘": "zhā,jié",
  "查语": "zhā,yǔ",
  "查调": "chá,diào",
  "查谈": "zhā,tán",
  "查赈": "zhā,zhèn",
  "查边": "zhā,biān",
  "查追": "zhā,zhuī",
  "查郎": "zhā,láng",
  "查铺": "chá,pù",
  "查销": "zhā,xiāo",
  "查门": "zhā,mén",
  "查黎": "zhā,lí",
  "柯劭忞": "kē,shào,mín",
  "柯干": "kē,gàn",
  "柰子": "nài,zi",
  "柱卷": "zhù,juàn",
  "柱子": "zhù,zi",
  "柱帖": "zhù,tiē",
  "柱干": "zhù,gàn",
  "柳下道儿": "liǔ,xià,dào,er",
  "柳堤": "liǔ,dī",
  "柳宠花迷": "liǔ,chǒng,huà,mí",
  "柳树上着刀": "liǔ,shù,shàng,zháo,dāo",
  "柳毅传": "liǔ,yì,zhuàn",
  "柳眉倒竖": "liǔ,méi,dào,shù",
  "柳绿桃红": "liǔ,lù,táo,hóng",
  "柳绿花红": "liǔ,lù,huā,hóng",
  "柳腰莲脸": "liǔ,yāo,lián,lián",
  "柳𬮴": "liǔ,ān",
  "柳阴仔": "liǔ,yīn,zǎi",
  "柳麻子": "liǔ,má,zi",
  "柴塞": "zhài,sāi",
  "柴护": "zhài,hù",
  "柴栅": "zhài,shān",
  "柴楂": "zhài,zhā",
  "柴楥": "chái,yuán",
  "柴毂": "chái,gū",
  "柴沟堡": "chái,gōu,bǔ",
  "柴火": "chái,huo",
  "柴火钱": "chái,huō,qián",
  "柴火饭": "chái,huō,fàn",
  "柴立不阿": "chái,lì,bù,ē",
  "柴篱": "zhài,lí",
  "柴路": "zhài,lù",
  "柿子": "shì,zi",
  "柿子挑软的捏": "shì,zi,tiāo,ruǎn,de,niē",
  "柿子椒": "shì,zi,jiāo",
  "柿子金": "shì,zi,jīn",
  "栀子": "zhī,zi",
  "栀子花": "zhī,zi,huā",
  "栅剌子": "shān,là,zǐ",
  "栅垒": "shān,lěi",
  "栅塘": "shān,táng",
  "栅墙": "shān,qiáng",
  "栅孔": "shān,kǒng",
  "栅极": "shān,jí",
  "栅格": "shān,gé",
  "栅钥": "shān,yuè",
  "栅锁": "shān,suǒ",
  "标冠": "biāo,guān",
  "标准地": "biāo,zhǔn,de",
  "标准差": "biāo,zhǔn,chā",
  "标准特许银行": "biāo,zhǔn,tè,xǔ,yín,háng",
  "标干": "biāo,gàn",
  "标搒": "biāo,péng",
  "标的": "biāo,dì",
  "标识": "biāo,zhì",
  "标题音乐": "biāo,tí,yīn,yuè",
  "栈桥式码头": "zhàn,qiáo,shì,mǎ,tou",
  "栉冠": "zhì,guān",
  "栉发": "zhì,fà",
  "栉掠": "zhì,lüě",
  "栉水母": "jié,shuǐ,mǔ",
  "栉霜沐露": "zhì,shuāng,mù,lù",
  "栊槛": "lóng,kǎn",
  "栋干": "dòng,gàn",
  "栋折": "dòng,shé",
  "栋折榱坏": "dòng,shé,cuī,huài",
  "栎阳": "yuè,yáng",
  "栏干子": "lán,gàn,zǐ",
  "栏栅": "lán,shān",
  "栏槛": "lán,kǎn",
  "树冠": "shù,guān",
  "树叶子掉下来都怕打了头": "shù,yè,zi,diào,xià,lái,dōu,pà,dǎ,le,tóu",
  "树塞门": "shù,sài,mén",
  "树干": "shù,gàn",
  "树杈": "shù,chà",
  "树杈把": "shù,chà,bǎ",
  "树林子": "shù,lín,zi",
  "树栅": "shù,shān",
  "树桃李得荫": "shù,táo,lǐ,de,yīn",
  "树桄": "shù,guàng",
  "树榾栋": "shù,gǔ,dòng",
  "树疙瘩": "shù,gē,dā",
  "树碑立传": "shù,bēi,lì,zhuàn",
  "树荆棘得刺": "shù,jīng,jí,de,cì",
  "树葡萄": "shù,pú,tao",
  "树行子": "shù,hàng,zi",
  "栓塞": "shuān,sè",
  "栖处": "qī,chǔ",
  "栖息地": "qī,xī,de",
  "栖栖": "xī,xī",
  "栖栖默默": "xī,xī,mò,mò",
  "栖遟": "qī,zhì",
  "栖霞市": "xī,xiá,shì",
  "栖风宿雨": "qī,fēng,xiǔ,yǔ",
  "栗子": "lì,zi",
  "栗惓": "lì,quán",
  "栗背伯劳": "lì,bèi,bó,láo",
  "栗背奇鹛": "lì,bèi,qí,méi",
  "栗背岩鹨": "lì,bèi,yán,liù",
  "栗背短翅鸫": "lì,bèi,duǎn,chì,dōng",
  "栗背短脚鹎": "lì,bèi,duǎn,jiǎo,bēi",
  "栟柑": "bīng,gān",
  "栟榈": "bīng,lǘ",
  "栟闾": "bīng,lǘ",
  "校书": "jiào,shū",
  "校书笺": "jiào,shū,jiān",
  "校书郎": "jiào,shū,láng",
  "校书部": "jiào,shū,bù",
  "校准": "jiào,zhǔn",
  "校勘": "jiào,kān",
  "校勘学": "jiào,kān,xué",
  "校场": "jiào,chǎng",
  "校实": "jiào,shí",
  "校对": "jiào,duì",
  "校对员": "jiào,duì,yuán",
  "校抡": "xiào,lún",
  "校改": "jiào,gǎi",
  "校数": "xiào,shù",
  "校样": "jiào,yàng",
  "校核": "jiào,hé",
  "校椅": "jiào,yǐ",
  "校次": "jiào,cì",
  "校正": "jiào,zhèng",
  "校正子": "jiào,zhèng,zǐ",
  "校注": "jiào,zhù",
  "校测": "jiào,cè",
  "校点": "jiào,diǎn",
  "校监": "xiào,jiàn",
  "校短量长": "jiào,duǎn,liáng,cháng",
  "校舍": "xiào,shè",
  "校订": "jiào,dìng",
  "校释": "jiào,shì",
  "校长": "xiào,zhǎng",
  "校阅": "jiào,yuè",
  "校雠": "jiào,chóu",
  "校饬": "jiào,chì",
  "校验": "jiào,yàn",
  "校验码": "jiào,yàn,mǎ",
  "株榾": "zhū,gǔ",
  "株累": "zhū,lèi",
  "栲折": "kǎo,shé",
  "样儿": "yàng,er",
  "样子": "yàng,zi",
  "样子瞥脚地": "yàng,zi,piē,jiǎo,de",
  "样子间": "yàng,zi,jiān",
  "样数": "yàng,shù",
  "样条函数": "yàng,tiáo,hán,shù",
  "核儿": "hú,ér",
  "核剖": "hé,pōu",
  "核反应": "hé,fǎn,yìng",
  "核反应堆": "hé,fǎn,yìng,duī",
  "核威慑力量": "hé,wēi,shè,lì,liang",
  "核子反应": "hé,zǐ,fǎn,yìng",
  "核导弹": "hé,dǎo,dàn",
  "核弹": "hé,dàn",
  "核弹头": "hé,dàn,tóu",
  "核桃仁": "hé,tao,rén",
  "核桃仁儿": "hé,táo,rén,er",
  "核桃凹": "hé,táo,wā",
  "核燃料后处理": "hé,rán,liào,hòu,chǔ,lǐ",
  "核电荷数": "hé,diàn,hè,shù",
  "核连锁反应": "hé,lián,suǒ,fǎn,yìng",
  "根子": "gēn,zi",
  "根干": "gēn,gàn",
  "根指数": "gēn,zhǐ,shù",
  "根本上地": "gēn,běn,shàng,de",
  "根深地": "gēn,shēn,de",
  "根牟": "gēn,mù",
  "根生土长": "gēn,shēng,tǔ,zhǎng",
  "根着": "gēn,zhe",
  "根连株逮": "gēn,lián,zhū,dǎi",
  "格不住": "gé,bú,zhù",
  "格什文": "gé,shí,wén",
  "格仆": "gé,pú",
  "格吧格吧": "gé,ba,gé,ba",
  "格吱": "gé,zī",
  "格喳": "gē,zhā",
  "格子": "gé,zi",
  "格子呢": "gé,zi,ní",
  "格子棉布": "gé,zi,mián,bù",
  "格子花呢": "gé,zi,huā,ní",
  "格得": "gé,de",
  "格支支": "gē,zhī,zhī",
  "格支格支": "gē,zhī,gē,zhī",
  "格格": "gé,ge",
  "格格不吐": "gē,gē,bù,tǔ",
  "格格不纳": "gē,gē,bù,nà",
  "格格地咬": "gé,gé,de,yǎo",
  "格格地响": "gé,gé,de,xiǎng",
  "格格地嚼": "gé,gé,de,jué",
  "格格地笑": "gé,gé,de,xiào",
  "格楞楞": "gé,lèng,lèng",
  "格登": "gē,dēng",
  "格登登": "gē,dēng,dēng",
  "格老子": "gé,lǎo,zi",
  "格调": "gé,diào",
  "格调说": "gé,diào,shuō",
  "格雷氏解剖学": "gé,léi,shì,jiě,pōu,xué",
  "栽子": "zāi,zi",
  "栽更头": "zāi,gēng,tóu",
  "栽种": "zāi,zhòng",
  "栽种机": "zāi,zhòng,jī",
  "栽筋斗": "zāi,jīn,dǒu",
  "栽跟头": "zāi,gēn,tou",
  "桀慠": "jié,ào",
  "桀贪骜诈": "jié,tān,ào,zhà",
  "桀骜": "jié,ào",
  "桀骜不恭": "jié,ào,bù,gōng",
  "桀骜不逊": "jié,ào,bù,xùn",
  "桀骜不顺": "jié,ào,bù,shùn",
  "桀骜不驯": "jié,ào,bù,xùn",
  "桀骜自恃": "jié,ào,zì,shì",
  "桀骜难驯": "jié,ào,nán,xùn",
  "桁杨": "háng,yáng",
  "桁杨刀锯": "háng,yáng,dāo,jù",
  "桂冠": "guì,guān",
  "桂折": "guì,shé",
  "桂折一枝": "guì,shé,yī,zhī",
  "桂折兰摧": "guì,shé,lán,cuī",
  "桂露": "guì,lù",
  "桃子": "táo,zi",
  "桃红柳绿": "táo,hóng,liǔ,lù",
  "桃花薄命": "táo,huā,bó,mìng",
  "桄充": "guàng,chōng",
  "桄关": "guàng,guān",
  "桄子": "guàng,zǐ",
  "桄桔": "guàng,jú",
  "桄桹": "guàng,láng",
  "桄综": "guàng,zōng",
  "桄面": "guàng,miàn",
  "桄颎": "guàng,jiǒng",
  "框子": "kuàng,zi",
  "框定": "kuāng,dìng",
  "案卷": "àn,juàn",
  "案子": "àn,zi",
  "案称": "àn,chèng",
  "案长": "àn,zhǎng",
  "桌子": "zhuō,zi",
  "桌面儿": "zhuō,miàn,er",
  "桎槛": "zhì,kǎn",
  "桑叶冠": "sāng,yè,guān",
  "桑土绸缪": "sāng,tǔ,chóu,miù",
  "桑户棬枢": "sāng,hù,juàn,shū",
  "桑朴": "sāng,piáo",
  "桑枢瓮牖": "sāng,shū,wěng,yǒu",
  "桑树上出血": "sāng,shù,shàng,chū,xuè",
  "桑椹": "sāng,shèn",
  "桑椹酒": "sāng,shèn,jiǔ",
  "桑耶": "sāng,yē",
  "桑葚儿": "sāng,rèn,er",
  "桑黮": "sāng,dǎn",
  "桓缪": "huán,miù",
  "桔子": "jú,zi",
  "桔柏渡": "jú,bǎi,dù",
  "桔柣": "jú,dié",
  "桔桀": "jú,jié",
  "桔皋": "jú,gāo",
  "桠杈": "yā,chà",
  "桡折": "ráo,shé",
  "桢干": "zhēn,gàn",
  "档子": "dàng,zi",
  "档案夹": "dàng,àn,jiā",
  "档调": "dàng,diào",
  "档车": "dǎng,chē",
  "桥栅": "qiáo,shān",
  "桥箭累弦": "qiáo,jiàn,lèi,xián",
  "桨叶背": "jiǎng,yè,bèi",
  "桴应": "fú,yìng",
  "桴鼓相应": "fú,gǔ,xiāng,yìng",
  "梁冠": "liáng,guān",
  "梁子湖": "liáng,zi,hú",
  "梁子湖区": "liáng,zi,hú,qū",
  "梁山泊": "liáng,shān,pō",
  "梁𪲔": "liáng,lǐ",
  "梁苑隋堤": "liáng,yuàn,suí,dī",
  "梁𬮴": "liáng,ān",
  "梅什儿": "méi,shí,ér",
  "梅塞德斯奔驰": "méi,sài,dé,sī,bēn,chí",
  "梅子": "méi,zi",
  "梅干": "méi,gàn",
  "梅桃子": "méi,táo,zi",
  "梅森素数": "méi,sēn,sù,shù",
  "梅毒地": "méi,dú,de",
  "梅花处士": "méi,huā,chǔ,shì",
  "梅花数": "méi,huā,shù",
  "梅花海鹘": "méi,huā,hǎi,hú",
  "梅花落": "méi,huā,lào",
  "梅花调": "méi,huā,diào",
  "梅葛": "méi,gě",
  "梅西耶": "méi,xī,yē",
  "梅西耶星表": "méi,xī,yē,xīng,biǎo",
  "梆子": "bāng,zi",
  "梆子头": "bāng,zi,tóu",
  "梆子戏": "bāng,zi,xì",
  "梆子腔": "bāng,zi,qiāng",
  "梏掠": "gù,lüě",
  "梗咽": "gěng,yè",
  "梗塞": "gěng,sè",
  "梗着脖子": "gěng,zhe,bó,zi",
  "梗调": "gěng,diào",
  "梗骜": "gěng,ào",
  "梦似地": "mèng,shì,de",
  "梦多地": "mèng,duō,de",
  "梦尸得官": "mèng,shī,de,guān",
  "梦幻般地": "mèng,huàn,bān,de",
  "梦想地": "mèng,xiǎng,de",
  "梦撒撩丁": "mèng,sā,liáo,dīng",
  "梦梦查查": "mèng,mèng,zhā,zhā",
  "梦露": "mèng,lù",
  "梨子": "lí,zi",
  "梨干": "lí,qián",
  "梭子": "suō,zi",
  "梭子鱼": "suō,zi,yú",
  "梯子": "tī,zi",
  "梯己": "tī,ji",
  "梯桄": "tī,guàng",
  "械数": "xiè,shù",
  "械槛": "xiè,kǎn",
  "梳云掠月": "shū,yún,lüě,yuè",
  "梳头盒子": "shū,tóu,hé,zi",
  "梳子": "shū,zi",
  "梳掠": "shū,lüě",
  "梳背": "shū,bèi",
  "梳辫子": "shū,biàn,zi",
  "梵呗": "fàn,bài",
  "梵夹": "fàn,jiā",
  "梵䇲": "fàn,jiā",
  "梵高": "fán,gāo",
  "梼戭": "táo,yǎn",
  "梼昧": "táo,mèi",
  "梼杌": "táo,wù",
  "梼树": "táo,shù",
  "梼演": "táo,yǎn",
  "检𠡠": "jiǎn,lài",
  "检卷": "jiǎn,juàn",
  "检察总长": "jiǎn,chá,zǒng,zhǎng",
  "检征": "jiǎn,zhǐ",
  "检得": "jiǎn,de",
  "检校": "jiǎn,jiào",
  "检着": "jiǎn,zhe",
  "检禁": "jiǎn,jìn",
  "检警调": "jiǎn,jǐng,diào",
  "棁杖": "tuō,zhàng",
  "棁藻": "tuō,zǎo",
  "棂槛": "líng,kǎn",
  "棉大夫": "mián,dài,fū",
  "棉猴儿": "mián,hóu,er",
  "棉花": "mián,hua",
  "棋处": "qí,chǔ",
  "棋罫": "qí,guà",
  "棋输先着": "qí,shū,xiān,zhāo",
  "棋输先著": "qí,shū,xiān,zhuó",
  "棋错一着": "qí,cuò,yī,zhāo",
  "棋高一着": "qí,gāo,yī,zhāo",
  "棍子": "gùn,zi",
  "棐几": "fěi,jī",
  "棒喝": "bàng,hè",
  "棒喝主义": "bàng,hè,zhǔ,yì",
  "棒喝党": "bàng,hè,dǎng",
  "棒子": "bàng,zi",
  "棒子国": "bàng,zi,guó",
  "棒子手": "bàng,zi,shǒu",
  "棒子糊涂": "bàng,zi,hú,tú",
  "棒子面": "bàng,zi,miàn",
  "棒子面儿": "bàng,zi,miàn,er",
  "棒子骨头": "bàng,zi,gú,tou",
  "棕叶": "zòng,yè",
  "棕背伯劳": "zōng,bèi,bó,láo",
  "棕背田鸡": "zōng,bèi,tián,jī",
  "棕背雪雀": "zōng,bèi,xuě,què",
  "棕背黑头鸫": "zōng,bèi,hēi,tóu,dōng",
  "棕顶树莺": "zòng,dǐng,shù,yīng",
  "棘手地": "jí,shǒu,de",
  "棘矜": "jí,qín",
  "棚圈": "péng,juàn",
  "棚子": "péng,zi",
  "棚架格子": "péng,jià,gé,zi",
  "棚状地": "péng,zhuàng,de",
  "棚舍": "péng,shè",
  "棜禁": "yù,jìn",
  "棠干": "táng,gàn",
  "棠朹子": "táng,guǐ,zǐ",
  "棠銕": "táng,yí",
  "棣棣": "dài,dài",
  "森海塞尔": "sēn,hǎi,sè,ěr",
  "森箾": "sēn,xiāo",
  "棯丽": "shēn,lì",
  "棰掠": "chuí,lüě",
  "棰搒": "chuí,péng",
  "棰朴": "chuí,piáo",
  "棱堡": "léng,pù",
  "棱缝": "léng,fèng",
  "棺材": "guān,cai",
  "棺材瓤子": "guān,cai,ráng,zi",
  "棼橑": "fén,lǎo",
  "棼缊": "fén,wēn",
  "椅子": "yǐ,zi",
  "椅子舆": "yǐ,zi,yú",
  "椅梧": "yī,wú",
  "椅背": "yǐ,bèi",
  "椆苕": "diào,tiáo",
  "椌楬": "qiāng,jié",
  "植发冲冠": "zhí,fà,chōng,guàn",
  "植发穿冠": "zhí,fà,chuān,guàn",
  "植物化学成分": "zhí,wù,huà,xué,chéng,fèn",
  "植物地": "zhí,wù,de",
  "植物学地": "zhí,wù,xué,de",
  "植被地": "zhí,bèi,de",
  "椎剥": "zhuī,bāo",
  "椎剽": "zhuī,piāo",
  "椎埋": "chuí,mái",
  "椎埋屠狗": "chuí,mái,tú,gǒu",
  "椎埋狗窃": "chuí,mái,gǒu,qiè",
  "椎埋穿掘": "chuí,mái,chuān,jué",
  "椎天抢地": "chuí,tiān,qiǎng,dì",
  "椎心": "chuí,xīn",
  "椎心呕血": "chuí,xīn,ǒu,xuè",
  "椎心泣血": "chuí,xīn,qì,xuè",
  "椎心顿足": "chuí,xīn,dùn,zú",
  "椎心饮泣": "chuí,xīn,yǐn,qì",
  "椎朴": "zhuī,piáo",
  "椎杀": "chuí,shā",
  "椎牛发冢": "chuí,niú,fā,zhǒng",
  "椎牛歃血": "chuí,niú,shà,xuè",
  "椎牛飨士": "chuí,niú,xiǎng,shì",
  "椎肤剥体": "chuí,fū,bō,tǐ",
  "椎肤剥髓": "chuí,fū,bō,suǐ",
  "椎胸跌足": "chuí,xiōng,diē,zú",
  "椎胸顿足": "chuí,xiōng,dùn,zú",
  "椎膺顿足": "chuí,yīng,dùn,zú",
  "椎轮": "chuí,lún",
  "椎锋陷阵": "chuí,fēng,xiàn,zhèn",
  "椎锋陷陈": "chuí,fēng,xiàn,chén",
  "椎髻": "chuí,jì",
  "椎鲁": "chuí,lǔ",
  "椎鲁敦朴": "chuí,lǔ,dūn,piáo",
  "椎鲁朴钝": "chuí,lǔ,piáo,dùn",
  "椎鼓": "chuí,gǔ",
  "椑干": "bēi,gàn",
  "椒子枇杷": "jiāo,zǐ,pí,bà",
  "椒稰": "jiāo,xū",
  "椓蠡": "zhuó,lí",
  "椭圆函数": "tuǒ,yuán,hán,shù",
  "椭圆形地": "tuǒ,yuán,xíng,de",
  "椭圆曲线": "tuǒ,yuán,qū,xiàn",
  "椰冠": "yē,guān",
  "椰子": "yē,zi",
  "椰子冠": "yē,zi,guān",
  "椰子树": "yē,zi,shù",
  "椰子汁": "yē,zi,zhī",
  "椰子油": "yē,zi,yóu",
  "椰子浆": "yē,zi,jiāng",
  "椰子猫": "yē,zi,māo",
  "椰子瓤": "yē,zi,ráng",
  "椰子皮": "yē,zi,pí",
  "椰子身": "yē,zi,shēn",
  "椰蓉": "yé,róng",
  "椽子": "chuán,zi",
  "楔子": "xiē,zi",
  "楛矢": "hù,shǐ",
  "楛矢之贡": "hù,shǐ,zhī,gòng",
  "楛砮": "kǔ,nú",
  "楞严": "lèng,yán",
  "楞子眼": "léng,zi,yǎn",
  "楞手楞脚": "lèng,shǒu,lèng,jiǎo",
  "楞楞地": "léng,léng,de",
  "楞眉横眼": "lèng,méi,héng,yǎn",
  "楦子": "xuàn,zi",
  "楮冠": "chǔ,guān",
  "楼子": "lóu,zi",
  "楼船箫鼓": "lou,chuan,xiao,gu",
  "楼观": "lóu,guàn",
  "概念地": "gài,niàn,de",
  "概括地": "gài,kuò,de",
  "概括地讲": "gài,kuò,de,jiǎng",
  "概括地说": "gài,kuò,de,shuō",
  "概括性地": "gài,kuò,xìng,de",
  "概数": "gài,shù",
  "概略地": "gài,lüè,de",
  "概略地叙述": "gài,lüè,de,xù,shù",
  "概要地": "gài,yào,de",
  "榅桲": "wēn,po",
  "榆木疙瘩": "yú,mù,gē,da",
  "榆木脑袋": "yú,mù,nǎo,dai",
  "榔头": "láng,tou",
  "榛仁儿": "zhēn,rén,er",
  "榛子": "zhēn,zi",
  "榜笞": "bàng,chī",
  "榧子": "fěi,zi",
  "榫子": "sǔn,zi",
  "榱崩栋折": "cuī,bēng,dòng,shé",
  "榱栋崩折": "cuī,dòng,bēng,shé",
  "榴弹": "liú,dàn",
  "榴弹发射器": "liú,dàn,fā,shè,qì",
  "榴弹炮": "liú,dàn,pào",
  "榴霰弹": "liú,xiàn,dàn",
  "榾柮": "gǔ,duò",
  "槁项黄馘": "gǎo,xiàng,huáng,xù",
  "槊血满袖": "shuò,xuè,mǎn,xiù",
  "槌牛酾酒": "chuí,niú,shāi,jiǔ",
  "槐荫": "huái,yìn",
  "槐荫区": "huái,yìn,qū",
  "槟城": "bīng,chéng",
  "槟州": "bīng,zhōu",
  "槟榔": "bīng,láng",
  "槟榔屿": "bīng,lang,yǔ",
  "槟榔西施": "bīng,lang,xī,shī",
  "槽子": "cáo,zi",
  "模仿地": "mó,fǎng,de",
  "模具": "mú,jù",
  "模压": "mú,yā",
  "模子": "mú,zǐ",
  "模拟地": "mó,nǐ,de",
  "模数": "mó,shù",
  "模数转换器": "mó,shù,zhuǎn,huàn,qì",
  "模板": "mú,bǎn",
  "模样": "mú,yàng",
  "模糊不清": "mó,hu,bù,qīng",
  "模糊地": "mó,hú,de",
  "模糊数学": "mó,hu,shù,xué",
  "模糊逻辑": "mó,hu,luó,ji",
  "模胡": "mó,hu",
  "横事": "hèng,shì",
  "横剖面": "héng,pōu,miàn",
  "横加梗阻": "hèng,jiā,gěng,zǔ",
  "横向地": "héng,xiàng,de",
  "横失": "heng,yi",
  "横宽地": "héng,kuān,de",
  "横征暴赋": "hèng,zhēng,bào,fù",
  "横征苛役": "hèng,zhēng,kē,yì",
  "横征苛敛": "hèng,zhēng,kē,liǎn",
  "横恣": "hèng,zì",
  "横恩滥赏": "hèng,ēn,làn,shǎng",
  "横抢武夺": "hèng,qiǎng,wǔ,duó",
  "横抢硬夺": "hèng,qiǎng,yìng,duó",
  "横拖倒扯": "héng,tuō,dào,chě",
  "横拖倒拽": "héng,tuō,dào,zhuāi",
  "横挑鼻子竖挑眼": "héng,tiāo,bí,zi,shù,tiāo,yǎn",
  "横斜地": "héng,xié,de",
  "横无忌惮": "hèng,wú,jì,dàn",
  "横暴": "hèng,bào",
  "横桁帆": "héng,héng,fān",
  "横楣子": "héng,méi,zi",
  "横死": "hèng,sǐ",
  "横殃飞祸": "hèng,yāng,fēi,huò",
  "横灾飞祸": "hèng,zāi,fēi,huò",
  "横祸": "hèng,huò",
  "横祸非灾": "hèng,huò,fēi,zāi",
  "横祸飞灾": "hèng,huò,fēi,zāi",
  "横科暴敛": "hèng,kē,bào,liǎn",
  "横竖劲儿": "héng,shù,jìn,er",
  "横筋斗": "héng,jīn,dǒu",
  "横翻筋斗": "héng,fān,jīn,dǒu",
  "横蛮": "hèng,mán",
  "横蛮不讲理": "hèng,mán,bù,jiǎng,lǐ",
  "横蛮无理": "hèng,mán,wú,lǐ",
  "横议": "hèng,yì",
  "横话": "hèng,huà",
  "横财": "hèng,cái",
  "横过地": "héng,guò,de",
  "横逆": "hèng,nì",
  "樱桃萝卜": "yīng,táo,luó,bo",
  "橘化为枳": "jú,huà,wéi,zhǐ",
  "橘子": "jú,zi",
  "橘子水": "jú,zi,shuǐ",
  "橘子汁": "jú,zi,zhī",
  "橘子酱": "jú,zi,jiàng",
  "橙子": "chéng,zi",
  "橙黄桔绿": "chéng,huáng,jú,lǜ",
  "橛子": "jué,zi",
  "橡子面": "xiàng,zi,miàn",
  "橡子面儿": "xiàng,zi,miàn,er",
  "橡皮图章": "xiàng,pí,tú,zhàng",
  "橡皮钉子": "xiàng,pí,dìng,zǐ",
  "橱子": "chú,zi",
  "檃栝": "yǐn,kuò",
  "檐溜": "yán,liù",
  "檩子": "lǐn,zi",
  "欠折": "qiàn,shé",
  "欠欠答答": "qiàn,qiàn,dā,dā",
  "欠肚儿亲家": "qiàn,dù,ér,qìng,jiā",
  "次卷": "cì,juàn",
  "次数": "cì,shù",
  "次月地": "cì,yuè,de",
  "次舍": "cì,shè",
  "次长": "cì,zhǎng",
  "次长祖": "cì,zhǎng,zǔ",
  "欢乐地": "huān,lè,de",
  "欢兴": "huān,xīng",
  "欢势": "huān,shi",
  "欢哄": "huān,hǒng",
  "欢喜地": "huān,xǐ,de",
  "欢天喜地地": "huān,tiān,xǐ,de,de",
  "欢娱地": "huān,yú,de",
  "欢实": "huān,shi",
  "欢快地": "huān,kuài,de",
  "欢快地跳": "huān,kuài,de,tiào",
  "欢愉地": "huān,yú,de",
  "欢然地": "huān,rán,de",
  "欢跃地": "huān,yuè,de",
  "欢迎地": "huān,yíng,de",
  "欢适": "huān,shì",
  "欢闹地": "huān,nào,de",
  "欣喜地": "xīn,xǐ,de",
  "欣喜地说": "xīn,xǐ,de,shuō",
  "欣慰地笑": "xīn,wèi,de,xiào",
  "欣懽": "xīn,guàn",
  "欣然地": "xīn,rán,de",
  "欣载": "xīn,zǎi",
  "欧侯": "ōu,hòu",
  "欧巴桑": "ōu,ba,sāng",
  "欧曾": "ōu,zēng",
  "欧柏林": "ōu,bó,lín",
  "欧洲中央银行": "ōu,zhōu,zhōng,yāng,yín,háng",
  "欧米伽": "ōu,mǐ,gā",
  "欧米茄表公司": "ōu,mǐ,jiā,biǎo,gōng,sī",
  "欧美化地": "ōu,měi,huà,de",
  "欧莳萝": "ōu,shí,luó",
  "欧血": "ōu,xuè",
  "欧褚": "ōu,chǔ",
  "欧轧": "ōu,zhá",
  "欬唾成珠": "ài,tuò,chéng,zhū",
  "欲厚遗之": "yù,hòu,wèi,zhī",
  "欲取姑予": "yù,qǔ,gū,yǔ",
  "欲取故予": "yù,qǔ,gù,yǔ",
  "欲得": "yù,de",
  "欲谁归罪": "yu,shui,gui,zhui",
  "欸乃": "ǎi,nǎi",
  "欸乃曲": "ǎi,nǎi,qǔ",
  "欸乃歌": "ǎi,nǎi,gē",
  "欸乃词": "ǎi,nǎi,cí",
  "欸欸": "ǎi,ǎi",
  "欹仆": "qī,pú",
  "欹削": "qī,xuē",
  "欺上蒙下": "qī,shàng,mēng,xià",
  "欺哄": "qī,hǒng",
  "欺瞒地": "qī,mán,de",
  "欺瞒夹帐": "qī,mán,jiā,zhàng",
  "欺行霸市": "qī,háng,bà,shì",
  "欺诈地": "qī,zhà,de",
  "欺诒": "qī,dài",
  "欺谩": "qī,màn",
  "欺负": "qī,fu",
  "欻吸": "chuā,xī",
  "欻拉": "chuā,lā",
  "欻欻": "chuā,chuā",
  "欻歙": "chuā,xī",
  "欻砉": "chuā,huā",
  "欻翕": "chuā,xī",
  "款儿": "kuǎn,er",
  "款子": "kuǎn,zi",
  "款缝": "kuǎn,fèng",
  "款识": "kuǎn,zhì",
  "歃血": "shà,xuè",
  "歃血为盟": "shà,xuè,wéi,méng",
  "歇了吧": "xiē,le,ba",
  "歇处": "xiē,chǔ",
  "歇息": "xiē,xi",
  "歇欻": "xiē,chuā",
  "歌仔戏": "gē,zǎi,xì",
  "歌儿": "gē,er",
  "歌呗": "gē,bài",
  "歌唫": "gē,yín",
  "歌子": "gē,zi",
  "歌折": "gē,shé",
  "歌片儿": "gē,piān,er",
  "歌珊地": "gē,shān,de",
  "歌讽": "gē,fěng",
  "歌调": "gē,diào",
  "歔吁": "xū,yù",
  "歙县": "shè,xiàn",
  "歙漆阿胶": "shè,qī,ē,jiāo",
  "歙砉": "xī,huā",
  "歙砚": "shè,yàn",
  "止戈为武": "zhǐ,gē,wéi,wǔ",
  "止戈兴仁": "zhǐ,gē,xīng,rén",
  "止暴禁非": "zhǐ,bào,jìn,fēi",
  "止疼片": "zhǐ,téng,piān",
  "止禁": "zhǐ,jìn",
  "止舍": "zhǐ,shè",
  "止血": "zhǐ,xuè",
  "止血剂": "zhǐ,xuè,jì",
  "止血垫": "zhǐ,xuè,diàn",
  "止血栓": "zhǐ,xuè,shuān",
  "止血贴": "zhǐ,xuè,tiē",
  "正不断地": "zhèng,bù,duàn,de",
  "正中下怀": "zhèng,zhòng,xià,huái",
  "正中己怀": "zhèng,zhòng,jǐ,huái",
  "正中要害": "zhèng,zhòng,yào,hài",
  "正义地": "zhèng,yì,de",
  "正乖乖地": "zhèng,guāi,guāi,de",
  "正交地": "zhèng,jiāo,de",
  "正仓院": "zhēng,cāng,yuàn",
  "正传": "zhèng,zhuàn",
  "正冷冷地": "zhèng,lěng,lěng,de",
  "正切地": "zhèng,qiē,de",
  "正则参数": "zhèng,zé,cān,shù",
  "正卖力地": "zhèng,mài,lì,de",
  "正吃力地": "zhèng,chī,lì,de",
  "正向地": "zhèng,xiàng,de",
  "正呆呆地": "zhèng,dāi,dāi,de",
  "正在疯狂地": "zhèng,zài,fēng,kuáng,de",
  "正在痴痴地": "zhèng,zài,chī,chī,de",
  "正处": "zhèng,chǔ",
  "正奇怪地": "zhèng,qí,guài,de",
  "正好地": "zhèng,hǎo,de",
  "正宫调": "zhèng,gōng,diào",
  "正帑": "zhèng,tǎng",
  "正常地": "zhèng,cháng,de",
  "正常地进行": "zhèng,cháng,de,jìn,xíng",
  "正干": "zhèng,gàn",
  "正式地": "zhèng,shì,de",
  "正当地": "zhèng,dāng,de",
  "正当性": "zhèng,dàng,xìng",
  "正当理由": "zhèng,dàng,lǐ,yóu",
  "正当防卫": "zhèng,dàng,fáng,wèi",
  "正慢慢地": "zhèng,màn,màn,de",
  "正手击地": "zhèng,shǒu,jī,de",
  "正数": "zhèng,shù",
  "正整数": "zhèng,zhěng,shù",
  "正方形地": "zhèng,fāng,xíng,de",
  "正日子": "zhèng,rì,zi",
  "正旦": "zhēng,dàn",
  "正月": "zhēng,yuè",
  "正月初一": "zhēng,yuè,chū,yī",
  "正月节": "zhēng,yuè,jié",
  "正朔": "zhēng,shuò",
  "正派地": "zhèng,pài,de",
  "正清楚地反映了": "zhèng,qīng,chǔ,de,fǎn,yìng,le",
  "正点背画": "zhèng,diǎn,bèi,huà",
  "正焦急地": "zhèng,jiāo,jí,de",
  "正电荷": "zhèng,diàn,hè",
  "正直地": "zhèng,zhí,de",
  "正着": "zhèng,zháo",
  "正着地": "zhèng,zhe,de",
  "正确地": "zhèng,què,de",
  "正确地使用": "zhèng,què,de,shǐ,yòng",
  "正确地分析": "zhèng,què,de,fēn,xī",
  "正确地对待": "zhèng,què,de,duì,dài",
  "正确地打出来": "zhèng,què,de,dǎ,chū,lái",
  "正确地推销": "zhèng,què,de,tuī,xiāo",
  "正确地教导": "zhèng,què,de,jiào,dǎo",
  "正确地显示": "zhèng,què,de,xiǎn,shì",
  "正确地看": "zhèng,què,de,kàn",
  "正确地输入": "zhèng,què,de,shū,rù",
  "正确地进行": "zhèng,què,de,jìn,xíng",
  "正确处理": "zhèng,què,chǔ,lǐ",
  "正确处理人民内部矛盾": "zhèng,què,chǔ,lǐ,rén,mín,nèi,bù,máo,dùn",
  "正笑吟吟地": "zhèng,xiào,yín,yín,de",
  "正紧张地": "zhèng,jǐn,zhāng,de",
  "正经地": "zhèng,jīng,de",
  "正规地": "zhèng,guī,de",
  "正起劲地": "zhèng,qǐ,jìn,de",
  "正身率下": "zhèng,shēn,shuài,xià",
  "正适": "zhèng,shì",
  "正错误地": "zhèng,cuò,wù,de",
  "正静静地": "zhèng,jìng,jìng,de",
  "正面地": "zhèng,miàn,de",
  "正默默地": "zhèng,mò,mò,de",
  "此唱彼和": "cǐ,chàng,bǐ,hè",
  "此处不留人": "cǐ,chǔ,bù,liú,rén",
  "此消彼长": "cǐ,xiāo,bǐ,zhǎng",
  "此风不可长": "cǐ,fēng,bù,kě,zhǎng",
  "步子": "bù,zi",
  "步摇冠": "bù,yáo,guān",
  "步斗踏罡": "bù,dǒu,tà,gāng",
  "步步为营": "bù,bù,wéi,yíng",
  "步罡踏斗": "bù,gāng,tà,dǒu",
  "步调": "bù,diào",
  "步调一致": "bù,diào,yī,zhì",
  "步调快速": "bù,diào,kuài,sù",
  "武侯吟": "wǔ,hòu,yín",
  "武冠": "wǔ,guān",
  "武器禁运": "wǔ,qì,jìn,yùn",
  "武头楯": "wǔ,tóu,dùn",
  "武将": "wǔ,jiàng",
  "武干": "wǔ,gàn",
  "武扬威地": "wǔ,yáng,wēi,de",
  "武把子": "wǔ,bà,zi",
  "武断乡曲": "wǔ,duàn,xiāng,qū",
  "武断地": "wǔ,duàn,de",
  "武断地提出": "wǔ,duàn,de,tí,chū",
  "武装分子": "wǔ,zhuāng,fèn,zǐ",
  "武贲": "wǔ,bēn",
  "武都": "wǔ,dū",
  "武都区": "wǔ,dū,qū",
  "武都市": "wǔ,dū,shì",
  "武露": "wǔ,lù",
  "歧嶷": "qí,nì",
  "歧视地": "qí,shì,de",
  "歪打正着": "wāi,dǎ,zhèng,zháo",
  "歪撇": "wāi,piě",
  "歪斜地": "wāi,xié,de",
  "歪曲": "wāi,qū",
  "歪歪地": "wāi,wāi,de",
  "歪点子": "wāi,diǎn,zi",
  "歪行货": "wāi,háng,huò",
  "歪货": "wǎi,huò",
  "死一样地": "sǐ,yī,yàng,de",
  "死一般地": "sǐ,yì,bān,de",
  "死不了": "sǐ,bù,liǎo",
  "死乞白赖": "sǐ,qi,bái,lài",
  "死了似地": "sǐ,le,shì,de",
  "死亡人数": "sǐ,wáng,rén,shù",
  "死劲儿": "sǐ,jìng,er",
  "死声咷气": "sǐ,shēng,huó,qì",
  "死当": "sǐ,dàng",
  "死心眼儿": "sǐ,xīn,yǎn,er",
  "死扣儿": "sǐ,kòu,er",
  "死数": "sǐ,shù",
  "死棋肚里有仙着": "sǐ,qí,dù,lǐ,yǒu,xiān,zhe",
  "死死地": "sǐ,sǐ,de",
  "死气白赖": "sǐ,qi,bái,lài",
  "死海古卷": "sǐ,hǎi,gǔ,juàn",
  "死海经卷": "sǐ,hǎi,jīng,juàn",
  "死灰槁木": "sǐ,huī,kū,mù",
  "死翘翘": "sǐ,qiào,qiào",
  "死而死矣": "si,er,si,yi",
  "死背": "sǐ,bèi",
  "死胡同": "sǐ,hú,tòng",
  "死血": "sǐ,xuè",
  "死要面子": "sǐ,yào,miàn,zi",
  "死要面子活受罪": "sǐ,yào,miàn,zi,huó,shòu,zuì",
  "死记硬背": "sǐ,jì,yìng,bèi",
  "死身分": "sǐ,shēn,fèn",
  "死难": "sǐ,nàn",
  "死难者": "sǐ,nàn,zhě",
  "歼剥": "jiān,bāo",
  "殀亡": "yǎo,wáng",
  "殀札": "yǎo,zhá",
  "殀殂": "yǎo,cú",
  "殂歾": "cú,wěn",
  "殂没": "cú,mò",
  "殂背": "cú,bèi",
  "殇折": "shāng,shé",
  "殇殀": "shāng,yǎo",
  "殉难": "xùn,nàn",
  "殊功劲节": "shū,gōng,jìng,jié",
  "殊数": "shū,shù",
  "殊调": "shū,diào",
  "残余地": "cán,yú,de",
  "残兵败将": "cán,bīng,bài,jiàng",
  "残军败将": "cán,jūn,bài,jiàng",
  "残削": "cán,xuē",
  "残剥": "cán,bāo",
  "残卷": "cán,juàn",
  "残忍地": "cán,rěn,de",
  "残折": "cán,shé",
  "残掠": "cán,lüě",
  "残暴地": "cán,bào,de",
  "残更": "cán,gēng",
  "残梗地": "cán,gěng,de",
  "残酷地": "cán,kù,de",
  "残露": "cán,lù",
  "残馀地": "cán,yú,de",
  "殒身不恤": "yǔn,shēn,bú,xù",
  "殚褚": "dān,chǔ",
  "殦雕": "diāo,diāo",
  "殪仆": "yì,pú",
  "殴血": "ōu,xuè",
  "段子": "duàn,zi",
  "段干": "duàn,gàn",
  "段数": "duàn,shù",
  "段长": "duàn,zhǎng",
  "殷冔": "yīn,xǔ",
  "殷切": "yīn,qiè",
  "殷勤地": "yīn,qín,de",
  "殷红": "yān,hóng",
  "殷都": "yīn,dū",
  "殷都区": "yīn,dū,qū",
  "殽乱": "yáo,luàn",
  "殽函": "yáo,hán",
  "殽列": "yáo,liè",
  "殽异": "yáo,yì",
  "殽杂": "yáo,zá",
  "殽混": "yáo,hùn",
  "殽烝": "yáo,zhēng",
  "殽然": "yáo,rán",
  "殽羞": "yáo,xiū",
  "殽脀": "yáo,zhēng",
  "殽舛": "yáo,chuǎn",
  "殽蔌": "yáo,sù",
  "殽赜": "yáo,zé",
  "殽坂": "yáo,bǎn",
  "殽𫗧": "yáo,sù",
  "殽馔": "yáo,zhuàn",
  "殽黾": "yáo,miǎn",
  "殿屎": "diàn,xī",
  "殿舍": "diàn,shè",
  "毁冠裂裳": "huǐ,guān,liè,cháng",
  "毁削": "huǐ,xuē",
  "毁剥": "huǐ,bāo",
  "毁家纾难": "huǐ,jiā,shū,nàn",
  "毁折": "huǐ,shé",
  "毁损地": "huǐ,sǔn,de",
  "毁灭似地": "huǐ,miè,shì,de",
  "毁灭地": "huǐ,miè,de",
  "毁禁": "huǐ,jìn",
  "毁舟为杕": "huǐ,zhōu,wéi,duò",
  "毁訿": "huǐ,zī",
  "毁跌": "huǐ,diē",
  "毁钟为铎": "huǐ,zhōng,wéi,duó",
  "毂下": "gū,xià",
  "毂兵": "gū,bīng",
  "毂毂": "gū,gū",
  "毂碌碌": "gū,lù,lù",
  "毂端": "gū,duān",
  "毂绾": "gū,wǎn",
  "毂𰺍": "gū,guǒ",
  "毂转": "gū,zhuǎn",
  "毂辘": "gū,lù",
  "毂辘鹰": "gū,lù,yīng",
  "毂阳": "gū,yáng",
  "毂骑": "gū,qí",
  "毅然地": "yì,rán,de",
  "毋为牛后": "wú,wéi,niú,hòu",
  "毋宁": "wú,nìng",
  "毋宁死": "wù,nìng,sǐ",
  "母丧": "mǔ,sāng",
  "母函数": "mǔ,hán,shù",
  "母弹": "mǔ,dàn",
  "母系地": "mǔ,xì,de",
  "母难日": "mǔ,nàn,rì",
  "每三年地": "měi,sān,nián,de",
  "每个人": "měi,ge,rén",
  "每分钟地": "měi,fēn,zhōng,de",
  "每半年地": "měi,bàn,nián,de",
  "每季地": "měi,jì,de",
  "每小时地": "měi,xiǎo,shí,de",
  "每年地": "měi,nián,de",
  "每日地": "měi,rì,de",
  "每次地": "měi,cì,de",
  "每百年地": "měi,bǎi,nián,de",
  "每音节地": "měi,yīn,jié,de",
  "毒剂弹": "dú,jì,dàn",
  "毒参": "dú,shēn",
  "毒学地": "dú,xué,de",
  "毒掠": "dú,lüě",
  "毒日头": "dú,rì,tou",
  "毒气弹": "dú,qì,dàn",
  "毒气炸弹": "dú,qì,zhà,dàn",
  "毒爪": "dú,zhuǎ",
  "毒虺": "dú,huī",
  "毒辣地": "dú,là,de",
  "比一比": "bǐ,yi,bǐ",
  "比不了": "bǐ,bù,liǎo",
  "比为": "bǐ,wéi",
  "比什凯克": "bǐ,shí,kǎi,kè",
  "比兴": "bǐ,xīng",
  "比划": "bǐ,huà",
  "比喻地": "bǐ,yù,de",
  "比喻失当": "bǐ,yù,shī,dàng",
  "比手划脚": "bǐ,shǒu,huà,jiǎo",
  "比才": "bì,cái",
  "比拼": "bǐ,pàn",
  "比数": "bǐ,shù",
  "比方": "bǐ,fang",
  "比方说": "bǐ,fang,shuō",
  "比照地": "bǐ,zhào,de",
  "比物属事": "bǐ,wù,zhǔ,shì",
  "比画": "bǐ,hua",
  "比舍": "bǐ,shè",
  "比色地": "bǐ,sè,de",
  "比讽": "bǐ,fěng",
  "比较地": "bǐ,jiào,de",
  "比较坏地": "bǐ,jiào,huài,de",
  "比较好地": "bǐ,jiào,hǎo,de",
  "比量": "bǐ,liáng",
  "毕剥": "bì,bāo",
  "毕宿五": "bì,xiù,wǔ",
  "毕肖": "bì,xiào",
  "毕露": "bì,lù",
  "毗耶": "pí,yē",
  "毗耶娑": "pí,yē,suō",
  "毗舍": "pí,shè",
  "毛丫头": "máo,yā,tou",
  "毛卷": "máo,juàn",
  "毛厕": "máo,si",
  "毛发": "máo,fà",
  "毛发丝粟": "máo,fà,sī,sù",
  "毛发之功": "máo,fà,zhī,gōng",
  "毛呢": "máo,ní",
  "毛头小子": "máo,tóu,xiǎo,zi",
  "毛子": "máo,zi",
  "毛子国": "máo,zi,guó",
  "毛孩子": "máo,hái,zi",
  "毛小子": "máo,xiǎo,zi",
  "毛栗子": "máo,lì,zi",
  "毛毛": "máo,mao",
  "毛毛楞楞": "máo,máo,lèng,lèng",
  "毛毛虫": "máo,mao,chóng",
  "毛求疵地": "máo,qiú,cī,de",
  "毛玻璃": "máo,bō,li",
  "毛糙地": "máo,cāo,de",
  "毛细血管": "máo,xì,xuè,guǎn",
  "毛肚": "máo,dǔ",
  "毛背心": "máo,bèi,xīn",
  "毛葛": "máo,gě",
  "毛血": "máo,xuè",
  "毛血旺": "máo,xuè,wàng",
  "毛遂": "máo,suí",
  "毛遂堕井": "máo,suí,duò,jǐng",
  "毛遂自荐": "máo,suí,zì,jiàn",
  "毛鸦头": "máo,yā,tou",
  "毡冠": "zhān,guān",
  "毡子": "zhān,zi",
  "毣毣": "mào,mào",
  "毪子": "mú,zi",
  "毫不夸张地说": "háo,bù,kuā,zhāng,de,shuō",
  "毫不客气": "háo,bù,kè,qi",
  "毫不客气地说": "háo,bú,kè,qì,de,shuō",
  "毫不容情地": "háo,bù,róng,qíng,de",
  "毫不屑意": "háo,bú,xiè,yì",
  "毫不犹豫地": "háo,bù,yóu,yù,de",
  "毫发": "háo,fà",
  "毫发不爽": "háo,fà,bù,shuǎng",
  "毫忒": "háo,tuī",
  "毫无保留地": "háo,wú,bǎo,liú,de",
  "毫无疑问地": "háo,wú,yí,wèn,de",
  "毫无痛苦地": "háo,wú,tòng,kǔ,de",
  "毫末不札": "háo,mò,bù,zhā",
  "毫露": "háo,lù",
  "毬露锦": "qiú,lù,jǐn",
  "毯子": "tǎn,zi",
  "毳冠": "cuì,guān",
  "毽子": "jiàn,zi",
  "氆氇": "pǔ,lu",
  "氏族地": "shì,zú,de",
  "氐土貉": "dī,tǔ,mò",
  "民为贵君为轻": "mín,wéi,guì,jūn,wéi,qīng",
  "民主地": "mín,zhǔ,de",
  "民乐": "mín,yuè",
  "民乐县": "mín,yuè,xiàn",
  "民以食为天": "mín,yǐ,shí,wéi,tiān",
  "民意调查": "mín,yì,diào,chá",
  "民数": "mín,shù",
  "民数记": "mín,shù,jì",
  "民族地": "mín,zú,de",
  "民民有地": "mín,mín,yǒu,de",
  "民法上地": "mín,fǎ,shàng,de",
  "民答那峨海": "mín,dā,nà,é,hǎi",
  "民累": "mín,lèi",
  "民舍": "mín,shè",
  "民调": "mín,diào",
  "民间音乐": "mín,jiān,yīn,yuè",
  "氓撩": "méng,liáo",
  "气候上地": "qì,hòu,shàng,de",
  "气克斗牛": "qì,kè,dǒu,niú",
  "气冲冲地": "qì,chōng,chōng,de",
  "气冲斗牛": "qì,chōng,dǒu,niú",
  "气冲牛斗": "qì,chōng,niú,dǒu",
  "气冷式反应堆": "qì,lěng,shì,fǎn,yìng,duī",
  "气动地": "qì,dòng,de",
  "气动葫芦": "qì,dòng,hú,lu",
  "气势磅礴": "qì,shì,páng,bó",
  "气包子": "qì,bāo,zi",
  "气吞牛斗": "qì,tūn,niú,dǒu",
  "气吞虹蜺": "qì,tūn,hóng,yī",
  "气呼呼地": "qì,hū,hū,de",
  "气咽": "qì,yè",
  "气哄哄": "qì,hǒng,hǒng",
  "气喘吁吁地": "qì,chuǎn,xū,xū,de",
  "气喘地": "qì,chuǎn,de",
  "气地": "qì,de",
  "气场": "qì,cháng",
  "气干": "qì,gàn",
  "气应": "qì,yìng",
  "气息奄奄": "qì,xī,yān,yān",
  "气恼地": "qì,nǎo,de",
  "气愤地": "qì,fèn,de",
  "气愤地说": "qì,fèn,de,shuō",
  "气愤地问": "qì,fèn,de,wèn",
  "气数": "qì,shù",
  "气禁": "qì,jìn",
  "气血": "qì,xuè",
  "气血方刚": "qì,xuè,fāng,gāng",
  "气调": "qì,diào",
  "气钻": "qì,zuàn",
  "气馁地": "qì,něi,de",
  "气鸣乐器": "qì,míng,yuè,qì",
  "气鼓鼓地": "qì,gǔ,gǔ,de",
  "气鼓鼓地不说话": "qì,gǔ,gǔ,de,bù,shuō,huà",
  "氢弹": "qīng,dàn",
  "氧吧": "yǎng,ba",
  "氧效应": "yǎng,xiào,yìng",
  "氨吖啶": "ān,ā,dìng",
  "氨基葡萄糖": "ān,jī,pú,tao,táng",
  "水中著盐": "shuǐ,zhōng,zhuó,yán",
  "水作坊": "shuǐ,zuō,fang",
  "水佩风裳": "shuǐ,pèi,fēng,shang",
  "水准地": "shuǐ,zhǔn,de",
  "水分": "shuǐ,fèn",
  "水吧": "shuǐ,ba",
  "水堨": "shuǐ,ài",
  "水处": "shuǐ,chǔ",
  "水处理": "shuǐ,chǔ,lǐ",
  "水宿山行": "shuǐ,xiǔ,shān,xíng",
  "水宿风餐": "shuǐ,xiǔ,fēng,cān",
  "水底相机": "shuǐ,dǐ,xiàng,jī",
  "水数制": "shuǐ,shù,zhì",
  "水晶猴子": "shuǐ,jīng,hóu,zi",
  "水曲柳": "shuǐ,qū,liǔ",
  "水栅": "shuǐ,shān",
  "水槛": "shuǐ,kǎn",
  "水沤": "shuǐ,ōu",
  "水泊": "shuǐ,pō",
  "水波不兴": "shuǐ,bō,bù,xīng",
  "水浒传": "shuǐ,hǔ,zhuàn",
  "水浒全传": "shuǐ,hǔ,quán,zhuàn",
  "水浒后传": "shuǐ,hǔ,hòu,zhuàn",
  "水渰老鼠": "shuǐ,yǎn,lǎo,shǔ",
  "水渰蓝桥": "shuǐ,yǎn,lán,qiáo",
  "水溜": "shuǐ,liù",
  "水溜溜": "shuǐ,liù,liū",
  "水漂儿": "shuǐ,piǎo,ér",
  "水𣸣": "shuǐ,pēn",
  "水牛儿": "shuǐ,niú,er",
  "水猴子": "shuǐ,hóu,zi",
  "水皮儿": "shuǐ,pí,er",
  "水相": "shuǐ,xiàng",
  "水硙": "shuǐ,wèi",
  "水磨沟": "shuǐ,mò,gōu",
  "水磨沟区": "shuǐ,mò,gōu,qū",
  "水祇": "shuǐ,qí",
  "水禁": "shuǐ,jìn",
  "水筩": "shuǐ,yǒng",
  "水簸箕": "shuǐ,bò,ji",
  "水米无干": "shuǐ,mǐ,wú,gàn",
  "水舀子": "shuǐ,yǎo,zi",
  "水萝卜": "shuǐ,luó,bo",
  "水虺": "shuǐ,huī",
  "水调": "shuǐ,diào",
  "水调歌头": "shuǐ,diào,gē,tóu",
  "水辗": "shuǐ,niǎn",
  "水过鸭背": "shuǐ,guò,yā,bèi",
  "水递铺": "shuǐ,dì,pù",
  "水长船高": "shuǐ,zhǎng,chuán,gāo",
  "水陼": "shuǐ,dǔ",
  "水饺儿": "shuǐ,jiǎo,er",
  "永久地": "yǒng,jiǔ,de",
  "永久性地": "yǒng,jiǔ,xìng,de",
  "永兴": "yǒng,xīng",
  "永兴县": "yǒng,xīng,xiàn",
  "永存地": "yǒng,cún,de",
  "永恒地": "yǒng,héng,de",
  "永贞内禅": "yǒng,zhēn,nèi,shàn",
  "永远地": "yǒng,yuǎn,de",
  "永远地在一起": "yǒng,yuǎn,de,zài,yì,qǐ",
  "永远地失去了": "yǒng,yuǎn,de,shī,qù,le",
  "永远地消失": "yǒng,yuǎn,de,xiāo,shī",
  "永逸地": "yǒng,yì,de",
  "永靓": "yǒng,liàng",
  "凼仔": "dàng,zǎi",
  "汀曲": "tīng,qū",
  "汀𣸣": "tīng,pēn",
  "汁莎": "zhī,shā",
  "求假": "qiú,jià",
  "求地": "qiú,de",
  "求好心切": "qiú,hǎo,xīn,qiè",
  "求灶头不如告灶尾": "qiú,zào,tou,bù,rú,gào,zào,wěi",
  "求灶头不如求灶尾": "qiú,zào,tou,bù,rú,qiú,zào,wěi",
  "求爷爷告奶奶": "qiú,yé,ye,gào,nǎi,nai",
  "求爹爹告奶奶": "qiú,diē,diē,gào,nǎi,nai",
  "求田问舍": "qiú,tián,wèn,shè",
  "求疵地": "qiú,cī,de",
  "求福": "qiú,fù",
  "求间": "qiú,jiàn",
  "求降": "qiú,xiáng",
  "汆子": "cuān,zi",
  "汇业银行": "huì,yè,yín,háng",
  "汇丰银行": "huì,fēng,yín,háng",
  "汇出行": "huì,chū,háng",
  "汇划": "huì,huà",
  "汇差": "huì,chā",
  "汉乐府": "hàn,yuè,fǔ",
  "汉堡包": "hàn,pù,bāo",
  "汉娜": "hàn,nà",
  "汉子": "hàn,zi",
  "汉家飞将": "hàn,jiā,fēi,jiàng",
  "汉甘露鼎": "hàn,gān,lù,dǐng",
  "汉票签处": "hàn,piào,qiān,chǔ",
  "汉藏语系": "hàn,zàng,yǔ,xì",
  "汉调": "hàn,diào",
  "汉调二黄": "hàn,diào,èr,huáng",
  "汋乐": "yuè,lè",
  "汋淘": "yuè,táo",
  "汋约": "yuè,yuē",
  "汗出沾背": "hàn,chū,zhān,bèi",
  "汗出洽背": "hàn,chū,qià,bèi",
  "汗出浃背": "hàn,chū,jiā,bèi",
  "汗国": "hán,guó",
  "汗流夹背": "hàn,liú,jiā,bèi",
  "汗流洽背": "hàn,liú,qià,bèi",
  "汗流浃背": "hàn,liú,jiā,bèi",
  "汗珠子": "hàn,zhū,zi",
  "汗禢儿": "hàn,tā,ér",
  "汗背心": "hàn,bèi,xīn",
  "汗腾格里峰": "hán,téng,gé,lǐ,fēng",
  "汗血": "hàn,xuè",
  "汗血宝马": "hàn,xuè,bǎo,mǎ",
  "汗血盐车": "hàn,xuè,yán,chē",
  "汗血马": "hàn,xuè,mǎ",
  "汗血驹": "hàn,xuè,jū",
  "汗褂儿": "hàn,guà,er",
  "汗褟儿": "hàn,tā,er",
  "汝帖": "rǔ,tiē",
  "江堤": "jiāng,dī",
  "江帆": "jiāng,fān",
  "江槛": "jiāng,kǎn",
  "江水地": "jiāng,shuǐ,de",
  "江沲": "jiāng,duò",
  "江湖骗子": "jiāng,hú,piàn,zi",
  "江𣸣": "jiāng,pēn",
  "江禁": "jiāng,jìn",
  "江调": "jiāng,diào",
  "江都": "jiāng,dū",
  "江都市": "jiāng,dū,shì",
  "江都马": "jiāng,dū,mǎ",
  "江隩": "jiāng,yù",
  "池子": "chí,zi",
  "池干": "chí,gàn",
  "池沤": "chí,ōu",
  "污庳": "wū,bì",
  "污染地": "wū,rǎn,de",
  "污水处理厂": "wū,shuǐ,chǔ,lǐ,chǎng",
  "污浊地": "wū,zhuó,de",
  "污潦": "wū,liáo",
  "污𰛦": "wū,wèi",
  "污秽地": "wū,huì,de",
  "污累": "wū,lèi",
  "污脏": "wū,zāng",
  "污骜": "wū,ào",
  "汤汤": "shāng,shāng",
  "汤汤儿": "shāng,shāng,ér",
  "汤汤荡荡": "shāng,shāng,dàng,dàng",
  "汤爆肚": "tāng,bào,dǔ",
  "汤羊": "tàng,yáng",
  "汦汦": "zhī,zhī",
  "汦河": "zhī,hé",
  "汨汨地流": "mì,mì,de,liú",
  "汩徂": "yù,cú",
  "汩没": "gǔ,mò",
  "汩流": "yù,liú",
  "汩潏": "gǔ,jué",
  "汩起": "yù,qǐ",
  "汩越": "yù,yuè",
  "汪洋恣肆": "wāng,yáng,zī,sì",
  "汪𰛦": "wāng,wèi",
  "汪踦卫国": "wāng,jī,wèi,guó",
  "汪锜卫国": "wāng,yǐ,wèi,guó",
  "汲汲忙忙": "ji,ji,mang,mang",
  "汶汶": "mén,mén",
  "汶浊": "mén,zhuó",
  "汹涌淜湃": "xiōng,yǒng,péng,pài",
  "汽油弹": "qì,yóu,dàn",
  "汽车炸弹": "qì,chē,zhà,dàn",
  "汽车炸弹事件": "qì,chē,zhà,dàn,shì,jiàn",
  "汾浍": "fén,huì",
  "汾露": "fén,lù",
  "沈到": "chén,dào",
  "沈博绝丽": "chén,bó,jué,lì",
  "沈朴": "shěn,piáo",
  "沈浸": "chén,jìn",
  "沈潦": "shěn,liáo",
  "沈着": "shěn,zhe",
  "沈着痛快": "shěn,zhe,tòng,kuài",
  "沈着脸": "shěn,zhe,liǎn",
  "沈𰱈": "shěn,yǒng",
  "沈累": "shěn,lèi",
  "沈薶": "shěn,wō",
  "沈鱼落雁": "chén,yú,luò,yàn",
  "沉默默": "shěn,mò,mò",
  "沉吟不语": "chén,yīn,bù,yǔ",
  "沉吟未决": "chén,yīn,wèi,jué",
  "沉寂地": "chén,jì,de",
  "沉得住气": "chén,de,zhù,qì",
  "沉思地": "chén,sī,de",
  "沉没": "chén,mò",
  "沉没成本": "chén,mò,chéng,běn",
  "沉甸甸地": "chén,diàn,diàn,de",
  "沉痛地": "chén,tòng,de",
  "沉着地": "chén,zhuó,de",
  "沉着地说": "chén,zhuó,de,shuō",
  "沉着应战": "chén,zhuó,yìng,zhàn",
  "沉谋重虑": "chén,móu,chóng,lǜ",
  "沉重地": "chén,zhòng,de",
  "沉重地行": "chén,zhòng,de,xíng",
  "沉重地行走": "chén,zhòng,de,xíng,zǒu",
  "沉重地走": "chén,zhòng,de,zǒu",
  "沉闷地": "chén,mèn,de",
  "沉降缝": "chén,jiàng,fèng",
  "沉静地": "chén,jìng,de",
  "沉默地": "chén,mò,de",
  "沐冠": "mù,guān",
  "沐浴露": "mù,yù,lù",
  "沐猴冠": "mù,hóu,guān",
  "沐露梳风": "mù,lù,shū,fēng",
  "沐露沾霜": "mù,lù,zhān,shuāng",
  "沕潏": "mì,jué",
  "沙加缅度": "shā,jiā,miǎn,duó",
  "沙参": "shā,shēn",
  "沙和尚": "shā,hé,shang",
  "沙哑地": "shā,yǎ,de",
  "沙嗄": "shā,á",
  "沙堤": "shā,dī",
  "沙塞子": "shā,sāi,zi",
  "沙声地": "shā,shēng,de",
  "沙子": "shā,zi",
  "沙子灯": "shā,zi,dēng",
  "沙子玉": "shā,zi,yù",
  "沙拉": "shā,là",
  "沙拉拉": "shā,là,lā",
  "沙拉沙拉": "shā,là,shā,là",
  "沙汏": "shā,dà",
  "沙背": "shā,bèi",
  "沙萝卜": "shā,luó,bo",
  "沙铫子": "shā,yáo,zǐ",
  "沙鹘": "shā,hú",
  "沛𰛦": "pèi,wèi",
  "沟浍": "gōu,huì",
  "没不煞": "méi,bù,shà",
  "没世": "mò,shì",
  "没世不忘": "mò,shì,bù,wàng",
  "没世难忘": "mò,shì,nán,wàng",
  "没乱": "mò,luàn",
  "没乱杀": "mò,luàn,shā",
  "没乱死": "mò,luàn,sǐ",
  "没乱煞": "mò,luàn,shà",
  "没了头": "méi,liǎo,tóu",
  "没了当": "méi,liǎo,dàng",
  "没了捆儿": "méi,liǎo,kǔn,ér",
  "没了收": "méi,liǎo,shōu",
  "没了落": "méi,liǎo,luò",
  "没亲没故": "méi,qín,méi,gù",
  "没人味儿": "méi,rén,wèi,er",
  "没什": "méi,shí",
  "没作理会处": "méi,zuò,lǐ,huì,chǔ",
  "没做奈何处": "méi,zuò,nài,hé,chǔ",
  "没做理会处": "méi,zuò,lǐ,huì,chǔ",
  "没入": "mò,rù",
  "没入脚处": "mò,rù,jiǎo,chǔ",
  "没六儿": "méi,liù,er",
  "没兴": "méi,xīng",
  "没准儿": "méi,zhǔn,er",
  "没准头": "méi,zhǔn,tou",
  "没出息地": "méi,chū,xī,de",
  "没动地方": "méi,dòng,de,fāng",
  "没劲儿": "méi,jìn,er",
  "没受伤地": "méi,shòu,shāng,de",
  "没口子": "méi,kǒu,zi",
  "没可得": "méi,kě,de",
  "没合煞": "méi,hé,shà",
  "没命地跑": "méi,mìng,de,pǎo",
  "没商量": "méi,shāng,liáng",
  "没地": "mò,dì",
  "没地里": "mò,dì,lǐ",
  "没地里的巡检": "mò,dì,lǐ,de,xún,jiǎn",
  "没头没尾": "méi,tóu,mò,wěi",
  "没头脑地": "méi,tóu,nǎo,de",
  "没奈何": "mò,nài,hé",
  "没好气地": "méi,hǎo,qì,de",
  "没好气地回答": "méi,hǎo,qì,de,huí,dá",
  "没好气地说": "méi,hǎo,qì,de,shuō",
  "没完没了": "méi,wán,méi,liǎo",
  "没完没了地": "méi,wán,méi,liǎo,de",
  "没帐得算": "méi,zhàng,de,suàn",
  "没干": "méi,gàn",
  "没干净": "méi,qián,jìng",
  "没干缠": "méi,gàn,chán",
  "没张倒置": "méi,zhāng,dào,zhì",
  "没弹剥": "méi,dàn,bāo",
  "没得": "méi,de",
  "没得挑剔": "méi,dé,tiāo,ti",
  "没得说": "méi,de,shuō",
  "没折至": "méi,shé,zhì",
  "没挑儿": "méi,tiāo,er",
  "没挞煞": "méi,tà,shà",
  "没揣": "méi,chuāi",
  "没搞头": "méi,gǎo,tou",
  "没搭煞": "méi,dā,shà",
  "没撩没乱": "méi,liáo,mò,luàn",
  "没收": "mò,shōu",
  "没收煞": "mò,shōu,shā",
  "没教养地": "méi,jiào,yǎng,de",
  "没日没夜地干": "méi,rì,méi,yè,de,gàn",
  "没有关系": "méi,yǒu,guān,xi",
  "没有劲头儿": "méi,yǒu,jìn,tóu,er",
  "没有差别": "méi,yǒu,chā,bié",
  "没有很好地": "méi,yǒu,hěn,hǎo,de",
  "没有意思": "méi,yǒu,yì,si",
  "没有真正地": "méi,yǒu,zhēn,zhèng,de",
  "没有神采地": "méi,yǒu,shén,cǎi,de",
  "没有空": "méi,yǒu,kòng",
  "没有认真地": "méi,yǒu,rèn,zhēn,de",
  "没有过多地": "méi,yǒu,guò,duō,de",
  "没来头": "méi,lái,tou",
  "没来由地": "méi,lái,yóu,de",
  "没查利": "méi,zhā,lì",
  "没样儿": "méi,yàng,er",
  "没气力地": "méi,qì,lì,de",
  "没没无闻": "mò,mò,wú,wén",
  "没溜儿": "méi,liù,er",
  "没理会处": "méi,lǐ,huì,chǔ",
  "没留没乱": "méi,liú,mò,luàn",
  "没皮子光棍": "méi,pí,zi,guāng,gùn",
  "没目标地": "méi,mù,biāo,de",
  "没矢": "mò,shǐ",
  "没礼貌地": "méi,lǐ,mào,de",
  "没空": "méi,kòng",
  "没空儿": "méi,kòng,er",
  "没空生有": "méi,kòng,shēng,yǒu",
  "没算数": "méi,suàn,shù",
  "没精打采地走": "méi,jīng,dǎ,cǎi,de,zǒu",
  "没精神地": "méi,jīng,shén,de",
  "没羞没臊": "méi,xiū,méi,sào",
  "没考虑地": "méi,kǎo,lǜ,de",
  "没肚子": "méi,dǔ,zi",
  "没药": "mò,yào",
  "没落": "mò,luò",
  "没衷一是": "mò,zhōng,yī,shì",
  "没襃弹": "méi,bāo,dàn",
  "没规矩地": "méi,guī,jǔ,de",
  "没谱儿": "méi,pǔ,er",
  "没起子": "méi,qǐ,zi",
  "没过": "mò,guò",
  "没金饮羽": "mò,jīn,yǐn,yǔ",
  "没长眼": "méi,zhǎng,yǎn",
  "没长眼睛": "méi,zhǎng,yǎn,jing",
  "没防备地": "méi,fáng,bèi,de",
  "没面子": "méi,miàn,zi",
  "没颜落色": "méi,yán,lào,shǎi",
  "没食子酸": "méi,sì,zǐ,suān",
  "没骨头": "méi,gú,tou",
  "没齿": "mò,chǐ",
  "没齿不忘": "mò,chǐ,bù,wàng",
  "没齿无怨": "mò,chǐ,wú,yuàn",
  "没齿难忘": "mò,chǐ,nán,wàng",
  "沤子": "ōu,zǐ",
  "沤库": "ōu,kù",
  "沤手香": "ōu,shǒu,xiāng",
  "沤朴": "ōu,piáo",
  "沤梦": "ōu,mèng",
  "沤榔": "ōu,láng",
  "沤气": "ōu,qì",
  "沤凼": "ōu,dàng",
  "沤沫槿艳": "ōu,mò,jǐn,yàn",
  "沤泄": "ōu,xiè",
  "沤泊": "ōu,bó",
  "沤泡": "ōu,pào",
  "沤浮泡影": "ōu,fú,pào,yǐng",
  "沤点": "ōu,diǎn",
  "沤珠槿艳": "ōu,zhū,jǐn,yàn",
  "沤粪": "ōu,fèn",
  "沤纻": "ōu,zhù",
  "沤罨": "ōu,yǎn",
  "沤苎": "ōu,zhù",
  "沤菅": "ōu,jiān",
  "沤郁": "ōu,yù",
  "沤钉": "ōu,dīng",
  "沤鸟": "ōu,niǎo",
  "沤鹭": "ōu,lù",
  "沥血": "lì,xuè",
  "沥血叩心": "lì,xuè,kòu,xīn",
  "沥血披心": "lì,xuè,pī,xīn",
  "沥血披肝": "lì,xuè,pī,gān",
  "沦为": "lún,wéi",
  "沦剥": "lún,bāo",
  "沦卷": "lún,juàn",
  "沦没": "lún,mò",
  "沦没丧亡": "lún,mò,sàng,wáng",
  "沦蕰": "lún,wēn",
  "沦铺": "lún,pù",
  "沧浪叟": "cāng,láng,sǒu",
  "沧浪君": "cāng,láng,jūn",
  "沧浪天": "cāng,láng,tiān",
  "沧浪子": "cāng,láng,zǐ",
  "沧浪客": "cāng,láng,kè",
  "沧浪洲": "cāng,láng,zhōu",
  "沧浪老人": "cāng,láng,lǎo,rén",
  "沨沨": "féng,féng",
  "沨融": "féng,róng",
  "沫儿": "mò,er",
  "沫子": "mò,zi",
  "沫血": "mò,xuè",
  "沬血": "mèi,xuè",
  "沮丧地": "jǔ,sàng,de",
  "沮丧地说": "jǔ,sàng,de,shuō",
  "沮折": "jǔ,shé",
  "沮泞": "jù,nìng",
  "沮洳": "jù,rù",
  "沮洳场": "jù,rù,chǎng",
  "沮淤": "jù,yū",
  "沮舍": "jǔ,shè",
  "河东狮子": "hé,dōng,shī,zi",
  "河东狮子吼": "hé,dōng,shī,zi,hǒu",
  "河伯为患": "hé,bó,wéi,huàn",
  "河侯": "hé,hòu",
  "河北梆子": "hé,běi,bāng,zi",
  "河南梆子": "hé,nán,bāng,zi",
  "河叉": "hé,chà",
  "河地": "hé,de",
  "河堤": "hé,dī",
  "河干": "hé,gàn",
  "河曲": "hé,qū",
  "河曲鸟": "hé,qū,niǎo",
  "河梁之谊": "hé,liáng,zhì,yí",
  "河𣸣": "hé,pēn",
  "河西堡": "hé,xī,pù",
  "河西堡镇": "hé,xī,pǔ,zhèn",
  "沸沸汤汤": "fèi,fèi,shāng,shāng",
  "沸涫": "fèi,guàn",
  "沸潏": "fèi,jué",
  "沸腾地": "fèi,téng,de",
  "沸腾着地": "fèi,téng,zhe,de",
  "油似地": "yóu,shì,de",
  "油嘴儿": "yóu,zuǐ,er",
  "油坊": "yóu,fáng",
  "油子": "yóu,zi",
  "油幢": "yóu,zhuàng",
  "油幢车": "yóu,zhuàng,chē",
  "油性地": "yóu,xìng,de",
  "油晃晃": "yóu,huàng,huǎng",
  "油榨地": "yóu,zhà,de",
  "油浸枇杷核": "yóu,jìn,pí,bà,hé",
  "油滑地": "yóu,huá,de",
  "油炒枇杷核": "yóu,chǎo,pí,bà,hé",
  "油炸": "yóu,zhá",
  "油炸圈饼": "yóu,zhá,quān,bǐng",
  "油炸土豆片": "yóu,zhá,tǔ,dòu,piàn",
  "油炸果": "yóu,zhá,guǒ",
  "油炸桧": "yóu,zhá,guì",
  "油炸烩": "yóu,zhá,huì",
  "油炸脍": "yóu,zhá,kuài",
  "油炸鬼": "yóu,zhá,guǐ",
  "油煔木": "yóu,qián,mù",
  "油票儿": "yóu,piào,er",
  "油脂仔": "yóu,zhī,zǎi",
  "油脂模糊": "yóu,zhī,mó,hu",
  "油腔滑调": "yóu,qiāng,huá,diào",
  "油腻地": "yóu,nì,de",
  "油腻腻地": "yóu,nì,nì,de",
  "油𫐌": "yóu,pēng",
  "油𫐌车": "yóu,pēng,chē",
  "油铛": "yóu,chēng",
  "油麻地": "yóu,má,de",
  "油麻地站": "yóu,má,de,zhàn",
  "油麻地避风塘": "yóu,má,de,bì,fēng,táng",
  "治不好地": "zhì,bù,hǎo,de",
  "治丧": "zhì,sāng",
  "治干": "zhì,gàn",
  "治数": "zhì,shù",
  "治疗地": "zhì,liáo,de",
  "治𰬽": "zhì,jiè",
  "治载": "zhì,zǎi",
  "治阿": "zhì,ē",
  "沽名干誉": "gū,míng,gàn,yù",
  "沾干": "zhān,gàn",
  "沾沾自好": "zhān,zhān,zì,hào",
  "沾涴": "zhān,wò",
  "沾粘": "zhān,zhān",
  "沾逮": "zhān,dǎi",
  "沾霔": "zhān,zhù",
  "沾露": "zhān,lù",
  "沿儿": "yán,er",
  "沿岸地": "yán,àn,de",
  "沿着": "yán,zhe",
  "沿边儿": "yán,biān,er",
  "泄泄": "yì,yì",
  "泄物地": "xiè,wù,de",
  "泉帖": "quán,tiē",
  "泉瀑": "quán,bào",
  "泊地": "pō,dì",
  "泊子": "pō,zǐ",
  "泊定地": "pō,deng,de",
  "泊洑": "pō,fú",
  "泌阳": "bì,yáng",
  "泌阳县": "bì,yáng,xiàn",
  "法不阿贵": "fǎ,bù,ē,guì",
  "法书帖": "fǎ,shū,tiē",
  "法儿": "fǎ,er",
  "法冠": "fǎ,guān",
  "法子": "fǎ,zi",
  "法定人数": "fǎ,dìng,rén,shù",
  "法家拂士": "fǎ,jiā,bì,shì",
  "法尔卡什": "fǎ,ěr,kǎ,shí",
  "法帖": "fǎ,tiè",
  "法幢": "fǎ,zhuàng",
  "法律上地": "fǎ,lǜ,shàng,de",
  "法律行为": "fǎ,lǜ,xíng,wéi",
  "法拉第电磁感应定律": "fǎ,lā,dì,diàn,cí,gǎn,yìng,dìng,lǜ",
  "法拉第电磁感应实验": "fǎ,lā,dì,diàn,cí,gǎn,yìng,shí,yàn",
  "法政": "fá,zhèng",
  "法数": "fǎ,shù",
  "法相宗": "fǎ,xiàng,zōng",
  "法禁": "fǎ,jìn",
  "法耶德": "fǎ,yē,dé",
  "法蠡": "fǎ,lí",
  "法轮常转": "fǎ,lún,cháng,zhuàn",
  "法隆寺": "fǎ,lōng,sì",
  "泗州调": "sì,zhōu,diào",
  "泗洟": "sì,tì",
  "泛代数": "fàn,dài,shù",
  "泛剽": "fàn,piāo",
  "泛应": "fàn,yìng",
  "泛查": "fàn,zhā",
  "泛泛地看一遍": "fàn,fàn,de,kàn,yī,biàn",
  "泛𣸣": "fàn,pēn",
  "泛驾": "fěng,jià",
  "泞潦": "nìng,liáo",
  "泡子": "pāo,zǐ",
  "泡子河": "pāo,zǐ,hé",
  "泡桐": "pāo,tóng",
  "泡泡浴露": "pào,pào,yù,lù",
  "泡泡袜": "pào,pao,wà",
  "泡涨": "pào,zhàng",
  "泡货": "pāo,huò",
  "波函数": "bō,hán,shù",
  "波士尼亚与赫塞哥维纳": "bō,shì,ní,yà,yǔ,hè,sè,gē,wéi,nà",
  "波属云委": "bō,zhǔ,yún,wěi",
  "波带片": "bō,dài,piān",
  "波数": "bō,shù",
  "波斯尼亚和黑塞哥维那": "bō,sī,ní,yà,hé,hēi,sài,gē,wéi,nà",
  "波斯尼亚和黑塞哥维那共和国": "bō,sī,ní,yà,hé,hēi,sài,gē,wéi,nà,gòng,hé,guó",
  "波查": "bō,zhā",
  "波流茅靡": "bō,liú,máo,mǐ",
  "波浪地": "bō,làng,de",
  "波浪般地": "bō,làng,bān,de",
  "波浪鼓": "bō,lang,gǔ",
  "波累": "bō,lèi",
  "波罗的": "bō,luó,dì",
  "波隆那": "bō,lōng,nà",
  "波骇云属": "bō,hài,yún,zhǔ",
  "泣下沾襟": "qǐ,xià,zhān,jīn",
  "泣愬": "qì,shuò",
  "泣数行下": "qì,shù,háng,xià",
  "泣血": "qì,xuè",
  "泣血捶膺": "qì,xuè,chuí,yīng",
  "泣血枕戈": "qì,xuè,zhěn,gē",
  "泣血稽颡": "qì,xuè,jī,sǎng",
  "泣露": "qì,lù",
  "泣麟悲凤": "qǐ,lín,bēi,fèng",
  "泥古": "nì,gǔ",
  "泥古不化": "nì,gǔ,bù,huà",
  "泥古拘方": "nì,gǔ,jū,fāng",
  "泥古非今": "nì,gǔ,fēi,jīn",
  "泥名失实": "nì,míng,shī,shí",
  "泥子": "nì,zǐ",
  "泥守": "nì,shǒu",
  "泥涴": "ní,wò",
  "泥筩花": "ní,yǒng,huā",
  "泥糊糊": "ní,hū,hū",
  "泥而不滓": "niè,ér,bù,zǐ",
  "泥脚杆": "ní,jiǎo,gǎn",
  "泥腿子": "ní,tuǐ,zi",
  "泥腿杆": "ní,tuǐ,gǎn",
  "泥铛": "ní,chēng",
  "泧漷": "yuè,kuò",
  "注兴": "zhù,xīng",
  "注册地": "zhù,cè,de",
  "注意地": "zhù,yì,de",
  "注意地听": "zhù,yì,de,tīng",
  "注意地看": "zhù,yì,de,kàn",
  "注释地": "zhù,shì,de",
  "泪汪汪地": "lèi,wāng,wāng,de",
  "泫露": "xuàn,lù",
  "泯没": "mǐn,mò",
  "泰兴": "tài,xīng",
  "泰兴市": "tài,xīng,shì",
  "泰华": "tài,huà",
  "泰孃": "tài,ráng",
  "泰山北斗": "tài,shān,běi,dǒu",
  "泰折": "tài,shé",
  "泰斗": "tài,dǒu",
  "泰来否往": "tài,lái,pǐ,wǎng",
  "泰来否极": "tài,lái,pǐ,jí",
  "泰极而否": "tài,jí,ér,pǐ",
  "泰然地": "tài,rán,de",
  "泰然处之": "tài,rán,chǔ,zhī",
  "泰适": "tài,shì",
  "泰阿": "tài,ē",
  "泱渀": "yāng,bēn",
  "泱瀼": "yǎng,nǎng",
  "泱轧": "yāng,zhá",
  "泷冈": "shuāng,gāng",
  "泷冈表": "shuāng,gāng,biǎo",
  "泷水": "shuāng,shuǐ",
  "泻肚子": "xiè,dù,zi",
  "泼喇喇": "pō,là,là",
  "泼天哄": "pō,tiān,hǒng",
  "泼脏水": "pō,zāng,shuǐ",
  "泼辣": "pō,la",
  "洁身累行": "jié,shēn,lèi,xíng",
  "洁身自好": "jié,shēn,zì,hào",
  "洁面露": "jié,miàn,lù",
  "洄潏": "huí,jué",
  "洄𬮴": "huí,ān",
  "洋为中用": "yáng,wéi,zhōng,yòng",
  "洋册子": "yáng,cè,zi",
  "洋味儿": "yáng,wèi,er",
  "洋嗓子": "yáng,sǎng,zi",
  "洋场恶少": "yáng,chǎng,è,shào",
  "洋壳": "yáng,qiào",
  "洋娃娃": "yáng,wá,wa",
  "洋将": "yáng,jiàng",
  "洋底地壳": "yáng,dǐ,dì,qiào",
  "洋洋得意地": "yáng,yáng,dé,yì,de",
  "洋洋𫄥𫄥": "yáng,yáng,sǎ,sǎ",
  "洋画儿": "yáng,huà,er",
  "洋相": "yáng,xiàng",
  "洋禁": "yáng,jìn",
  "洋腔洋调": "yáng,qiāng,yáng,diào",
  "洋芫荽": "yáng,yán,sui",
  "洋落": "yáng,là",
  "洋行": "yáng,háng",
  "洋钿": "yáng,tián",
  "洋铺子": "yáng,pù,zǐ",
  "洋鬼子": "yáng,guǐ,zi",
  "洒削": "sǎ,xuē",
  "洒扫应对": "sǎ,sào,yìng,duì",
  "洒调": "sǎ,diào",
  "洗削": "xǐ,xuē",
  "洗剥": "xǐ,bāo",
  "洗发": "xǐ,fà",
  "洗发乳": "xǐ,fà,rǔ",
  "洗发剂": "xǐ,fà,jì",
  "洗发水": "xǐ,fà,shuǐ",
  "洗发水儿": "xǐ,fà,shuǐ,er",
  "洗发皂": "xǐ,fà,zào",
  "洗发粉": "xǐ,fà,fěn",
  "洗发精": "xǐ,fà,jīng",
  "洗发露": "xǐ,fà,lù",
  "洗手不干": "xǐ,shǒu,bù,gàn",
  "洗掠": "xǐ,lüě",
  "洗渒": "xǐ,pì",
  "洗澣": "xǐ,hàn",
  "洗礼地": "xǐ,lǐ,de",
  "洗马": "xiǎn,mǎ",
  "洛扎": "luò,zhā",
  "洛扎县": "luò,zhā,xiàn",
  "洛钟东应": "luò,zhōng,dōng,yìng",
  "洞子": "dòng,zi",
  "洞察一切": "dòng,chá,yī,qiè",
  "洞鉴废兴": "dòng,jiàn,fèi,xīng",
  "洟涕": "tì,tì",
  "津关险塞": "jīn,guān,xiǎn,sài",
  "津帖": "jīn,tiē",
  "津干": "jīn,gàn",
  "津逮": "jīn,dǎi",
  "津铺": "jīn,pù",
  "洪干": "hóng,gàn",
  "洪水似地": "hóng,shuǐ,shì,de",
  "洪洞": "hóng,tóng",
  "洪洞县": "hóng,tóng,xiàn",
  "洪潦": "hóng,liáo",
  "洪炉燎发": "hóng,lú,liáo,fà",
  "洬洬": "shuò,shuò",
  "洲际导弹": "zhōu,jì,dǎo,dàn",
  "洲际弹道导弹": "zhōu,jì,dàn,dào,dǎo,dàn",
  "洴淜": "píng,péng",
  "活不下去": "huó,bù,xià,qu",
  "活儿": "huó,er",
  "活剥生吞": "huó,bāo,shēng,tūn",
  "活力地": "huó,lì,de",
  "活动分子": "huó,dòng,fèn,zǐ",
  "活动地": "huó,dòng,de",
  "活动曲尺": "huó,dòng,qū,chǐ",
  "活喇喇": "huó,là,là",
  "活头儿": "huó,tou,er",
  "活得不耐烦": "huó,de,bù,nài,fán",
  "活忒忒": "huó,tuī,tuī",
  "活支煞": "huó,zhī,shà",
  "活泛": "huó,fan",
  "活泼": "huó,po",
  "活泼地": "huó,pō,de",
  "活活地拆散": "huó,huó,de,chāi,sàn",
  "活生生地": "huó,shēng,shēng,de",
  "活着": "huó,zhe",
  "活血": "huó,xuè",
  "活血止痛": "huó,xuè,zhǐ,tòng",
  "活跃分子": "huó,yuè,fèn,zǐ",
  "活跃地": "huó,yuè,de",
  "活靶子": "huó,bǎ,zi",
  "洽博德闻": "qià,bó,duō,wén",
  "洽应": "qià,yìng",
  "洽着": "qià,zhe",
  "派不是": "pài,bú,shì",
  "派司": "pā,sī",
  "派数": "pài,shù",
  "派活儿": "pài,huó,er",
  "派系地": "pài,xì,de",
  "派调": "pài,diào",
  "流佣": "liú,yòng",
  "流刑地": "liú,xíng,de",
  "流利地": "liú,lì,de",
  "流利地讲": "liú,lì,de,jiǎng",
  "流动地": "liú,dòng,de",
  "流弹": "liú,dàn",
  "流徵": "liú,zhǐ",
  "流愒": "liú,kài",
  "流愬": "liú,shuò",
  "流星十八跌": "liú,xīng,shí,bā,diē",
  "流杮": "liú,bèi",
  "流查": "liú,zhā",
  "流氓": "liú,máng",
  "流氓国家": "liú,máng,guó,jiā",
  "流氓地": "liú,máng,de",
  "流氓无产者": "liú,máng,wú,chǎn,zhě",
  "流氓罪": "liú,máng,zuì",
  "流氓软件": "liú,máng,ruǎn,jiàn",
  "流氓集团": "liú,máng,jí,tuán",
  "流汗浃背": "liú,hàn,jiā,bèi",
  "流潦": "liú,liáo",
  "流畅地": "liú,chàng,de",
  "流畅地说": "liú,chàng,de,shuō",
  "流畅地输入": "liú,chàng,de,shū,rù",
  "流磻": "liú,bō",
  "流腔流调": "liú,qiāng,liú,diào",
  "流莩": "liú,piǎo",
  "流血千里": "liú,xuè,qiān,lǐ",
  "流血漂卤": "liú,xuè,piāo,lǔ",
  "流行音乐": "liú,xíng,yīn,yuè",
  "流调": "liú,diào",
  "流𰷠": "liú,yí",
  "流逮": "liú,dǎi",
  "流里流气": "liú,li,liú,qì",
  "流露": "liú,lù",
  "浃渫": "xiá,xiè",
  "浃背汗流": "jiā,bèi,hàn,liú",
  "浄住舍": "jìng,zhù,shè",
  "浄刹": "jìng,shā",
  "浅数": "qiǎn,shù",
  "浅明地说": "qiǎn,míng,de,shuō",
  "浅浅": "jiān,jiān",
  "浅缪": "qiǎn,miù",
  "浅薄": "qiǎn,bó",
  "浅薄地": "qiǎn,bó,de",
  "浅𬮴": "qiǎn,ān",
  "浅露": "qiǎn,lù",
  "浅鲜": "qiǎn,xiǎn",
  "浆纸": "jiàng,zhǐ",
  "浇头": "jiāo,tou",
  "浇湻": "jiāo,zhūn",
  "浇薄": "jiāo,bó",
  "浇风薄俗": "jiāo,fēng,bó,sú",
  "浊塞音": "zhuó,sè,yīn",
  "浊𰛦": "zhuó,wèi",
  "测地曲率": "cè,dì,qū,lǜ",
  "测地线曲率": "cè,dì,xiàn,qū,lǜ",
  "测度": "cè,duó",
  "测海学地": "cè,hǎi,xué,de",
  "测海蠡": "cè,hǎi,lí",
  "测量": "cè,liáng",
  "测量学": "cè,liáng,xué",
  "测量工具": "cè,liáng,gōng,jù",
  "测量标志": "cè,liáng,biāo,zhì",
  "测量标石": "cè,liáng,biāo,shí",
  "测量船": "cè,liáng,chuán",
  "测量觇标": "cè,liáng,chān,biāo",
  "浍浚": "huì,jùn",
  "浍畎": "huì,quǎn",
  "济南": "jǐ,nán",
  "济南地区": "jǐ,nán,dì,qū",
  "济南市": "jǐ,nán,shì",
  "济南生": "jǐ,nán,shēng",
  "济宁": "jǐ,níng",
  "济宁地区": "jǐ,níng,dì,qū",
  "济宁市": "jǐ,níng,shì",
  "济楚": "jǐ,chǔ",
  "济水": "jǐ,shuǐ",
  "济济一堂": "jǐ,jǐ,yī,táng",
  "济济哄哄": "jì,jì,hǒng,hǒng",
  "济济楚楚": "jì,jǐ,chǔ,chǔ",
  "济济漆漆": "jì,qí,qī,qī",
  "济济跄跄": "jì,qí,qiàng,qiàng",
  "济济锵锵": "jì,qí,qiāng,qiāng",
  "济跄": "qí,qiàng",
  "济难": "jì,nàn",
  "济馋都护": "jì,chán,dū,hù",
  "浑不是": "hún,bú,shì",
  "浑名": "hùn,míng",
  "浑天家": "hún,tiān,jie",
  "浑小子": "hún,xiǎo,zi",
  "浑抡吞枣": "hún,lún,tūn,zǎo",
  "浑朴": "hún,piáo",
  "浑殽": "hún,yáo",
  "浑水摸鱼": "hún,shuǐ,mó,yú",
  "浑沌": "hùn,dùn",
  "浑沌氏": "hùn,dùn,shì",
  "浑浊地": "hún,zhuó,de",
  "浑浑沉沉": "hún,hún,shěn,chén",
  "浑球儿": "hún,qiú,er",
  "浑舍": "hún,shè",
  "浑身解数": "hún,shēn,xiè,shù",
  "浒墅关": "xǔ,shù,guān",
  "浓厚地": "nóng,hòu,de",
  "浓妆淡抹": "nóng,zhuāng,dàn,mò",
  "浓密地": "nóng,mì,de",
  "浓抹淡妆": "nóng,mò,dàn,zhuāng",
  "浓浓地": "nóng,nóng,de",
  "浓粥状地": "nóng,zhōu,zhuàng,de",
  "浓荫地": "nóng,yīn,de",
  "浓装艳抹": "nóng,zhuāng,yàn,mò",
  "浓郁地": "nóng,yù,de",
  "浓酾": "nóng,shāi",
  "浚削": "jùn,xuē",
  "浚县": "xùn,xiàn",
  "浟浟": "yóu,yóu",
  "浟湙": "yóu,yì",
  "浟溶": "yóu,róng",
  "浡潏": "bó,jué",
  "浣澣": "huàn,hàn",
  "浣衣菲食": "huàn,yī,fěi,shí",
  "浦帆": "pǔ,fān",
  "浩浩汤汤": "hào,hào,shāng,shāng",
  "浩皛": "hào,jiǎo",
  "浩露": "hào,lù",
  "浪包喽": "làng,bāo,lou",
  "浪包搂": "làng,bāo,lōu",
  "浪头": "làng,tou",
  "浪子宰相": "làng,zǐ,zǎi,xiàng",
  "浪沤": "làng,ōu",
  "浪漫地": "làng,màn,de",
  "浪费地": "làng,fèi,de",
  "浪跄": "làng,qiàng",
  "浮云朝露": "fú,yún,zhāo,lù",
  "浮光跃金": "fu,guang,yue,jin",
  "浮剽": "fú,piāo",
  "浮力调整背心": "fú,lì,tiáo,zhěng,bèi,xīn",
  "浮华地": "fú,huá,de",
  "浮名薄利": "fú,míng,bó,lì",
  "浮声切响": "fú,shēng,qiè,xiǎng",
  "浮头儿": "fú,tou,er",
  "浮夸地": "fú,kuā,de",
  "浮收勒折": "fú,shōu,lè,shé",
  "浮斿": "fú,yóu",
  "浮查": "fú,zhā",
  "浮沤": "fú,ōu",
  "浮沤钉": "fú,ōu,dīng",
  "浮法玻璃": "fú,fǎ,bō,li",
  "浮点数": "fú,diǎn,shù",
  "浮生切响": "fú,shēng,qiè,xiǎng",
  "浮白载笔": "fú,bái,zǎi,bǐ",
  "浮皮潦草": "fú,pí,liáo,cǎo",
  "浮着": "fú,zhe",
  "浮累": "fú,lèi",
  "浮薄": "fú,bó",
  "浮薄子": "fú,bó,zǐ",
  "浮躁地": "fú,zào,de",
  "浮铺": "fú,pù",
  "浮露": "fú,lù",
  "浴火重生": "yù,huǒ,chóng,shēng",
  "浴血": "yù,xuè",
  "浴血奋战": "yù,xuè,fèn,zhàn",
  "浴血苦战": "yù,xuè,kǔ,zhàn",
  "海上花列传": "hǎi,shàng,huā,liè,zhuàn",
  "海兴": "hǎi,xīng",
  "海兴县": "hǎi,xīng,xiàn",
  "海军少校": "hǎi,jūn,shào,xiào",
  "海北藏族自治州": "hǎi,běi,zàng,zú,zì,zhì,zhōu",
  "海南藏族自治州": "hǎi,nán,zàng,zú,zì,zhì,zhōu",
  "海参": "hǎi,shēn",
  "海参崴": "hǎi,shēn,wēi",
  "海埏": "hǎi,shān",
  "海堤": "hǎi,dī",
  "海子": "hǎi,zi",
  "海岸地": "hǎi,àn,de",
  "海峡两岸关系协会": "hǎi,xiá,liǎng,àn,guān,xi,xié,huì",
  "海底地": "hǎi,dǐ,de",
  "海德堡大学": "hǎi,dé,pù,dà,xué",
  "海查": "hǎi,zhā",
  "海椰子": "hǎi,yē,zi",
  "海水不可斗量": "hǎi,shuǐ,bù,kě,dǒu,liáng",
  "海水倒灌": "hǎi,shuǐ,dào,guàn",
  "海水难量": "hǎi,shuǐ,nán,liáng",
  "海沤": "hǎi,ōu",
  "海洋性贫血": "hǎi,yáng,xìng,pín,xuè",
  "海洋温差发电": "hǎi,yáng,wēn,chā,fā,diàn",
  "海监船": "hǎi,jiàn,chuán",
  "海盗地": "hǎi,dào,de",
  "海盗行为": "hǎi,dào,xíng,wéi",
  "海相": "hǎi,xiàng",
  "海禁": "hǎi,jìn",
  "海肠子": "hǎi,cháng,zi",
  "海蛎子": "hǎi,lì,zi",
  "海蠡": "hǎi,lí",
  "海西蒙古族藏族自治州": "hǎi,xī,měng,gǔ,zú,zàng,zú,zì,zhì,zhōu",
  "海陆空": "hǎi,lù,kòng",
  "海难": "hǎi,nàn",
  "海鹘": "hǎi,hú",
  "浸没": "jìn,mò",
  "浸潦": "jìn,liáo",
  "涂塈": "tú,xì",
  "涂尔干": "tú,ěr,gàn",
  "涂数": "tú,shù",
  "涂浆台": "tú,jiàng,tái",
  "涂潦": "tú,liáo",
  "消仆": "xiāo,pú",
  "消削": "xiāo,xuē",
  "消得": "xiāo,de",
  "消息": "xiāo,xi",
  "消息来源": "xiāo,xi,lái,yuán",
  "消息灵通": "xiāo,xi,líng,tōng",
  "消息灵通人士": "xiāo,xi,líng,tōng,rén,shì",
  "消息队列": "xiāo,xi,duì,liè",
  "消愁释愦": "xiāo,cháo,shì,kuì",
  "消折": "xiāo,shé",
  "消极地": "xiāo,jí,de",
  "消沉地": "xiāo,chén,de",
  "消溶地": "xiāo,róng,de",
  "消煞": "xiāo,shà",
  "消瘅": "xiāo,dān",
  "消褪": "xiāo,tùn",
  "消费价格指数": "xiāo,fèi,jià,gé,zhǐ,shù",
  "消遣地": "xiāo,qiǎn,de",
  "消长": "xiāo,zhǎng",
  "消闲儿": "xiāo,xián,er",
  "消除对妇女一切形式歧视公约": "xiāo,chú,duì,fù,nǚ,yī,qiè,xíng,shì,qí,shì,gōng,yuē",
  "消食儿": "xiāo,shí,er",
  "涉嫌地": "shè,xián,de",
  "涉血": "shè,xuè",
  "涉贿": "shè,huī",
  "涌趯": "yǒng,yuè",
  "涎𰛦": "xián,wèi",
  "涎着脸": "xián,zhe,liǎn",
  "涎脸饧眼": "xián,liǎn,táng,yǎn",
  "涓浍": "juān,huì",
  "涓滴不剩": "juān,dī,bú,shèng",
  "涓露": "juān,lù",
  "涕洟": "tì,tì",
  "涕血": "tì,xuè",
  "涟猗": "lián,yǐ",
  "涡河": "guō,hé",
  "涡阳": "guō,yáng",
  "涡阳县": "guō,yáng,xiàn",
  "涤场": "dí,cháng",
  "涤故更新": "dí,gù,gēng,xīn",
  "涤瑕蹈隙": "dí,xiá,dǎo,xī",
  "润发液": "rùn,fà,yè",
  "润发露": "rùn,fà,lù",
  "润肤露": "rùn,fū,lù",
  "涨溢": "zhàng,yì",
  "涨满": "zhàng,mǎn",
  "涨潦": "zhǎng,liáo",
  "涨红": "zhàng,hóng",
  "涨红了脸": "zhàng,hóng,le,liǎn",
  "涨红脸地": "zhàng,hóng,liǎn,de",
  "涨绿": "zhàng,lǜ",
  "涨膀": "zhàng,bǎng",
  "涨跌": "zhǎng,diē",
  "涨跌幅限制": "zhǎng,diē,fú,xiàn,zhì",
  "涨闷": "zhàng,mèn",
  "涪沤": "fú,ōu",
  "涫汤": "guàn,tāng",
  "涫沸": "guàn,fèi",
  "涫涫": "guàn,guàn",
  "涫漱": "guàn,shù",
  "涮锅子": "shuàn,guō,zi",
  "液体地": "yè,tǐ,de",
  "液体炸弹": "yè,tǐ,zhà,dàn",
  "涴染": "wò,rǎn",
  "涴漫": "wò,màn",
  "涴濑": "wò,lài",
  "涵咀": "hán,zuǐ",
  "淇奥": "qí,yù",
  "淇澳": "qí,yù",
  "淋溶土": "lìn,róng,tǔ",
  "淋滤": "lìn,lǜ",
  "淋潦": "lín,liáo",
  "淋球菌": "lìn,qiú,jūn",
  "淋病": "lìn,bìng",
  "淋血": "lín,xuè",
  "淋露": "lín,lù",
  "淑人君子": "shū,rén,jūn,zi",
  "淑着": "shū,zhe",
  "淖潦": "nào,liáo",
  "淘气地": "táo,qì,de",
  "淘潠": "táo,sùn",
  "淘澄飞跌": "táo,chéng,fēi,diē",
  "淜洪": "péng,hóng",
  "淜淜": "péng,péng",
  "淜湃": "péng,pài",
  "淜滂": "péng,pāng",
  "淜𣸣": "péng,pēn",
  "淜犇": "péng,bēn",
  "淡妆轻抹": "dàn,zhuāng,qīng,mò",
  "淡朴": "dàn,piáo",
  "淡沲": "dàn,duò",
  "淡泊地": "dàn,bó,de",
  "淡淡地": "dàn,dàn,de",
  "淡淡地回答": "dàn,dàn,de,huí,dá",
  "淡淡地解释": "dàn,dàn,de,jiě,shì",
  "淡淡地说": "dàn,dàn,de,shuō",
  "淡淡地问": "dàn,dàn,de,wèn",
  "淡然地": "dàn,rán,de",
  "淡然处之": "dàn,rán,chǔ,zhī",
  "淡红色地": "dàn,hóng,sè,de",
  "淡色地": "dàn,sè,de",
  "淡薄": "dàn,bó",
  "淡薄地": "dàn,bó,de",
  "淡褐色地": "dàn,hè,sè,de",
  "淤塞": "yū,sè",
  "淤血": "yū,xuè",
  "淤血斑": "yū,xuè,bān",
  "淫掠": "yín,lüě",
  "淫汏": "yín,dà",
  "淫潦": "yín,liáo",
  "淫猥地": "yín,wěi,de",
  "淫秽地": "yín,huì,de",
  "淫荡地": "yín,dàng,de",
  "淫邪地": "yín,xié,de",
  "淫靡": "yín,mǐ",
  "淭挐": "qú,ná",
  "淮南子": "huái,nán,zi",
  "淮橘为枳": "huái,jú,wéi,zhǐ",
  "淮𣸣": "huái,pēn",
  "深为": "shēn,wéi",
  "深仇宿怨": "shēn,chóu,xiǔ,yuàn",
  "深信不疑地": "shēn,xìn,bù,yí,de",
  "深入地": "shēn,rù,de",
  "深入持久地开展下": "shēn,rù,chí,jiǔ,de,kāi,zhǎn,xià",
  "深入持久地开展下去": "shēn,rù,chí,jiǔ,de,kāi,zhǎn,xià,qù",
  "深切": "shēn,qiè",
  "深切地": "shēn,qiè,de",
  "深切地怀念": "shēn,qiè,de,huái,niàn",
  "深切着明": "shēn,qiē,zhe,míng",
  "深切着白": "shēn,qiē,zhe,bái",
  "深切著明": "shēn,qiè,zhù,míng",
  "深切著白": "shēn,qiè,zhù,bái",
  "深刻地": "shēn,kè,de",
  "深刻地指出": "shēn,kè,de,zhǐ,chū",
  "深刻地解剖": "shēn,kè,de,jiě,pōu",
  "深刻地调查": "shēn,kè,de,diào,chá",
  "深厉浅揭": "shēn,lì,qiǎn,qì",
  "深奥地": "shēn,ào,de",
  "深思地": "shēn,sī,de",
  "深恶痛嫉": "shēn,wù,tòng,jí",
  "深恶痛疾": "shēn,wù,tòng,jí",
  "深恶痛绝": "shēn,wù,tòng,jué",
  "深情地": "shēn,qíng,de",
  "深情地呼唤": "shēn,qíng,de,hū,huàn",
  "深情地看着": "shēn,qíng,de,kàn,zhe",
  "深扃固钥": "shēn,jiōng,gù,yào",
  "深拗": "shēn,niù",
  "深文周内": "shēn,wén,zhōu,nà",
  "深文曲折": "shēn,wén,qǔ,shé",
  "深更": "shēn,gēng",
  "深更半夜": "shēn,gēng,bàn,yè",
  "深有感触地": "shēn,yǒu,gǎn,chù,de",
  "深水炸弹": "shēn,shuǐ,zhà,dàn",
  "深测术地": "shēn,cè,shù,de",
  "深深地": "shēn,shēn,de",
  "深深地刺进": "shēn,shēn,de,cì,jìn",
  "深深地吸了一口气": "shēn,shēn,de,xī,le,yì,kǒu,qì",
  "深深地吸气": "shēn,shēn,de,xī,qì",
  "深深地埋藏在": "shēn,shēn,de,mái,cáng,zài",
  "深深地感到": "shēn,shēn,de,gǎn,dào",
  "深深地感受到": "shēn,shēn,de,gǎn,shòu,dào",
  "深深地感染了": "shēn,shēn,de,gǎn,rǎn,le",
  "深深地扎进": "shēn,shēn,de,zhā,jìn",
  "深深地陷在": "shēn,shēn,de,xiàn,zài",
  "深深地鞠躬": "shēn,shēn,de,jū,gōng",
  "深爱地": "shēn,ài,de",
  "深省": "shēn,xǐng",
  "深禁": "shēn,jìn",
  "深虑地": "shēn,lǜ,de",
  "深谷为陵": "shēn,gǔ,wéi,líng",
  "深远地问": "shēn,yuǎn,de,wèn",
  "深靓": "shēn,liàng",
  "淳化阁帖": "chún,huà,gé,tiē",
  "淳朴地": "chún,pǔ,de",
  "淳熬": "chún,áo",
  "淳着": "chún,zhe",
  "淳絜": "chún,jié",
  "混为一体": "hùn,wéi,yì,tǐ",
  "混为一谈": "hùn,wéi,yī,tán",
  "混乱地": "hùn,luàn,de",
  "混凝纸浆": "hùn,níng,zhǐ,jiàng",
  "混出名堂": "hùn,chū,míng,tang",
  "混合面儿": "hùn,hé,miàn,er",
  "混名儿": "hùn,míng,er",
  "混处": "hùn,chǔ",
  "混天撩日": "hùn,tiān,liáo,rì",
  "混帐行子": "hùn,zhàng,háng,zǐ",
  "混战一场": "hùn,zhàn,yì,chǎng",
  "混抖搂酸": "hùn,dǒu,lōu,suān",
  "混日子": "hùn,rì,zi",
  "混杂地": "hùn,zá,de",
  "混殽": "hùn,yáo",
  "混水墙": "hún,shuǐ,qiáng",
  "混活": "hún,huó",
  "混浊": "hún,zhuó",
  "混浊地": "hún,zhuó,de",
  "混混儿": "hùn,hùn,er",
  "混混噩噩": "hún,hún,è,è",
  "混然一体": "hún,rán,yī,tǐ",
  "混熟": "hùn,shóu",
  "混球": "hún,qiú",
  "混球儿": "hùn,qiú,er",
  "混蒙": "hùn,mēng",
  "混蛋": "hún,dàn",
  "混蛋地": "hùn,dàn,de",
  "混血": "hùn,xuè",
  "混血儿": "hùn,xuè,ér",
  "混行": "hún,xíng",
  "混话": "hún,huà",
  "淹数": "yān,shù",
  "淹没": "yān,mò",
  "淹禁": "yān,jìn",
  "淹翫": "yān,wàn",
  "添削": "tiān,xuē",
  "添头": "tiān,tou",
  "添盐着醋": "tiān,yán,zhe,cù",
  "添补": "tiān,bu",
  "添麻烦": "tiān,má,fan",
  "渀湃": "bēn,pài",
  "渀荡": "bēn,dàng",
  "清兴": "qīng,xīng",
  "清冠": "qīng,guān",
  "清净无为": "qīng,jìng,wú,wéi",
  "清削": "qīng,xuē",
  "清史列传": "qīng,shǐ,liè,zhuàn",
  "清吭": "qīng,kēng",
  "清呗": "qīng,bài",
  "清商三调": "qīng,shāng,sān,diào",
  "清夐": "qīng,xuàn",
  "清客相公": "qīng,kè,xiàng,gōng",
  "清干": "qīng,gàn",
  "清平调": "qīng,píng,diào",
  "清彻地": "qīng,chè,de",
  "清徵": "qīng,zhǐ",
  "清折": "qīng,shé",
  "清晰地": "qīng,xī,de",
  "清晰地昭示着": "qīng,xī,de,zhāo,shì,zhe",
  "清晰地看到": "qīng,xī,de,kàn,dào",
  "清朗地": "qīng,lǎng,de",
  "清朴": "qīng,piáo",
  "清楚": "qīng,chu",
  "清楚地": "qīng,chǔ,de",
  "清楚地写在": "qīng,chǔ,de,xiě,zài",
  "清楚地意识到": "qīng,chǔ,de,yì,shí,dào",
  "清楚地感觉到": "qīng,chǔ,de,gǎn,jué,dào",
  "清楚地显示": "qīng,chǔ,de,xiǎn,shì",
  "清楚地看到": "qīng,chǔ,de,kàn,dào",
  "清楚地知道": "qīng,chǔ,de,zhī,dào",
  "清楚地表现": "qīng,chǔ,de,biǎo,xiàn",
  "清楚地认识到": "qīng,chǔ,de,rèn,shí,dào",
  "清楚地说": "qīng,chǔ,de,shuō",
  "清洁地": "qīng,jié,de",
  "清浄无为": "qīng,jìng,wú,wéi",
  "清浑皁白": "qīng,hún,wú,bái",
  "清浰": "qīng,liàn",
  "清淡地": "qīng,dàn,de",
  "清澄地": "qīng,chéng,de",
  "清澈地": "qīng,chè,de",
  "清𣸣": "qīng,pēn",
  "清照": "qīng,zhāo",
  "清爽地": "qīng,shuǎng,de",
  "清玅": "qīng,yāo",
  "清甽": "qīng,quǎn",
  "清臒": "qīng,qú",
  "清白地": "qīng,bái,de",
  "清禁": "qīng,jìn",
  "清禁钟": "qīng,jìn,zhōng",
  "清算行": "qīng,suàn,háng",
  "清絜": "qīng,jié",
  "清脆地": "qīng,cuì,de",
  "清蓹": "qīng,yǔ",
  "清血": "qīng,xuè",
  "清调曲": "qīng,diào,qǔ",
  "清輭": "qīng,ér",
  "清适": "qīng,shì",
  "清透地": "qīng,tòu,de",
  "清都绛阙": "qīng,dōu,jiàng,què",
  "清醒地": "qīng,xǐng,de",
  "清醒地认识到": "qīng,xǐng,de,rèn,shí,dào",
  "清露": "qīng,lù",
  "清靓": "qīng,liàng",
  "清静无为": "qīng,jìng,wú,wéi",
  "清风劲节": "qīng,fēng,jìng,jié",
  "清高地": "qīng,gāo,de",
  "渊削": "yuān,xuē",
  "渊嚜": "yuān,me",
  "渊嶷": "yuān,nì",
  "渊涓蠖濩": "yuān,juān,huò,hù",
  "渊清玉絜": "yuān,qīng,yù,jié",
  "渊翫": "yuān,wàn",
  "渊蜎蠖伏": "yuān,juān,huò,fú",
  "渊调": "yuān,diào",
  "渊靓": "yuān,liàng",
  "渊鱼丛爵": "yuān,yú,cóng,què",
  "渐不可长": "jiàn,bù,kě,zhǎng",
  "渐仁摩义": "jiān,rén,mó,yì",
  "渐仁摩谊": "jiān,rén,mó,yì",
  "渐减地": "jiàn,jiǎn,de",
  "渐增地": "jiàn,zēng,de",
  "渐寖": "jiàn,jìn",
  "渐少地": "jiàn,shǎo,de",
  "渐弱地": "jiàn,ruò,de",
  "渐强地": "jiàn,qiáng,de",
  "渐快地": "jiàn,kuài,de",
  "渐慢地": "jiàn,màn,de",
  "渐染": "jiān,rǎn",
  "渐洳": "jiān,rù",
  "渐渍": "jiān,zì",
  "渐渐地": "jiàn,jiàn,de",
  "渐渐地习惯了": "jiàn,jiàn,de,xí,guàn,le",
  "渐渐地发现": "jiàn,jiàn,de,fā,xiàn",
  "渐渐地大": "jiàn,jiàn,de,dà",
  "渐渐地失去": "jiàn,jiàn,de,shī,qù",
  "渐渐地小": "jiàn,jiàn,de,xiǎo",
  "渐渐地明白": "jiàn,jiàn,de,míng,bái",
  "渐渐地有些": "jiàn,jiàn,de,yǒu,xiē",
  "渐渐地消失": "jiàn,jiàn,de,xiāo,shī",
  "渐渐地被": "jiàn,jiàn,de,bèi",
  "渐渐地远去": "jiàn,jiàn,de,yuǎn,qù",
  "渐渐离地": "jiàn,jiàn,lí,de",
  "渐速地": "jiàn,sù,de",
  "渐靡": "jiān,mí",
  "渔帆": "yú,fān",
  "渔查": "yú,zhā",
  "渔父": "yú,fǔ",
  "渔父引": "yú,fǔ,yǐn",
  "渔父曲": "yú,fǔ,qǔ",
  "渔父行": "yú,fǔ,xíng",
  "渔舍": "yú,shè",
  "渔钩儿": "yú,gōu,er",
  "渔阳参挝": "yú,yáng,cān,zhuā",
  "渔阳掺": "yú,yáng,càn",
  "渔阳掺挝": "yú,yáng,càn,zhuā",
  "渔阳鞞鼓": "yú,yáng,pí,gǔ",
  "渔阳鼙鼓": "yǔ,yáng,pí,gǔ",
  "渗出地": "shèn,chū,de",
  "渗透地": "shèn,tòu,de",
  "渠们": "qú,men",
  "渠堨": "qú,ài",
  "渠挐": "qú,ná",
  "渡仔": "dù,zǎi",
  "渡假": "dù,jià",
  "渣子": "zhā,zi",
  "渣打银行": "zhā,dǎ,yín,háng",
  "渨涹": "wēi,wō",
  "温乎": "wēn,hu",
  "温凊定省": "wēn,qìng,dìng,xǐng",
  "温卷": "wēn,juàn",
  "温和地": "wēn,hé,de",
  "温存地": "wēn,cún,de",
  "温室效应": "wēn,shì,xiào,yìng",
  "温席扇枕": "wēn,xí,shān,zhěn",
  "温德米尔夫人的扇子": "wēn,dé,mǐ,ěr,fū,rén,de,shàn,zi",
  "温情脉脉": "wēn,qíng,mò,mò",
  "温文地": "wēn,wén,de",
  "温暖地": "wēn,nuǎn,de",
  "温朴": "wēn,piáo",
  "温枕扇席": "wēn,zhěn,shān,xí",
  "温柔地": "wēn,róu,de",
  "温煖": "wēn,xuān",
  "温腝": "wēn,ní",
  "温血": "wēn,xuè",
  "温衾扇枕": "wēn,qīn,shān,zhěn",
  "温适": "wēn,shì",
  "温顺地": "wēn,shùn,de",
  "渭濩": "wèi,hù",
  "港味儿": "gǎng,wèi,er",
  "渴望地": "kě,wàng,de",
  "渴求地": "kě,qiú,de",
  "渴者易为饮": "kě,zhě,yì,wéi,yǐn",
  "游乐地": "yóu,lè,de",
  "游山翫水": "yóu,shān,wàn,shuǐ",
  "游戏地": "yóu,xì,de",
  "游戏手把": "yóu,xì,shǒu,bà",
  "游手好闲": "yóu,shǒu,hào,xián",
  "游泳裤衩": "yóu,yǒng,kù,chǎ",
  "游牧民地": "yóu,mù,mín,de",
  "游说": "yóu,shuì",
  "游说团": "yóu,shuì,tuán",
  "游说团体": "yóu,shuì,tuán,tǐ",
  "游说集团": "yóu,shuì,jí,tuán",
  "游骑无归": "yóu,jì,wú,guī",
  "湖泊": "hú,pō",
  "湫隘": "jiǎo,ài",
  "湮塞": "yān,sè",
  "湮没": "yān,mò",
  "湮没无闻": "yān,mò,wú,wén",
  "湼不缁": "hè,bù,zī",
  "湼而不缁": "hè,ér,bù,zī",
  "湾仔": "wān,zǎi",
  "湿冷地": "shī,lěng,de",
  "湿润地": "shī,rùn,de",
  "湿淋淋地": "shī,lín,lín,de",
  "湿答答": "shī,dā,dā",
  "湿透地": "shī,tòu,de",
  "溃于蚁穴": "kuì,yú,yǐ,xuè",
  "溃堤": "kuì,dī",
  "溃濩": "kuì,hù",
  "溃疡性地": "kuì,yáng,xìng,de",
  "溃脓": "huì,nóng",
  "溃蹶": "kuì,juě",
  "溅溅": "jiān,jiān",
  "溅血": "jiàn,xuè",
  "源源不断地": "yuán,yuán,bù,duàn,de",
  "源源不断地流": "yuán,yuán,bù,duàn,de,liú",
  "溘先朝露": "kè,xiān,zhāo,lù",
  "溜溜转": "liū,liū,zhuàn",
  "溜边儿": "liū,biān,er",
  "溢出效应": "yì,chū,xiào,yìng",
  "溢美溢恶": "yì,měi,yì,wù",
  "溲血": "sōu,xuè",
  "溶没": "róng,mò",
  "溶血": "róng,xuè",
  "溶血病": "róng,xuè,bìng",
  "溺爱地": "nì,ài,de",
  "滇藏": "diān,zàng",
  "滇藏川": "diān,zàng,chuān",
  "滋长": "zī,zhǎng",
  "滑溜溜地": "huá,liū,liū,de",
  "滑稽地": "huá,jī,de",
  "滑行地": "huá,xíng,de",
  "滑顺地": "huá,shùn,de",
  "滔滔不绝地": "tāo,tāo,bù,jué,de",
  "滔滔地": "tāo,tāo,de",
  "滔滔地说": "tāo,tāo,de,shuō",
  "滕薛争长": "téng,xuē,zhēng,zhǎng",
  "滚动地": "gǔn,dòng,de",
  "滚子": "gǔn,zi",
  "滚子轴承": "gǔn,zi,zhóu,chéng",
  "滚烫地": "gǔn,tàng,de",
  "滚犊子": "gǔn,dú,zi",
  "满口应承": "mǎn,kǒu,yìng,chéng",
  "满口答应": "mǎn,kǒu,dā,ying",
  "满口脏话": "mǎn,kǒu,zāng,huà",
  "满嘴跑舌头": "mǎn,zuǐ,pǎo,shé,tou",
  "满处": "mǎn,chǔ",
  "满天星斗": "mǎn,tiān,xīng,dǒu",
  "满帆": "mǎn,fān",
  "满意地": "mǎn,yì,de",
  "满意地离开": "mǎn,yì,de,lí,kāi",
  "满意地笑": "mǎn,yì,de,xiào",
  "满意地笑了": "mǎn,yì,de,xiào,le",
  "满意地说": "mǎn,yì,de,shuō",
  "满溢地": "mǎn,yì,de",
  "满满地": "mǎn,mǎn,de",
  "满腔热枕": "mǎn,qiāng,rè,chén",
  "满负荷": "mǎn,fù,hè",
  "满足地": "mǎn,zú,de",
  "满足地看": "mǎn,zú,de,kàn",
  "滥套子": "làn,tào,zi",
  "滥竽充数": "làn,yú,chōng,shù",
  "滥调": "làn,diào",
  "滴溜儿": "dī,liù,ér",
  "滴溜溜地": "dī,liū,liū,de",
  "滴滴答答": "dī,dī,dā,dā",
  "滴答地响": "dī,dá,de,xiǎng",
  "滴答声": "dī,da,shēng",
  "滴里嘟噜": "dī,lǐ,dū,lu",
  "滴露研朱": "dī,lù,yán,zhū",
  "滴露研珠": "dī,lù,yán,zhū",
  "漂亮": "piào,liàng",
  "漂亮地": "piào,liàng,de",
  "漂亮话": "piào,liàng,huà",
  "漂染": "piǎo,rǎn",
  "漂泊地": "piāo,bó,de",
  "漂洗": "piǎo,xǐ",
  "漂流地": "piāo,liú,de",
  "漂浮地": "piāo,fú,de",
  "漂白": "piǎo,bái",
  "漂白剂": "piǎo,bái,jì",
  "漂白水": "piǎo,bái,shuǐ",
  "漂白粉": "piǎo,bái,fěn",
  "漂绿": "piǎo,lǜ",
  "漂走": "piào,zǒu",
  "漆弹": "qī,dàn",
  "漏子": "lòu,zi",
  "漏尽更阑": "lòu,jìn,gēng,lán",
  "漏斗": "lòu,dǒu",
  "漏斗云": "lòu,dǒu,yún",
  "漏水转浑天仪": "lòu,shuǐ,zhuàn,hún,tiān,yí",
  "漏瓮沃焦釜": "lòu,wēng,wò,jiāo,fǔ",
  "演绎地": "yǎn,yì,de",
  "演绎式地": "yǎn,yì,shì,de",
  "演讲似地": "yǎn,jiǎng,shì,de",
  "漫不经心地": "màn,bù,jīng,xīn,de",
  "漫卷": "màn,juàn",
  "漫地匝地": "màn,de,zā,de",
  "漫应": "màn,yìng",
  "漫无目的": "màn,wú,mù,dì",
  "漫然地": "màn,rán,de",
  "漯河": "tà,hé",
  "潇洒地": "xiāo,sǎ,de",
  "潇洒地穿": "xiāo,sǎ,de,chuān",
  "潇洒地走": "xiāo,sǎ,de,zǒu",
  "潜伏地": "qián,fú,de",
  "潜意识地": "qián,yì,shí,de",
  "潜没": "qián,mò",
  "潜滋暗长": "qián,zī,àn,zhǎng",
  "潜窃阳剽": "qián,qiè,yáng,piāo",
  "潜血": "qián,xuè",
  "潦倒": "liáo,dǎo",
  "潦草": "liáo,cǎo",
  "潦草地": "liáo,cǎo,de",
  "潦草地写": "liáo,cǎo,de,xiě",
  "潮差": "cháo,chā",
  "潮鸣电挚": "cháo,míng,diàn,chè",
  "澄汰": "dèng,tài",
  "澄沙": "dèng,shā",
  "澄沙汰砾": "dèng,shā,tài,lì",
  "澄结": "dèng,jié",
  "澳大利亚首都特区": "ào,dà,lì,yà,shǒu,dū,tè,qū",
  "澹台": "tán,tái",
  "激切": "jī,qiè",
  "激动地": "jī,dòng,de",
  "激动地哭了": "jī,dòng,de,kū,le",
  "激动地说": "jī,dòng,de,shuō",
  "激将": "jī,jiàng",
  "激将法": "jī,jiàng,fǎ",
  "激怒地": "jī,nù,de",
  "激情地": "jī,qíng,de",
  "激昂地": "jī,áng,de",
  "激昂地说": "jī,áng,de,shuō",
  "激昂青云": "ji,ang,qing,yun",
  "激烈地": "jī,liè,de",
  "激薄停浇": "jī,bó,tíng,jiāo",
  "激越地": "jī,yuè,de",
  "激辩地": "jī,biàn,de",
  "激进分子": "jī,jìn,fèn,zǐ",
  "激进武装分子": "jī,jìn,wǔ,zhuāng,fèn,zǐ",
  "瀪漩": "fán,xuán",
  "火儿": "huǒ,er",
  "火冠雀": "huǒ,guān,què",
  "火囤": "huǒ,dùn",
  "火地岛": "huǒ,de,dǎo",
  "火头食子": "huǒ,tóu,sì,zǐ",
  "火夹": "huǒ,jiā",
  "火山似地": "huǒ,shān,shì,de",
  "火山爆发指数": "huǒ,shān,bào,fā,zhǐ,shù",
  "火弹": "huǒ,dàn",
  "火急地": "huǒ,jí,de",
  "火急火燎": "huǒ,jí,huǒ,liǎo",
  "火性子": "huǒ,xìng,zi",
  "火挟": "huǒ,jiā",
  "火数": "huǒ,shù",
  "火星子": "huǒ,xīng,zi",
  "火澣布": "huǒ,hàn,bù",
  "火炬计划": "huǒ,jù,jì,huà",
  "火烧火燎": "huǒ,shāo,huǒ,liǎo",
  "火烧眉毛": "huǒ,shāo,méi,mao",
  "火𬊉": "huǒ,tā",
  "火禁": "huǒ,jìn",
  "火䇲": "huǒ,jiā",
  "火筷子": "huǒ,kuài,zi",
  "火箭弹": "huǒ,jiàn,dàn",
  "火箭推进榴弹": "huǒ,jiàn,tuī,jìn,liú,dàn",
  "火罐儿": "huǒ,guàn,er",
  "火耕水种": "huǒ,gēng,shuǐ,zhòng",
  "火辣辣地": "huǒ,là,là,de",
  "火迫酂侯": "huǒ,pò,zàn,hòu",
  "火钻": "huǒ,zuàn",
  "火铺": "huǒ,pù",
  "火齐": "huǒ,jì",
  "火齐汤": "huǒ,jì,tāng",
  "火齐珠": "huǒ,jì,zhū",
  "火齐粥": "huǒ,jì,zhōu",
  "火齐镜": "huǒ,jì,jìng",
  "灭弗得": "miè,fú,de",
  "灭景": "miè,yǐng",
  "灭景追风": "miè,yǐng,zhuī,fēng",
  "灭此朝食": "miè,cǐ,zhāo,shí",
  "灭没": "miè,mò",
  "灭虫宁": "miè,chóng,nìng",
  "灯匣子": "dēng,xiá,zi",
  "灯晕": "dēng,yùn",
  "灯筩": "dēng,yǒng",
  "灯红酒绿": "dēng,hóng,jiǔ,lù",
  "灰不溜秋": "huī,bu,liū,qiū",
  "灰冠鸦雀": "huī,guān,yā,què",
  "灰冠鹟莺": "huī,guān,wēng,yīng",
  "灰姑娘": "huī,gū,niang",
  "灰孙子": "huī,sūn,zi",
  "灰指甲": "huī,zhǐ,jiá",
  "灰溜溜地": "huī,liū,liū,de",
  "灰溜溜地跑了": "huī,liū,liū,de,pǎo,le",
  "灰灰地": "huī,huī,de",
  "灰獴": "huī,měng",
  "灰背伯劳": "huī,bèi,bó,láo",
  "灰背椋鸟": "huī,bèi,liáng,niǎo",
  "灰背燕尾": "huī,bèi,yàn,wěi",
  "灰背隼": "huī,bèi,sǔn",
  "灰背鸥": "huī,bèi,ōu",
  "灰背鸫": "huī,bèi,dōng",
  "灰蒙蒙": "huī,mēng,méng",
  "灰鹡鸰": "huī,jí,líng",
  "灰黄地": "huī,huáng,de",
  "灰黄色地": "huī,huáng,sè,de",
  "灵刹": "líng,shā",
  "灵场": "líng,cháng",
  "灵巧地": "líng,qiǎo,de",
  "灵巧地做": "líng,qiǎo,de,zuò",
  "灵幢": "líng,zhuàng",
  "灵应": "líng,yìng",
  "灵敏地": "líng,mǐn,de",
  "灵明地": "líng,míng,de",
  "灵朮": "líng,zhú",
  "灵朴": "líng,piáo",
  "灵查": "líng,zhā",
  "灵活地": "líng,huó,de",
  "灵活地转动": "líng,huó,de,zhuàn,dòng",
  "灵祇": "líng,qí",
  "灵长目": "líng,zhǎng,mù",
  "灵长类": "líng,zhǎng,lèi",
  "灵雀寺": "líng,qiǎo,sì",
  "灵露": "líng,lù",
  "灵验地": "líng,yàn,de",
  "灶头": "zào,tou",
  "灶火": "zào,huo",
  "灶火坑": "zào,huō,kēng",
  "灼剥": "zhuó,bāo",
  "灼烜": "zhuó,huǐ",
  "灼𰞻": "zhuó,bèn",
  "灼背烧顶": "zhuó,bèi,shāo,dǐng",
  "灼臂落发": "zhuó,bì,luò,fà",
  "灼钻": "zhuó,zuàn",
  "灾数": "zāi,shù",
  "灾潦": "zāi,liáo",
  "灾煞": "zāi,shà",
  "灾祸地": "zāi,huò,de",
  "灾缪": "zāi,miù",
  "灾难": "zāi,nàn",
  "灾难地": "zāi,nàn,de",
  "灾难性": "zāi,nàn,xìng",
  "灾难片": "zāi,nàn,piàn",
  "灿烂地": "càn,làn,de",
  "炉子": "lú,zi",
  "炉箅子": "lú,bì,zi",
  "炊帚": "chuī,zhou",
  "炊累": "chuī,lèi",
  "炎性反应": "yán,xìng,fǎn,yìng",
  "炒更": "chǎo,gēng",
  "炒肝儿": "chǎo,gān,er",
  "炘炘": "xīn,xīn",
  "炘然": "xīn,rán",
  "炙毂": "zhì,gū",
  "炙毂过": "zhì,gū,guò",
  "炙背": "zhì,bèi",
  "炤亮": "zhāo,liàng",
  "炤依": "zhāo,yī",
  "炤壁": "zhāo,bì",
  "炤察": "zhāo,chá",
  "炤明": "zhāo,míng",
  "炤映": "zhāo,yìng",
  "炤晰": "zhāo,xī",
  "炤灼": "zhāo,zhuó",
  "炤炤": "zhāo,zhāo",
  "炤烁": "zhāo,shuò",
  "炤烂": "zhāo,làn",
  "炤燎": "zhāo,liáo",
  "炤管": "zhāo,guǎn",
  "炤耀": "zhāo,yào",
  "炤𰴞": "zhāo,qù",
  "炤顾": "zhāo,gù",
  "炤龟": "zhāo,guī",
  "炫丽地": "xuàn,lì,de",
  "炫晃": "xuàn,huàng",
  "炫玉贾石": "xuàn,yù,gǔ,shí",
  "炫石为玉": "xuàn,shí,wéi,yù",
  "炫耀地": "xuàn,yào,de",
  "炫露": "xuàn,lù",
  "炭疽杆菌": "tàn,jū,gǎn,jūn",
  "炮儿局": "pào,er,jú",
  "炮凤烹龙": "páo,fèng,pēng,lóng",
  "炮制": "páo,zhì",
  "炮子儿": "pào,zǐ,er",
  "炮弹": "pào,dàn",
  "炮格": "páo,gé",
  "炮炙": "páo,zhì",
  "炮炼": "páo,liàn",
  "炮烙": "páo,luò",
  "炮熬": "pào,áo",
  "炮长": "pào,zhǎng",
  "炯晃": "jiǒng,huàng",
  "炰哮": "páo,xiāo",
  "炳着": "bǐng,zhe",
  "炳贲": "bǐng,bēn",
  "炳露": "bǐng,lù",
  "炸两": "zhá,liǎng",
  "炸丸": "zhá,wán",
  "炸丸子": "zhá,wán,zǐ",
  "炸元宵": "zhá,yuán,xiāo",
  "炸土豆条": "zhá,tǔ,dòu,tiáo",
  "炸土豆条儿": "zhá,tǔ,dòu,tiáo,er",
  "炸土豆片": "zhá,tǔ,dòu,piàn",
  "炸子": "zhá,zǐ",
  "炸子鸡": "zhá,zǐ,jī",
  "炸弹": "zhà,dàn",
  "炸弹之母": "zhà,dàn,zhī,mǔ",
  "炸弹之父": "zhà,dàn,zhī,fù",
  "炸弹坑": "zhà,dàn,kēng",
  "炸油条": "zhá,yóu,tiáo",
  "炸油饼": "zhá,yóu,bǐng",
  "炸烹大虾": "zhá,pēng,dà,xiā",
  "炸糕": "zhá,gāo",
  "炸肉丸子": "zhá,ròu,wán,zi",
  "炸薯条": "zhá,shǔ,tiáo",
  "炸薯片": "zhá,shǔ,piàn",
  "炸虾": "zhá,xiā",
  "炸裂弹": "zhà,liè,dàn",
  "炸酱": "zhá,jiàng",
  "炸酱面": "zhá,jiàng,miàn",
  "炸馏": "zhà,liú",
  "炸鱼": "zhá,yú",
  "炸鸡": "zhá,jī",
  "炸鸡蛋": "zhá,jī,dàn",
  "点一点二": "diǎn,yì,diǎn,èr",
  "点儿": "diǎn,er",
  "点儿背": "diǎn,er,bèi",
  "点击数": "diǎn,jī,shù",
  "点子": "diǎn,zi",
  "点子背": "diǎn,zi,bèi",
  "点将": "diǎn,jiàng",
  "点将录": "diǎn,jiàng,lù",
  "点心": "diǎn,xin",
  "点心瓤子": "diǎn,xīn,ráng,zi",
  "点手划脚": "diǎn,shǒu,huà,jiǎo",
  "点手莋脚": "diǎn,shǒu,huá,jiǎo",
  "点指划脚": "diǎn,zhǐ,huà,jiǎo",
  "点指莋脚": "diǎn,zhǐ,cè,jiǎo",
  "点数": "diǎn,shù",
  "点校": "diǎn,jiào",
  "点涴": "diǎn,wò",
  "点电荷": "diǎn,diàn,hè",
  "点着": "diǎn,zháo",
  "点石为金": "diǎn,shí,wéi,jīn",
  "点种": "diǎn,zhòng",
  "点累": "diǎn,lèi",
  "点背": "diǎn,bèi",
  "炽燃地": "chì,rán,de",
  "烂仔": "làn,zǎi",
  "烂摊子": "làn,tān,zi",
  "烂椹": "làn,shèn",
  "烂橘子": "làn,jú,zi",
  "烈性子": "liè,xìng,zi",
  "烈钻": "liè,zuàn",
  "烘云讬月": "hōng,yún,zhì,yuè",
  "烘笼儿": "hōng,lóng,er",
  "烛炤": "zhú,zhāo",
  "烛照数计": "zhú,zhào,shù,jì",
  "烜卓": "huǐ,zhuó",
  "烜奕": "huǐ,yì",
  "烜日": "huǐ,rì",
  "烜洲": "huǐ,zhōu",
  "烜烈": "huǐ,liè",
  "烜然": "huǐ,rán",
  "烜爚": "huǐ,yuè",
  "烜耀": "huǐ,yào",
  "烝熬": "zhēng,áo",
  "烟卷": "yān,juàn",
  "烟嘴儿": "yān,zuǐ,er",
  "烟头儿": "yān,tóu,er",
  "烟屁股": "yān,pì,gu",
  "烟帆": "yān,fān",
  "烟幕弹": "yān,mù,dàn",
  "烟斗": "yān,dǒu",
  "烟月作坊": "yān,yuè,zuō,fang",
  "烟杆": "yān,gǎn",
  "烟条露叶": "yān,tiáo,lù,yè",
  "烟槛": "yān,kǎn",
  "烟波兴": "yān,bō,xīng",
  "烟熏火燎": "yān,xūn,huǒ,liǎo",
  "烟燎火气": "yān,liǎo,huǒ,qì",
  "烟盒子": "yān,hé,zi",
  "烟禁": "yān,jìn",
  "烟筒": "yān,tóng",
  "烟筩": "yān,yǒng",
  "烟舍": "yān,shè",
  "烟袋杆儿": "yān,dài,gǎn,ér",
  "烟铺": "yān,pù",
  "烟雾弹": "yān,wù,dàn",
  "烟霞痼疾": "yān,xiá,gù,jì",
  "烟霞色相": "yān,xiá,sè,xiàng",
  "烟露": "yān,lù",
  "烦乱地": "fán,luàn,de",
  "烦兴": "fán,xīng",
  "烦天恼地": "fán,tiān,nǎo,de",
  "烦恼地": "fán,nǎo,de",
  "烦挐": "fán,ná",
  "烦数": "fán,shù",
  "烦累": "fán,lèi",
  "烦缪": "fán,miù",
  "烦言碎辞": "fán,yán,suì,yǔ",
  "烦躁地": "fán,zào,de",
  "烦闷地": "fán,mèn,de",
  "烧刀子": "shāo,dāo,zi",
  "烧夷弹": "shāo,yí,dàn",
  "烧烤地": "shāo,kǎo,de",
  "烧糊了卷子": "shāo,hú,le,juǎn,zi",
  "烧𰞻": "shāo,bèn",
  "烧茄子": "shāo,qié,zi",
  "烧锅子": "shāo,guō,zi",
  "烧饼": "shāo,bing",
  "烫发": "tàng,fà",
  "烫头发": "tàng,tóu,fa",
  "烫斗": "tàng,dǒu",
  "热丧": "rè,sāng",
  "热乎": "rè,hu",
  "热切": "rè,qiè",
  "热切地": "rè,qiè,de",
  "热力学第一定律": "rè,lì,xué,dì,yí,dìng,lǜ",
  "热呼": "rè,hu",
  "热和": "rè,huo",
  "热哄哄": "rè,hǒng,hǒng",
  "热地上蚰蜒": "rè,dì,shàng,yóu,dàn",
  "热地蚰蜒": "rè,dì,yóu,dàn",
  "热地里的蚰蜒": "rè,dì,lǐ,de,yóu,dàn",
  "热处理": "rè,chǔ,lǐ",
  "热岛效应": "rè,dǎo,xiào,yìng",
  "热得快": "rè,de,kuài",
  "热心地": "rè,xīn,de",
  "热忱地": "rè,chén,de",
  "热情地": "rè,qíng,de",
  "热情地向": "rè,qíng,de,xiàng",
  "热情地提出": "rè,qíng,de,tí,chū",
  "热情地握手": "rè,qíng,de,wò,shǒu",
  "热效应": "rè,xiào,yìng",
  "热望地": "rè,wàng,de",
  "热核反应": "rè,hé,fǎn,yìng",
  "热核反应堆": "rè,hé,fǎn,yìng,duī",
  "热核炸弹": "rè,hé,zhà,dàn",
  "热核聚变反应": "rè,hé,jù,biàn,fǎn,yìng",
  "热汤汤": "rè,shāng,shāng",
  "热液地": "rè,yè,de",
  "热烈地": "rè,liè,de",
  "热烈地吻": "rè,liè,de,wěn",
  "热熬翻饼": "rè,áo,fān,bǐng",
  "热狂地": "rè,kuáng,de",
  "热着": "rè,zhe",
  "热脚儿": "rè,jué,ér",
  "热脸贴冷屁股": "rè,liǎn,tiē,lěng,pì,gu",
  "热血": "rè,xuè",
  "热血动物": "rè,xuè,dòng,wù",
  "热血日报": "rè,xuè,rì,bào",
  "热血沸腾": "rè,xuè,fèi,téng",
  "热诚地": "rè,chéng,de",
  "热谩": "rè,màn",
  "热轧": "rè,zhá",
  "热闹": "rè,nao",
  "热麻麻": "rè,mā,ma",
  "烹熬": "pēng,áo",
  "烹𮝹": "pēng,huán",
  "烹龙炮凤": "pēng,lóng,páo,fèng",
  "烽堡": "fēng,pù",
  "烽火连年": "fēng,huò,lián,nián",
  "烽炉子": "fēng,lú,zi",
  "焄羶": "hūn,shān",
  "焄膻": "hūn,shān",
  "焉耆一龟兹语": "yān,qí,yī,qiū,cí,yǔ",
  "焊栅": "hàn,shān",
  "焊缝": "hàn,fèng",
  "焌律": "jùn,lǜ",
  "焌灯": "jùn,dēng",
  "焌糟": "jùn,zāo",
  "焌黑": "jùn,hēi",
  "焕然一新": "huàn,rán,yì,xīn",
  "焘养": "tāo,yǎng",
  "焘冒": "tāo,mào",
  "焘奡": "tāo,ào",
  "焘育": "tāo,yù",
  "焘覆": "tāo,fù",
  "焘载": "tāo,zǎi",
  "焚削": "fén,xuē",
  "焚剽": "fén,piāo",
  "焚掠": "fén,lüě",
  "焚煞": "fén,shà",
  "焚香礼拜": "fén,xiān,lǐ,bài",
  "焜晃": "kūn,huàng",
  "焢肉": "kòng,ròu",
  "焦侥": "jiāo,yáo",
  "焦卷": "jiāo,juàn",
  "焦急地": "jiāo,jí,de",
  "焦点地": "jiāo,diǎn,de",
  "焦熬": "jiāo,áo",
  "焦熬投石": "jiāo,áo,tóu,shí",
  "焦虑地": "jiāo,lǜ,de",
  "焦躁地": "jiāo,zào,de",
  "焯烁": "chāo,shuò",
  "焯焯": "chāo,chāo",
  "焯然": "chāo,rán",
  "焯着": "chāo,zhe",
  "焯耀": "chāo,yào",
  "焯辉": "chāo,huī",
  "然后偷偷地": "rán,hòu,tōu,tōu,de",
  "煎炸": "jiān,zhá",
  "煎炸油": "jiān,zhá,yóu",
  "煎炸食品": "jiān,zhá,shí,pǐn",
  "煎熬": "jiān,áo",
  "煎调": "jiān,diào",
  "煔灼": "qián,zhuó",
  "煔煔": "qián,qián",
  "煞不如": "shà,bù,rú",
  "煞到": "shà,dào",
  "煞台": "shà,tái",
  "煞后": "shà,hòu",
  "煞回": "shà,huí",
  "煞场": "shà,chǎng",
  "煞实": "shà,shí",
  "煞帐": "shà,zhàng",
  "煞年": "shà,nián",
  "煞强似": "shà,qiáng,sì",
  "煞强如": "shà,qiáng,rú",
  "煞性": "shà,xìng",
  "煞性子": "shā,xìng,zi",
  "煞手锏": "shà,shǒu,jiǎn",
  "煞拍": "shà,pāi",
  "煞时间": "shà,shí,jiān",
  "煞星": "shà,xīng",
  "煞是": "shà,shì",
  "煞有": "shà,yǒu",
  "煞有介事": "shà,yǒu,jiè,shì",
  "煞有其事": "shà,yǒu,qí,shì",
  "煞果": "shà,guǒ",
  "煞气": "shà,qì",
  "煞水": "shà,shuǐ",
  "煞火": "shà,huǒ",
  "煞痒": "shà,yǎng",
  "煞癞": "shà,lài",
  "煞白": "shà,bái",
  "煞神": "shà,shén",
  "煞绳": "shà,shéng",
  "煞耗": "shà,hào",
  "煞落": "shà,luò",
  "煞认": "shà,rèn",
  "煞费心机": "shà,fèi,xīn,jī",
  "煞费苦心": "shà,fèi,kǔ,xīn",
  "煞风景地": "shā,fēng,jǐng,de",
  "煞鬼": "shà,guǐ",
  "煞黑": "shà,hēi",
  "煟兴": "wèi,xīng",
  "煤核": "méi,hú",
  "煤核儿": "méi,hú,ér",
  "煤气中毒": "méi,qì,zhòng,dú",
  "煤炭中毒": "méi,tàn,zhòng,dú",
  "煤熏": "méi,xùn",
  "煦姁": "xù,xū",
  "照例地": "zhào,lì,de",
  "照字义地": "zhào,zì,yì,de",
  "照字面地": "zhào,zì,miàn,de",
  "照宗规地": "zhào,zōng,guī,de",
  "照应": "zhào,yìng",
  "照惯例地": "zhào,guàn,lì,de",
  "照拍子地": "zhào,pāi,zi,de",
  "照数": "zhào,shù",
  "照明弹": "zhào,míng,dàn",
  "照样地": "zhào,yàng,de",
  "照片": "zhào,piān",
  "照片子": "zhào,piàn,zi",
  "照相": "zhào,xiàng",
  "照相侦察卫星": "zhào,xiàng,zhēn,chá,wèi,xīng",
  "照相弹": "zhào,xiàng,dàn",
  "照相排版": "zhào,xiàng,pái,bǎn",
  "照相机": "zhào,xiàng,jī",
  "照相枪": "zhào,xiàng,qiāng",
  "照相版": "zhào,xiàng,bǎn",
  "照相簿": "zhào,xiàng,bù",
  "照相纸": "zhào,xiàng,zhǐ",
  "照相馆": "zhào,xiàng,guǎn",
  "照着": "zhào,zhe",
  "照耀地": "zhào,yào,de",
  "照葫芦画瓢": "zhào,hú,lu,huà,piáo",
  "照面儿": "zhào,miàn,er",
  "照顾": "zhào,gu",
  "煮熟": "zhǔ,shóu",
  "煮熟的鸭子飞了": "zhǔ,shú,de,yā,zi,fēi,le",
  "煮豆燃箕": "zhǔ,dòu,rán,qí",
  "熊亲戚": "xióng,qīn,qi",
  "熊侯": "xióng,hòu",
  "熊孩子": "xióng,hái,zi",
  "熊爪子": "xióng,zhuǎ,zi",
  "熊猫血": "xióng,māo,xuè",
  "熊瞎子": "xióng,xiā,zi",
  "熊背": "xióng,bèi",
  "熊腰虎背": "xióng,yāo,hǔ,bèi",
  "熊虎将": "xióng,hǔ,jiàng",
  "熊虺": "xióng,huī",
  "熏倒": "xùn,dǎo",
  "熏着": "xùn,zháo",
  "熏蚊子": "xūn,wén,zi",
  "熏血": "xūn,xuè",
  "熏𰺛": "xūn,láo",
  "熏透": "xùn,tòu",
  "熐蠡": "mì,lí",
  "熙载": "xī,zǎi",
  "𤇹𤇹剥剥": "bì,bì,bāo,bāo",
  "熟切担子": "shú,qiē,dàn,zi",
  "熟思审处": "shú,sī,shěn,chǔ",
  "熟悉地": "shú,xī,de",
  "熟睡地": "shú,shuì,de",
  "熟练地": "shú,liàn,de",
  "熟练地使用": "shú,liàn,de,shǐ,yòng",
  "熟练地进入": "shú,liàn,de,jìn,rù",
  "熟背": "shú,bèi",
  "熟虑地": "shú,lǜ,de",
  "熟道儿": "shú,dào,er",
  "熢燧": "fēng,suì",
  "熨帖": "yù,tiē",
  "熨斗": "yùn,dǒu",
  "熨斗焦": "yùn,dǒu,jiāo",
  "熨贴": "yù,tiē",
  "熬不住": "áo,bú,zhù",
  "熬不过": "áo,bù,guò",
  "熬出头": "áo,chū,tóu",
  "熬刑": "áo,xíng",
  "熬困": "áo,kùn",
  "熬夜": "áo,yè",
  "熬头儿": "áo,tou,er",
  "熬姜呷醋": "áo,jiāng,xiā,cù",
  "熬审": "áo,shěn",
  "熬心": "áo,xīn",
  "熬心费力": "áo,xīn,fèi,lì",
  "熬愁": "áo,chóu",
  "熬日头": "áo,rì,tou",
  "熬更守夜": "áo,gēng,shǒu,yè",
  "熬月子": "áo,yuè,zǐ",
  "熬枯受淡": "áo,kū,shòu,dàn",
  "熬汤": "áo,tāng",
  "熬油": "áo,yóu",
  "熬油费火": "áo,yóu,fèi,huǒ",
  "熬波": "áo,bō",
  "熬活": "áo,huó",
  "熬清受淡": "áo,qīng,shòu,dàn",
  "熬清守淡": "áo,qīng,shǒu,dàn",
  "熬清守谈": "áo,qīng,shǒu,tán",
  "熬炙": "áo,zhì",
  "熬炼": "áo,liàn",
  "熬然": "áo,rán",
  "熬煎": "áo,jiān",
  "熬煮": "áo,zhǔ",
  "熬熬": "áo,áo",
  "熬熬汲汲": "áo,áo,jí,jí",
  "熬熬煎煎": "áo,áo,jiān,jiān",
  "熬盐": "áo,yán",
  "熬眼": "áo,yǎn",
  "熬磨": "áo,mó",
  "熬累": "áo,lèi",
  "熬肉": "áo,ròu",
  "熬肠刮肚": "áo,cháng,guā,dù",
  "熬膏": "áo,gāo",
  "熬茶": "áo,chá",
  "熬药": "áo,yào",
  "熬谷": "áo,gǔ",
  "熬锅": "áo,guō",
  "燂洗": "qián,xǐ",
  "燂烁": "qián,shuò",
  "燃烧弹": "rán,shāo,dàn",
  "燃烧炸弹": "rán,shāo,zhà,dàn",
  "燃烧般地": "rán,shāo,bān,de",
  "燋卷": "jiāo,juàn",
  "燋折": "jiāo,shé",
  "燋熬": "jiāo,áo",
  "燎发摧枯": "liǎo,fà,cuī,kū",
  "燎如观火": "liǎo,rú,guān,huǒ",
  "燎彻": "liǎo,chè",
  "燎火": "liǎo,huǒ",
  "燎燔": "liào,fán",
  "燎猎": "liào,liè",
  "燎眉": "liǎo,méi",
  "燎祭": "liào,jì",
  "燎草儿": "liǎo,cǎo,ér",
  "燎荒": "liǎo,huāng",
  "燎野": "liǎo,yě",
  "燕京": "yān,jīng",
  "燕京啤酒": "yān,jīng,pí,jiǔ",
  "燕京大学": "yān,jīng,dà,xué",
  "燕国": "yān,guó",
  "燕处": "yàn,chǔ",
  "燕处危巢": "yàn,chǔ,wēi,cháo",
  "燕处焚巢": "yàn,chǔ,fén,cháo",
  "燕太子丹": "yān,tài,zǐ,dān",
  "燕媠": "yàn,duò",
  "燕子": "yàn,zi",
  "燕子楼": "yàn,zi,lóu",
  "燕子矶": "yàn,zi,jī",
  "燕子窠": "yàn,zi,kē",
  "燕子衔泥垒大窝": "yàn,zi,xián,ní,lěi,dà,wō",
  "燕尾蝶": "yān,wěi,dié",
  "燕山": "yān,shān",
  "燕山石": "yān,shān,shí",
  "燕山铭": "yān,shān,míng",
  "燕山颂": "yān,shān,sòng",
  "燕岱之石": "yān,dài,zhī,shí",
  "燕市": "yān,shì",
  "燕市悲歌": "yān,shì,bēi,gē",
  "燕昭": "yān,zhāo",
  "燕昭台": "yān,zhāo,tái",
  "燕昭好马": "yān,zhāo,hǎo,mǎ",
  "燕昭市骏": "yān,zhāo,shì,jùn",
  "燕昭馆": "yān,zhāo,guǎn",
  "燕歌": "yān,gē",
  "燕歌行": "yān,gē,xíng",
  "燕歌赵舞": "yān,gē,zhào,wǔ",
  "燕王台": "yān,wáng,tái",
  "燕石": "yān,shí",
  "燕石妄珍": "yān,shí,wàng,zhēn",
  "燕脂": "yān,zhī",
  "燕说": "yàn,yuè",
  "燕赵": "yān,zhào",
  "燕赵人": "yān,zhào,rén",
  "燕赵女": "yān,zhào,nǚ",
  "燕赵姝": "yān,zhào,shū",
  "燕赵都市报": "yān,zhào,dū,shì,bào",
  "燕赵风": "yān,zhào,fēng",
  "燕适": "yàn,shì",
  "燕金": "yān,jīn",
  "燕金募秀": "yān,jīn,mù,xiù",
  "燕雀处堂": "yàn,què,chǔ,táng",
  "燕雀处屋": "yàn,què,chǔ,wū",
  "燕雀焉知鸿鹄之志": "yàn,què,yān,zhī,hóng,gǔ,zhī,zhì",
  "燕驾越毂": "yān,jià,yuè,gū",
  "燕骏千金": "yān,jùn,qiān,jīn",
  "燕麦": "yān,mài",
  "燕麦地组": "yān,mài,de,zǔ",
  "燕麦粥": "yān,mài,zhōu",
  "𬊈剥": "xún,bāo",
  "燥子": "sào,zǐ",
  "燧堡": "suì,pù",
  "燮调": "xiè,diào",
  "爆仗": "bào,zhang",
  "爆冷门儿": "bào,lěng,mén,er",
  "爆发地": "bào,fā,de",
  "爆弹": "bào,dàn",
  "爆栗子": "bào,lì,zi",
  "爆炸地": "bào,zhà,de",
  "爆破炸弹": "bào,pò,zhà,dàn",
  "爆肚": "bào,dǔ",
  "爆肚儿": "bào,dǔ,er",
  "爆裂弹": "bào,liè,dàn",
  "爆趠": "bào,chào",
  "𤆓晃": "kuàng,huàng",
  "𤆓肉": "kòng,ròu",
  "𬊵阆": "tǎng,láng",
  "爪儿": "zhuǎ,ér",
  "爪子": "zhuǎ,zǐ",
  "爪尖儿": "zhuǎ,jiān,er",
  "爪机": "zhuǎ,jī",
  "爪蟾": "zhuǎ,chán",
  "爬格子": "pá,gé,zi",
  "爱丽舍宫": "ài,lì,shè,gōng",
  "爱乐": "ài,yuè",
  "爱乐乐团": "ài,yuè,yuè,tuán",
  "爱人": "ài,ren",
  "爱人好士": "ài,rén,hào,shì",
  "爱他地": "ài,tā,de",
  "爱冒险地": "ài,mào,xiǎn,de",
  "爱国地": "ài,guó,de",
  "爱好": "ài,hào",
  "爱好者": "ài,hào,zhě",
  "爱将": "ài,jiàng",
  "爱幻想地": "ài,huàn,xiǎng,de",
  "爱得死去活来": "ài,de,sǐ,qù,huó,lái",
  "爱怜地": "ài,lián,de",
  "爱情征服一切": "ài,qíng,zhēng,fú,yī,qiè",
  "爱才好士": "ài,cái,hào,shì",
  "爱扯谎地": "ài,chě,huǎng,de",
  "爱抚地": "ài,fǔ,de",
  "爱梦想地": "ài,mèng,xiǎng,de",
  "爱游玩地": "ài,yóu,wán,de",
  "爱漂亮": "ài,piào,liang",
  "爱爱": "ài,ai",
  "爱生恶死": "ài,shēng,wù,sǐ",
  "爱生气地": "ài,shēng,qì,de",
  "爱着": "ài,zhe",
  "爱睡地": "ài,shuì,de",
  "爱空想地": "ài,kōng,xiǎng,de",
  "爱窝窝": "ài,wō,wo",
  "爱素好古": "ài,sù,hào,gǔ",
  "爱翫": "ài,wàn",
  "爱说话地": "ài,shuō,huà,de",
  "爱谁谁": "ài,shéi,shéi",
  "爱远恶近": "ài,yuǎn,wù,jìn",
  "爱面子": "ài,miàn,zi",
  "爵士乐": "jué,shì,yuè",
  "爵士地": "jué,shì,de",
  "爵士音乐": "jué,shì,yīn,yuè",
  "父丧": "fù,sāng",
  "父为子隐": "fù,wéi,zǐ,yǐn",
  "父债子还": "fù,zhài,zǐ,huán",
  "爷们": "yé,men",
  "爷们儿": "yé,men,er",
  "爷俩": "yé,liǎ",
  "爷儿们": "yé,ér,men",
  "爷儿俩": "yé,ér,liǎ",
  "爷孃": "yé,ráng",
  "爷爷": "yé,ye",
  "爸比": "bǎ,bí",
  "爸爸": "bà,ba",
  "爹爹": "diē,die",
  "爽口地": "shuǎng,kǒu,de",
  "爽忒": "shuǎng,tuī",
  "爽快": "shuǎng,kuai",
  "爽快地": "shuǎng,kuài,de",
  "爽快地答应": "shuǎng,kuài,de,dā,yìng",
  "爽快地说": "shuǎng,kuài,de,shuō",
  "爽朗地": "shuǎng,lǎng,de",
  "爽朗地笑声": "shuǎng,lǎng,de,xiào,shēng",
  "爽爽地": "shuǎng,shuǎng,de",
  "爽直地": "shuǎng,zhí,de",
  "爽缪": "shuǎng,miù",
  "爽适": "shuǎng,shì",
  "片儿": "piān,er",
  "片儿会": "piān,er,huì",
  "片儿汤": "piān,er,tāng",
  "片儿警": "piàn,er,jǐng",
  "片分类地": "piàn,fēn,lèi,de",
  "片刻地": "piàn,kè,de",
  "片名": "piān,míng",
  "片头": "piān,tóu",
  "片子": "piān,zi",
  "片子地": "piān,zi,de",
  "片帆": "piàn,fān",
  "片文只事": "piàn,wén,zhī,shì",
  "片甲不还": "piàn,jiǎ,bù,huán",
  "片纸只字": "piàn,zhǐ,zhī,zì",
  "片言只字": "piàn,yán,zhī,zì",
  "片言只语": "piàn,yán,zhī,yǔ",
  "片词只句": "piàn,cí,zhī,jù",
  "片长薄技": "piàn,cháng,bó,jì",
  "片面地": "piàn,miàn,de",
  "片面地看": "piàn,miàn,de,kàn",
  "片鳞只甲": "piàn,lín,zhī,jiǎ",
  "牌儿": "pái,er",
  "牌子": "pái,zi",
  "牌子曲": "pái,zi,qǔ",
  "牌楼": "pái,lou",
  "牍背": "dú,bèi",
  "牓帖": "bǎng,tiē",
  "牙冠": "yá,guān",
  "牙子": "yá,zi",
  "牙帖": "yá,tiē",
  "牙幢": "yá,zhuàng",
  "牙得": "yá,de",
  "牙欸": "yá,ǎi",
  "牙綮": "yá,qǐ",
  "牙缝": "yá,fèng",
  "牙缝儿": "yá,fèng,er",
  "牙行": "yá,háng",
  "牛不喝水强按头": "niú,bù,hē,shuǐ,qiǎng,àn,tóu",
  "牛仔": "niú,zǎi",
  "牛仔布": "niú,zǎi,bù",
  "牛仔服": "niú,zǎi,fú",
  "牛仔裤": "niú,zǎi,kù",
  "牛只": "niú,zhī",
  "牛囤": "niú,dùn",
  "牛头㹴": "niú,tóu,gěng",
  "牛头刨": "niú,tóu,bào",
  "牛头刨床": "niú,tóu,bào,chuáng",
  "牛头阿旁": "niú,tóu,ē,páng",
  "牛奶杮": "niú,nǎi,bèi",
  "牛性子": "niú,xìng,zi",
  "牛折齿": "niú,shé,chǐ",
  "牛气": "niú,qi",
  "牛犊子": "niú,dú,zi",
  "牛肚": "niú,dǔ",
  "牛肝菌": "niú,gān,jùn",
  "牛背笛": "niú,bèi,dí",
  "牛背鹭": "niú,bèi,lù",
  "牛脖子": "niú,bó,zi",
  "牛脾气": "niú,pí,qi",
  "牛蒡子": "niú,bàng,zi",
  "牛鞅": "niú,yàng",
  "牛首阿旁": "niú,shǒu,ē,páng",
  "牛马襟裾": "niú,mǎ,jīn,jú",
  "牛鬼少年": "niú,guǐ,shào,nián",
  "牛鼻子": "niú,bí,zi",
  "牟光": "mù,guāng",
  "牟呼婆羯洛婆": "mù,hū,pó,jié,luò,pó",
  "牟呼栗多": "mù,hū,lì,duō",
  "牟婆洛揭拉婆": "mù,pó,luò,jiē,lā,pó",
  "牟尼": "mù,ní",
  "牟尼子": "mù,ní,zǐ",
  "牟尼教": "mù,ní,jiào",
  "牟尼珠": "mù,ní,zhū",
  "牟平": "mù,píng",
  "牟平区": "mù,píng,qū",
  "牟撷": "mù,xié",
  "牟槊": "mù,shuò",
  "牟比乌斯带": "mù,bǐ,wū,sī,dài",
  "牟牟": "mù,mù",
  "牟甲": "mù,jiǎ",
  "牟盛": "mù,shèng",
  "牟知": "mù,zhī",
  "牟衫": "mù,shān",
  "牟贼": "mù,zéi",
  "牟追": "mù,zhuī",
  "牟食": "mù,shí",
  "牟麦": "mù,mài",
  "牡丹": "mǔ,dan",
  "牡丹乡": "mǔ,dan,xiāng",
  "牡丹亭": "mǔ,dan,tíng",
  "牡丹区": "mǔ,dan,qū",
  "牡丹卡": "mǔ,dan,kǎ",
  "牡丹坊": "mǔ,dan,fāng",
  "牡丹江": "mǔ,dan,jiāng",
  "牡丹江地区": "mǔ,dan,jiāng,dì,qū",
  "牡丹江市": "mǔ,dan,jiāng,shì",
  "牡丹皮": "mǔ,dan,pí",
  "牡牛": "mù,niú",
  "牢什古子": "láo,shí,gǔ,zi",
  "牢什子": "láo,shí,zi",
  "牢固地": "láo,gù,de",
  "牢实": "láo,shi",
  "牢槛": "láo,kǎn",
  "牢牢地": "láo,láo,de",
  "牢牢地抓住": "láo,láo,de,zhuā,zhù",
  "牢牢地粘住": "láo,láo,de,zhān,zhù",
  "牢牢地记住": "láo,láo,de,jì,zhù",
  "牢犴": "láo,àn",
  "牢䇲": "láo,jiā",
  "牢靠妥当": "láo,kào,tuǒ,dàng",
  "牧歌地": "mù,gē,de",
  "牧歌般地": "mù,gē,bān,de",
  "物什": "wù,shí",
  "物以希为贵": "wù,yǐ,xī,wéi,guì",
  "物以稀为贵": "wù,yǐ,xī,wéi,guì",
  "物价指数": "wù,jià,zhǐ,shù",
  "物学地": "wù,xué,de",
  "物稀为贵": "wù,xī,wéi,guì",
  "物累": "wù,lèi",
  "物资供应": "wù,zī,gōng,yìng",
  "牲口": "shēng,kou",
  "牵一发而动全身": "qiān,yī,fà,ér,dòng,quán,shēn",
  "牵强": "qiān,qiǎng",
  "牵徬": "qiān,bàng",
  "牵着鼻子走": "qiān,zhe,bí,zi,zǒu",
  "牵累": "qiān,lěi",
  "牵羊担酒": "qiān,yáng,dàn,jiǔ",
  "特兀": "tè,wū",
  "特别任务连": "tè,bié,rèn,wu,lián",
  "特别地": "tè,bié,de",
  "特别地冻": "tè,bié,de,dòng",
  "特别地忙": "tè,bié,de,máng",
  "特别地敏感": "tè,bié,de,mǐn,gǎn",
  "特别地累": "tè,bié,de,lèi",
  "特别地酷": "tè,bié,de,kù",
  "特务": "tè,wu",
  "特𠡠": "tè,lài",
  "特定地": "tè,deng,de",
  "特尔地木": "tè,ěr,de,mù",
  "特征地": "tè,zhēng,de",
  "特得": "tè,de",
  "特徵": "tè,zhǐ",
  "特性地": "tè,xìng,de",
  "特意地": "tè,yì,de",
  "特意地看": "tè,yì,de,kàn",
  "特殊函数": "tè,shū,hán,shù",
  "特殊地": "tè,shū,de",
  "特殊气候地": "tè,shū,qì,hòu,de",
  "特煞": "tè,shà",
  "特特为为": "tè,tè,wèi,wéi",
  "特色地": "tè,sè,de",
  "特雷莎": "tè,léi,shā",
  "牺牲地": "xī,shēng,de",
  "牻牛儿苗科": "máng,niú,er,miáo,kē",
  "𰠲翟": "kēng,zhái",
  "犀仆": "xī,pú",
  "犀利地": "xī,lì,de",
  "犀帖": "xī,tiē",
  "犀楯": "xī,dùn",
  "犆县": "tè,xiàn",
  "犆牲": "tè,shēng",
  "犊子": "dú,zi",
  "犍为": "qián,wéi",
  "犍为县": "qián,wèi,xiàn",
  "犟劲儿": "jiàng,jìn,er",
  "𰠹牛": "bái,niú",
  "犦槊": "bó,shuò",
  "犦牛": "bó,niú",
  "犦牲": "bó,shēng",
  "犦矟": "bó,shuò",
  "犬夜叉": "quǎn,yè,chà",
  "犬铺": "quǎn,pù",
  "犯不着": "fàn,bù,zháo",
  "犯了罪地": "fàn,le,zuì,de",
  "犯嘀咕": "fàn,dí,gu",
  "犯土禁": "fàn,tǔ,jìn",
  "犯干": "fàn,gàn",
  "犯得上": "fàn,děi,shàng",
  "犯得着": "fàn,de,zháo",
  "犯曲": "fàn,qū",
  "犯滥铺摸": "fàn,làn,pù,mō",
  "犯牛脖子": "fàn,niú,bó,zi",
  "犯禁": "fàn,jìn",
  "犯罪目的": "fàn,zuì,mù,dì",
  "犯罪行为": "fàn,zuì,xíng,wéi",
  "犯而不校": "fàn,ér,bù,jiào",
  "犯言直谏": "fàn,yán,zhǐ,jiǎn",
  "犯调": "fàn,diào",
  "犯雾露": "fàn,wù,lù",
  "犯霜露": "fàn,shuāng,lù",
  "犴噬": "àn,shì",
  "犴圄": "àn,yǔ",
  "犴庭": "àn,tíng",
  "犴户": "àn,hù",
  "犴狱": "àn,yù",
  "犴狴": "àn,bì",
  "犴讼": "àn,sòng",
  "状铺": "zhuàng,pù",
  "犷骜": "guǎng,ào",
  "犹兀自": "yóu,wū,zì",
  "犹未为晚": "yóu,wèi,wéi,wǎn",
  "犹解倒悬": "yóu,jiě,dào,xuán",
  "犹豫地": "yóu,yù,de",
  "狂且": "kuáng,jū",
  "狂为": "kuáng,wéi",
  "狂乱地": "kuáng,luàn,de",
  "狂伧": "kuáng,chen",
  "狂兴": "kuáng,xīng",
  "狂勷": "kuáng,xiāng",
  "狂吠狴犴": "kuáng,fèi,bì,àn",
  "狂喜地": "kuáng,xǐ,de",
  "狂天说地": "kuáng,tiān,shuō,de",
  "狂妄地": "kuáng,wàng,de",
  "狂怒地": "kuáng,nù,de",
  "狂文地": "kuáng,wén,de",
  "狂暴地": "kuáng,bào,de",
  "狂欢地": "kuáng,huān,de",
  "狂烈地": "kuáng,liè,de",
  "狂犬病地": "kuáng,quǎn,bìng,de",
  "狂獝": "kuáng,yù",
  "狂缪": "kuáng,miù",
  "狂背": "kuáng,bèi",
  "狂跌": "kuáng,diē",
  "狂蹶": "kuáng,juě",
  "狂𬮴": "kuáng,ān",
  "狂闹地": "kuáng,nào,de",
  "狂风地": "kuáng,fēng,de",
  "狂风怒号": "kuáng,fēng,nù,háo",
  "狃忕": "niǔ,tài",
  "狄更斯": "dí,gēng,sī",
  "狋吽牙": "yí,ōu,yá",
  "狌狌": "xīng,xīng",
  "狌狞": "xīng,níng",
  "狍子": "páo,zi",
  "狎兴": "xiá,xīng",
  "狎处": "xiá,chǔ",
  "狎翫": "xiá,wàn",
  "狐狸": "hú,li",
  "狐狸座": "hú,li,zuò",
  "狐狸精": "hú,li,jīng",
  "狐獴": "hú,měng",
  "狐裘尨茸": "hú,qiú,méng,róng",
  "狐襟貉袖": "hú,jīn,mò,xiù",
  "狐貉": "hú,mò",
  "狗仔": "gǒu,zǎi",
  "狗仔子": "gǒu,zǎi,zǐ",
  "狗仔式": "gǒu,zǎi,shì",
  "狗仔队": "gǒu,zǎi,duì",
  "狗头上生角": "gǒu,tóu,shàng,shēng,jué",
  "狗崽子": "gǒu,zǎi,zi",
  "狗拿耗子": "gǒu,ná,hào,zi",
  "狗改不了吃屎": "gǒu,gǎi,bù,liǎo,chī,shǐ",
  "狗爪子": "gǒu,zhuǎ,zǐ",
  "狗狗": "gǒu,gōu",
  "狗玩儿的": "gǒu,wán,er,de",
  "狗生角": "gǒu,shēng,jué",
  "狗续侯冠": "gǒu,xù,hòu,guàn",
  "狗腿子": "gǒu,tuǐ,zi",
  "狗舍": "gǒu,shè",
  "狗血喷头": "gǒu,xuè,pēn,tóu",
  "狗血淋头": "gǒu,xuè,lín,tóu",
  "狗逮老鼠": "gǒu,dǎi,lǎo,shǔ",
  "狗长尾巴尖儿的好日子": "gǒu,cháng,wěi,bā,jiān,er,de,hǎo,rì,zi",
  "狗颠屁股": "gǒu,diān,pì,gu",
  "狗骨头": "gǒu,gú,tou",
  "狙伺": "jū,sì",
  "狞獝": "níng,yù",
  "狠性子": "hěn,xìng,zi",
  "狠毒地": "hěn,dú,de",
  "狠狠地": "hěn,hěn,de",
  "狠狠地亲了一下": "hěn,hěn,de,qīn,le,yī,xià",
  "狠狠地咬了一口": "hěn,hěn,de,yǎo,le,yī,kǒu",
  "狠狠地扁一顿": "hěn,hěn,de,biǎn,yī,dùn",
  "狠狠地打": "hěn,hěn,de,dǎ",
  "狠狠地打击了": "hěn,hěn,de,dǎ,jī,le",
  "狠狠地掐了一把": "hěn,hěn,de,qiā,le,yī,bǎ",
  "狠狠地插进": "hěn,hěn,de,chā,jìn",
  "狠狠地教训": "hěn,hěn,de,jiào,xùn",
  "狠狠地砸在": "hěn,hěn,de,zá,zài",
  "狠狠地罚": "hěn,hěn,de,fá",
  "狠狠地说": "hěn,hěn,de,shuō",
  "狠狠地踩几下": "hěn,hěn,de,cǎi,jǐ,xià",
  "狠狠地追": "hěn,hěn,de,zhuī",
  "狠狠地骂道": "hěn,hěn,de,mà,dào",
  "狠𬮴": "hěn,ān",
  "狡兔得而猎犬烹": "jiǎo,tù,de,ér,liè,quǎn,pēng",
  "狡数": "jiǎo,shù",
  "狡猾地": "jiǎo,huá,de",
  "狡獝": "jiǎo,yù",
  "狡诈地": "jiǎo,zhà,de",
  "狡诈地笑": "jiǎo,zhà,de,xiào",
  "狡黠地": "jiǎo,xiá,de",
  "狤獠": "jí,liáo",
  "狧穅及米": "shì,kāng,jí,mǐ",
  "独不见": "dú,bú,jiàn",
  "独个儿": "dú,gè,er",
  "独具只眼": "dú,jù,zhī,yǎn",
  "独冠": "dú,guān",
  "独创地": "dú,chuàng,de",
  "独占地": "dú,zhàn,de",
  "独在异乡为异客": "dú,zài,yì,xiāng,wéi,yì,kè",
  "独处": "dú,chǔ",
  "独处愁": "dú,chǔ,chóu",
  "独得": "dú,de",
  "独断地": "dú,duàn,de",
  "独有千秋": "dú,yòu,qiān,qiū",
  "独着": "dú,zhe",
  "独立地": "dú,lì,de",
  "独立钻石": "dú,lì,zuàn,shí",
  "独脚五通": "dú,jiǎo,wǔ,tòng",
  "独自个": "dú,zì,gě",
  "独自地": "dú,zì,de",
  "独裁地": "dú,cái,de",
  "独辟蹊径": "dú,pì,xī,jìng",
  "独院儿": "dú,yuàn,er",
  "狭义地讲": "xiá,yì,de,jiǎng",
  "狭义地说": "xiá,yì,de,shuō",
  "狭窄地": "xiá,zhǎi,de",
  "狭缝": "xiá,fèng",
  "狭隘地": "xiá,ài,de",
  "狮子": "shī,zi",
  "狮子会": "shī,zi,huì",
  "狮子吼": "shī,zi,hǒu",
  "狮子壶": "shī,zi,hú",
  "狮子头": "shī,zi,tóu",
  "狮子山": "shī,zi,shān",
  "狮子山区": "shī,zi,shān,qū",
  "狮子床": "shī,zi,chuáng",
  "狮子座": "shī,zi,zuò",
  "狮子术": "shī,zi,shù",
  "狮子林": "shī,zi,lín",
  "狮子林园": "shī,zi,lín,yuán",
  "狮子滚绣毬": "shī,zi,gǔn,xiù,qiú",
  "狮子滚绣球": "shī,zi,gǔn,xiù,qiú",
  "狮子灯": "shī,zi,dēng",
  "狮子狗": "shī,zi,gǒu",
  "狮子舞": "shī,zi,wǔ",
  "狮子花": "shī,zi,huā",
  "狮子补": "shī,zi,bǔ",
  "狮子身中虫": "shī,zi,shēn,zhōng,chóng",
  "狮子骢": "shī,zi,cōng",
  "狮子鼻": "shī,zi,bí",
  "狱家院子": "yù,jiā,yuàn,zi",
  "狱犴": "yù,àn",
  "狱舍": "yù,shè",
  "狴犴": "bì,àn",
  "狷介之士": "juàn,jiě,zhī,shì",
  "狸子": "lí,zi",
  "狸狌": "lí,xīng",
  "狸骨帖": "lí,gǔ,tiē",
  "狼仆": "láng,pú",
  "狼号鬼哭": "láng,háo,guǐ,kū",
  "狼吞虎咽地吃": "láng,tūn,hǔ,yàn,de,chī",
  "狼嚎般地": "láng,háo,bān,de",
  "狼狈为奸": "láng,bèi,wéi,jiān",
  "狼狈地": "láng,bèi,de",
  "狼艰狈蹶": "láng,jiān,bèi,juě",
  "狼藉": "láng,jí",
  "狼顾鸱跱": "láng,gù,chī,yín",
  "狼顾麕惊": "láng,gù,qiān,jīng",
  "狼飡虎咽": "láng,cān,hǔ,yān",
  "猃猲": "xiǎn,hè",
  "猎兴": "liè,xīng",
  "猎古调": "liè,gǔ,diào",
  "猎禁": "liè,jìn",
  "猑蹏": "kūn,dì",
  "猓然": "guǒ,rán",
  "猓猓": "guǒ,guǒ",
  "猓猡": "guǒ,luó",
  "猖蹶": "chāng,juě",
  "猗靡": "yǐ,mí",
  "猛乍地": "měng,zhà,de",
  "猛冲地": "měng,chōng,de",
  "猛力踩地": "měng,lì,cǎi,de",
  "猛劲儿": "měng,jìn,er",
  "猛地": "měng,de",
  "猛地一动": "měng,de,yī,dòng",
  "猛地一变": "měng,de,yī,biàn",
  "猛地一愣": "měng,de,yī,lèng",
  "猛地一把": "měng,de,yī,bǎ",
  "猛地一拉": "měng,de,yī,lā",
  "猛地一拍手": "měng,de,yī,pāi,shǒu",
  "猛地一看": "měng,de,yī,kàn",
  "猛地一翻身": "měng,de,yī,fān,shēn",
  "猛地一震": "měng,de,yī,zhèn",
  "猛地一顿": "měng,de,yī,dùn",
  "猛地住口": "měng,de,zhù,kǒu",
  "猛地关": "měng,de,guān",
  "猛地发现": "měng,de,fā,xiàn",
  "猛地向上": "měng,de,xiàng,shàng",
  "猛地往下": "měng,de,wǎng,xià",
  "猛地想来": "měng,de,xiǎng,lái",
  "猛地想起": "měng,de,xiǎng,qǐ",
  "猛地想起来": "měng,de,xiǎng,qǐ,lái",
  "猛地扑到": "měng,de,pū,dào",
  "猛地扑打": "měng,de,pū,dǎ",
  "猛地扔下": "měng,de,rēng,xià",
  "猛地抓住": "měng,de,zhuā,zhù",
  "猛地抬起了头": "měng,de,tái,qǐ,le,tóu",
  "猛地推开": "měng,de,tuī,kāi",
  "猛地站了起来": "měng,de,zhàn,le,qǐ,lái",
  "猛地站起": "měng,de,zhàn,qǐ",
  "猛地站起来": "měng,de,zhàn,qǐ,lái",
  "猛地缩小": "měng,de,suō,xiǎo",
  "猛地落下": "měng,de,là,xià",
  "猛地跪下": "měng,de,guì,xià",
  "猛地跳起": "měng,de,tiào,qǐ",
  "猛地转身": "měng,de,zhuǎn,shēn",
  "猛地醒觉": "měng,de,xǐng,jué",
  "猛地闯入": "měng,de,chuǎng,rù",
  "猛孤丁地": "měng,gū,dīng,de",
  "猛将": "měng,jiàng",
  "猛干": "měng,gàn",
  "猛拉地": "měng,lā,de",
  "猛烈地": "měng,liè,de",
  "猛烈地刮": "měng,liè,de,guā",
  "猛然地": "měng,rán,de",
  "猛省": "měng,xǐng",
  "猛跌": "měng,diē",
  "猛进地": "měng,jìn,de",
  "猜不透": "cāi,bu,tòu",
  "猜中": "cāi,zhòng",
  "猜头儿": "cāi,tou,er",
  "猜度": "cāi,duó",
  "猜得透": "cāi,de,tòu",
  "猜忌地": "cāi,jì,de",
  "猜疑地": "cāi,yí,de",
  "猜着": "cāi,zháo",
  "猜谜儿": "cāi,mí,er",
  "猜间": "cāi,jiàn",
  "猡猓": "luó,guǒ",
  "猢狲大王": "hú,sūn,dài,wáng",
  "猥亵地": "wěi,xiè,de",
  "猥亵性暴露": "wěi,xiè,xìng,bào,lù",
  "猥朝侯": "wěi,cháo,hòu",
  "猥欸": "wěi,ǎi",
  "猥獕": "wěi,cuī",
  "猥闶": "wěi,kāng",
  "猩猩": "xīng,xing",
  "猩猩血": "xīng,xīng,xuè",
  "猩血": "xīng,xuè",
  "猪一般地": "zhū,yì,bān,de",
  "猪仔": "zhū,zǎi",
  "猪仔包": "zhū,zǎi,bāo",
  "猪仔国会": "zhū,zǎi,guó,huì",
  "猪仔议员": "zhū,zǎi,yì,yuán",
  "猪仔馆": "zhū,zǎi,guǎn",
  "猪倌儿": "zhū,guān,er",
  "猪卑狗险": "zhū,bēi,gǒu,liǎn",
  "猪只": "zhū,zhī",
  "猪圈": "zhū,juàn",
  "猪尾巴": "zhū,wěi,ba",
  "猪尿泡": "zhū,suī,pào",
  "猪尿脬": "zhū,suī,pāo",
  "猪扒": "zhū,pá",
  "猪肚": "zhū,dǔ",
  "猪肚儿": "zhū,dǔ,er",
  "猫哭耗子": "māo,kū,hào,zi",
  "猫弹竹": "māo,dàn,zhú",
  "猫爪子": "māo,zhuǎ,zi",
  "猫眼儿": "māo,yǎn,er",
  "猫腰": "máo,yāo",
  "猫鼠同处": "māo,shǔ,tóng,chǔ",
  "猬兴": "wèi,xīng",
  "献处": "xiàn,chǔ",
  "献殷勤地": "xiàn,yīn,qín,de",
  "献血": "xiàn,xuè",
  "献血者": "xiàn,xuè,zhě",
  "献酢": "xiàn,cù",
  "猲狙": "hè,jū",
  "猴儿急": "hóu,er,jí",
  "猴儿精": "hóu,er,jīng",
  "猴冠": "hóu,guān",
  "猴子": "hóu,zi",
  "猴子似地": "hóu,zi,shì,de",
  "猴子偷桃": "hóu,zi,tōu,táo",
  "猴子跳": "hóu,zi,tiào",
  "猴孩子": "hóu,hái,zi",
  "猴查": "hóu,zhā",
  "猵狙": "piàn,jū",
  "猷为": "yóu,wéi",
  "猸子": "méi,zi",
  "猼𫍙": "bó,yí",
  "猿嗛": "yuán,qiàn",
  "猿扳蛇折": "yuán,bān,shé,shé",
  "獐子": "zhāng,zi",
  "𰡞羊": "bèn,yáng",
  "獝狂": "yù,kuáng",
  "獝狘": "yù,xuè",
  "獬冠": "xiè,guān",
  "獬豸冠": "xiè,zhì,guān",
  "獭皮冠": "tǎ,pí,guān",
  "獴科": "měng,kē",
  "玄元大夫": "xuán,yuán,dài,fū",
  "玄冠": "xuán,guān",
  "玄嚜": "xuán,me",
  "玄干": "xuán,qián",
  "玄朴": "xuán,piáo",
  "玄着": "xuán,zhe",
  "玄祇": "xuán,qí",
  "玄舍": "xuán,shè",
  "玄菟": "xuán,tú",
  "玄蕰": "xuán,wēn",
  "玄露": "xuán,lù",
  "玅年": "yāo,nián",
  "玅策": "yāo,cè",
  "玅诀": "yāo,jué",
  "玅选": "yāo,xuǎn",
  "率以为常": "shuài,yǐ,wéi,cháng",
  "率俾": "lǜ,bǐ",
  "率先": "shuài,xiān",
  "率兽食人": "shuài,shòu,shí,rén",
  "率军": "shuài,jūn",
  "率割": "shuài,gē",
  "率土": "shuài,tǔ",
  "率土之滨": "shuài,tǔ,zhī,bīn",
  "率土同庆": "shuài,tǔ,tóng,qìng",
  "率土大将军": "shuài,tǔ,dà,jiàng,jūn",
  "率土宅心": "shuài,tǔ,zhái,xīn",
  "率土归心": "shuài,tǔ,guī,xīn",
  "率夺": "shuài,duó",
  "率尔": "shuài,ěr",
  "率尔成章": "shuài,ěr,chéng,zhāng",
  "率尔操觚": "shuài,ěr,cāo,gū",
  "率履": "shuài,lǚ",
  "率常": "shuài,cháng",
  "率性": "shuài,xìng",
  "率性任意": "shuài,xìng,rèn,yì",
  "率意": "shuài,yì",
  "率数": "lǜ,shù",
  "率更": "lǜ,gēng",
  "率更书": "lǜ,gēng,shū",
  "率更令": "lǜ,gēng,lìng",
  "率更体": "lǜ,gēng,tǐ",
  "率服": "shuài,fú",
  "率然": "shuài,rán",
  "率由旧则": "shuài,yóu,jiù,zé",
  "率由旧章": "shuài,yóu,jiù,zhāng",
  "率直": "shuài,zhí",
  "率直地": "shuài,zhí,de",
  "率真": "shuài,zhēn",
  "率礼": "shuài,lǐ",
  "率舞": "shuài,wǔ",
  "率队": "shuài,duì",
  "率领": "shuài,lǐng",
  "率马以骥": "shuài,mǎ,yǐ,jì",
  "玉兔鹘": "yù,tù,hú",
  "玉冠": "yù,guān",
  "玉刹": "yù,shā",
  "玉卮无当": "yù,zhī,wú,dàng",
  "玉参差": "yù,cēn,cī",
  "玉叶冠": "yù,yè,guān",
  "玉吐鹘": "yù,tǔ,hú",
  "玉婘": "yù,quán",
  "玉尺量才": "yù,chǐ,liáng,cái",
  "玉巵无当": "yù,zhī,wú,dàng",
  "玉帖镫": "yù,tiē,dèng",
  "玉幢": "yù,zhuàng",
  "玉干": "yù,gàn",
  "玉弹": "yù,dàn",
  "玉折": "yù,shé",
  "玉指甲": "yù,zhǐ,jiá",
  "玉斗": "yù,dǒu",
  "玉枕𫉄": "yù,zhěn,zhū",
  "玉栅": "yù,shān",
  "玉树藏族自治州": "yù,shù,zàng,zú,zì,zhì,zhōu",
  "玉槛": "yù,kǎn",
  "玉漏犹滴": "yu,lou,you,di",
  "玉皛": "yù,jiǎo",
  "玉禁": "yù,jìn",
  "玉𥮾": "yù,zān",
  "玉米棒子": "yù,mǐ,bàng,zi",
  "玉米糊糊": "yù,mǐ,hū,hū",
  "玉米花儿": "yù,mǐ,huā,er",
  "玉糁": "yù,shēn",
  "玉糁羹": "yù,shēn,gēng",
  "玉舃": "yù,tuō",
  "玉菌子": "yù,jùn,zǐ",
  "玉虺": "yù,huī",
  "玉质金相": "yù,zhì,jīn,xiàng",
  "玉𫐌": "yù,pēng",
  "玉露": "yù,lù",
  "玉面狸": "yù,miàn,mái",
  "王侯将相": "wáng,hóu,jiàng,xiàng",
  "王八犊子": "wáng,bā,dú,zi",
  "王冠": "wáng,guān",
  "王后般地": "wáng,hòu,bān,de",
  "王天下": "wàng,tiān,xià",
  "王徐应刘": "wáng,xú,yìng,liú",
  "王有地": "wáng,yǒu,de",
  "王正月": "wáng,zhēng,yuè",
  "王氏帖": "wáng,shì,tiē",
  "王舍": "wáng,shè",
  "王舍城": "wáng,shè,chéng",
  "王葛": "wáng,gě",
  "王虺": "wáng,huī",
  "王蚥": "wáng,fǔ",
  "王贡弹冠": "wáng,gòng,dàn,guàn",
  "王载": "wáng,zǎi",
  "玚珌": "dàng,bì",
  "玚琫": "dàng,běng",
  "玚花": "yáng,huā",
  "玛莎拉蒂": "mǎ,shā,lā,dì",
  "玩不起": "wán,bu,qǐ",
  "玩乐地": "wán,lè,de",
  "玩偶似地": "wán,ǒu,shì,de",
  "玩儿": "wán,er",
  "玩儿不转": "wán,ér,bù,zhuàn",
  "玩儿命": "wán,er,mìng",
  "玩儿坏": "wán,er,huài",
  "玩儿完": "wán,er,wán",
  "玩儿得转": "wán,er,dé,zhuàn",
  "玩儿花招": "wán,er,huā,zhāo",
  "玩家角色": "wán,jiā,jué,sè",
  "玩岁愒日": "wán,suì,kài,rì",
  "玩岁愒时": "wán,suì,kài,shí",
  "玩岁愒月": "wán,suì,kài,yuè",
  "玩意儿": "wán,yì,er",
  "玩愒": "wán,kài",
  "玩日愒时": "wán,rì,kài,shí",
  "玩时愒日": "wán,shí,kài,rì",
  "玩笑地": "wán,xiào,de",
  "玩艺儿": "wán,yì,er",
  "玩讽": "wán,fěng",
  "玩转": "wán,zhuàn",
  "玩适": "wán,shì",
  "玫瑰念珠": "méi,gui,niàn,zhū",
  "玫瑰茄": "méi,gui,qié",
  "玫瑰露": "méi,guī,lù",
  "环伺": "huán,sì",
  "环境上地": "huán,jìng,shàng,de",
  "环形地": "huán,xíng,de",
  "环挐": "huán,ná",
  "环晕": "huán,yùn",
  "环状地": "huán,zhuàng,de",
  "环球音乐集团": "huán,qiú,yīn,yuè,jí,tuán",
  "环絙": "huán,gēng",
  "环行地": "huán,xíng,de",
  "环𰺷": "huán,rǎo",
  "环钻": "huán,zuàn",
  "现世地": "xiàn,shì,de",
  "现代地": "xiàn,dài,de",
  "现代式地": "xiàn,dài,shì,de",
  "现代音乐": "xiàn,dài,yīn,yuè",
  "现在为止": "xiàn,zài,wéi,zhǐ",
  "现在仔细地": "xiàn,zài,zǐ,xì,de",
  "现在是过去钥匙": "xiàn,zài,shì,guò,qu,yào,shi",
  "现撇": "xiàn,piě",
  "现行地": "xiàn,xíng,de",
  "现象上地": "xiàn,xiàng,shàng,de",
  "现路子": "xiàn,lù,zi",
  "现银子": "xiàn,yín,zi",
  "现露": "xiàn,lù",
  "玷累": "diàn,lèi",
  "玻璃丝": "bō,li,sī",
  "玻璃似地": "bō,lí,shì,de",
  "玻璃动物园": "bō,li,dòng,wù,yuán",
  "玻璃化": "bō,li,huà",
  "玻璃心": "bō,li,xīn",
  "玻璃春": "bō,li,chūn",
  "玻璃板": "bō,li,bǎn",
  "玻璃江": "bō,li,jiāng",
  "玻璃球": "bō,li,qiú",
  "玻璃砂": "bō,li,shā",
  "玻璃砖": "bō,li,zhuān",
  "玻璃管": "bō,li,guǎn",
  "玻璃罩": "bō,li,zhào",
  "珊瑚翘": "shān,hú,qiào",
  "珍奇地": "zhēn,qí,de",
  "珍翫": "zhēn,wàn",
  "珍调": "zhēn,diào",
  "珍贵地": "zhēn,guì,de",
  "珑珑兀兀": "lóng,lóng,wū,wū",
  "珠冠": "zhū,guān",
  "珠子": "zhū,zi",
  "珠子灯": "zhū,zi,dēng",
  "珠子花儿": "zhū,zi,huā,ér",
  "珠子菊": "zhū,zi,jú",
  "珠子褐": "zhū,zi,hè",
  "珠宫贝阙": "zhū,gōng,bèi,què",
  "珠弹": "zhū,dàn",
  "珠徙珠还": "zhū,xǐ,zhū,huán",
  "珠沉玉𬒍": "zhū,chén,yù,zǐ",
  "珠翘": "zhū,qiào",
  "珠𧏖": "zhū,bīn",
  "珠还": "zhū,huán",
  "珠还合浦": "zhū,huán,hé,pǔ",
  "珠露": "zhū,lù",
  "珧铫": "yáo,yáo",
  "珩佩": "háng,pèi",
  "珩璜": "háng,huáng",
  "珩磨": "háng,mó",
  "珩组": "háng,zǔ",
  "珩黻": "háng,fú",
  "班什": "bān,shí",
  "班剥": "bān,bāo",
  "班子": "bān,zi",
  "班禅喇嘛": "bān,chán,lǎ,ma",
  "班行": "bān,háng",
  "班辈儿": "bān,bèi,er",
  "班长": "bān,zhǎng",
  "琀玉": "hàn,yù",
  "球地": "qiú,de",
  "球差": "qiú,chā",
  "球弹": "qiú,dàn",
  "球栅阵列封装": "qiú,shān,zhèn,liè,fēng,zhuāng",
  "球状地": "qiú,zhuàng,de",
  "球露锦": "qiú,lù,jǐn",
  "琅邪": "láng,yá",
  "琅邪台": "láng,yá,tái",
  "琅铛": "láng,chēng",
  "理事长": "lǐ,shì,zhǎng",
  "理儿": "lǐ,er",
  "理发": "lǐ,fà",
  "理发厅": "lǐ,fà,tīng",
  "理发员": "lǐ,fà,yuán",
  "理发师": "lǐ,fà,shī",
  "理发店": "lǐ,fà,diàn",
  "理发院": "lǐ,fà,yuàn",
  "理发馆": "lǐ,fà,guǎn",
  "理干": "lǐ,gàn",
  "理性地": "lǐ,xìng,de",
  "理性知识": "lǐ,xìng,zhī,shi",
  "理性认识": "lǐ,xìng,rèn,shi",
  "理想上地": "lǐ,xiǎng,shàng,de",
  "理想地": "lǐ,xiǎng,de",
  "理折": "lǐ,shé",
  "理数": "lǐ,shù",
  "理智地": "lǐ,zhì,de",
  "理智地把": "lǐ,zhì,de,bǎ",
  "理解地笑": "lǐ,jiě,de,xiào",
  "理论上地": "lǐ,lùn,shàng,de",
  "理论地": "lǐ,lùn,de",
  "琉璃": "liú,li",
  "琐细地": "suǒ,xì,de",
  "琕琫": "bǐng,běng",
  "琢削": "zhuó,xuē",
  "琢磨": "zuó,mó",
  "琦傀": "qí,guī",
  "琱璚": "diāo,jué",
  "琴调": "qín,diào",
  "琵琶": "pí,pa",
  "琵琶鱼": "pí,pa,yú",
  "琼什": "qióng,shí",
  "琼楼金阙": "qióng,lóu,jīn,què",
  "琼毂": "qióng,gū",
  "琼畟": "qióng,jī",
  "琼花露": "qióng,huā,lù",
  "琼荂露": "qióng,fū,lù",
  "琼铺": "qióng,pù",
  "瑑削": "zhuàn,xuē",
  "瑕瑜互见": "xiá,yú,hù,xiàn",
  "瑕累": "xiá,lèi",
  "瑕适": "xiá,shì",
  "瑗珲": "yuàn,huī",
  "瑞应": "ruì,yìng",
  "瑞应泉": "ruì,yìng,quán",
  "瑞应车": "ruì,yìng,chē",
  "瑞露": "ruì,lù",
  "瑟踧": "sè,dí",
  "瑶台银阙": "yáo,tái,yín,què",
  "瑶池玉液": "yáo,shi,yù,yè",
  "瑶𥮾": "yáo,zān",
  "瑶铣": "yáo,xǐ",
  "璁珩": "cōng,háng",
  "璇霄丹阙": "xuán,xiāo,dān,què",
  "璧还": "bì,huán",
  "瓜分豆剖": "guā,fēn,dòu,pōu",
  "瓜剖碁布": "guā,pōu,qí,bù",
  "瓜剖豆分": "guā,pōu,dòu,fēn",
  "瓜娃子": "guā,wá,zi",
  "瓜子仁儿": "guā,zi,rén,er",
  "瓜子儿": "guā,zi,er",
  "瓜子儿脸": "guā,zi,er,liǎn",
  "瓜皮搭李树": "guā,pǐ,dā,lǐ,shù",
  "瓜葛相连": "guā,gě,xiāng,lián",
  "瓜蔓": "guā,wàn",
  "瓜蔓抄": "guā,wàn,chāo",
  "瓜蔓水": "guā,wàn,shuǐ",
  "瓠蠡": "hù,lí",
  "瓢冠": "piáo,guān",
  "瓣儿": "bàn,er",
  "瓤儿": "ráng,er",
  "瓤口儿": "ráng,kǒu,er",
  "瓤子": "ráng,zi",
  "瓦刀": "wà,dāo",
  "瓦屋子": "wǎ,wū,zi",
  "瓦岗军": "wǎ,gāng,jūn",
  "瓦影之鱼": "wǎ,yǐng,huā,yú",
  "瓦查": "wǎ,zhā",
  "瓦渣地": "wǎ,zhā,de",
  "瓦窑堡": "wǎ,yáo,bǔ",
  "瓦缝": "wǎ,fèng",
  "瓦舍": "wǎ,shè",
  "瓦同子": "wǎ,tòng,zǐ",
  "瓦西里耶夫兄弟": "wǎ,xī,lǐ,yē,fū,xiōng,dì",
  "瓦西里耶维奇": "wǎ,xī,lǐ,yē,wéi,qí",
  "瓦都兹": "wǎ,dū,zī",
  "瓦铛": "wǎ,chēng",
  "瓦铫": "wǎ,yáo",
  "瓦隆": "wǎ,lōng",
  "瓮天蠡海": "wèng,tiān,lí,hǎi",
  "瓶塞钻": "píng,sāi,zuàn",
  "瓶子": "píng,zi",
  "瓶沈簪折": "píng,shěn,zān,shé",
  "瓷实": "cí,shi",
  "瓷铛": "cí,chēng",
  "甄载": "zhēn,zǎi",
  "甑子": "zèng,zi",
  "甑尘釜鱼": "zēng,chén,fǔ,yú",
  "甑箄": "zèng,bǐ",
  "瓮里酰鸡": "wèng,lǐ,xī,jī",
  "甗锜": "yǎn,yǐ",
  "甘为": "gān,wéi",
  "甘乃地": "gān,nǎi,de",
  "甘井子区": "gān,jǐng,zi,qū",
  "甘分随时": "gān,fèn,suí,shí",
  "甘南藏族自治州": "gān,nán,zàng,zú,zì,zhì,zhōu",
  "甘处下流": "gān,chǔ,xià,liú",
  "甘孜藏族自治州": "gān,zī,zàng,zú,zì,zhì,zhōu",
  "甘得": "gān,de",
  "甘腝": "gān,ní",
  "甘蔗": "gān,zhe",
  "甘蔗地": "gān,zhè,de",
  "甘蔗渣": "gān,zhe,zhā",
  "甘锐侯": "gān,ruì,hòu",
  "甘霔": "gān,zhù",
  "甘露": "gān,lù",
  "甘露厨": "gān,lù,chú",
  "甘露寺": "gān,lù,sì",
  "甘露浆": "gān,lù,jiāng",
  "甘露灭": "gān,lù,miè",
  "甘露糖醇": "gān,lù,táng,chún",
  "甘露醇": "gān,lù,chún",
  "甘露门": "gān,lù,mén",
  "甚为": "shèn,wéi",
  "甚么": "shén,me",
  "甚于": "shén,yú",
  "甜口儿": "tián,kǒu,er",
  "甜味儿": "tián,wèi,er",
  "甜咪咪地": "tián,mī,mī,de",
  "甜头": "tián,tou",
  "甜得发腻": "tián,de,fā,nì",
  "甜甜地": "tián,tián,de",
  "甜甜地睡": "tián,tián,de,shuì",
  "甜甜地说": "tián,tián,de,shuō",
  "甜甜地问": "tián,tián,de,wèn",
  "甜美地": "tián,měi,de",
  "甜蜜地": "tián,mì,de",
  "甜蜜地说": "tián,mì,de,shuō",
  "甜适": "tián,shì",
  "甜露": "tián,lù",
  "生个子": "shēng,gè,zi",
  "生产反应堆": "shēng,chǎn,fǎn,yìng,duī",
  "生人血": "shēng,rén,xuè",
  "生什": "shēng,shí",
  "生剥": "shēng,bāo",
  "生动地": "shēng,dòng,de",
  "生动活泼地": "shēng,dòng,huó,pō,de",
  "生卷": "shēng,juàn",
  "生发": "shēng,fà",
  "生发剂": "shēng,fà,jì",
  "生发未燥": "shēng,fà,wèi,zào",
  "生发油": "shēng,fà,yóu",
  "生各扎": "shēng,gè,zhā",
  "生命力地": "shēng,mìng,lì,de",
  "生喇喇": "shēng,là,là",
  "生存力地": "shēng,cún,lì,de",
  "生帐子货": "shēng,zhàng,zi,huò",
  "生得": "shēng,de",
  "生态地": "shēng,tài,de",
  "生态型地": "shēng,tài,xíng,de",
  "生息地": "shēng,xī,de",
  "生意兴隆": "shēng,yì,xīng,lóng",
  "生意经": "shēng,yi,jīng",
  "生扢扎": "shēng,gǔ,zhā",
  "生拖死拽": "shēng,tuō,sǐ,zhuāi",
  "生数": "shēng,shù",
  "生日地": "shēng,rì,de",
  "生杀予夺": "shēng,shā,yǔ,duó",
  "生来地": "shēng,lái,de",
  "生查子": "shēng,zhā,zǐ",
  "生死予夺": "shēng,sǐ,yǔ,duó",
  "生殖地": "shēng,zhí,de",
  "生气地": "shēng,qì,de",
  "生气地看着": "shēng,qì,de,kàn,zhe",
  "生气地说": "shēng,qì,de,shuō",
  "生物反应器": "shēng,wù,fǎn,yìng,qì",
  "生物学地": "shēng,wù,xué,de",
  "生物弹药": "shēng,wù,dàn,yào",
  "生理假": "shēng,lǐ,jià",
  "生理地": "shēng,lǐ,de",
  "生理学地": "shēng,lǐ,xué,de",
  "生生地": "shēng,shēng,de",
  "生疏地": "shēng,shū,de",
  "生盘子": "shēng,pán,zi",
  "生相": "shēng,xiàng",
  "生硬地说": "shēng,yìng,de,shuō",
  "生累": "shēng,lèi",
  "生肖": "shēng,xiào",
  "生肖属相": "shēng,xiào,shǔ,xiàng",
  "生肖钱": "shēng,xiào,qián",
  "生臊": "shēng,sào",
  "生药铺": "shēng,yào,pù",
  "生蕃": "shēng,fān",
  "生角": "shēng,jué",
  "生辉地": "shēng,huī,de",
  "生辰吉帖": "shēng,chén,jí,tiē",
  "生还": "shēng,huán",
  "生还者": "shēng,huán,zhě",
  "生长": "shēng,zhǎng",
  "生长期": "shēng,zhǎng,qī",
  "生长激素": "shēng,zhǎng,jī,sù",
  "生长点": "shēng,zhǎng,diǎn",
  "生长率": "shēng,zhǎng,lǜ",
  "生长素": "shēng,zhǎng,sù",
  "生闷气": "shēng,mēn,qì",
  "用不了": "yòng,bu,liǎo",
  "用不着": "yòng,bu,zháo",
  "用人不当": "yòng,rén,bú,dàng",
  "用假名地": "yòng,jiǎ,míng,de",
  "用催眠地": "yòng,cuī,mián,de",
  "用力一搡": "yòng,lì,yì,sǎng",
  "用力地": "yòng,lì,de",
  "用力地一拧": "yòng,lì,de,yī,níng",
  "用力地一捏": "yòng,lì,de,yī,niē",
  "用力地打": "yòng,lì,de,dǎ",
  "用力地抛起": "yòng,lì,de,pāo,qǐ",
  "用力地拉着": "yòng,lì,de,lā,zhe",
  "用力地挖": "yòng,lì,de,wā",
  "用力地撞击": "yòng,lì,de,zhuàng,jī",
  "用力地砸": "yòng,lì,de,zá",
  "用力地踢开": "yòng,lì,de,tī,kāi",
  "用力猛地": "yòng,lì,měng,de",
  "用功地": "yòng,gōng,de",
  "用口地": "yòng,kǒu,de",
  "用在一朝": "yòng,zài,yī,zhāo",
  "用处": "yòng,chǔ",
  "用完地": "yòng,wán,de",
  "用尽地": "yòng,jǐn,de",
  "用得上": "yòng,de,shàng",
  "用得其所": "yòng,de,qí,suǒ",
  "用得着": "yòng,de,zháo",
  "用心地": "yòng,xīn,de",
  "用挟": "yòng,jiā",
  "用智铺谋": "yòng,zhì,pù,móu",
  "用水和面": "yòng,shuǐ,huò,miàn",
  "用眼睛偷偷地": "yòng,yǎn,jīng,tōu,tōu,de",
  "用眼睛地": "yòng,yǎn,jīng,de",
  "用舍": "yòng,shè",
  "用言辞地": "yòng,yán,cí,de",
  "用词不当": "yòng,cí,bú,dàng",
  "用词切当": "yòng,cí,qiè,dàng",
  "用钱": "yòng,qian",
  "用间": "yòng,jiàn",
  "用魔法地": "yòng,mó,fǎ,de",
  "用鼻拱地": "yòng,bí,gǒng,de",
  "甩包袱": "shuǎi,bāo,fu",
  "甩开膀子": "shuǎi,kāi,bǎng,zi",
  "甩笔头子": "shuǎi,bǐ,tóu,zi",
  "甩脸子": "shuǎi,liǎn,zi",
  "甩袖子": "shuǎi,xiù,zi",
  "田主子": "tián,zhǔ,zi",
  "田仆": "tián,pú",
  "田仔": "tián,zǎi",
  "田坑": "tián,gāng",
  "田更": "tián,gēng",
  "田浍": "tián,huì",
  "田父": "tián,fǔ",
  "田父之功": "tián,fǔ,zhī,gōng",
  "田父可坐杀": "tián,fǔ,kě,zuò,shā",
  "田父献曝": "tián,fǔ,xiàn,pù",
  "田父野叟": "tián,fǔ,yě,sǒu",
  "田父野老": "tián,fǔ,yě,lǎo",
  "田背": "tián,bèi",
  "田舍": "tián,shè",
  "田舍人": "tián,shè,rén",
  "田舍儿": "tián,shè,ér",
  "田舍公": "tián,shè,gōng",
  "田舍奴": "tián,shè,nú",
  "田舍娘": "tián,shè,niáng",
  "田舍子": "tián,shè,zǐ",
  "田舍汉": "tián,shè,hàn",
  "田舍翁": "tián,shè,wēng",
  "田舍郎": "tián,shè,láng",
  "田茀": "tián,bó",
  "由头": "yóu,tou",
  "由帖": "yóu,tiē",
  "由得": "yóu,de",
  "由着": "yóu,zhe",
  "由衷地": "yóu,zhōng,de",
  "由衷地感谢": "yóu,zhōng,de,gǎn,xiè",
  "由衷地说": "yóu,zhōng,de,shuō",
  "由衷地赞美": "yóu,zhōng,de,zàn,měi",
  "由远处地": "yóu,yuǎn,chù,de",
  "甲不离将身": "jiǎ,bù,lí,jiàng,shēn",
  "甲兵": "jiá,bīng",
  "甲𠡠": "jiǎ,lài",
  "甲地左": "jiǎ,de,zuǒ",
  "甲坼": "jiá,chè",
  "甲士": "jiá,shì",
  "甲壳": "jiǎ,qiào",
  "甲壳动物": "jiǎ,qiào,dòng,wù",
  "甲壳类": "jiǎ,qiào,lèi",
  "甲壳素": "jiǎ,qiào,sù",
  "甲壳虫": "jiǎ,qiào,chóng",
  "甲宅": "jiá,zhái",
  "甲帖": "jiǎ,tiē",
  "甲库": "jiá,kù",
  "甲扎": "jiǎ,zhā",
  "甲折翁": "jiǎ,shé,wēng",
  "甲楯": "jiǎ,dùn",
  "甲殻": "jiǎ,qiào",
  "甲殻动物": "jiǎ,qiào,dòng,wù",
  "甲𰬔": "jiǎ,bīng",
  "甲胆": "jiá,dǎn",
  "甲舍": "jiǎ,shè",
  "甲长": "jiá,cháng",
  "甲首": "jiá,shǒu",
  "申𠡠": "shēn,lài",
  "申扎": "shēn,zhā",
  "申扎县": "shēn,zhā,xiàn",
  "申斥似地": "shēn,chì,shì,de",
  "申着": "shēn,zhe",
  "申禁": "shēn,jìn",
  "电光朝露": "diàn,guāng,zhāo,lù",
  "电刨": "diàn,bào",
  "电力地": "diàn,lì,de",
  "电动葫芦": "diàn,dòng,hú,lu",
  "电动转盘": "diàn,dòng,zhuàn,pán",
  "电匣子": "diàn,xiá,zi",
  "电发": "diàn,fà",
  "电声乐队": "diàn,shēng,yuè,duì",
  "电子乐器": "diàn,zǐ,yuè,qì",
  "电子出版物": "diàn,zi,chū,bǎn,wù",
  "电子图书": "diàn,zi,tú,shū",
  "电子垃圾": "diàn,zi,lā,jī",
  "电子层数": "diàn,zǐ,céng,shù",
  "电子数字计算机": "diàn,zǐ,shù,zì,jì,suàn,jī",
  "电子数据交换": "diàn,zǐ,shù,jù,jiāo,huàn",
  "电子汇款": "diàn,zi,huì,kuǎn",
  "电子玩具": "diàn,zi,wán,jù",
  "电子词典": "diàn,zi,cí,diǎn",
  "电子音乐": "diàn,zǐ,yīn,yuè",
  "电影片": "diàn,yǐng,piān",
  "电影音乐": "diàn,yǐng,yīn,yuè",
  "电源供应器": "diàn,yuán,gōng,yìng,qì",
  "电熨斗": "diàn,yùn,dǒu",
  "电磁感应": "diàn,cí,gǎn,yìng",
  "电磨": "diàn,mò",
  "电荷": "diàn,hè",
  "电荷守恒定律": "diàn,hè,shǒu,héng,dìng,lǜ",
  "电荷耦合": "diàn,hè,ǒu,hé",
  "电荷耦合器件": "diàn,hè,ǒu,hé,qì,jiàn",
  "电荷量": "diàn,hè,liàng",
  "电褥子": "diàn,rù,zi",
  "电视制导炸弹": "diàn,shì,zhì,dǎo,zhà,dàn",
  "电视差转台": "diàn,shì,chà,zhuàn,tái",
  "电调": "diàn,diào",
  "电转": "diàn,zhuàn",
  "电转儿": "diàn,zhuàn,ér",
  "电转盘": "diàn,zhuàn,pán",
  "电邮位置": "diàn,yóu,wèi,zhi",
  "电钻": "diàn,zuàn",
  "电镐": "diàn,hào",
  "电露": "diàn,lù",
  "电驴子": "diàn,lǘ,zi",
  "男人家": "nán,rén,jia",
  "男仆": "nán,pú",
  "男修道院长": "nán,xiū,dào,yuàn,zhǎng",
  "男傧相": "nán,bīn,xiàng",
  "男女老少": "nán,nǚ,lǎo,shào",
  "男子似地": "nán,zi,shì,de",
  "男子汉大丈夫": "nán,zǐ,hàn,dà,zhàng,fu",
  "男孩乐队": "nán,hái,yuè,duì",
  "男孩儿": "nán,hái,er",
  "男孩子": "nán,hái,zi",
  "男性厌恶": "nán,xìng,yàn,wù",
  "男朋友": "nán,péng,you",
  "男相": "nán,xiàng",
  "甸侯": "diàn,hòu",
  "町崖": "tīng,yá",
  "町畽": "tīng,tuǎn",
  "画儿": "huà,er",
  "画兴": "huà,xīng",
  "画冠": "huà,guān",
  "画刹": "huà,shā",
  "画卷": "huà,juàn",
  "画圈儿": "huà,quān,er",
  "画地为牢": "huà,dì,wéi,láo",
  "画地为狱": "huà,dì,wéi,yù",
  "画夹": "huà,jiā",
  "画帖": "huà,tiè",
  "画数": "huà,shù",
  "画槛": "huà,kǎn",
  "画毂": "huà,gū",
  "画片": "huà,piān",
  "画片儿": "huà,piān,er",
  "画翟": "huà,zhái",
  "画肖像": "huà,xiào,xiàng",
  "画荻和丸": "huà,dí,huò,wán",
  "画蛇著足": "huà,shé,zhuó,zú",
  "画衣冠": "huà,yì,guān",
  "画铺": "huà,pù",
  "画鞞": "huà,bǐ",
  "画龙不成反为狗": "huà,lóng,bù,chéng,fǎn,wéi,gǒu",
  "畀予": "bì,yǔ",
  "畅所欲为": "chàng,suǒ,yù,wéi",
  "畅毂": "chàng,gū",
  "畅适": "chàng,shì",
  "界划": "jiè,huà",
  "畎浍": "quǎn,huì",
  "畏惧地": "wèi,jù,de",
  "畏缩地": "wèi,suō,de",
  "留侯": "liú,hòu",
  "留吁": "liú,yù",
  "留处": "liú,chǔ",
  "留心眼儿": "liú,xīn,yǎn,er",
  "留意地": "liú,yì,de",
  "留更": "liú,gēng",
  "留空": "liú,kòng",
  "留舍": "liú,shè",
  "留都": "liú,dū",
  "留难": "liú,nàn",
  "畚挶": "běn,jū",
  "畜产": "xù,chǎn",
  "畜产品": "xù,chǎn,pǐn",
  "畜养": "xù,yǎng",
  "畜圈": "chù,juàn",
  "畜妻养子": "xù,qī,yǎng,zǐ",
  "畜牧": "xù,mù",
  "畜牧业": "xù,mù,yè",
  "畜牧场": "xù,mù,chǎng",
  "畜积": "xù,jī",
  "畜菟": "chù,tú",
  "畜血": "chù,xuè",
  "畟奸": "jī,jiān",
  "畟然": "jī,rán",
  "畟畟": "jī,jī",
  "畡数": "gāi,shù",
  "略为": "lüè,wéi",
  "略微地": "lüè,wēi,de",
  "畦町": "qí,tīng",
  "番将": "fān,jiàng",
  "番更": "fān,gēng",
  "番禺": "pān,yú",
  "番禺区": "pān,yú,qū",
  "番𫉄": "fān,zhū",
  "畲乡": "yú,xiāng",
  "畸型地": "jī,xíng,de",
  "畹町": "wǎn,dīng",
  "畹町市": "wǎn,dīng,shì",
  "疆干": "jiāng,gàn",
  "疆潦": "jiāng,liáo",
  "疆甽": "jiāng,quǎn",
  "疋似": "pì,sì",
  "疏不间亲": "shū,bù,jiàn,qīn",
  "疏侻": "shū,tuì",
  "疏内": "shū,nè",
  "疏喇喇": "shū,là,là",
  "疏忽": "shū,hu",
  "疏忽地": "shū,hū,de",
  "疏数": "shū,cù",
  "疏朴": "shū,piáo",
  "疏率": "shū,shuài",
  "疏禁": "shū,jìn",
  "疏缪": "shū,miù",
  "疏𬮴": "shū,ān",
  "疐便": "dì,biàn",
  "疐后跋前": "dì,hòu,bá,qián",
  "疐跋": "dì,bá",
  "疑为": "yí,wéi",
  "疑心生𬮴鬼": "yí,xīn,shēng,ān,guǐ",
  "疑惑地": "yí,huò,de",
  "疑惑地想": "yí,huò,de,xiǎng",
  "疑惑地看着": "yí,huò,de,kàn,zhe",
  "疑惑地问": "yí,huò,de,wèn",
  "疑揣": "yí,chuāi",
  "疑缪": "yí,miù",
  "疑背": "yí,bèi",
  "疑问地": "yí,wèn,de",
  "疑间": "yí,jiàn",
  "疖子": "jiē,zi",
  "疙疙瘩瘩": "gē,gē,dā,dá",
  "疙疸": "gē,da",
  "疙瘩": "gē,dā",
  "疙瘩汤": "gē,dā,tāng",
  "疙里疙瘩": "gē,lǐ,gē,dā",
  "疚心疾首": "jiù,xīn,jí,shòu",
  "疟子": "yào,zǐ",
  "疟子花": "yào,zǐ,huā",
  "疟子鬼儿": "yào,zǐ,guǐ,ér",
  "疤痆": "bā,nì",
  "疫病地": "yì,bìng,de",
  "疯子": "fēng,zi",
  "疯子似地": "fēng,zi,shì,de",
  "疯子院": "fēng,zi,yuàn",
  "疯狂似地": "fēng,kuáng,shì,de",
  "疯狂地": "fēng,kuáng,de",
  "疯狂地增长": "fēng,kuáng,de,zēng,zhǎng",
  "疯疯癫癫": "fēng,feng,diān,diān",
  "疯长": "fēng,zhǎng",
  "疲倦地": "pí,juàn,de",
  "疲塌": "pí,ta",
  "疲累": "pí,lèi",
  "疲累地走": "pí,lèi,de,zǒu",
  "疲𦬼": "pí,ěr",
  "疵累": "cī,lèi",
  "疹子": "zhěn,zi",
  "疼痛地": "téng,tòng,de",
  "疾不可为": "jí,bù,kě,wéi",
  "疾恶": "jí,wù",
  "疾恶好善": "jí,wù,hào,shàn",
  "疾速地": "jí,sù,de",
  "疾风劲草": "jí,fēng,jìng,cǎo",
  "疾风彰劲草": "jí,fēng,zhāng,jìng,cǎo",
  "疾风知劲草": "jí,fēng,zhī,jìng,cǎo",
  "疾驰地": "jí,chí,de",
  "痀偻": "jū,lóu",
  "痀㥪": "jū,lóu",
  "痀瘘": "jū,lòu",
  "痂查": "jiā,zhā",
  "病休假": "bìng,xiū,jià",
  "病假": "bìng,jià",
  "病假条": "bìng,jià,tiáo",
  "病包儿": "bìng,bāo,er",
  "病厌厌": "bìng,yān,yān",
  "病因子": "bìng,yīn,zi",
  "病态地": "bìng,tài,de",
  "病毒血症": "bìng,dú,xuè,zhèng",
  "病理地": "bìng,lǐ,de",
  "病病歪歪": "bìng,bing,wāi,wāi",
  "病病殃殃": "bìng,bing,yāng,yāng",
  "病秧子": "bìng,yāng,zi",
  "病累": "bìng,lèi",
  "病革": "bìng,jí",
  "症瘕": "zhēng,jiǎ",
  "症瘕积聚": "zhēng,jiǎ,jī,jù",
  "症结": "zhēng,jié",
  "痉挛性地": "jìng,luán,xìng,de",
  "痉笑地": "jìng,xiào,de",
  "痒痒": "yǎng,yang",
  "痒痒挠": "yǎng,yang,náo",
  "痒磨树者": "yang,mo,shu,zhe",
  "痒背": "yǎng,bèi",
  "痔同": "zhì,tòng",
  "痕累": "hén,lèi",
  "痛切": "tòng,qiè",
  "痛切地": "tòng,qiè,de",
  "痛可言邪": "tong,ke,yan,ye",
  "痛咽": "tòng,yān",
  "痛咽咽": "tòng,yè,yè",
  "痛心切骨": "tòng,xīn,qiè,gǔ",
  "痛快地": "tòng,kuài,de",
  "痛快地哭": "tòng,kuài,de,kū",
  "痛快地打": "tòng,kuài,de,dǎ",
  "痛快地讲": "tòng,kuài,de,jiǎng",
  "痛快地说出来吧": "tòng,kuài,de,shuō,chū,lái,ba",
  "痛恶": "tòng,wù",
  "痛深恶绝": "tòng,shēn,wù,jué",
  "痛煞煞": "tòng,shà,shà",
  "痛痛切切": "tòng,tòng,qiè,qiē",
  "痛痛快快": "tòng,tong,kuài,kuài",
  "痛痛快快地": "tòng,tòng,kuài,kuài,de",
  "痛自创艾": "tòng,zì,chuāng,yì",
  "痛苦地": "tòng,kǔ,de",
  "痛苦地去": "tòng,kǔ,de,qù",
  "痛苦地呻吟": "tòng,kǔ,de,shēn,yín",
  "痛苦地死去": "tòng,kǔ,de,sǐ,qù",
  "痛苦地说": "tòng,kǔ,de,shuō",
  "痞子": "pǐ,zi",
  "痞子蔡": "pǐ,zi,cài",
  "痢疾": "lì,ji",
  "痦子": "wù,zi",
  "痫痓": "xián,chì",
  "痰盂儿": "tán,yú,er",
  "痴云𫘤雨": "chī,yún,ái,yǔ",
  "痴伯子": "chī,bǎi,zǐ",
  "痴儿𫘤女": "chī,ér,ái,nǚ",
  "痴儿𫘤子": "chī,ér,ái,zǐ",
  "痴呆地": "chī,dāi,de",
  "痴男𫘤女": "chī,nán,ái,nǚ",
  "痴痴地": "chī,chī,de",
  "痴痴地想": "chī,chī,de,xiǎng",
  "痴痴地望着": "chī,chī,de,wàng,zhe",
  "痴痴地看着": "chī,chī,de,kàn,zhe",
  "痴痴地等": "chī,chī,de,děng",
  "痴迷地": "chī,mí,de",
  "痴长": "chī,zhǎng",
  "痴顽老子": "chī,wán,lǎo,zi",
  "痴𫘤": "chī,ái",
  "痶痪": "diǎn,huàn",
  "痿蹶": "wěi,juě",
  "瘀血": "yū,xuè",
  "瘁瘅": "cuì,dān",
  "瘅暑": "dān,shǔ",
  "瘅热": "dān,rè",
  "瘅疽": "dān,jū",
  "瘅疾": "dān,jí",
  "瘆得慌": "shèn,de,huāng",
  "瘈疭": "chì,zòng",
  "瘊子": "hóu,zi",
  "瘗埳": "yì,kǎn",
  "瘗毛血": "yì,máo,xuè",
  "瘗薶": "yì,wō",
  "瘗血": "yì,xuè",
  "瘢痆": "bān,nì",
  "瘣木": "lěi,mù",
  "瘣疾": "lěi,jí",
  "瘣𬯎": "lěi,tuí",
  "瘤子": "liú,zi",
  "瘦削": "shòu,xuē",
  "瘦劲": "shòu,jìng",
  "瘦子": "shòu,zi",
  "瘦弱地": "shòu,ruò,de",
  "瘦死的骆驼比马大": "shòu,sǐ,de,luò,tuo,bǐ,mǎ,dà",
  "瘦猴似的": "shòu,hóu,shì,de",
  "瘦猴儿": "shòu,hóu,er",
  "瘦瘦地": "shòu,shòu,de",
  "瘦瘪": "shòu,biě",
  "瘦臒": "shòu,qú",
  "瘦长地": "shòu,cháng,de",
  "瘦长子": "shòu,zhǎng,zǐ",
  "瘦高挑儿": "shòu,gāo,tiǎo,ér",
  "瘩背": "dá,bèi",
  "瘪嘴": "biě,zuǐ",
  "瘪塌塌": "biě,tā,tā",
  "瘪子": "biě,zǐ",
  "瘪扭": "biě,niǔ",
  "瘪煞瘪煞": "biě,shà,biě,shà",
  "瘪瘦": "biě,shòu",
  "瘪窳": "biě,yǔ",
  "瘪螺痧": "biě,luó,shā",
  "瘪陷": "biě,xiàn",
  "瘫子": "tān,zi",
  "瘯蠡": "cù,lí",
  "瘸子": "qué,zi",
  "瘾君子": "yǐn,jūn,zi",
  "瘾头儿": "yǐn,tóu,er",
  "癖好": "pǐ,hào",
  "癖好地": "pǐ,hào,de",
  "癞汉指头": "lài,hàn,zhǐ,tou",
  "癞猴子": "lài,hóu,zi",
  "癞痢": "là,lì",
  "癞虾蟆": "lài,há,má",
  "癞虾蟆想吃天鹅肉": "lài,há,má,xiǎng,chī,tiān,é,ròu",
  "癞蛤蟆": "lài,há,má",
  "癞蛤蟆想吃天鹅肉": "lài,há,má,xiǎng,chī,tiān,é,ròu",
  "癫狂地": "diān,kuáng,de",
  "臒仙": "qú,xiān",
  "臒儒": "qú,rú",
  "臒劣": "qú,liè",
  "臒弊": "qú,bì",
  "臒惙": "qú,chuò",
  "臒毁": "qú,huǐ",
  "臒瘁": "qú,cuì",
  "臒瘠": "qú,jí",
  "臒瘦": "qú,shòu",
  "臒羸": "qú,léi",
  "臒辱": "qú,rǔ",
  "臒露": "qú,lù",
  "臒颜": "qú,yán",
  "登上陆地": "dēng,shàng,lù,de",
  "登兴": "dēng,xīng",
  "登台拜将": "dēng,tái,bài,jiàng",
  "登坛拜将": "dēng,tán,bài,jiàng",
  "登得": "dēng,de",
  "登㧛": "dēng,lǎn",
  "登祇": "dēng,qí",
  "登载": "dēng,zǎi",
  "登陴": "dēng,pí",
  "白不呲咧": "bái,bù,cī,liě",
  "白云亲舍": "bái,yún,qīn,shè",
  "白云观": "bái,yún,guàn",
  "白云青舍": "bái,yún,qīng,shè",
  "白侯": "bái,hòu",
  "白公堤": "bái,gōng,dī",
  "白冠": "bái,guān",
  "白冠厘缨": "bái,guān,lí,yīng",
  "白冠噪鹛": "bái,guān,zào,méi",
  "白冠攀雀": "bái,guān,pān,què",
  "白冠燕尾": "bái,guān,yàn,wěi",
  "白冠牦缨": "bái,guān,máo,yīng",
  "白冠长尾雉": "bái,guān,cháng,wěi,zhì",
  "白刀子进去": "bái,dāo,zi,jìn,qù",
  "白削": "bái,xuē",
  "白卷": "bái,juàn",
  "白发": "bái,fà",
  "白发丹心": "bái,fà,dān,xīn",
  "白发人送黑发人": "bái,fà,rén,sòng,hēi,fà,rén",
  "白发千丈": "bái,fà,qiān,zhàng",
  "白发朱颜": "bái,fà,zhū,yán",
  "白发红颜": "bái,fà,hóng,yán",
  "白发苍苍": "bái,fà,cāng,cāng",
  "白发苍颜": "bái,fà,cāng,yán",
  "白发青衫": "bái,fà,qīng,shān",
  "白发鱼": "bái,fà,yú",
  "白哗哗": "bái,huā,huā",
  "白喉冠鹎": "bái,hóu,guān,bēi",
  "白喉杆菌": "bái,hóu,gǎn,jūn",
  "白大衣高血压": "bái,dà,yī,gāo,xuè,yā",
  "白夹": "bái,jiā",
  "白夹蓝衫": "bái,jiā,lán,shān",
  "白帆": "bái,fān",
  "白帢青衫": "bái,jiá,qīng,shān",
  "白干": "bái,qián",
  "白房子": "bái,fáng,zi",
  "白手兴家": "bái,shǒu,xīng,jiā",
  "白日衣绣": "bái,rì,yì,xiù",
  "白昼地": "bái,zhòu,de",
  "白晃晃": "bái,huàng,huǎng",
  "白术": "bái,zhú",
  "白杆兵": "bái,gǎn,bīng",
  "白杆军": "bái,gǎn,jūn",
  "白条子": "bái,tiáo,zi",
  "白沙在涅": "bái,shān,zài,niè",
  "白沙堤": "bái,shā,dī",
  "白炉子": "bái,lú,zi",
  "白热地": "bái,rè,de",
  "白版侯": "bái,bǎn,hòu",
  "白玩儿": "bái,wán,er",
  "白珩": "bái,háng",
  "白班儿": "bái,bān,er",
  "白甚么": "bái,shèn,mǒ",
  "白痴地": "bái,chī,de",
  "白白地": "bái,bái,de",
  "白白地死": "bái,bái,de,sǐ",
  "白白地浪费了": "bái,bái,de,làng,fèi,le",
  "白相": "bái,xiàng",
  "白相人": "bái,xiàng,rén",
  "白眼儿狼": "bái,yǎn,er,láng",
  "白眼珠儿": "bái,yǎn,zhū,er",
  "白眼珠子": "bái,yǎn,zhū,zi",
  "白着": "bái,zhe",
  "白石砬子": "bái,shí,lá,zi",
  "白翟": "bái,zhái",
  "白背": "bái,bèi",
  "白背兀鹫": "bái,bèi,wù,jiù",
  "白背啄木鸟": "bái,bèi,zhuó,mù,niǎo",
  "白背矶鸫": "bái,bèi,jī,dōng",
  "白舍人行诗图": "bái,shè,rén,xíng,shī,tú",
  "白茬儿": "bái,chá,er",
  "白菟": "bái,tú",
  "白萝卜": "bái,luó,bo",
  "白葛": "bái,gě",
  "白虎观": "bái,hǔ,guàn",
  "白蛇传": "bái,shé,zhuàn",
  "白血": "bái,xuè",
  "白血球": "bái,xuè,qiú",
  "白血病": "bái,xuè,bìng",
  "白衣冠": "bái,yì,guān",
  "白衣卿相": "bái,yī,qīng,xiàng",
  "白衣宰相": "bái,yī,zǎi,xiàng",
  "白衫儿": "bái,shān,er",
  "白话地": "bái,huà,de",
  "白贲": "bái,bēn",
  "白送地": "bái,sòng,de",
  "白酂": "bái,zàn",
  "白铜堤": "bái,tóng,dī",
  "白铺": "bái,pù",
  "白露": "bái,lù",
  "白面儒冠": "bái,miàn,rú,guān",
  "白面儿": "bái,miàn,er",
  "白额侯": "bái,é,hòu",
  "白首为功名": "bái,shǒu,wéi,gōng,míng",
  "白首为郎": "bái,shǒu,wéi,láng",
  "白马长史": "bái,mǎ,zhǎng,shǐ",
  "白驹过郄": "bái,jū,guò,xì",
  "白骨露野": "bái,gǔ,lù,yě",
  "白鹡鸰": "bái,jí,líng",
  "白鹭𬙋": "bái,lù,rǎng",
  "白鹭缞": "bái,lù,shuāi",
  "白鼻子": "bái,bí,zi",
  "百万买宅": "bǎ,wàn,mǎi,zhái",
  "百万倍地": "bǎi,wàn,bèi,de",
  "百下百着": "bǎi,xià,bǎi,zháo",
  "百不为多": "bǎi,bù,wéi,duō",
  "百不咋": "bǎi,bù,za",
  "百不杂": "bǎi,bù,za",
  "百中": "bǎi,zhòng",
  "百中百发": "bǎi,zhòng,bǎi,fā",
  "百为": "bǎi,wéi",
  "百乘": "bǎi,shèng",
  "百了千当": "bǎi,liǎo,qiān,dāng",
  "百什": "bǎi,shí",
  "百倍地": "bǎi,bèi,de",
  "百兽率舞": "bǎi,shòu,shuài,wǔ",
  "百分位数": "bǎi,fēn,wèi,shù",
  "百分数": "bǎi,fēn,shù",
  "百发百中": "bǎi,fā,bǎi,zhòng",
  "百和": "bǎi,hè",
  "百和香": "bǎi,hè,xiāng",
  "百善孝为先": "bǎi,shàn,xiào,wéi,xiān",
  "百堕俱举": "bǎi,huī,jù,jǔ",
  "百夫长": "bǎi,fū,zhǎng",
  "百孔千创": "bǎi,kǒng,qiān,chuāng",
  "百废俱兴": "bǎi,fèi,jù,xīng",
  "百废具兴": "bǎi,fèi,jù,xīng",
  "百废待兴": "bǎi,fèi,dài,xīng",
  "百度知道": "bǎi,dù,zhī,dao",
  "百数": "bǎi,shù",
  "百无禁忌": "bǎi,wú,jìn,jì",
  "百日咳": "bǎi,rì,hāi",
  "百祇": "bǎi,qí",
  "百累": "bǎi,lèi",
  "百舍": "bǎi,shè",
  "百舍重茧": "bǎi,shè,chóng,jiǎn",
  "百舍重趼": "bǎi,shè,chóng,jiǎn",
  "百般刁难": "bǎi,bān,diāo,nàn",
  "百色起义": "bó,sè,qǐ,yì",
  "百花朝": "bǎi,huā,zhāo",
  "百螣": "bǎi,tè",
  "百载": "bǎi,zǎi",
  "百载树人": "bǎi,zǎi,shù,rén",
  "百辟": "bǎi,bì",
  "百适": "bǎi,shì",
  "百𰺷": "bǎi,rǎo",
  "百金求间": "bǎi,jīn,qiú,jiàn",
  "皂舃": "zào,tuō",
  "的一确二": "dí,yī,què,èr",
  "的卡": "dí,kǎ",
  "的卢": "dì,lú",
  "的历": "dì,lì",
  "的哥": "dī,gē",
  "的士": "dī,shì",
  "的士高": "dí,shì,gāo",
  "的姐": "dī,jiě",
  "的应": "de,yìng",
  "的当": "dí,dàng",
  "的款": "dí,kuǎn",
  "的溜骨碌": "de,liū,gū,lù",
  "的的": "dí,dí",
  "的的喀喀湖": "dì,dì,kā,kā,hú",
  "的的圆": "de,dí,yuán",
  "的真": "dí,zhēn",
  "的着": "de,zhe",
  "的确": "dí,què",
  "的确凉": "dí,què,liáng",
  "的确良": "dí,què,liáng",
  "的证": "dí,zhèng",
  "的里雅斯特": "dì,lǐ,yǎ,sī,tè",
  "的黎波里": "dì,lí,bō,lǐ",
  "皇上不急太监急": "huáng,shàng,bù,jí,tài,jiàn,jí",
  "皇上不急急太监": "huáng,shàng,bù,jí,jí,tài,jiàn",
  "皇冠": "huáng,guān",
  "皇冠上的明珠": "huáng,guān,shàng,de,míng,zhū",
  "皇冠假日酒店": "huáng,guān,jià,rì,jiǔ,diàn",
  "皇冠出版": "huáng,guān,chū,bǎn",
  "皇冠出版集团": "huáng,guān,chū,bǎn,jí,tuán",
  "皇历": "huáng,li",
  "皇地祇": "huáng,dì,qí",
  "皇㛤": "huáng,lí",
  "皇帝不急太监急": "huáng,dì,bù,jí,tài,jiàn,jí",
  "皇帝不急急死太监": "huáng,dì,bù,jí,jí,sǐ,tài,jiàn",
  "皇帝老子": "huáng,dì,lǎo,zi",
  "皇带子": "huáng,dài,zi",
  "皇干": "huáng,gàn",
  "皇曾祖": "huáng,zēng,zǔ",
  "皇祇": "huáng,qí",
  "皋陶": "gāo,yáo",
  "皎皛": "jiǎo,jiǎo",
  "皎阳似火": "jiǎo,yáng,shì,huǒ",
  "皓发": "hào,fà",
  "皓晃": "hào,huàng",
  "皓皛": "hào,jiǎo",
  "皓簳": "hào,gàn",
  "皓露": "hào,lù",
  "皛光": "jiǎo,guāng",
  "皛旷": "jiǎo,kuàng",
  "皛淼": "jiǎo,miǎo",
  "皛清": "jiǎo,qīng",
  "皛溔": "jiǎo,yǎo",
  "皛白": "jiǎo,bái",
  "皛皎": "jiǎo,jiǎo",
  "皛皛": "jiǎo,jiǎo",
  "皛耀": "jiǎo,yào",
  "皛饭": "jiǎo,fàn",
  "皦絜": "jiǎo,jié",
  "皮侯": "pí,hòu",
  "皮儿": "pí,er",
  "皮冠": "pí,guān",
  "皮剥": "pí,bāo",
  "皮剥所": "pí,bāo,suǒ",
  "皮包骨头": "pí,bāo,gú,tou",
  "皮匠": "pí,jiang",
  "皮壳": "pí,qiào",
  "皮夹": "pí,jiā",
  "皮夹克": "pí,jiā,kè",
  "皮夹子": "pí,jiā,zi",
  "皮子": "pí,zi",
  "皮子面": "pí,zi,miàn",
  "皮实": "pí,shi",
  "皮干": "pí,gàn",
  "皮毱": "pí,jú",
  "皮猴子": "pí,hóu,zi",
  "皮相": "pí,xiàng",
  "皮相之见": "pí,xiàng,zhī,jiàn",
  "皮相之谈": "pí,xiàng,zhī,tán",
  "皮破血流": "pí,pò,xuè,liú",
  "皮褥子": "pí,rù,zi",
  "皮蹴毱": "pí,cù,jú",
  "皮馄饨": "pí,hún,tun",
  "皱眉头": "zhòu,méi,tou",
  "皱面还丹": "zhòu,miàn,huán,dān",
  "皴剥": "cūn,bāo",
  "皿卷": "mǐn,juàn",
  "盆子": "pén,zi",
  "盈千累万": "yíng,qiān,lěi,wàn",
  "盈把": "yíng,bà",
  "盈数": "yíng,shù",
  "盈溢地": "yíng,yì,de",
  "盈盈秋水": "yíng,yíng,shuǐ,qiū",
  "盈箱累箧": "yíng,xiāng,lěi,qiè",
  "盈篇累牍": "yíng,piān,lěi,dú",
  "益觉困难": "yì,jué,kùn,nan",
  "盐分": "yán,fèn",
  "盐呆子": "yán,dāi,zi",
  "盐坨子": "yán,tuó,zi",
  "盐干皮": "yán,gàn,pí",
  "盐数": "yán,shù",
  "盐渍地": "yán,zì,de",
  "盐禁": "yán,jìn",
  "盐䇲": "yán,jiā",
  "盐角儿": "yán,jué,ér",
  "盐角儿令": "yán,jué,ér,lìng",
  "盐都": "yán,dū",
  "盐都区": "yán,dū,qū",
  "盐酢": "yán,cù",
  "盐酰": "yán,xī",
  "盐钻粱": "yán,zuàn,liáng",
  "盐铺": "yán,pù",
  "盐驮子": "yán,duò,zǐ",
  "监仆": "jiān,pú",
  "监伺": "jiān,sì",
  "监利": "jiàn,lì",
  "监帖": "jiān,tiē",
  "监本": "jiàn,běn",
  "监河侯": "jiān,hé,hòu",
  "监生": "jiàn,shēng",
  "监禁": "jiān,jìn",
  "监铺": "jiān,pù",
  "盒子": "hé,zi",
  "盒子会": "hé,zi,huì",
  "盒子枪": "hé,zi,qiāng",
  "盒子炮": "hé,zi,pào",
  "盒子菜": "hé,zi,cài",
  "盔头": "kuī,tou",
  "盖上": "gài,shang",
  "盖儿": "gài,er",
  "盖子": "gài,zi",
  "盖老": "gě,lǎo",
  "盖革计数器": "gài,gé,jì,shù,qì",
  "盗剽": "dào,piāo",
  "盗帑": "dào,tǎng",
  "盗录行为": "dào,lù,xíng,wéi",
  "盗掠": "dào,lüě",
  "盗穵": "dào,yà",
  "盗颉": "dào,jiá",
  "盘儿菜": "pán,er,cài",
  "盘固侯": "pán,gù,hòu",
  "盘子": "pán,zi",
  "盘子头": "pán,zi,tóu",
  "盘折": "pán,shé",
  "盘旋曲折": "pán,xuán,qū,zhé",
  "盘曲": "pán,qū",
  "盘杠子": "pán,gàng,zi",
  "盘水加剑": "pan,shui,jia,jian",
  "盘载": "pán,zǎi",
  "盛器": "chéng,qì",
  "盛大地": "shèng,dà,de",
  "盛怒地": "shèng,nù,de",
  "盛水不漏": "chéng,shuǐ,bù,lòu",
  "盛满": "chéng,mǎn",
  "盛筵易散": "shèng,yàn,yì,sàn",
  "盛菜": "chéng,cài",
  "盛衰兴废": "shèng,shuāi,xīng,fèi",
  "盛装": "chéng,zhuāng",
  "盛载": "shèng,zǎi",
  "盛锐": "shèng,duì",
  "盛饭": "chéng,fàn",
  "盟载": "méng,zǎi",
  "盥澣": "guàn,hàn",
  "目下十行": "mù,xià,shí,háng",
  "目不暇给": "mù,bù,xiá,jǐ",
  "目不转睛地": "mù,bù,zhuǎn,jīng,de",
  "目为": "mù,wéi",
  "目前为止": "mù,qián,wéi,zhǐ",
  "目前地": "mù,qián,de",
  "目挑心招": "mù,tiǎo,xīn,zhāo",
  "目擩耳染": "mù,rù,ěr,rǎn",
  "目数": "mù,shù",
  "目无尊长": "mù,wú,zūn,zhǎng",
  "目标地": "mù,biāo,de",
  "目濡耳染": "mù,rǔ,ěr,rǎn",
  "目的": "mù,dì",
  "目的地": "mù,dì,dì",
  "目的性": "mù,dì,xìng",
  "目的物": "mù,dì,wù",
  "目的论": "mù,dì,lùn",
  "目𥆧": "mù,shùn",
  "目瞪舌彊": "mù,dèng,shé,jiàng",
  "目禁": "mù,jìn",
  "目空一切": "mù,kōng,yī,qiè",
  "目翫": "mù,wàn",
  "目识": "mù,zhì",
  "盱睢": "xū,suī",
  "盲信地": "máng,xìn,de",
  "盲干": "máng,gàn",
  "盲目地": "máng,mù,de",
  "盲翁扪钥": "máng,wēng,mén,yào",
  "直不笼统": "zhí,bù,lǒng,tǒng",
  "直勾勾地": "zhí,gōu,gōu,de",
  "直发": "zhí,fà",
  "直发人": "zhí,fà,rén",
  "直发器": "zhí,fà,qì",
  "直发板": "zhí,fà,bǎn",
  "直奔": "zhí,bèn",
  "直帖": "zhí,tiē",
  "直干": "zhí,gàn",
  "直得": "zhí,de",
  "直怔怔": "zhí,zhèng,zhèng",
  "直性子": "zhí,xìng,zi",
  "直愣愣地": "zhí,lèng,lèng,de",
  "直截了当": "zhí,jié,liǎo,dàng",
  "直截地": "zhí,jié,de",
  "直拗": "zhí,niù",
  "直挺挺地": "zhí,tǐng,tǐng,de",
  "直捷了当": "zhí,jié,liǎo,dàng",
  "直接了当": "zhí,jiē,liǎo,dàng",
  "直接了当地": "zhí,jiē,liǎo,dàng,de",
  "直接数据": "zhí,jiē,shù,jù",
  "直更": "zhí,gēng",
  "直朴": "zhí,piáo",
  "直朴无华": "zhí,piáo,wú,huá",
  "直楞楞": "zhí,lèng,lèng",
  "直爽地": "zhí,shuǎng,de",
  "直率": "zhí,shuài",
  "直率地": "zhí,shuài,de",
  "直率地说": "zhí,shuài,de,shuō",
  "直直地": "zhí,zhí,de",
  "直瞪瞪地": "zhí,dèng,dèng,de",
  "直筒子": "zhí,tǒng,zi",
  "直系地": "zhí,xì,de",
  "直系血亲": "zhí,xì,xuè,qìng",
  "直线地": "zhí,xiàn,de",
  "直缝": "zhí,fèng",
  "直肠子": "zhí,cháng,zi",
  "直舍": "zhí,shè",
  "直观地": "zhí,guān,de",
  "直觉地": "zhí,jué,de",
  "直角地": "zhí,jiǎo,de",
  "直言不讳地": "zhí,yán,bù,huì,de",
  "直言地": "zhí,yán,de",
  "直言贾祸": "zhí,yán,gǔ,huò",
  "直蹶蹶": "zhí,juě,juě",
  "直进地": "zhí,jìn,de",
  "直馏": "zhí,liú",
  "相与为一": "xiāng,yǔ,wéi,yī",
  "相中": "xiāng,zhòng",
  "相为": "xiāng,wéi",
  "相为命": "xiāng,wéi,mìng",
  "相为表里": "xiāng,wéi,biǎo,lǐ",
  "相互地": "xiāng,hù,de",
  "相交数": "xiāng,jiāo,shù",
  "相似地": "xiāng,sì,de",
  "相位": "xiàng,wèi",
  "相位差": "xiàng,wèi,chā",
  "相体裁衣": "xiàng,tǐ,cái,yī",
  "相依为命": "xiāng,yī,wéi,mìng",
  "相信地": "xiāng,xìn,de",
  "相公": "xiàng,gōng",
  "相公堂子": "xiàng,gōng,táng,zǐ",
  "相公竹": "xiàng,gōng,zhú",
  "相公鹾": "xiàng,gōng,cuó",
  "相关地": "xiāng,guān,de",
  "相册": "xiàng,cè",
  "相冲突地": "xiāng,chōng,tū,de",
  "相出没": "xiāng,chū,mò",
  "相反地": "xiāng,fǎn,de",
  "相反数": "xiāng,fǎn,shù",
  "相同地": "xiāng,tóng,de",
  "相和": "xiāng,hè",
  "相和歌": "xiāng,hè,gē",
  "相喣以沫": "xiāng,xù,yǐ,mò",
  "相国": "xiàng,guó",
  "相国寺": "xiàng,guó,sì",
  "相国庄": "xiàng,guó,zhuāng",
  "相图": "xiàng,tú",
  "相士": "xiàng,shì",
  "相声": "xiàng,shēng",
  "相处": "xiāng,chǔ",
  "相夫教子": "xiàng,fū,jiào,zǐ",
  "相女配夫": "xiàng,nǚ,pèi,fū",
  "相如": "xiàng,rú",
  "相如台": "xiàng,rú,tái",
  "相如檄": "xiàng,rú,xí",
  "相如渴": "xiàng,rú,kě",
  "相如草": "xiàng,rú,cǎo",
  "相宜地": "xiāng,yí,de",
  "相容地": "xiāng,róng,de",
  "相对位置": "xiāng,duì,wèi,zhi",
  "相对地": "xiāng,duì,de",
  "相对地说": "xiāng,duì,de,shuō",
  "相对正确地": "xiāng,duì,zhèng,què,de",
  "相对象": "xiàng,duì,xiàng",
  "相属": "xiāng,zhǔ",
  "相差不多": "xiāng,chà,bu,duō",
  "相差不大": "xiāng,chā,bú,dà",
  "相差无几": "xiāng,chā,wú,jǐ",
  "相差甚远": "xiāng,chā,shèn,yuǎn",
  "相平面": "xiàng,píng,miàn",
  "相并地": "xiāng,bìng,de",
  "相应": "xiāng,yìng",
  "相应地": "xiāng,yìng,de",
  "相异地": "xiāng,yì,de",
  "相当地": "xiāng,dāng,de",
  "相当地不错": "xiāng,dāng,de,bù,cuò",
  "相当地同意": "xiāng,dāng,de,tóng,yì",
  "相当地好": "xiāng,dāng,de,hǎo",
  "相当地好用": "xiāng,dāng,de,hǎo,yòng",
  "相当地完善": "xiāng,dāng,de,wán,shàn",
  "相当地快": "xiāng,dāng,de,kuài",
  "相当地有效": "xiāng,dāng,de,yǒu,xiào",
  "相当地棒": "xiāng,dāng,de,bàng",
  "相当地火": "xiāng,dāng,de,huǒ",
  "相当地高": "xiāng,dāng,de,gāo",
  "相当多地": "xiāng,dāng,duō,de",
  "相当大地": "xiāng,dāng,dà,de",
  "相当快地": "xiāng,dāng,kuài,de",
  "相得": "xiāng,de",
  "相得无间": "xiāng,dé,wú,jiàn",
  "相懽": "xiāng,guàn",
  "相扑": "xiàng,pū",
  "相扑人": "xiàng,pū,rén",
  "相扑手": "xiàng,pū,shǒu",
  "相斥地": "xiāng,chì,de",
  "相时度力": "xiāng,shí,duó,lì",
  "相时而动": "xiàng,shí,ér,dòng",
  "相朴人": "xiāng,piáo,rén",
  "相机": "xiàng,jī",
  "相机而动": "xiàng,jī,ér,dòng",
  "相机而行": "xiàng,jī,ér,xíng",
  "相架": "xiàng,jià",
  "相框": "xiàng,kuàng",
  "相比地": "xiāng,bǐ,de",
  "相片": "xiàng,piān",
  "相片儿": "xiàng,piān,er",
  "相牟": "xiāng,mù",
  "相率": "xiāng,shuài",
  "相着": "xiāng,zhe",
  "相称": "xiāng,chèn",
  "相称地": "xiāng,chèn,de",
  "相称性地": "xiāng,chèn,xìng,de",
  "相空间": "xiàng,kōng,jiān",
  "相等地": "xiāng,děng,de",
  "相簿": "xiàng,bù",
  "相纸": "xiàng,zhǐ",
  "相继地": "xiāng,jì,de",
  "相缪": "xiāng,miù",
  "相背": "xiāng,bèi",
  "相藉": "xiāng,jí",
  "相角": "xiàng,jiǎo",
  "相貌": "xiàng,mào",
  "相貌堂堂": "xiàng,mào,táng,táng",
  "相貌寒碜": "xiàng,mào,hán,chěn",
  "相轧": "xiāng,zhá",
  "相连地": "xiāng,lián,de",
  "相遗以水": "xiāng,wèi,yǐ,shuǐ",
  "相配地": "xiāng,pèi,de",
  "相里": "xiàng,lǐ",
  "相门有相": "xiàng,mén,yǒu,xiàng",
  "相间": "xiāng,jiàn",
  "相面": "xiàng,miàn",
  "相面先生": "xiàng,miàn,xiān,shēng",
  "相须为命": "xiāng,xū,wéi,mìng",
  "相风使帆": "xiāng,fēng,shǐ,fān",
  "相马": "xiàng,mǎ",
  "相鼠有皮": "xiàng,shǔ,yǒu,pí",
  "相齐地": "xiāng,qí,de",
  "盹儿": "dǔn,er",
  "盼头": "pàn,tou",
  "省亲": "xǐng,qīn",
  "省俗": "xǐng,sú",
  "省劲儿": "shěng,jìn,er",
  "省察": "xǐng,chá",
  "省得": "shěng,de",
  "省悟": "xǐng,wù",
  "省方": "xǐng,fāng",
  "省略地": "shěng,lüè,de",
  "省省吧": "shěng,sheng,ba",
  "省着": "shěng,zhe",
  "省禁": "shěng,jìn",
  "省舍": "shěng,shè",
  "省视": "xǐng,shì",
  "省览": "xǐng,lǎn",
  "省觐": "xǐng,jìn",
  "省身克己": "xǐng,shēn,kè,jǐ",
  "省过": "xǐng,guò",
  "省长": "shěng,zhǎng",
  "省阅": "xǐng,yuè",
  "眄伺": "miǎn,sì",
  "眄眄": "miàn,miàn",
  "眄睐": "miàn,lài",
  "眄睨": "miàn,nì",
  "眄视": "miàn,shì",
  "眄视指使": "miǎn,shǐ,zhǐ,shǐ",
  "眇么": "miǎo,mǒ",
  "眉头一皱": "méi,tou,yí,zhòu",
  "眉嵴": "méi,jí",
  "眉毛": "méi,mao",
  "眉毛胡子一把抓": "méi,máo,hú,zi,yī,bǎ,zhuā",
  "眉𰮇": "méi,wǔ",
  "看上去": "kàn,shang,qu",
  "看不中": "kàn,bu,zhōng",
  "看不出": "kàn,bu,chū",
  "看不出地": "kàn,bù,chū,de",
  "看不懂": "kàn,bu,dǒng",
  "看不见": "kàn,bú,jiàn",
  "看不见地": "kàn,bú,jiàn,de",
  "看不过去": "kàn,bu,guò,qu",
  "看中": "kàn,zhòng",
  "看他不停地": "kàn,tā,bù,tíng,de",
  "看伺": "kàn,sì",
  "看吧": "kàn,ba",
  "看在眼里": "kàn,zài,yǎn,li",
  "看场": "kān,chǎng",
  "看头": "kàn,tou",
  "看头儿": "kàn,tou,er",
  "看守": "kān,shǒu",
  "看守内阁": "kān,shǒu,nèi,gé",
  "看守所": "kān,shǒu,suǒ",
  "看守者": "kān,shǒu,zhě",
  "看家": "kān,jiā",
  "看家戏": "kān,jiā,xì",
  "看家本事": "kān,jiā,běn,shì",
  "看家本领": "kān,jiā,běn,lǐng",
  "看家狗": "kān,jiā,gǒu",
  "看得": "kàn,de",
  "看得中": "kàn,de,zhòng",
  "看得出": "kàn,de,chū",
  "看得懂": "kàn,de,dǒng",
  "看得清": "kàn,de,qīng",
  "看得见地": "kàn,dé,jiàn,de",
  "看得起": "kàn,de,qǐ",
  "看得过": "kàn,de,guò",
  "看得过儿": "kàn,de,guò,er",
  "看护": "kān,hù",
  "看押": "kān,yā",
  "看日子": "kàn,rì,zi",
  "看样子": "kàn,yàng,zi",
  "看热闹": "kàn,rè,nao",
  "看煞": "kàn,shà",
  "看相": "kàn,xiàng",
  "看着": "kàn,zhe",
  "看着不管": "kàn,zhe,bù,guǎn",
  "看着办": "kàn,zhe,bàn",
  "看穿了地": "kàn,chuān,le,de",
  "看管": "kān,guǎn",
  "看翫": "kàn,wàn",
  "看肖神": "kàn,xiào,shén",
  "看花眼": "kān,huā,yǎn",
  "看起来是那样地": "kàn,qǐ,lái,shì,nà,yàng,de",
  "看跌": "kàn,diē",
  "看门": "kān,mén",
  "看门人": "kān,mén,rén",
  "看门狗": "kān,mén,gǒu",
  "看风使帆": "kàn,fēng,shǐ,fān",
  "眍䁖": "kōu,lou",
  "真人不露相": "zhēn,rén,bù,lòu,xiàng",
  "真分数": "zhēn,fēn,shù",
  "真切": "zhēn,qiè",
  "真孃": "zhēn,ráng",
  "真孃墓": "zhēn,ráng,mù",
  "真实地": "zhēn,shí,de",
  "真宰相": "zhēn,zǎi,xiàng",
  "真帖": "zhēn,tiē",
  "真挚地": "zhēn,zhì,de",
  "真数": "zhēn,shù",
  "真是": "zhēn,shi",
  "真是的": "zhēn,shi,de",
  "真朴": "zhēn,piáo",
  "真枪实弹": "zhēn,qiāng,shí,dàn",
  "真正地": "zhēn,zhèng,de",
  "真正地做": "zhēn,zhèng,de,zuò",
  "真正地去": "zhēn,zhèng,de,qù",
  "真正地快乐": "zhēn,zhèng,de,kuài,lè",
  "真正地满足": "zhēn,zhèng,de,mǎn,zú",
  "真率": "zhēn,shuài",
  "真率会": "zhēn,shuài,huì",
  "真率社": "zhēn,shuài,shè",
  "真番郡": "zhēn,pān,jùn",
  "真相": "zhēn,xiàng",
  "真相大白": "zhēn,xiàng,dà,bái",
  "真相毕露": "zhēn,xiāng,bì,lù",
  "真真正正地": "zhēn,zhēn,zhèng,zhèng,de",
  "真着": "zhēn,zhe",
  "真空地带": "zhēn,kòng,dì,dài",
  "真脏实犯": "zhēn,zāng,shí,fàn",
  "真菌界": "zhēn,jùn,jiè",
  "真诚地": "zhēn,chéng,de",
  "真诚地去": "zhēn,chéng,de,qù",
  "真诚地希望": "zhēn,chéng,de,xī,wàng",
  "真诚地说": "zhēn,chéng,de,shuō",
  "真龙地": "zhēn,lóng,de",
  "眡瞭": "shì,le",
  "眦血": "zì,xuè",
  "眦裂发指": "zì,liè,fà,zhǐ",
  "眨巴": "zhǎ,ba",
  "眩仆": "xuàn,pú",
  "眩晃": "xuàn,huàng",
  "眩晕仆地": "xuàn,yūn,pū,de",
  "眯盹儿": "mī,dǔn,er",
  "眯糊": "mī,hu",
  "眯紧": "mǐ,jǐn",
  "眯缝": "mī,feng",
  "眴目": "shùn,mù",
  "眵目糊": "chī,mu,hū",
  "眸子": "móu,zi",
  "眸𰥨": "móu,jiàn",
  "眼不着砂": "yǎn,bù,zhe,shā",
  "眼不见为净": "yǎn,bù,jiàn,wéi,jìng",
  "眼不见为浄": "yǎn,bú,jiàn,wéi,jìng",
  "眼不转睛": "yǎn,bù,zhuàn,jīng",
  "眼侯": "yǎn,hòu",
  "眼巴巴地": "yǎn,bā,bā,de",
  "眼底下": "yǎn,dǐ,xia",
  "眼怔怔": "yǎn,zhèng,zhèng",
  "眼晕": "yǎn,yùn",
  "眼泡": "yǎn,pāo",
  "眼泪横流": "yǎn,lèi,hèng,liú",
  "眼犄角儿": "yǎn,jī,jué,ér",
  "眼珠儿": "yǎn,zhū,er",
  "眼珠子": "yǎn,zhū,zi",
  "眼皮子": "yǎn,pí,zi",
  "眼皮子底下": "yǎn,pí,zi,dǐ,xià",
  "眼皮子浅": "yǎn,pí,zi,qiǎn",
  "眼皮子高": "yǎn,pí,zi,gāo",
  "眼皮底下": "yǎn,pí,dǐ,xia",
  "眼看得": "yǎn,kàn,de",
  "眼眶子": "yǎn,kuàng,zi",
  "眼睁睁地": "yǎn,zhēng,zhēng,de",
  "眼睁睁地看着": "yǎn,zhēng,zhēng,de,kàn,zhe",
  "眼睛": "yǎn,jing",
  "眼睛吃冰淇淋": "yǎn,jing,chī,bīng,qí,lín",
  "眼睛珠子": "yǎn,jīng,zhū,zi",
  "眼𥆧": "yǎn,shùn",
  "眼红红地": "yǎn,hóng,hóng,de",
  "眼花地": "yǎn,huā,de",
  "眼花撩乱": "yǎn,huā,liáo,luàn",
  "眼见为实": "yǎn,jiàn,wéi,shí",
  "眼见得": "yǎn,jiàn,de",
  "眼观为实": "yǎn,guān,wéi,shí",
  "眼里容不得沙子": "yǎn,lǐ,róng,bu,dé,shā,zi",
  "眼里揉不下沙子": "yǎn,lǐ,róu,bù,xià,shā,zi",
  "眼里揉不得沙子": "yǎn,lǐ,róu,bu,dé,shā,zi",
  "眼错不见": "yǎn,cuò,bú,jiàn",
  "眼露杀气": "yǎn,lù,shā,qì",
  "着三不着两": "zháo,sān,bù,zháo,liǎng",
  "着业": "zhe,yè",
  "着么": "zhe,mǒ",
  "着人": "zhe,rén",
  "着位": "zhe,wèi",
  "着作": "zhe,zuò",
  "着作权": "zhe,zuò,quán",
  "着作郎": "zhe,zuò,láng",
  "着便": "zhe,biàn",
  "着先鞭": "zhe,xiān,biān",
  "着凉": "zháo,liáng",
  "着劲儿": "zhuó,jìn,er",
  "着号": "zhe,hào",
  "着名": "zhe,míng",
  "着呢": "zhe,ne",
  "着哩": "zhe,lǐ",
  "着地": "zháo,dì",
  "着声": "zhe,shēng",
  "着姓": "zhe,xìng",
  "着定": "zhe,dìng",
  "着己": "zhe,jǐ",
  "着帐": "zhe,zhàng",
  "着帐户": "zhe,zhàng,hù",
  "着帐郎君": "zhe,zhàng,láng,jūn",
  "着庸": "zhe,yōng",
  "着心": "zhe,xīn",
  "着志": "zhe,zhì",
  "着忙": "zháo,máng",
  "着急": "zháo,jí",
  "着急地": "zháo,jí,de",
  "着急地想要": "zháo,jí,de,xiǎng,yào",
  "着急地说": "zháo,jí,de,shuō",
  "着急地问": "zháo,jí,de,wèn",
  "着惊": "zhe,jīng",
  "着慌": "zháo,huāng",
  "着手生春": "zhe,shǒu,shēng,chūn",
  "着抹": "zhe,mǒ",
  "着摸": "zhe,mō",
  "着撰": "zhe,zhuàn",
  "着数": "zhāo,shù",
  "着明": "zhe,míng",
  "着末": "zhe,mò",
  "着极": "zhe,jí",
  "着格": "zhe,gé",
  "着槁": "zhe,gǎo",
  "着气": "zhe,qì",
  "着水": "zhe,shuǐ",
  "着法": "zhāo,fǎ",
  "着浅": "zhe,qiǎn",
  "着火": "zháo,huǒ",
  "着火地": "zháo,huǒ,de",
  "着火点": "zháo,huǒ,diǎn",
  "着甚": "zhe,shèn",
  "着生": "zhe,shēng",
  "着疑": "zhe,yí",
  "着相": "zhe,xiāng",
  "着着": "zhe,zhe",
  "着积": "zhe,jī",
  "着稿": "zhe,gǎo",
  "着籍": "zhe,jí",
  "着紧": "zháo,jǐn",
  "着绿": "zhe,lǜ",
  "着绊": "zhe,bàn",
  "着绩": "zhe,jì",
  "着绯": "zhe,fēi",
  "着翅人": "zhe,chì,rén",
  "着者": "zhe,zhě",
  "着肉": "zhe,ròu",
  "着脚": "zhe,jiǎo",
  "着节": "zhe,jié",
  "着花": "zháo,huā",
  "着莫": "zhe,mò",
  "着藁": "zhe,gǎo",
  "着要": "zhe,yào",
  "着警": "zhe,jǐng",
  "着趣": "zhe,qù",
  "着边儿": "zháo,biān,er",
  "着述": "zhe,shù",
  "着迷": "zháo,mí",
  "着迷地": "zháo,mí,de",
  "着迹": "zhe,jì",
  "着道儿": "zháo,dào,er",
  "着重地": "zhuó,zhòng,de",
  "着录": "zhe,lù",
  "着闻": "zhe,wén",
  "着雝": "zhe,yōng",
  "着题": "zhe,tí",
  "着风": "zháo,fēng",
  "着魔": "zháo,mó",
  "睁一只眼闭一只眼": "zhēng,yī,zhī,yǎn,bì,yī,zhī,yǎn",
  "睁只眼": "zhēng,zhī,yǎn",
  "睁只眼闭只眼": "zhēng,zhī,yǎn,bì,zhī,yǎn",
  "睁只眼阖只眼": "zhēng,zhī,yǎn,hé,zhī,yǎn",
  "睁眼瞎子": "zhēng,yǎn,xiā,zi",
  "睁着眼睛说瞎话": "zhēng,zhe,yǎn,jīng,shuō,xiā,huà",
  "睒瞲": "shǎn,xù",
  "睟面盎背": "suì,miàn,àng,bèi",
  "睡不着地": "shuì,bù,zhe,de",
  "睡兀": "shuì,wū",
  "睡兴": "shuì,xīng",
  "睡午觉": "shuì,wǔ,jiào",
  "睡回笼觉": "shuì,huí,lóng,jiào",
  "睡得着": "shuì,de,zháo",
  "睡相": "shuì,xiàng",
  "睡着": "shuì,zháo",
  "睡觉": "shuì,jiào",
  "睡铺": "shuì,pù",
  "睢于": "suī,yú",
  "睢剌": "suī,là",
  "睢县": "suī,xiàn",
  "睢呿": "suī,qù",
  "睢园": "suī,yuán",
  "睢宁": "suī,níng",
  "睢宁县": "suī,níng,xiàn",
  "睢睢": "suī,suī",
  "睢维": "suī,wéi",
  "睢苑": "suī,yuàn",
  "睢阳": "suī,yáng",
  "睢阳区": "suī,yáng,qū",
  "睢阳曲": "suī,yáng,qǔ",
  "睢鸠": "suī,jiū",
  "督率": "dū,shuài",
  "督相": "dū,xiàng",
  "睥盼": "pì,pàn",
  "睥睨": "pì,nì",
  "睥睨一切": "pì,nì,yī,qiè",
  "睥窃": "pì,qiè",
  "睪丸": "gāo,wán",
  "睹物兴情": "dǔ,wù,xīng,qíng",
  "睹着知微": "dǔ,zhe,zhī,wēi",
  "睽睢": "kuí,suī",
  "睿蕃": "ruì,fān",
  "瞅空": "chǒu,kòng",
  "瞅空儿": "chǒu,kòng,ér",
  "瞅粘": "chǒu,zhān",
  "瞋目切齿": "chēn,mù,qiè,chǐ",
  "瞋目张胆": "tián,mù,zhāng,dǎn",
  "瞋目搤腕": "tián,mù,è,wàn",
  "瞋目竖眉": "tián,mù,shù,méi",
  "瞌睡地": "kē,shuì,de",
  "瞎头子": "xiā,tóu,zi",
  "瞎子": "xiā,zi",
  "瞎子摸象": "xiā,zi,mō,xiàng",
  "瞎子摸鱼": "xiā,zi,mō,yú",
  "瞎晃": "xiā,huàng",
  "瞎猫碰上死耗子": "xiā,māo,pèng,shàng,sǐ,hào,zi",
  "瞎琢磨": "xiā,zuó,mó",
  "瞎蒙": "xiā,mēng",
  "瞒哄": "mán,hǒng",
  "𰥛觉": "fèn,jiào",
  "𥆧动": "shùn,dòng",
  "𥆧息": "shùn,xī",
  "瞥一眼": "piē,yì,yǎn",
  "瞧不起地": "qiáo,bù,qǐ,de",
  "瞧得起": "qiáo,de,qǐ",
  "瞧着办": "qiáo,zhe,bàn",
  "瞪目哆口": "dèng,mù,chǐ,kǒu",
  "瞪眼咋舌": "dèng,yǎn,zé,shé",
  "瞬间地": "shùn,jiān,de",
  "瞭哨": "liào,shào",
  "瞭望": "liào,wàng",
  "瞭望军": "liào,wàng,jūn",
  "瞭望台": "liào,wàng,tái",
  "瞭望哨": "liào,wàng,shào",
  "瞭望塔": "liào,wàng,tǎ",
  "𰥨摸": "jiàn,mō",
  "𰥨然": "jiàn,rán",
  "瞰瑕伺隙": "kàn,xiá,sì,xì",
  "瞲然": "xù,rán",
  "瞵伺": "lín,sì",
  "瞆祸翫灾": "guì,huò,wàn,zāi",
  "瞻卬": "zhān,áng",
  "瞻翫": "zhān,wàn",
  "瞻葛": "zhān,gě",
  "瞽阇": "gǔ,shé",
  "瞿卢折娜": "qú,lú,shé,nà",
  "瞿然": "jù,rán",
  "瞿瞿地叫": "qú,qú,de,jiào",
  "矗削": "chù,xuē",
  "矙瑕伺隙": "kàn,xiá,sì,xì",
  "矛楯": "máo,dùn",
  "矛盾地": "máo,dùn,de",
  "矛骹": "máo,xiāo",
  "矜寡": "guān,guǎ",
  "矜絜": "jīn,jié",
  "矜露": "jīn,lù",
  "矢干": "shǐ,gàn",
  "知不道": "zhì,bù,dào",
  "知之为知之": "zhī,zhī,wéi,zhī,zhī",
  "知了": "zhī,liǎo",
  "知其不可为而为之": "zhī,qí,bù,kě,wéi,ér,wéi,zhī",
  "知其不可而为之": "zhī,qí,bù,kě,ér,wéi,zhī",
  "知几": "zhī,jī",
  "知名地": "zhī,míng,de",
  "知得": "zhī,de",
  "知心着意": "zhī,xīn,zhe,yì",
  "知无不为": "zhī,wú,bù,wéi",
  "知更": "zhī,gēng",
  "知更雀": "zhī,gēng,què",
  "知更鸟": "zhī,gēng,niǎo",
  "知疼着热": "zhī,téng,zháo,rè",
  "知疼着痒": "zhī,téng,zháo,yǎng",
  "知觉地": "zhī,jué,de",
  "知识共享": "zhī,shi,gòng,xiǎng",
  "知识分子": "zhī,shí,fèn,zǐ",
  "知识工程师": "zhī,shi,gōng,chéng,shī",
  "知识更新": "zhī,shí,gēng,xīn",
  "知识越多越反动": "zhī,shi,yuè,duō,yuè,fǎn,dòng",
  "知趣地": "zhī,qù,de",
  "矫国更俗": "jiǎo,guó,gēng,sú",
  "矫情": "jiáo,qing",
  "矫正地": "jiǎo,zhèng,de",
  "矫絜": "jiǎo,jié",
  "矫饰地": "jiǎo,shì,de",
  "矫饰地做": "jiǎo,shì,de,zuò",
  "矬子里拔将军": "cuó,zi,lǐ,bá,jiāng,jūn",
  "短不了": "duǎn,bù,liǎo",
  "短什": "duǎn,shí",
  "短卷": "duǎn,juàn",
  "短发地": "duǎn,fā,de",
  "短吁长叹": "duǎn,yù,cháng,tàn",
  "短地": "duǎn,de",
  "短打扮": "duǎn,dǎ,ban",
  "短折": "duǎn,shé",
  "短时间地": "duǎn,shí,jiān,de",
  "短暂地": "duǎn,zàn,de",
  "短蕃匠": "duǎn,fān,jiàng",
  "短见薄识": "duǎn,jiàn,bó,shí",
  "短调": "duǎn,diào",
  "短道儿": "duǎn,dào,er",
  "矮个儿": "ǎi,gè,er",
  "矮个子": "ǎi,gè,zi",
  "矮人观场": "ǎi,rén,guān,cháng",
  "矮子": "ǎi,zi",
  "矮子观场": "ǎi,zǐ,guān,cháng",
  "矮子里拔将军": "ǎi,zi,li,bá,jiāng,jūn",
  "矮小地": "ǎi,xiǎo,de",
  "矮杆品种": "ǎi,gǎn,pǐn,zhǒng",
  "石乡侯": "shí,xiāng,hòu",
  "石于菟": "shí,yú,tú",
  "石南花": "shī,nán,huā",
  "石囤": "shí,dùn",
  "石堤": "shí,dī",
  "石堨": "shí,ài",
  "石头": "shí,tou",
  "石头人": "shí,tou,rén",
  "石头似地": "shí,tou,shì,de",
  "石头城": "shí,tou,chéng",
  "石头子儿": "shí,tou,zi,er",
  "石头火锅": "shí,tou,huǒ,guō",
  "石头记": "shí,tou,jì",
  "石头鱼": "shí,tou,yú",
  "石子儿": "shí,zǐ,er",
  "石室金匮": "shí,shì,jīn,guì",
  "石帆": "shí,fān",
  "石揵": "shí,jiàn",
  "石林精舍": "shí,lín,jīng,shè",
  "石栏干": "shí,lán,gàn",
  "石榴子": "shí,liu,zǐ",
  "石榴树": "shí,liu,shù",
  "石榴石": "shí,liu,shí",
  "石狮子": "shí,shī,zi",
  "石砮": "shí,nú",
  "石磎": "shí,qī",
  "石谷": "dàn,gǔ",
  "石蹬": "shí,dēng",
  "石铛": "shí,chēng",
  "石阙": "shí,què",
  "石隄": "shí,dī",
  "石鼓区": "dàn,gǔ,qū",
  "矸子": "gān,zi",
  "矻蹬蹬": "kū,dēng,dēng",
  "矾仔": "fán,zǎi",
  "矿朴": "kuàng,piáo",
  "矿芯": "kuàng,xìn",
  "矿长": "kuàng,zhǎng",
  "矿难": "kuàng,nàn",
  "砀力地": "dàng,lì,de",
  "码子": "mǎ,zi",
  "砂子": "shā,zi",
  "砉划": "huā,huá",
  "砉剨": "huā,huò",
  "砉欻": "huā,chuā",
  "砉然": "huā,rán",
  "砉𬴃": "huā,huō",
  "砌末": "qiè,mo",
  "砌煞": "qì,shà",
  "砌累": "qì,lèi",
  "砌红堆绿": "qì,hóng,duī,lù",
  "砍削": "kǎn,xuē",
  "砍砢": "kǎn,luǒ",
  "研几": "yán,jī",
  "研揣": "yán,chuāi",
  "研究反应堆": "yán,jiū,fǎn,yìng,duī",
  "研翫": "yán,wàn",
  "研覃": "yán,qín",
  "研钻": "yán,zuàn",
  "砘子": "dùn,zi",
  "砚台": "yàn,tāi",
  "砚水壶儿": "yàn,shuǐ,hú,er",
  "砟硌": "zhǎ,gè",
  "砢么": "luǒ,mǒ",
  "砢硪": "luǒ,wò",
  "砢确": "luǒ,què",
  "砢碜": "kē,chen",
  "砢磨": "luǒ,mó",
  "砢礧": "luǒ,léi",
  "砣子": "tuó,zi",
  "砥𰊂": "dǐ,dì",
  "砥砫": "dǐ,zhǔ",
  "砦堡": "zhài,pù",
  "砦栅": "zhài,shān",
  "砬子": "lá,zǐ",
  "砬礘": "lá,è",
  "砭削": "biān,xuē",
  "砭剥": "biān,bāo",
  "砭庸针俗": "biān,yōng,zhén,sú",
  "砮石": "nú,shí",
  "砰地一下": "pēng,de,yī,xià",
  "砰地一声": "pēng,de,yī,shēng",
  "砰地关上": "pēng,de,guān,shàng",
  "砰地响": "pēng,de,xiǎng",
  "砰地摔下": "pēng,de,shuāi,xià",
  "砰地撞": "pēng,de,zhuàng",
  "砰地撞到": "pēng,de,zhuàng,dào",
  "砰地放下": "pēng,de,fàng,xià",
  "砰地落下": "pēng,de,là,xià",
  "砰然地": "pēng,rán,de",
  "砰然地响": "pēng,rán,de,xiǎng",
  "砰砰地打": "pēng,pēng,de,dǎ",
  "砰砰地敲": "pēng,pēng,de,qiāo",
  "砰砰地跳": "pēng,pēng,de,tiào",
  "破丢不落": "pò,diū,bù,là",
  "破例地": "pò,lì,de",
  "破剥": "pò,bāo",
  "破坏地": "pò,huài,de",
  "破坏性地": "pò,huài,xìng,de",
  "破处": "pò,chǔ",
  "破家为国": "pò,jiā,wéi,guó",
  "破帆风": "pò,fān,fēng",
  "破帖": "pò,tiē",
  "破愁为笑": "pò,chóu,wéi,xiào",
  "破旧地": "pò,jiù,de",
  "破涕为笑": "pò,tì,wéi,xiào",
  "破烂儿": "pò,làn,er",
  "破烂地": "pò,làn,de",
  "破甲弹": "pò,jiǎ,dàn",
  "破的": "pò,dì",
  "破相": "pò,xiàng",
  "破相宗": "pò,xiàng,zōng",
  "破矩为圆": "pò,jǔ,wéi,yuán",
  "破禁": "pò,jìn",
  "破罐子破摔": "pò,guàn,zi,pò,shuāi",
  "破落汗": "pò,lào,hàn",
  "破觚为圜": "pò,gū,wéi,yuán",
  "破调": "pò,diào",
  "破谜儿": "pò,mèi,ér",
  "破镜重圆": "pò,jìng,chóng,yuán",
  "破阵乐": "pò,zhèn,yuè",
  "破阵子": "pò,zhèn,zi",
  "破露": "pò,lù",
  "砷中毒": "shēn,zhòng,dú",
  "砸牌子": "zá,pái,zi",
  "砻坊": "lóng,fáng",
  "础舃": "chǔ,tuō",
  "硅脂": "guī,zhǐ",
  "硉兀": "lù,wū",
  "硌吱": "gè,zī",
  "硌硌": "gè,gè",
  "硌磴": "gè,dèng",
  "硌窝儿": "gè,wō,ér",
  "硌蹴": "gè,cù",
  "硕望宿德": "shuò,wàng,xiǔ,dé",
  "硕果累累": "shuò,guǒ,lěi,lěi",
  "硙牛": "wèi,niú",
  "硙硙": "ái,ái",
  "硙碾": "wèi,niǎn",
  "硙磨": "wèi,mó",
  "硙船": "wèi,chuán",
  "硙轮": "wèi,lún",
  "硝云弹雨": "xiāo,yún,dàn,yǔ",
  "硡峒": "hōng,dòng",
  "硬干": "yìng,gàn",
  "硬底子": "yìng,dǐ,zi",
  "硬扎": "yìng,zhā",
  "硬挣": "yìng,zhēng",
  "硬挣子": "yìng,zhēng,zǐ",
  "硬挣挣": "yìng,zhēng,zhèng",
  "硬汉子": "yìng,hàn,zi",
  "硬生生地": "yìng,shēng,shēng,de",
  "硬着头皮": "yìng,zhe,tóu,pí",
  "硬硬地": "yìng,yìng,de",
  "硬翘翘": "yìng,qiào,qiào",
  "硬蹶蹶": "yìng,juě,juě",
  "硬门槛子": "yìng,mén,kǎn,zǐ",
  "硬骨头": "yìng,gǔ,tou",
  "确信地": "què,xìn,de",
  "确切": "què,qiè",
  "确切不移": "què,qiè,bù,yí",
  "确切地": "què,qiè,de",
  "确切地来说": "què,qiè,de,lái,shuō",
  "确切地讲": "què,qiè,de,jiǎng",
  "确切地说": "què,qiè,de,shuō",
  "确地": "què,de",
  "确地叙述": "què,de,xù,shù",
  "确定地": "què,deng,de",
  "确定效应": "què,dìng,xiào,yìng",
  "确定无疑地": "què,deng,wú,yí,de",
  "确实性地": "què,shí,xìng,de",
  "确当": "què,dàng",
  "确数": "què,shù",
  "确查": "què,zhā",
  "确然地": "què,rán,de",
  "确硌": "què,gè",
  "确确实实地": "què,què,shí,shí,de",
  "硱磈": "kǔn,wěi",
  "硼玻璃": "péng,bō,li",
  "碌碌无为": "lù,lù,wú,wéi",
  "碌碡": "liù,zhóu",
  "碌碡磙": "liù,zhou,gǔn",
  "碍事地": "ài,shì,de",
  "碍面子": "ài,miàn,zi",
  "碎块儿": "suì,kuài,er",
  "碎折": "suì,shé",
  "碎折裙": "suì,shé,qún",
  "碎末儿": "suì,mò,er",
  "碎累": "suì,lèi",
  "碎钻": "suì,zuàn",
  "碑帖": "bēi,tiè",
  "碑座儿": "bēi,zuò,er",
  "碓栅": "duì,shān",
  "碓硙": "duì,wèi",
  "碕𥐟": "qí,yǐ",
  "碘酊": "diǎn,dǐng",
  "碛磈": "qì,wěi",
  "碟子": "dié,zi",
  "碧卝": "bì,kuàng",
  "碧幢": "bì,zhuàng",
  "碧晕": "bì,yùn",
  "碧油幢": "bì,yóu,zhuàng",
  "碧海舍人": "bì,hǎi,shè,rén",
  "碧澄澄": "bì,deng,deng",
  "碧玉𥮾": "bì,yù,zān",
  "碧琳侯": "bì,lín,hòu",
  "碧砮": "bì,nú",
  "碧筩": "bì,yǒng",
  "碧筩杯": "bì,yǒng,bēi",
  "碧藉藉": "bì,jí,jí",
  "碧血": "bì,xuè",
  "碧血丹心": "bì,xuè,dān,xīn",
  "碧露": "bì,lù",
  "碨垒": "wèi,lěi",
  "碨抰": "wèi,yāng",
  "碨柍": "wèi,yǎng",
  "碨泱": "wèi,yāng",
  "碨磥": "wèi,lěi",
  "碨礧": "wèi,léi",
  "碰一鼻子灰": "pèng,yī,bí,zi,huī",
  "碰劲儿": "pèng,jìn,er",
  "碰头会": "pèng,tóu,kuài",
  "碰撞地": "pèng,zhuàng,de",
  "碰瓷儿": "pèng,cí,er",
  "碰运气": "pèng,yùn,qi",
  "碰钉子": "pèng,dìng,zǐ",
  "碱面儿": "jiǎn,miàn,er",
  "碻凿": "qiāo,záo",
  "碻当": "qiāo,dāng",
  "碻据": "qiāo,jù",
  "碻磝": "qiāo,áo",
  "碻车": "qiāo,chē",
  "碾坊": "niǎn,fáng",
  "碾子": "niǎn,zi",
  "碾子山": "niǎn,zi,shān",
  "碾子山区": "niǎn,zi,shān,qū",
  "碾硙": "niǎn,wèi",
  "磁力地": "cí,lì,de",
  "磁吸效应": "cí,xī,xiào,yìng",
  "磁感应": "cí,gǎn,yìng",
  "磁感应强度": "cí,gǎn,yìng,qiáng,dù",
  "磁流体发电": "cí,liú,tǐ,fà,diàn",
  "磁重联": "cí,chóng,lián",
  "磅子儿": "bàng,zǐ,er",
  "磅礴": "páng,bó",
  "磈垒": "wěi,lěi",
  "磈氏": "wěi,shì",
  "磈砢": "wěi,luǒ",
  "磈硊": "wěi,wěi",
  "磈磥": "wěi,lěi",
  "磈礧": "wěi,léi",
  "磈礨": "wěi,lěi",
  "磊砢": "lěi,luǒ",
  "磊硌": "lěi,gè",
  "磊磈": "lěi,wěi",
  "磋跌": "cuō,diē",
  "磎壑": "qī,hè",
  "磎鼠": "qī,shǔ",
  "磔砉": "zhé,huā",
  "磕磕绊绊": "kē,ke,bàn,bàn",
  "磕膝头子": "kē,xī,tóu,zi",
  "磨了半截舌头": "mó,le,bàn,jié,shé,tou",
  "磨兜鞬": "mó,dōu,jiān",
  "磨动": "mo,dong",
  "磨叨": "mò,dāo",
  "磨叽": "mò,ji",
  "磨嘴皮子": "mó,zuǐ,pí,zi",
  "磨坊": "mò,fáng",
  "磨坊主": "mò,fáng,zhǔ",
  "磨子": "mò,zǐ",
  "磨子兵": "mò,zǐ,bīng",
  "磨工病": "mò,gōng,bìng",
  "磨得开": "mó,de,kāi",
  "磨捋": "mó,lǚ",
  "磨揣": "mó,chuāi",
  "磨晻": "mó,ǎn",
  "磨烦": "mò,fán",
  "磨牙吮血": "mó,yá,shǔn,xuè",
  "磨盘": "mò,pán",
  "磨盘两圆": "mò,pán,liǎng,yuán",
  "磨石子地": "mó,shí,zi,de",
  "磨破嘴皮子": "mó,pò,zuǐ,pí,zi",
  "磨碎": "mò,suì",
  "磨磨蹭蹭地": "mó,mó,cèng,cèng,de",
  "磨米": "mò,mǐ",
  "磨趄子": "mó,jū,zǐ",
  "磨轧": "mó,zhá",
  "磨难": "mó,nàn",
  "磨面": "mò,miàn",
  "磬折": "qìng,shé",
  "磻石": "bō,shí",
  "磻磎": "bō,qī",
  "磻礴": "bō,bó",
  "礌石": "lèi,shí",
  "𰧔磻": "jiān,bō",
  "礤床儿": "cǎ,chuáng,er",
  "礧砢": "léi,luǒ",
  "礧硌": "léi,gè",
  "礧碨": "léi,wèi",
  "礧磈": "léi,wěi",
  "礨硌": "lěi,gè",
  "礷诸": "lán,zhū",
  "示范地": "shì,fàn,de",
  "礼为情貌": "lǐ,wéi,qíng,mào",
  "礼乐": "lǐ,yuè",
  "礼乐崩坏": "lǐ,yuè,bēng,huài",
  "礼坏乐崩": "lǐ,huài,yuè,bēng",
  "礼崩乐坏": "lǐ,bēng,yuè,huài",
  "礼废乐崩": "lǐ,fèi,yuè,bēng",
  "礼数": "lǐ,shù",
  "礼禁": "lǐ,jìn",
  "礼让为国": "lǐ,ràng,wéi,guó",
  "礼貌地": "lǐ,mào,de",
  "社交上地": "shè,jiāo,shàng,de",
  "社会总供给": "shè,huì,zǒng,gōng,jǐ",
  "社区地": "shè,qū,de",
  "社𭏸": "shè,wěi",
  "社长": "shè,zhǎng",
  "祀𰱈": "sì,yǒng",
  "祀舍": "sì,shè",
  "祇令": "qí,lìng",
  "祇园": "qí,yuán",
  "祇园精舍": "qí,yuán,jīng,shè",
  "祇夜": "qí,yè",
  "祇悔": "qí,huǐ",
  "祇林": "qí,lín",
  "祇树": "qí,shù",
  "祇树园": "qí,shù,yuán",
  "祇树林": "qí,shù,lín",
  "祇洹": "qí,huán",
  "祇洹精舍": "qí,huán,jīng,shè",
  "祇苑": "qí,yuàn",
  "祇重衣衫不重人": "qí,zhòng,yī,shān,bù,zhòng,rén",
  "祇陀": "qí,tuó",
  "祈求地": "qí,qiú,de",
  "祈衈": "qí,èr",
  "祖国内地": "zǔ,guó,nèi,de",
  "祖帖": "zǔ,tiē",
  "祖爷爷": "zǔ,yé,ye",
  "祖调": "zǔ,diào",
  "祖载": "zǔ,zǎi",
  "祗应": "zhī,yìng",
  "祗应人": "zhī,yìng,rén",
  "祛累": "qu,lei",
  "祛褪": "qū,tùn",
  "祝予": "zhù,yǔ",
  "祝发": "zhù,fà",
  "祝咽祝哽": "zhù,yān,zhù,gěng",
  "祝诅": "zhòu,zǔ",
  "神乐": "shén,yuè",
  "神仙不是凡人作": "shén,xiān,bú,shì,fán,rén,zuò",
  "神兴": "shén,xīng",
  "神出鬼没": "shén,chū,guǐ,mò",
  "神号": "shén,háo",
  "神号鬼哭": "shén,háo,guǐ,kū",
  "神奇地": "shén,qí,de",
  "神妙隽美": "shén,miào,juàn,měi",
  "神学上地": "shén,xué,shàng,de",
  "神学地": "shén,xué,de",
  "神差鬼使": "shén,chāi,guǐ,shǐ",
  "神应": "shén,yìng",
  "神怡": "shēn,yí",
  "神情激动地": "shén,qíng,jī,dòng,de",
  "神成为人": "shén,chéng,wéi,rén",
  "神曲": "shén,qū",
  "神气地": "shén,qì,de",
  "神灵地": "shén,líng,de",
  "神煞": "shén,shà",
  "神狗干郎": "shén,gǒu,gàn,láng",
  "神甫": "shén,fu",
  "神的儿子": "shén,de,ér,zi",
  "神祇": "shén,qí",
  "神神叨叨": "shén,shen,dāo,dāo",
  "神神道道": "shén,shen,dào,dào",
  "神秘地": "shén,mì,de",
  "神秘地说": "shén,mì,de,shuō",
  "神䇲": "shén,jiā",
  "神经质地": "shén,jīng,zhì,de",
  "神荼": "shēn,shū",
  "神荼郁垒": "shēn,shū,yù,lǜ",
  "神融气泰": "shén,róng,qì,tai",
  "神话地": "shén,huà,de",
  "神话故事": "shén,huà,gù,shi",
  "神霄绛阙": "shén,xiāo,jiàng,què",
  "神魂不定": "shén,hún,bú,dìng",
  "神龙失埶": "shén,lóng,shī,shì",
  "祥应": "xiáng,yìng",
  "祥蓂": "xiáng,mì",
  "票友儿": "piào,yǒu,er",
  "票夹": "piào,jiā",
  "票子": "piào,zi",
  "票帖": "piào,tiē",
  "票数": "piào,shù",
  "票查": "piào,zhā",
  "票贩子": "piào,fàn,zi",
  "祭仆": "jì,pú",
  "祭侯": "jì,hòu",
  "祭𬳂": "jì,zhuì",
  "祸为福先": "huò,wéi,fú,xiān",
  "祸及池鱼": "huò,jí,shi,yú",
  "祸必重来": "huò,bì,chóng,lái",
  "祸福相倚": "huò,fú,xiāng,yī",
  "祸近池鱼": "huò,jìn,shi,yú",
  "祸适": "huò,shì",
  "禀应": "bǐng,yìng",
  "禁不住": "jīn,bú,zhù",
  "禁不住地": "jīn,bú,zhù,de",
  "禁严": "jìn,yán",
  "禁中": "jìn,zhōng",
  "禁中语": "jìn,zhōng,yǔ",
  "禁中颇牧": "jìn,zhōng,pō,mù",
  "禁久": "jìn,jiǔ",
  "禁乐": "jìn,lè",
  "禁书": "jìn,shū",
  "禁从": "jìn,cóng",
  "禁仓": "jìn,cāng",
  "禁仗": "jìn,zhàng",
  "禁令": "jìn,lìng",
  "禁伐": "jìn,fá",
  "禁伶": "jìn,líng",
  "禁佅": "jìn,mài",
  "禁住": "jìn,zhù",
  "禁体": "jìn,tǐ",
  "禁体诗": "jìn,tǐ,shī",
  "禁例": "jìn,lì",
  "禁侍": "jìn,shì",
  "禁兵": "jìn,bīng",
  "禁典": "jìn,diǎn",
  "禁内": "jìn,nèi",
  "禁军": "jìn,jūn",
  "禁切": "jìn,qiē",
  "禁刑日": "jìn,xíng,rì",
  "禁制": "jìn,zhì",
  "禁制令": "jìn,zhì,lìng",
  "禁制品": "jìn,zhì,pǐn",
  "禁割": "jìn,gē",
  "禁劝": "jìn,quàn",
  "禁加": "jìn,jiā",
  "禁动": "jìn,dòng",
  "禁劾": "jìn,hé",
  "禁区": "jìn,qū",
  "禁匾": "jìn,biǎn",
  "禁卒": "jìn,zú",
  "禁卢": "jìn,lú",
  "禁卫": "jìn,wèi",
  "禁卫兵": "jìn,wèi,bīng",
  "禁卫军": "jìn,wèi,jūn",
  "禁印": "jìn,yìn",
  "禁压": "jìn,yā",
  "禁发": "jìn,fā",
  "禁取": "jìn,qǔ",
  "禁口": "jìn,kǒu",
  "禁口痢": "jìn,kǒu,lì",
  "禁台": "jìn,tái",
  "禁号": "jìn,hào",
  "禁司": "jìn,sī",
  "禁呪": "jìn,zhòu",
  "禁呵": "jìn,hē",
  "禁咒": "jìn,zhòu",
  "禁品": "jìn,pǐn",
  "禁售": "jìn,shòu",
  "禁喝": "jìn,hē",
  "禁囚": "jìn,qiú",
  "禁园": "jìn,yuán",
  "禁围": "jìn,wéi",
  "禁围门": "jìn,wéi,mén",
  "禁固": "jìn,gù",
  "禁囿": "jìn,yòu",
  "禁圃": "jìn,pǔ",
  "禁圉": "jìn,yǔ",
  "禁土": "jìn,tǔ",
  "禁地": "jìn,dì",
  "禁坊": "jìn,fāng",
  "禁坐": "jìn,zuò",
  "禁坰": "jìn,jiōng",
  "禁垣": "jìn,yuán",
  "禁城": "jìn,chéng",
  "禁域": "jìn,yù",
  "禁塞": "jìn,sāi",
  "禁墀": "jìn,chí",
  "禁墙": "jìn,qiáng",
  "禁声": "jìn,shēng",
  "禁备": "jìn,bèi",
  "禁夜": "jìn,yè",
  "禁奈": "jìn,nài",
  "禁奥": "jìn,ào",
  "禁女": "jìn,nǚ",
  "禁奸": "jìn,jiān",
  "禁子": "jìn,zǐ",
  "禁字体": "jìn,zì,tǐ",
  "禁学": "jìn,xué",
  "禁宝": "jìn,bǎo",
  "禁室": "jìn,shì",
  "禁宪": "jìn,xiàn",
  "禁宫": "jìn,gōng",
  "禁宫花": "jìn,gōng,huā",
  "禁害": "jìn,hài",
  "禁宸": "jìn,chén",
  "禁密": "jìn,mì",
  "禁察": "jìn,chá",
  "禁寺": "jìn,sì",
  "禁封日": "jìn,fēng,rì",
  "禁居": "jìn,jū",
  "禁屠": "jìn,tú",
  "禁山": "jìn,shān",
  "禁帑": "jìn,tǎng",
  "禁庐": "jìn,lú",
  "禁库": "jìn,kù",
  "禁府": "jìn,fǔ",
  "禁庭": "jìn,tíng",
  "禁廷": "jìn,tíng",
  "禁弃": "jìn,qì",
  "禁当": "jìn,dāng",
  "禁律": "jìn,lǜ",
  "禁得": "jīn,de",
  "禁得住": "jīn,de,zhù",
  "禁得起": "jīn,de,qǐ",
  "禁御": "jìn,yù",
  "禁微": "jìn,wēi",
  "禁忌": "jìn,jì",
  "禁忌日": "jìn,jì,rì",
  "禁忌症": "jìn,jì,zhèng",
  "禁忌证": "jìn,jì,zhèng",
  "禁忌语": "jìn,jì,yǔ",
  "禁忍": "jìn,rěn",
  "禁急": "jìn,jí",
  "禁情割欲": "jìn,qíng,gē,yù",
  "禁戎": "jìn,róng",
  "禁戒": "jìn,jiè",
  "禁戢": "jìn,jí",
  "禁户": "jìn,hù",
  "禁所": "jìn,suǒ",
  "禁扃": "jìn,jiōng",
  "禁扉": "jìn,fēi",
  "禁执": "jìn,zhí",
  "禁抑": "jìn,yì",
  "禁护": "jìn,hù",
  "禁押": "jìn,yā",
  "禁持": "jìn,chí",
  "禁指": "jìn,zhǐ",
  "禁掖": "jìn,yè",
  "禁推": "jìn,tuī",
  "禁攻寝兵": "jìn,gōng,qǐn,bīng",
  "禁放": "jìn,fàng",
  "禁文": "jìn,wén",
  "禁斥": "jìn,chì",
  "禁断": "jìn,duàn",
  "禁方": "jìn,fāng",
  "禁旅": "jìn,lǚ",
  "禁旅八旗": "jìn,lǚ,bā,qí",
  "禁昏家": "jìn,hūn,jiā",
  "禁春": "jìn,chūn",
  "禁暴": "jìn,bào",
  "禁暴正乱": "jìn,bào,zhèng,luàn",
  "禁暴氏": "jìn,bào,shì",
  "禁暴诛乱": "jìn,bào,zhū,luàn",
  "禁曲": "jìn,qǔ",
  "禁更": "jìn,gēng",
  "禁月明": "jìn,yuè,míng",
  "禁末": "jìn,mò",
  "禁术": "jìn,shù",
  "禁杀": "jìn,shā",
  "禁杀日": "jìn,shā,rì",
  "禁条": "jìn,tiáo",
  "禁林": "jìn,lín",
  "禁果": "jìn,guǒ",
  "禁架": "jìn,jià",
  "禁柳": "jìn,liǔ",
  "禁树": "jìn,shù",
  "禁检": "jìn,jiǎn",
  "禁楄": "jìn,pián",
  "禁楼": "jìn,lóu",
  "禁榷": "jìn,què",
  "禁欲": "jìn,yù",
  "禁欲主义": "jìn,yù,zhǔ,yì",
  "禁欲地": "jìn,yù,de",
  "禁止": "jìn,zhǐ",
  "禁止令行": "jìn,zhǐ,lìng,xíng",
  "禁止吸烟": "jìn,zhǐ,xī,yān",
  "禁止地": "jìn,zhǐ,de",
  "禁止外出": "jìn,zhǐ,wài,chū",
  "禁止核武器试验条约": "jìn,zhǐ,hé,wǔ,qì,shì,yàn,tiáo,yuē",
  "禁止驶入": "jìn,zhǐ,shǐ,rù",
  "禁步": "jìn,bù",
  "禁殿": "jìn,diàn",
  "禁毁": "jìn,huǐ",
  "禁毒": "jìn,dú",
  "禁气": "jìn,qì",
  "禁水": "jìn,shuǐ",
  "禁池": "jìn,chí",
  "禁沟": "jìn,gōu",
  "禁治": "jìn,zhì",
  "禁法": "jìn,fǎ",
  "禁海": "jìn,hǎi",
  "禁涂": "jìn,tú",
  "禁渔": "jìn,yú",
  "禁漏": "jìn,lòu",
  "禁演": "jìn,yǎn",
  "禁火": "jìn,huǒ",
  "禁火天": "jìn,huǒ,tiān",
  "禁火日": "jìn,huǒ,rì",
  "禁火辰": "jìn,huǒ,chén",
  "禁烟": "jìn,yān",
  "禁烟节": "jìn,yān,jié",
  "禁牌": "jìn,pái",
  "禁牒": "jìn,dié",
  "禁牧": "jìn,mù",
  "禁物": "jìn,wù",
  "禁狱": "jìn,yù",
  "禁猎": "jìn,liè",
  "禁猎地": "jìn,liè,de",
  "禁生": "jìn,shēng",
  "禁甬": "jìn,yǒng",
  "禁甲": "jìn,jiǎ",
  "禁瘆": "jìn,shèn",
  "禁的": "jìn,de",
  "禁直": "jìn,zhí",
  "禁省": "jìn,shěng",
  "禁祝": "jìn,zhù",
  "禁穴": "jìn,xué",
  "禁筦": "jìn,guǎn",
  "禁管": "jìn,guǎn",
  "禁籍": "jìn,jí",
  "禁篽": "jìn,yù",
  "禁系": "jìn,xì",
  "禁约": "jìn,yuē",
  "禁绝": "jìn,jué",
  "禁缪": "jìn,miù",
  "禁网": "jìn,wǎng",
  "禁网疏阔": "jìn,wǎng,shū,kuò",
  "禁罔": "jìn,wǎng",
  "禁罚": "jìn,fá",
  "禁署": "jìn,shǔ",
  "禁耐": "jìn,nài",
  "禁耕": "jìn,gēng",
  "禁职": "jìn,zhí",
  "禁肉": "jìn,ròu",
  "禁脔": "jìn,luán",
  "禁脔壻": "jìn,jī,xù",
  "禁脔婿": "jìn,jī,xù",
  "禁脔格": "jìn,jī,gé",
  "禁脚": "jìn,jiǎo",
  "禁膳": "jìn,shàn",
  "禁臣": "jìn,chén",
  "禁臧": "jìn,zāng",
  "禁舍开塞": "jìn,shě,kāi,sāi",
  "禁花": "jìn,huā",
  "禁苑": "jìn,yuàn",
  "禁苑黄": "jìn,yuàn,huáng",
  "禁药": "jìn,yào",
  "禁营": "jìn,yíng",
  "禁藏": "jìn,cáng",
  "禁蓹": "jìn,yǔ",
  "禁虐": "jìn,nüè",
  "禁虣": "jìn,bào",
  "禁街": "jìn,jiē",
  "禁衢": "jìn,qú",
  "禁袖": "jìn,xiù",
  "禁要": "jìn,yào",
  "禁见": "jìn,jiàn",
  "禁诃": "jìn,hē",
  "禁诘": "jìn,jié",
  "禁诫": "jìn,jiè",
  "禁语": "jìn,yǔ",
  "禁财": "jìn,cái",
  "禁赌": "jìn,dǔ",
  "禁赛": "jìn,sài",
  "禁足": "jìn,zú",
  "禁路": "jìn,lù",
  "禁身": "jìn,shēn",
  "禁轩": "jìn,xuān",
  "禁过": "jìn,guò",
  "禁运": "jìn,yùn",
  "禁近": "jìn,jìn",
  "禁近语": "jìn,jìn,yǔ",
  "禁遏": "jìn,è",
  "禁遮": "jìn,zhē",
  "禁邪": "jìn,xié",
  "禁邸": "jìn,dǐ",
  "禁酒": "jìn,jiǔ",
  "禁酒令": "jìn,jiǔ,lìng",
  "禁里": "jìn,lǐ",
  "禁重": "jìn,zhòng",
  "禁钟": "jìn,zhōng",
  "禁钥": "jìn,yuè",
  "禁钱": "jìn,qián",
  "禁销得": "jìn,xiāo,de",
  "禁锢": "jìn,gù",
  "禁门": "jìn,mén",
  "禁闭": "jìn,bì",
  "禁闭室": "jìn,bì,shì",
  "禁闱": "jìn,wéi",
  "禁闺": "jìn,guī",
  "禁闼": "jìn,tà",
  "禁阁": "jìn,gé",
  "禁阃": "jìn,kǔn",
  "禁阍": "jìn,hūn",
  "禁阙": "jìn,quē",
  "禁防": "jìn,fáng",
  "禁阻": "jìn,zǔ",
  "禁陌": "jìn,mò",
  "禁限": "jìn,xiàn",
  "禁陛": "jìn,bì",
  "禁院": "jìn,yuàn",
  "禁障": "jìn,zhàng",
  "禁革": "jìn,gé",
  "禁额": "jìn,é",
  "禁食": "jìn,shí",
  "禁饬": "jìn,chì",
  "禁驻": "jìn,zhù",
  "禁魇": "jìn,yǎn",
  "禁麛卵": "jìn,mí,luǎn",
  "禁黜": "jìn,chù",
  "禁鼎一脔": "jìn,dǐng,yī,luán",
  "禁鼓": "jìn,gǔ",
  "禄数": "lù,shù",
  "禅代": "shàn,dài",
  "禅位": "shàn,wèi",
  "禅刹": "chán,shā",
  "禅化": "shàn,huà",
  "禅变": "shàn,biàn",
  "禅数": "chán,shù",
  "禅文": "shàn,wén",
  "禅更": "chán,gēng",
  "禅让": "shàn,ràng",
  "禅诰": "shàn,gào",
  "禅钻": "chán,zuàn",
  "禊帖": "xì,tiē",
  "禋絜": "yīn,jié",
  "福不重至": "fú,bù,chóng,zhì",
  "福为祸先": "fú,wéi,huò,xiān",
  "福为祸始": "fú,wéi,huò,shǐ",
  "福兴": "fú,xīng",
  "福兴乡": "fú,xīng,xiāng",
  "福兴地": "fú,xīng,de",
  "福孙荫子": "fú,sūn,yìn,zǐ",
  "福应": "fú,yìng",
  "福建省地": "fú,jiàn,shěng,de",
  "福德舍": "fú,dé,shè",
  "福气": "fú,qi",
  "福相": "fú,xiàng",
  "福禔": "fú,zhī",
  "福舍": "fú,shè",
  "𰧰祓": "yáng,fú",
  "禔福": "zhī,fú",
  "禔身": "zhī,shēn",
  "禔躬": "zhī,gōng",
  "𰱈祷": "yǒng,dǎo",
  "𰱈禳": "yǒng,ráng",
  "禳𰱈": "ráng,yǒng",
  "禺䇲": "yú,jiā",
  "离乡背井": "lí,xiāng,bèi,jǐng",
  "离乡背土": "lí,xiāng,bèi,tǔ",
  "离乡调远": "lí,xiāng,diào,yuǎn",
  "离口地": "lí,kǒu,de",
  "离哩连": "lí,lǐ,lián",
  "离奇地": "lí,qí,de",
  "离山调虎": "lí,shān,diào,hǔ",
  "离慜": "lí,mǐn",
  "离搂": "lí,lōu",
  "离散地": "lí,sàn,de",
  "离散数学": "lí,sàn,shù,xué",
  "离数": "lí,shù",
  "离本徼末": "lí,běn,yāo,mò",
  "离本趣末": "lí,běn,qū,mò",
  "离离蔚蔚": "lí,lí,yù,yù",
  "离背": "lí,bèi",
  "离舍": "lí,shè",
  "离蔬释𪨗": "lí,shū,shì,zhe",
  "离蔬释𫏋": "lí,shū,shì,zhe",
  "离间": "lí,jiàn",
  "离题地": "lí,tí,de",
  "离魂舍": "lí,hún,shè",
  "禾场": "hé,cháng",
  "禾更": "hé,gēng",
  "禾杆": "hé,gǎn",
  "秀出班行": "xiù,chū,bān,háng",
  "秀削": "xiù,xuē",
  "秀发垂肩": "xiù,fà,chuí,jiān",
  "秀嶷": "xiù,nì",
  "秀才": "xiù,cai",
  "秀气": "xiù,qi",
  "私下地": "sī,xià,de",
  "私为": "sī,wéi",
  "私人地": "sī,rén,de",
  "私人钥匙": "sī,rén,yào,shi",
  "私伺": "sī,sì",
  "私处": "sī,chǔ",
  "私孩子": "sī,hái,zi",
  "私定终身": "sī,dìng,zhōng,shēng",
  "私帑": "sī,tǎng",
  "私掠": "sī,lüě",
  "私曲": "sī,qū",
  "私有地": "sī,yǒu,de",
  "私椷": "sī,hán",
  "私活儿": "sī,huó,er",
  "私着": "sī,zhe",
  "私禁": "sī,jìn",
  "私累": "sī,lèi",
  "私舍": "sī,shè",
  "私褚": "sī,chǔ",
  "私谩": "sī,màn",
  "私𫎆献豜": "sī,zòng,xiàn,jiān",
  "私载": "sī,zǎi",
  "私逮": "sī,dǎi",
  "秃子": "tū,zi",
  "秃楬": "tū,jié",
  "秃瓢儿": "tū,piáo,er",
  "秃露": "tū,lù",
  "秆儿": "gǎn,er",
  "秉笔太监": "bǐng,bǐ,tài,jiàn",
  "秋兴": "qiū,xīng",
  "秋卷": "qiū,juàn",
  "秋地站": "qiū,de,zhàn",
  "秋孛辘": "qiū,bó,lù",
  "秋实春华": "qiū,shí,chūn,huā",
  "秋思": "qiū,sì",
  "秋潦": "qiū,liáo",
  "秋皛": "qiū,jiǎo",
  "秋蓂": "qiū,mì",
  "秋行夏令": "qiū,xíng,xià,líng",
  "秋露": "qiū,lù",
  "种下": "zhòng,xià",
  "种到地里": "zhǒng,dào,de,lǐ",
  "种地": "zhòng,dì",
  "种子": "zhǒng,zi",
  "种子地": "zhǒng,zi,de",
  "种子岛": "zhǒng,zi,dǎo",
  "种子植物": "zhǒng,zi,zhí,wù",
  "种子田": "zhǒng,zi,tián",
  "种子选手": "zhǒng,zi,xuǎn,shǒu",
  "种子队": "zhǒng,zi,duì",
  "种德": "zhòng,dé",
  "种李得李": "zhǒng,lǐ,de,lǐ",
  "种树": "zhòng,shù",
  "种树书": "zhòng,shù,shū",
  "种植": "zhòng,zhí",
  "种植业": "zhòng,zhí,yè",
  "种植体": "zhòng,zhí,tǐ",
  "种植园": "zhòng,zhí,yuán",
  "种植园奴隶制": "zhòng,zhí,yuán,nú,lì,zhì",
  "种民": "zhòng,mín",
  "种民天": "zhòng,mín,tiān",
  "种牛": "zhòng,niú",
  "种牛痘": "zhòng,niú,dòu",
  "种瓜": "zhòng,guā",
  "种瓜人": "zhòng,guā,rén",
  "种瓜得瓜": "zhòng,guā,dé,guā",
  "种田": "zhòng,tián",
  "种痘": "zhòng,dòu",
  "种稻": "zhòng,dào",
  "种粮": "zhòng,liáng",
  "种花": "zhòng,huā",
  "种菜": "zhòng,cài",
  "种蠡": "zhǒng,lí",
  "种谷得谷": "zhǒng,gǔ,de,gǔ",
  "种豆得豆": "zhòng,dòu,dé,dòu",
  "种麦得麦": "zhòng,mài,de,mài",
  "科什图尼察": "kē,shí,tú,ní,chá",
  "科处": "kē,chǔ",
  "科学地": "kē,xué,de",
  "科学地安排": "kē,xué,de,ān,pái",
  "科学地总结了": "kē,xué,de,zǒng,jié,le",
  "科学地概括": "kē,xué,de,gài,kuò",
  "科学教育影片": "kē,xué,jiào,yù,yǐng,piān",
  "科学知识": "kē,xué,zhī,shi",
  "科学种田": "kē,xué,zhòng,tián",
  "科技地": "kē,jì,de",
  "科折": "kē,shé",
  "科教兴国": "kē,jiào,xīng,guó",
  "科教影片": "kē,jiào,yǐng,piān",
  "科教片": "kē,jiào,piān",
  "科斗": "kē,dǒu",
  "科斗子": "kē,dǒu,zi",
  "科禁": "kē,jìn",
  "科罗娜": "kē,luó,nà",
  "科调": "kē,diào",
  "科适": "kē,shì",
  "科长": "kē,zhǎng",
  "秒差距": "miǎo,chā,jù",
  "秕子": "bǐ,zi",
  "秕缪": "bǐ,miù",
  "秘书长": "mì,shū,zhǎng",
  "秘卷": "mì,juàn",
  "秘密地": "mì,mì,de",
  "秘着": "mì,zhe",
  "秘而不露": "mì,ér,bù,lù",
  "秘阁帖": "mì,gé,tiē",
  "秘阁续帖": "mì,gé,xù,tiē",
  "秘鲁": "bì,lǔ",
  "秘鲁苦蘵": "bì,lǔ,kǔ,zhí",
  "租子": "zū,zi",
  "租庸调": "zū,yōng,diào",
  "租折": "zū,shé",
  "租更": "zū,gēng",
  "租调": "zū,diào",
  "租钱": "zū,qian",
  "秤停": "chēng,tíng",
  "秤平斗满": "chèng,píng,dǒu,mǎn",
  "秤斤注两": "chēng,jīn,zhù,liǎng",
  "秤杆": "chèng,gǎn",
  "秤盘子": "chèng,pán,zi",
  "秤薪而爨": "chēng,xīn,ér,cuàn",
  "秤量": "chēng,liàng",
  "秤锤不离秤杆": "chèng,chuí,bù,lí,chèng,gǎn",
  "秦侯瓜": "qín,hòu,guā",
  "秦吉了": "qín,jí,liǎo",
  "秦汉子": "qín,hàn,zi",
  "秦王破阵乐": "qín,wáng,pò,zhèn,yuè",
  "秦邮帖": "qín,yóu,tiē",
  "秦都": "qín,dū",
  "秦都区": "qín,dū,qū",
  "秧子": "yāng,zi",
  "秧歌": "yāng,ge",
  "秧歌剧": "yāng,ge,jù",
  "秪今": "zhī,jīn",
  "秪候": "zhī,hòu",
  "秪应": "zhī,yìng",
  "秪管": "zhī,guǎn",
  "秫缝": "shú,fèng",
  "积习地": "jī,xí,de",
  "积以为常": "jī,yǐ,wéi,cháng",
  "积分常数": "jī,fēn,cháng,shù",
  "积功兴业": "jī,gōng,xīng,yè",
  "积囤": "jī,dùn",
  "积土为山": "jī,shuǐ,wéi,shān",
  "积𰊂": "jī,dì",
  "积处": "jī,chǔ",
  "积岁累月": "jī,suì,lěi,yuè",
  "积年累岁": "jī,nián,lěi,suì",
  "积年累月": "jī,nián,lěi,yuè",
  "积微致着": "jī,wēi,zhì,zhe",
  "积德累仁": "jī,dé,lěi,rén",
  "积德累功": "jī,dé,lěi,gōng",
  "积德累善": "jī,dé,lěi,shàn",
  "积数": "jī,shù",
  "积日累久": "jī,rì,lěi,jiǔ",
  "积日累岁": "jī,rì,lěi,suì",
  "积日累月": "jī,rì,lěi,yuè",
  "积时累日": "jī,shí,lěi,rì",
  "积极分子": "jī,jí,fèn,zǐ",
  "积极反应": "jī,jí,fǎn,yìng",
  "积极地": "jī,jí,de",
  "积极地推动": "jī,jí,de,tuī,dòng",
  "积极地收集": "jī,jí,de,shōu,jí",
  "积极地改善": "jī,jí,de,gǎi,shàn",
  "积水为海": "jī,shuǐ,wéi,hǎi",
  "积着": "jī,zhe",
  "积素累旧": "jī,sù,lěi,jiù",
  "积累": "jī,lěi",
  "积累性": "jī,lěi,xìng",
  "积累毒性": "jī,lěi,dú,xìng",
  "积翫": "jī,wàn",
  "积葛": "jī,gě",
  "积褚": "jī,chǔ",
  "积谗糜骨": "jī,chán,méi,gǔ",
  "积载": "jī,zǎi",
  "积金累玉": "jī,jīn,lèi,yù",
  "积金至斗": "jī,jīn,zhì,dǒu",
  "积铢累寸": "jī,zhū,lěi,cùn",
  "积露为波": "jī,lù,wéi,bō",
  "称为": "chēng,wéi",
  "称之为": "chēng,zhī,wéi",
  "称体": "chèn,tǐ",
  "称体裁衣": "chèn,tǐ,cái,yī",
  "称体载衣": "chèn,tǐ,zài,yī",
  "称多": "chèn,duō",
  "称多县": "chèn,duō,xiàn",
  "称家有无": "chèn,jiā,yǒu,wú",
  "称得上": "chēng,de,shàng",
  "称德度功": "chēng,dé,duó,gōng",
  "称心": "chèn,xīn",
  "称心如意": "chèn,xīn,rú,yì",
  "称心快意": "chèn,xīn,kuài,yì",
  "称心满意": "chèn,xīn,mǎn,yì",
  "称愿": "chèn,yuàn",
  "称手": "chèn,shǒu",
  "称数": "chēng,shù",
  "称职": "chèn,zhí",
  "称蕃": "chēng,fān",
  "称责": "chēng,zhài",
  "称赞地": "chēng,zàn,de",
  "称身": "chèn,shēn",
  "称量": "chēng,liáng",
  "称钱": "chèn,qián",
  "称锤": "chèng,chuí",
  "秸杆": "jiē,gǎn",
  "移天适人": "yí,tiān,shì,rén",
  "移孝为忠": "yí,xiào,wéi,zhōng",
  "移星换斗": "yí,xīng,huàn,dǒu",
  "移春槛": "yí,chūn,kǎn",
  "移更": "yí,gēng",
  "移的就箭": "yí,dì,jiù,jiàn",
  "移行": "yí,háng",
  "移解": "yí,jiè",
  "移调": "yí,diào",
  "移里堇": "yí,lǐ,jǐn",
  "秽累": "huì,lèi",
  "秽貉": "huì,mò",
  "稀即地": "xī,jí,de",
  "稀奇古怪地": "xī,qí,gǔ,guài,de",
  "稀少地": "xī,shǎo,de",
  "稀成性地": "xī,chéng,xìng,de",
  "稀疏地": "xī,shū,de",
  "稀罕": "xī,han",
  "稀薄": "xī,bó",
  "稀释地": "xī,shì,de",
  "稀里光当": "xī,li,guāng,dāng",
  "稀里哗啦": "xī,lǐ,huā,lā",
  "稀零零地": "xī,líng,líng,de",
  "程子": "chéng,zi",
  "程度地": "chéng,dù,de",
  "程朱学派": "chéng,zhū,xué,pai",
  "程露": "chéng,lù",
  "稍为": "shāo,wéi",
  "稍快地": "shāo,kuài,de",
  "稍息": "shào,xī",
  "稍缓地": "shāo,huǎn,de",
  "稍迟地": "shāo,chí,de",
  "税卡": "shuì,qiǎ",
  "税帖": "shuì,tiē",
  "税舍": "shuì,shè",
  "税调": "shuì,diào",
  "稖头": "bàng,tou",
  "稗乘": "bài,shèng",
  "稗子面": "bài,zi,miàn",
  "稗子面馍馍": "bài,zi,miàn,mó,mó",
  "稚免": "zhì,wèn",
  "稚嫩地": "zhì,nèn,de",
  "稚气地": "zhì,qì,de",
  "稚齿婑媠": "zhì,chǐ,wǒ,tuǒ",
  "稛载": "kǔn,zǎi",
  "稠密地": "chóu,mì,de",
  "稠糊": "chóu,hū",
  "稠适": "chóu,shì",
  "稡撷": "zú,xié",
  "稳健地": "wěn,jiàn,de",
  "稳吃三注": "wén,chī,sān,zhù",
  "稳固地": "wěn,gù,de",
  "稳定地": "wěn,deng,de",
  "稳帖": "wěn,tiē",
  "稳当地": "wěn,dāng,de",
  "稳扎稳打": "wěn,zhā,wěn,dǎ",
  "稳打稳扎": "wěn,dǎ,wěn,zhā",
  "稳步前进": "wén,bù,qián,jìn",
  "稳步地": "wěn,bù,de",
  "稳秘地": "wěn,mì,de",
  "稳稳地": "wěn,wěn,de",
  "稳稳扎扎": "wěn,wěn,zhā,zhā",
  "稴䅟": "xián,shān",
  "稻子": "dào,zi",
  "稻舍": "dào,shè",
  "稻荷寿司": "dào,hè,shòu,sī",
  "稽山大王": "jī,shān,dài,wáng",
  "稽颡": "qǐ,sǎng",
  "稽首": "qǐ,shǒu",
  "稽首再拜": "qǐ,shǒu,zài,bài",
  "稾芼": "gǎo,mào",
  "稿子": "gǎo,zi",
  "稿干": "gǎo,gàn",
  "穆棱": "mù,líng",
  "穆棱市": "mù,líng,shì",
  "䅟稗": "shān,bài",
  "䅟䅟": "shān,shān",
  "穰穰": "rǎng,rǎng",
  "穰穰劳劳": "rǎng,rǎng,láo,láo",
  "穰穰垓垓": "rǎng,rǎng,gāi,gāi",
  "穴埳": "xué,kǎn",
  "穴处": "xué,chǔ",
  "穴居野处": "xué,jū,yě,chǔ",
  "穵运": "yà,yùn",
  "穵选": "yà,xuǎn",
  "究处": "jiū,chǔ",
  "穷于应付": "qióng,yú,yìng,fù",
  "穷亡解沮": "qing,wang,jie,ju",
  "穷剥": "qióng,bāo",
  "穷发": "qióng,fà",
  "穷咽": "qióng,yān",
  "穷哥们": "qióng,gē,men",
  "穷困地": "qióng,kùn,de",
  "穷困潦倒": "qióng,kùn,liáo,dǎo",
  "穷埏": "qióng,shān",
  "穷处": "qióng,chǔ",
  "穷家薄业": "qióng,jiā,bó,yè",
  "穷小子": "qióng,xiǎo,zi",
  "穷岁累月": "qióng,suì,lèi,yuè",
  "穷年累世": "qióng,nián,lěi,shì",
  "穷年累岁": "qióng,nián,lèi,suì",
  "穷年累月": "qióng,nián,lěi,yuè",
  "穷形尽相": "qióng,xíng,jìn,xiàng",
  "穷愁潦倒": "qióng,chóu,liáo,dǎo",
  "穷折": "qióng,shé",
  "穷朴": "qióng,piáo",
  "穷棒子": "qióng,bàng,zi",
  "穷瘪醋": "qióng,biě,cù",
  "穷相骨头": "qióng,xiāng,gú,tou",
  "穷踧": "qióng,dí",
  "穷途潦倒": "qióng,tú,liáo,dǎo",
  "穷途落魄": "qióng,tú,luò,tuò",
  "穷酸相": "qióng,suān,xiàng",
  "穷露": "qióng,lù",
  "穷骨头": "qióng,gú,tou",
  "穹状地": "qióng,zhuàng,de",
  "穹祇": "qióng,qí",
  "空中少爷": "kōng,zhōng,shào,ye",
  "空余": "kòng,yú",
  "空侯": "kōng,hòu",
  "空儿": "kòng,ér",
  "空出": "kòng,chū",
  "空前地": "kōng,qián,de",
  "空前地多": "kōng,qián,de,duō",
  "空包弹": "kōng,bāo,dàn",
  "空匮": "kòng,kuì",
  "空地": "kòng,dì",
  "空地导弹": "kōng,dì,dǎo,dàn",
  "空场闲地": "kōng,chǎng,xián,de",
  "空埳": "kōng,kǎn",
  "空夐": "kōng,xuàn",
  "空子": "kòng,zi",
  "空孔状地": "kōng,kǒng,zhuàng,de",
  "空对空导弹": "kōng,duì,kōng,dǎo,dàn",
  "空少": "kōng,shào",
  "空峒": "kōng,dòng",
  "空弮": "kōng,quān",
  "空心儿": "kòng,xīn,er",
  "空心地": "kōng,xīn,de",
  "空心架子": "kōng,xīn,jià,zi",
  "空心萝卜": "kōng,xīn,luó,bo",
  "空想地": "kōng,xiǎng,de",
  "空手地": "kōng,shǒu,de",
  "空无一人": "kōng,wú,yì,rén",
  "空日": "kòng,rì",
  "空旷地": "kōng,kuàng,de",
  "空暇": "kòng,xiá",
  "空暇地": "kòng,xiá,de",
  "空架子": "kōng,jià,zi",
  "空格键": "kòng,gé,jiàn",
  "空洞地": "kōng,dòng,de",
  "空瘪": "kōng,biě",
  "空白": "kòng,bái",
  "空白地": "kòng,bái,de",
  "空白支票": "kòng,bái,zhī,piào",
  "空白点": "kòng,bái,diǎn",
  "空着手": "kōng,zhe,shǒu",
  "空穴来风未必无因": "kòng,xué,lái,fēng,wèi,bì,wú,yīn",
  "空空儿": "kōng,kòng,ér",
  "空空地": "kōng,kōng,de",
  "空空导弹": "kōng,kōng,dǎo,dàn",
  "空缺": "kòng,quē",
  "空腹便便": "kōng,fù,pián,pián",
  "空舍清野": "kōng,shè,qīng,yě",
  "空虚地": "kōng,xū,de",
  "空转": "kōng,zhuàn",
  "空载地": "kōng,zài,de",
  "空郄": "kōng,xì",
  "空钟": "kōng,zhong",
  "空闲": "kòng,xián",
  "空闲地": "kòng,xián,de",
  "空间地": "kōng,jiān,de",
  "空隙": "kòng,xì",
  "空难": "kōng,nàn",
  "空额": "kòng,é",
  "穿一条裤子": "chuān,yī,tiáo,kù,zi",
  "穿上": "chuān,shang",
  "穿扎": "chuān,zhā",
  "穿甲弹": "chuān,jiǎ,dàn",
  "穿着": "chuān,zhe",
  "穿着打扮": "chuān,zhe,dǎ,bàn",
  "穿着讲究": "chuān,zhuó,jiǎng,jiu",
  "穿红着绿": "chuān,hóng,zhe,lù",
  "突出地": "tū,chū,de",
  "突发地": "tū,fā,de",
  "突将": "tū,jiàng",
  "突然地": "tū,rán,de",
  "突起地": "tū,qǐ,de",
  "突飞猛进地": "tū,fēi,měng,jìn,de",
  "窃掠": "qiè,lüě",
  "窄窄别别": "zhǎi,zhǎi,biè,biè",
  "窄缝": "zhǎi,fèng",
  "窇穵": "báo,yà",
  "窈娜": "yǎo,nà",
  "窋室": "kū,shì",
  "窋窡": "kū,zhuó",
  "窍门儿": "qiào,mén,er",
  "窑姐儿": "yáo,jiě,er",
  "窑子": "yáo,zi",
  "窑箄": "yáo,bǐ",
  "窑调": "yáo,diào",
  "窗口行业": "chuāng,kǒu,háng,yè",
  "窗子": "chuāng,zi",
  "窗户": "chuāng,hu",
  "窗明几净": "chuāng,míng,jī,jìng",
  "窗格子": "chuāng,gé,zi",
  "窗棂子": "chuāng,líng,zi",
  "窗槛": "chuāng,kǎn",
  "窘困地": "jiǒng,kùn,de",
  "窘相": "jiǒng,xiàng",
  "窘蹶": "jiǒng,juě",
  "窜削": "cuàn,xuē",
  "窜𰺷": "cuàn,rǎo",
  "窝儿里横": "wō,ér,lǐ,hèng",
  "窝囊": "wō,nāng",
  "窝囊废": "wō,nāng,fèi",
  "窝囊气": "wō,nāng,qì",
  "窝囊相": "wō,nāng,xiāng",
  "窝囊肺": "wō,nāng,fèi",
  "窝囤": "wō,dùn",
  "窝子": "wō,zi",
  "窝瘪": "wō,biě",
  "窝窝别别": "wō,wō,biè,biè",
  "窝窝瘪瘪": "wō,wō,biě,biě",
  "窝脖儿": "wō,bó,er",
  "窝里反": "wō,li,fǎn",
  "窝里斗": "wō,li,dòu",
  "窝里横": "wō,li,hèng",
  "窝铺": "wō,pù",
  "窝阔台汗": "wō,kuò,tái,hán",
  "窞处": "dàn,chǔ",
  "窟窿": "kū,long",
  "窟窿眼": "kū,long,yǎn",
  "窥伺": "kuī,sì",
  "窥度": "kuī,duó",
  "窥筩": "kuī,yǒng",
  "窥间伺隙": "kuī,jiàn,sì,xì",
  "窨付": "xūn,fù",
  "窨服": "xūn,fú",
  "窨气": "xūn,qì",
  "窨清": "xūn,qīng",
  "窨约": "xūn,yuē",
  "窨腹": "xūn,fù",
  "窭数": "jù,shù",
  "窸窣": "xī,sù",
  "窾郄": "kuǎn,xì",
  "立传": "lì,zhuàn",
  "立体地": "lì,tǐ,de",
  "立体声地": "lì,tǐ,shēng,de",
  "立刻地": "lì,kè,de",
  "立即地": "lì,jí,de",
  "立卷": "lì,juàn",
  "立慬": "lì,jìn",
  "立扎": "lì,zhā",
  "立有间": "lì,yǒu,jiàn",
  "立朝夕": "lì,zhāo,xī",
  "立规矩": "lì,guī,ju",
  "立身处世": "lì,shēn,chǔ,shì",
  "立适": "lì,shì",
  "立𬭢": "lì,kuì",
  "竖直地": "shù,zhí,de",
  "竖着地": "shù,zhe,de",
  "竖篴": "shù,dí",
  "竖起大拇指": "shù,qǐ,dà,mu,zhǐ",
  "竖起耳朵": "shù,qǐ,ěr,duo",
  "竖起脊梁": "shù,qǐ,jí,liáng",
  "站不住脚": "zhàn,bu,zhù,jiǎo",
  "站得远远地": "zhàn,dé,yuǎn,yuǎn,de",
  "站相": "zhàn,xiàng",
  "站着说话不腰疼": "zhàn,zhe,shuō,huà,bù,yāo,téng",
  "站长": "zhàn,zhǎng",
  "竞争地": "jìng,zhēng,de",
  "竞今疏古": "jìng,jīng,shū,gǔ",
  "竞赛地": "jìng,sài,de",
  "竞赛性地": "jìng,sài,xìng,de",
  "竟哇地一声": "jìng,wa,de,yī,shēng",
  "章什": "zhāng,shí",
  "章子": "zhāng,zi",
  "章甫缝掖": "zhāng,fǔ,fèng,yè",
  "章着": "zhāng,zhe",
  "章缝": "zhāng,fèng",
  "章露": "zhāng,lù",
  "章鱼小丸子": "zhāng,yú,xiǎo,wán,zi",
  "童仆": "tóng,pú",
  "童冠": "tóng,guān",
  "童卷": "tóng,juàn",
  "童颜鹤发": "tóng,yán,hè,fà",
  "童𫘤": "tóng,ái",
  "竦削": "sǒng,xuē",
  "竭尽地": "jié,jìn,de",
  "竭朴": "jié,piáo",
  "端子": "duān,zi",
  "端嶷": "duān,nì",
  "端庄地": "duān,zhuāng,de",
  "端架子": "duān,jià,zi",
  "端正地": "duān,zhèng,de",
  "端正月": "duān,zhēng,yuè",
  "端的": "duān,dì",
  "端量": "duān,liáng",
  "竹冠": "zhú,guān",
  "竹叶冠": "zhú,yè,guān",
  "竹园精舍": "zhú,yuán,jīng,shè",
  "竹夹": "zhú,jiā",
  "竹夹膝": "zhú,jiā,xī",
  "竹子": "zhú,zi",
  "竹帘子": "zhú,lián,zi",
  "竹干": "zhú,gàn",
  "竹弹": "zhú,dàn",
  "竹林精舍": "zhú,lín,jīng,shè",
  "竹栅": "zhú,shān",
  "竹槛": "zhú,kǎn",
  "竹町": "zhú,tīng",
  "竹皮冠": "zhú,pí,guān",
  "竹笓": "zhú,bì",
  "竹笮": "zhú,zé",
  "竹筒倒豆子": "zhú,tǒng,dǎo,dòu,zi",
  "竹筩": "zhú,yǒng",
  "竹签儿": "zhú,qiān,er",
  "竹箄": "zhú,bǐ",
  "竹箍儿": "zhú,gū,er",
  "竹篓子": "zhú,lǒu,zi",
  "竹篮打水": "zhú,lán,dá,shuǐ",
  "竹篱茅舍": "zhú,lí,máo,shè",
  "竹絙": "zhú,gēng",
  "竹节骨": "zhú,jiē,gǔ",
  "竹行": "zhú,háng",
  "竹露": "zhú,lù",
  "竺干": "zhú,gàn",
  "竺干公": "zhú,gàn,gōng",
  "竺干学": "zhú,gàn,xué",
  "竺干服": "zhú,gàn,fú",
  "竺干氏": "zhú,gàn,shì",
  "竿子": "gān,zi",
  "竿累": "gān,lèi",
  "笃么": "dǔ,mǒ",
  "笃信地": "dǔ,xìn,de",
  "笃信好学": "dǔ,xìn,hào,xué",
  "笃学好古": "dǔ,xué,hào,gǔ",
  "笃实好学": "dǔ,shí,hào,xué",
  "笄冠": "jī,guān",
  "笆斗": "bā,dǒu",
  "笆篱子": "bā,lí,zi",
  "笊篱": "zhào,li",
  "笋干儿": "sǔn,gān,er",
  "笋笴": "sǔn,gǎn",
  "笑到碌地": "xiào,dào,lù,de",
  "笑吟吟地": "xiào,yín,yín,de",
  "笑呵呵地": "xiào,hē,hē,de",
  "笑呵呵地说": "xiào,hē,hē,de,shuō",
  "笑呷呷": "xiào,gā,xiā",
  "笑咳咳": "xiào,hāi,hāi",
  "笑哄": "xiào,hǒng",
  "笑哑哑": "xiào,yā,yā",
  "笑嗑亚热": "xiào,kè,yà,rè",
  "笑嘻嘻地": "xiào,xī,xī,de",
  "笑嘻嘻地说": "xiào,xī,xī,de,shuō",
  "笑处藏刀": "xiào,chǔ,cáng,dāo",
  "笑眯眯地": "xiào,mī,mī,de",
  "笑眯眯地看着": "xiào,mī,mī,de,kàn,zhe",
  "笑笑地": "xiào,xiào,de",
  "笑筵歌席": "xiào,yàn,gē,xí",
  "笑脸儿": "xiào,liǎn,er",
  "笑话": "xiào,hua",
  "笑调": "xiào,diào",
  "笑迷糊": "xiào,mí,hu",
  "笓格": "bì,gé",
  "笓篱战格": "bì,lí,zhàn,gé",
  "笔乘": "bǐ,shèng",
  "笔兴": "bǐ,xīng",
  "笔划": "bǐ,huà",
  "笔划检字表": "bǐ,huà,jiǎn,zì,biǎo",
  "笔削": "bǐ,xuē",
  "笔削褒贬": "bǐ,xuē,bāo,biǎn",
  "笔头儿": "bǐ,tou,er",
  "笔帖": "bǐ,tiē",
  "笔帖式": "bǐ,tiē,shì",
  "笔杆": "bǐ,gǎn",
  "笔杆儿": "bǐ,gǎn,ér",
  "笔杆子": "bǐ,gǎn,zi",
  "笔画数": "bǐ,huà,shù",
  "笔直地": "bǐ,zhí,de",
  "笔调": "bǐ,diào",
  "笙咽": "shēng,yān",
  "笙煖": "shēng,xuān",
  "笙管乐": "shēng,guǎn,yuè",
  "笛子": "dí,zi",
  "笞搒": "chī,péng",
  "笞背": "chī,bèi",
  "笠冠蓑袂": "lì,guān,suō,mèi",
  "笠毂": "lì,gū",
  "笤帚": "tiáo,zhou",
  "符号逻辑": "fú,hào,luó,ji",
  "符合地": "fú,hé,de",
  "符帖": "fú,tiē",
  "符应": "fú,yìng",
  "符禁": "fú,jìn",
  "符𦈡": "fú,xū",
  "笨家伙": "bèn,jiā,huo",
  "笨拙地": "bèn,zhuō,de",
  "笨拙地做": "bèn,zhuō,de,zuò",
  "笨拙地爬行": "bèn,zhuō,de,pá,xíng",
  "笨重地": "bèn,zhòng,de",
  "第一信号系统": "dì,yī,shēn,hào,xì,tǒng",
  "第一名": "dì,yì,míng",
  "第一次世界大战": "dì,yí,cì,shì,jiè,dà,zhàn",
  "第一次东征": "dì,yí,cì,dōng,zhēng",
  "第一次国内革命战争": "dì,yí,cì,guó,nèi,gé,mìng,zhàn,zhēng",
  "第三代领导集体的当务之急": "dì,sān,dài,lǐng,dǎo,jí,tǐ,dí,dàng,wù,zhī,jí",
  "第二个人": "dì,èr,ge,rén",
  "第二性征": "dì,èr,xìng,zhǐ",
  "第比利斯": "dì,bì,lì,sī",
  "第舍": "dì,shè",
  "笭箐": "líng,jīng",
  "笮足": "zé,zú",
  "笮马": "zé,mǎ",
  "笮鼠": "zé,shǔ",
  "笼冠": "lóng,guān",
  "笼头": "lóng,tou",
  "笼子": "lóng,zi",
  "笼毂": "lóng,gū",
  "笼禽槛兽": "lóng,qín,kǎn,shòu",
  "笼络": "lǒng,luò",
  "笼络人心": "lǒng,luò,rén,xīn",
  "笼统": "lǒng,tǒng",
  "笼统地喊": "lǒng,tǒng,de,hǎn",
  "笼统地讲": "lǒng,tǒng,de,jiǎng",
  "笼统地说": "lǒng,tǒng,de,shuō",
  "笼罩": "lǒng,zhào",
  "笼街喝道": "lóng,jiē,hè,dào",
  "等一下": "děng,yí,xià",
  "等一下儿": "děng,yī,xià,er",
  "等一会儿": "děng,yī,huì,er",
  "等为": "děng,wéi",
  "等会儿": "děng,huì,er",
  "等地方": "děng,de,fāng",
  "等地相继": "děng,de,xiāng,jì",
  "等地租": "děng,de,zū",
  "等地部分地区": "děng,de,bù,fèn,de,qū",
  "等差数列": "děng,chā,shù,liè",
  "等差级数": "děng,chà,jí,shù",
  "等得": "děng,de",
  "等数": "děng,shù",
  "等无间缘": "děng,wú,jiàn,yuán",
  "等比数列": "děng,bǐ,shù,liè",
  "等比级数": "děng,bǐ,jí,shù",
  "等着瞧": "děng,zhe,qiáo",
  "等衰": "děng,cuī",
  "等身着作": "děng,shēn,zhe,zuò",
  "等高种植": "děng,gāo,zhòng,zhí",
  "筋干": "jīn,gàn",
  "筋斗": "jīn,dǒu",
  "筋斗云": "jīn,dǒu,yún",
  "筋簳": "jīn,gàn",
  "筋血": "jīn,xuè",
  "筌蹏": "quán,dì",
  "筌蹏一悟": "quán,dì,yī,wù",
  "筏子": "fá,zi",
  "筑坛拜将": "zhù,tán,bài,jiàng",
  "筑城睢阳曲": "zhù,chéng,suī,yáng,qǔ",
  "筑堤": "zhù,dī",
  "筑舍道傍": "zhù,shè,dào,bàng",
  "筒子": "tǒng,zi",
  "筒子斤斗": "tǒng,zǐ,jīn,dǒu",
  "答允": "dā,yǔn",
  "答剌棱登": "dá,là,lēng,dēng",
  "答卷": "dá,juàn",
  "答嘴": "dā,zuǐ",
  "答应": "dā,yìng",
  "答数": "dá,shù",
  "答理": "dā,lǐ",
  "答白": "dā,bái",
  "答答": "dā,dā",
  "答答战": "dā,dā,zhàn",
  "答腔": "dā,qiāng",
  "答蕃书": "dá,fān,shū",
  "答讪": "dā,shàn",
  "策划": "cè,huà",
  "策划人": "cè,huà,rén",
  "策应": "cè,yìng",
  "策得": "cè,de",
  "策数": "cè,shù",
  "策略地": "cè,lüè,de",
  "筛子": "shāi,zi",
  "筠筩": "yún,yǒng",
  "筠篁": "jūn,huáng",
  "筢子": "pá,zi",
  "筣笓": "lí,bì",
  "筩中": "yǒng,zhōng",
  "筩洒": "yǒng,sǎ",
  "筩瓦": "yǒng,wǎ",
  "筩褹": "yǒng,yì",
  "筩酒": "yǒng,jiǔ",
  "筵上": "yán,shǎng",
  "筷子": "kuài,zi",
  "筷子腿": "kuài,zi,tuǐ",
  "筷子舞": "kuài,zi,wǔ",
  "筷子芥": "kuài,zi,jiè",
  "筷笼子": "kuài,lóng,zi",
  "筹划": "chóu,huà",
  "筹子": "chóu,zi",
  "筹干": "chóu,gàn",
  "筹䇲": "chóu,jiā",
  "签堤": "qiān,dī",
  "签子": "qiān,zi",
  "签帖": "qiān,tiē",
  "签押处": "qiān,yā,chǔ",
  "签筩": "qiān,yǒng",
  "简伉": "jiǎn,gāng",
  "简侻": "jiǎn,tuì",
  "简便地": "jiǎn,biàn,de",
  "简分数": "jiǎn,fēn,shù",
  "简切": "jiǎn,qiè",
  "简切了当": "jiǎn,qiè,liǎo,dàng",
  "简单地": "jiǎn,dān,de",
  "简单地看了一下": "jiǎn,dān,de,kàn,le,yī,xià",
  "简单地讲": "jiǎn,dān,de,jiǎng",
  "简单地说": "jiǎn,dān,de,shuō",
  "简单明了": "jiǎn,dān,míng,liǎo",
  "简帖": "jiǎn,tiē",
  "简帖儿": "jiǎn,tiě,er",
  "简慠": "jiǎn,ào",
  "简截了当": "jiǎn,jié,liǎo,dàng",
  "简捷了当": "jiǎn,jié,liǎo,dàng",
  "简明地": "jiǎn,míng,de",
  "简易爆炸装置": "jiǎn,yì,zhà,dàn,zhuāng,zhì",
  "简朴": "jiǎn,piáo",
  "简朴地": "jiǎn,piáo,de",
  "简查": "jiǎn,zhā",
  "简洁地": "jiǎn,jié,de",
  "简牌子": "jiǎn,pái,zi",
  "简略地": "jiǎn,lüè,de",
  "简短地": "jiǎn,duǎn,de",
  "简种薄收": "jiǎn,zhǒng,bó,shōu",
  "简䇲": "jiǎn,jiā",
  "简絜": "jiǎn,jié",
  "简练地": "jiǎn,liàn,de",
  "简练揣摩": "jiǎn,liàn,chuǎi,mó",
  "简翟": "jiǎn,zhái",
  "简要地": "jiǎn,yào,de",
  "简调": "jiǎn,diào",
  "箄筏": "bǐ,fá",
  "箄篮": "bǐ,lán",
  "箄船": "bǐ,chuán",
  "箍儿": "gū,er",
  "箍子": "gū,zi",
  "箍节儿": "gū,jie,er",
  "箐峒": "qìng,dòng",
  "箐泽": "jīng,zé",
  "箐鸡": "jīng,jī",
  "算不了": "suàn,bù,liǎo",
  "算命先生": "suàn,mìng,xiān,sheng",
  "算子": "suàn,zi",
  "算应": "suàn,yìng",
  "算得": "suàn,de",
  "算数": "suàn,shù",
  "算术地": "suàn,shù,de",
  "算术平均数": "suàn,shù,píng,jūn,shù",
  "算术级数": "suàn,shù,jí,shù",
  "算盘子儿": "suàn,pán,zi,er",
  "算计": "suàn,ji",
  "箘露": "jùn,lù",
  "箝揣": "qián,chuāi",
  "箝𥬞": "qián,mí",
  "管不着": "guǎn,bu,zháo",
  "管乐": "guǎn,yuè",
  "管乐器": "guǎn,yuè,qì",
  "管乐队": "guǎn,yuè,duì",
  "管儿灯": "guǎn,er,dēng",
  "管城侯": "guǎn,chéng,hòu",
  "管子工": "guǎn,zi,gōng",
  "管子钳": "guǎn,zi,qián",
  "管干": "guǎn,gàn",
  "管弦乐": "guǎn,xián,yuè",
  "管弦乐团": "guǎn,xián,yuè,tuán",
  "管弦乐队": "guǎn,xián,yuè,duì",
  "管得着": "guǎn,de,zháo",
  "管着": "guǎn,zhe",
  "管窥蠡测": "guǎn,kuī,lí,cè",
  "管葛": "guǎn,gě",
  "管蠡": "guǎn,lí",
  "管蠡窥测": "guǎn,lí,kuī,cè",
  "管辖地": "guǎn,xiá,de",
  "箢子": "yuān,zǐ",
  "箢箕": "yuān,jī",
  "箢篼": "yuān,dōu",
  "箥箩": "bǒ,luó",
  "箥罗": "bǒ,luó",
  "箨冠": "tuò,guān",
  "箪食": "dān,sì",
  "箪食壶浆": "dān,sì,hú,jiāng",
  "箪食壶酒": "dān,sì,hú,jiǔ",
  "箪食瓢饮": "dān,sì,piáo,yǐn",
  "箫干": "xiāo,gàn",
  "箭也似地": "jiàn,yě,shì,de",
  "箭干": "jiàn,gàn",
  "箭干白": "jiàn,gàn,bái",
  "箭杆": "jiàn,gǎn",
  "箭穿着雁口": "jiàn,chuān,zhe,yàn,kǒu",
  "箭笴": "jiàn,gǎn",
  "箭筩": "jiàn,yǒng",
  "箭簳": "jiàn,gàn",
  "箱儿里盛只": "xiāng,ér,lǐ,shèng,zhī",
  "箱子": "xiāng,zi",
  "箱笼": "xiāng,lǒng",
  "箴讽": "zhēn,fěng",
  "箾椮": "xiāo,sēn",
  "箾蔘": "xiāo,shēn",
  "箾韶": "xiāo,sháo",
  "篇什": "piān,shí",
  "篇卷": "piān,juàn",
  "篇幅": "piān,fu",
  "篇数": "piān,shù",
  "篓子": "lǒu,zi",
  "篙头": "gāo,tou",
  "篡夺地": "cuàn,duó,de",
  "篡煞": "cuàn,shà",
  "篣捶": "páng,chuí",
  "篣格": "páng,gé",
  "篣楚": "páng,chǔ",
  "篣筤": "páng,láng",
  "篦头铺": "bì,tóu,pù",
  "篦子": "bì,zi",
  "篮子": "lán,zi",
  "篱笆": "lí,ba",
  "篷帆": "péng,fān",
  "𥮾岭": "zān,lǐng",
  "𥮾管": "zān,guǎn",
  "𥮾𥮾": "zān,zān",
  "簇生地": "cù,shēng,de",
  "簇肆地": "cù,sì,de",
  "簟茀": "diàn,bó",
  "簪冠": "zān,guān",
  "簪子": "zān,zi",
  "簪笔磬折": "zān,bǐ,qìng,shé",
  "簳珠": "gàn,zhū",
  "簸动": "bǒ,dòng",
  "簸土扬沙": "bǒ,tǔ,yáng,shā",
  "簸弄": "bǒ,nòng",
  "簸扬": "bǒ,yáng",
  "簸扬糠秕": "bǒ,yáng,kāng,bǐ",
  "簸扬糠粃": "bǒ,yáng,kāng,bǐ",
  "簸箕掌": "bò,ji,zhǎng",
  "簸箕星": "bò,ji,xīng",
  "簸箕虫": "bò,ji,chóng",
  "簸箩": "bǒ,luó",
  "簸荡": "bǒ,dàng",
  "簸行": "bǒ,xíng",
  "簸谷": "bǒ,gǔ",
  "𥬞口": "mí,kǒu",
  "𥬞子": "mí,zǐ",
  "籍削": "jí,xuē",
  "籍没": "jí,mò",
  "籍禁": "jí,jìn",
  "籍茅": "jiè,máo",
  "籍贯地": "jí,guàn,de",
  "篯彭": "jiān,péng",
  "篯芽": "jiān,yá",
  "篯铿": "jiān,kēng",
  "籧筁": "jǔ,qū",
  "籧筐": "jǔ,kuāng",
  "籧篨": "jǔ,chú",
  "籧蒢": "jǔ,chú",
  "米芾": "mǐ,fú",
  "米袋子": "mǐ,dài,zi",
  "类似地": "lèi,sì,de",
  "类兰若": "lèi,lán,rě",
  "类帖": "lèi,tiē",
  "类推地": "lèi,tuī,de",
  "类犴": "lèi,àn",
  "粃缪": "bǐ,miù",
  "粉侯": "fěn,hòu",
  "粉坊": "fěn,fáng",
  "粉白黛绿": "fěn,bái,dài,lù",
  "粉雕玉琢": "fěn,diāo,yù,zuó",
  "粗俗地": "cū,sú,de",
  "粗劣地": "cū,liè,de",
  "粗卤地": "cū,lǔ,de",
  "粗厚地": "cū,hòu,de",
  "粗呢": "cū,ní",
  "粗声地": "cū,shēng,de",
  "粗声地说": "cū,shēng,de,shuō",
  "粗心地": "cū,xīn,de",
  "粗暴地": "cū,bào,de",
  "粗朴": "cū,piáo",
  "粗杂地": "cū,zá,de",
  "粗活儿": "cū,huó,er",
  "粗率": "cū,shuài",
  "粗率地": "cū,lǜ,de",
  "粗率地作": "cū,lǜ,de,zuò",
  "粗略地": "cū,lüè,de",
  "粗略地说": "cū,lüè,de,shuō",
  "粗略地阅读": "cū,lüè,de,yuè,dú",
  "粗笨地": "cū,bèn,de",
  "粗粗地": "cū,cū,de",
  "粗糙地": "cū,cāo,de",
  "粗缞斩": "cū,shuāi,zhǎn",
  "粗缪": "cū,miù",
  "粗花呢": "cū,huā,ní",
  "粗谩": "cū,màn",
  "粗鄙地": "cū,bǐ,de",
  "粗野地": "cū,yě,de",
  "粗陋地": "cū,lòu,de",
  "粗鲁地": "cū,lǔ,de",
  "粘信封": "zhān,xìn,fēng",
  "粘儿": "zhān,ér",
  "粘冰冰地": "zhān,bīng,bīng,de",
  "粘叶": "zhān,yè",
  "粘带": "zhān,dài",
  "粘据": "zhān,jù",
  "粘接": "zhān,jiē",
  "粘涂": "zhān,tú",
  "粘涎": "zhān,xián",
  "粘涩": "zhān,sè",
  "粘湿": "zhān,shī",
  "粘牙": "zhān,yá",
  "粘皮带骨": "zhān,pí,dài,gǔ",
  "粘皮着骨": "zhān,pí,zhe,gǔ",
  "粘皮著骨": "nián,pí,zhuó,gǔ",
  "粘着性地": "zhān,zhe,xìng,de",
  "粘竿": "zhān,gān",
  "粘粘糊糊": "nián,nián,hū,hū",
  "粘糊": "nián,hū",
  "粘糊糊": "nián,hū,hū",
  "粘糕": "zhān,gāo",
  "粘船鱼": "zhān,chuán,yú",
  "粘花惹草": "zhān,huā,rě,cǎo",
  "粘补": "zhān,bǔ",
  "粘贴": "zhān,tiē",
  "粘赘": "zhān,zhuì",
  "粘踪": "zhān,zōng",
  "粘连": "zhān,lián",
  "粘附地": "zhān,fù,de",
  "粘鸡": "zhān,jī",
  "粟子": "sù,zi",
  "粢盛": "zī,chéng",
  "粪便隐血试验": "fèn,biàn,yǐn,xuè,shì,yàn",
  "粪土不如": "fèn,tú,bù,rú",
  "粪耙": "fèn,pá",
  "粮囤": "liáng,dùn",
  "粮行": "liáng,háng",
  "粹折": "cuì,shé",
  "粽子": "zòng,zi",
  "粽熬将军": "zòng,áo,jiāng,jūn",
  "精义入神": "jing,yi,ru,shen",
  "精兵强将": "jīng,bīng,qiáng,jiàng",
  "精切": "jīng,qiè",
  "精制地蜡": "jīng,zhì,de,là",
  "精力旺盛地": "jīng,lì,wàng,shèng,de",
  "精子库": "jīng,zi,kù",
  "精密地": "jīng,mì,de",
  "精巧地": "jīng,qiǎo,de",
  "精干": "jīng,gàn",
  "精干高效": "jīng,gàn,gāo,xiào",
  "精当": "jīng,dàng",
  "精彩地": "jīng,cǎi,de",
  "精悍地": "jīng,hàn,de",
  "精明地": "jīng,míng,de",
  "精明强干": "jīng,míng,qiáng,gàn",
  "精明能干": "jīng,míng,néng,gàn",
  "精晃晃": "jīng,huàng,huǎng",
  "精校": "jīng,jiào",
  "精液地": "jīng,yè,de",
  "精灵宝钻": "jīng,líng,bǎo,zuàn",
  "精炼地": "jīng,liàn,de",
  "精甲": "jīng,jiá",
  "精确地": "jīng,què,de",
  "精确地找到": "jīng,què,de,zhǎo,dào",
  "精确地说": "jīng,què,de,shuō",
  "精神上地": "jīng,shén,shàng,de",
  "精神不振": "jīng,shén,bú,zhèn",
  "精神地": "jīng,shén,de",
  "精神头儿": "jīng,shén,tóu,er",
  "精神抖擞": "jīng,shén,dǒu,sǒu",
  "精索静脉曲张": "jīng,suǒ,jìng,mài,qū,zhāng",
  "精絜": "jīng,jié",
  "精练地": "jīng,liàn,de",
  "精细地": "jīng,xì,de",
  "精致地": "jīng,zhì,de",
  "精致露营": "jīng,zhì,lù,yíng",
  "精舍": "jīng,shè",
  "精血": "jīng,xuè",
  "精辟地": "jīng,pì,de",
  "精选地": "jīng,xuǎn,de",
  "精通地": "jīng,tōng,de",
  "精馏": "jīng,liú",
  "糁盆": "shēn,pén",
  "糁粒": "shēn,lì",
  "糁糁": "shēn,shēn",
  "糊弄": "hù,nòng",
  "糊涂地": "hú,tú,de",
  "糊状地": "hú,zhuàng,de",
  "糊糊": "hū,hū",
  "糊糊涂涂": "hū,hū,tú,tú",
  "糖人儿": "táng,rén,er",
  "糖块儿": "táng,kuài,er",
  "糖弹": "táng,dàn",
  "糖萝卜": "táng,luó,bo",
  "糖葫芦": "táng,hú,lu",
  "糖衣炮弹": "táng,yī,pào,dàn",
  "糜子": "méi,zǐ",
  "糟坊": "zāo,fáng",
  "糟堤": "zāo,dī",
  "糟糕地": "zāo,gāo,de",
  "糟腌": "zāo,yān",
  "糟践": "zāo,jian",
  "糟蹋地": "zāo,tà,de",
  "糟透地": "zāo,tòu,de",
  "糟隄": "zāo,dī",
  "糢糊": "mó,hu",
  "糨子": "jiàng,zi",
  "糨糊": "jiàng,hù",
  "系上": "jì,shang",
  "系好": "jì,hǎo",
  "系带": "jì,dài",
  "系数": "xì,shù",
  "系泊": "jì,bó",
  "系留": "jì,liú",
  "系着": "xì,zhe",
  "系紧": "jì,jǐn",
  "系绁": "xì,yì",
  "系统地": "xì,tǒng,de",
  "系统地阐述": "xì,tǒng,de,chǎn,shù",
  "系统角色": "xì,tǒng,jué,sè",
  "系绳": "jì,shéng",
  "系绳子": "jì,shéng,zǐ",
  "系缆": "jì,lǎn",
  "系腰": "jì,yāo",
  "系鞋带": "jì,xié,dài",
  "紊乱地": "wěn,luàn,de",
  "素丞相": "sù,chéng,xiàng",
  "素侯": "sù,hòu",
  "素冠": "sù,guān",
  "素卷": "sù,juàn",
  "素数": "sù,shù",
  "素朴": "sù,piáo",
  "素着": "sù,zhe",
  "素祇": "sù,qí",
  "素绩": "sù,jī",
  "素锦褚": "sù,jǐn,chǔ",
  "索兴": "suǒ,xīng",
  "索处": "suǒ,chǔ",
  "索葛": "suǒ,gě",
  "索还": "suǒ,huán",
  "紧卷": "jǐn,juàn",
  "紧密地": "jǐn,mì,de",
  "紧密地合作": "jǐn,mì,de,hé,zuò",
  "紧密地结合": "jǐn,mì,de,jié,hé",
  "紧张不安地": "jǐn,zhāng,bù,ān,de",
  "紧张地": "jǐn,zhāng,de",
  "紧张地工作": "jǐn,zhāng,de,gōng,zuò",
  "紧张地握着": "jǐn,zhāng,de,wò,zhe",
  "紧张地盯着": "jǐn,zhāng,de,dīng,zhe",
  "紧张地说": "jǐn,zhāng,de,shuō",
  "紧急地": "jǐn,jí,de",
  "紧急应变": "jǐn,jí,yìng,biàn",
  "紧挨着地": "jǐn,āi,zhe,de",
  "紧接着": "jǐn,jiē,zhe",
  "紧握地": "jǐn,wò,de",
  "紧着": "jǐn,zhe",
  "紧紧地": "jǐn,jǐn,de",
  "紧紧地吸住": "jǐn,jǐn,de,xī,zhù",
  "紧紧地吸附": "jǐn,jǐn,de,xī,fù",
  "紧紧地把": "jǐn,jǐn,de,bǎ",
  "紧紧地抓住": "jǐn,jǐn,de,zhuā,zhù",
  "紧紧地抱住": "jǐn,jǐn,de,bào,zhù",
  "紧紧地抱着": "jǐn,jǐn,de,bào,zhe",
  "紧紧地握住": "jǐn,jǐn,de,wò,zhù",
  "紧紧地搂住": "jǐn,jǐn,de,lǒu,zhù",
  "紧紧地搂在怀里": "jǐn,jǐn,de,lǒu,zài,huái,lǐ",
  "紧紧地粘在一起": "jǐn,jǐn,de,zhān,zài,yì,qǐ",
  "紧紧地绑在": "jǐn,jǐn,de,bǎng,zài",
  "紧紧地贴住": "jǐn,jǐn,de,tiē,zhù",
  "紧紧地贴在": "jǐn,jǐn,de,tiē,zài",
  "紧紧地贴着": "jǐn,jǐn,de,tiē,zhe",
  "紧紧地跟随着": "jǐn,jǐn,de,gēn,suí,zhe",
  "紧紧地靠着": "jǐn,jǐn,de,kào,zhe",
  "紧要地": "jǐn,yào,de",
  "紧跟不舍": "jǐn,gēn,bú,shè",
  "紧迫地": "jǐn,pò,de",
  "紧邻地": "jǐn,lín,de",
  "紧靠地": "jǐn,kào,de",
  "紫微斗数": "zǐ,wēi,dǒu,shù",
  "紫微舍人": "zǐ,wēi,shè,rén",
  "紫摽": "zǐ,biāo",
  "紫禁": "zǐ,jìn",
  "紫禁城": "zǐ,jìn,chéng",
  "紫背椋鸟": "zǐ,bèi,liáng,niǎo",
  "紫阳观": "zǐ,yáng,guàn",
  "累七": "lèi,qī",
  "累世": "lěi,shì",
  "累世不仕": "lěi,shì,bú,shì",
  "累丸": "lèi,wán",
  "累乏": "lèi,fá",
  "累了": "lèi,le",
  "累人": "lèi,rén",
  "累仍": "lèi,réng",
  "累代": "lěi,dài",
  "累俘": "lèi,fú",
  "累加": "lèi,jiā",
  "累加器": "lěi,jiā,qì",
  "累加总数": "lěi,jiā,zǒng,shù",
  "累劫": "lèi,jié",
  "累劳": "lěi,láo",
  "累卵": "lěi,luǎn",
  "累卵之危": "lěi,luǎn,zhī,wēi",
  "累及": "lěi,jí",
  "累及无辜": "lěi,jí,wú,gū",
  "累句": "lěi,jù",
  "累叶": "lèi,yè",
  "累土聚沙": "lěi,tǔ,jù,shā",
  "累土至山": "lěi,tǔ,zhì,shān",
  "累圣": "lèi,shèng",
  "累坏": "lèi,huài",
  "累块积苏": "lěi,kuài,jī,sū",
  "累垂": "lèi,chuí",
  "累垮": "lèi,kuǎ",
  "累垮了": "lèi,kuǎ,le",
  "累堆": "lèi,duī",
  "累夜": "lèi,yè",
  "累子": "lèi,zǐ",
  "累官": "lèi,guān",
  "累害": "lèi,hài",
  "累封": "lèi,fēng",
  "累屋": "lèi,wū",
  "累屋重架": "lěi,wū,chóng,jià",
  "累岁": "lěi,suì",
  "累帝": "lèi,dì",
  "累席": "lèi,xí",
  "累年": "lěi,nián",
  "累建奇功": "lěi,jiàn,qí,gōng",
  "累形": "lěi,xíng",
  "累德": "lèi,dé",
  "累心": "lèi,xīn",
  "累息": "lèi,xī",
  "累成狗": "lèi,chéng,gǒu",
  "累手": "lèi,shǒu",
  "累掯": "lèi,kèn",
  "累教不改": "lěi,jiào,bù,gǎi",
  "累日": "lěi,rì",
  "累旬": "lèi,xún",
  "累时": "lěi,shí",
  "累月": "lěi,yuè",
  "累月经年": "lěi,yuè,jīng,nián",
  "累朝": "lèi,cháo",
  "累棊": "lèi,qí",
  "累次": "lěi,cì",
  "累欷": "lèi,xī",
  "累死累活": "lèi,sǐ,lèi,huó",
  "累气": "lèi,qì",
  "累活": "lèi,huó",
  "累活儿": "lèi,huó,er",
  "累洽": "lěi,qià",
  "累烦": "lèi,fán",
  "累然": "lèi,rán",
  "累爵": "lèi,jué",
  "累牍": "lěi,dú",
  "累牍连篇": "lěi,dú,lián,piān",
  "累牛": "lèi,niú",
  "累犯": "lěi,fàn",
  "累瓦结绳": "lěi,wǎ,jié,shéng",
  "累盛": "lèi,shèng",
  "累着": "lèi,zhe",
  "累碁": "lèi,qí",
  "累祖": "lèi,zǔ",
  "累离": "lèi,lí",
  "累积": "lěi,jī",
  "累积剂量": "lěi,jī,jì,liàng",
  "累积地": "lěi,jī,de",
  "累稔": "lèi,rěn",
  "累累": "lěi,lěi",
  "累累作案": "lěi,lěi,zuò,àn",
  "累累失误": "lěi,lěi,shī,wù",
  "累累如珠": "lěi,lěi,rú,zhū",
  "累累若若": "lěi,lěi,ruò,ruò",
  "累絷": "lèi,zhí",
  "累缀": "lèi,zhuì",
  "累罚": "lěi,fá",
  "累胝": "lèi,zhī",
  "累苏积块": "lěi,sū,jī,kuài",
  "累苏积磈": "lèi,sū,jī,wěi",
  "累茧": "lèi,jiǎn",
  "累茵": "lèi,yīn",
  "累见不鲜": "lěi,jiàn,bù,xiǎn",
  "累觉不爱": "lèi,jué,bù,ài",
  "累计": "lěi,jì",
  "累译": "lèi,yì",
  "累赘地": "léi,zhuì,de",
  "累足": "lěi,zú",
  "累足成步": "lěi,zú,chéng,bù",
  "累趴": "lèi,pā",
  "累趼": "lèi,jiǎn",
  "累路": "lèi,lù",
  "累身": "lèi,shēn",
  "累载": "lèi,zǎi",
  "累辈": "lèi,bèi",
  "累进": "lěi,jìn",
  "累进税": "lèi,jìn,shuì",
  "累迭": "lèi,dié",
  "累迹": "lěi,jì",
  "累重": "lèi,zhòng",
  "累黍": "lěi,shǔ",
  "𬘝戾": "tiǎn,lì",
  "𫄟𦈡": "shī,xū",
  "𮉤数": "guà,shù",
  "𮉤累": "guà,lèi",
  "絙人": "gēng,rén",
  "絙桥": "gēng,qiáo",
  "絙级": "gēng,jí",
  "絜令": "jié,lìng",
  "絜己": "jié,jǐ",
  "絜廉": "jié,lián",
  "絜情": "jié,qíng",
  "絜操": "jié,cāo",
  "絜斋": "jié,zhāi",
  "絜楹": "jié,yíng",
  "絜清": "jié,qīng",
  "絜白": "jié,bái",
  "絜皋": "jié,gāo",
  "絜矢": "jié,shǐ",
  "絜知": "jié,zhī",
  "絜粢": "jié,zī",
  "絜臯": "jié,gāo",
  "絜行": "jié,xíng",
  "絜诚": "jié,chéng",
  "絜身": "jié,shēn",
  "絜钩": "jié,gōu",
  "絜静": "jié,jìng",
  "絜驾": "jié,jià",
  "絜鲜": "jié,xiān",
  "絜齐": "jié,qí",
  "𰬔扒": "bīng,bā",
  "𰬔扒吊拷": "bīng,bā,diào,kǎo",
  "𰬔把": "bīng,bǎ",
  "𰬔纮": "bīng,hóng",
  "𬘡缊": "yīn,yūn",
  "絮叨": "xù,dáo",
  "絮叨叨": "xù,dáo,dao",
  "絮絮": "xù,xu",
  "絮絮答答": "xù,xù,dā,dā",
  "𫄨葛": "chī,gě",
  "𰬜钺": "wèn,yuè",
  "𬘭𫄥": "chēn,lí",
  "綮窾": "qǐ,kuǎn",
  "綮肯": "qǐ,kěn",
  "綮要": "qǐ,yào",
  "𰬡猎": "qiè,liè",
  "绿叶成阴": "lù,yè,chéng,yīn",
  "绿女红男": "lù,nǚ,hóng,nán",
  "绿帽子": "lǜ,mào,zi",
  "绿惨红愁": "lù,cǎn,hóng,chóu",
  "绿惨红销": "lù,cǎn,hóng,xiāo",
  "绿拗儿": "lǜ,niù,ér",
  "绿暗红稀": "lù,àn,hóng,xī",
  "绿朝云": "lǜ,zhāo,yún",
  "绿林": "lù,lín",
  "绿林大盗": "lù,lín,dà,dào",
  "绿林好汉": "lù,lín,hǎo,hàn",
  "绿林山": "lù,lín,shān",
  "绿林强盗": "lù,lín,qiáng,dào",
  "绿林豪士": "lù,lín,háo,shì",
  "绿林豪客": "lù,lín,háo,kè",
  "绿林豪杰": "lù,lín,háo,jié",
  "绿水青山": "lù,shuǐ,qīng,shān",
  "绿澄澄": "lǜ,deng,deng",
  "绿竹": "lù,zhú",
  "绿翘": "lǜ,qiào",
  "绿肥红瘦": "lù,féi,hóng,shòu",
  "绿莎": "lǜ,shā",
  "绿营": "lù,yíng",
  "绿豆皮儿": "lǜ,dòu,pí,er",
  "绿酒红灯": "lù,jiǔ,hóng,dēng",
  "绿鬓朱颜": "lù,bìn,zhū,yán",
  "绿鬓红颜": "lù,bìn,hóng,yán",
  "𫟆复": "zhòng,fù",
  "𫟆𰷠": "zhòng,yí",
  "𦈕此": "tóu,cǐ",
  "𦈉𰬜": "yùn,wèn",
  "𰬲冠": "quàn,guān",
  "𰬲缘": "quàn,yuán",
  "繁兴": "fán,xīng",
  "繁冠": "pán,guān",
  "繁华旺地": "fán,huá,wàng,de",
  "繁台": "pó,tái",
  "繁奓": "fán,zhà",
  "繁峙": "fán,shì",
  "繁峙县": "fán,shì,xiàn",
  "繁数": "fán,shù",
  "繁累": "fán,lèi",
  "繁缨": "pán,yīng",
  "繁𰮇": "fán,wǔ",
  "繁荣兴旺": "fán,róng,xīng,wàng",
  "繁露": "fán,lù",
  "繁驵": "pó,zǎng",
  "繇辞": "zhòu,cí",
  "𰬻井": "yù,jǐng",
  "𦈡券": "xū,quàn",
  "𦈡绁": "xū,xiè",
  "纂着": "zuǎn,zhe",
  "𬘧缞": "qí,shuāi",
  "纔兹": "shān,zī",
  "纔则": "shān,zé",
  "纔刚": "shān,gāng",
  "纔可": "shān,kě",
  "纔属": "shān,shǔ",
  "纔待": "shān,dài",
  "纔恰": "shān,qià",
  "纔方": "shān,fāng",
  "纔此": "shān,cǐ",
  "纔然": "shān,rán",
  "𬙋冠": "rǎng,guān",
  "纠折": "jiū,shé",
  "纠禁": "jiū,jìn",
  "纠纷地": "jiū,fēn,de",
  "纠结地": "jiū,jié,de",
  "纠缠地": "jiū,chán,de",
  "纠缪": "jiū,miù",
  "纡折": "yū,shé",
  "红不棱登": "hóng,bù,lēng,dēng",
  "红刀子": "hóng,dāo,zi",
  "红刀子出来": "hóng,dāo,zi,chū,lái",
  "红剥银": "hóng,bāo,yín",
  "红外线导引飞弹": "hóng,wài,xiàn,dǎo,yǐn,fēi,dàn",
  "红头子": "hóng,tóu,zi",
  "红姑娘": "hóng,gū,niang",
  "红寡妇鸟": "hóng,guǎ,fu,niǎo",
  "红带子": "hóng,dài,zi",
  "红帽子": "hóng,mào,zi",
  "红得发紫": "hóng,de,fā,zǐ",
  "红情绿意": "hóng,qíng,lù,yì",
  "红扎": "hóng,zhā",
  "红晕": "hóng,yùn",
  "红椅子": "hóng,yǐ,zi",
  "红模子": "hóng,mú,zǐ",
  "红派司": "hóng,pā,sī",
  "红灯绿酒": "hóng,dēng,lù,jiǔ",
  "红男绿女": "hóng,nán,lù,nǚ",
  "红着脸地": "hóng,zhe,liǎn,de",
  "红箍儿": "hóng,gū,er",
  "红糁": "hóng,shēn",
  "红绿帖": "hóng,lǜ,tiē",
  "红绳系足": "hóng,shéng,jì,zú",
  "红背伯劳": "hóng,bèi,bó,láo",
  "红背红尾鸲": "hóng,bèi,hóng,wěi,qú",
  "红背蜘蛛": "hóng,bèi,zhī,zhū",
  "红胡子": "hóng,hú,zi",
  "红脖子": "hóng,bó,zi",
  "红色娘子军": "hóng,sè,niáng,zi,jūn",
  "红色炸弹": "hóng,sè,zhà,dàn",
  "红苕": "hóng,sháo",
  "红苕气": "hóng,sháo,qì",
  "红萝卜": "hóng,luó,bo",
  "红血球": "hóng,xuè,qiú",
  "红血球生成素": "hóng,xuè,qiú,shēng,chéng,sù",
  "红衣大将": "hóng,yī,dà,jiàng",
  "红衫儿": "hóng,shān,er",
  "红角儿": "hóng,jué,ér",
  "红铺": "hóng,pù",
  "红颜白发": "hóng,yán,bái,fà",
  "红颜薄命": "hóng,yán,bó,mìng",
  "纤削": "xiān,xuē",
  "纤夫": "qiàn,fū",
  "纤手": "qiàn,shǒu",
  "纤玅": "xiān,yāo",
  "纤绳": "qiàn,shéng",
  "纤缴": "xiān,zhuó",
  "纤道": "qiàn,dào",
  "纥刺星": "gē,cì,xīng",
  "纥地": "gē,dì",
  "纥干": "hé,gàn",
  "纥𫄤": "gē,da",
  "约𠡠": "yuē,lài",
  "约塔": "yāo,tǎ",
  "约数": "yuē,shù",
  "约维克": "yāo,wéi,kè",
  "级数": "jí,shù",
  "级长": "jí,zhǎng",
  "纪录影片": "jì,lù,yǐng,piān",
  "纪念地": "jì,niàn,de",
  "纪纲人论": "jì,gāng,rén,lún",
  "纪纲仆": "jì,gāng,pú",
  "纪载": "jì,zǎi",
  "纫缝": "rèn,fèng",
  "纯合子地": "chún,hé,zǐ,de",
  "纯小数": "chún,xiǎo,shù",
  "纯庬": "chún,máng",
  "纯朴": "chún,piáo",
  "纯束": "tún,shù",
  "纯正地": "chún,zhèng,de",
  "纯洁地": "chún,jié,de",
  "纯理论地": "chún,lǐ,lùn,de",
  "纯真地": "chún,zhēn,de",
  "纯种地": "chún,zhǒng,de",
  "纯粹地": "chún,cuì,de",
  "纯粹数学": "chún,cuì,shù,xué",
  "纯絜": "chún,jié",
  "纯纯地": "chún,chún,de",
  "纯血统": "chún,xuè,tǒng",
  "纰缪": "pī,miù",
  "纱似地": "shā,shì,de",
  "纱冠": "shā,guān",
  "纱橱地": "shā,chú,de",
  "纲纪仆": "gāng,jì,pú",
  "纳什": "nà,shí",
  "纳什维尔": "nà,shí,wéi,ěr",
  "纳扎尔巴耶夫": "nà,zhā,ěr,bā,yē,fū",
  "纳粹分子": "nà,cuì,fèn,zǐ",
  "纳降": "nà,xiáng",
  "纵剖面": "zòng,pōu,miàn",
  "纵向地": "zòng,xiàng,de",
  "纵容地": "zòng,róng,de",
  "纵得": "zòng,de",
  "纵情地唱": "zòng,qíng,de,chàng",
  "纵排地": "zòng,pái,de",
  "纵掠": "zòng,lüě",
  "纵舍": "zòng,shè",
  "纵适": "zòng,shì",
  "纵长地": "zòng,zhǎng,de",
  "纶巾": "guān,jīn",
  "纶巾羽扇": "guān,jīn,yǔ,shàn",
  "纷乱地": "fēn,luàn,de",
  "纷挐": "fēn,ná",
  "纷更": "fēn,gēng",
  "纷红骇绿": "fēn,hóng,hài,lù",
  "纷缊": "fēn,wēn",
  "纸冠": "zhǐ,guān",
  "纸包不住火": "zhǐ,bāo,bú,zhù,huǒ",
  "纸叶子": "zhǐ,yè,zi",
  "纸夹": "zhǐ,jiā",
  "纸扎": "zhǐ,zhā",
  "纸煤儿": "zhǐ,méi,er",
  "纸背": "zhǐ,bèi",
  "纸里包不住火": "zhǐ,lǐ,bāo,bú,zhù,huǒ",
  "纸马儿": "zhǐ,mǎ,er",
  "纸马铺": "zhǐ,mǎ,pù",
  "纹丝儿": "wén,sī,er",
  "纹缕儿": "wén,lǚ,er",
  "纹背捕蛛鸟": "wén,bèi,bǔ,zhū,niǎo",
  "纽几内亚": "niǔ,jī,nèi,yà",
  "纽子": "niǔ,zi",
  "纾难": "shū,nàn",
  "线儿": "xiàn,er",
  "线坯子": "xiàn,pī,zi",
  "线性代数": "xiàn,xìng,dài,shù",
  "线性算子": "xiàn,xìng,suàn,zi",
  "线性规划": "xiàn,xìng,guī,huà",
  "线杆": "xiàn,gǎn",
  "线络子": "xiàn,lào,zi",
  "线绨": "xiàn,tì",
  "绂𰬜": "fú,wèn",
  "练冠": "liàn,guān",
  "练裙子": "liàn,qún,zi",
  "组分": "zǔ,fèn",
  "组合数学": "zǔ,hé,shù,xué",
  "组成部分": "zǔ,chéng,bù,fèn",
  "组织上地": "zǔ,zhī,shàng,de",
  "组织得当": "zǔ,zhī,dé,dàng",
  "组织论地": "zǔ,zhī,lùn,de",
  "组长": "zǔ,zhǎng",
  "细侯": "xì,hòu",
  "细发": "xì,fà",
  "细密地": "xì,mì,de",
  "细尾獴": "xì,wěi,měng",
  "细屑子": "xì,xiè,zi",
  "细微地": "xì,wēi,de",
  "细心地": "xì,xīn,de",
  "细心地听": "xì,xīn,de,tīng",
  "细活儿": "xì,huó,er",
  "细碎地": "xì,suì,de",
  "细磨刀石": "xì,mò,dāo,shí",
  "细细地": "xì,xì,de",
  "细细地流": "xì,xì,de,liú",
  "细细地读": "xì,xì,de,dú",
  "细莎": "xì,shā",
  "细菌域": "xì,jùn,yù",
  "细菌性食物中毒": "xì,jūn,xìng,shí,wù,zhòng,dú",
  "细菌炸弹": "xì,jùn,zhà,dàn",
  "细菌界": "xì,jùn,jiè",
  "细调": "xì,diào",
  "细輭": "xì,ér",
  "细长地": "xì,cháng,de",
  "细高挑儿": "xì,gāo,tiǎo,ér",
  "终为江河": "zhōng,wéi,jiāng,hé",
  "终了": "zhōng,liǎo",
  "终日地": "zhōng,rì,de",
  "终朝": "zhōng,zhāo",
  "终身为父": "zhōng,shēn,wéi,fù",
  "终身地": "zhōng,shēn,de",
  "终身监禁": "zhōng,shēn,jiān,jìn",
  "绉折": "zhòu,shé",
  "绊儿": "bàn,er",
  "绋𰬜": "fú,wèn",
  "绍兴": "shào,xīng",
  "绍兴和议": "shào,xīng,hé,yì",
  "绍兴地区": "shào,xīng,dì,qū",
  "绍兴市": "shào,xīng,shì",
  "绍兴师爷": "shào,xīng,shī,yé",
  "绍兴戏": "shào,xīng,xì",
  "绍兴酒": "shào,xīng,jiǔ",
  "经不住": "jīng,bu,zhù",
  "经不起": "jīng,bu,qǐ",
  "经久地": "jīng,jiǔ,de",
  "经传": "jīng,zhuàn",
  "经分析地": "jīng,fēn,xī,de",
  "经分解地": "jīng,fēn,jiě,de",
  "经卷": "jīng,juàn",
  "经常地": "jīng,cháng,de",
  "经年累月": "jīng,nián,lěi,yuè",
  "经得起": "jīng,de,qǐ",
  "经承认地": "jīng,chéng,rèn,de",
  "经折": "jīng,shé",
  "经折装": "jīng,shé,zhuāng",
  "经数": "jīng,shù",
  "经济力量": "jīng,jì,lì,liang",
  "经济地": "jīng,jì,de",
  "经济增长": "jīng,jì,zēng,zhǎng",
  "经济增长率": "jīng,jì,zēng,zhǎng,lǜ",
  "经济学地": "jīng,jì,xué,de",
  "经济杠杆": "jīng,jì,gàng,gǎn",
  "经血": "jīng,xuè",
  "经衰弱地": "jīng,shuāi,ruò,de",
  "经风雨见世面": "jīng,fēng,yǔ,xiàn,shì,miàn",
  "经验主义地": "jīng,yàn,zhǔ,yì,de",
  "绑扎": "bǎng,zhā",
  "绑扎所": "bǎng,zhā,suǒ",
  "结出": "jiē,chū",
  "结发": "jié,fà",
  "结发夫妻": "jié,fà,fū,qī",
  "结合地": "jié,hé,de",
  "结实": "jiē,shí",
  "结巴": "jiē,bā",
  "结核杆菌": "jié,hé,gǎn,jūn",
  "结梁子": "jié,liáng,zi",
  "结结巴巴": "jiē,jiē,bā,bā",
  "结结巴巴地说": "jiē,jiē,bā,bā,de,shuō",
  "结结巴巴地说出": "jiē,jiē,bā,bā,de,shuō,chū",
  "结韈": "jié,wà",
  "绕圈子": "rào,quān,zi",
  "绕弯儿": "rào,wān,er",
  "绕弯子": "rào,wān,zi",
  "绕弯子儿": "rào,wān,zǐ,er",
  "绕梁": "rǎo,liáng",
  "绕梁之音": "rǎo,liáng,zhī,yīn",
  "绕脖子": "rào,bó,zi",
  "绕腾": "rào,teng",
  "绕舌地": "rào,shé,de",
  "绘划": "huì,huà",
  "绘卷": "huì,juàn",
  "绘画地": "huì,huà,de",
  "绘画般地": "huì,huà,bān,de",
  "给予": "jǐ,yǔ",
  "给事中": "jǐ,shì,zhōng",
  "给事郎": "jǐ,shì,láng",
  "给事黄门": "jǐ,shì,huáng,mén",
  "给事黄门侍郎": "jǐ,shì,huáng,mén,shì,láng",
  "给体": "jǐ,tǐ",
  "给你点颜色看看": "gěi,nǐ,diǎn,yán,sè,kàn,kan",
  "给养": "jǐ,yǎng",
  "给回": "jǐ,huí",
  "给我狠狠地打": "gěi,wǒ,hěn,hěn,de,dǎ",
  "给我狠狠地杀": "gěi,wǒ,hěn,hěn,de,shā",
  "给数": "gěi,shù",
  "给水": "jǐ,shuǐ",
  "给水器": "jǐ,shuǐ,qì",
  "给水工程": "jǐ,shuǐ,gōng,chéng",
  "给水站": "jǐ,shuǐ,zhàn",
  "给水管": "jǐ,shuǐ,guǎn",
  "给水箱": "jǐ,shuǐ,xiāng",
  "给皂器": "jǐ,zào,qì",
  "给脸不要脸": "gěi,liǎn,bú,yào,liǎn",
  "给舍": "gěi,shè",
  "给视": "jǐ,shì",
  "给面子": "gěi,miàn,zi",
  "绛侯": "jiàng,hòu",
  "绛衣大冠": "jiàng,yī,dà,guān",
  "络子": "lào,zi",
  "络𫄲": "luò,mò",
  "绝人事": "jue,ren,shi",
  "绝吭": "jué,kēng",
  "绝大多数": "jué,dà,duō,shù",
  "绝大部分": "jué,dà,bù,fen",
  "绝妙地": "jué,miào,de",
  "绝对地": "jué,duì,de",
  "绝对地说": "jué,duì,de,shuō",
  "绝对地高": "jué,duì,de,gāo",
  "绝对大多数": "jué,duì,dà,duō,shù",
  "绝对数字": "jué,duì,shù,zì",
  "绝望地": "jué,wàng,de",
  "绝望地发现": "jué,wàng,de,fā,xiàn",
  "绝着": "jué,zhāo",
  "绝裙而去": "jué,jū,ér,qù",
  "绝调": "jué,diào",
  "绝门儿": "jué,mén,er",
  "绝顶聪明": "jué,dǐng,cōng,ming",
  "统一规划": "tǒng,yī,guī,huà",
  "统率": "tǒng,shuài",
  "统称为": "tǒng,chēng,wéi",
  "统统地": "tǒng,tǒng,de",
  "统统地杀光": "tǒng,tǒng,de,shā,guāng",
  "统计上地": "tǒng,jì,shàng,de",
  "统计地": "tǒng,jì,de",
  "统计数据": "tǒng,jì,shù,jù",
  "统铺": "tǒng,pù",
  "绢帖": "juàn,tiē",
  "绣镼": "xiù,jué",
  "绦子": "tāo,zi",
  "绦纶": "dí,lún",
  "继兴": "jì,xīng",
  "继继绳绳": "jì,jì,mǐn,mǐn",
  "继续地": "jì,xù,de",
  "绨袍之义": "tì,páo,zhī,yì",
  "续假": "xù,jià",
  "续跌": "xù,diē",
  "续随子": "xù,suí,zi",
  "绮靡": "qǐ,mǐ",
  "绰削": "chuò,xuē",
  "绰有余暇": "chuō,yǒu,yú,xiá",
  "绰然有余": "chuō,rán,yǒu,yú",
  "绰经": "chāo,jīng",
  "绰起": "chāo,qǐ",
  "绲殽": "gǔn,yáo",
  "绳削": "shéng,xuē",
  "绳子": "shéng,zi",
  "绳弹": "shéng,dàn",
  "绳愆纠缪": "shéng,qiān,jiū,miù",
  "绳绳": "mǐn,mǐn",
  "维基数据": "wéi,jī,shù,jù",
  "维妙维肖": "wéi,miào,wéi,xiào",
  "维数": "wéi,shù",
  "维斗": "wéi,dǒu",
  "绵力薄材": "mián,lì,bó,cái",
  "绵子": "mián,zi",
  "绵绵地": "mián,mián,de",
  "绵薄": "mián,bó",
  "绵里薄材": "mián,lǐ,bó,cái",
  "绷不住": "bēng,bu,zhù",
  "绷劲": "běng,jìn",
  "绷弓子": "bēng,gōng,zi",
  "绷瓷": "bèng,cí",
  "绷着脸": "běng,zhe,liǎn",
  "绷脸": "běng,liǎn",
  "绸子": "chóu,zi",
  "绸缪帐扆": "chóu,miù,zhàng,yǐ",
  "绸缪帷帐": "chóu,miù,wéi,zhàng",
  "绸缪未雨": "chóu,miù,wèi,yǔ",
  "绸缪桑土": "chóu,miù,sāng,tǔ",
  "绸缪牖户": "chóu,miù,yǒu,hù",
  "绻毛地": "quǎn,máo,de",
  "综亮": "zèng,liàng",
  "综光瓦亮": "zèng,guāng,wǎ,liàng",
  "综合业务数字网": "zōng,hé,yè,wù,shù,zì,wǎng",
  "综合地": "zōng,hé,de",
  "综合服务数位网络": "zōng,hé,fú,wù,shù,wèi,wǎng,luò",
  "绽口儿": "zhàn,kǒu,er",
  "绽露": "zhàn,lù",
  "绾毂": "wǎn,gū",
  "绾角儿": "wǎn,jué,ér",
  "绿林起义": "lù,lín,qǐ,yì",
  "绿树成荫": "lǜ,shù,chéng,yìn",
  "绿背姬鹟": "lǜ,bèi,jī,wēng",
  "绿背山雀": "lǜ,bèi,shān,què",
  "绿背林鹟": "lǜ,bèi,lín,wēng",
  "绿荫": "lǜ,yìn",
  "绿莹莹": "lǜ,yīng,yīng",
  "缀斿": "zhuì,yóu",
  "缀翼地": "zhuì,yì,de",
  "缀跲": "zhuì,jiá",
  "缁布冠": "zī,bù,guān",
  "缃帖": "xiāng,tiē",
  "缃舃": "xiāng,tuō",
  "缄帖": "jiān,tiē",
  "缇幢": "tí,zhuàng",
  "缊丽": "wēn,lì",
  "缊奥": "wēn,ào",
  "缊巡": "wēn,xún",
  "缊枲": "wēn,xǐ",
  "缊畜": "wēn,chù",
  "缊着": "wēn,zhe",
  "缊絮": "wēn,xù",
  "缊绪": "wēn,xù",
  "缊缕": "wēn,lǚ",
  "缊藉": "wēn,jiè",
  "缊袯": "wēn,bó",
  "缊褐": "wēn,hè",
  "缊褚": "wēn,chǔ",
  "缊豫": "wēn,yù",
  "缊𫖒": "wēn,bì",
  "缊韨": "wēn,fú",
  "缊𱋱": "wēn,fén",
  "缌缞": "sī,shuāi",
  "缎子": "duàn,zi",
  "缓慢地": "huǎn,màn,de",
  "缓慢地流": "huǎn,màn,de,liú",
  "缓慢地行进": "huǎn,màn,de,xíng,jìn",
  "缓慢地说": "huǎn,màn,de,shuō",
  "缓慢地走": "huǎn,màn,de,zǒu",
  "缓慢而费力地前": "huǎn,màn,ér,fèi,lì,de,qián",
  "缓慢而费力地前进": "huǎn,màn,ér,fèi,lì,de,qián,jìn",
  "缓缓地": "huǎn,huǎn,de",
  "缓缓地摇头": "huǎn,huǎn,de,yáo,tóu",
  "缓缓地走上": "huǎn,huǎn,de,zǒu,shàng",
  "缕堤": "lǚ,dī",
  "缕数": "lǚ,shù",
  "编制上地": "biān,zhì,shàng,de",
  "编削": "biān,xuē",
  "编掜": "biān,niè",
  "编数": "biān,shù",
  "编町": "biān,tīng",
  "编造地": "biān,zào,de",
  "缗蛮": "mián,mán",
  "缘分": "yuán,fèn",
  "缘累": "yuán,lèi",
  "缚扎": "fù,zhā",
  "缝人": "fèng,rén",
  "缝儿": "fèng,er",
  "缝刺": "fèng,cì",
  "缝合带": "fèng,hé,dài",
  "缝子": "fèng,zi",
  "缝工": "fèng,gōng",
  "缝开": "fèng,kāi",
  "缝扣子": "féng,kòu,zi",
  "缝掖": "fèng,yè",
  "缝破补绽": "fèng,pò,bǔ,zhàn",
  "缝穷": "fèng,qióng",
  "缝𮉢": "fèng,zhì",
  "缝纴": "fèng,rèn",
  "缝线": "fèng,xiàn",
  "缝织": "fèng,zhī",
  "缝绽": "fèng,zhàn",
  "缝缉": "fèng,jī",
  "缝缝连连": "fèng,fèng,lián,lián",
  "缝罅": "fèng,xià",
  "缝联": "fèng,lián",
  "缝联补绽": "fèng,lián,bǔ,zhàn",
  "缝腋": "fèng,yè",
  "缝衽": "fèng,rèn",
  "缝被子": "féng,bèi,zi",
  "缝际": "fèng,jì",
  "缝隙": "fèng,xì",
  "缞帻": "shuāi,zé",
  "缞服": "shuāi,fú",
  "缞粗": "shuāi,cū",
  "缞麤": "shuāi,cū",
  "缞麻": "shuāi,má",
  "缟冠": "gǎo,guān",
  "缟纻之交": "gāo,zhù,zhī,jiāo",
  "缟衣白冠": "gǎo,yī,bái,guān",
  "缠夹": "chán,jiā",
  "缠夹不清": "chán,jiā,bù,qīng",
  "缠夹二先生": "chán,jiā,èr,xiān,sheng",
  "缠累": "chán,lèi",
  "缥缈": "piāo,miǎo",
  "缥缥": "piāo,piāo",
  "缨冠": "yīng,guān",
  "缨子": "yīng,zi",
  "缨𬙋": "yīng,rǎng",
  "缩地成寸": "suō,de,chéng,cùn",
  "缩砂": "sù,shā",
  "缩砂密": "sù,shā,mì",
  "缩砂蔤": "sù,shā,mì",
  "缩脖子": "suō,bó,zi",
  "缩踡": "suō,juǎn",
  "缪丑": "miù,chǒu",
  "缪书": "miù,shū",
  "缪乱": "miù,luàn",
  "缪传": "miù,chuán",
  "缪公": "mù,gōng",
  "缪力同心": "miù,lì,tóng,xīn",
  "缪卜": "miù,bǔ",
  "缪妄": "miù,wàng",
  "缪巧": "miù,qiǎo",
  "缪思": "miù,sī",
  "缪恩": "miù,ēn",
  "缪悠": "miù,yōu",
  "缪惑": "miù,huò",
  "缪戾": "miù,lì",
  "缪政": "miù,zhèng",
  "缪数": "miù,shù",
  "缪斯": "miù,sī",
  "缪盭": "lù,lì",
  "缪种流传": "miù,zhǒng,liú,chuán",
  "缪篆": "miù,zhuàn",
  "缪紊": "miù,wěn",
  "缪𬘝": "miù,tiǎn",
  "缪结": "miù,jié",
  "缪绕": "miù,rào",
  "缪缪": "miù,miù",
  "缪缺": "miù,quē",
  "缪节": "miù,jié",
  "缪荃孙": "miù,quán,sūn",
  "缪葛": "miù,gě",
  "缪误": "miù,wù",
  "缪说": "miù,shuō",
  "缪错": "miù,cuò",
  "缪陋": "miù,lòu",
  "缪龙": "miù,lóng",
  "缭边儿": "liáo,biān,er",
  "缮校": "shàn,jiào",
  "缴卷": "jiǎo,juàn",
  "缺乏地": "quē,fá,de",
  "缺口镊子": "quē,kǒu,niè,zi",
  "缺心眼儿": "quē,xīn,yǎn,er",
  "缺折": "quē,shé",
  "缺血": "quē,xuè",
  "缾沈簪折": "píng,shěn,zān,shé",
  "缿筩": "xiàng,yǒng",
  "罂粟种子": "yīng,sù,zhǒng,zi",
  "罄卷": "qìng,juàn",
  "罄折": "qìng,shé",
  "罄身儿": "qìng,shēn,er",
  "罄露": "qìng,lù",
  "罅缝": "xià,fèng",
  "罐头": "guàn,tou",
  "罐头盒": "guàn,tou,hé",
  "罐头起子": "guàn,tou,qǐ,zi",
  "罐子": "guàn,zi",
  "罐子玉": "guàn,zi,yù",
  "网子": "wǎng,zi",
  "网禁": "wǎng,jìn",
  "网络应用": "wǎng,luò,yìng,yòng",
  "网络规划人员": "wǎng,luò,guī,huà,rén,yuán",
  "网路应用": "wǎng,lù,yìng,yòng",
  "网路特务": "wǎng,lù,tè,wu",
  "罔阆": "wǎng,láng",
  "罕有地": "hǎn,yǒu,de",
  "罕𬙝": "hǎn,bì",
  "罕见地": "hǎn,jiàn,de",
  "罕达犴": "hǎn,dá,àn",
  "罗唆": "luō,suō",
  "罗嗦": "luō,suo",
  "罗嗦地": "luó,suo,de",
  "罗圈儿": "luó,quān,er",
  "罗圈儿腿": "luó,quān,er,tuǐ",
  "罗夫诺": "luō,fū,nuò",
  "罗巴切夫斯基": "luó,bā,qiè,fū,sī,jī",
  "罗布泊": "luó,bù,pō",
  "罗曼带克": "luō,màn,dài,kè",
  "罗汉椅子": "luó,hàn,yǐ,zi",
  "罗盘地": "luó,pán,de",
  "罗盛教": "luó,chéng,jiào",
  "罗禁": "luó,jìn",
  "罗罗": "luō,luō",
  "罗莎": "luó,shā",
  "罗锅儿": "luó,guō,er",
  "罗韈": "luó,wà",
  "罗马数字": "luó,mǎ,shù,zì",
  "罙入": "mí,rù",
  "罚没": "fá,mò",
  "罚没款": "fá,mò,kuǎn",
  "罢咧": "bà,liě",
  "罢士": "ba,shì",
  "罢民": "ba,mín",
  "罢软": "pí,ruǎn",
  "罢露": "bà,lù",
  "罢马": "pí,mǎ",
  "罩子": "zhào,zi",
  "罪人不帑": "zuì,rén,bù,tǎng",
  "罪恶地": "zuì,è,de",
  "罪恶昭着": "zuì,è,zhāo,zhe",
  "罪累": "zuì,lèi",
  "罪行累累": "zuì,xíng,lěi,lèi",
  "置信地": "zhì,xìn,de",
  "置信系数": "zhì,xìn,xì,shù",
  "置地筑屋": "zhì,de,zhù,wū",
  "置堇": "zhì,jǐn",
  "置楬": "zhì,jié",
  "罹难": "lí,nàn",
  "𬙝圭": "bì,guī",
  "𬙝弋": "bì,yì",
  "𬙝罕": "bì,hǎn",
  "羁仆": "jī,pú",
  "羁累": "jī,lèi",
  "羊圈": "yáng,juàn",
  "羊肚": "yáng,dǔ",
  "羊肚子手巾": "yáng,dù,zi,shǒu,jīn",
  "羊肚子毛巾": "yáng,dù,zi,máo,jīn",
  "羌帖": "qiāng,tiē",
  "美丽地": "měi,lì,de",
  "美人坯子": "měi,rén,pī,zi",
  "美体小铺": "měi,tǐ,xiǎo,pù",
  "美劲儿": "měi,jìn,er",
  "美发": "měi,fà",
  "美发师": "měi,fà,shī",
  "美味地": "měi,wèi,de",
  "美味牛肝菌": "měi,wèi,niú,gān,jùn",
  "美国地质调查局": "měi,guó,dì,zhì,diào,chá,jú",
  "美好地": "měi,hǎo,de",
  "美如冠玉": "měi,rú,guān,yù",
  "美妙地": "měi,miào,de",
  "美容觉": "měi,róng,jiào",
  "美差": "měi,chāi",
  "美差事": "měi,chāi,shì",
  "美术地": "měi,shù,de",
  "美杜莎": "měi,dù,shā",
  "美滋滋地": "měi,zī,zī,de",
  "美满地": "měi,mǎn,de",
  "美猴儿王": "měi,hóu,er,wáng",
  "美男子": "měi,nán,zi",
  "美的": "měi,dí",
  "美耐皿": "mǎi,nài,mǐn",
  "美颜相机": "měi,yán,xiàng,jī",
  "羞与为伍": "xiū,yǔ,wéi,wǔ",
  "羞人答答": "xiū,rén,dā,dā",
  "羞地": "xiū,de",
  "羞怯地": "xiū,qiè,de",
  "羞恶": "xiū,wù",
  "羞愧地": "xiū,kuì,de",
  "羞涩地看": "xiū,sè,de,kàn",
  "羞涩地问道": "xiū,sè,de,wèn,dào",
  "羞答答": "xiū,dā,dā",
  "羞羞答答": "xiū,xiū,dā,dā",
  "羞臊": "xiū,sào",
  "羡慕地": "xiàn,mù,de",
  "群仆": "qún,pú",
  "群口相声": "qún,kǒu,xiàng,shēng",
  "群处": "qún,chǔ",
  "群居地": "qún,jū,de",
  "群居穴处": "qún,jū,xué,chǔ",
  "群干": "qún,gàn",
  "群虱处裈中": "qún,shī,chǔ,kūn,zhōng",
  "群蚁溃堤": "qún,yǐ,kuì,dī",
  "群辟": "qún,bì",
  "群雌粥粥": "qún,cí,yù,yù",
  "羸臒": "léi,qú",
  "羸𦬼": "léi,ěr",
  "羸露": "léi,lù",
  "羸骀": "léi,dài",
  "羽冠": "yǔ,guān",
  "羽幢": "yǔ,zhuàng",
  "羽扇纶巾": "yǔ,shàn,guān,jīn",
  "羽林子": "yǔ,lín,zi",
  "羽翟": "yǔ,zhái",
  "羽葆幢": "yǔ,bǎo,zhuàng",
  "羽钻": "yǔ,zuàn",
  "翁翁地": "wēng,wēng,de",
  "翅子": "chì,zi",
  "翅楞楞": "chì,lèng,lèng",
  "翎子": "líng,zi",
  "翏翏": "lù,lù",
  "翔庳": "xiáng,bì",
  "翔折": "xiáng,shé",
  "翕侯": "xī,hòu",
  "翕应": "xī,yìng",
  "翕訿": "xī,zī",
  "翖侯": "xī,hòu",
  "翘举": "qiào,jǔ",
  "翘二郎腿": "qiào,èr,láng,tuǐ",
  "翘伫": "qiào,zhù",
  "翘俊": "qiào,jùn",
  "翘关": "qiào,guān",
  "翘切": "qiào,qiē",
  "翘勤": "qiào,qín",
  "翘尾巴": "qiào,wěi,bā",
  "翘异": "qiào,yì",
  "翘弓": "qiào,gōng",
  "翘彦": "qiào,yàn",
  "翘待": "qiào,dài",
  "翘心": "qiào,xīn",
  "翘思": "qiào,sī",
  "翘悚": "qiào,sǒng",
  "翘想": "qiào,xiǎng",
  "翘惶": "qiào,huáng",
  "翘慕": "qiào,mù",
  "翘懃": "qiào,qín",
  "翘拇指": "qiào,mǔ,zhǐ",
  "翘拔": "qiào,bá",
  "翘捷": "qiào,jié",
  "翘揭": "qiào,jiē",
  "翘敏": "qiào,mǐn",
  "翘敬": "qiào,jìng",
  "翘明": "qiào,míng",
  "翘曲": "qiáo,qū",
  "翘板": "qiào,bǎn",
  "翘棱": "qiáo,lēng",
  "翘注": "qiào,zhù",
  "翘滋": "qiào,zī",
  "翘然": "qiào,rán",
  "翘特": "qiào,tè",
  "翘班": "qiào,bān",
  "翘瞻": "qiào,zhān",
  "翘硬": "qiào,yìng",
  "翘秀": "qiào,xiù",
  "翘竚": "qiào,zhù",
  "翘竦": "qiào,sǒng",
  "翘𥮾": "qiào,zān",
  "翘结": "qiào,jié",
  "翘翘": "qiào,qiào",
  "翘翘板": "qiào,qiào,bǎn",
  "翘肖": "qiào,xiāo",
  "翘腾": "qiào,téng",
  "翘舌音": "qiào,shé,yīn",
  "翘舞": "qiào,wǔ",
  "翘英": "qiào,yīng",
  "翘萧": "qiào,xiāo",
  "翘袖": "qiào,xiù",
  "翘诚": "qiào,chéng",
  "翘课": "qiào,kè",
  "翘起": "qiào,qǐ",
  "翘足可待": "qiào,zú,kě,dài",
  "翘跂": "qiào,qí",
  "翘踛": "qiào,lù",
  "翘蹄捻脚": "qiào,tí,niē,jiǎo",
  "翘车": "qiào,chē",
  "翘辫子": "qiào,biàn,zi",
  "翘过": "qiào,guò",
  "翘遥": "qiào,yáo",
  "翘陆": "qiào,lù",
  "翘隽": "qiào,jùn",
  "翘颙": "qiào,yóng",
  "翘馆": "qiào,guǎn",
  "翘首跂踵": "qiáo,shǒu,qǐ,zhǒng",
  "翘驻": "qiào,zhù",
  "翘鼻麻鸭": "qiào,bí,má,yā",
  "翟公之门": "zhái,gōng,zhī,mén",
  "翟公客": "zhái,gōng,kè",
  "翟志刚": "zhái,zhì,gāng",
  "翟文": "zhái,wén",
  "翟理斯": "zhái,lǐ,sī",
  "翟茀": "zhái,bó",
  "翟蔽": "zhái,bì",
  "翟衣": "zhái,yī",
  "翟袆": "zhái,huī",
  "翟辂": "zhái,lù",
  "翟门": "zhái,mén",
  "翟雉": "zhái,zhì",
  "翠云翘": "cuì,yún,qiào",
  "翠冠": "cuì,guān",
  "翠冠玉": "cuì,guān,yù",
  "翠翘": "cuì,qiào",
  "翠𫐌": "cuì,pēng",
  "翣血": "shà,xuè",
  "翦削": "jiǎn,xuē",
  "翦截铺": "jiǎn,jié,pù",
  "翩翩少年": "piān,piān,shào,nián",
  "翫世": "wàn,shì",
  "翫习": "wàn,xí",
  "翫兵": "wàn,bīng",
  "翫华": "wàn,huá",
  "翫味": "wàn,wèi",
  "翫境": "wàn,jìng",
  "翫好": "wàn,hǎo",
  "翫守": "wàn,shǒu",
  "翫寇": "wàn,kòu",
  "翫岁愒月": "wàn,suì,kài,yuè",
  "翫弄": "wàn,nòng",
  "翫悦": "wàn,yuè",
  "翫愒": "wàn,kài",
  "翫日愒月": "wàn,rì,kài,yuè",
  "翫月": "wàn,yuè",
  "翫服": "wàn,fú",
  "翫烖": "wàn,zāi",
  "翫物": "wàn,wù",
  "翫索": "wàn,suǒ",
  "翫翫": "wàn,wàn",
  "翫谑": "wàn,xuè",
  "翫赏": "wàn,shǎng",
  "翫轻": "wàn,qīng",
  "翫闻": "wàn,wén",
  "翫阅": "wàn,yuè",
  "翫鲍": "wàn,bào",
  "翰蕃": "hàn,fān",
  "翻囤": "fān,dùn",
  "翻子拳": "fān,zi,quán",
  "翻手为云": "fān,shǒu,wéi,yún",
  "翻手为云覆手变雨": "fān,shǒu,wéi,yún,fù,shǒu,biàn,yǔ",
  "翻斗": "fān,dǒu",
  "翻斗卡车": "fān,dǒu,kǎ,chē",
  "翻斗车": "fān,dǒu,chē",
  "翻斤斗": "fān,jīn,dǒu",
  "翻更": "fān,gēng",
  "翻本儿": "fān,běn,er",
  "翻枱": "fān,tái",
  "翻着袜": "fān,zhe,wà",
  "翻筋斗": "fān,jīn,dǒu",
  "翻篇儿": "fān,piān,er",
  "翻肠倒肚": "fān,cháng,dǎo,dǔ",
  "翻背": "fān,bèi",
  "翻褂子": "fān,guà,zi",
  "翻调": "fān,diào",
  "翻贺为吊": "fān,hè,wéi,diào",
  "翻跟头": "fān,gēn,tou",
  "翻跟斗": "fān,gēn,dǒu",
  "翼善冠": "yì,shàn,guān",
  "翼夹": "yì,jiā",
  "翼子板": "yì,zi,bǎn",
  "耀目地": "yào,mù,de",
  "耀眼地": "yào,yǎn,de",
  "老丈人": "lǎo,zhàng,ren",
  "老不着": "lǎo,bù,zháo",
  "老东西": "lǎo,dōng,xi",
  "老两口儿": "lǎo,liǎng,kǒu,er",
  "老丫头": "lǎo,yā,tou",
  "老仆": "lǎo,pú",
  "老伧": "lǎo,chen",
  "老伴儿": "lǎo,bàn,er",
  "老儿子": "lǎo,ér,zi",
  "老八辈子": "lǎo,bā,bèi,zi",
  "老公公": "lǎo,gōng,gong",
  "老到": "lǎo,dao",
  "老区": "lǎo,ōu",
  "老医少卜": "lǎo,yī,shǎo,bo",
  "老口儿": "lǎo,kǒu,er",
  "老哥儿们": "lǎo,gē,ér,men",
  "老哥哥": "lǎo,gē,ge",
  "老在行": "lǎo,zài,háng",
  "老地方等": "lǎo,de,fāng,děng",
  "老处女": "lǎo,chǔ,nǚ",
  "老大难": "lǎo,dà,nàn",
  "老天隔不了一层纸": "lǎo,tiān,gé,bù,liǎo,yī,céng,zhǐ",
  "老太太": "lǎo,tài,tai",
  "老头儿": "lǎo,tou,er",
  "老头儿乐": "lǎo,tou,er,lè",
  "老头子": "lǎo,tóu,zi",
  "老套子": "lǎo,tào,zi",
  "老奶奶": "lǎo,nǎi,nai",
  "老妈妈论儿": "lǎo,mā,ma,lùn,ér",
  "老妈子": "lǎo,mā,zi",
  "老姥": "lǎo,mǔ",
  "老娘们": "lǎo,niáng,men",
  "老婆孩子热炕头": "lǎo,pó,hái,zi,rè,kàng,tou",
  "老婆舌头": "lǎo,pó,shé,tou",
  "老子": "lǎo,zi",
  "老子天下第一": "lǎo,zi,tiān,xià,dì,yī",
  "老子娘": "lǎo,zi,niáng",
  "老子长孙": "lǎo,zi,zhǎng,sūn",
  "老实": "lǎo,shi",
  "老实巴交": "lǎo,shi,bā,jiāo",
  "老实疙瘩": "lǎo,shí,gē,dā",
  "老客儿": "lǎo,kè,er",
  "老家伙": "lǎo,jiā,huo",
  "老将": "lǎo,jiàng",
  "老少": "lǎo,shào",
  "老少咸宜": "lǎo,shào,xián,yí",
  "老少无欺": "lǎo,shào,wú,qī",
  "老少皆宜": "lǎo,shào,jiē,yí",
  "老少边穷": "lǎo,shào,biān,qióng",
  "老师傅": "lǎo,shī,fū",
  "老师宿儒": "lǎo,shī,xiǔ,rú",
  "老师父": "lǎo,shī,fu",
  "老帽儿": "lǎo,mào,er",
  "老干部": "lǎo,gàn,bù",
  "老底子": "lǎo,dǐ,zi",
  "老式地": "lǎo,shì,de",
  "老扎": "lǎo,zhā",
  "老是": "lǎo,shi",
  "老更": "lǎo,gēng",
  "老朋友": "lǎo,péng,you",
  "老本儿": "lǎo,běn,er",
  "老本行": "lǎo,běn,háng",
  "老来少": "lǎo,lái,shào",
  "老板子": "lǎo,bǎn,zi",
  "老样子": "lǎo,yàng,zi",
  "老根子": "lǎo,gēn,zi",
  "老梆子": "lǎo,bāng,zi",
  "老毛子": "lǎo,máo,zi",
  "老油子": "lǎo,yóu,zi",
  "老爷": "lǎo,ye",
  "老爷们": "lǎo,yé,men",
  "老爷子": "lǎo,yé,zi",
  "老爷岭": "lǎo,ye,lǐng",
  "老爷爷": "lǎo,yé,ye",
  "老爷车": "lǎo,ye,chē",
  "老狐狸": "lǎo,hú,li",
  "老玉米": "lǎo,yù,mi",
  "老班子": "lǎo,bān,zi",
  "老疙瘩": "lǎo,gē,dā",
  "老白相": "lǎo,bái,xiàng",
  "老相公": "lǎo,xiàng,gōng",
  "老着脸": "lǎo,zhe,liǎn",
  "老着脸皮": "lǎo,zhe,liǎn,pí",
  "老老": "lǎo,lao",
  "老老少少": "lǎo,lǎo,shào,shào",
  "老而不死是为贼": "lǎo,ér,bù,sǐ,shì,wéi,zéi",
  "老背悔": "lǎo,bèi,huǐ",
  "老背晦": "lǎo,bèi,huì",
  "老臊胡": "lǎo,sào,hú",
  "老行家": "lǎo,háng,jiā",
  "老调": "lǎo,diào",
  "老调子": "lǎo,diào,zi",
  "老调重弹": "lǎo,diào,zhòng,dàn",
  "老调重谈": "lǎo,diào,chóng,tán",
  "老身长子": "lǎo,shēn,zhǎng,zǐ",
  "老马为驹": "lǎo,mǎ,wéi,jū",
  "老骨头": "lǎo,gú,tou",
  "老鼠夹": "lǎo,shǔ,jiā",
  "老鼠尾巴": "lǎo,shǔ,wěi,ba",
  "老鼻子": "lǎo,bí,zi",
  "考卷": "kǎo,juàn",
  "考掠": "kǎo,lüě",
  "考波什堡": "kǎo,bō,shí,bǎo",
  "考究地": "kǎo,jiū,de",
  "考试卷": "kǎo,shì,juàn",
  "考试卷子": "kǎo,shì,juàn,zi",
  "考量": "kǎo,liáng",
  "者么": "zhě,mǒ",
  "而相应地": "ér,xiāng,yìng,de",
  "而重复地": "ér,chóng,fù,de",
  "耍嘴皮子": "shuǎ,zuǐ,pí,zi",
  "耍坛子": "shuǎ,tán,zi",
  "耍大嗓子": "shuǎ,dà,sǎng,zi",
  "耍子": "shuǎ,zi",
  "耍小聪明": "shuǎ,xiǎo,cōng,ming",
  "耍得团团转": "shuǎ,de,tuán,tuán,zhuàn",
  "耍性子": "shuǎ,xìng,zi",
  "耍横": "shuǎ,hèng",
  "耍流氓": "shuǎ,liú,máng",
  "耍牌子": "shuǎ,pái,zi",
  "耍狮子": "shuǎ,shī,zi",
  "耍盘子": "shuǎ,pán,zi",
  "耍笔杆": "shuǎ,bǐ,gǎn",
  "耍笔杆子": "shuǎ,bǐ,gǎn,zi",
  "耍线儿": "shuǎ,xiàn,er",
  "耍舌头": "shuǎ,shé,tou",
  "耍骨头": "shuǎ,gú,tou",
  "耐久地": "nài,jiǔ,de",
  "耐人咀嚼": "nài,rén,jǔ,jué",
  "耐劳地": "nài,láo,de",
  "耐心地等待": "nài,xīn,de,děng,dài",
  "耑人": "zhuān,rén",
  "耑候": "zhuān,hòu",
  "耑函": "zhuān,hán",
  "耑勒": "zhuān,lè",
  "耑启": "zhuān,qǐ",
  "耑家": "zhuān,jiā",
  "耑意": "zhuān,yì",
  "耑此": "zhuān,cǐ",
  "耑泐": "zhuān,lè",
  "耑爱": "zhuān,ài",
  "耑管": "zhuān,guǎn",
  "耑绪": "zhuān,xù",
  "耑耑": "zhuān,zhuān",
  "耑诚": "zhuān,chéng",
  "耑门": "zhuān,mén",
  "耕牛为主遭鞭杖": "gēng,niú,wéi,zhǔ,zāo,biān,zhàng",
  "耕种": "gēng,zhòng",
  "耗子": "hào,zi",
  "耗子尾汁": "hào,zi,wěi,zhī",
  "耗子药": "hào,zi,yào",
  "耗尽地": "hào,jìn,de",
  "耗折": "hào,shé",
  "耘耙": "yún,pá",
  "耘耛": "yún,chí",
  "耙子": "pá,zǐ",
  "耙梳": "pá,shū",
  "耙耧": "pá,lóu",
  "耙耱": "pá,mò",
  "耙耳朵": "pā,ěr,duo",
  "耳刮子": "ěr,guā,zi",
  "耳剽": "ěr,piāo",
  "耳发": "ěr,fa",
  "耳听为虚": "ěr,tīng,wéi,xū",
  "耳咽管": "ěr,yān,guǎn",
  "耳坠子": "ěr,zhuì,zi",
  "耳子": "ěr,zi",
  "耳报神": "ě,bào,shén",
  "耳挖子": "ěr,wā,zi",
  "耳掴子": "ěr,guāi,zi",
  "耳朵": "ěr,duo",
  "耳朵底子": "ěr,duǒ,dǐ,zi",
  "耳朵眼儿": "ěr,duo,yǎn,er",
  "耳朵软": "ěr,duo,ruǎn",
  "耳根子": "ěr,gēn,zi",
  "耳根子软": "ěr,gēn,zi,ruǎn",
  "耳源性眩晕": "ěr,yuán,xìng,xuàn,yùn",
  "耳片": "ěr,piān",
  "耳背": "ěr,bèi",
  "耳舍": "ěr,shè",
  "耳顺之年": "ér,shùn,zhī,nián",
  "耳鼻咽喉": "ěr,bí,yān,hóu",
  "耶乐": "yē,lè",
  "耶利哥": "yē,lì,gē",
  "耶利米": "yē,lì,mǐ",
  "耶利米书": "yē,lì,mǐ,shū",
  "耶利米哀歌": "yē,lì,mǐ,āi,gē",
  "耶和华": "yē,hé,huá",
  "耶和华见证人": "yē,hé,huá,jiàn,zhèng,rén",
  "耶和瓦": "yē,hé,wǎ",
  "耶哥尼雅": "yē,gē,ní,yǎ",
  "耶𪠸": "yē,hù",
  "耶娘": "yē,niáng",
  "耶孃": "yē,ráng",
  "耶弗他": "yē,fú,tā",
  "耶律": "yē,lǜ",
  "耶律大石": "yē,lǜ,dà,shí",
  "耶律楚材": "yē,lǜ,chǔ,cái",
  "耶悉茗": "yē,xī,míng",
  "耶户": "yē,hù",
  "耶揄": "yē,yú",
  "耶教": "yē,jiào",
  "耶洗别": "yē,xǐ,bié",
  "耶溪": "yē,xī",
  "耶烈万": "yē,liè,wàn",
  "耶禺": "yē,yú",
  "耶稣": "yē,sū",
  "耶稣会": "yē,sū,huì",
  "耶稣会地": "yē,sū,huì,de",
  "耶稣会士": "yē,sū,huì,shì",
  "耶稣光": "yē,sū,guāng",
  "耶稣升天节": "yē,sū,shēng,tiān,jié",
  "耶稣受难节": "yē,sū,shòu,nàn,jié",
  "耶稣基督": "yē,sū,jī,dū",
  "耶稣基督后期圣徒教会": "yē,sū,jī,dū,hòu,qī,shèng,tú,jiào,huì",
  "耶稣基督末世圣徒教会": "yē,sū,jī,dū,mò,shì,shèng,tú,jiào,huì",
  "耶稣教": "yē,sū,jiào",
  "耶稣降临节": "yē,sū,jiàng,lín,jié",
  "耶维": "yē,wéi",
  "耶耶": "yē,yē",
  "耶耶乎": "yē,yē,hū",
  "耶西": "yē,xī",
  "耶许": "yē,xǔ",
  "耶诞节": "yē,dàn,jié",
  "耶路撒冷": "yē,lù,sā,lěng",
  "耶酥": "yē,sū",
  "耶酥会": "yē,sū,huì",
  "耶酥会士": "yē,sū,huì,shì",
  "耶鲁": "yē,lǔ",
  "耶鲁大学": "yē,lǔ,dà,xué",
  "耸干": "sǒng,gàn",
  "耸肩曲背": "sǒng,jiān,qū,bèi",
  "耸肩缩背": "sǒng,jiān,suō,bèi",
  "耻与哙伍": "chǐ,yú,kuài,wǔ",
  "耻辱地": "chǐ,rǔ,de",
  "耽翫": "dān,wàn",
  "耽误": "dān,wu",
  "耿着": "gěng,zhe",
  "耿絜": "gěng,jié",
  "耿黾": "gěng,miǎn",
  "聆翫": "líng,wàn",
  "聊以塞责": "liáo,yǐ,sè,zé",
  "聊天儿": "liáo,tiān,er",
  "聋子": "lóng,zi",
  "职业上地": "zhí,yè,shàng,de",
  "职业化地": "zhí,yè,huà,de",
  "职业地": "zhí,yè,de",
  "职业性地": "zhí,yè,xìng,de",
  "职分": "zhí,fèn",
  "职分田": "zhí,fèn,tián",
  "职权或地": "zhí,quán,huò,de",
  "联合国开发计划署": "lián,hé,guó,kāi,fā,jì,huà,shǔ",
  "联合国环境规划署": "lián,hé,guó,huán,jìng,guī,huà,shǔ",
  "联机分析处理": "lián,jī,fēn,xī,chǔ,lǐ",
  "联盟地": "lián,méng,de",
  "联篇累牍": "lián,piān,lěi,dú",
  "联累": "lián,lèi",
  "联轴器": "lián,zhòu,qì",
  "联轴节": "lián,zhòu,jié",
  "联邦调查局": "lián,bāng,diào,chá,jú",
  "聘调": "pìn,diào",
  "聚变反应": "jù,biàn,fǎn,yìng",
  "聚米为山": "jù,mǐ,wéi,shān",
  "聚米为谷": "jù,mǐ,wéi,gǔ",
  "聚集地": "jù,jí,de",
  "聪慜": "cōng,mǐn",
  "聪敏地": "cōng,mǐn,de",
  "聪明": "cōng,ming",
  "聪明伶俐": "cōng,ming,líng,lì",
  "聪明地": "cōng,míng,de",
  "聪明才智": "cōng,ming,cái,zhì",
  "聪明绝顶": "cōng,ming,jué,dǐng",
  "聪明过头": "cōng,ming,guò,tóu",
  "聱牙诘屈": "áo,yá,jí,qū",
  "聱牙诘曲": "áo,yá,jié,qū",
  "肃北蒙古族自治县": "sù,běi,měng,gǔ,zú,zì,zhì,xiàn",
  "肃静地": "sù,jìng,de",
  "肆剽": "sì,piāo",
  "肆应": "sì,yìng",
  "肆意地": "sì,yì,de",
  "肆意妄为": "sì,yì,wàng,wéi",
  "肆掠": "sì,lüě",
  "肆无忌惮地": "sì,wú,jì,dàn,de",
  "肇兴": "zhào,xīng",
  "肉体上地": "ròu,tǐ,shàng,de",
  "肉体地": "ròu,tǐ,de",
  "肉冠": "ròu,guān",
  "肉包子打狗": "ròu,bāo,zi,dǎ,gǒu",
  "肉囊囊": "ròu,nāng,nang",
  "肉夹馍": "ròu,jiā,mó",
  "肉感地": "ròu,gǎn,de",
  "肉末儿": "ròu,mò,er",
  "肉桃子": "ròu,táo,zi",
  "肉欲地": "ròu,yù,de",
  "肉毒杆菌": "ròu,dú,gǎn,jūn",
  "肉毒杆菌毒素": "ròu,dú,gǎn,jūn,dú,sù",
  "肉毒梭状芽孢杆菌": "ròu,dú,suō,zhuàng,yá,bāo,gǎn,jūn",
  "肉片儿": "ròu,piàn,er",
  "肉皮儿": "ròu,pí,er",
  "肉眼泡": "ròu,yǎn,pāo",
  "肉脯子": "ròu,pú,zǐ",
  "肉薄": "ròu,bó",
  "肉薄骨并": "ròu,bó,gǔ,bìng",
  "肉铺": "ròu,pù",
  "肉馅儿": "ròu,xiàn,er",
  "肋脦": "lē,te",
  "肋膜炎": "lē,mó,yán",
  "肋间肌": "lèi,jiàn,jī",
  "肌肉萎缩症": "jī,ròu,wēi,suō,zhèng",
  "肐膊上走得马": "gē,bó,shàng,zǒu,de,mǎ",
  "肖似": "xiào,sì",
  "肖像": "xiào,xiàng",
  "肖像权": "xiào,xiàng,quán",
  "肖像画": "xiào,xiàng,huà",
  "肖形": "xiào,xíng",
  "肖想": "xiào,xiǎng",
  "肖物": "xiào,wù",
  "肖神": "xiào,shén",
  "肖翘": "xiāo,qiào",
  "肖蛸": "xiāo,shāo",
  "肖貌": "xiào,mào",
  "肖题": "xiào,tí",
  "肘子": "zhǒu,zi",
  "肘见": "zhǒu,xiàn",
  "肚丝": "dǔ,sī",
  "肚儿": "dǔ,er",
  "肚子": "dǔ,zi",
  "肚子痛": "dù,zi,tòng",
  "肚子饿": "dù,zi,è",
  "肚片": "dǔ,piàn",
  "肚脐眼儿": "dù,qí,yǎn,er",
  "肜肜": "chēn,chēn",
  "肝血": "gān,xuè",
  "肠子": "cháng,zi",
  "股价指数": "gǔ,jià,zhǐ,shù",
  "股票指数": "gǔ,piào,zhǐ,shù",
  "股长": "gǔ,zhǎng",
  "肤愬": "fū,shuò",
  "肤浅地": "fū,qiǎn,de",
  "肤皮潦草": "fū,pí,liǎo,cǎo",
  "肤缪": "fū,miù",
  "肥喏": "féi,rě",
  "肥珠子": "féi,zhū,zi",
  "肩射导弹": "jiān,shè,dǎo,dàn",
  "肩并肩地": "jiān,bìng,jiān,de",
  "肩摩毂接": "jiān,mó,gū,jiē",
  "肩背": "jiān,bèi",
  "肩背相望": "jiān,bèi,xiāng,wàng",
  "肩背难望": "jiān,bèi,nán,wàng",
  "肮脏": "āng,zāng",
  "肮脏地": "āng,zāng,de",
  "肯切地": "kěn,qiè,de",
  "肯切地说": "kěn,qiè,de,shuō",
  "肯定地": "kěn,deng,de",
  "肯定地说": "kěn,deng,de,shuō",
  "肯干": "kěn,gàn",
  "肯德基炸鸡": "kěn,dé,jī,zhá,jī",
  "育婴假": "yù,yīng,jià",
  "育贲": "yù,bēn",
  "肺栓塞": "fèi,shuān,sè",
  "肿瘤切除术": "zhǒng,liú,qiè,chú,shù",
  "肿胀地": "zhǒng,zhàng,de",
  "胁肩累足": "xié,jiān,lěi,zú",
  "胁迫地": "xié,pò,de",
  "胆儿": "dǎn,er",
  "胆大如斗": "dǎn,dà,rú,dǒu",
  "胆大妄为": "dǎn,dà,wàng,wéi",
  "胆如斗": "dǎn,rú,dǒu",
  "胆子": "dǎn,zi",
  "胆小地": "dǎn,xiǎo,de",
  "胆层地": "dǎn,céng,de",
  "胆干": "dǎn,gàn",
  "胆怯地": "dǎn,qiè,de",
  "胆薄": "dǎn,bó",
  "背不住": "bèi,bú,zhù",
  "背世": "bèi,shì",
  "背临": "bèi,lín",
  "背主": "bèi,zhǔ",
  "背义忘恩": "bèi,yì,wàng,ēn",
  "背义负信": "bèi,yì,fù,xìn",
  "背义负恩": "bèi,yì,fù,ēn",
  "背乡": "bèi,xiāng",
  "背乡离井": "bèi,xiāng,lí,jǐng",
  "背书": "bèi,shū",
  "背乱": "bèi,luàn",
  "背云": "bèi,yún",
  "背井离乡": "bèi,jǐng,lí,xiāng",
  "背人": "bèi,rén",
  "背会": "bèi,huì",
  "背依": "bèi,yī",
  "背侧": "bèi,cè",
  "背信": "bèi,xìn",
  "背信地": "bèi,xìn,de",
  "背信弃义": "bèi,xìn,qì,yì",
  "背倚": "bèi,yǐ",
  "背偻": "bèi,lǚ",
  "背僻": "bèi,pì",
  "背光": "bèi,guāng",
  "背光性": "bèi,guāng,xìng",
  "背兜": "bèi,dōu",
  "背公": "bèi,gōng",
  "背公向私": "bèi,gōng,xiàng,sī",
  "背公营私": "bèi,gōng,yíng,sī",
  "背兴": "bèi,xìng",
  "背军": "bèi,jūn",
  "背判": "bèi,pàn",
  "背利": "bèi,lì",
  "背前面后": "bèi,qián,miàn,hòu",
  "背剪": "bèi,jiǎn",
  "背包游": "bèi,bāo,yóu",
  "背匙": "bèi,chí",
  "背匠": "bèi,jiàng",
  "背厅": "bèi,tīng",
  "背反": "bèi,fǎn",
  "背叛": "bèi,pàn",
  "背叛地": "bèi,pàn,de",
  "背叛者": "bèi,pàn,zhě",
  "背后": "bèi,hòu",
  "背向": "bèi,xiàng",
  "背吕": "bèi,lǚ",
  "背囊": "bèi,náng",
  "背地": "bèi,dì",
  "背地地": "bèi,de,de",
  "背地里": "bèi,dì,lǐ",
  "背地风": "bèi,dì,fēng",
  "背场": "bèi,chǎng",
  "背场儿": "bèi,chǎng,ér",
  "背坏": "bèi,huài",
  "背城": "bèi,chéng",
  "背城一战": "bèi,chéng,yī,zhàn",
  "背城借一": "bèi,chéng,jiè,yī",
  "背境": "bèi,jìng",
  "背处": "bèi,chǔ",
  "背夹电池": "bèi,jiā,diàn,chí",
  "背奥媚灶": "bèi,ào,mèi,zào",
  "背子": "bēi,zi",
  "背字": "bèi,zì",
  "背字儿": "bèi,zì,ér",
  "背对": "bèi,duì",
  "背对背": "bèi,duì,bèi",
  "背山": "bèi,shān",
  "背山临水": "bèi,shān,lín,shuǐ",
  "背山起楼": "bèi,shān,qǐ,lóu",
  "背峞": "bèi,wéi",
  "背嵬": "bèi,wéi",
  "背工": "bèi,gōng",
  "背巷": "bèi,xiàng",
  "背弃": "bèi,qì",
  "背弓": "bèi,gōng",
  "背影": "bèi,yǐng",
  "背影儿": "bèi,yǐng,er",
  "背影杀手": "bèi,yǐng,shā,shǒu",
  "背征": "bèi,zhēng",
  "背德": "bèi,dé",
  "背心": "bèi,xīn",
  "背恩": "bèi,ēn",
  "背恩弃义": "bèi,ēn,qì,yì",
  "背恩忘义": "bèi,ēn,wàng,yì",
  "背恩负义": "bèi,ēn,fù,yì",
  "背悔": "bèi,huǐ",
  "背惠食言": "bèi,huì,shí,yán",
  "背憎": "bèi,zēng",
  "背战": "bèi,zhàn",
  "背戾": "bèi,lì",
  "背手": "bèi,shǒu",
  "背拉": "bèi,lā",
  "背指": "bèi,zhǐ",
  "背搭子": "bèi,dā,zǐ",
  "背敌": "bèi,dí",
  "背文": "bèi,wén",
  "背斗": "bèi,dòu",
  "背斜": "bèi,xié",
  "背斜层": "bèi,xié,céng",
  "背日性": "bèi,rì,xìng",
  "背旮旯儿": "bèi,gā,lá,ér",
  "背时": "bèi,shí",
  "背时鬼": "bèi,shí,guǐ",
  "背晦": "bèi,huì",
  "背景": "bèi,jǐng",
  "背景虚化": "bèi,jǐng,xū,huà",
  "背景音乐": "bèi,jǐng,yīn,yuè",
  "背暗投明": "bèi,àn,tóu,míng",
  "背曲腰弯": "bèi,qǔ,yāo,wān",
  "背曲腰躬": "bèi,qǔ,yāo,gōng",
  "背本": "bèi,běn",
  "背本就末": "bèi,běn,jiù,mò",
  "背本趋末": "bèi,běn,qū,mò",
  "背杀": "bèi,shā",
  "背板": "bèi,bǎn",
  "背槽抛粪": "bèi,cáo,pāo,fèn",
  "背毁": "bèi,huǐ",
  "背气": "bèi,qì",
  "背水一战": "bèi,shuǐ,yī,zhàn",
  "背水仗": "bèi,shuǐ,zhàng",
  "背水战": "bèi,shuǐ,zhàn",
  "背水阵": "bèi,shuǐ,zhèn",
  "背水陈": "bèi,shuǐ,chén",
  "背流": "bèi,liú",
  "背溜": "bèi,liū",
  "背灶": "bèi,zào",
  "背熟": "bèi,shú",
  "背珥": "bèi,ěr",
  "背理": "bèi,lǐ",
  "背璚": "bèi,jué",
  "背生儿": "bèi,shēng,ér",
  "背生芒刺": "bèi,shēng,máng,cì",
  "背畔": "bèi,pàn",
  "背盟": "bèi,méng",
  "背盟败约": "bèi,méng,bài,yuē",
  "背眼": "bèi,yǎn",
  "背着": "bēi,zhe",
  "背着手": "bèi,zhe,shǒu",
  "背着抱着一般重": "bēi,zhe,bào,zhe,yī,bān,zhòng",
  "背碑覆局": "bèi,bēi,fù,jú",
  "背礼": "bèi,lǐ",
  "背离": "bèi,lí",
  "背称": "bèi,chēng",
  "背穴": "bèi,xué",
  "背立": "bèi,lì",
  "背篷": "bèi,péng",
  "背篼": "bèi,dōu",
  "背约": "bèi,yuē",
  "背绑": "bèi,bǎng",
  "背缝印": "bèi,fèng,yìn",
  "背罪": "bèi,zuì",
  "背群": "bèi,qún",
  "背肐拉子": "bèi,gē,lā,zǐ",
  "背胸": "bèi,xiōng",
  "背脊": "bèi,jǐ",
  "背腹受敌": "bèi,fù,shòu,dí",
  "背膂": "bèi,lǚ",
  "背臣": "bèi,chén",
  "背花": "bèi,huā",
  "背若芒刺": "bèi,ruò,máng,cì",
  "背蓬": "bèi,péng",
  "背行": "bèi,xíng",
  "背街": "bèi,jiē",
  "背衬": "bèi,chèn",
  "背袋": "bèi,dài",
  "背褡": "bèi,dā",
  "背褡子": "bèi,dā,zǐ",
  "背角": "bèi,jiǎo",
  "背誓": "bèi,shì",
  "背诞": "bèi,dàn",
  "背诵": "bèi,sòng",
  "背谬": "bèi,miù",
  "背谱": "bèi,pǔ",
  "背谲": "bèi,jué",
  "背货": "bèi,huò",
  "背贰": "bèi,èr",
  "背身": "bèi,shēn",
  "背躬": "bèi,gōng",
  "背转": "bèi,zhuǎn",
  "背过气": "bèi,guò,qì",
  "背运": "bèi,yùn",
  "背违": "bèi,wéi",
  "背述": "bèi,shù",
  "背道": "bèi,dào",
  "背道儿": "bèi,dào,er",
  "背道而驰": "bèi,dào,ér,chí",
  "背部": "bèi,bù",
  "背部地": "bèi,bù,de",
  "背𫔎": "bèi,jué",
  "背阔肌": "bèi,kuò,jī",
  "背阴": "bèi,yīn",
  "背阴儿": "bèi,yīn,ér",
  "背集": "bèi,jí",
  "背霉": "bèi,méi",
  "背静": "bèi,jìng",
  "背靠": "bèi,kào",
  "背靠背": "bèi,kào,bèi",
  "背靠背地": "bèi,kào,bèi,de",
  "背面": "bèi,miàn",
  "背风": "bèi,fēng",
  "背风港": "bèi,fēng,gǎng",
  "背风面": "bèi,fēng,miàn",
  "背驰": "bèi,chí",
  "背驼": "bèi,tuó",
  "背骨": "bèi,gǔ",
  "背鳍": "bèi,qí",
  "胎发": "tāi,fà",
  "胎生地": "tāi,shēng,de",
  "胏石": "fèi,shí",
  "胏肝": "fèi,gān",
  "胏腑": "fèi,fǔ",
  "胏附": "fèi,fù",
  "胖墩儿": "pàng,dūn,er",
  "胖子": "pàng,zi",
  "胖子年": "pàng,zi,nián",
  "胜任地": "shèng,rèn,de",
  "胜冠": "shèng,guān",
  "胜利地": "shèng,lì,de",
  "胡为": "hú,wéi",
  "胡乐": "hú,yuè",
  "胡乱地": "hú,luàn,de",
  "胡云海嗙": "hú,yún,hǎi,pǎng",
  "胡作乱为": "hú,zuò,luàn,wéi",
  "胡作胡为": "hú,zuò,hú,wéi",
  "胡作非为": "hú,zuò,fēi,wéi",
  "胡厮哄": "hú,sī,hǒng",
  "胡同": "hú,tòng",
  "胡吹乱嗙": "hú,chuī,luàn,pǎng",
  "胡吹地": "hú,chuī,de",
  "胡咯咯": "hú,gē,gē",
  "胡哄": "hú,hǒng",
  "胡嘌": "hú,piào",
  "胡塞尔": "hú,sài,ěr",
  "胡子": "hú,zi",
  "胡子扎撒": "hú,zǐ,zhā,sā",
  "胡子拉碴": "hú,zǐ,lā,chā",
  "胡子茬儿": "hú,zi,chá,er",
  "胡弄": "hú,nong",
  "胡搂": "hú,lōu",
  "胡桃夹子": "hú,táo,jiā,zi",
  "胡椒薄荷": "hú,jiāo,bò,he",
  "胡椒面儿": "hú,jiāo,miàn,er",
  "胡涂": "hú,tu",
  "胡涂虫": "hú,tu,chóng",
  "胡渰": "hú,yǎn",
  "胡燕妮": "hú,yān,nī",
  "胡琴": "hú,qin",
  "胡琴儿": "hú,qín,er",
  "胡碴": "hú,chā",
  "胡胡麻麻": "hú,hú,mā,ma",
  "胡萝卜": "hú,luó,bo",
  "胡萝卜素": "hú,luó,bo,sù",
  "胡行乱为": "hú,xíng,luàn,wéi",
  "胡言乱语地说": "hú,yán,luàn,yǔ,de,shuō",
  "胡说地": "hú,shuō,de",
  "胡调": "hú,diào",
  "胡貉": "hú,mò",
  "胡适": "hú,shì",
  "胡铺搭": "hú,pù,dā",
  "胡面子": "hú,miàn,zi",
  "胡骑": "hú,jì",
  "胥仆": "xū,pú",
  "胯下韩侯": "kuà,xià,hán,hòu",
  "胳膊肘儿": "gē,bó,zhǒu,er",
  "胳膊肘往外拐": "gē,bo,zhǒu,wǎng,wài,guǎi",
  "胳膊肘朝外拐": "gē,bo,zhǒu,cháo,wài,guǎi",
  "胳臂": "gē,bei",
  "胳臂箍儿": "gē,bei,gū,er",
  "胳臂肘儿": "gē,bei,zhǒu,er",
  "胳臂钱": "gē,bei,qián",
  "胶折": "jiāo,shé",
  "胶着": "jiāo,zhe",
  "胶着地": "jiāo,zhe,de",
  "胶粘地": "jiāo,zhān,de",
  "胶葛": "jiāo,gě",
  "胸中万卷": "xiōng,zhōng,wàn,juàn",
  "胸中万卷书": "xiōng,zhōng,wàn,juàn,shū",
  "胸中书万卷": "xiōng,zhōng,shū,wàn,juàn",
  "胸中无数": "xiōng,zhōng,wú,shù",
  "胸中有数": "xiōng,zhōng,yǒu,shù",
  "胸背": "xiōng,bèi",
  "胸脯": "xiōng,pú",
  "胸闷": "xiōng,mēn",
  "胸闷难受": "xiōng,mēn,nán,shòu",
  "能不称官": "néng,bù,chèn,guān",
  "能不能偷偷地": "néng,bù,néng,tōu,tōu,de",
  "能不能简单地": "néng,bù,néng,jiǎn,dān,de",
  "能为": "néng,wéi",
  "能共处地": "néng,gòng,chǔ,de",
  "能准确地": "néng,zhǔn,què,de",
  "能变地": "néng,biàn,de",
  "能否准确地": "néng,fǒu,zhǔn,què,de",
  "能否简单地": "néng,fǒu,jiǎn,dān,de",
  "能够不断地": "néng,gòu,bù,duàn,de",
  "能够很好地": "néng,gòu,hěn,hǎo,de",
  "能够很快地": "néng,gòu,hěn,kuài,de",
  "能够更好地": "néng,gòu,gèng,hǎo,de",
  "能够更快地": "néng,gòu,gèng,kuài,de",
  "能够有效地": "néng,gòu,yǒu,xiào,de",
  "能够正常地": "néng,gòu,zhèng,cháng,de",
  "能够正确地": "néng,gòu,zhèng,què,de",
  "能够清晰地看到": "néng,gòu,qīng,xī,de,kàn,dào",
  "能够较好地": "néng,gòu,jiào,hǎo,de",
  "能干": "néng,gàn",
  "能干地": "néng,gàn,de",
  "能幸运地": "néng,xìng,yùn,de",
  "能很好地": "néng,hěn,hǎo,de",
  "能很好地完成": "néng,hěn,hǎo,de,wán,chéng",
  "能很好地解决": "néng,hěn,hǎo,de,jiě,jué",
  "能很方便地": "néng,hěn,fāng,biàn,de",
  "能忍耐地": "néng,rěn,nài,de",
  "能快速地": "néng,kuài,sù,de",
  "能断地": "néng,duàn,de",
  "能方便地": "néng,fāng,biàn,de",
  "能旋转地": "néng,xuán,zhuǎn,de",
  "能更好地": "néng,gèng,hǎo,de",
  "能更好地发挥": "néng,gèng,hǎo,de,fā,huī",
  "能更好地实现": "néng,gèng,hǎo,de,shí,xiàn",
  "能有效地": "néng,yǒu,xiào,de",
  "能极大地": "néng,jí,dà,de",
  "能正确地": "néng,zhèng,què,de",
  "能清楚地": "néng,qīng,chǔ,de",
  "能清楚地看到": "néng,qīng,chǔ,de,kàn,dào",
  "能熟练地": "néng,shú,liàn,de",
  "能理解地": "néng,lǐ,jiě,de",
  "能生动地": "néng,shēng,dòng,de",
  "能着": "néng,zhe",
  "能者为师": "néng,zhě,wéi,shī",
  "能胜任地": "néng,shèng,rèn,de",
  "能自觉地": "néng,zì,jué,de",
  "能迅速地": "néng,xùn,sù,de",
  "能量不灭定律": "néng,liàng,bú,miè,dìng,lǜ",
  "能顺利地": "néng,shùn,lì,de",
  "脂麻": "zhī,ma",
  "脆弱地": "cuì,ruò,de",
  "脉脉": "mò,mò",
  "脉脉含情": "mò,mò,hán,qíng",
  "脊令": "jí,líng",
  "脊令原": "jǐ,líng,yuán",
  "脊椎侧弯": "jǐ,zhù,cè,wān",
  "脊背": "jǐ,bèi",
  "脏乱": "zāng,luàn",
  "脏乱差": "zāng,luàn,chà",
  "脏了": "zāng,le",
  "脏兮兮": "zāng,xī,xī",
  "脏土": "zāng,tǔ",
  "脏字": "zāng,zì",
  "脏字儿": "zāng,zì,er",
  "脏弹": "zāng,dàn",
  "脏标": "zāng,biāo",
  "脏水": "zāng,shuǐ",
  "脏污": "zāng,wū",
  "脏污狼藉": "zāng,wū,láng,jí",
  "脏活儿": "zāng,huó,er",
  "脏煤": "zāng,méi",
  "脏病": "zāng,bìng",
  "脏稀稀": "zāng,xī,xī",
  "脏脏": "zāng,zāng",
  "脏脏包": "zāng,zāng,bāo",
  "脏衣服": "zāng,yī,fú",
  "脏话": "zāng,huà",
  "脏象": "zāng,xiàng",
  "脏躁症": "zāng,zào,zhèng",
  "脏辫": "zāng,biàn",
  "脑中风": "nǎo,zhòng,fēng",
  "脑体倒挂": "nǎo,tǐ,dào,guà",
  "脑儿": "nǎo,er",
  "脑儿酒": "nǎo,er,jiǔ",
  "脑充血": "nǎo,chōng,xuè",
  "脑出血": "nǎo,chū,xuè",
  "脑力上地": "nǎo,lì,shàng,de",
  "脑勺儿": "nǎo,sháo,er",
  "脑卒中": "nǎo,cù,zhòng",
  "脑子": "nǎo,zi",
  "脑子有泡": "nǎo,zi,yǒu,pào",
  "脑子生锈": "nǎo,zi,shēng,xiù",
  "脑子进水": "nǎo,zi,jìn,shuǐ",
  "脑干": "nǎo,gàn",
  "脑梗塞": "nǎo,gěng,sè",
  "脑涨": "nǎo,zhàng",
  "脑溢血": "nǎo,yì,xuè",
  "脑瓜儿": "nǎo,guā,er",
  "脑瓜子": "nǎo,guā,zi",
  "脑瓢儿": "nǎo,piáo,er",
  "脑盖子": "nǎo,gài,zi",
  "脑血": "nǎo,xuè",
  "脑血栓": "nǎo,xuè,shuān",
  "脑血栓形成": "nǎo,xuè,shuān,xíng,chéng",
  "脑血管": "nǎo,xuè,guǎn",
  "脑血管屏障": "nǎo,xuè,guǎn,píng,zhàng",
  "脑血管疾病": "nǎo,xuè,guǎn,jí,bìng",
  "脑袋": "nǎo,dai",
  "脑袋瓜儿": "nǎo,dài,guā,er",
  "脑贫血": "nǎo,pín,xuè",
  "脑门子": "nǎo,mén,zi",
  "脓血": "nóng,xuè",
  "脓血债": "nóng,xuè,zhài",
  "脔卷": "luán,juàn",
  "脖子": "bó,zi",
  "脖子拐": "bó,zi,guǎi",
  "脖梗儿": "bó,gěng,er",
  "脖领子": "bó,lǐng,zi",
  "脖颈": "bó,gěng",
  "脖颈儿": "bó,gěng,er",
  "脖颈子": "bó,gěng,zi",
  "脚丫子": "jiǎo,yā,zi",
  "脚孤拐": "jiǎo,gū,guai",
  "脚尖点地": "jiǎo,jiān,diǎn,de",
  "脚尖着地": "jiǎo,jiān,zhe,de",
  "脚打着脑杓子": "jiǎo,dǎ,zhe,nǎo,sháo,zǐ",
  "脚指头": "jiǎo,zhǐ,tou",
  "脚指甲": "jiǎo,zhǐ,jia",
  "脚搭着脑杓": "jiǎo,dā,zhe,nǎo,sháo",
  "脚杆": "jiǎo,gǎn",
  "脚柞": "jiǎo,zhà",
  "脚着地": "jiǎo,zhe,de",
  "脚着地时": "jiǎo,zhe,de,shí",
  "脚𰬔": "jiǎo,bīng",
  "脚背": "jiǎo,bèi",
  "脚脖子": "jiǎo,bó,zi",
  "脚腕子": "jiǎo,wàn,zi",
  "脚色": "jué,sè",
  "脚色状": "jué,sè,zhuàng",
  "脚趾头": "jiǎo,zhǐ,tou",
  "脚踏两只船": "jiǎo,tà,liǎng,zhī,chuán",
  "脚踏着脑杓子": "jiǎo,tà,zhe,nǎo,sháo,zǐ",
  "脚踩两只船": "jiǎo,cǎi,liǎng,zhī,chuán",
  "脚蹬": "jiǎo,dēng",
  "脚蹬子": "jiǎo,dēng,zǐ",
  "脚鸭子": "jiǎo,yā,zi",
  "脩絜": "xiū,jié",
  "脯子": "pú,zi",
  "脯氨酸": "pú,ān,suān",
  "脱不了": "tuō,bù,liǎo",
  "脱不了身": "tuō,bù,liǎo,shēn",
  "脱冠": "tuō,guān",
  "脱剥": "tuō,bāo",
  "脱剥杂剧": "tuō,bāo,zá,jù",
  "脱发": "tuō,fà",
  "脱壳": "tuō,qiào",
  "脱手弹丸": "tuō,shǒu,dàn,wán",
  "脱煞": "tuō,shà",
  "脱白挂绿": "tuō,bái,guà,lù",
  "脱皮儿裹剂": "tuō,pí,er,guǒ,jì",
  "脱累": "tuō,lèi",
  "脱缝": "tuō,fèng",
  "脱缪": "tuō,miù",
  "脱舃": "tuō,tuō",
  "脱节地": "tuō,jié,de",
  "脱血": "tuō,xuè",
  "脱裤子放屁": "tuō,kù,zi,fàng,pì",
  "脱轨地": "tuō,guǐ,de",
  "脸不红心不跳": "liǎn,bù,hóng,xīn,bú,tiào",
  "脸巴子": "liǎn,bā,zi",
  "脸模子": "liǎn,mú,zǐ",
  "脸盘儿": "liǎn,pán,er",
  "脸相": "liǎn,xiàng",
  "脸红地": "liǎn,hóng,de",
  "脸红脖子粗": "liǎn,hóng,bó,zi,cū",
  "脸蛋儿": "liǎn,dàn,er",
  "脸蛋子": "liǎn,dàn,zi",
  "脾气": "pí,qi",
  "脾气地": "pí,qì,de",
  "脾气坏地": "pí,qì,huài,de",
  "脾气很拗": "pí,qì,hěn,niù",
  "腃发": "quān,fā",
  "腃急": "quān,jí",
  "腄腄": "hóu,hóu",
  "腊毒": "xī,dú",
  "腋臊": "yè,sào",
  "腌制": "yān,zhì",
  "腌剌答": "yān,là,dá",
  "腌势": "yān,shì",
  "腌咸": "yān,xián",
  "腌对付": "yān,duì,fù",
  "腌汁": "yān,zhī",
  "腌泡": "yān,pào",
  "腌渍": "yān,zì",
  "腌猪肉": "yān,zhū,ròu",
  "腌盆儿": "yān,pén,ér",
  "腌肉": "yān,ròu",
  "腌胙": "yān,zuò",
  "腌脏": "yān,zāng",
  "腌腊": "yān,là",
  "腌苦": "yān,kǔ",
  "腌菜": "yān,cài",
  "腌藏": "yān,cáng",
  "腌货": "yān,huò",
  "腌躯老": "yān,qū,lǎo",
  "腌造": "yān,zào",
  "腌里巴臜": "yān,lǐ,bā,zā",
  "腌陈": "yān,chén",
  "腌黄瓜": "yān,huáng,guā",
  "腐烂了地": "fǔ,làn,le,de",
  "腐蚀性地": "fǔ,shí,xìng,de",
  "腑脏": "fǔ,zāng",
  "腔子": "qiāng,zi",
  "腔调": "qiāng,diào",
  "腕儿": "wàn,er",
  "腕子": "wàn,zi",
  "腞楯": "zhuàn,dùn",
  "腥血": "xīng,xuè",
  "腥风血雨": "xīng,fēng,xuè,yǔ",
  "腮帮子": "sāi,bāng,zi",
  "腰子": "yāo,zi",
  "腰干": "yāo,gàn",
  "腰把子": "yāo,bà,zi",
  "腰折": "yāo,shé",
  "腰杆": "yāo,gǎn",
  "腰杆子": "yāo,gān,zi",
  "腰篴": "yāo,dí",
  "腰背": "yāo,bèi",
  "腰酸背痛": "yāo,suān,bèi,tòng",
  "腱子": "jiàn,zi",
  "腲脓血": "wěi,nóng,xuè",
  "腴𰮇": "yú,wǔ",
  "腹便便": "fù,pián,pián",
  "腹笥便便": "fù,sì,pián,pián",
  "腹背": "fù,bèi",
  "腹背之毛": "fù,bèi,zhī,máo",
  "腹背受敌": "fù,bèi,shòu,dí",
  "腹背相亲": "fù,bèi,xiāng,qīn",
  "腺嘌呤": "xiàn,piào,lìng",
  "腺嘌呤核苷三磷酸": "xiàn,piào,lìng,hé,gān,sān,lín,suān",
  "腻味": "nì,wei",
  "腻子": "nì,zi",
  "腻得得": "nì,de,de",
  "腻歪": "nì,wai",
  "腻烦": "nì,fan",
  "腻缝": "nì,fèng",
  "腼脸": "tiǎn,liǎn",
  "腼腆地": "miǎn,tiǎn,de",
  "腼腆地笑": "miǎn,tiǎn,de,xiào",
  "腼腆地说": "miǎn,tiǎn,de,shuō",
  "腾地": "téng,de",
  "腾地一下": "téng,de,yī,xià",
  "腾腾兀兀": "téng,téng,wū,wū",
  "腾腾地": "téng,téng,de",
  "腾趠": "téng,chào",
  "腾跞": "téng,luò",
  "腾蹶": "téng,juě",
  "腾逴": "téng,chuò",
  "腿杆": "tuǐ,gǎn",
  "腿𰬔": "tuǐ,bīng",
  "腿肚子": "tuǐ,dǔ,zi",
  "膀子": "bǎng,zi",
  "膀子吊": "bǎng,zi,diào",
  "膀扇子": "bǎng,shàn,zi",
  "膀胱": "páng,guāng",
  "膀胱气化": "páng,guāng,qì,huà",
  "膀胱炎": "páng,guāng,yán",
  "膈应": "gè,ying",
  "膈肢": "gé,zhi",
  "䒿血": "liáo,xuè",
  "膍胵": "pí,zhì",
  "膏唇岐舌": "gào,chún,qí,shé",
  "膏唇贩舌": "gào,chún,fàn,shé",
  "膏场绣浍": "gāo,cháng,xiù,kuài",
  "膏沐": "gào,mù",
  "膏油": "gào,yóu",
  "膏泽": "gào,zé",
  "膏润": "gào,rùn",
  "膏立": "gào,lì",
  "膏粱年少": "gāo,liáng,nián,shào",
  "膏臊": "gāo,sào",
  "膏药旗": "gāo,yao,qí",
  "膏血": "gāo,xuè",
  "膏车": "gào,chē",
  "膏车秣马": "gào,chē,mò,mǎ",
  "膏露": "gāo,lù",
  "膏面": "gào,miàn",
  "膜呗": "mó,bài",
  "膝痒搔背": "xī,yǎng,sāo,bèi",
  "膝馒头": "xī,mán,tou",
  "𦝼腊": "lóu,là",
  "膨胀系数": "péng,zhàng,xì,shù",
  "𰮇仕": "wǔ,shì",
  "𰮇然": "wǔ,rán",
  "𰮇盛": "wǔ,shèng",
  "𰮇𰮇": "wǔ,wǔ",
  "膺揲": "yīng,dié",
  "膺擖": "yīng,yè",
  "膺蕃": "yīng,fān",
  "膻中": "dàn,zhōng",
  "膻味": "shàn,wèi",
  "膻臊": "shān,sào",
  "膻裼": "shān,tì",
  "臀沟": "tún,gòu",
  "臆度": "yì,duó",
  "臆想狂": "yì,xiǎn,kuáng",
  "臆揣": "yì,chuāi",
  "臊声": "sào,shēng",
  "臊子": "sào,zǐ",
  "臊根": "sào,gēn",
  "臊皮": "sào,pí",
  "臊眉耷眼": "sào,méi,dā,yǎn",
  "臊秽": "sào,huì",
  "臊膻": "sào,shān",
  "臊陀": "sào,tuó",
  "臊陁": "sào,tuó",
  "臝露": "luǒ,lù",
  "臣仆": "chén,pú",
  "臧仆": "zāng,pú",
  "臧否": "zāng,pǐ",
  "臧否人物": "zāng,pǐ,rén,wù",
  "自个儿": "zì,gě,ér",
  "自主地": "zì,zhǔ,de",
  "自以为得计": "zì,yǐ,wéi,dé,jì",
  "自以为是": "zì,yǐ,wéi,shì",
  "自以为是地": "zì,yǐ,wéi,shì,de",
  "自以为然": "zì,yǐ,wéi,rán",
  "自传": "zì,zhuàn",
  "自信地": "zì,xìn,de",
  "自傲地": "zì,ào,de",
  "自僝自僽": "zì,zhuàn,zì,zhōu",
  "自制炸弹": "zì,zhì,zhà,dàn",
  "自刽以下": "zì,kuài,yǐ,xià",
  "自剖": "zì,pōu",
  "自力更生": "zì,lì,gēng,shēng",
  "自动倒卷": "zì,dòng,dào,juǎn",
  "自动倒带": "zì,dòng,dào,dài",
  "自动地": "zì,dòng,de",
  "自𠡠": "zì,lài",
  "自发地": "zì,fā,de",
  "自发对称破缺": "zì,fā,duì,chèn,pò,quē",
  "自各儿": "zì,gě,ér",
  "自在": "zì,zai",
  "自处": "zì,chǔ",
  "自大地": "zì,dà,de",
  "自夸地": "zì,kuā,de",
  "自好": "zì,hào",
  "自己可以自由地": "zì,jǐ,kě,yǐ,zì,yóu,de",
  "自形地": "zì,xíng,de",
  "自律地": "zì,lǜ,de",
  "自怨自艾": "zì,yuàn,zì,yì",
  "自愬": "zì,shuò",
  "自愿地": "zì,yuàn,de",
  "自慊": "zì,qiè",
  "自我意识性": "zì,wǒ,yì,shi,xìng",
  "自找麻烦": "zì,zhǎo,má,fan",
  "自拍杆": "zì,pāi,gǎn",
  "自挟": "zì,jiā",
  "自明地": "zì,míng,de",
  "自有留人处": "zì,yǒu,liú,rén,chǔ",
  "自杀式炸弹": "zì,shā,shì,zhà,dàn",
  "自杀性地": "zì,shā,xìng,de",
  "自杀炸弹杀手": "zì,shā,zhà,dàn,shā,shǒu",
  "自满地": "zì,mǎn,de",
  "自然地": "zì,rán,de",
  "自然地物": "zì,rán,de,wù",
  "自然对数": "zì,rán,duì,shù",
  "自然数": "zì,rán,shù",
  "自然数集": "zì,rán,shù,jí",
  "自然而然地": "zì,rán,ér,rán,de",
  "自然而然地记住": "zì,rán,ér,rán,de,jì,zhù",
  "自然语言处理": "zì,rán,yǔ,yán,chǔ,lǐ",
  "自由地": "zì,yóu,de",
  "自由地成长": "zì,yóu,de,chéng,zhǎng",
  "自由地翱翔": "zì,yóu,de,áo,xiáng",
  "自由地调整": "zì,yóu,de,tiáo,zhěng",
  "自由地选择": "zì,yóu,de,xuǎn,zé",
  "自由散漫": "zì,yóu,sǎn,màn",
  "自由爵士乐": "zì,yóu,jué,shì,yuè",
  "自省": "zì,xǐng",
  "自私地": "zì,sī,de",
  "自立地": "zì,lì,de",
  "自筹给养": "zì,chóu,jǐ,yǎng",
  "自累": "zì,lèi",
  "自絜": "zì,jié",
  "自繇": "zì,yóu",
  "自繇自在": "zì,yóu,zì,zai",
  "自给": "zì,jǐ",
  "自给自足": "zì,jǐ,zì,zú",
  "自背黑锅": "zì,bèi,hēi,guō",
  "自艾": "zì,yì",
  "自若地": "zì,ruò,de",
  "自苦地": "zì,kǔ,de",
  "自行了断": "zì,xíng,liǎo,duàn",
  "自见": "zì,xiàn",
  "自觉地": "zì,jué,de",
  "自觉地用": "zì,jué,de,yòng",
  "自觉地配合着": "zì,jué,de,pèi,hé,zhe",
  "自言自语地说": "zì,yán,zì,yǔ,de,shuō",
  "自豪地": "zì,háo,de",
  "自豪地说": "zì,háo,de,shuō",
  "自负地": "zì,fù,de",
  "自责地想": "zì,zé,de,xiǎng",
  "自转": "zì,zhuàn",
  "自转轴": "zì,zhuàn,zhóu",
  "自适": "zì,shì",
  "自适应": "zì,shì,yìng",
  "臬兀": "niè,wū",
  "臭名昭着": "chòu,míng,zhāo,zhe",
  "臭味儿": "chòu,wèi,er",
  "臭味相投": "xiù,wèi,xiāng,tóu",
  "臭子儿": "chòu,zǐ,er",
  "臭弹": "chòu,dàn",
  "臭揍一顿": "chòu,zòu,yí,dùn",
  "臭架子": "chòu,jià,zi",
  "臭败": "xiù,bài",
  "至上地": "zhì,shàng,de",
  "至为": "zhì,wéi",
  "至当不易": "zhì,dàng,bù,yì",
  "至数": "zhì,shù",
  "至朴": "zhì,piáo",
  "至死地": "zhì,sǐ,de",
  "至死靡它": "zhì,sǐ,mǐ,tā",
  "至高地": "zhì,gāo,de",
  "致命地": "zhì,mìng,de",
  "致害地": "zhì,hài,de",
  "致得": "zhì,de",
  "致政大夫": "zhì,zhèng,dài,fū",
  "舀子": "yǎo,zi",
  "舀服地": "yǎo,fú,de",
  "舂容大雅": "chōng,róng,dà,yá",
  "舃凫": "tuō,fú",
  "舃卤": "tuō,lǔ",
  "舃咸": "tuō,xián",
  "舃奕": "tuō,yì",
  "舃履": "tuō,lǚ",
  "舅舅": "jiù,jiu",
  "舆论调查": "yú,lùn,diào,chá",
  "舌下含服": "shé,xià,hán,fù",
  "舌头": "shé,tou",
  "舌苔": "shé,tāi",
  "舍不得孩子套不住狼": "shě,bù,de,hái,zi,tào,bù,zhù,láng",
  "舍中": "shè,zhōng",
  "舍亲": "shè,qīn",
  "舍人": "shè,rén",
  "舍利": "shè,lì",
  "舍利塔": "shè,lì,tǎ",
  "舍利子": "shè,lì,zi",
  "舍利子塔": "shè,lì,zi,tǎ",
  "舍匿": "shè,nì",
  "舍友": "shè,yǒu",
  "舍园": "shè,yuán",
  "舍奠": "shè,diàn",
  "舍字": "shè,zì",
  "舍寿": "shè,shòu",
  "舍帐": "shè,zhàng",
  "舍弟": "shè,dì",
  "舍得": "shè,de",
  "舍戍": "shè,shù",
  "舍拼": "shè,pīn",
  "舍敬": "shè,jìng",
  "舍次": "shè,cì",
  "舍止": "shè,zhǐ",
  "舍毒": "shè,dú",
  "舍然": "shè,rán",
  "舍监": "shè,jiān",
  "舍眷": "shè,juàn",
  "舍着金钟撞破盆": "shè,zhe,jīn,zhōng,zhuàng,pò,pén",
  "舍禁": "shě,jìn",
  "舍离": "shè,lí",
  "舍缘豆": "shè,yuán,dòu",
  "舍菜": "shì,cài",
  "舍藏": "shè,cáng",
  "舍讲": "shè,jiǎng",
  "舍越": "shè,yuè",
  "舍身为国": "shě,shēn,wéi,guó",
  "舍身崖": "shè,shēn,yá",
  "舍身饲虎": "shè,shēn,sì,hǔ",
  "舍车保帅": "shè,jū,bǎo,shuài",
  "舍采": "shì,cǎi",
  "舍长": "shè,zhǎng",
  "舍间": "shè,jiān",
  "舍馆": "shè,guǎn",
  "舒卷": "shū,juàn",
  "舒坦": "shū,tan",
  "舒服地": "shū,fú,de",
  "舒服地躺": "shū,fú,de,tǎng",
  "舒畅地": "shū,chàng,de",
  "舒筋活血": "shū,jīn,huó,xuè",
  "舒舒服服": "shū,shu,fu,fu",
  "舒舒服服地": "shū,shū,fú,fú,de",
  "舒适": "shū,shì",
  "舒适地": "shū,shì,de",
  "舒适地坐定": "shū,shì,de,zuò,deng",
  "舒适音": "shū,shì,yīn",
  "舒遟": "shū,zhì",
  "舔屁股": "tiǎn,pì,gu",
  "舛剥": "chuǎn,bāo",
  "舛缪": "chuǎn,miù",
  "舞台音乐": "wǔ,tái,yīn,yuè",
  "舞干": "wǔ,gàn",
  "舞絙": "wǔ,gēng",
  "般乐": "pán,lè",
  "般伏": "pán,fú",
  "般剥": "bān,bāo",
  "般地": "bān,de",
  "般桓": "pán,huán",
  "般游": "pán,yóu",
  "般缠": "pán,chán",
  "般若": "bō,rě",
  "般若汤": "bō,rě,tāng",
  "般若波罗密": "bō,rě,bō,luó,mì",
  "般若波罗密多心经": "bō,rě,bō,luó,mì,duō,xīn,jīng",
  "般调": "bān,diào",
  "般费": "pán,fèi",
  "般辟": "pán,pì",
  "般还": "pán,hái",
  "般逸": "pán,yì",
  "般量": "pán,liàng",
  "舰只": "jiàn,zhī",
  "舰空导弹": "jiàn,kōng,dǎo,dàn",
  "舰长": "jiàn,zhǎng",
  "舶趠风": "bó,chào,fēng",
  "舷细地": "xián,xì,de",
  "船只": "chuán,zhī",
  "船帆": "chuán,fān",
  "船帆座": "chuán,fān,zuò",
  "船长": "chuán,zhǎng",
  "艋舺": "měng,jiǎ",
  "艮背": "gèn,bèi",
  "良好地": "liáng,hǎo,de",
  "良将": "liáng,jiàng",
  "良干": "liáng,gàn",
  "良心上地": "liáng,xīn,shàng,de",
  "良心大大地坏了": "liáng,xīn,dà,dà,de,huài,le",
  "良贾": "liáng,gǔ",
  "艰苦地": "jiān,kǔ,de",
  "艰苦地从事于": "jiān,kǔ,de,cóng,shì,yú",
  "艰苦地劳动": "jiān,kǔ,de,láo,dòng",
  "艰苦地干": "jiān,kǔ,de,gàn",
  "艰辛地": "jiān,xīn,de",
  "艰难地": "jiān,nán,de",
  "艰难地开口": "jiān,nán,de,kāi,kǒu",
  "艰难地说": "jiān,nán,de,shuō",
  "艰难地走": "jiān,nán,de,zǒu",
  "艰难地转过头": "jiān,nán,de,zhuǎn,guò,tóu",
  "艰难曲折": "jiān,nán,qū,zhé",
  "色厉胆薄": "sè,lì,dǎn,bó",
  "色子": "shǎi,zǐ",
  "色情地": "sè,qíng,de",
  "色数儿": "sè,shù,ér",
  "色晕": "sè,yùn",
  "色析法地": "sè,xī,fǎ,de",
  "色盅": "shǎi,zhōng",
  "色相": "sè,xiàng",
  "色调": "sè,diào",
  "色调地": "sè,diào,de",
  "色达县": "shǎi,dá,xiàn",
  "色酒": "shǎi,jiǔ",
  "色钟": "shǎi,zhōng",
  "色长": "sè,zhǎng",
  "艳丽地": "yàn,lì,de",
  "艳什": "yàn,shí",
  "艳冶地": "yàn,yě,de",
  "艺术地": "yì,shù,de",
  "艾发": "ài,fà",
  "艾哈迈德": "ài,hǎ,mài,dé",
  "艾尔米塔什": "ài,ěr,mǐ,tǎ,shí",
  "艾尔米塔奇": "ài,ěr,mǐ,tǎ,jī",
  "艾窝窝": "ài,wō,wo",
  "艿稗": "rèng,bài",
  "节俭地": "jié,jiǎn,de",
  "节假日": "jié,jià,rì",
  "节制地": "jié,zhì,de",
  "节地率": "jié,de,lǜ",
  "节子": "jiē,zǐ",
  "节干": "jié,gàn",
  "节日地": "jié,rì,de",
  "节棁": "jié,tuō",
  "节省地": "jié,shěng,de",
  "节约地": "jié,yuē,de",
  "节调": "jié,diào",
  "节适": "jié,shì",
  "节骨眼": "jiē,gǔ,yǎn",
  "节骨眼儿": "jiē,gu,yǎn,er",
  "芋头": "yù,tou",
  "芋头色": "yù,tou,sè",
  "芋妳": "yù,nǎi",
  "芍陂": "què,pí",
  "芎林": "qiōng,lín",
  "芎林乡": "qiōng,lín,xiāng",
  "芒刺在背": "máng,cì,zài,bèi",
  "芒种": "máng,zhòng",
  "芒背": "máng,bèi",
  "芘乘": "pí,chéng",
  "芘依": "pí,yī",
  "芘芣": "pí,fǒu",
  "芘苤": "pí,piě",
  "芘荫": "pí,yīn",
  "芘𰱾": "pí,lài",
  "芘赖": "pí,lài",
  "芜𰛦": "wú,wèi",
  "芜累": "wú,lěi",
  "芝朮": "zhī,zhú",
  "芝草无根": "zhi,cao,wu,geng",
  "芝露": "zhī,lù",
  "芝麻": "zhī,ma",
  "芝麻包": "zhī,ma,bāo",
  "芝麻官": "zhī,ma,guān",
  "芝麻小事": "zhī,ma,xiǎo,shì",
  "芝麻油": "zhī,ma,yóu",
  "芝麻绿豆": "zhī,ma,lǜ,dòu",
  "芝麻酱": "zhī,ma,jiàng",
  "芝麻饼": "zhī,ma,bǐng",
  "芟削": "shān,xuē",
  "芟柞": "shān,zhà",
  "芣苡": "fǒu,yǐ",
  "芥兰": "gài,lán",
  "芥茉": "jiè,mo",
  "芥蓝": "gài,lán",
  "芥蓝菜": "gài,lán,cài",
  "芦莩": "lú,piǎo",
  "芦萉": "lú,féi",
  "芫荽": "yán,suī",
  "芫荽叶": "yán,sui,yè",
  "芬茀": "fēn,bó",
  "芯子": "xìn,zǐ",
  "花不棱登": "huā,bù,lēng,dēng",
  "花冠": "huā,guān",
  "花冠皱盔犀鸟": "huā,guān,zhòu,kuī,xī,niǎo",
  "花呢": "huā,ní",
  "花哄": "huā,hǒng",
  "花哨": "huā,shao",
  "花头": "huā,tou",
  "花奶奶": "huā,nǎi,nai",
  "花子": "huā,zi",
  "花岗岩": "huā,gāng,yán",
  "花心大萝卜": "huā,xīn,dà,luó,bo",
  "花攒锦簇": "huā,cuán,jǐn,cù",
  "花攒锦聚": "huā,cuán,jǐn,jù",
  "花旗参": "huā,qí,shēn",
  "花旗银行": "huā,qí,yín,háng",
  "花朝": "huā,zhāo",
  "花朝月夕": "huā,zhāo,yuè,xī",
  "花朝月夜": "huā,zhāo,yuè,yè",
  "花朝节": "huā,zhāo,jié",
  "花架子": "huā,jià,zi",
  "花样子": "huā,yàng,zi",
  "花池子": "huā,chí,zi",
  "花点子": "huā,diǎn,zi",
  "花生仁儿": "huā,shēng,rén,er",
  "花生浆": "huā,shēng,jiàng",
  "花生豆儿": "huā,shēng,dòu,er",
  "花甲子": "huā,jiá,zǐ",
  "花着": "huā,zhāo",
  "花着儿": "huā,zhe,ér",
  "花簇锦攒": "huā,cù,jǐn,cuán",
  "花籽儿": "huā,zǐ,er",
  "花翘": "huā,qiào",
  "花胡同": "huā,hú,tòng",
  "花腔音地": "huā,qiāng,yīn,de",
  "花臊": "huā,sào",
  "花花搭搭": "huā,hua,dā,dā",
  "花花肠子": "huā,huā,cháng,zi",
  "花调": "huā,diào",
  "花边儿": "huā,biān,er",
  "花都": "huā,dū",
  "花都区": "huā,dū,qū",
  "花里胡哨": "huā,li,hú,shào",
  "花露": "huā,lù",
  "花露水": "huā,lù,shuǐ",
  "花霾脖子": "huā,mái,bó,zi",
  "花骨头": "huā,gū,tou",
  "花骨朵": "huā,gū,duǒ",
  "芳香地": "fāng,xiāng,de",
  "芳香疗法": "fāng,xiāng,liǎo,fǎ",
  "芹舍": "qín,shè",
  "芼羹": "mào,gēng",
  "芽子": "yá,zi",
  "苇笮": "wěi,zé",
  "苍劲": "cāng,jìng",
  "苍术": "cāng,zhú",
  "苍白地": "cāng,bái,de",
  "苍祇": "cāng,qí",
  "苍背山雀": "cāng,bèi,shān,què",
  "苍蝇": "cāng,ying",
  "苍蝇不叮无缝蛋": "cāng,ying,bù,dīng,wú,fèng,dàn",
  "苍蝇座": "cāng,ying,zuò",
  "苍蝇拍": "cāng,ying,pāi",
  "苍蝇老虎": "cāng,ying,lǎo,hǔ",
  "苍颜白发": "cāng,yán,bái,fà",
  "苍鹘": "cāng,hú",
  "苏公堤": "sū,gōng,dī",
  "苏兴": "sū,xīng",
  "苏堤": "sū,dī",
  "苏打": "sū,dá",
  "苏打水": "sū,dá,shuǐ",
  "苏打粉": "sū,dá,fěn",
  "苏打饼干": "sū,dá,bǐng,gān",
  "苏隄": "sū,dī",
  "苗子": "miáo,zi",
  "苗条地": "miáo,tiáo,de",
  "苛刻地": "kē,kè,de",
  "苛削": "kē,xuē",
  "苛求地": "kē,qiú,de",
  "苛禁": "kē,jìn",
  "苟得": "gǒu,de",
  "苣卖菜": "qǔ,mài,cài",
  "苣荬菜": "qǔ,mǎi,cài",
  "若为": "ruò,wéi",
  "若夫": "ruò,fú",
  "若有所思地": "ruò,yǒu,suǒ,sī,de",
  "若耶": "ruò,yē",
  "若耶溪": "ruò,yē,xī",
  "苦不唧": "kǔ,bu,jī",
  "苦不唧儿": "kǔ,bu,jī,er",
  "苦厌厌": "kǔ,yān,yān",
  "苦参": "kǔ,shēn",
  "苦处": "kǔ,chǔ",
  "苦差": "kǔ,chāi",
  "苦差事": "kǔ,chāi,shì",
  "苦干": "kǔ,gàn",
  "苦役般地": "kǔ,yì,bān,de",
  "苦恼地": "kǔ,nǎo,de",
  "苦日子": "kǔ,rì,zi",
  "苦活儿": "kǔ,huó,er",
  "苦涩地": "kǔ,sè,de",
  "苦熬": "kǔ,áo",
  "苦痛地": "kǔ,tòng,de",
  "苦累": "kǔ,lèi",
  "苦苦地": "kǔ,kǔ,de",
  "苦苦地哀求": "kǔ,kǔ,de,āi,qiú",
  "苦苦地干": "kǔ,kǔ,de,gàn",
  "苦苦地挣扎": "kǔ,kǔ,de,zhēng,zhá",
  "苦苦地等待着": "kǔ,kǔ,de,děng,dài,zhe",
  "苦蘵": "kǔ,zhí",
  "苦行地": "kǔ,xíng,de",
  "苦行头陀": "kǔ,xíng,tou,tuó",
  "苦调": "kǔ,diào",
  "苦闷地": "kǔ,mèn,de",
  "苦难": "kǔ,nàn",
  "苦难深重": "kǔ,nàn,shēn,zhòng",
  "苧烯": "níng,xī",
  "苫布": "shàn,bù",
  "苫席": "shàn,xí",
  "苫盖": "shàn,gài",
  "英俊地": "yīng,jùn,de",
  "英勇地": "yīng,yǒng,de",
  "英嶷": "yīng,nì",
  "英干": "yīng,gàn",
  "英格兰银行": "yīng,gé,lán,yín,háng",
  "英濩": "yīng,hù",
  "英翘": "yīng,qiào",
  "英语教学": "yīng,yǔ,jiāo,xué",
  "英雄地": "yīng,xióng,de",
  "苲草": "zhǎ,cǎo",
  "苴茅焘土": "jū,máo,tāo,tǔ",
  "苹果篮子静物画": "píng,guǒ,lán,zi,jìng,wù,huà",
  "茀矢": "bó,shǐ",
  "茀禄": "bó,lù",
  "茀茀": "bó,bó",
  "茀郁": "bó,yù",
  "茁壮地": "zhuó,zhuàng,de",
  "茁壮成长": "zhuó,zhuàng,chéng,zhǎng",
  "茁轧": "zhuó,zhá",
  "茁长": "zhuó,zhǎng",
  "茂盛地": "mào,shèng,de",
  "茂着": "mào,zhe",
  "范数": "fàn,shù",
  "茄克": "jiā,kè",
  "茄克衫": "jiā,kè,shān",
  "茄子": "qié,zi",
  "茄子河区": "qié,zi,hé,qū",
  "茄房": "jiā,fáng",
  "茄袋": "jiā,dài",
  "茅厕": "máo,si",
  "茅塞": "máo,sè",
  "茅塞顿开": "máo,sè,dùn,kāi",
  "茅舍": "máo,shè",
  "茅茨土阶": "máo,cì,tǔ,jiē",
  "茅靡": "máo,mǐ",
  "茇舍": "bá,shè",
  "茉莉花": "mò,li,huā",
  "茉莉花茶": "mò,li,huā,chá",
  "茎干": "jīng,gàn",
  "茎杆": "jīng,gǎn",
  "茓子": "xué,zi",
  "茖葱": "gé,cōng",
  "茗铛": "míng,chēng",
  "茜茜公主": "xī,xī,gōng,zhǔ",
  "茜草": "xī,cǎo",
  "茝若": "zhǐ,ruò",
  "茝药": "zhǐ,yào",
  "茧子": "jiǎn,zi",
  "茨菰": "cí,gu",
  "茫然地": "máng,rán,de",
  "茫然地看": "máng,rán,de,kàn",
  "茫茫然地": "máng,máng,rán,de",
  "茬子": "chá,zi",
  "茶几": "chá,jī",
  "茶叶末儿": "chá,yè,mò,er",
  "茶禁": "chá,jìn",
  "茶缸子": "chá,gāng,zi",
  "茶藨子": "chá,biāo,zi",
  "茶铛": "chá,chēng",
  "茶铺": "chá,pù",
  "茶馆儿": "chá,guǎn,er",
  "茹毛饮血": "rú,máo,yǐn,xuè",
  "荆冠": "jīng,guān",
  "荆朴": "jīng,piáo",
  "荆棘塞途": "jīng,jí,sè,tú",
  "草台班子": "cǎo,tái,bān,zi",
  "草垫子": "cǎo,diàn,zi",
  "草头露": "cǎo,tóu,lù",
  "草字头儿": "cǎo,zì,tóu,er",
  "草帖": "cǎo,tiē",
  "草底儿": "cǎo,dǐ,er",
  "草爬子": "cǎo,pá,zi",
  "草率": "cǎo,shuài",
  "草率从事": "cǎo,shuài,cóng,shì",
  "草率地": "cǎo,shuài,de",
  "草率地做": "cǎo,shuài,de,zuò",
  "草率收兵": "cǎo,shuài,shōu,bīng",
  "草盘地": "cǎo,pán,de",
  "草耙": "cǎo,pá",
  "草舍": "cǎo,shè",
  "草草了事": "cǎo,cǎo,liǎo,shì",
  "草行露宿": "cǎo,xíng,lù,sù",
  "草长莺飞": "cǎo,zhǎng,yīng,fēi",
  "草露": "cǎo,lù",
  "荎蕏": "chí,chú",
  "荐卷": "jiàn,juàn",
  "荐头": "jiàn,tou",
  "荐头店": "jiàn,tou,diàn",
  "荐数": "jiàn,shù",
  "荐更": "jiàn,gēng",
  "荒伧": "huāng,chen",
  "荒凉地": "huāng,liáng,de",
  "荒唐地": "huāng,táng,de",
  "荒数": "huāng,shù",
  "荒淫地": "huāng,yín,de",
  "荒缪": "huāng,miù",
  "荒茀": "huāng,bó",
  "荒诞地": "huāng,dàn,de",
  "荒谬地": "huāng,miù,de",
  "荜露蓝蒌": "bì,lù,lán,lóu",
  "荞面饸饹": "qiáo,miàn,hé,le",
  "荠苧": "jì,níng",
  "荠苨": "qí,nǐ",
  "荡兀": "dàng,wū",
  "荡折": "dàng,shé",
  "荡潏": "dàng,jué",
  "荡骀": "dàng,dài",
  "荣冠": "róng,guān",
  "荣干": "róng,gàn",
  "荣弹": "róng,dàn",
  "荣楯": "róng,dùn",
  "荣𰮇": "róng,wǔ",
  "荣适": "róng,shì",
  "荣露": "róng,lù",
  "荤笑话": "hūn,xiào,hua",
  "荤粥": "xūn,zhōu",
  "荤臊": "hūn,sào",
  "荤血": "hūn,xuè",
  "荥播": "yíng,bō",
  "荥水": "yíng,shuǐ",
  "荥泽": "yíng,zé",
  "荥𰝅": "yíng,yíng",
  "荥灌": "yíng,guàn",
  "荥经": "yíng,jīng",
  "荥经县": "yíng,jīng,xiàn",
  "荨麻": "xún,má",
  "荨麻疹": "xún,má,zhěn",
  "荫凉": "yìn,liáng",
  "荫子": "yìn,zǐ",
  "荫子封妻": "yìn,zǐ,fēng,qī",
  "荫干": "yīn,gàn",
  "荫庇": "yìn,bì",
  "荫监": "yìn,jiān",
  "荫监生": "yīn,jiàn,shēng",
  "荫蔽地": "yīn,bì,de",
  "荫调": "yīn,diào",
  "药劲儿": "yào,jìn,er",
  "药帖": "yào,tiē",
  "药捻子": "yào,niǎn,zi",
  "药方儿": "yào,fāng,er",
  "药水儿": "yào,shuǐ,er",
  "药渣": "yào,zhà",
  "药物毒性反应": "yào,wù,dú,xìng,fǎn,yìng",
  "药罐子": "yào,guàn,zi",
  "药铺": "yào,pù",
  "荴露": "fū,lù",
  "荷得": "hé,de",
  "荷枪实弹": "hè,qiāng,shí,dàn",
  "荷筩": "hé,yǒng",
  "荷累": "hé,lèi",
  "荷负": "hè,fù",
  "荷载": "hè,zǎi",
  "荷重": "hè,zhòng",
  "荷锄": "hè,chú",
  "荸荠": "bí,qí",
  "荼荠": "tú,qí",
  "莎丽": "shā,lì",
  "莎塔八": "shā,tǎ,bā",
  "莎士比亚": "shā,shì,bǐ,yà",
  "莎帷": "shā,wéi",
  "莎拉": "shā,lā",
  "莎拉波娃": "shā,lā,bō,wá",
  "莎搭八": "shā,dā,bā",
  "莎笠": "shā,lì",
  "莎笼": "shā,lóng",
  "莎翁": "shā,wēng",
  "莎莎舞": "shā,shā,wǔ",
  "莎菲女士的日记": "shā,fēi,nǚ,shì,de,rì,jì",
  "莎虫": "shā,chóng",
  "莎衣": "shā,yī",
  "莎车": "shā,chē",
  "莎车县": "shā,chē,xiàn",
  "莎随": "shā,suí",
  "莎鸡": "shā,jī",
  "莗葥": "chē,jiàn",
  "莘庄": "xīn,zhuāng",
  "莘庄镇": "xīn,zhuāng,zhèn",
  "莘莘将将": "shēn,shēn,qiāng,qiāng",
  "莞尔一笑": "wǎn,ěr,yí,xiào",
  "莞蒻": "guān,ruò",
  "莤茅": "yóu,máo",
  "莤酒": "yóu,jiǔ",
  "莨绸": "liáng,chóu",
  "莩末": "piǎo,mò",
  "莩甲": "piǎo,jiá",
  "莫不是": "mò,bú,shì",
  "莫为已甚": "mò,wéi,yǐ,shèn",
  "莫伊谢耶夫": "mò,yī,xiè,yē,fū",
  "莫侯": "mò,hòu",
  "莫名其妙地": "mò,míng,qí,miào,de",
  "莫名地": "mò,míng,de",
  "莫得": "mò,de",
  "莫扎特": "mò,zhā,tè",
  "莫折": "mò,shé",
  "莫此为甚": "mò,cǐ,wéi,shèn",
  "莫知所为": "mò,zhī,suǒ,wéi",
  "莫管他家瓦上霜": "mò,guǎn,tā,jiā,wǎ,shàng,shāng",
  "莫耶": "mò,yē",
  "莫若勿为": "mò,ruò,wù,wéi",
  "莫邪": "mò,yé",
  "莱切": "lái,qiè",
  "莱齐耶三世": "lái,qí,yē,sān,shì",
  "莲花落": "lián,huā,lào",
  "莲都": "lián,dū",
  "莲都区": "lián,dū,qū",
  "莳罗": "shí,luó",
  "莳萝": "shí,luó",
  "莳萝籽": "shí,luó,zǐ",
  "获准地": "huò,zhǔn,de",
  "获利地": "huò,lì,de",
  "获陇望蜀": "huò,lǒng,wāng,shǔ",
  "莺吭": "yīng,kēng",
  "莺背色": "yīng,bèi,sè",
  "莺飞草长": "yīng,fēi,cǎo,zhǎng",
  "莽大夫": "mǎng,dài,fū",
  "莽撞地": "mǎng,zhuàng,de",
  "菀枯": "yù,kū",
  "菀枯盈虚": "yù,kū,yíng,xū",
  "菀枯隆杀": "yù,kū,lóng,shā",
  "菀柳": "yù,liǔ",
  "菀结": "yù,jié",
  "菈擸": "lā,là",
  "菌伞": "jùn,sǎn",
  "菌子": "jùn,zi",
  "菌柄": "jùn,bǐng",
  "菌盖": "jùn,gài",
  "菌褶": "jùn,zhě",
  "菜包子": "cài,bāo,zi",
  "菜团子": "cài,tuán,zi",
  "菜墩子": "cài,dūn,zi",
  "菜帮子": "cài,bāng,zi",
  "菜殽": "cài,yáo",
  "菜篮子": "cài,lán,zi",
  "菜篮子工程": "cài,lán,zi,gōng,chéng",
  "菜脯": "cài,pú",
  "菟肩": "tú,jiān",
  "菟苑": "tú,yuàn",
  "菟葵": "tú,kuí",
  "菥蓂": "xī,mì",
  "菱角": "líng,jiao",
  "菲什": "fēi,shí",
  "菲仪": "fěi,yí",
  "菲姬": "fěi,jī",
  "菲才": "fěi,cái",
  "菲材": "fěi,cái",
  "菲礼": "fěi,lǐ",
  "菲薄": "fěi,bó",
  "菲食": "fěi,shí",
  "菲食薄衣": "fěi,shí,bó,yī",
  "菵露": "wǎng,lù",
  "菸斗": "yān,dǒu",
  "萍飘蓬转": "píng,piāo,péng,zhuàn",
  "萎折": "wěi,shé",
  "萎𦬼": "wěi,ěr",
  "萎靡": "wěi,mǐ",
  "萎靡不振": "wěi,mǐ,bù,zhèn",
  "萎靡地": "wěi,mǐ,de",
  "萝卜": "luó,bo",
  "萝卜快了不洗泥": "luó,bo,kuài,le,bù,xǐ,ní",
  "萝卜糕": "luó,bo,gāo",
  "萝卜花": "luó,bo,huā",
  "营业时候": "yíng,yè,shí,hou",
  "营为": "yíng,wéi",
  "营堡": "yíng,pù",
  "营处": "yíng,chǔ",
  "营干": "yíng,gàn",
  "营栅": "yíng,shān",
  "营舍": "yíng,shè",
  "营运长": "yíng,yùn,zhǎng",
  "营酂": "yíng,zàn",
  "营长": "yíng,zhǎng",
  "萦带为垣": "yíng,dài,wéi,yuán",
  "萦折": "yíng,shé",
  "萦累": "yíng,lèi",
  "萦𰺷": "yíng,rǎo",
  "萧折鱼": "xiāo,shé,yú",
  "萧摵": "xiāo,shè",
  "萧条地": "xiāo,tiáo,de",
  "萧煞": "xiāo,shà",
  "萨卡什维利": "sà,kǎ,shí,wéi,lì",
  "萨哈罗夫": "sà,hǎ,luó,fū",
  "萨哈罗夫人权奖": "sà,hǎ,luó,fū,rén,quán,jiǎng",
  "萨哈罗夫奖": "sà,hǎ,luó,fū,jiǎng",
  "萨哈诺夫": "sà,hǎ,nuò,fū",
  "萨哈诺夫人权奖": "sà,hǎ,nuò,fū,rén,quán,jiǎng",
  "萨摩耶犬": "sà,mó,yē,quǎn",
  "萷椮": "xiāo,sēn",
  "萷蔘": "xiāo,shēn",
  "萹豆": "biǎn,dòu",
  "落下": "là,xià",
  "落不是": "luò,bú,shì",
  "落了": "là,le",
  "落价": "lào,jià",
  "落便宜": "luò,pián,yí",
  "落儿": "lào,ér",
  "落卷": "luò,juàn",
  "落发": "luò,fà",
  "落可的": "luò,kě,dì",
  "落后地": "luò,hòu,de",
  "落埋怨": "lào,mán,yuàn",
  "落头": "lào,tou",
  "落头鲜": "lào,tou,xiān",
  "落子": "lào,zǐ",
  "落子馆": "lào,zǐ,guǎn",
  "落得": "luò,de",
  "落枕": "lào,zhěn",
  "落架": "lào,jià",
  "落栈": "lào,zhàn",
  "落汗": "lào,hàn",
  "落泪地": "luò,lèi,de",
  "落炕": "lào,kàng",
  "落着": "luò,zhe",
  "落腮胡子": "luò,sāi,hú,zi",
  "落色": "lào,shǎi",
  "落草为寇": "luò,cǎo,wéi,kòu",
  "落难": "luò,nàn",
  "葇荑花序": "róu,tí,huā,xù",
  "著令": "zhuó,lìng",
  "著名地": "zhù,míng,de",
  "著雍": "zhe,yōng",
  "葛仙米": "gě,xiān,mǐ",
  "葛优": "gě,yōu",
  "葛优躺": "gě,yōu,tǎng",
  "葛兰素史克": "gě,lán,sù,shǐ,kè",
  "葛天": "gě,tiān",
  "葛天氏": "gě,tiān,shì",
  "葛子": "gě,zǐ",
  "葛屦履霜": "gě,jù,lǚ,shuāng",
  "葛带": "gě,dài",
  "葛摩": "gě,mó",
  "葛沟": "gě,gōu",
  "葛法翁": "gě,fǎ,wēng",
  "葛洪": "gě,hóng",
  "葛瑞格尔": "gě,ruì,gé,ěr",
  "葛缕": "gě,lǚ",
  "葛缕子": "gě,lǚ,zi",
  "葛茀": "gě,bó",
  "葛莱美奖": "gě,lái,měi,jiǎng",
  "葛藟": "gě,lěi",
  "葛越": "gě,yuè",
  "葛逻禄": "gě,luó,lù",
  "葛麻": "gě,má",
  "葡萄": "pú,tao",
  "葡萄干儿": "pú,tao,gān,er",
  "葡萄弹": "pú,tao,dàn",
  "葡萄球菌": "pú,tao,qiú,jūn",
  "葡萄糖": "pú,tao,táng",
  "葡萄糖胺": "pú,tao,táng,àn",
  "葡萄紫": "pú,tao,zǐ",
  "葡萄藤": "pú,tao,téng",
  "葡萄酒": "pú,tao,jiǔ",
  "董事长": "dǒng,shì,zhǎng",
  "葩髿": "pā,suō",
  "葫芦依样": "hú,lu,yī,yàng",
  "葫芦里卖的是什么药": "hú,lu,lǐ,mài,de,shì,shén,me,yào",
  "葫萝卜": "hú,luó,bo",
  "葬薶": "zàng,wō",
  "葰楙": "jùn,mào",
  "葱白儿": "cōng,bái,er",
  "葵涌": "kuí,chōng",
  "蒂固地": "de,gù,de",
  "蒙事": "mēng,shì",
  "蒙古": "měng,gǔ",
  "蒙古人": "měng,gǔ,rén",
  "蒙古人民共和国": "měng,gǔ,rén,mín,gòng,hé,guó",
  "蒙古人种": "měng,gǔ,rén,zhǒng",
  "蒙古包": "měng,gǔ,bāo",
  "蒙古国": "měng,gǔ,guó",
  "蒙古大夫": "měng,gǔ,dài,fū",
  "蒙古文": "měng,gǔ,wén",
  "蒙古族": "měng,gǔ,zú",
  "蒙古沙鸻": "měng,gǔ,shā,héng",
  "蒙古语": "měng,gǔ,yǔ",
  "蒙哄": "méng,hǒng",
  "蒙嘉慧": "měng,jiā,huì",
  "蒙圈": "mēng,quān",
  "蒙头转向": "mēng,tóu,zhuàn,xiàng",
  "蒙娜丽莎": "méng,nà,lì,shā",
  "蒙帕纳斯": "měng,pà,nà,sī",
  "蒙得维的亚": "méng,de,wéi,de,yà",
  "蒙文": "měng,wén",
  "蒙松雨": "mēng,sōng,yǔ",
  "蒙牛": "měng,niú",
  "蒙着": "mēng,zháo",
  "蒙着锅儿": "mēng,zhe,guō,er",
  "蒙蒙亮": "méng,mēng,liàng",
  "蒙蒙黑": "mēng,mēng,hēi",
  "蒙难": "méng,nàn",
  "蒜瓣儿": "suàn,bàn,er",
  "蒲帆": "pú,fān",
  "蒲𫓴": "pú,móu",
  "蒸气重整": "zhēng,qì,chóng,zhěng",
  "蒸沙为饭": "zhēng,shā,wéi,fàn",
  "蒸馏": "zhēng,liú",
  "蒸馏器": "zhēng,liú,qì",
  "蒸馏水": "zhēng,liú,shuǐ",
  "蒸馏酒": "zhēng,liú,jiǔ",
  "蒿子": "hāo,zi",
  "蓂历": "mì,lì",
  "蓂灵": "mì,líng",
  "蓂菁": "mì,jīng",
  "蓄意地": "xù,yì,de",
  "蓄菟": "xù,tú",
  "蓄谋": "xù,mòu",
  "蓇朵儿": "gū,duǒ,er",
  "蓍占": "shī,zhān",
  "蓝田种玉": "lán,tián,zhòng,yù",
  "蓝背八色鸫": "lán,bèi,bā,sè,dōng",
  "蓝调": "lán,diào",
  "蓬头散发": "péng,tóu,sàn,fà",
  "蓬散": "péng,sǎn",
  "蓬累": "péng,lèi",
  "蓬藋": "péng,dí",
  "蓬转": "péng,zhuàn",
  "蓬阆": "péng,láng",
  "蔑视地": "miè,shì,de",
  "蔓儿": "màn,er",
  "蔓延地": "màn,yán,de",
  "蔓生地": "màn,shēng,de",
  "蔓菁": "mán,jing",
  "蔗露": "zhè,lù",
  "蔚为": "wèi,wéi",
  "蔚为壮观": "wèi,wéi,zhuàng,guān",
  "蔚为大观": "wèi,wéi,dà,guān",
  "蔚县": "yù,xiàn",
  "蔫儿": "niān,er",
  "蔽明塞聪": "bì,míng,sè,cōng",
  "蔽聪塞明": "bì,cōng,sè,míng",
  "蕃庑": "fán,wú",
  "蕃王": "fān,wáng",
  "蕃茄": "fān,qié",
  "蕉萃": "qiáo,cuì",
  "蕙折兰摧": "huì,shé,lán,cuī",
  "蕞尔弹丸": "zuì,ěr,dàn,wán",
  "蕾哈娜": "lěi,hā,nà",
  "薄一波": "bó,yī,bō",
  "薄产": "bó,chǎn",
  "薄伽丘": "bó,jiā,qiū",
  "薄养厚葬": "bó,yǎng,hòu,zàng",
  "薄利": "bó,lì",
  "薄利多销": "bó,lì,duō,xiāo",
  "薄厚": "bó,hòu",
  "薄命": "bó,mìng",
  "薄命佳人": "bó,mìng,jiā,rén",
  "薄地": "bó,dì",
  "薄寒中人": "bó,hán,zhòng,rén",
  "薄幸": "bó,xìng",
  "薄弱": "bó,ruò",
  "薄弱环节": "bó,ruò,huán,jié",
  "薄待": "bó,dài",
  "薄情": "bó,qíng",
  "薄情地": "bó,qíng,de",
  "薄技": "bó,jì",
  "薄技在身": "bó,jì,zài,shēn",
  "薄明": "bó,míng",
  "薄晓": "bó,xiǎo",
  "薄暗": "bó,àn",
  "薄暮": "bó,mù",
  "薄暮冥冥": "bó,mù,míng,míng",
  "薄油层": "bó,yóu,céng",
  "薄海": "bó,hǎi",
  "薄烤饼": "bó,kǎo,bǐng",
  "薄熙来": "bó,xī,lái",
  "薄片地": "báo,piàn,de",
  "薄物细故": "bó,wù,xì,gù",
  "薄瑞光": "bó,ruì,guāng",
  "薄田": "bó,tián",
  "薄皮地": "báo,pí,de",
  "薄砂地": "báo,shā,de",
  "薄礼": "bó,lǐ",
  "薄胎瓷器": "bó,tāi,cí,qì",
  "薄膜地": "báo,mó,de",
  "薄荷": "bò,hé",
  "薄荷油": "bò,he,yóu",
  "薄荷糖": "bò,he,táng",
  "薄荷脑": "bò,hé,nǎo",
  "薄荷酮": "bò,he,tóng",
  "薄酒": "bó,jiǔ",
  "薄酬": "bó,chóu",
  "薄雾": "bó,wù",
  "薯莨": "shǔ,liáng",
  "薯莨绸": "shǔ,liáng,chóu",
  "借着": "jiè,zhe",
  "藏人": "zàng,rén",
  "藏传佛教": "zàng,chuán,fó,jiào",
  "藏历": "zàng,lì",
  "藏头露尾": "cáng,tóu,lù,wěi",
  "藏府": "zàng,fǔ",
  "藏戏": "zàng,xì",
  "藏掖躲闪": "cáng,yē,duǒ,shǎn",
  "藏文": "zàng,wén",
  "藏族": "zàng,zú",
  "藏族人": "zàng,zú,rén",
  "藏独": "zàng,dú",
  "藏獒": "zàng,áo",
  "藏红花": "zàng,hóng,huā",
  "藏经洞": "zàng,jīng,dòng",
  "藏羚": "zàng,líng",
  "藏羚羊": "zàng,líng,yáng",
  "藏茴香果": "zàng,huí,xiāng,guǒ",
  "藏药": "zàng,yào",
  "藏蓝": "zàng,lán",
  "藏藏掖掖": "cáng,cáng,yē,yē",
  "藏语": "zàng,yǔ",
  "藏象": "zàng,xiàng",
  "藏踪蹑迹": "cáng,zōng,niè,jī",
  "藏雀": "zàng,què",
  "藏雪雀": "zàng,xuě,què",
  "藏雪鸡": "zàng,xuě,jī",
  "藏青": "zàng,qīng",
  "藏青果": "zàng,qīng,guǒ",
  "藏青色": "zàng,qīng,sè",
  "藏马鸡": "zàng,mǎ,jī",
  "藏鹀": "zàng,wú",
  "藏黄雀": "zàng,huáng,què",
  "藐视一切": "miǎo,shì,yī,qiè",
  "藐视地": "miǎo,shì,de",
  "藒车": "qiè,chē",
  "藠头": "jiào,tou",
  "藤子": "téng,zi",
  "藤蔓": "téng,wàn",
  "蘑菇": "mó,gu",
  "蘑菇汤": "mó,gu,tāng",
  "虎不拉": "hù,bu,lǎ",
  "虎仆": "hǔ,pú",
  "虎侯": "hǔ,hòu",
  "虎冠": "hǔ,guān",
  "虎咽地吃": "hǔ,yàn,de,chī",
  "虎咽狼飡": "hǔ,yān,láng,cān",
  "虎咽狼餐": "hǔ,yān,láng,cān",
  "虎地坳道": "hǔ,de,ào,dào",
  "虎奔": "hǔ,bèn",
  "虎将": "hǔ,jiàng",
  "虎形地": "hǔ,xíng,de",
  "虎掷龙挐": "hǔ,zhì,lóng,ná",
  "虎爪派": "hǔ,zhuǎ,pài",
  "虎生三子": "hǔ,shēng,sān,zì",
  "虎着脸": "hǔ,zhe,liǎn",
  "虎穴得子": "hǔ,xué,de,zǐ",
  "虎背熊腰": "hǔ,bèi,xióng,yāo",
  "虎视眈眈地": "hǔ,shì,dān,dān,de",
  "虎𬤀": "hǔ,háo",
  "虎贲": "hǔ,bēn",
  "虎跑": "hǔ,páo",
  "虎跑泉": "hǔ,páo,quán",
  "虏掠": "lǔ,lüě",
  "虐待地": "nüè,dài,de",
  "虔敬地": "qián,jìng,de",
  "虔诚地": "qián,chéng,de",
  "虔诚地说": "qián,chéng,de,shuō",
  "虚与委蛇": "xū,yǔ,wēi,yí",
  "虚伪地": "xū,wěi,de",
  "虚假地": "xū,jiǎ,de",
  "虚华地": "xū,huá,de",
  "虚卷": "xū,juàn",
  "虚哄": "xū,hǒng",
  "虚喝": "xū,hè",
  "虚夸地": "xū,kuā,de",
  "虚幻地": "xū,huàn,de",
  "虚应了事": "xū,yìng,liǎo,shì",
  "虚应故事": "xū,yìng,gù,shì",
  "虚弱地": "xū,ruò,de",
  "虚心好学": "xū,xīn,hào,xué",
  "虚数": "xū,shù",
  "虚无地": "xū,wú,de",
  "虚无恬惔": "xū,wú,tián,dàn",
  "虚无缥缈": "xū,wú,piāo,miǎo",
  "虚晃一枪": "xū,huàng,yī,qiāng",
  "虚构地": "xū,gòu,de",
  "虚构无端": "xu,gou,wu,duan",
  "虚槛": "xū,kǎn",
  "虚猲": "xū,hè",
  "虚空藏菩萨": "xū,kōng,zàng,pú,sà",
  "虚缪": "xū,miù",
  "虚舍": "xū,shè",
  "虚荣地": "xū,róng,de",
  "虚𬮴": "xū,ān",
  "虚饰地": "xū,shì,de",
  "虚骄恃气": "xiù,jiāo,shì,qì",
  "虞应龙": "yú,yìng,lóng",
  "虞褚": "yú,chǔ",
  "虣露": "bào,lù",
  "虫儿": "chóng,er",
  "虫子": "chóng,zi",
  "虫子牙": "chóng,zi,yá",
  "虫虺": "chóng,huī",
  "虫鱼之学": "chóng,yù,zhī,xué",
  "虬卷": "qiú,juàn",
  "虮子": "jǐ,zi",
  "虮虱": "jī,shī",
  "虮虱臣": "jī,shī,chén",
  "虱处裈": "shī,chǔ,kūn",
  "虱处裈中": "shī,chǔ,kūn,zhōng",
  "虱子": "shī,zi",
  "虱胫虮肝": "shī,jìng,jī,gān",
  "虺床": "huī,chuáng",
  "虺易": "huī,yì",
  "虺毒": "huī,dú",
  "虺民": "huī,mín",
  "虺皮": "huī,pí",
  "虺蛇": "huī,shé",
  "虺蜓": "huī,tíng",
  "虺蜴": "huǐ,xí",
  "虺螣": "huī,tè",
  "虺螫": "huī,shì",
  "虺豺": "huī,chái",
  "虺蹊": "huī,qī",
  "虺𬯎": "huī,tuí",
  "虺𮧵": "huī,wěi",
  "虺颓": "huī,tuí",
  "虼蚤": "gè,zao",
  "虽有搞暴": "shui,you,gao,pu",
  "虾什蚂": "xiā,shí,mǎ",
  "虾兵蟹将": "xiā,bīng,xiè,jiàng",
  "虾子": "xiā,zi",
  "虾弓子": "xiā,gōng,zi",
  "虾爬子": "xiā,pá,zi",
  "虾蚾": "xiā,bǒ",
  "虾蟆": "há,má",
  "虾蟆台": "há,má,tái",
  "虾蟆头幡": "há,má,tóu,fān",
  "虾蟆子": "há,má,zǐ",
  "虾蟆护": "há,má,hù",
  "虾蟆抱桂": "há,má,bào,guì",
  "虾蟆更": "há,má,gēng",
  "虾蟆柝": "há,má,tuò",
  "虾蟆泉": "há,má,quán",
  "虾蟆烟": "há,má,yān",
  "虾蟆瘟": "há,má,wēn",
  "虾蟆禅": "há,má,chán",
  "虾蟆窑": "há,má,yáo",
  "虾蟆粘": "há,má,zhān",
  "虾蟆精": "há,má,jīng",
  "虾蟆给事": "há,má,jǐ,shì",
  "虾蟆蓝": "há,má,lán",
  "虾蟆衣": "há,má,yī",
  "虾蟆车": "há,má,chē",
  "虾蟆镜": "há,má,jìng",
  "虾蟆陵": "há,má,líng",
  "蚀剥": "shí,bāo",
  "蚁拥蜂攒": "yǐ,yōng,fēng,cuán",
  "蚁旋磨": "yǐ,xuán,mò",
  "蚁穴": "yǐ,xuè",
  "蚁穴坏堤": "yǐ,xué,huài,dī",
  "蚁穴溃堤": "yǐ,xué,kuì,dī",
  "蚁聚蜂攒": "yǐ,jù,fēng,cuán",
  "蚁聚蠭攒": "yǐ,jù,páng,zǎn",
  "蚁集蜂攒": "yǐ,jí,fēng,cuán",
  "蚂蚁啃骨头": "mǎ,yǐ,kěn,gú,tou",
  "蚂蚱": "mà,zhà",
  "蚂蚱也是肉": "mà,zha,yě,shì,ròu",
  "蚂蚱车子": "mà,zhà,chē,zi",
  "蚂螂": "mā,láng",
  "蚊子": "wén,zi",
  "蚊子再小也是肉": "wén,zi,zài,xiǎo,yě,shì,ròu",
  "蚊子木": "wén,zi,mù",
  "蚊子树": "wén,zi,shù",
  "蚊子船": "wén,zi,chuán",
  "蚊子馆": "wén,zi,guǎn",
  "蚊裯": "wén,dāo",
  "蚌埠": "bèng,bù",
  "蚌埠市": "bèng,bù,shì",
  "蚌山": "bèng,shān",
  "蚌山区": "bèng,shān,qū",
  "蚌帆": "bàng,fān",
  "蚕头马尾": "cán,tóu,mǎ,yǐ",
  "蚕禁": "cán,jìn",
  "蚕舍": "cán,shè",
  "蚕薄": "cán,bó",
  "蚖𬶛": "yuán,tuó",
  "蚡缊": "fén,wēn",
  "蚤兴夜寐": "zǎo,xīng,yè,mèi",
  "蚤揃": "zǎo,jiān",
  "蚨虶": "fú,yū",
  "蚩尤血": "chī,yóu,xuè",
  "蚩𫘤": "chī,ái",
  "蚰蜒": "yóu,yan",
  "蚰蜒堑": "yóu,dàn,qiàn",
  "蚰蜒壕": "yóu,dàn,háo",
  "蚰蜒草": "yóu,dàn,cǎo",
  "蚰蜒路": "yóu,yan,lù",
  "蚴蟉": "yòu,liào",
  "蚵仔": "é,zi",
  "蚵仔煎": "é,zǐ,jiān",
  "蚵蚾": "kē,bǒ",
  "蚶子": "hān,zi",
  "蛃属": "bǐng,shǔ",
  "蛃鱼": "bǐng,yú",
  "蛇入筩中曲性在": "shé,rù,yǒng,zhōng,qǔ,xìng,zài",
  "蛇化为龙": "shé,huà,wéi,lóng",
  "蛇藨": "shé,pāo",
  "蛇虺": "shé,huī",
  "蛇蝎为心": "shé,xiē,wéi,xīn",
  "蛇蟺": "shé,dàn",
  "蛇跌鳖": "shé,diē,biē",
  "蛇钻的窟窿蛇知道": "shé,zuàn,de,kū,lóng,shé,zhī,dào",
  "蛇钻窟洞蛇知道": "shé,zuàn,kū,dòng,shé,zhī,dào",
  "蛇钻竹洞": "shé,zuàn,zhú,dòng",
  "蛇𬶛": "shé,tuó",
  "蛊干": "gǔ,gàn",
  "蛋卷儿": "dàn,juǎn,er",
  "蛏子": "chēng,zi",
  "蛏干": "chēng,gàn",
  "蛐蛐儿": "qū,qu,er",
  "蛐蟮": "qū,shan",
  "蛐蟺哥": "qū,dàn,gē",
  "蛑蝤": "móu,yóu",
  "蛖蜄": "máng,zhèn",
  "蛙𧏖衣": "wā,bīn,yī",
  "蛙黾": "wā,miǎn",
  "蛛蛛": "zhū,zhu",
  "蛛蝥": "zhū,móu",
  "蛟镡": "jiāo,tán",
  "蛟龙得云雨": "jiāo,lóng,de,yún,yǔ",
  "蛤仔": "gé,zǎi",
  "蛤蜊": "gé,lí",
  "蛤蜊粉": "gé,lí,fěn",
  "蛤蟆": "há,má",
  "蛤蟆夯": "há,ma,hāng",
  "蛤蟆镜": "há,má,jìng",
  "蛤蟹": "há,xiè",
  "蛮为": "mán,wéi",
  "蛮夷大长": "mán,yí,dà,zhǎng",
  "蛮子": "mán,zi",
  "蛮峒": "mán,dòng",
  "蛮干": "mán,gàn",
  "蛮性子": "mán,xìng,zi",
  "蛮查": "mán,zhā",
  "蛮横": "mán,hèng",
  "蛮横地": "mán,hèng,de",
  "蛮横地喊": "mán,hèng,de,hǎn",
  "蛮横地拖": "mán,hèng,de,tuō",
  "蛮横地说": "mán,hèng,de,shuō",
  "蛮横无理": "mán,hèng,wú,lǐ",
  "蛮猓": "mán,guǒ",
  "蛮箐": "mán,jīng",
  "蛮貉": "mán,mò",
  "蛮龙舌血": "mán,lóng,shé,xuè",
  "蛰处": "zhé,chǔ",
  "蛰虺": "zhé,huī",
  "蛾子": "é,zi",
  "蛾度虵行": "é,dù,yě,xíng",
  "蛾附": "yǐ,fù",
  "蛾附蠭屯": "é,fù,páng,tún",
  "蜀中无大将": "shǔ,zhōng,wú,dà,jiàng",
  "蜀侯": "shǔ,hòu",
  "蜀相": "shǔ,xiàng",
  "蜂兴": "fēng,xīng",
  "蜂扇蚁聚": "fēng,shān,yǐ,jù",
  "蜂攒": "fēng,cuán",
  "蜂攒蚁聚": "fēng,cuán,yǐ,jù",
  "蜂攒蚁集": "fēng,cuán,yǐ,jí",
  "蜂腰削背": "fēng,yāo,xuē,bèi",
  "蜂腰猿背": "fēng,yāo,yuán,bèi",
  "蜂蜜梳子": "fēng,mì,shū,zi",
  "蜂螫": "fēng,zhē",
  "蜇花": "zhē,huā",
  "蜇螫": "zhē,shì",
  "蜇鼻": "zhē,bí",
  "蜉蝤": "fú,yóu",
  "蜊黄": "lí,huáng",
  "蜎飞": "xuān,fēi",
  "蜎飞蝡动": "xuān,fēi,ruǎn,dòng",
  "蜎飞蠕动": "xuān,fēi,rú,dòng",
  "蜎飞蠢动": "xuān,fēi,chǔn,dòng",
  "蜗杆": "wō,gǎn",
  "蜗杆副": "wō,gǎn,fù",
  "蜗牛舍": "wō,niú,shè",
  "蜗舍": "wō,shè",
  "蜗舍荆扉": "wo,she,jing,fei",
  "蜙蝑": "sōng,xū",
  "蜚廉": "fěi,lián",
  "蜚廉虫": "fěi,lián,chóng",
  "蜚翘": "fēi,qiào",
  "蜚虫": "fěi,chóng",
  "蜚蠊": "fěi,lián",
  "蜚蠊科": "fěi,lián,kē",
  "蜜月假期": "mì,yuè,jià,qī",
  "蜜筩": "mì,yǒng",
  "蜜罐儿": "mì,guàn,er",
  "蜜露": "mì,lù",
  "蜡坨儿": "là,tuó,er",
  "蜡坨子": "là,tuó,zi",
  "蜡弹": "là,dàn",
  "蜡查": "là,zhā",
  "蜡样芽孢杆菌": "là,yàng,yá,bāo,gǎn,jūn",
  "蜡祭": "zhà,jì",
  "蜩蟉": "tiáo,liào",
  "蜱蛸": "pí,shāo",
  "蜲娜": "wēi,nà",
  "蜷曲": "quán,qū",
  "蜿蜒曲折": "wān,yán,qū,zhé",
  "蜿蟺": "wān,dàn",
  "蝃蝥": "zhuō,máo",
  "蝇子": "yíng,zi",
  "蝇攒蚁聚": "yíng,cuán,yǐ,jù",
  "蝇攒蚁附": "yíng,cuán,yǐ,fù",
  "蝇黾": "yíng,miǎn",
  "蝈蝈": "guō,guo",
  "蝈蝈儿": "guō,guo,er",
  "蝉冠": "chán,guān",
  "蝉冠豸绣": "chán,guān,zhì,xiù",
  "蝉翼为重": "chán,yì,wéi,zhòng",
  "蝉露": "chán,lù",
  "蝍蛆": "jí,jū",
  "蝎子": "xiē,zi",
  "蝎蝎蜇蜇": "xiē,xiē,zhē,zhē",
  "蝎蝎螫螫": "xiē,xiē,zhē,zhē",
  "蝙蝠不自见": "biān,fú,bù,zì,xiàn",
  "蝤蚓": "yóu,yǐn",
  "蝤蛑": "yóu,móu",
  "蝤蛑炙": "yóu,móu,zhì",
  "蝤蝥": "yóu,móu",
  "蝤蠓": "yóu,měng",
  "蝤领": "yóu,lǐng",
  "蝥弧": "móu,hú",
  "蝥网": "móu,wǎng",
  "蝨处裈": "shī,chǔ,kūn",
  "蝭母": "tí,mǔ",
  "蝭蛙": "tí,wā",
  "蝭𮔚": "tí,láo",
  "蝭跂": "tí,qí",
  "蝲蛄": "là,gǔ",
  "蝴蝶效应": "hú,dié,xiào,yìng",
  "蝼螲": "lóu,zhì",
  "螌蝥": "bān,móu",
  "融为一体": "róng,wéi,yī,tǐ",
  "融合为一": "róng,hé,wéi,yī",
  "融和骀荡": "róng,hé,dài,dàng",
  "融洽地": "róng,qià,de",
  "融洽无间": "róng,qià,wú,jiàn",
  "融调": "róng,diào",
  "螟螣": "míng,tè",
  "螫中": "zhē,zhòng",
  "螭头载笔": "chī,tóu,zǎi,bǐ",
  "螲蝼": "zhì,lóu",
  "𰳂离": "jiàn,lí",
  "𰳂胡": "jiàn,hú",
  "螺丝起子": "luó,sī,qǐ,zi",
  "螺丝钻": "luó,sī,zuàn",
  "螺呗": "luó,bài",
  "螺旋曲面": "luó,xuán,qū,miàn",
  "螺杆": "luó,gǎn",
  "螺桨毂": "luó,jiǎng,gū",
  "蟆更": "má,gēng",
  "蟉屈": "liào,qū",
  "蟉糅": "liào,róu",
  "蟉结": "liào,jié",
  "蟉虬": "liào,qiú",
  "蟋蟀相公": "xī,shuài,xiàng,gōng",
  "蟏蛸": "xiāo,shāo",
  "蟏蛸满室": "xiāo,shāo,mǎn,shì",
  "蟒虺": "mǎng,huī",
  "蟠委错𬘝": "pán,wěi,cuò,tiǎn",
  "蟠挐": "pán,ná",
  "蟠曲": "pán,qū",
  "蟠虺纹": "pán,huī,wén",
  "蟠蟉": "pán,liào",
  "蟢子": "xǐ,zi",
  "𰳊蛴": "bēn,qí",
  "蟹爪兰": "xiè,zhuǎ,lán",
  "蟹獴": "xiè,měng",
  "蟹舍": "xiè,shè",
  "蟺绪": "dàn,xù",
  "蟺蜂": "dàn,fēng",
  "蟺蜎": "dàn,yuān",
  "蟺蜎蠖濩": "dàn,yuān,huò,hù",
  "蟾背": "chán,bèi",
  "蟿螽": "jì,zhōng",
  "蠉飞蝡动": "xuān,fēi,ruǎn,dòng",
  "𧏖珠": "bīn,zhū",
  "蠡勺": "lí,sháo",
  "蠡卜": "lí,bǔ",
  "蠡口": "lí,kǒu",
  "蠡器": "lí,qì",
  "蠡园": "lí,yuán",
  "蠡城": "lí,chéng",
  "蠡壳": "lí,ké",
  "蠡屏": "lí,píng",
  "蠡母": "lí,mǔ",
  "蠡测": "lí,cè",
  "蠡浦": "lí,pǔ",
  "蠡渎": "lí,dú",
  "蠡湖": "lí,hú",
  "蠡𬍙": "lí,zhǎn",
  "蠡种": "lí,zhǒng",
  "蠡结": "lí,jié",
  "蠡舫": "lí,fǎng",
  "蠡荠": "lí,qí",
  "蠡蠡": "lí,lí",
  "蠡见": "lí,jiàn",
  "蠡谷": "lí,gǔ",
  "蠢朴": "chǔn,piáo",
  "蠢蝡": "chǔn,ruǎn",
  "蠢𫘤": "chǔn,ái",
  "蠲削": "juān,xuē",
  "蠲絜": "juān,jié",
  "蠲𱄆": "juān,chì",
  "蠹啄剖梁柱": "dù,zhuó,pōu,liáng,zhù",
  "蠹居棊处": "dù,jū,qí,chǔ",
  "蠹居棋处": "dù,jū,qí,chǔ",
  "蠹折": "dù,shé",
  "蠹鱼子": "dù,yú,zi",
  "蠿蟊": "zhuō,máo",
  "血不归经": "xuè,bù,guī,jīng",
  "血丝": "xuè,sī",
  "血中毒": "xuè,zhòng,dú",
  "血书": "xuè,shū",
  "血亏": "xuè,kuī",
  "血产": "xuè,chǎn",
  "血亲": "xuè,qīn",
  "血亲复仇": "xuè,qīn,fù,chóu",
  "血仇": "xuè,chóu",
  "血余": "xuè,yú",
  "血债": "xuè,zhài",
  "血债累累": "xuè,zhài,lěi,lěi",
  "血债血偿": "xuè,zhài,xuè,cháng",
  "血债要用血来偿": "xuè,zhài,yào,yòng,xuè,lái,cháng",
  "血债要用血来还": "xuè,zhài,yào,yòng,xuè,lái,huán",
  "血光": "xuè,guāng",
  "血光之灾": "xuè,guāng,zhī,zāi",
  "血光灾": "xuè,guāng,zāi",
  "血凝": "xuè,níng",
  "血凝固": "xuè,níng,gù",
  "血凝素": "xuè,níng,sù",
  "血刃": "xuè,rèn",
  "血分": "xuè,fēn",
  "血制品": "xuè,zhì,pǐn",
  "血力": "xuè,lì",
  "血勇": "xuè,yǒng",
  "血勇之人": "xuè,yǒng,zhī,rén",
  "血华": "xuè,huá",
  "血卦": "xuè,guà",
  "血印": "xuè,yìn",
  "血压": "xuè,yā",
  "血压正常": "xuè,yā,zhèng,cháng",
  "血压计": "xuè,yā,jì",
  "血压高升": "xuè,yā,gāo,shēng",
  "血友病": "xuè,yǒu,bìng",
  "血友病患者": "xuè,yǒu,bìng,huàn,zhě",
  "血叔": "xuè,shū",
  "血口": "xuè,kǒu",
  "血口喷人": "xuè,kǒu,pēn,rén",
  "血史": "xuè,shǐ",
  "血吸虫": "xuè,xī,chóng",
  "血吸虫病": "xuè,xī,chóng,bìng",
  "血吻": "xuè,wěn",
  "血唬零喇": "xuè,hǔ,líng,lǎ",
  "血嗣": "xuè,sì",
  "血国": "xuè,guó",
  "血国三千": "xuè,guó,sān,qiān",
  "血地": "xuè,dì",
  "血场": "xuè,chǎng",
  "血坑": "xuè,kēng",
  "血块": "xuè,kuài",
  "血型": "xuè,xíng",
  "血型分类": "xuè,xíng,fēn,lèi",
  "血塞": "xuè,sè",
  "血姑": "xuè,gū",
  "血孩": "xuè,hái",
  "血小板": "xuè,xiǎo,bǎn",
  "血小板病": "xuè,xiǎo,bǎn,bìng",
  "血尸灵": "xuè,shī,líng",
  "血尿": "xuè,niào",
  "血尿素": "xuè,niào,sù",
  "血属": "xuè,shǔ",
  "血山崩": "xuè,shān,bēng",
  "血崩": "xuè,bēng",
  "血崩症": "xuè,bēng,zhèng",
  "血师": "xuè,shī",
  "血帮": "xuè,bāng",
  "血库": "xuè,kù",
  "血循环": "xuè,xún,huán",
  "血心": "xuè,xīn",
  "血忌": "xuè,jì",
  "血忱": "xuè,chén",
  "血忽淋剌": "xuè,hū,lín,là",
  "血怒": "xuè,nù",
  "血性": "xuè,xìng",
  "血性男儿": "xuè,xìng,nán,ér",
  "血恳": "xuè,kěn",
  "血战": "xuè,zhàn",
  "血战到底": "xuè,zhàn,dào,dǐ",
  "血拼": "xuè,pīn",
  "血指": "xuè,zhǐ",
  "血指汗颜": "xuè,zhǐ,hàn,yán",
  "血斑": "xuè,bān",
  "血料": "xuè,liào",
  "血族": "xuè,zú",
  "血旗": "xuè,qí",
  "血星": "xuè,xīng",
  "血晕": "xiě,yùn",
  "血晕妆": "xiě,yùn,zhuāng",
  "血本": "xuè,běn",
  "血本无归": "xuè,běn,wú,guī",
  "血枯": "xuè,kū",
  "血枯病": "xuè,kū,bìng",
  "血染": "xuè,rǎn",
  "血染沙场": "xuè,rǎn,shā,chǎng",
  "血栓": "xuè,shuān",
  "血栓形成": "xuè,shuān,xíng,chéng",
  "血栓心内膜炎": "xuè,shuān,xīn,nèi,mó,yán",
  "血栓栓塞": "xuè,shuān,shuān,sè",
  "血栓病": "xuè,shuān,bìng",
  "血栓症": "xuè,shuān,zhèng",
  "血栓脉管炎": "xuè,shuān,mài,guǎn,yán",
  "血样": "xuè,yàng",
  "血案": "xuè,àn",
  "血殷": "xuè,yīn",
  "血毛": "xuè,máo",
  "血气": "xuè,qì",
  "血气之勇": "xuè,qì,zhī,yǒng",
  "血气方刚": "xuè,qì,fāng,gāng",
  "血气方壮": "xuè,qì,fāng,zhuàng",
  "血气方盛": "xuè,qì,fāng,shèng",
  "血氧含量": "xuè,yǎng,hán,liàng",
  "血氧量": "xuè,yǎng,liàng",
  "血水": "xuè,shuǐ",
  "血汗": "xuè,hàn",
  "血汗工厂": "xuè,hàn,gōng,chǎng",
  "血汗钱": "xuè,hàn,qián",
  "血池": "xuè,chí",
  "血污": "xuè,wū",
  "血污池": "xuè,wū,chí",
  "血沉": "xuè,chén",
  "血沉实验": "xuè,chén,shí,yàn",
  "血沉淀素": "xuè,chén,diàn,sù",
  "血沉素": "xuè,chén,sù",
  "血沟": "xuè,gōu",
  "血沥沥": "xuè,lì,lì",
  "血泊": "xuè,pō",
  "血泡": "xuè,pào",
  "血泣": "xuè,qì",
  "血泥": "xuè,ní",
  "血泪": "xuè,lèi",
  "血泪史": "xuè,lèi,shǐ",
  "血泪斑斑": "xuè,lèi,bān,bān",
  "血泪盈襟": "xuè,lèi,yíng,jīn",
  "血洗": "xuè,xǐ",
  "血津": "xuè,jīn",
  "血流": "xuè,liú",
  "血流动力学": "xuè,liú,dòng,lì,xué",
  "血流如注": "xuè,liú,rú,zhù",
  "血流成河": "xuè,liú,chéng,hé",
  "血流成渠": "xuè,liú,chéng,qú",
  "血流漂卤": "xuè,liú,piāo,lǔ",
  "血流漂杵": "xuè,liú,piāo,chǔ",
  "血浆": "xuè,jiāng",
  "血浆蛋白": "xuè,jiāng,dàn,bái",
  "血浓于水": "xuè,nóng,yú,shuǐ",
  "血浪": "xuè,làng",
  "血海": "xuè,hǎi",
  "血海冤仇": "xuè,hǎi,yuān,chóu",
  "血海寃仇": "xuè,hǎi,yuān,chóu",
  "血海尸山": "xuè,hǎi,shī,shān",
  "血海深仇": "xuè,hǎi,shēn,chóu",
  "血浸": "xuè,jìn",
  "血液": "xuè,yè",
  "血液凝结": "xuè,yè,níng,jié",
  "血液增强剂": "xuè,yè,zēng,qiáng,jì",
  "血液学": "xuè,yè,xué",
  "血液循环": "xuè,yè,xún,huán",
  "血液恐怖症": "xuè,yè,kǒng,bù,zhèng",
  "血液病": "xuè,yè,bìng",
  "血液透析": "xuè,yè,tòu,xī",
  "血液透析器": "xuè,yè,tòu,xī,qì",
  "血液透析机": "xuè,yè,tòu,xi,jī",
  "血清": "xuè,qīng",
  "血清型": "xuè,qīng,xíng",
  "血清张力素": "xuè,qīng,zhāng,lì,sù",
  "血清性肝炎": "xuè,qīng,xìng,gān,yán",
  "血清病": "xuè,qīng,bìng",
  "血清白蛋白": "xuè,qīng,bái,dàn,bái",
  "血清素": "xuè,qīng,sù",
  "血渌渌": "xuè,lù,lù",
  "血渍": "xuè,zì",
  "血渍斑斑": "xuè,zì,bān,bān",
  "血湖洞": "xuè,hú,dòng",
  "血滴滴": "xuè,dī,dī",
  "血滴虫": "xuè,dī,chóng",
  "血潮": "xuè,cháo",
  "血点": "xuè,diǎn",
  "血牛": "xuè,niú",
  "血牲": "xuè,shēng",
  "血环": "xuè,huán",
  "血球": "xuè,qiú",
  "血球计数器": "xuè,qiú,jì,shù,qì",
  "血田": "xuè,tián",
  "血疏": "xuè,shū",
  "血疾": "xuè,jí",
  "血痂": "xuè,jiā",
  "血痕": "xuè,hén",
  "血痢": "xuè,lì",
  "血痨": "xuè,láo",
  "血瘕": "xuè,jiǎ",
  "血瘤": "xuè,liú",
  "血癌": "xuè,ái",
  "血盆": "xuè,pén",
  "血盆大口": "xuè,pén,dà,kǒu",
  "血盆池": "xuè,pén,chí",
  "血盆经": "xuè,pén,jīng",
  "血盟": "xuè,méng",
  "血碌碌": "xuè,lù,lù",
  "血祀": "xuè,sì",
  "血祥": "xuè,xiáng",
  "血祭": "xuè,jì",
  "血窦": "xuè,dòu",
  "血竭": "xuè,jié",
  "血竭髯枯": "xuè,jié,rán,kū",
  "血管": "xuè,guǎn",
  "血管再造": "xuè,guǎn,zài,zào",
  "血管切除术": "xuè,guǎn,qiē,chú,shù",
  "血管扩张": "xuè,guǎn,kuò,zhāng",
  "血管摄影": "xuè,guǎn,shè,yǐng",
  "血管收缩": "xuè,guǎn,shōu,suō",
  "血管梗阻": "xuè,guǎn,gěng,zǔ",
  "血管炎": "xuè,guǎn,yán",
  "血管病": "xuè,guǎn,bìng",
  "血管痉挛": "xuè,guǎn,jìng,luán",
  "血管瘤": "xuè,guǎn,liú",
  "血管破裂": "xuè,guǎn,pò,liè",
  "血管硬化": "xuè,guǎn,yìng,huà",
  "血管粥样硬化": "xuè,guǎn,zhōu,yàng,yìng,huà",
  "血管紧张": "xuè,guǎn,jǐn,zhāng",
  "血管膜": "xuè,guǎn,mó",
  "血管舒张": "xuè,guǎn,shū,zhāng",
  "血管造影": "xuè,guǎn,zào,yǐng",
  "血粉": "xuè,fěn",
  "血糊糊": "xiě,hū,hū",
  "血糖": "xuè,táng",
  "血糖低": "xuè,táng,dī",
  "血糖高": "xuè,táng,gāo",
  "血系": "xuè,xì",
  "血紫": "xuè,zǐ",
  "血红": "xuè,hóng",
  "血红素": "xuè,hóng,sù",
  "血红色": "xuè,hóng,sè",
  "血红蛋白": "xuè,hóng,dàn,bái",
  "血细胞": "xuè,xì,bāo",
  "血经": "xuè,jīng",
  "血统": "xuè,tǒng",
  "血统论": "xuè,tǒng,lùn",
  "血缕": "xuè,lǚ",
  "血缘": "xuè,yuán",
  "血缘关系": "xuè,yuán,guān,xì",
  "血羹": "xuè,gēng",
  "血肉": "xuè,ròu",
  "血肉之躯": "xuè,ròu,zhī,qū",
  "血肉模糊": "xuè,ròu,mó,hú",
  "血肉横飞": "xuè,ròu,héng,fēi",
  "血肉相联": "xuè,ròu,xiāng,lián",
  "血肉相连": "xuè,ròu,xiāng,lián",
  "血肠": "xuè,cháng",
  "血肿": "xuè,zhǒng",
  "血胄": "xuè,zhòu",
  "血胞": "xuè,bāo",
  "血胡同": "xuè,hú,tòng",
  "血胡淋剌": "xuè,hú,lín,là",
  "血胤": "xuè,yìn",
  "血胸": "xuè,xiōng",
  "血脂": "xuè,zhī",
  "血脉": "xuè,mài",
  "血脉不畅": "xuè,mài,bú,chàng",
  "血脉偾张": "xuè,mài,fèn,zhāng",
  "血脉相通": "xuè,mài,xiāng,tōng",
  "血脏": "xuè,zāng",
  "血脸": "xuè,liǎn",
  "血腥": "xuè,xīng",
  "血腥味": "xuè,xīng,wèi",
  "血腥地": "xuè,xīng,de",
  "血腥屠杀": "xuè,xīng,tú,shā",
  "血腥玛丽": "xuè,xīng,mǎ,lì",
  "血腥统治": "xuè,xīng,tǒng,zhì",
  "血腥镇压": "xuè,xīng,zhèn,yā",
  "血䒿": "xuè,liáo",
  "血膏": "xuè,gāo",
  "血色": "xuè,sè",
  "血色素": "xuè,sè,sù",
  "血色素沉积症": "xuè,sè,sù,chén,jī,zhèng",
  "血艳": "xuè,yàn",
  "血花": "xuè,huā",
  "血茹": "xuè,rú",
  "血荫": "xuè,yīn",
  "血蒜羹": "xuè,suàn,gēng",
  "血蓝素": "xuè,lán,sù",
  "血虚": "xuè,xū",
  "血蛋白": "xuè,dàn,bái",
  "血蝠": "xuè,fú",
  "血衣": "xuè,yī",
  "血衫": "xuè,shān",
  "血证": "xuè,zhèng",
  "血诚": "xuè,chéng",
  "血象": "xuè,xiàng",
  "血败气索": "xuè,bài,qì,suǒ",
  "血账": "xuè,zhàng",
  "血赀": "xuè,zī",
  "血赤": "xuè,chì",
  "血路": "xuè,lù",
  "血踪": "xuè,zōng",
  "血身": "xuè,shēn",
  "血躯": "xuè,qū",
  "血轮": "xuè,lún",
  "血迹": "xuè,jì",
  "血迹斑斑": "xuè,jì,bān,bān",
  "血道子": "xiě,dào,zi",
  "血郁": "xuè,yù",
  "血酒": "xuè,jiǔ",
  "血量": "xuè,liàng",
  "血钻": "xuè,zuàn",
  "血锅巴": "xuè,guō,bā",
  "血防": "xuè,fáng",
  "血雀": "xuě,què",
  "血雉": "xuě,zhì",
  "血雠": "xuè,chóu",
  "血雨": "xuè,yǔ",
  "血雨腥风": "xuè,yǔ,xīng,fēng",
  "血风肉雨": "xuè,fēng,ròu,yǔ",
  "血食": "xuè,shí",
  "血饼": "xuè,bǐng",
  "血马": "xuè,mǎ",
  "血髓": "xuè,suǐ",
  "衃血": "pēi,xuè",
  "衄折": "nǜ,shé",
  "衄血": "nǜ,xuè",
  "衅累": "xìn,lèi",
  "衉血": "kè,xuè",
  "行不得哥哥": "xíng,bù,dé,gē,ge",
  "行不更名": "xíng,bù,gēng,míng",
  "行不踰方": "xíng,bù,yáo,fāng",
  "行业": "háng,yè",
  "行为": "xíng,wéi",
  "行为不端": "xíng,wéi,bù,duān",
  "行为主义": "xíng,wéi,zhǔ,yì",
  "行为准则": "xíng,wéi,zhǔn,zé",
  "行为数据": "xíng,wéi,shù,jù",
  "行为能力": "xíng,wéi,néng,lì",
  "行仆": "xíng,pú",
  "行伍": "háng,wǔ",
  "行会": "háng,huì",
  "行侠好义": "xíng,xiá,hào,yì",
  "行几": "háng,jǐ",
  "行列": "háng,liè",
  "行列式": "háng,liè,shì",
  "行剽": "xíng,piāo",
  "行动计划": "xíng,dòng,jì,huà",
  "行卷": "xíng,juàn",
  "行号": "háng,háo",
  "行号卧泣": "xíng,háo,wò,qì",
  "行号巷哭": "xíng,háo,xiàng,kū",
  "行唫": "xíng,yín",
  "行商": "háng,shāng",
  "行处": "xíng,chǔ",
  "行头": "xíng,tou",
  "行子": "háng,zǐ",
  "行家": "háng,jiā",
  "行家生活": "háng,jiā,shēng,huó",
  "行家话": "háng,jiā,huà",
  "行家里手": "háng,jiā,lǐ,shǒu",
  "行市": "háng,shì",
  "行帆": "xíng,fān",
  "行帖": "xíng,tiē",
  "行帮": "háng,bāng",
  "行当": "háng,dāng",
  "行得通": "xíng,de,tōng",
  "行情": "háng,qíng",
  "行政区划": "xíng,zhèng,qū,huà",
  "行政区划图": "xíng,zhèng,qū,huà,tú",
  "行政处分": "xíng,zhèng,chǔ,fèn",
  "行政处罚": "xíng,zhèng,chǔ,fá",
  "行政长官": "xíng,zhèng,zhǎng,guān",
  "行李传送带": "xíng,li,chuán,sòng,dài",
  "行李卷": "xíng,lǐ,juàn",
  "行李卷儿": "xíng,lǐ,juǎn,er",
  "行李员": "xíng,li,yuán",
  "行李架": "xíng,li,jià",
  "行李票": "xíng,li,piào",
  "行李箱": "xíng,li,xiāng",
  "行李袋": "xíng,li,dài",
  "行款": "háng,kuǎn",
  "行潦": "xíng,liáo",
  "行絜": "xíng,jié",
  "行舍": "xíng,shè",
  "行若狐鼠": "háng,ruò,hú,shǔ",
  "行行出状元": "háng,háng,chū,zhuàng,yuán",
  "行行子": "xíng,háng,zǐ",
  "行行蛇蚓": "háng,háng,shé,yǐn",
  "行规": "háng,guī",
  "行话": "háng,huà",
  "行语": "háng,yǔ",
  "行说": "xíng,shuì",
  "行𰷞": "xíng,tè",
  "行货": "háng,huò",
  "行货子": "háng,huò,zǐ",
  "行贾": "xíng,gǔ",
  "行距": "háng,jù",
  "行路子": "xíng,lù,zi",
  "行辈": "háng,bèi",
  "行道": "háng,dào",
  "行道树": "háng,dào,shù",
  "行都": "xíng,dū",
  "行铺": "xíng,pù",
  "行长": "háng,zhǎng",
  "行间": "háng,jiān",
  "行间字里": "háng,jiān,zì,lǐ",
  "行阵": "háng,zhèn",
  "行露": "xíng,lù",
  "行鲜": "xíng,xiǎn",
  "衍处": "yǎn,chǔ",
  "衍射格子": "yǎn,shè,gé,zi",
  "衍忒": "yǎn,tuī",
  "衍数": "yǎn,shù",
  "衍蕃": "yǎn,fān",
  "衍𰷞": "yǎn,tè",
  "衍隩": "yǎn,yù",
  "衒玉求售": "zuì,yù,qiú,shòu",
  "衒玉自售": "zuì,yù,zì,shòu",
  "衒露": "xuàn,lù",
  "衔口垫背": "xián,kǒu,diàn,bèi",
  "衔𪧘": "xián,lóu",
  "衔窭数": "xián,jù,shù",
  "衔蹶": "xián,juě",
  "衖堂": "lòng,táng",
  "街弹": "jiē,dàn",
  "街禁": "jiē,jìn",
  "衙内钻": "yá,nèi,zuàn",
  "衙门": "yá,men",
  "衡平法地": "héng,píng,fǎ,de",
  "衡撃": "héng,ji",
  "衡量": "héng,liáng",
  "衡量制": "héng,liang,zhì",
  "衢处": "qú,chǔ",
  "衢衖": "qú,lòng",
  "衣冠": "yì,guān",
  "衣冠冢": "yì,guān,zhǒng",
  "衣冠南渡": "yì,guān,nán,dù",
  "衣冠土枭": "yī,guān,tǔ,xiāo",
  "衣冠墓": "yì,guān,mù",
  "衣冠客": "yì,guān,kè",
  "衣冠文物": "yī,guān,wén,wù",
  "衣冠枭獍": "yī,guān,xiāo,jìng",
  "衣冠楚楚": "yī,guān,chǔ,chǔ",
  "衣冠盛事": "yì,guān,shèng,shì",
  "衣冠禽兽": "yī,guān,qín,shòu",
  "衣单食薄": "yī,dān,shí,bó",
  "衣夹": "yī,jiā",
  "衣折": "yī,shé",
  "衣服缝边": "yī,fú,fèng,biān",
  "衣甲": "yì,jiǎ",
  "衣租食税": "yì,zū,shí,shuì",
  "衣绣昼行": "yì,xiù,zhòu,xíng",
  "衣被": "yì,pī",
  "衣被群生": "yì,bèi,qún,shēng",
  "衣裓": "yī,jiē",
  "衣裳": "yī,shang",
  "衣裳之会": "yī,shang,zhī,huì",
  "衣裳格子": "yī,shang,gé,zi",
  "衣裳盟会": "yī,shang,méng,huì",
  "衣裳钩儿": "yī,shang,gōu,er",
  "衣褐": "yì,hè",
  "衣𰴂": "yī,shān",
  "衣襆": "yī,pú",
  "衣覆": "yì,fù",
  "衣轻乘肥": "yì,qīng,chéng,féi",
  "衣钩儿": "yī,gōu,er",
  "衣锦": "yì,jǐn",
  "衣锦夜游": "yì,jǐn,yè,yóu",
  "衣锦夜行": "yì,jǐn,yè,xíng",
  "衣锦尚䌹": "yì,jǐn,shàng,jiōng",
  "衣锦昼游": "yì,jǐn,zhòu,yóu",
  "衣锦昼行": "yì,jǐn,zhòu,xíng",
  "衣锦褧衣": "yì,jǐn,jiǒng,yī",
  "衣锦过乡": "yì,jǐn,guò,xiāng",
  "衣锦还乡": "yì,jǐn,huán,xiāng",
  "衣锦食肉": "yì,jǐn,shí,ròu",
  "衣马轻肥": "yì,mǎ,qīng,féi",
  "补假": "bǔ,jià",
  "补助地": "bǔ,zhù,de",
  "补数": "bǔ,shù",
  "补种": "bǔ,zhòng",
  "补给": "bǔ,jǐ",
  "补给品": "bǔ,jǐ,pǐn",
  "补给站": "bǔ,jǐ,zhàn",
  "补给线": "bǔ,jǐ,xiàn",
  "补给舰": "bǔ,jǐ,jiàn",
  "补给船": "bǔ,jǐ,chuán",
  "补血": "bǔ,xuè",
  "补靪": "bǔ,ding",
  "表妹夫": "biǎo,mèi,fu",
  "表姐夫": "biǎo,jiě,fu",
  "表开心地": "biǎo,kāi,xīn,de",
  "表徵": "biǎo,zhǐ",
  "表性地": "biǎo,xìng,de",
  "表率": "biǎo,shuài",
  "表现地": "biǎo,xiàn,de",
  "表瓤子": "biǎo,ráng,zi",
  "表着": "biǎo,zhe",
  "表示地": "biǎo,shì,de",
  "表背": "biǎo,bèi",
  "表背匠": "biǎo,bèi,jiàng",
  "表识": "biǎo,zhì",
  "表貉": "biǎo,mò",
  "表载": "biǎo,zǎi",
  "表达地": "biǎo,dá,de",
  "表酂": "biǎo,zàn",
  "表里为奸": "biǎo,lǐ,wéi,jiān",
  "表里相应": "biǎo,lǐ,xiāng,yìng",
  "表露": "biǎo,lù",
  "表露无遗": "biǎo,lù,wú,yí",
  "表面上": "biǎo,miàn,shang",
  "表面上地": "biǎo,miàn,shàng,de",
  "表面地": "biǎo,miàn,de",
  "衮实无阙": "gǔn,shí,wú,què",
  "衰仔": "shuāi,zǎi",
  "衰冠": "shuāi,guān",
  "衰减地": "shuāi,jiǎn,de",
  "衰变曲线": "shuāi,biàn,qū,xiàn",
  "衰嗛": "shuāi,qiàn",
  "衰绖": "cuī,dié",
  "衰葛": "shuāi,gě",
  "衰𦬼": "shuāi,ěr",
  "衰衣": "cuī,yī",
  "衰𬮴": "shuāi,ān",
  "衷衵": "zhōng,yì",
  "衾枕之乐": "qīn,zhěn,zhī,yuè",
  "衾裯": "qīn,dāo",
  "衾裯不掩": "qīn,dāo,bù,yǎn",
  "衾裯事": "qīn,dāo,shì",
  "衾裯妾": "qīn,dāo,qiè",
  "衾裯枷锁": "qīn,dāo,jiā,suǒ",
  "袄子": "ǎo,zi",
  "袅袅娉娉": "niǎo,niǎo,píng,píng",
  "袋子": "dài,zi",
  "袋子包": "dài,zi,bāo",
  "袍子": "páo,zi",
  "袒胸露背": "tǎn,xiōng,lù,bèi",
  "袒胸露臂": "tǎn,xiōng,lù,bì",
  "袒露": "tǎn,lù",
  "袖子": "xiù,zi",
  "袖筒儿": "xiù,tǒng,er",
  "袜子": "wà,zi",
  "被人猛地": "bèi,rén,měng,de",
  "被侮辱地": "bèi,wǔ,rǔ,de",
  "被冒犯地": "bèi,mào,fàn,de",
  "被剥削者": "bèi,bō,xuē,zhě",
  "被动地": "bèi,dòng,de",
  "被动地接受": "bèi,dòng,de,jiē,shòu",
  "被发左衽": "pī,fà,zuǒ,rèn",
  "被发文身": "pī,fà,wén,shēn",
  "被发缨冠": "pī,fà,yīng,guàn",
  "被子": "bèi,zi",
  "被子植物": "bèi,zi,zhí,wù",
  "被山带河": "pī,shān,dài,hé",
  "被打扰地": "bèi,dǎ,rǎo,de",
  "被明确地": "bèi,míng,què,de",
  "被歪曲地": "bèi,wāi,qū,de",
  "被永久地接受": "bèi,yǒng,jiǔ,de,jiē,shòu",
  "被甲执兵": "pī,jiǎ,zhí,bīng",
  "被甲持兵": "pī,jiǎ,chí,bīng",
  "被甲据鞍": "pī,jiǎ,jù,ān",
  "被甲枕戈": "pī,jiǎ,zhěn,gē",
  "被称为": "bèi,chēng,wéi",
  "被褐怀玉": "pī,hè,huái,yù",
  "被褐怀珠": "pī,hè,huái,zhū",
  "被视为": "bèi,shì,wéi",
  "被评为": "bèi,píng,wéi",
  "被诅咒地": "bèi,zǔ,zhòu,de",
  "被迫地": "bèi,pò,de",
  "被遗弃地": "bèi,yí,qì,de",
  "被除数": "bèi,chú,shù",
  "被难": "bèi,nàn",
  "袭侯": "xí,hòu",
  "袭兴": "xí,xīng",
  "袭掠": "xí,lüě",
  "袭逮": "xí,dǎi",
  "袷袢": "qiā,pàn",
  "裁书叙心": "cai,shu,xu,xin",
  "裁什": "cái,shí",
  "裁判长": "cái,pàn,zhǎng",
  "裁削": "cái,xuē",
  "裁剖": "cái,pōu",
  "裁处": "cái,chǔ",
  "裁度": "cái,duó",
  "裁折": "cái,shé",
  "裁㧑": "cái,huī",
  "裁椷": "cái,hán",
  "裁禁": "cái,jìn",
  "裁缝铺": "cái,féng,pù",
  "裂变炸弹": "liè,biàn,zhà,dàn",
  "裂巴": "liě,ba",
  "裂𦈡": "liè,xū",
  "裂缝": "liè,fèng",
  "裂裳衣疮": "liè,shang,yī,chuāng",
  "装么做大": "zhuāng,mǒ,zuò,dà",
  "装内行地": "zhuāng,nèi,háng,de",
  "装孙子": "zhuāng,sūn,zi",
  "装幌子": "zhuāng,huǎng,zi",
  "装弹": "zhuāng,dàn",
  "装憨地问": "zhuāng,hān,de,wèn",
  "装折": "zhuāng,shé",
  "装样子": "zhuāng,yàng,zi",
  "装样子地": "zhuāng,yàng,zi,de",
  "装模作样": "zhuāng,mú,zuò,yàng",
  "装模作样地": "zhuāng,mú,zuò,yàng,de",
  "装模做样": "zhuāng,mú,zuò,yàng",
  "装洋吃相": "zhuāng,yáng,chī,xiàng",
  "装相": "zhuāng,xiàng",
  "装背": "zhuāng,bèi",
  "装裹": "zhuāng,guo",
  "装饰地": "zhuāng,shì,de",
  "裒削": "póu,xuē",
  "裒剥": "póu,bāo",
  "裘葛": "qiú,gě",
  "裘馨氏肌肉萎缩症": "qiú,xīn,shì,jī,ròu,wēi,suō,zhèng",
  "裙子": "qún,zi",
  "裙屐少年": "qún,jī,shào,nián",
  "裤子": "kù,zi",
  "裤缝": "kù,fèng",
  "裤衩": "kù,chǎ",
  "裨将": "pí,jiàng",
  "裨益": "bì,yì",
  "裨补": "bì,bǔ",
  "裱背": "biǎo,bèi",
  "裸体地": "luǒ,tǐ,de",
  "裸露": "luǒ,lù",
  "裸露狂": "luǒ,lù,kuáng",
  "裹夹": "guǒ,jiā",
  "裹脚条子": "guǒ,jiǎo,tiáo,zi",
  "裹血力战": "guǒ,xuè,lì,zhàn",
  "裹鲊帖": "guǒ,zhǎ,tiē",
  "褂子": "guà,zi",
  "褎如充耳": "yòu,rú,chōng,ěr",
  "褎然": "yòu,rán",
  "褎然举首": "yòu,rán,jǔ,shǒu",
  "褎然冠首": "yòu,rán,guàn,shǒu",
  "褎然居首": "yòu,rán,jú,shǒu",
  "褎褎": "yòu,yòu",
  "褐冠山雀": "hè,guān,shān,què",
  "褐冠鹃隼": "hè,guān,juān,sǔn",
  "褐背地山雀": "hè,bèi,dì,shān,què",
  "褐背鹟䴗": "hè,bèi,wēng,jú",
  "褒呔": "bāo,tāi",
  "褒衣危冠": "bāo,yī,wēi,guān",
  "褚人获": "chǔ,rén,huò",
  "褚遂良": "chǔ,suì,liáng",
  "褟绦子": "tā,tāo,zi",
  "褡裢": "dā,lian",
  "褥子": "rù,zi",
  "褪下": "tùn,xià",
  "褪去": "tùn,qù",
  "褪套儿": "tùn,tào,er",
  "褪色": "tuì,shǎi",
  "𬡇亸": "niǎo,tuǒ",
  "𬡇娜": "niǎo,nà",
  "𬡇蹏": "niǎo,dì",
  "褰帷露冕": "qiān,wéi,lù,miǎn",
  "褶子": "zhě,zi",
  "褶子了": "zhě,zi,le",
  "褶曲": "zhě,qū",
  "襃圣侯": "bāo,shèng,hòu",
  "襃弹": "bāo,dàn",
  "襃德侯": "bāo,dé,hòu",
  "襃贲": "bāo,bēn",
  "襞𫌀": "bì,jī",
  "西不着际": "xī,bù,zháo,jì",
  "西乐": "xī,yuè",
  "西仔": "xī,zǎi",
  "西兴": "xī,xīng",
  "西华葛被": "xī,huá,gě,bèi",
  "西南冠纹柳莺": "xī,nán,guān,wén,liǔ,yīng",
  "西又不着": "xī,yòu,bù,zháo",
  "西塞山": "xī,sài,shān",
  "西塞山区": "xī,sài,shān,qū",
  "西夹": "xī,jiā",
  "西打": "xī,dá",
  "西方地": "xī,fāng,de",
  "西格蒙德": "xī,gé,mēng,dé",
  "西洋化地": "xī,yáng,huà,de",
  "西洋参": "xī,yáng,shēn",
  "西湖处士": "xī,hú,chǔ,shì",
  "西米露": "xī,mǐ,lù",
  "西耶那": "xī,yē,nà",
  "西舍": "xī,shè",
  "西葫芦": "xī,hú,lu",
  "西蕃": "xī,fān",
  "西藏": "xī,zàng",
  "西藏人": "xī,zàng,rén",
  "西藏毛腿沙鸡": "xī,zàng,máo,tuǐ,shā,jī",
  "西藏百万农奴解放纪念日": "xī,zàng,bǎi,wàn,nóng,nú,jiě,fàng,jì,niàn,rì",
  "西藏自治区": "xī,zàng,zì,zhì,qū",
  "西边儿": "xī,biān,er",
  "西部地": "xī,bù,de",
  "西镐": "xī,hào",
  "西门町": "xī,mén,dīng",
  "西黄鹡鸰": "xī,huáng,jí,líng",
  "要不了": "yào,bù,liǎo",
  "要不价": "yào,bù,jie",
  "要不停地": "yào,bù,tíng,de",
  "要不断地": "yào,bù,duàn,de",
  "要不是": "yào,bú,shì",
  "要乖乘地": "yào,guāi,chéng,de",
  "要买人心": "yāo,mǎi,rén,xīn",
  "要价还价": "yào,jià,huán,jià",
  "要击": "yāo,jī",
  "要功": "yāo,gōng",
  "要及时地": "yào,jí,shí,de",
  "要合理地": "yào,hé,lǐ,de",
  "要嘛": "yào,ma",
  "要坚决地": "yào,jiān,jué,de",
  "要坚定地": "yào,jiān,deng,de",
  "要塞": "yào,sài",
  "要处": "yào,chǔ",
  "要大大地": "yào,dà,dà,de",
  "要好": "yāo,hǎo",
  "要好好地": "yāo,hǎo,hǎo,de",
  "要尽可能地": "yào,jìn,kě,néng,de",
  "要很好地": "yào,hěn,hǎo,de",
  "要得": "yào,de",
  "要恰当地": "yào,qià,dàng,de",
  "要抢地盘": "yào,qiǎng,de,pán",
  "要挟": "yāo,xié",
  "要晕": "yāo,yūn",
  "要有计划地": "yào,yǒu,jì,huà,de",
  "要末": "yào,me",
  "要样儿": "yào,yàng,er",
  "要求": "yāo,qiú",
  "要清醒地": "yào,qīng,xǐng,de",
  "要狠狠地吃": "yào,hěn,hěn,de,chī",
  "要认真地": "yào,rèn,zhēn,de",
  "要轻轻地": "yào,qīng,qīng,de",
  "要适当地": "yào,shì,dàng,de",
  "要面子": "yào,miàn,zi",
  "覃及": "qín,jí",
  "覃吁": "qín,yù",
  "覃均": "qín,jūn",
  "覃奥": "qín,ào",
  "覃平": "qín,píng",
  "覃庆": "qín,qìng",
  "覃心": "qín,xīn",
  "覃志": "qín,zhì",
  "覃惠": "qín,huì",
  "覃敷": "qín,fū",
  "覃爱": "qín,ài",
  "覃研": "qín,yán",
  "覃精": "qín,jīng",
  "覃被": "qín,bèi",
  "覃𬣙": "qín,xǔ",
  "覃转": "qín,zhuǎn",
  "覃迁": "qín,qiān",
  "覃霈": "qín,pèi",
  "覃鬯": "qín,chàng",
  "覆公折足": "fù,gōng,shé,zú",
  "覆帖": "fù,tiē",
  "覆帱": "fù,dào",
  "覆手为雨": "fù,shǒu,wéi,yǔ",
  "覆折": "fù,shé",
  "覆是为非": "fù,shì,wéi,fēi",
  "覆查": "fù,zhā",
  "覆橑": "fù,lǎo",
  "覆没": "fù,mò",
  "覆焘": "fù,tāo",
  "覆盆子": "fù,pén,zi",
  "覆背": "fù,bèi",
  "覆芘": "fù,pí",
  "覆载": "fù,zǎi",
  "覆逴": "fù,chuò",
  "复露": "fù,lù",
  "𬢎着知微": "dǔ,zhe,zhī,wēi",
  "见不得人": "jiàn,bu,dé,rén",
  "见世": "xiàn,shì",
  "见世报": "xiàn,shì,bào",
  "见世面": "xiàn,shì,miàn",
  "见义勇为": "jiàn,yì,yǒng,wéi",
  "见义当为": "jiàn,yì,dāng,wéi",
  "见义必为": "jiàn,yì,bì,wéi",
  "见义敢为": "jiàn,yì,gǎn,wéi",
  "见几而作": "jiàn,jī,ér,zuò",
  "见哭兴悲": "jiàn,kū,xīng,bēi",
  "见处": "jiàn,chǔ",
  "见小𬮴大": "jiàn,xiǎo,ān,dà",
  "见年": "xiàn,nián",
  "见弹求鸮": "jiàn,dàn,qiú,xiāo",
  "见弹求鹗": "jiàn,dàn,qiú,è",
  "见得": "jiàn,de",
  "见数": "jiàn,shù",
  "见禁": "jiàn,jìn",
  "见粮": "xiàn,liáng",
  "见素抱朴": "xiàn,sù,bào,pǔ",
  "见缝就钻": "jiàn,fèng,jiù,zuān",
  "见缝插针": "jiàn,fèng,chā,zhēn",
  "见背": "jiàn,bèi",
  "见血封喉树": "jiàn,xuè,fēng,hóu,shù",
  "见讽": "jiàn,fěng",
  "见识浅": "jiàn,shi,qiǎn",
  "见长": "jiàn,zhǎng",
  "见风使帆": "jiàn,fēng,shǐ,fān",
  "观塘": "guàn,táng",
  "观山翫水": "guān,shān,wàn,shuǐ",
  "观翫": "guān,wàn",
  "观衅伺隙": "guān,xìn,sì,xì",
  "规为": "guī,wéi",
  "规划": "guī,huà",
  "规划人员": "guī,huà,rén,yuán",
  "规划局": "guī,huà,jú",
  "规则地": "guī,zé,de",
  "规则性效应": "guī,zé,xìng,xiào,yìng",
  "规劝地": "guī,quàn,de",
  "规圜": "guī,yuán",
  "规处": "guī,chǔ",
  "规定地": "guī,deng,de",
  "规旋矩折": "guī,xuán,jǔ,shé",
  "规矩准绳": "guī,ju,zhǔn,shéng",
  "规矩绳墨": "guī,ju,shéng,mò",
  "规矩镜": "guī,ju,jìng",
  "规范地": "guī,fàn,de",
  "规蒦": "guī,wò",
  "规讽": "guī,fěng",
  "规重矩叠": "guī,chóng,jǔ,dié",
  "觅缝": "mì,fèng",
  "觅食行为": "mì,shí,xíng,wéi",
  "视丹如绿": "shì,dān,rú,lù",
  "视为": "shì,wéi",
  "视为儿戏": "shì,wéi,ér,xì",
  "视为寇雠": "shì,wéi,kòu,chóu",
  "视为畏途": "shì,wéi,wèi,tú",
  "视为知己": "shì,wéi,zhī,jǐ",
  "视力地": "shì,lì,de",
  "视微知著": "shì,wēi,zhī,zhuó",
  "视㧑": "shì,huī",
  "视觉上地": "shì,jué,shàng,de",
  "觇伺": "chān,sì",
  "觉得": "jué,de",
  "觉露": "jué,lù",
  "觑忽": "qù,hu",
  "觑着眼": "qù,zhe,yǎn",
  "觑糊": "qù,hu",
  "角冠": "jiǎo,guān",
  "角力": "jué,lì",
  "角力戏": "jué,lì,xì",
  "角抵": "jué,dǐ",
  "角抵戏": "jué,dǐ,xì",
  "角抵社": "jué,dǐ,shè",
  "角抵队": "jué,dǐ,duì",
  "角斗": "jué,dòu",
  "角斗场": "jué,dòu,chǎng",
  "角曲尺": "jiǎo,qū,chǐ",
  "角色": "jué,sè",
  "角色扮演游戏": "jué,sè,bàn,yǎn,yóu,xì",
  "角逐": "jué,zhú",
  "角逐场": "jué,zhú,chǎng",
  "角韈": "jiǎo,wà",
  "觕朴": "cū,piáo",
  "觜宿": "zī,xiù",
  "觟冠": "huà,guān",
  "解㑊": "xiè,yì",
  "解事舍人": "jiě,shì,shè,rén",
  "解倒悬": "jiě,dào,xuán",
  "解元": "jiè,yuán",
  "解典铺": "jiě,diǎn,pù",
  "解冠": "jiě,guān",
  "解剖": "jiě,pōu",
  "解剖刀": "jiě,pōu,dāo",
  "解剖学": "jiě,pōu,xué",
  "解剖室": "jiě,pōu,shì",
  "解剖麻雀": "jiě,pōu,má,què",
  "解剥": "jiě,bāo",
  "解发佯狂": "jiě,fà,yáng,kuáng",
  "解子": "jiè,zǐ",
  "解差": "jiè,chāi",
  "解帆": "jiě,fān",
  "解帖": "jiě,tiē",
  "解廌": "xiè,zhì",
  "解廌冠": "jiě,zhì,guān",
  "解弦更张": "jiě,xián,gēng,zhāng",
  "解当铺": "jiě,dàng,pù",
  "解折": "jiě,shé",
  "解数": "xiè,shù",
  "解析函数": "jiě,xī,hán,shù",
  "解析函数论": "jiě,xī,hán,shù,lùn",
  "解析地": "jiě,xī,de",
  "解款": "jiè,kuǎn",
  "解民倒悬": "jiě,mín,dào,xuán",
  "解池": "xiè,chí",
  "解法": "xiè,fǎ",
  "解煞": "jiě,shà",
  "解痉剂": "xiè,jìng,jì",
  "解盐": "xiè,yán",
  "解禁": "jiě,jìn",
  "解累": "jiě,lèi",
  "解舍": "jiě,shè",
  "解衣槃磅": "jiě,yī,pán,páng",
  "解衣盘磅": "jiě,yī,pán,páng",
  "解衣磅礴": "jiě,yī,páng,bó",
  "解衣衣人": "jiè,yī,yī,rén",
  "解衵": "jiě,yì",
  "解謿": "jiě,zhāo",
  "解豸": "xiè,zhì",
  "解趣": "xiè,qù",
  "解送": "jiè,sòng",
  "解铃系铃": "jiě,líng,jì,líng",
  "解铃还需系铃人": "jiě,líng,hái,xū,jì,líng,rén",
  "解铺": "jiě,pù",
  "触兴": "chù,xīng",
  "触处机来": "chù,chǔ,jī,lái",
  "触感地": "chù,gǎn,de",
  "触物兴怀": "chù,wù,xīng,huái",
  "触电似地": "chù,diàn,shì,de",
  "触目兴叹": "chù,mù,xīng,tàn",
  "触着": "chù,zhe",
  "触禁": "chù,jìn",
  "触蹶": "chù,juě",
  "触邪冠": "chù,xié,guān",
  "触露": "chù,lù",
  "觰沙": "dǎ,shā",
  "觱剥剥": "bì,bāo,bāo",
  "觳折": "hú,shé",
  "言不逮意": "yán,bù,dǎi,yì",
  "言为心声": "yán,wéi,xīn,shēng",
  "言之过早": "yán,zhì,guò,zǎo",
  "言信行直": "yan,xin,xing,zhi",
  "言归正传": "yán,guī,zhèng,zhuàn",
  "言必有中": "yán,bì,yǒu,zhòng",
  "言数": "yán,shù",
  "言气卑弱": "yan,qi,bei,ruo",
  "言讽": "yán,fěng",
  "言词恳切": "yán,cí,kěn,qiè",
  "言调": "yán,diào",
  "訇哮": "hōng,xiāo",
  "𬣙俞": "xǔ,yú",
  "𬣙猷": "xǔ,yóu",
  "𬣙策": "xǔ,cè",
  "𬣙𬣙": "xǔ,xǔ",
  "𬣙谋": "xǔ,móu",
  "𫍙尿": "yí,niào",
  "𫍙言": "yí,yán",
  "𫍙𫍙": "yí,yí",
  "𫍙谩": "yí,màn",
  "䜣合": "xī,hé",
  "䜣然": "xī,rán",
  "䜣䜣": "xī,xī",
  "䜣载": "xī,zǎi",
  "𰵏婧": "miǎo,jìng",
  "𰵏𰵏": "miǎo,miǎo",
  "𰵏轻": "miǎo,qīng",
  "訾咎": "zǐ,jiù",
  "訾屈": "zǐ,qū",
  "訾怨": "zǐ,yuàn",
  "訾数": "zī,shù",
  "訾毁": "zǐ,huǐ",
  "訾病": "zǐ,bìng",
  "訾短": "zǐ,duǎn",
  "訾笮": "zī,zé",
  "訾美": "zǐ,měi",
  "訾訾嚣嚣": "zī,zī,áo,áo",
  "訾议": "zǐ,yì",
  "訾食": "zǐ,shí",
  "詈夷为跖": "lì,yí,wéi,zhí",
  "詈訾": "lì,zǐ",
  "𫍡谩": "tuó,màn",
  "𬣱和": "zhòu,hé",
  "𬣱咨": "zhòu,zī",
  "𬣱唱": "zhòu,chàng",
  "𬣱寄": "zhòu,jì",
  "𬣱对": "zhòu,duì",
  "𬣱应": "zhòu,yīng",
  "𬣱悦": "zhòu,yuè",
  "𬣱抗": "zhòu,kàng",
  "𬣱接": "zhòu,jiē",
  "𬣱敌": "zhòu,dí",
  "𬣱直": "zhòu,zhí",
  "𬣱答": "zhòu,dá",
  "𬣱纳": "zhòu,nà",
  "𬣱继": "zhòu,jì",
  "𬣱言": "zhòu,yán",
  "𬣱譬": "zhòu,pì",
  "𬣱诺": "zhòu,nuò",
  "𬣱赏": "zhòu,shǎng",
  "𬣱赛": "zhòu,sài",
  "詹翫": "zhān,wàn",
  "𰵤𰵤": "è,è",
  "𫍥撆": "diào,piē",
  "𫍥越": "diào,yuè",
  "誉为": "yù,wéi",
  "誉处": "yù,chǔ",
  "誓以皦日": "shì,yǐ,wéi,rì",
  "誓死不降": "shì,sǐ,bù,xiáng",
  "誓禁": "shì,jìn",
  "誖缪": "bèi,miù",
  "誖谩": "bèi,màn",
  "諀訿": "pǐ,zī",
  "𬤀吓": "háo,xià",
  "𬤀杀": "háo,shā",
  "𬤀死": "háo,sǐ",
  "𬤀煞": "háo,shà",
  "𬤎客夺主": "xī,kè,duó,zhǔ",
  "謇慠": "jiǎn,ào",
  "謦咳": "qǐng,hāi",
  "謷牙诘屈": "áo,yá,jí,qū",
  "謿呓": "zhāo,yì",
  "謿哂": "zhāo,shěn",
  "謿笑": "zhāo,xiào",
  "謿讦": "zhāo,jié",
  "謿诙": "zhāo,huī",
  "謿话": "zhāo,huà",
  "謿诟": "zhāo,gòu",
  "謿谑": "zhāo,xuè",
  "謿风": "zhāo,fēng",
  "警𠡠": "jǐng,lài",
  "警句式地": "jǐng,jù,shì,de",
  "警告地": "jǐng,gào,de",
  "警惕地": "jǐng,tì,de",
  "警扞": "jǐng,gǎn",
  "警拗": "jǐng,niù",
  "警省": "jǐng,xǐng",
  "警觉地": "jǐng,jué,de",
  "警逴": "jǐng,chuò",
  "警长": "jǐng,zhǎng",
  "警露": "jǐng,lù",
  "𫍦𫍦": "nóu,nóu",
  "譬喻地": "pì,yù,de",
  "𬤰露": "huān,lù",
  "𰵨妄": "zhán,wàng",
  "𰵨语": "zhán,yǔ",
  "计侯": "jì,hòu",
  "计出无奈": "jì,chū,wú,nai",
  "计划": "jì,huà",
  "计划单列市": "jì,huà,dān,liè,shì",
  "计划性报废": "jì,huà,xìng,bào,fèi",
  "计划报废": "jì,huà,bào,fèi",
  "计划生育": "jì,huà,shēng,yù",
  "计划目标": "jì,huà,mù,biāo",
  "计划经济": "jì,huà,jīng,jì",
  "计处": "jì,chǔ",
  "计数": "jì,shù",
  "计数器": "jì,shù,qì",
  "计数法": "jì,shù,fǎ",
  "计数率仪": "jì,shù,lǜ,yí",
  "计数管": "jì,shù,guǎn",
  "计数者": "jì,shù,zhě",
  "计无付之": "jì,wú,fǔ,zhī",
  "计时炸弹": "jì,shí,zhà,dàn",
  "计校": "jì,jiào",
  "计䇲": "jì,jiā",
  "计算数学": "jì,suàn,shù,xué",
  "计都": "jì,dū",
  "计量地": "jì,liàng,de",
  "讣帖": "fù,tiē",
  "认不是": "rèn,bú,shì",
  "认为": "rèn,wéi",
  "认人儿": "rèn,rén,er",
  "认可地": "rèn,kě,de",
  "认处": "rèn,chǔ",
  "认影为头": "rèn,yǐng,wéi,tóu",
  "认得": "rèn,de",
  "认得破": "rèn,de,pò",
  "认死扣儿": "rèn,sǐ,kòu,er",
  "认死扣子": "rèn,sǐ,kòu,zi",
  "认死理儿": "rèn,sǐ,lǐ,er",
  "认真地": "rèn,zhēn,de",
  "认真地写": "rèn,zhēn,de,xiě",
  "认真地去": "rèn,zhēn,de,qù",
  "认真地吃": "rèn,zhēn,de,chī",
  "认真地听": "rèn,zhēn,de,tīng",
  "认真地工作": "rèn,zhēn,de,gōng,zuò",
  "认真地活下去": "rèn,zhēn,de,huó,xià,qù",
  "认真地看": "rèn,zhēn,de,kàn",
  "认真地看了一下": "rèn,zhēn,de,kàn,le,yī,xià",
  "认真地说": "rèn,zhēn,de,shuō",
  "认真地进行": "rèn,zhēn,de,jìn,xíng",
  "认着": "rèn,zhe",
  "认识不能": "rèn,shi,bù,néng",
  "认识地": "rèn,shí,de",
  "认贼为子": "rèn,zéi,wéi,zǐ",
  "认贼为父": "rèn,zéi,wéi,fù",
  "讥兴": "jī,xīng",
  "讥刺地": "jī,cì,de",
  "讥剌地": "jī,lá,de",
  "讥揣": "jī,chuāi",
  "讥查": "jī,zhā",
  "讥禁": "jī,jìn",
  "讥讽": "jī,fěng",
  "讥讽地": "jī,fěng,de",
  "讥调": "jī,diào",
  "讦露": "jié,lù",
  "讨人喜欢": "tǎo,rén,xǐ,huan",
  "讨价还价": "tǎo,jià,huán,jià",
  "讨便宜": "tǎo,pián,yí",
  "讨厌地": "tǎo,yàn,de",
  "讨口子": "tǎo,kǒu,zi",
  "讨好人地": "tǎo,hǎo,rén,de",
  "讨好地": "tǎo,hǎo,de",
  "讨好地笑": "tǎo,hǎo,de,xiào",
  "讨底儿": "tǎo,dǐ,er",
  "讨臊": "tǎo,sào",
  "讨还": "tǎo,huán",
  "让步地": "ràng,bù,de",
  "讪答答地": "shàn,dā,dā,dì",
  "讪讪地": "shàn,shàn,de",
  "讬兴": "tuō,xīng",
  "讬处": "tuō,chǔ",
  "讬孤寄命": "xíng,gū,jì,mìng",
  "讬物寓兴": "tuō,wù,yù,xīng",
  "讬舍": "tuō,shè",
  "讬芘": "tuō,pí",
  "讬讽": "tuō,fěng",
  "讬载": "tuō,zǎi",
  "训𠡠": "xùn,lài",
  "训诂地": "xùn,gǔ,de",
  "议处": "yì,chǔ",
  "议干": "yì,gàn",
  "议长": "yì,zhǎng",
  "讯夹": "xùn,jiā",
  "讯掠": "xùn,lüě",
  "记不住": "jì,bu,zhù",
  "记为": "jì,wéi",
  "记传": "jì,zhuàn",
  "记住": "jì,zhu",
  "记号笔": "jì,hao,bǐ",
  "记在心里": "jì,zài,xīn,li",
  "记得": "jì,de",
  "记性": "jì,xing",
  "记性好地": "jì,xìng,hǎo,de",
  "记着": "jì,zhe",
  "记载": "jì,zǎi",
  "讲处": "jiǎng,chǔ",
  "讲数": "jiǎng,shù",
  "讲盘子": "jiǎng,pán,zi",
  "讲真话地": "jiǎng,zhēn,huà,de",
  "讲究": "jiǎng,jiu",
  "讲究地": "jiǎng,jiū,de",
  "讲舍": "jiǎng,shè",
  "讲讽": "jiǎng,fěng",
  "讲道理地": "jiǎng,dào,lǐ,de",
  "讳树数马": "huì,shù,shù,mǎ",
  "讴唫": "ōu,yín",
  "讴轧": "ōu,zhá",
  "讵得": "jù,de",
  "讷朴": "nè,piáo",
  "讷𫘤": "nè,ái",
  "许处": "xǔ,chǔ",
  "许多倍地": "xǔ,duō,bèi,de",
  "许廑父": "xǔ,qín,fù",
  "讹殽": "é,yáo",
  "论处": "lùn,chǔ",
  "论帖": "lùn,tiē",
  "论证地": "lùn,zhèng,de",
  "论语": "lún,yǔ",
  "论调": "lùn,diào",
  "论载": "lùn,zǎi",
  "论难": "lùn,nàn",
  "论黄数白": "lùn,huáng,shù,bái",
  "讼愬": "sòng,shuò",
  "讼筩": "sòng,yǒng",
  "讼逮": "sòng,dǎi",
  "讽一劝百": "fěng,yī,quàn,bǎi",
  "讽世": "fěng,shì",
  "讽习": "fěng,xí",
  "讽书": "fěng,shū",
  "讽令": "fěng,lìng",
  "讽传": "fěng,chuán",
  "讽兴": "fěng,xīng",
  "讽切": "fěng,qiē",
  "讽刺": "fěng,cì",
  "讽刺地": "fěng,cì,de",
  "讽劝": "fěng,quàn",
  "讽动": "fěng,dòng",
  "讽励": "fěng,lì",
  "讽勉": "fěng,miǎn",
  "讽厉": "fěng,lì",
  "讽告": "fěng,gào",
  "讽呗": "fěng,bài",
  "讽呪": "fěng,zhòu",
  "讽味": "fěng,wèi",
  "讽咏": "fěng,yǒng",
  "讽咒": "fěng,zhòu",
  "讽啸": "fěng,xiào",
  "讽喻": "fěng,yù",
  "讽嘲": "fěng,cháo",
  "讽多要寡": "fěng,duō,yào,guǎ",
  "讽寤": "fěng,wù",
  "讽席": "fěng,xí",
  "讽德诵功": "fěng,dé,sòng,gōng",
  "讽念": "fěng,niàn",
  "讽怨": "fěng,yuàn",
  "讽意": "fěng,yì",
  "讽托": "fěng,tuō",
  "讽持": "fěng,chí",
  "讽旨": "fěng,zhǐ",
  "讽术": "fěng,shù",
  "讽玩": "fěng,wán",
  "讽示": "fěng,shì",
  "讽籀": "fěng,zhòu",
  "讽纠": "fěng,jiū",
  "讽绎": "fěng,yì",
  "讽经": "fěng,jīng",
  "讽翫": "fěng,wàn",
  "讽职": "fěng,zhí",
  "讽胁": "fěng,xié",
  "讽解": "fěng,jiě",
  "讽誉": "fěng,yù",
  "讽讥": "fěng,jī",
  "讽讪": "fěng,shàn",
  "讽讬": "fěng,tuō",
  "讽议": "fěng,yì",
  "讽论": "fěng,lùn",
  "讽讽": "fěng,fěng",
  "讽诏": "fěng,zhào",
  "讽诫": "fěng,jiè",
  "讽说": "fěng,shuō",
  "讽诵": "fěng,sòng",
  "讽读": "fěng,dú",
  "讽谏": "fěng,jiàn",
  "讽谕": "fěng,yù",
  "讽赞": "fěng,zàn",
  "讽辞": "fěng,cí",
  "讽述": "fěng,shù",
  "讽道": "fěng,dào",
  "讽采": "fěng,cǎi",
  "设处": "shè,chǔ",
  "设心处虑": "shè,xīn,chǔ,lǜ",
  "设想地": "shè,xiǎng,de",
  "设数": "shè,shù",
  "设熬": "shè,áo",
  "设禁": "shè,jìn",
  "设舍": "shè,shè",
  "设身处地": "shè,shēn,chǔ,dì",
  "访覃": "fǎng,qín",
  "访逮": "fǎng,dǎi",
  "证券行": "zhèng,quàn,háng",
  "证逮": "zhèng,dǎi",
  "诂经精舍": "gǔ,jīng,jīng,shè",
  "诃咥": "hē,xī",
  "诃子": "hē,zi",
  "评为": "píng,wéi",
  "评价量规": "píng,jià,liáng,guī",
  "评传": "píng,zhuàn",
  "评卷": "píng,juàn",
  "评释地": "píng,shì,de",
  "诅咒地": "zǔ,zhòu,de",
  "识得": "shí,de",
  "识微知著": "shí,wēi,zhī,zhuó",
  "识念": "zhì,niàn",
  "识数": "shí,shù",
  "识时务者为俊杰": "shí,shí,wù,zhě,wéi,jùn,jié",
  "识相": "shí,xiàng",
  "识记": "zhì,jì",
  "识趣地": "shí,qù,de",
  "诇伺": "xiòng,sì",
  "诈哄": "zhà,hǒng",
  "诈扎": "zhà,zhā",
  "诈称地": "zhà,chēng,de",
  "诈降": "zhà,xiáng",
  "诉苦地": "sù,kǔ,de",
  "诋弹": "dǐ,dàn",
  "诋訾": "dǐ,zǐ",
  "诋訿": "dǐ,zī",
  "诋谩": "dǐ,màn",
  "词优效应": "cí,yōu,xiào,yìng",
  "词卷": "cí,juàn",
  "词干": "cí,gàn",
  "词汇判断任务": "cí,huì,pàn,duàn,rèn,wu",
  "词甚切激": "cí,shèn,qiè,jī",
  "词相似效应": "cí,xiāng,sì,xiào,yìng",
  "词禁": "cí,jìn",
  "词筩": "cí,yǒng",
  "词语地": "cí,yǔ,de",
  "词调": "cí,diào",
  "词长效应": "cí,cháng,xiào,yìng",
  "词项逻辑": "cí,xiàng,luó,ji",
  "词频效应": "cí,pín,xiào,yìng",
  "诎折": "qū,shé",
  "诏𠡠": "zhào,lài",
  "诏卷": "zhào,juàn",
  "译载": "yì,zǎi",
  "诓哄": "kuāng,hǒng",
  "试卷": "shì,juàn",
  "试墨帖": "shì,mò,tiē",
  "试手儿": "shì,shǒu,er",
  "试探地问": "shì,tàn,de,wèn",
  "试着": "shì,zhe",
  "试着步儿": "shì,zhe,bù,ér",
  "试种": "shì,zhòng",
  "试铺": "shì,pù",
  "试验性地": "shì,yàn,xìng,de",
  "诗书发冢": "shī,shū,fà,zhǒng",
  "诗云子曰": "shī,yún,zǐ,yuè",
  "诗什": "shī,shí",
  "诗卷": "shī,juàn",
  "诗宰相": "shī,zǎi,xiàng",
  "诗帖": "shī,tiē",
  "诗臒": "shī,qú",
  "诗筩": "shī,yǒng",
  "诗肠鼓吹": "shī,chá,gǔ,chuì",
  "诗行": "shī,háng",
  "诗调": "shī,diào",
  "诘屈": "jí,qū",
  "诘屈磝碻": "jí,qū,áo,qiāo",
  "诘屈聱牙": "jí,qū,áo,yá",
  "诘屈謷牙": "jí,qū,áo,yá",
  "诘折": "jié,shé",
  "诘朝": "jí,cháo",
  "诘禁": "jié,jìn",
  "诘调": "jié,diào",
  "诘蹶": "jié,juě",
  "诘轧": "jié,zhá",
  "诙謿": "huī,zhāo",
  "诙调": "huī,diào",
  "诙谐地": "huī,xié,de",
  "诙谐地说": "huī,xié,de,shuō",
  "诚心地": "chéng,xīn,de",
  "诚心诚意地": "chéng,xīn,chéng,yì,de",
  "诚恳地": "chéng,kěn,de",
  "诚恳地说": "chéng,kěn,de,shuō",
  "诚慊": "chéng,qiè",
  "诚挚地": "chéng,zhì,de",
  "诚朴": "chéng,piáo",
  "诛削": "zhū,xuē",
  "诛剥": "zhū,bāo",
  "诛揃": "zhū,jiān",
  "话匣子": "huà,xiá,zi",
  "话又说回来": "huà,yòu,shuō,huí,lai",
  "话口儿": "huà,kǒu,er",
  "话口袋子": "huà,kǒu,dài,zi",
  "话把": "huà,bà",
  "话把儿": "huà,bà,er",
  "话把戏": "huà,bà,xì",
  "话盒子": "huà,hé,zi",
  "话茬儿": "huà,chá,er",
  "话说回来": "huà,shuō,huí,lai",
  "诞兴": "dàn,xīng",
  "诞应": "dàn,yìng",
  "诞得": "dàn,de",
  "诞谩": "dàn,màn",
  "诞谩不经": "dàn,màn,bù,jīng",
  "诞载": "dàn,zǎi",
  "诞铺": "dàn,pù",
  "诟数": "gòu,shù",
  "诟訿": "gòu,zī",
  "诡挟": "guǐ,jiā",
  "诡数": "guǐ,shù",
  "诡更": "guǐ,gēng",
  "诡禁": "guǐ,jìn",
  "诡秘地": "guǐ,mì,de",
  "诡诈地": "guǐ,zhà,de",
  "询吁之乐": "xún,yù,zhī,yuè",
  "该着": "gāi,zháo",
  "该罚地": "gāi,fá,de",
  "该诅咒地": "gāi,zǔ,zhòu,de",
  "该载": "gāi,zǎi",
  "该骂地": "gāi,mà,de",
  "详处": "xiáng,chǔ",
  "详尽地": "xiáng,jìn,de",
  "详应": "xiáng,yìng",
  "详情度理": "xiáng,qíng,duó,lǐ",
  "详星拜斗": "xiáng,xīng,bài,dǒu",
  "详狂": "yáng,kuáng",
  "详细地": "xiáng,xì,de",
  "详细地检查": "xiáng,xì,de,jiǎn,chá",
  "详细地说": "xiáng,xì,de,shuō",
  "详细地说明": "xiáng,xì,de,shuō,míng",
  "详细地说明一下": "xiáng,xì,de,shuō,míng,yī,xià",
  "详细地问": "xiáng,xì,de,wèn",
  "详载": "xiáng,zǎi",
  "诧异地": "chà,yì,de",
  "诪张为幻": "zhōu,zhāng,wéi,huàn",
  "诫𠡠": "jiè,lài",
  "诬愬": "wū,shuò",
  "诬良为盗": "wū,liáng,wéi,dào",
  "诬蔑地": "wū,miè,de",
  "诬谩": "wū,màn",
  "诬逮": "wū,dǎi",
  "语塞": "yǔ,sè",
  "语数": "yǔ,shù",
  "语数外": "yǔ,shù,wài",
  "语言上地": "yǔ,yán,shàng,de",
  "语调": "yǔ,diào",
  "语重心长地说": "yǔ,zhòng,xīn,cháng,de,shuō",
  "诮累": "qiào,lèi",
  "诮讽": "qiào,fěng",
  "误以为": "wù,yǐ,wéi",
  "误作非为": "wù,zuò,fēi,wéi",
  "误入歧途效应": "wù,rù,qí,tú,xiào,yìng",
  "误差": "wù,chā",
  "误缪": "wù,miù",
  "误解地": "wù,jiě,de",
  "诰𠡠": "gào,lài",
  "诱人地": "yòu,rén,de",
  "诱哄": "yòu,hòng",
  "诱导地": "yòu,dǎo,de",
  "诱惑人地": "yòu,huò,rén,de",
  "诱惑地": "yòu,huò,de",
  "诱惑性地": "yòu,huò,xìng,de",
  "诱愒": "yòu,kài",
  "诱扎": "yòu,zhā",
  "诱降": "yòu,xiáng",
  "诲淫地": "huì,yín,de",
  "诳𬤀": "kuáng,háo",
  "诳谩": "kuáng,màn",
  "说不上去": "shuō,bù,shǎng,qù",
  "说不了": "shuō,bù,liǎo",
  "说不出": "shuō,bu,chū",
  "说不出地": "shuō,bù,chū,de",
  "说不到": "shuō,bú,dào",
  "说不着": "shuō,bù,zháo",
  "说中": "shuō,zhòng",
  "说什": "shuō,shí",
  "说什么": "shuō,shí,mǒ",
  "说反话地": "shuō,fǎn,huà,de",
  "说嘴郎中无好药": "shuō,zuǐ,láng,zhōng,wú,hào,yào",
  "说头儿": "shuō,tou,er",
  "说媒拉纤": "shuō,méi,lā,qiàn",
  "说岳全传": "shuō,yuè,quán,zhuàn",
  "说干就干": "shuō,gàn,jiù,gàn",
  "说得": "shuō,de",
  "说得上": "shuō,de,shàng",
  "说得去": "shuō,děi,qù",
  "说得响": "shuō,de,xiǎng",
  "说得嘴": "shuō,de,zuǐ",
  "说得拢": "shuō,de,lǒng",
  "说得来": "shuō,de,lái",
  "说得着": "shuō,de,zháo",
  "说得起": "shuō,de,qǐ",
  "说明地": "shuō,míng,de",
  "说明式地": "shuō,míng,shì,de",
  "说漂亮话": "shuō,piào,liàng,huà",
  "说玩笑地": "shuō,wán,xiào,de",
  "说白道绿": "shuō,bái,dào,lù",
  "说的着": "shuō,de,zhe",
  "说着玩": "shuō,zhe,wán",
  "说着玩儿": "shuō,zhe,wán,er",
  "说着谎地": "shuō,zhe,huǎng,de",
  "说老婆舌头": "shuō,lǎo,pó,shé,tou",
  "说老实话": "shuō,lǎo,shi,huà",
  "说葡萄酸": "shuō,pú,tao,suān",
  "说话不当话": "shuō,huà,bù,dàng,huà",
  "说话算数": "shuō,huà,suàn,shù",
  "说话要算数": "shuō,huà,yào,suàn,shù",
  "说说": "shuō,shuo",
  "说调": "shuō,diào",
  "说载": "shuō,zǎi",
  "说项": "shuì,xiàng",
  "诵呗": "sòng,bài",
  "诵数": "sòng,shù",
  "诵讽": "sòng,fěng",
  "诵读困难症": "sòng,dú,kùn,nan,zhèng",
  "请假": "qǐng,jià",
  "请假条": "qǐng,jià,tiáo",
  "请将不如激将": "qǐng,jiàng,bù,rú,jī,jiàng",
  "请由此亡": "qing,you,chi,wang",
  "请调": "qǐng,diào",
  "请降": "qǐng,xiáng",
  "请靓": "qǐng,liàng",
  "诸公调": "zhū,gōng,diào",
  "诸处": "zhū,chǔ",
  "诸宫调": "zhū,gōng,diào",
  "诸相": "zhū,xiàng",
  "诸葛": "zhū,gě",
  "诸葛亮": "zhū,gě,liàng",
  "诸葛垒": "zhū,gě,lěi",
  "诸葛庐": "zhū,gě,lú",
  "诸葛弩": "zhū,gě,nǔ",
  "诸葛灯": "zhū,gě,dēng",
  "诸葛笔": "zhū,gě,bǐ",
  "诸葛菜": "zhū,gě,cài",
  "诸葛铜鼓": "zhū,gě,tóng,gǔ",
  "诸葛鼓": "zhū,gě,gǔ",
  "诸蕃": "zhū,fān",
  "诸贲": "zhū,bēn",
  "读为": "dú,wéi",
  "读书得间": "dú,shū,dé,jiàn",
  "读书破万卷": "dú,shū,pò,wàn,juàn",
  "读卷": "dú,juàn",
  "读帖": "dú,tiē",
  "读数": "dú,shù",
  "读数语句": "dú,shù,yǔ,jù",
  "诽訿": "fěi,zī",
  "课卷": "kè,juàn",
  "课嘴撩牙": "kè,zuǐ,liáo,yá",
  "课调": "kè,diào",
  "课长": "kè,zhǎng",
  "谀中伤地": "yú,zhòng,shāng,de",
  "谀逊地": "yú,xùn,de",
  "谁人乐队": "shéi,rén,yuè,duì",
  "谁们": "shuí,men",
  "谁怕谁": "shéi,pà,shéi",
  "谁数": "shuí,shù",
  "谁料": "shéi,liào",
  "谁更好地": "shéi,gèng,hǎo,de",
  "谁的": "shéi,de",
  "谁知": "shéi,zhī",
  "谁知道": "shéi,zhī,dào",
  "谁都": "shéi,dōu",
  "调一": "diào,yī",
  "调下": "diào,xià",
  "调中": "diào,zhōng",
  "调举": "diào,jǔ",
  "调九鼎": "diào,jiǔ,dǐng",
  "调习": "diào,xí",
  "调书带": "diào,shū,dài",
  "调书袋": "diào,shū,dài",
  "调亭": "diào,tíng",
  "调人": "diào,rén",
  "调令": "diào,lìng",
  "调任": "diào,rèn",
  "调伏": "diào,fú",
  "调体": "diào,tǐ",
  "调侃地": "tiáo,kǎn,de",
  "调值": "diào,zhí",
  "调假": "diào,jiǎ",
  "调充": "diào,chōng",
  "调入": "diào,rù",
  "调兵": "diào,bīng",
  "调兵山": "diào,bīng,shān",
  "调兵山市": "diào,bīng,shān,shì",
  "调兵遣将": "diào,bīng,qiǎn,jiàng",
  "调函": "diào,hán",
  "调判": "diào,pàn",
  "调利": "diào,lì",
  "调刺": "diào,cì",
  "调动": "diào,dòng",
  "调勰": "diào,xié",
  "调包": "diào,bāo",
  "调化": "diào,huà",
  "调匙": "diào,chí",
  "调升": "diào,shēng",
  "调卫": "diào,wèi",
  "调印": "diào,yìn",
  "调卷": "diào,juàn",
  "调历": "diào,lì",
  "调发": "diào,fā",
  "调取": "diào,qǔ",
  "调叠": "diào,dié",
  "调口": "diào,kǒu",
  "调号": "diào,hào",
  "调和地": "tiáo,hé,de",
  "调和平均数": "tiáo,hé,píng,jūn,shù",
  "调品": "diào,pǐn",
  "调哄": "diào,hǒng",
  "调啖": "diào,dàn",
  "调嗓子": "diào,sǎng,zi",
  "调嘴调舌": "tiáo,zuǐ,diào,shé",
  "调器": "diào,qì",
  "调回": "diào,huí",
  "调均": "diào,jūn",
  "调声": "diào,shēng",
  "调声叶律": "diào,shēng,xié,lǜ",
  "调壹": "diào,yī",
  "调处": "tiáo,chǔ",
  "调外": "diào,wài",
  "调头": "diào,tóu",
  "调夷": "diào,yí",
  "调奏": "diào,zòu",
  "调奸": "diào,jiān",
  "调妆": "diào,zhuāng",
  "调娱": "diào,yú",
  "调媚": "diào,mèi",
  "调子": "diào,zi",
  "调官": "diào,guān",
  "调审": "diào,shěn",
  "调密": "diào,mì",
  "调察": "diào,chá",
  "调布": "diào,bù",
  "调帖": "diào,tiē",
  "调干": "diào,gàn",
  "调干生": "diào,gàn,shēng",
  "调平": "diào,píng",
  "调年": "diào,nián",
  "调度": "diào,dù",
  "调度员": "diào,dù,yuán",
  "调开": "diào,kāi",
  "调式": "diào,shì",
  "调弓": "diào,gōng",
  "调弦品竹": "diào,xián,pǐn,zhú",
  "调当": "diào,dāng",
  "调役": "diào,yì",
  "调征": "diào,zhēng",
  "调得": "diào,de",
  "调御": "diào,yù",
  "调御丈夫": "diào,yù,zhàng,fū",
  "调心": "diào,xīn",
  "调态": "diào,tài",
  "调懴": "diào,chàn",
  "调把戏": "diào,bǎ,xì",
  "调抚": "diào,fǔ",
  "调抟": "diào,tuán",
  "调拳": "diào,quán",
  "调按": "diào,àn",
  "调挠": "diào,náo",
  "调换": "diào,huàn",
  "调授": "diào,shòu",
  "调揭": "diào,jiē",
  "调摆": "diào,bǎi",
  "调救": "diào,jiù",
  "调敛": "diào,liǎn",
  "调数": "diào,shù",
  "调文": "diào,wén",
  "调斗": "diào,dòu",
  "调斡": "diào,wò",
  "调旨": "diào,zhǐ",
  "调易": "diào,yì",
  "调曲": "diào,qǔ",
  "调服": "diào,fú",
  "调柔": "diào,róu",
  "调查": "diào,chá",
  "调查人员": "diào,chá,rén,yuán",
  "调查员": "diào,chá,yuán",
  "调查团": "diào,chá,tuán",
  "调查核实": "diào,chá,hé,shí",
  "调查研究": "diào,chá,yán,jiū",
  "调查组": "diào,chá,zǔ",
  "调查结果": "diào,chá,jié,guǒ",
  "调查者": "diào,chá,zhě",
  "调查表": "diào,chá,biǎo",
  "调格": "diào,gé",
  "调梅": "diào,méi",
  "调欺": "diào,qī",
  "调正": "diào,zhèng",
  "调歪": "diào,wāi",
  "调民": "diào,mín",
  "调求": "diào,qiú",
  "调沃": "diào,wò",
  "调法": "diào,fǎ",
  "调泛": "diào,fàn",
  "调派": "diào,pài",
  "调润": "diào,rùn",
  "调滑": "diào,huá",
  "调演": "diào,yǎn",
  "调灰抄": "diào,huī,chāo",
  "调炼": "diào,liàn",
  "调烛": "diào,zhú",
  "调烹": "diào,pēng",
  "调熟": "diào,shú",
  "调燮": "diào,xiè",
  "调犯": "diào,fàn",
  "调猱": "diào,náo",
  "调猱酿旦": "diào,náo,niàng,dàn",
  "调率": "diào,lǜ",
  "调玉烛": "diào,yù,zhú",
  "调用": "diào,yòng",
  "调画": "diào,huà",
  "调疎": "diào,shū",
  "调疏": "diào,shū",
  "调疾": "diào,jí",
  "调白": "diào,bái",
  "调百戏": "diào,bǎi,xì",
  "调皮地说": "tiáo,pí,de,shuō",
  "调盉": "diào,hé",
  "调益": "diào,yì",
  "调盐": "diào,yán",
  "调直": "diào,zhí",
  "调相": "tiáo,xiàng",
  "调省": "diào,shěng",
  "调眼色": "diào,yǎn,sè",
  "调睡参军": "diào,shuì,cān,jūn",
  "调研": "diào,yán",
  "调研员": "diào,yán,yuán",
  "调离": "diào,lí",
  "调立": "diào,lì",
  "调笇": "diào,suàn",
  "调笔": "diào,bǐ",
  "调笙": "diào,shēng",
  "调笛": "diào,dí",
  "调符": "diào,fú",
  "调筝": "diào,zhēng",
  "调簧": "diào,huáng",
  "调类": "diào,lèi",
  "调粉": "diào,fěn",
  "调糜量水": "diào,mí,liáng,shuǐ",
  "调繁": "diào,fán",
  "调练": "diào,liàn",
  "调经": "diào,jīng",
  "调维": "diào,wéi",
  "调罄": "diào,qìng",
  "调罨子": "diào,yǎn,zǐ",
  "调署": "diào,shǔ",
  "调美": "diào,měi",
  "调羽": "diào,yǔ",
  "调翰": "diào,hàn",
  "调职": "diào,zhí",
  "调聚": "diào,jù",
  "调胃": "diào,wèi",
  "调腔": "diào,qiāng",
  "调膳": "diào,shàn",
  "调舱": "diào,cāng",
  "调茬": "diào,chá",
  "调茶": "diào,chá",
  "调药": "diào,yào",
  "调营": "diào,yíng",
  "调虎离山": "diào,hǔ,lí,shān",
  "调虚嚣": "diào,xū,xiāo",
  "调融": "diào,róng",
  "调行": "diào,xíng",
  "调补": "diào,bǔ",
  "调角": "diào,jiǎo",
  "调𬤩": "diào,ài",
  "调讥": "diào,jī",
  "调议": "diào,yì",
  "调讴": "diào,ōu",
  "调诐": "diào,bì",
  "调话": "diào,huà",
  "调诮": "diào,qiào",
  "调说": "diào,shuō",
  "调调": "tiáo,diào",
  "调谇": "diào,suì",
  "调谎": "diào,huǎng",
  "调谕": "diào,yù",
  "调豫": "diào,yù",
  "调责": "diào,zé",
  "调质": "diào,zhì",
  "调贩": "diào,fàn",
  "调贴": "diào,tiē",
  "调赋": "diào,fù",
  "调赴": "diào,fù",
  "调足": "diào,zú",
  "调蹇": "diào,jiǎn",
  "调身": "diào,shēn",
  "调车场": "diào,chē,chǎng",
  "调转": "diào,zhuǎn",
  "调辑": "diào,jí",
  "调辞": "diào,cí",
  "调迁": "diào,qiān",
  "调运": "diào,yùn",
  "调运翁": "diào,yùn,wēng",
  "调迭": "diào,dié",
  "调送": "diào,sòng",
  "调适": "tiáo,shì",
  "调选": "diào,xuǎn",
  "调逗": "diào,dòu",
  "调通": "diào,tōng",
  "调遣": "diào,qiǎn",
  "调配": "diào,pèi",
  "调钟": "diào,zhōng",
  "调门": "diào,mén",
  "调门儿": "diào,mén,ér",
  "调阅": "diào,yuè",
  "调队子": "diào,duì,zǐ",
  "调防": "diào,fáng",
  "调阳": "diào,yáng",
  "调阴": "diào,yīn",
  "调阴阳": "diào,yīn,yáng",
  "调阵": "diào,zhèn",
  "调阵子": "diào,zhèn,zi",
  "调集": "diào,jí",
  "调露": "diào,lù",
  "调革": "diào,gé",
  "调顺": "diào,shùn",
  "调食": "diào,shí",
  "调饍": "diào,shàn",
  "调饥": "zhōu,jī",
  "调饪": "diào,rèn",
  "调马": "diào,mǎ",
  "调驱": "diào,qū",
  "调验": "diào,yàn",
  "调骗": "diào,piàn",
  "调鬼": "diào,guǐ",
  "调鹄": "diào,hú",
  "调鹤": "diào,hè",
  "调鹰": "diào,yīng",
  "调齐": "diào,qí",
  "谄俾": "chǎn,bǐ",
  "谄媚地": "chǎn,mèi,de",
  "谄谩": "chǎn,màn",
  "谄𬮴": "chǎn,ān",
  "谅𬮴": "liàng,ān",
  "谆朴": "zhūn,piáo",
  "谆谆地": "zhūn,zhūn,de",
  "谈判地": "tán,pàn,de",
  "谈得来": "tán,de,lái",
  "谈朋友": "tán,péng,you",
  "谈言微中": "tán,yán,wēi,zhòng",
  "谈论地": "tán,lùn,de",
  "谈道儿": "tán,dào,er",
  "谊切苔岑": "yì,qiè,tái,cén",
  "谋为不轨": "móu,wéi,bù,guǐ",
  "谋划": "móu,huà",
  "谋干": "móu,gàn",
  "谋臣武将": "móu,chén,wǔ,jiàng",
  "谋长": "móu,zhǎng",
  "谍查": "dié,zhā",
  "谎汉子": "huǎng,hàn,zi",
  "谏折": "jiàn,shé",
  "谏舍": "jiàn,shè",
  "谐应": "xié,yìng",
  "谐调": "xié,diào",
  "谐谑地": "xié,xuè,de",
  "谐适": "xié,shì",
  "谑调": "xuè,diào",
  "谒干": "yè,gàn",
  "谒禁": "yè,jìn",
  "谒舍": "yè,shè",
  "谓为": "wèi,wéi",
  "谕帖": "yù,tiē",
  "谕查": "yù,zhā",
  "谗愬": "chán,shuò",
  "谛伺": "dì,sì",
  "谜一样": "mí,yí,yàng",
  "谜一般地": "mí,yì,bān,de",
  "谜儿": "mèi,er",
  "谢家兴": "xiè,jiā,xīng",
  "谢谢": "xiè,xie",
  "谢郎着帽": "xiè,láng,zhe,mào",
  "谤帖": "bàng,tiē",
  "谤累": "bàng,lèi",
  "谦卑地": "qiān,bēi,de",
  "谦恭地": "qiān,gōng,de",
  "谦㧑": "qiān,huī",
  "谦虚地": "qiān,xū,de",
  "谦虚地说": "qiān,xū,de,shuō",
  "谦让地": "qiān,ràng,de",
  "谦逊地": "qiān,xùn,de",
  "谨𠡠": "jǐn,lài",
  "谨处": "jǐn,chǔ",
  "谨干": "jǐn,gàn",
  "谨慎地": "jǐn,shèn,de",
  "谨朴": "jǐn,piáo",
  "谨舍": "jǐn,shè",
  "谩不经意": "màn,bù,jīng,yì",
  "谩与": "màn,yǔ",
  "谩且": "màn,qiě",
  "谩书": "màn,shū",
  "谩他": "màn,tā",
  "谩侮": "màn,wǔ",
  "谩切": "màn,qiē",
  "谩劳": "màn,láo",
  "谩嗟": "màn,jiē",
  "谩天谩地": "màn,tiān,màn,dì",
  "谩夸": "màn,kuā",
  "谩好": "màn,hǎo",
  "谩妒": "màn,dù",
  "谩学": "màn,xué",
  "谩尔": "màn,ěr",
  "谩应": "màn,yìng",
  "谩彧": "màn,yù",
  "谩忆": "màn,yì",
  "谩怜": "màn,lián",
  "谩怠": "màn,dài",
  "谩扣": "màn,kòu",
  "谩昧": "màn,mèi",
  "谩欺": "màn,qī",
  "谩歌": "màn,gē",
  "谩正": "màn,zhèng",
  "谩生": "màn,shēng",
  "谩神": "màn,shén",
  "谩索": "màn,suǒ",
  "谩约": "màn,yuē",
  "谩荒": "màn,huāng",
  "谩蔽": "màn,bì",
  "谩藏": "màn,cáng",
  "谩藏诲盗": "màn,cáng,huì,dào",
  "谩视": "màn,shì",
  "谩言": "màn,yán",
  "谩𫍙": "màn,yí",
  "谩𫍧": "màn,chī",
  "谩𬤀": "màn,háo",
  "谩论": "màn,lùn",
  "谩诈": "màn,zhà",
  "谩词": "màn,cí",
  "谩诚": "màn,chéng",
  "谩诞": "màn,dàn",
  "谩诧": "màn,chà",
  "谩语": "màn,yǔ",
  "谩说": "màn,shuō",
  "谩谀": "màn,yú",
  "谩谩": "màn,màn",
  "谩谰": "màn,lán",
  "谩辞": "màn,cí",
  "谩辞哗说": "màn,cí,huá,shuō",
  "谩道": "màn,dào",
  "谩都歌": "màn,dōu,gē",
  "谩都𬤐": "màn,dōu,gē",
  "谩附": "màn,fù",
  "谩骂": "màn,mà",
  "谪调": "zhé,diào",
  "谬为": "miù,wéi",
  "谬得": "miù,de",
  "谬忒": "miù,tuī",
  "谬误地": "miù,wù,de",
  "谭言微中": "tán,yán,wēi,zhòng",
  "谮愬": "zèn,shuò",
  "谰调": "lán,diào",
  "谰谩": "lán,màn",
  "谱儿": "pǔ,er",
  "谱子": "pǔ,zi",
  "谱帖": "pǔ,tiē",
  "谲数": "jué,shù",
  "谲𫍥": "jué,diào",
  "谴𠡠": "qiǎn,lài",
  "谴累": "qiǎn,lèi",
  "谵妄地": "zhān,wàng,de",
  "谷口子真": "gǔ,kǒu,zi,zhēn",
  "谷嗛": "gǔ,qiàn",
  "谷坊": "gǔ,fáng",
  "谷壳儿": "gǔ,ké,er",
  "谷处": "gǔ,chǔ",
  "谷子": "gǔ,zi",
  "谷梁传": "gǔ,liáng,zhuàn",
  "谷浑": "yù,hún",
  "谷类地": "gǔ,lèi,de",
  "谷蠡": "gǔ,lí",
  "谷蠡王": "gǔ,lí,wáng",
  "谷都": "gǔ,dū",
  "豁亮": "huò,liàng",
  "豁亮亮": "huò,liàng,liàng",
  "豁人耳目": "huò,rén,ěr,mù",
  "豁免": "huò,miǎn",
  "豁免权": "huò,miǎn,quán",
  "豁喇喇": "huō,là,là",
  "豁拳": "huá,quán",
  "豁指头": "huō,zhǐ,tou",
  "豁朗": "huò,lǎng",
  "豁楞": "huō,leng",
  "豁然": "huò,rán",
  "豁然大悟": "huò,rán,dà,wù",
  "豁然开悟": "huò,rán,kāi,wù",
  "豁然开朗": "huò,rán,kāi,lǎng",
  "豁然省悟": "huò,rán,xǐng,wù",
  "豁然确斯": "huò,rán,què,sī",
  "豁然贯通": "huò,rán,guàn,tōng",
  "豁然顿悟": "huò,rán,dùn,wù",
  "豁目": "huò,mù",
  "豁荡": "huò,dàng",
  "豁达": "huò,dá",
  "豁达大度": "huò,dá,dà,dù",
  "豁露": "huō,lù",
  "豆佉": "dòu,qiā",
  "豆分瓜剖": "dòu,fēn,guā,pōu",
  "豆剖瓜分": "dòu,pōu,guā,fēn",
  "豆子": "dòu,zi",
  "豆泡": "dòu,pāo",
  "豆瓣儿": "dòu,bàn,er",
  "豆皀": "dòu,bī",
  "豆秸": "dòu,jí",
  "豆秸灰": "dòu,jí,huī",
  "豆腐乳": "dòu,fu,rǔ",
  "豆腐渣": "dòu,fu,zhā",
  "豆腐渣工程": "dòu,fu,zhā,gōng,chéng",
  "豆腐皮": "dòu,fu,pí",
  "豆腐脑": "dòu,fu,nǎo",
  "豆腐脑儿": "dòu,fǔ,nǎo,er",
  "豆腐花": "dòu,fu,huā",
  "豆花儿": "dòu,huā,er",
  "豆袋弹": "dòu,dài,dàn",
  "豆角儿": "dòu,jué,ér",
  "豆重榆瞑": "dòu,chóng,yú,míng",
  "豕折": "shǐ,shé",
  "豚栅": "tún,shān",
  "豚蹏": "tún,dì",
  "豜𫎆": "jiān,zòng",
  "象上地": "xiàng,shàng,de",
  "象为": "xiàng,wéi",
  "象声词地": "xiàng,shēng,cí,de",
  "象征地": "xiàng,zhēng,de",
  "象征性地": "xiàng,zhēng,xìng,de",
  "象揥": "xiàng,dì",
  "象数": "xiàng,shù",
  "象櫡": "xiàng,zhù",
  "象煞有介事": "xiàng,shà,yǒu,jiè,shì",
  "象箾": "xiàng,xiāo",
  "象载": "xiàng,zǎi",
  "豪华地": "háo,huá,de",
  "豪唫": "háo,yín",
  "豪干暴取": "háo,gàn,bào,qǔ",
  "豪横": "háo,hèng",
  "豪爽地": "háo,shuǎng,de",
  "豫数": "yù,shù",
  "豰觫": "bó,sù",
  "豳什": "bīn,shí",
  "豸冠": "zhì,guān",
  "豸角冠": "zhì,jiǎo,guān",
  "豹侯": "bào,hòu",
  "豹子": "bào,zi",
  "豹子胆": "bào,zi,dǎn",
  "豹子马": "bào,zi,mǎ",
  "豹犆": "bào,tè",
  "豹褎": "bào,yòu",
  "豺虺": "chái,huī",
  "豻侯": "àn,hòu",
  "貂冠": "diāo,guān",
  "貂蝉冠": "diāo,chán,guān",
  "貆猪": "huān,zhū",
  "貈子": "mò,zǐ",
  "貉一丘": "mò,yī,qiū",
  "貉同丘": "mò,tóng,qiū",
  "貉奴": "mò,nú",
  "貉子": "háo,zi",
  "貉睡": "mò,shuì",
  "貉绒": "háo,róng",
  "貉袖": "mò,xiù",
  "貉裘": "mò,qiú",
  "貉道": "mò,dào",
  "貉隶": "mò,lì",
  "貌冠": "mào,guān",
  "貌如其心": "mao,ru,qi,xin",
  "䝙犴": "chū,àn",
  "䝙𦝼": "chū,lóu",
  "𰷞丐": "tè,gài",
  "𰷞贷": "tè,dài",
  "𰷠先录后": "yí,xiān,lù,hòu",
  "𰷠典": "yí,diǎn",
  "𰷠封": "yí,fēng",
  "𰷠庆": "yí,qìng",
  "𰷠恩": "yí,ēn",
  "𰷠爵": "yí,jué",
  "𰷠缪": "yí,miù",
  "𰷠衍": "yí,yǎn",
  "𰷠谬": "yí,miù",
  "𰷠赏": "yí,shǎng",
  "𰷠赠": "yí,zèng",
  "𫎫卷": "dàn,juàn",
  "贝壳儿": "bèi,ké,er",
  "贝夹": "bèi,jiā",
  "贝槛": "bèi,kǎn",
  "贝阙珠宫": "bèi,què,zhū,gōng",
  "贞干": "zhēn,gàn",
  "贞松劲柏": "zhēn,sōng,jìng,bǎi",
  "贞洁地": "zhēn,jié,de",
  "贞淑地": "zhēn,shū,de",
  "贞絜": "zhēn,jié",
  "贞观": "zhēn,guàn",
  "贞观之治": "zhēn,guàn,zhī,zhì",
  "贞观之理": "zhēn,guàn,zhī,lǐ",
  "贞靓": "zhēn,liàng",
  "负侯": "fù,hòu",
  "负俗之累": "fù,sú,zhī,lèi",
  "负债累累": "fù,zhài,lěi,lěi",
  "负向地地": "fù,xiàng,de,de",
  "负地性": "fù,de,xìng",
  "负增长": "fù,zēng,zhǎng",
  "负处": "fù,chǔ",
  "负德背义": "fù,dé,bèi,yì",
  "负恩背义": "fù,ēn,bèi,yì",
  "负担不起": "fù,dān,bu,qǐ",
  "负担舍舟": "fu,dan,she,zhou",
  "负挟": "fù,jiā",
  "负数": "fù,shù",
  "负整数": "fù,zhěng,shù",
  "负气斗狠": "fù,qì,dǒu,hěn",
  "负电荷": "fù,diàn,hè",
  "负累": "fù,lèi",
  "负背": "fù,bèi",
  "负荷": "fù,hè",
  "负责任地": "fù,zé,rèn,de",
  "负驽前驱": "fù,nǔ,qián,qū",
  "贡嘎": "gòng,gá",
  "贡嘎县": "gòng,gá,xiàn",
  "贡禹弹冠": "gòng,yǔ,tán,guān",
  "财不露白": "cái,bù,lù,bái",
  "财会": "cái,kuài",
  "财帑": "cái,tǎng",
  "财政上地": "cái,zhèng,shàng,de",
  "财政部长": "cái,zhèng,bù,zhǎng",
  "财相": "cái,xiàng",
  "财长": "cái,zhǎng",
  "责处": "zé,chǔ",
  "责备似地": "zé,bèi,shì,de",
  "责备地": "zé,bèi,de",
  "责数": "zé,shù",
  "责赂": "zhài,lù",
  "责难": "zé,nàn",
  "责难似地": "zé,nàn,shì,de",
  "责难地": "zé,nàn,de",
  "贤传": "xián,zhuàn",
  "贤侯": "xián,hòu",
  "贤明地": "xián,míng,de",
  "贤相": "xián,xiàng",
  "贤缊": "xián,wēn",
  "贤能地": "xián,néng,de",
  "败军之将": "bài,jūn,zhī,jiàng",
  "败则为寇": "bài,zé,wéi,kòu",
  "败则为虏": "bài,zé,wéi,lǔ",
  "败则为贼": "bài,zé,wéi,zéi",
  "败坏了赫德莱堡的人": "bài,huài,le,hè,dé,lái,pù,de,rén",
  "败坏地": "bài,huài,de",
  "败将": "bài,jiàng",
  "败将残兵": "bài,jiàng,cán,bīng",
  "败折": "bài,shé",
  "败血": "bài,xuè",
  "败血病": "bài,xuè,bìng",
  "败血症": "bài,xuè,zhèng",
  "败露": "bài,lù",
  "账主子": "zhàng,zhǔ,zi",
  "账房先生": "zhàng,fáng,xiān,sheng",
  "账载": "zhàng,zǎi",
  "货币供应量": "huò,bì,gōng,yìng,liàng",
  "货挑子": "huò,tiāo,zi",
  "货架子": "huò,jià,zi",
  "质伛影曲": "zhì,yǔ,yǐng,qū",
  "质因数": "zhì,yīn,shù",
  "质子数": "zhì,zǐ,shù",
  "质干": "zhì,gàn",
  "质当": "zhì,dàng",
  "质数": "zhì,shù",
  "质朴": "zhì,piáo",
  "质朴地": "zhì,piáo,de",
  "质疑问难": "zhì,yí,wèn,nàn",
  "质的": "zhì,dì",
  "质累": "zhì,lèi",
  "质舍": "zhì,shè",
  "质量数": "zhì,liàng,shù",
  "质铺": "zhì,pù",
  "质𬮴": "zhì,ān",
  "质问地": "zhì,wèn,de",
  "质难": "zhì,nàn",
  "贪便宜": "tān,pián,yí",
  "贪婪地": "tān,lán,de",
  "贪婪地吃": "tān,lán,de,chī",
  "贪婪地盯": "tān,lán,de,dīng",
  "贪婪地看": "tān,lán,de,kàn",
  "贪婪地看着": "tān,lán,de,kàn,zhe",
  "贪得": "tān,de",
  "贪心地": "tān,xīn,de",
  "贪惏": "tān,lín",
  "贪惏无餍": "tān,lín,wú,yàn",
  "贪污地": "tān,wū,de",
  "贪污狼藉": "tān,wū,láng,jí",
  "贪玩儿": "tān,wán,er",
  "贪着": "tān,zhe",
  "贪缪": "tān,miù",
  "贪脏枉法": "tān,zāng,wǎng,fǎ",
  "贪财地": "tān,cái,de",
  "贪财好色": "tān,cái,hào,sè",
  "贪食地": "tān,shí,de",
  "贪𫘤": "tān,ái",
  "贫乏地": "pín,fá,de",
  "贫伧": "pín,chen",
  "贫嘴薄舌": "pín,zuǐ,bó,shé",
  "贫困地": "pín,kùn,de",
  "贫困潦倒": "pín,kùn,liáo,dǎo",
  "贫富差距": "pín,fù,chā,jù",
  "贫𪧘": "pín,lóu",
  "贫弱地": "pín,ruò,de",
  "贫相": "pín,xiàng",
  "贫穷地": "pín,qióng,de",
  "贫穷潦倒": "pín,qióng,liáo,dǎo",
  "贫累": "pín,lèi",
  "贫舍": "pín,shè",
  "贫血": "pín,xuè",
  "贫血性坏死": "pín,xuè,xìng,huài,sǐ",
  "贫血症": "pín,xuè,zhèng",
  "贫露": "pín,lù",
  "贬削": "biǎn,xuē",
  "贬剥": "biǎn,bāo",
  "贬处": "biǎn,chǔ",
  "贬弹": "biǎn,dàn",
  "贬折": "biǎn,shé",
  "贬累": "biǎn,lèi",
  "购得": "gòu,de",
  "购销差价": "gòu,xiāo,chā,jià",
  "贯侯": "guàn,hòu",
  "贯月查": "guàn,yuè,zhā",
  "贯注地": "guàn,zhù,de",
  "贰忒": "èr,tuī",
  "贰毂": "èr,gū",
  "贰适": "èr,shì",
  "贱处": "jiàn,chǔ",
  "贱更": "jiàn,gēng",
  "贱皮子": "jiàn,pí,zi",
  "贱累": "jiàn,lèi",
  "贱骨头": "jiàn,gú,tou",
  "贱骨子": "jiàn,gǔ,zi",
  "贲信": "fèn,xìn",
  "贲典": "bēn,diǎn",
  "贲军": "fèn,jūn",
  "贲华": "bēn,huá",
  "贲墉": "bēn,yōng",
  "贲士": "bēn,shì",
  "贲宠": "bēn,chǒng",
  "贲室": "bēn,shì",
  "贲帛": "bēn,bó",
  "贲帱": "bēn,chóu",
  "贲庸": "bēn,yōng",
  "贲彘": "bēn,zhì",
  "贲戋": "bēn,jiān",
  "贲敷": "bēn,fū",
  "贲星": "bēn,xīng",
  "贲治": "bēn,zhì",
  "贲浑": "bēn,hún",
  "贲海": "fèn,hǎi",
  "贲溃": "bēn,kuì",
  "贲然": "bēn,rán",
  "贲石": "bēn,shí",
  "贲禺": "bēn,yú",
  "贲羊": "bēn,yáng",
  "贲耀": "bēn,yào",
  "贲育": "bēn,yù",
  "贲若": "bēn,ruò",
  "贲获": "bēn,huò",
  "贲诸": "bēn,zhū",
  "贲豚": "bēn,tún",
  "贲象": "bēn,xiàng",
  "贲贲": "bēn,bēn",
  "贲赉": "bēn,lài",
  "贲镛": "bēn,yōng",
  "贲门": "bēn,mén",
  "贲隅": "bēn,yú",
  "贲露": "fèn,lù",
  "贲饰": "bēn,shì",
  "贲鼓": "bēn,gǔ",
  "贲龟": "bēn,guī",
  "贳𰷞": "shì,tè",
  "贴切": "tiē,qiè",
  "贴切地": "tiē,qiè,de",
  "贴心地": "tiē,xīn,de",
  "贴本儿": "tiē,běn,er",
  "贴着": "tiē,zhe",
  "贴着地": "tiē,zhe,de",
  "贴调": "tiē,diào",
  "贴身子": "tiē,shēn,zi",
  "贴铺": "tiē,pù",
  "贴饼子": "tiē,bǐng,zi",
  "贵侯": "guì,hòu",
  "贵冠履轻头足": "guì,guān,lǚ,qīng,tóu,zú",
  "贵处": "guì,chǔ",
  "贵干": "guì,gàn",
  "贵族似地": "guì,zú,shì,de",
  "贵族地": "guì,zú,de",
  "贵族般地": "guì,zú,bān,de",
  "贵重地": "guì,zhòng,de",
  "贷帖": "dài,tiē",
  "贷舍": "dài,shè",
  "贷𰷞": "dài,tè",
  "贸折": "mào,shé",
  "贸易逆差": "mào,yì,nì,chā",
  "贸易顺差": "mào,yì,shùn,chā",
  "贸然地": "mào,rán,de",
  "贸载": "mào,zǎi",
  "费力地": "fèi,lì,de",
  "费力地找": "fèi,lì,de,zhǎo",
  "费劲儿": "fèi,jìn,er",
  "费嘴皮子": "fèi,zuǐ,pí,zi",
  "费尔干纳": "fèi,ěr,gàn,nà",
  "费尔干纳盆地": "fèi,ěr,gàn,nà,pén,dì",
  "费尽心思": "fèi,jìn,xīn,si",
  "费尽心血": "fèi,jìn,xīn,xuè",
  "费工夫": "fèi,gōng,fu",
  "费累": "fèi,lèi",
  "费解地": "fèi,jiě,de",
  "贺正": "hè,zhēng",
  "贺葛": "hè,gě",
  "贻累": "yí,lèi",
  "贼忒嘻嘻": "zéi,tuī,xī,xī",
  "贼忒嬉嬉": "zéi,tuī,xī,xī",
  "贼忒忒": "zéi,tuī,tuī",
  "贼溜溜地": "zéi,liū,liū,de",
  "贼馄饨": "zéi,hún,tun",
  "贼骨头": "zéi,gú,tou",
  "贽卷": "zhì,juàn",
  "贾人": "gǔ,rén",
  "贾勇": "gǔ,yǒng",
  "贾夹威德": "jiǎ,jiā,wēi,dé",
  "贾官": "gǔ,guān",
  "贾客": "gǔ,kè",
  "贾害": "gǔ,hài",
  "贾帆": "jiǎ,fān",
  "贾平凹": "jiǎ,píng,wā",
  "贾欺": "gǔ,qī",
  "贾用": "gǔ,yòng",
  "贾田": "gǔ,tián",
  "贾祸": "gǔ,huò",
  "贾贷": "gǔ,dài",
  "贾贸": "gǔ,mào",
  "贾资": "gǔ,zī",
  "贾道": "gǔ,dào",
  "贾马": "gǔ,mǎ",
  "贾马服郑": "gǔ,mǎ,fú,zhèng",
  "贾马许郑": "gǔ,mǎ,xǔ,zhèng",
  "赀载": "zī,zǎi",
  "赁仆": "lìn,pú",
  "赃污狼藉": "zāng,wū,láng,jí",
  "赃私狼藉": "zāng,sī,láng,jí",
  "赃秽狼藉": "zāng,huì,láng,jí",
  "赃累": "zāng,lèi",
  "赃货狼藉": "zāng,huò,láng,jí",
  "赃贿狼藉": "zāng,huì,láng,jí",
  "资予": "zī,yǔ",
  "资兴": "zī,xīng",
  "资兴市": "zī,xīng,shì",
  "资帖": "zī,tiē",
  "资干": "zī,gàn",
  "资料夹": "zī,liào,jiā",
  "资本地": "zī,běn,de",
  "资朴": "zī,piáo",
  "资血": "zī,xuè",
  "资调": "zī,diào",
  "资金杠杆": "zī,jīn,gàng,gǎn",
  "赈捄": "zhèn,jū",
  "赉假": "lài,jià",
  "赋予": "fù,yǔ",
  "赋得": "fù,de",
  "赋调": "fù,diào",
  "赌兴": "dǔ,xīng",
  "赌擂": "dǔ,lèi",
  "赌禁": "dǔ,jìn",
  "赍𠡠": "jī,lài",
  "赍志而没": "jī,zhì,ér,mò",
  "赍调": "jī,diào",
  "赍𰷞": "jī,tè",
  "赎帖": "shú,tiē",
  "赎当": "shú,dàng",
  "赎折": "shú,shé",
  "赎罪地": "shú,zuì,de",
  "赏兴": "shǎng,xīng",
  "赏帖": "shǎng,tiē",
  "赏得": "shǎng,de",
  "赏翫": "shǎng,wàn",
  "赏适": "shǎng,shì",
  "赏钱": "shǎng,qian",
  "赐予": "cì,yǔ",
  "赐舍": "cì,shè",
  "赓和": "gēng,hè",
  "赓载": "gēng,zǎi",
  "赔不是": "péi,bú,shì",
  "赔累": "péi,lěi",
  "赔罪地": "péi,zuì,de",
  "赔还": "péi,huán",
  "赖得": "lài,de",
  "赖皮子": "lài,pí,zi",
  "赖耶": "lài,yē",
  "赘壻得牛": "zhuì,xù,de,niú",
  "赘婿得牛": "zhuì,xù,de,niú",
  "赘斿": "zhuì,yóu",
  "赘累": "zhuì,lèi",
  "赘调": "zhuì,diào",
  "赚哄": "zhuàn,hǒng",
  "赚啜": "zuàn,chuò",
  "赚回来": "zhuàn,huí,lai",
  "赚头": "zhuàn,tou",
  "赚得": "zuàn,de",
  "赚杀": "zuàn,shā",
  "赚法": "zuàn,fǎ",
  "赚煞": "zhuàn,shà",
  "赛先生": "sài,xiān,sheng",
  "赛德娜": "sài,dé,nà",
  "赛过诸葛亮": "sài,guò,zhū,gě,liàng",
  "赜殽": "zé,yáo",
  "赝卷": "yàn,juàn",
  "赞仆": "zàn,pú",
  "赞兴": "zàn,xīng",
  "赞冠": "zàn,guān",
  "赞同地": "zàn,tóng,de",
  "赞呗": "zàn,bài",
  "赞成地": "zàn,chéng,de",
  "赞老子": "zàn,lǎo,zi",
  "赞许地": "zàn,xǔ,de",
  "赞赏地": "zàn,shǎng,de",
  "赠予": "zèng,yǔ",
  "赠处": "zèng,chǔ",
  "赢得": "yíng,de",
  "赢数": "yíng,shù",
  "赤剥": "chì,bāo",
  "赤剥剥": "chì,bāo,bāo",
  "赤堇": "chì,jǐn",
  "赤堇山": "chì,jǐn,shān",
  "赤字累累": "chì,zì,lěi,lěi",
  "赤嵌楼": "chì,kǎn,lóu",
  "赤干": "chì,gàn",
  "赤朴": "chì,piáo",
  "赤查": "chì,zhā",
  "赤爪子": "chì,zhuǎ,zǐ",
  "赤犮": "chì,bá",
  "赤留兀剌": "chì,liú,wū,là",
  "赤绳系足": "chì,shéng,jì,zú",
  "赤翟": "chì,zhái",
  "赤背": "chì,bèi",
  "赤舃": "chì,tuō",
  "赤茀": "chì,bó",
  "赤菟": "chì,tú",
  "赤葛": "chì,gě",
  "赤裸地": "chì,luǒ,de",
  "赤裸裸地": "chì,luǒ,luǒ,de",
  "赤诚相见": "chì,chéng,xiàng,jiàn",
  "赤身露体": "chì,shēn,lù,tǐ",
  "赤道几内亚": "chì,dào,jī,nèi,yà",
  "赤露": "chì,lù",
  "赤鸟夹日": "chì,niǎo,jiā,rì",
  "赦肺侯": "shè,fèi,hòu",
  "赫咺": "hè,xuān",
  "赫塞哥维纳": "hè,sè,gē,wéi,nà",
  "赫氏角鹰": "hè,shì,jué,yīng",
  "赫烜": "hè,huǐ",
  "赫着": "hè,zhe",
  "赫赫之光": "hè,hè,zhì,guāng",
  "赫赫之功": "hè,hè,zhì,gōng",
  "赫蹏": "hè,dì",
  "赫鲁晓夫": "hè,lǔ,xiǎo,fu",
  "赫鲁雪夫": "hè,lǔ,xuě,fu",
  "赭衣塞路": "zhě,yī,sè,lù",
  "走为上": "zǒu,wéi,shàng",
  "走为上着": "zǒu,wèi,shàng,zhāo",
  "走为上策": "zǒu,wéi,shàng,cè",
  "走为上计": "zǒu,wéi,shàng,jì",
  "走了和尚走不了寺": "zǒu,le,hé,shàng,zǒu,bù,liǎo,sì",
  "走了和尚走不了庙": "zǒu,le,hé,shàng,zǒu,bù,liǎo,miào",
  "走吧": "zǒu,ba",
  "走味儿": "zǒu,wèi,er",
  "走形儿": "zǒu,xíng,er",
  "走得起": "zǒu,de,qǐ",
  "走更": "zǒu,gēng",
  "走样儿": "zǒu,yàng,er",
  "走溜儿": "zǒu,liù,ér",
  "走漏消息": "zǒu,lòu,xiāo,xi",
  "走相": "zǒu,xiàng",
  "走着看": "zǒu,zhe,kàn",
  "走着瞧": "zǒu,zhe,qiáo",
  "走神儿": "zǒu,shén,er",
  "走𰬽": "zǒu,jiè",
  "走绳子": "zǒu,shéng,zi",
  "走背字": "zǒu,bèi,zì",
  "走背字儿": "zǒu,bèi,zì,er",
  "走背运": "zǒu,bèi,yùn",
  "走调": "zǒu,diào",
  "走调儿": "zǒu,diào,ér",
  "走路子": "zǒu,lù,zi",
  "走辗": "zǒu,niǎn",
  "走道儿": "zǒu,dào,er",
  "走门子": "zǒu,mén,zi",
  "走阴差": "zǒu,yīn,chā",
  "走露": "zǒu,lù",
  "走骠骑": "zǒu,piào,qí",
  "赴愬": "fù,shuò",
  "赴调": "fù,diào",
  "赴难": "fù,nàn",
  "赵杲送曾哀": "zhào,gǎo,sòng,zēng,āi",
  "赶人不要赶上": "gǎn,rén,bú,yào,gǎn,shàng",
  "赶得上": "gǎn,děi,shàng",
  "赶得及": "gǎn,de,jí",
  "赶明儿": "gǎn,míng,er",
  "赶活儿": "gǎn,huó,er",
  "赶着": "gǎn,zhe",
  "赶紧地": "gǎn,jǐn,de",
  "赶露": "gǎn,lù",
  "赶鸭子": "gǎn,yā,zi",
  "起为头": "qǐ,wéi,tóu",
  "起予": "qǐ,yǔ",
  "起五更": "qǐ,wǔ,gēng",
  "起偃为竖": "qǐ,yǎn,wéi,shù",
  "起冠": "qǐ,guān",
  "起初地": "qǐ,chū,de",
  "起剥": "qǐ,bāo",
  "起劲地": "qǐ,jìn,de",
  "起劲地干": "qǐ,jìn,de,gàn",
  "起劲地笑": "qǐ,jìn,de,xiào",
  "起名儿": "qǐ,míng,er",
  "起哄": "qǐ,hòng",
  "起圈": "qǐ,juàn",
  "起地": "qǐ,de",
  "起处": "qǐ,chǔ",
  "起子": "qǐ,zi",
  "起小儿": "qǐ,xiǎo,er",
  "起居舍人": "qǐ,jū,shè,rén",
  "起床号": "qǐ,chuáng,háo",
  "起开": "qǐ,kai",
  "起数": "qǐ,shù",
  "起更": "qǐ,gēng",
  "起来": "qǐ,lai",
  "起根由头": "qǐ,gēn,yóu,tou",
  "起泡地": "qǐ,pào,de",
  "起泡沫地": "qǐ,pào,mò,de",
  "起解": "qǐ,jiè",
  "起调": "qǐ,diào",
  "起蹶": "qǐ,juě",
  "起重葫芦": "qǐ,chóng,hú,lu",
  "趁兴": "chèn,xīng",
  "趁打哄": "chèn,dǎ,hǒng",
  "趁早儿": "chèn,zǎo,er",
  "趁水和泥": "chèn,shuǐ,huò,ní",
  "趁空": "chèn,kòng",
  "趁风使柁": "chèn,fēng,shǐ,duò",
  "趁风转帆": "chèn,fēng,zhuǎn,fān",
  "趄避": "jū,bì",
  "超一流": "chāo,yì,liú",
  "超人地": "chāo,rén,de",
  "超友谊关系": "chāo,yǒu,yì,guān,xi",
  "超对称": "chāo,duì,chèn",
  "超敏反应": "chāo,mǐn,fǎn,yìng",
  "超然独处": "chāo,rán,dú,chǔ",
  "超着": "chāo,zhe",
  "超群地": "chāo,qún,de",
  "超肉体地": "chāo,ròu,tǐ,de",
  "超自然地": "chāo,zì,rán,de",
  "超负荷": "chāo,fù,hè",
  "超越数": "chāo,yuè,shù",
  "超趠": "chāo,chào",
  "超逴": "chāo,chuò",
  "越分": "yuè,fèn",
  "越处子": "yuè,chǔ,zǐ",
  "越大夫": "yuè,dài,fū",
  "越来越多地": "yuè,lái,yuè,duō,de",
  "越舷地": "yuè,xián,de",
  "越蠡": "yuè,lí",
  "趋向地": "qū,xiàng,de",
  "趋数": "qū,shù",
  "趋背": "qū,bèi",
  "趋舍": "qū,shè",
  "趋药性地": "qū,yào,xìng,de",
  "趋跄": "qū,qiàng",
  "趋蹶": "qū,juě",
  "趑趄": "zī,jū",
  "趑趄不前": "zī,jū,bù,qián",
  "趑趄嗫嚅": "zī,jū,niè,rú",
  "趟地": "tāng,dì",
  "趟水": "tāng,shuǐ",
  "趟浑水": "tāng,hún,shuǐ",
  "趠荦": "chào,luò",
  "趣使": "cù,shǐ",
  "趣兴": "qù,xīng",
  "趣数": "qù,shù",
  "趣督": "cù,dū",
  "趣舍": "qù,shè",
  "趣董": "cù,dǒng",
  "趣袭": "cù,xí",
  "趣装": "cù,zhuāng",
  "趦趄嗫嚅": "zī,jū,niè,rú",
  "𰷶揵": "qiáo,jiàn",
  "趯弄": "yuè,nòng",
  "趯毬": "yuè,qiú",
  "趯然": "yuè,rán",
  "趯球": "yuè,qiú",
  "趯趯": "yuè,yuè",
  "趯鞠": "yuè,jū",
  "足不离地": "zú,bù,lí,de",
  "足不踰户": "zú,bù,yáo,hù",
  "足丢没乱": "zú,diū,mò,luàn",
  "足利义稙": "zú,lì,yì,zhí",
  "足够地": "zú,gòu,de",
  "足帆": "zú,fān",
  "足干": "zú,gàn",
  "足弹陀": "zú,dàn,tuó",
  "足数": "zú,shù",
  "足杆": "zú,gǎn",
  "足足地": "zú,zú,de",
  "趴踢": "pā,ti",
  "趵突": "bō,tū",
  "趵突泉": "bō,tū,quán",
  "趵趵": "bō,bō",
  "趷查": "kē,zhā",
  "趷蹬": "kē,dēng",
  "趷蹬蹬": "kē,dēng,dēng",
  "趸数": "dǔn,shù",
  "趹步": "guì,bù",
  "趹踶": "guì,dì",
  "趹蹄": "guì,tí",
  "趺处": "fū,chǔ",
  "趼子": "jiǎn,zi",
  "趿拉儿": "tā,la,er",
  "趿拉着鞋": "tā,la,zhe,xié",
  "跁跒": "pá,qiǎ",
  "跂坐": "qì,zuò",
  "跂想": "qǐ,xiǎng",
  "跂望": "qǐ,wàng",
  "跂訾": "qǐ,zǐ",
  "跂踦": "qí,jī",
  "跂踵": "qǐ,zhǒng",
  "跂𫏋": "qí,jué",
  "跃踉": "yuè,liàng",
  "跄地": "qiàng,dì",
  "跄扬": "qiàng,yáng",
  "跄捍": "qiàng,hàn",
  "跄济": "qiàng,qí",
  "跄跄": "qiàng,qiàng",
  "跄跄济济": "qiàng,qiàng,qí,jì",
  "跄跄跻跻": "qiàng,qiàng,jī,jī",
  "跄跪": "qiàng,guì",
  "跄跭": "qiàng,xiáng",
  "跄跻": "qiàng,jī",
  "跄踉": "qiàng,liàng",
  "跄逾": "qiàng,yú",
  "跋𠡠": "bá,lài",
  "跋扈地": "bá,hù,de",
  "跋扈恣睢": "bá,hù,zì,suī",
  "跋来报往": "bá,lái,fù,wǎng",
  "跋疐": "bá,dì",
  "跋躠": "bá,xiè",
  "跌了下巴": "diē,le,xià,bā",
  "跌交": "diē,jiāo",
  "跌仆": "diē,pú",
  "跌价": "diē,jià",
  "跌份": "diē,fèn",
  "跌倒": "diē,dǎo",
  "跌停板": "diē,tíng,bǎn",
  "跌剥": "diē,bāo",
  "跌势": "diē,shì",
  "跌千金": "diē,qiān,jīn",
  "跌卦": "diē,guà",
  "跌四平": "diē,sì,píng",
  "跌坐": "diē,zuò",
  "跌坠": "diē,zhuì",
  "跌坡": "diē,pō",
  "跌大": "diē,dà",
  "跌失": "diē,shī",
  "跌子": "diē,zǐ",
  "跌宕": "diē,dàng",
  "跌宕不羁": "dié,dàng,bù,jī",
  "跌宕不覊": "diē,dàng,bù,jī",
  "跌宕昭彰": "diē,dàng,zhāo,zhāng",
  "跌宕格": "dié,dàng,gé",
  "跌宕风流": "diē,dàng,fēng,liú",
  "跌家打事": "diē,jiā,dǎ,shì",
  "跌屑屑": "diē,xiè,xiè",
  "跌岔": "diē,chà",
  "跌市": "diē,shì",
  "跌幅": "diē,fú",
  "跌弹斑鸠": "diē,dàn,bān,jiū",
  "跌成": "diē,chéng",
  "跌扑": "diē,pū",
  "跌打": "diē,dǎ",
  "跌打丸": "diē,dǎ,wán",
  "跌打损伤": "diē,dǎ,sǔn,shāng",
  "跌打药": "diē,dǎ,yào",
  "跌扤": "diē,wù",
  "跌折": "diē,shé",
  "跌断": "diē,duàn",
  "跌来碰去": "diē,lái,pèng,qù",
  "跌根头": "diē,gēn,tóu",
  "跌水": "diē,shuǐ",
  "跌目": "diē,mù",
  "跌眼镜": "diē,yǎn,jìng",
  "跌破": "diē,pò",
  "跌破眼镜": "diē,pò,yǎn,jìng",
  "跌磕": "diē,kē",
  "跌窨": "diē,xūn",
  "跌翻": "diē,fān",
  "跌脚": "diē,jiǎo",
  "跌脚扮手": "diē,jiǎo,bàn,shǒu",
  "跌脚捶胸": "diē,jiǎo,chuí,xiōng",
  "跌脚搥胸": "diē,jiǎo,chuī,xiōng",
  "跌脚槌胸": "diē,jiǎo,chuí,xiōng",
  "跌脚绊手": "diē,jiǎo,bàn,shǒu",
  "跌至": "diē,zhì",
  "跌至谷底": "diē,zhì,gǔ,dǐ",
  "跌荡": "diē,dàng",
  "跌荡不拘": "diē,dàng,bù,jū",
  "跌荡不羁": "diē,dàng,bù,jī",
  "跌荡风流": "diē,dàng,fēng,liú",
  "跌落": "diē,luò",
  "跌误": "diē,wù",
  "跌足": "diē,zú",
  "跌跌冲冲": "diē,diē,chōng,chōng",
  "跌跌挞挞": "diē,diē,tà,tà",
  "跌跌撞撞": "diē,die,zhuàng,zhuàng",
  "跌跌滚滚": "diē,diē,gǔn,gǔn",
  "跌跌爬爬": "diē,diē,pá,pá",
  "跌跌绊绊": "diē,diē,bàn,bàn",
  "跌跌跄跄": "diē,diē,qiàng,qiàng",
  "跌跌𬧀𬧀": "diē,diē,qiāng,qiāng",
  "跌跌铳铳": "diē,diē,chòng,chòng",
  "跌跤": "diē,jiāo",
  "跌跪": "diē,guì",
  "跌踒": "diē,wō",
  "跌踣": "diē,bó",
  "跌𰸄": "diē,táng",
  "跌蹉": "diē,cuō",
  "跌蹏": "diē,dì",
  "跌蹶": "diē,juě",
  "跌蹼": "diē,pǔ",
  "跌躞躞": "diē,xiè,xiè",
  "跌进": "diē,jìn",
  "跌退": "diē,tuì",
  "跌𰺲": "diē,dàng",
  "跌钱": "diē,qián",
  "跌顿": "diē,dùn",
  "跌风": "diē,fēng",
  "跎背": "tuó,bèi",
  "跐着门槛": "cǐ,zhe,mén,kǎn",
  "跐踦": "cī,jī",
  "跐蹬": "cī,dēng",
  "跑供销": "pǎo,gōng,xiāo",
  "跑味儿": "pǎo,wèi,er",
  "跑堂儿": "pǎo,táng,er",
  "跑堂儿的": "pǎo,táng,er,de",
  "跑尖子": "pǎo,jiān,zi",
  "跑槽": "páo,cáo",
  "跑泉": "páo,quán",
  "跑神儿": "pǎo,shén,er",
  "跑腿子": "pǎo,tuǐ,zi",
  "跑调": "pǎo,diào",
  "跑马卖解": "pǎo,mǎ,mài,xiè",
  "跒跁": "qiǎ,pá",
  "跕坠": "dié,zhuì",
  "跕堕": "dié,duò",
  "跕屣": "dié,xǐ",
  "跕班": "dié,bān",
  "跕立": "dié,lì",
  "跕跕": "dié,dié",
  "跕蹀": "dié,dié",
  "跕蹝": "dié,xǐ",
  "跕躔": "dié,chán",
  "跕躞": "dié,xiè",
  "跕𰸐": "dié,xǐ",
  "跕鸢": "dié,yuān",
  "跖犬吠尧": "zhí,quán,fèi,yáo",
  "跖𫏋": "zhí,jué",
  "跗萼载𮧵": "fū,è,zǎi,wěi",
  "跗蕚载𮧵": "fū,è,zǎi,wěi",
  "跛子": "bǒ,zi",
  "跛行地": "bǒ,xíng,de",
  "跛踦": "bǒ,jī",
  "跛蹶": "bǒ,juě",
  "距趯": "jù,yuè",
  "距跃三百": "jū,yuè,sān,bǎi",
  "跞躁": "luò,zào",
  "跟上地": "gēn,shàng,de",
  "跟不上": "gēn,bu,shàng",
  "跟头": "gēn,tou",
  "跟头戏": "gēn,tou,xì",
  "跟头虫": "gēn,tou,chóng",
  "跟屁股": "gēn,pì,gu",
  "跟差": "gēn,chāi",
  "跟斗": "gēn,dǒu",
  "跟斗翻": "gēn,dǒu,fān",
  "跟斗虫": "gēn,dǒu,chóng",
  "跟班儿": "gēn,bān,er",
  "跟着": "gēn,zhe",
  "跟超掖夹": "gēn,chāo,yè,jiā",
  "跣剥": "xiǎn,bāo",
  "跣露": "xiǎn,lù",
  "跧仆": "quán,pú",
  "跧折": "quán,shé",
  "跨缝": "kuà,fèng",
  "跨行业": "kuà,háng,yè",
  "跨跞": "kuà,luò",
  "跨蹍": "kuà,zhǎn",
  "跨辗": "kuà,niǎn",
  "跨院儿": "kuà,yuàn,er",
  "跪下": "guì,xia",
  "路上比终点更有意义": "lù,shang,bǐ,zhōng,diǎn,gèng,yǒu,yì,yì",
  "路卡": "lù,qiǎ",
  "路堤": "lù,dī",
  "路子": "lù,zi",
  "路数": "lù,shù",
  "跰足": "bèng,zú",
  "跰趾": "bèng,zhǐ",
  "跰跚": "bèng,shān",
  "跰跰": "bèng,bèng",
  "跰跹": "bèng,xiān",
  "跲疐": "jiá,dì",
  "跲踬": "jiá,zhì",
  "跳一只脚": "tiào,yī,zhī,jiǎo",
  "跳动地": "tiào,dòng,de",
  "跳喇嘛": "tiào,lǎ,ma",
  "跳弹": "tiào,dàn",
  "跳房子": "tiào,fáng,zi",
  "跳皮筋儿": "tiào,pí,jīn,er",
  "跳行": "tiào,háng",
  "跳趯": "tiào,yuè",
  "跳跳钻钻": "tiào,tiào,zuàn,zuàn",
  "跳蹬": "tiào,dēng",
  "跳蹶": "tiào,juě",
  "践更": "jiàn,gēng",
  "践翟": "jiàn,zhái",
  "跷趹": "qiāo,guì",
  "跷踦": "qiāo,jī",
  "跷蹬弩": "qiāo,dēng,nǔ",
  "跷辫子": "qiāo,biàn,zi",
  "跺蹬": "duò,dēng",
  "跻跻跄跄": "jī,jī,qiàng,qiàng",
  "踅子": "xué,zi",
  "踅折": "xué,shé",
  "踅摸": "xué,mo",
  "踆乌": "cūn,wū",
  "踉跄": "liàng,qiàng",
  "踉跄地走": "liàng,qiàng,de,zǒu",
  "踉跳": "liàng,tiào",
  "踉踉跄跄": "liàng,liàng,qiàng,qiàng",
  "踉𬧀": "liàng,qiàng",
  "踌躇地": "chóu,chú,de",
  "踏实": "tā,shi",
  "踏实地": "tà,shí,de",
  "踏拍子": "tà,pāi,zi",
  "踏斗": "tà,dǒu",
  "踏破门槛": "tā,pò,mén,kǎn",
  "踏𥬞": "tà,mí",
  "踏踏": "tā,tà",
  "踏踏实实": "tā,tā,shí,shí",
  "踏踏歌": "tā,tà,gē",
  "踏踏玛儿": "tā,tà,mǎ,ér",
  "踏踧": "tà,dí",
  "踏蹬": "tà,dēng",
  "踏𫏋": "tà,jué",
  "踏高𫏋": "tà,gāo,jué",
  "踒折": "wō,shé",
  "踒跌": "wō,diē",
  "踔跞": "chuō,luò",
  "踖踧": "jí,dí",
  "踜蹬": "lèng,dēng",
  "踞鼃食蛤": "jù,wā,shí,há",
  "踠折": "wǎn,shé",
  "踠跌": "wǎn,diē",
  "踠蹏": "wǎn,dì",
  "踢嚓咯嚓": "tī,chā,gē,chā",
  "踢断门槛": "tī,duàn,mén,kǎn",
  "踢毽子": "tī,jiàn,zi",
  "踢蹬": "tī,dēng",
  "踢鞬": "tī,jiān",
  "踢鞬子": "tī,jiān,zǐ",
  "踣跌": "bó,diē",
  "踣蹶": "bó,juě",
  "踦偶": "jī,ǒu",
  "踦只": "jī,zhī",
  "踦履": "jī,lǚ",
  "踦屦": "jī,jù",
  "踦户": "jī,hù",
  "踦挐": "jī,ná",
  "踦校": "jī,xiào",
  "踦牂": "jī,zāng",
  "踦犊": "jī,dú",
  "踦跂": "jī,qí",
  "踦跛": "jī,bǒ",
  "踦踦": "jī,jī",
  "踦重": "jī,zhòng",
  "踦闾": "jī,lǘ",
  "踦零钱": "jī,líng,qián",
  "踦颇": "jī,pō",
  "踧口": "dí,kǒu",
  "踧沑": "dí,nǜ",
  "踧然": "dí,rán",
  "踧眉": "dí,méi",
  "踧笮": "cù,zé",
  "踧缩": "dí,suō",
  "踧行": "dí,xíng",
  "踧足": "dí,zú",
  "踧踧": "dí,dí",
  "踧蹐": "dí,jí",
  "踧蹜": "dí,sù",
  "踧迫": "dí,pò",
  "踩刹车": "cǎi,shā,chē",
  "踩杆": "cǎi,gǎn",
  "踩高𫏋": "cǎi,gāo,jué",
  "踬跲": "zhì,jiá",
  "踬蹶": "zhì,juě",
  "踳缪": "chuǎn,miù",
  "踵兴": "zhǒng,xīng",
  "踵踵跌跌": "zhǒng,zhǒng,diē,diē",
  "踶趹": "dì,guì",
  "踶跂": "dì,zhī",
  "踶蹶": "dì,juě",
  "踹一脚": "chuài,yì,jiǎo",
  "踹蹬": "chuài,dēng",
  "𰸄跌": "táng,diē",
  "踾踧": "fú,dí",
  "踿跄": "zú,qiàng",
  "蹀儿鸭子": "dié,er,yā,zi",
  "蹀血": "dié,xuè",
  "蹂掠": "róu,lüě",
  "蹄子": "tí,zi",
  "蹄毂": "tí,gū",
  "蹄趹": "tí,guì",
  "蹄蹶": "tí,juě",
  "蹄闲三寻": "tí,jiàn,sān,xún",
  "蹄间三寻": "tí,jiàn,sān,xún",
  "蹄髈": "tí,pǎng",
  "蹇剥": "jiǎn,bāo",
  "蹇数": "jiǎn,shù",
  "蹇蹶": "jiǎn,juě",
  "蹈矩循彟": "dǎo,jǔ,xún,yuē",
  "蹈背": "dǎo,bèi",
  "蹈藉": "dǎo,jí",
  "蹈锋饮血": "dǎo,fēng,yǐn,xuè",
  "蹈难": "dǎo,nàn",
  "蹉跌": "cuō,diē",
  "蹊径": "xī,jìng",
  "蹊田": "xī,tián",
  "蹊田夺牛": "xī,tián,duó,niú",
  "蹊𫏋": "qī,jué",
  "蹍地": "zhǎn,dì",
  "蹍履": "zhǎn,lǚ",
  "蹍步": "zhǎn,bù",
  "蹍水": "zhǎn,shuǐ",
  "蹍然": "zhǎn,rán",
  "蹍足": "zhǎn,zú",
  "蹍踏": "zhǎn,tà",
  "蹎仆": "diān,pú",
  "蹎跌": "diān,diē",
  "蹎蹶": "diān,juě",
  "蹑𪨗檐簦": "niè,juàn,yán,dēng",
  "蹑手蹑脚地走动": "niè,shǒu,niè,jiǎo,de,zǒu,dòng",
  "蹑景": "niè,yǐng",
  "蹑着脚": "niè,zhe,jiǎo",
  "蹑蹬": "niè,dēng",
  "蹑𫏋": "niè,jué",
  "蹑𫏋担簦": "niè,juē,dān,dēng",
  "蹑𫏋檐簦": "niè,juē,dàn,dēng",
  "蹒跚地": "pán,shān,de",
  "蹒跚地走": "pán,shān,de,zǒu",
  "蹓晃": "liū,huàng",
  "蹓跶": "liū,da",
  "蹙削": "cù,xuē",
  "蹙折": "cù,shé",
  "蹙蹙靡骋": "cù,cù,mǐ,chěng",
  "𰸚嵲": "dié,niè",
  "蹢躅": "zhí,zhú",
  "蹦儿": "bèng,er",
  "蹦出来": "bèng,chū,lai",
  "蹦跳地走": "bèng,tiào,de,zǒu",
  "蹦跶": "bèng,da",
  "蹦蹦儿车": "bèng,bèng,er,chē",
  "蹦蹦调": "bèng,bèng,diào",
  "蹦高儿": "bèng,gāo,er",
  "蹧塌": "zāo,tà",
  "蹩躠": "bié,xiè",
  "蹬地": "dēng,de",
  "蹬子": "dēng,zi",
  "蹬弹": "dēng,dàn",
  "蹬心拳": "dēng,xīn,quán",
  "蹬心拳头": "dēng,xīn,quán,tou",
  "蹬技": "dēng,jì",
  "蹬梯": "dēng,tī",
  "蹬空": "dēng,kōng",
  "蹬脚": "dēng,jiǎo",
  "蹬脱": "dēng,tuō",
  "蹬腿": "dēng,tuǐ",
  "蹬足": "dēng,zú",
  "蹬跶": "dēng,dá",
  "蹬踏": "dēng,tà",
  "蹬蹭": "dèng,cèng",
  "蹬道": "dēng,dào",
  "蹬鼻子上脸": "dēng,bí,zi,shàng,liǎn",
  "蹭蹬": "cèng,dèng",
  "蹲跕": "dūn,dié",
  "蹲蹬": "dūn,dēng",
  "蹲蹲": "cún,cún",
  "蹲马步": "dùn,mǎ,bù",
  "蹴折": "cù,shé",
  "蹴毱": "cù,jú",
  "蹴跄": "cù,qiàng",
  "蹶仆": "juě,pú",
  "蹶倒": "juě,dǎo",
  "蹶兴": "juě,xīng",
  "蹶劣": "juě,liè",
  "蹶动": "juě,dòng",
  "蹶失": "juě,shī",
  "蹶张": "juě,zhāng",
  "蹶张士": "juě,zhāng,shì",
  "蹶弩": "juě,nǔ",
  "蹶拔": "juě,bá",
  "蹶撒": "juě,sā",
  "蹶机": "juě,jī",
  "蹶死": "juě,sǐ",
  "蹶泄": "juě,xiè",
  "蹶然": "juě,rán",
  "蹶痿": "juě,wěi",
  "蹶穴": "juě,xué",
  "蹶船": "juě,chuán",
  "蹶蛩": "juě,qióng",
  "蹶衂": "juě,nǜ",
  "蹶趋": "juě,qū",
  "蹶跃": "juě,yuè",
  "蹶跌": "juě,diē",
  "蹶踣": "juě,bó",
  "蹶踬": "juě,zhì",
  "蹶蹄": "juě,tí",
  "蹶蹏": "juě,dì",
  "蹶蹙": "juě,cù",
  "蹶蹶": "juě,juě",
  "蹶躄": "juě,bì",
  "蹶阴": "juě,yīn",
  "𫏋健": "jué,jiàn",
  "𫏋勇": "jué,yǒng",
  "𫏋容": "jué,róng",
  "𫏋履": "jué,lǚ",
  "𫏋捷": "jué,jié",
  "𫏋疾": "jué,jí",
  "𫏋腾": "jué,téng",
  "𫏋跖": "jué,zhí",
  "𫏋𫏋": "jué,jué",
  "蹼蹬": "pǔ,dēng",
  "躁剽": "zào,piāo",
  "躁舍": "zào,shè",
  "躁露": "zào,lù",
  "躃躠": "bì,xiè",
  "躅路": "zhuó,lù",
  "躏跞": "lìn,luò",
  "𨅬跞": "lán,luò",
  "𰸐舃": "xǐ,tuō",
  "𰸐高𫏋": "xǐ,gāo,jué",
  "身不离地": "shēn,bù,lí,de",
  "身个子": "shēn,gè,zi",
  "身为": "shēn,wéi",
  "身体上地": "shēn,tǐ,shàng,de",
  "身体发肤": "shēn,tǐ,fà,fū",
  "身体地": "shēn,tǐ,de",
  "身体质量指数": "shēn,tǐ,zhì,liàng,zhǐ,shù",
  "身体部分": "shēn,tǐ,bù,fèn",
  "身先朝露": "shēn,xiān,cháo,lù",
  "身兼数职": "shēn,jiān,shù,zhí",
  "身分": "shēn,fèn",
  "身分不明": "shēn,fèn,bù,míng",
  "身分证": "shēn,fèn,zhèng",
  "身分证号码": "shēn,fèn,zhèng,hào,mǎ",
  "身单力薄": "shēn,dān,lì,bó",
  "身名两泰": "shēn,míng,liǎng,tai",
  "身名俱泰": "shēn,míng,jù,tai",
  "身处": "shēn,chǔ",
  "身处险境": "shēn,chǔ,xiǎn,jìng",
  "身子": "shēn,zi",
  "身子骨": "shēn,zi,gǔ",
  "身子骨儿": "shēn,zi,gǔ,ér",
  "身家调查": "shēn,jiā,diào,chá",
  "身帖": "shēn,tiē",
  "身干": "shēn,gàn",
  "身无立锥": "sheng,wu,li,zhui",
  "身条儿": "shēn,tiáo,er",
  "身板儿": "shēn,bǎn,er",
  "身毒": "yuān,dú",
  "躬自菲薄": "gōng,zì,fěi,bó",
  "躭翫": "dān,wàn",
  "躯壳": "qū,qiào",
  "躯干": "qū,gàn",
  "躯干骨": "qū,gàn,gǔ",
  "躲不起": "duǒ,bu,qǐ",
  "躲得和尚躲不得寺": "duǒ,de,hé,shàng,duǒ,bù,dé,sì",
  "躲煞": "duǒ,shà",
  "躲避不了地": "duǒ,bì,bù,liǎo,de",
  "躲避地": "duǒ,bì,de",
  "躲难": "duǒ,nàn",
  "躹躬": "jú,gōng",
  "躺着也中枪": "tǎng,zhe,yě,zhòng,qiāng",
  "躺着地": "tǎng,zhe,de",
  "𫐉𫐌": "líng,pēng",
  "軪轧": "āo,zhá",
  "𬨄轧": "yǎng,zhá",
  "𫐌凑": "pēng,còu",
  "𫐌列": "pēng,liè",
  "𫐌接": "pēng,jiē",
  "𫐌罗衣": "pēng,luó,yī",
  "𫐌臻": "pēng,zhēn",
  "𫐌訇": "pēng,hōng",
  "𫐌车": "pēng,chē",
  "𫐌轩": "pēng,xuān",
  "𫐌辂": "pēng,lù",
  "𫐌辎": "pēng,zī",
  "𫐌阗": "pēng,tián",
  "𫐌马": "pēng,mǎ",
  "𫐌驰": "pēng,chí",
  "𰹼路": "zhàn,lù",
  "𰹼辂": "zhàn,lù",
  "𰺏轧": "péng,zhá",
  "𫐖葛": "jiāo,gě",
  "𫐖轧": "jiāo,zhá",
  "𰺛釜": "láo,fǔ",
  "𰺛铛": "láo,chēng",
  "𰺛阳": "láo,yáng",
  "𰺛饭": "láo,fàn",
  "𫐘轲": "kǎn,kě",
  "𮝹刑": "huán,xíng",
  "𮝹曲": "huán,qǔ",
  "𮝹磔": "huán,zhé",
  "𮝹脔": "huán,luán",
  "𮝹药": "huán,yào",
  "𮝹身": "huán,shēn",
  "𮝹辕": "huán,yuán",
  "车上吐茵": "chē,shàng,tù,yīn",
  "车丞相": "chē,chéng,xiàng",
  "车什": "chē,shí",
  "车仆": "chē,pú",
  "车份儿": "chē,fèn,er",
  "车厘子": "chē,lí,zi",
  "车头相": "chē,tóu,xiàng",
  "车子": "chē,zi",
  "车斗": "chē,dǒu",
  "车毂": "chē,gū",
  "车熬": "chē,áo",
  "车葥": "chē,jiàn",
  "车蕃": "chē,fān",
  "车行道": "chē,háng,dào",
  "车蹬": "chē,dēng",
  "车𫐌": "chē,pēng",
  "车𮝹": "chē,huán",
  "车轮子": "chē,lún,zi",
  "车载斗量": "chē,zài,dǒu,liáng",
  "车载船装": "chē,zǎi,chuán,zhuāng",
  "车量斗数": "chē,liàng,dòu,shù",
  "车马炮": "jū,mǎ,pào",
  "轧伊": "zhá,yī",
  "轧制": "zhá,zhì",
  "轧勒": "zhá,lè",
  "轧口": "zhá,kǒu",
  "轧姘头": "zhá,pīn,tou",
  "轧实": "zhá,shí",
  "轧弦": "zhá,xián",
  "轧忽": "zhá,hū",
  "轧拉": "zhá,lā",
  "轧捺": "zhá,nà",
  "轧摩": "zhá,mó",
  "轧敚排很": "zhá,duó,pái,hěn",
  "轧朋友": "gá,péng,yǒu",
  "轧机": "zhá,jī",
  "轧沕": "zhá,mì",
  "轧然": "zhá,rán",
  "轧盘": "zhá,pán",
  "轧空": "gá,kōng",
  "轧空头": "gá,kōng,tóu",
  "轧窒": "zhá,zhì",
  "轧筝": "zhá,zhēng",
  "轧米": "zhá,mǐ",
  "轧色": "zhá,sè",
  "轧芴": "zhá,wù",
  "轧茁": "zhá,zhuó",
  "轧荦山": "zhá,luò,shān",
  "轧账": "gá,zhàng",
  "轧车": "zhá,chē",
  "轧轹": "zhá,lì",
  "轧辊": "zhá,gǔn",
  "轧辞": "zhá,cí",
  "轧钢": "zhá,gāng",
  "轧钢厂": "zhá,gāng,chǎng",
  "轧钢机": "zhá,gāng,jī",
  "轧钢条": "zhá,gāng,tiáo",
  "轧铄": "zhá,shuò",
  "轧雁": "zhá,yàn",
  "轧露": "zhá,lù",
  "轧鸦": "zhá,yā",
  "轨忒": "guǐ,tuī",
  "轨数": "guǐ,shù",
  "轨物范世": "guī,wù,fàn,shì",
  "轩帆": "xuān,fān",
  "轩干": "xuān,gàn",
  "轩禁": "xuān,jìn",
  "轩豁": "xuān,huò",
  "轩𫐌": "xuān,pēng",
  "轩露": "xuān,lù",
  "轩骜": "xuān,ào",
  "转一趟": "zhuàn,yī,tàng",
  "转为": "zhuǎn,wéi",
  "转动": "zhuàn,dòng",
  "转动件": "zhuàn,dòng,jiàn",
  "转动轴": "zhuàn,dòng,zhóu",
  "转危为安": "zhuǎn,wēi,wéi,ān",
  "转去": "zhuàn,qù",
  "转台": "zhuàn,tái",
  "转嗔为喜": "zhuǎn,chēn,wéi,xǐ",
  "转圈": "zhuàn,quān",
  "转圈子": "zhuàn,quān,zi",
  "转塔": "zhuàn,tǎ",
  "转子": "zhuàn,zǐ",
  "转子莲": "zhuàn,zǐ,lián",
  "转字锁": "zhuàn,zì,suǒ",
  "转差": "zhuǎn,chā",
  "转差率": "zhuǎn,chā,lǜ",
  "转帆": "zhuǎn,fān",
  "转帖": "zhuǎn,tiē",
  "转干": "zhuǎn,gàn",
  "转弯子": "zhuǎn,wān,zi",
  "转弯抹角": "zhuǎn,wān,mò,jiǎo",
  "转忧为喜": "zhuǎn,yōu,wéi,xǐ",
  "转悠": "zhuàn,yōu",
  "转悲为喜": "zhuǎn,bēi,wéi,xǐ",
  "转愁为喜": "zhuǎn,chóu,wéi,xǐ",
  "转文": "zhuǎi,wén",
  "转晃": "zhuǎn,huàng",
  "转来": "zhuàn,lái",
  "转来转去": "zhuàn,lái,zhuàn,qù",
  "转椅": "zhuàn,yǐ",
  "转毂": "zhuǎn,gū",
  "转浑天仪": "zhuàn,hún,tiān,yí",
  "转游": "zhuàn,you",
  "转湾抹角": "zhuǎn,wān,mò,jiǎo",
  "转灾为福": "zhuǎn,zāi,wéi,fú",
  "转炉": "zhuàn,lú",
  "转矩": "zhuàn,jǔ",
  "转矩臂": "zhuàn,jǔ,bì",
  "转磨": "zhuàn,mò",
  "转祸为福": "zhuǎn,huò,wéi,fú",
  "转笔刀": "zhuàn,bǐ,dāo",
  "转筋": "zhuàn,jīn",
  "转纽": "zhuàn,niǔ",
  "转置": "zhuàn,zhì",
  "转背": "zhuǎn,bèi",
  "转腰": "zhuàn,yāo",
  "转腰子": "zhuàn,yāo,zi",
  "转行": "zhuǎn,háng",
  "转讽": "zhuǎn,fěng",
  "转调": "zhuǎn,diào",
  "转败为功": "zhuǎn,bài,wéi,gōng",
  "转败为成": "zhuǎn,bài,wéi,chéng",
  "转败为胜": "zhuǎn,bài,wéi,shèng",
  "转軐": "zhuǎn,xiàn",
  "转车台": "zhuàn,chē,tái",
  "转轮": "zhuàn,lún",
  "转轮圣王": "zhuàn,lún,shèng,wáng",
  "转轮手枪": "zhuàn,lún,shǒu,qiāng",
  "转轮藏": "zhuàn,lún,cáng",
  "转轴儿": "zhuàn,zhóu,er",
  "转载": "zhuǎn,zǎi",
  "转辗": "zhuǎn,niǎn",
  "转速": "zhuàn,sù",
  "转速比": "zhuàn,sù,bǐ",
  "转速表": "zhuàn,sù,biǎo",
  "转铃": "zhuàn,líng",
  "转铃儿": "zhuàn,líng,er",
  "转门": "zhuàn,mén",
  "转鼓": "zhuàn,gǔ",
  "轮休地": "lún,xiū,de",
  "轮子": "lún,zi",
  "轮更": "lún,gēng",
  "轮机长": "lún,jī,zhǎng",
  "轮流地": "lún,liú,de",
  "轮种": "lún,zhòng",
  "轮蹏": "lún,dì",
  "轮𫐌": "lún,pēng",
  "轮𰺛": "lún,láo",
  "轮转": "lún,zhuàn",
  "轮转椅": "lún,zhuàn,yǐ",
  "软兀剌": "ruǎn,wū,là",
  "软刀子": "ruǎn,dāo,zi",
  "软化地": "ruǎn,huà,de",
  "软厮禁": "ruǎn,sī,jìn",
  "软古囊囊": "ruǎn,gǔ,nāng,nang",
  "软叽咯托": "ruǎn,jī,gē,tuō",
  "软呢": "ruǎn,ní",
  "软和": "ruǎn,huo",
  "软和和": "ruǎn,huo,hé",
  "软囊囊": "ruǎn,nāng,nang",
  "软弱地": "ruǎn,ruò,de",
  "软揣": "ruǎn,chuāi",
  "软揣揣": "ruǎn,chuāi,chuāi",
  "软柿子": "ruǎn,shì,zi",
  "软泥儿": "ruǎn,ní,er",
  "软禁": "ruǎn,jìn",
  "软耳朵": "ruǎn,ěr,duo",
  "软背脊": "ruǎn,bèi,jǐ",
  "软脓咂血": "ruǎn,nóng,zā,xuè",
  "软钉子": "ruǎn,dīng,zi",
  "软铺铺": "ruǎn,pù,pù",
  "软骨头": "ruǎn,gú,tou",
  "轰动地": "hōng,dòng,de",
  "轰动效应": "hōng,dòng,xiào,yìng",
  "轰哄": "hōng,hǒng",
  "轰地一声": "hōng,de,yī,shēng",
  "轰应": "hōng,yìng",
  "轰隆": "hōng,lōng",
  "轰隆地响": "hōng,lōng,de,xiǎng",
  "轰隆轰隆": "hōng,lōng,hōng,lōng",
  "轰隆隆": "hōng,lōng,lóng",
  "轴上地": "zhóu,shàng,de",
  "轴对称": "zhóu,duì,chèn",
  "轵虺": "zhǐ,huī",
  "轸宿": "zhěn,xiù",
  "轹跞辚辚": "lì,luò,lín,lín",
  "轺毂": "yáo,gū",
  "轻佻地": "qīng,tiāo,de",
  "轻侻": "qīng,tuì",
  "轻信地": "qīng,xìn,de",
  "轻剽": "qīng,piāo",
  "轻嘴薄舌": "qīng,zuǐ,bó,shé",
  "轻地": "qīng,de",
  "轻声地": "qīng,shēng,de",
  "轻声地讲": "qīng,shēng,de,jiǎng",
  "轻声地说": "qīng,shēng,de,shuō",
  "轻声地走": "qīng,shēng,de,zǒu",
  "轻媠": "qīng,duò",
  "轻嫷": "qīng,duò",
  "轻帆": "qīng,fān",
  "轻微地": "qīng,wēi,de",
  "轻快地": "qīng,kuài,de",
  "轻快地动": "qīng,kuài,de,dòng",
  "轻快地唱": "qīng,kuài,de,chàng",
  "轻快地说": "qīng,kuài,de,shuō",
  "轻快地走": "qīng,kuài,de,zǒu",
  "轻快地飞": "qīng,kuài,de,fēi",
  "轻悠悠地": "qīng,yōu,yōu,de",
  "轻才好施": "qīng,cái,hào,shī",
  "轻易地": "qīng,yì,de",
  "轻松地": "qīng,sōng,de",
  "轻松地做": "qīng,sōng,de,zuò",
  "轻松地笑": "qīng,sōng,de,xiào",
  "轻松地说": "qīng,sōng,de,shuō",
  "轻柔地": "qīng,róu,de",
  "轻水反应堆": "qīng,shuǐ,fǎn,yìng,duī",
  "轻沤": "qīng,ōu",
  "轻浪浮薄": "qīng,làng,fú,bó",
  "轻浮地": "qīng,fú,de",
  "轻狂地": "qīng,kuáng,de",
  "轻率": "qīng,shuài",
  "轻率地": "qīng,shuài,de",
  "轻率地说": "qīng,shuài,de,shuō",
  "轻盈地": "qīng,yíng,de",
  "轻蔑地": "qīng,miè,de",
  "轻蔑地一笑": "qīng,miè,de,yī,xiào",
  "轻蔑地拒绝": "qīng,miè,de,jù,jué",
  "轻蔑地笑": "qīng,miè,de,xiào",
  "轻薄": "qīng,bó",
  "轻薄莲华": "qīng,bó,lián,huá",
  "轻装地": "qīng,zhuāng,de",
  "轻视地": "qīng,shì,de",
  "轻𰵏": "qīng,miǎo",
  "轻讽": "qīng,fěng",
  "轻谩": "qīng,màn",
  "轻财好义": "qīng,cái,hào,yì",
  "轻𫏋": "qīng,jué",
  "轻輭": "qīng,ér",
  "轻轻地": "qīng,qīng,de",
  "轻轻地一推": "qīng,qīng,de,yī,tuī",
  "轻轻地吹": "qīng,qīng,de,chuī",
  "轻轻地吹着": "qīng,qīng,de,chuī,zhe",
  "轻轻地吻了一下": "qīng,qīng,de,wěn,le,yī,xià",
  "轻轻地咬": "qīng,qīng,de,yǎo",
  "轻轻地咬着": "qīng,qīng,de,yǎo,zhe",
  "轻轻地在上面": "qīng,qīng,de,zài,shàng,miàn",
  "轻轻地将": "qīng,qīng,de,jiāng",
  "轻轻地打": "qīng,qīng,de,dǎ",
  "轻轻地抓": "qīng,qīng,de,zhuā",
  "轻轻地抱住": "qīng,qīng,de,bào,zhù",
  "轻轻地拉着": "qīng,qīng,de,lā,zhe",
  "轻轻地捏着": "qīng,qīng,de,niē,zhe",
  "轻轻地捶着": "qīng,qīng,de,chuí,zhe",
  "轻轻地推开": "qīng,qīng,de,tuī,kāi",
  "轻轻地摇": "qīng,qīng,de,yáo",
  "轻轻地摇了摇头": "qīng,qīng,de,yáo,le,yáo,tóu",
  "轻轻地放在": "qīng,qīng,de,fàng,zài",
  "轻轻地来": "qīng,qīng,de,lái",
  "轻轻地舀": "qīng,qīng,de,yǎo",
  "轻轻地讲": "qīng,qīng,de,jiǎng",
  "轻轻地说": "qīng,qīng,de,shuō",
  "轻轻地说着": "qīng,qīng,de,shuō,zhe",
  "轻轻地走": "qīng,qīng,de,zǒu",
  "轻轻地问": "qīng,qīng,de,wèn",
  "轻轻地飘": "qīng,qīng,de,piāo",
  "轻轻着地": "qīng,qīng,zhe,de",
  "轻轻薄薄": "qīng,qīng,bó,báo",
  "轻载": "qīng,zǎi",
  "轻重九府": "qīng,chóng,jiǔ,fǔ",
  "轻重倒置": "qīng,zhòng,dào,zhì",
  "轻靓": "qīng,liàng",
  "轻音乐": "qīng,yīn,yuè",
  "轻飘地": "qīng,piāo,de",
  "轻飘飘地": "qīng,piāo,piāo,de",
  "轻𫘝": "qīng,kuài",
  "轻骨头": "qīng,gú,tou",
  "载世": "zǎi,shì",
  "载书": "zǎi,shū",
  "载任": "zǎi,rèn",
  "载伯德": "zǎi,bó,dé",
  "载入": "zǎi,rù",
  "载入史册": "zǎi,rù,shǐ,cè",
  "载列": "zǎi,liè",
  "载削": "zǎi,xuē",
  "载力": "zǎi,lì",
  "载叙": "zǎi,xù",
  "载地": "zǎi,dì",
  "载子": "zǎi,zǐ",
  "载履": "zǎi,lǚ",
  "载师": "zǎi,shī",
  "载帱": "zǎi,chóu",
  "载常": "zǎi,cháng",
  "载弄": "zǎi,nòng",
  "载弹量": "zài,dàn,liàng",
  "载归": "zǎi,guī",
  "载德": "zǎi,dé",
  "载心": "zǎi,xīn",
  "载懽载笑": "zǎi,guàn,zǎi,xiào",
  "载时": "zǎi,shí",
  "载明": "zǎi,míng",
  "载果": "zǎi,guǒ",
  "载民": "zǎi,mín",
  "载涂": "zǎi,tú",
  "载湉": "zǎi,tián",
  "载焘": "zǎi,tāo",
  "载牲": "zǎi,shēng",
  "载璧": "zǎi,bì",
  "载生": "zǎi,shēng",
  "载生魄": "zǎi,shēng,pò",
  "载畜量": "zǎi,chù,liàng",
  "载社": "zǎi,shè",
  "载祀": "zǎi,sì",
  "载福": "zǎi,fú",
  "载种": "zǎi,zhǒng",
  "载笔": "zǎi,bǐ",
  "载籍": "zǎi,jí",
  "载纪": "zǎi,jì",
  "载脂": "zǎi,zhī",
  "载花船": "zǎi,huā,chuán",
  "载荷": "zài,hè",
  "载营抱魄": "zǎi,yíng,bào,pò",
  "载营魄": "zǎi,yíng,pò",
  "载覆": "zǎi,fù",
  "载言": "zǎi,yán",
  "载记": "zǎi,jì",
  "载词": "zǎi,cí",
  "载负": "zǎi,fù",
  "载贽": "zǎi,zhì",
  "载辞": "zǎi,cí",
  "载述": "zǎi,shù",
  "载送": "zǎi,sòng",
  "载酒问奇字": "zǎi,jiǔ,wèn,qí,zì",
  "载醪": "zǎi,láo",
  "载录": "zǎi,lù",
  "载雪": "zǎi,xuě",
  "载𬴐": "zǎi,huān",
  "载驰载驱": "zǎi,chí,zǎi,qū",
  "载驳船": "zǎi,bó,chuán",
  "载鬼": "zǎi,guǐ",
  "载鬼一车": "zǎi,guǐ,yī,chē",
  "载魄": "zǎi,pò",
  "轿子": "jiào,zi",
  "轿铺": "jiào,pù",
  "辁朴": "quán,piáo",
  "较为": "jiào,wéi",
  "较劲儿": "jiào,jìn,er",
  "较合适地": "jiào,hé,shì,de",
  "较好地": "jiào,hǎo,de",
  "较好地了解": "jiào,hǎo,de,liǎo,jiě",
  "较好地控制": "jiào,hǎo,de,kòng,zhì",
  "较好地落实": "jiào,hǎo,de,luò,shí",
  "较早地": "jiào,zǎo,de",
  "较真儿": "jiào,zhēn,er",
  "较短量长": "jiào,duǎn,liáng,cháng",
  "辅世长民": "fǔ,shì,zhǎng,mín",
  "辅夹": "fǔ,jiā",
  "辅相": "fǔ,xiàng",
  "辈儿": "bèi,er",
  "辈子": "bèi,zi",
  "辈数": "bèi,shù",
  "辈数儿": "bèi,shù,ér",
  "辉焯": "huī,chāo",
  "辉煌地": "huī,huáng,de",
  "辊弹": "gǔn,dàn",
  "辊辗": "gǔn,niǎn",
  "辍卷": "chuò,juàn",
  "辎𫐌车": "zī,pēng,chē",
  "辐射对称": "fú,shè,duì,chèn",
  "辐射直接效应": "fú,shè,zhí,jiē,xiào,yìng",
  "辑着": "jí,zhe",
  "输得起": "shū,de,qǐ",
  "输掠": "shū,lüě",
  "输肝剖胆": "shū,gān,pōu,dǎn",
  "输血": "shū,xuè",
  "辔䇲": "pèi,jiā",
  "辔衘": "pèi,yù",
  "辗动": "niǎn,dòng",
  "辗房": "niǎn,fáng",
  "辗然": "niǎn,rán",
  "辗移": "niǎn,yí",
  "辗翻": "niǎn,fān",
  "辗轹": "niǎn,lì",
  "辗顾": "niǎn,gù",
  "辘轳": "lù,lu",
  "辘轳体": "lù,lu,tǐ",
  "辘轳刼": "lù,lu,jié",
  "辘轳剑": "lù,lu,jiàn",
  "辘轳劫": "lù,lu,jié",
  "辘轳格": "lù,lu,gé",
  "辘轳韵": "lù,lu,yùn",
  "辙乱旗靡": "zhé,luàn,qí,mǐ",
  "辙𮝹": "zhé,huán",
  "辛劳地": "xīn,láo,de",
  "辛勤地工作": "xīn,qín,de,gōng,zuò",
  "辛苦地": "xīn,kǔ,de",
  "辛苦地做": "xīn,kǔ,de,zuò",
  "辛苦地干": "xīn,kǔ,de,gàn",
  "辛辣地": "xīn,là,de",
  "辛酸地": "xīn,suān,de",
  "辜恩背义": "gū,ēn,bèi,yì",
  "辞愬": "cí,shuò",
  "辞调": "cí,diào",
  "辟举": "bì,jǔ",
  "辟书": "bì,shū",
  "辟召": "bì,zhào",
  "辟吏": "bì,lì",
  "辟引": "bì,yǐn",
  "辟摽": "pì,biāo",
  "辟支下乘": "pì,zhī,xià,shèng",
  "辟禁": "pì,jìn",
  "辟𮉡": "bì,lú",
  "辟舍": "pì,shè",
  "辟言": "bì,yán",
  "辟谷": "bì,gǔ",
  "辟邪": "bì,xié",
  "辟阳侯": "pì,yáng,hòu",
  "辟除": "bì,chú",
  "辟雍": "bì,yōng",
  "辠征": "zuì,zhǐ",
  "辣哈布": "lā,hā,bù",
  "辣妹子": "là,mèi,zi",
  "辣子": "là,zi",
  "辣椒仔": "là,jiāo,zǎi",
  "辣眼睛": "là,yǎn,jing",
  "辣臊": "là,sào",
  "辣菜根子": "là,cài,gēn,zi",
  "辨剖": "biàn,pōu",
  "辨愬": "biàn,shuò",
  "辨折": "biàn,shé",
  "辨絜": "biàn,jié",
  "辨颠帖": "biàn,diān,tiē",
  "辩剖": "biàn,pōu",
  "辩口利舌": "biàn,kǒu,lì,cí",
  "辩折": "biàn,shé",
  "辩数": "biàn,shù",
  "辩絜": "biàn,jié",
  "辩给": "biàn,jǐ",
  "辩解地": "biàn,jiě,de",
  "辩证地": "biàn,zhèng,de",
  "辩证法地": "biàn,zhèng,fǎ,de",
  "辩证逻辑": "biàn,zhèng,luó,ji",
  "辩难": "biàn,nàn",
  "辫子": "biàn,zi",
  "辰宿": "chén,xiù",
  "辱么": "rǔ,mǒ",
  "辱没": "rǔ,mò",
  "辱贲": "rǔ,bēn",
  "边儿": "biān,er",
  "边卡": "biān,qiǎ",
  "边反卷地": "biān,fǎn,juǎn,de",
  "边堡": "biān,pù",
  "边塞": "biān,sài",
  "边对边地": "biān,duì,biān,de",
  "边干": "biān,gàn",
  "边扞": "biān,gǎn",
  "边撩": "biān,liáo",
  "边橑": "biān,lǎo",
  "边禁": "biān,jìn",
  "边缘地": "biān,yuán,de",
  "边缝": "biān,fèng",
  "边老便便": "biān,lǎo,biàn,pián",
  "边蕃": "biān,fān",
  "边调": "biān,diào",
  "边都护": "biān,dū,hù",
  "边铺": "biān,pù",
  "辽东隺": "liáo,dōng,hè",
  "辽天华表": "liáo,tiān,huā,biǎo",
  "辽𰛦": "liáo,wèi",
  "辽𰺷": "liáo,rǎo",
  "辽阆": "liáo,láng",
  "达头地": "dá,tóu,de",
  "达姆弹": "dá,mǔ,dàn",
  "达干": "dá,gàn",
  "达累斯萨拉姆": "dá,lèi,sī,sà,lā,mǔ",
  "达赖喇嘛": "dá,lài,lǎ,ma",
  "达么": "dá,mǒ",
  "迁削": "qiān,xuē",
  "迁更": "qiān,gēng",
  "迁累": "qiān,lèi",
  "迁舍": "qiān,shè",
  "迁调": "qiān,diào",
  "迁都": "qiān,dū",
  "迂回地": "yū,huí,de",
  "迂回曲折": "yū,huí,qū,zhé",
  "迂折": "yū,shé",
  "迂曲": "yū,qū",
  "迄今为止": "qì,jīn,wéi,zhǐ",
  "迅捷地落": "xùn,jié,de,luò",
  "迅猛地": "xùn,měng,de",
  "迅速地": "xùn,sù,de",
  "迅速地抓住": "xùn,sù,de,zhuā,zhù",
  "迅速地拉近": "xùn,sù,de,lā,jìn",
  "迅速地提升": "xùn,sù,de,tí,shēng",
  "迅速地离开": "xùn,sù,de,lí,kāi",
  "迅速地蔓延": "xùn,sù,de,màn,yán",
  "迅𫘝": "xùn,kuài",
  "过一会儿": "guò,yī,huì,er",
  "过不下": "guò,bu,xià",
  "过为": "guò,wéi",
  "过为已甚": "guò,wéi,yǐ,shèn",
  "过了头地": "guò,le,tóu,de",
  "过了这个村就没这个店": "guò,le,zhè,ge,cūn,jiù,méi,zhè,ge,diàn",
  "过五关斩六将": "guò,wǔ,guān,zhǎn,liù,jiàng",
  "过人地": "guò,rén,de",
  "过份地": "guò,fèn,de",
  "过关斩将": "guò,guān,zhǎn,jiàng",
  "过分": "guò,fèn",
  "过分地": "guò,fèn,de",
  "过分地做": "guò,fèn,de,zuò",
  "过切": "guò,qiè",
  "过剩地": "guò,shèng,de",
  "过劲儿": "guò,jìn,er",
  "过半数": "guò,bàn,shù",
  "过去分词": "guò,qu,fēn,cí",
  "过去式": "guò,qu,shì",
  "过去经验": "guò,qu,jīng,yàn",
  "过多地": "guò,duō,de",
  "过多地供应": "guò,duō,de,gōng,yìng",
  "过家": "guō,jiā",
  "过家伙": "guō,jiā,huo",
  "过家家": "guō,jiā,jiā",
  "过家家儿": "guō,jiā,jiā,ér",
  "过屠大嚼": "guò,tú,dà,jué",
  "过屠门而大嚼": "guò,tú,mén,ér,dà,jué",
  "过度地": "guò,dù,de",
  "过得去": "guò,děi,qù",
  "过得硬": "guò,de,yìng",
  "过急地": "guò,jí,de",
  "过房子": "guò,fáng,zi",
  "过敏反应": "guò,mǐn,fǎn,yìng",
  "过敏地": "guò,mǐn,de",
  "过敏性反应": "guò,mǐn,xìng,fǎn,yìng",
  "过日子": "guò,rì,zi",
  "过早地": "guò,zǎo,de",
  "过早地死去": "guò,zǎo,de,sǐ,qù",
  "过时地": "guò,shí,de",
  "过更": "guò,gēng",
  "过江仆射": "guò,jiāng,pú,yè",
  "过淋": "guò,lìn",
  "过渡地": "guò,dù,de",
  "过滤嘴儿": "guò,lǜ,zuǐ,er",
  "过激地": "guò,jī,de",
  "过累": "guò,lèi",
  "过细地": "guò,xì,de",
  "过肩摔": "guò,jiān,shuǎi",
  "过背": "guò,bèi",
  "过节似地": "guò,jié,shì,de",
  "过谩": "guò,màn",
  "过迟地": "guò,chí,de",
  "过适": "guò,shì",
  "过郄": "guò,xì",
  "过都历块": "guò,dū,lì,kuài",
  "过量地": "guò,liàng,de",
  "过门儿": "guò,mén,er",
  "过露": "guò,lù",
  "迉迡": "qī,nì",
  "迍剥": "zhūn,bāo",
  "迍蹶": "zhūn,juě",
  "迎头儿": "yíng,tóu,er",
  "迎接挑战": "yíng,jiē,tiǎo,zhàn",
  "迎日推䇲": "yíng,rì,tuī,jiā",
  "迎𬮤": "yíng,gé",
  "迎面地": "yíng,miàn,de",
  "迎风簸簸箕": "yíng,fēng,bò,bò,ji",
  "运为": "yùn,wéi",
  "运亡为存": "yùn,wáng,wéi,cún",
  "运剥": "yùn,bāo",
  "运动会地": "yùn,dòng,huì,de",
  "运动健将": "yùn,dòng,jiàn,jiàng",
  "运动地": "yùn,dòng,de",
  "运将": "yùn,jiàng",
  "运干": "yùn,gàn",
  "运数": "yùn,shù",
  "运斗": "yùn,dǒu",
  "运智铺谋": "yùn,zhì,pù,móu",
  "运气": "yùn,qi",
  "运气好地": "yùn,qì,hǎo,de",
  "运筹划策": "yùn,chóu,huà,cè",
  "运算数": "yùn,suàn,shù",
  "运计铺谋": "yùn,jì,pù,móu",
  "运转": "yùn,zhuàn",
  "运道": "yùn,dao",
  "运𬬱": "yùn,yǐn",
  "近乎": "jìn,hu",
  "近什": "jìn,shí",
  "近代地": "jìn,dài,de",
  "近似地": "jìn,sì,de",
  "近光镜子": "jìn,guāng,jìng,zi",
  "近卫文麿": "jìn,wèi,wén,mǒ",
  "近射地": "jìn,shè,de",
  "近尾部地": "jìn,wěi,bù,de",
  "近旁地": "jìn,páng,de",
  "近旁地在": "jìn,páng,de,zài",
  "近来地": "jìn,lái,de",
  "近着": "jìn,zhe",
  "近程导弹": "jìn,chéng,dǎo,dàn",
  "近端地": "jìn,duān,de",
  "近血": "jìn,xuè",
  "返本还元": "fǎn,běn,huán,yuán",
  "返本还原": "fǎn,běn,huán,yuán",
  "返本还源": "fǎn,běn,huán,yuán",
  "返朴": "fǎn,piáo",
  "返朴还淳": "fǎn,pǔ,huán,chún",
  "返朴还真": "fǎn,pǔ,huán,zhēn",
  "返老还童": "fǎn,lǎo,huán,tóng",
  "返舍": "fǎn,shè",
  "返辔收帆": "fǎn,pèi,shōu,fān",
  "返还": "fǎn,huán",
  "返还占有": "fǎn,huán,zhàn,yǒu",
  "还不断地": "hái,bù,duàn,de",
  "还不时地": "hái,bù,shí,de",
  "还不能很好地": "hái,bù,néng,hěn,hǎo,de",
  "还不错": "hái,bú,cuò",
  "还东": "huán,dōng",
  "还东山": "huán,dōng,shān",
  "还丹": "huán,dān",
  "还乡": "huán,xiāng",
  "还乡团": "huán,xiāng,tuán",
  "还乡女": "huán,xiāng,nǚ",
  "还乡昼锦": "huán,xiāng,zhòu,jǐn",
  "还乡队": "huán,xiāng,duì",
  "还书": "huán,shū",
  "还价": "huán,jià",
  "还俗": "huán,sú",
  "还债": "huán,zhài",
  "还偷偷地": "hái,tōu,tōu,de",
  "还元": "huán,yuán",
  "还元大品": "huán,yuán,dà,pǐn",
  "还元水": "huán,yuán,shuǐ",
  "还元汤": "huán,yuán,tāng",
  "还元返本": "huán,yuán,fǎn,běn",
  "还击": "huán,jī",
  "还原": "huán,yuán",
  "还原乳": "huán,yuán,rǔ",
  "还原剂": "huán,yuán,jì",
  "还原反本": "huán,yuán,fǎn,běn",
  "还原号": "huán,yuán,hào",
  "还原染料": "huán,yuán,rǎn,liào",
  "还原真相": "huán,yuán,zhēn,xiàng",
  "还口": "huán,kǒu",
  "还口愿": "huán,kǒu,yuàn",
  "还同情地": "hái,tóng,qíng,de",
  "还君明珠": "huán,jūn,míng,zhū",
  "还嘴": "huán,zuǐ",
  "还在不断地进步": "hái,zài,bù,duàn,de,jìn,bù",
  "还好好地": "hái,hǎo,hǎo,de",
  "还家": "huán,jiā",
  "还席": "huán,xí",
  "还年却老": "huán,nián,què,lǎo",
  "还年驻色": "huán,nián,zhù,sè",
  "还愉快地": "hái,yú,kuài,de",
  "还愿": "huán,yuàn",
  "还愿心": "huán,yuàn,xīn",
  "还我河山": "huán,wǒ,hé,shān",
  "还手": "huán,shǒu",
  "还时不时地": "hái,shí,bù,shí,de",
  "还是乖乖地": "hái,shì,guāi,guāi,de",
  "还是好好地": "hái,shì,hǎo,hǎo,de",
  "还是稳稳地": "hái,shì,wěn,wěn,de",
  "还是能很好地": "hái,shì,néng,hěn,hǎo,de",
  "还是顺利地": "hái,shì,shùn,lì,de",
  "还本": "huán,běn",
  "还朴反古": "huán,pǔ,fǎn,gǔ",
  "还没有很好地": "hái,méi,yǒu,hěn,hǎo,de",
  "还治其人之身": "huán,zhì,qí,rén,zhī,shēn",
  "还淳": "huán,chún",
  "还淳反古": "huán,chún,fǎn,gǔ",
  "还淳反朴": "huán,chún,fǎn,pǔ",
  "还淳反素": "huán,chún,fǎn,sù",
  "还淳返朴": "huán,chún,fǎn,pǔ",
  "还清": "huán,qīng",
  "还清晰地": "huán,qīng,xī,de",
  "还源": "huán,yuán",
  "还珠": "huán,zhū",
  "还珠买椟": "huán,zhū,mǎi,dú",
  "还珠亭": "huán,zhū,tíng",
  "还珠合浦": "huán,zhū,hé,pǔ",
  "还珠守": "huán,zhū,shǒu",
  "还珠洞": "huán,zhū,dòng",
  "还珠返璧": "huán,zhū,fǎn,bì",
  "还甜甜地": "hái,tián,tián,de",
  "还礼": "huán,lǐ",
  "还突出地": "hái,tū,chū,de",
  "还童": "huán,tóng",
  "还算不错": "hái,suàn,bú,cuò",
  "还紧紧地": "hái,jǐn,jǐn,de",
  "还给": "huán,gěi",
  "还蕃": "hái,fān",
  "还要乖乖地": "hái,yào,guāi,guāi,de",
  "还账": "huán,zhàng",
  "还贷": "huán,dài",
  "还迊": "hái,bì",
  "还适当地": "hái,shì,dàng,de",
  "还醇返朴": "huán,chún,fǎn,pǔ",
  "还钱": "huán,qián",
  "还阳": "huán,yáng",
  "还顾": "huán,gù",
  "还魂": "huán,hún",
  "还魂丹": "huán,hún,dān",
  "还魂秀才": "huán,hún,xiù,cái",
  "还魂纸": "huán,hún,zhǐ",
  "还魂草": "huán,hún,cǎo",
  "这一阵子": "zhè,yī,zhèn,zi",
  "这下子": "zhè,xià,zi",
  "这不": "zhè,bu",
  "这个要狠狠地": "zhè,gè,yào,hěn,hěn,de",
  "这么个": "zhè,mǒ,gè",
  "这么方便地": "zhè,me,fāng,biàn,de",
  "这么点": "zhè,mǒ,diǎn",
  "这么点儿": "zhè,me,diǎn,er",
  "这么着": "zhè,me,zhāo",
  "这么自由地": "zhè,me,zì,yóu,de",
  "这么说": "zhè,mǒ,shuō",
  "这也是为了更好地": "zhè,yě,shì,wèi,le,gèng,hǎo,de",
  "这些个": "zhè,xiē,ge",
  "这些儿": "zhèi,xiē,ér",
  "这些子": "zhèi,xiē,zǐ",
  "这们": "zhè,men",
  "这会儿": "zhè,huì,er",
  "这大大地": "zhè,dà,dà,de",
  "这山望着那山高": "zhè,shān,wàng,zhe,nà,shān,gāo",
  "这干": "zhè,gàn",
  "这年头": "zhè,nián,tou",
  "这才真正地": "zhè,cái,zhēn,zhèng,de",
  "这才缓缓地": "zhè,cái,huǎn,huǎn,de",
  "这早晚儿": "zhè,zǎo,wǎn,er",
  "这末": "zhè,me",
  "这样不停地叫着": "zhè,yàng,bù,tíng,de,jiào,zhe",
  "这样可以更好地": "zhè,yàng,kě,yǐ,gèng,hǎo,de",
  "这样地": "zhè,yàng,de",
  "这样地喜欢": "zhè,yàng,de,xǐ,huān",
  "这样子": "zhè,yàng,zi",
  "这样就能更好地": "zhè,yàng,jiù,néng,gèng,hǎo,de",
  "这样就能更快地": "zhè,yàng,jiù,néng,gèng,kuài,de",
  "这样才能真正地": "zhè,yàng,cái,néng,zhēn,zhèng,de",
  "这溜儿": "zhè,liù,ér",
  "这着": "zhè,zhāo",
  "这边儿": "zhè,biān,er",
  "这边地": "zhè,biān,de",
  "这还了得": "zhè,hái,liǎo,dé",
  "这里能够清楚地": "zhè,lǐ,néng,gòu,qīng,chǔ,de",
  "这阵儿": "zhè,zhèn,er",
  "这阵子": "zhè,zhèn,zi",
  "进一步": "jìn,yí,bù",
  "进一步地": "jìn,yí,bù,de",
  "进侯": "jìn,hòu",
  "进卷": "jìn,juàn",
  "进取地": "jìn,qǔ,de",
  "进帆": "jìn,fān",
  "进干": "jìn,gàn",
  "进德冠": "jìn,dé,guān",
  "进折": "jìn,shé",
  "进步地": "jìn,bù,de",
  "进给": "jìn,jǐ",
  "进给量": "jìn,jǐ,liàng",
  "进舍": "jìn,shè",
  "进舍女壻": "jìn,shè,nǚ,xù",
  "进舍女婿": "jìn,shè,nǚ,xù",
  "进贤兴功": "jìn,xián,xīng,gōng",
  "进贤冠": "jìn,xián,guān",
  "进退中度": "jìn,tuì,zhòng,dù",
  "进退为难": "jìn,tuì,wéi,nán",
  "进退出处": "jìn,tuì,chū,chǔ",
  "进退迍邅": "jìn,tuì,chù,zǔ",
  "进锐退速": "jǐn,ruì,tuì,sù",
  "进项": "jìn,xiang",
  "远不间亲": "yuǎn,bù,jiàn,qīn",
  "远侥": "yuǎn,yáo",
  "远兴": "yuǎn,xīng",
  "远年": "yuǎn,nìng",
  "远房地": "yuǎn,fáng,de",
  "远数": "yuǎn,shù",
  "远曾": "yuǎn,zēng",
  "远来的和尚会念经": "yuǎn,lái,de,hé,shang,huì,niàn,jīng",
  "远水救不了近火": "yuǎn,shuǐ,jiù,bù,liǎo,jìn,huǒ",
  "远水解不了近渴": "yuǎn,shuǐ,jiě,bù,liǎo,jìn,kě",
  "远涉重洋": "yuǎn,shè,chóng,yáng",
  "远渡重洋": "yuǎn,dù,chóng,yáng",
  "远游冠": "yuǎn,yóu,guān",
  "远着": "yuǎn,zhe",
  "远程导弹": "yuǎn,chéng,dǎo,dàn",
  "远背": "yuǎn,bèi",
  "远蕃": "yuǎn,fān",
  "远血": "yuǎn,xuè",
  "远覃": "yuǎn,qín",
  "远视地": "yuǎn,shì,de",
  "远距离地": "yuǎn,jù,lí,de",
  "远远地": "yuǎn,yuǎn,de",
  "远远地抛到后边": "yuǎn,yuǎn,de,pāo,dào,hòu,biān",
  "远远地看着": "yuǎn,yuǎn,de,kàn,zhe",
  "远适": "yuǎn,shì",
  "违信背约": "wéi,xìn,bèi,yuē",
  "违命侯": "wéi,mìng,hòu",
  "违干": "wéi,gàn",
  "违心地": "wéi,xīn,de",
  "违心地做": "wéi,xīn,de,zuò",
  "违慠": "wéi,ào",
  "违扞": "wéi,gǎn",
  "违法地": "wéi,fǎ,de",
  "违禁": "wéi,jìn",
  "违禁品": "wéi,jìn,pǐn",
  "违禁药品": "wéi,jìn,yào,pǐn",
  "违背": "wéi,bèi",
  "违舍": "wéi,shè",
  "违规批地": "wéi,guī,pī,de",
  "违𰺷": "wéi,rǎo",
  "连中": "lián,zhòng",
  "连中三元": "lián,zhòng,sān,yuán",
  "连串地": "lián,chuàn,de",
  "连乹": "lián,gān",
  "连冠": "lián,guān",
  "连动杆": "lián,dòng,gǎn",
  "连卷": "lián,juàn",
  "连哄带骗": "lián,hǒng,dài,piàn",
  "连堤": "lián,dī",
  "连夹": "lián,jiā",
  "连家铺": "lián,jiā,pù",
  "连帙累牍": "lián,zhì,lèi,dú",
  "连带地": "lián,dài,de",
  "连扯跟头": "lián,chě,gēn,tou",
  "连朝": "lián,zhāo",
  "连杆": "lián,gǎn",
  "连栅": "lián,shān",
  "连橇": "lián,qiào",
  "连𪲔": "lián,lǐ",
  "连毂": "lián,gū",
  "连片子嘴": "lián,piān,zi,zuǐ",
  "连犿": "lián,fān",
  "连着": "lián,zhe",
  "连章累牍": "lián,zhāng,lèi,dú",
  "连笮": "lián,zé",
  "连筩": "lián,yǒng",
  "连篇累册": "lián,piān,lèi,cè",
  "连篇累帙": "lián,piān,lèi,zhì",
  "连篇累帧": "lián,piān,lèi,zhēn",
  "连篇累幅": "lián,piān,lèi,fú",
  "连篇累牍": "lián,piān,lěi,dú",
  "连粘": "lián,zhān",
  "连累": "lián,lěi",
  "连结地": "lián,jié,de",
  "连续不断地": "lián,xù,bù,duàn,de",
  "连续函数": "lián,xù,hán,shù",
  "连续变调": "lián,xù,biàn,diào",
  "连续地": "lián,xù,de",
  "连编累牍": "lián,biān,lěi,dú",
  "连缝": "lián,fèng",
  "连舳": "lián,zhòu",
  "连蒙带唬": "lián,mēng,dài,hǔ",
  "连蒙带骗": "lián,mēng,dài,piàn",
  "连蝉冠": "lián,chán,guān",
  "连贯地": "lián,guàn,de",
  "连贯地输入": "lián,guàn,de,shū,rù",
  "连车平斗": "lián,chē,píng,dǒu",
  "连轧机": "lián,zhá,jī",
  "连轴转": "lián,zhóu,zhuàn",
  "连载": "lián,zǎi",
  "连载地": "lián,zǎi,de",
  "连载小说": "lián,zǎi,xiǎo,shuō",
  "连辟公府不就": "lián,bì,gōng,fǔ,bù,jiù",
  "连逮": "lián,dǎi",
  "连锁反应": "lián,suǒ,fǎn,yìng",
  "连长": "lián,zhǎng",
  "连阡累陌": "lián,qiān,lèi,mò",
  "连阶累任": "lián,jiē,lèi,rèn",
  "迟佪": "chí,huái",
  "迟到地": "chí,dào,de",
  "迟延地": "chí,yán,de",
  "迟数": "chí,shù",
  "迟朴": "chí,piáo",
  "迟疑地": "chí,yí,de",
  "迟疑地看着": "chí,yí,de,kàn,zhe",
  "迟缓地": "chí,huǎn,de",
  "迟迟地": "chí,chí,de",
  "迟钝地": "chí,dùn,de",
  "迩陕": "ěr,xiá",
  "迪庆藏族自治州": "dí,qìng,zàng,zú,zì,zhì,zhōu",
  "迫不及待地": "pò,bù,jí,dài,de",
  "迫击": "pǎi,jī",
  "迫击炮": "pǎi,jī,pào",
  "迫击炮弹": "pǎi,jī,pào,dàn",
  "迫切": "pò,qiè",
  "迫切地": "pò,qiè,de",
  "迫切性": "pò,qiè,xìng",
  "迫着": "pò,zhe",
  "迭为宾主": "dié,wéi,bīn,zhǔ",
  "迭兴": "dié,xīng",
  "迭噷": "dié,hēn",
  "迭更": "dié,gēng",
  "迭矩重规": "dié,jǔ,chóng,guī",
  "迭窨": "dié,xūn",
  "迭累": "dié,lèi",
  "述词地": "shù,cí,de",
  "述载": "shù,zǎi",
  "迷人地": "mí,rén,de",
  "迷住": "mí,zhu",
  "迷信地": "mí,xìn,de",
  "迷地装": "mí,de,zhuāng",
  "迷幻蘑菇": "mí,huàn,mó,gu",
  "迷恋地": "mí,liàn,de",
  "迷惑": "mí,huo",
  "迷惑地": "mí,huò,de",
  "迷惑地问": "mí,huò,de,wèn",
  "迷惑龙": "mí,huo,lóng",
  "迷溜没乱": "mí,liū,mò,luàn",
  "迷留没乱": "mí,liú,mò,luàn",
  "迷着": "mí,zhe",
  "迷离马虎": "mí,lí,mǎ,hu",
  "迷糊": "mí,hū",
  "迷糊地": "mí,hū,de",
  "迷缪": "mí,miù",
  "迷背": "mí,bèi",
  "迷迷怔怔": "mí,mí,zhèng,zhèng",
  "迷迷糊糊": "mí,mí,hū,hū",
  "迷途地": "mí,tú,de",
  "迷𬮴": "mí,ān",
  "迷露": "mí,lù",
  "迸瀑": "bèng,bào",
  "迸缝": "bèng,fèng",
  "追削": "zhuī,xuē",
  "追根子": "zhuī,gēn,zi",
  "追根究底儿": "zhuī,gēn,jiū,dǐ,er",
  "追溯地": "zhuī,sù,de",
  "追琢": "duī,zhuó",
  "追蠡": "zhuī,lí",
  "追覃": "zhuī,qín",
  "追贲": "zhuī,bēn",
  "追趋逐耆": "zhuī,qū,zhú,shì",
  "追踪调查": "zhuī,zōng,diào,chá",
  "追还": "zhuī,huán",
  "追逮": "zhuī,dǎi",
  "迾禁": "liè,jìn",
  "退三舍": "tuì,sān,shè",
  "退动地": "tuì,dòng,de",
  "退处": "tuì,chǔ",
  "退学地": "tuì,xué,de",
  "退恶地": "tuì,è,de",
  "退步抽身": "tui,bu,chou,sheng",
  "退省": "tuì,xǐng",
  "退真地": "tuì,zhēn,de",
  "退耕还林": "tuì,gēng,huán,lín",
  "退舍": "tuì,shè",
  "退还": "tuì,huán",
  "退避三舍": "tuì,bì,sān,shè",
  "退食委蛇": "tuì,shí,wēi,yí",
  "送卷头": "sòng,juàn,tóu",
  "送字样子": "sòng,zì,yàng,zi",
  "送日子": "sòng,rì,zi",
  "送杜少府之任蜀州": "sòng,dù,shào,fǔ,zhī,rèn,shǔ,zhōu",
  "送煖偎寒": "sòng,xuān,wēi,hán",
  "送煖偷寒": "sòng,xuān,tōu,hán",
  "送铺": "sòng,pù",
  "适丁": "shì,dīng",
  "适世": "shì,shì",
  "适中": "shì,zhōng",
  "适中地": "shì,zhōng,de",
  "适主": "shì,zhǔ",
  "适事": "shì,shì",
  "适于": "shì,yú",
  "适人": "shì,rén",
  "适从": "shì,cóng",
  "适以相成": "shì,yǐ,xiāng,chéng",
  "适价": "shì,jià",
  "适会": "shì,huì",
  "适体": "shì,tǐ",
  "适例": "shì,lì",
  "适便": "shì,biàn",
  "适俗": "shì,sú",
  "适俗随时": "shì,sú,suí,shí",
  "适值": "shì,zhí",
  "适兴": "shì,xīng",
  "适分": "shì,fēn",
  "适切": "shì,qiè",
  "适切地": "shì,qiè,de",
  "适卒": "shì,zú",
  "适历": "shì,lì",
  "适变": "shì,biàn",
  "适口": "shì,kǒu",
  "适可": "shì,kě",
  "适可而止": "shì,kě,ér,zhǐ",
  "适合": "shì,hé",
  "适合地": "shì,hé,de",
  "适味": "shì,wèi",
  "适嗣": "shì,sì",
  "适均": "shì,jūn",
  "适士": "shì,shì",
  "适备": "shì,bèi",
  "适如": "shì,rú",
  "适如其分": "shì,rú,qí,fèn",
  "适妇": "shì,fù",
  "适婚": "shì,hūn",
  "适婚期": "shì,hūn,qī",
  "适子": "shì,zǐ",
  "适存度": "shì,cún,dù",
  "适孙": "shì,sūn",
  "适孼": "shì,niè",
  "适孽": "shì,niè",
  "适宜": "shì,yí",
  "适室": "shì,shì",
  "适寝": "shì,qǐn",
  "适尔": "shì,ěr",
  "适居其反": "shì,jū,qí,fǎn",
  "适巧": "shì,qiǎo",
  "适己": "shì,jǐ",
  "适应": "shì,yìng",
  "适应性": "shì,yìng,xìng",
  "适应症": "shì,yìng,zhèng",
  "适度": "shì,dù",
  "适度地": "shì,dù,de",
  "适庶": "shì,shù",
  "适归": "shì,guī",
  "适当": "shì,dàng",
  "适当其冲": "shì,dāng,qí,chōng",
  "适当其时": "shì,dāng,qí,shí",
  "适当地": "shì,dàng,de",
  "适当地提高": "shì,dàng,de,tí,gāo",
  "适得其反": "shì,dé,qí,fǎn",
  "适得其所": "shì,dé,qí,suǒ",
  "适徙": "shì,xǐ",
  "适心": "shì,xīn",
  "适心娱目": "shì,xīn,yú,mù",
  "适志": "shì,zhì",
  "适性": "shì,xìng",
  "适性任情": "shì,xìng,rèn,qíng",
  "适性忘虑": "shì,xìng,wàng,lǜ",
  "适情": "shì,qíng",
  "适情任欲": "shì,qíng,rèn,yù",
  "适情率意": "shì,qíng,shuài,yì",
  "适意": "shì,yì",
  "适愿": "shì,yuàn",
  "适戍": "shì,shù",
  "适所": "shì,suǒ",
  "适才": "shì,cái",
  "适时": "shì,shí",
  "适时地": "shì,shí,de",
  "适时应务": "shì,shí,yīng,wù",
  "适景": "shì,jǐng",
  "适材适所": "shì,cái,shì,suǒ",
  "适来": "shì,lái",
  "适格": "shì,gé",
  "适欲": "shì,yù",
  "适正": "shì,zhèng",
  "适母": "shì,mǔ",
  "适民": "shì,mín",
  "适法地": "shì,fǎ,de",
  "适温": "shì,wēn",
  "适然": "shì,rán",
  "适物": "shì,wù",
  "适理": "shì,lǐ",
  "适生": "shì,shēng",
  "适用": "shì,yòng",
  "适秝": "shì,lì",
  "适称": "shì,chēng",
  "适等": "shì,děng",
  "适纔": "shì,shān",
  "适统": "shì,tǒng",
  "适缘": "shì,yuán",
  "适罚": "shì,fá",
  "适者生存": "shì,zhě,shēng,cún",
  "适航": "shì,háng",
  "适莫": "shì,mò",
  "适行": "shì,xíng",
  "适衬": "shì,chèn",
  "适衷": "shì,zhōng",
  "适要": "shì,yào",
  "适观": "shì,guān",
  "适贤": "shì,xián",
  "适趣": "shì,qù",
  "适足": "shì,zú",
  "适路": "shì,lù",
  "适身": "shì,shēn",
  "适軄": "shì,zhí",
  "适过": "shì,guò",
  "适远": "shì,yuǎn",
  "适适": "shì,shì",
  "适逢": "shì,féng",
  "适逢其会": "shì,féng,qí,huì",
  "适逢其时": "shì,féng,qí,shí",
  "适逸": "shì,yì",
  "适道": "shì,dào",
  "适遘": "shì,gòu",
  "适配": "shì,pèi",
  "适配器": "shì,pèi,qì",
  "适配层": "shì,pèi,céng",
  "适野": "shì,yě",
  "适野谋": "shì,yě,móu",
  "适量": "shì,liàng",
  "适销": "shì,xiāo",
  "适长": "shì,cháng",
  "适长公主": "shì,cháng,gōng,zhǔ",
  "适长孙": "shì,zhǎng,sūn",
  "适间": "shì,jiān",
  "适闷": "shì,mèn",
  "适音": "shì,yīn",
  "适顺": "shì,shùn",
  "适馆授粲": "shì,guǎn,shòu,càn",
  "适龄": "shì,líng",
  "逃不掉地": "táo,bù,diào,de",
  "逃也似地": "táo,yě,shì,de",
  "逃奔": "táo,bèn",
  "逃灾避难": "táo,zāi,bì,nàn",
  "逃背": "táo,bèi",
  "逃避地": "táo,bì,de",
  "逃难": "táo,nàn",
  "逅适": "hòu,shì",
  "逆动地": "nì,dòng,de",
  "逆反应": "nì,fǎn,yìng",
  "逆向地": "nì,xiàng,de",
  "逆折": "nì,shé",
  "逆揣": "nì,chuāi",
  "逆数": "nì,shù",
  "逆时针地": "nì,shí,zhēn,de",
  "逆流地": "nì,liú,de",
  "逆生长": "nì,shēng,zhǎng",
  "逆蕃": "nì,fān",
  "逆行倒施": "nì,xíng,dào,shī",
  "逆行地": "nì,xíng,de",
  "逆计数": "nì,jì,shù",
  "逆风地": "nì,fēng,de",
  "选中": "xuǎn,zhòng",
  "选举地": "xuǎn,jǔ,de",
  "选抡": "xuǎn,lún",
  "选择性地": "xuǎn,zé,xìng,de",
  "选蝡": "xuǎn,ruǎn",
  "选调": "xuǎn,diào",
  "选輭": "xuǎn,ér",
  "逋累": "bū,lèi",
  "逍遥自在": "xiāo,yáo,zì,zai",
  "透不过地": "tòu,bù,guò,de",
  "透彻地": "tòu,chè,de",
  "透明地": "tòu,míng,de",
  "透水地": "tòu,shuǐ,de",
  "透背": "tòu,bèi",
  "透露": "tòu,lù",
  "逐个地": "zhú,gè,de",
  "逐字地": "zhú,zì,de",
  "逐机应变": "zhú,jī,yìng,biàn",
  "逐条地": "zhú,tiáo,de",
  "逐次地": "zhú,cì,de",
  "逐步地": "zhú,bù,de",
  "逐渐地": "zhú,jiàn,de",
  "逐渐地失去": "zhú,jiàn,de,shī,qù",
  "逐物不还": "zhú,wù,bù,huán",
  "逐行": "zhú,háng",
  "逐行扫描": "zhú,háng,sǎo,miáo",
  "递兴": "dì,xīng",
  "递兴递废": "dì,xīng,dì,fèi",
  "递减地": "de,jiǎn,de",
  "递归地": "de,guī,de",
  "递更": "dì,gēng",
  "递条子": "dì,tiáo,zi",
  "递解": "dì,jiè",
  "递铺": "dì,pù",
  "逗嘴皮子": "dòu,zuǐ,pí,zi",
  "逗比": "dòu,bī",
  "逗笑儿": "dòu,xiào,er",
  "逗遛": "dòu,liú",
  "逗露": "dòu,lù",
  "通事舍人": "tōng,shì,shè,rén",
  "通什": "tōng,shí",
  "通侻": "tōng,tuì",
  "通俗地": "tōng,sú,de",
  "通俗地讲": "tōng,sú,de,jiǎng",
  "通俗地说": "tōng,sú,de,shuō",
  "通则地": "tōng,zé,de",
  "通厮脚儿": "tōng,sī,jué,ér",
  "通叚": "tōng,jiǎ",
  "通天冠": "tōng,tiān,guān",
  "通天台": "tōng,tiān,tāi",
  "通宵地": "tōng,xiāo,de",
  "通常地": "tōng,cháng,de",
  "通应子鱼": "tōng,yìng,zǐ,yú",
  "通数": "tōng,shù",
  "通文调武": "tōng,wén,diào,wǔ",
  "通晓地": "tōng,xiǎo,de",
  "通畅地": "tōng,chàng,de",
  "通盘地看": "tōng,pán,de,kàn",
  "通禁": "tōng,jìn",
  "通称地": "tōng,chēng,de",
  "通红": "tòng,hóng",
  "通红地": "tòng,hóng,de",
  "通背拳": "tōng,bèi,quán",
  "通血": "tōng,xuè",
  "通讯行业": "tōng,xùn,háng,yè",
  "通调": "tōng,diào",
  "通路子": "tōng,lù,zi",
  "通透地": "tōng,tòu,de",
  "通都": "tōng,dū",
  "通都大邑": "tōng,dū,dà,yì",
  "通铺": "tōng,pù",
  "通顺地": "tōng,shùn,de",
  "通鼻子": "tōng,bí,zi",
  "逛膀子": "guàng,bǎng,zi",
  "逛逛": "guàng,guang",
  "逛道儿": "guàng,dào,er",
  "逞兴": "chěng,xīng",
  "逞应": "chěng,yìng",
  "逞强好胜": "chěng,qiáng,hào,shèng",
  "逞性妄为": "chěng,xìng,wàng,wéi",
  "逞性子": "chěng,xìng,zi",
  "逞能地": "chěng,néng,de",
  "逞角色": "chěng,jué,sè",
  "逞露": "chěng,lù",
  "速帖": "sù,tiē",
  "速累": "sù,lèi",
  "造为": "zào,wéi",
  "造反地": "zào,fǎn,de",
  "造耑": "zào,zhuān",
  "造血": "zào,xuè",
  "造血干细胞": "zào,xuè,gàn,xì,bāo",
  "造谋布穽": "zào,móu,bù,yán",
  "造谣中伤": "zào,yáo,zhòng,shāng",
  "造适": "zào,shì",
  "造难": "zào,nàn",
  "逢俉": "féng,wú",
  "逢处": "féng,chǔ",
  "逢累": "féng,lèi",
  "逩波": "bēn,bō",
  "逩迸": "bēn,bèng",
  "逩逐": "bēn,zhú",
  "逫律": "jué,lǜ",
  "逮下": "dǎi,xià",
  "逮亲": "dǎi,qīn",
  "逮养": "dǎi,yǎng",
  "逮及": "dǎi,jí",
  "逮坐": "dǎi,zuò",
  "逮小偷": "dǎi,xiǎo,tōu",
  "逮引": "dǎi,yǐn",
  "逮意": "dǎi,yì",
  "逮案": "dǎi,àn",
  "逮治": "dǎi,zhì",
  "逮特务": "dǎi,tè,wù",
  "逮狱": "dǎi,yù",
  "逮系": "dǎi,xì",
  "逮累": "dǎi,lèi",
  "逮老鼠": "dǎi,lǎo,shǔ",
  "逮至": "dǎi,zhì",
  "逮蚊子": "dǎi,wén,zi",
  "逮行": "dǎi,xíng",
  "逮讯": "dǎi,xùn",
  "逮贱": "dǎi,jiàn",
  "逮赴": "dǎi,fù",
  "逮送": "dǎi,sòng",
  "逮通": "dǎi,tōng",
  "逮逮": "dǎi,dǎi",
  "逮录": "dǎi,lù",
  "逮问": "dǎi,wèn",
  "逮革": "dǎi,gé",
  "逮鞫": "dǎi,jū",
  "逴优": "chuò,yōu",
  "逴俗绝物": "chuò,sú,jué,wù",
  "逴姹": "chuò,chà",
  "逴斡": "chuò,wò",
  "逴绝": "chuò,jué",
  "逴行": "chuò,xíng",
  "逴覆": "chuò,fù",
  "逴见": "chuò,jiàn",
  "逴越": "chuò,yuè",
  "逴跞": "chuō,luò",
  "逴迈": "chuò,mài",
  "逴远": "chuò,yuǎn",
  "逴逴": "chuò,chuò",
  "逴龙": "chuò,lóng",
  "逵舍": "kuí,shè",
  "逶媠": "wēi,duò",
  "逶折": "wēi,shé",
  "逶迤": "wēi,yí",
  "逶迤退食": "wēi,yí,tuì,shí",
  "逶遟": "wēi,zhì",
  "逸处": "yì,chǔ",
  "逸干": "yì,gàn",
  "逸调": "yì,diào",
  "逻伺": "luó,sì",
  "逻刹": "luó,shā",
  "逻堡": "luó,pù",
  "逻舍": "luó,shè",
  "逻莎": "luó,shā",
  "逻辑学": "luó,ji,xué",
  "逻辑思维": "luó,ji,sī,wéi",
  "逻辑演算": "luó,ji,yǎn,suàn",
  "逻辑炸弹": "luó,jí,zhà,dàn",
  "逻辑电路": "luó,ji,diàn,lù",
  "逻辑链路控制": "luó,ji,liàn,lù,kòng,zhì",
  "逻辑错误": "luó,ji,cuò,wù",
  "逻逮": "luó,dǎi",
  "逼削": "bī,xuē",
  "逼剥": "bī,bāo",
  "逼处": "bī,chǔ",
  "逼夹": "bī,jiā",
  "逼掠": "bī,lüě",
  "逼真地": "bī,zhēn,de",
  "逼笮": "bī,zé",
  "逼绰刀子": "bī,chāo,dāo,zi",
  "逼肖": "bī,xiào",
  "逼良为娼": "bī,liáng,wéi,chāng",
  "逼近地": "bī,jìn,de",
  "逼逼": "bī,bi",
  "逼逼剥剥": "bī,bī,bāo,bāo",
  "逼阽": "bī,yán",
  "逾冠": "yú,guān",
  "逾分": "yú,fèn",
  "逾墙钻穴": "yú,qiáng,zuàn,xué",
  "逾墙钻𧏖": "yú,qiáng,zuàn,pín",
  "逾处": "yú,chǔ",
  "逾趯": "yú,yuè",
  "逾载": "yú,zǎi",
  "遁舍": "dùn,shè",
  "遂大夫": "suì,dài,fū",
  "遂心快意": "suí,xīn,kuài,yì",
  "遂惔": "suì,dàn",
  "遂迷不寤": "suí,mí,bù,wù",
  "遂迷不窹": "suí,mí,bù,wù",
  "遂迷忘反": "suí,mí,wàng,fǎn",
  "遂长": "suì,zhǎng",
  "遂非文过": "suí,fēi,wén,guò",
  "遇难": "yù,nàn",
  "遇难呈祥": "yù,nàn,chéng,xiáng",
  "遇难成祥": "yù,nàn,chéng,xiáng",
  "遇难者": "yù,nàn,zhě",
  "遍处": "biàn,chǔ",
  "遏岨": "è,qū",
  "遏折": "è,shé",
  "遐覃": "xiá,qín",
  "遐载": "xiá,zǎi",
  "遐适": "xiá,shì",
  "遒劲": "qiú,jìng",
  "道三不着两": "dào,sān,bù,zháo,liǎng",
  "道不同不相为谋": "dào,bù,tóng,bù,xiāng,wéi,móu",
  "道不是": "dào,bú,shì",
  "道令纸": "dào,lǐng,zhǐ",
  "道傍苦李": "dào,páng,kǔ,lǐ",
  "道儿": "dào,er",
  "道冠": "dào,guān",
  "道在人为": "dào,zài,rén,wéi",
  "道场院": "dào,cháng,yuàn",
  "道得应得": "dào,de,yīng,de",
  "道德地": "dào,dé,de",
  "道德行为": "dào,dé,xíng,wéi",
  "道德认识": "dào,dé,rèn,shi",
  "道数": "dào,shù",
  "道理": "dào,li",
  "道琼斯指数": "dào,qióng,sī,zhǐ,shù",
  "道的应的": "dào,de,yìng,de",
  "道真仡佬族苗族自治县": "dào,zhēn,gē,lǎo,zú,miáo,zú,zì,zhì,xiàn",
  "道禁": "dào,jìn",
  "道舍": "dào,shè",
  "道茀": "dào,bó",
  "道藏": "dào,zàng",
  "道行": "dào,héng",
  "道观": "dào,guàn",
  "道调": "dào,diào",
  "道路藉藉": "dào,lù,jí,jí",
  "道道儿": "dào,dào,er",
  "道长": "dào,zhǎng",
  "遗世忘累": "yí,shì,wàng,lěi",
  "遗亾": "yí,wú",
  "遗传上地": "yí,chuán,shàng,de",
  "遗传因子": "yí,chuán,yīn,zi",
  "遗使": "wèi,shǐ",
  "遗劳": "wèi,láo",
  "遗𠡠": "yí,lài",
  "遗卷": "yí,juàn",
  "遗大": "wèi,dà",
  "遗少": "yí,shào",
  "遗帖": "yí,tiē",
  "遗忘地": "yí,wàng,de",
  "遗憾地": "yí,hàn,de",
  "遗憾地说": "yí,hàn,de,shuō",
  "遗折": "yí,shé",
  "遗操": "wèi,cāo",
  "遗朴": "yí,piáo",
  "遗漏地": "yí,lòu,de",
  "遗炤": "yí,zhāo",
  "遗着": "yí,zhe",
  "遗砮": "yí,nú",
  "遗禁": "yí,jìn",
  "遗秉": "wèi,bǐng",
  "遗䇲": "yí,jiā",
  "遗簪脱舃": "yí,zān,tuō,tuō",
  "遗累": "yí,lèi",
  "遗缪": "yí,miù",
  "遗老遗少": "yí,lǎo,yí,shào",
  "遗臊撒粪": "yí,sào,sā,fèn",
  "遗臭万载": "yí,chòu,wàn,zǎi",
  "遗舃": "yí,tuō",
  "遗调": "yí,diào",
  "遗贼": "wèi,zéi",
  "遗赂": "wèi,lù",
  "遗躅": "yí,zhuó",
  "遗载": "yí,zǎi",
  "遗送": "wèi,sòng",
  "遗酌": "wèi,zhuó",
  "遗金": "wèi,jīn",
  "遗露": "yí,lù",
  "遛弯儿": "liù,wān,er",
  "遛搭": "liú,dā",
  "遛早": "liú,zǎo",
  "遛早儿": "liú,zǎo,er",
  "遛步": "liú,bù",
  "遛脚": "liú,jiǎo",
  "遛腿": "liú,tuǐ",
  "遛达": "liú,dá",
  "遣兵调将": "qiǎn,bīng,diào,jiàng",
  "遣将": "qiǎn,jiàng",
  "遣将调兵": "qiǎn,jiāng,diào,bīng",
  "遣累": "qiǎn,lèi",
  "遣适": "qiǎn,shì",
  "遥兴": "yáo,xīng",
  "遥呼相应": "yáo,hū,xiāng,yìng",
  "遥堤": "yáo,dī",
  "遥应": "yáo,yìng",
  "遥相呼应": "yáo,xiāng,hū,yìng",
  "遥远地": "yáo,yuǎn,de",
  "遥遥地": "yáo,yáo,de",
  "遭劫在数": "zāo,jié,zài,shù",
  "遭累": "zāo,lèi",
  "遭难": "zāo,nàn",
  "遮么": "zhē,mǒ",
  "遮扞": "zhē,gǎn",
  "遮禁": "zhē,jìn",
  "遮面子": "zhē,miàn,zi",
  "遴调": "lín,diào",
  "遵从地": "zūn,cóng,de",
  "遵本舍末": "zūn,běn,shè,mò",
  "遵炤": "zūn,zhāo",
  "遵禁": "zūn,jìn",
  "𰺷佛": "rǎo,fó",
  "𰺷围": "rǎo,wéi",
  "𰺷圜": "rǎo,huán",
  "𰺷弄": "rǎo,nòng",
  "𰺷弯": "rǎo,wān",
  "𰺷指": "rǎo,zhǐ",
  "𰺷指柔": "rǎo,zhǐ,róu",
  "𰺷束": "rǎo,shù",
  "𰺷梁": "rǎo,liáng",
  "𰺷梁声": "rǎo,liáng,shēng",
  "𰺷梁歌": "rǎo,liáng,gē",
  "𰺷殿雷": "rǎo,diàn,léi",
  "𰺷膝": "rǎo,xī",
  "𰺷萦": "rǎo,yíng",
  "𰺷身": "rǎo,shēn",
  "𰺷道": "rǎo,dào",
  "𰺷𰺷": "rǎo,rǎo",
  "避三舍": "bì,sān,shè",
  "避免地": "bì,miǎn,de",
  "避军三舍": "bì,jūn,sān,shè",
  "避君三舍": "bì,jūn,sān,shè",
  "避堇": "bì,jǐn",
  "避处": "bì,chǔ",
  "避开地": "bì,kāi,de",
  "避弹坑": "bì,dàn,kēng",
  "避弹服": "bì,dàn,fú",
  "避慊": "bì,qiè",
  "避煞": "bì,shà",
  "避祸求福": "bì,huò,qiú,fù",
  "避舍": "bì,shè",
  "避难": "bì,nàn",
  "避难所": "bì,nàn,suǒ",
  "避风头": "bì,fēng,tou",
  "邀帖": "yāo,tiē",
  "邀挟": "yāo,jiā",
  "邈处欿视": "miǎo,chǔ,kǎn,shì",
  "邈掠": "miǎo,lüě",
  "邋塌地": "lā,tā,de",
  "邋遢": "lā,tā",
  "邋遢地": "lā,tā,de",
  "邋里邋遢": "lā,li,lā,ta",
  "邑侯": "yì,hòu",
  "邙风": "māng,fēng",
  "邛笮": "qióng,zé",
  "邛葛": "qióng,gě",
  "那么地": "nà,me,de",
  "那么点儿": "nà,me,diǎn,er",
  "那么着": "nà,me,zhāo",
  "那些": "nèi,xiē",
  "那些个": "nèi,xiē,gè",
  "那们": "nà,men",
  "那会儿": "nà,huì,er",
  "那伽": "nà,qié",
  "那伽花": "nà,qié,huā",
  "那倒是": "nà,dào,shi",
  "那咤": "né,zhà",
  "那咱": "nà,zan",
  "那堤": "nà,tí",
  "那就大大地": "nà,jiù,dà,dà,de",
  "那得": "nà,de",
  "那拉提草原": "nà,lā,dī,cǎo,yuán",
  "那时候": "nà,shí,hou",
  "那昝": "nà,zan",
  "那是": "nà,shi",
  "那是地": "nà,shì,de",
  "那曲": "nǎ,qū",
  "那曲县": "nǎ,qū,xiàn",
  "那末着": "nà,mò,zhe",
  "那查": "nà,zhā",
  "那样地说": "nà,yàng,de,shuō",
  "那溜儿": "nà,liù,ér",
  "那点儿": "nà,diǎn,er",
  "那着": "nà,zhe",
  "那知": "nǎ,zhī",
  "那维克": "nǎ,wéi,kè",
  "那话儿": "nà,huà,er",
  "那里放着": "nà,lǐ,fàng,zhe",
  "那阵子": "nà,zhèn,zi",
  "邦以民为本": "bāng,yǐ,mín,wéi,běn",
  "邦侯": "bāng,hòu",
  "邦汋": "bāng,yuè",
  "邦禁": "bāng,jìn",
  "邨堡": "cūn,pù",
  "邨舍": "cūn,shè",
  "邪恶地": "xié,è,de",
  "邪揄": "yé,yú",
  "邪皮子": "xié,pí,zi",
  "邪累": "xié,lèi",
  "邪见幢": "xié,jiàn,zhuàng",
  "邪许": "yé,hǔ",
  "邮差": "yóu,chāi",
  "邮筩": "yóu,yǒng",
  "邮舍": "yóu,shè",
  "邯郸重步": "hán,dān,chóng,bù",
  "邷么儿": "wǎ,mó,er",
  "邸舍": "dǐ,shè",
  "邹夹": "zōu,jiā",
  "邹查": "zōu,zhā",
  "邺侯": "yè,hòu",
  "邺侯书": "yè,hòu,shū",
  "邺侯架": "yè,hòu,jià",
  "邻篴": "lín,dí",
  "邻舍": "lín,shè",
  "邻舍笛": "lín,shè,dí",
  "郁兴": "yù,xīng",
  "郁垒": "yù,lǜ",
  "郁垒神荼": "yù,lǜ,shēn,shū",
  "郁垒符": "yù,lǜ,fú",
  "郁塞": "yù,sè",
  "郁捋": "yù,lǚ",
  "郁朴": "yù,piáo",
  "郁林葛": "yù,lín,gě",
  "郁茀": "yù,bó",
  "郁血": "yù,xuè",
  "郁郁累累": "yù,yù,lěi,lěi",
  "郁金翘": "yù,jīn,qiào",
  "郁銕": "yù,yí",
  "郁𬮴": "yù,ān",
  "郁闭地沉思": "yù,bì,de,chén,sī",
  "郁闷地": "yù,mèn,de",
  "郁闷地坐在": "yù,mèn,de,zuò,zài",
  "郁闷地坐着": "yù,mèn,de,zuò,zhe",
  "郁闷地说": "yù,mèn,de,shuō",
  "郄公": "xì,gōng",
  "郄兵": "xì,bīng",
  "郄地": "xì,dì",
  "郄始": "xì,shǐ",
  "郄曲": "xì,qǔ",
  "郄枝": "xì,zhī",
  "郄桂": "xì,guì",
  "郄穴": "xì,xué",
  "郄縠": "xì,hú",
  "郄蝉草": "xì,chán,cǎo",
  "郄诜枝": "xì,shēn,zhī",
  "郄诜树": "xì,shēn,shù",
  "郄诜桂": "xì,shēn,guì",
  "郄诜第": "xì,shēn,dì",
  "郄诜策": "xì,shēn,cè",
  "郄诜荣": "xì,shēn,róng",
  "郇公五云体": "huán,gōng,wǔ,yún,tǐ",
  "郇公厨": "huán,gōng,chú",
  "郇厨": "huán,chú",
  "郇庖": "huán,páo",
  "郇瑕": "huán,xiá",
  "郇笺": "huán,jiān",
  "郈成分宅": "hòu,chéng,fèn,zhái",
  "郊处": "jiāo,chǔ",
  "郊干": "jiāo,gàn",
  "郊舍": "jiāo,shè",
  "郊菟": "jiāo,tú",
  "郊血": "jiāo,xuè",
  "郎将": "láng,jiàng",
  "郎耶草": "láng,yē,cǎo",
  "郎舍": "láng,shè",
  "郑庄好客": "zhèng,zhuāng,hào,kè",
  "郑重其事地": "zhèng,zhòng,qí,shì,de",
  "郑重地": "zhèng,zhòng,de",
  "郑重地希望": "zhèng,zhòng,de,xī,wàng",
  "郑重地说": "zhèng,zhòng,de,shuō",
  "郡侯": "jùn,hòu",
  "郢书燕说": "yǐng,shū,yān,shuō",
  "郢削": "yǐng,xuē",
  "郢调": "yǐng,diào",
  "郢都": "yǐng,dū",
  "郄诜丹桂": "xì,shēn,dān,guì",
  "郄诜高第": "xì,shēn,gāo,dì",
  "郦食其": "lì,yì,jī",
  "部份地": "bù,fèn,de",
  "部份性地": "bù,fèn,xìng,de",
  "部分": "bù,fèn",
  "部分分式": "bù,fèn,fēn,shì",
  "部分切除": "bù,fèn,qiē,chú",
  "部分地": "bù,fèn,de",
  "部分工时": "bù,fen,gōng,shí",
  "部将": "bù,jiàng",
  "部帑": "bù,tǎng",
  "部帖": "bù,tiē",
  "部长": "bù,zhǎng",
  "部长会": "bù,zhǎng,huì",
  "部长会议": "bù,zhǎng,huì,yì",
  "部长级": "bù,zhǎng,jí",
  "部长级会议": "bù,zhǎng,jí,huì,yì",
  "郭细侯": "guō,xì,hòu",
  "都下": "dū,xià",
  "都中纸贵": "dū,zhōng,zhǐ,guì",
  "都乡侯": "dōu,xiāng,hòu",
  "都亭": "dū,tíng",
  "都任性地": "dōu,rèn,xìng,de",
  "都会传奇": "dū,huì,chuán,qí",
  "都会美型男": "dū,huì,měi,xíng,nán",
  "都伯林": "dū,bó,lín",
  "都兰": "dū,lán",
  "都兰县": "dū,lán,xiàn",
  "都匀": "dū,yún",
  "都匀市": "dū,yún,shì",
  "都司": "dū,sī",
  "都在不停地": "dōu,zài,bù,tíng,de",
  "都城": "dū,chéng",
  "都头": "dū,tóu",
  "都头异姓": "dū,tóu,yì,xìng",
  "都好好地": "dōu,hǎo,hǎo,de",
  "都安县": "dū,ān,xiàn",
  "都安瑶族自治县": "dū,ān,yáo,zú,zì,zhì,xiàn",
  "都察院": "dū,chá,yuàn",
  "都尉": "dū,wèi",
  "都市": "dū,shì",
  "都市传奇": "dū,shì,chuán,qí",
  "都市化地区": "dū,shì,huà,dì,qū",
  "都市病": "dū,shì,bìng",
  "都市美型男": "dū,shì,měi,xíng,nán",
  "都府": "dū,fǔ",
  "都庞岭": "dū,páng,lǐng",
  "都御使": "dū,yù,shǐ",
  "都德": "dū,dé",
  "都悄悄地": "dōu,qiāo,qiāo,de",
  "都护": "dū,hù",
  "都接连地": "dōu,jiē,lián,de",
  "都数": "dōu,shù",
  "都昌": "dū,chāng",
  "都昌县": "dū,chāng,xiàn",
  "都是直直地下": "dōu,shì,zhí,zhí,de,xià",
  "都是那么地": "dōu,shì,nà,me,de",
  "都更案": "dū,gēng,àn",
  "都柏林": "dōu,bó,lín",
  "都柱": "dū,zhù",
  "都根主子": "dōu,gēn,zhǔ,zi",
  "都江堰": "dū,jiāng,yàn",
  "都江堰市": "dū,jiāng,yàn,shì",
  "都没有很好地": "dōu,méi,yǒu,hěn,hǎo,de",
  "都深深地": "dōu,shēn,shēn,de",
  "都灵": "dū,líng",
  "都甸": "dū,diàn",
  "都畿": "dū,jī",
  "都督": "dū,dū",
  "都简单地": "dōu,jiǎn,dān,de",
  "都紧紧地": "dōu,jǐn,jǐn,de",
  "都给事中": "dū,jǐ,shì,zhōng",
  "都统": "dū,tǒng",
  "都统笼": "dū,tǒng,lóng",
  "都能很好地": "dōu,néng,hěn,hǎo,de",
  "都自觉地": "dōu,zì,jué,de",
  "都要不停地": "dōu,yào,bù,tíng,de",
  "都认真地": "dōu,rèn,zhēn,de",
  "都试": "dū,shì",
  "都豪迈地": "dōu,háo,mài,de",
  "都辇": "dū,niǎn",
  "都邑": "dū,yì",
  "都邑簿": "dū,yì,bù",
  "都都统": "dōu,dū,tǒng",
  "都鄙": "dū,bǐ",
  "都铎王朝": "dū,duó,wáng,cháo",
  "鄙俗地": "bǐ,sú,de",
  "鄙劣地": "bǐ,liè,de",
  "鄙晻": "bǐ,ǎn",
  "鄙朴": "bǐ,piáo",
  "鄙累": "bǐ,lèi",
  "鄙缪": "bǐ,miù",
  "鄙背": "bǐ,bèi",
  "鄙薄": "bǐ,bó",
  "鄙訿": "bǐ,zī",
  "鄙𬮴": "bǐ,ān",
  "鄙𫘤": "bǐ,ái",
  "酂侯": "zàn,hòu",
  "酂台": "zàn,tái",
  "酂白": "zàn,bái",
  "酂鄙": "zàn,bǐ",
  "酆都": "fēng,dū",
  "酆都城": "fēng,dū,chéng",
  "酋长": "qiú,zhǎng",
  "酋长国": "qiú,zhǎng,guó",
  "酌予": "zhuó,yǔ",
  "酌处": "zhuó,chǔ",
  "酌处权": "zhuó,chǔ,quán",
  "酌情处理": "zhuó,qíng,chǔ,lǐ",
  "酌数": "zhuó,shù",
  "配乐": "pèi,yuè",
  "配合地": "pèi,hé,de",
  "配对儿": "pèi,duì,er",
  "配称": "pèi,chèn",
  "配给": "pèi,jǐ",
  "配给制": "pèi,jǐ,zhì",
  "配角": "pèi,jué",
  "配调": "pèi,diào",
  "配载": "pèi,zǎi",
  "配适": "pèi,shì",
  "配钥匙": "pèi,yào,shi",
  "酒令儿": "jiǔ,lìng,er",
  "酒晕": "jiǔ,yùn",
  "酒曲": "jiǔ,qū",
  "酒殽": "jiǔ,yáo",
  "酒疯子": "jiǔ,fēng,zi",
  "酒禁": "jiǔ,jìn",
  "酒精中毒": "jiǔ,jīng,zhòng,dú",
  "酒绿灯红": "jiǔ,lù,dēng,hóng",
  "酒罐子": "jiǔ,guàn,zi",
  "酒肉朋友": "jiǔ,ròu,péng,you",
  "酒舍": "jiǔ,shè",
  "酒适": "jiǔ,shì",
  "酒醉地": "jiǔ,zuì,de",
  "酒铛": "jiǔ,chēng",
  "酒铺": "jiǔ,pù",
  "酒馆儿": "jiǔ,guǎn,er",
  "酒香不怕巷子深": "jiǔ,xiāng,bù,pà,xiàng,zi,shēn",
  "酢伪": "cù,wěi",
  "酢味": "cù,wèi",
  "酢器": "cù,qì",
  "酢报": "cù,bào",
  "酢歰": "cù,sè",
  "酢母": "cù,mǔ",
  "酢浆": "cù,jiāng",
  "酢浆草": "cù,jiāng,cǎo",
  "酢菜": "cù,cài",
  "酢败": "cù,bài",
  "酢酒": "cù,jiǔ",
  "酢酨": "cù,zài",
  "酢酬": "cù,chóu",
  "酣兴": "hān,xīng",
  "酣畅地": "hān,chàng,de",
  "酣适": "hān,shì",
  "酦酵": "fā,jiào",
  "酩酊": "mǐng,dǐng",
  "酩酊大醉": "mǐng,dǐng,dà,zuì",
  "酩酊烂醉": "mǐng,dǐng,làn,zuì",
  "酬和": "chóu,hè",
  "酬应": "chóu,yìng",
  "酷掠": "kù,lüě",
  "酷烈地": "kù,liè,de",
  "酷累": "kù,lèi",
  "酸不溜秋": "suān,bu,liū,qiū",
  "酸削": "suān,xuē",
  "酸头儿": "suān,tou,er",
  "酸葡萄": "suān,pú,tao",
  "酸酸地": "suān,suān,de",
  "酽酢": "yàn,cù",
  "酾尊": "shāi,zūn",
  "酾沈淡灾": "shāi,shěn,dàn,zāi",
  "酾沈澹灾": "shāi,shěn,dàn,zāi",
  "酾流": "shāi,liú",
  "酾浚": "shāi,jùn",
  "酾酒": "shāi,jiǔ",
  "醇朴": "chún,piáo",
  "醉乡侯": "zuì,xiāng,hòu",
  "醉人地": "zuì,rén,de",
  "醉侯": "zuì,hòu",
  "醉兀": "zuì,wū",
  "醉兀兀": "zuì,wū,wū",
  "醉厌厌": "zuì,yān,yān",
  "醉咕隆咚": "zuì,gū,lōng,dōng",
  "醉帖": "zuì,tiē",
  "醉煖": "zuì,xuān",
  "醉落魄": "zuì,luò,tuò",
  "醉𫘤": "zuì,ái",
  "醋劲儿": "cù,jìn,er",
  "醋坛子": "cù,tán,zi",
  "醋罐子": "cù,guàn,zi",
  "醒目地": "xǐng,mù,de",
  "醒豁": "xǐng,huò",
  "采侯": "cǎi,hòu",
  "采地": "cài,dì",
  "采折": "cǎi,shé",
  "采捋": "cǎi,lǚ",
  "采掘地": "cǎi,jué,de",
  "采掠": "cǎi,lüě",
  "采斿": "cǎi,yóu",
  "采生折割": "cǎi,shēng,shé,gē",
  "采芼": "cǎi,mào",
  "采荠": "cǎi,qí",
  "采葛": "cǎi,gě",
  "采血": "cǎi,xuè",
  "采邑": "cài,yì",
  "釉子": "yòu,zi",
  "释卷": "shì,juàn",
  "释累": "shì,lèi",
  "释𫏋": "shì,jué",
  "释迦牟尼": "shì,jiā,mù,ní",
  "里外夹攻": "lǐ,wài,jiā,gōng",
  "里头": "lǐ,tou",
  "里子": "lǐ,zi",
  "里应外合": "lǐ,yìng,wài,hé",
  "里弄": "lǐ,lòng",
  "里挑外撅": "lǐ,tiǎo,wài,juē",
  "里瓦几亚条约": "lǐ,wǎ,jī,yà,tiáo,yuē",
  "里维耶拉": "lǐ,wéi,yē,lā",
  "里脊": "lǐ,ji",
  "里脊肉": "lǐ,jí,ròu",
  "里舍": "lǐ,shè",
  "里衖": "lǐ,lòng",
  "里边": "lǐ,bian",
  "里边儿": "lǐ,bian,er",
  "里长": "lǐ,zhǎng",
  "里长伯": "lǐ,zhǎng,bó",
  "重三叠四": "chóng,sān,dié,sì",
  "重三迭四": "chóng,sān,dié,sì",
  "重九": "chóng,jiǔ",
  "重九登高": "chóng,jiǔ,dēng,gāo",
  "重九译": "chóng,jiǔ,yì",
  "重五": "chóng,wǔ",
  "重仞": "chóng,rèn",
  "重估": "chóng,gū",
  "重侯": "zhòng,hòu",
  "重修": "chóng,xiū",
  "重修旧好": "chóng,xiū,jiù,hǎo",
  "重光": "chóng,guāng",
  "重光累洽": "chóng,guāng,lèi,qià",
  "重关击柝": "chóng,guān,jī,tuò",
  "重兴旗鼓": "chóng,xīng,qí,gǔ",
  "重出": "chóng,chū",
  "重出江湖": "chóng,chū,jiāng,hú",
  "重刚": "chóng,gāng",
  "重创": "zhòng,chuāng",
  "重制": "chóng,zhì",
  "重午": "chóng,wǔ",
  "重印": "chóng,yìn",
  "重历旧游": "chóng,lì,jiù,yóu",
  "重又": "chóng,yòu",
  "重叠": "chóng,dié",
  "重合": "chóng,hé",
  "重启": "chóng,qǐ",
  "重味": "chóng,wèi",
  "重唱": "chóng,chàng",
  "重回": "chóng,huí",
  "重围": "chóng,wéi",
  "重圆": "chóng,yuán",
  "重圭叠组": "chóng,guī,dié,zǔ",
  "重垣叠锁": "chóng,yuán,dié,suǒ",
  "重垣迭锁": "chóng,yuán,dié,suǒ",
  "重塑": "chóng,sù",
  "重增其放": "chong,zhen,qi,fang",
  "重处": "zhòng,chǔ",
  "重复": "chóng,fù",
  "重复使力伤害": "chóng,fù,shǐ,lì,shāng,hài",
  "重复地": "chóng,fù,de",
  "重复地说": "chóng,fù,de,shuō",
  "重复性": "chóng,fù,xìng",
  "重复性劳损": "chóng,fù,xìng,láo,sǔn",
  "重复法": "chóng,fù,fǎ",
  "重复节": "chóng,fù,jié",
  "重复语境": "chóng,fù,yǔ,jìng",
  "重大地": "zhòng,dà,de",
  "重头": "chóng,tóu",
  "重头戏": "chóng,tóu,xì",
  "重奏": "chóng,zòu",
  "重婚": "chóng,hūn",
  "重婚罪": "chóng,hūn,zuì",
  "重字": "chóng,zì",
  "重孙": "chóng,sūn",
  "重孙女": "chóng,sūn,nǚ",
  "重孙子": "chóng,sūn,zi",
  "重定向": "chóng,dìng,xiàng",
  "重审": "chóng,shěn",
  "重屋": "chóng,wū",
  "重山": "chóng,shān",
  "重山复岭": "chóng,shān,fù,lǐng",
  "重山复水": "chóng,shān,fù,shuǐ",
  "重山峻岭": "chóng,shān,jùn,lǐng",
  "重岩叠嶂": "chóng,yán,dié,zhàng",
  "重岩叠障": "chóng,yán,dié,zhàng",
  "重岩迭障": "chóng,yán,dié,zhàng",
  "重峦叠嶂": "chóng,luán,dié,zhàng",
  "重峦叠𪩘": "chóng,luán,dié,yǎn",
  "重峦复嶂": "chóng,luán,fù,zhàng",
  "重峦迭嶂": "chóng,luán,dié,zhàng",
  "重峦迭𪩘": "chóng,luán,dié,yǎn",
  "重帑": "zhòng,tǎng",
  "重帛": "chóng,bó",
  "重席": "chóng,xí",
  "重庆": "chóng,qìng",
  "重庆大学": "chóng,qìng,dà,xué",
  "重庆市": "chóng,qìng,shì",
  "重庆科技学院": "chóng,qìng,kē,jì,xué,yuàn",
  "重床叠屋": "chóng,chuáng,dié,wū",
  "重床叠架": "chóng,chuáng,dié,jià",
  "重床迭屋": "chóng,chuáng,dié,wū",
  "重床迭架": "chóng,chuáng,dié,jià",
  "重建": "chóng,jiàn",
  "重开": "chóng,kāi",
  "重弹": "chóng,tán",
  "重影": "chóng,yǐng",
  "重手累足": "chóng,shǒu,lěi,zú",
  "重披战袍": "chóng,pī,zhàn,páo",
  "重担": "zhòng,dàn",
  "重拍": "chóng,pāi",
  "重拾": "chóng,shí",
  "重挂": "chóng,guà",
  "重振": "chóng,zhèn",
  "重振旗鼓": "chóng,zhèn,qí,gǔ",
  "重排": "chóng,pái",
  "重提": "chóng,tí",
  "重提旧事": "chóng,tí,jiù,shì",
  "重插": "chóng,chā",
  "重播": "chóng,bō",
  "重操旧业": "chóng,cāo,jiù,yè",
  "重数": "chóng,shù",
  "重整": "chóng,zhěng",
  "重整旗鼓": "chóng,zhěng,qí,gǔ",
  "重文": "chóng,wén",
  "重新": "chóng,xīn",
  "重新做人": "chóng,xīn,zuò,rén",
  "重新启动": "chóng,xīn,qǐ,dòng",
  "重新地": "chóng,xīn,de",
  "重新审视": "chóng,xīn,shěn,shì",
  "重新开始": "chóng,xīn,kāi,shǐ",
  "重新开机": "chóng,xīn,kāi,jī",
  "重新统一": "chóng,xīn,tǒng,yī",
  "重新装修": "chóng,xīn,zhuāng,xiū",
  "重新评价": "chóng,xīn,píng,jià",
  "重新造林": "chóng,xīn,zào,lín",
  "重明继焰": "chóng,míng,jì,yàn",
  "重映": "chóng,yìng",
  "重来": "chóng,lái",
  "重来郭伋": "chóng,lái,guō,jí",
  "重构": "chóng,gòu",
  "重查": "chóng,chá",
  "重栅": "zhòng,shān",
  "重样": "chóng,yàng",
  "重根": "chóng,gēn",
  "重橑": "zhòng,lǎo",
  "重正化": "chóng,zhèng,huà",
  "重毂": "zhòng,gū",
  "重水反应堆": "zhòng,shuǐ,fǎn,yìng,duī",
  "重沓": "chóng,tà",
  "重洋": "chóng,yáng",
  "重活儿": "zhòng,huó,er",
  "重混": "chóng,hùn",
  "重温": "chóng,wēn",
  "重温旧业": "chóng,wēn,jiù,yè",
  "重温旧梦": "chóng,wēn,jiù,mèng",
  "重演": "chóng,yǎn",
  "重熙累叶": "chóng,xī,lěi,yè",
  "重熙累洽": "chóng,xī,lěi,qià",
  "重熙累盛": "chóng,xī,lěi,shèng",
  "重熙累绩": "chóng,xī,lěi,jì",
  "重版": "chóng,bǎn",
  "重犯": "chóng,fàn",
  "重犴": "zhòng,àn",
  "重玩": "chóng,wán",
  "重现": "chóng,xiàn",
  "重现江湖": "chóng,xiàn,jiāng,hú",
  "重珪叠组": "chóng,guī,dié,zǔ",
  "重珪迭组": "chóng,guī,dié,zǔ",
  "重理旧业": "chóng,lǐ,jiù,yè",
  "重瓣": "chóng,bàn",
  "重生": "chóng,shēng",
  "重生父母": "chóng,shēng,fù,mǔ",
  "重生爷娘": "chóng,shēng,yé,niáng",
  "重申": "chóng,shēn",
  "重眼皮": "chóng,yǎn,pí",
  "重眼皮儿": "chóng,yǎn,pí,er",
  "重着": "zhòng,zhe",
  "重睹天日": "chóng,dǔ,tiān,rì",
  "重码": "chóng,mǎ",
  "重码词频": "chóng,mǎ,cí,pín",
  "重碳酸盐": "chóng,tàn,suān,yán",
  "重碳酸钙": "chóng,tàn,suān,gài",
  "重磅炸弹": "zhòng,bàng,zhà,dàn",
  "重禁": "zhòng,jìn",
  "重算": "chóng,suàn",
  "重累": "zhòng,lèi",
  "重纰𰷠缪": "chóng,pī,yí,miù",
  "重纸累札": "chóng,zhǐ,lèi,zhá",
  "重组": "chóng,zǔ",
  "重编": "chóng,biān",
  "重置": "chóng,zhì",
  "重翟": "zhòng,zhái",
  "重联": "chóng,lián",
  "重聚": "chóng,jù",
  "重茧": "chóng,jiǎn",
  "重荷": "zhòng,hè",
  "重获": "chóng,huò",
  "重葩累藻": "chóng,pā,lèi,zǎo",
  "重行": "chóng,xíng",
  "重衾": "chóng,qīn",
  "重裀": "chóng,yīn",
  "重裀列鼎": "chóng,yīn,liè,dǐng",
  "重裘": "chóng,qiú",
  "重裯": "zhòng,dāo",
  "重要地": "zhòng,yào,de",
  "重见天日": "chóng,jiàn,tiān,rì",
  "重规": "chóng,guī",
  "重规叠矩": "chóng,guī,dié,jǔ",
  "重规沓矩": "chóng,guī,tà,jǔ",
  "重规累矩": "chóng,guī,lèi,jǔ",
  "重规袭矩": "chóng,guī,xí,jǔ",
  "重规迭矩": "chóng,guī,dié,jǔ",
  "重觞": "chóng,shāng",
  "重访": "chóng,fǎng",
  "重评": "chóng,píng",
  "重译": "chóng,yì",
  "重试": "chóng,shì",
  "重说地": "zhòng,shuō,de",
  "重𰷠": "zhòng,yí",
  "重起炉灶": "chóng,qǐ,lú,zào",
  "重足一迹": "chóng,zú,yī,jì",
  "重足屏息": "chóng,zú,bǐng,xī",
  "重足屏气": "chóng,zú,bǐng,qì",
  "重足累息": "chóng,zú,lèi,xī",
  "重足而立": "chóng,zú,ér,lì",
  "重趼": "chóng,jiǎn",
  "重蹈": "chóng,dǎo",
  "重蹈覆辙": "chóng,dǎo,fù,zhé",
  "重身": "chóng,shēn",
  "重身子": "zhòng,shēn,zi",
  "重𰺛": "zhòng,láo",
  "重返": "chóng,fǎn",
  "重连": "chóng,lián",
  "重述": "chóng,shù",
  "重述地": "chóng,shù,de",
  "重迹屏气": "chóng,jì,bǐng,qì",
  "重适": "chóng,shì",
  "重造": "chóng,zào",
  "重逢": "chóng,féng",
  "重采": "chóng,cǎi",
  "重重": "chóng,chóng",
  "重重地": "zhòng,zhòng,de",
  "重重地打在": "zhòng,zhòng,de,dǎ,zài",
  "重重地摔在": "zhòng,zhòng,de,shuāi,zài",
  "重重地落下": "zhòng,zhòng,de,là,xià",
  "重重孙": "chóng,chóng,sūn",
  "重金兼紫": "chóng,jīn,jiān,zǐ",
  "重金袭汤": "chóng,jīn,xí,tāng",
  "重铬酸钾": "chóng,gè,suān,jiǎ",
  "重门": "chóng,mén",
  "重门击柝": "chóng,mén,jī,tuò",
  "重阳": "chóng,yáng",
  "重阳糕": "chóng,yáng,gāo",
  "重阳节": "chóng,yáng,jié",
  "重阳落帽": "chóng,yáng,luò,mào",
  "重阳酒": "chóng,yáng,jiǔ",
  "重阳餻": "chóng,yáng,gāo",
  "重霄": "chóng,xiāo",
  "重黎": "chóng,lí",
  "野乘": "yě,shèng",
  "野兴": "yě,xīng",
  "野兽地": "yě,shòu,de",
  "野处": "yě,chǔ",
  "野性地": "yě,xìng,de",
  "野掠": "yě,lüě",
  "野朴": "yě,piáo",
  "野汉子": "yě,hàn,zi",
  "野禁": "yě,jìn",
  "野胡萝卜": "yě,hú,luó,bo",
  "野舍": "yě,shè",
  "野葛": "yě,gě",
  "野蛮地": "yě,mán,de",
  "野调": "yě,diào",
  "野调无腔": "yě,diào,wú,qiāng",
  "野路子": "yě,lù,zi",
  "量体温": "liáng,tǐ,wēn",
  "量体重": "liáng,tǐ,zhòng",
  "量入为出": "liàng,rù,wéi,chū",
  "量具": "liáng,jù",
  "量力度德": "liàng,lì,duó,dé",
  "量力而为": "liàng,lì,ér,wéi",
  "量功": "liáng,gōng",
  "量化逻辑": "liàng,huà,luó,ji",
  "量器": "liáng,qì",
  "量处": "liàng,chǔ",
  "量尺寸": "liáng,chǐ,cùn",
  "量度": "liáng,dù",
  "量才而为": "liàng,cái,ér,wéi",
  "量数": "liàng,shù",
  "量杯": "liáng,bēi",
  "量沙": "liáng,shā",
  "量油尺": "liáng,yóu,chǐ",
  "量测": "liáng,cè",
  "量珠": "liáng,zhū",
  "量瓶": "liáng,píng",
  "量程": "liáng,chéng",
  "量筒": "liáng,tǒng",
  "量血压": "liáng,xuè,yā",
  "量表": "liáng,biǎo",
  "量规": "liáng,guī",
  "量角器": "liáng,jiǎo,qì",
  "量计": "liáng,jì",
  "量身": "liáng,shēn",
  "量身定做": "liáng,shēn,dìng,zuò",
  "量身定制": "liáng,shēn,dìng,zhì",
  "金人捧露盘": "jīn,rén,pěng,lù,pán",
  "金仆": "jīn,pú",
  "金仆姑": "jīn,pú,gū",
  "金冠": "jīn,guān",
  "金冠地莺": "jīn,guān,dì,yīng",
  "金冠戴菊": "jīn,guān,dài,jú",
  "金冠树八哥": "jīn,guān,shù,bā,gē",
  "金刚钻": "jīn,gāng,zuàn",
  "金刹": "jīn,shā",
  "金匮": "jīn,guì",
  "金匮石室": "jīn,guì,shí,shì",
  "金华山": "jīn,huà,shān",
  "金发": "jīn,fà",
  "金发碧眼": "jīn,fà,bì,yǎn",
  "金口角": "jīn,kǒu,jué",
  "金叶子": "jīn,yè,zi",
  "金叶子格": "jīn,yè,zi,gé",
  "金吾不禁": "jīn,wú,bù,jìn",
  "金嗓子": "jīn,sǎng,zi",
  "金国汗": "jīn,guó,hán",
  "金城池地": "jīn,chéng,chí,de",
  "金城汤地": "jīn,chéng,tāng,de",
  "金堤": "jīn,dī",
  "金头缝叶莺": "jīn,tóu,fèng,yè,yīng",
  "金娃娃": "jīn,wá,wa",
  "金小相": "jīn,xiǎo,xiàng",
  "金山屯": "jīn,shān,zhūn",
  "金山屯区": "jīn,shān,zhūn,qū",
  "金帐汗国": "jīn,zhàng,hán,guó",
  "金弹": "jīn,dàn",
  "金指甲": "jīn,zhǐ,jiá",
  "金数": "jīn,shù",
  "金晃晃": "jīn,huàng,huǎng",
  "金栅": "jīn,shān",
  "金桂冠": "jīn,guì,guān",
  "金桔": "jīn,jú",
  "金槛": "jīn,kǎn",
  "金汋": "jīn,yuè",
  "金沤浮钉": "jīn,ōu,fú,dīng",
  "金琕": "jīn,bǐng",
  "金相": "jīn,xiàng",
  "金相玉质": "jīn,xiàng,yù,zhì",
  "金祇": "jīn,qí",
  "金簳": "jīn,gàn",
  "金粟山藏经纸": "jīn,sù,shān,zàng,jīng,zhǐ",
  "金翅擘海": "jīn,chì,bāi,hǎi",
  "金翘": "jīn,qiào",
  "金翟": "jīn,zhái",
  "金背": "jīn,bèi",
  "金背三趾啄木鸟": "jīn,bèi,sān,zhǐ,zhuó,mù,niǎo",
  "金色地": "jīn,sè,de",
  "金茎露": "jīn,jīng,lù",
  "金虾蟆": "jīn,há,má",
  "金蝉脱壳": "jīn,chán,tuō,qiào",
  "金蝉脱殻": "jīn,chán,tuō,què",
  "金融时报指数": "jīn,róng,shí,bào,zhǐ,shù",
  "金融杠杆": "jīn,róng,gàng,gǎn",
  "金蠡": "jīn,lí",
  "金谷酒数": "jīn,gǔ,jiǔ,shù",
  "金鋺": "jīn,yuān",
  "金𰾎": "jīn,bēi",
  "金𬭚": "jīn,duì",
  "金𫔇": "jīn,pī",
  "金针见血": "jīn,zhēn,jiàn,xuè",
  "金钗十二行": "jīn,chāi,shí,èr,háng",
  "金钥匙": "jīn,yào,shi",
  "金钩子": "jīn,gōu,zi",
  "金铃子": "jīn,líng,zi",
  "金铣": "jīn,xǐ",
  "金银花露": "jīn,yín,huā,lù",
  "金镏子": "jīn,liù,zi",
  "金阙": "jīn,què",
  "金雘": "jīn,wò",
  "金风玉露": "jīn,fēng,yù,lù",
  "釜鬵": "fǔ,qín",
  "鈭𰾎": "zī,bēi",
  "𬬺铻": "chú,yǔ",
  "𬬸心刳形": "xù,xīn,kū,xíng",
  "𬬸心刿目": "tóng,xīn,guì,mù",
  "𬬸心刿肾": "huì,xīn,guì,shèn",
  "𬬸肝刿肾": "diāo,gān,guì,shèn",
  "鉴影度形": "jiàn,yǐng,duó,xíng",
  "鉴真和尚": "jiàn,zhēn,hé,shang",
  "𬭅筩": "hóu,yǒng",
  "𰽲轧": "jí,zhá",
  "鋈𬭚": "wù,duì",
  "鋈铣": "wù,xǐ",
  "𫓶人": "juān,rén",
  "𫓶玉": "juān,yù",
  "𬭌锄": "wú,chú",
  "𬭌锹": "wú,qiāo",
  "𬭗𨱌": "wèi,guàn",
  "𮣵䇲": "zhuì,jiā",
  "錾口儿": "zàn,kǒu,er",
  "錾子": "zàn,zi",
  "𫔂针": "dī,zhēn",
  "𰾘然": "zhēn,rán",
  "𰾘𰽻": "zhēn,rén",
  "𨱍头": "láng,tou",
  "𨱍铛": "láng,chēng",
  "𲇲铫": "tuán,yáo",
  "鏊子": "ào,zi",
  "𬭝金": "qiāo,jīn",
  "䦃镐": "zhuō,hào",
  "针头削铁": "zhēn,tóu,xuē,tiě",
  "针对性地": "zhēn,duì,xìng,de",
  "针对性地解决": "zhēn,duì,xìng,de,jiě,jué",
  "针尖儿对麦芒儿": "zhēn,jiān,er,duì,mài,máng,er",
  "针帖": "zhēn,tiē",
  "针扎": "zhēn,zhā",
  "针箍儿": "zhēn,gū,er",
  "针线活儿": "zhēn,xiàn,huó,er",
  "针缝": "zhēn,fèng",
  "钉书机": "dìng,shū,jī",
  "钉书针": "dìng,shū,zhēn",
  "钉住": "dìng,zhù",
  "钉子": "dīng,zi",
  "钉子户": "dīng,zi,hù",
  "钉扣子": "dìng,kòu,zi",
  "钉死": "dìng,sǐ",
  "钉箱子": "dìng,xiāng,zi",
  "钉耙": "dīng,pá",
  "钉钉子": "dìng,dīng,zi",
  "钉钮扣": "dìng,niǔ,kòu",
  "钉铛": "dīng,chēng",
  "钉鞵": "dìng,xié",
  "钉𫖇": "dìng,xuē",
  "钉马掌": "dìng,mǎ,zhǎng",
  "钌铞": "liào,diào",
  "钌铞儿": "liào,diào,er",
  "钎子": "qiān,zi",
  "钎栅": "qiān,shān",
  "钐镰": "shàn,lián",
  "钓凯子": "diào,kǎi,zi",
  "钓名沽誉": "diào,yù,gū,míng",
  "钓杆": "diào,gǎn",
  "钓查": "diào,zhā",
  "钓钩儿": "diào,gōu,er",
  "钕玻璃": "nǚ,bō,li",
  "钙玻璃": "gài,bō,li",
  "钜什": "jù,shí",
  "钜细靡遗": "jù,xì,mǐ,yí",
  "钜鹿侯": "jù,lù,hòu",
  "钝学累功": "dùn,xué,lěi,gōng",
  "钝惽": "dùn,hūn",
  "钝折": "dùn,shé",
  "钝朴": "dùn,piáo",
  "钝𫘤": "dùn,ái",
  "钞剽": "chāo,piāo",
  "钞掠": "chāo,lüě",
  "钟乐": "zhōng,yuè",
  "钟呗": "zhōng,bài",
  "钟情地": "zhōng,qíng,de",
  "钟爱地": "zhōng,ài,de",
  "钟鼎人家": "zhōng,dǐng,rén,jia",
  "钠钙玻璃": "nà,gài,bō,li",
  "钢弹": "gāng,dàn",
  "钢曲尺": "gāng,qū,chǐ",
  "钢镚儿": "gāng,bèng,er",
  "钤干": "qián,gàn",
  "钤缝": "qián,fèng",
  "钥匙": "yào,shi",
  "钥匙卡": "yào,shi,kǎ",
  "钥匙夹套": "yào,shi,jiā,tào",
  "钥匙洞孔": "yào,shi,dòng,kǒng",
  "钥匙链": "yào,shi,liàn",
  "钦佩地": "qīn,pèi,de",
  "钦天监": "qīn,tiān,jiàn",
  "钦差": "qīn,chāi",
  "钦差大臣": "qīn,chāi,dà,chén",
  "钧天广乐": "jūn,tiān,guǎng,yuè",
  "钧天调": "jūn,tiān,diào",
  "钧帖": "jūn,tiē",
  "钧折行仓": "jūn,shé,xíng,cāng",
  "钧调": "jūn,diào",
  "钧适": "jūn,shì",
  "钩儿": "gōu,er",
  "钩剥": "gōu,bāo",
  "钩卷": "gōu,juàn",
  "钩子": "gōu,zi",
  "钩子麻糖": "gōu,zi,má,táng",
  "钩挐": "gōu,ná",
  "钩揣": "gōu,chuāi",
  "钩楯": "gōu,dùn",
  "钩环": "gòu,huán",
  "钩町": "gōu,tīng",
  "钩葛": "gōu,gě",
  "钩逮": "gōu,dǎi",
  "钱串儿": "qián,chuàn,er",
  "钱串子": "qián,chuàn,zi",
  "钱夹": "qián,jiā",
  "钱帖": "qián,tiē",
  "钱数": "qián,shù",
  "钱眼儿": "qián,yǎn,er",
  "钱筩": "qián,yǒng",
  "钱舍": "qián,shè",
  "钱过北斗": "qián,guò,běi,dǒu",
  "钱铺": "qián,pù",
  "钱锅子": "qián,guō,zi",
  "钲鞞": "zhēng,bǐ",
  "钳子": "qián,zi",
  "钴弹": "gǔ,dàn",
  "钵𰽗": "bō,yú",
  "钻井": "zuàn,jǐng",
  "钻井机": "zuàn,jǐng,jī",
  "钻井船": "zuàn,jǐng,chuán",
  "钻井队": "zuàn,jǐng,duì",
  "钻人情": "zuàn,rén,qíng",
  "钻仰": "zuàn,yǎng",
  "钻修": "zuàn,xiū",
  "钻充": "zuàn,chōng",
  "钻具": "zuàn,jù",
  "钻冰取火": "zuàn,bīng,qǔ,huǒ",
  "钻凿": "zuàn,záo",
  "钻刀": "zuàn,dāo",
  "钻刺": "zuàn,cì",
  "钻动": "zuàn,dòng",
  "钻劲儿": "zuān,jìn,er",
  "钻卡": "zuàn,qiǎ",
  "钻厉": "zuàn,lì",
  "钻压": "zuàn,yā",
  "钻发": "zuàn,fā",
  "钻台": "zuàn,tái",
  "钻味": "zuàn,wèi",
  "钻咏": "zuàn,yǒng",
  "钻坚仰高": "zuàn,jiān,yǎng,gāo",
  "钻坚研微": "zuàn,jiān,yán,wēi",
  "钻塔": "zuàn,tǎ",
  "钻天觅缝": "zuàn,tiān,mì,féng",
  "钻头": "zuàn,tóu",
  "钻头就锁": "zuàn,tóu,jiù,suǒ",
  "钻头觅缝": "zuān,tóu,mì,fèng",
  "钻山塞海": "zuàn,shān,sāi,hǎi",
  "钻干": "zuàn,gàn",
  "钻床": "zuàn,chuáng",
  "钻弄": "zuàn,nòng",
  "钻心刺骨": "zuàn,xīn,cì,gǔ",
  "钻心地": "zuān,xīn,de",
  "钻心地疼": "zuān,xīn,de,téng",
  "钻思": "zuàn,sī",
  "钻戒": "zuàn,jiè",
  "钻揅": "zuàn,yán",
  "钻摩": "zuàn,mó",
  "钻攻": "zuàn,gōng",
  "钻故纸": "zuàn,gù,zhǐ",
  "钻故纸堆": "zuàn,gù,zhǐ,duī",
  "钻木": "zuàn,mù",
  "钻木取火": "zuàn,mù,qǔ,huǒ",
  "钻木得火": "zuàn,mù,de,huǒ",
  "钻机": "zuàn,jī",
  "钻杆": "zuàn,gǎn",
  "钻架": "zuàn,jià",
  "钻柱": "zuàn,zhù",
  "钻核": "zuàn,hé",
  "钻桌子": "zuān,zhuō,zi",
  "钻求": "zuàn,qiú",
  "钻沙": "zuàn,shā",
  "钻洞觅缝": "zuàn,dòng,mì,féng",
  "钻火": "zuàn,huǒ",
  "钻灯棚": "zuàn,dēng,péng",
  "钻灰": "zuàn,huī",
  "钻灼": "zuàn,zhuó",
  "钻炼": "zuàn,liàn",
  "钻燧": "zuàn,suì",
  "钻燧改火": "zuàn,suì,gǎi,huǒ",
  "钻燧易火": "zuàn,suì,yì,huǒ",
  "钻牛角": "zuàn,niú,jiǎo",
  "钻狗洞": "zuàn,gǒu,dòng",
  "钻玄": "zuàn,xuán",
  "钻环": "zuàn,huán",
  "钻珠": "zuàn,zhū",
  "钻瓦": "zuàn,wǎ",
  "钻疾": "zuàn,jí",
  "钻皮": "zuàn,pí",
  "钻石": "zuàn,shí",
  "钻石王老五": "zuàn,shí,wáng,lǎo,wǔ",
  "钻砅": "zuàn,lì",
  "钻砺": "zuàn,lì",
  "钻磨": "zuàn,mó",
  "钻穴": "zuàn,xué",
  "钻穴踰垣": "zuàn,xué,yú,yuán",
  "钻穴踰墙": "zuàn,xué,yú,qiáng",
  "钻穴踰隙": "zuàn,xué,yú,xì",
  "钻穴逾垣": "zuàn,xué,yú,yuán",
  "钻空": "zuān,kòng",
  "钻空子": "zuān,kòng,zi",
  "钻窥": "zuàn,kuī",
  "钻笮": "zuàn,zé",
  "钻篱菜": "zuàn,lí,cài",
  "钻纸蝇": "zuàn,zhǐ,yíng",
  "钻缘": "zuàn,yuán",
  "钻缝儿": "zuàn,fèng,ér",
  "钻腮": "zuàn,sāi",
  "钻访": "zuàn,fǎng",
  "钻踰": "zuàn,yú",
  "钻逾": "zuàn,yú",
  "钻𬭼": "zuàn,suì",
  "钻钻": "zuàn,zuàn",
  "钻门出户": "zuàn,mén,chū,hù",
  "钻门子": "zuàn,mén,zǐ",
  "钻阅": "zuàn,yuè",
  "钻隙踰墙": "zuàn,xì,yú,qiáng",
  "钻饰": "zuàn,shì",
  "钻龟": "zuàn,guī",
  "钿头": "tián,tóu",
  "钿朵": "tián,duǒ",
  "钿波": "tián,bō",
  "钿璎": "tián,yīng",
  "钿窝": "tián,wō",
  "钿蝉": "tián,chán",
  "钿钗": "tián,chāi",
  "钿黛": "tián,dài",
  "铁丝状地": "tiě,sī,zhuàng,de",
  "铁了事": "tiě,liǎo,shì",
  "铁什": "tiě,shí",
  "铁冠": "tiě,guān",
  "铁刹": "tiě,shā",
  "铁匠": "tiě,jiang",
  "铁叉子": "tiě,chā,zi",
  "铁哥们": "tiě,gē,men",
  "铁哥们儿": "tiě,gē,men,er",
  "铁唤头": "tiě,huàn,tou",
  "铁子": "tiě,zi",
  "铁帽子王": "tiě,mào,zi,wáng",
  "铁扫帚": "tiě,sào,zhǒu",
  "铁斗子": "tiě,dǒu,zi",
  "铁杆": "tiě,gǎn",
  "铁杆粉丝": "tiě,gǎn,fěn,sī",
  "铁杆蒲": "tiě,gǎn,pú",
  "铁板茄子": "tiě,bǎn,qié,zi",
  "铁板钉钉": "tiě,bǎn,dìng,dīng",
  "铁查": "tiě,zhā",
  "铁树开华": "tiě,shù,kāi,huā",
  "铁格子": "tiě,gé,zi",
  "铁椎": "tiě,chuí",
  "铁爪子": "tiě,zhuǎ,zǐ",
  "铁甲兵轮": "tiě,jiá,bīng,lún",
  "铁窨": "tiě,xūn",
  "铁絙": "tiě,gēng",
  "铁绰铜琶": "tiě,chāo,tóng,pá",
  "铁耙": "tiě,pá",
  "铁蒺藜骨朵": "tiě,jí,lí,gū,duǒ",
  "铁蛋子": "tiě,dàn,zi",
  "铁血": "tiě,xuè",
  "铁血宰相": "tiě,xuè,zǎi,xiàng",
  "铁血政策": "tiě,xuè,zhèng,cè",
  "铁钩儿": "tiě,gōu,er",
  "铁铣": "tiě,xǐ",
  "铁链夹棒": "tiě,liàn,jiā,bàng",
  "铅中毒": "qiān,zhòng,dú",
  "铅山": "yán,shān",
  "铅山县": "yán,shān,xiàn",
  "铅弹": "qiān,dàn",
  "铆劲儿": "mǎo,jìn,er",
  "铆起来": "mǎo,qǐ,lai",
  "铆足劲儿": "mǎo,zú,jìn,er",
  "铗子": "jiá,zi",
  "铛头": "chēng,tóu",
  "铛户": "chēng,hù",
  "铛旋": "chēng,xuán",
  "铛油": "chēng,yóu",
  "铛脚刺史": "chēng,jiǎo,cì,shǐ",
  "铛脚政": "chēng,jiǎo,zhèng",
  "铛鬲": "chēng,gé",
  "铛鼎": "chēng,dǐng",
  "铜乐队": "tóng,yuè,duì",
  "铜匠": "tóng,jiang",
  "铜嗓子": "tóng,sǎng,zi",
  "铜堤": "tóng,dī",
  "铜子儿": "tóng,zǐ,er",
  "铜枓": "tóng,dǒu",
  "铜模": "tóng,mú",
  "铜琶铁板": "tóng,pā,tiě,bǎn",
  "铜磨笴": "tóng,mó,gǎn",
  "铜禁": "tóng,jìn",
  "铜管乐": "tóng,guǎn,yuè",
  "铜管乐器": "tóng,guǎn,yuè,qì",
  "铜管乐队": "tóng,guǎn,yuè,duì",
  "铜臭": "tóng,xiù",
  "铜臭味": "tóng,xiù,wèi",
  "铜蠡": "tóng,lí",
  "铜𫔂": "tóng,dī",
  "铜钿": "tóng,tián",
  "铜铺": "tóng,pù",
  "铜镜反应": "tóng,jìng,fǎn,yìng",
  "铜阬": "tóng,gāng",
  "铜鼓地": "tóng,gǔ,de",
  "铠扞": "kǎi,gǎn",
  "铢两悉称": "zhū,liǎng,xī,chèn",
  "铢两相称": "zhū,liǎng,xiāng,chèn",
  "铢寸累积": "zhū,cùn,lèi,jī",
  "铢积丝累": "zhū,jī,sī,lèi",
  "铢积寸累": "zhū,jī,cùn,lěi",
  "铢积锱累": "zhū,jī,zī,lèi",
  "铢称寸量": "zhū,chēng,cùn,liáng",
  "铢累寸积": "zhū,lèi,cùn,jī",
  "铢量寸度": "zhū,liáng,cùn,duó",
  "铣刀": "xǐ,dāo",
  "铣削": "xǐ,xiāo",
  "铣塞": "xǐ,sāi",
  "铣工": "xǐ,gōng",
  "铣床": "xǐ,chuáng",
  "铣树": "xǐ,shù",
  "铣泽": "xǐ,zé",
  "铣珧": "xǐ,yáo",
  "铣𰽢": "xǐ,xiàn",
  "铣锒": "xǐ,láng",
  "铤鹿": "dìng,lù",
  "铤鹿走险": "dìng,lù,zǒu,xiǎn",
  "铨调": "quán,diào",
  "铫子": "yáo,zǐ",
  "铫弋": "yáo,yì",
  "铫盏": "yáo,zhǎn",
  "铫耨": "yáo,nòu",
  "铫芅": "yáo,yì",
  "铫𬭦": "yáo,nòu",
  "铫铛": "yáo,chēng",
  "铲削": "chǎn,xuē",
  "铲子": "chǎn,zi",
  "铳子": "chòng,zi",
  "铴锣": "tāng,luó",
  "银一般地": "yín,yì,bān,de",
  "银发": "yín,fà",
  "银子": "yín,zi",
  "银子钱": "yín,zi,qián",
  "银幢": "yín,zhuàng",
  "银折": "yín,shé",
  "银折盂": "yín,shé,yú",
  "银指甲": "yín,zhǐ,jiá",
  "银掠儿": "yín,lüě,ér",
  "银揲子": "yín,dié,zǐ",
  "银朴": "yín,piáo",
  "银河倒泻": "yín,hé,dào,xiè",
  "银菟符": "yín,tú,fú",
  "银行": "yín,háng",
  "银行业": "yín,háng,yè",
  "银行业务": "yín,háng,yè,wù",
  "银行卡": "yín,háng,kǎ",
  "银行家": "yín,háng,jiā",
  "银行对账单": "yín,háng,duì,zhàng,dān",
  "银行行员": "yín,háng,háng,yuán",
  "银铺": "yín,pù",
  "铸剑为犁": "zhù,jiàn,wéi,lí",
  "铺丁": "pù,dīng",
  "铺主": "pù,zhǔ",
  "铺丽": "pù,lì",
  "铺买": "pù,mǎi",
  "铺于": "pù,yú",
  "铺仓": "pù,cāng",
  "铺位": "pù,wèi",
  "铺保": "pù,bǎo",
  "铺公": "pù,gōng",
  "铺兵": "pù,bīng",
  "铺兵锣": "pù,bīng,luó",
  "铺写": "pù,xiě",
  "铺凿": "pù,záo",
  "铺列": "pù,liè",
  "铺卒": "pù,zú",
  "铺卧": "pù,wò",
  "铺厫": "pù,áo",
  "铺叠": "pù,dié",
  "铺司": "pù,sī",
  "铺呈": "pù,chéng",
  "铺地钱": "pù,dì,qián",
  "铺地锦": "pù,dì,jǐn",
  "铺堂": "pù,táng",
  "铺夫": "pù,fū",
  "铺头口": "pù,tóu,kǒu",
  "铺子": "pù,zǐ",
  "铺家": "pù,jiā",
  "铺尺": "pù,chǐ",
  "铺屋": "pù,wū",
  "铺席": "pù,xí",
  "铺底": "pù,dǐ",
  "铺张地": "pū,zhāng,de",
  "铺德": "pù,dé",
  "铺户": "pù,hù",
  "铺房": "pù,fáng",
  "铺手": "pù,shǒu",
  "铺扬": "pù,yáng",
  "铺拉": "pù,lā",
  "铺持": "pù,chí",
  "铺捐": "pù,juān",
  "铺搭": "pù,dā",
  "铺摊": "pū,tan",
  "铺摊子": "pù,tān,zi",
  "铺撒": "pù,sā",
  "铺敦": "pù,dūn",
  "铺敷": "pù,fū",
  "铺文": "pù,wén",
  "铺施": "pù,shī",
  "铺板": "pù,bǎn",
  "铺棻": "pù,fēn",
  "铺模": "pù,mó",
  "铺殿花": "pù,diàn,huā",
  "铺母": "pù,mǔ",
  "铺派": "pù,pài",
  "铺海": "pù,hǎi",
  "铺滕": "pù,téng",
  "铺潦": "pù,liáo",
  "铺牌": "pù,pái",
  "铺班": "pù,bān",
  "铺白": "pù,bái",
  "铺监": "pù,jiān",
  "铺盖卷儿": "pū,gài,juǎn,er",
  "铺眉苫眼": "pū,méi,shàn,yǎn",
  "铺着": "pù,zhe",
  "铺程": "pù,chéng",
  "铺筑": "pù,zhù",
  "铺绎": "pù,yì",
  "铺结": "pù,jié",
  "铺绪": "pù,xù",
  "铺置": "pù,zhì",
  "铺翠销金": "pù,cuì,xiāo,jīn",
  "铺翳": "pù,yì",
  "铺腾": "pù,téng",
  "铺舍": "pù,shè",
  "铺舒": "pù,shū",
  "铺行": "pù,xíng",
  "铺衍": "pù,yǎn",
  "铺观": "pù,guān",
  "铺说": "pù,shuō",
  "铺调": "pù,diào",
  "铺谋定计": "pù,móu,dìng,jì",
  "铺过": "pù,guò",
  "铺迟": "pù,chí",
  "铺迭": "pù,dié",
  "铺述": "pù,shù",
  "铺递": "pù,dì",
  "铺采摛文": "pù,cǎi,chī,wén",
  "铺铺": "pù,pù",
  "铺锦": "pù,jǐn",
  "铺闻": "pù,wén",
  "铺食": "pù,shí",
  "铺马": "pù,mǎ",
  "铺马圣旨": "pù,mǎ,shèng,zhǐ",
  "铺马札子": "pù,mǎ,zhá,zǐ",
  "铺驿": "pù,yì",
  "链反应": "liàn,fǎn,yìng",
  "链子": "liàn,zi",
  "链式反应": "liàn,shì,fǎn,yìng",
  "链式裂变反应": "liàn,shì,liè,biàn,fǎn,yìng",
  "链钳子": "liàn,qián,zi",
  "铿镗": "kēng,táng",
  "铿镪顿挫": "kēng,qiāng,dùn,cuò",
  "销假": "xiāo,jià",
  "销子": "xiāo,zi",
  "销折": "xiāo,shé",
  "销断地": "xiāo,duàn,de",
  "锁匠": "suǒ,jiang",
  "锁头": "suǒ,tou",
  "锁应": "suǒ,yìng",
  "锁桔": "suǒ,jú",
  "锁禁": "suǒ,jìn",
  "锄削": "chú,xuē",
  "锄头": "chú,tou",
  "锄头雨": "chú,tou,yǔ",
  "锄掊": "chú,póu",
  "锅伙": "guō,huo",
  "锅子": "guō,zi",
  "锅炉给水": "guō,lú,jǐ,shuǐ",
  "锈蚀地": "xiù,shí,de",
  "锉折": "cuò,shé",
  "锋芒不露": "fēng,máng,bù,lù",
  "锋芒毕露": "fēng,máng,bì,lù",
  "锋𫔂": "fēng,dī",
  "锋铓毕露": "fēng,máng,bì,lù",
  "锐利地": "ruì,lì,de",
  "锒镗": "láng,táng",
  "锔子": "jū,zi",
  "错处": "cuò,chǔ",
  "错折": "cuò,shé",
  "错着水": "cuò,zhe,shuǐ",
  "错𬘝": "cuò,tiǎn",
  "错缝儿": "cuò,fèng,ér",
  "错缪": "cuò,miù",
  "错觉地": "cuò,jué,de",
  "错误地": "cuò,wù,de",
  "错误地认为": "cuò,wù,de,rèn,wéi",
  "锚泊地": "máo,pō,dì",
  "锟𬭌": "kūn,wú",
  "锡予": "xī,yǔ",
  "锢禁": "gù,jìn",
  "锣鼓点儿": "luó,gǔ,diǎn,er",
  "锤子": "chuí,zi",
  "锥处囊中": "zhuī,chǔ,náng,zhōng",
  "锥子": "zhuī,zi",
  "锦卷": "jǐn,juàn",
  "锦囊还矢": "jǐn,náng,huán,shǐ",
  "锦帆": "jǐn,fān",
  "锦帆天子": "jǐn,fān,tiān,zǐ",
  "锦帆泾": "jǐn,fān,jīng",
  "锦笮": "jǐn,zé",
  "锦𬙋": "jǐn,rǎng",
  "锧笮": "zhì,zé",
  "锪孔": "huō,kǒng",
  "锪钻": "huō,zuàn",
  "锭子": "dìng,zi",
  "锭模": "dìng,mú",
  "键盘乐器": "jiàn,pán,yuè,qì",
  "锯子": "jù,zi",
  "锯齿形地": "jù,chǐ,xíng,de",
  "锻模": "duàn,mú",
  "镂冰㔉雪": "lòu,bīng,diāo,xuě",
  "镂心呕血": "lòu,xīn,ǒu,xuè",
  "镂心𬬸肝": "lòu,xīn,fèng,gān",
  "镂肝𬬸肾": "lòu,gān,qiā,shèn",
  "镂金铺翠": "lòu,jīn,pù,cuì",
  "镆干": "mò,gàn",
  "镆耶": "mò,yē",
  "镆䥺": "mò,yá",
  "镇压地": "zhèn,yā,de",
  "镇子": "zhèn,zi",
  "镇定地": "zhèn,deng,de",
  "镇得住": "zhèn,de,zhù",
  "镇扞": "zhèn,gǎn",
  "镇笮": "zhèn,zé",
  "镇长": "zhèn,zhǎng",
  "镇静地": "zhèn,jìng,de",
  "镊子": "niè,zi",
  "镌载": "juān,zǎi",
  "镏子": "liù,zi",
  "镐京": "hào,jīng",
  "镐宴": "hào,yàn",
  "镐池": "hào,chí",
  "镐池君": "hào,chí,jūn",
  "镐洛": "hào,luò",
  "镐镐": "hào,hào",
  "镐饮": "hào,yǐn",
  "镑子儿": "bàng,zǐ,er",
  "镕调": "róng,diào",
  "镗威": "táng,wēi",
  "镗孔": "táng,kǒng",
  "镗床": "táng,chuáng",
  "镗𨱏": "táng,dā",
  "镗锝": "táng,dé",
  "镗锣": "táng,luó",
  "镗镗": "táng,táng",
  "镚子": "bèng,zi",
  "镚子儿": "bèng,zǐ,er",
  "镜子": "jìng,zi",
  "镜槛": "jìng,kǎn",
  "镣铣": "liào,xǐ",
  "镣铫": "liào,yáo",
  "镦宽": "dūn,kuān",
  "镦短": "dūn,duǎn",
  "镦粗": "dūn,cū",
  "镩子": "cuān,zi",
  "镪水": "qiāng,shuǐ",
  "镫子": "dèng,zi",
  "镯子": "zhuó,zi",
  "镰刀细胞贫血": "lián,dāo,xì,bāo,pín,xuè",
  "镰形血球贫血症": "lián,xíng,xuè,qiú,pín,xuè,zhèng",
  "镰状细胞血症": "lián,zhuàng,xì,bāo,xuè,zhèng",
  "镵削": "chán,xuē",
  "长一智": "zhǎng,yī,zhì",
  "长上": "zhǎng,shàng",
  "长上匠": "zhǎng,shàng,jiàng",
  "长久地": "cháng,jiǔ,de",
  "长乐老": "cháng,yuè,lǎo",
  "长亲": "zhǎng,qīn",
  "长仆": "cháng,pú",
  "长他人志气": "zhǎng,tā,rén,zhì,qì",
  "长侯": "cháng,hòu",
  "长假": "cháng,jià",
  "长傲": "zhǎng,ào",
  "长傲饰非": "zhǎng,ào,shì,fēi",
  "长兄": "zhǎng,xiōng",
  "长兴": "cháng,xīng",
  "长兴县": "cháng,xīng,xiàn",
  "长兴岛": "cháng,xīng,dǎo",
  "长冠": "cháng,guān",
  "长出": "zhǎng,chū",
  "长别": "zhǎng,bié",
  "长势": "zhǎng,shì",
  "长卷": "cháng,juàn",
  "长卿": "zhǎng,qīng",
  "长卿疾": "zhǎng,qīng,jí",
  "长卿病": "zhǎng,qīng,bìng",
  "长厚": "zhǎng,hòu",
  "长厚者": "zhǎng,hòu,zhě",
  "长发": "cháng,fà",
  "长发王": "cháng,fà,wáng",
  "长史": "zhǎng,shǐ",
  "长吏": "zhǎng,lì",
  "长君": "zhǎng,jūn",
  "长啜大嚼": "cháng,chuò,dà,jué",
  "长大": "zhǎng,dà",
  "长大夫": "zhǎng,dài,fū",
  "长头儿": "cháng,tou,er",
  "长女": "zhǎng,nǚ",
  "长姊": "zhǎng,zǐ",
  "长子": "zhǎng,zǐ",
  "长孙": "zhǎng,sūn",
  "长孙无忌": "zhǎng,sūn,wú,jì",
  "长安少年": "cháng,ān,shào,nián",
  "长官": "zhǎng,guān",
  "长官意志": "zhǎng,guān,yì,zhì",
  "长干": "cháng,gàn",
  "长干曲": "cháng,gàn,qǔ",
  "长年三老": "zhǎng,nián,sān,lǎo",
  "长年累月": "cháng,nián,lěi,yuè",
  "长幼": "zhǎng,yòu",
  "长幼尊卑": "zhǎng,yòu,zūn,bēi",
  "长幼有叙": "zhǎng,yòu,yǒu,xù",
  "长幼有序": "zhǎng,yòu,yǒu,xù",
  "长度地": "cháng,dù,de",
  "长得": "zhǎng,de",
  "长恶靡悛": "cháng,è,mǐ,quān",
  "长成": "zhǎng,chéng",
  "长房": "zhǎng,fáng",
  "长房萸": "zhǎng,fáng,yú",
  "长撎": "cháng,yì",
  "长更": "cháng,gēng",
  "长期地": "cháng,qī,de",
  "长条子": "cháng,tiáo,zi",
  "长柄勺子": "cháng,bǐng,sháo,zi",
  "长楙": "cháng,mào",
  "长歌当哭": "cháng,gē,dàng,kū",
  "长毂": "cháng,gū",
  "长满": "zhǎng,mǎn",
  "长满荒草": "zhǎng,mǎn,huāng,cǎo",
  "长点心眼": "zhǎng,diǎn,xīn,yǎn",
  "长牙": "zhǎng,yá",
  "长男": "zhǎng,nán",
  "长白朝鲜族自治县": "cháng,bái,cháo,xiǎn,zú,zì,zhì,xiàn",
  "长相": "zhǎng,xiàng",
  "长相寒碜": "zhǎng,xiàng,hán,chěn",
  "长眼": "zhǎng,yǎn",
  "长知识": "zhǎng,zhī,shi",
  "长篇累牍": "cháng,piān,lěi,dú",
  "长绳系日": "cháng,shéng,jì,rì",
  "长翟": "cháng,zhái",
  "长老": "zhǎng,lǎo",
  "长老会": "zhǎng,lǎo,huì",
  "长老派": "zhǎng,lǎo,pài",
  "长者": "zhǎng,zhě",
  "长者家儿": "zhǎng,zhě,jiā,ér",
  "长者车": "zhǎng,zhě,chē",
  "长者辙": "zhǎng,zhě,zhé",
  "长脸": "zhǎng,liǎn",
  "长膘": "zhǎng,biāo",
  "长葛": "cháng,gě",
  "长葛市": "cháng,gě,shì",
  "长虺成蛇": "zhǎng,huǐ,chéng,shé",
  "长见": "zhǎng,jiàn",
  "长见识": "zhǎng,jiàn,shi",
  "长解子": "cháng,jiè,zǐ",
  "长记性": "zhǎng,jì,xing",
  "长调": "cháng,diào",
  "长赘疣": "zhǎng,zhuì,yóu",
  "长踦": "cháng,jī",
  "长𫏋": "cháng,jué",
  "长辈": "zhǎng,bèi",
  "长辈图": "zhǎng,bèi,tú",
  "长进": "zhǎng,jìn",
  "长钉": "cháng,dìng",
  "长铫": "cháng,yáo",
  "长长地": "cháng,cháng,de",
  "长长地舒了口气": "cháng,cháng,de,shū,le,kǒu,qì",
  "长随带驮子": "cháng,suí,dài,duò,zǐ",
  "长鸣都尉": "cháng,míng,dū,wèi",
  "𬮠砢": "kě,luǒ",
  "𮤲载": "bì,zǎi",
  "𬮤皁": "gé,zào",
  "𬮴丁": "ān,dīng",
  "𬮴世": "ān,shì",
  "𬮴中": "ān,zhōng",
  "𬮴主": "ān,zhǔ",
  "𬮴书": "ān,shū",
  "𬮴乱": "ān,luàn",
  "𬮴人": "ān,rén",
  "𬮴伤": "ān,shāng",
  "𬮴俗": "ān,sú",
  "𬮴修": "ān,xiū",
  "𬮴冥": "ān,míng",
  "𬮴劣": "ān,liè",
  "𬮴化": "ān,huà",
  "𬮴合": "ān,hé",
  "𬮴君": "ān,jūn",
  "𬮴塞": "ān,sāi",
  "𬮴墨": "ān,mò",
  "𬮴夕": "ān,xī",
  "𬮴夫": "ān,fū",
  "𬮴奸": "ān,jiān",
  "𬮴室": "ān,shì",
  "𬮴室不欺": "ān,shì,bù,qī",
  "𬮴对": "ān,duì",
  "𬮴将": "ān,jiāng",
  "𬮴干": "ān,gàn",
  "𬮴度陈仓": "ān,dù,chén,cāng",
  "𬮴弱": "ān,ruò",
  "𬮴当": "ān,dāng",
  "𬮴彰": "ān,zhāng",
  "𬮴很": "ān,hěn",
  "𬮴忽": "ān,hū",
  "𬮴惑": "ān,huò",
  "𬮴惰": "ān,duò",
  "𬮴愎": "ān,bì",
  "𬮴懦": "ān,nuò",
  "𬮴戆": "ān,gàng",
  "𬮴投": "ān,tóu",
  "𬮴拙": "ān,zhuō",
  "𬮴政": "ān,zhèng",
  "𬮴敝": "ān,bì",
  "𬮴无天日": "ān,wú,tiān,rì",
  "𬮴时": "ān,shí",
  "𬮴昧": "ān,mèi",
  "𬮴晦": "ān,huì",
  "𬮴暝": "ān,míng",
  "𬮴曶": "ān,hū",
  "𬮴机": "ān,jī",
  "𬮴汶": "ān,mén",
  "𬮴沕": "ān,mì",
  "𬮴没": "ān,méi",
  "𬮴浅": "ān,qiǎn",
  "𬮴涩": "ān,sè",
  "𬮴淡": "ān,dàn",
  "𬮴漠": "ān,mò",
  "𬮴然": "ān,rán",
  "𬮴王": "ān,wáng",
  "𬮴相": "ān,xiāng",
  "𬮴眇": "ān,miǎo",
  "𬮴瞀": "ān,mào",
  "𬮴短": "ān,duǎn",
  "𬮴秽": "ān,huì",
  "𬮴穆": "ān,mù",
  "𬮴练": "ān,liàn",
  "𬮴聋": "ān,lóng",
  "𬮴莫": "ān,mò",
  "𬮴蔼": "ān,ǎi",
  "𬮴蔽": "ān,bì",
  "𬮴薄": "ān,báo",
  "𬮴虚": "ān,xū",
  "𬮴虫": "ān,chóng",
  "𬮴蚀": "ān,shí",
  "𬮴行": "ān,xíng",
  "𬮴解": "ān,jiě",
  "𬮴记": "ān,jì",
  "𬮴诵": "ān,sòng",
  "𬮴质": "ān,zhì",
  "𬮴跳": "ān,tiào",
  "𬮴过": "ān,guò",
  "𬮴鄙": "ān,bǐ",
  "𬮴野": "ān,yě",
  "𬮴钝": "ān,dùn",
  "𬮴𬮴": "ān,ān",
  "𬮴门": "ān,mén",
  "𬮴陋": "ān,lòu",
  "𬮴隘": "ān,ài",
  "𬮴饰": "ān,shì",
  "𬮴𫘤": "ān,ái",
  "𬮴魄": "ān,pò",
  "𬮴鸟": "ān,niǎo",
  "𬮴默": "ān,mò",
  "𬮴黝": "ān,yǒu",
  "𬮴黮": "ān,dǎn",
  "𰿺合": "tāng,hé",
  "𰿺𬮤": "tāng,gé",
  "𰿺阖": "tāng,hé",
  "𰿺鞈": "tāng,tà",
  "𰿺鞳": "tāng,tà",
  "门仆": "mén,pú",
  "门兴格拉德巴赫": "mén,xīng,gé,lā,dé,bā,hè",
  "门单户薄": "mén,dān,hù,bó",
  "门吊儿": "mén,diào,er",
  "门坎儿": "mén,kǎn,er",
  "门大夫": "mén,dài,fū",
  "门子": "mén,zi",
  "门干": "mén,gàn",
  "门户差拨": "mén,hù,chāi,bō",
  "门把": "mén,bà",
  "门斗": "mén,dǒu",
  "门桄": "mén,guàng",
  "门槛": "mén,kǎn",
  "门槛税": "mén,kǎn,shuì",
  "门着": "mén,zhe",
  "门禁": "mén,jìn",
  "门禁森严": "mén,jìn,sēn,yán",
  "门缝": "mén,fèng",
  "门脸儿": "mén,liǎn,er",
  "门铺": "mén,pù",
  "门闾之望": "mén,lǚ,zhī,wàng",
  "门面": "mén,mian",
  "门面铺席人": "mén,miàn,pù,xí,rén",
  "闪亮儿": "shǎn,liàng,er",
  "闪亮地": "shǎn,liàng,de",
  "闪光地": "shǎn,guāng,de",
  "闪烁地": "shǎn,shuò,de",
  "闪电般地": "shǎn,diàn,bān,de",
  "闪耀地": "shǎn,yào,de",
  "闪露": "shǎn,lù",
  "闭上": "bì,shang",
  "闭上嘴巴": "bì,shang,zuǐ,bā",
  "闭卷": "bì,juàn",
  "闭卷考试": "bì,juàn,kǎo,shì",
  "闭只眼": "bì,zhī,yǎn",
  "闭塞": "bì,sè",
  "闭塞眼睛捉麻雀": "bì,sè,yǎn,jīng,zhuō,má,què",
  "闭明塞聪": "bì,míng,sè,cōng",
  "闭目塞听": "bì,mù,sè,tīng",
  "闭目塞耳": "bì,mù,sè,ěr",
  "闭着": "bì,zhe",
  "闭破莫商量": "bì,pò,mò,shāng,liáng",
  "闭禁": "bì,jìn",
  "闭𬮴": "bì,ān",
  "闭门却轨": "bì,kǒu,què,guǐ",
  "闭门塞户": "bì,mén,sè,hù",
  "闭门塞窦": "bì,mén,sè,dòu",
  "闭门墐户": "bì,kǒu,jǐn,hù",
  "问卷": "wèn,juàn",
  "问慰帖": "wèn,wèi,tiē",
  "问数": "wèn,shù",
  "问禁": "wèn,jìn",
  "问答体地": "wèn,dá,tǐ,de",
  "问难": "wèn,nàn",
  "闯丧": "chuǎng,sāng",
  "闯伺": "chuǎng,sì",
  "闯出名堂": "chuǎng,chū,míng,tang",
  "闯将": "chuǎng,jiàng",
  "闲伺": "xián,sì",
  "闲嗑": "xián,kè",
  "闲嗑牙": "xián,kè,yá",
  "闲在": "xián,zai",
  "闲处": "xián,chǔ",
  "闲散": "xián,sǎn",
  "闲散地": "xián,sǎn,de",
  "闲晃": "xián,huàng",
  "闲空": "xián,kòng",
  "闲絜": "xián,jié",
  "闲置地": "xián,zhì,de",
  "闲翫": "xián,wàn",
  "闲踢蹬": "xián,tī,dēng",
  "闲适": "xián,shì",
  "闲郄": "xián,xì",
  "闲闲地": "xián,xián,de",
  "闲靓": "xián,liàng",
  "间不容发": "jiān,bù,róng,fà",
  "间不容息": "jiàn,bù,róng,xī",
  "间作": "jiàn,zuò",
  "间使": "jiàn,shǐ",
  "间充质干细胞": "jiān,chōng,zhì,gàn,xì,bāo",
  "间壁": "jiàn,bì",
  "间奏": "jiàn,zòu",
  "间奏曲": "jiàn,zòu,qǔ",
  "间或": "jiàn,huò",
  "间或地": "jiàn,huò,de",
  "间接": "jiàn,jiē",
  "间接宾语": "jiàn,jiē,bīn,yǔ",
  "间接税": "jiàn,jiē,shuì",
  "间接证据": "jiàn,jiē,zhèng,jù",
  "间接选举": "jiàn,jiē,xuǎn,jǔ",
  "间断": "jiàn,duàn",
  "间断地": "jiàn,duàn,de",
  "间日": "jiàn,rì",
  "间歇": "jiàn,xiē",
  "间歇地": "jiàn,xiē,de",
  "间歇训练": "jiàn,xiē,xùn,liàn",
  "间种": "jiàn,zhòng",
  "间色": "jiàn,sè",
  "间苗": "jiàn,miáo",
  "间见层出": "jiàn,xiàn,céng,chū",
  "间谍": "jiàn,dié",
  "间谍活动": "jiàn,dié,huó,dòng",
  "间谍网": "jiàn,dié,wǎng",
  "间谍罪": "jiàn,dié,zuì",
  "间谍软件": "jiàn,dié,ruǎn,jiàn",
  "间道": "jiàn,dào",
  "间阻": "jiàn,zǔ",
  "间隔": "jiàn,gé",
  "间隔号": "jiàn,gé,hào",
  "间隔地": "jiàn,gé,de",
  "间隔摄影": "jiàn,gé,shè,yǐng",
  "间隙": "jiàn,xì",
  "闵行区": "mǐn,háng,qū",
  "闶门": "kāng,mén",
  "闶闳": "kāng,hóng",
  "闶阆": "kāng,láng",
  "闷在家里": "mēn,zài,jiā,lǐ",
  "闷在心里": "mēn,zài,xīn,lǐ",
  "闷声": "mēn,shēng",
  "闷声不吭": "mèn,shēng,bù,kēng",
  "闷声不响": "mēn,shēng,bù,xiǎng",
  "闷声发大财": "mēn,shēng,fā,dà,cái",
  "闷声闷气": "mēn,shēng,mēn,qì",
  "闷头儿": "mèn,tou,er",
  "闷头儿干": "mēn,tóu,er,gàn",
  "闷头儿干活": "mēn,tóu,er,gàn,huó",
  "闷屁": "mēn,pì",
  "闷得发慌": "mèn,de,fā,huāng",
  "闷气": "mēn,qì",
  "闷热": "mēn,rè",
  "闷热地": "mēn,rè,de",
  "闷罐子": "mèn,guàn,zi",
  "闷锄": "mēn,chú",
  "闷雷": "mēn,léi",
  "闷骚": "mēn,sāo",
  "闸槛": "zhá,kǎn",
  "闸牌子": "zhá,pái,zi",
  "闹乱子": "nào,luàn,zi",
  "闹别扭": "nào,biè,niǔ",
  "闹吖吖": "nào,ā,ā",
  "闹吵吵": "nào,chāo,chao",
  "闹咳咳": "nào,hāi,hāi",
  "闹哄哄": "nào,hōng,hǒng",
  "闹嚷": "nào,rāng",
  "闹嚷嚷": "nào,rāng,rāng",
  "闹性子": "nào,xìng,zi",
  "闹杆": "nào,gǎn",
  "闹濩铎": "nào,hù,duó",
  "闹着玩": "nào,zhe,wán",
  "闹着玩儿": "nào,zhe,wán,ér",
  "闹着玩地": "nào,zhe,wán,de",
  "闹着顽": "nào,zhe,wán",
  "闹穰穰": "nào,rǎng,rǎng",
  "闹笑话": "nào,xiào,hua",
  "闹糊糊": "nào,hú,hu",
  "闹肚子": "nào,dǔ,zi",
  "闹脾气": "nào,pí,qi",
  "闹腾": "nào,teng",
  "闹闹穰穰": "nào,nào,rǎng,rǎng",
  "闺禁": "guī,jìn",
  "闻得": "wén,de",
  "闻风而兴": "wén,fēng,ér,xīng",
  "闽侥": "mǐn,yáo",
  "闽侯": "mǐn,hòu",
  "闾舍": "lǘ,shè",
  "闾衖": "lǘ,lòng",
  "闾阎安堵": "lǔ,yán,ān,dǔ",
  "阁不住": "gé,bú,zhù",
  "阁仔": "gé,zǎi",
  "阁帖": "gé,tiē",
  "阃隩": "kǔn,yù",
  "阄儿": "jiū,er",
  "阅卷": "yuè,juàn",
  "阅女无数": "yuè,nǚ,wú,shù",
  "阅男无数": "yuè,nán,wú,shù",
  "阆丘": "láng,qiū",
  "阆中": "láng,zhōng",
  "阆中市": "láng,zhōng,shì",
  "阆伉": "láng,kàng",
  "阆凤山": "láng,fèng,shān",
  "阆宫": "láng,gōng",
  "阆山": "láng,shān",
  "阆邱": "láng,qiū",
  "阆阆": "láng,láng",
  "阆阙": "láng,quē",
  "阆颠": "láng,diān",
  "阆风": "láng,fēng",
  "阆风台": "láng,fēng,tái",
  "阆风岑": "láng,fēng,cén",
  "阆风巅": "láng,fēng,diān",
  "阇梨": "shé,lí",
  "阇黎": "shé,lí",
  "阋蹏": "xì,dì",
  "阎王老子": "yán,wáng,lǎo,zi",
  "阎罗大王": "yán,luó,dài,wáng",
  "阎罗老子": "yán,luó,lǎo,zi",
  "阏与": "yù,yǔ",
  "阏氏": "yān,zhī",
  "阏蓬": "yān,péng",
  "阏逢": "yān,féng",
  "阐着": "chǎn,zhe",
  "阑得": "lán,de",
  "阑楯": "lán,dùn",
  "阔少": "kuò,shào",
  "阔少爷": "kuò,shào,yé",
  "阔气": "kuò,qi",
  "阔禁": "kuò,jìn",
  "阔阔地": "kuò,kuò,de",
  "阙一不可": "què,yī,bù,kě",
  "阙下": "què,xià",
  "阙卷": "quē,juàn",
  "阙庭": "què,tíng",
  "阙掖": "què,yè",
  "阙竦": "què,sǒng",
  "阙翟": "quē,zhái",
  "阙翦": "jué,jiǎn",
  "阙门": "què,mén",
  "阜新蒙古族自治县": "fù,xīn,měng,gǔ,zú,zì,zhì,xiàn",
  "阜蕃": "fù,fān",
  "队沉地": "duì,chén,de",
  "队长": "duì,zhǎng",
  "阤坏": "yǐ,huài",
  "阤崩": "yǐ,bēng",
  "阤废": "yǐ,fèi",
  "阤靡": "yǐ,mí",
  "阮舍": "ruǎn,shè",
  "防伺": "fáng,sì",
  "防堤": "fáng,dī",
  "防夹": "fáng,jiā",
  "防守地": "fáng,shǒu,de",
  "防弹": "fáng,dàn",
  "防弹衣": "fáng,dàn,yī",
  "防扞": "fáng,gǎn",
  "防护堤": "fáng,hù,dī",
  "防护玻璃": "fáng,hù,bō,li",
  "防毒斗篷": "fáng,dú,dǒu,péng",
  "防波堤": "fáng,bō,dī",
  "防洪堤": "fáng,hóng,dī",
  "防潮堤": "fáng,cháo,dī",
  "防禁": "fáng,jìn",
  "防血凝": "fáng,xuè,níng",
  "防长": "fáng,zhǎng",
  "阳侯": "yáng,hòu",
  "阳侯之变": "yáng,hòu,zhī,biàn",
  "阳夏": "yáng,jiǎ",
  "阳差": "yáng,chā",
  "阳干": "yáng,gàn",
  "阳性地": "yáng,xìng,de",
  "阳数": "yáng,shù",
  "阳电荷": "yáng,diàn,hè",
  "阳萎地": "yáng,wēi,de",
  "阳𰰤": "yáng,xū",
  "阳鼌": "yáng,zhāo",
  "阴地厥": "yīn,de,jué",
  "阴处": "yīn,chǔ",
  "阴山背后": "yīn,shān,bèi,hòu",
  "阴差阳错": "yīn,chā,yáng,cuò",
  "阴影地": "yīn,yǐng,de",
  "阴摽": "yīn,biāo",
  "阴数": "yīn,shù",
  "阴森地": "yīn,sēn,de",
  "阴沉地": "yīn,chén,de",
  "阴着儿": "yīn,zhāo,ér",
  "阴祇": "yīn,qí",
  "阴血": "yīn,xuè",
  "阴调": "yīn,diào",
  "阴郁地": "yīn,yù,de",
  "阴错阳差": "yīn,cuò,yáng,chā",
  "阴𬮴": "yīn,ān",
  "阵发性地": "zhèn,fā,xìng,de",
  "阵子": "zhèn,zi",
  "阵风地": "zhèn,fēng,de",
  "阶梯式地": "jiē,tī,shì,de",
  "阶级成分": "jiē,jí,chéng,fèn",
  "阶蓂": "jiē,mì",
  "阸陕": "è,xiá",
  "阻塞": "zǔ,sè",
  "阻差办公": "zǔ,chāi,bàn,gōng",
  "阻折": "zǔ,shé",
  "阻拗": "zǔ,niù",
  "阻止地": "zǔ,zhǐ,de",
  "阻碍地": "zǔ,ài,de",
  "阻难": "zǔ,nàn",
  "阽切": "yán,qiē",
  "阽死": "yán,sǐ",
  "阽苦": "yán,kǔ",
  "阽身": "yán,shēn",
  "阿下": "ē,xià",
  "阿世": "ē,shì",
  "阿世取容": "ē,shì,qǔ,róng",
  "阿世媚俗": "ē,shì,mèi,sú",
  "阿世盗名": "ē,shì,dào,míng",
  "阿丽亚娜": "ā,lì,yà,nà",
  "阿什哈巴特": "ā,shí,hā,bā,tè",
  "阿们": "ā,men",
  "阿伊莎": "ā,yī,shā",
  "阿伏伽德罗常数": "ā,fú,jiā,dé,luó,cháng,shù",
  "阿伽陀药": "ā,qié,tuó,yào",
  "阿佛洛狄忒": "ā,fú,luò,dí,tè",
  "阿依莎": "ā,yī,shā",
  "阿侯": "ā,hòu",
  "阿保之功": "ē,bǎo,zhī,gōng",
  "阿僧祇": "ā,sēng,qí",
  "阿僧祇劫": "ā,sēng,qí,jié",
  "阿僧秪劫": "ā,sēng,zhī,jié",
  "阿克塞县": "ā,kè,sài,xiàn",
  "阿克塞哈萨克族自治县": "ā,kè,sài,hā,sà,kè,zú,zì,zhì,xiàn",
  "阿党": "ē,dǎng",
  "阿党比周": "ē,dǎng,bǐ,zhōu",
  "阿党相为": "ē,dǎng,xiāng,wéi",
  "阿兰若": "ā,lán,rě",
  "阿其所好": "ē,qí,suǒ,hào",
  "阿其那": "ē,qí,nà",
  "阿匼": "ē,kē",
  "阿卡提": "ā,kǎ,dī",
  "阿图什": "ā,tú,shí",
  "阿图什县": "ā,tú,shí,xiàn",
  "阿图什市": "ā,tú,shí,shì",
  "阿坝藏族羌族自治州": "ā,bà,zàng,zú,qiāng,zú,zì,zhì,zhōu",
  "阿堵": "ē,dǔ",
  "阿堵物": "ē,dǔ,wù",
  "阿塞拜疆人": "ā,sài,bài,jiāng,rén",
  "阿妳": "ā,nǎi",
  "阿娜": "ā,nà",
  "阿嬷": "ā,mā",
  "阿家": "ā,gū",
  "阿家阿翁": "ā,gū,ā,wēng",
  "阿尊事贵": "ē,zūn,shì,guì",
  "阿尔瓦塞特": "ā,ěr,wǎ,sè,tè",
  "阿布扎比": "ā,bù,zhā,bǐ",
  "阿布沙耶夫": "ā,bù,shā,yē,fū",
  "阿干": "ā,gàn",
  "阿弥": "ē,mí",
  "阿弥巴": "ē,mí,bā",
  "阿弥陀": "ē,mí,tuó",
  "阿弥陀佛": "ē,mí,tuó,fó",
  "阿弥陀如来": "ē,mí,tuó,rú,lái",
  "阿忒迷失": "ā,tuī,mí,shī",
  "阿意": "ē,yì",
  "阿意取容": "ē,yì,qǔ,róng",
  "阿意顺旨": "ē,yì,shùn,zhǐ",
  "阿房": "ē,páng",
  "阿房宫": "ē,páng,gōng",
  "阿房宫赋": "ē,páng,gōng,fù",
  "阿房殿": "ē,páng,diàn",
  "阿拉伯数字": "ā,lā,bó,shù,zì",
  "阿拉伯联合酋长国": "ā,lā,bó,lián,hé,qiú,zhǎng,guó",
  "阿搂": "ā,lōu",
  "阿斗": "ā,dǒu",
  "阿斯匹灵": "ā,sī,pí,líng",
  "阿旁": "ē,páng",
  "阿时": "ē,shí",
  "阿时趋俗": "ē,shí,qū,sú",
  "阿旺曲培": "ā,wàng,qū,péi",
  "阿曲": "ē,qǔ",
  "阿曾": "ā,zēng",
  "阿月浑子": "ā,yuè,hún,zi",
  "阿权𰮇仕": "ā,quán,wǔ,shì",
  "阿步干": "ā,bù,gàn",
  "阿波罗计划": "ā,bō,luó,jì,huà",
  "阿物儿": "ā,wù,er",
  "阿甘正传": "ā,gān,zhèng,zhuàn",
  "阿𤶊𤶊": "ā,guì,guì",
  "阿的": "ā,dì",
  "阿的平": "ā,dì,píng",
  "阿罗耶": "ā,luó,yē",
  "阿罗耶识": "ā,luó,yē,shí",
  "阿耶": "ā,yē",
  "阿耶娘": "ā,yē,niáng",
  "阿联酋长国": "ā,lián,qiú,zhǎng,guó",
  "阿胶": "ē,jiāo",
  "阿莎力": "ā,shā,lì",
  "阿西吧": "ā,xī,ba",
  "阿谀": "ē,yú",
  "阿谀取容": "ē,yú,qǔ,róng",
  "阿谀奉承": "ē,yú,fèng,chéng",
  "阿谀谄媚": "ē,yú,chǎn,mèi",
  "阿谀趋奉": "ē,yú,qū,fèng",
  "阿谀逢迎": "ē,yú,féng,yíng",
  "阿谀顺意": "ē,yú,shùn,yì",
  "阿谀顺旨": "ē,yú,shùn,zhǐ",
  "阿赖耶": "ā,lài,yē",
  "阿赖耶识": "ā,lài,yē,shí",
  "阿铺": "ā,pù",
  "阿阇": "ā,shé",
  "阿阇梨": "ā,shé,lí",
  "阿阇黎": "ā,shé,lí",
  "阿附": "ē,fù",
  "阿难": "ē,nán",
  "阿难陀": "ē,nán,tuó",
  "阿顺": "ē,shùn",
  "阿顺取容": "ē,shùn,qǔ,róng",
  "阿黎耶识": "ā,lí,yē,shí",
  "陀思妥耶夫斯基": "tuó,sī,tuǒ,yē,fū,sī,jī",
  "陀罗尼幢": "tuó,luó,ní,zhuàng",
  "陂堨": "bēi,ài",
  "陂寖": "bēi,jìn",
  "陂栅": "bēi,shān",
  "陂渰": "bēi,yǎn",
  "陂湖禀量": "bēi,hú,bǐng,liáng",
  "陂艿": "bēi,rèng",
  "陂阤": "bēi,yǐ",
  "陂陀": "pō,tuó",
  "陂陁": "pō,tuó",
  "附卷": "fù,juàn",
  "附和": "fù,hè",
  "附带地": "fù,dài,de",
  "附识": "fù,zhì",
  "附赘悬肬": "fù,zhuì,xuán,shé",
  "附载": "fù,zǎi",
  "陆万": "liù,wàn",
  "陆仟": "liù,qiān",
  "陆佰": "liù,bǎi",
  "陆圆": "liù,yuán",
  "陆基导弹": "lù,jī,dǎo,dàn",
  "陆处": "lù,chǔ",
  "陆大夫": "lù,dài,fū",
  "陆拾": "liù,shí",
  "陆掠": "lù,lüě",
  "陆续地": "lù,xù,de",
  "陇𡵝": "lǒng,zōng",
  "陈冠希": "chén,guān,xī",
  "陈天华": "chén,tiān,huà",
  "陈妈妈": "chén,mā,ma",
  "陈姥姥": "chén,lǎo,lao",
  "陈寔遗盗": "chén,shí,wèi,dào",
  "陈愬": "chén,shuò",
  "陈省身": "chén,xǐng,shēn",
  "陈腐地": "chén,fǔ,de",
  "陈蕃下榻": "chén,fān,xià,tà",
  "陈蕃室": "chén,fān,shì",
  "陈蕃榻": "chén,fān,tà",
  "陈词滥调": "chén,cí,làn,diào",
  "陈谷子烂芝麻": "chén,gǔ,zi,làn,zhī,ma",
  "陈辞滥调": "chén,cí,làn,diào",
  "陈隋调": "chén,suí,diào",
  "陈露": "chén,lù",
  "陊剥": "duò,bāo",
  "陋侻": "lòu,tuì",
  "陌生地": "mò,shēng,de",
  "降人": "xiáng,rén",
  "降伏": "xiáng,fú",
  "降妖": "xiáng,yāo",
  "降妖捉怪": "xiáng,yāo,zhuō,guài",
  "降将": "xiáng,jiàng",
  "降手儿": "jiàng,shǒu,er",
  "降服": "xiáng,fú",
  "降服而囚": "xiang,fu,er,qiu",
  "降血压药": "jiàng,xuè,yā,yào",
  "降血钙素": "jiàng,xuè,gài,sù",
  "降调": "jiàng,diào",
  "降逮": "jiàng,dǎi",
  "降顺": "xiáng,shùn",
  "降魔": "xiáng,mó",
  "降魔杵": "xiáng,mó,chǔ",
  "降魔棍": "xiáng,mó,gùn",
  "降龙": "xiáng,lóng",
  "降龙伏虎": "xiáng,lóng,fú,hǔ",
  "降龙钵": "xiáng,lóng,bō",
  "限制地": "xiàn,zhì,de",
  "限制性地": "xiàn,zhì,xìng,de",
  "限禁": "xiàn,jìn",
  "陖翟": "jùn,zhái",
  "陗帆": "qiào,fān",
  "陗阤": "qiào,yǐ",
  "陛楯": "bì,dùn",
  "陛楯郎": "bì,dùn,láng",
  "陛槛": "bì,kǎn",
  "陟罚臧否": "zhì,fá,zāng,pǐ",
  "陡地一惊": "dǒu,de,yī,jīng",
  "陡峭地": "dǒu,qiào,de",
  "陡趄": "dǒu,jū",
  "陡跌": "dǒu,diē",
  "院子": "yuàn,zi",
  "院子家": "yuàn,zi,jiā",
  "院长": "yuàn,zhǎng",
  "除不尽地": "chú,bù,jìn,de",
  "除害兴利": "chú,hài,xīng,lì",
  "除患兴利": "chú,huàn,xīng,lì",
  "除折": "chú,shé",
  "除数": "chú,shù",
  "除旧更新": "chú,jiù,gēng,xīn",
  "除舍": "chú,shè",
  "除𬮴": "chú,ān",
  "除非己莫为": "chú,fēi,jǐ,mò,wéi",
  "陨仆": "yǔn,pú",
  "陨背": "yǔn,bèi",
  "陨蹶": "yǔn,juě",
  "险峻地": "xiǎn,jùn,de",
  "险恶地": "xiǎn,è,de",
  "险折": "xiǎn,shé",
  "险道神将": "xiǎn,dào,shén,jiàng",
  "险陡地": "xiǎn,dǒu,de",
  "陪不是": "péi,bú,shì",
  "陪产假": "péi,chǎn,jià",
  "陪仆": "péi,pú",
  "陪唱小姐": "péi,chàng,xiǎo,jie",
  "陪累": "péi,lèi",
  "陪裨": "péi,bì",
  "陪都": "péi,dū",
  "陫侧": "péi,cè",
  "陭氏": "yī,shì",
  "陴倪": "pí,ní",
  "陴县": "pí,xiàn",
  "陴坞": "pí,wù",
  "陴堞": "pí,dié",
  "陴隍": "pí,huáng",
  "陵劲淬砺": "líng,jìng,cuì,lì",
  "陵慠": "líng,ào",
  "陵折": "líng,shé",
  "陵母知兴": "líng,mǔ,zhī,xīng",
  "陵舃": "líng,tuō",
  "陵轧": "líng,zhá",
  "陵迟": "ling,chi",
  "陵遟": "líng,zhì",
  "陵阙": "líng,què",
  "陶兀": "táo,wū",
  "陶埏": "táo,shān",
  "陶情适性": "táo,qíng,shì,xìng",
  "陶缊": "táo,wēn",
  "陶葛": "táo,gě",
  "陷累": "xiàn,lèi",
  "陼堤": "dǔ,dī",
  "隃冠": "yú,guān",
  "隆兴": "lóng,xīng",
  "隆兴和议": "lóng,xīng,hé,yì",
  "隆兴寺": "lóng,xīng,sì",
  "隆干": "lóng,gàn",
  "隆重地": "lóng,zhòng,de",
  "隆隆地响": "lóng,lóng,de,xiǎng",
  "隆隆地行进": "lóng,lóng,de,xíng,jìn",
  "隈隩": "wēi,yù",
  "隋堤": "suí,dī",
  "隋堤柳": "suí,dī,liǔ",
  "隌𬮴": "ǎn,ān",
  "隍陴": "huáng,pí",
  "随份子": "suí,fèn,zi",
  "随便地": "suí,biàn,de",
  "随俗雅化": "shui,shu,ya,hua",
  "随兴": "suí,xīng",
  "随口地唱": "suí,kǒu,de,chàng",
  "随后地": "suí,hòu,de",
  "随和地": "suí,hé,de",
  "随堤": "suí,dī",
  "随声附和": "suí,shēng,fù,hè",
  "随大溜": "suí,dà,liù",
  "随心所欲地": "suí,xīn,suǒ,yù,de",
  "随性适分": "suí,xìng,shì,fēn",
  "随意地": "suí,yì,de",
  "随意地发出": "suí,yì,de,fā,chū",
  "随意地坐在": "suí,yì,de,zuò,zài",
  "随意地打": "suí,yì,de,dǎ",
  "随手地": "suí,shǒu,de",
  "随折": "suí,shé",
  "随时地": "suí,shí,de",
  "随时度势": "suí,shí,duó,shì",
  "随机地": "suí,jī,de",
  "随机应变": "suí,jī,yìng,biàn",
  "随机效应": "suí,jī,xiào,yìng",
  "随机数": "suí,jī,shù",
  "随溜儿": "suí,liù,ér",
  "随着": "suí,zhe",
  "随行就市": "suí,háng,jiù,shì",
  "随逮": "suí,dǎi",
  "随随便便地": "suí,suí,biàn,biàn,de",
  "随风而靡": "suí,fēng,ér,mǐ",
  "隐侯": "yǐn,hòu",
  "隐侯体": "yǐn,hòu,tǐ",
  "隐几": "yìn,jī",
  "隐函数": "yǐn,hán,shù",
  "隐匿地": "yǐn,nì,de",
  "隐君子": "yǐn,jūn,zi",
  "隐含地": "yǐn,hán,de",
  "隐喻地": "yǐn,yù,de",
  "隐处": "yǐn,chǔ",
  "隐居性地": "yǐn,jū,xìng,de",
  "隐形地": "yǐn,xíng,de",
  "隐晦曲折": "yǐn,huì,qū,zhé",
  "隐没": "yǐn,mò",
  "隐煣": "yǐn,rǒu",
  "隐秘地": "yǐn,mì,de",
  "隐约地": "yǐn,yuē,de",
  "隐约地听到": "yǐn,yuē,de,tīng,dào",
  "隐约地看见": "yǐn,yuē,de,kàn,jiàn",
  "隐背": "yǐn,bèi",
  "隐舍": "yǐn,shè",
  "隐芘": "yǐn,pí",
  "隐蔽地": "yǐn,bì,de",
  "隐蔽强迫下载": "yǐn,bì,qiǎng,pò,xià,zǎi",
  "隐血": "yǐn,xuè",
  "隐讽": "yǐn,fěng",
  "隐身草儿": "yǐn,shēn,cǎo,er",
  "隐遁地": "yǐn,dùn,de",
  "隐隐地": "yǐn,yǐn,de",
  "隐隐地感觉到": "yǐn,yǐn,de,gǎn,jué,dào",
  "隐隐地疼": "yǐn,yǐn,de,téng",
  "隐隐糊糊": "yǐn,yǐn,hū,hū",
  "隐隐约约地": "yǐn,yǐn,yuē,yuē,de",
  "隐隐讽讽": "yǐn,yǐn,fěng,fěng",
  "隐隩": "yǐn,yù",
  "𬮿州": "gāi,zhōu",
  "𬮿𬮿": "gāi,gāi",
  "隔三岔五": "gé,sǎn,chà,wǔ",
  "隔周地": "gé,zhōu,de",
  "隔扇": "gé,shān",
  "隔行": "gé,háng",
  "隔行如隔山": "gé,háng,rú,gé,shān",
  "隔行扫描": "gé,háng,sǎo,miáo",
  "隔阂地": "gé,hé,de",
  "隗炤版": "wěi,zhāo,bǎn",
  "隘庳": "ài,bì",
  "隙缝": "xì,fèng",
  "障堡": "zhàng,pù",
  "障堤": "zhàng,dī",
  "障扞": "zhàng,gǎn",
  "障碍性贫血": "zhàng,ài,xìng,pín,xuè",
  "障禁": "zhàng,jìn",
  "障累": "zhàng,lèi",
  "隩区": "yù,qū",
  "隩厚": "yù,hòu",
  "隩壤": "yù,rǎng",
  "隩室": "yù,shì",
  "隩爱": "yù,ài",
  "隩隅": "yù,yú",
  "隶仆": "lì,pú",
  "隶仆人": "lì,pú,rén",
  "隺俸": "hè,fèng",
  "隺料": "hè,liào",
  "隽品": "juàn,pǐn",
  "隽妙": "juàn,miào",
  "隽拔": "juàn,bá",
  "隽敏": "juàn,mǐn",
  "隽材": "juàn,cái",
  "隽楚": "juàn,chǔ",
  "隽永": "juàn,yǒng",
  "隽茂": "juàn,mào",
  "隽蹶": "jùn,juě",
  "难为": "nán,wéi",
  "难为听": "nán,wéi,tīng",
  "难为情": "nán,wéi,qíng",
  "难为情地": "nán,wéi,qíng,de",
  "难乎为情": "nán,hū,wéi,qíng",
  "难乎为继": "nán,hū,wéi,jì",
  "难以为情": "nán,yǐ,wéi,qíng",
  "难以为继": "nán,yǐ,wéi,jì",
  "难以应付": "nán,yǐ,yìng,fù",
  "难以相信地": "nán,yǐ,xiāng,xìn,de",
  "难以置信地": "nán,yǐ,zhì,xìn,de",
  "难伺候": "nán,cì,hou",
  "难侨": "nàn,qiáo",
  "难保证地": "nán,bǎo,zhèng,de",
  "难信地": "nán,xìn,de",
  "难允许地": "nán,yǔn,xǔ,de",
  "难兄": "nàn,xiōng",
  "难兄难弟": "nàn,xiōng,nàn,dì",
  "难割难舍": "nán,gē,nán,shè",
  "难卒合": "nán,cù,hé",
  "难友": "nàn,yǒu",
  "难取悦地": "nán,qǔ,yuè,de",
  "难和解地": "nán,hé,jiě,de",
  "难堪地": "nán,kān,de",
  "难处": "nán,chǔ",
  "难处理地": "nán,chǔ,lǐ,de",
  "难宽恕地": "nán,kuān,shù,de",
  "难对付地": "nán,duì,fù,de",
  "难属": "nàn,shǔ",
  "难弟": "nàn,dì",
  "难得": "nán,de",
  "难得地": "nán,de,de",
  "难忍受地": "nán,rěn,shòu,de",
  "难忘地": "nán,wàng,de",
  "难懂地": "nán,dǒng,de",
  "难战胜地": "nán,zhàn,shèng,de",
  "难折": "nán,shé",
  "难挨": "nán,ái",
  "难接近地": "nán,jiē,jìn,de",
  "难控制地": "nán,kòng,zhì,de",
  "难更仆数": "nán,gēng,pú,shǔ",
  "难民": "nàn,mín",
  "难民营": "nàn,mín,yíng",
  "难治地": "nán,zhì,de",
  "难熬": "nán,áo",
  "难熬地": "nán,áo,de",
  "难看地": "nán,kàn,de",
  "难着莫": "nán,zhe,mò",
  "难经": "nàn,jīng",
  "难胞": "nàn,bāo",
  "难舍": "nán,shè",
  "难觉察地": "nán,jué,chá,de",
  "难解地": "nán,jiě,de",
  "难解说地": "nán,jiě,shuō,de",
  "难识别地": "nán,shí,bié,de",
  "难读地": "nán,dú,de",
  "难转向地": "nán,zhuǎn,xiàng,de",
  "难辨别地": "nán,biàn,bié,de",
  "难辨地": "nán,biàn,de",
  "难过地": "nán,guò,de",
  "难避免地": "nán,bì,miǎn,de",
  "难驭地": "nán,yù,de",
  "难驯地": "nán,xùn,de",
  "雀子": "qiāo,zǐ",
  "雀屏中选": "què,píng,zhòng,xuǎn",
  "雀盲眼": "qiǎo,mang,yǎn",
  "雁孃": "yàn,ráng",
  "雁帖": "yàn,tiē",
  "雁行": "yàn,háng",
  "雄伟地": "xióng,wěi,de",
  "雄削": "xióng,xuē",
  "雄劲": "xióng,jìng",
  "雄处": "xióng,chǔ",
  "雄挐": "xióng,ná",
  "雄虺": "xióng,huī",
  "雄赳赳地": "xióng,jiū,jiū,de",
  "雄辩地": "xióng,biàn,de",
  "雄长": "xióng,zhǎng",
  "雄骜": "xióng,ào",
  "雄鹘箭": "xióng,hú,jiàn",
  "雅乐": "yǎ,yuè",
  "雅什": "yǎ,shí",
  "雅典娜": "yǎ,diǎn,nà",
  "雅片": "yā,piàn",
  "雅片枪": "yā,piàn,qiāng",
  "雅相": "yǎ,xiàng",
  "雅致地": "yǎ,zhì,de",
  "雅讽": "yǎ,fěng",
  "雅诺什": "yǎ,nuò,shí",
  "雅调": "yǎ,diào",
  "雅鲁藏布大峡谷": "yǎ,lǔ,zàng,bù,dà,xiá,gǔ",
  "雅鲁藏布江": "yǎ,lǔ,zàng,bù,jiāng",
  "集中地": "jí,zhōng,de",
  "集体地": "jí,tǐ,de",
  "集子": "jí,zi",
  "集束炸弹": "jí,shù,zhà,dàn",
  "集电杆": "jí,diàn,gǎn",
  "集结地": "jí,jié,de",
  "集腋为裘": "jí,yè,wéi,qiú",
  "集训地": "jí,xùn,de",
  "雉姁": "zhì,xū",
  "雉翘": "zhì,qiào",
  "雌儿": "cí,er",
  "雌呿雄吟": "cí,qù,xióng,yín",
  "雌牙露嘴": "cí,yá,lù,zuǐ",
  "雕削": "diāo,xuē",
  "雕掞": "diāo,yàn",
  "雕楹碧槛": "diāo,yíng,bì,kǎn",
  "雕槛": "diāo,kǎn",
  "雕橑": "diāo,lǎo",
  "雕玉双联": "diāo,yǔ,shuāng,lián",
  "雕篹": "diāo,suǎn",
  "雕花玻璃": "diāo,huā,bō,li",
  "雕钻": "diāo,zuàn",
  "雚菌": "huán,jūn",
  "雠应": "chóu,yìng",
  "雠柞": "chóu,zhà",
  "雠校": "chóu,jiào",
  "雨僝云僽": "yǔ,chán,yún,zhòu",
  "雨僝风僽": "yǔ,chán,fēng,zhòu",
  "雨僽风僝": "yǔ,zhòu,fēng,chán",
  "雨冠": "yǔ,guān",
  "雨夹雪": "yǔ,jiā,xuě",
  "雨是斜斜地下": "yǔ,shì,xié,xié,de,xià",
  "雨毛": "yù,máo",
  "雨泗": "yù,sì",
  "雨潦": "yǔ,liáo",
  "雨瀑": "yǔ,bào",
  "雨点般地": "yǔ,diǎn,bān,de",
  "雨珠儿": "yǔ,zhū,er",
  "雨矢": "yù,shǐ",
  "雨祇": "yǔ,qí",
  "雨都是直直地下": "yǔ,dōu,shì,zhí,zhí,de,xià",
  "雨露": "yǔ,lù",
  "雨露之恩": "yǔ,lù,zhī,ēn",
  "雩𰱈": "yú,yǒng",
  "雪兴": "xuě,xīng",
  "雪堤": "xuě,dī",
  "雪山狮子": "xuě,shān,shī,zi",
  "雪山狮子旗": "xuě,shān,shī,zi,qí",
  "雪帆": "xuě,fān",
  "雪狮子向火": "xuě,shī,zi,xiàng,huǒ",
  "雪窑冰天": "xuě,jiào,bīng,tiān",
  "雪糁": "xuě,shēn",
  "雪糕新地": "xuě,gāo,xīn,de",
  "雪茄": "xuě,jiā",
  "雪茄头": "xuě,jiā,tóu",
  "雪茄烟": "xuě,jiā,yān",
  "雪荠": "xuě,qí",
  "雪虾蟆": "xuě,há,má",
  "雪调": "xuě,diào",
  "雪里蕻": "xuě,lǐ,hóng",
  "零刀子": "líng,dāo,zi",
  "零削": "líng,xuē",
  "零增长": "líng,zēng,zhǎng",
  "零支了米麦无重数": "líng,zhī,le,mǐ,mài,wú,chóng,shù",
  "零散": "líng,sǎn",
  "零散地": "líng,sǎn,de",
  "零数": "líng,shù",
  "零星地": "líng,xīng,de",
  "零曲率": "líng,qū,lǜ",
  "零杂儿": "líng,zá,er",
  "零活儿": "líng,huó,er",
  "零碎地": "líng,suì,de",
  "零碎地花": "líng,suì,de,huā",
  "零零散散": "líng,líng,sǎn,sǎn",
  "零露": "líng,lù",
  "零露瀼瀼": "líng,lù,ráng,ráng",
  "雷公打豆腐": "léi,gōng,dǎ,dòu,fu",
  "雷呴": "léi,hǒu",
  "雷子": "léi,zi",
  "雷扎耶湖": "léi,zhá,yē,hú",
  "雷殷": "léi,yǐn",
  "雷毂": "léi,gū",
  "雷渀": "léi,bēn",
  "雷诺数": "léi,nuò,shù",
  "雷辗": "léi,niǎn",
  "雹子": "báo,zi",
  "雾兴云涌": "wù,xīng,yún,yǒng",
  "雾浓地": "wù,nóng,de",
  "雾露": "wù,lù",
  "需氧地": "xū,yǎng,de",
  "需要不断地": "xū,yào,bù,duàn,de",
  "需要地": "xū,yào,de",
  "需要大量地": "xū,yào,dà,liàng,de",
  "需要好好地": "xū,yào,hǎo,hǎo,de",
  "霄露": "xiāo,lù",
  "霅溪": "zhà,xī",
  "震兴": "zhèn,xīng",
  "震动地": "zhèn,dòng,de",
  "震呴": "zhèn,hǒu",
  "震天价响": "zhèn,tiān,ga,xiǎng",
  "震撼弹": "zhèn,hàn,dàn",
  "震眩弹": "zhèn,xuàn,dàn",
  "霍乱杆菌": "huò,luàn,gǎn,jūn",
  "霍嚓": "huò,chā",
  "霍濩": "huò,hù",
  "霑涴": "zhān,wò",
  "霑逮": "zhān,dǎi",
  "霑霔": "zhān,zhù",
  "霑露": "zhān,lù",
  "霓幢": "ní,zhuàng",
  "霔雨": "zhù,yǔ",
  "霖潦": "lín,liáo",
  "霖霔": "lín,zhù",
  "霜凋夏绿": "shuāng,diāo,xià,lù",
  "霜干": "shuāng,gàn",
  "霜沤": "shuāng,ōu",
  "霜皛": "shuāng,jiǎo",
  "霜行草宿": "shuāng,xíng,cǎo,xiǔ",
  "霜蹏": "shuāng,dì",
  "霜露": "shuāng,lù",
  "霜露之思": "shuāng,lù,zhī,sī",
  "霜露之悲": "shuāng,lù,zhī,bēi",
  "霜露之感": "shuāng,lù,zhī,gǎn",
  "霜露之疾": "shuāng,lù,zhī,jí",
  "霜露之病": "shuāng,lù,zhī,bìng",
  "霜露之辰": "shuāng,lù,zhī,chén",
  "霜露感": "shuāng,lù,gǎn",
  "霜鞞": "shuāng,bǐ",
  "霜鹘": "shuāng,hú",
  "霞冠": "xiá,guān",
  "霞刹": "xiá,shā",
  "霞槛": "xiá,kǎn",
  "霞炤": "xiá,zhāo",
  "霞血": "xiá,xuè",
  "霞铺": "xiá,pù",
  "霪潦": "yín,liáo",
  "霭露": "ǎi,lù",
  "霰弹": "xiàn,dàn",
  "霰弹枪": "xiàn,dàn,qiāng",
  "露七露八": "lù,qī,lù,bā",
  "露书": "lù,shū",
  "露井": "lù,jǐng",
  "露会": "lù,huì",
  "露体": "lù,tǐ",
  "露光": "lù,guāng",
  "露养": "lù,yǎng",
  "露冕": "lù,miǎn",
  "露出": "lù,chū",
  "露出地": "lù,chū,de",
  "露出马脚": "lù,chū,mǎ,jiǎo",
  "露劾": "lù,hé",
  "露华": "lù,huá",
  "露华浓": "lù,huá,nóng",
  "露卯": "lù,mǎo",
  "露原形": "lù,yuán,xíng",
  "露口信": "lù,kǒu,xìn",
  "露台": "lù,tái",
  "露台之产": "lù,tái,zhī,chǎn",
  "露台弟子": "lù,tái,dì,zǐ",
  "露叶": "lù,yè",
  "露吐": "lù,tǔ",
  "露告": "lù,gào",
  "露囤": "lù,dùn",
  "露国": "lù,guó",
  "露地": "lù,dì",
  "露地牛": "lù,dì,niú",
  "露地白牛": "lù,dì,bái,niú",
  "露坛": "lù,tán",
  "露堂": "lù,táng",
  "露墅": "lù,shù",
  "露处": "lù,chǔ",
  "露天": "lù,tiān",
  "露天地": "lù,tiān,de",
  "露天堆栈": "lù,tiān,duī,zhàn",
  "露天大戏院": "lù,tiān,dà,xì,yuàn",
  "露天开采": "lù,tiān,kāi,cǎi",
  "露天矿": "lù,tiān,kuàng",
  "露天通事": "lù,tiān,tōng,shì",
  "露天采矿": "lù,tiān,cǎi,kuàng",
  "露头": "lù,tóu",
  "露头妻": "lù,tóu,qī",
  "露头角": "lù,tóu,jiǎo",
  "露头露脑": "lù,tóu,lù,nǎo",
  "露奏": "lù,zòu",
  "露妆": "lù,zhuāng",
  "露宿": "lù,sù",
  "露宿风餐": "lù,sù,fēng,cān",
  "露寝": "lù,qǐn",
  "露尘": "lù,chén",
  "露尾藏头": "lù,wěi,cáng,tóu",
  "露居": "lù,jū",
  "露屑": "lù,xiè",
  "露己扬才": "lù,jǐ,yáng,cái",
  "露布": "lù,bù",
  "露幕": "lù,mù",
  "露床": "lù,chuáng",
  "露店": "lù,diàn",
  "露庭": "lù,tíng",
  "露形": "lù,xíng",
  "露影藏形": "lù,yǐng,cáng,xíng",
  "露往霜来": "lù,wǎng,shuāng,lái",
  "露情": "lù,qíng",
  "露房": "lù,fáng",
  "露才扬己": "lù,cái,yáng,jǐ",
  "露拍": "lù,pāi",
  "露掌": "lù,zhǎng",
  "露撒": "lù,sā",
  "露斯": "lù,sī",
  "露日": "lù,rì",
  "露晓": "lù,xiǎo",
  "露晞": "lù,xī",
  "露暴": "lù,bào",
  "露木": "lù,mù",
  "露朴": "lù,piáo",
  "露朵": "lù,duǒ",
  "露朽": "lù,xiǔ",
  "露板": "lù,bǎn",
  "露柱": "lù,zhù",
  "露根": "lù,gēn",
  "露桁": "lù,héng",
  "露桃": "lù,táo",
  "露桡": "lù,ráo",
  "露棚": "lù,péng",
  "露槿": "lù,jǐn",
  "露檄": "lù,xí",
  "露次": "lù,cì",
  "露止": "lù,zhǐ",
  "露气": "lù,qì",
  "露水": "lù,shuǐ",
  "露水夫妻": "lù,shuǐ,fū,qī",
  "露水姻缘": "lù,shuǐ,yīn,yuán",
  "露水相逢": "lù,shuǐ,xiāng,féng",
  "露水缘": "lù,shuǐ,yuán",
  "露泄": "lù,xiè",
  "露洁": "lù,jié",
  "露洒": "lù,sǎ",
  "露滴": "lù,dī",
  "露点": "lù,diǎn",
  "露版": "lù,bǎn",
  "露牙": "lù,yá",
  "露犬": "lù,quǎn",
  "露珠": "lù,zhū",
  "露琼": "lù,qióng",
  "露田": "lù,tián",
  "露申": "lù,shēn",
  "露申辛夷": "lù,shēn,xīn,yí",
  "露电": "lù,diàn",
  "露盖": "lù,gài",
  "露盘": "lù,pán",
  "露相": "lòu,xiàng",
  "露眠": "lù,mián",
  "露眼": "lù,yǎn",
  "露砌": "lù,qì",
  "露禽": "lù,qín",
  "露积": "lù,jī",
  "露立": "lù,lì",
  "露章": "lù,zhāng",
  "露第": "lù,dì",
  "露筋": "lù,jīn",
  "露筋夫人": "lù,jīn,fū,rén",
  "露筋女": "lù,jīn,nǚ",
  "露筋祠": "lù,jīn,cí",
  "露簟": "lù,diàn",
  "露索": "lù,suǒ",
  "露纂雪钞": "lù,zuǎn,xuě,chāo",
  "露红": "lù,hóng",
  "露红烟紫": "lù,hóng,yān,zǐ",
  "露红烟绿": "lù,hóng,yān,lù",
  "露网": "lù,wǎng",
  "露网车": "lù,wǎng,chē",
  "露胆披肝": "lù,dǎn,pī,gān",
  "露胆披诚": "lù,dǎn,pī,chéng",
  "露背": "lòu,bèi",
  "露胔": "lù,zì",
  "露脚": "lù,jiǎo",
  "露节": "lù,jié",
  "露花": "lù,huā",
  "露花风絮": "lù,huā,fēng,xù",
  "露芽": "lù,yá",
  "露英": "lù,yīng",
  "露茜": "lù,xī",
  "露草": "lù,cǎo",
  "露营": "lù,yíng",
  "露葵": "lù,kuí",
  "露蔓": "lù,màn",
  "露薤": "lù,xiè",
  "露蚕": "lù,cán",
  "露蛬风蝉": "lù,qióng,fēng,chán",
  "露衣": "lù,yī",
  "露表": "lù,biǎo",
  "露袒": "lù,tǎn",
  "露褐": "lù,hè",
  "露西": "lù,xī",
  "露西亚": "lù,xī,yà",
  "露复": "lù,fù",
  "露见": "lù,jiàn",
  "露跣": "lù,xiǎn",
  "露车": "lù,chē",
  "露辋": "lù,wǎng",
  "露酎": "lù,zhòu",
  "露酒": "lù,jiǔ",
  "露醑": "lù,xǔ",
  "露钞雪纂": "lù,chāo,xuě,zuǎn",
  "露锷": "lù,è",
  "露门": "lù,mén",
  "露门学": "lù,mén,xué",
  "露阴癖": "lù,yīn,pǐ",
  "露陌": "lù,mò",
  "露雨": "lù,yǔ",
  "露面抛头": "lù,miàn,pāo,tóu",
  "露韩": "lù,hán",
  "露颖": "lù,yǐng",
  "露颗": "lù,kē",
  "露餐风宿": "lù,cān,fēng,sù",
  "露饮": "lù,yǐn",
  "露香": "lù,xiāng",
  "露骨": "lù,gǔ",
  "露骨地": "lù,gǔ,de",
  "露鸡": "lù,jī",
  "露鸿": "lù,hóng",
  "露鹄": "lù,hú",
  "露鹤": "lù,hè",
  "露齿": "lù,chǐ",
  "露齿地": "lù,chǐ,de",
  "露齿而笑": "lù,chǐ,ér,xiào",
  "靃靡靡": "huò,mǐ,mǐ",
  "青削": "qīng,xuē",
  "青堂瓦舍": "qīng,táng,wǎ,shè",
  "青天大老爷": "qīng,tiān,dà,lǎo,ye",
  "青少年": "qīng,shào,nián",
  "青山一发": "qīng,shān,yī,fà",
  "青山绿水": "qīng,shān,lù,shuǐ",
  "青幢": "qīng,zhuàng",
  "青干": "qīng,gàn",
  "青年旅舍": "qīng,nián,lǚ,shè",
  "青春地": "qīng,chūn,de",
  "青春种": "qīng,chūn,zhòng",
  "青曾": "qīng,zēng",
  "青林音乐": "qīng,lín,yīn,yuè",
  "青林黑塞": "qīng,lín,hēi,sài",
  "青枝绿叶": "qīng,zhī,lù,yè",
  "青梼": "qīng,táo",
  "青沤": "qīng,ōu",
  "青灯黄卷": "qīng,dēng,huáng,juàn",
  "青臒": "qīng,qú",
  "青祇": "qīng,qí",
  "青禁": "qīng,jìn",
  "青禁客": "qīng,jìn,kè",
  "青紫被体": "qīng,zǐ,pī,tǐ",
  "青翠地": "qīng,cuì,de",
  "青肝碧血": "qīng,gān,bì,xuè",
  "青草峒": "qīng,cǎo,dòng",
  "青莎": "qīng,shā",
  "青莲冠": "qīng,lián,guān",
  "青莲舍": "qīng,lián,shè",
  "青葙子": "qīng,xiāng,zi",
  "青藏": "qīng,zàng",
  "青藏公路": "qīng,zàng,gōng,lù",
  "青藏线": "qīng,zàng,xiàn",
  "青藏铁路": "qīng,zàng,tiě,lù",
  "青藏铁路线": "qīng,zàng,tiě,lù,xiàn",
  "青藏高原": "qīng,zàng,gāo,yuán",
  "青蘪": "qīng,méi",
  "青血": "qīng,xuè",
  "青袜子": "qīng,wà,zi",
  "青豆舍": "qīng,dòu,shè",
  "青铺": "qīng,pù",
  "青雘": "qīng,wò",
  "青骹": "qīng,xiāo",
  "青鹘": "qīng,hú",
  "靓严": "liàng,yán",
  "靓丽": "liàng,lì",
  "靓仔": "liàng,zǎi",
  "靓号": "liàng,hào",
  "靓女": "liàng,nǚ",
  "靓妹": "liàng,mèi",
  "靓姝": "liàng,shū",
  "靓媚": "liàng,mèi",
  "靓审": "liàng,shěn",
  "靓服": "liàng,fú",
  "靓深": "liàng,shēn",
  "靓白": "liàng,bái",
  "靓妆": "liàng,zhuāng",
  "靓耀": "liàng,yào",
  "靓艳": "liàng,yàn",
  "靓袨": "liàng,xuàn",
  "靓装": "liàng,zhuāng",
  "靓观": "liàng,guān",
  "靓质": "liàng,zhì",
  "靓闲": "liàng,xián",
  "靓雅": "liàng,yǎ",
  "靖长官": "jìng,zhǎng,guān",
  "静兀兀": "jìng,wū,wū",
  "静养地": "jìng,yǎng,de",
  "静处": "jìng,chǔ",
  "静如处女": "jìng,rú,chǔ,nǚ",
  "静影沉璧": "jing,ying,chen,bi",
  "静态地": "jìng,tài,de",
  "静悄悄地": "jìng,qiāo,qiāo,de",
  "静搒": "jìng,péng",
  "静朴": "jìng,piáo",
  "静止地": "jìng,zhǐ,de",
  "静电反应": "jìng,diàn,fǎn,yìng",
  "静絜": "jìng,jié",
  "静脉曲张": "jìng,mài,qū,zhāng",
  "静脉注射地": "jìng,mài,zhù,shè,de",
  "静若处子": "jìng,ruò,chǔ,zǐ",
  "静讽": "jìng,fěng",
  "静适": "jìng,shì",
  "静静地": "jìng,jìng,de",
  "静静地体会着": "jìng,jìng,de,tǐ,huì,zhe",
  "静静地听": "jìng,jìng,de,tīng",
  "静静地听着": "jìng,jìng,de,tīng,zhe",
  "静静地呆着": "jìng,jìng,de,dāi,zhe",
  "静静地在一旁": "jìng,jìng,de,zài,yī,páng",
  "静静地坐在": "jìng,jìng,de,zuò,zài",
  "静静地坐在那里": "jìng,jìng,de,zuò,zài,nà,lǐ",
  "静静地坐着": "jìng,jìng,de,zuò,zhe",
  "静静地思索着": "jìng,jìng,de,sī,suǒ,zhe",
  "静静地想着": "jìng,jìng,de,xiǎng,zhe",
  "静静地看": "jìng,jìng,de,kàn",
  "静静地看书": "jìng,jìng,de,kàn,shū",
  "静静地看看": "jìng,jìng,de,kàn,kàn",
  "静静地看着": "jìng,jìng,de,kàn,zhe",
  "静静地看着你": "jìng,jìng,de,kàn,zhe,nǐ",
  "静静地站着": "jìng,jìng,de,zhàn,zhe",
  "静静地等": "jìng,jìng,de,děng",
  "静静地等待": "jìng,jìng,de,děng,dài",
  "静静地等待着": "jìng,jìng,de,děng,dài,zhe",
  "静静地说": "jìng,jìng,de,shuō",
  "静静地走着": "jìng,jìng,de,zǒu,zhe",
  "静静地躺在床上": "jìng,jìng,de,tǎng,zài,chuáng,shàng",
  "靛冠噪鹛": "diàn,guān,zào,méi",
  "非为": "fēi,wéi",
  "非公认地": "fēi,gōng,rèn,de",
  "非典型地": "fēi,diǎn,xíng,de",
  "非凡地": "fēi,fán,de",
  "非分": "fēi,fèn",
  "非分之念": "fēi,fèn,zhī,niàn",
  "非分之想": "fēi,fèn,zhī,xiǎng",
  "非分之财": "fēi,fèn,zhī,cái",
  "非固有地": "fēi,gù,yǒu,de",
  "非国家行为体": "fēi,guó,jiā,xíng,wéi,tǐ",
  "非处": "fēi,chǔ",
  "非处方药": "fēi,chǔ,fāng,yào",
  "非宗教地": "fēi,zōng,jiào,de",
  "非官办地": "fēi,guān,bàn,de",
  "非官方地": "fēi,guān,fāng,de",
  "非对称": "fēi,duì,chèn",
  "非对称式数据用户线": "fēi,duì,chèn,shì,shù,jù,yòng,hù,xiàn",
  "非常严重地": "fēi,cháng,yán,zhòng,de",
  "非常地": "fēi,cháng,de",
  "非常地不喜欢": "fēi,cháng,de,bù,xǐ,huān",
  "非常地不满": "fēi,cháng,de,bù,mǎn",
  "非常地困难": "fēi,cháng,de,kùn,nán",
  "非常地好": "fēi,cháng,de,hǎo",
  "非常地好用": "fēi,cháng,de,hǎo,yòng",
  "非常地开心": "fēi,cháng,de,kāi,xīn",
  "非常地快": "fēi,cháng,de,kuài",
  "非常地感谢": "fēi,cháng,de,gǎn,xiè",
  "非常地愿意": "fēi,cháng,de,yuàn,yì",
  "非常地慢": "fēi,cháng,de,màn",
  "非常地有利": "fēi,cháng,de,yǒu,lì",
  "非常地清楚": "fēi,cháng,de,qīng,chǔ",
  "非常地重": "fēi,cháng,de,zhòng",
  "非常多地": "fēi,cháng,duō,de",
  "非常好地": "fēi,cháng,hǎo,de",
  "非常快地": "fēi,cháng,kuài,de",
  "非常激烈地": "fēi,cháng,jī,liè,de",
  "非常热情地": "fēi,cháng,rè,qíng,de",
  "非常迅速地": "fēi,cháng,xùn,sù,de",
  "非常非常地": "fēi,cháng,fēi,cháng,de",
  "非得": "fēi,děi",
  "非想非非想处": "fēi,xiǎng,fēi,fēi,xiǎng,chǔ",
  "非想非非想处天": "fēi,xiǎng,fēi,fēi,xiǎng,chǔ,tiān",
  "非折": "fēi,shé",
  "非政治地": "fēi,zhèng,zhì,de",
  "非故意地": "fēi,gù,yì,de",
  "非数值应用": "fēi,shù,zhí,yìng,yòng",
  "非数字": "fēi,shù,zì",
  "非杠杆化": "fēi,gàng,gǎn,huà",
  "非正常地": "fēi,zhèng,cháng,de",
  "非正式地": "fēi,zhèng,shì,de",
  "非正数": "fēi,zhèng,shù",
  "非正统地": "fēi,zhèng,tǒng,de",
  "非法地": "fēi,fǎ,de",
  "非法行为": "fēi,fǎ,xíng,wéi",
  "非洲开发银行": "fēi,zhōu,kāi,fā,yín,háng",
  "非社会地": "fēi,shè,huì,de",
  "非累": "fēi,lèi",
  "非经常地": "fēi,jīng,cháng,de",
  "非誉": "fěi,yù",
  "非词重复测验": "fēi,cí,chóng,fù,cè,yàn",
  "非负数": "fēi,fù,shù",
  "非道德行为": "fēi,dào,dé,xíng,wéi",
  "非都会郡": "fēi,dū,huì,jùn",
  "非难": "fēi,nàn",
  "非难似地": "fēi,nàn,shì,de",
  "非难地": "fēi,nàn,de",
  "靠不住": "kào,bú,zhù",
  "靠不住地": "kào,bú,zhù,de",
  "靠头": "kào,tou",
  "靠得": "kào,de",
  "靠得住": "kào,de,zhù",
  "靠牌子": "kào,pái,zi",
  "靠着地": "kào,zhe,de",
  "靠背": "kào,bèi",
  "靠背椅": "kào,bèi,yǐ",
  "靠自己不断地": "kào,zì,jǐ,bù,duàn,de",
  "靠近地": "kào,jìn,de",
  "靡不有初": "mǐ,bù,yǒu,chū",
  "靡丽": "mǐ,lì",
  "靡他": "mǐ,tā",
  "靡它": "mǐ,tā",
  "靡忒": "mí,tuī",
  "靡所适从": "mí,suǒ,shì,cóng",
  "靡旗": "mǐ,qí",
  "靡有孑遗": "mǐ,yǒu,jié,yí",
  "靡然": "mǐ,rán",
  "靡然从风": "mǐ,rán,cóng,fēng",
  "靡𰮇": "mí,wǔ",
  "靡衣偷食": "mǐ,yī,tōu,shí",
  "靡衣媮食": "mǐ,yī,tōu,shí",
  "靡跌": "mí,diē",
  "靡靡": "mǐ,mǐ",
  "靡靡之乐": "mǐ,mǐ,zhī,yuè",
  "靡靡之声": "mǐ,mǐ,zhī,shēng",
  "靡靡之音": "mǐ,mǐ,zhī,yīn",
  "靡颜腻理": "mǐ,yán,nì,lǐ",
  "靡骋": "mǐ,chěng",
  "面人儿": "miàn,rén,er",
  "面儿": "miàn,er",
  "面南背北": "miàn,nán,bèi,běi",
  "面如傅粉": "miàn,rú,fǔ,fěn",
  "面如冠玉": "miàn,rú,guān,yù",
  "面子": "miàn,zi",
  "面子帐": "miàn,zi,zhàng",
  "面子情儿": "miàn,zi,qíng,ér",
  "面子话": "miàn,zi,huà",
  "面对面地": "miàn,duì,miàn,de",
  "面对面地坐在": "miàn,duì,miàn,de,zuò,zài",
  "面弹": "miàn,dàn",
  "面折": "miàn,shé",
  "面折庭争": "miàn,shé,tíng,zhēng",
  "面折廷诤": "miàn,shé,tíng,zhèng",
  "面数": "miàn,shù",
  "面是背非": "miàn,shì,bèi,fēi",
  "面朝黄土背朝天": "miàn,cháo,huáng,tǔ,bèi,cháo,tiān",
  "面条儿": "miàn,tiáo,er",
  "面片儿": "miàn,piān,er",
  "面疙瘩": "miàn,gē,da",
  "面的": "miàn,dī",
  "面盘子": "miàn,pán,zi",
  "面粘": "miàn,zhān",
  "面糊": "miàn,hù",
  "面红面绿": "miàn,hóng,miàn,lù",
  "面背": "miàn,bèi",
  "面蕃": "miàn,fān",
  "面誉背毁": "miàn,yù,bèi,huǐ",
  "面誉背非": "miàn,yù,bèi,fēi",
  "面谀背毁": "miàn,yú,bèi,huǐ",
  "面谩": "miàn,màn",
  "面谩腹诽": "miàn,màn,fù,fěi",
  "面铺": "miàn,pù",
  "面露": "miàn,lù",
  "面露不悦": "miàn,lù,bù,yuè",
  "面露倦意": "miàn,lù,juàn,yì",
  "革削": "gé,xuē",
  "革更": "gé,gēng",
  "革舃": "gé,tuō",
  "靴子": "xuē,zi",
  "靴掖子": "xuē,yē,zi",
  "靴筩": "xuē,yǒng",
  "靶儿镜子": "bǎ,ér,jìng,zi",
  "靶子": "bǎ,zi",
  "靻𫏋": "zǔ,jué",
  "鞅牛": "yǎng,niú",
  "鞉鞞": "táo,bǐ",
  "鞋匠": "xié,jiang",
  "鞋子": "xié,zi",
  "鞋拔子": "xié,bá,zi",
  "鞋跟儿": "xié,gēn,er",
  "鞋韈": "xié,wà",
  "鞍不离马背": "ān,bù,lí,mǎ,bèi",
  "鞍子": "ān,zi",
  "鞙丝": "juān,sī",
  "鞙佩": "juān,pèi",
  "鞙鞙": "juān,juān",
  "鞞婆": "bǐ,pó",
  "鞞扇舞": "bǐ,shàn,wǔ",
  "鞞柝": "bǐ,tuò",
  "鞞舞": "bǐ,wǔ",
  "鞞蓝风": "bǐ,lán,fēng",
  "鞞革": "bǐ,gé",
  "鞞靫": "bǐ,chá",
  "鞞鞛": "bǐ,běng",
  "鞞鼓": "bǐ,gǔ",
  "鞠为茂草": "jū,wéi,mào,cǎo",
  "鞠侯": "jū,hòu",
  "鞠翟": "jū,zhái",
  "鞠躬屏气": "jū,gōng,bǐng,qì",
  "鞫为茂草": "jū,wéi,mào,cǎo",
  "鞬子": "jiān,zǐ",
  "鞬弭": "jiān,mǐ",
  "鞬服": "jiān,fú",
  "鞬櫜": "jiān,gāo",
  "鞬腰": "jiān,yāo",
  "鞬辀": "jiān,zhōu",
  "鞬镳": "jiān,biāo",
  "鞭子": "biān,zi",
  "鞭挝": "biān,zhuā",
  "鞭朴": "biān,piáo",
  "鞭杆溜子": "biān,gǎn,liū,zǐ",
  "鞭着": "biān,zhe",
  "鞭䇲": "biān,jiā",
  "鞭背": "biān,bèi",
  "鞭血": "biān,xuè",
  "鞭蹬": "biān,dēng",
  "鞭辟": "biān,bì",
  "鞭辟向里": "biān,bì,xiàng,lǐ",
  "鞭辟着里": "biān,bì,zhuó,lǐ",
  "鞭鞘": "biān,shāo",
  "鞮鞪": "dī,móu",
  "鞲扞": "gōu,gǎn",
  "鞴扞": "bèi,gǎn",
  "韈劫子": "wà,jié,zǐ",
  "韈子": "wà,zǐ",
  "韈材": "wà,cái",
  "韈系": "wà,xì",
  "韈罗": "wà,luó",
  "韈袴": "wà,kù",
  "𱂇靽": "juàn,bàn",
  "韦应物": "wéi,yìng,wù",
  "韦毂": "wéi,gū",
  "韦舃": "wéi,tuō",
  "韧干": "rèn,gàn",
  "韩侯蔌": "hán,hòu,sù",
  "韩信将兵": "hán,xìn,jiàng,bīng",
  "韩国银行": "hán,guó,yín,háng",
  "韩棒子": "hán,bàng,zi",
  "韩熙载夜宴图": "hán,xī,zǎi,yè,yàn,tú",
  "韬戈卷甲": "tāo,gē,juàn,jiǎ",
  "音乐": "yīn,yuè",
  "音乐之声": "yīn,yuè,zhī,shēng",
  "音乐会": "yīn,yuè,huì",
  "音乐光碟": "yīn,yuè,guāng,dié",
  "音乐剧": "yīn,yuè,jù",
  "音乐厅": "yīn,yuè,tīng",
  "音乐喷泉": "yīn,yuè,pēn,quán",
  "音乐学": "yīn,yuè,xué",
  "音乐学院": "yīn,yuè,xué,yuàn",
  "音乐家": "yīn,yuè,jiā",
  "音乐片": "yīn,yuè,piàn",
  "音乐电视": "yīn,yuè,diàn,shì",
  "音乐界": "yīn,yuè,jiè",
  "音乐老师": "yīn,yuè,lǎo,shī",
  "音乐般地": "yīn,yuè,bān,de",
  "音乐节": "yīn,yuè,jié",
  "音乐茶座": "yīn,yuè,chá,zuò",
  "音乐院": "yīn,yuè,yuàn",
  "音乐频道": "yīn,yuè,pín,dào",
  "音撇": "yīn,piě",
  "音色地": "yīn,sè,de",
  "音调": "yīn,diào",
  "音调地": "yīn,diào,de",
  "音调好地": "yīn,diào,hǎo,de",
  "韵律地": "yùn,lǜ,de",
  "韵调": "yùn,diào",
  "韶濩": "sháo,hù",
  "韶箾": "sháo,xiāo",
  "𫖳砡": "yūn,yù",
  "页数": "yè,shù",
  "顶冠束带": "dǐng,guān,shù,dài",
  "顶头子": "dǐng,tóu,zi",
  "顶尖儿": "dǐng,jiān,er",
  "顶帅地": "dǐng,shuài,de",
  "顶数": "dǐng,shù",
  "顶杆": "dǐng,gǎn",
  "顶柱子": "dǐng,zhù,zi",
  "顶牛儿": "dǐng,niú,er",
  "顶皮儿": "dǐng,pí,er",
  "顷倒": "qīng,dǎo",
  "顷危": "qīng,wēi",
  "顷宫": "qīng,gōng",
  "顷数": "qǐng,shù",
  "顷筐": "qīng,kuāng",
  "项背": "xiàng,bèi",
  "项背相望": "xiàng,bèi,xiāng,wàng",
  "顺之者兴": "shùn,zhī,zhě,xīng",
  "顺人应天": "shùn,rén,yìng,tiān",
  "顺从地": "shùn,cóng,de",
  "顺便一提": "shùn,biàn,yì,tí",
  "顺便地": "shùn,biàn,de",
  "顺利地": "shùn,lì,de",
  "顺利地到达": "shùn,lì,de,dào,dá",
  "顺利地完成": "shùn,lì,de,wán,chéng",
  "顺利地进行": "shùn,lì,de,jìn,xíng",
  "顺利地通过": "shùn,lì,de,tōng,guò",
  "顺嘴儿": "shùn,zuǐ,er",
  "顺坦": "shùn,tan",
  "顺天应人": "shùn,tiān,yìng,rén",
  "顺子": "shùn,zi",
  "顺差": "shùn,chā",
  "顺序地": "shùn,xù,de",
  "顺序数": "shùn,xù,shù",
  "顺应": "shùn,yìng",
  "顺应不良": "shùn,yìng,bù,liáng",
  "顺应天时": "shùn,yìng,tiān,shí",
  "顺手儿": "shùn,shǒu,er",
  "顺数": "shùn,shù",
  "顺时针地": "shùn,shí,zhēn,de",
  "顺时间方向地": "shùn,shí,jiān,fāng,xiàng,de",
  "顺杆爬": "shùn,gǎn,pá",
  "顺流地": "shùn,liú,de",
  "顺济侯": "shùn,jì,hòu",
  "顺畅地": "shùn,chàng,de",
  "顺着": "shùn,zhe",
  "顺适": "shùn,shì",
  "顺风使帆": "shùn,fēng,shǐ,fān",
  "顺风地": "shùn,fēng,de",
  "顺风张帆": "shùn,fēng,zhāng,fān",
  "顺风扯帆": "shùn,fēng,chě,fān",
  "须不是": "xū,bú,shì",
  "须发": "xū,fà",
  "须发皆白": "xū,fà,jiē,bái",
  "须子": "xū,zi",
  "须得": "xū,de",
  "须掠": "xū,lüě",
  "须着": "xū,zhe",
  "须髯若神": "xu,ran,ruo,sheng",
  "顽仆": "wán,pú",
  "顽固地": "wán,gù,de",
  "顽固地坚持": "wán,gù,de,jiān,chí",
  "顽强地": "wán,qiáng,de",
  "顽强地奋斗": "wán,qiáng,de,fèn,dòu",
  "顽强地拼搏": "wán,qiáng,de,pàn,bó",
  "顽朴": "wán,piáo",
  "顽查": "wán,zhā",
  "顽皮地": "wán,pí,de",
  "顽皮地笑": "wán,pí,de,xiào",
  "顽𬮴": "wán,ān",
  "顽𫘤": "wán,ái",
  "顾不上": "gù,bu,shàng",
  "顾不得": "gù,bu,de",
  "顾景": "gù,yǐng",
  "顾景惭形": "gù,yǐng,cán,xíng",
  "顾累": "gù,lèi",
  "顾菟": "gù,tú",
  "顾虑重重": "gù,lǜ,chóng,chóng",
  "顾逮": "gù,dǎi",
  "顾颉刚": "gù,xié,gāng",
  "顿仆": "dùn,pú",
  "顿咽": "dùn,yān",
  "顿堡": "dùn,pù",
  "顿处": "dùn,chǔ",
  "顿学累功": "dùn,xué,lěi,gōng",
  "顿开茅塞": "dùn,kāi,máo,sè",
  "顿折": "dùn,shé",
  "顿撇": "dùn,piě",
  "顿毂": "dùn,gū",
  "顿牟": "dùn,mù",
  "顿着": "dùn,zhe",
  "顿舍": "dùn,shè",
  "顿足搥胸": "dùn,zú,duī,xiōng",
  "顿跌": "dùn,diē",
  "顿遟": "dùn,zhì",
  "颂声载道": "sòng,shēng,zǎi,dào",
  "颂祇": "sòng,qí",
  "预兆地": "yù,zhào,de",
  "预备地": "yù,bèi,de",
  "预备知识": "yù,bèi,zhī,shi",
  "预应力": "yù,yìng,lì",
  "预应力混凝土": "yù,yìng,lì,hùn,níng,tǔ",
  "预感地": "yù,gǎn,de",
  "预见地": "yù,jiàn,de",
  "预言性地": "yù,yán,xìng,de",
  "预防接种": "yù,fáng,jiē,zhòng",
  "颅测量": "lú,cè,liáng",
  "领夹": "lǐng,jiā",
  "领子": "lǐng,zi",
  "领导班子": "lǐng,dǎo,bān,zi",
  "领干": "lǐng,gàn",
  "领悟地": "lǐng,wù,de",
  "领絜": "lǐng,jié",
  "颇为": "pō,wéi",
  "颈子": "jǐng,zi",
  "颈背": "jǐng,bèi",
  "颈脖子": "jǐng,bó,zi",
  "颉佷": "xié,hěn",
  "颉利": "xié,lì",
  "颉利发": "xié,lì,fā",
  "颉曲": "jié,qū",
  "颉桥": "jié,jiāo",
  "颉滑": "xié,huá",
  "颉羌": "xié,qiāng",
  "颉羹": "jiá,gēng",
  "颉颃": "xié,háng",
  "颊适": "jiá,shì",
  "频切": "pín,qiè",
  "频密地": "pín,mì,de",
  "频数": "pín,shuò",
  "频数分布": "pín,shù,fēn,bù",
  "频繁地": "pín,fán,de",
  "频繁地更换": "pín,fán,de,gēng,huàn",
  "频繁地更新": "pín,fán,de,gēng,xīn",
  "频频地": "pín,pín,de",
  "颓云𫘝雨": "tuí,yún,kuài,yǔ",
  "颓剥": "tuí,bāo",
  "颓废地": "tuí,fèi,de",
  "颓折": "tuí,shé",
  "颓沲": "tuí,duò",
  "颓累": "tuí,lèi",
  "颓老子": "tuí,lǎo,zi",
  "颓阤": "tuí,yǐ",
  "颖悟地": "yǐng,wù,de",
  "颖露": "yǐng,lù",
  "颙卬": "yóng,áng",
  "颙颙卬卬": "yóng,yóng,áng,áng",
  "颜帖": "yán,tiē",
  "颜曾": "yán,zēng",
  "额外主事": "é,wai,zhǔ,shì",
  "额定转速": "é,dìng,zhuàn,sù",
  "额数": "é,shù",
  "额载": "é,zǎi",
  "额部地": "é,bù,de",
  "颠仆": "diān,pú",
  "颠仆流离": "diān,pú,liú,lí",
  "颠倒干坤": "diān,dǎo,gàn,kūn",
  "颠儿面": "diān,er,miàn",
  "颠头簸脑": "diān,tóu,bǒ,nǎo",
  "颠来簸去": "diān,lái,bǒ,qù",
  "颠窨": "diān,xūn",
  "颠簸": "diān,bǒ",
  "颠簸不破": "diān,bǒ,bù,pò",
  "颠簸地": "diān,bǒ,de",
  "颠簸地行进": "diān,bǒ,de,xíng,jìn",
  "颠簸地行驶": "diān,bǒ,de,xíng,shǐ",
  "颠衣到裳": "diān,yī,dào,shang",
  "颠覆分子": "diān,fù,fèn,zǐ",
  "颠跌": "diān,diē",
  "颠蹶": "diān,juě",
  "颠骨子": "diān,gǔ,zi",
  "颢兴": "hào,xīng",
  "颢露": "hào,lù",
  "颤儿哆嗦": "chàn,ér,duō,suo",
  "颤声地": "chàn,shēng,de",
  "颤抖地": "chàn,dǒu,de",
  "颤抖地说": "chàn,dǒu,de,shuō",
  "颤栗": "zhàn,lì",
  "颤音地": "chàn,yīn,de",
  "𮨵戾": "liáo,lì",
  "风云月露": "fēng,yún,yuè,lù",
  "风什": "fēng,shí",
  "风僝雨僽": "fēng,zhuàn,yǔ,zhōu",
  "风兴云蒸": "fēng,xīng,yún,zhēng",
  "风号雨泣": "fēng,háo,yǔ,qì",
  "风咳": "fēng,hāi",
  "风土人情": "fēng,tú,rén,qíng",
  "风土性地": "fēng,tǔ,xìng,de",
  "风头": "fēng,tou",
  "风头巾": "fēng,tou,jīn",
  "风宿水飡": "fēng,xiǔ,shuǐ,cān",
  "风宿水餐": "fēng,xiǔ,shuǐ,cān",
  "风尘仆仆": "fēng,chén,pú,pú",
  "风尘肮脏": "fēng,chén,āng,zāng",
  "风帆": "fēng,fān",
  "风斗": "fēng,dǒu",
  "风档玻璃": "fēng,dàng,bō,li",
  "风毛雨血": "fēng,máo,yǔ,xuè",
  "风水轮流转": "fēng,shuǐ,lún,liú,zhuàn",
  "风沤": "fēng,ōu",
  "风流地": "fēng,liú,de",
  "风流缊藉": "fēng,liú,wēn,jiè",
  "风流藴藉": "fēng,liú,wēn,jiè",
  "风流调法": "fēng,liú,diào,fǎ",
  "风流跌宕": "fēng,liú,diē,dàng",
  "风烛草露": "fēng,zhú,cǎo,lù",
  "风煞": "fēng,shà",
  "风疙瘩": "fēng,gē,dā",
  "风禁": "fēng,jìn",
  "风缊": "fēng,wēn",
  "风调": "fēng,diào",
  "风趣地": "fēng,qù,de",
  "风趣地说": "fēng,qù,de,shuō",
  "风蹶": "fēng,juě",
  "风钻": "fēng,zuàn",
  "风镐": "fēng,hào",
  "风露": "fēng,lù",
  "风靡": "fēng,mǐ",
  "风靡一世": "fēng,mǐ,yī,shì",
  "风靡一时": "fēng,mǐ,yī,shí",
  "风靡云涌": "fēng,mǐ,yún,yǒng",
  "风靡云蒸": "fēng,mǐ,yún,zhēng",
  "风飡水宿": "fēng,cān,shuǐ,xiǔ",
  "风飧水宿": "fēng,sūn,shuǐ,xiǔ",
  "风餐水宿": "fēng,cān,shuǐ,xiǔ",
  "风餐雨宿": "fēng,cān,yǔ,xiǔ",
  "风餐露宿": "fēng,cān,lù,sù",
  "风驰草靡": "fēng,chí,cǎo,mǐ",
  "风骚娘们": "fēng,sāo,niáng,men",
  "飏帆": "yáng,fān",
  "飏累": "yáng,lèi",
  "飒擖": "sà,yè",
  "飒飒地": "sà,sà,de",
  "飒飒地响": "sà,sà,de,xiǎng",
  "飕地挥舞": "sōu,de,huī,wǔ",
  "飕飕地飞": "sōu,sōu,de,fēi",
  "飘兀": "piāo,wū",
  "飘动地": "piāo,dòng,de",
  "飘扬地": "piāo,yáng,de",
  "飘萍浪迹": "piāo,péng,làng,jì",
  "飙斿": "biāo,yóu",
  "飙欻": "biāo,chuā",
  "飞也似地": "fēi,yě,shì,de",
  "飞也似的": "fēi,yě,shì,de",
  "飞传": "fēi,zhuàn",
  "飞凫舃": "fēi,fú,tuō",
  "飞出个未来": "fēi,chū,ge,wèi,lái",
  "飞叶子": "fēi,yè,zi",
  "飞唌": "fēi,yán",
  "飞孛": "fēi,bó",
  "飞将": "fēi,jiàng",
  "飞将军": "fēi,jiàng,jūn",
  "飞将数奇": "fēi,jiàng,shù,jī",
  "飞弹": "fēi,dàn",
  "飞快地": "fēi,kuài,de",
  "飞快地奔驰": "fēi,kuài,de,bēn,chí",
  "飞快地走": "fēi,kuài,de,zǒu",
  "飞快地跑": "fēi,kuài,de,pǎo",
  "飞快地跑开": "fēi,kuài,de,pǎo,kāi",
  "飞掠": "fēi,lüě",
  "飞来横祸": "fēi,lái,hèng,huò",
  "飞毂": "fēi,gū",
  "飞灾横祸": "fēi,zāi,hèng,huò",
  "飞舃": "fēi,tuō",
  "飞菟": "fēi,tú",
  "飞𫐌": "fēi,pēng",
  "飞转": "fēi,zhuàn",
  "飞速地": "fēi,sù,de",
  "飞遁鸣高": "fēi,dùn,míng,kāo",
  "食不累味": "shí,bù,lèi,wèi",
  "食不重味": "shí,bù,chóng,wèi",
  "食不重肉": "shí,bù,chóng,ròu",
  "食为民天": "shí,wéi,mín,tiān",
  "食养": "sì,yǎng",
  "食咽": "shí,yān",
  "食士": "sì,shì",
  "食子": "sì,zǐ",
  "食官": "sì,guān",
  "食官令": "sì,guān,lìng",
  "食干": "shí,gàn",
  "食椹": "shí,shèn",
  "食母": "sì,mǔ",
  "食焄": "shí,hūn",
  "食物中毒": "shí,wù,zhòng,dú",
  "食监": "sì,jiān",
  "食祭": "sì,jì",
  "食菌": "shí,jùn",
  "食葛": "shí,gě",
  "食蛤蜊": "shí,gé,lí",
  "食蟹獴": "shí,xiè,měng",
  "食马": "sì,mǎ",
  "餐桌转盘": "cān,zhuō,zhuàn,pán",
  "餐葩饮露": "cān,pā,yǐn,lù",
  "餐霞吸露": "cān,xiá,xī,lù",
  "餐风咽露": "cān,fēng,yàn,lù",
  "餐风宿露": "cān,fēng,sù,lù",
  "餐风露宿": "cān,fēng,lù,sù",
  "餐风饮露": "cān,fēng,yǐn,lù",
  "𫗦糟": "bǔ,zāo",
  "𫗦糟歠漓": "bǔ,zāo,huài,lí",
  "𫗦𬳂": "bū,zhuì",
  "𬳂酹": "zhuì,lèi",
  "𬳂食": "zhuì,shí",
  "𱄆人": "chì,rén",
  "𱄆爨": "chì,cuàn",
  "𱄆𱃼": "chì,fēn",
  "饔飧不给": "yōng,sūn,bù,jǐ",
  "𱄀𱄆": "fēn,chì",
  "𱄀馏": "fēn,liú",
  "饥僝": "jī,chán",
  "饥嗛": "jī,qiàn",
  "饥者易为食": "jī,zhě,yì,wéi,shí",
  "饥莩": "jī,piǎo",
  "饥虺": "jī,huī",
  "饥饿地": "jī,è,de",
  "饧粥": "táng,zhōu",
  "饬朴": "chì,piáo",
  "饬查": "chì,zhā",
  "饬禁": "chì,jìn",
  "饭把子": "fàn,bà,zi",
  "饭数": "fàn,shù",
  "饭糁": "fàn,shēn",
  "饭铺": "fàn,pù",
  "饭馆儿": "fàn,guǎn,er",
  "饮兴": "yǐn,xīng",
  "饮冰茹蘖": "yǐn,bīng,rú,bò",
  "饮冰食蘖": "yǐn,bīng,shí,bò",
  "饮咽": "yǐn,yān",
  "饮场": "yìn,chǎng",
  "饮弹": "yǐn,dàn",
  "饮弹自尽": "yǐn,dàn,zì,jìn",
  "饮弹身亡": "yǐn,dàn,shēn,wáng",
  "饮水曲肱": "yǐn,shuǐ,qū,gōng",
  "饮牛津": "yìn,niú,jīn",
  "饮犊上流": "yìn,dú,shàng,liú",
  "饮羊": "yìn,yáng",
  "饮胆尝血": "yǐn,dǎn,cháng,xuè",
  "饮血": "yǐn,xuè",
  "饮血崩心": "yǐn,xuè,bēng,xīn",
  "饮血茹毛": "yǐn,xuè,rú,máo",
  "饮露餐风": "yǐn,lù,cān,fēng",
  "饮风餐露": "yǐn,fēng,cān,lù",
  "饮马": "yìn,mǎ",
  "饮马投钱": "yìn,mǎ,tóu,qián",
  "饮马窟": "yìn,mǎ,kū",
  "饰翫": "shì,wàn",
  "饰非遂过": "shì,fēi,suí,guò",
  "饱呃": "bǎo,e",
  "饱和点": "bǎo,huó,diǎn",
  "饱咯": "bǎo,gē",
  "饱嗝儿": "bǎo,gé,er",
  "饱掠": "bǎo,lüě",
  "饱更": "bǎo,gēng",
  "饱载": "bǎo,zǎi",
  "饱飨老拳": "bǎo,xiǎng,lào,quán",
  "饲料地": "sì,liào,de",
  "饴露": "yí,lù",
  "饵子": "ěr,zi",
  "饶舌地": "ráo,shé,de",
  "饶舌音乐": "ráo,shé,yīn,yuè",
  "饷干": "xiǎng,qián",
  "饸饹": "hé,le",
  "饺子": "jiǎo,zi",
  "饺子馆": "jiǎo,zi,guǎn",
  "饼子": "bǐng,zi",
  "饼子桃": "bǐng,zi,táo",
  "饼屑子": "bǐng,xiè,zi",
  "饼铛": "bǐng,chēng",
  "饽饽": "bō,bo",
  "饿殍枕藉": "è,piǎo,zhěn,jí",
  "饿肚子": "è,dù,zi",
  "饿莩": "è,piǎo",
  "饿莩载道": "è,piǎo,zǎi,dào",
  "饿莩遍野": "è,piǎo,biàn,yě",
  "饿虎之蹊": "è,hǔ,zhī,xī",
  "馄饨皮儿": "hún,tún,pí,er",
  "馅儿": "xiàn,er",
  "馅儿饼": "xiàn,er,bǐng",
  "馆子": "guǎn,zi",
  "馆舍": "guǎn,shè",
  "馆长": "guǎn,zhǎng",
  "馈贫之粮": "zuò,pín,zhī,liáng",
  "馈𱄆": "kuì,chì",
  "馊主意": "sōu,zhǔ,yi",
  "馍馍": "mó,mo",
  "馏分": "liú,fèn",
  "馒头": "mán,tou",
  "馓子": "sǎn,zi",
  "馔殽": "zhuàn,yáo",
  "馕嗓": "nǎng,sǎng",
  "馕糠": "nǎng,kāng",
  "首先地": "shǒu,xiān,de",
  "首冠": "shǒu,guān",
  "首卷": "shǒu,juàn",
  "首尾相应": "shǒu,wěi,xiāng,yìng",
  "首相": "shǒu,xiàng",
  "首要地": "shǒu,yào,de",
  "首足异处": "shǒu,zú,yì,chǔ",
  "首都": "shǒu,dū",
  "首都剧场": "shǒu,dū,jù,chǎng",
  "首都国际机场": "shǒu,dū,guó,jì,jī,chǎng",
  "首都机场": "shǒu,dū,jī,chǎng",
  "首都经济贸易大学": "shǒu,dū,jīng,jì,mào,yì,dà,xué",
  "首都经贸大学": "shǒu,dū,jīng,mào,dà,xué",
  "首都领地": "shǒu,dū,lǐng,dì",
  "首长": "shǒu,zhǎng",
  "首难": "shǒu,nàn",
  "首露": "shǒu,lù",
  "香几": "xiāng,jī",
  "香刹": "xiāng,shā",
  "香干儿": "xiāng,gān,er",
  "香椒铺": "xiāng,jiāo,pù",
  "香榭丽舍": "xiāng,xiè,lì,shè",
  "香榭丽舍大街": "xiāng,xiè,lì,shè,dà,jiē",
  "香毂": "xiāng,gū",
  "香气地": "xiāng,qì,de",
  "香泡树": "xiāng,pāo,shù",
  "香港银行公会": "xiāng,gǎng,yín,háng,gōng,huì",
  "香獐子": "xiāng,zhāng,zi",
  "香胰子": "xiāng,yí,zi",
  "香莎": "xiāng,shā",
  "香菌": "xiāng,jùn",
  "香薄荷": "xiāng,bò,he",
  "香衖": "xiāng,lòng",
  "香裓": "xiāng,jiē",
  "香貍": "xiāng,mái",
  "香蹬": "xiāng,dēng",
  "香郁地": "xiāng,yù,de",
  "香铺": "xiāng,pù",
  "香隂": "xiāng,yìn",
  "香露": "xiāng,lù",
  "香饽饽": "xiāng,bō,bo",
  "馚馧": "fén,yūn",
  "馰颡": "dì,sǎng",
  "𱅂莎": "sà,shā",
  "𫘝卒": "kuài,zú",
  "𫘝河": "kuài,hé",
  "𫘝烈": "kuài,liè",
  "𫘝牛": "kuài,niú",
  "𫘝疾": "kuài,jí",
  "𫘝雨": "kuài,yǔ",
  "𫘝雪": "kuài,xuě",
  "𫘝题": "kuài,tí",
  "𫘝马": "kuài,mǎ",
  "𫘟𱅗": "pǒ,é",
  "𫘤儿": "ái,ér",
  "𫘤冶": "ái,yě",
  "𫘤呐": "ái,nà",
  "𫘤女": "ái,nǚ",
  "𫘤女痴儿": "ái,nǚ,chī,ér",
  "𫘤女痴男": "ái,nǚ,chī,nán",
  "𫘤子": "ái,zǐ",
  "𫘤幼": "ái,yòu",
  "𫘤庸": "ái,yōng",
  "𫘤怯": "ái,qiè",
  "𫘤惰": "ái,duò",
  "𫘤憨": "ái,hān",
  "𫘤戆": "ái,gàng",
  "𫘤拙": "ái,zhuō",
  "𫘤昧": "ái,mèi",
  "𫘤汉": "ái,hàn",
  "𫘤滞": "ái,zhì",
  "𫘤痴": "ái,chī",
  "𫘤穉": "ái,zhì",
  "𫘤竖": "ái,shù",
  "𫘤童": "ái,tóng",
  "𫘤童钝夫": "ái,tóng,dùn,fū",
  "𫘤谑": "ái,xuè",
  "𫘤蹇": "ái,jiǎn",
  "𫘤野": "ái,yě",
  "𫘤钝": "ái,dùn",
  "𫘤颠": "ái,diān",
  "𬴃砉": "huō,huā",
  "驝𫘞": "tuō,tuó",
  "驝驼": "tuō,tuó",
  "马上房子": "mǎ,shàng,fáng,zi",
  "马仔": "mǎ,zǎi",
  "马价银子": "mǎ,jià,yín,zi",
  "马兀": "mǎ,wū",
  "马入华山": "mǎ,rù,huà,shān",
  "马冠": "mǎ,guān",
  "马勃菌": "mǎ,bó,jùn",
  "马勺子": "mǎ,sháo,zi",
  "马咽车阗": "mǎ,yān,chē,tián",
  "马圈": "mǎ,juàn",
  "马垛子": "mǎ,duǒ,zi",
  "马埳": "mǎ,kǎn",
  "马塞卢": "mǎ,sài,lú",
  "马头调": "mǎ,tóu,diào",
  "马夹": "mǎ,jiā",
  "马夹袋": "mǎ,jiā,dài",
  "马妳子": "mǎ,nǎi,zǐ",
  "马子": "mǎ,zi",
  "马尔地夫": "mǎ,ěr,de,fū",
  "马尔扎赫": "mǎ,ěr,zhā,hè",
  "马尾": "mǎ,yǐ",
  "马尾巴": "mǎ,yǐ,bā",
  "马尾松": "mǎ,yǐ,sōng",
  "马尾罗": "mǎ,yǐ,luó",
  "马尾萝": "mǎ,yǐ,luó",
  "马尾藻": "mǎ,yǐ,zǎo",
  "马尾蜂": "mǎ,yǐ,fēng",
  "马尾辫": "mǎ,yǐ,biàn",
  "马尾香": "mǎ,yǐ,xiāng",
  "马干": "mǎ,gàn",
  "马扎": "mǎ,zhá",
  "马扎子": "mǎ,zhá,zǐ",
  "马扎尔": "mǎ,zhā,ěr",
  "马扎尔语": "mǎ,zhā,ěr,yǔ",
  "马拉喀什": "mǎ,lā,kā,shí",
  "马拉地": "mǎ,lā,de",
  "马拉地语": "mǎ,lā,de,yǔ",
  "马日": "mǎ,mì",
  "马日事变": "mǎ,mì,shì,biàn",
  "马杆": "mǎ,gǎn",
  "马架子": "mǎ,jià,zi",
  "马槟榔": "mǎ,bīng,lang",
  "马歇尔计划": "mǎ,xiē,ěr,jì,huà",
  "马灯调": "mǎ,dēng,diào",
  "马相如": "mǎ,xiàng,rú",
  "马禁": "mǎ,jìn",
  "马䇲": "mǎ,jiā",
  "马糊": "mǎ,hu",
  "马累": "mǎ,lèi",
  "马约卡": "mǎ,yāo,kǎ",
  "马背": "mǎ,bèi",
  "马背学校": "mǎ,bèi,xué,xiào",
  "马背船唇": "mǎ,bèi,chuán,chún",
  "马莎": "mǎ,shā",
  "马萨诸塞": "mǎ,sà,zhū,sài",
  "马萨诸塞州": "mǎ,sà,zhū,sài,zhōu",
  "马蕃": "mǎ,fān",
  "马虎": "mǎ,hu",
  "马虎地": "mǎ,hǔ,de",
  "马虎地做": "mǎ,hǔ,de,zuò",
  "马褡子": "mǎ,dā,zi",
  "马褥子": "mǎ,rù,zi",
  "马调": "mǎ,diào",
  "马赫数": "mǎ,hè,shù",
  "马路沿儿": "mǎ,lù,yán,er",
  "马路牙子": "mǎ,lù,yá,zi",
  "马蹏": "mǎ,dì",
  "马蹏金": "mǎ,dì,jīn",
  "马蹬": "mǎ,dèng",
  "马适": "mǎ,shì",
  "马铺": "mǎ,pù",
  "马陵削树": "mǎ,líng,xuē,shù",
  "马鞭子": "mǎ,biān,zi",
  "马马虎虎": "mǎ,ma,hū,hū",
  "马驮子": "mǎ,duò,zǐ",
  "马驹子": "mǎ,jū,zi",
  "马齿徒长": "mǎ,chǐ,tú,zhǎng",
  "驭风幢": "yù,fēng,zhuàng",
  "驮垛": "duò,duǒ",
  "驮子": "duò,zi",
  "驮担": "duò,dān",
  "驮背": "tuó,bèi",
  "驮装": "duò,zhuāng",
  "驮载": "tuó,zǎi",
  "驯养地": "xùn,yǎng,de",
  "驯服地": "xùn,fú,de",
  "驯朴": "xùn,piáo",
  "驯翟": "xùn,zhái",
  "驯良地": "xùn,liáng,de",
  "驯顺地": "xùn,shùn,de",
  "驰𠡠": "chí,lài",
  "驱剽": "qū,piāo",
  "驱弹": "qū,dàn",
  "驱掠": "qū,lüě",
  "驱禁": "qū,jìn",
  "驱踧": "qū,dí",
  "驳子": "bó,zi",
  "驳弹": "bó,dàn",
  "驳查": "bó,zhā",
  "驳跞": "bó,luò",
  "驳面子": "bó,miàn,zi",
  "驴子": "lǘ,zi",
  "驴性子": "lǘ,xìng,zi",
  "驴驹子": "lǘ,jū,zi",
  "驹子": "jū,zi",
  "驺仆": "zōu,pú",
  "驺哄": "zōu,hǒng",
  "驺虞幢": "zōu,yú,zhuàng",
  "驻扎": "zhù,zhā",
  "驻毂": "zhù,gū",
  "驻色酒": "zhù,shǎi,jiǔ",
  "驻跸": "zhu,bi",
  "驼子": "tuó,zi",
  "驼背": "tuó,bèi",
  "驼背虫": "tuó,bèi,chóng",
  "驼背鲸": "tuó,bèi,jīng",
  "驼蹏鸡": "tuó,dì,jī",
  "驼载": "tuó,zǎi",
  "驽箭离弦": "nǔ,jiàn,lí,xián",
  "驽𦬼": "nú,ěr",
  "驽𬮴": "nú,ān",
  "驽马十舍": "nú,mǎ,shí,shè",
  "驾帆船": "jià,fān,chuán",
  "驾帖": "jià,tiē",
  "驾载": "jià,zǎi",
  "驿舍": "yì,shè",
  "驿铺": "yì,pù",
  "骀佗": "dài,tuó",
  "骀它": "dài,tā",
  "骀宕": "dài,dàng",
  "骀浩": "dài,hào",
  "骀背": "dài,bèi",
  "骀背鹤发": "dài,bèi,hè,fā",
  "骀荡": "dài,dàng",
  "骀藉": "tái,jí",
  "骀𫘞": "dài,tuó",
  "骀驽": "dài,nú",
  "骀骀": "dài,dài",
  "骁将": "xiāo,jiàng",
  "骂人地": "mà,rén,de",
  "骄傲地": "jiāo,ào,de",
  "骄傲地说": "jiāo,ào,de,shuō",
  "骄慠": "jiāo,ào",
  "骄慢地": "jiāo,màn,de",
  "骄横": "jiāo,hèng",
  "骄气": "jiāo,qi",
  "骄𬮴": "jiāo,ān",
  "骄𫘤": "jiāo,ái",
  "骄骜": "jiāo,ào",
  "骅骝开道": "hua,liu,kai,dao",
  "骆驼": "luò,tuo",
  "骆驼祥子": "luò,tuo,xiáng,zi",
  "骇吁": "hài,yù",
  "骈兴错出": "pián,xīng,cuò,chū",
  "骈干": "pián,gàn",
  "骈肩累足": "pián,jiān,lěi,zú",
  "骈肩累踵": "pián,jiān,lèi,zhǒng",
  "骈肩累迹": "pián,jiān,lěi,jì",
  "骈蕃": "pián,fān",
  "骈首就僇": "pián,shǒu,jiù,guī",
  "骈首就逮": "pián,shǒu,jiù,dǎi",
  "验数": "yàn,shù",
  "验血": "yàn,xuè",
  "骑士地": "qí,shì,de",
  "骑缝": "qí,fèng",
  "骑缝印": "qí,fèng,yìn",
  "骑缝章": "qí,fèng,zhāng",
  "骑脖子拉屎": "qí,bó,zi,lā,shǐ",
  "骑马带子": "qí,mǎ,dài,zi",
  "骑鹤更扬州": "qí,hè,gēng,yáng,zhōu",
  "骖仆": "cān,pú",
  "骗人地": "piàn,rén,de",
  "骗哄": "piàn,hǒng",
  "骗子": "piàn,zi",
  "骗子手": "piàn,zi,shǒu",
  "骚乱地": "sāo,luàn,de",
  "骚兴": "sāo,xīng",
  "骚动地": "sāo,dòng,de",
  "骚扰地": "sāo,rǎo,de",
  "骚掠": "sāo,lüě",
  "骜主": "ào,zhǔ",
  "骜亢": "ào,kàng",
  "骜侮": "ào,wǔ",
  "骜侻": "ào,tuì",
  "骜倨": "ào,jù",
  "骜嚣": "ào,xiāo",
  "骜夏": "ào,xià",
  "骜好": "ào,hǎo",
  "骜岸": "ào,àn",
  "骜很": "ào,hěn",
  "骜忽": "ào,hū",
  "骜悍": "ào,hàn",
  "骜愎": "ào,bì",
  "骜放": "ào,fàng",
  "骜杰": "ào,jié",
  "骜然": "ào,rán",
  "骜狠": "ào,hěn",
  "骜猾": "ào,huá",
  "骜肆": "ào,sì",
  "骜蹇": "ào,jiǎn",
  "骜辟": "ào,pì",
  "骜骜": "ào,ào",
  "骠信": "piào,xìn",
  "骠勇": "piào,yǒng",
  "骠国": "piào,guó",
  "骠悍": "piào,hàn",
  "骠骏": "piào,jùn",
  "骠骑": "piào,qí",
  "骡子": "luó,zi",
  "骡子似地": "luó,zi,shì,de",
  "骡子军": "luó,zi,jūn",
  "骡子营": "luó,zi,yíng",
  "骤兴": "zhòu,xīng",
  "骤雨地": "zhòu,yǔ,de",
  "骥骜": "jì,ào",
  "骨利干": "gǔ,lì,gàn",
  "骨嘟": "gū,dū",
  "骨头": "gú,tou",
  "骨头架子": "gú,tou,jià,zi",
  "骨头节儿": "gǔ,tou,jié,er",
  "骨头骨脑": "gú,tou,gǔ,nǎo",
  "骨子": "gǔ,zi",
  "骨子里": "gǔ,zi,lǐ",
  "骨干": "gǔ,gàn",
  "骨干网路": "gǔ,gàn,wǎng,lù",
  "骨朵": "gū,duǒ",
  "骨朵儿": "gū,duǒ,er",
  "骨朵子": "gū,duǒ,zǐ",
  "骨朵子直": "gū,duǒ,zǐ,zhí",
  "骨朵直": "gū,duǒ,zhí",
  "骨查脸": "gǔ,zhā,liǎn",
  "骨殖": "gǔ,shi",
  "骨殖匣": "gǔ,shi,xiá",
  "骨牌效应": "gǔ,pái,xiào,yìng",
  "骨相学地": "gǔ,xiāng,xué,de",
  "骨碌": "gū,lù",
  "骨碌子": "gū,lù,zǐ",
  "骨碌碌": "gū,lù,lù",
  "骨碌碌地": "gū,lù,lù,de",
  "骨董铺": "gǔ,dǒng,pù",
  "骨血": "gǔ,xuè",
  "骨𫏋": "gǔ,jué",
  "骨都侯": "gǔ,dōu,hòu",
  "骫曲": "wěi,qū",
  "骫靡": "wěi,mǐ",
  "骴禁": "cī,jìn",
  "髑髅地": "dú,lóu,de",
  "高个儿": "gāo,gè,er",
  "高个子": "gāo,gè,zi",
  "高丽": "gāo,lí",
  "高丽伎": "gāo,lí,jì",
  "高丽八万大藏经": "gāo,lí,bā,wàn,dà,zàng,jīng",
  "高丽参": "gāo,lí,shēn",
  "高丽大藏经": "gāo,lí,dà,zàng,jīng",
  "高丽朝": "gāo,lí,cháo",
  "高丽棒子": "gāo,lí,bàng,zi",
  "高丽王朝": "gāo,lí,wáng,cháo",
  "高丽纸": "gāo,lí,zhǐ",
  "高丽舞": "gāo,lí,wǔ",
  "高丽菜": "gāo,lí,cài",
  "高义薄云": "gāo,yì,bó,yún",
  "高傲地": "gāo,ào,de",
  "高傲地说": "gāo,ào,de,shuō",
  "高兴地": "gāo,xìng,de",
  "高兴地从": "gāo,xìng,de,cóng",
  "高兴地喊": "gāo,xìng,de,hǎn",
  "高兴地大叫": "gāo,xìng,de,dà,jiào",
  "高兴地大笑": "gāo,xìng,de,dà,xiào",
  "高兴地接过": "gāo,xìng,de,jiē,guò",
  "高兴地离开": "gāo,xìng,de,lí,kāi",
  "高兴地笑": "gāo,xìng,de,xiào",
  "高兴地说": "gāo,xìng,de,shuō",
  "高兴地说道": "gāo,xìng,de,shuō,dào",
  "高兴地走了": "gāo,xìng,de,zǒu,le",
  "高冠博带": "gāo,guān,bó,dài",
  "高分子": "gāo,fèn,zǐ",
  "高分子功能材料": "gāo,fèn,zǐ,gōng,néng,cái,liào",
  "高分子化合物": "gāo,fèn,zǐ,huà,hé,wù",
  "高分子化工": "gāo,fèn,zǐ,huà,gōng",
  "高利贷地": "gāo,lì,dài,de",
  "高勾丽": "gāo,gōu,lí",
  "高卬": "gāo,áng",
  "高原反应": "gāo,yuán,fǎn,yìng",
  "高句丽": "gāo,gōu,lí",
  "高句骊": "gāo,gōu,lí",
  "高吭": "gāo,kēng",
  "高声地": "gāo,shēng,de",
  "高声地说话": "gāo,shēng,de,shuō,huà",
  "高夐": "gāo,xuàn",
  "高大地": "gāo,dà,de",
  "高头": "gāo,tou",
  "高密侯": "gāo,mì,hòu",
  "高尚地": "gāo,shàng,de",
  "高山冠": "gāo,shān,guān",
  "高山反应": "gāo,shān,fǎn,yìng",
  "高嶷": "gāo,nì",
  "高帆": "gāo,fān",
  "高帽子": "gāo,mào,zi",
  "高干": "gāo,gàn",
  "高干大": "gāo,gàn,dà",
  "高当铺": "gāo,dàng,pù",
  "高情逸兴": "gāo,qíng,yì,xīng",
  "高情逸态": "gāo,qíng,yì,tai",
  "高挑": "gāo,tiǎo",
  "高挑儿": "gāo,tiǎo,ér",
  "高挑子": "gāo,tiǎo,zi",
  "高效地": "gāo,xiào,de",
  "高数": "gāo,shù",
  "高更": "gāo,gēng",
  "高曾": "gāo,zēng",
  "高清数字电视": "gāo,qīng,shù,zì,diàn,shì",
  "高着": "gāo,zhāo",
  "高着儿": "gāo,zhāo,ér",
  "高知": "gāo,zhì",
  "高等代数": "gāo,děng,dài,shù",
  "高簳": "gāo,gàn",
  "高粱帽子": "gāo,liáng,mào,zi",
  "高絙伎": "gāo,gēng,jì",
  "高絙百尺": "gāo,gēng,bǎi,chǐ",
  "高絜": "gāo,jié",
  "高维代数簇": "gāo,wéi,dài,shù,cù",
  "高脂血症": "gāo,zhī,xuè,zhèng",
  "高血压": "gāo,xuè,yā",
  "高血糖": "gāo,xuè,táng",
  "高血脂": "gāo,xuè,zhī",
  "高调": "gāo,diào",
  "高调照片": "gāo,diào,zhào,piān",
  "高质量地完成了": "gāo,zhì,liàng,de,wán,chéng,le",
  "高跟儿": "gāo,gēn,er",
  "高跷鹬": "gāo,qiào,yù",
  "高蹶": "gāo,juě",
  "高𫏋": "gāo,jué",
  "高采烈地": "gāo,cǎi,liè,de",
  "高铁血红蛋白": "gāo,tiě,xuè,hóng,dàn,bái",
  "高雅地": "gāo,yǎ,de",
  "高露洁": "gāo,lù,jié",
  "高音喇叭": "gāo,yīn,lǎ,ba",
  "高风劲节": "gāo,fēng,jìng,jié",
  "高高兴兴": "gāo,gāo,xìng,xīng",
  "高高兴兴地": "gāo,gāo,xìng,xīng,de",
  "高高地": "gāo,gāo,de",
  "高高手儿": "gāo,gāo,shǒu,er",
  "髡削": "kūn,xuē",
  "髣髴": "fǎng,fèi",
  "髦髿": "máo,suō",
  "髫冠": "tiáo,guān",
  "髯口": "rán,kou",
  "髲鬄": "bì,dí",
  "髴髣": "fèi,fǎng",
  "髴髴": "fèi,fèi",
  "髴髻": "fèi,jì",
  "髿髿": "suō,suō",
  "髿𩭹": "suō,sān",
  "鬀发": "tì,fà",
  "鬀发工": "tì,fà,gōng",
  "鬄匠": "dí,jiàng",
  "鬄发": "dí,fā",
  "鬈发": "quán,fà",
  "鬒发": "zhěn,fà",
  "鬓发": "bìn,fà",
  "𩭹髿": "sān,suō",
  "鬟露": "huán,lù",
  "鬲咽": "gé,yān",
  "鬻弹": "yù,dàn",
  "鬻文为生": "yù,wén,wéi,shēng",
  "鬻矛誉楯": "yù,máo,yù,dùn",
  "鬻鸡为凤": "yù,jī,wéi,fèng",
  "鬼乐官": "guǐ,yuè,guān",
  "鬼使神差": "guǐ,shǐ,shén,chāi",
  "鬼侯": "guǐ,hòu",
  "鬼勾当": "guǐ,gòu,dàng",
  "鬼名堂": "guǐ,míng,tang",
  "鬼头": "guǐ,tou",
  "鬼头蛤蟆眼": "guǐ,tóu,há,má,yǎn",
  "鬼子": "guǐ,zi",
  "鬼子姜": "guǐ,zi,jiāng",
  "鬼子孙": "guǐ,zi,sūn",
  "鬼子母": "guǐ,zi,mǔ",
  "鬼弹": "guǐ,dàn",
  "鬼打更": "guǐ,dǎ,gēng",
  "鬼推磨": "guǐ,tuī,mò",
  "鬼撇": "guǐ,piě",
  "鬼故事": "guǐ,gù,shi",
  "鬼朴": "guǐ,piáo",
  "鬼跌记": "guǐ,diē,jì",
  "鬼门上占卦": "guǐ,mén,shàng,zhān,guà",
  "鬼风疙瘩": "guǐ,fēng,gē,dā",
  "鬼馒头": "guǐ,mán,tou",
  "魁瘣": "kuí,lěi",
  "魁累": "kuí,lèi",
  "魂不守舍": "hún,bù,shǒu,shè",
  "魂不著体": "hún,bù,zhuó,tǐ",
  "魂干": "hún,gàn",
  "魂飞魄丧": "hún,fēi,pò,sāng",
  "魂飞魄飏": "hún,fēi,pò,shān",
  "魅力地": "mèi,lì,de",
  "魆魆": "xù,xù",
  "魏堤": "wèi,dī",
  "魏王堤": "wèi,wáng,dī",
  "魏瓦地": "wèi,wǎ,de",
  "魏都": "wèi,dū",
  "魏都区": "wèi,dū,qū",
  "魔侯罗": "mó,hòu,luó",
  "魔术般地": "mó,shù,bān,de",
  "魔法似地": "mó,fǎ,shì,de",
  "魔都": "mó,dū",
  "魔难": "mó,nàn",
  "魔高一丈": "mó,gāo,yí,zhàng",
  "魔鬼似地": "mó,guǐ,shì,de",
  "魔鬼地": "mó,guǐ,de",
  "魔鬼粘": "mó,guǐ,zhān",
  "魔鬼般地": "mó,guǐ,bān,de",
  "𱇙冠": "shěn,guān",
  "𱇙角冠子": "shěn,jiǎo,guàn,zi",
  "𱇐断": "wǎn,duàn",
  "𫚖刀鱼": "jì,dāo,yú",
  "𫚖力": "jì,lì",
  "𫚖子": "jì,zǐ",
  "𫚖窳": "jì,yǔ",
  "𫚖酱": "jì,jiàng",
  "鲞铺": "xiǎng,pù",
  "𮬜科": "qí,kē",
  "𱇳𱇒": "suō,bǐ",
  "𫚙𱇒": "pū,bǐ",
  "鱳得": "lì,de",
  "鱼丽于罶": "yú,lí,yú,liǔ",
  "鱼丽陈": "yú,lí,chén",
  "鱼卷": "yú,juàn",
  "鱼呗": "yú,bài",
  "鱼封雁帖": "yú,fēng,yàn,tiē",
  "鱼封鴈帖": "yú,fēng,yàn,tiē",
  "鱼帘子": "yú,lián,zi",
  "鱼更": "yú,gēng",
  "鱼杆": "yú,gǎn",
  "鱼枕冠": "yú,zhěn,guān",
  "鱼栅": "yú,shān",
  "鱼槛": "yú,kǎn",
  "鱼水相懽": "yú,shuǐ,xiāng,guàn",
  "鱼游燋釜": "yú,yóu,zhuó,fǔ",
  "鱼潦": "yú,liáo",
  "鱼片儿": "yú,piàn,er",
  "鱼牙行": "yú,yá,háng",
  "鱼矼": "yú,qiāng",
  "鱼类学地": "yú,lèi,xué,de",
  "鱼肚": "yú,dǔ",
  "鱼肚白": "yú,dǔ,bái",
  "鱼薧": "yú,kǎo",
  "鱼钩儿": "yú,gōu,er",
  "鱼露": "yú,lù",
  "鱼鞞": "yú,bǐ",
  "鱼𱇙冠": "yú,shěn,guān",
  "鱼鲏": "yú,pī",
  "鲁佛尔宫": "lǔ,fú,ěr,gōng",
  "鲁削": "lǔ,xuē",
  "鲁斤燕削": "lǔ,jīn,yàn,xuē",
  "鲁朴": "lǔ,piáo",
  "鲁殿灵光": "lú,diàn,líng,guāng",
  "鲁莽地": "lǔ,mǎng,de",
  "鲁钝地": "lǔ,dùn,de",
  "鲁难未已": "lǔ,nàn,wèi,yǐ",
  "鲌鲜": "bà,xiān",
  "鲍耶": "bào,yē",
  "鲍舍": "bào,shè",
  "鲎帆": "hòu,fān",
  "鲐背": "tái,bèi",
  "鲑冠": "guī,guān",
  "鲑珍": "xié,zhēn",
  "鲗鱼涌": "zéi,yú,chōng",
  "鲙楯": "kuài,dùn",
  "鲜为人知": "xiǎn,wéi,rén,zhī",
  "鲜克有终": "xiǎn,kè,yǒu,zhōng",
  "鲜冠": "xiān,guān",
  "鲜卑奴": "xiān,bì,nú",
  "鲜卑山": "xiān,bì,shān",
  "鲜少": "xiǎn,shǎo",
  "鲜明地": "xiān,míng,de",
  "鲜有": "xiǎn,yǒu",
  "鲜絜": "xiān,jié",
  "鲜腆": "xiǎn,tiǎn",
  "鲜艳地": "xiān,yàn,de",
  "鲜薧": "xiān,kǎo",
  "鲜血": "xiān,xuè",
  "鲜血淋漓": "xiān,xuè,lín,lí",
  "鲜见": "xiǎn,jiàn",
  "鲠咽": "gěng,yān",
  "鲠朴": "gěng,piáo",
  "鲭鲊": "zhēng,zhǎ",
  "鲵𲍑": "ní,miáo",
  "鲸呿": "jīng,qù",
  "鲸背": "jīng,bèi",
  "鲽离鹣背": "dié,lí,jiān,bèi",
  "鳀冠": "tí,guān",
  "鳃鳃": "xǐ,xǐ",
  "鳄鱼夹": "è,yú,jiā",
  "鳅蝥": "qiū,móu",
  "鳅𫚖": "qiū,jì",
  "鳌掷鲸呿": "áo,zhì,jīng,qù",
  "鳌禁": "áo,jìn",
  "鳌背": "áo,bèi",
  "鳌背负山": "áo,bèi,fù,shān",
  "鳏处": "guān,chǔ",
  "鳏寡孤惸": "guān,guǎ,gū,dì",
  "鳏寡惸独": "guān,guǎ,gū,dú",
  "鳑𱇒": "páng,bǐ",
  "鳑𱇒树": "páng,bǐ,shù",
  "鳑𱇒鲗": "páng,bǐ,zéi",
  "鳖咳": "biē,hāi",
  "鳖拗": "biē,niù",
  "鳖盖子": "biē,gài,zi",
  "鳜豚": "jué,tún",
  "鳜𫚡": "jué,zhǒu",
  "鳝更": "shàn,gēng",
  "鳣舍": "zhān,shè",
  "鳪衣": "bǔ,yī",
  "𱉾𱉌": "jùn,yí",
  "𫛳舍": "fú,shè",
  "𫛵居": "jué,jū",
  "𫛵𱊌": "jué,jū",
  "𫛵鸠": "jué,jiū",
  "𫛵鸼": "jué,zhōu",
  "𱊬琟": "zhú,wéi",
  "𱊬𱉍": "zhú,yù",
  "𱉌冠": "yí,guān",
  "𱉌𱉾冠": "yí,jùn,guān",
  "䴙𱊕": "bì,tí",
  "䴙鹈": "bì,tí",
  "䴙鹈刀": "bì,tí,dāo",
  "䴙鹈剑": "bì,tí,jiàn",
  "䴙鹈泉": "bì,tí,quán",
  "䴙鹈膏": "bì,tí,gāo",
  "鸟人": "diǎo,rén",
  "鸟儿": "niǎo,er",
  "鸟占": "niǎo,zhān",
  "鸟嘌呤": "niǎo,piào,lìng",
  "鸟帑": "niǎo,tǎng",
  "鸟折": "niǎo,shé",
  "鸟背": "niǎo,bèi",
  "鸟跕": "niǎo,dié",
  "鸟闹": "diǎo,nào",
  "鸠僝": "jiū,chán",
  "鸠居鹊巢": "jiū,jú,què,cháo",
  "鸠摩罗什": "jiū,mó,luó,shí",
  "鸡内金": "jī,nà,jīn",
  "鸡冠": "jī,guān",
  "鸡冠区": "jī,guān,qū",
  "鸡冠子": "jī,guān,zi",
  "鸡冠花": "jī,guān,huā",
  "鸡子儿": "jī,zǐ,er",
  "鸡巴": "jī,ba",
  "鸡扒": "jī,pá",
  "鸡枞": "jī,zōng",
  "鸡爪子": "jī,zhuǎ,zi",
  "鸡皮栗子": "jī,pí,lì,zi",
  "鸡皮疙瘩": "jī,pí,gē,dā",
  "鸡皮鹤发": "jī,pí,hè,fà",
  "鸡翘": "jī,qiào",
  "鸡胸龟背": "jī,xiōng,guī,bèi",
  "鸡舍": "jī,shè",
  "鸡蛋壳儿": "jī,dàn,ké,er",
  "鸡蛋碰石头": "jī,dàn,pèng,shí,tou",
  "鸡蛋里挑骨头": "jī,dàn,li,tiāo,gǔ,tou",
  "鸡血藤": "jī,xuè,téng",
  "鸡豆子": "jī,dòu,zi",
  "鸡鸣馌耕": "jī,míng,gǒu,gēng",
  "鸢跕": "yuān,dié",
  "鸣凤朝阳": "míng,fèng,zhāo,yáng",
  "鸣哮": "míng,xiāo",
  "鸣弹": "míng,dàn",
  "鸣毂": "míng,gū",
  "鸣锣喝道": "míng,luó,hè,dào",
  "鸣鞞": "míng,bǐ",
  "鸣骹": "míng,xiāo",
  "鸦头": "yā,tou",
  "鸦头袜": "yā,tou,wà",
  "鸦孃": "yā,ráng",
  "鸦胆子": "yā,dǎn,zi",
  "鸦轧": "yā,zhá",
  "鸦飞不到山": "yā,fēi,bú,dào,shān",
  "鸦鹘": "yā,hú",
  "鸦鹘关": "yā,hú,guān",
  "鸦鹘石": "yā,hú,shí",
  "鸧鸡": "qiāng,jī",
  "鸪鸪地叫": "gū,gū,de,jiào",
  "鸬鹚句当": "lú,cí,gòu,dāng",
  "鸬鹚咳": "lú,cí,hāi",
  "鸭头丸帖": "yā,tóu,wán,tiē",
  "鸭子": "yā,zi",
  "鸭子儿": "yā,zǐ,er",
  "鸭绿": "yā,lù",
  "鸭绿水": "yā,lù,shuǐ",
  "鸭绿江": "yā,lù,jiāng",
  "鸭馄饨": "yā,hún,tun",
  "鸳鸯板子": "yuān,yāng,bǎn,zi",
  "鸳鸯蝴蝶": "yuān,yang,hú,dié",
  "鸳鸯蝴蝶派": "yuān,yang,hú,dié,pài",
  "鸳鸯锅": "yuān,yang,guō",
  "鸷扞": "zhì,gǎn",
  "鸷骜": "zhì,ào",
  "鸷鸟累百": "zhì,niǎo,lèi,bǎi",
  "鸹捋": "guā,lǚ",
  "鸽子": "gē,zi",
  "鸽子笼": "gē,zi,lóng",
  "鸾凤和鸣": "luán,fèng,hè,míng",
  "鸾只凤单": "luán,zhī,fèng,dān",
  "鸾咽鹤唳": "luán,yān,hè,lì",
  "鸾堤": "luán,dī",
  "鸾孤凤只": "luán,gū,fèng,zhī",
  "鸾幢": "luán,zhuàng",
  "鸾歌凤吹": "luán,gē,fèng,chuí",
  "鸾毂": "luán,gū",
  "鸾跄": "luán,qiàng",
  "鸾𫐌": "luán,pēng",
  "鸿朴": "hóng,piáo",
  "鸿渐于干": "hóng,jiàn,yú,gàn",
  "鸿篇巨着": "hóng,piān,jù,zhe",
  "鸿𫄡": "hóng,tóng",
  "鸿芘": "hóng,pí",
  "鸿衣羽裳": "hóng,yī,yǔ,shang",
  "鸿郄陂": "hóng,xì,bēi",
  "鸿雁行": "hóng,yàn,háng",
  "鸿露": "hóng,lù",
  "鹃血": "juān,xuè",
  "鹄的": "gǔ,dì",
  "鹅帖": "é,tiē",
  "鹅梨旋风髻": "é,lí,xuàn,fēng,jì",
  "鹅梨角儿": "é,lí,jué,ér",
  "鹅群帖": "é,qún,tiē",
  "鹊尾冠": "què,wěi,guān",
  "鹊血": "què,xuè",
  "鹊血弓": "què,xuè,gōng",
  "鹌鹑馉饳儿": "ān,chún,gǔ,duò,er",
  "鹏抟鹢退": "péng,tuán,huā,tuì",
  "鹏背": "péng,bèi",
  "鹑居𬆮饮": "chún,jú,kòu,yǐn",
  "鹑贲": "chún,bēn",
  "鹓禁": "yuān,jìn",
  "鹖冠": "hé,guān",
  "鹖鸟冠": "hé,niǎo,guān",
  "鹖鸡冠": "hé,jī,guān",
  "鹘人": "hú,rén",
  "鹘仑": "hú,lún",
  "鹘仑吞": "hú,lún,tūn",
  "鹘仑吞枣": "hú,lún,tūn,zǎo",
  "鹘伶": "hú,líng",
  "鹘伶声嗽": "hú,líng,shēng,sòu",
  "鹘兀": "hú,wū",
  "鹘入鸦群": "hú,rù,yā,qún",
  "鹘军": "hú,jūn",
  "鹘响": "hú,xiǎng",
  "鹘嘲": "hú,cháo",
  "鹘囵": "hú,lún",
  "鹘坊": "hú,fāng",
  "鹘城猿洞": "hú,chéng,yuán,dòng",
  "鹘尾叶": "hú,wěi,yè",
  "鹘打雁": "hú,dǎ,yàn",
  "鹘打鹅": "hú,dǎ,é",
  "鹘拳": "hú,quán",
  "鹘握": "hú,wò",
  "鹘没": "hú,méi",
  "鹘沦": "hú,lún",
  "鹘眼": "hú,yǎn",
  "鹘睛": "hú,jīng",
  "鹘石": "hú,shí",
  "鹘突": "hú,tū",
  "鹘突帐": "hú,tū,zhàng",
  "鹘翅": "hú,chì",
  "鹘臭": "hú,chòu",
  "鹘莽": "hú,mǎng",
  "鹘落": "hú,luò",
  "鹘起": "hú,qǐ",
  "鹘蹄": "hú,tí",
  "鹘蹏": "hú,dì",
  "鹘雕": "hú,diāo",
  "鹘露蹄": "hú,lù,tí",
  "鹘饼": "hú,bǐng",
  "鹘𱊖": "hú,tú",
  "鹘鸠": "gú,jiū",
  "鹘鸠氏": "gú,jiū,shì",
  "鹘鸰": "hú,líng",
  "鹘鸰眼": "hú,líng,yǎn",
  "鹘鸼": "gú,zhōu",
  "鹡原": "jí,yuán",
  "鹡鸰": "jí,líng",
  "鹡鸰原": "jí,líng,yuán",
  "鹡鸰在原": "jí,líng,zài,yuán",
  "鹡鸰科": "jí,líng,kē",
  "鹤发": "hè,fà",
  "鹤发松姿": "hè,fà,sōng,zī",
  "鹤发童颜": "hè,fà,tóng,yán",
  "鹤发翁": "hè,fà,wēng",
  "鹤发鸡皮": "hè,fà,jī,pí",
  "鹤嘴镐": "hè,zuǐ,hào",
  "鹤处鸡群": "hè,chǔ,jī,qún",
  "鹤林玉露": "hè,lín,yù,lù",
  "鹤栅": "hè,shān",
  "鹤禁": "hè,jìn",
  "鹤背": "hè,bèi",
  "鹤背扬州": "hè,bèi,yáng,zhōu",
  "鹤𫐌": "hè,pēng",
  "鹤露": "hè,lù",
  "鹬冠": "yù,guān",
  "鹬蚌持争": "yù,bàng,xiāng,zhēng",
  "鹰手营子矿": "yīng,shǒu,yíng,zi,kuàng",
  "鹰手营子矿区": "yīng,shǒu,yíng,zi,kuàng,qū",
  "鹰爪子": "yīng,zhuǎ,zi",
  "鹰爪翻子拳": "yīng,zhuǎ,fān,zi,quán",
  "鹰狗处": "yīng,gǒu,chǔ",
  "鹰背狗": "yīng,bèi,gǒu",
  "鹰觑鹘望": "yīng,qù,hú,wàng",
  "鹰鹘": "yīng,hú",
  "鹾䇲": "cuó,jiā",
  "鹿为马": "lù,wéi,mǎ",
  "鹿冠": "lù,guān",
  "鹿卢𫏋": "lù,lú,jué",
  "鹿头栅": "lù,tóu,shān",
  "鹿栅": "lù,shān",
  "鹿死谁手": "lù,sǐ,shéi,shǒu",
  "鹿皮冠": "lù,pí,guān",
  "鹿皮夹": "lù,pí,jiā",
  "鹿茤": "lù,duō",
  "鹿蠡": "lù,lí",
  "麃摇": "biāo,yáo",
  "麃邑": "biāo,yì",
  "麃鹿": "biāo,lù",
  "麃麃": "biāo,biāo",
  "麇至沓来": "qún,zhì,tà,lái",
  "麇载": "jūn,zǎi",
  "麇集": "qún,jí",
  "麋侯": "mí,hòu",
  "麙羊": "yán,yáng",
  "麟角凤觜": "lín,jiǎo,fèng,zuǐ",
  "麟角斗": "lín,jué,dòu",
  "麟趾𬡇蹏": "lín,zhǐ,niǎo,dì",
  "麤强": "cū,jiāng",
  "麤朴": "cū,piáo",
  "麤缞斩": "cū,shuāi,zhǎn",
  "麤缪": "cū,miù",
  "麤谩": "cū,màn",
  "麤露": "cū,lù",
  "麦克白夫人": "mài,kè,bái,fū,ren",
  "麦子": "mài,zi",
  "麦当劳叔叔": "mài,dāng,láo,shū,shu",
  "麦当娜": "mài,dāng,nà",
  "麦曲": "mài,qū",
  "麦盖提": "mài,gě,tí",
  "麦盖提县": "mài,gě,tí,xiàn",
  "麦秆儿": "mài,gǎn,er",
  "麦茬儿": "mài,chá,er",
  "麸子": "fū,zi",
  "麻俐": "má,li",
  "麻利": "má,li",
  "麻力": "má,li",
  "麻叶子": "má,yè,zi",
  "麻地敖包": "má,de,áo,bāo",
  "麻姑搔背": "má,gū,sāo,bèi",
  "麻子": "má,zi",
  "麻将": "má,jiàng",
  "麻将牌": "má,jiàng,pái",
  "麻扎": "má,zhā",
  "麻扎刀": "má,zhā,dāo",
  "麻扎大砍刀": "má,zhā,dà,kǎn,dāo",
  "麻木地": "má,mù,de",
  "麻杆": "má,gǎn",
  "麻查": "má,zhā",
  "麻烦": "má,fan",
  "麻烦地": "má,fán,de",
  "麻秆儿": "má,gǎn,er",
  "麻秸": "má,jí",
  "麻累": "má,lèi",
  "麻絙": "má,gēng",
  "麻𰬜": "má,wèn",
  "麻葛糕": "má,gě,gāo",
  "麻袋片儿": "má,dài,piān,er",
  "麻麻": "mā,ma",
  "麻麻亮": "mā,ma,liàng",
  "麻麻糊糊": "mā,ma,hū,hū",
  "麻麻雨": "mā,ma,yǔ",
  "麻麻黑": "mā,ma,hēi",
  "麾之即去": "huī,zhī,jì,qù",
  "麾幢": "huī,zhuàng",
  "𱋱缊": "fén,wēn",
  "黄兴": "huáng,xīng",
  "黄冠": "huáng,guān",
  "黄冠体": "huáng,guān,tǐ",
  "黄冠啄木鸟": "huáng,guān,zhuó,mù,niǎo",
  "黄南藏族自治州": "huáng,nán,zàng,zú,zì,zhì,zhōu",
  "黄卷": "huáng,juàn",
  "黄卷幼妇": "huáng,juàn,yòu,fù",
  "黄卷青灯": "huáng,juàn,qīng,dēng",
  "黄历": "huáng,li",
  "黄发": "huáng,fà",
  "黄发儿齿": "huáng,fà,ér,chǐ",
  "黄发台背": "huáng,fā,tái,bèi",
  "黄发垂髫": "huáng,fà,chuí,tiáo",
  "黄发期": "huáng,fà,qī",
  "黄发骀背": "huáng,fā,dài,bèi",
  "黄发鲐背": "huáng,fā,tái,bèi",
  "黄口儿": "huáng,kǒu,er",
  "黄台瓜蔓": "huáng,tái,guā,wàn",
  "黄喉地莺": "huáng,hóu,de,yīng",
  "黄嘌呤": "huáng,piào,lìng",
  "黄土不露天": "huáng,tǔ,bù,lù,tiān",
  "黄头鹡鸰": "huáng,tóu,jí,líng",
  "黄妳": "huáng,nǎi",
  "黄婆地": "huáng,pó,de",
  "黄帝八十一难经": "huáng,dì,bā,shí,yī,nàn,jīng",
  "黄带子": "huáng,dài,zi",
  "黄昏地": "huáng,hūn,de",
  "黄晕": "huáng,yùn",
  "黄曲霉": "huáng,qū,méi",
  "黄曲霉毒素": "huáng,qū,méi,dú,sù",
  "黄曲霉菌": "huáng,qū,méi,jūn",
  "黄柏": "huáng,bò",
  "黄梁一梦": "huáng,liáng,yí,mèng",
  "黄毛丫头": "huáng,máo,yā,tou",
  "黄潦": "huáng,liáo",
  "黄澄澄": "huáng,dèng,dèng",
  "黄煞煞": "huáng,shà,shà",
  "黄爪隼": "huáng,zhuǎ,sǔn",
  "黄犊舍": "huáng,dú,shè",
  "黄狮子": "huáng,shī,zi",
  "黄瘅": "huáng,dān",
  "黄皮子": "huáng,pí,zi",
  "黄祇": "huáng,qí",
  "黄穰穰": "huáng,rǎng,rǎng",
  "黄米头儿": "huáng,mǐ,tou,er",
  "黄胖日头": "huáng,pàng,rì,tou",
  "黄腹冠鹎": "huáng,fù,guān,bēi",
  "黄花姑娘": "huáng,huā,gū,niang",
  "黄花岗七十二烈士": "huáng,huā,gāng,qī,shí,èr,liè,shì",
  "黄葛": "huáng,gě",
  "黄葛峡": "huáng,gě,xiá",
  "黄葛树": "huáng,gě,shù",
  "黄藕冠": "huáng,ǒu,guān",
  "黄血盐": "huáng,xuè,yán",
  "黄褐侯": "huáng,hè,hòu",
  "黄金弹": "huáng,jīn,dàn",
  "黄金阙": "huáng,jīn,què",
  "黄钟调": "huáng,zhōng,diào",
  "黄钻": "huáng,zuàn",
  "黄铜地": "huáng,tóng,de",
  "黄陂": "huáng,pí",
  "黄陂区": "huáng,pí,qū",
  "黄院子": "huáng,yuàn,zi",
  "黄雀伺蝉": "huáng,què,sì,chán",
  "黄面老子": "huáng,miàn,lǎo,zi",
  "黄馘": "huáng,xù",
  "黄香扇枕": "huáng,xiāng,shān,zhěn",
  "黄骢少年": "huáng,cōng,shào,nián",
  "黄鹘": "huáng,hú",
  "黄鹡鸰": "huáng,jí,líng",
  "黉舍": "hóng,shè",
  "黉门监生": "hóng,mén,jiàn,shēng",
  "黍累": "shǔ,lèi",
  "黎曼曲面": "lí,màn,qū,miàn",
  "黏儿": "nián,er",
  "黏忒忒": "nián,tuī,tuī",
  "黏涎": "nián,xian",
  "黏涎子": "nián,xián,zi",
  "黏皮着骨": "nián,pí,zhe,gǔ",
  "黏着": "nián,zhe",
  "黏答答": "nián,dā,dā",
  "黏糊糊": "nián,hū,hū",
  "黏附地": "nián,fù,de",
  "黏黏糊糊": "nián,nián,hū,hū",
  "黑丧着脸": "hēi,sàng,zhe,liǎn",
  "黑册子": "hēi,cè,zi",
  "黑冠山雀": "hēi,guān,shān,què",
  "黑冠椋鸟": "hēi,guān,liáng,niǎo",
  "黑冠长臂猿": "hēi,guān,cháng,bì,yuán",
  "黑冠鹃隼": "hēi,guān,juān,sǔn",
  "黑冠黄鹎": "hēi,guān,huáng,bēi",
  "黑匣子": "hēi,xiá,zi",
  "黑咕隆咚": "hēi,gū,lōng,dōng",
  "黑喽喽": "hēi,lou,lou",
  "黑塞哥维那": "hēi,sài,gē,wéi,nà",
  "黑奴吁天录": "hēi,nú,yù,tiān,lù",
  "黑旋风": "hēi,xuàn,fēng",
  "黑晻晻": "hēi,ǎn,ǎn",
  "黑更半夜": "hēi,gēng,bàn,yè",
  "黑汗王朝": "hēi,hán,wáng,cháo",
  "黑潦": "hēi,liáo",
  "黑煞": "hēi,shà",
  "黑猩猩": "hēi,xīng,xing",
  "黑甜一觉": "hēi,tián,yī,jiào",
  "黑白相间": "hēi,bái,xiāng,jiàn",
  "黑瞎子": "hēi,xiā,zi",
  "黑瞎子岛": "hēi,xiā,zi,dǎo",
  "黑箱子": "hēi,xiāng,zi",
  "黑糁糁": "hēi,shēn,shēn",
  "黑糊糊": "hēi,hū,hū",
  "黑肚子": "hēi,dǔ,zi",
  "黑背": "hēi,bèi",
  "黑背信天翁": "hēi,bèi,xìn,tiān,wēng",
  "黑背燕尾": "hēi,bèi,yàn,wěi",
  "黑茶藨子": "hēi,chá,biāo,zi",
  "黑莓子": "hēi,méi,zi",
  "黑血": "hēi,xuè",
  "黑衣宰相": "hēi,yī,zǎi,xiàng",
  "黑车子": "hēi,chē,zi",
  "黑𬮴": "hēi,ān",
  "黑骨头": "hēi,gú,tou",
  "黑骨胧东": "hēi,gu,lōng,dōng",
  "黑麻麻": "hēi,mā,ma",
  "黑黝黝地": "hēi,yǒu,yǒu,de",
  "黕黮": "dǎn,dǎn",
  "默想地": "mò,xiǎng,de",
  "默揣": "mò,chuāi",
  "默数": "mò,shù",
  "默认地": "mò,rèn,de",
  "默默地": "mò,mò,de",
  "默默地想": "mò,mò,de,xiǎng",
  "默默地承受": "mò,mò,de,chéng,shòu",
  "默默地流下了眼泪": "mò,mò,de,liú,xià,le,yǎn,lèi",
  "默默地看着": "mò,mò,de,kàn,zhe",
  "默默地离去": "mò,mò,de,lí,qù",
  "默默无闻地奉献": "mò,mò,wú,wén,de,fèng,xiàn",
  "黛安娜": "dài,ān,nà",
  "黜位削地": "chù,wèi,xuē,dì",
  "黜削": "chù,xuē",
  "黝暗地": "yǒu,àn,de",
  "黝贲": "yǒu,bēn",
  "黠骜": "xiá,ào",
  "黤黮": "yǎn,dǎn",
  "黧黮": "lí,dǎn",
  "黩扎": "dú,zhā",
  "黭黮": "yǎn,dǎn",
  "黮昏": "dǎn,hūn",
  "黮暗": "dǎn,àn",
  "黮浊": "dǎn,zhuó",
  "黮漶": "dǎn,huàn",
  "黮袍": "dǎn,páo",
  "黮𬮴": "dǎn,àn",
  "黮黕": "dǎn,dǎn",
  "黮黤": "dǎn,yǎn",
  "黮黭": "dǎn,yǎn",
  "黮黮": "dǎn,dǎn",
  "黮黯": "dǎn,àn",
  "黯然地": "àn,rán,de",
  "黯𬮴": "àn,ān",
  "黯黮": "àn,dǎn",
  "黯黮滩": "àn,dǎn,tān",
  "黼冔": "fǔ,xǔ",
  "黾俛": "miǎn,miǎn",
  "黾俯": "miǎn,fǔ",
  "黾厄塞": "miǎn,è,sāi",
  "黾塞": "miǎn,sāi",
  "黾媒": "miǎn,méi",
  "黾敏": "miǎn,mǐn",
  "黾池": "miǎn,chí",
  "黾穴鸲巢": "měng,xué,qú,cháo",
  "黾窟": "miǎn,kū",
  "黾蜮": "miǎn,yù",
  "黾谷": "miǎn,gǔ",
  "黾阨塞": "miǎn,è,sāi",
  "黾隘塞": "miǎn,ài,sāi",
  "黾黾孳孳": "miǎn,miǎn,zī,zī",
  "鼃𧏖衣": "wā,bīn,yī",
  "鼃黾": "wā,miǎn",
  "鼋𬶛": "yuán,tuó",
  "鼋鸣鳖应": "yuán,míng,biē,yìng",
  "鼌不及夕": "zhāo,bù,jí,xī",
  "鼌夕": "zhāo,xī",
  "鼌采": "zhāo,cǎi",
  "鼍更": "tuó,gēng",
  "鼎兴": "dǐng,xīng",
  "鼎折": "dǐng,shé",
  "鼎折覆𫗧": "dǐng,shé,fù,sù",
  "鼎折𫗧覆": "dǐng,shé,sù,fù",
  "鼎𮝹": "dǐng,huán",
  "鼎铛": "dǐng,chēng",
  "鼎铛有耳": "dǐng,chēng,yǒu,ěr",
  "鼎铛玉石": "dǐng,chēng,yù,shí",
  "鼎铛耳": "dǐng,chēng,ěr",
  "鼓乐": "gǔ,yuè",
  "鼓乐喧天": "gǔ,yuè,xuān,tiān",
  "鼓乐手": "gǔ,yuè,shǒu",
  "鼓乐齐鸣": "gǔ,yuè,qí,míng",
  "鼓励地": "gǔ,lì,de",
  "鼓囊囊": "gǔ,nāng,nāng",
  "鼓帆": "gǔ,fān",
  "鼓弹": "gǔ,dàn",
  "鼓捣": "gǔ,dao",
  "鼓楞楞": "gǔ,lèng,lèng",
  "鼓点子": "gǔ,diǎn,zi",
  "鼓䇲": "gǔ,jiā",
  "鼓舞地": "gǔ,wǔ,de",
  "鼓躁地": "gǔ,zào,de",
  "鼓鞞": "gǔ,pí",
  "鼓鼓囊囊": "gǔ,gǔ,nāng,nāng",
  "鼗鞞": "táo,bǐ",
  "鼜鼓": "qì,gǔ",
  "鼠曲": "shǔ,qū",
  "鼠朴": "shǔ,piáo",
  "鼠疫杆菌": "shǔ,yì,gǎn,jūn",
  "鼠蹊": "shǔ,xī",
  "鼻儿": "bí,er",
  "鼻出血": "bí,chū,xuè",
  "鼻咽": "bí,yān",
  "鼻咽癌": "bí,yān,ái",
  "鼻声地": "bí,shēng,de",
  "鼻子": "bí,zi",
  "鼻子下面": "bí,zi,xià,miàn",
  "鼻子头": "bí,zi,tóu",
  "鼻子底下": "bí,zi,dǐ,xià",
  "鼻子眼儿": "bí,zi,yǎn,ér",
  "鼻子管": "bí,zi,guǎn",
  "鼻孔撩天": "bí,kǒng,liáo,tiān",
  "鼻洟": "bí,tì",
  "鼻牛儿": "bí,niú,er",
  "鼻血": "bí,xuè",
  "鼻音地": "bí,yīn,de",
  "齁喽": "hōu,lou",
  "齁喽喽": "hōu,lou,lou",
  "齐冠": "qí,guān",
  "齐割扎": "qí,gē,zhā",
  "齐声地": "qí,shēng,de",
  "齐头子": "qí,tóu,zi",
  "齐头数": "qí,tóu,shù",
  "齐平地": "qí,píng,de",
  "齐庄": "zhāi,zhuāng",
  "齐心地": "qí,xīn,de",
  "齐戒": "zhāi,jiè",
  "齐打夯儿地": "qí,dǎ,hāng,er,de",
  "齐斧": "zī,fǔ",
  "齐柏林": "qí,bó,lín",
  "齐柏林飞艇": "qí,bó,lín,fēi,tǐng",
  "齐盛": "zī,shèng",
  "齐眉穗儿": "qí,méi,suì,er",
  "齐絜": "qí,jié",
  "齐缞": "qí,shuāi",
  "齐舍": "qí,shè",
  "齐铺铺": "qí,pù,pù",
  "齑葛": "jī,gě",
  "𱌫历": "yǎn,lì",
  "𱌫唇": "yǎn,chún",
  "𫜪姜呷醋": "yǎo,jiāng,gā,cù",
  "𱌹差": "óu,chà",
  "𱌹齿": "óu,chǐ",
  "齿冠": "chǐ,guān",
  "齿发": "chǐ,fà",
  "齿更": "chǐ,gēng",
  "齿牙为猾": "chǐ,yá,wéi,huá",
  "齿牙为祸": "chǐ,yá,wéi,huò",
  "齿豁": "chǐ,huò",
  "齿𬱓": "chǐ,kuí",
  "龂齿弹舌": "yín,chǐ,dàn,shé",
  "龂龂计较": "yǐn,yǐn,jì,jiào",
  "龇牙咧嘴": "zī,yá,liě,zuǐ",
  "龈齿弹舌": "yín,chǐ,dàn,shé",
  "龌𱌶": "wò,chuò",
  "龌龊地": "wò,chuò,de",
  "龙举云兴": "lóng,jǔ,yún,xīng",
  "龙仔": "lóng,zǎi",
  "龙兴": "lóng,xīng",
  "龙兴云属": "lóng,xīng,yún,shǔ",
  "龙兴凤举": "lóng,xīng,fèng,jǔ",
  "龙兴寺": "lóng,xīng,sì",
  "龙凤帖": "lóng,fèng,tiē",
  "龙吟虎啸": "lóng,yīn,hǔ,xiào",
  "龙吭": "lóng,kēng",
  "龙图老子": "lóng,tú,lǎo,zi",
  "龙子湖": "lóng,zi,hú",
  "龙子湖区": "lóng,zi,hú,qū",
  "龙斿": "lóng,yóu",
  "龙楯": "lóng,dùn",
  "龙楼凤池": "lóng,lóu,fèng,shi",
  "龙楼凤阙": "lóng,lóu,fèng,què",
  "龙槛": "lóng,kǎn",
  "龙游曲沼": "lóng,yóu,qū,zhǎo",
  "龙皮扇子": "lóng,pí,shàn,zi",
  "龙禁": "lóng,jìn",
  "龙禁尉": "lóng,jìn,wèi",
  "龙篴": "lóng,dí",
  "龙脑薄荷": "lóng,nǎo,bò,he",
  "龙蟠虎𰺷": "lóng,pán,hǔ,rǎo",
  "龙血": "lóng,xuè",
  "龙血凤髓": "lóng,xuè,fèng,suǐ",
  "龙血树": "lóng,xuè,shù",
  "龙血玄黄": "lóng,xuè,xuán,huáng",
  "龙见": "lóng,xiàn",
  "龙蹏": "lóng,dì",
  "龙𫏋": "lóng,jué",
  "龙𫏋经": "lóng,jué,jīng",
  "龙门刨": "lóng,mén,bào",
  "龙雒侯": "lóng,luò,hòu",
  "龙额侯": "lóng,é,hòu",
  "龙骧虎跱": "lóng,xiāng,hǔ,jià",
  "龙鱼杂戏": "lóng,yú,zá,hū",
  "龟儿子": "guī,ér,zi",
  "龟兹": "qiū,cí",
  "龟兹伎": "qiū,cí,jì",
  "龟兹板": "qiū,cí,bǎn",
  "龟孙子": "guī,sūn,zi",
  "龟手": "jūn,shǒu",
  "龟折": "guī,shé",
  "龟甲屏": "guī,jiá,píng",
  "龟甲屏风": "guī,jiá,píng,fēng",
  "龟甲香": "guī,jiá,xiāng",
  "龟䇲": "guī,jiā",
  "龟背": "guī,bèi",
  "龟背戏": "guī,bèi,xì",
  "龟背竹": "guī,bèi,zhú",
  "龟背锦": "guī,bèi,jǐn",
  "龟裂": "jūn,liè",
  "𥻗子": "chá,zi"}''';
int minPhraseLengthPy = 2;
int maxPhraseLengthPy = 14;
